/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/base/common/types","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/terminal/node/ptyHostService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/terminal/node/ptyHostService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(Z){for(var e=[],L=0,i=Z.length;L<i;L++)e[L]=oe[Z[L]];return e};define(oe[52],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function L(k){return k?k.replace(/\$\((.*?)\)/g,(N,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(N,P,I){this.id=N,this.fontCharacter=P,this.description=I,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add","\\ea60"),i.plus=new i("plus",i.add.fontCharacter),i.gistNew=new i("gist-new",i.add.fontCharacter),i.repoCreate=new i("repo-create",i.add.fontCharacter),i.lightbulb=new i("lightbulb","\\ea61"),i.lightBulb=new i("light-bulb","\\ea61"),i.repo=new i("repo","\\ea62"),i.repoDelete=new i("repo-delete","\\ea62"),i.gistFork=new i("gist-fork","\\ea63"),i.repoForked=new i("repo-forked","\\ea63"),i.gitPullRequest=new i("git-pull-request","\\ea64"),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned","\\ea64"),i.recordKeys=new i("record-keys","\\ea65"),i.keyboard=new i("keyboard","\\ea65"),i.tag=new i("tag","\\ea66"),i.tagAdd=new i("tag-add","\\ea66"),i.tagRemove=new i("tag-remove","\\ea66"),i.person=new i("person","\\ea67"),i.personFollow=new i("person-follow","\\ea67"),i.personOutline=new i("person-outline","\\ea67"),i.personFilled=new i("person-filled","\\ea67"),i.gitBranch=new i("git-branch","\\ea68"),i.gitBranchCreate=new i("git-branch-create","\\ea68"),i.gitBranchDelete=new i("git-branch-delete","\\ea68"),i.sourceControl=new i("source-control","\\ea68"),i.mirror=new i("mirror","\\ea69"),i.mirrorPublic=new i("mirror-public","\\ea69"),i.star=new i("star","\\ea6a"),i.starAdd=new i("star-add","\\ea6a"),i.starDelete=new i("star-delete","\\ea6a"),i.starEmpty=new i("star-empty","\\ea6a"),i.comment=new i("comment","\\ea6b"),i.commentAdd=new i("comment-add","\\ea6b"),i.alert=new i("alert","\\ea6c"),i.warning=new i("warning","\\ea6c"),i.search=new i("search","\\ea6d"),i.searchSave=new i("search-save","\\ea6d"),i.logOut=new i("log-out","\\ea6e"),i.signOut=new i("sign-out","\\ea6e"),i.logIn=new i("log-in","\\ea6f"),i.signIn=new i("sign-in","\\ea6f"),i.eye=new i("eye","\\ea70"),i.eyeUnwatch=new i("eye-unwatch","\\ea70"),i.eyeWatch=new i("eye-watch","\\ea70"),i.circleFilled=new i("circle-filled","\\ea71"),i.primitiveDot=new i("primitive-dot",i.circleFilled.fontCharacter),i.closeDirty=new i("close-dirty",i.circleFilled.fontCharacter),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.fontCharacter),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.fontCharacter),i.debugHint=new i("debug-hint",i.circleFilled.fontCharacter),i.primitiveSquare=new i("primitive-square","\\ea72"),i.edit=new i("edit","\\ea73"),i.pencil=new i("pencil","\\ea73"),i.info=new i("info","\\ea74"),i.issueOpened=new i("issue-opened","\\ea74"),i.gistPrivate=new i("gist-private","\\ea75"),i.gitForkPrivate=new i("git-fork-private","\\ea75"),i.lock=new i("lock","\\ea75"),i.mirrorPrivate=new i("mirror-private","\\ea75"),i.close=new i("close","\\ea76"),i.removeClose=new i("remove-close","\\ea76"),i.x=new i("x","\\ea76"),i.repoSync=new i("repo-sync","\\ea77"),i.sync=new i("sync","\\ea77"),i.clone=new i("clone","\\ea78"),i.desktopDownload=new i("desktop-download","\\ea78"),i.beaker=new i("beaker","\\ea79"),i.microscope=new i("microscope","\\ea79"),i.vm=new i("vm","\\ea7a"),i.deviceDesktop=new i("device-desktop","\\ea7a"),i.file=new i("file","\\ea7b"),i.fileText=new i("file-text","\\ea7b"),i.more=new i("more","\\ea7c"),i.ellipsis=new i("ellipsis","\\ea7c"),i.kebabHorizontal=new i("kebab-horizontal","\\ea7c"),i.mailReply=new i("mail-reply","\\ea7d"),i.reply=new i("reply","\\ea7d"),i.organization=new i("organization","\\ea7e"),i.organizationFilled=new i("organization-filled","\\ea7e"),i.organizationOutline=new i("organization-outline","\\ea7e"),i.newFile=new i("new-file","\\ea7f"),i.fileAdd=new i("file-add","\\ea7f"),i.newFolder=new i("new-folder","\\ea80"),i.fileDirectoryCreate=new i("file-directory-create","\\ea80"),i.trash=new i("trash","\\ea81"),i.trashcan=new i("trashcan","\\ea81"),i.history=new i("history","\\ea82"),i.clock=new i("clock","\\ea82"),i.folder=new i("folder","\\ea83"),i.fileDirectory=new i("file-directory","\\ea83"),i.symbolFolder=new i("symbol-folder","\\ea83"),i.logoGithub=new i("logo-github","\\ea84"),i.markGithub=new i("mark-github","\\ea84"),i.github=new i("github","\\ea84"),i.terminal=new i("terminal","\\ea85"),i.console=new i("console","\\ea85"),i.repl=new i("repl","\\ea85"),i.zap=new i("zap","\\ea86"),i.symbolEvent=new i("symbol-event","\\ea86"),i.error=new i("error","\\ea87"),i.stop=new i("stop","\\ea87"),i.variable=new i("variable","\\ea88"),i.symbolVariable=new i("symbol-variable","\\ea88"),i.array=new i("array","\\ea8a"),i.symbolArray=new i("symbol-array","\\ea8a"),i.symbolModule=new i("symbol-module","\\ea8b"),i.symbolPackage=new i("symbol-package","\\ea8b"),i.symbolNamespace=new i("symbol-namespace","\\ea8b"),i.symbolObject=new i("symbol-object","\\ea8b"),i.symbolMethod=new i("symbol-method","\\ea8c"),i.symbolFunction=new i("symbol-function","\\ea8c"),i.symbolConstructor=new i("symbol-constructor","\\ea8c"),i.symbolBoolean=new i("symbol-boolean","\\ea8f"),i.symbolNull=new i("symbol-null","\\ea8f"),i.symbolNumeric=new i("symbol-numeric","\\ea90"),i.symbolNumber=new i("symbol-number","\\ea90"),i.symbolStructure=new i("symbol-structure","\\ea91"),i.symbolStruct=new i("symbol-struct","\\ea91"),i.symbolParameter=new i("symbol-parameter","\\ea92"),i.symbolTypeParameter=new i("symbol-type-parameter","\\ea92"),i.symbolKey=new i("symbol-key","\\ea93"),i.symbolText=new i("symbol-text","\\ea93"),i.symbolReference=new i("symbol-reference","\\ea94"),i.goToFile=new i("go-to-file","\\ea94"),i.symbolEnum=new i("symbol-enum","\\ea95"),i.symbolValue=new i("symbol-value","\\ea95"),i.symbolRuler=new i("symbol-ruler","\\ea96"),i.symbolUnit=new i("symbol-unit","\\ea96"),i.activateBreakpoints=new i("activate-breakpoints","\\ea97"),i.archive=new i("archive","\\ea98"),i.arrowBoth=new i("arrow-both","\\ea99"),i.arrowDown=new i("arrow-down","\\ea9a"),i.arrowLeft=new i("arrow-left","\\ea9b"),i.arrowRight=new i("arrow-right","\\ea9c"),i.arrowSmallDown=new i("arrow-small-down","\\ea9d"),i.arrowSmallLeft=new i("arrow-small-left","\\ea9e"),i.arrowSmallRight=new i("arrow-small-right","\\ea9f"),i.arrowSmallUp=new i("arrow-small-up","\\eaa0"),i.arrowUp=new i("arrow-up","\\eaa1"),i.bell=new i("bell","\\eaa2"),i.bold=new i("bold","\\eaa3"),i.book=new i("book","\\eaa4"),i.bookmark=new i("bookmark","\\eaa5"),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified","\\eaa6"),i.debugBreakpointConditional=new i("debug-breakpoint-conditional","\\eaa7"),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled","\\eaa7"),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified","\\eaa8"),i.debugBreakpointData=new i("debug-breakpoint-data","\\eaa9"),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled","\\eaa9"),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified","\\eaaa"),i.debugBreakpointLog=new i("debug-breakpoint-log","\\eaab"),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled","\\eaab"),i.briefcase=new i("briefcase","\\eaac"),i.broadcast=new i("broadcast","\\eaad"),i.browser=new i("browser","\\eaae"),i.bug=new i("bug","\\eaaf"),i.calendar=new i("calendar","\\eab0"),i.caseSensitive=new i("case-sensitive","\\eab1"),i.check=new i("check","\\eab2"),i.checklist=new i("checklist","\\eab3"),i.chevronDown=new i("chevron-down","\\eab4"),i.dropDownButton=new i("drop-down-button",i.chevronDown.fontCharacter),i.chevronLeft=new i("chevron-left","\\eab5"),i.chevronRight=new i("chevron-right","\\eab6"),i.chevronUp=new i("chevron-up","\\eab7"),i.chromeClose=new i("chrome-close","\\eab8"),i.chromeMaximize=new i("chrome-maximize","\\eab9"),i.chromeMinimize=new i("chrome-minimize","\\eaba"),i.chromeRestore=new i("chrome-restore","\\eabb"),i.circle=new i("circle","\\eabc"),i.circleOutline=new i("circle-outline",i.circle.fontCharacter),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.fontCharacter),i.circleSlash=new i("circle-slash","\\eabd"),i.circuitBoard=new i("circuit-board","\\eabe"),i.clearAll=new i("clear-all","\\eabf"),i.clippy=new i("clippy","\\eac0"),i.closeAll=new i("close-all","\\eac1"),i.cloudDownload=new i("cloud-download","\\eac2"),i.cloudUpload=new i("cloud-upload","\\eac3"),i.code=new i("code","\\eac4"),i.collapseAll=new i("collapse-all","\\eac5"),i.colorMode=new i("color-mode","\\eac6"),i.commentDiscussion=new i("comment-discussion","\\eac7"),i.compareChanges=new i("compare-changes","\\eafd"),i.creditCard=new i("credit-card","\\eac9"),i.dash=new i("dash","\\eacc"),i.dashboard=new i("dashboard","\\eacd"),i.database=new i("database","\\eace"),i.debugContinue=new i("debug-continue","\\eacf"),i.debugDisconnect=new i("debug-disconnect","\\ead0"),i.debugPause=new i("debug-pause","\\ead1"),i.debugRestart=new i("debug-restart","\\ead2"),i.debugStart=new i("debug-start","\\ead3"),i.debugStepInto=new i("debug-step-into","\\ead4"),i.debugStepOut=new i("debug-step-out","\\ead5"),i.debugStepOver=new i("debug-step-over","\\ead6"),i.debugStop=new i("debug-stop","\\ead7"),i.debug=new i("debug","\\ead8"),i.deviceCameraVideo=new i("device-camera-video","\\ead9"),i.deviceCamera=new i("device-camera","\\eada"),i.deviceMobile=new i("device-mobile","\\eadb"),i.diffAdded=new i("diff-added","\\eadc"),i.diffIgnored=new i("diff-ignored","\\eadd"),i.diffModified=new i("diff-modified","\\eade"),i.diffRemoved=new i("diff-removed","\\eadf"),i.diffRenamed=new i("diff-renamed","\\eae0"),i.diff=new i("diff","\\eae1"),i.discard=new i("discard","\\eae2"),i.editorLayout=new i("editor-layout","\\eae3"),i.emptyWindow=new i("empty-window","\\eae4"),i.exclude=new i("exclude","\\eae5"),i.extensions=new i("extensions","\\eae6"),i.eyeClosed=new i("eye-closed","\\eae7"),i.fileBinary=new i("file-binary","\\eae8"),i.fileCode=new i("file-code","\\eae9"),i.fileMedia=new i("file-media","\\eaea"),i.filePdf=new i("file-pdf","\\eaeb"),i.fileSubmodule=new i("file-submodule","\\eaec"),i.fileSymlinkDirectory=new i("file-symlink-directory","\\eaed"),i.fileSymlinkFile=new i("file-symlink-file","\\eaee"),i.fileZip=new i("file-zip","\\eaef"),i.files=new i("files","\\eaf0"),i.filter=new i("filter","\\eaf1"),i.flame=new i("flame","\\eaf2"),i.foldDown=new i("fold-down","\\eaf3"),i.foldUp=new i("fold-up","\\eaf4"),i.fold=new i("fold","\\eaf5"),i.folderActive=new i("folder-active","\\eaf6"),i.folderOpened=new i("folder-opened","\\eaf7"),i.gear=new i("gear","\\eaf8"),i.gift=new i("gift","\\eaf9"),i.gistSecret=new i("gist-secret","\\eafa"),i.gist=new i("gist","\\eafb"),i.gitCommit=new i("git-commit","\\eafc"),i.gitCompare=new i("git-compare","\\eafd"),i.gitMerge=new i("git-merge","\\eafe"),i.githubAction=new i("github-action","\\eaff"),i.githubAlt=new i("github-alt","\\eb00"),i.globe=new i("globe","\\eb01"),i.grabber=new i("grabber","\\eb02"),i.graph=new i("graph","\\eb03"),i.gripper=new i("gripper","\\eb04"),i.heart=new i("heart","\\eb05"),i.home=new i("home","\\eb06"),i.horizontalRule=new i("horizontal-rule","\\eb07"),i.hubot=new i("hubot","\\eb08"),i.inbox=new i("inbox","\\eb09"),i.issueClosed=new i("issue-closed","\\eba4"),i.issueReopened=new i("issue-reopened","\\eb0b"),i.issues=new i("issues","\\eb0c"),i.italic=new i("italic","\\eb0d"),i.jersey=new i("jersey","\\eb0e"),i.json=new i("json","\\eb0f"),i.kebabVertical=new i("kebab-vertical","\\eb10"),i.key=new i("key","\\eb11"),i.law=new i("law","\\eb12"),i.lightbulbAutofix=new i("lightbulb-autofix","\\eb13"),i.linkExternal=new i("link-external","\\eb14"),i.link=new i("link","\\eb15"),i.listOrdered=new i("list-ordered","\\eb16"),i.listUnordered=new i("list-unordered","\\eb17"),i.liveShare=new i("live-share","\\eb18"),i.loading=new i("loading","\\eb19"),i.location=new i("location","\\eb1a"),i.mailRead=new i("mail-read","\\eb1b"),i.mail=new i("mail","\\eb1c"),i.markdown=new i("markdown","\\eb1d"),i.megaphone=new i("megaphone","\\eb1e"),i.mention=new i("mention","\\eb1f"),i.milestone=new i("milestone","\\eb20"),i.mortarBoard=new i("mortar-board","\\eb21"),i.move=new i("move","\\eb22"),i.multipleWindows=new i("multiple-windows","\\eb23"),i.mute=new i("mute","\\eb24"),i.noNewline=new i("no-newline","\\eb25"),i.note=new i("note","\\eb26"),i.octoface=new i("octoface","\\eb27"),i.openPreview=new i("open-preview","\\eb28"),i.package_=new i("package","\\eb29"),i.paintcan=new i("paintcan","\\eb2a"),i.pin=new i("pin","\\eb2b"),i.play=new i("play","\\eb2c"),i.run=new i("run","\\eb2c"),i.plug=new i("plug","\\eb2d"),i.preserveCase=new i("preserve-case","\\eb2e"),i.preview=new i("preview","\\eb2f"),i.project=new i("project","\\eb30"),i.pulse=new i("pulse","\\eb31"),i.question=new i("question","\\eb32"),i.quote=new i("quote","\\eb33"),i.radioTower=new i("radio-tower","\\eb34"),i.reactions=new i("reactions","\\eb35"),i.references=new i("references","\\eb36"),i.refresh=new i("refresh","\\eb37"),i.regex=new i("regex","\\eb38"),i.remoteExplorer=new i("remote-explorer","\\eb39"),i.remote=new i("remote","\\eb3a"),i.remove=new i("remove","\\eb3b"),i.replaceAll=new i("replace-all","\\eb3c"),i.replace=new i("replace","\\eb3d"),i.repoClone=new i("repo-clone","\\eb3e"),i.repoForcePush=new i("repo-force-push","\\eb3f"),i.repoPull=new i("repo-pull","\\eb40"),i.repoPush=new i("repo-push","\\eb41"),i.report=new i("report","\\eb42"),i.requestChanges=new i("request-changes","\\eb43"),i.rocket=new i("rocket","\\eb44"),i.rootFolderOpened=new i("root-folder-opened","\\eb45"),i.rootFolder=new i("root-folder","\\eb46"),i.rss=new i("rss","\\eb47"),i.ruby=new i("ruby","\\eb48"),i.saveAll=new i("save-all","\\eb49"),i.saveAs=new i("save-as","\\eb4a"),i.save=new i("save","\\eb4b"),i.screenFull=new i("screen-full","\\eb4c"),i.screenNormal=new i("screen-normal","\\eb4d"),i.searchStop=new i("search-stop","\\eb4e"),i.server=new i("server","\\eb50"),i.settingsGear=new i("settings-gear","\\eb51"),i.settings=new i("settings","\\eb52"),i.shield=new i("shield","\\eb53"),i.smiley=new i("smiley","\\eb54"),i.sortPrecedence=new i("sort-precedence","\\eb55"),i.splitHorizontal=new i("split-horizontal","\\eb56"),i.splitVertical=new i("split-vertical","\\eb57"),i.squirrel=new i("squirrel","\\eb58"),i.starFull=new i("star-full","\\eb59"),i.starHalf=new i("star-half","\\eb5a"),i.symbolClass=new i("symbol-class","\\eb5b"),i.symbolColor=new i("symbol-color","\\eb5c"),i.symbolCustomColor=new i("symbol-customcolor","\\eb5c"),i.symbolConstant=new i("symbol-constant","\\eb5d"),i.symbolEnumMember=new i("symbol-enum-member","\\eb5e"),i.symbolField=new i("symbol-field","\\eb5f"),i.symbolFile=new i("symbol-file","\\eb60"),i.symbolInterface=new i("symbol-interface","\\eb61"),i.symbolKeyword=new i("symbol-keyword","\\eb62"),i.symbolMisc=new i("symbol-misc","\\eb63"),i.symbolOperator=new i("symbol-operator","\\eb64"),i.symbolProperty=new i("symbol-property","\\eb65"),i.wrench=new i("wrench","\\eb65"),i.wrenchSubaction=new i("wrench-subaction","\\eb65"),i.symbolSnippet=new i("symbol-snippet","\\eb66"),i.tasklist=new i("tasklist","\\eb67"),i.telescope=new i("telescope","\\eb68"),i.textSize=new i("text-size","\\eb69"),i.threeBars=new i("three-bars","\\eb6a"),i.thumbsdown=new i("thumbsdown","\\eb6b"),i.thumbsup=new i("thumbsup","\\eb6c"),i.tools=new i("tools","\\eb6d"),i.triangleDown=new i("triangle-down","\\eb6e"),i.triangleLeft=new i("triangle-left","\\eb6f"),i.triangleRight=new i("triangle-right","\\eb70"),i.triangleUp=new i("triangle-up","\\eb71"),i.twitter=new i("twitter","\\eb72"),i.unfold=new i("unfold","\\eb73"),i.unlock=new i("unlock","\\eb74"),i.unmute=new i("unmute","\\eb75"),i.unverified=new i("unverified","\\eb76"),i.verified=new i("verified","\\eb77"),i.versions=new i("versions","\\eb78"),i.vmActive=new i("vm-active","\\eb79"),i.vmOutline=new i("vm-outline","\\eb7a"),i.vmRunning=new i("vm-running","\\eb7b"),i.watch=new i("watch","\\eb7c"),i.whitespace=new i("whitespace","\\eb7d"),i.wholeWord=new i("whole-word","\\eb7e"),i.window=new i("window","\\eb7f"),i.wordWrap=new i("word-wrap","\\eb80"),i.zoomIn=new i("zoom-in","\\eb81"),i.zoomOut=new i("zoom-out","\\eb82"),i.listFilter=new i("list-filter","\\eb83"),i.listFlat=new i("list-flat","\\eb84"),i.listSelection=new i("list-selection","\\eb85"),i.selection=new i("selection","\\eb85"),i.listTree=new i("list-tree","\\eb86"),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified","\\eb87"),i.debugBreakpointFunction=new i("debug-breakpoint-function","\\eb88"),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled","\\eb88"),i.debugStackframeActive=new i("debug-stackframe-active","\\eb89"),i.circleSmallFilled=new i("circle-small-filled","\\eb8a"),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.fontCharacter),i.debugStackframe=new i("debug-stackframe","\\eb8b"),i.debugStackframeFocused=new i("debug-stackframe-focused","\\eb8b"),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported","\\eb8c"),i.symbolString=new i("symbol-string","\\eb8d"),i.debugReverseContinue=new i("debug-reverse-continue","\\eb8e"),i.debugStepBack=new i("debug-step-back","\\eb8f"),i.debugRestartFrame=new i("debug-restart-frame","\\eb90"),i.callIncoming=new i("call-incoming","\\eb92"),i.callOutgoing=new i("call-outgoing","\\eb93"),i.menu=new i("menu","\\eb94"),i.expandAll=new i("expand-all","\\eb95"),i.feedback=new i("feedback","\\eb96"),i.groupByRefType=new i("group-by-ref-type","\\eb97"),i.ungroupByRefType=new i("ungroup-by-ref-type","\\eb98"),i.account=new i("account","\\eb99"),i.bellDot=new i("bell-dot","\\eb9a"),i.debugConsole=new i("debug-console","\\eb9b"),i.library=new i("library","\\eb9c"),i.output=new i("output","\\eb9d"),i.runAll=new i("run-all","\\eb9e"),i.syncIgnored=new i("sync-ignored","\\eb9f"),i.pinned=new i("pinned","\\eba0"),i.githubInverted=new i("github-inverted","\\eba1"),i.debugAlt=new i("debug-alt","\\eb91"),i.serverProcess=new i("server-process","\\eba2"),i.serverEnvironment=new i("server-environment","\\eba3"),i.pass=new i("pass","\\eba4"),i.stopCircle=new i("stop-circle","\\eba5"),i.playCircle=new i("play-circle","\\eba6"),i.record=new i("record","\\eba7"),i.debugAltSmall=new i("debug-alt-small","\\eba8"),i.vmConnect=new i("vm-connect","\\eba9"),i.cloud=new i("cloud","\\ebaa"),i.merge=new i("merge","\\ebab"),i.exportIcon=new i("export","\\ebac"),i.graphLeft=new i("graph-left","\\ebad"),i.magnet=new i("magnet","\\ebae"),i.notebook=new i("notebook","\\ebaf"),i.redo=new i("redo","\\ebb0"),i.checkAll=new i("check-all","\\ebb1"),i.pinnedDirty=new i("pinned-dirty","\\ebb2"),i.passFilled=new i("pass-filled","\\ebb3"),i.circleLargeFilled=new i("circle-large-filled","\\ebb4"),i.circleLarge=new i("circle-large","\\ebb5"),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.fontCharacter),i.combine=new i("combine","\\ebb6"),i.gather=new i("gather","\\ebb6"),i.table=new i("table","\\ebb7"),i.variableGroup=new i("variable-group","\\ebb8"),i.typeHierarchy=new i("type-hierarchy","\\ebb9"),i.typeHierarchySub=new i("type-hierarchy-sub","\\ebba"),i.typeHierarchySuper=new i("type-hierarchy-super","\\ebbb"),i.gitPullRequestCreate=new i("git-pull-request-create","\\ebbc"),i.runAbove=new i("run-above","\\ebbd"),i.runBelow=new i("run-below","\\ebbe"),i.notebookTemplate=new i("notebook-template","\\ebbf"),i.debugRerun=new i("debug-rerun","\\ebc0"),i.workspaceTrusted=new i("workspace-trusted","\\ebc1"),i.workspaceUntrusted=new i("workspace-untrusted","\\ebc2"),i.workspaceUnspecified=new i("workspace-unspecified","\\ebc3"),i.terminalCmd=new i("terminal-cmd","\\ebc4"),i.terminalDebian=new i("terminal-debian","\\ebc5"),i.terminalLinux=new i("terminal-linux","\\ebc6"),i.terminalPowershell=new i("terminal-powershell","\\ebc7"),i.terminalTmux=new i("terminal-tmux","\\ebc8"),i.terminalUbuntu=new i("terminal-ubuntu","\\ebc9"),i.terminalBash=new i("terminal-bash","\\ebca"),i.arrowSwap=new i("arrow-swap","\\ebcb"),i.copy=new i("copy","\\ebcc"),i.personAdd=new i("person-add","\\ebcd"),i.filterFilled=new i("filter-filled","\\ebce"),i.wand=new i("wand","\\ebcf"),i.debugLineByLine=new i("debug-line-by-line","\\ebd0"),i.inspect=new i("inspect","\\ebd1"),i.layers=new i("layers","\\ebd2"),i.layersDot=new i("layers-dot","\\ebd3"),i.layersActive=new i("layers-active","\\ebd4"),i.compass=new i("compass","\\ebd5"),i.compassDot=new i("compass-dot","\\ebd6"),i.compassActive=new i("compass-active","\\ebd7"),i.azure=new i("azure","\\ebd8"),i.issueDraft=new i("issue-draft","\\ebd9"),i.gitPullRequestClosed=new i("git-pull-request-closed","\\ebda"),i.gitPullRequestDraft=new i("git-pull-request-draft","\\ebdb"),i.debugAll=new i("debug-all","\\ebdc"),i.debugCoverage=new i("debug-coverage","\\ebdd"),i.runErrors=new i("run-errors","\\ebde"),i.folderLibrary=new i("folder-library","\\ebdf"),i.debugContinueSmall=new i("debug-continue-small","\\ebe0"),i.beakerStop=new i("beaker-stop","\\ebe1"),i.graphLine=new i("graph-line","\\ebe2"),i.graphScatter=new i("graph-scatter","\\ebe3"),i.pieChart=new i("pie-chart","\\ebe4"),i.bracket=new i("bracket",i.json.fontCharacter),i.bracketDot=new i("bracket-dot","\\ebe5"),i.bracketError=new i("bracket-error","\\ebe6"),i.lockSmall=new i("lock-small","\\ebe7"),i.azureDevops=new i("azure-devops","\\ebe8"),i.verifiedFilled=new i("verified-filled","\\ebe9"),i.newLine=new i("newline","\\ebea"),i.layout=new i("layout","\\ebeb"),i.layoutActivitybarLeft=new i("layout-activitybar-left","\\ebec"),i.layoutActivitybarRight=new i("layout-activitybar-right","\\ebed"),i.layoutPanelLeft=new i("layout-panel-left","\\ebee"),i.layoutPanelCenter=new i("layout-panel-center","\\ebef"),i.layoutPanelJustify=new i("layout-panel-justify","\\ebf0"),i.layoutPanelRight=new i("layout-panel-right","\\ebf1"),i.layoutPanel=new i("layout-panel","\\ebf2"),i.layoutSidebarLeft=new i("layout-sidebar-left","\\ebf3"),i.layoutSidebarRight=new i("layout-sidebar-right","\\ebf4"),i.layoutStatusbar=new i("layout-statusbar","\\ebf5"),i.layoutMenubar=new i("layout-menubar","\\ebf6"),i.layoutCentered=new i("layout-centered","\\ebf7"),i.layoutSidebarRightOff=new i("layout-sidebar-right-off","\\ec00"),i.layoutPanelOff=new i("layout-panel-off","\\ec01"),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off","\\ec02"),i.target=new i("target","\\ebf8"),i.indent=new i("indent","\\ebf9"),i.recordSmall=new i("record-small","\\ebfa"),i.errorSmall=new i("error-small","\\ebfb"),i.arrowCircleDown=new i("arrow-circle-down","\\ebfc"),i.arrowCircleLeft=new i("arrow-circle-left","\\ebfd"),i.arrowCircleRight=new i("arrow-circle-right","\\ebfe"),i.arrowCircleUp=new i("arrow-circle-up","\\ebff"),i.heartFilled=new i("heart-filled","\\ec04"),i.map=new i("map","\\ec05"),i.mapFilled=new i("map-filled","\\ec06"),i.circleSmall=new i("circle-small","\\ec07"),i.bellSlash=new i("bell-slash","\\ec08"),i.bellSlashDot=new i("bell-slash-dot","\\ec09"),i.commentUnresolved=new i("comment-unresolved","\\ec0a"),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes","\\ec0b"),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes","\\ec0c"),i.searchFuzzy=new i("search-fuzzy","\\ec0d"),i.commentDraft=new i("comment-draft","\\ec0e"),i.dialogError=new i("dialog-error",i.error.fontCharacter),i.dialogWarning=new i("dialog-warning",i.warning.fontCharacter),i.dialogInfo=new i("dialog-info",i.info.fontCharacter),i.dialogClose=new i("dialog-close",i.close.fontCharacter),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.fontCharacter),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.fontCharacter),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.fontCharacter),i.treeFilterClear=new i("tree-filter-clear",i.close.fontCharacter),i.treeItemLoading=new i("tree-item-loading",i.loading.fontCharacter),i.menuSelection=new i("menu-selection",i.check.fontCharacter),i.menuSubmenu=new i("menu-submenu",i.chevronRight.fontCharacter),i.menuBarMore=new i("menubar-more",i.more.fontCharacter),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.fontCharacter),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.fontCharacter),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.fontCharacter),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.fontCharacter),i.toolBarMore=new i("toolbar-more",i.more.fontCharacter),i.quickInputBack=new i("quick-input-back",i.arrowLeft.fontCharacter);var D;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const N=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function P(C){if(C instanceof i)return["codicon","codicon-"+C.id];const w=N.exec(C.id);if(!w)return P(i.error);const[,g,m]=w,f=["codicon","codicon-"+g];return m&&f.push("codicon-modifier-"+m.substring(1)),f}k.asClassNameArray=P;function I(C){return P(C).join(" ")}k.asClassName=I;function y(C){return"."+P(C).join(".")}k.asCSSSelector=y})(D=e.CSSIcon||(e.CSSIcon={}))}),define(oe[63],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(N){return(P,I,y)=>{let C=null,w=null;if(typeof y.value=="function"?(C="value",w=y.value):typeof y.get=="function"&&(C="get",w=y.get),!w)throw new Error("not supported");y[C]=N(w,I)}}function i(N,P,I){let y=null,C=null;if(typeof I.value=="function"?(y="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(y="get",C=I.get),!C)throw new Error("not supported");const w=`$memoize$${P}`;I[y]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,g)}),this[w]}}e.memoize=i;function D(N,P,I){return L((y,C)=>{const w=`$debounce$${C}`,g=`$debounce$result$${C}`;return function(...m){this[g]||(this[g]=I?I():void 0),clearTimeout(this[w]),P&&(this[g]=P(this[g],...m),m=[this[g]]),this[w]=setTimeout(()=>{y.apply(this,m),this[g]=I?I():void 0},N)}})}e.debounce=D;function k(N,P,I){return L((y,C)=>{const w=`$throttle$timer$${C}`,g=`$throttle$result$${C}`,m=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...v){if(this[g]||(this[g]=I?I():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...v)),this[f])return;const u=this[m]+N;u<=Date.now()?(this[m]=Date.now(),y.apply(this,[this[g]]),this[g]=I?I():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[m]=Date.now(),y.apply(this,[this[g]]),this[g]=I?I():void 0},u-Date.now()))}})}e.throttle=k}),define(oe[7],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?p.isErrorNoTelemetry(s)?new p(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(c=>{c(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=L,e.errorHandler=new L;function i(R){e.errorHandler.setUnexpectedErrorHandler(R)}e.setUnexpectedErrorHandler=i;function D(R){I(R)||e.errorHandler.onUnexpectedError(R)}e.onUnexpectedError=D;function k(R){I(R)||e.errorHandler.onUnexpectedExternalError(R)}e.onUnexpectedExternalError=k;function N(R){if(R instanceof Error){const{name:s,message:c}=R,t=R.stacktrace||R.stack;return{$isError:!0,name:s,message:c,stack:t,noTelemetry:p.isErrorNoTelemetry(R)}}return R}e.transformErrorForSerialization=N;const P="Canceled";function I(R){return R instanceof y?!0:R instanceof Error&&R.name===P&&R.message===P}e.isCancellationError=I;class y extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=y;function C(){const R=new Error(P);return R.name=R.message,R}e.canceled=C;function w(R){return R?new Error(`Illegal argument: ${R}`):new Error("Illegal argument")}e.illegalArgument=w;function g(R){return R?new Error(`Illegal state: ${R}`):new Error("Illegal state")}e.illegalState=g;function m(R){return R?new Error(`readonly property '${R} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function f(R){const s=new Error(`${R} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function v(R){return R?R.message?R.message:R.stack?R.stack.split(`
`)[0]:String(R):"Error"}e.getErrorMessage=v;class u extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=u;class l extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class p extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof p)return s;const c=new p;return c.message=s.message,c.stack=s.stack,c}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class S extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}e.BugIndicatingError=S}),define(oe[21],ae([0,1,7]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(Y,Q=0){return Y[Y.length-(1+Q)]}e.tail=i;function D(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.tail2=D;function k(Y,Q,se=(le,ue)=>le===ue){if(Y===Q)return!0;if(!Y||!Q||Y.length!==Q.length)return!1;for(let le=0,ue=Y.length;le<ue;le++)if(!se(Y[le],Q[le]))return!1;return!0}e.equals=k;function N(Y,Q){const se=Y.length-1;Q<se&&(Y[Q]=Y[se]),Y.pop()}e.removeFastWithoutKeepingOrder=N;function P(Y,Q,se){return I(Y.length,le=>se(Y[le],Q))}e.binarySearch=P;function I(Y,Q){let se=0,le=Y-1;for(;se<=le;){const ue=(se+le)/2|0,pe=Q(ue);if(pe<0)se=ue+1;else if(pe>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=I;function y(Y,Q){let se=0,le=Y.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);Q(Y[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=y;function C(Y,Q,se){if(Y=Y|0,Y>=Q.length)throw new TypeError("invalid index");const le=Q[Math.floor(Q.length*Math.random())],ue=[],pe=[],we=[];for(const be of Q){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?pe.push(be):we.push(be)}return Y<ue.length?C(Y,ue,se):Y<ue.length+we.length?we[0]:C(Y-(ue.length+we.length),pe,se)}e.quickSelect=C;function w(Y,Q){const se=[];let le;for(const ue of Y.slice(0).sort(Q))!le||Q(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=w;function g(Y,Q,se){const le=[];function ue(be,Ee,Te){if(Ee===0&&Te.length===0)return;const Ue=le[le.length-1];Ue&&Ue.start+Ue.deleteCount===be?(Ue.deleteCount+=Ee,Ue.toInsert.push(...Te)):le.push({start:be,deleteCount:Ee,toInsert:Te})}let pe=0,we=0;for(;;){if(pe===Y.length){ue(pe,0,Q.slice(we));break}if(we===Q.length){ue(pe,Y.length-pe,[]);break}const be=Y[pe],Ee=Q[we],Te=se(be,Ee);Te===0?(pe+=1,we+=1):Te<0?(ue(pe,1,[]),pe+=1):Te>0&&(ue(pe,0,[Ee]),we+=1)}return le}e.sortedDiff=g;function m(Y,Q,se){const le=g(Y,Q,se),ue=[],pe=[];for(const we of le)ue.push(...Y.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:ue,added:pe}}e.delta=m;function f(Y,Q,se){if(se===0)return[];const le=Y.slice(0,se).sort(Q);return u(Y,Q,le,se,Y.length),le}e.top=f;function v(Y,Q,se,le,ue){return se===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const be=Y.length,Ee=Y.slice(0,se).sort(Q);for(let Te=se,Ue=Math.min(se+le,be);Te<be;Te=Ue,Ue=Math.min(Ue+le,be)){if(Te>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new L.CancellationError;u(Y,Q,Ee,Te,Ue)}return Ee})().then(pe,we)})}e.topAsync=v;function u(Y,Q,se,le,ue){for(const pe=se.length;le<ue;le++){const we=Y[le];if(Q(we,se[pe-1])<0){se.pop();const be=y(se,Ee=>Q(we,Ee)<0);se.splice(be,0,we)}}}function l(Y){return Y.filter(Q=>!!Q)}e.coalesce=l;function d(Y){let Q=0;for(let se=0;se<Y.length;se++)Y[se]&&(Y[Q]=Y[se],Q+=1);Y.length=Q}e.coalesceInPlace=d;function p(Y,Q,se){Y.splice(se,0,Y.splice(Q,1)[0])}e.move=p;function S(Y){return!Array.isArray(Y)||Y.length===0}e.isFalsyOrEmpty=S;function R(Y){return Array.isArray(Y)&&Y.length>0}e.isNonEmptyArray=R;function s(Y,Q=se=>se){const se=new Set;return Y.filter(le=>{const ue=Q(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=s;function c(Y){const Q=new Set;return se=>{const le=Y(se);return Q.has(le)?!1:(Q.add(le),!0)}}e.uniqueFilter=c;function t(Y,Q){const se=n(Y,Q);if(se!==-1)return Y[se]}e.findLast=t;function n(Y,Q){for(let se=Y.length-1;se>=0;se--){const le=Y[se];if(Q(le))return se}return-1}e.lastIndex=n;function r(Y,Q){return Y.length>0?Y[0]:Q}e.firstOrDefault=r;function o(Y,Q){return Y.length>0?Y[Y.length-1]:Q}e.lastOrDefault=o;function a(Y,Q,se=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(Y.length,Q.length);ue<pe&&se(Y[ue],Q[ue]);ue++)le++;return le}e.commonPrefixLength=a;function h(Y){return[].concat(...Y)}e.flatten=h;function b(Y,Q){let se=typeof Q=="number"?Y:0;typeof Q=="number"?se=Y:(se=0,Q=Y);const le=[];if(se<=Q)for(let ue=se;ue<Q;ue++)le.push(ue);else for(let ue=se;ue>Q;ue--)le.push(ue);return le}e.range=b;function E(Y,Q,se){return Y.reduce((le,ue)=>(le[Q(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=E;function T(Y,Q){return Y.push(Q),()=>O(Y,Q)}e.insert=T;function O(Y,Q){const se=Y.indexOf(Q);if(se>-1)return Y.splice(se,1),Q}e.remove=O;function M(Y,Q,se){const le=Y.slice(0,Q),ue=Y.slice(Q);return le.concat(se,ue)}e.arrayInsert=M;function F(Y,Q){let se;if(typeof Q=="number"){let le=Q;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=Y.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),pe=Y[le];Y[le]=Y[ue],Y[ue]=pe}}e.shuffle=F;function A(Y,Q){const se=Y.indexOf(Q);se>-1&&(Y.splice(se,1),Y.unshift(Q))}e.pushToStart=A;function $(Y,Q){const se=Y.indexOf(Q);se>-1&&(Y.splice(se,1),Y.push(Q))}e.pushToEnd=$;function z(Y,Q){for(const se of Q)Y.push(se)}e.pushMany=z;function H(Y,Q){return Array.isArray(Y)?Y.map(Q):Q(Y)}e.mapArrayOrNot=H;function X(Y){return Array.isArray(Y)?Y:[Y]}e.asArray=X;function ie(Y){return Y[Math.floor(Math.random()*Y.length)]}e.getRandomElement=ie;function G(Y,Q){for(const se of Y){const le=Q(se);if(le!==void 0)return le}}e.mapFind=G;function j(Y,Q,se){const le=x(Y,Q),ue=Y.length,pe=se.length;Y.length=ue+pe;for(let we=ue-1;we>=le;we--)Y[we+pe]=Y[we];for(let we=0;we<pe;we++)Y[we+le]=se[we]}e.insertInto=j;function V(Y,Q,se,le){const ue=x(Y,Q),pe=Y.splice(ue,se);return j(Y,ue,le),pe}e.splice=V;function x(Y,Q){return Q<0?Math.max(Q+Y.length,0):Math.min(Q,Y.length)}var ee;(function(Y){function Q(ue){return ue<0}Y.isLessThan=Q;function se(ue){return ue>0}Y.isGreaterThan=se;function le(ue){return ue===0}Y.isNeitherLessOrGreaterThan=le,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function re(Y,Q){return(se,le)=>Q(Y(se),Y(le))}e.compareBy=re;function te(...Y){return(Q,se)=>{for(const le of Y){const ue=le(Q,se);if(!ee.isNeitherLessOrGreaterThan(ue))return ue}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const U=(Y,Q)=>Y-Q;e.numberComparator=U;function B(Y,Q){if(Y.length===0)return;let se=Y[0];for(let le=1;le<Y.length;le++){const ue=Y[le];Q(ue,se)>0&&(se=ue)}return se}e.findMaxBy=B;function W(Y,Q){if(Y.length===0)return;let se=Y[0];for(let le=1;le<Y.length;le++){const ue=Y[le];Q(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=W;function q(Y,Q){return B(Y,(se,le)=>-Q(se,le))}e.findMinBy=q;class J{constructor(Q){this.f=Q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let se=this.c;for(;se<this.f.length&&Q(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(Q){let se=this.d;for(;se>=0&&Q(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Q=this.f[this.c];return this.c++,Q}removeLast(){const Q=this.f[this.d];return this.d--,Q}takeCount(Q){const se=this.f.slice(this.c,this.c+Q);return this.c+=Q,se}}e.ArrayQueue=J;class _{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(se=>(Q(se),!0))}toArray(){const Q=[];return this.iterate(se=>(Q.push(se),!0)),Q}filter(Q){return new _(se=>this.iterate(le=>Q(le)?se(le):!0))}map(Q){return new _(se=>this.iterate(le=>se(Q(le))))}some(Q){let se=!1;return this.iterate(le=>(se=Q(le),!se)),se}findFirst(Q){let se;return this.iterate(le=>Q(le)?(se=le,!1):!0),se}findLast(Q){let se;return this.iterate(le=>(Q(le)&&(se=le),!0)),se}findLastMaxBy(Q){let se,le=!0;return this.iterate(ue=>((le||ee.isGreaterThan(Q(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=_,_.empty=new _(Y=>{})}),define(oe[129],ae([0,1,7]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(I,y){if(!I)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=i;function D(I,y="Unreachable"){throw new Error(y)}e.assertNever=D;function k(I){if(!I)throw new L.BugIndicatingError("Assertion Failed")}e.assert=k;function N(I){if(!I()){debugger;I(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function P(I,y){let C=0;for(;C<I.length-1;){const w=I[C],g=I[C+1];if(!y(w,g))return!1;C++}return!0}e.checkAdjacentItems=P}),define(oe[82],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(i){const D=this;let k=!1,N;return function(){return k||(k=!0,N=i.apply(D,arguments)),N}}e.once=L}),define(oe[64],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(i){function D(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}i.is=D;const k=Object.freeze([]);function N(){return k}i.empty=N;function*P(S){yield S}i.single=P;function I(S){return D(S)?S:P(S)}i.wrap=I;function y(S){return S||k}i.from=y;function C(S){return!S||S[Symbol.iterator]().next().done===!0}i.isEmpty=C;function w(S){return S[Symbol.iterator]().next().value}i.first=w;function g(S,R){for(const s of S)if(R(s))return!0;return!1}i.some=g;function m(S,R){for(const s of S)if(R(s))return s}i.find=m;function*f(S,R){for(const s of S)R(s)&&(yield s)}i.filter=f;function*v(S,R){let s=0;for(const c of S)yield R(c,s++)}i.map=v;function*u(...S){for(const R of S)for(const s of R)yield s}i.concat=u;function l(S,R,s){let c=s;for(const t of S)c=R(c,t);return c}i.reduce=l;function*d(S,R,s=S.length){for(R<0&&(R+=S.length),s<0?s+=S.length:s>S.length&&(s=S.length);R<s;R++)yield S[R]}i.slice=d;function p(S,R=Number.POSITIVE_INFINITY){const s=[];if(R===0)return[s,S];const c=S[Symbol.iterator]();for(let t=0;t<R;t++){const n=c.next();if(n.done)return[s,i.empty()];s.push(n.value)}return[s,{[Symbol.iterator](){return c}}]}i.consume=p})(L=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var i;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(s){s.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function N(s,c=!1){let t=0;const n=s.length;let r="",o=0,a=16,h=0;function b($){let z=0,H=0;for(;z<$;){const X=s.charCodeAt(t);if(X>=48&&X<=57)H=H*16+X-48;else if(X>=65&&X<=70)H=H*16+X-65+10;else if(X>=97&&X<=102)H=H*16+X-97+10;else break;t++,z++}return z<$&&(H=-1),H}function E($){t=$,r="",o=0,a=16,h=0}function T(){const $=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&y(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&y(s.charCodeAt(t)))for(t++;t<s.length&&y(s.charCodeAt(t));)t++;else return h=3,s.substring($,t);let z=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&y(s.charCodeAt(t))){for(t++;t<s.length&&y(s.charCodeAt(t));)t++;z=t}else h=3;return s.substring($,z)}function O(){let $="",z=t;for(;;){if(t>=n){$+=s.substring(z,t),h=2;break}const H=s.charCodeAt(t);if(H===34){$+=s.substring(z,t),t++;break}if(H===92){if($+=s.substring(z,t),t++,t>=n){h=2;break}switch(s.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const ie=b(4);ie>=0?$+=String.fromCharCode(ie):h=4;break}default:h=5}z=t;continue}if(H>=0&&H<=31)if(I(H)){$+=s.substring(z,t),h=2;break}else h=6;t++}return $}function M(){if(r="",h=0,o=t,t>=n)return o=n,a=17;let $=s.charCodeAt(t);if(P($)){do t++,r+=String.fromCharCode($),$=s.charCodeAt(t);while(P($));return a=15}if(I($))return t++,r+=String.fromCharCode($),$===13&&s.charCodeAt(t)===10&&(t++,r+=`
`),a=14;switch($){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,r=O(),a=10;case 47:{const z=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<n&&!I(s.charCodeAt(t));)t++;return r=s.substring(z,t),a=12}if(s.charCodeAt(t+1)===42){t+=2;const H=n-1;let X=!1;for(;t<H;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,X=!0;break}t++}return X||(t++,h=1),r=s.substring(z,t),a=13}return r+=String.fromCharCode($),t++,a=16}case 45:if(r+=String.fromCharCode($),t++,t===n||!y(s.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),a=11;default:for(;t<n&&F($);)t++,$=s.charCodeAt(t);if(o!==t){switch(r=s.substring(o,t),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode($),t++,a=16}}function F($){if(P($)||I($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:E,getPosition:()=>t,scan:c?A:M,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>h}}e.createScanner=N;function P(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function I(s){return s===10||s===13||s===8232||s===8233}function y(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function w(s,c){const t=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(b,E,T,O){o.value=b,o.offset=E,o.length=T,o.type=O,o.colonOffset=void 0,r=o}try{p(s,{onObjectBegin:(b,E)=>{if(c<=b)throw n;r=void 0,a=c>b,t.push("")},onObjectProperty:(b,E,T)=>{if(c<E||(h(b,E,T,"property"),t[t.length-1]=b,c<=E+T))throw n},onObjectEnd:(b,E)=>{if(c<=b)throw n;r=void 0,t.pop()},onArrayBegin:(b,E)=>{if(c<=b)throw n;r=void 0,t.push(0)},onArrayEnd:(b,E)=>{if(c<=b)throw n;r=void 0,t.pop()},onLiteralValue:(b,E,T)=>{if(c<E||(h(b,E,T,R(b)),c<=E+T))throw n},onSeparator:(b,E,T)=>{if(c<=E)throw n;if(b===":"&&r&&r.type==="property")r.colonOffset=E,a=!1,r=void 0;else if(b===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(a=!0,t[t.length-1]=""),r=void 0}}})}catch(b){if(b!==n)throw b}return{path:t,previousNode:r,isAtPropertyKey:a,matches:b=>{let E=0;for(let T=0;E<b.length&&T<t.length;T++)if(b[E]===t[T]||b[E]==="*")E++;else if(b[E]!=="**")return!1;return E===b.length}}}e.getLocation=w;function g(s,c=[],t=k.DEFAULT){let n=null,r=[];const o=[];function a(b){Array.isArray(r)?r.push(b):n!==null&&(r[n]=b)}return p(s,{onObjectBegin:()=>{const b={};a(b),o.push(r),r=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const b=[];a(b),o.push(r),r=b,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(b,E,T)=>{c.push({error:b,offset:E,length:T})}},t),r[0]}e.parse=g;function m(s,c=[],t=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function o(b){return n.children.push(b),b}p(s,{onObjectBegin:b=>{n=o({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,E,T)=>{n=o({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:E,length:T,parent:n})},onObjectEnd:(b,E)=>{n.length=b+E-n.offset,n=n.parent,r(b+E)},onArrayBegin:(b,E)=>{n=o({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,E)=>{n.length=b+E-n.offset,n=n.parent,r(b+E)},onLiteralValue:(b,E,T)=>{o({type:R(b),offset:E,length:T,parent:n,value:b}),r(E+T)},onSeparator:(b,E,T)=>{n.type==="property"&&(b===":"?n.colonOffset=E:b===","&&r(E))},onError:(b,E,T)=>{c.push({error:b,offset:E,length:T})}},t);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=m;function f(s,c){if(!s)return;let t=s;for(const n of c)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=f;function v(s){if(!s.parent||!s.parent.children)return[];const c=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;c.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&c.push(t)}return c}e.getNodePath=v;function u(s){switch(s.type){case"array":return s.children.map(u);case"object":{const c=Object.create(null);for(const t of s.children){const n=t.children[1];n&&(c[t.children[0].value]=u(n))}return c}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=u;function l(s,c,t=!1){return c>=s.offset&&c<s.offset+s.length||t&&c===s.offset+s.length}e.contains=l;function d(s,c,t=!1){if(l(s,c,t)){const n=s.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=c;r++){const o=d(n[r],c,t);if(o)return o}return s}}e.findNodeAtOffset=d;function p(s,c,t=k.DEFAULT){const n=N(s,!1);function r(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(re){return re?te=>re(te,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(c.onObjectBegin),h=o(c.onObjectProperty),b=r(c.onObjectEnd),E=r(c.onArrayBegin),T=r(c.onArrayEnd),O=o(c.onLiteralValue),M=o(c.onSeparator),F=r(c.onComment),A=o(c.onError),$=t&&t.disallowComments,z=t&&t.allowTrailingComma;function H(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:$||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(re){case 12:case 13:$?X(10):F();break;case 16:X(1);break;case 15:case 14:break;default:return re}}}function X(re,te=[],U=[]){if(A(re),te.length+U.length>0){let B=n.getToken();for(;B!==17;){if(te.indexOf(B)!==-1){H();break}else if(U.indexOf(B)!==-1)break;B=H()}}}function ie(re){const te=n.getTokenValue();return re?O(te):h(te),H(),!0}function G(){switch(n.getToken()){case 11:{let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(X(2),re=0)}catch{X(2)}O(re);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function j(){return n.getToken()!==10?(X(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(M(":"),H(),ee()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){a(),H();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||X(4,[],[]),M(","),H(),n.getToken()===2&&z)break}else re&&X(6,[],[]);j()||X(4,[],[2,5]),re=!0}return b(),n.getToken()!==2?X(7,[2],[]):H(),!0}function x(){E(),H();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||X(4,[],[]),M(","),H(),n.getToken()===4&&z)break}else re&&X(6,[],[]);ee()||X(4,[],[4,5]),re=!0}return T(),n.getToken()!==4?X(8,[4],[]):H(),!0}function ee(){switch(n.getToken()){case 3:return x();case 1:return V();case 10:return ie(!0);default:return G()}}return H(),n.getToken()===17?t.allowEmptyContent?!0:(X(4,[],[]),!1):ee()?(n.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=p;function S(s,c){const t=N(s),n=[];let r,o=0,a;do switch(a=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:o!==a&&n.push(s.substring(o,a)),c!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,c)),o=t.getPosition();break}while(r!==17);return n.join("")}e.stripComments=S;function R(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(oe[43],ae([0,1,35]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(y,C,w){let g,m,f,v,u;if(C){for(v=C.offset,u=v+C.length,f=v;f>0&&!I(y,f-1);)f--;let a=u;for(;a<y.length&&!I(y,a);)a++;m=y.substring(f,a),g=N(m,w)}else m=y,g=0,f=0,v=0,u=y.length;const l=P(w,y);let d=!1,p=0,S;w.insertSpaces?S=k(" ",w.tabSize||4):S="	";const R=(0,L.createScanner)(m,!1);let s=!1;function c(){return l+k(S,g+p)}function t(){let a=R.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=R.scan();return s=a===16||R.getTokenError()!==0,a}const n=[];function r(a,h,b){!s&&h<u&&b>v&&y.substring(h,b)!==a&&n.push({offset:h,length:b-h,content:a})}let o=t();if(o!==17){const a=R.getTokenOffset()+f,h=k(S,g);r(h,f,a)}for(;o!==17;){let a=R.getTokenOffset()+R.getTokenLength()+f,h=t(),b="";for(;!d&&(h===12||h===13);){const T=R.getTokenOffset()+f;r(" ",a,T),a=R.getTokenOffset()+R.getTokenLength()+f,b=h===12?c():"",h=t()}if(h===2)o!==1&&(p--,b=c());else if(h===4)o!==3&&(p--,b=c());else{switch(o){case 3:case 1:p++,b=c();break;case 5:case 12:b=c();break;case 13:d?b=c():b=" ";break;case 6:b=" ";break;case 10:if(h===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?b=" ":h!==5&&h!==17&&(s=!0);break;case 16:s=!0;break}d&&(h===12||h===13)&&(b=c())}const E=R.getTokenOffset()+f;r(b,a,E),o=h}return n}e.format=i;function D(y,C){const w=JSON.stringify(y,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?w.replace(/\r\n|\r|\n/g,C.eol):w}e.toFormattedString=D;function k(y,C){let w="";for(let g=0;g<C;g++)w+=y;return w}function N(y,C){let w=0,g=0;const m=C.tabSize||4;for(;w<y.length;){const f=y.charAt(w);if(f===" ")g++;else if(f==="	")g+=m;else break;w++}return Math.floor(g/m)}function P(y,C){for(let w=0;w<C.length;w++){const g=C.charAt(w);if(g==="\r")return w+1<C.length&&C.charAt(w+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=P;function I(y,C){return`\r
`.indexOf(y.charAt(C))!==-1}e.isEOL=I}),define(oe[83],ae([0,1,35,43]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(y,C,w){return k(y,C,void 0,w)}e.removeProperty=D;function k(y,C,w,g,m){const f=C.slice(),v=[],u=(0,L.parseTree)(y,v);let l,d;for(;f.length>0&&(d=f.pop(),l=(0,L.findNodeAtLocation)(u,f),l===void 0&&w!==void 0);)typeof d=="string"?w={[d]:w}:w=[w];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const p=(0,L.findNodeAtLocation)(l,[d]);if(p!==void 0)if(w===void 0){if(!p.parent)throw new Error("Malformed AST");const S=l.children.indexOf(p.parent);let R,s=p.parent.offset+p.parent.length;if(S>0){const c=l.children[S-1];R=c.offset+c.length}else R=l.offset+1,l.children.length>1&&(s=l.children[1].offset);return N(y,{offset:R,length:s-R,content:""},g)}else return N(y,{offset:p.offset,length:p.length,content:JSON.stringify(w)},g);else{if(w===void 0)return[];const S=`${JSON.stringify(d)}: ${JSON.stringify(w)}`,R=m?m(l.children.map(c=>c.children[0].value)):l.children.length;let s;if(R>0){const c=l.children[R-1];s={offset:c.offset+c.length,length:0,content:","+S}}else l.children.length===0?s={offset:l.offset+1,length:0,content:S}:s={offset:l.offset+1,length:0,content:S+","};return N(y,s,g)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(w!==void 0){const p=`${JSON.stringify(w)}`;let S;if(l.children.length===0||d===0)S={offset:l.offset+1,length:0,content:l.children.length===0?p:p+","};else{const R=d===-1||d>l.children.length?l.children.length:d,s=l.children[R-1];S={offset:s.offset+s.length,length:0,content:","+p}}return N(y,S,g)}else{const p=d,S=l.children[p];let R;if(l.children.length===1)R={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===p){const s=l.children[p-1],c=s.offset+s.length,t=l.offset+l.length;R={offset:c,length:t-2-c,content:""}}else R={offset:S.offset,length:l.children[p+1].offset-S.offset,content:""};return N(y,R,g)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return N(y,{offset:u?u.offset:0,length:u?u.length:0,content:JSON.stringify(w)},g)}}e.setProperty=k;function N(y,C,w){let g=P(y,C),m=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;m>0&&!(0,i.isEOL)(g,m-1);)m--;for(;f<g.length&&!(0,i.isEOL)(g,f);)f++}const v=(0,i.format)(g,{offset:m,length:f-m},w);for(let l=v.length-1;l>=0;l--){const d=v[l];g=P(g,d),m=Math.min(m,d.offset),f=Math.max(f,d.offset+d.length),f+=d.content.length-d.length}const u=y.length-(g.length-f)-m;return[{offset:m,length:u,content:g.substring(m,f)}]}e.withFormatting=N;function P(y,C){return y.substring(0,C.offset)+C.content+y.substring(C.offset+C.length)}e.applyEdit=P;function I(y,C){const w=C.slice(0).sort((m,f)=>{const v=m.offset-f.offset;return v===0?m.length-f.length:v});let g=y.length;for(let m=w.length-1;m>=0;m--){const f=w[m];if(f.offset+f.length<=g)y=P(y,f);else throw new Error("Overlapping edit");g=f.offset}return y}e.applyEdits=I}),define(oe[130],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=L}),define(oe[2],ae([0,1,82,64]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function N(o){k=o}if(e.setDisposableTracker=N,D){const o="__is_disposable_tracked__";N(new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(h)},3e3)}setParent(a,h){if(a&&a!==d.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==d.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function P(o){return k?.trackDisposable(o),o}function I(o){k?.markAsDisposed(o)}function y(o,a){k?.setParent(o,a)}function C(o,a){if(!!k)for(const h of o)k.setParent(h,a)}function w(o){return k?.markAsSingleton(o),o}e.markAsSingleton=w;function g(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=g;function m(o){if(i.Iterable.is(o)){const a=[];for(const h of o)if(h)try{h.dispose()}catch(b){a.push(b)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=m;function f(o){for(const a of o)g(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function v(...o){const a=u(()=>m(o));return C(o,a),a}e.combinedDisposable=v;function u(o){const a=P({dispose:(0,L.once)(()=>{I(a),o()})});return a}e.toDisposable=u;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{m(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return y(a,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new l,P(this),y(this.q,this)}dispose(){I(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&y(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&y(a,null),a}}e.MutableDisposable=p;class S{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let h=a;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,I(this))},this}}e.SafeDisposable=R;class s{constructor(){this.a=new Map}acquire(a,...h){let b=this.a.get(a);b||(b={counter:0,object:this.b(a,...h)},this.a.set(a,b));const{object:E}=b,T=(0,L.once)(()=>{--b.counter===0&&(this.c(a,b.object),this.a.delete(a))});return b.counter++,{object:E,dispose:T}}}e.ReferenceCollection=s;class c{constructor(a){this.a=a}async acquire(a,...h){const b=this.a.acquire(a,...h);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(E){throw b.dispose(),E}}}e.AsyncReferenceCollection=c;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function n(o){const a=new l;try{o(a)}finally{a.dispose()}}e.disposeOnReturn=n;class r{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,h,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(a)?.dispose(),this.a.set(a,h)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(oe[84],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(k){this.element=k,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class i{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let k=this.a;for(;k!==L.Undefined;){const N=k.next;k.prev=L.Undefined,k.next=L.Undefined,k=N}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,N){const P=new L(k);if(this.a===L.Undefined)this.a=P,this.b=P;else if(N){const y=this.b;this.b=P,P.prev=y,y.next=P}else{const y=this.a;this.a=P,P.next=y,y.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==L.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==L.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==L.Undefined&&k.next!==L.Undefined){const N=k.prev;N.next=k.next,k.next.prev=N}else k.prev===L.Undefined&&k.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):k.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):k.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==L.Undefined;)yield k.element,k=k.next}}e.LinkedList=i}),define(oe[37],ae([0,1]),function(Z,e){"use strict";var L,i,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(f,v,u){let l=f.get(v);return l===void 0&&(l=u,f.set(v,l)),l}e.getOrSet=k;function N(f){const v=[];return f.forEach((u,l)=>{v.push(`${l} => ${u}`)}),`Map(${f.size}) {${v.join(", ")}}`}e.mapToString=N;function P(f){const v=[];return f.forEach(u=>{v.push(u)}),`Set(${f.size}) {${v.join(", ")}}`}e.setToString=P;class I{constructor(v,u){this.uri=v,this.value=u}}class y{constructor(v,u){this[L]="ResourceMap",v instanceof y?(this.b=new Map(v.b),this.c=u??y.a):(this.b=new Map,this.c=v??y.a)}set(v,u){return this.b.set(this.c(v),new I(v,u)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,u){typeof u<"u"&&(v=v.bind(u));for(const[l,d]of this.b)v(d.value,d.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}e.ResourceMap=y,y.a=f=>f.toString();class C{constructor(v,u){this[i]="ResourceSet",!v||typeof v=="function"?this.a=new y(v):(this.a=new y(u),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,u){this.a.forEach((l,d)=>v.call(u,d,d,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class g{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,u=0){const l=this.a.get(v);if(!!l)return u!==0&&this.j(l,u),l.value}set(v,u,l=0){let d=this.a.get(v);if(d)d.value=u,l!==0&&this.j(d,l);else{switch(d={key:v,value:u,next:void 0,previous:void 0},l){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(v,d),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const u=this.a.get(v);if(!!u)return this.a.delete(v),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,u){const l=this.e;let d=this.b;for(;d;){if(u?v.bind(u)(d.value,d.key,this):v(d.value,d.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const v=this,u=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(v.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.key,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return d}values(){const v=this,u=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(v.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.value,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return d}entries(){const v=this,u=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(v.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:[l.key,l.value],done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return d}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let u=this.b,l=this.size;for(;u&&l>v;)this.a.delete(u.key),u=u.next,l--;this.b=u,this.d=l,u&&(u.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const u=v.next,l=v.previous;if(!u||!l)throw new Error("Invalid list");u.previous=l,l.next=u}v.next=void 0,v.previous=void 0,this.e++}j(v,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(v===this.b)return;const l=v.next,d=v.previous;v===this.c?(d.next=void 0,this.c=d):(l.previous=d,d.next=l),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(u===2){if(v===this.c)return;const l=v.next,d=v.previous;v===this.b?(l.previous=void 0,this.b=l):(l.previous=d,d.next=l),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((u,l)=>{v.push([l,u])}),v}fromJSON(v){this.clear();for(const[u,l]of v)this.set(u,l)}}e.LinkedMap=g;class m extends g{constructor(v,u=1){super(),this.k=v,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,u=2){return super.get(v,u)}peek(v){return super.get(v,0)}set(v,u){return super.set(v,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=m}),define(oe[85],ae([0,1,37]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new L.LRUCache(1e4);function D(y){return I(y,"NFC",i)}e.normalizeNFC=D;const k=new L.LRUCache(1e4);function N(y){return I(y,"NFD",k)}e.normalizeNFD=N;const P=/[^\u0000-\u0080]/;function I(y,C,w){if(!y)return y;const g=w.get(y);if(g)return g;let m;return P.test(y)?m=y.normalize(C):m=y,w.set(y,m),m}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(C){return N(C).replace(y,"")}}()}),define(oe[131],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(P,I,y){return Math.min(Math.max(P,I),y)}e.clamp=L;function i(P,I){return(I+P%I)%I}e.rot=i;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class k{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=k;class N{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const y=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function Z(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function N(I){k.push(I,Date.now())}function P(){const I=[];for(let y=0;y<k.length;y+=2)I.push({name:k[y],startTime:k[y+1]});return I}return{mark:N,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const N of performance.getEntriesByType("mark"))k.push({name:N.name,startTime:Math.round(D+N.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function L(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=L(i))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var i in L)(typeof exports=="object"?exports:Z)[i]=L[i]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function L(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return Z[i].call(D.exports,D,D.exports,L),D.l=!0,D.exports}return L.m=Z,L.c=e,L.d=function(i,D,k){L.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:k})},L.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},L.t=function(i,D){if(1&D&&(i=L(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var k=Object.create(null);if(L.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var N in i)L.d(k,N,function(P){return i[P]}.bind(null,N));return k},L.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return L.d(D,"a",D),D},L.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},L.p="",L(L.s=0)}([function(Z,e,L){(function(i){var D;e=Z.exports=U,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],y=0,C=y++;I[C]="0|[1-9]\\d*";var w=y++;I[w]="[0-9]+";var g=y++;I[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=y++;I[m]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var f=y++;I[f]="("+I[w]+")\\.("+I[w]+")\\.("+I[w]+")";var v=y++;I[v]="(?:"+I[C]+"|"+I[g]+")";var u=y++;I[u]="(?:"+I[w]+"|"+I[g]+")";var l=y++;I[l]="(?:-("+I[v]+"(?:\\."+I[v]+")*))";var d=y++;I[d]="(?:-?("+I[u]+"(?:\\."+I[u]+")*))";var p=y++;I[p]="[0-9A-Za-z-]+";var S=y++;I[S]="(?:\\+("+I[p]+"(?:\\."+I[p]+")*))";var R=y++,s="v?"+I[m]+I[l]+"?"+I[S]+"?";I[R]="^"+s+"$";var c="[v=\\s]*"+I[f]+I[d]+"?"+I[S]+"?",t=y++;I[t]="^"+c+"$";var n=y++;I[n]="((?:<|>)?=?)";var r=y++;I[r]=I[w]+"|x|X|\\*";var o=y++;I[o]=I[C]+"|x|X|\\*";var a=y++;I[a]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[l]+")?"+I[S]+"?)?)?";var h=y++;I[h]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[d]+")?"+I[S]+"?)?)?";var b=y++;I[b]="^"+I[n]+"\\s*"+I[a]+"$";var E=y++;I[E]="^"+I[n]+"\\s*"+I[h]+"$";var T=y++;I[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=y++;I[O]="(?:~>?)";var M=y++;I[M]="(\\s*)"+I[O]+"\\s+",P[M]=new RegExp(I[M],"g");var F=y++;I[F]="^"+I[O]+I[a]+"$";var A=y++;I[A]="^"+I[O]+I[h]+"$";var $=y++;I[$]="(?:\\^)";var z=y++;I[z]="(\\s*)"+I[$]+"\\s+",P[z]=new RegExp(I[z],"g");var H=y++;I[H]="^"+I[$]+I[a]+"$";var X=y++;I[X]="^"+I[$]+I[h]+"$";var ie=y++;I[ie]="^"+I[n]+"\\s*("+c+")$|^$";var G=y++;I[G]="^"+I[n]+"\\s*("+s+")$|^$";var j=y++;I[j]="(\\s*)"+I[n]+"\\s*("+c+"|"+I[a]+")",P[j]=new RegExp(I[j],"g");var V=y++;I[V]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var x=y++;I[x]="^\\s*("+I[h]+")\\s+-\\s+("+I[h]+")\\s*$";var ee=y++;I[ee]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)D(re,I[re]),P[re]||(P[re]=new RegExp(I[re]));function te(ce,de){if(ce instanceof U)return ce;if(typeof ce!="string"||ce.length>k||!(de?P[t]:P[R]).test(ce))return null;try{return new U(ce,de)}catch{return null}}function U(ce,de){if(ce instanceof U){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof U))return new U(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[R]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<N)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ce,de){var ge=te(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=te(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof U||(ce=new U(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},U.prototype.compareMain=function(ce){return ce instanceof U||(ce=new U(ce,this.loose)),W(this.major,ce.major)||W(this.minor,ce.minor)||W(this.patch,ce.patch)},U.prototype.comparePre=function(ce){if(ce instanceof U||(ce=new U(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return W(ge,Ce)}while(++de)},U.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new U(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(Y(ce,de))return null;var ge=te(ce),Ce=te(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=W;var B=/^[0-9]+$/;function W(ce,de){var ge=B.test(ce),Ce=B.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function q(ce,de,ge){return new U(ce,ge).compare(new U(de,ge))}function J(ce,de,ge){return q(ce,de,ge)>0}function _(ce,de,ge){return q(ce,de,ge)<0}function Y(ce,de,ge){return q(ce,de,ge)===0}function Q(ce,de,ge){return q(ce,de,ge)!==0}function se(ce,de,ge){return q(ce,de,ge)>=0}function le(ce,de,ge){return q(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=Y(ce,ge,Ce);break;case"!=":Pe=Q(ce,ge,Ce);break;case">":Pe=J(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=_(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function pe(ce,de){if(ce instanceof pe){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===we?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return W(de,ce)},e.major=function(ce,de){return new U(ce,de).major},e.minor=function(ce,de){return new U(ce,de).minor},e.patch=function(ce,de){return new U(ce,de).patch},e.compare=q,e.compareLoose=function(ce,de){return q(ce,de,!0)},e.rcompare=function(ce,de,ge){return q(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=J,e.lt=_,e.eq=Y,e.neq=Q,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=pe;var we={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof pe)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Te(ce,de,ge,Ce,Pe,Ae,De,je,Oe,Fe,ze,ke,Ne){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Oe)?"":Ee(Fe)?"<"+(+Oe+1)+".0.0":Ee(ze)?"<"+Oe+"."+(+Fe+1)+".0":ke?"<="+Oe+"."+Fe+"."+ze+"-"+ke:"<="+je)).trim()}function Ue(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==we&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function Be(ce,de,ge,Ce){var Pe,Ae,De,je,Oe;switch(ce=new U(ce,Ce),de=new be(de,Ce),ge){case">":Pe=J,Ae=le,De=_,je=">",Oe=">=";break;case"<":Pe=_,Ae=se,De=J,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var ze=de.set[Fe],ke=null,Ne=null;if(ze.forEach(function(ne){ne.semver===we&&(ne=new pe(">=0.0.0")),ke=ke||ne,Ne=Ne||ne,Pe(ne.semver,ke.semver,Ce)?ke=ne:De(ne.semver,Ne.semver,Ce)&&(Ne=ne)}),ke.operator===je||ke.operator===Oe||(!Ne.operator||Ne.operator===je)&&Ae(ce,Ne.semver)||Ne.operator===Oe&&De(ce,Ne.semver))return!1}return!0}pe.prototype.parse=function(ce){var de=this.loose?P[ie]:P[G],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===we||(typeof ce=="string"&&(ce=new U(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,de){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?P[x]:P[V];ce=ce.replace(ge,Te),D("hyphen replace",ce),ce=ce.replace(P[j],"$1$2$3"),D("comparator trim",ce,P[j]),ce=(ce=(ce=ce.replace(P[M],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var Ce=de?P[ie]:P[G],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(ze){return function(ke,Ne){D("caret",ke,Ne);var ne=Ne?P[X]:P[H];return ke.replace(ne,function(he,fe,me,ve,Ie){var Re;return D("caret",ke,he,fe,me,ve,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(ve)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+me+"."+(+ve+1):">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ve+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+ve+" <"+fe+"."+me+"."+(+ve+1):">="+fe+"."+me+"."+ve+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ve+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),D("caret",De),De=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(ze){return function(ke,Ne){var ne=Ne?P[A]:P[F];return ke.replace(ne,function(he,fe,me,ve,Ie){var Re;return D("tilde",ke,he,fe,me,ve,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(ve)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+ve+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),D("tildes",De),De=function(Oe,Fe){return D("replaceXRanges",Oe,Fe),Oe.split(/\s+/).map(function(ze){return function(ke,Ne){ke=ke.trim();var ne=Ne?P[E]:P[b];return ke.replace(ne,function(he,fe,me,ve,Ie,Re){D("xRange",ke,he,fe,me,ve,Ie,Re);var He=Ee(me),$e=He||Ee(ve),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(ve=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,ve=0,Ie=0):Le&&(ve=+ve+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:ve=+ve+1),he=fe+me+"."+ve+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0"),D("xRange return",he),he})}(ze,Fe)}).join(" ")}(De,je),D("xrange",De),De=function(Oe,Fe){return D("replaceStars",Oe,Fe),Oe.trim().replace(P[ee],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new pe(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new U(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Ue(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new U(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new U(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return Be(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return Be(ce,de,">",ge)},e.outside=Be,e.prerelease=function(ce,de){var ge=te(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof U)return ce;if(typeof ce!="string")return null;var de=ce.match(P[T]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,L(1))},function(Z,e){var L,i,D=Z.exports={};function k(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function P(u){if(L===setTimeout)return setTimeout(u,0);if((L===k||!L)&&setTimeout)return L=setTimeout,setTimeout(u,0);try{return L(u,0)}catch{try{return L.call(null,u,0)}catch{return L.call(this,u,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:k}catch{L=k}try{i=typeof clearTimeout=="function"?clearTimeout:N}catch{i=N}})();var I,y=[],C=!1,w=-1;function g(){C&&I&&(C=!1,I.length?y=I.concat(y):w=-1,y.length&&m())}function m(){if(!C){var u=P(g);C=!0;for(var l=y.length;l;){for(I=y,y=[];++w<l;)I&&I[w].run();w=-1,l=y.length}I=null,C=!1,function(d){if(i===clearTimeout)return clearTimeout(d);if((i===N||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(d);try{i(d)}catch{try{return i.call(null,d)}catch{return i.call(this,d)}}}(u)}}function f(u,l){this.fun=u,this.array=l}function v(){}D.nextTick=function(u){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];y.push(new f(u,l)),y.length!==1||C||P(m)},f.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=v,D.addListener=v,D.once=v,D.off=v,D.removeListener=v,D.removeAllListeners=v,D.emit=v,D.prependListener=v,D.prependOnceListener=v,D.listeners=function(u){return[]},D.binding=function(u){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(u){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[132],ae([0,1]),function(Z,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,I,y){this.level=P,this.key=I,this.value=y,this.forward=[]}}const D=void 0;class k{constructor(P,I=2**16){this.comparator=P,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new i(this.c,D,D)}get size(){return this.f}clear(){this.e=new i(this.c,D,D)}has(P){return Boolean(k.g(this,P,this.comparator))}get(P){return k.g(this,P,this.comparator)?.value}set(P,I){return k.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=k.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let y=this.e.forward[0];for(;y;)P.call(I,y.value,y.key,this),y=y.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,y){let C=P.e;for(let w=P.d-1;w>=0;w--)for(;C.forward[w]&&y(C.forward[w].key,I)<0;)C=C.forward[w];if(C=C.forward[0],C&&y(C.key,I)===0)return C}static h(P,I,y,C){const w=[];let g=P.e;for(let m=P.d-1;m>=0;m--){for(;g.forward[m]&&C(g.forward[m].key,I)<0;)g=g.forward[m];w[m]=g}if(g=g.forward[0],g&&C(g.key,I)===0)return g.value=y,!1;{const m=k.j(P);if(m>P.d){for(let f=P.d;f<m;f++)w[f]=P.e;P.d=m}g=new i(m,I,y);for(let f=0;f<m;f++)g.forward[f]=w[f].forward[f],w[f].forward[f]=g;return!0}}static j(P,I=.5){let y=1;for(;Math.random()<I&&y<P.c;)y+=1;return y}static k(P,I,y){const C=[];let w=P.e;for(let g=P.d-1;g>=0;g--){for(;w.forward[g]&&y(w.forward[g].key,I)<0;)w=w.forward[g];C[g]=w}if(w=w.forward[0],!w||y(w.key,I)!==0)return!1;for(let g=0;g<P.d&&C[g].forward[g]===w;g++)C[g].forward[g]=w.forward[g];for(;P.d>0&&P.e.forward[P.d-1]===D;)P.d-=1;return!0}}e.SkipList=k}),define(oe[44],ae([0,1,7,2]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(S){const R=S;return R?typeof R.read=="function":!1}e.isReadable=D;function k(S){const R=S;return R?[R.on,R.pause,R.resume,R.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=k;function N(S){const R=S;return R?k(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=N;function P(S,R){return new I(S,R)}e.newWriteableStream=P;class I{constructor(R,s){this.e=R,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(s=>s(R))}h(R){this.c.error.length===0?(0,L.onUnexpectedError)(R):this.c.error.slice(0).forEach(s=>s(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,s){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(R,s){if(this.a.destroyed)return;let c;switch(R){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const t=c.indexOf(s);t>=0&&c.splice(t,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(S,R){const s=[];let c;for(;(c=S.read())!==null;)s.push(c);return R(s)}e.consumeReadable=y;function C(S,R,s){const c=[];let t;for(;(t=S.read())!==null&&c.length<s;)c.push(t);return t===null&&c.length>0?R(c):{read:()=>{if(c.length>0)return c.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return S.read()}}}e.peekReadable=C;function w(S,R){return new Promise((s,c)=>{const t=[];g(S,{onData:n=>{R&&t.push(n)},onError:n=>{R?c(n):s(void 0)},onEnd:()=>{s(R?R(t):void 0)}})})}e.consumeStream=w;function g(S,R){let s=!1;return S.on("error",c=>{s||R.onError(c)}),S.on("end",()=>{s||R.onEnd()}),S.on("data",c=>{s||R.onData(c)}),(0,i.toDisposable)(()=>s=!0)}e.listenStream=g;function m(S,R){return new Promise((s,c)=>{const t=new i.DisposableStore,n=[],r=h=>{if(n.push(h),n.length>R)return t.dispose(),S.pause(),s({stream:S,buffer:n,ended:!1})},o=h=>c(h),a=()=>s({stream:S,buffer:n,ended:!0});t.add((0,i.toDisposable)(()=>S.removeListener("error",o))),S.on("error",o),t.add((0,i.toDisposable)(()=>S.removeListener("end",a))),S.on("end",a),t.add((0,i.toDisposable)(()=>S.removeListener("data",r))),S.on("data",r)})}e.peekStream=m;function f(S,R){const s=P(R);return s.end(S),s}e.toStream=f;function v(){const S=P(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=v;function u(S){let R=!1;return{read:()=>R?null:(R=!0,S)}}e.toReadable=u;function l(S,R,s){const c=P(s);return g(S,{onData:t=>c.write(R.data(t)),onError:t=>c.error(R.error?R.error(t):t),onEnd:()=>c.end()}),c}e.transform=l;function d(S,R,s){let c=!1;return{read:()=>{const t=R.read();return c?t:(c=!0,t!==null?s([S,t]):S)}}}e.prefixedReadable=d;function p(S,R,s){let c=!1;const t=P(s);return g(R,{onData:n=>c?t.write(n):(c=!0,t.write(s([S,n]))),onError:n=>t.error(n),onEnd:()=>{c||(c=!0,t.write(S)),t.end()}}),t}e.prefixedStream=p}),define(oe[17],ae([0,1,44]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let D,k;class N{static alloc(h){return i?new N(Buffer.allocUnsafe(h)):new N(new Uint8Array(h))}static wrap(h){return i&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new N(h)}static fromString(h,b){return!(b?.dontUseNodeBuffer||!1)&&i?new N(Buffer.from(h)):(D||(D=new TextEncoder),new N(D.encode(h)))}static fromByteArray(h){const b=N.alloc(h.length);for(let E=0,T=h.length;E<T;E++)b.buffer[E]=h[E];return b}static concat(h,b){if(typeof b>"u"){b=0;for(let O=0,M=h.length;O<M;O++)b+=h[O].byteLength}const E=N.alloc(b);let T=0;for(let O=0,M=h.length;O<M;O++){const F=h[O];E.set(F,T),T+=F.byteLength}return E}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=N.alloc(this.byteLength);return h.set(this),h}toString(){return i?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(h,b){return new N(this.buffer.subarray(h,b))}set(h,b){if(h instanceof N)this.buffer.set(h.buffer,b);else if(h instanceof Uint8Array)this.buffer.set(h,b);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),b);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return y(this.buffer,h)}writeUInt32BE(h,b){C(this.buffer,h,b)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,b){g(this.buffer,h,b)}readUInt8(h){return m(this.buffer,h)}writeUInt8(h,b){f(this.buffer,h,b)}}e.VSBuffer=N;function P(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=P;function I(a,h,b){a[b+0]=h&255,h=h>>>8,a[b+1]=h&255}e.writeUInt16LE=I;function y(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=y;function C(a,h,b){a[b+3]=h,h=h>>>8,a[b+2]=h,h=h>>>8,a[b+1]=h,h=h>>>8,a[b]=h}e.writeUInt32BE=C;function w(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=w;function g(a,h,b){a[b+0]=h&255,h=h>>>8,a[b+1]=h&255,h=h>>>8,a[b+2]=h&255,h=h>>>8,a[b+3]=h&255}e.writeUInt32LE=g;function m(a,h){return a[h]}e.readUInt8=m;function f(a,h,b){a[b]=h}e.writeUInt8=f;function v(a){return L.consumeReadable(a,h=>N.concat(h))}e.readableToBuffer=v;function u(a){return L.toReadable(a)}e.bufferToReadable=u;function l(a){return L.consumeStream(a,h=>N.concat(h))}e.streamToBuffer=l;async function d(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=d;function p(a){return L.toStream(a,h=>N.concat(h))}e.bufferToStream=p;function S(a){return L.transform(a,{data:h=>typeof h=="string"?N.fromString(h):N.wrap(h)},h=>N.concat(h))}e.streamToBufferReadableStream=S;function R(a){return L.newWriteableStream(h=>N.concat(h),a)}e.newWriteableBufferStream=R;function s(a,h){return L.prefixedReadable(a,h,b=>N.concat(b))}e.prefixedBufferReadable=s;function c(a,h){return L.prefixedStream(a,h,b=>N.concat(b))}e.prefixedBufferStream=c;function t(a){let h=0,b=0,E=0;const T=new Uint8Array(Math.floor(a.length/4*3)),O=F=>{switch(b){case 3:T[E++]=h|F,b=0;break;case 2:T[E++]=h|F>>>2,h=F<<6,b=3;break;case 1:T[E++]=h|F>>>4,h=F<<4,b=2;break;default:h=F<<2,b=1}};for(let F=0;F<a.length;F++){const A=a.charCodeAt(F);if(A>=65&&A<=90)O(A-65);else if(A>=97&&A<=122)O(A-97+26);else if(A>=48&&A<=57)O(A-48+52);else if(A===43||A===45)O(62);else if(A===47||A===95)O(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${a[F]}`)}}const M=E;for(;b>0;)O(0);return N.wrap(T).slice(0,M)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},h=!0,b=!1){const E=b?r:n;let T="";const O=a.byteLength%3;let M=0;for(;M<a.byteLength-O;M+=3){const F=a[M+0],A=a[M+1],$=a[M+2];T+=E[F>>>2],T+=E[(F<<4|A>>>4)&63],T+=E[(A<<2|$>>>6)&63],T+=E[$&63]}if(O===1){const F=a[M+0];T+=E[F>>>2],T+=E[F<<4&63],h&&(T+="==")}else if(O===2){const F=a[M+0],A=a[M+1];T+=E[F>>>2],T+=E[(F<<4|A>>>4)&63],T+=E[A<<2&63],h&&(T+="=")}return T}e.encodeBase64=o}),define(oe[13],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(c){return typeof c=="string"}e.isString=L;function i(c){return Array.isArray(c)&&c.every(t=>L(t))}e.isStringArray=i;function D(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=D;function k(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.isTypedArray=k;function N(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=N;function P(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=P;function I(c){return c===!0||c===!1}e.isBoolean=I;function y(c){return typeof c>"u"}e.isUndefined=y;function C(c){return!w(c)}e.isDefined=C;function w(c){return y(c)||c===null}e.isUndefinedOrNull=w;function g(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=g;function m(c){if(w(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=m;function f(...c){const t=[];for(let n=0;n<c.length;n++){const r=c[n];if(w(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(r)}return t}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function u(c){if(!D(c))return!1;for(const t in c)if(v.call(c,t))return!1;return!0}e.isEmptyObject=u;function l(c){return typeof c=="function"}e.isFunction=l;function d(...c){return c.length>0&&c.every(l)}e.areFunctions=d;function p(c,t){const n=Math.min(c.length,t.length);for(let r=0;r<n;r++)S(c[r],t[r])}e.validateConstraints=p;function S(c,t){if(L(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(c instanceof t)return}catch{}if(!w(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function R(c){return c===null?void 0:c}e.withNullAsUndefined=R;function s(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=s}),define(oe[32],ae([0,1,13]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([p,S])=>{d[p]=S&&typeof S=="object"?i(S):S}),d}e.deepClone=i;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const S in p)if(k.call(p,S)){const R=p[S];typeof R=="object"&&!Object.isFrozen(R)&&!(0,L.isTypedArray)(R)&&d.push(R)}}return l}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function N(l,d){return P(l,d,new Set)}e.cloneAndChange=N;function P(l,d,p){if((0,L.isUndefinedOrNull)(l))return l;const S=d(l);if(typeof S<"u")return S;if(Array.isArray(l)){const R=[];for(const s of l)R.push(P(s,d,p));return R}if((0,L.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const R={};for(const s in l)k.call(l,s)&&(R[s]=P(l[s],d,p));return p.delete(l),R}return l}function I(l,d,p=!0){return(0,L.isObject)(l)?((0,L.isObject)(d)&&Object.keys(d).forEach(S=>{S in l?p&&((0,L.isObject)(l[S])&&(0,L.isObject)(d[S])?I(l[S],d[S],p):l[S]=d[S]):l[S]=d[S]}),l):d}e.mixin=I;function y(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let p,S;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(p=0;p<l.length;p++)if(!y(l[p],d[p]))return!1}else{const R=[];for(S in l)R.push(S);R.sort();const s=[];for(S in d)s.push(S);if(s.sort(),!y(R,s))return!1;for(p=0;p<R.length;p++)if(!y(l[R[p]],d[R[p]]))return!1}return!0}e.equals=y;function C(l){const d=new Set;return JSON.stringify(l,(p,S)=>{if((0,L.isObject)(S)||Array.isArray(S)){if(d.has(S))return"[Circular]";d.add(S)}return S})}e.safeStringify=C;function w(l,d){const p=Object.create(null);return!l||!d||Object.keys(d).forEach(R=>{const s=l[R],c=d[R];y(s,c)||(p[R]=c)}),p}e.distinct=w;function g(l,d){const p=d.toLowerCase(),S=Object.keys(l).find(R=>R.toLowerCase()===p);return S?l[S]:l[d]}e.getCaseInsensitive=g;function m(l,d){const p=Object.create(null);for(const[S,R]of Object.entries(l))d(S,R)&&(p[S]=R);return p}e.filter=m;function f(l){let d=[],p=Object.getPrototypeOf(l);for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}e.getAllPropertyNames=f;function v(l){const d=[];for(const p of f(l))typeof l[p]=="function"&&d.push(p);return d}e.getAllMethodNames=v;function u(l,d){const p=R=>function(){const s=Array.prototype.slice.call(arguments,0);return d(R,s)},S={};for(const R of l)S[R]=p(R);return S}e.createProxyObject=u}),define(oe[31],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(D){return L.test(D)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const k=new Uint8Array(16),N=[];for(let P=0;P<256;P++)N.push(P.toString(16).padStart(2,"0"));return function(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let I=0,y="";return y+=N[k[I++]],y+=N[k[I++]],y+=N[k[I++]],y+=N[k[I++]],y+="-",y+=N[k[I++]],y+=N[k[I++]],y+="-",y+=N[k[I++]],y+=N[k[I++]],y+="-",y+=N[k[I++]],y+=N[k[I++]],y+="-",y+=N[k[I++]],y+=N[k[I++]],y+=N[k[I++]],y+=N[k[I++]],y+=N[k[I++]],y+=N[k[I++]],y}}()}),define(oe[133],ae([0,1,34]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(N){const P=N.replace(/\-/g,":").toLowerCase();return!i.has(P)}function k(){const N=(0,L.networkInterfaces)();for(const P in N){const I=N[P];if(I){for(const{mac:y}of I)if(D(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(oe[134],ae([0,1,86]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,I,y,C=1){let w=!1;return new Promise(g=>{const m=setTimeout(()=>{if(!w)return w=!0,g(0)},y);D(P,I,C,f=>{if(!w)return w=!0,clearTimeout(m),g(f)})})}e.findFreePort=i;function D(P,I,y,C){if(I===0)return C(0);const w=new L.Socket;w.once("connect",()=>(N(w),D(P+y,I-1,y,C))),w.once("data",()=>{}),w.once("error",g=>(N(w),g.code!=="ECONNREFUSED"?D(P+y,I-1,y,C):C(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(P,I,y,C="127.0.0.1"){let w=!1,g,m=1;const f=L.createServer({pauseOnConnect:!0});function v(u,l){w||(w=!0,f.removeAllListeners(),f.close(),g&&clearTimeout(g),l(u))}return new Promise(u=>{g=setTimeout(()=>{v(0,u)},y),f.on("listening",()=>{v(P,u)}),f.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&m<I?(P++,m++,f.listen(P,C)):v(0,u)}),f.on("close",()=>{v(0,u)}),f.listen(P,C)})}e.findFreePortFaster=k;function N(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(oe[135],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const L="Offline";function i(k){return k instanceof D?!0:k instanceof Error&&k.name===L&&k.message===L}e.isOfflineError=i;class D extends Error{constructor(){super(L),this.name=this.message}}e.OfflineError=D}),define(oe[136],ae([0,1,17,7,135]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(I,y){if(!navigator.onLine)throw new D.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((w,g)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),N(C,I),C.responseType="arraybuffer",C.onerror=m=>g(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=m=>{w({res:{statusCode:C.status,headers:P(C)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=m=>g(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),y.onCancellationRequested(()=>{C.abort(),g((0,i.canceled)())})})}e.request=k;function N(I,y){if(y.headers){e:for(const C in y.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,y.headers[C])}}}function P(I){const y=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const w=C.indexOf(":");y[C.substr(0,w).trim().toLowerCase()]=C.substr(w+1).trim()}return y}}),define(oe[137],ae([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,137]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,k=D*24,N=k*7,P=k*30,I=k*365;function y(w,g,m,f){typeof w!="number"&&(w=w.getTime());const v=Math.round((new Date().getTime()-w)/1e3);if(v<-30)return(0,L.localize)(0,null,y(new Date().getTime()+v*1e3,!1));if(!f&&v<30)return(0,L.localize)(1,null);let u;return v<i?(u=v,g?u===1?m?(0,L.localize)(2,null,u):(0,L.localize)(3,null,u):m?(0,L.localize)(4,null,u):(0,L.localize)(5,null,u):u===1?m?(0,L.localize)(6,null,u):(0,L.localize)(7,null,u):m?(0,L.localize)(8,null,u):(0,L.localize)(9,null,u)):v<D?(u=Math.floor(v/i),g?u===1?m?(0,L.localize)(10,null,u):(0,L.localize)(11,null,u):m?(0,L.localize)(12,null,u):(0,L.localize)(13,null,u):u===1?m?(0,L.localize)(14,null,u):(0,L.localize)(15,null,u):m?(0,L.localize)(16,null,u):(0,L.localize)(17,null,u)):v<k?(u=Math.floor(v/D),g?u===1?m?(0,L.localize)(18,null,u):(0,L.localize)(19,null,u):m?(0,L.localize)(20,null,u):(0,L.localize)(21,null,u):u===1?m?(0,L.localize)(22,null,u):(0,L.localize)(23,null,u):m?(0,L.localize)(24,null,u):(0,L.localize)(25,null,u)):v<N?(u=Math.floor(v/k),g?u===1?(0,L.localize)(26,null,u):(0,L.localize)(27,null,u):u===1?(0,L.localize)(28,null,u):(0,L.localize)(29,null,u)):v<P?(u=Math.floor(v/N),g?u===1?m?(0,L.localize)(30,null,u):(0,L.localize)(31,null,u):m?(0,L.localize)(32,null,u):(0,L.localize)(33,null,u):u===1?m?(0,L.localize)(34,null,u):(0,L.localize)(35,null,u):m?(0,L.localize)(36,null,u):(0,L.localize)(37,null,u)):v<I?(u=Math.floor(v/P),g?u===1?m?(0,L.localize)(38,null,u):(0,L.localize)(39,null,u):m?(0,L.localize)(40,null,u):(0,L.localize)(41,null,u):u===1?m?(0,L.localize)(42,null,u):(0,L.localize)(43,null,u):m?(0,L.localize)(44,null,u):(0,L.localize)(45,null,u)):(u=Math.floor(v/I),g?u===1?m?(0,L.localize)(46,null,u):(0,L.localize)(47,null,u):m?(0,L.localize)(48,null,u):(0,L.localize)(49,null,u):u===1?m?(0,L.localize)(50,null,u):(0,L.localize)(51,null,u):m?(0,L.localize)(52,null,u):(0,L.localize)(53,null,u))}e.fromNow=y;function C(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(oe[138],ae([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,13,138]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(w,g){return g&&(w.stack||w.stacktrace)?D.localize(0,null,P(w),N(w.stack)||N(w.stacktrace)):P(w)}function N(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function I(w=null,g=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const m=L.coalesce(w),f=I(m[0],g);return m.length>1?D.localize(4,null,f,m.length):f}if(i.isString(w))return w;if(w.detail){const m=w.detail;if(m.error)return k(m.error,g);if(m.exception)return k(m.exception,g)}return w.stack?k(w,g):w.message?w.message:D.localize(5,null)}e.toErrorMessage=I;function y(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=y;function C(w,g){let m;return typeof w=="string"?m=new Error(w):m=w,m.actions=g,m}e.createErrorWithActions=C}),define(oe[139],ae([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(oe[140],ae([0,1,139]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(D){switch(D){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(oe[141],ae([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,141]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,D=!1,k=!1,N=!1,P=!1,I=!1,y=!1,C=!1,w=!1,g=!1,m,f=e.LANGUAGE_DEFAULT,v,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const d=typeof l?.versions?.electron=="string",p=d&&l?.type==="renderer";if(typeof navigator=="object"&&!p)u=navigator.userAgent,i=u.indexOf("Windows")>=0,D=u.indexOf("Macintosh")>=0,C=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=u.indexOf("Linux")>=0,g=u?.indexOf("Mobi")>=0,I=!0,m=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,f=m;else if(typeof l=="object"){i=l.platform==="win32",D=l.platform==="darwin",k=l.platform==="linux",N=k&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,y=d,w=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=l.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),b=h.availableLanguages["*"];m=h.locale,f=b||e.LANGUAGE_DEFAULT,v=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var S;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function R(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let s=0;D?s=1:i?s=3:k&&(s=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=N,e.isNative=P,e.isElectron=y,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=g,e.isCI=w,e.platform=s,e.userAgent=u,e.language=f;var c;(function(a){function h(){return e.language}a.value=h;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=b;function E(){return e.language==="en"}a.isDefault=E})(c=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let E=0,T=a.length;E<T;E++){const O=a[E];if(O.id===b.data.vscodeScheduleAsyncWork){a.splice(E,1),O.callback();return}}});let h=0;return b=>{const E=++h;a.push({id:E,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:i?1:3;let n=!0,r=!1;function o(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,n=new Uint16Array(a.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const D=L.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(oe[12],ae([0,1,36]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,k=90,N=122,P=46,I=47,y=92,C=58,w=63;class g extends Error{constructor(c,t,n){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${o} ${r} of type ${t}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function m(s,c){if(s===null||typeof s!="object")throw new g(c,"Object",s)}function f(s,c){if(typeof s!="string")throw new g(c,"string",s)}const v=L.platform==="win32";function u(s){return s===I||s===y}function l(s){return s===I}function d(s){return s>=i&&s<=k||s>=D&&s<=N}function p(s,c,t,n){let r="",o=0,a=-1,h=0,b=0;for(let E=0;E<=s.length;++E){if(E<s.length)b=s.charCodeAt(E);else{if(n(b))break;b=I}if(n(b)){if(!(a===E-1||h===1))if(h===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const T=r.lastIndexOf(t);T===-1?(r="",o=0):(r=r.slice(0,T),o=r.length-1-r.lastIndexOf(t)),a=E,h=0;continue}else if(r.length!==0){r="",o=0,a=E,h=0;continue}}c&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${s.slice(a+1,E)}`:r=s.slice(a+1,E),o=E-a-1;a=E,h=0}else b===P&&h!==-1?++h:h=-1}return r}function S(s,c){m(c,"pathObject");const t=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return t?t===c.root?`${t}${n}`:`${t}${s}${n}`:n}e.win32={resolve(...s){let c="",t="",n=!1;for(let r=s.length-1;r>=-1;r--){let o;if(r>=0){if(o=s[r],f(o,"path"),o.length===0)continue}else c.length===0?o=L.cwd():(o=L.env[`=${c}`]||L.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===y)&&(o=`${c}\\`));const a=o.length;let h=0,b="",E=!1;const T=o.charCodeAt(0);if(a===1)u(T)&&(h=1,E=!0);else if(u(T))if(E=!0,u(o.charCodeAt(1))){let O=2,M=O;for(;O<a&&!u(o.charCodeAt(O));)O++;if(O<a&&O!==M){const F=o.slice(M,O);for(M=O;O<a&&u(o.charCodeAt(O));)O++;if(O<a&&O!==M){for(M=O;O<a&&!u(o.charCodeAt(O));)O++;(O===a||O!==M)&&(b=`\\\\${F}\\${o.slice(M,O)}`,h=O)}}}else h=1;else d(T)&&o.charCodeAt(1)===C&&(b=o.slice(0,2),h=2,a>2&&u(o.charCodeAt(2))&&(E=!0,h=3));if(b.length>0)if(c.length>0){if(b.toLowerCase()!==c.toLowerCase())continue}else c=b;if(n){if(c.length>0)break}else if(t=`${o.slice(h)}\\${t}`,n=E,E&&c.length>0)break}return t=p(t,!n,"\\",u),n?`${c}\\${t}`:`${c}${t}`||"."},normalize(s){f(s,"path");const c=s.length;if(c===0)return".";let t=0,n,r=!1;const o=s.charCodeAt(0);if(c===1)return l(o)?"\\":s;if(u(o))if(r=!0,u(s.charCodeAt(1))){let h=2,b=h;for(;h<c&&!u(s.charCodeAt(h));)h++;if(h<c&&h!==b){const E=s.slice(b,h);for(b=h;h<c&&u(s.charCodeAt(h));)h++;if(h<c&&h!==b){for(b=h;h<c&&!u(s.charCodeAt(h));)h++;if(h===c)return`\\\\${E}\\${s.slice(b)}\\`;h!==b&&(n=`\\\\${E}\\${s.slice(b,h)}`,t=h)}}}else t=1;else d(o)&&s.charCodeAt(1)===C&&(n=s.slice(0,2),t=2,c>2&&u(s.charCodeAt(2))&&(r=!0,t=3));let a=t<c?p(s.slice(t),!r,"\\",u):"";return a.length===0&&!r&&(a="."),a.length>0&&u(s.charCodeAt(c-1))&&(a+="\\"),n===void 0?r?`\\${a}`:a:r?`${n}\\${a}`:`${n}${a}`},isAbsolute(s){f(s,"path");const c=s.length;if(c===0)return!1;const t=s.charCodeAt(0);return u(t)||c>2&&d(t)&&s.charCodeAt(1)===C&&u(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let c,t;for(let o=0;o<s.length;++o){const a=s[o];f(a,"path"),a.length>0&&(c===void 0?c=t=a:c+=`\\${a}`)}if(c===void 0)return".";let n=!0,r=0;if(typeof t=="string"&&u(t.charCodeAt(0))){++r;const o=t.length;o>1&&u(t.charCodeAt(1))&&(++r,o>2&&(u(t.charCodeAt(2))?++r:n=!1))}if(n){for(;r<c.length&&u(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(s,c){if(f(s,"from"),f(c,"to"),s===c)return"";const t=e.win32.resolve(s),n=e.win32.resolve(c);if(t===n||(s=t.toLowerCase(),c=n.toLowerCase(),s===c))return"";let r=0;for(;r<s.length&&s.charCodeAt(r)===y;)r++;let o=s.length;for(;o-1>r&&s.charCodeAt(o-1)===y;)o--;const a=o-r;let h=0;for(;h<c.length&&c.charCodeAt(h)===y;)h++;let b=c.length;for(;b-1>h&&c.charCodeAt(b-1)===y;)b--;const E=b-h,T=a<E?a:E;let O=-1,M=0;for(;M<T;M++){const A=s.charCodeAt(r+M);if(A!==c.charCodeAt(h+M))break;A===y&&(O=M)}if(M!==T){if(O===-1)return n}else{if(E>T){if(c.charCodeAt(h+M)===y)return n.slice(h+M+1);if(M===2)return n.slice(h+M)}a>T&&(s.charCodeAt(r+M)===y?O=M:M===2&&(O=3)),O===-1&&(O=0)}let F="";for(M=r+O+1;M<=o;++M)(M===o||s.charCodeAt(M)===y)&&(F+=F.length===0?"..":"\\..");return h+=O,F.length>0?`${F}${n.slice(h,b)}`:(n.charCodeAt(h)===y&&++h,n.slice(h,b))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const c=e.win32.resolve(s);if(c.length<=2)return s;if(c.charCodeAt(0)===y){if(c.charCodeAt(1)===y){const t=c.charCodeAt(2);if(t!==w&&t!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(d(c.charCodeAt(0))&&c.charCodeAt(1)===C&&c.charCodeAt(2)===y)return`\\\\?\\${c}`;return s},dirname(s){f(s,"path");const c=s.length;if(c===0)return".";let t=-1,n=0;const r=s.charCodeAt(0);if(c===1)return u(r)?s:".";if(u(r)){if(t=n=1,u(s.charCodeAt(1))){let h=2,b=h;for(;h<c&&!u(s.charCodeAt(h));)h++;if(h<c&&h!==b){for(b=h;h<c&&u(s.charCodeAt(h));)h++;if(h<c&&h!==b){for(b=h;h<c&&!u(s.charCodeAt(h));)h++;if(h===c)return s;h!==b&&(t=n=h+1)}}}}else d(r)&&s.charCodeAt(1)===C&&(t=c>2&&u(s.charCodeAt(2))?3:2,n=t);let o=-1,a=!0;for(let h=c-1;h>=n;--h)if(u(s.charCodeAt(h))){if(!a){o=h;break}}else a=!1;if(o===-1){if(t===-1)return".";o=t}return s.slice(0,o)},basename(s,c){c!==void 0&&f(c,"ext"),f(s,"path");let t=0,n=-1,r=!0,o;if(s.length>=2&&d(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(t=2),c!==void 0&&c.length>0&&c.length<=s.length){if(c===s)return"";let a=c.length-1,h=-1;for(o=s.length-1;o>=t;--o){const b=s.charCodeAt(o);if(u(b)){if(!r){t=o+1;break}}else h===-1&&(r=!1,h=o+1),a>=0&&(b===c.charCodeAt(a)?--a===-1&&(n=o):(a=-1,n=h))}return t===n?n=h:n===-1&&(n=s.length),s.slice(t,n)}for(o=s.length-1;o>=t;--o)if(u(s.charCodeAt(o))){if(!r){t=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":s.slice(t,n)},extname(s){f(s,"path");let c=0,t=-1,n=0,r=-1,o=!0,a=0;s.length>=2&&s.charCodeAt(1)===C&&d(s.charCodeAt(0))&&(c=n=2);for(let h=s.length-1;h>=c;--h){const b=s.charCodeAt(h);if(u(b)){if(!o){n=h+1;break}continue}r===-1&&(o=!1,r=h+1),b===P?t===-1?t=h:a!==1&&(a=1):t!==-1&&(a=-1)}return t===-1||r===-1||a===0||a===1&&t===r-1&&t===n+1?"":s.slice(t,r)},format:S.bind(null,"\\"),parse(s){f(s,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return c;const t=s.length;let n=0,r=s.charCodeAt(0);if(t===1)return u(r)?(c.root=c.dir=s,c):(c.base=c.name=s,c);if(u(r)){if(n=1,u(s.charCodeAt(1))){let O=2,M=O;for(;O<t&&!u(s.charCodeAt(O));)O++;if(O<t&&O!==M){for(M=O;O<t&&u(s.charCodeAt(O));)O++;if(O<t&&O!==M){for(M=O;O<t&&!u(s.charCodeAt(O));)O++;O===t?n=O:O!==M&&(n=O+1)}}}}else if(d(r)&&s.charCodeAt(1)===C){if(t<=2)return c.root=c.dir=s,c;if(n=2,u(s.charCodeAt(2))){if(t===3)return c.root=c.dir=s,c;n=3}}n>0&&(c.root=s.slice(0,n));let o=-1,a=n,h=-1,b=!0,E=s.length-1,T=0;for(;E>=n;--E){if(r=s.charCodeAt(E),u(r)){if(!b){a=E+1;break}continue}h===-1&&(b=!1,h=E+1),r===P?o===-1?o=E:T!==1&&(T=1):o!==-1&&(T=-1)}return h!==-1&&(o===-1||T===0||T===1&&o===h-1&&o===a+1?c.base=c.name=s.slice(a,h):(c.name=s.slice(a,o),c.base=s.slice(a,h),c.ext=s.slice(o,h))),a>0&&a!==n?c.dir=s.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(v){const s=/\\/g;return()=>{const c=L.cwd().replace(s,"/");return c.slice(c.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...s){let c="",t=!1;for(let n=s.length-1;n>=-1&&!t;n--){const r=n>=0?s[n]:R();f(r,"path"),r.length!==0&&(c=`${r}/${c}`,t=r.charCodeAt(0)===I)}return c=p(c,!t,"/",l),t?`/${c}`:c.length>0?c:"."},normalize(s){if(f(s,"path"),s.length===0)return".";const c=s.charCodeAt(0)===I,t=s.charCodeAt(s.length-1)===I;return s=p(s,!c,"/",l),s.length===0?c?"/":t?"./":".":(t&&(s+="/"),c?`/${s}`:s)},isAbsolute(s){return f(s,"path"),s.length>0&&s.charCodeAt(0)===I},join(...s){if(s.length===0)return".";let c;for(let t=0;t<s.length;++t){const n=s[t];f(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(s,c){if(f(s,"from"),f(c,"to"),s===c||(s=e.posix.resolve(s),c=e.posix.resolve(c),s===c))return"";const t=1,n=s.length,r=n-t,o=1,a=c.length-o,h=r<a?r:a;let b=-1,E=0;for(;E<h;E++){const O=s.charCodeAt(t+E);if(O!==c.charCodeAt(o+E))break;O===I&&(b=E)}if(E===h)if(a>h){if(c.charCodeAt(o+E)===I)return c.slice(o+E+1);if(E===0)return c.slice(o+E)}else r>h&&(s.charCodeAt(t+E)===I?b=E:E===0&&(b=0));let T="";for(E=t+b+1;E<=n;++E)(E===n||s.charCodeAt(E)===I)&&(T+=T.length===0?"..":"/..");return`${T}${c.slice(o+b)}`},toNamespacedPath(s){return s},dirname(s){if(f(s,"path"),s.length===0)return".";const c=s.charCodeAt(0)===I;let t=-1,n=!0;for(let r=s.length-1;r>=1;--r)if(s.charCodeAt(r)===I){if(!n){t=r;break}}else n=!1;return t===-1?c?"/":".":c&&t===1?"//":s.slice(0,t)},basename(s,c){c!==void 0&&f(c,"ext"),f(s,"path");let t=0,n=-1,r=!0,o;if(c!==void 0&&c.length>0&&c.length<=s.length){if(c===s)return"";let a=c.length-1,h=-1;for(o=s.length-1;o>=0;--o){const b=s.charCodeAt(o);if(b===I){if(!r){t=o+1;break}}else h===-1&&(r=!1,h=o+1),a>=0&&(b===c.charCodeAt(a)?--a===-1&&(n=o):(a=-1,n=h))}return t===n?n=h:n===-1&&(n=s.length),s.slice(t,n)}for(o=s.length-1;o>=0;--o)if(s.charCodeAt(o)===I){if(!r){t=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":s.slice(t,n)},extname(s){f(s,"path");let c=-1,t=0,n=-1,r=!0,o=0;for(let a=s.length-1;a>=0;--a){const h=s.charCodeAt(a);if(h===I){if(!r){t=a+1;break}continue}n===-1&&(r=!1,n=a+1),h===P?c===-1?c=a:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||n===-1||o===0||o===1&&c===n-1&&c===t+1?"":s.slice(c,n)},format:S.bind(null,"/"),parse(s){f(s,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return c;const t=s.charCodeAt(0)===I;let n;t?(c.root="/",n=1):n=0;let r=-1,o=0,a=-1,h=!0,b=s.length-1,E=0;for(;b>=n;--b){const T=s.charCodeAt(b);if(T===I){if(!h){o=b+1;break}continue}a===-1&&(h=!1,a=b+1),T===P?r===-1?r=b:E!==1&&(E=1):r!==-1&&(E=-1)}if(a!==-1){const T=o===0&&t?1:o;r===-1||E===0||E===1&&r===a-1&&r===o+1?c.base=c.name=s.slice(T,a):(c.name=s.slice(T,r),c.base=s.slice(T,a),c.ext=s.slice(r,a))}return o>0?c.dir=s.slice(0,o-1):t&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(oe[142],ae([0,1,12]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(C){const w=(0,L.extname)(C),g=i[w.toLowerCase()];return g!==void 0?g:N(C)}e.getMediaOrTextMime=k;function N(C){const w=(0,L.extname)(C);return D[w.toLowerCase()]}e.getMediaMime=N;function P(C){for(const w in D)if(D[w]===C)return w}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function y(C,w){const g=I.exec(C);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:w?void 0:C}e.normalizeMimeType=y}),define(oe[87],ae([0,1,4]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(P,...I){const y=I.reduce((g,m)=>(g[m]=!0,g),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(g=>!y[g]).forEach(g=>{for(let m=0;m<C.length;m++)if(g.search(C[m])!==-1){delete P[g];break}})}e.sanitizeProcessEnvironment=k;function N(P){!P||(delete P.DEBUG,L.isMacintosh&&delete P.DYLD_LIBRARY_PATH,L.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(oe[88],ae([0,1,4]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=L.globals.performance&&typeof L.globals.performance.now=="function";class D{static create(N=!0){return new D(N)}constructor(N){this.a=i&&N,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?L.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,7,82,2,84,88]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var y;(function(o){o.None=()=>D.Disposable.None;function a(q){if(I){const{onDidAddListener:J}=q,_=f.create();let Y=0;q.onDidAddListener=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),J?.()}}}function h(q,J){return z(q,()=>{},0,void 0,void 0,J)}o.defer=h;function b(q){return(J,_=null,Y)=>{let Q=!1,se;return se=q(le=>{if(!Q)return se?se.dispose():Q=!0,J.call(_,le)},null,Y),Q&&se.dispose(),se}}o.once=b;function E(q,J,_){return $((Y,Q=null,se)=>q(le=>Y.call(Q,J(le)),null,se),_)}o.map=E;function T(q,J,_){return $((Y,Q=null,se)=>q(le=>{J(le),Y.call(Q,le)},null,se),_)}o.forEach=T;function O(q,J,_){return $((Y,Q=null,se)=>q(le=>J(le)&&Y.call(Q,le),null,se),_)}o.filter=O;function M(q){return q}o.signal=M;function F(...q){return(J,_=null,Y)=>(0,D.combinedDisposable)(...q.map(Q=>Q(se=>J.call(_,se),null,Y)))}o.any=F;function A(q,J,_,Y){let Q=_;return E(q,se=>(Q=J(Q,se),Q),Y)}o.reduce=A;function $(q,J){let _;const Y={onWillAddFirstListener(){_=q(Q.fire,Q)},onDidRemoveLastListener(){_?.dispose()}};J||a(Y);const Q=new u(Y);return J?.add(Q),Q.event}function z(q,J,_=100,Y=!1,Q,se){let le,ue,pe,we=0;const be={leakWarningThreshold:Q,onWillAddFirstListener(){le=q(Te=>{we++,ue=J(ue,Te),Y&&!pe&&(Ee.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ue=ue;ue=void 0,pe=void 0,(!Y||we>1)&&Ee.fire(Ue),we=0},_)})},onDidRemoveLastListener(){le.dispose()}};se||a(be);const Ee=new u(be);return se?.add(Ee),Ee.event}o.debounce=z;function H(q,J=0,_){return o.debounce(q,(Y,Q)=>Y?(Y.push(Q),Y):[Q],J,void 0,void 0,_)}o.accumulate=H;function X(q,J=(Y,Q)=>Y===Q,_){let Y=!0,Q;return O(q,se=>{const le=Y||!J(se,Q);return Y=!1,Q=se,le},_)}o.latch=X;function ie(q,J,_){return[o.filter(q,J,_),o.filter(q,Y=>!J(Y),_)]}o.split=ie;function G(q,J=!1,_=[]){let Y=_.slice(),Q=q(ue=>{Y?Y.push(ue):le.fire(ue)});const se=()=>{Y?.forEach(ue=>le.fire(ue)),Y=null},le=new u({onWillAddFirstListener(){Q||(Q=q(ue=>le.fire(ue)))},onDidAddFirstListener(){Y&&(J?setTimeout(se):se())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return le.event}o.buffer=G;class j{constructor(J){this.event=J,this.c=new D.DisposableStore}map(J){return new j(E(this.event,J,this.c))}forEach(J){return new j(T(this.event,J,this.c))}filter(J){return new j(O(this.event,J,this.c))}reduce(J,_){return new j(A(this.event,J,_,this.c))}latch(){return new j(X(this.event,void 0,this.c))}debounce(J,_=100,Y=!1,Q){return new j(z(this.event,J,_,Y,Q,this.c))}on(J,_,Y){return this.event(J,_,Y)}once(J,_,Y){return b(this.event)(J,_,Y)}dispose(){this.c.dispose()}}function V(q){return new j(q)}o.chain=V;function x(q,J,_=Y=>Y){const Y=(...ue)=>le.fire(_(...ue)),Q=()=>q.on(J,Y),se=()=>q.removeListener(J,Y),le=new u({onWillAddFirstListener:Q,onDidRemoveLastListener:se});return le.event}o.fromNodeEventEmitter=x;function ee(q,J,_=Y=>Y){const Y=(...ue)=>le.fire(_(...ue)),Q=()=>q.addEventListener(J,Y),se=()=>q.removeEventListener(J,Y),le=new u({onWillAddFirstListener:Q,onDidRemoveLastListener:se});return le.event}o.fromDOMEventEmitter=ee;function re(q){return new Promise(J=>b(q)(J))}o.toPromise=re;function te(q,J){return J(void 0),q(_=>J(_))}o.runAndSubscribe=te;function U(q,J){let _=null;function Y(se){_?.dispose(),_=new D.DisposableStore,J(se,_)}Y(void 0);const Q=q(se=>Y(se));return(0,D.toDisposable)(()=>{Q.dispose(),_?.dispose()})}o.runAndSubscribeWithStore=U;class B{constructor(J,_){this.obs=J,this.c=0,this.d=!1;const Y={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};_||a(Y),this.emitter=new u(Y),_&&_.add(this.emitter)}beginUpdate(J){this.c++}handleChange(J,_){this.d=!0}endUpdate(J){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(q,J){return new B(q,J).emitter.event}o.fromObservable=W})(y=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C.c++}`,C.all.add(this)}start(a){this.d=new N.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let w=-1;function g(o){const a=w;return w=o,{dispose(){w=a}}}e.setGlobalLeakWarningThreshold=g;class m{constructor(a,h=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=h,this.d=0}dispose(){this.c?.clear()}check(a,h){const b=this.threshold;if(b<=0||h<b)return;this.c||(this.c=new Map);const E=this.c.get(a.value)||0;if(this.c.set(a.value,E+1),this.d-=1,this.d<=0){this.d=b*.5;let T,O=0;for(const[M,F]of this.c)(!T||O<F)&&(T=M,O=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${O}):`),console.warn(T)}return()=>{const T=this.c.get(a.value)||0;this.c.set(a.value,T-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(a,h,b){this.callback=a,this.callbackThis=h,this.stack=b,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class u{constructor(a){this.j=!1,this.d=a,this.f=w>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??w):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const a=Array.from(this.q);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,h,b)=>{if(this.q||(this.q=new k.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=f.create(),T=this.f.check(O,this.q.size+1)),P&&(O=O??f.create());const M=new v(a,h,O),F=this.q.push(M);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,h);const A=M.subscription.set(()=>{T?.(),this.j||(F(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof D.DisposableStore?b.add(A):Array.isArray(b)&&b.push(A),A}),this.l}fire(a){if(this.q){this.m||(this.m=new d);for(const h of this.q)this.m.push(this,h,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=u;class l{constructor(){this.c=new k.LinkedList}get size(){return this.c.size}push(a,h,b){this.c.push(new p(a,h,b))}clear(a){const h=new k.LinkedList;for(const b of this.c)b.emitter!==a&&h.push(b);this.c=h}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(h){(0,L.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=l;class d extends l{clear(a){this.c.clear()}}class p{constructor(a,h,b){this.emitter=a,this.listener=h,this.event=b}}class S extends u{async fireAsync(a,h,b){if(!!this.q){this.c||(this.c=new k.LinkedList);for(const E of this.q)this.c.push([E,a]);for(;this.c.size>0&&!h.isCancellationRequested;){const[E,T]=this.c.shift(),O=[],M={...T,token:h,waitUntil:F=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");b&&(F=b(F,E.callback)),O.push(F)}};try{E.invoke(M)}catch(F){(0,L.onUnexpectedError)(F);continue}Object.freeze(O),await Promise.allSettled(O).then(F=>{for(const A of F)A.status==="rejected"&&(0,L.onUnexpectedError)(A.reason)})}}}}e.AsyncEmitter=S;class R extends u{constructor(a){super(a),this.h=0,this.s=new k.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=R;class s extends R{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=s;class c extends u{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=c;class t{constructor(){this.d=!1,this.f=[],this.c=new u({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const h={event:a,listener:null};this.f.push(h),this.d&&this.j(h);const b=()=>{this.d&&this.k(h);const E=this.f.indexOf(h);this.f.splice(E,1)};return(0,D.toDisposable)((0,i.once)(b))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(h=>this.c.fire(h))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.c=[]}wrapEvent(a){return(h,b,E)=>a(T=>{const O=this.c[this.c.length-1];O?O.push(()=>h.call(b,T)):h.call(b,T)},void 0,E)}bufferEvents(a){const h=[];this.c.push(h);const b=a();return this.c.pop(),h.forEach(E=>E()),b}}e.EventBufferer=n;class r{constructor(){this.c=!1,this.d=y.None,this.f=D.Disposable.None,this.g=new u({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(oe[23],ae([0,1,3]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,I){const y=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(y)}}});var D;(function(P){function I(y){return y===P.None||y===P.Cancelled||y instanceof k?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new L.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new k),this.a}cancel(){this.a?this.a instanceof k&&this.a.cancel():this.a=D.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof k&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=N}),define(oe[143],ae([0,1,23]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new L.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=i;class D{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=D;class k{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=k}),define(oe[27],ae([0,1,143,130]),function(Z,e,L,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=k;const N=/{(\d+)}/g;function P(ne,...he){return he.length===0?ne:ne.replace(N,function(fe,me){const ve=parseInt(me,10);return isNaN(ve)||ve<0||ve>=he.length?fe:he[ve]})}e.format=P;const I=/{([^}]+)}/g;function y(ne,he){return ne.replace(I,(fe,me)=>he[me]??fe)}e.format2=y;function C(ne){return ne.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function g(ne,he){let fe=0;const me=he.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===me&&fe++;return fe}e.count=g;function m(ne,he,fe="\u2026"){return ne.length<=he?ne:`${ne.substr(0,he)}${fe}`}e.truncate=m;function f(ne,he=" "){const fe=v(ne,he);return u(fe,he)}e.trim=f;function v(ne,he){if(!ne||!he)return ne;const fe=he.length;if(fe===0||ne.length===0)return ne;let me=0;for(;ne.indexOf(he,me)===me;)me=me+fe;return ne.substring(me)}e.ltrim=v;function u(ne,he){if(!ne||!he)return ne;const fe=he.length,me=ne.length;if(fe===0||me===0)return ne;let ve=me,Ie=-1;for(;Ie=ne.lastIndexOf(he,ve-1),!(Ie===-1||Ie+fe!==ve);){if(Ie===0)return"";ve=Ie}return ne.substring(0,ve)}e.rtrim=u;function l(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function d(ne){return ne.replace(/\*/g,"")}e.stripWildcards=d;function p(ne,he,fe={}){if(!ne)throw new Error("Cannot create regex from empty string");he||(ne=w(ne)),fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ne,me)}e.createRegExp=p;function S(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function R(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function s(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=s;function c(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=c;function t(ne){for(let he=0,fe=ne.length;he<fe;he++){const me=ne.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function n(ne,he=0,fe=ne.length){for(let me=he;me<fe;me++){const ve=ne.charCodeAt(me);if(ve!==32&&ve!==9)return ne.substring(he,me)}return ne.substring(he,fe)}e.getLeadingWhitespace=n;function r(ne,he=ne.length-1){for(let fe=he;fe>=0;fe--){const me=ne.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=r;function o(ne,he,fe){const me=[];let ve=0;for(const Ie of ne.matchAll(he)){if(me.push(ne.slice(ve,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");ve=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ne,Ie.groups))}return me.push(ne.slice(ve)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=o;function a(ne,he){return ne<he?-1:ne>he?1:0}e.compare=a;function h(ne,he,fe=0,me=ne.length,ve=0,Ie=he.length){for(;fe<me&&ve<Ie;fe++,ve++){const $e=ne.charCodeAt(fe),Le=he.charCodeAt(ve);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-ve;return Re<He?-1:Re>He?1:0}e.compareSubstring=h;function b(ne,he){return E(ne,he,0,ne.length,0,he.length)}e.compareIgnoreCase=b;function E(ne,he,fe=0,me=ne.length,ve=0,Ie=he.length){for(;fe<me&&ve<Ie;fe++,ve++){let $e=ne.charCodeAt(fe),Le=he.charCodeAt(ve);if($e===Le)continue;if($e>=128||Le>=128)return h(ne.toLowerCase(),he.toLowerCase(),fe,me,ve,Ie);O($e)&&($e-=32),O(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-ve;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=E;function T(ne){return ne>=48&&ne<=57}e.isAsciiDigit=T;function O(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=O;function M(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=M;function F(ne,he){return ne.length===he.length&&E(ne,he)===0}e.equalsIgnoreCase=F;function A(ne,he){const fe=he.length;return he.length>ne.length?!1:E(ne,he,0,fe)===0}e.startsWithIgnoreCase=A;function $(ne,he){const fe=Math.min(ne.length,he.length);let me;for(me=0;me<fe;me++)if(ne.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=$;function z(ne,he){const fe=Math.min(ne.length,he.length);let me;const ve=ne.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ne.charCodeAt(ve-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function H(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=H;function X(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=X;function ie(ne,he){return(ne-55296<<10)+(he-56320)+65536}e.computeCodePoint=ie;function G(ne,he,fe){const me=ne.charCodeAt(fe);if(H(me)&&fe+1<he){const ve=ne.charCodeAt(fe+1);if(X(ve))return ie(me,ve)}return me}e.getNextCodePoint=G;function j(ne,he){const fe=ne.charCodeAt(he-1);if(X(fe)&&he>1){const me=ne.charCodeAt(he-2);if(H(me))return ie(me,fe)}return fe}class V{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=j(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=G(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=V;class x{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new V(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let ve=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(ve,Re)){fe.setOffset(Ie);break}ve=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let ve=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,ve)){fe.setOffset(Ie);break}ve=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=x;function ee(ne,he){return new x(ne,he).nextGraphemeLength()}e.nextCharLength=ee;function re(ne,he){return new x(ne,he).prevGraphemeLength()}e.prevCharLength=re;function te(ne,he){he>0&&X(ne.charCodeAt(he))&&he--;const fe=he+ee(ne,he);return[fe-re(ne,fe),fe]}e.getCharContainingOffset=te;function U(ne){const he=new x(ne);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=U;let B;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ne){return B||(B=W()),B.test(ne)}e.containsRTL=q;const J=/^[\t\n\r\x20-\x7E]*$/;function _(ne){return J.test(ne)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=Y;function Q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Q;function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=se;function le(ne,he){if(ne.length<he)return ne;const fe=/\b/g;let me=0;for(;fe.test(ne)&&!(ne.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ne.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function be(ne){return ne&&(ne=ne.replace(ue,""),ne=ne.replace(pe,""),ne=ne.replace(we,"")),ne}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Te(ne){return Ee(ne)?ne.substr(1):ne}e.stripUTF8BOM=Te;function Ue(ne,he){if(!ne||!he||ne.length<he.length)return!1;const fe=he.length,me=ne.toLowerCase();let ve=0,Ie=-1;for(;ve<fe;){const Re=me.indexOf(he[ve],Ie+1);if(Re<0)return!1;Ie=Re,ve++}return!0}e.fuzzyContains=Ue;function Ye(ne,he=!1){return ne?(he&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Ye;function Be(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Be;function ce(ne,he=1){if(he===0)return"";let fe=-1;do fe=ne.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ne:(ne[fe-1]==="\r"&&fe--,ne.substr(0,fe))}e.getNLines=ce;function de(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=de;function ge(ne){return Ae.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ge;function Ce(ne,he){return ne===0?he!==5&&he!==7:ne===2&&he===3?!1:ne===4||ne===2||ne===3||he===4||he===2||he===3?!0:!(ne===8&&(he===8||he===9||he===11||he===12)||(ne===11||ne===9)&&(he===9||he===10)||(ne===12||ne===10)&&he===10||he===5||he===13||he===7||ne===1||ne===13&&he===14||ne===6&&he===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let ve=1;for(;ve<=me;)if(he<fe[3*ve])ve=2*ve;else if(he>fe[3*ve+1])ve=2*ve+1;else return fe[3*ve+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,he){if(ne===0)return 0;const fe=Oe(ne,he);if(fe!==void 0)return fe;const me=new V(he,ne);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(ne,he){const fe=new V(he,ne);let me=fe.prevCodePoint();for(;Fe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let ve=fe.offset;return ve>0&&fe.prevCodePoint()===8205&&(ve=fe.offset),ve}function Fe(ne){return 127995<=ne&&ne<=127999}var ze;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new L.LRUCachedFunction(ne=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,rt]of qe)Ge.set(et,rt);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,rt]of Le)qe.has(et)&&Ge.set(et,rt);return Ge}const ve=D.c.value;let Ie=ne.filter(Le=>!Le.startsWith("_")&&Le in ve);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(ve[Le]);Re=me(Re,qe)}const He=he(ve._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.value).filter(ne=>!ne.startsWith("_")));class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(he){return Ne.e().has(he)}static get codePoints(){return Ne.e()}}e.InvisibleCharacters=Ne,Ne.d=void 0}),define(oe[48],ae([0,1,12,4,27,13]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function N(r){return r===47||r===92}e.isPathSeparator=N;function P(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=P;function I(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function y(r,o=L.posix.sep){if(!r)return"";const a=r.length,h=r.charCodeAt(0);if(N(h)){if(N(r.charCodeAt(1))&&!N(r.charCodeAt(2))){let E=3;const T=E;for(;E<a&&!N(r.charCodeAt(E));E++);if(T!==E&&!N(r.charCodeAt(E+1))){for(E+=1;E<a;E++)if(N(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,o)}}return o}else if(l(h)&&r.charCodeAt(1)===58)return N(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let b=r.indexOf("://");if(b!==-1){for(b+=3;b<a;b++)if(N(r.charCodeAt(b)))return r.slice(0,b+1)}return""}e.getRoot=y;function C(r){if(!i.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let a=2;const h=a;for(;a<r.length&&(o=r.charCodeAt(a),o!==92);a++);return!(h===a||(o=r.charCodeAt(a+1),isNaN(o)||o===92))}e.isUNC=C;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,o=i.isWindows){const a=o?w:g;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||o&&m.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function v(r,o,a){const h=r===o;return!a||h?h:!r||!o?!1:(0,D.equalsIgnoreCase)(r,o)}e.isEqual=v;function u(r,o,a,h=L.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let E=o.length;return o.charAt(o.length-1)===h&&E--,r.charAt(E)===h}return o.charAt(o.length-1)!==h&&(o+=h),r.indexOf(o)===0}e.isEqualOrParent=u;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=l;function d(r,o){return i.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(o,r)),r=(0,L.normalize)(r),i.isWindows?(r=(0,D.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,D.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=d;function p(r){const o=(0,L.normalize)(r);return i.isWindows?r.length>3?!1:S(o)&&(r.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=p;function S(r,o=i.isWindows){return o?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function R(r){return S(r)?r[0]:void 0}e.getDriveLetter=R;function s(r,o,a){return o.length>r.length?-1:r===o?0:(a&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=s;function c(r){const o=r.split(":");let a,h,b;for(const E of o){const T=Number(E);(0,k.isNumber)(T)?h===void 0?h=T:b===void 0&&(b=T):a=a?[a,E].join(":"):E}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:b!==void 0?b:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,o,a=8){let h="";for(let E=0;E<a;E++)h+=t.charAt(Math.floor(Math.random()*t.length));let b;return o?b=`${o}-${h}`:b=h,r?(0,L.join)(r,b):b}e.randomPath=n}),define(oe[66],ae([0,1,27]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(l){return D(l,0)}e.hash=i;function D(l,d){switch(typeof l){case"object":return l===null?k(349,d):Array.isArray(l)?I(l,d):y(l,d);case"string":return P(l,d);case"boolean":return N(l,d);case"number":return k(l,d);case"undefined":return k(937,d);default:return k(617,d)}}e.doHash=D;function k(l,d){return(d<<5)-d+l|0}e.numberHash=k;function N(l,d){return k(l?433:863,d)}function P(l,d){d=k(149417,d);for(let p=0,S=l.length;p<S;p++)d=k(l.charCodeAt(p),d);return d}e.stringHash=P;function I(l,d){return d=k(104579,d),l.reduce((p,S)=>D(S,p),d)}function y(l,d){return d=k(181387,d),Object.keys(l).sort().reduce((p,S)=>(p=P(S,p),D(l[S],p)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.Hasher=C;var w;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(l,d,p=32){const S=p-d,R=~((1<<S)-1);return(l<<d|(R&l)>>>S)>>>0}function m(l,d=0,p=l.byteLength,S=0){for(let R=0;R<p;R++)l[d+R]=S}function f(l,d,p="0"){for(;l.length<d;)l=p+l;return l}function v(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),d/4)}e.toHexString=v;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const p=d.length;if(p===0)return;const S=this.p;let R=this.r,s=this.u,c,t;for(s!==0?(c=s,t=-1,s=0):(c=d.charCodeAt(0),t=0);;){let n=c;if(L.isHighSurrogate(c))if(t+1<p){const r=d.charCodeAt(t+1);L.isLowSurrogate(r)?(t++,n=L.computeCodePoint(c,r)):n=65533}else{s=c;break}else L.isLowSurrogate(c)&&(n=65533);if(R=this.w(S,R,n),t++,t<p)c=d.charCodeAt(t);else break}this.r=R,this.u=s}w(d,p,S){return S<128?d[p++]=S:S<2048?(d[p++]=192|(S&1984)>>>6,d[p++]=128|(S&63)>>>0):S<65536?(d[p++]=224|(S&61440)>>>12,d[p++]=128|(S&4032)>>>6,d[p++]=128|(S&63)>>>0):(d[p++]=240|(S&1835008)>>>18,d[p++]=128|(S&258048)>>>12,d[p++]=128|(S&4032)>>>6,d[p++]=128|(S&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=u.g,p=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,p.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,g(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let S=this.h,R=this.l,s=this.m,c=this.n,t=this.o,n,r,o;for(let a=0;a<80;a++)a<20?(n=R&s|~R&c,r=1518500249):a<40?(n=R^s^c,r=1859775393):a<60?(n=R&s|R&c|s&c,r=2400959708):(n=R^s^c,r=3395469782),o=g(S,5)+n+t+r+d.getUint32(a*4,!1)&4294967295,t=c,c=s,s=g(R,30),R=S,S=o;this.h=this.h+S&4294967295,this.l=this.l+R&4294967295,this.m=this.m+s&4294967295,this.n=this.n+c&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=u,u.g=new DataView(new ArrayBuffer(320))}),define(oe[89],ae([0,1,27]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const k="error",N="warning",P="warn",I="info",y="ignore";function C(g){return g?L.equalsIgnoreCase(k,g)?D.Error:L.equalsIgnoreCase(N,g)||L.equalsIgnoreCase(P,g)?D.Warning:L.equalsIgnoreCase(I,g)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function w(g){switch(g){case D.Error:return k;case D.Warning:return N;case D.Info:return I;default:return y}}D.toString=w}(i||(i={})),e.default=i}),define(oe[49],ae([0,1,21,27]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const f=m.charCodeAt(0),v=this.b.charCodeAt(this.c);return f-v}value(){return this.b[this.c]}}e.StringIterator=D;class k{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,i.compareSubstring)(m,this.b,0,m.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=k;class N{constructor(m=!0,f=!0){this.f=m,this.g=f}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let f=m.length-1;f>=0;f--,this.c--){const v=this.b.charCodeAt(f);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,i.compareSubstring)(m,this.b,0,m.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=N;var P;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(m,f){this.f=m,this.g=f,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(m,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,i.compare)(m,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(C||(C={}));class w{static forUris(m=()=>!1,f=()=>!1){return new w(new I(m,f))}static forPaths(m=!1){return new w(new N(void 0,!m))}static forStrings(){return new w(new D)}static forConfigKeys(){return new w(new k)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,f){if(f){const v=f.slice(0);(0,L.shuffle)(v);for(const u of v)this.set(u,m)}else{const v=m.slice(0);(0,L.shuffle)(v);for(const u of v)this.set(u[0],u[1])}}set(m,f){const v=this.b.reset(m);let u;this.c||(this.c=new y,this.c.segment=v.value());const l=[];for(u=this.c;;){const p=v.cmp(u.segment);if(p>0)u.left||(u.left=new y,u.left.segment=v.value()),l.push([-1,u]),u=u.left;else if(p<0)u.right||(u.right=new y,u.right.segment=v.value()),l.push([1,u]),u=u.right;else if(v.hasNext())v.next(),u.mid||(u.mid=new y,u.mid.segment=v.value()),l.push([0,u]),u=u.mid;else break}const d=u.value;u.value=f,u.key=m;for(let p=l.length-1;p>=0;p--){const S=l[p][1];S.updateHeight();const R=S.balanceFactor();if(R<-1||R>1){const s=l[p][0],c=l[p+1][0];if(s===1&&c===1)l[p][1]=S.rotateLeft();else if(s===-1&&c===-1)l[p][1]=S.rotateRight();else if(s===1&&c===-1)S.right=l[p+1][1]=l[p+1][1].rotateRight(),l[p][1]=S.rotateLeft();else if(s===-1&&c===1)S.left=l[p+1][1]=l[p+1][1].rotateLeft(),l[p][1]=S.rotateRight();else throw new Error;if(p>0)switch(l[p-1][0]){case-1:l[p-1][1].left=l[p][1];break;case 1:l[p-1][1].right=l[p][1];break;case 0:l[p-1][1].mid=l[p][1];break}else this.c=l[0][1]}}return d}get(m){return this.d(m)?.value}d(m){const f=this.b.reset(m);let v=this.c;for(;v;){const u=f.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else break}return v}has(m){const f=this.d(m);return!(f?.value===void 0&&f?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,f){const v=this.b.reset(m),u=[];let l=this.c;for(;l;){const d=v.cmp(l.segment);if(d>0)u.push([-1,l]),l=l.left;else if(d<0)u.push([1,l]),l=l.right;else if(v.hasNext())v.next(),u.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:p,value:S,segment:R}=d;this.e(d.key,!1),l.key=p,l.value=S,l.segment=R}}else{const d=l.left??l.right;if(u.length>0){const[p,S]=u[u.length-1];switch(p){case-1:S.left=d;break;case 0:S.mid=d;break;case 1:S.right=d;break}}else this.c=d}for(let d=u.length-1;d>=0;d--){const p=u[d][1];p.updateHeight();const S=p.balanceFactor();if(S>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),u[d][1]=p.rotateLeft()):S<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),u[d][1]=p.rotateRight()),d>0)switch(u[d-1][0]){case-1:u[d-1][1].left=u[d][1];break;case 1:u[d-1][1].right=u[d][1];break;case 0:u[d-1][1].mid=u[d][1];break}else this.c=u[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const f=this.b.reset(m);let v=this.c,u;for(;v;){const l=f.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if(f.hasNext())f.next(),u=v.value||u,v=v.mid;else break}return v&&v.value||u}findSuperstr(m){return this.g(m,!1)}g(m,f){const v=this.b.reset(m);let u=this.c;for(;u;){const l=v.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(v.hasNext())v.next(),u=u.mid;else return u.mid?this.h(u.mid):f?u.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[f,v]of this)m(v,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const f=[];return this.j(m,f),f[Symbol.iterator]()}j(m,f){!m||(m.left&&this.j(m.left,f),m.value&&f.push([m.key,m.value]),m.mid&&this.j(m.mid,f),m.right&&this.j(m.right,f))}_isBalanced(){const m=f=>{if(!f)return!0;const v=f.balanceFactor();return v<-1||v>1?!1:m(f.left)&&m(f.right)};return m(this.c)}}e.TernarySearchTree=w}),define(oe[8],ae([0,1,12,4]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,N=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,n){return!t&&!n?"file":t}function y(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const C="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,o,a,h,b=!1){typeof n=="object"?(this.scheme=n.scheme||C,this.authority=n.authority||C,this.path=n.path||C,this.query=n.query||C,this.fragment=n.fragment||C):(this.scheme=I(n,b),this.authority=r||C,this.path=y(this.scheme,o||C),this.query=a||C,this.fragment=h||C,P(this,b))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:o,path:a,query:h,fragment:b}=n;return r===void 0?r=this.scheme:r===null&&(r=C),o===void 0?o=this.authority:o===null&&(o=C),a===void 0?a=this.path:a===null&&(a=C),h===void 0?h=this.query:h===null&&(h=C),b===void 0?b=this.fragment:b===null&&(b=C),r===this.scheme&&o===this.authority&&a===this.path&&h===this.query&&b===this.fragment?this:new v(r,o,a,h,b)}static parse(n,r=!1){const o=g.exec(n);return o?new v(o[2]||C,c(o[4]||C),c(o[5]||C),c(o[7]||C),c(o[9]||C),r):new v(C,C,C,C,C)}static file(n){let r=C;if(i.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const o=n.indexOf(w,2);o===-1?(r=n.substring(2),n=w):(r=n.substring(2,o),n=n.substring(o)||w)}return new v("file",r,n,C,C)}static from(n){const r=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return P(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&n.scheme==="file"?o=m.file(L.win32.join(p(n,!0),...r)).path:o=L.posix.join(n.path,...r),n.with({path:o})}toString(n=!1){return S(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const r=new v(n);return r._formatted=n.external,r._fsPath=n._sep===f?n.fsPath:null,r}}else return n}}e.URI=m;const f=i.isWindows?1:void 0;class v extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=f),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,n,r){let o,a=-1;for(let h=0;h<t.length;h++){const b=t.charCodeAt(h);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||n&&b===47||r&&b===91||r&&b===93||r&&b===58)a!==-1&&(o+=encodeURIComponent(t.substring(a,h)),a=-1),o!==void 0&&(o+=t.charAt(h));else{o===void 0&&(o=t.substr(0,h));const E=u[b];E!==void 0?(a!==-1&&(o+=encodeURIComponent(t.substring(a,h)),a=-1),o+=E):a===-1&&(a=h)}}return a!==-1&&(o+=encodeURIComponent(t.substring(a))),o!==void 0?o:t}function d(t){let n;for(let r=0;r<t.length;r++){const o=t.charCodeAt(r);o===35||o===63?(n===void 0&&(n=t.substr(0,r)),n+=u[o]):n!==void 0&&(n+=t[r])}return n!==void 0?n:t}function p(t,n){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function S(t,n){const r=n?d:l;let o="",{scheme:a,authority:h,path:b,query:E,fragment:T}=t;if(a&&(o+=a,o+=":"),(h||a==="file")&&(o+=w,o+=w),h){let O=h.indexOf("@");if(O!==-1){const M=h.substr(0,O);h=h.substr(O+1),O=M.lastIndexOf(":"),O===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,O),!1,!1),o+=":",o+=r(M.substr(O+1),!1,!0)),o+="@"}h=h.toLowerCase(),O=h.lastIndexOf(":"),O===-1?o+=r(h,!1,!0):(o+=r(h.substr(0,O),!1,!0),o+=h.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}o+=r(b,!0,!1)}return E&&(o+="?",o+=r(E,!1,!1)),T&&(o+="#",o+=n?T:l(T,!1,!1)),o}function R(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+R(t.substr(3)):t}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(t){return t.match(s)?t.replace(s,n=>R(n)):t}}),define(oe[144],ae([0,1,8]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(y){const C=y;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=i;function D(y){const C=[];let w;try{const g=JSON.parse(y.arguments),m=g[g.length-1];m&&m.__$stack&&(g.pop(),w=m.__$stack),C.push(...g)}catch{C.push("Unable to log remote console arguments",y.arguments)}return{args:C,stack:w}}e.parse=D;function k(y){if(typeof y!="string")return k(D(y).stack);const C=y;if(C){const w=N(C),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function N(y){if(!y)return y;const C=y.indexOf(`
`);return C===-1?y:y.substring(0,C)}function P(y,C){const{args:w,stack:g}=D(y),m=typeof w[0]=="string"&&w.length===1;let f=N(g);f&&(f=`(${f.trim()})`);let v=[];if(typeof w[0]=="string"?f&&m?v=[`%c[${C}] %c${w[0]} %c${f}`,I("blue"),I(""),I("grey")]:v=[`%c[${C}] %c${w[0]}`,I("blue"),I(""),...w.slice(1)]:v=[`%c[${C}]%`,I("blue"),...w],f&&!m&&v.push(f),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,v)}e.log=P;function I(y){return`color: ${y}`}}),define(oe[67],ae([0,1,17,27,8]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(y){return JSON.stringify(y,P)}e.stringify=k;function N(y){let C=JSON.parse(y);return C=I(C),C}e.parse=N;function P(y,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,i.regExpFlags)(C)}:C}function I(y,C=0){if(!y||C>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return D.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof L.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let w=0;w<y.length;++w)y[w]=I(y[w],C+1);else for(const w in y)Object.hasOwnProperty.call(y,w)&&(y[w]=I(y[w],C+1))}return y}e.revive=I}),define(oe[24],ae([0,1,7,4,8]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${k.vscodeRemoteResource}`}set(C,w,g){this.a[C]=w,this.b[C]=g}setConnectionToken(C,w){this.c[C]=w}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(u){return L.onUnexpectedError(u),C}const w=C.authority;let g=this.a[w];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const m=this.b[w],f=this.c[w];let v=`path=${encodeURIComponent(C.path)}`;return typeof f=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),D.URI.from({scheme:i.isWeb?this.d:k.vscodeRemoteResource,authority:`${g}:${m}`,path:this.f,query:v})}}e.RemoteAuthorities=new N,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(C){const w=this.b(C,Z);return this.uriToBrowserUri(w)}uriToBrowserUri(C){return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${k.vscodeFileResource}://${P.a}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||P.a,query:null,fragment:null}):C}asFileUri(C){const w=this.b(C,Z);return this.uriToFileUri(w)}uriToFileUri(C){return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==P.a?C.authority:null,query:null,fragment:null}):C}b(C,w){return D.URI.isUri(C)?C:D.URI.parse(w.toUrl(C))}}P.a="vscode-app",e.FileAccess=new P;var I;(function(y){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(C.get("3"));const w="vscode-coi";function g(f){let v;typeof f=="string"?v=new URL(f).searchParams:f instanceof URL?v=f.searchParams:D.URI.isUri(f)&&(v=new URL(f.toString(!0)).searchParams);const u=v?.get(w);if(!!u)return C.get(u)}y.getHeadersFromQuery=g;function m(f,v,u){if(!globalThis.crossOriginIsolated)return;const l=v&&u?"3":u?"2":"1";f instanceof URLSearchParams?f.set(w,l):f[w]=l}y.addSearchParam=m})(I=e.COI||(e.COI={}))}),define(oe[22],ae([0,1,48,24,12,4,27,8]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=I;class y{constructor(f){this.a=f}compare(f,v,u=!1){return f===v?0:(0,N.compare)(this.getComparisonKey(f,u),this.getComparisonKey(v,u))}isEqual(f,v,u=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,u)===this.getComparisonKey(v,u)}getComparisonKey(f,v=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,v,u=!1){if(f.scheme===v.scheme){if(f.scheme===i.Schemas.file)return L.isEqualOrParent(I(f),I(v),this.a(f))&&f.query===v.query&&(u||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return L.isEqualOrParent(f.path,v.path,this.a(f),"/")&&f.query===v.query&&(u||f.fragment===v.fragment)}return!1}joinPath(f,...v){return P.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===i.Schemas.file?v=P.URI.file(D.dirname(I(f))).path:(v=D.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===i.Schemas.file?v=P.URI.file(D.normalize(I(f))).path:v=D.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===i.Schemas.file){const d=D.relative(I(f),I(v));return k.isWindows?L.toSlashes(d):d}let u=f.path||"/";const l=v.path||"/";if(this.a(f)){let d=0;for(const p=Math.min(u.length,l.length);d<p&&!(u.charCodeAt(d)!==l.charCodeAt(d)&&u.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);u=l.substr(0,d)+u.substr(d)}return D.posix.relative(u,l)}resolvePath(f,v){if(f.scheme===i.Schemas.file){const u=P.URI.file(D.resolve(I(f),v));return f.with({authority:u.authority,path:u.path})}return v=L.toPosixPath(v),f.with({path:D.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,N.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=D.sep){if(f.scheme===i.Schemas.file){const u=I(f);return u.length>L.getRoot(u).length&&u[u.length-1]===v}else{const u=f.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=D.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=D.sep){let u=!1;if(f.scheme===i.Schemas.file){const l=I(f);u=l!==void 0&&l.length===L.getRoot(l).length&&l[l.length-1]===v}else{v="/";const l=f.path;u=l.length===1&&l.charCodeAt(l.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(m=>m.scheme===i.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new y(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(m,f){const v=[];for(let u=0;u<m.length;u++){const l=f(m[u]);m.some((d,p)=>p===u?!1:(0,e.isEqualOrParent)(l,f(d)))||v.push(m[u])}return v}e.distinctParents=C;var w;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function f(v){const u=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(p=>{const[S,R]=p.split(":");S&&R&&u.set(S,R)});const d=v.path.substring(0,v.path.indexOf(";"));return d&&u.set(m.META_DATA_MIME,d),u}m.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function g(m,f,v){if(f){let u=m.path;return u&&u[0]!==D.posix.sep&&(u=D.posix.sep+u),m.with({scheme:v,authority:f,path:u})}return m.with({scheme:v})}e.toLocalResource=g}),define(oe[6],ae([0,1,23,7,3,2,22,4]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(te){return!!te&&typeof te.then=="function"}e.isThenable=I;function y(te){const U=new L.CancellationTokenSource,B=te(U.token),W=new Promise((q,J)=>{const _=U.token.onCancellationRequested(()=>{_.dispose(),U.dispose(),J(new i.CancellationError)});Promise.resolve(B).then(Y=>{_.dispose(),U.dispose(),q(Y)},Y=>{_.dispose(),U.dispose(),J(Y)})});return new class{cancel(){U.cancel()}then(q,J){return W.then(q,J)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=y;function C(te,U,B){return new Promise((W,q)=>{const J=U.onCancellationRequested(()=>{J.dispose(),W(B)});te.then(W,q).finally(()=>J.dispose())})}e.raceCancellation=C;function w(te,U){return new Promise((B,W)=>{const q=U.onCancellationRequested(()=>{q.dispose(),W(new i.CancellationError)});te.then(B,W).finally(()=>q.dispose())})}e.raceCancellationError=w;async function g(te){let U=-1;const B=te.map((q,J)=>q.then(_=>(U=J,_))),W=await Promise.race(B);return te.forEach((q,J)=>{J!==U&&q.cancel()}),W}e.raceCancellablePromises=g;function m(te,U,B){let W;const q=setTimeout(()=>{W?.(void 0),B?.()},U);return Promise.race([te.finally(()=>clearTimeout(q)),new Promise(J=>W=J)])}e.raceTimeout=m;function f(te){return new Promise((U,B)=>{const W=te();I(W)?W.then(U,B):U(W)})}e.asPromise=f;class v{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const B=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=U(),new Promise((B,W)=>{this.a.then(q=>{this.a=null,B(q)},q=>{this.a=null,W(q)})})}}e.Throttler=v;class u{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=u;class l{constructor(){this.a=new Map}queue(U,B){const q=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(U)===q&&this.a.delete(U)});return this.a.set(U,q),q}}e.SequencerByKey=l;const d=(te,U)=>{let B=!0;const W=setTimeout(()=>{B=!1,U()},te);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},p=te=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,te())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,B=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((q,J)=>{this.d=q,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===e.MicrotaskDelay?p(W):d(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=S;class R{constructor(U){this.a=new S(U),this.b=new v}trigger(U,B){return this.a.trigger(()=>this.b.queue(U),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=R;class s{constructor(){this.a=!1,this.b=new Promise((U,B)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class c extends s{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=c;function t(te,U){return U?new Promise((B,W)=>{const q=setTimeout(()=>{J.dispose(),B()},te),J=U.onCancellationRequested(()=>{clearTimeout(q),J.dispose(),W(new i.CancellationError)})}):y(B=>t(te,B))}e.timeout=t;function n(te,U=0){const B=setTimeout(te,U);return(0,k.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=n;function r(te){const U=[];let B=0;const W=te.length;function q(){return B<W?te[B++]():null}function J(_){_!=null&&U.push(_);const Y=q();return Y?Y.then(J):Promise.resolve(U)}return Promise.resolve(null).then(J)}e.sequence=r;function o(te,U=W=>!!W,B=null){let W=0;const q=te.length,J=()=>{if(W>=q)return Promise.resolve(B);const _=te[W++];return Promise.resolve(_()).then(Q=>U(Q)?Promise.resolve(Q):J())};return J()}e.first=o;function a(te,U=W=>!!W,B=null){if(te.length===0)return Promise.resolve(B);let W=te.length;const q=()=>{W=-1;for(const J of te)J.cancel?.()};return new Promise((J,_)=>{for(const Y of te)Y.then(Q=>{--W>=0&&U(Q)?(q(),J(Q)):W===0&&J(B)}).catch(Q=>{--W>=0&&(q(),_(Q))})})}e.firstParallel=a;class h{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((B,W)=>{this.f.push({factory:U,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const B=U.factory();B.then(U.c,U.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class b extends h{constructor(){super(1)}}e.Queue=b;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new G;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,B=N.extUri){const W=B.getComparisonKey(U);let q=this.a.get(W);return q||(q=new b,D.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,q)),q}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class T{constructor(U,B){this.a=-1,typeof U=="function"&&typeof B=="number"&&this.setIfNotSet(U,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},B)}setIfNotSet(U,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},B))}}e.TimeoutTimer=T;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setInterval(()=>{U()},B)}}e.IntervalTimer=O;class M{constructor(U,B){this.b=-1,this.a=U,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=M;class F{constructor(U,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=U,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class A extends M{constructor(U,B){super(U,B),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=A;class $ extends k.Disposable{constructor(U,B){super(),this.g=U,this.h=B,this.a=[],this.b=this.B(new k.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of U)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,P.setTimeout0)(()=>{if(U)return;const B=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(te,U)=>{const B=requestIdleCallback(te,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(B))}}}}();class z{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function H(te,U,B){let W;for(let q=0;q<B;q++)try{return await te()}catch(J){W=J,await t(U)}throw W}e.retry=H;class X{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,B,W){return this.a={taskId:U,cancel:()=>W?.(),promise:B},B.then(()=>this.d(U),()=>this.d(U)),B}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let B,W;const q=new Promise((J,_)=>{B=J,W=_});this.b={run:U,promise:q,promiseResolve:B,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ie{constructor(U,B=()=>Date.now()){this.d=U,this.f=B,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=ie;class G{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,B)=>{this.a=U,this.b=B})}complete(U){return new Promise(B=>{this.a(U),this.f=!0,B()})}error(U){return new Promise(B=>{this.b(U),this.d=!0,B()})}cancel(){new Promise(U=>{this.b(new i.CancellationError),this.d=!0,U()})}}e.DeferredPromise=G;var j;(function(te){async function U(W){let q;const J=await Promise.all(W.map(_=>_.then(Y=>Y,Y=>{q||(q=Y)})));if(typeof q<"u")throw q;return J}te.settled=U;function B(W){return new Promise(async(q,J)=>{try{await W(q,J)}catch(_){J(_)}})}te.withAsyncBody=B})(j=e.Promises||(e.Promises={}));var V;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(V||(V={}));class x{static fromArray(U){return new x(B=>{B.emitMany(U)})}static fromPromise(U){return new x(async B=>{B.emitMany(await U)})}static fromPromises(U){return new x(async B=>{await Promise.all(U.map(async W=>B.emitOne(await W)))})}static merge(U){return new x(async B=>{await Promise.all(U.map(async W=>{for await(const q of W)B.emitOne(q)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(U(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(U,B){return new x(async W=>{for await(const q of U)W.emitOne(B(q))})}map(U){return x.map(this,U)}static filter(U,B){return new x(async W=>{for await(const q of U)B(q)&&W.emitOne(q)})}filter(U){return x.filter(this,U)}static coalesce(U){return x.filter(U,B=>!!B)}coalesce(){return x.coalesce(this)}static async toPromise(U){const B=[];for await(const W of U)B.push(W);return B}toPromise(){return x.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=x,x.EMPTY=x.fromArray([]);class ee extends x{constructor(U,B){super(B),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ee;function re(te){const U=new L.CancellationTokenSource,B=te(U.token);return new ee(U,async W=>{const q=U.token.onCancellationRequested(()=>{q.dispose(),U.dispose(),W.reject(new i.CancellationError)});try{for await(const J of B){if(U.token.isCancellationRequested)return;W.emitOne(J)}q.dispose(),U.dispose()}catch(J){q.dispose(),U.dispose(),W.reject(J)}})}e.createCancelableAsyncIterable=re}),define(oe[90],ae([0,1,21,6,48,37,12,4,27]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",w="[^/\\\\]",g=/\//g;function m(G,j){switch(G){case 0:return"";case 1:return`${w}*?`;default:return`(?:${C}|${w}+${C}${j?`|${C}${w}+`:""})*?`}}function f(G,j){if(!G)return[];const V=[];let x=!1,ee=!1,re="";for(const te of G){switch(te){case j:if(!x&&!ee){V.push(re),re="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}re+=te}return re&&V.push(re),V}e.splitGlobAware=f;function v(G){if(!G)return"";let j="";const V=f(G,e.GLOB_SPLIT);if(V.every(x=>x===e.GLOBSTAR))j=".*";else{let x=!1;V.forEach((ee,re)=>{if(ee===e.GLOBSTAR){if(x)return;j+=m(2,re===V.length-1)}else{let te=!1,U="",B=!1,W="";for(const q of ee){if(q!=="}"&&te){U+=q;continue}if(B&&(q!=="]"||!W)){let J;q==="-"?J=q:(q==="^"||q==="!")&&!W?J="^":q===e.GLOB_SPLIT?J="":J=(0,I.escapeRegExpCharacters)(q),W+=J;continue}switch(q){case"{":te=!0;continue;case"[":B=!0;continue;case"}":{j+=`(?:${f(U,",").map(Y=>v(Y)).join("|")})`,te=!1,U="";break}case"]":{j+="["+W+"]",B=!1,W="";break}case"?":j+=w;continue;case"*":j+=m(1);continue;default:j+=(0,I.escapeRegExpCharacters)(q)}}re<V.length-1&&(V[re+1]!==e.GLOBSTAR||re+2<V.length)&&(j+=C)}x=ee===e.GLOBSTAR})}return j}const u=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new k.LRUCache(1e4),c=function(){return!1},t=function(){return null};function n(G,j){if(!G)return t;let V;typeof G!="string"?V=G.pattern:V=G,V=V.trim();const x=`${V}_${!!j.trimForExclusions}`;let ee=s.get(x);if(ee)return r(ee,G);let re;return u.test(V)?ee=a(V.substr(4),V):(re=l.exec(o(V,j)))?ee=h(re[1],V):(j.trimForExclusions?p:d).test(V)?ee=b(V,j):(re=S.exec(o(V,j)))?ee=E(re[1].substr(1),V,!0):(re=R.exec(o(V,j)))?ee=E(re[1],V,!1):ee=T(V),s.set(x,ee),r(ee,G)}function r(G,j){if(typeof j=="string")return G;const V=function(x,ee){return(0,D.isEqualOrParent)(x,j.base,!P.isLinux)?G((0,I.ltrim)(x.substr(j.base.length),N.sep),ee):null};return V.allBasenames=G.allBasenames,V.allPaths=G.allPaths,V.basenames=G.basenames,V.patterns=G.patterns,V}function o(G,j){return j.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function a(G,j){return function(V,x){return typeof V=="string"&&V.endsWith(G)?j:null}}function h(G,j){const V=`/${G}`,x=`\\${G}`,ee=function(te,U){return typeof te!="string"?null:U?U===G?j:null:te===G||te.endsWith(V)||te.endsWith(x)?j:null},re=[G];return ee.basenames=re,ee.patterns=[j],ee.allBasenames=re,ee}function b(G,j){const V=X(G.slice(1,-1).split(",").map(U=>n(U,j)).filter(U=>U!==t),G),x=V.length;if(!x)return t;if(x===1)return V[0];const ee=function(U,B){for(let W=0,q=V.length;W<q;W++)if(V[W](U,B))return G;return null},re=V.find(U=>!!U.allBasenames);re&&(ee.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(ee.allPaths=te),ee}function E(G,j,V){const x=N.sep===N.posix.sep,ee=x?G:G.replace(g,N.sep),re=N.sep+ee,te=N.posix.sep+G;let U;return V?U=function(B,W){return typeof B=="string"&&(B===ee||B.endsWith(re)||!x&&(B===G||B.endsWith(te)))?j:null}:U=function(B,W){return typeof B=="string"&&(B===ee||!x&&B===G)?j:null},U.allPaths=[(V?"*/":"./")+G],U}function T(G){try{const j=new RegExp(`^${v(G)}$`);return function(V){return j.lastIndex=0,typeof V=="string"&&j.test(V)?G:null}}catch{return t}}function O(G,j,V){return!G||typeof j!="string"?!1:M(G)(j,void 0,V)}e.match=O;function M(G,j={}){if(!G)return c;if(typeof G=="string"||F(G)){const V=n(G,j);if(V===t)return c;const x=function(ee,re){return!!V(ee,re)};return V.allBasenames&&(x.allBasenames=V.allBasenames),V.allPaths&&(x.allPaths=V.allPaths),x}return z(G,j)}e.parse=M;function F(G){const j=G;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=F;function A(G){return G.allBasenames||[]}e.getBasenameTerms=A;function $(G){return G.allPaths||[]}e.getPathTerms=$;function z(G,j){const V=X(Object.getOwnPropertyNames(G).map(U=>H(U,G[U],j)).filter(U=>U!==t)),x=V.length;if(!x)return t;if(!V.some(U=>!!U.requiresSiblings)){if(x===1)return V[0];const U=function(q,J){let _;for(let Y=0,Q=V.length;Y<Q;Y++){const se=V[Y](q,J);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(_||(_=[]),_.push(se))}return _?(async()=>{for(const Y of _){const Q=await Y;if(typeof Q=="string")return Q}return null})():null},B=V.find(q=>!!q.allBasenames);B&&(U.allBasenames=B.allBasenames);const W=V.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return W.length&&(U.allPaths=W),U}const ee=function(U,B,W){let q,J;for(let _=0,Y=V.length;_<Y;_++){const Q=V[_];Q.requiresSiblings&&W&&(B||(B=(0,N.basename)(U)),q||(q=B.substr(0,B.length-(0,N.extname)(U).length)));const se=Q(U,B,q,W);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(J||(J=[]),J.push(se))}return J?(async()=>{for(const _ of J){const Y=await _;if(typeof Y=="string")return Y}return null})():null},re=V.find(U=>!!U.allBasenames);re&&(ee.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(ee.allPaths=te),ee}function H(G,j,V){if(j===!1)return t;const x=n(G,V);if(x===t)return t;if(typeof j=="boolean")return x;if(j){const ee=j.when;if(typeof ee=="string"){const re=(te,U,B,W)=>{if(!W||!x(te,U))return null;const q=ee.replace("$(basename)",()=>B),J=W(q);return(0,i.isThenable)(J)?J.then(_=>_?G:null):J?G:null};return re.requiresSiblings=!0,re}}return x}function X(G,j){const V=G.filter(U=>!!U.basenames);if(V.length<2)return G;const x=V.reduce((U,B)=>{const W=B.basenames;return W?U.concat(W):U},[]);let ee;if(j){ee=[];for(let U=0,B=x.length;U<B;U++)ee.push(j)}else ee=V.reduce((U,B)=>{const W=B.patterns;return W?U.concat(W):U},[]);const re=function(U,B){if(typeof U!="string")return null;if(!B){let q;for(q=U.length;q>0;q--){const J=U.charCodeAt(q-1);if(J===47||J===92)break}B=U.substr(q)}const W=x.indexOf(B);return W!==-1?ee[W]:null};re.basenames=x,re.patterns=ee,re.allBasenames=x;const te=G.filter(U=>!U.basenames);return te.push(re),te}function ie(G,j){return(0,L.equals)(G,j,(V,x)=>typeof V=="string"&&typeof x=="string"?V===x:typeof V!="string"&&typeof x!="string"?V.base===x.base&&V.pattern===x.pattern:!1)}e.patternsEquals=ie}),define(oe[145],ae([0,1,17,8]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(w){return w.toJSON()}class k{constructor(g){this.a=g}transformIncoming(g){const m=this.a.transformIncoming(g);return m===g?g:D(i.URI.from(m))}transformOutgoing(g){const m=this.a.transformOutgoing(g);return m===g?g:D(i.URI.from(m))}transformOutgoingURI(g){const m=this.a.transformOutgoing(g);return m===g?g:i.URI.from(m)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function N(w,g,m){if(!w||m>200)return null;if(typeof w=="object"){if(w instanceof i.URI)return g.transformOutgoing(w);for(const f in w)if(Object.hasOwnProperty.call(w,f)){const v=N(w[f],g,m+1);v!==null&&(w[f]=v)}}return null}function P(w,g){const m=N(w,g,0);return m===null?w:m}e.transformOutgoingURIs=P;function I(w,g,m,f){if(!w||f>200)return null;if(typeof w=="object"){if(w.$mid===1)return m?i.URI.revive(g.transformIncoming(w)):g.transformIncoming(w);if(w instanceof L.VSBuffer)return null;for(const v in w)if(Object.hasOwnProperty.call(w,v)){const u=I(w[v],g,m,f+1);u!==null&&(w[v]=u)}}return null}function y(w,g){const m=I(w,g,!1,0);return m===null?w:m}e.transformIncomingURIs=y;function C(w,g){const m=I(w,g,!0,0);return m===null?w:m}e.transformAndReviveIncomingURIs=C}),define(oe[146],ae([0,1,34,7,49,31,133]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,w=0;const g=(0,L.networkInterfaces)();for(const m in g){const f=g[m];if(f)for(const{mac:v,internal:u}of f)u||(w+=1,this.c(v.toUpperCase())&&(C+=1))}this.b=w>0?C/w:0}return this.b}};let P;async function I(){return P||(P=(async()=>await y()||k.generateUuid())()),P}e.getMachineId=I;async function y(){try{const C=await new Promise((g,m)=>{Z(["crypto"],g,m)}),w=(0,N.getMac)();return C.createHash("sha256").update(w,"utf8").digest("hex")}catch(C){i.onUnexpectedError(C);return}}}),define(oe[28],ae([0,1,53,34,288,6,48,85,12,4,22,8]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function m(z,H=g.UNLINK){if((0,N.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return H===g.UNLINK?v(z):f(z)}async function f(z){try{const H=(0,N.randomPath)((0,i.tmpdir)());try{await L.promises.rename(z,H)}catch(X){return X.code==="ENOENT"?void 0:v(z)}v(H).catch(X=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function v(z){return(0,D.promisify)(L.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function u(z){if((0,N.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function l(z,H){return S(await(H?d(z):(0,D.promisify)(L.readdir)(z)))}async function d(z){try{return await(0,D.promisify)(L.readdir)(z,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const H=[],X=await l(z);for(const ie of X){let G=!1,j=!1,V=!1;try{const x=await e.Promises.lstat((0,I.join)(z,ie));G=x.isFile(),j=x.isDirectory(),V=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}H.push({name:ie,isFile:()=>G,isDirectory:()=>j,isSymbolicLink:()=>V})}return H}function p(z){return S(L.readdirSync(z))}e.readdirSync=p;function S(z){return z.map(H=>typeof H=="string"?y.isMacintosh?(0,P.normalizeNFC)(H):H:(H.name=y.isMacintosh?(0,P.normalizeNFC)(H.name):H.name,H))}async function R(z){const H=await l(z),X=[];for(const ie of H)await c.existsDirectory((0,I.join)(z,ie))&&X.push(ie);return X}function s(z,H=1e3){return new Promise(X=>{let ie=!1;const G=setInterval(()=>{ie||(ie=!0,L.access(z,j=>{ie=!1,j&&(clearInterval(G),X(void 0))}))},H)})}e.whenDeleted=s;var c;(function(z){async function H(G){let j;try{if(j=await e.Promises.lstat(G),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(y.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw x}throw V}}z.stat=H;async function X(G){try{const{stat:j,symbolicLink:V}=await z.stat(G);return j.isFile()&&V?.dangling!==!0}catch{}return!1}z.existsFile=X;async function ie(G){try{const{stat:j,symbolicLink:V}=await z.stat(G);return j.isDirectory()&&V?.dangling!==!0}catch{}return!1}z.existsDirectory=ie})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function n(z,H,X){return t.queueFor(w.URI.file(z),C.extUriBiasedIgnorePathCase).queue(()=>{const ie=b(X);return new Promise((G,j)=>a(z,H,ie,V=>V?j(V):G()))})}let r=!0;function o(z){r=z}e.configureFlushOnWrite=o;function a(z,H,X,ie){if(!r)return L.writeFile(z,H,{mode:X.mode,flag:X.flag},ie);L.open(z,X.flag,X.mode,(G,j)=>{if(G)return ie(G);L.writeFile(j,H,V=>{if(V)return L.close(j,()=>ie(V));L.fdatasync(j,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),o(!1)),L.close(j,ee=>ie(ee))))})})}function h(z,H,X){const ie=b(X);if(!r)return L.writeFileSync(z,H,{mode:ie.mode,flag:ie.flag});const G=L.openSync(z,ie.flag,ie.mode);try{L.writeFileSync(G,H);try{L.fdatasyncSync(G)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o(!1)}}finally{L.closeSync(G)}}e.writeFileSync=h;function b(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function E(z,H){if(z!==H)try{await e.Promises.rename(z,H)}catch(X){if(z.toLowerCase()!==H.toLowerCase()&&X.code==="EXDEV"||z.endsWith("."))await T(z,H,{preserveSymlinks:!1}),await m(z,g.MOVE);else throw X}}async function T(z,H,X){return M(z,H,{root:{source:z,target:H},options:X,handledSourcePaths:new Set})}const O=511;async function M(z,H,X){if(X.handledSourcePaths.has(z))return;X.handledSourcePaths.add(z);const{stat:ie,symbolicLink:G}=await c.stat(z);if(G){if(X.options.preserveSymlinks)try{return await $(z,H,X)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(G.dangling)return}return ie.isDirectory()?F(z,H,ie.mode&O,X):A(z,H,ie.mode&O)}async function F(z,H,X,ie){await e.Promises.mkdir(H,{recursive:!0,mode:X});const G=await l(z);for(const j of G)await M((0,I.join)(z,j),(0,I.join)(H,j),ie)}async function A(z,H,X){await e.Promises.copyFile(z,H),await e.Promises.chmod(H,X)}async function $(z,H,X){let ie=await e.Promises.readlink(z);(0,N.isEqualOrParent)(ie,X.root.source,!y.isLinux)&&(ie=(0,I.join)(X.root.target,ie.substr(X.root.source.length+1))),await e.Promises.symlink(ie,H)}e.Promises=new class{get access(){return(0,D.promisify)(L.access)}get stat(){return(0,D.promisify)(L.stat)}get lstat(){return(0,D.promisify)(L.lstat)}get utimes(){return(0,D.promisify)(L.utimes)}get read(){return(z,H,X,ie,G)=>new Promise((j,V)=>{L.read(z,H,X,ie,G,(x,ee,re)=>x?V(x):j({bytesRead:ee,buffer:re}))})}get readFile(){return(0,D.promisify)(L.readFile)}get write(){return(z,H,X,ie,G)=>new Promise((j,V)=>{L.write(z,H,X,ie,G,(x,ee,re)=>x?V(x):j({bytesWritten:ee,buffer:re}))})}get appendFile(){return(0,D.promisify)(L.appendFile)}get fdatasync(){return(0,D.promisify)(L.fdatasync)}get truncate(){return(0,D.promisify)(L.truncate)}get rename(){return(0,D.promisify)(L.rename)}get copyFile(){return(0,D.promisify)(L.copyFile)}get open(){return(0,D.promisify)(L.open)}get close(){return(0,D.promisify)(L.close)}get symlink(){return(0,D.promisify)(L.symlink)}get readlink(){return(0,D.promisify)(L.readlink)}get chmod(){return(0,D.promisify)(L.chmod)}get mkdir(){return(0,D.promisify)(L.mkdir)}get unlink(){return(0,D.promisify)(L.unlink)}get rmdir(){return(0,D.promisify)(L.rmdir)}get realpath(){return(0,D.promisify)(L.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return R}get writeFile(){return n}get rm(){return m}get move(){return E}get copy(){return T}}}),define(oe[147],ae([0,1,53,12,4,27,28]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(g){if(D.isLinux)return g;const m=(0,i.dirname)(g);if(g===m)return g;const f=((0,i.basename)(g)||g).toLowerCase();try{const u=(0,N.readdirSync)(m).filter(l=>l.toLowerCase()===f);if(u.length===1){const l=P(m);if(l)return(0,i.join)(l,u[0])}else if(u.length>1){const l=u.indexOf(f);if(l>=0){const d=P(m);if(d)return(0,i.join)(d,u[l])}}}catch{}return null}e.realcaseSync=P;async function I(g){if(D.isLinux)return g;const m=(0,i.dirname)(g);if(g===m)return g;const f=((0,i.basename)(g)||g).toLowerCase();try{const u=(await N.Promises.readdir(m)).filter(l=>l.toLowerCase()===f);if(u.length===1){const l=await I(m);if(l)return(0,i.join)(l,u[0])}else if(u.length>1){const l=u.indexOf(f);if(l>=0){const d=await I(m);if(d)return(0,i.join)(d,u[l])}}}catch{}return null}e.realcase=I;async function y(g){try{return await N.Promises.realpath(g)}catch{const f=w(g);return await N.Promises.access(f,L.constants.R_OK),f}}e.realpath=y;function C(g){try{return L.realpathSync(g)}catch{const f=w(g);return L.accessSync(f,L.constants.R_OK),f}}e.realpathSync=C;function w(g){return(0,k.rtrim)((0,i.normalize)(g),i.sep)}}),define(oe[91],ae([0,1,34,12,28]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,N=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(I||(I={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class w{constructor(R,s,c){this.exePath=R,this.displayName=s,this.a=c}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:S=!1}={}){return S?y===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:S=!1,findPreview:R=!1}={}){const s=g({useAlternateBitness:S});if(!s)return null;const c=i.join(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(c))return null;let t=-1,n=null;for(const a of await D.Promises.readdir(c)){let h=-1;if(R){const E=a.indexOf("-");if(E<0)continue;const T=a.substring(0,E);if(!k.test(T)||a.substring(E+1)!=="preview")continue;h=parseInt(T,10)}else{if(!k.test(a))continue;h=parseInt(a,10)}if(h<=t)continue;const b=i.join(c,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(b)||(n=b,t=h)}if(!n)return null;const r=s.includes("x86")?" (x86)":"",o=R?" Preview":"";return new w(n,`PowerShell${o}${r}`,!0)}async function f({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const R=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:s,pwshMsixName:c}=S?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(R))if(s.test(t)){const n=i.join(R,t,"pwsh.exe");return new w(n,c)}return null}function v(){const S=i.join(L.homedir(),".dotnet","tools","pwsh.exe");return new w(S,".NET Core PowerShell Global Tool")}function u(){const S=i.join(process.env.windir,y===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(S,"Windows PowerShell",!0)}async function*l(){let S=await m();S&&(yield S),S=await m({useAlternateBitness:!0}),S&&(yield S),S=await f(),S&&(yield S),S=v(),S&&(yield S),S=await m({findPreview:!0}),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await m({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=u(),S&&(yield S)}async function*d(){for await(const S of l())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=d;async function p(){for await(const S of d())return S;return null}e.getFirstAvailablePowerShellInstallation=p}),define(oe[92],ae([0,1,12,4,36,87,13,28]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function I(w=D.env){return w.comspec||"cmd.exe"}e.getWindowsShell=I;function y(w){let g=[],m=!1;const f=function(v){if(m){g.push(v);return}(!w.send(v,l=>{if(l&&console.error(l),m=!1,g.length>0){const d=g.slice(0);g=[],d.forEach(p=>f(p))}})||i.isWindows)&&(m=!0)};return{send:f}}e.createQueuedSender=y;var C;(function(w){async function g(m,f,v){if(L.isAbsolute(m))return m;if(f===void 0&&(f=D.cwd()),L.dirname(m)!=="."||(v===void 0&&N.isString(D.env.PATH)&&(v=D.env.PATH.split(L.delimiter)),v===void 0||v.length===0))return L.join(f,m);async function l(d){if(await P.Promises.exists(d)){let p;try{p=await P.Promises.stat(d)}catch(S){S.message.startsWith("EACCES")&&(p=await P.Promises.lstat(d))}return p?!p.isDirectory():!1}return!1}for(const d of v){let p;if(L.isAbsolute(d)?p=L.join(d,m):p=L.join(f,d,m),await l(p))return p;let S=p+".com";if(await l(S)||(S=p+".exe",await l(S)))return S}return L.join(f,m)}w.findExecutable=g})(C=e.win32||(e.win32={}))}),define(oe[148],ae([0,1,50,24]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(N){return new Promise((P,I)=>{let y;const C=new Map;function w(m,f,v,u,l){const d=C.get(f);if(m===N||d){const p={name:g(v),cmd:v,pid:m,ppid:f,load:u,mem:l};C.set(m,p),m===N&&(y=p),d&&(d.children||(d.children=[]),d.children.push(p),d.children.length>1&&(d.children=d.children.sort((S,R)=>S.pid-R.pid)))}}function g(m){const f=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,u=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,p=/--crashes-directory/,S=/\\pipe\\winpty-control/,R=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(p.exec(m))return"electron-crash-reporter";if(S.exec(m))return"winpty-process";if(R.exec(m))return"console-window-host (Windows internal process)";let c=s.exec(m);if(c&&c.length===2){if(c[1]==="renderer")return f.exec(m)?"shared-process":v.exec(m)?"issue-reporter":u.exec(m)?"process-explorer":"window";if(c[1]==="utility"){if(l.exec(m))return"utility-network-service";if(d.exec(m))return"extension-host"}else if(c[1]==="extensionHost")return"extension-host";return c[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do c=t.exec(m),c&&(n+=c+" ");while(c);return n&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${n}`:m}if(process.platform==="win32"){const m=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,v)=>{Z(["windows-process-tree"],f,v)}).then(f=>{f.getProcessList(N,v=>{if(!v){I(new Error(`Root process ${N} not found`));return}f.getProcessCpuUsage(v,u=>{const l=new Map;u.forEach(d=>{const p=m(d.commandLine||"");l.set(d.pid,{name:g(p),cmd:p,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),y=l.get(N),y?(l.forEach(d=>{const p=l.get(d.ppid);p&&(p.children||(p.children=[]),p.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((p,S)=>p.pid-S.pid))}),P(y)):I(new Error(`Root process ${N} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let m=function(){let f=[y];const v=[];for(;f.length;){const l=f.shift();l&&(v.push(l.pid),l.children&&(f=f.concat(l.children)))}let u=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);u+=" "+v.join(" "),(0,L.exec)(u,{},(l,d,p)=>{if(l||p)I(l||new Error(p.toString()));else{const S=d.toString().split(`
`);for(let R=0;R<v.length;R++){const s=C.get(v[R]);s.load=parseFloat(S[R])}if(!y){I(new Error(`Root process ${N} not found`));return}P(y)}})};(0,L.exec)("which ps",{},(f,v,u)=>{if(f||u)if(process.platform!=="linux")I(f||new Error(u.toString()));else{const l=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(l,{},(d,p,S)=>{d||S?I(d||new Error(S.toString())):(k(p,w),m())})}else{const l=v.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${l} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,S,R)=>{p||R&&!R.includes("screen size is bogus")?I(p||new Error(R.toString())):(k(S,w),process.platform==="linux"?m():y?P(y):I(new Error(`Root process ${N} not found`)))})}})}})}e.listProcesses=D;function k(N,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=N.toString().split(`
`);for(const C of y){const w=I.exec(C.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(oe[149],ae([0,1,34,4,91,92]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(w,g){return w===1?i.isWindows?C():k.getWindowsShell(g):I(w,g)}e.getSystemShell=N;let P=null;function I(w,g){if(i.isLinux&&w===2||i.isMacintosh&&w===3)return"/bin/bash";if(!P){let m;if(i.isWindows)m="/bin/bash";else{if(m=g.SHELL,!m)try{m=(0,L.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}P=m}return P}let y=null;async function C(){return y||(y=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),y}});var ye=this&&this.__decorate||function(Z,e,L,i){var D=arguments.length,k=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,L):i,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Z,e,L,i);else for(var P=Z.length-1;P>=0;P--)(N=Z[P])&&(k=(D<3?N(k):D>3?N(e,L,k):N(e,L))||k);return D>3&&k&&Object.defineProperty(e,L,k),k};define(oe[39],ae([0,1,21,6,17,23,63,7,3,2,67,27,13]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(m||(m={}));function f(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(v||(v={}));function u(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(l||(l={}));function d(j){let V=0;for(let x=0;;x+=7){const ee=j.read(1);if(V|=(ee.buffer[0]&127)<<x,!(ee.buffer[0]&128))return V}}const p=t(0);function S(j,V){if(V===0){j.write(p);return}let x=0;for(let re=V;re!==0;re=re>>>7)x++;const ee=D.VSBuffer.alloc(x);for(let re=0;V!==0;re++)ee.buffer[re]=V&127,V=V>>>7,V>0&&(ee.buffer[re]|=128);j.write(ee)}class R{constructor(V){this.b=V,this.a=0}read(V){const x=this.b.slice(this.a,this.a+V);return this.a+=x.byteLength,x}}e.BufferReader=R;class s{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=s;var c;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(c||(c={}));function t(j){const V=D.VSBuffer.alloc(1);return V.writeUInt8(j,0),V}const n={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object),Uint:t(c.Int)},r=typeof Buffer<"u";function o(j,V){if(typeof V>"u")j.write(n.Undefined);else if(typeof V=="string"){const x=D.VSBuffer.fromString(V);j.write(n.String),S(j,x.byteLength),j.write(x)}else if(r&&Buffer.isBuffer(V)){const x=D.VSBuffer.wrap(V);j.write(n.Buffer),S(j,x.byteLength),j.write(x)}else if(V instanceof D.VSBuffer)j.write(n.VSBuffer),S(j,V.byteLength),j.write(V);else if(Array.isArray(V)){j.write(n.Array),S(j,V.length);for(const x of V)o(j,x)}else if(typeof V=="number"&&(V|0)===V)j.write(n.Uint),S(j,V);else{const x=D.VSBuffer.fromString(JSON.stringify(V));j.write(n.Object),S(j,x.byteLength),j.write(x)}}e.serialize=o;function a(j){switch(j.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return j.read(d(j)).toString();case c.Buffer:return j.read(d(j)).buffer;case c.VSBuffer:return j.read(d(j));case c.Array:{const x=d(j),ee=[];for(let re=0;re<x;re++)ee.push(a(j));return ee}case c.Object:return JSON.parse(j.read(d(j)).toString());case c.Int:return d(j)}}e.deserialize=a;class h{constructor(V,x,ee=null,re=1e3){this.h=V,this.j=x,this.k=ee,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(V,x){this.b.set(V,x),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const x=this.o([V.type]);this.k?.logOutgoing(x,0,1,u(V.type));return}case 201:case 202:case 204:case 203:{const x=this.o([V.type,V.id],V.data);this.k?.logOutgoing(x,V.id,1,u(V.type),V.data);return}}}o(V,x=void 0){const ee=new s;return o(ee,V),o(ee,x),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const x=new R(V),ee=a(x),re=a(x),te=ee[0];switch(te){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(te)}: ${ee[2]}.${ee[3]}`,re),this.s({type:te,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(te)}: ${ee[2]}.${ee[3]}`,re),this.t({type:te,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(te)}`),this.u({type:te,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(te)}`),this.u({type:te,id:ee[1]})}}s(V){const x=this.b.get(V.channelName);if(!x){this.v(V);return}const ee=new k.CancellationTokenSource;let re;try{re=x.call(this.j,V.name,V.arg,ee.token)}catch(B){re=Promise.reject(B)}const te=V.id;re.then(B=>{this.m({id:te,data:B,type:201}),this.d.delete(V.id)},B=>{B instanceof Error?this.m({id:te,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:te,data:B,type:203}),this.d.delete(V.id)});const U=(0,y.toDisposable)(()=>ee.cancel());this.d.set(V.id,U)}t(V){const x=this.b.get(V.channelName);if(!x){this.v(V);return}const ee=V.id,te=x.listen(this.j,V.name,V.arg)(U=>this.m({id:ee,data:U,type:204}));this.d.set(V.id,te)}u(V){const x=this.d.get(V.id);x&&(x.dispose(),this.d.delete(V.id))}v(V){let x=this.g.get(V.channelName);x||(x=[],this.g.set(V.channelName,x));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:V,timeoutTimer:ee})}w(V){const x=this.g.get(V);if(x){for(const ee of x)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var b;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(V,x=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=x}getChannel(V){const x=this;return{call(ee,re,te){return x.a?Promise.reject(new P.CancellationError):x.m(V,ee,re,te)},listen(ee,re){return x.a?I.Event.None:x.o(V,ee,re)}}}m(V,x,ee,re=k.CancellationToken.None){const te=this.g++,B={id:te,type:100,channelName:V,name:x,arg:ee};if(re.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((J,_)=>{if(re.isCancellationRequested)return _(new P.CancellationError);const Y=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(te),J(pe.data);break;case 202:{this.f.delete(te);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,_(we);break}case 203:this.f.delete(te),_(pe.data);break}};this.f.set(te,ue),this.p(B)};let Q=null;this.b===l.Idle?Y():(Q=(0,i.createCancelablePromise)(ue=>this.u()),Q.then(()=>{Q=null,Y()}));const se=()=>{Q?(Q.cancel(),Q=null):this.p({id:te,type:101}),_(new P.CancellationError)},le=re.onCancellationRequested(se);W=(0,y.combinedDisposable)((0,y.toDisposable)(se),le),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(V,x,ee){const re=this.g++,U={id:re,type:102,channelName:V,name:x,arg:ee};let B=null;const W=new I.Emitter({onWillAddFirstListener:()=>{B=(0,i.createCancelablePromise)(J=>this.u()),B.then(()=>{B=null,this.d.add(W),this.p(U)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(W),this.p({id:re,type:103}))}}),q=J=>W.fire(J.data);return this.f.set(re,q),W.event}p(V){switch(V.type){case 100:case 102:{const x=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(x,V.id,0,`${f(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const x=this.q([V.type,V.id]);this.j?.logOutgoing(x,V.id,0,f(V.type));return}}}q(V,x=void 0){const ee=new s;return o(ee,V),o(ee,x),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const x=new R(V),ee=a(x),re=a(x),te=ee[0];switch(te){case 200:return this.j?.logIncoming(V.byteLength,0,0,u(te)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,u(te),re),this.t({type:ee[0],id:ee[1],data:re})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}ye([N.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class T{get connections(){const V=[];return this.f.forEach(x=>V.push(x)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:x,onDidClientDisconnect:ee})=>{I.Event.once(x.onMessage)(te=>{const U=new R(te),B=a(U),W=new h(x,B),q=new E(x);this.a.forEach((_,Y)=>W.registerChannel(Y,_));const J={channelServer:W,channelClient:q,ctx:B};this.f.add(J),this.g.fire(J),ee(()=>{W.dispose(),q.dispose(),this.f.delete(J),this.h.fire(J)})})})}getChannel(V,x){const ee=this;return{call(re,te,U){let B;if((0,g.isFunction)(x)){const q=(0,L.getRandomElement)(ee.connections.filter(x));B=q?Promise.resolve(q):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,x))}else B=x.routeCall(ee,re,te);const W=B.then(q=>q.channelClient.getChannel(V));return M(W).call(re,te,U)},listen(re,te){if((0,g.isFunction)(x))return ee.j(V,x,re,te);const U=x.routeEvent(ee,re,te).then(B=>B.channelClient.getChannel(V));return M(U).listen(re,te)}}}j(V,x,ee,re){const te=this;let U=new y.DisposableStore;const B=new I.Emitter({onWillAddFirstListener:()=>{U=new y.DisposableStore;const W=new I.EventMultiplexer,q=new Map,J=Y=>{const se=Y.channelClient.getChannel(V).listen(ee,re),le=W.add(se);q.set(Y,le)},_=Y=>{const Q=q.get(Y);!Q||(Q.dispose(),q.delete(Y))};te.connections.filter(x).forEach(J),I.Event.filter(te.onDidAddConnection,x)(J,void 0,U),te.onDidRemoveConnection(_,void 0,U),W.event(B.fire,B,U),U.add(W)},onDidRemoveLastListener:()=>{U.dispose()}});return B.event}registerChannel(V,x){this.a.set(V,x),this.f.forEach(ee=>{ee.channelServer.registerChannel(V,x)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class O{constructor(V,x,ee=null){const re=new s;o(re,x),V.send(re.buffer),this.a=new E(V,ee),this.d=new h(V,x,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,x){this.d.registerChannel(V,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function M(j){return{call(V,x,ee){return j.then(re=>re.call(V,x,ee))},listen(V,x){const ee=new I.Relay;return j.then(re=>ee.input=re.listen(V,x)),ee.event}}}e.getDelayedChannel=M;function F(j){let V=!1;return{call(x,ee,re){return V?j.call(x,ee,re):(0,i.timeout)(0).then(()=>V=!0).then(()=>j.call(x,ee,re))},listen(x,ee){if(V)return j.listen(x,ee);const re=new I.Relay;return(0,i.timeout)(0).then(()=>V=!0).then(()=>re.input=j.listen(x,ee)),re.event}}}e.getNextTickChannel=F;class A{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const x of V.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await I.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=A;var $;(function(j){function V(te,U){const B=te,W=U&&U.disableMarshalling,q=new Map;for(const J in B)ee(J)&&q.set(J,I.Event.buffer(B[J],!0));return new class{listen(J,_,Y){const Q=q.get(_);if(Q)return Q;if(re(_)){const se=B[_];if(typeof se=="function")return se.call(B,Y)}throw new Error(`Event not found: ${_}`)}call(J,_,Y){const Q=B[_];if(typeof Q=="function"){if(!W&&Array.isArray(Y))for(let se=0;se<Y.length;se++)Y[se]=(0,C.revive)(Y[se]);return Q.apply(B,Y)}throw new Error(`Method not found: ${_}`)}}}j.fromService=V;function x(te,U){const B=U&&U.disableMarshalling;return new Proxy({},{get(W,q){if(typeof q=="string")return U?.properties?.has(q)?U.properties.get(q):re(q)?function(J){return te.listen(q,J)}:ee(q)?te.listen(q):async function(...J){let _;U&&!(0,g.isUndefinedOrNull)(U.context)?_=[U.context,...J]:_=J;const Y=await te.call(q,_);return B?Y:(0,C.revive)(Y)};throw new Error(`Property not found: ${String(q)}`)}})}j.toService=x;function ee(te){return te[0]==="o"&&te[1]==="n"&&w.isUpperAsciiLetter(te.charCodeAt(2))}function re(te){return/^onDynamic/.test(te)&&w.isUpperAsciiLetter(te.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const V=j.toString();if(V!=="[object Object]")return V}return j}function X(j){return Array.isArray(j)?j.map(H):H(j)}function ie(j,V,x,ee,re,te,U){U=X(U);const B=z[re],W=B[ee%B.length];let q=[`%c[${j}]%c[${String(V).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(te)?(q=q.concat(U),q.push(")")):q.push(U),console.log.apply(console,q)}class G{constructor(V,x){this.d=V,this.f=x,this.a=0,this.b=0}logOutgoing(V,x,ee,re,te){this.b+=V,ie(this.d,this.b,V,x,ee,re,te)}logIncoming(V,x,ee,re,te){this.a+=V,ie(this.f,this.a,V,x,ee,re,te)}}e.IPCLogger=G}),define(oe[150],ae([0,1,17,3,39]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(I){this.a=I,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",y=>L.VSBuffer.wrap(y.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=k;class N extends D.IPCClient{constructor(I,y){const C=new k(I);super(C,y),this.b=C}dispose(){this.b.disconnect()}}e.Client=N}),define(oe[93],ae([0,1,6,17,3,2,39]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(E){E.enableDiagnostics=!1,E.records=[];const T=new WeakMap;let O=0;function M(A,$){if(!T.has(A)){const z=String(++O);T.set(A,z)}return T.get(A)}function F(A,$,z,H){if(!E.enableDiagnostics)return;const X=M(A,$);if(H instanceof i.VSBuffer||H instanceof Uint8Array||H instanceof ArrayBuffer||ArrayBuffer.isView(H)){const ie=i.VSBuffer.alloc(H.byteLength);ie.set(H),E.records.push({timestamp:Date.now(),id:X,label:$,type:z,buff:ie})}else E.records.push({timestamp:Date.now(),id:X,label:$,type:z,data:H})}E.traceSocketEvent=F})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function w(){return C||(C=i.VSBuffer.alloc(0)),C}class g{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,O){if(T===0)return w();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const $=this.a[0];return O&&(this.a.shift(),this.b-=T),$}if(this.a[0].byteLength>T){const $=this.a[0].slice(0,T);return O&&(this.a[0]=this.a[0].slice(T),this.b-=T),$}const M=i.VSBuffer.alloc(T);let F=0,A=0;for(;T>0;){const $=this.a[A];if($.byteLength>T){const z=$.slice(0,T);M.set(z,F),F+=T,O&&(this.a[A]=$.slice(T),this.b-=T),T-=T}else M.set($,F),F+=$.byteLength,O?(this.a.shift(),this.b-=$.byteLength):A++,T-=$.byteLength}return M}}e.ChunkStream=g;var m;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(m||(m={}));function f(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(T,O,M,F){this.type=T,this.id=O,this.ack=M,this.data=F,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends k.Disposable{constructor(T){super(),this.f=this.B(new D.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new g,this.B(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,F=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new u(M,F,A,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=i.VSBuffer.alloc(13);O.writeUInt8(T.type,0),O.writeUInt32BE(T.id,1),O.writeUInt32BE(T.ack,5),O.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(O,T.data)}g(T,O){const M=this.f===0;return this.d.push(T,O),this.f+=T.byteLength+O.byteLength,M}h(){const T=i.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,O){this.g(T,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class p extends k.Disposable{constructor(T){super(),this.f=new D.Emitter,this.onMessage=this.f.event,this.g=new D.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new d(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new u(1,0,0,T))}}e.Protocol=p;class S extends N.IPCClient{static fromSocket(T,O){return new S(new p(T),O)}get onDidDispose(){return this.b.onDidDispose}constructor(T,O,M=null){super(T,O,M),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=S;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class s{constructor(T){this.data=T,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let T=0,O=this.a;for(;O;)O=O.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let O=0,M=this.a;for(;M;)T[O++]=M.data,M=M.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const O=new s(T);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const T=Date.now();for(let O=0;O<t.a;O++)this.c[O]=T-1e3*O;setInterval(()=>{for(let O=t.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),O=(1+t.a)*1e3;let M=0;for(let F=0;F<t.a;F++)T-this.c[F]<=O&&M++;return 1-M/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var n;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class o{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=o;class a{constructor(T,O){this.roundTripTime=T,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=a;class h{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??t.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new k.DisposableStore,this.o=T.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new u(5,0,0,w());this.p.write(T),this.p.flush()}sendPause(){const T=new u(7,0,0,w());this.p.write(T)}sendResume(){const T=new u(8,0,0,w());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,O){this.a=!0,this.t.dispose(),this.t=new k.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new u(3,0,this.h,w());this.p.write(T);const O=this.b.toArray();for(let M=0,F=O.length;M<F;M++)this.p.write(O[M]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const O=this.b.peek();if(O&&O.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new u(6,0,0,w())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let M=0,F=O.length;M<F;M++)this.p.write(O[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const O=++this.c;this.h=this.g;const M=new u(1,O,this.h,T);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(T){const O=new u(2,0,0,T);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),O=Date.now()-T.writtenTime,M=Date.now()-this.q.lastReadTime,F=Date.now()-this.n;if(O>=2e4&&M>=2e4&&F>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:M});return}const A=Math.max(2e4-O,2e4-M,2e4-F,500);this.f=setTimeout(()=>{this.f=null,this.G()},A)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new u(3,0,this.h,w());this.p.write(T)}I(){this.h=this.g;const T=new u(9,0,this.h,w());this.p.write(T)}J(T){this.h=this.g;const O=new u(10,0,this.h,T);this.p.write(O)}K(T){this.h=this.g;const O=new u(11,0,this.h,T);this.p.write(O)}}e.PersistentProtocol=h;class b extends k.Disposable{constructor(){super(),this.a=this.B(new D.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new D.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new D.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new L.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,O=i.VSBuffer.alloc(4);O.writeUInt32BE(T,0),this.a.fire(O)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const O=T.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const M=Date.now()-this.g,F=this.k++;this.j[F%this.j.length]=M;const A=this.l,$=this.j.filter(z=>z>=1e3).length;this.l=$>=3?1:0,M>1e3&&this.b.fire(new a(M,$)),A!==this.l&&this.c.fire(this.l)}}}),define(oe[151],ae([0,1,94,3,39,150]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class N extends D.IPCServer{static b(){const I=i.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(y,C)=>C);return i.Event.map(I,y=>{const{port1:C,port2:w}=new MessageChannel,m={protocol:new k.Protocol(C),onDidClientDisconnect:i.Event.fromDOMEventEmitter(C,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",y,[w]),m})}constructor(){super(N.b())}}e.Server=N}),define(oe[68],ae([0,1,50,6,17,23,144,7,3,2,32,92,87,39]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends m.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=f;class v{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const p=d&&d.timeout?d.timeout:6e4;this.b=new i.Delayer(p),this.d=null,this.f=null}getChannel(l){const d=this;return{call(p,S,R){return d.k(l,p,S,R)},listen(p,S){return d.l(l,p,S)}}}k(l,d,p,S=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const R=this.n(l),s=(0,i.createCancelablePromise)(n=>R.call(d,p,n)),c=S.onCancellationRequested(()=>s.cancel()),t=(0,y.toDisposable)(()=>s.cancel());return this.c.add(t),s.finally(()=>{c.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,d,p){if(!this.b)return I.Event.None;this.b.cancel();let S;const R=new I.Emitter({onWillAddFirstListener:()=>{S=this.n(l).listen(d,p)(R.fire,R),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,g.removeDangerousEnvVariables)(d.env),this.d=(0,L.fork)(this.i,l,d);const p=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.isRemoteConsoleLog)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}p.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const R=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,s=r=>this.d&&this.d.connected&&R.send(r.buffer.toString("base64")),c=p.event,t={send:s,onMessage:c};this.f=new m.ChannelClient(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,y.dispose)(a)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(oe[152],ae([0,1,17,7,3,2,12,4,31,39,93]),function(Z,e,L,i,D,k,N,P,I,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class g{traceSocketEvent(a,h){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}constructor(a,h=""){this.f=!0,this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=b=>{if(this.traceSocketEvent("error",{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,i.onUnexpectedError)(b)}},this.socket.on("error",this.a),this.b=b=>{this.traceSocketEvent("close",{hadError:b}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const h=b=>{this.traceSocketEvent("read",b),a(L.VSBuffer.wrap(b))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=b=>{a({type:0,hadError:b,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=g;var m;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var f;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(f||(f={}));class v extends k.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}constructor(a,h,b,E){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:b?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new u(this,h,b,E,this.f,(T,O)=>this.k(T,O))),this.B(this.a.onError(T=>{console.error(T),(0,i.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new C.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this.a.writeMessage(a)}k(a,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let b=2;a.byteLength<126?b+=0:a.byteLength<2**16?b+=2:b+=8;const E=L.VSBuffer.alloc(b);if(h?E.writeUInt8(194,0):E.writeUInt8(130,0),a.byteLength<126)E.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){E.writeUInt8(126,1);let T=1;E.writeUInt8(a.byteLength>>>8&255,++T),E.writeUInt8(a.byteLength>>>0&255,++T)}else{E.writeUInt8(127,1);let T=1;E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(a.byteLength>>>24&255,++T),E.writeUInt8(a.byteLength>>>16&255,++T),E.writeUInt8(a.byteLength>>>8&255,++T),E.writeUInt8(a.byteLength>>>0&255,++T)}this.socket.write(L.VSBuffer.concat([E,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),b=h.readUInt8(0),E=(b&128)>>>7,T=(b&64)>>>6,O=h.readUInt8(1),M=(O&128)>>>7,F=O&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),b=h.readUInt8(1),E=(b&128)>>>7;let T=b&127,O=1;T===126?T=h.readUInt8(++O)*2**8+h.readUInt8(++O):T===127&&(T=h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*2**24+h.readUInt8(++O)*2**16+h.readUInt8(++O)*2**8+h.readUInt8(++O));let M=0;E&&(M=h.readUInt8(++O)*2**24+h.readUInt8(++O)*2**16+h.readUInt8(++O)*2**8+h.readUInt8(++O)),this.j.state=3,this.j.readLen=T,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),p(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class u extends k.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(a,h,b,E,T,O){super(),this.k=a,this.l=T,this.m=O,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,h?(this.b=this.B(new l(this.k,E,b,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const h=await this.r(this.f,a);this.m(h,!0)}else this.m(a,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(a,h){return new Promise((b,E)=>{a.write(h),a.flush(T=>b(T))})}acceptFrame(a,h,b){this.h.push({data:a,isCompressed:h,isLastFrameOfMessage:b}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const h=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.l.fire(h)}else this.l.fire(a.data)}this.s=!1}}u(a,h,b){return new Promise((E,T)=>{a.write(h),b&&a.write(L.VSBuffer.fromByteArray([0,0,255,255])),a.flush(O=>E(O))})}}class l extends k.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(a,h,b,E){super(),this.h=a,this.j=h,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=w().zlib.createInflateRaw(E),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(L.VSBuffer.wrap(T))}),b&&(this.h.traceSocketEvent("zlibInflateInitialWrite",b.buffer),this.b.write(b.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=L.VSBuffer.concat(this.g);this.g.length=0,a(h)})}}class d extends k.Disposable{constructor(a,h){super(),this.g=a,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=w().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",b=>{this.g.traceSocketEvent("zlibDeflateError",{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.g.traceSocketEvent("zlibDeflateData",b),this.f.push(L.VSBuffer.wrap(b))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=L.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function p(o,a){if(a===0)return;const h=o.byteLength>>>2;for(let F=0;F<h;F++){const A=o.readUInt32BE(F*4);o.writeUInt32BE(A^a,F*4)}const b=h*4,E=o.byteLength-b,T=a>>>24&255,O=a>>>16&255,M=a>>>8&255;E>=1&&o.writeUInt8(o.readUInt8(b)^T,b),E>=2&&o.writeUInt8(o.readUInt8(b+1)^O,b+1),E>=3&&o.writeUInt8(o.readUInt8(b+2)^M,b+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function R(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,N.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):a=(0,N.join)(w().os.tmpdir(),`vscode-ipc-${o}.sock`),c(a),a}e.createRandomIPCHandle=R;function s(o,a,h){const b=w().crypto.createHash("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${h}-${a}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,N.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${h}-${a}.sock`):E=(0,N.join)(o,`${h}-${a}.sock`),c(E),E}e.createStaticIPCHandle=s;function c(o){const a=S[P.platform];typeof a=="number"&&o.length>=a&&console.warn(`WARNING: IPC handle "${o}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends y.IPCServer{static b(a){const h=D.Event.fromNodeEventEmitter(a,"connection");return D.Event.map(h,b=>({protocol:new C.Protocol(new g(b,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(b,"close"))}))}constructor(a){super(t.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function n(o){return new Promise((a,h)=>{const b=w().net.createServer();b.on("error",h),b.listen(o,()=>{b.removeListener("error",h),a(new t(b))})})}e.serve=n;function r(o,a){return new Promise((h,b)=>{const E=w().net.createConnection(o,()=>{E.removeListener("error",b),h(C.Client.fromSocket(new g(E,`ipc-client${a}`),a))});E.once("error",b)})}e.connect=r}),define(oe[69],ae([0,1,6,3,2,13]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function P(w){const g=w;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class y extends D.Disposable{constructor(g,m=Object.create(null)){super(),this.m=g,this.n=m,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new L.ThrottledDelayer(y.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((m,f)=>this.s(f,m)),g.deleted?.forEach(m=>this.s(m,void 0))}s(g,m){if(this.c===I.Closed)return;let f=!1;(0,k.isUndefinedOrNull)(m)?f=this.f.delete(g):this.f.get(g)!==m&&(this.f.set(g,m),f=!0),f&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,m){const f=this.f.get(g);return(0,k.isUndefinedOrNull)(f)?m:f}getBoolean(g,m){const f=this.get(g);return(0,k.isUndefinedOrNull)(f)?m:f==="true"}getNumber(g,m){const f=this.get(g);return(0,k.isUndefinedOrNull)(f)?m:parseInt(f,10)}async set(g,m){if(this.c===I.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(g);const f=String(m);if(this.f.get(g)!==f)return this.f.set(g,f),this.j.set(g,f),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===I.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(!!this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(!!this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=y,y.a=100;class C{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((m,f)=>this.a.set(f,m)),g.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[153],ae([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(oe[154],ae([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[155],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(oe[156],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(oe[157],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[158],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[159],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[160],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[161],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[162],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[163],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[164],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[165],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(oe[166],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(oe[167],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(oe[168],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[169],ae([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[170],ae([10,11]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[171],ae([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(oe[172],ae([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(oe[173],ae([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[174],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[175],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[176],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/node/ptyHostService",e)}),define(oe[177],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[178],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[179],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[180],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[181],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[182],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[183],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[184],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[185],ae([10,11]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(oe[95],ae([0,1,65,63,24,12,36,22,8]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class y{get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=N.env.VSCODE_PORTABLE;return f?I.URI.file((0,k.join)(f,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.resolve)(f):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?I.URI.file((0,k.resolve)(f)):I.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.resolve)(f);const v=N.env.VSCODE_EXTENSIONS;if(v)return v;const u=N.env.VSCODE_PORTABLE;return u?(0,k.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,k.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?I.URI.parse(f):I.URI.file((0,k.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);u&&u[1]&&u[2]&&f.push([u[1],u[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=N.env.VSCODE_PORTABLE;return f?I.URI.file((0,k.join)(f,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,u){this.a=f,this.b=v,this.c=u,this.editSessionId=this.args.editSessionId}}ye([i.memoize],y.prototype,"appRoot",null),ye([i.memoize],y.prototype,"userHome",null),ye([i.memoize],y.prototype,"userDataPath",null),ye([i.memoize],y.prototype,"appSettingsHome",null),ye([i.memoize],y.prototype,"tmpDir",null),ye([i.memoize],y.prototype,"cacheHome",null),ye([i.memoize],y.prototype,"stateResource",null),ye([i.memoize],y.prototype,"userRoamingDataHome",null),ye([i.memoize],y.prototype,"userDataSyncHome",null),ye([i.memoize],y.prototype,"userDataSyncLogResource",null),ye([i.memoize],y.prototype,"editSessionsLogResource",null),ye([i.memoize],y.prototype,"sync",null),ye([i.memoize],y.prototype,"machineSettingsResource",null),ye([i.memoize],y.prototype,"workspaceStorageHome",null),ye([i.memoize],y.prototype,"localHistoryHome",null),ye([i.memoize],y.prototype,"keyboardLayoutResource",null),ye([i.memoize],y.prototype,"argvResource",null),ye([i.memoize],y.prototype,"isExtensionDevelopment",null),ye([i.memoize],y.prototype,"untitledWorkspacesHome",null),ye([i.memoize],y.prototype,"installSourcePath",null),ye([i.memoize],y.prototype,"builtinExtensionsPath",null),ye([i.memoize],y.prototype,"extensionsPath",null),ye([i.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ye([i.memoize],y.prototype,"extensionDevelopmentKind",null),ye([i.memoize],y.prototype,"extensionTestsLocationURI",null),ye([i.memoize],y.prototype,"debugExtensionHost",null),ye([i.memoize],y.prototype,"logLevel",null),ye([i.memoize],y.prototype,"extensionLogLevel",null),ye([i.memoize],y.prototype,"serviceMachineIdResource",null),ye([i.memoize],y.prototype,"telemetryLogResource",null),ye([i.memoize],y.prototype,"disableWorkspaceTrust",null),ye([i.memoize],y.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=y;function C(m,f){return g(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=C;function w(m,f){return g(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,f,m.extensionEnvironment)}e.parsePtyHostPort=w;function g(m,f,v,u,l,d){const S=Number(f||m)||(u?null:v),R=S?Boolean(!!f):!1;let s;if(d)try{s=JSON.parse(d)}catch{}return{port:S,break:R,debugId:l,env:s}}}),define(oe[186],ae([0,1,289,4,155]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const N={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(v,u,l=N){const d=v.find(o=>o.length>0&&o[0]!=="-"),p={},S=["_"],R=[],s={};let c;for(const o in u){const a=u[o];a.type==="subcommand"?o===d&&(c=a):(a.alias&&(p[o]=a.alias),a.type==="string"||a.type==="string[]"?(S.push(o),a.deprecates&&S.push(...a.deprecates)):a.type==="boolean"&&(R.push(o),a.deprecates&&R.push(...a.deprecates)),a.global&&(s[o]=a))}if(c&&d){const o=s;for(const E in c.options)o[E]=c.options[E];const a=v.filter(E=>E!==d),h=l.getSubcommandReporter?l.getSubcommandReporter(d):void 0,b=P(a,o,h);return{[d]:b,_:[]}}const t=L(v,{string:S,boolean:R,alias:p}),n={},r=t;n._=t._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in u){const a=u[o];if(a.type==="subcommand")continue;a.alias&&delete r[a.alias];let h=r[o];if(a.deprecates)for(const b of a.deprecates)r.hasOwnProperty(b)&&(h||(h=r[b],h&&l.onDeprecatedOption(b,a.deprecationMessage||(0,D.localize)(36,null,o))),delete r[b]);if(typeof h<"u"){if(a.type==="string[]"){if(Array.isArray(h)||(h=[h]),!a.allowEmptyValue){const b=h.filter(E=>E.length>0);b.length!==h.length&&(l.onEmptyValue(o),h=b.length>0?b:void 0)}}else a.type==="string"&&(Array.isArray(h)?(h=h.pop(),l.onMultipleValues(o,h)):!h&&!a.allowEmptyValue&&(l.onEmptyValue(o),h=void 0));n[o]=h,a.deprecationMessage&&l.onDeprecatedOption(o,a.deprecationMessage)}delete r[o]}for(const o in r)l.onUnknownOption(o);return n}e.parseArgs=P;function I(v,u){let l="";return u.args&&(Array.isArray(u.args)?l=` <${u.args.join("> <")}>`:l=` <${u.args}>`),u.alias?`-${u.alias} --${v}${l}`:`--${v}${l}`}function y(v,u){const l=[];for(const d in v){const p=v[d],S=I(d,p);l.push([S,p.description])}return C(l,u)}e.formatOptions=y;function C(v,u){const d=v.reduce((R,s)=>Math.max(R,s[0].length),12)+2+1;if(u-d<25)return v.reduce((R,s)=>R.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const p=u-d-1,S=[];for(const R of v){const s=R[0],c=g(R[1],p),t=w(d-s.length-2);S.push("  "+s+t+c[0]);for(let n=1;n<c.length;n++)S.push(w(d)+c[n])}return S}function w(v){return" ".repeat(v)}function g(v,u){const l=[];for(;v.length;){const d=v.length<u?v.length:v.lastIndexOf(" ",u),p=v.slice(0,d).trim();v=v.slice(d),l.push(p)}return l}function m(v,u,l,d,p){const S=process.stdout.isTTY&&process.stdout.columns||80,R=p?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",s=[`${v} ${l}`];s.push(""),s.push(`${(0,D.localize)(38,null)}: ${u} [${(0,D.localize)(39,null)}]${R}`),s.push(""),p?.noPipe!==!0&&(i.isWindows?s.push((0,D.localize)(40,null,u)):s.push((0,D.localize)(41,null,u)),s.push(""));const c={},t=[];for(const n in d){const r=d[n];if(r.type==="subcommand")r.description&&t.push({command:n,description:r.description});else if(r.description&&r.cat){let o=c[r.cat];o||(c[r.cat]=o={}),o[n]=r}}for(const n in c){const r=n,o=c[r];o&&(s.push(k[r]),s.push(...y(o,S)),s.push(""))}return t.length&&(s.push((0,D.localize)(42,null)),s.push(...C(t.map(n=>[n.command,n.description]),S)),s.push("")),s.join(`
`)}e.buildHelpMessage=m;function f(v,u){return`${v||(0,D.localize)(43,null)}
${u||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(oe[187],ae([0,1,290,156,186]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function N(g,m){const f=(S,R)=>{console.warn((0,i.localize)(0,null,S,R))},v=S=>{console.warn((0,i.localize)(1,null,S))},u=(S,R)=>{console.warn((0,i.localize)(2,null,S,R))},l=S=>({onUnknownOption:R=>{S!=="tunnel"&&console.warn((0,i.localize)(3,null,R,S))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:u,getSubcommandReporter:S!=="tunnel"?l:void 0}),d={onUnknownOption:S=>{console.warn((0,i.localize)(4,null,S))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:u,getSubcommandReporter:l},p=(0,D.parseArgs)(g,D.OPTIONS,m?d:void 0);return p.goto&&p._.forEach(S=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,i.localize)(5,null))),p["max-memory"]&&L(parseInt(p["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),p}function P(g){const m=g.findIndex(f=>!/^-/.test(f));if(m>-1)return[...g.slice(0,m),...g.slice(m+1)]}function I(g){let[,...m]=g;process.env.VSCODE_DEV&&(m=P(m)||[]);const f=!w(process.env);return N(m,f)}e.parseMainProcessArgv=I;function y(g){let[,,...m]=g;return process.env.VSCODE_DEV&&(m=P(m)||[]),N(m,!0)}e.parseCLIProcessArgv=y;function C(g,...m){const f=g.indexOf("--");return f===-1?g.push(...m):g.splice(f,0,...m),g}e.addArg=C;function w(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Z(e,L,i){function D(N,P){const I=k(N,P),y=[I];return e.isAbsolute(I)||y.unshift(i),e.resolve(...y)}function k(N,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,P);const C=N["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(w,"AppData","Roaming")}break;case"darwin":y=e.join(L.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,P)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[188],ae([291,34,36]),function(e,L,i){return Z(e,L,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=Z(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[189],ae([0,1,34,95,188]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends i.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=k}),define(oe[190],ae([0,1,8]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,N=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function y(u){const l=u.match(N);return l?l[1]:null}function C(u){if(u.indexOf("://")===-1){const l=u.match(i);return l?y(l[2]):null}try{const l=L.URI.parse(u);if(l.authority)return y(l.authority)}catch{}return null}function w(u,l){const d=new Set;let p;for(;p=P.exec(u);){const R=C(p[1]);R&&d.add(R)}const S=new Set(l);return Array.from(d).map(R=>S.has(R)?R:R.replace(I,"a"))}e.getDomainsOfRemotes=w;function g(u){const l=u.match(k);return l?l[2]:null}function m(u,l,d){return u&&l?(d&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${u}${l}`:`${u}/${l}`):null}function f(u,l){if(u.indexOf("://")===-1){const d=u.match(D);if(d)return m(d[2],d[3],l)}try{const d=L.URI.parse(u);if(d.authority)return m(g(d.authority),d.path,l)}catch{}return null}function v(u,l=!1){const d=[];let p;for(;p=P.exec(u);){const S=f(p[1],l);S&&d.push(S)}return d}e.getRemotes=v}),define(oe[191],ae([0,1,13,159]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(N,P,I){try{k(N,P,I)}catch(y){console.error(y?.message??y)}return N}e.localizeManifest=D;function k(N,P,I){const y=(C,w,g)=>{const m=C[w];if((0,L.isString)(m)){const f=m,v=f.length;if(v>1&&f[0]==="%"&&f[v-1]==="%"){const u=f.substr(1,v-2);let l=P[u];l===void 0&&I&&(l=I[u]);const d=typeof l=="string"?l:l?.message,p=I?.[u],S=typeof p=="string"?p:p?.message;if(!d){S||console.warn(`[${N.name}]: ${(0,i.localize)(0,null,u)}`);return}if(g&&(w==="title"||w==="category")&&S&&S!==d){const R={value:d,original:S};C[w]=R}else C[w]=d}}else if((0,L.isObject)(m))for(const f in m)m.hasOwnProperty(f)&&(f==="commands"?y(m,f,!0):y(m,f,g));else if(Array.isArray(m))for(let f=0;f<m.length;f++)y(m,f,g)};for(const C in N)N.hasOwnProperty(C)&&y(N,C)}}),define(oe[192],ae([0,1,7]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(k,N){this.a.set(k,N)}updateManifest(k){if(!(typeof k.main>"u"&&typeof k.browser>"u")&&(k.activationEvents===void 0&&Object.assign(k,{activationEvents:[]}),!(!Array.isArray(k.activationEvents)||!k.contributes)))for(const N in k.contributes){const P=this.a.get(N);if(!P)continue;const I=k.contributes[N],y=Array.isArray(I)?I:[I];try{P(y,k.activationEvents)}catch(C){(0,L.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(oe[193],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,N,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[k,N,P,I])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class i{constructor(k){this.a=k}listen(k,N){throw new Error(`Event not found: ${N}`)}call(k,N,P){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${N}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(oe[70],ae([0,1,22,89,164,54]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(l){return l=l.trim(),l==="*"||N.test(l)}e.isValidVersionStr=I;function y(l){if(!I(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(N);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=y;function C(l){if(!l)return null;const d=l.majorBase,p=l.majorMustEqual,S=l.minorBase;let R=l.minorMustEqual;const s=l.patchBase;let c=l.patchMustEqual;l.hasCaret&&(d===0||(R=!1),c=!1);let t=0;if(l.preRelease){const n=P.exec(l.preRelease);if(n){const[,r,o,a]=n;t=Date.UTC(Number(r),Number(o)-1,Number(a))}}return{majorBase:d,majorMustEqual:p,minorBase:S,minorMustEqual:R,patchBase:s,patchMustEqual:c,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function w(l,d,p){let S;typeof l=="string"?S=C(y(l)):S=l;let R;d instanceof Date?R=d.getTime():typeof d=="string"&&(R=new Date(d).getTime());let s;if(typeof p=="string"?s=C(y(p)):s=p,!S||!s)return!1;const c=S.majorBase,t=S.minorBase,n=S.patchBase;let r=s.majorBase,o=s.minorBase,a=s.patchBase;const h=s.notBefore;let b=s.majorMustEqual,E=s.minorMustEqual,T=s.patchMustEqual;return s.isMinimum?c>r?!0:c<r?!1:t>o?!0:t<o||R&&R<h?!1:n>=a:(c===1&&r===0&&(!b||!E||!T)&&(r=1,o=0,a=0,b=!0,E=!1,T=!1),c<r?!1:c>r?!b:t<o?!1:t>o?!E:n<a?!1:n>a?!T:!(R&&R<h))}e.isValidVersion=w;function g(l,d,p,S,R){const s=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return s.push([i.default.Error,D.localize(0,null)]),s;if(typeof S.name!="string")return s.push([i.default.Error,D.localize(1,null,"name")]),s;if(typeof S.version!="string")return s.push([i.default.Error,D.localize(2,null,"version")]),s;if(!S.engines)return s.push([i.default.Error,D.localize(3,null,"engines")]),s;if(typeof S.engines.vscode!="string")return s.push([i.default.Error,D.localize(4,null,"engines.vscode")]),s;if(typeof S.extensionDependencies<"u"&&!u(S.extensionDependencies))return s.push([i.default.Error,D.localize(5,null,"extensionDependencies")]),s;if(typeof S.activationEvents<"u"){if(!u(S.activationEvents))return s.push([i.default.Error,D.localize(6,null,"activationEvents")]),s;if(typeof S.main>"u"&&typeof S.browser>"u")return s.push([i.default.Error,D.localize(7,null,"activationEvents","main")]),s}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&s.push([i.default.Warning,D.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return s.push([i.default.Error,D.localize(9,null,"main")]),s;{const n=(0,L.joinPath)(p,S.main);(0,L.isEqualOrParent)(n,p)||s.push([i.default.Warning,D.localize(10,null,n.path,p.path)])}if(typeof S.activationEvents>"u")return s.push([i.default.Error,D.localize(11,null,"activationEvents","main")]),s}if(typeof S.browser<"u"){if(typeof S.browser!="string")return s.push([i.default.Error,D.localize(12,null,"browser")]),s;{const n=(0,L.joinPath)(p,S.browser);(0,L.isEqualOrParent)(n,p)||s.push([i.default.Warning,D.localize(13,null,n.path,p.path)])}if(typeof S.activationEvents>"u")return s.push([i.default.Error,D.localize(14,null,"activationEvents","browser")]),s}if(!k.valid(S.version))return s.push([i.default.Error,D.localize(15,null)]),s;const c=[];if(!m(l,d,S,R,c))for(const n of c)s.push([i.default.Error,n]);return s}e.validateExtensionManifest=g;function m(l,d,p,S,R){return S||typeof p.main>"u"&&typeof p.browser>"u"?!0:v(l,d,p.engines.vscode,R)}e.isValidExtensionVersion=m;function f(l,d,p){return l==="*"||v(d,p,l)}e.isEngineValid=f;function v(l,d,p,S=[]){const R=C(y(p));if(!R)return S.push(D.localize(16,null,p)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return S.push(D.localize(17,null,p)),!1}else if(!R.majorMustEqual)return S.push(D.localize(18,null,p)),!1;return w(l,d,R)?!0:(S.push(D.localize(19,null,l,p)),!1)}function u(l){if(!Array.isArray(l))return!1;for(let d=0,p=l.length;d<p;d++)if(typeof l[d]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,N,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await N.readFile(k.serviceMachineIdResource)).value.toString();I=(0,i.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,i.generateUuid)();try{await N.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=D}),define(oe[55],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(D,k=[],N=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=L}),define(oe[71],ae([0,1,55]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function k(P,I,y){I instanceof L.SyncDescriptor||(I=new L.SyncDescriptor(I,[],Boolean(y))),i.push([P,I])}e.registerSingleton=k;function N(){return i}e.getSingletonServiceDescriptors=N}),define(oe[194],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(k,N){this.key=k,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class i{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const N of this.a.values())N.outgoing.size===0&&k.push(N);return k}insertEdge(k,N){const P=this.lookupOrInsertNode(k),I=this.lookupOrInsertNode(N);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(k){const N=this.b(k);this.a.delete(N);for(const P of this.a.values())P.outgoing.delete(N),P.incoming.delete(N)}lookupOrInsertNode(k){const N=this.b(k);let P=this.a.get(N);return P||(P=new L(N,k),this.a.set(N,P)),P}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[N,P]of this.a)k.push(`${N}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,N]of this.a){const P=new Set([k]),I=this.c(N,P);if(I)return I}}c(k,N){for(const[P,I]of k.outgoing){if(N.has(P))return[...N,P].join(" -> ");N.add(P);const y=this.c(I,N);if(y)return y;N.delete(P)}}}e.Graph=i}),define(oe[5],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=P})(L=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(N,P,I){P[L.DI_TARGET]===P?P[L.DI_DEPENDENCIES].push({id:N,index:I}):(P[L.DI_DEPENDENCIES]=[{id:N,index:I}],P[L.DI_TARGET]=P)}function D(N){if(L.serviceIds.has(N))return L.serviceIds.get(N);const P=function(I,y,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,I,C)};return P.toString=()=>N,L.serviceIds.set(N,P),P}e.createDecorator=D;function k(N){return N}e.refineServiceDecorator=k}),define(oe[195],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(oe[16],ae([0,1,13,8,5]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationOverrides=k;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=N;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function y(l,d){const p=Object.create(null);for(const S in l)C(p,S,l[S],d);return p}e.toValuesTree=y;function C(l,d,p,S){const R=d.split("."),s=R.pop();let c=l;for(let t=0;t<R.length;t++){const n=R[t];let r=c[n];switch(typeof r){case"undefined":r=c[n]=Object.create(null);break;case"object":break;default:S(`Ignoring ${d} as ${R.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}c=r}if(typeof c=="object"&&c!==null)try{c[s]=p}catch{S(`Ignoring ${d} as ${R.join(".")} is ${JSON.stringify(c)}`)}else S(`Ignoring ${d} as ${R.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=C;function w(l,d){const p=d.split(".");g(l,p)}e.removeFromValueTree=w;function g(l,d){const p=d.shift();if(d.length===0){delete l[p];return}if(Object.keys(l).indexOf(p)!==-1){const S=l[p];typeof S=="object"&&!Array.isArray(S)&&(g(S,d),Object.keys(S).length===0&&delete l[p])}}function m(l,d,p){function S(c,t){let n=c;for(const r of t){if(typeof n!="object"||n===null)return;n=n[r]}return n}const R=d.split("."),s=S(l,R);return typeof s>"u"?p:s}e.getConfigurationValue=m;function f(l,d,p){Object.keys(d).forEach(S=>{S!=="__proto__"&&(S in l?L.isObject(l[S])&&L.isObject(d[S])?f(l[S],d[S],p):p&&(l[S]=d[S]):l[S]=d[S])})}e.merge=f;function v(l,d,p){const S=l.inspect(d),R=l.inspect(p);return typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:typeof R.userValue<"u"||typeof R.workspaceValue<"u"||typeof R.workspaceFolderValue<"u"?R.value:S.defaultValue}e.getMigratedSettingValue=v;function u(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(oe[196],ae([0,1,4,27,5]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",L.isMacintosh),k.set("isLinux",L.isLinux),k.set("isWindows",L.isWindows),k.set("isWeb",L.isWeb),k.set("isMacNative",L.isMacintosh&&!L.isWeb),k.set("isEdge",L.isEdge),k.set("isFirefox",L.isFirefox),k.set("isChrome",L.isChrome),k.set("isSafari",L.isSafari);const N=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return w.INSTANCE}static true(){return g.INSTANCE}static has(A){return m.create(A)}static equals(A,$){return f.create(A,$)}static notEquals(A,$){return l.create(A,$)}static regex(A,$){return t.create(A,$)}static in(A,$){return v.create(A,$)}static notIn(A,$){return u.create(A,$)}static not(A){return d.create(A)}static and(...A){return o.create(A,null,!0)}static or(...A){return a.create(A,null,!0)}static greater(A,$){return S.create(A,$)}static greaterEquals(A,$){return R.create(A,$)}static smaller(A,$){return s.create(A,$)}static smallerEquals(A,$){return c.create(A,$)}static deserialize(A,$=!1){if(!!A)return this.c(A,$)}static c(A,$){const z=A.split("||");return a.create(z.map(H=>this.d(H,$)),null,!0)}static d(A,$){const z=A.split("&&");return o.create(z.map(H=>this.f(H,$)),null,!0)}static f(A,$){if(A=A.trim(),A.indexOf("!=")>=0){const z=A.split("!=");return l.create(z[0].trim(),this.g(z[1],$))}if(A.indexOf("==")>=0){const z=A.split("==");return f.create(z[0].trim(),this.g(z[1],$))}if(A.indexOf("=~")>=0){const z=A.split("=~");return t.create(z[0].trim(),this.h(z[1],$))}if(A.indexOf(" not in ")>=0){const z=A.split(" not in ");return u.create(z[0].trim(),this.g(z[1],$))}if(A.indexOf(" in ")>=0){const z=A.split(" in ");return v.create(z[0].trim(),this.g(z[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const z=A.split(">=");return R.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const z=A.split(">");return S.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const z=A.split("<=");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const z=A.split("<");return s.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(A)?d.create(A.substr(1).trim()):m.create(A)}static g(A,$){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const z=/^'([^']*)'$/.exec(A);return z?z[1].trim():A}static h(A,$){if((0,i.isFalsyOrWhitespace)(A)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=A.indexOf("/"),H=A.lastIndexOf("/");if(z===H||z<0){if($)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const X=A.slice(z+1,H),ie=A[H+1]==="i"?"i":"";try{return new RegExp(X,ie)}catch(G){if($)throw new Error(`bad regexp-value '${A}', parse error: ${G}`);return console.warn(`bad regexp-value '${A}', parse error: ${G}`),null}}}e.ContextKeyExpr=I;function y(F,A){const $=F?F.substituteConstants():void 0,z=A?A.substituteConstants():void 0;return!$&&!z?!0:!$||!z?!1:$.equals(z)}e.expressionsAreEqualWithConstantSubstitution=y;function C(F,A){return F.cmp(A)}class w{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class g{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{static create(A,$=null){const z=k.get(A);return typeof z=="boolean"?z?g.INSTANCE:w.INSTANCE:new m(A,$)}constructor(A,$){this.key=A,this.c=$,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:b(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=k.get(this.key);return typeof A=="boolean"?A?g.INSTANCE:w.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=m;class f{static create(A,$,z=null){if(typeof $=="boolean")return $?m.create(A,z):d.create(A,z);const H=k.get(A);return typeof H=="boolean"?$===(H?"true":"false")?g.INSTANCE:w.INSTANCE:new f(A,$,z)}constructor(A,$,z){this.c=A,this.d=$,this.f=z,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=k.get(this.c);if(typeof A=="boolean"){const $=A?"true":"false";return this.d===$?g.INSTANCE:w.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class v{static create(A,$){return new v(A,$)}constructor(A,$){this.d=A,this.f=$,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:E(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const $=A.getValue(this.f),z=A.getValue(this.d);return Array.isArray($)?$.includes(z):typeof z=="string"&&typeof $=="object"&&$!==null?N.call($,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=v;class u{static create(A,$){return new u(A,$)}constructor(A,$){this.d=A,this.f=$,this.type=11,this.c=v.create(A,$)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=u;class l{static create(A,$,z=null){if(typeof $=="boolean")return $?d.create(A,z):m.create(A,z);const H=k.get(A);return typeof H=="boolean"?$===(H?"true":"false")?w.INSTANCE:g.INSTANCE:new l(A,$,z)}constructor(A,$,z){this.c=A,this.d=$,this.f=z,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=k.get(this.c);if(typeof A=="boolean"){const $=A?"true":"false";return this.d===$?w.INSTANCE:g.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class d{static create(A,$=null){const z=k.get(A);return typeof z=="boolean"?z?w.INSTANCE:g.INSTANCE:new d(A,$)}constructor(A,$){this.c=A,this.d=$,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:b(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=k.get(this.c);return typeof A=="boolean"?A?w.INSTANCE:g.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function p(F,A){if(typeof F=="string"){const $=parseFloat(F);isNaN($)||(F=$)}return typeof F=="string"||typeof F=="number"?A(F):w.INSTANCE}class S{static create(A,$,z=null){return p($,H=>new S(A,H,z))}constructor(A,$,z){this.c=A,this.d=$,this.f=z,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=S;class R{static create(A,$,z=null){return p($,H=>new R(A,H,z))}constructor(A,$,z){this.c=A,this.d=$,this.f=z,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=R;class s{static create(A,$,z=null){return p($,H=>new s(A,H,z))}constructor(A,$,z){this.c=A,this.d=$,this.f=z,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class c{static create(A,$,z=null){return p($,H=>new c(A,H,z))}constructor(A,$,z){this.c=A,this.d=$,this.f=z,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=c;class t{static create(A,$){return new t(A,$)}constructor(A,$){this.d=A,this.f=$,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const $=this.f?this.f.source:"",z=A.f?A.f.source:"";return $<z?-1:$>z?1:0}equals(A){if(A.type===this.type){const $=this.f?this.f.source:"",z=A.f?A.f.source:"";return this.d===A.d&&$===z}return!1}substituteConstants(){return this}evaluate(A){const $=A.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=t;class n{static create(A){return new n(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(A){return new n(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function r(F){let A=null;for(let $=0,z=F.length;$<z;$++){const H=F[$].substituteConstants();if(F[$]!==H&&A===null){A=[];for(let X=0;X<$;X++)A[X]=F[X]}A!==null&&(A[$]=H)}return A===null?F:A}class o{static create(A,$,z){return o.d(A,$,z)}constructor(A,$){this.expr=A,this.c=$,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const H=C(this.expr[$],A.expr[$]);if(H!==0)return H}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(A.expr[$]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:o.create(A,this.c,!1)}evaluate(A){for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].evaluate(A))return!1;return!0}static d(A,$,z){const H=[];let X=!1;for(const ie of A)if(!!ie){if(ie.type===1){X=!0;continue}if(ie.type===0)return w.INSTANCE;if(ie.type===6){H.push(...ie.expr);continue}H.push(ie)}if(H.length===0&&X)return g.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(C);for(let ie=1;ie<H.length;ie++)H[ie-1].equals(H[ie])&&(H.splice(ie,1),ie--);if(H.length===1)return H[0];for(;H.length>1;){const ie=H[H.length-1];if(ie.type!==9)break;H.pop();const G=H.pop(),j=H.length===0,V=a.create(ie.expr.map(x=>o.create([x,G],null,z)),null,j);V&&(H.push(V),H.sort(C))}if(H.length===1)return H[0];if(z){for(let ie=0;ie<H.length;ie++)for(let G=ie+1;G<H.length;G++)if(H[ie].negate().equals(H[G]))return w.INSTANCE;if(H.length===1)return H[0]}return new o(H,$)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const $ of this.expr)A.push(...$.keys());return A}map(A){return new o(this.expr.map($=>$.map(A)),null)}negate(){if(!this.c){const A=[];for(const $ of this.expr)A.push($.negate());this.c=a.create(A,this,!0)}return this.c}}class a{static create(A,$,z){return a.d(A,$,z)}constructor(A,$){this.expr=A,this.c=$,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const H=C(this.expr[$],A.expr[$]);if(H!==0)return H}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(A.expr[$]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:a.create(A,this.c,!1)}evaluate(A){for(let $=0,z=this.expr.length;$<z;$++)if(this.expr[$].evaluate(A))return!0;return!1}static d(A,$,z){let H=[],X=!1;if(A){for(let ie=0,G=A.length;ie<G;ie++){const j=A[ie];if(!!j){if(j.type===0){X=!0;continue}if(j.type===1)return g.INSTANCE;if(j.type===9){H=H.concat(j.expr);continue}H.push(j)}}if(H.length===0&&X)return w.INSTANCE;H.sort(C)}if(H.length!==0){if(H.length===1)return H[0];for(let ie=1;ie<H.length;ie++)H[ie-1].equals(H[ie])&&(H.splice(ie,1),ie--);if(H.length===1)return H[0];if(z){for(let ie=0;ie<H.length;ie++)for(let G=ie+1;G<H.length;G++)if(H[ie].negate().equals(H[G]))return g.INSTANCE;if(H.length===1)return H[0]}return new a(H,$)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const $ of this.expr)A.push(...$.keys());return A}map(A){return new a(this.expr.map($=>$.map(A)),null)}negate(){if(!this.c){const A=[];for(const $ of this.expr)A.push($.negate());for(;A.length>1;){const $=A.shift(),z=A.shift(),H=[];for(const X of M($))for(const ie of M(z))H.push(o.create([X,ie],null,!1));A.unshift(a.create(H,null,!1))}this.c=a.create(A,this,!0)}return this.c}}class h extends m{static all(){return h.d.values()}constructor(A,$,z){super(A,null),this.f=$,typeof z=="object"?h.d.push({...z,key:A}):z!==!0&&h.d.push({key:A,description:z,type:$!=null?typeof $:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return f.create(this.key,A)}notEqualsTo(A){return l.create(this.key,A)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function b(F,A){return F<A?-1:F>A?1:0}function E(F,A,$,z){return F<$?-1:F>$?1:A<z?-1:A>z?1:0}function T(F,A){if(F.type===0||A.type===1)return!0;if(F.type===9)return A.type===9?O(F.expr,A.expr):!1;if(A.type===9){for(const $ of A.expr)if(T(F,$))return!0;return!1}if(F.type===6){if(A.type===6)return O(A.expr,F.expr);for(const $ of F.expr)if(T($,A))return!0;return!1}return F.equals(A)}e.implies=T;function O(F,A){let $=0,z=0;for(;$<F.length&&z<A.length;){const H=F[$].cmp(A[z]);if(H<0)return!1;H===0&&$++,z++}return $===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(oe[96],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function i(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=i;class D{async getPerformanceInfo(N,P){return{}}async getSystemInfo(N,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,P){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.NullDiagnosticsService=D}),define(oe[97],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[30],ae([0,1,158,5]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function N(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function P(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(l,d,p){return P(d,p)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===p?!0:y(p).includes(l)}e.isTargetPlatformCompatible=I;function y(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var v;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(d,p){super(d),this.code=p,this.name=p}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[197],ae([0,1,3,2,67,32,8,145,30]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(u,l){return N.URI.revive(l?l.transformIncoming(u):u)}function C(u,l){return l?l.transformOutgoingURI(u):u}function w(u,l){l=l||P.DefaultURITransformer;const d=u.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...u,manifest:void 0},l),manifest:d}}function g(u,l){return l?(0,k.cloneAndChange)(u,d=>d instanceof N.URI?l.transformOutgoingURI(d):void 0):u}class m{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=L.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,d){const p=this.b(l);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,S=>S.map(R=>({...R,local:R.local?g(R.local,p):R.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,d,p){const S=this.b(l);switch(d){case"zip":return this.a.zip(w(p[0],S)).then(R=>C(R,S));case"unzip":return this.a.unzip(y(p[0],S));case"install":return this.a.install(y(p[0],S),(0,D.revive)(p[1]));case"installFromLocation":return this.a.installFromLocation(y(p[0],S),N.URI.revive(p[1]));case"getManifest":return this.a.getManifest(y(p[0],S));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],(0,D.revive)(p[1]));case"uninstall":return this.a.uninstall(w(p[0],S),(0,D.revive)(p[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(w(p[0],S));case"getInstalled":return this.a.getInstalled(p[0],N.URI.revive(p[1])).then(R=>R.map(s=>g(s,S)));case"getMetadata":return this.a.getMetadata(w(p[0],S));case"updateMetadata":return this.a.updateMetadata(w(p[0],S),p[1]).then(R=>g(R,S));case"updateExtensionScope":return this.a.updateExtensionScope(w(p[0],S),p[1]).then(R=>g(R,S));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class f extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new L.Emitter),this.f=this.B(new L.Emitter),this.g=this.B(new L.Emitter),this.h=this.B(new L.Emitter),this.B(this.j.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.k(d.source)?N.URI.revive(d.source):d.source,profileLocation:N.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(p=>({...p,local:p.local?w(p.local,null):p.local,source:this.k(p.source)?N.URI.revive(p.source):p.source,profileLocation:N.URI.revive(p.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:N.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:N.URI.revive(d.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(p=>(0,I.isTargetPlatformCompatible)(p,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(d=>N.URI.revive(d)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,d){return Promise.resolve(this.j.call("install",[l,d])).then(p=>w(p,null))}installFromLocation(l,d){return Promise.resolve(this.j.call("installFromLocation",[l,d])).then(p=>w(p,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.j.call("installFromGallery",[l,d])).then(p=>w(p,null))}uninstall(l,d){return Promise.resolve(this.j.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l])).then(d=>w(d,null))}getInstalled(l=null,d){return Promise.resolve(this.j.call("getInstalled",[l,d])).then(p=>p.map(S=>w(S,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,d){return Promise.resolve(this.j.call("updateMetadata",[l,d])).then(p=>w(p,null))}updateExtensionScope(l,d){return Promise.resolve(this.j.call("updateExtensionScope",[l,d])).then(p=>w(p,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,d){const p=await this.j.call("download",[l,d]);return N.URI.revive(p)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class v{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,p){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(N.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(oe[98],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((k,N)=>Z(["node-vsce-sign"],async P=>k(P),N))),this.a}async verify(k,N){let P;try{P=await this.b()}catch{return!1}return P.verify(k,N)}}e.ExtensionSignatureVerificationService=i}),define(oe[99],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(N){switch(N){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[14],ae([0,1,49,12,27,13,8,166,5,4]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function C(j){return j.create===!0}e.isFileOpenForWriteOptions=C;var w;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var g;(function(j){j[j.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var m;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=f;function v(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=v;function u(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=u;function l(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;function p(j){return f(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class R extends Error{constructor(V,x){super(V),this.code=x}}e.FileSystemProviderError=R;function s(j,V){const x=new R(j.toString(),V);return t(x,V),x}e.createFileSystemProviderError=s;function c(j){return j||s((0,P.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function t(j,V){return j.name=V?`${V} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=t;function n(j){if(!j)return S.Unknown;if(j instanceof R)return j.code;const V=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!V)return S.Unknown;switch(V[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=n;function r(j){if(j instanceof T)return j.fileOperationResult;switch(n(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(V,x,ee){this.resource=V,this.operation=x,this.target=ee}isOperation(V){return this.operation===V}}e.FileOperationEvent=a;var h;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class b{constructor(V,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ee=new Map;for(const re of V){const te=ee.get(re.type);switch(te?te.push([re.resource,re]):ee.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,te]of ee)switch(re){case 1:this.a=L.TernarySearchTree.forUris(()=>x),this.a.fill(te);break;case 0:this.b=L.TernarySearchTree.forUris(()=>x),this.b.fill(te);break;case 2:this.c=L.TernarySearchTree.forUris(()=>x),this.c.fill(te);break}}contains(V,...x){return this.d(V,{includeChildren:!1},...x)}affects(V,...x){return this.d(V,{includeChildren:!0},...x)}d(V,x,...ee){if(!V)return!1;const re=ee.length>0;return!!((!re||ee.includes(1))&&(this.a?.get(V)||x.includeChildren&&this.a?.findSuperstr(V))||(!re||ee.includes(0))&&(this.b?.get(V)||x.includeChildren&&this.b?.findSuperstr(V))||(!re||ee.includes(2))&&(this.c?.findSubstr(V)||x.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=b;function E(j,V,x){return!j||!V||j===V||V.length>j.length?!1:(V.charAt(V.length-1)!==i.sep&&(V+=i.sep),x?(0,D.startsWithIgnoreCase)(j,V):j.indexOf(V)===0)}e.isParent=E;class T extends Error{constructor(V,x,ee){super(V),this.fileOperationResult=x,this.options=ee}}e.FileOperationError=T;class O extends T{constructor(V,x,ee,re){super(V,x,re),this.fileOperationResult=x,this.size=ee}}e.TooLargeFileOperationError=O;class M extends T{constructor(V,x,ee){super(V,2,ee),this.stat=x}}e.NotModifiedSinceFileOperationError=M;var F;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=$;async function z(j,V){if(!V.hasProvider(N.URI.from({scheme:j.scheme})))return new Promise(x=>{const ee=V.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===j.scheme&&re.added&&(ee.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(V){return(0,k.isNumber)(V)||(V=0),V<H.KB?(0,P.localize)(1,null,V.toFixed(0)):V<H.MB?(0,P.localize)(2,null,(V/H.KB).toFixed(2)):V<H.GB?(0,P.localize)(3,null,(V/H.MB).toFixed(2)):V<H.TB?(0,P.localize)(4,null,(V/H.GB).toFixed(2)):(0,P.localize)(5,null,(V/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var X;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(X=e.Arch||(e.Arch={}));function ie(j){return{maxFileSize:j===0?300*H.MB:16*H.GB,maxHeapSize:j===0?700*H.MB:2*700*H.MB}}e.getPlatformFileLimits=ie;function G(j){return y.isWeb?j?10*H.MB:50*H.MB:j?100*H.MB:1024*H.MB}e.getLargeFileConfirmationLimit=G});var K=this&&this.__param||function(Z,e){return function(L,i){e(L,i,Z)}};define(oe[198],ae([0,1,100,44,14]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((y,C)=>{const w=(0,L.createHash)("md5");(0,i.listenStream)(I,{onData:g=>w.update(g.buffer),onError:g=>C(g),onEnd:()=>y(w.digest("base64").replace(/=+$/,""))})})}};k=ye([K(0,D.IFileService)],k),e.ChecksumService=k}),define(oe[199],ae([0,1,17,38,7,3,2,44,8,31,14]),function(Z,e,L,i,D,k,N,P,I,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends N.Disposable{constructor(m,f){super(),this.a=m,this.b=f,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.h=(0,y.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,f){const{buffer:v}=await this.a.call("readFile",[m,f]);return v}readFileStream(m,f,v){const u=(0,P.newWriteableStream)(d=>L.VSBuffer.concat(d.map(p=>L.VSBuffer.wrap(p))).buffer),l=this.a.listen("readFileStream",[m,f])(d=>{if(d instanceof L.VSBuffer)u.write(d.buffer);else{if(d==="end")u.end();else{let p;if(d instanceof Error)p=d;else{const S=d;p=(0,C.createFileSystemProviderError)(S.message??(0,i.toErrorMessage)(S),S.code??C.FileSystemProviderErrorCode.Unknown)}u.error(p),u.end()}l.dispose()}});return v.onCancellationRequested(()=>{u.error((0,D.canceled)()),u.end(),l.dispose()}),u}writeFile(m,f,v){return this.a.call("writeFile",[m,L.VSBuffer.wrap(f),v])}open(m,f){return this.a.call("open",[m,f])}close(m){return this.a.call("close",[m])}async read(m,f,v,u,l){const[d,p]=await this.a.call("read",[m,f,l]);return v.set(d.buffer.slice(0,p),u),p}write(m,f,v,u,l){return this.a.call("write",[m,f,L.VSBuffer.wrap(v),u,l])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,f){return this.a.call("delete",[m,f])}rename(m,f,v){return this.a.call("rename",[m,f,v])}copy(m,f,v){return this.a.call("copy",[m,f,v])}cloneFile(m,f){return this.a.call("cloneFile",[m,f])}i(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const f=m;this.f.fire(f.map(v=>({resource:I.URI.revive(v.resource),type:v.type})))}else{const f=m;this.g.fire(f)}}))}watch(m,f){const v=(0,y.generateUuid)();return this.a.call("watch",[this.h,v,m,f]),(0,N.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=w}),define(oe[101],ae([0,1,17,7,167,14]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(C,w,g,m,f,v){let u;try{await P(C,w,g,m,f,v)}catch(l){u=l}finally{u&&f.errorTransformer&&(u=f.errorTransformer(u)),typeof u<"u"&&g.error(u),g.end()}}e.readFileIntoStream=N;async function P(C,w,g,m,f,v){I(v);const u=await C.open(w,{create:!1});try{I(v);let l=0,d=0,p=f&&typeof f.length=="number"?f.length:void 0,S=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof p=="number"?p:f.bufferSize)),R=f&&typeof f.position=="number"?f.position:0,s=0;do d=await C.read(u,R,S.buffer,s,S.byteLength-s),R+=d,s+=d,l+=d,typeof p=="number"&&(p-=d),s===S.byteLength&&(await g.write(m(S)),S=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof p=="number"?p:f.bufferSize)),s=0);while(d>0&&(typeof p!="number"||p>0)&&I(v)&&y(l,f));if(s>0){let c=s;typeof p=="number"&&(c=Math.min(s,p)),g.write(m(S.slice(0,c)))}}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await C.close(u)}}function I(C){if(C.isCancellationRequested)throw(0,i.canceled)();return!0}function y(C,w){if(w?.limits){if(typeof w.limits.memory=="number"&&C>w.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&C>w.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,90,2,12,4,8,14]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(l){return l.recursive===!0}e.isRecursiveWatchRequest=I;class y extends i.Disposable{constructor(d,p,S,R){super(),this.h=d,this.i=p,this.j=S,this.k=R,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new i.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(p=>this.h(p))),d.add(this.b.onDidLogMessage(p=>this.i(p))),d.add(this.b.onDidError(p=>this.n(p)))}n(d){this.k.restartOnError?this.g<y.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=y,y.a=5;class C extends y{constructor(d,p,S){super(d,p,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class w extends y{constructor(d,p,S){super(d,p,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function g(l){return l.map(d=>({type:d.type,resource:N.URI.file(d.path)}))}e.toFileChanges=g;function m(l){const d=new u;for(const p of l)d.processEvent(p);return d.coalesce()}e.coalesceEvents=m;function f(l,d){return typeof d=="string"&&!d.startsWith(L.GLOBSTAR)&&!(0,D.isAbsolute)(d)?{base:l,pattern:d}:d}e.normalizeWatcherPattern=f;function v(l,d){const p=[];for(const S of d)p.push((0,L.parse)(f(l,S)));return p}e.parseWatcherPatterns=v;class u{constructor(){this.a=new Set,this.b=new Map}c(d){return k.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.b.get(this.c(d));let S=!1;if(p){const R=p.type,s=d.type;p.path!==d.path&&(d.type===2||d.type===1)?S=!0:R===1&&s===2?(this.b.delete(this.c(d)),this.a.delete(p)):R===2&&s===1?p.type=0:R===1&&s===0||(p.type=s)}else S=!0;S&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],p=[];return Array.from(this.a).filter(S=>S.type!==2?(d.push(S),!1):!0).sort((S,R)=>S.path.length-R.path.length).filter(S=>p.some(R=>(0,P.isParent)(S.path,R,!k.isLinux))?!1:(p.push(S.path),!0)).concat(d)}}}),define(oe[200],ae([0,1,53,6,23,48,2,85,12,4,147,28,56]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends N.Disposable{constructor(u,l,d,p){super(),this.j=u,this.k=l,this.l=d,this.m=p,this.c=this.B(new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new i.RunOnceWorker(S=>this.u(S),m.b)),this.g=(0,g.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,g.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new D.CancellationTokenSource,this.ready=this.n()}async n(){try{const u=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await w.Promises.stat(u);this.B(await this.s(u,l.isDirectory()))}catch(u){u.code!=="ENOENT"?this.w(u):this.z(u)}}async r(u){let l=u.path;try{l=await w.Promises.realpath(u.path),u.path===l&&(l=await(0,C.realcase)(u.path)??u.path),u.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${l})`)}catch{}return l}async s(u,l){if(y.isMacintosh&&(0,k.isEqualOrParent)(u,"/Volumes/",!0))return this.w(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),N.Disposable.None;const d=new D.CancellationTokenSource(this.i.token),p=new N.DisposableStore;try{const S=(0,I.basename)(u),R=(0,L.watch)(u);p.add((0,N.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${u}'`);const s=new Set;if(l)try{for(const t of await w.Promises.readdir(u))s.add(t)}catch(t){this.w(t)}const c=new Map;p.add((0,N.toDisposable)(()=>{for(const[,t]of c)t.dispose();c.clear()})),R.on("error",(t,n)=>{this.w(`Failed to watch ${u} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),R.on("change",(t,n)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${n}`);let r="";if(n&&(r=n.toString(),y.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!(!r||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){c.get(r)?.dispose();const o=setTimeout(async()=>{if(c.delete(r),r===S&&!await w.Promises.exists(u)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,I.join)(u,r));if(d.token.isCancellationRequested)return;let h;a?s.has(r)?h=0:(h=1,s.add(r)):(s.delete(r),h=2),this.t({path:(0,I.join)(this.j.path,r),type:h})},m.a);c.set(r,(0,N.toDisposable)(()=>clearTimeout(o)))}else{let o;s.has(r)?o=0:(o=1,s.add(r)),this.t({path:(0,I.join)(this.j.path,r),type:o})}else if(t==="rename"||r!==S){const o=setTimeout(async()=>{const a=await w.Promises.exists(u);d.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(u,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},m.a);p.clear(),p.add((0,N.toDisposable)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await w.Promises.exists(u)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${u} for changes using fs.watch() (${S.toString()})`)}return(0,N.toDisposable)(()=>{d.dispose(!0),p.dispose()})}t(u,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),!l&&this.g.some(d=>d(u.path))?this.m&&this.z(` >> ignored (excluded) ${u.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.path))?this.m&&this.z(` >> ignored (not included) ${u.path}`):this.f.work(u))}u(u){const l=(0,g.coalesceEvents)(u);if(l.length>0){if(this.m)for(const p of l)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(u){if(y.isLinux)return w.Promises.exists(u);try{const l=(0,I.basename)(u);return(await w.Promises.readdir((0,I.dirname)(u))).some(p=>p===l)}catch(l){return this.z(l),!1}}setVerboseLogging(u){this.m=u}w(u){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}y(u){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}z(u){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.a=100,m.b=75;async function f(v,u,l,d,p=512){const S=await w.Promises.open(v,"r"),R=Buffer.allocUnsafe(p),s=new D.CancellationTokenSource(d);let c,t=!1;const n={path:v,excludes:[],recursive:!1},r=new m(n,o=>{(async()=>{for(const{type:a}of o)if(a===0){if(t)return;t=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:h}=await w.Promises.read(S,R,0,p,null);if(!h||s.token.isCancellationRequested)break;u(R.slice(0,h))}}catch(h){c=new Error(h),s.dispose(!0)}finally{t=!1}}})()});return await r.ready,l(),new Promise((o,a)=>{s.token.onCancellationRequested(async()=>{r.dispose();try{await w.Promises.close(S)}catch(h){c=new Error(h)}c?a(c):o()})})}e.watchFileContents=f}),define(oe[201],ae([0,1,3,90,2,4,200]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(y){const C=this.i(y),w=C.filter(m=>{const f=this.c.get(m.path);return f?!(0,i.patternsEquals)(f.request.excludes,m.excludes)||!(0,i.patternsEquals)(f.request.includes,m.includes):!0}),g=Array.from(this.c.values()).filter(({request:m})=>!C.find(f=>f.path===m.path&&(0,i.patternsEquals)(f.excludes,m.excludes)&&(0,i.patternsEquals)(f.includes,m.includes))).map(({request:m})=>m.path);w.length&&this.j(`Request to start watching: ${w.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const m of g)this.h(m);for(const m of w)this.g(m)}g(y){const C=new N.NodeJSFileWatcherLibrary(y,g=>this.a.fire(g),g=>this.b.fire(g),this.f),w={request:y,instance:C};this.c.set(y.path,w)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const C=this.c.get(y);C&&(this.c.delete(y),C.instance.dispose())}i(y){const C=new Map;for(const w of y){const g=k.isLinux?w.path:w.path.toLowerCase();C.set(g,w)}return Array.from(C.values())}async setVerboseLogging(y){this.f=y;for(const[,C]of this.c)C.instance.setVerboseLogging(y)}j(y){this.f&&this.b.fire({type:"trace",message:this.k(y)})}k(y,C){return C?`[File Watcher (node.js)] ${y} (path: ${C.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=P}),define(oe[202],ae([0,1,56,201]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends L.AbstractNonRecursiveWatcherClient{constructor(N,P,I){super(N,P,I),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[203],ae([0,1,24,39,68,56]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends k.AbstractUniversalWatcherClient{constructor(I,y,C){super(I,y,C),this.m()}l(I){const y=I.add(new D.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(y.onDidProcessExit(({code:C,signal:w})=>this.n(`terminated by itself with code ${C}, signal: ${w}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(oe[72],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...D){this.a=new Map;for(const[k,N]of D)this.set(k,N)}set(D,k){const N=this.a.get(D);return this.a.set(D,k),N}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=L}),define(oe[204],ae([0,1,6,7,2,55,194,5,72,84]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class w extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class g{constructor(u=new I.ServiceCollection,l=!1,d,p=C){this.f=u,this.g=l,this.h=d,this.i=p,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=p?d?._globalGraph??new N.Graph(S=>S):void 0}createChild(u){return new g(u,this.g,this,this.i)}invokeFunction(u,...l){const d=f.traceInvocation(this.i,u);let p=!1;try{return u({get:R=>{if(p)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(R,d);if(!s)throw new Error(`[invokeFunction] unknown service '${R}'`);return s}},...l)}finally{p=!0,d.stop()}}createInstance(u,...l){let d,p;return u instanceof k.SyncDescriptor?(d=f.traceCreation(this.i,u.ctor),p=this.j(u.ctor,u.staticArguments.concat(l),d)):(d=f.traceCreation(this.i,u),p=this.j(u,l,d)),d.stop(),p}j(u,l=[],d){const p=P._util.getServiceDependencies(u).sort((s,c)=>s.index-c.index),S=[];for(const s of p){const c=this.m(s.id,d);c||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`,!1),S.push(c)}const R=p.length>0?p[0].index:l.length;if(l.length!==R){console.trace(`[createInstance] First service dependency of ${u.name} at position ${R+1} conflicts with ${l.length} static arguments`);const s=R-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,R)}return Reflect.construct(u,l.concat(S))}k(u,l){if(this.f.get(u)instanceof k.SyncDescriptor)this.f.set(u,l);else if(this.h)this.h.k(u,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const l=this.f.get(u);return!l&&this.h?this.h.l(u):l}m(u,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const d=this.l(u);return d instanceof k.SyncDescriptor?this.q(u,d,l.branch(u,!0)):(l.branch(u,!1),d)}q(u,l,d){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,l,d)}finally{this.o.delete(u)}}r(u,l,d){const p=new N.Graph(s=>s.id.toString());let S=0;const R=[{id:u,desc:l,_trace:d}];for(;R.length;){const s=R.pop();if(p.lookupOrInsertNode(s),S++>1e3)throw new w(p);for(const c of P._util.getServiceDependencies(s.desc.ctor)){const t=this.l(c.id);if(t||this.u(`[createInstance] ${u} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(c.id)),t instanceof k.SyncDescriptor){const n={id:c.id,desc:t,_trace:s._trace.branch(c.id,!0)};p.insertEdge(s,n),R.push(n)}}}for(;;){const s=p.roots();if(s.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:c}of s){if(this.l(c.id)instanceof k.SyncDescriptor){const n=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,n)}p.removeNode(c)}}return this.l(u)}s(u,l,d=[],p,S){if(this.f.get(u)instanceof k.SyncDescriptor)return this.t(u,l,d,p,S);if(this.h)return this.h.s(u,l,d,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(u,l,d=[],p,S){if(p){const R=new g(void 0,this.g,this,this.i);R.c=String(u);const s=new Map,c=new L.IdleValue(()=>{const t=R.j(l,d,S);for(const[n,r]of s){const o=t[n];if(typeof o=="function")for(const a of r)o.apply(t,a)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!c.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=s.get(n);return a||(a=new y.LinkedList,s.set(n,a)),(b,E,T)=>{const O=a.push([b,E,T]);return(0,D.toDisposable)(O)}}if(n in t)return t[n];const r=c.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),t[n]=o),o},set(t,n,r){return c.value[n]=r,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,d,S)}u(u,l){if(l&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=g;var m;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(m||(m={}));class f{static traceInvocation(u,l){return u?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(u,l){return u?new f(1,l.name):f.c}constructor(u,l){this.type=u,this.name=l,this.g=Date.now(),this.h=[]}branch(u,l){const d=new f(3,u.toString());return this.h.push([u,l,d]),d}stop(){const u=Date.now()-this.g;f.f+=u;let l=!1;function d(S,R){const s=[],c=new Array(S+1).join("	");for(const[t,n,r]of R.h)if(n&&r){l=!0,s.push(`${c}CREATES -> ${t}`);const o=d(S+1,r);o&&s.push(o)}else s.push(`${c}uses -> ${t}`);return s.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(u>2||l)&&f.all.add(p.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(oe[205],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(D,k){this.a=D,this.b=k}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,k){this.a.registerChannel(D,k)}}e.MessagePortMainProcessService=L}),define(oe[57],ae([0,1,39,55,71,5]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class N{constructor(m,f,v,u){const l=v.getChannel(m);return P(f)?u.createInstance(new i.SyncDescriptor(f.channelClientCtor,[l])):L.ProxyChannel.toService(l,f?.proxyOptions)}}function P(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let I=class extends N{constructor(m,f,v,u){super(m,f,v,u)}};I=ye([K(2,e.IMainProcessService),K(3,k.IInstantiationService)],I);function y(g,m,f){(0,D.registerSingleton)(g,new i.SyncDescriptor(I,[m,f],!0))}e.registerMainProcessRemoteService=y,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let C=class extends N{constructor(m,f,v,u){super(m,f,v,u)}};C=ye([K(2,e.ISharedProcessService),K(3,k.IInstantiationService)],C);function w(g,m,f){(0,D.registerSingleton)(g,new i.SyncDescriptor(C,[m,f],!0))}e.registerSharedProcessRemoteService=w}),define(oe[73],ae([0,1,23,2,4,169,30,5]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(C){return C.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let y=class extends i.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new L.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const f=g.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(u=>u.startsWith("lp-"))).map(v=>{const u=v.properties.localizedLanguages?.[0],l=I(v);return{...this.f(l,u,v),extensionId:v.identifier.id,galleryExtension:v}});return f.push({...this.f("en","English"),extensionId:"default"}),f}f(w,g,m){const f=g??w;let v;if(f!==w&&(v=`(${w})`),w.toLowerCase()===D.language.toLowerCase()&&(v??="",v+=(0,k.localize)(0,null)),m?.installCount){v??="";const u=m.installCount;let l;u>1e6?l=`${Math.floor(u/1e5)/10}M`:u>1e3?l=`${Math.floor(u/1e3)}K`:l=String(u),v+=` $(cloud-download) ${l}`}return{id:w,label:f,description:v}}};y=ye([K(0,N.IExtensionGalleryService)],y),e.LanguagePackBaseService=y}),define(oe[206],ae([0,1,2,73]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends L.Disposable{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};D=ye([K(0,i.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[9],ae([0,1,38,3,2,37,4,5]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function C(r,o,a){switch(o){case y.Trace:r.trace(a);break;case y.Debug:r.debug(a);break;case y.Info:r.info(a);break;case y.Warning:r.warn(a);break;case y.Error:r.error(a);break;case y.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=C;function w(r){let o="";for(let a=0;a<r.length;a++){let h=r[a];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}o+=(a>0?" ":"")+h}return o}e.format=w;class g extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==y.Off&&this.b<=o}}e.AbstractLogger=g;class m extends g{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...a){this.f(y.Trace)&&this.g(y.Trace,w([o,...a]))}debug(o,...a){this.f(y.Debug)&&this.g(y.Debug,w([o,...a]))}info(o,...a){this.f(y.Info)&&this.g(y.Info,w([o,...a]))}warn(o,...a){this.f(y.Warning)&&this.g(y.Warning,w([o,...a]))}error(o,...a){if(this.f(y.Error))if(o instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=o.stack,this.g(y.Error,w(h))}else this.g(y.Error,w([o,...a]))}flush(){}}e.AbstractMessageLogger=m;class f extends g{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!N.isWindows}trace(o,...a){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,o,...a):console.log(`[main ${I()}]`,o,...a))}debug(o,...a){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,o,...a):console.log(`[main ${I()}]`,o,...a))}info(o,...a){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,o,...a):console.log(`[main ${I()}]`,o,...a))}warn(o,...a){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,o,...a):console.warn(`[main ${I()}]`,o,...a))}error(o,...a){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,o,...a):console.error(`[main ${I()}]`,o,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class v extends g{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...a){this.f(y.Trace)&&console.log("%cTRACE","color: #888",o,...a)}debug(o,...a){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...a)}info(o,...a){this.f(y.Info)&&console.log("%c INFO","color: #33f",o,...a)}warn(o,...a){this.f(y.Warning)&&console.log("%c WARN","color: #993",o,...a)}error(o,...a){this.f(y.Error)&&console.log("%c  ERR","color: #f33",o,...a)}dispose(){}flush(){}}e.ConsoleLogger=v;class u extends g{constructor(o,a=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(a)}trace(o,...a){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(o),...a])}debug(o,...a){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(o),...a])}info(o,...a){this.f(y.Info)&&this.g.log(y.Info,[this.h(o),...a])}warn(o,...a){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(o),...a])}error(o,...a){this.f(y.Error)&&this.g.log(y.Error,[this.h(o),...a])}h(o){return typeof o=="string"?o:(0,L.toErrorMessage)(o,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class l extends g{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const a of this.g)a.setLevel(o);super.setLevel(o)}trace(o,...a){for(const h of this.g)h.trace(o,...a)}debug(o,...a){for(const h of this.g)h.debug(o,...a)}info(o,...a){for(const h of this.g)h.info(o,...a)}warn(o,...a){for(const h of this.g)h.warn(o,...a)}error(o,...a){for(const h of this.g)h.error(o,...a)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=l;class d extends D.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...a){this.b.trace(o,...a)}debug(o,...a){this.b.debug(o,...a)}info(o,...a){this.b.info(o,...a)}warn(o,...a){this.b.warn(o,...a)}error(o,...a){this.b.error(o,...a)}flush(){this.b.flush()}}e.LogService=d;class p extends D.Disposable{constructor(o,a,h){if(super(),this.h=o,this.b=new k.ResourceMap,this.c=new k.ResourceMap,this.f=this.B(new i.Emitter),this.onDidChangeLoggerResources=this.f.event,this.g=this.B(new i.Emitter),this.onDidChangeLogLevel=this.g.event,this.B(a(b=>this.j(b))),h)for(const b of h)this.c.set(b.resource,b)}getLogger(o){return this.b.get(o)}createLogger(o,a,h){let b=this.b.get(o);return b||(h=a?.always?y.Trace:h,b=this.k(o,h??this.getLogLevel(o)??this.h,a),this.b.set(o,b),this.registerLoggerResource({resource:o,logLevel:h,name:a?.name})),b}setLogLevel(o,a){const h=this.c.get(o);h&&a!==h.logLevel&&(h.logLevel=a===this.h?void 0:a,this.b.get(o)?.setLevel(a),this.c.set(h.resource,h),this.g.fire(h))}j(o){this.h=o;for(const[a,h]of this.b.entries())this.c.get(a)?.logLevel===void 0&&h.setLevel(this.h)}getLogLevel(o){return this.c.get(o)?.logLevel}registerLoggerResource(o){this.c.get(o.resource)||(this.c.set(o.resource,o),this.f.fire({added:[o],removed:[]}))}deregisterLoggerResource(o){const a=this.c.get(o);a&&(this.c.delete(o),this.f.fire({added:[],removed:[a]}))}getLoggerResources(){return this.c.values()}dispose(){this.b.forEach(o=>o.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class S{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...a){}debug(o,...a){}info(o,...a){}warn(o,...a){}error(o,...a){}critical(o,...a){}dispose(){}flush(){}}e.NullLogger=S;class R extends S{}e.NullLogService=R;class s extends p{constructor(){super(y.Info,i.Event.None)}k(o,a,h){return new S}}e.NullLoggerService=s;function c(r){if(r.verbose)return y.Trace;if(typeof r.logLevel=="string"){const o=n(r.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function t(r){switch(r){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=t;function n(r){switch(r){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=n}),define(oe[207],ae([0,1,6,7,2,12,28,15,9]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let y=class extends D.Disposable{constructor(w,g){super(),this.a=w,this.b=g,this.B(new L.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,k.basename)(this.a.logsPath),g=(0,k.dirname)(this.a.logsPath),v=(await N.Promises.readdir(g)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==w),u=v.slice(0,Math.max(0,v.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(l=>N.Promises.rm((0,k.join)(g,l)))))}catch(w){(0,i.onUnexpectedError)(w)}}};y=ye([K(0,P.IEnvironmentService),K(1,I.ILogService)],y),e.LogsDataCleaner=y}),define(oe[208],ae([0,1,21,6,7,3,2,12,56,9]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends N.Disposable{constructor(g,m){super(),this.a=g,this.b=m,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(g,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(g,m):this.u(g,m)}l(g,m){const f={path:this.C(g),excludes:m.excludes,includes:m.includes,recursive:m.recursive},v=(0,L.insert)(this.j,f);return this.m(),(0,N.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,D.onUnexpectedError)(g))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,I.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const m of this.j)(0,I.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const m of this.j)(0,I.isRecursiveWatchRequest)(m)&&g.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,m){const f={path:this.C(g),excludes:m.excludes,includes:m.includes,recursive:!1},v=(0,L.insert)(this.s,f);return this.v(),(0,N.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,D.onUnexpectedError)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,I.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,P.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(oe[209],ae([0,1,21,6,17,23,3,66,64,2,49,24,102,22,44,165,14,101,9,7]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends y.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new i.ResourceQueue)}registerProvider(s,c){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${s}`);const t=new y.DisposableStore;return this.h.set(s,c),this.c.fire({added:!0,scheme:s,provider:c}),t.add(c.onDidChangeFile(n=>this.R.fire(new u.FileChangesEvent(n,!this.O(c))))),typeof c.onDidWatchError=="function"&&t.add(c.onDidWatchError(n=>this.S.fire(new Error(n)))),t.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:s}))),(0,y.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:c}),this.h.delete(s),(0,y.dispose)(t)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const c=[];this.f.fire({scheme:s,join(t){c.push(t)}}),!this.h.has(s)&&await i.Promises.settled(c)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,c){const t=this.h.get(s.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return I.Iterable.map(this.h,([s,c])=>({scheme:s,capabilities:c.capabilities}))}async j(s){if(!(0,m.isAbsolutePath)(s))throw new u.FileOperationError((0,v.localize)(0,null,this.nb(s)),8);await this.activateProvider(s.scheme);const c=this.h.get(s.scheme);if(!c){const t=new p.ErrorNoTelemetry;throw t.message=(0,v.localize)(1,null,s.toString()),t}return c}async k(s){const c=await this.j(s);if((0,u.hasOpenReadWriteCloseCapability)(c)||(0,u.hasReadWriteCapability)(c)||(0,u.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const c=await this.j(s);if((0,u.hasOpenReadWriteCloseCapability)(c)||(0,u.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,c){try{return await this.n(s,c)}catch(t){throw(0,u.toFileSystemProviderErrorCode)(t)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,v.localize)(2,null,this.nb(s)),1):(0,u.ensureFileSystemProviderError)(t)}}async n(s,c){const t=await this.j(s),n=this.O(t),r=c?.resolveTo,o=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,h=await t.stat(s);let b;return this.p(t,s,h,void 0,!!a,(E,T)=>(b||(b=C.TernarySearchTree.forUris(()=>!n),b.set(s,!0),r&&b.fill(!0,r)),b.get(E.resource)||b.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?T===1:!1))}async p(s,c,t,n,r,o){const{providerExtUri:a}=this.N(s),h={resource:c,name:a.basename(c),isFile:(t.type&u.FileType.File)!==0,isDirectory:(t.type&u.FileType.Directory)!==0,isSymbolicLink:(t.type&u.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&u.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,u.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(h.isDirectory&&o(h,n)){try{const b=await s.readdir(c),E=await i.Promises.settled(b.map(async([T,O])=>{try{const M=a.joinPath(c,T),F=r?await s.stat(M):{type:O};return await this.p(s,M,F,b.length,r,o)}catch(M){return this.b.trace(M),null}}));h.children=(0,L.coalesce)(E)}catch(b){this.b.trace(b),h.children=[]}return h}return h}async resolveAll(s){return i.Promises.settled(s.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(s){const c=await this.j(s),t=await c.stat(s);return this.p(c,s,t,void 0,!0,()=>!1)}async exists(s){const c=await this.j(s);try{return!!await c.stat(s)}catch{return!1}}async canCreateFile(s,c){try{await this.r(s,c)}catch(t){return t}return!0}async r(s,c){if(!c?.overwrite&&await this.exists(s))throw new u.FileOperationError((0,v.localize)(3,null,this.nb(s)),3,c)}async createFile(s,c=D.VSBuffer.fromString(""),t){await this.r(s,t);const n=await this.writeFile(s,c);return this.m.fire(new u.FileOperationEvent(s,0,n)),n}async writeFile(s,c,t){const n=this.lb(await this.l(s),s),{providerExtUri:r}=this.N(n);try{await this.s(n,s,t)||await this.P(n,r.dirname(s));let a;if((0,u.hasReadWriteCapability)(n)&&!(c instanceof D.VSBuffer))if((0,f.isReadableStream)(c)){const h=await(0,f.peekStream)(c,3);h.ended?a=D.VSBuffer.concat(h.buffer):a=h}else a=(0,f.peekReadable)(c,h=>D.VSBuffer.concat(h),3);else a=c;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&a instanceof D.VSBuffer?await this.cb(n,s,t,a):await this.Y(n,s,t,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this.m.fire(new u.FileOperationEvent(s,4))}catch(o){throw new u.FileOperationError((0,v.localize)(4,null,this.nb(s),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),t)}return this.resolve(s,{resolveMetadata:!0})}async s(s,c,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(c)));let r;try{r=await s.stat(c)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,v.localize)(6,null,this.nb(c)),0,t);if(this.mb(c,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,u.etag)({mtime:t.mtime,size:r.size}))throw new u.FileOperationError((0,v.localize)(7,null),3,t);return r}async readFile(s,c,t){const n=await this.k(s);return c?.atomic?this.t(n,s,c,t):this.u(n,s,c,t)}async t(s,c,t,n){return new Promise((r,o)=>{this.X.queueFor(c,this.N(s).providerExtUri).queue(async()=>{try{const a=await this.u(s,c,t,n);r(a)}catch(a){o(a)}})})}async u(s,c,t,n){const r=await this.v(s,c,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(s,c,t){const n=await this.k(s);return this.v(n,s,c,t)}async v(s,c,t,n){const r=new k.CancellationTokenSource(n),o=this.F(c,t).then(h=>h,h=>{throw r.cancel(),h});let a;try{return typeof t?.etag=="string"&&t.etag!==u.ETAG_DISABLED&&await o,t?.atomic&&(0,u.hasFileAtomicReadCapability)(s)||!((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasFileReadStreamCapability)(s))||(0,u.hasReadWriteCapability)(s)&&t?.preferUnbuffered?a=this.D(s,c,t):(0,u.hasFileReadStreamCapability)(s)?a=this.z(s,c,r.token,t):a=this.C(s,c,r.token,t),{...await o,value:a}}catch(h){throw a&&await(0,f.consumeStream)(a),this.w(h,c,t)}}w(s,c,t){const n=(0,v.localize)(8,null,this.nb(c),(0,u.ensureFileSystemProviderError)(s).toString());return s instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(n,s.stat,t):s instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(n,s.fileOperationResult,s.size,s.options):new u.FileOperationError(n,(0,u.toFileOperationResult)(s),t)}z(s,c,t,n=Object.create(null)){const r=s.readFileStream(c,n,t);return(0,f.transform)(r,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>this.w(o,c,n)},o=>D.VSBuffer.concat(o))}C(s,c,t,n=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,c,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,c,n)},t),r}D(s,c,t){const n=(0,f.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;t?.atomic&&(0,u.hasFileAtomicReadCapability)(s)?r=await s.readFile(c,{atomic:!0}):r=await s.readFile(c),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.G(c,r.byteLength,t),n.end(D.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(s,c){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new u.FileOperationError((0,v.localize)(9,null,this.nb(s)),0,c);if(typeof c?.etag=="string"&&c.etag!==u.ETAG_DISABLED&&c.etag===t.etag)throw new u.NotModifiedSinceFileOperationError((0,v.localize)(10,null),t,c);return this.G(s,t.size,c),t}G(s,c,t){if(t?.limits){let n;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&c>t.limits.size&&(n=7),typeof n=="number")throw new u.TooLargeFileOperationError((0,v.localize)(11,null,this.nb(s)),n,c,t)}}async canMove(s,c,t){return this.H(s,c,"move",t)}async canCopy(s,c,t){return this.H(s,c,"copy",t)}async H(s,c,t,n){if(s.toString()!==c.toString())try{const r=t==="move"?this.lb(await this.l(s),s):await this.k(s),o=this.lb(await this.l(c),c);await this.M(r,s,o,c,t,n)}catch(r){return r}return!0}async move(s,c,t){const n=this.lb(await this.l(s),s),r=this.lb(await this.l(c),c),o=await this.I(n,s,r,c,"move",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(s,o==="move"?2:3,a)),a}async copy(s,c,t){const n=await this.k(s),r=this.lb(await this.l(c),c),o=await this.I(n,s,r,c,"copy",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(s,o==="copy"?3:2,a)),a}async I(s,c,t,n,r,o){if(c.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.M(s,c,t,n,r,o);if(a&&!h&&o&&await this.del(n,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(n)),r==="copy"){if(s===t&&(0,u.hasFileFolderCopyCapability)(s))await s.copy(c,n,{overwrite:o});else{const b=await this.resolve(c);b.isDirectory?await this.L(s,b,t,n):await this.J(s,c,t,n)}return r}else return s===t?(await s.rename(c,n,{overwrite:o}),r):(await this.I(s,c,t,n,"copy",o),await this.del(c,{recursive:!0}),"copy")}async J(s,c,t,n){if((0,u.hasOpenReadWriteCloseCapability)(s)&&(0,u.hasOpenReadWriteCloseCapability)(t))return this.eb(s,c,t,n);if((0,u.hasOpenReadWriteCloseCapability)(s)&&(0,u.hasReadWriteCapability)(t))return this.kb(s,c,t,n);if((0,u.hasReadWriteCapability)(s)&&(0,u.hasOpenReadWriteCloseCapability)(t))return this.ib(s,c,t,n);if((0,u.hasReadWriteCapability)(s)&&(0,u.hasReadWriteCapability)(t))return this.gb(s,c,t,n)}async L(s,c,t,n){await t.mkdir(n),Array.isArray(c.children)&&await i.Promises.settled(c.children.map(async r=>{const o=this.N(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(s,await this.resolve(r.resource),t,o):this.J(s,r.resource,t,o)}))}async M(s,c,t,n,r,o){let a=!1;if(s===t){const{providerExtUri:b,isPathCaseSensitive:E}=this.N(s);if(E||(a=b.isEqual(c,n)),a&&r==="copy")throw new Error((0,v.localize)(12,null,this.nb(c),this.nb(n)));if(!a&&b.isEqualOrParent(n,c))throw new Error((0,v.localize)(13,null,this.nb(c),this.nb(n)))}const h=await this.exists(n);if(h&&!a){if(!o)throw new u.FileOperationError((0,v.localize)(14,null,this.nb(c),this.nb(n)),4);if(s===t){const{providerExtUri:b}=this.N(s);if(b.isEqualOrParent(c,n))throw new Error((0,v.localize)(15,null,this.nb(c),this.nb(n)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}N(s){const c=this.O(s);return{providerExtUri:c?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:c}}O(s){return!!(s.capabilities&1024)}async createFolder(s){const c=this.lb(await this.j(s),s);await this.P(c,s);const t=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(s,0,t)),t}async P(s,c){const t=[],{providerExtUri:n}=this.N(s);for(;!n.isEqual(c,n.dirname(c));)try{if(((await s.stat(c)).type&u.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.nb(c)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(c)),c=n.dirname(c)}for(let r=t.length-1;r>=0;r--){c=n.joinPath(c,t[r]);try{await s.mkdir(c)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,c){try{await this.Q(s,c)}catch(t){return t}return!0}async Q(s,c){const t=this.lb(await this.j(s),s);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,v.localize)(17,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{}if(r)this.mb(s,r);else throw new u.FileOperationError((0,v.localize)(18,null,this.nb(s)),1);if(!!!c?.recursive){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,v.localize)(19,null,this.nb(s)))}return t}async del(s,c){const t=await this.Q(s,c),n=!!c?.useTrash,r=!!c?.recursive;await t.delete(s,{recursive:r,useTrash:n}),this.m.fire(new u.FileOperationEvent(s,1))}async cloneFile(s,c){const t=await this.j(s),n=this.lb(await this.l(c),c);if(t===n&&this.N(t).providerExtUri.isEqual(s,c))return;if(t===n&&(0,u.hasFileCloneCapability)(t))return t.cloneFile(s,c);await this.P(n,this.N(n).providerExtUri.dirname(c));const r=this.X.queueFor(s,this.N(t).providerExtUri);return t===n&&(0,u.hasFileFolderCopyCapability)(t)?r.queue(()=>t.copy(s,c,{overwrite:!0})):r.queue(()=>this.J(t,s,n,c))}watch(s,c={recursive:!1,excludes:[]}){const t=new y.DisposableStore;let n=!1,r=()=>{n=!0};return t.add((0,y.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(s,c);n?(0,y.dispose)(o):r=()=>(0,y.dispose)(o)}catch(o){this.b.error(o)}})(),t}async W(s,c){const t=await this.j(s),n=(0,P.hash)([this.N(t).providerExtUri.getComparisonKey(s),c]);let r=this.U.get(n);return r||(r={count:0,disposable:t.watch(s,c)},this.U.set(n,r)),r.count+=1,(0,y.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,y.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.U)(0,y.dispose)(s.disposable);this.U.clear()}async Y(s,c,t,n){return this.X.queueFor(c,this.N(s).providerExtUri).queue(async()=>{const r=await s.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,f.isReadableStream)(n)||(0,f.isReadableBufferedStream)(n)?await this.Z(s,r,n):await this.ab(s,r,n)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async Z(s,c,t){let n=0,r;if((0,f.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=D.VSBuffer.concat(t.buffer);await this.bb(s,c,o,o.byteLength,n,0),n+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,a)=>{(0,f.listenStream)(r,{onData:async h=>{r.pause();try{await this.bb(s,c,h,h.byteLength,n,0)}catch(b){return a(b)}n+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>a(h),onEnd:()=>o()})})}async ab(s,c,t){let n=0,r;for(;(r=t.read())!==null;)await this.bb(s,c,r,r.byteLength,n,0),n+=r.byteLength}async bb(s,c,t,n,r,o){let a=0;for(;a<n;)a+=await s.write(c,r+a,t.buffer,o+a,n-a)}async cb(s,c,t,n){return this.X.queueFor(c,this.N(s).providerExtUri).queue(()=>this.db(s,c,t,n))}async db(s,c,t,n){let r;n instanceof D.VSBuffer?r=n:(0,f.isReadableStream)(n)?r=await(0,D.streamToBuffer)(n):(0,f.isReadableBufferedStream)(n)?r=await(0,D.bufferedStreamToBuffer)(n):r=(0,D.readableToBuffer)(n),await s.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(s,c,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.fb(s,c,t,n))}async fb(s,c,t,n){let r,o;try{r=await s.open(c,{create:!1}),o=await t.open(n,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.a);let h=0,b=0,E=0;do E=await s.read(r,h,a.buffer,b,a.byteLength-b),await this.bb(t,o,a,E,h,b),h+=E,b+=E,b===a.byteLength&&(b=0);while(E>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await i.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async gb(s,c,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.hb(s,c,t,n))}async hb(s,c,t,n){return t.writeFile(n,await s.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(s,c,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.jb(s,c,t,n))}async jb(s,c,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const o=await s.readFile(c);await this.bb(t,r,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await t.close(r)}}async kb(s,c,t,n){const r=await(0,D.streamToBuffer)(this.C(s,c,k.CancellationToken.None));await this.cb(t,n,void 0,r)}lb(s,c){if(s.capabilities&2048)throw new u.FileOperationError((0,v.localize)(20,null,this.nb(c)),6);return s}mb(s,c){if((c.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,v.localize)(21,null,this.nb(s)),6)}nb(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};S=ye([K(0,d.ILogService)],S),e.FileService=S}),define(oe[210],ae([0,1,53,292,6,37,17,3,48,2,12,4,22,44,28,168,14,101,208,38,203,202]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(L)}catch(c){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(c)}`)}})();class s extends d.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.H=new k.ResourceMap(r=>g.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:n,symbolicLink:r}=await f.SymlinkSupport.stat(this.C(t));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(t){try{const n=await f.Promises.readdir(this.C(t),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,g.joinPath)(t,o.name))).type:a=this.G(o),r.push([o.name,a])}catch(a){this.a.trace(a)}})),r}catch(n){throw this.Y(n)}}G(t,n){let r;return n?.dangling?r=u.FileType.Unknown:t.isFile()?r=u.FileType.File:t.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,n&&(r|=u.FileType.SymbolicLink),r}async I(t){const n=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new D.Barrier;return this.H.set(t,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,y.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(t)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),r=await this.I(t));const o=this.C(t);return await f.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(t){s.D&&this.a.trace(t)}readFileStream(t,n,r){const o=(0,m.newWriteableStream)(a=>N.VSBuffer.concat(a.map(h=>N.VSBuffer.wrap(h))).buffer);return(0,l.readFileIntoStream)(this,t,o,a=>a.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(t,n,r){let o;try{const a=this.C(t);if(!r.create||!r.overwrite){if(await f.Promises.exists(a)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,v.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,v.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(t,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.Z(t,a)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(t){s.O=t}async open(t,n){const r=this.C(t);let o;(0,u.isFileOpenForWriteOptions)(n)&&(o=await this.I(t));let a;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:b}=await f.SymlinkSupport.stat(r);b.mode&128||await f.Promises.chmod(r,b.mode|128)}catch(b){this.a.trace(b)}let h;if((0,u.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await f.Promises.truncate(r,0),h="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}h||(h="w")}else h="r";a=await f.Promises.open(r,h)}catch(h){throw o?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.Z(t,h):this.Y(h)}if(this.L.set(a,0),(0,u.isFileOpenForWriteOptions)(n)&&this.N.set(a,t),o){const h=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.M.set(a,o),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),h.dispose())}return a}async close(t){const n=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&s.O)try{await f.Promises.fdatasync(t)}catch(r){s.configureFlushOnWrite(!1),this.a.error(r)}return await f.Promises.close(t)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(t)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,r,o,a){const h=this.P(t,n);let b=null;try{b=(await f.Promises.read(t,r,o,a,h)).bytesRead}catch(E){throw this.Y(E)}finally{this.Q(t,h,b)}return b}P(t,n){return n===this.L.get(t)?null:n}Q(t,n,r){const o=this.L.get(t);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(t,o+r):this.L.delete(t)))}async write(t,n,r,o,a){return(0,D.retry)(()=>this.R(t,n,r,o,a),100,3)}async R(t,n,r,o,a){const h=this.P(t,n);let b=null;try{b=(await f.Promises.write(t,r,o,a,h)).bytesWritten}catch(E){throw await this.Z(this.N.get(t),E)}finally{this.Q(t,h,b)}return b}async mkdir(t){try{await f.Promises.mkdir(this.C(t))}catch(n){throw this.Y(n)}}async delete(t,n){try{const r=this.C(t);n.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(t,n,r){const o=this.C(t),a=this.C(n);if(o!==a)try{await this.S(t,n,"move",r.overwrite),await f.Promises.move(o,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(2,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(a)),h.toString()))),this.Y(h)}}async copy(t,n,r){const o=this.C(t),a=this.C(n);if(o!==a)try{await this.S(t,n,"copy",r.overwrite),await f.Promises.copy(o,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(3,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(a)),h.toString()))),this.Y(h)}}async S(t,n,r,o){const a=this.C(t),h=this.C(n);let b=!1;if(!!(this.capabilities&1024)||(b=(0,I.isEqual)(a,h,!0)),b&&r==="copy")throw(0,u.createFileSystemProviderError)((0,v.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!b&&await f.Promises.exists(h)){if(!o)throw(0,u.createFileSystemProviderError)((0,v.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.U(t,n,!1)}async U(t,n,r){const o=this.C(t),a=this.C(n),h=!!(this.capabilities&1024);if((0,I.isEqual)(o,a,!h))return;const b=new y.DisposableStore;try{const[E,T]=await Promise.all([this.I(t),this.I(n)]);b.add(E),b.add(T),r&&await f.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await f.Promises.copyFile(o,a)}catch(E){if(E.code==="ENOENT"&&!r)return this.U(t,n,!0);throw this.Y(E)}finally{b.dispose()}}p(t,n,r){return new S.UniversalWatcherClient(o=>t(o),o=>n(o),r)}y(t,n,r){return new R.NodeJSWatcherClient(o=>t(o),o=>n(o),r)}Y(t){if(t instanceof u.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(t,n)}async Z(t,n){let r=this.Y(n);if(t&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await f.SymlinkSupport.stat(this.C(t));o.mode&128||(r=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}e.DiskFileSystemProvider=s,s.D=!1,s.O=!0}),define(oe[103],ae([0,1,6,3,2,5,9]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,k.createDecorator)("lifecycleSharedProcessService");let P=class extends D.Disposable{constructor(y){super(),this.c=y,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const y=[];return this.b.fire({join(C){y.push(C)}}),this.a=(async()=>{try{await L.Promises.settled(y)}catch(C){this.c.error(C)}})(),this.a}};P=ye([K(0,N.ILogService)],P),e.SharedProcessLifecycleService=P}),define(oe[104],ae([0,1,3,8,9]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(w,g){this.a=w,this.b=g,this.onDidChangeLogLevel=L.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(w,g,m){switch(g){case"setLevel":return m[1]?this.b.setLogLevel(i.URI.revive(m[1]),m[0]):this.a.setLevel(m[0])}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=k;class N{constructor(w){this.a=w}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(w,g){N.setLevel(this.a,w,g)}static setLevel(w,g,m){return w.call("setLevel",[g,m])}}e.LogLevelChannelClient=N;class P extends D.AbstractLoggerService{constructor(w,g,m,f,v){super(g,m,f.map(u=>({...u,resource:i.URI.revive(u.resource)}))),this.l=w,this.m=v,this.B(v.listen("onDidChangeLogLevel",w)(u=>super.setLogLevel(i.URI.revive(u.resource),u.logLevel??this.h))),this.B(v.listen("onDidChangeLoggerResources",w)(({added:u,removed:l})=>{for(const d of u)super.registerLoggerResource({...d,resource:i.URI.revive(d.resource)});for(const d of l)super.deregisterLoggerResource(d.resource)}))}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,g)=>{this.m.call("consoleLog",[w,g])}})}registerLoggerResource(w){this.m.call("registerLoggerResource",[w,this.l])}deregisterLoggerResource(w){this.m.call("deregisterLoggerResource",[w,this.l])}setLogLevel(w,g){this.m.call("setLogLevel",[w,g])}k(w,g,m){return new I(this.m,w,g,m)}}e.LoggerChannelClient=P;class I extends D.AbstractMessageLogger{constructor(w,g,m,f){super(f?.always),this.m=w,this.n=g,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[g,f]).then(()=>{this.r(this.l),this.k=!0})}g(w,g){const m=[[w,g]];this.k?this.r(m):this.l.push(...m)}r(w){this.m.call("log",[this.n,w])}}class y extends D.LogService{constructor(w,g){super(g),this.c=w,this.B(w.onDidChangeLogLevel(m=>g.setLevel(m)))}setLevel(w){super.setLevel(w),this.c.setLevel(w)}}e.FollowerLogService=y}),define(oe[58],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(oe[59],ae([0,1,3,64,2,5]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class N extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const C=Object.keys(this.f).length;return this.f={...y,...this.f},C!==Object.keys(this.f).length&&await this.i(y),i.Iterable.reduce(this.g.entries(),(w,[g,m])=>({...w,[g]:m}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(y,[C,w])=>({...y,[C]:{definition:w,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=N;class P{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(oe[211],ae([0,1,3,2,59]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(I){this.b=I,this.a=new i.DisposableStore}listen(I,y){switch(y){case"onDidChange":return L.Event.map(this.b.onDidChange,C=>C.reduce((w,g)=>({...w,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${y}`)}call(I,y,C){switch(y){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${y}`)}dispose(){this.a.dispose()}}e.PolicyChannel=k;class N extends D.AbstractPolicyService{constructor(I,y){super(),this.a=y;for(const C in I){const{definition:w,value:g}=I[C];this.f[C]=w,g!==void 0&&this.g.set(C,g)}this.a.listen("onDidChange")(C=>{for(const w in C){const g=C[w];g===null?this.g.delete(w):this.g.set(w,g)}this.h.fire(Object.keys(C))})}async i(I){const y=await this.a.call("updatePolicyDefinitions",I);for(const C in y)this.g.set(C,y[C])}}e.PolicyChannelClient=N}),define(oe[105],ae([0,1,4,36]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const k=L.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:k.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[25],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[212],ae([0,1,6,7,2,12,28,9,25]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let y=class extends D.Disposable{constructor(w,g,m){super(),this.b=g,this.c=m,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this.B(new L.RunOnceScheduler(()=>{this.f(w)},3e4)).schedule()}async f(w){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),m=(0,k.dirname)(w),f=(0,k.basename)(w),v=await N.Promises.readdir(m);await Promise.all(v.map(async u=>{if(u===f)return;const l=(0,k.join)(m,u),d=await N.Promises.stat(l);if(d.isDirectory()&&g-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${u}.`),N.Promises.rm(l)}))}catch(g){(0,i.onUnexpectedError)(g)}}};y=ye([K(1,I.IProductService),K(2,P.ILogService)],y),e.CodeCacheCleaner=y}),define(oe[213],ae([0,1,6,7,2,12,28,15,9,25]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(g,m,f){super(),this.b=g,this.c=m,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new L.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),m=JSON.parse(await N.Promises.readFile((0,k.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(m)){const p=m[d];g[`${p.hash}.${d}`]=!0}const f=(0,k.join)(this.b.userDataPath,"clp");if(!await N.Promises.exists(f))return;const u=await N.Promises.readdir(f);for(const d of u){if(g[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await N.Promises.rm((0,k.join)(f,d))}const l=Date.now();for(const d of Object.keys(g)){const p=(0,k.join)(f,d),S=await N.Promises.readdir(p);for(const R of S){if(R==="tcf.json")continue;const s=(0,k.join)(p,R),c=await N.Promises.stat(s);c.isDirectory()&&l-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(d,R)}`),await N.Promises.rm(s))}}}catch(g){(0,i.onUnexpectedError)(g)}}};C=ye([K(0,P.INativeEnvironmentService),K(1,I.ILogService),K(2,y.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(oe[214],ae([0,1,21,2,22,190,14,25]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends i.Disposable{constructor(C,w){super(),this.b=C,this.c=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,g])=>this.a.set(g.configPath,g))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const w=[];for(const[g,m]of this.a)if(!(m.configScheme&&m.configScheme!==C.scheme))try{const f=await this.b.readFile((0,D.joinPath)(C,g)),v=new Map;Object.entries(m.recommendations).forEach(([l,d])=>{if((0,L.isNonEmptyArray)(d.remotes))for(const p of d.remotes)v.set(p,{extensionId:l,extensionName:d.name,configName:m.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else w.push({extensionId:l,extensionName:d.name,configName:m.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const u=(0,k.getDomainsOfRemotes)(f.value.toString(),[...v.keys()]);for(const l of u){const d=v.get(l);d&&w.push(d)}}catch{}return w}};I=ye([K(0,N.IFileService),K(1,P.IProductService)],I),e.ExtensionTipsService=I}),define(oe[215],ae([0,1,12,5]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(k){function N(I){return Boolean(I.samples&&I.timeDeltas)}k.isValidProfile=N;function P(I,y="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,L.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,L.join)(y,(0,L.basename)(C.callFrame.url)));return I}k.rewriteAbsolutePaths=P})(D=e.Utils||(e.Utils={}))}),define(oe[216],ae([0,1,31]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(k){const P=await(await new Promise((y,C)=>{Z(["v8-inspect-profiler"],y,C)})).startProfiling({port:k.port,checkForPaused:!0}),I=(0,L.generateUuid)();return this.a.set(I,P),I}async stopProfiling(k){const N=this.a.get(k);if(!N)throw new Error(`UNKNOWN session '${k}'`);const P=await N.stop();return this.a.delete(k),P.profile}}e.InspectProfilingService=i}),define(oe[40],ae([0,1,129,13]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(N,P){L.ok(i.isString(N)),L.ok(i.isObject(P)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,P)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new D}),define(oe[106],ae([0,1,3,40]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,y){this.a[D(I)]=y,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const N=new k;i.Registry.add(e.Extensions.JSONContribution,N)}),define(oe[46],ae([0,1,21,3,13,154,16,106,40]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=I.Registry.as(P.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(s,c=!0){this.registerConfigurations([s],c)}registerConfigurations(s,c=!0){const t=new Set;this.n(s,c,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const c=new Set;this.o(s,c),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:s,remove:c}){const t=new Set;this.o(c,t),this.n(s,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const c=new Set;this.k(s,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(s,c){const t=[];for(const{overrides:n,source:r}of s)for(const o in n)if(c.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.a.get(o),h=a?.valuesSources??new Map;if(r)for(const O of Object.keys(n[o]))h.set(O,r);const b={...a?.value||{},...n[o]};this.a.set(o,{source:r,value:b,valuesSources:h});const E=(0,N.getLanguageTagSettingPlainKey)(o),T={type:"object",default:b,description:k.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:D.isString(r)?void 0:r,defaultValueSource:r};t.push(...v(o)),this.d[o]=T,this.b.properties[o]=T}else{this.a.set(o,{value:n[o],source:r});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(t)}deregisterDefaultConfigurations(s){const c=new Set;this.l(s,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(s,c){for(const{overrides:t,source:n}of s)for(const r in t){const o=this.a.get(r),a=D.isString(n)?n:n?.id,h=D.isString(o?.source)?o?.source:o?.source?.id;if(a===h)if(c.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const b=this.d[r];b&&(this.w(r,b),this.r(r,b))}}this.u()}deltaConfiguration(s){let c=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),c=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),c=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const c of s)this.h.add(c);this.u()}n(s,c,t){s.forEach(n=>{this.p(n,c,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(s,c){const t=n=>{if(n.properties)for(const r in n.properties){c.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>t(r))};for(const n of s){t(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(s,c=!0,t,n,r=3,o){r=D.isUndefinedOrNull(s.scope)?r:s.scope;const a=s.properties;if(a)for(const b in a){const E=a[b];if(c&&p(b,E)){delete a[b];continue}if(E.source=t,E.defaultDefaultValue=a[b].default,this.w(b,E),e.OVERRIDE_PROPERTY_REGEX.test(b)?E.scope=void 0:(E.scope=D.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=D.isUndefinedOrNull(E.restricted)?!!n?.includes(b):E.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),o.add(b)}const h=s.allOf;if(h)for(const b of h)this.p(b,c,t,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const c=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(c)};c(s)}r(s,c){switch(e.allSettings.properties[s]=c,c.scope){case 1:e.applicationSettings.properties[s]=c;break;case 2:e.machineSettings.properties[s]=c;break;case 6:e.machineOverridableSettings.properties[s]=c;break;case 3:e.windowSettings.properties[s]=c;break;case 4:e.resourceSettings.properties[s]=c;break;case 5:e.resourceSettings.properties[s]=c,this.g.properties[s]=c;break}}s(s,c){switch(delete e.allSettings.properties[s],c.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const c=`[${s}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,t),e.allSettings.properties[c]=t,e.applicationSettings.properties[c]=t,e.machineSettings.properties[c]=t,e.machineOverridableSettings.properties[c]=t,e.windowSettings.properties[c]=t,e.resourceSettings.properties[c]=t}}v(){const s={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}w(s,c){const t=this.a.get(s);let n=t?.value,r=t?.source;D.isUndefined(n)&&(n=c.defaultDefaultValue,r=void 0),D.isUndefined(n)&&(n=l(c.type)),c.default=n,c.defaultValueSource=r}}const m="\\[([^\\]]+)\\]",f=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(R){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let c=f.exec(R);for(;c?.length;){const t=c[1].trim();t&&s.push(t),c=f.exec(R)}}return(0,L.distinct)(s)}e.overrideIdentifiersFromKey=v;function u(R){return R.reduce((s,c)=>`${s}[${c}]`,"")}e.keyFromOverrideIdentifiers=u;function l(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new g;I.Registry.add(e.Extensions.Configuration,d);function p(R,s){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?k.localize(7,null,R):d.getConfigurationProperties()[R]!==void 0?k.localize(8,null,R):s.policy?.name&&d.getPolicyConfigurations().get(s.policy?.name)!==void 0?k.localize(9,null,R,s.policy?.name,d.getPolicyConfigurations().get(s.policy?.name)):null:k.localize(6,null)}e.validateProperty=p;function S(){const R=[],s=d.getConfigurationProperties();for(const c of Object.keys(s))R.push([c,s[c].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=S}),define(oe[74],ae([0,1,21,3,35,2,37,32,13,8,16,46,40]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(c){return Object.isFrozen(c)?c:P.deepFreeze(c)}class f{constructor(t={},n=[],r=[],o){this.b=t,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof f)return n;const r=new v("");return r.parseRaw(n),r.configurationModel});this.f=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const r=this.rawConfiguration.getValue(t),o=n?this.rawConfiguration.getOverrideValue(t,n):void 0,a=n?this.rawConfiguration.override(n).getValue(t):r;return{value:r,override:o,merged:a}}getOverrideValue(t,n){const r=this.i(n);return r?t?(0,C.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return L.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return L.distinct(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const h of t)if(a.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(n,h.contents);for(const b of h.overrides){const[E]=r.filter(T=>L.equals(T.identifiers,b.identifiers));E?(this.h(E.contents,b.contents),E.keys.push(...b.keys),E.keys=L.distinct(E.keys)):r.push(P.deepClone(b))}for(const b of h.keys)o.indexOf(b)===-1&&o.push(b)}return new f(n,o,r,a.every(h=>h instanceof f)?void 0:a)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const h=n[o];h&&(typeof a=="object"&&typeof h=="object"?(a=P.deepClone(a),this.h(a,h)):a=h),r[o]=a}return new f(r,this.keys,this.overrides)}h(t,n){for(const r of Object.keys(n)){if(r in t&&I.isObject(t[r])&&I.isObject(n[r])){this.h(t[r],n[r]);continue}t[r]=P.deepClone(n[r])}}i(t){let n=null,r=null;const o=a=>{a&&(r?this.h(r,a):r=P.deepClone(a))};for(const a of this.overrides)L.equals(a.identifiers,[t])?n=a.contents:a.identifiers.includes(t)&&o(a.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,C.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>L.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}j(t,n,r){(0,C.addToValueTree)(this.contents,t,n,o=>console.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,C.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=f;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!I.isUndefinedOrNull(t)){const r=this.g(t);this.parseRaw(r,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:r,keys:o,overrides:a,restricted:h,hasExcludedProperties:b}=this.h(t,n);this.b=new f(r,o,a,b?[t]:void 0),this.c=h||[]}g(t){let n={},r=null,o=[];const a=[],h=[];function b(T){Array.isArray(o)?o.push(T):r!==null&&(o[r]=T)}const E={onObjectBegin:()=>{const T={};b(T),a.push(o),o=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const T=[];b(T),a.push(o),o=T,r=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:b,onError:(T,O,M)=>{h.push({error:T,offset:O,length:M})}};if(t)try{D.visit(t,E),n=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return n}h(t,n){const r=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.i(t,r,!0,n);t=o.raw;const a=(0,C.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),h=Object.keys(t),b=this.j(t,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:a,keys:h,overrides:b,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,r,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:a};const h={},b=[];for(const E in t)if(w.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const T=this.i(t[E],n,!1,o);h[E]=T.raw,a=a||T.hasExcludedProperties,b.push(...T.restricted)}else{const T=n[E],O=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&b.push(E),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&!(o.skipRestricted&&T?.restricted)?h[E]=t[E]:a=!0}return{raw:h,restricted:b,hasExcludedProperties:a}}j(t,n){const r=[];for(const o of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const h in t[o])a[h]=t[o][h];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,C.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=v;class u extends k.Disposable{constructor(t,n,r,o){super(),this.f=t,this.g=n,this.h=o,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class l{constructor(t,n,r,o,a,h,b,E,T,O,M,F,A){this.a=t,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=a,this.f=h,this.g=b,this.h=E,this.i=T,this.j=O,this.k=M,this.l=F,this.m=A}get value(){return m(this.c)}n(t,n,r){const o=t.inspect(n,r);return{get value(){return m(o.value)},get override(){return m(o.override)},get merged(){return m(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(t,n,r,o,a=new f,h=new f,b=new N.ResourceMap,E=new f,T=new N.ResourceMap){this.c=t,this.d=n,this.f=r,this.g=o,this.h=a,this.i=h,this.j=b,this.l=E,this.m=T,this.a=null,this.b=new N.ResourceMap,this.n=null}getValue(t,n,r){return this.q(t,n,r).getValue(t)}updateValue(t,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new f,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),r.resource||(this.a=null)}inspect(t,n,r){const o=this.q(t,n,r),a=this.u(n.resource,r),h=n.resource?this.m.get(n.resource)||this.l:this.l,b=new Set;for(const E of o.overrides)for(const T of E.identifiers)o.getOverrideValue(t,T)!==void 0&&b.add(T);return new l(t,n,o.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,a||void 0,h)}keys(t){const n=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:o,updated:a,removed:h}=R(this.c,t);n=[...o,...a,...h]}for(const o of n)for(const a of(0,w.overrideIdentifiersFromKey)(o)){const h=this.c.getKeysForOverrideIdentifier(a),b=t.getKeysForOverrideIdentifier(a),E=[...b.filter(T=>h.indexOf(T)===-1),...h.filter(T=>b.indexOf(T)===-1),...h.filter(T=>!P.equals(this.c.override(a).getValue(T),t.override(a).getValue(T)))];r.push([a,E])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:o}=R(this.d,t),a=[...n,...r,...o];return a.length&&this.updatePolicyConfiguration(t),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:o,overrides:a}=R(this.applicationConfiguration,t),h=[...n,...r,...o];return h.length&&this.updateApplicationConfiguration(t),{keys:h,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:a}=R(this.localUserConfiguration,t),h=[...n,...r,...o];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:a}=R(this.remoteUserConfiguration,t),h=[...n,...r,...o];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:o,overrides:a}=R(this.workspaceConfiguration,t),h=[...n,...r,...o];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,n){const r=this.p.get(t),{added:o,updated:a,removed:h,overrides:b}=R(r,n),E=[...o,...a,...h];return(E.length||!r)&&this.updateFolderConfiguration(t,n),{keys:E,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.p.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:a,overrides:h}=R(n,void 0);return{keys:[...r,...o,...a],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}r({resource:t},n){let r=this.s();if(n&&t){const o=n.getFolder(t);o&&(r=this.t(o.uri)||r);const a=this.m.get(t);a&&(r=r.merge(a))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let n=this.b.get(t);if(!n){const r=this.s(),o=this.j.get(t);o?(n=r.merge(o),this.b.set(t,n)):n=r}return n}u(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:r,overrides:o,keys:a}=this.j.get(n);return t.push([n,{contents:r,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}w(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.x(t.defaults),r=this.x(t.policy),o=this.x(t.application),a=this.x(t.user),h=this.x(t.workspace),b=t.folders.reduce((E,T)=>(E.set(y.URI.revive(T[0]),this.x(T[1])),E),new N.ResourceMap);return new d(n,r,o,a,new f,h,b,new f,new N.ResourceMap)}static x(t){return new f(t.contents,t.keys,t.overrides)}}e.Configuration=d;function p(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,n=new Map;for(const o of c)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,h])=>{const b=(0,N.getOrSet)(n,a,new Set);h.forEach(E=>b.add(E))});const r=[];return n.forEach((o,a)=>r.push([a,[...o.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=p;class S{constructor(t,n,r,o){this.change=t,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of t.keys)this.affectedKeys.add(a);for(const[,a]of t.overrides)for(const h of a)this.affectedKeys.add(h);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(t,n){const r=this.a+t,o=this.d.indexOf(r);if(o<0)return!1;const a=o+r.length;if(a>=this.d.length)return!1;const h=this.d.charCodeAt(a);if(h!==this.b&&h!==this.c)return!1;if(n){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,E=this.g.getValue(t,n,this.h);return!P.equals(b,E)}return!0}}e.ConfigurationChangeEvent=S;function R(c,t){const{added:n,removed:r,updated:o}=s(t?.rawConfiguration,c?.rawConfiguration),a=[],h=c?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const E=b.filter(T=>!h.includes(T));for(const T of E)a.push([T,t.getKeysForOverrideIdentifier(T)])}if(c){const E=h.filter(T=>!b.includes(T));for(const T of E)a.push([T,c.getKeysForOverrideIdentifier(T)])}if(t&&c){for(const E of h)if(b.includes(E)){const T=s({contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)},{contents:t.getOverrideValue(void 0,E)||{},keys:t.getKeysForOverrideIdentifier(E)});a.push([E,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:r,updated:o,overrides:a}}function s(c,t){const n=c?t?c.keys.filter(a=>t.keys.indexOf(a)===-1):[...c.keys]:[],r=t?c?t.keys.filter(a=>c.keys.indexOf(a)===-1):[...t.keys]:[],o=[];if(c&&t){for(const a of t.keys)if(c.keys.indexOf(a)!==-1){const h=(0,C.getConfigurationValue)(t.contents,a),b=(0,C.getConfigurationValue)(c.contents,a);P.equals(h,b)||o.push(a)}}return{added:n,removed:r,updated:o}}}),define(oe[217],ae([0,1,21,3,2,32,13,74,46,9,59,40]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:l})=>this.c(Array.from(u),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,l){this.h(u,w.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new P.ConfigurationModel;const u=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,l){const d=this.f();for(const p of u){const S=d[p],R=l[p];S!==void 0?this.b.addValue(p,S):R?this.b.addValue(p,R.default):this.b.removeValue(p)}}}e.DefaultConfiguration=g;class m{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let f=class extends D.Disposable{get configurationModel(){return this.b}constructor(u,l,d){super(),this.c=u,this.f=l,this.g=d,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const l={},d=[],p=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const S of u){const R=p[S];if(!R){d.push(S);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}d.push(S),l[R.policy.name]={type:R.type}}}return(0,N.isEmptyObject)(l)||await this.f.updatePolicyDefinitions(l),d}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const l=w.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,L.coalesce)(u.map(p=>l.get(p)));this.j(d,!0)}j(u,l){this.g.trace("PolicyConfiguration#update",u);const d=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),p=[],S=this.b.isEmpty();for(const R of u){const s=d[R]?.policy?.name;if(s){const c=this.f.getPolicyValue(s);(S?c!==void 0:!(0,k.equals)(this.b.getValue(R),c))&&p.push([R,c])}else this.b.getValue(R)!==void 0&&p.push([R,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const R=this.b;this.b=new P.ConfigurationModel;for(const s of R.keys)this.b.setValue(s,R.getValue(s));for(const[s,c]of p)c===void 0?this.b.removeValue(s):this.b.setValue(s,c);l&&this.a.fire(this.b)}}};f=ye([K(1,C.IPolicyService),K(2,y.ILogService)],f),e.PolicyConfiguration=f}),define(oe[218],ae([0,1,6,3,2,22,16,74,217,59]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(g,m,f,v){super(),this.i=g,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=f instanceof y.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,f,v)),this.f=this.B(new P.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,m)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:l})=>this.k(u,l))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,m,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(g,m,new P.ConfigurationModel,f)}getConfigurationData(){return this.a.toData()}getValue(g,m){const f=typeof g=="string"?g:void 0,v=(0,N.isConfigurationOverrides)(g)?g:(0,N.isConfigurationOverrides)(m)?m:{};return this.a.getValue(f,v,void 0)}updateValue(g,m,f,v){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const m=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(f,m,2)}k(g,m){const f=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(g,m);this.m(v,f,7)}l(g){const m=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(g);this.m(f,m,7)}m(g,m,f){const v=new P.ConfigurationChangeEvent(g,{data:m},this.a);v.source=f,v.sourceConfig=this.n(f),this.h.fire(v)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(oe[219],ae([0,1,7,5]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends L.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof k&&I._code===D.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===D.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===D.NoResolverFound}static isHandled(I){return I instanceof k&&I.isHandled}constructor(I,y=D.Unknown,C){super(I),this._message=I,this._code=y,this._detail=C,this.isHandled=y===D.NotAvailable&&C===!0,Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k;function N(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.getRemoteAuthorityPrefix=N}),define(oe[75],ae([0,1,24]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(y){return y.scheme===L.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=i;function D(y){if(!y)return;const C=y.indexOf("+");return C<0?y:y.substr(0,C)}e.getRemoteName=D;function k(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=k;function N(y){const{host:C,port:w}=I(y);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:w}}e.parseAuthorityWithPort=N;function P(y,C){let{host:w,port:g}=I(y);return typeof g>"u"&&(g=C),{host:w,port:g}}e.parseAuthorityWithOptionalPort=P;function I(y){const C=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const w=y.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=y.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:y,port:void 0}}}),define(oe[42],ae([0,1,27,5,75]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=k;function N(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(v){this.value=v,this.c=v.toLowerCase()}static equals(v,u){if(typeof v>"u"||v===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof v=="string"||typeof u=="string"){const l=typeof v=="string"?v:v.value,d=typeof u=="string"?u:u.value;return L.equalsIgnoreCase(l,d)}return v.c===u.c}static toKey(v){return typeof v=="string"?v.toLowerCase():v.c}}e.ExtensionIdentifier=y;function C(f){return w(f)}e.isApplicationScopedExtension=C;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function g(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function m(f,v){if(v){const u=`onResolveRemoteAuthority:${(0,D.getRemoteName)(v)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[220],ae([0,1,2,12,28,42]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends L.Disposable{constructor(I,y){super(),this.b=I,this.a=(0,i.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(y.onDidInstallExtensions(C=>this.c(C))),this.B(y.onDidUninstallExtension(C=>this.f(C)))}c(I){I.some(y=>!!y.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(oe[221],ae([0,1,6,17,23,7,3,2,102,88,31,93,219,75]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function u(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(W){const q=new D.CancellationTokenSource;return setTimeout(()=>q.cancel(),W),q.token}function d(W,q){if(W.isCancellationRequested||q.isCancellationRequested)return D.CancellationToken.Cancelled;const J=new D.CancellationTokenSource;return W.onCancellationRequested(()=>J.cancel()),q.onCancellationRequested(()=>J.cancel()),J.token}class p{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((J,_)=>{this.f=J,this.g=_}),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function S(W,q){const J=new p(q);return J.registerDisposable(W.onControlMessage(_=>{const Y=JSON.parse(_.toString()),Q=x(Y);Q?J.reject(Q):J.resolve(Y)})),J.promise}function R(W,q,J,_,Y,Q,se,le,ue){const pe=new p(ue),we=y.StopWatch.create(!1);return W.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${se}`),q.connect(J,_,Y,Q,le,(be,Ee)=>{pe.didTimeout?(I.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) finished after ${we.elapsed()} ms, but this is too late and has timed out already.`),be&&W.error(be),Ee?.dispose()):be||!Ee?(I.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) returned an error after ${we.elapsed()} ms.`),pe.reject(be)):(I.mark(`code/didCreateSocketOK/${se}`),W.info(`Creating a socket (${le}) was successful after ${we.elapsed()} ms.`),pe.resolve(Ee))}),pe.promise}function s(W,q){const J=new p(q);return W.then(_=>{J.didTimeout||J.resolve(_)},_=>{J.didTimeout||J.reject(_)}),J.promise}async function c(W,q,J,_){const Y=U(W,q);W.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await R(W.logService,W.socketFactory,W.host,W.port,(0,m.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,u(q),`renderer-${u(q)}-${W.reconnectionToken}`,_)}catch(we){throw W.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),W.logService.error(we),we}W.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let se,le;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Q,null),se=W.reconnectionProtocol,le=!1):(se=new w.PersistentProtocol({socket:Q,measureRoundTripTime:!0}),le=!0),W.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ue=await s(W.signService.createNewMessage((0,C.generateUuid)()),_),pe={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ue.data};se.sendControl(i.VSBuffer.fromString(JSON.stringify(pe)));try{const we=await S(se,d(_,l(1e4)));if(we.type!=="sign"||typeof we.data!="string"){const Ue=new Error("Unexpected handshake message");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}if(W.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await s(W.signService.validate(ue,we.signedData),_)){const Ue=new Error("Refused to connect to unsupported server");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}const Ee=await s(W.signService.sign(we.data),_),Te={type:"connectionType",commit:W.commit,signedData:Ee,desiredConnectionType:q};return J&&(Te.args=J),W.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(i.VSBuffer.fromString(JSON.stringify(Te))),{protocol:se,ownsProtocol:le}}catch(we){throw we&&we.code==="ETIMEDOUT"&&(W.logService.error(`${Y} the handshake timed out. Error:`),W.logService.error(we)),we&&we.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(we)),le&&V(se),we}}async function t(W,q,J,_){const Y=Date.now(),Q=U(W,q),{protocol:se,ownsProtocol:le}=await c(W,q,J,_),ue=new p(_);return ue.registerDisposable(se.onControlMessage(pe=>{const we=JSON.parse(pe.toString()),be=x(we);be?(W.logService.error(`${Q} received error control message when negotiating connection. Error:`),W.logService.error(be),le&&V(se),ue.reject(be)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${B(Y)}!`),ue.resolve({protocol:se,firstMessage:we}))})),ue.promise}async function n(W,q){const{protocol:J}=await t(W,1,void 0,q);return{protocol:J}}async function r(W,q,J){const{protocol:_,firstMessage:Y}=await t(W,2,q,J),Q=Y&&Y.debugPort;return{protocol:_,debugPort:Q}}async function o(W,q,J){const _=Date.now(),Y=U(W,3),{protocol:Q}=await c(W,3,q,J);return W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${B(_)}!`),Q}async function a(W,q,J){const{host:_,port:Y,connectionToken:Q}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:_,port:Y,connectionToken:Q,reconnectionToken:q,reconnectionProtocol:J,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function h(W,q,J){return E(W,async _=>{const{protocol:Y}=await n(_,D.CancellationToken.None);return new G(W,q,J,_.reconnectionToken,Y)})}e.connectRemoteAgentManagement=h;async function b(W,q){return E(W,async J=>{const{protocol:_,debugPort:Y}=await r(J,q,D.CancellationToken.None);return new j(W,q,J.reconnectionToken,_,Y)})}e.connectRemoteAgentExtensionHost=b;async function E(W,q){for(let _=1;;_++)try{const Y=(0,C.generateUuid)(),Q=await a(W,Y,null);return await q(Q)}catch(Y){if(_<5)W.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(Y);else throw W.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(Y),ie.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(Y)),Y}}async function T(W,q,J){const _=await a(W,(0,C.generateUuid)(),null);return await o(_,{host:q,port:J},D.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function O(W){return(0,L.createCancelablePromise)(q=>new Promise((J,_)=>{const Y=setTimeout(J,W*1e3);q.onCancellationRequested(()=>{clearTimeout(Y),J()})}))}var M;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(q,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.type=0}}e.ConnectionLostEvent=F;class A{constructor(q,J,_,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.durationSeconds=_,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=A;class ${constructor(q,J,_){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=$;class z{constructor(q,J,_){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.attempt=_,this.type=4}}e.ConnectionGainEvent=z;class H{constructor(q,J){this.reconnectionToken=q,this.connectionHealth=J,this.type=5}}e.ConnectionHealthChangedEvent=H;class X{constructor(q,J,_,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.attempt=_,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=X;class ie extends P.Disposable{static triggerPermanentFailure(q,J,_){this._permanentFailure=!0,this.f=q,this.g=J,this.h=_,this.i.forEach(Y=>Y.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(q=>q.r())}static debugPauseSocketWriting(){this.i.forEach(q=>q.v())}get k(){return this.c||ie._permanentFailure}constructor(q,J,_,Y,Q){super(),this.m=q,this.n=J,this.reconnectionToken=_,this.protocol=Y,this.p=Q,this.j=this.B(new N.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new z(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(se=>{const le=te(this.m,this.reconnectionToken,!0);se?se.type===0?(this.n.logService.info(`${le} received socket close event (hadError: ${se.hadError}).`),se.error&&this.n.logService.error(se.error)):(this.n.logService.info(`${le} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.n.logService.error(se.event)):this.n.logService.info(`${le} received socket close event.`),this.r()})),this.B(Y.onSocketTimeout(se=>{const le=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(Y.onHighRoundTripTime(se=>{const le=re(this.m,this.reconnectionToken);this.n.logService.info(`${le} high roundtrip time: ${se.roundTripTime}ms (${se.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(Y.onDidChangeConnectionHealth(se=>{this.j.fire(new H(this.reconnectionToken,se))})),ie.i.push(this),this.B((0,P.toDisposable)(()=>{const se=ie.i.indexOf(this);se>=0&&ie.i.splice(se,1)})),this.k&&this.u(ie.f,ie.g,ie.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const q=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const Y=_<J.length?J[_]:J[J.length-1];try{if(Y>0){const se=O(Y);this.j.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,se)),this.n.logService.info(`${q} waiting for ${Y} seconds before reconnecting...`);try{await se}catch{}}if(this.k){this.n.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.n.logService.info(`${q} resolving connection...`);const Q=await a(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${q} connecting to ${Q.host}:${Q.port}...`),await this.w(Q,l(f)),this.n.logService.info(`${q} reconnected!`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.n.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Q)){this.n.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.n.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Q);continue}if((0,k.isCancellationError)(Q)){this.n.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Q);continue}if(Q instanceof g.RemoteAuthorityResolverError){this.n.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,g.RemoteAuthorityResolverError.isHandled(Q));break}this.n.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.k)}t(q,J,_){this.p?ie.triggerPermanentFailure(q,J,_):this.u(q,J,_)}u(q,J,_){this.j.fire(new X(this.reconnectionToken,q,J,_)),V(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie.f=0,ie.g=0,ie.h=!1,ie.i=[];class G extends ie{constructor(q,J,_,Y,Q){super(1,q,Y,Q,!0),this.client=this.B(new w.Client(Q,{remoteAuthority:J,clientId:_},q.ipcLogger))}async w(q,J){await n(q,J)}}e.ManagementPersistentConnection=G;class j extends ie{constructor(q,J,_,Y,Q){super(2,q,_,Y,!1),this.y=J,this.debugPort=Q}async w(q,J){await r(q,this.y,J)}}e.ExtensionHostPersistentConnection=j;function V(W){try{W.acceptDisconnect();const q=W.getSocket();W.dispose(),q.dispose()}catch(q){(0,k.onUnexpectedError)(q)}}function x(W){if(W&&W.type==="error"){const q=new Error(`Connection error: ${W.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function ee(W,q){for(;W.length<q;)W+=" ";return W}function re(W,q){return`[remote-connection][${ee(u(W),13)}][${q.substr(0,5)}\u2026]`}function te(W,q,J){return`${re(W,q)}[${J?"reconnect":"initial"}]`}function U(W,q){return`${te(q,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function B(W){return`${Date.now()-W} ms`}}),define(oe[222],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[223],ae([0,1,86,152]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,N,P,I,y){const C=g=>y(g,void 0),w=L.createConnection({host:D,port:k},()=>{w.removeListener("error",C);const g=Buffer.alloc(16);for(let u=0;u<16;u++)g[u]=Math.round(Math.random()*256);const m=g.toString("base64"),f=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}${N}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];w.write(f.join(`\r
`)+`\r
\r
`);const v=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",v),y(void 0,new i.NodeSocket(w,I)))};w.on("data",v)});w.setNoDelay(!0),w.once("error",C)}}}),define(oe[107],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var i;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=k=>({type:"connected",info:k}),D.connecting=k=>({type:"connecting",progress:k})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[224],ae([0,1,136,16,9]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const y=await(0,L.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),y}catch(y){throw this.b.error("RequestService#request (browser) - error",P.url,y),y}}async resolveProxy(P){}};k=ye([K(0,i.IConfigurationService),K(1,D.ILogService)],k),e.RequestService=k}),define(oe[60],ae([0,1,17,171,46,5,40]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=P;function I(v){return v.res.statusCode===204}async function y(v){return I(v)?null:(await(0,L.streamToBuffer)(v.stream)).toString()}e.asText=y;async function C(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);return y(v)}e.asTextOrError=C;async function w(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);if(I(v))return null;const l=(await(0,L.streamToBuffer)(v.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=w;function g(v){f(v)}e.updateProxyConfigurationsScope=g;let m;function f(v){const u=N.Registry.as(D.Extensions.Configuration),l=m;m={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[m],remove:l?[l]:[]})}f(2)}),define(oe[225],ae([0,1,23,24,14,60]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(I,y){this.a=I,this.b=y}async download(I,y,C=L.CancellationToken.None){if(I.scheme===i.Schemas.file||I.scheme===i.Schemas.vscodeRemote){await this.b.copy(I,y);return}const w={type:"GET",url:I.toString(!0)},g=await this.a.request(w,C);if(g.res.statusCode===200)await this.b.writeFile(y,g.stream);else{const m=await(0,k.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${m}`)}}};N=ye([K(0,k.IRequestService),K(1,D.IFileService)],N),e.DownloadService=N}),define(oe[226],ae([0,1,17,23]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,y,C=i.CancellationToken.None){switch(I){case"request":return this.a.request(y[0],C).then(async({res:w,stream:g})=>{const m=await(0,L.streamToBuffer)(g);return[{statusCode:w.statusCode,headers:w.headers},m]});case"resolveProxy":return this.a.resolveProxy(y[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class k{constructor(P){this.a=P}async request(P,I){const[y,C]=await this.a.call("request",[P],I);return{res:y,stream:(0,L.bufferToStream)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=k}),define(oe[227],ae([0,1,13,224,226]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(P,I,y,C){this.c=I,this.d=y,this.e=C,this.a=new i.RequestService(I,C),this.b=new D.RequestChannelClient(P.getChannel("request"))}request(P,I){return this.f().request(P,I)}async resolveProxy(P){return this.f().resolveProxy(P)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const P=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,L.isBoolean)(P)?P:this.d.quality!=="stable"}}e.SharedProcessRequestService=k}),define(oe[108],ae([0,1,66,5]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,L.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[228],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[229],ae([0,1,94,6,23,3,2,24,31,9,108,228]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let g=class{constructor(v){this.d=v,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(v){const u=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${u})`);const l=(0,C.hash)(v);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${u})`),this.f(v));const d=new D.CancellationTokenSource;let p,S,R;this.b.set(l,n=>{d.dispose(!0),p?.terminate(v,D.CancellationToken.None),S?.close(),R?.close(),this.b.delete(l);const r=this.c.get(l);r&&(this.c.delete(l),r({reason:n}))}),p=await this.e(v);const s=new Promise(n=>{this.c.set(l,n)});if(d.token.isCancellationRequested)return s;const{port1:c,port2:t}=new MessageChannel;return S=c,R=t,await p.spawn(v,R,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${u})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[S])),s}e(v){let u=this.a.get(v.process.moduleId);if(!u){this.d.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const l=new m(v.process.type,this.d);u=l.init(),l.onDidProcessSelfTerminate(({configuration:d,reason:p})=>{this.f(d,p)}),this.a.set(v.process.moduleId,u)}return u}async disposeWorker(v){return this.f(v)}f(v,u){const l=this.b.get((0,C.hash)(v));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),l(u))}};g=ye([K(0,y.ILogService)],g),e.SharedProcessWorkerService=g;class m extends N.Disposable{constructor(v,u){super(),this.f=v,this.g=u,this.a=this.B(new k.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const v=new i.DeferredPromise,u=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return u.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},u.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},u.onmessage=l=>{const{id:d,message:p,configuration:S,nonce:R}=l.data;switch(d){case w.SharedProcessWorkerMessages.Ready:v.complete(u);break;case w.SharedProcessWorkerMessages.Ack:if(R){const s=this.c.get(R);s&&(this.c.delete(R),s())}break;case w.SharedProcessWorkerMessages.SelfTerminated:S&&p&&this.a.fire({configuration:S,reason:JSON.parse(p)});break;case w.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case w.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},u.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async i(v,u,l){const d=await this.b;if(!u.isCancellationRequested)return new Promise(p=>{const S=(0,I.generateUuid)();this.c.set(S,p);const R={...v,nonce:S};l?d.postMessage(R,[l]):d.postMessage(R),u.onCancellationRequested(()=>{this.c.delete(S)&&p()})})}spawn(v,u,l){const d={id:w.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,l,u)}terminate(v,u){const l={id:w.SharedProcessWorkerMessages.Terminate,configuration:v};return this.i(l,u)}}}),define(oe[230],ae([0,1,63,24,189]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ye([L.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(oe[231],ae([0,1,50,12,172,23,38,7,4,31,149,187,6,131]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let f;async function v(l,d,p,S){return p["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(S)&&!p["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(S)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=g.Promises.withAsyncBody(async(R,s)=>{const c=new k.CancellationTokenSource;let t=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,m.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{c.dispose(!0),s(new Error((0,D.localize)(0,null)))},t);try{R(await u(d,c.token))}catch(o){!(0,P.isCancellationError)(o)&&!c.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,N.toErrorMessage)(o)))):R({})}finally{clearTimeout(r),c.dispose()}})),f)}e.getResolvedShellEnv=v;async function u(l,d){const p=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",p);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",S);const R=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(R+"({.*})"+R),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",c);const t=await(0,C.getSystemShell)(I.OS,c);return l.trace("getUnixShellEnvironment#shell",t),new Promise((n,r)=>{if(d.isCancellationRequested)return r(new P.CancellationError);const o=(0,i.basename)(t);let a,h;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${b} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${b} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,o==="tcsh"||o==="csh"?h=["-ic"]:h=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const E=(0,L.spawn)(t,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});d.onCancellationRequested(()=>(E.kill(),r(new P.CancellationError))),E.on("error",M=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(M)),r(M)});const T=[];E.stdout.on("data",M=>T.push(M));const O=[];E.stderr.on("data",M=>O.push(M)),E.on("close",(M,F)=>{const A=Buffer.concat(T).toString("utf8");l.trace("getUnixShellEnvironment#raw",A);const $=Buffer.concat(O).toString("utf8");if($.trim()&&l.trace("getUnixShellEnvironment#stderr",$),M||F)return r(new Error((0,D.localize)(2,null,M,F)));const z=s.exec(A),H=z?z[1]:"{}";try{const X=JSON.parse(H);p?X.ELECTRON_RUN_AS_NODE=p:delete X.ELECTRON_RUN_AS_NODE,S?X.ELECTRON_NO_ATTACH_CONSOLE=S:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",X),n(X)}catch(X){l.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(X)),r(X)}})})}}),define(oe[109],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[232],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.b=new Map}c(){return new Promise((D,k)=>Z(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.c(),N=new k.validator;if(N){const P=String(L.a++);return this.b.set(P,N),{id:P,data:N.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const N=this.b.get(D.id);if(!N)return!1;this.b.delete(D.id);try{return N.validate(k)==="ok"}catch{return!1}}async sign(D){try{const k=await this.c(),N=new k.signer;if(N)return N.sign(D)}catch{}return D}}e.SignService=L,L.a=1}),define(oe[76],ae([0,1,3,2]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends i.Disposable{constructor(w,g,m){super(),this.a=w,this.b=g,this.c=m}async getItems(){const w={profile:this.b,workspace:this.c},g=await this.a.call("getItems",w);return new Map(g)}updateItems(w){const g={profile:this.b,workspace:this.c};return w.insert&&(g.insert=Array.from(w.insert.entries())),w.delete&&(g.delete=Array.from(w.delete.values())),this.a.call("updateItems",g)}}class k extends D{constructor(w,g){super(w,g,void 0),this.f=this.B(new L.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(w=>this.h(w)))}h(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this.f.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class N extends k{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=N;class P extends k{constructor(w,g){super(w,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends D{constructor(w,g){super(w,void 0,g),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class y{constructor(w){this.a=w}isUsed(w){const g={payload:w,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.StorageClient=y}),define(oe[110],ae([0,1,4,36,8,31]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(y){if(L.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function P(y,C,w,g,m,f,v,u,l,d){const p=Object.create(null);p["common.machineId"]=v,p.sessionID=(0,k.generateUuid)()+Date.now(),p.commitHash=m,p.version=f,p["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,L.PlatformToString)(L.platform),p["common.nodePlatform"]=i.platform,p["common.nodeArch"]=g,p["common.product"]=d||"desktop",u&&(p["common.msftInternal"]=u);let S=0;const R=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),L.isLinuxSnap&&(p["common.snap"]="true");const s=N(w);s&&(p["common.platformDetail"]=s);try{const c=await y.readFile(D.URI.file(l));p["common.source"]=c.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=P;function I(y){const C=i.env.USERDNSDOMAIN;if(!C)return!1;const w=C.toLowerCase();return y.some(g=>w===g)}e.verifyMicrosoftInternalDomain=I}),define(oe[19],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[233],ae([0,1,34,6,35,24,12,4,8,146,28,148,96,14,25,19]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const u=new Map;async function l(s,c){const t=`${s}::${c.join(":")}`,n=u.get(t);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,h=2e4;function b(T,O,M,F){const A=O.substring(T.length+1);return i.Promises.withAsyncBody(async $=>{let z;try{z=await C.Promises.readdir(O,{withFileTypes:!0})}catch{$();return}if(F.count>=h){F.count+=z.length,F.maxReached=!0,$();return}let H=z.length;if(H===0){$();return}let X=z;F.count+z.length>h&&(F.maxReached=!0,H=h-F.count,X=z.slice(0,H)),F.count+=z.length;for(const ie of X)if(ie.isDirectory()){if(M.includes(ie.name)||await b(T,(0,N.join)(O,ie.name),M,F),--H===0){$();return}}else{const G=ie.name.lastIndexOf(".");if(G>=0){const j=ie.name.substring(G+1);j&&o.set(j,(o.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test(A)!==!1&&j.filePattern.test(ie.name)&&a.set(j.tag,(a.get(j.tag)??0)+1);if(--H===0){$();return}}})}const E=i.Promises.withAsyncBody(async T=>{const O={count:0,maxReached:!1};await b(s,s,c,O);const M=await S(s);T({configFiles:d(a),fileTypes:d(o),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:M})});return u.set(t,E),E}e.collectWorkspaceStats=l;function d(s){return Array.from(s.entries(),([c,t])=>({name:c,count:t})).sort((c,t)=>t.count-c.count)}function p(){const s={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},c=L.cpus();return c&&c.length>0&&(s.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),s}e.getMachineInfo=p;async function S(s){try{const c=new Map,t=(0,N.join)(s,".vscode","launch.json"),n=await C.Promises.readFile(t),r=[],o=(0,D.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(o)==="object"&&o.configurations)for(const a of o.configurations){const h=a.type;h&&(c.has(h)?c.set(h,c.get(h)+1):c.set(h,1))}return d(c)}catch{return[]}}e.collectLaunchConfigs=S;let R=class{constructor(c,t){this.c=c,this.d=t}f(c){const t=[];return t.push(`OS Version:       ${c.os}`),t.push(`CPUs:             ${c.cpus}`),t.push(`Memory (System):  ${c.memory}`),t.push(`VM:               ${c.vmHint}`),t.join(`
`)}g(c){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const n=L.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(L.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${L.loadavg().map(r=>Math.round(r)).join(", ")}`),t.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${c.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(c,t){return Promise.all([(0,w.listProcesses)(c.mainPID),this.k(c)]).then(async n=>{let[r,o]=n,a=this.m(c,r);return t.forEach(h=>{if((0,g.isRemoteDiagnosticError)(h))a+=`
${h.errorMessage}`,o+=`
${h.errorMessage}`;else if(a+=`

Remote: ${h.hostName}`,h.processes&&(a+=`
${this.m(c,h.processes)}`),h.workspaceMetadata){o+=`
|  Remote: ${h.hostName}`;for(const b of Object.keys(h.workspaceMetadata)){const E=h.workspaceMetadata[b];let T=`${E.fileCount} files`;E.maxFilesReached&&(T=`more than ${T}`),o+=`|    Folder (${b}): ${T}`,o+=this.h(E)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(c,t){const{memory:n,vmHint:r,os:o,cpus:a}=p(),h={os:o,memory:n,cpus:a,vmHint:r,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(h.load=`${L.loadavg().map(b=>Math.round(b)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(c,t){const n=[];return(0,w.listProcesses)(c.mainPID).then(async r=>(n.push(""),n.push(this.g(c)),n.push(""),n.push(this.m(c,r)),c.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(c))),t.forEach(o=>{if((0,g.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.f(o.machineInfo)),o.processes&&n.push(this.m(c,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const h=o.workspaceMetadata[a];let b=`${h.fileCount} files`;h.maxFilesReached&&(b=`more than ${b}`),n.push(`Folder (${a}): ${b}`),n.push(this.h(h))}}),n.push(""),n.push(""),n.join(`
`)))}h(c){const t=[];let r=0;const o=(E,T)=>{const O=` ${E}(${T})`;r+O.length>60?(t.push(a),a="|                 ",r=a.length):r+=O.length,a+=O};let a="|      File types:";const h=10,b=c.fileTypes.length>h?h:c.fileTypes.length;for(let E=0;E<b;E++){const T=c.fileTypes[E];o(T.name,T.count)}if(t.push(a),c.configFiles.length>=0&&(a="|      Conf files:",r=0,c.configFiles.forEach(E=>{o(E.name,E.count)}),t.push(a)),c.launchConfigFiles.length>0){let E="|      Launch Configs:";c.launchConfigFiles.forEach(T=>{E+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),t.push(E)}return t.join(`
`)}j(c){const t=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${c[n]}`).join(`
                  `)}k(c){const t=[],n=[];return c.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(t.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const a=I.URI.revive(o);if(a.scheme===k.Schemas.file){const h=a.fsPath;n.push(l(h,["node_modules",".git"]).then(b=>{let E=`${b.fileCount} files`;b.maxFilesReached&&(E=`more than ${E}`),t.push(`|    Folder (${(0,N.basename)(h)}): ${E}`),t.push(this.h(b))}).catch(b=>{t.push(`|      Error: Unable to collect workspace stats for folder ${h} (${b.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>t.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(c,t){const n=new Map;c.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),t&&this.n(c.mainPID,n,r,t,0),r.join(`
`)}n(c,t,n,r,o){const a=o===0;let h;a?h=r.pid===c?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(h=`${h} (${t.get(r.pid)})`));const b=process.platform==="win32"?r.mem:L.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(b/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(r.children)&&r.children.forEach(E=>this.n(c,t,n,E,o+1))}async getWorkspaceFileExtensions(c){const t=new Set;for(const{uri:n}of c.folders){const r=I.URI.revive(n);if(r.scheme!==k.Schemas.file)continue;const o=r.fsPath;try{(await l(o,["node_modules",".git"])).fileTypes.forEach(h=>t.add(h.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(c){for(const{uri:t}of c.folders){const n=I.URI.revive(t);if(n.scheme!==k.Schemas.file)continue;const r=n.fsPath;try{const o=await l(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};R=ye([K(0,v.ITelemetryService),K(1,f.IProductService)],R),e.DiagnosticsService=R}),define(oe[234],ae([0,1,107,3,19,15,2,9,12,50,25,4,6,103,16,170,34,8]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let d=class extends N.Disposable{constructor(S,R,s,c,t,n){super(),this.p=S,this.r=R,this.s=s,this.t=n,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=L.TunnelStates.disconnected;const r=l.URI.file((0,I.join)(s.logsPath,L.LOG_FILE_NAME));this.g=this.B(c.createLogger(r,{name:L.LOGGER_NAME})),this.k=new g.Delayer(100),this.B(this.g.onDidChangeLogLevel(o=>this.g.info("Log level changed to "+(0,P.LogLevelToString)(o)))),this.B(t.onWillShutdown(o=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(n.onDidChangeConfiguration(o=>{o.affectsConfiguration(L.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(S){if(S&&this.h?S.token!==this.h.token||S.providerId!==this.h.providerId:S!==this.h){this.h=S,this.f.fire(S),S?this.g.info(`Account updated: ${S.accountLabel} (${S.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!S});try{await this.k.trigger(()=>this.v())}catch(R){this.g.error(R)}}return this.j}u(){if(!this.n){let S;w.isMacintosh?S=this.s.appRoot:S=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.n=(0,I.join)(S,"bin",`${this.r.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(L.TunnelStates.disconnected);return}const{token:S,providerId:R,accountLabel:s}=this.h;this.w(L.TunnelStates.connecting((0,v.localize)(0,null,s,R)));const c=(a,h)=>{a=a.replaceAll(S,"*".repeat(4)),h?this.g.error(a):this.g.info(a),!this.s.isBuilt&&a.startsWith("   Compiling")&&this.w(L.TunnelStates.connecting((0,v.localize)(1,null)))},t=this.y("login",["user","login","--provider",R,"--access-token",S,"--log",(0,P.LogLevelToString)(this.g.getLevel())],c);this.i=t;try{if(await t,this.i!==t)return}catch(a){this.g.error(a),this.i=void 0,this.b.fire(!0),this.w(L.TunnelStates.disconnected);return}const n=this.z();n?this.w(L.TunnelStates.connecting((0,v.localize)(2,null,n))):this.w(L.TunnelStates.connecting((0,v.localize)(3,null)));const r=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.g.getLevel())];n?r.push("--name",n):r.push("--random-name");const o=this.y("tunnel",r,(a,h)=>{h?this.g.error(a):this.g.info(a);const b=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const E={link:b[1],domain:b[2],hostName:b[4]};this.w(L.TunnelStates.connected(E))}else a.match(/error refreshing token/)&&(o.cancel(),this.b.fire(!0),this.w(L.TunnelStates.disconnected))});this.i=o,o.finally(()=>{o===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(S){this.j=S,this.c.fire(S)}y(S,R,s=()=>{}){return(0,g.createCancelablePromise)(c=>new Promise((t,n)=>{c.isCancellationRequested&&t();let r;if(c.onCancellationRequested(()=>{r&&(this.g.info(`${S} terminating(${r.pid})`),r.kill())}),!this.s.isBuilt)s("Building tunnel CLI from sources and run",!1),s(`${S} Spawning: cargo run -- tunnel ${R.join(" ")}`,!1),r=(0,y.spawn)("cargo",["run","--","tunnel",...R],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{s("Running tunnel CLI",!1);const o=this.u();s(`${S} Spawning: ${o} tunnel ${R.join(" ")}`,!1),r=(0,y.spawn)(o,["tunnel",...R],{cwd:(0,u.homedir)()})}r.stdout.on("data",o=>{if(r){const a=o.toString();s(a,!1)}}),r.stderr.on("data",o=>{if(r){const a=o.toString();s(a,!0)}}),r.on("exit",o=>{r&&(s(`${S} exit(${r.pid}): + ${o} `,!1),r=void 0,o===0?t():n())}),r.on("error",o=>{r&&(s(`${S} error(${r.pid}): + ${o} `,!0),r=void 0,n())})}))}async getHostName(){return this.z()}z(){let S=this.t.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,u.hostname)();return S=S.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),S||void 0}};d=ye([K(0,D.ITelemetryService),K(1,C.IProductService),K(2,k.INativeEnvironmentService),K(3,P.ILoggerService),K(4,m.ISharedProcessLifecycleService),K(5,f.IConfigurationService)],d),e.RemoteTunnelService=d}),define(oe[111],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(k){this.b=k}listen(k,N){throw new Error(`Event not found: ${N}`)}call(k,N,{eventName:P,data:I}){return this.b.forEach(y=>y.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class i{constructor(k){this.b=k}log(k,N){return this.b.call("log",{eventName:k,data:N}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(oe[47],ae([0,1,32,13,3,16,75,110,19]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class y{constructor(a){this.value=a}}e.TelemetryTrustedValue=y;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,h){return Promise.resolve(void 0)}publicLog2(a,h){return this.publicLog(a,h)}publicLogError(a,h){return Promise.resolve(void 0)}publicLogError2(a,h){return this.publicLogError(a,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class w{async publicLog(a,h,b){}async publicLogError(a,h,b){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(o,a){return D.Event.debounce(a.onDidChangeConfiguration,(b,E)=>{const T=b?new Set([...b.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:T}},1e3,!0)(b=>{b.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(b.source),configurationKeys:S(b.affectedKeys)})})}e.configurationTelemetry=g;function m(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=m;function f(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=f;function v(o){const a=o.getValue(I.TELEMETRY_SETTING_ID),h=o.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function u(o){const a={},h={},b={};p(o,b);for(let E in b){E=E.length>150?E.substr(E.length-149):E;const T=b[E];typeof T=="number"?h[E]=T:typeof T=="boolean"?h[E]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${T.length}`),a[E]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(a[E]=T)}return{properties:a,measurements:h}}e.validateTelemetryData=u;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(o){if(!o)return"none";const a=(0,N.getRemoteName)(o);return l.has(a)?a:"other"}e.cleanRemoteAuthority=d;function p(o,a,h=0,b){if(!!o)for(const E of Object.getOwnPropertyNames(o)){const T=o[E],O=b?b+E:E;Array.isArray(T)?a[O]=(0,L.safeStringify)(T):T instanceof Date?a[O]=T.toISOString():(0,i.isObject)(T)?h<2?p(T,a,h+1,O+"."):a[O]=(0,L.safeStringify)(T):a[O]=T}}function S(o){if(!o)return[];const a=[];return R(a,"",o),a}function R(o,a,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(b=>R(o,a?`${a}.${b}`:b,h[b])):o.push(a)}function s(o,a){const h=o.msftInternalDomains||[],b=a.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(h)||b}e.isInternalTelemetry=s;function c(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=c;function t(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let h=o;const b=[];for(const M of a)for(;;){const F=M.exec(o);if(!F)break;b.push([F.index,M.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let O=0;for(h="";;){const M=T.exec(o);if(!M)break;const F=b.some(([A,$])=>M.index<$&&A<T.lastIndex);!E.test(M[0])&&!F&&(h+=o.substring(O,M.index)+"<REDACTED: user-file-path>",O=T.lastIndex)}return O<o.length&&(h+=o.substr(O)),h}function n(o){if(!o)return o;const a=o.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of h)if(b.regex.test(a))return`<REDACTED: ${b.label}>`;return o}function r(o,a){return(0,L.cloneAndChange)(o,h=>{if(h instanceof y)return h.value;if(typeof h=="string"){let b=h.replaceAll("%20"," ");b=t(b,a);for(const E of a)b=b.replace(E,"");return b=n(b),b}})}e.cleanData=r}),define(oe[33],ae([0,1,27,30,42,4,8,7,36,47]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,L.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=C;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,r,o)}static parse(n){const r=w.exec(n);return r&&r[1]&&r[2]?new g({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?C(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(t){const n=m.exec(t);return n&&n[1]?[u(n[1]),n[2]]:[u(t),void 0]}e.getIdAndVersion=f;function v(t,n){return`${t}.${n}`}e.getExtensionId=v;function u(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function l(t,n){return u(v(t,n))}e.getGalleryExtensionId=l;function d(t,n){const r=[],o=a=>{for(const h of r)if(h.some(b=>C(n(b),n(a))))return h;return null};for(const a of t){const h=o(a);h?h.push(a):r.push([a])}return r}e.groupByExtension=d;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function S(t){return{id:new y.TelemetryTrustedValue(t.identifier.id),name:new y.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function R(t,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&r.every(h=>!C(h.identifier,{id:a}))){const h=t.filter(b=>C(b.identifier,{id:a}));h.length===1&&(r.push(h[0]),o.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=R;async function s(t,n){if(!k.isLinux)return!1;let r;try{r=(await t.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function c(t,n){const r=await s(t,n),o=(0,i.getTargetPlatform)(r?"alpine":k.platform,I.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=c}),define(oe[235],ae([0,1,23,33]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(k,N,P,I,y){try{const C=await k.getExtensionsControlManifest();if(!C.deprecated)return;const w=await k.getInstalled(1);for(const[g,m]of Object.entries(C.deprecated)){if(!m?.extension)continue;const{id:f,autoMigrate:v,preRelease:u}=m.extension;if(!v)continue;const l=w.find(p=>(0,i.areSameExtensions)(p.identifier,{id:g}));if(!l)continue;const d=(await N.getExtensions([{id:f,preRelease:u}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!d){y.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{y.info(`Migrating '${l.identifier.id}' extension to '${f}' extension...`);const p=!I.getDisabledExtensions().some(R=>(0,i.areSameExtensions)(R,l.identifier));await k.uninstall(l),y.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let S=w.find(R=>(0,i.areSameExtensions)(R.identifier,{id:f}));(!S||!S.isPreReleaseVersion&&p)&&(S=await k.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),y.info(`Installed the pre-release extension '${S.identifier.id}'`),p||(await I.disableExtension(S.identifier),y.info(`Disabled the pre-release extension '${S.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),v.storage&&(P.addToMigrationList((0,i.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,i.getExtensionId)(S.manifest.publisher,S.manifest.name)),y.info("Added pre-release extension to the storage migration list"))),y.info(`Migrated '${l.identifier.id}' extension to '${f}' extension.`)}catch(p){y.error(p)}}}catch(C){y.error(C)}}e.migrateUnsupportedExtensions=D}),define(oe[236],ae([0,1,6,7,2,24,4,22,54,13,31,28,16,15,30,33,98,14,9,25]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let S=class wt extends D.Disposable{constructor(s,c,t,n,r,o,a){super(),this.h=c,this.i=t,this.j=n,this.k=r,this.l=o,this.m=a,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(s,c){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.w(s));try{await this.t(s,t,r=>this.i.download(s,r,c))}catch(r){throw new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(s)){const r=await this.r(s);try{await this.l.verify(t.fsPath,r.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${s.identifier.id}. Verification status: ${n}.`)}catch(o){const a=o.code;if(a==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${s.identifier.id}. Verification status: ${n}.`);else throw await this.delete(r),await this.delete(t),new f.ExtensionManagementError(a,f.ExtensionManagementErrorCode.Signature)}}return{location:t,verificationStatus:n}}async n(s){if(!s.isSigned)return!1;const c=this.j.getValue("extensions.verifySignature");return(0,y.isBoolean)(c)?c:this.k.quality!=="stable"}async r(s){await this.g;const c=(0,P.joinPath)(this.extensionsDownloadDir,`${this.w(s)}${wt.c}`);return await this.t(s,c,t=>this.i.downloadSignatureArchive(s,t)),c}async t(s,c,t){if(await this.h.exists(c))return;if(c.scheme!==k.Schemas.file){await t(c);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.h.exists(n)||await t(n);try{await this.u(n,c,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,c.path);else throw this.m.info(`Rename failed because of ${(0,i.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(s){await this.g,await this.h.del(s)}async u(s,c,t){try{await w.Promises.rename(s.fsPath,c.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<t)return this.m.info(`Failed renaming ${s} to ${c} with 'EPERM' error. Trying again...`),this.u(s,c,t);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const c=[],t=[],n=[];for(const a of s.children)if(a.name.endsWith(wt.c))n.push(a.resource);else{const h=v.ExtensionKey.parse(a.name);h&&t.push([h,a])}const r=(0,v.groupByExtension)(t,([a])=>a),o=[];for(const a of r)a.sort((h,b)=>I.rcompare(h[0].version,b[0].version)),c.push(...a.slice(1).map(h=>h[1].resource)),o.push(a[0][1]);o.sort((a,h)=>a.mtime-h.mtime),c.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),c.push(...n),await L.Promises.settled(c.map(a=>(this.m.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(s){this.m.error(s)}}w(s){return this.f?v.ExtensionKey.create(s).toString().toLowerCase():(0,C.generateUuid)()}};S.c=".sigzip",S=ye([K(0,m.INativeEnvironmentService),K(1,l.IFileService),K(2,f.IExtensionGalleryService),K(3,g.IConfigurationService),K(4,p.IProductService),K(5,u.IExtensionSignatureVerificationService),K(6,d.ILogService)],S),e.ExtensionsDownloader=S}),define(oe[237],ae([0,1,3,2,37,33,42]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends i.Disposable{constructor(y,C,w,g,m,f,v){super(),this.f=y,this.g=C,this.h=w,this.i=g,this.j=m,this.k=f,this.l=v,this.a=this.B(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,u=>v.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(y=>this.p(y.added,y.removed))),this.B(this.i.onAddExtensions(y=>this.r(y))),this.B(this.i.onDidAddExtensions(y=>this.s(y))),this.B(this.i.onRemoveExtensions(y=>this.t(y))),this.B(this.i.onDidRemoveExtensions(y=>this.u(y))),this.B(this.k.onDidFilesChange(y=>this.v(y)))}async p(y,C){try{await Promise.all(C.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),y.length&&await Promise.all(y.map(w=>(this.c.set(w.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(y){for(const C of y.extensions)this.D(this.G(C.identifier,C.version),y.profileLocation)}async s(y){for(const C of y.extensions){const w=this.G(C.identifier,C.version);y.error?this.F(w,y.profileLocation):this.D(w,y.profileLocation)}}async t(y){for(const C of y.extensions)this.F(this.G(C.identifier,C.version),y.profileLocation)}async u(y){let C=!1;for(const w of y.extensions){const g=this.G(w.identifier,w.version);y.error?this.D(g,y.profileLocation):(this.F(g,y.profileLocation),C=C||!this.b.has(g))}C&&await this.C()}v(y){for(const C of this.h.profiles)y.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(y){const C=[],w=[],g=await this.i.scanProfileExtensions(y),m=new Set,f=new Set;for(const[v,u]of this.b)u.has(y)&&f.add(v);for(const v of g){const u=this.G(v.identifier,v.version);m.add(u),f.has(u)||(C.push(v.identifier),this.D(u,y))}for(const v of f)if(!m.has(v)){const u=this.H(v);u&&(w.push(u.identifier),this.F(v,y))}(C.length||w.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:y}:void 0,removed:w.length?{extensions:w,profileLocation:y}:void 0})}async y(y){const C=await this.i.scanProfileExtensions(y);for(const w of C)this.D(this.G(w.identifier,w.version),y)}async z(y){for(const C of[...this.b.keys()])this.F(C,y);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(w=>w.installedTimestamp&&!this.b.has(this.G(w.identifier,w.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(y,C){let w=this.b.get(y);w||this.b.set(y,w=new D.ResourceSet(g=>this.j.extUri.getComparisonKey(g))),w.add(C)}F(y,C){const w=this.b.get(y);w&&w.delete(C),w?.size||this.b.delete(y)}G(y,C){return`${N.ExtensionIdentifier.toKey(y.id)}@${C}`}H(y){const[C,w]=(0,k.getIdAndVersion)(y);return w?{identifier:{id:C},version:w}:void 0}}e.ExtensionsWatcher=P}),define(oe[238],ae([0,1,45,47]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(k,N,P,I,y,C,w){const g={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${N.nameShort})`};if((0,i.supportsTelemetry)(N,P)&&(0,i.getTelemetryLevel)(I)===3){const m=await(0,L.getServiceMachineId)(P,y,C),{machineId:f}=await w.getTelemetryInfo();g["X-Market-User-Id"]=m,g["VSCode-SessionId"]=f||m}return g}e.resolveMarketplaceHeaders=D}),define(oe[239],ae([0,1,100,21,6,2,24,12,28,15,30,33,9,73,4,8]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends m.LanguagePackBaseService{constructor(S,R,s,c){super(s),this.h=S,this.i=c,this.g=this.B(new l(R,c)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(S){const s=(await this.g.getLanguagePacks())[f.Language.value()];if(!s){this.i.warn(`No language pack found for ${f.Language.value()}`);return}const c=s.translations[S];return c?v.URI.file(c):void 0}async getInstalledLanguages(){const S=await this.g.getLanguagePacks(),R=Object.keys(S).map(s=>{const c=S[s];return{...this.f(s,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return R.push({...this.f("en","English"),extensionId:"default"}),R.sort((s,c)=>s.label.localeCompare(c.label)),R}async j(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",S.identifier.id),await this.update())}async k(S){const R=await this.g.getLanguagePacks();Object.keys(R).some(s=>R[s]&&R[s].extensions.some(c=>(0,w.areSameExtensions)(c.extensionIdentifier,S.identifier)))&&(this.i.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,R]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),s=await this.g.update(R);return!(0,i.equals)(Object.keys(S),Object.keys(s))}};u=ye([K(0,C.IExtensionManagementService),K(1,y.INativeEnvironmentService),K(2,C.IExtensionGalleryService),K(3,g.ILogService)],u),e.NativeLanguagePackService=u;let l=class extends k.Disposable{constructor(S,R){super(),this.i=R,this.c={},this.f=(0,P.join)(S.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(S){return this.m(R=>{Object.keys(R).forEach(s=>delete R[s]),this.j(R,...S)}).then(()=>this.c)}j(S,...R){for(const s of R)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.k(S,s);Object.keys(S).forEach(s=>this.l(S[s]))}k(S,R){const s=R.identifier,c=R.manifest.contributes&&R.manifest.contributes.localizations?R.manifest.contributes.localizations:[];for(const t of c)if(R.location.scheme===N.Schemas.file&&d(t)){let n=S[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},S[t.languageId]=n);const r=n.extensions.filter(o=>(0,w.areSameExtensions)(o.extensionIdentifier,s))[0];r?r.version=R.manifest.version:n.extensions.push({extensionIdentifier:s,version:R.manifest.version});for(const o of t.translations)n.translations[o.id]=(0,P.join)(R.location.fsPath,o.path)}}l(S){if(S){const R=(0,L.createHash)("md5");for(const s of S.extensions)R.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);S.hash=R.digest("hex")}}m(S=()=>null){return this.g.queue(()=>{let R=null;return I.Promises.readFile(this.f,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch{return{}}}).then(s=>(R=S(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.c=s,this.h=!0;const c=JSON.stringify(this.c);return this.i.debug("Writing language packs",c),I.Promises.writeFile(this.f,c)}).then(()=>R,s=>this.i.error(s))})}};l=ye([K(0,y.INativeEnvironmentService),K(1,g.ILogService)],l);function d(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const S of p.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(oe[240],ae([0,1,7,32,47]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function P(y,C,w){const g=await new Promise((l,d)=>{Z(["@microsoft/1ds-core-js"],l,d)}),m=await new Promise((l,d)=>{Z(["@microsoft/1ds-post-js"],l,d)}),f=new g.AppInsightsCore,v=new m.PostChannel,u={instrumentationKey:y,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(w){u.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:w};u.extensionConfig[v.identifier]=l}return f.initialize(u,[]),f.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),f}class I{constructor(C,w,g,m,f){this.e=C,this.f=w,this.g=g,this.h=f,this.c=k,this.d=N,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{C(w)},w=>{(0,L.onUnexpectedError)(w),console.error(w)})}}log(C,w){if(!this.a)return;w=(0,i.mixin)(w,this.g),w=(0,D.validateTelemetryData)(w);const g=this.f+"/"+C;try{this.i(m=>{m.pluginVersionString=w?.properties.version??"Unknown",m.track({name:g,baseData:{name:g,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[112],ae([0,1,2,15,9,47]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let N=class extends L.Disposable{constructor(I,y,C=""){super(),this.b=C;const w=I.getLogger(y.telemetryLogResource);w?this.a=this.B(w):(this.a=this.B(I.createLogger(y.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,y){this.a.trace(`${this.b}telemetry/${I}`,(0,k.validateTelemetryData)(y))}};N=ye([K(0,D.ILoggerService),K(1,i.IEnvironmentService)],N),e.TelemetryLogAppender=N}),define(oe[113],ae([0,1,2,32,4,27,173,16,46,105,25,40,19,47]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(l,d,p){this.k=d,this.l=p,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,k.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(g.TELEMETRY_SETTING_ID)||S.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,m.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;l=Math.min(l,p)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,d=l.sessionID,p=l["common.machineId"],S=l["common.firstSessionDate"],R=l["common.msftInternal"];return{sessionId:d,machineId:p,firstSessionDate:S,msftInternal:R}}dispose(){this.i.dispose()}n(l,d,p){return this.g<d?Promise.resolve(void 0):this.c.then(S=>{p=(0,i.mixin)(p,this.d),p=(0,m.cleanData)(p,this.j),p=(0,i.mixin)(p,S),this.b.forEach(R=>R.log(l,p))},S=>{console.error(S)})}publicLog(l,d){return this.n(l,3,d)}publicLog2(l,d){return this.publicLog(l,d)}publicLogError(l,d){return this.h?this.n(l,2,d):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=ye([K(1,P.IConfigurationService),K(2,C.IProductService)],f),e.TelemetryService=f;function v(){const u=(0,N.localize)(0,null,y.default.nameLong),l=y.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.isWeb?"":(0,N.localize)(3,null),p=(0,N.localize)(4,null),S=(0,N.localize)(5,null),R=(0,N.localize)(6,null),s=(0,N.localize)(7,null),c=`
|       | ${p} | ${S} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${u} ${l} ${d}

&nbsp;

${s}
${c}

&nbsp;

${t}
`}w.Registry.as(I.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(I.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,N.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,N.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[241],ae([0,1,293,240]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends i.AbstractOneDataSystemAppender{constructor(N,P,I,y){const C={sendPOST:(w,g)=>{const m={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const f=L.request(w.urlString,m,v=>{v.on("data",function(u){g(v.statusCode??200,v.headers,u.toString())}),v.on("error",function(u){g(0,{})})});f.write(w.data),f.end()}catch{g(0,{})}}};super(N,P,I,y,C)}}e.OneDataSystemAppender=D}),define(oe[242],ae([0,1,24,68,16,15,9,25,19,111,112,113]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(f,v,u,l,d){this.b=f,this.c=v,this.d=u,this.e=l,this.f=d,this.a=new Map}async g(f){if(!this.a.has(f.id)){const{machineId:v,sessionId:u}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=v,l["common.vscodesessionid"]=u;const d=[f.id,JSON.stringify(l),f.aiKey],S=new i.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),R=[new y.TelemetryAppenderClient(S),new C.TelemetryLogAppender(this.d,this.e,`[${f.id}] `)];this.a.set(f.id,new w.TelemetryService({appenders:R,sendErrorTelemetry:f.sendErrorTelemetry},this.b,this.f))}return this.a.get(f.id)}async publicLog(f,v,u){await(await this.g(f)).publicLog(v,u)}async publicLogError(f,v,u){await(await this.g(f)).publicLogError(v,u)}};g=ye([K(0,D.IConfigurationService),K(1,I.ITelemetryService),K(2,N.ILoggerService),K(3,k.IEnvironmentService),K(4,P.IProductService)],g),e.CustomEndpointTelemetryService=g}),define(oe[114],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(i){i[i.Replace=1]="Replace",i[i.Append=2]="Append",i[i.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(oe[243],ae([0,1,4,114]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(I){this.collections=I,this.map=new Map,I.forEach((y,C)=>{const w=y.map.entries();let g=w.next();for(;!g.done;){const m=g.value[0];let f=this.map.get(m);if(f||(f=[],this.map.set(m,f)),f.length>0&&f[0].type===i.EnvironmentVariableMutatorType.Replace){g=w.next();continue}const v=g.value[1];f.unshift({extensionIdentifier:C,value:v.value,type:v.type}),g=w.next()}})}async applyToProcessEnvironment(I,y){let C;L.isWindows&&(C={},Object.keys(I).forEach(w=>C[w.toLowerCase()]=w));for(const[w,g]of this.map){const m=L.isWindows&&C[w.toLowerCase()]||w;for(const f of g){const v=y?await y(f.value):f.value;switch(f.type){case i.EnvironmentVariableMutatorType.Append:I[m]=(I[m]||"")+v;break;case i.EnvironmentVariableMutatorType.Prepend:I[m]=v+(I[m]||"");break;case i.EnvironmentVariableMutatorType.Replace:I[m]=v;break}}}}diff(I){const y=new Map,C=new Map,w=new Map;if(I.map.forEach((g,m)=>{const f=this.map.get(m),v=k(g,f);v&&y.set(m,v)}),this.map.forEach((g,m)=>{const f=I.map.get(m),v=k(g,f);v&&w.set(m,v)}),this.map.forEach((g,m)=>{const f=I.map.get(m),v=N(g,f);v&&C.set(m,v)}),!(y.size===0&&C.size===0&&w.size===0))return{added:y,changed:C,removed:w}}}e.MergedEnvironmentVariableCollection=D;function k(P,I){if(!I)return P;const y=new Set;I.forEach(w=>y.add(w.extensionIdentifier));const C=[];return P.forEach(w=>{y.has(w.extensionIdentifier)||C.push(w)}),C.length===0?void 0:C}function N(P,I){if(!I)return;const y=new Map;I.forEach(w=>y.set(w.extensionIdentifier,w));const C=[];return P.forEach(w=>{const g=y.get(w.extensionIdentifier);g&&(w.type!==g.type||w.value!==g.value)&&C.push(g)}),C.length===0?void 0:C}}),define(oe[244],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(N){return[...N.entries()]}e.serializeEnvironmentVariableCollection=L;function i(N){return new Map(N)}e.deserializeEnvironmentVariableCollection=i;function D(N){return Array.from(N.entries()).map(P=>[P[0],L(P[1].map)])}e.serializeEnvironmentVariableCollections=D;function k(N){return new Map(N.map(P=>[P[0],{map:i(P[1])}]))}e.deserializeEnvironmentVariableCollections=k}),define(oe[245],ae([0,1,6,23,3,2,9]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(y,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=y===void 0?15e3:y}createRequest(y){return new Promise((C,w)=>{const g=++this.a;this.c.set(g,C),this.g.fire({requestId:g,...y});const m=new i.CancellationTokenSource;(0,L.timeout)(this.b,m.token).then(()=>w(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,k.toDisposable)(()=>m.cancel())])})}acceptReply(y,C){const w=this.c.get(y);w?(this.c.delete(y),(0,k.dispose)(this.f.get(y)||[]),this.f.delete(y),w(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};P=ye([K(1,N.ILogService)],P),e.RequestStore=P}),define(oe[115],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(p){p.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var N;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(N=e.PosixShellType||(e.PosixShellType={}));var P;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var y;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Log="log",p.Heartbeat="heartbeat"})(y=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var C;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var g;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(g=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(p){p.TerminalView="view",p.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}));var l;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[246],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(oe[247],ae([0,1,34,24,32,12,4,36,27,13,28,114,244,243]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function f(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let r=0;return n&&n.length===4&&(r=parseInt(n[3])),r}e.getWindowsBuildNumber=f;async function v(n,r,o,a=P.env,h=C.Promises.exists){if(k.isAbsolute(n))return await h(n)?n:void 0;if(r===void 0&&(r=P.cwd()),k.dirname(n)!=="."){const O=k.join(r,n);return await h(O)?O:void 0}const E=(0,D.getCaseInsensitive)(a,"PATH");if(o===void 0&&(0,y.isString)(E)&&(o=E.split(k.delimiter)),o===void 0||o.length===0){const O=k.join(r,n);return await h(O)?O:void 0}for(const O of o){let M;if(k.isAbsolute(O)?M=k.join(O,n):M=k.join(r,O,n),await h(M))return M;if(N.isWindows){let F=M+".com";if(await h(F)||(F=M+".exe",await h(F)))return F}}const T=k.join(r,n);return await h(T)?T:void 0}e.findExecutable=v;function u(n,r,o,a,h){if(!r.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||N.isWindows&&!r.windowsEnableConpty)return;const b=n.args,E=P.platform==="win32"?k.basename(n.executable).toLowerCase():k.basename(n.executable),T=k.dirname(i.FileAccess.asFileUri("").fsPath);let O;const M={VSCODE_INJECTION:"1"};if(N.isWindows){if(E==="pwsh.exe"||E==="powershell.exe")return!b||c(b)?O=p.get(d.WindowsPwsh):s(b)&&(O=p.get(d.WindowsPwshLogin)),O?(O=[...O],O[O.length-1]=(0,I.format)(O[O.length-1],T,""),{newArgs:O,envMixin:M}):void 0;a.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(E){case"bash":return!b||b.length===0?O=p.get(d.Bash):t(b)&&(M.VSCODE_SHELL_LOGIN="1",l(r,M),O=p.get(d.Bash)),O?(O=[...O],O[O.length-1]=(0,I.format)(O[O.length-1],T),{newArgs:O,envMixin:M}):void 0;case"fish":{const F=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",A=k.join(T,"out/vs/workbench/contrib/xdg_data");return M.XDG_DATA_DIRS=`${F}:${A}`,l(r,M),{newArgs:void 0,envMixin:M}}case"pwsh":return!b||c(b)?O=p.get(d.Pwsh):s(b)&&(O=p.get(d.PwshLogin)),O?(O=[...O],O[O.length-1]=(0,I.format)(O[O.length-1],T,""),{newArgs:O,envMixin:M}):void 0;case"zsh":{if(!b||b.length===0?O=p.get(d.Zsh):t(b)?(O=p.get(d.ZshLogin),l(r,M)):(b===p.get(d.Zsh)||b===p.get(d.ZshLogin))&&(O=b),!O)return;O=[...O],O[O.length-1]=(0,I.format)(O[O.length-1],T);let F;try{F=L.userInfo().username}catch{F="unknown"}const A=k.join(L.tmpdir(),`${F}-${h.applicationName}-zsh`);M.ZDOTDIR=A;const $=o?.ZDOTDIR??L.homedir()??"~";M.USER_ZDOTDIR=$;const z=[];return z.push({source:k.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(A,".zshrc")}),z.push({source:k.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(A,".zprofile")}),z.push({source:k.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(A,".zshenv")}),z.push({source:k.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(A,".zlogin")}),{newArgs:O,envMixin:M,filesToCopy:z}}}a.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=u;function l(n,r){if(N.isMacintosh&&n.environmentVariableCollections){const o=(0,g.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),h=new m.MergedEnvironmentVariableCollection(o).map.get("PATH"),b=[];if(h)for(const E of h)E.type===w.EnvironmentVariableMutatorType.Prepend&&b.push(E.value);b.length>0&&(r.VSCODE_PATH_PREFIX=b.join(""))}}var d;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(d||(d={}));const p=new Map;p.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(d.Zsh,["-i"]),p.set(d.ZshLogin,["-il"]),p.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],R=["-nol","-nologo"];function s(n){return typeof n=="string"?S.includes(n.toLowerCase()):n.length===1&&S.includes(n[0].toLowerCase())||n.length===2&&(S.includes(n[0].toLowerCase())||S.includes(n[1].toLowerCase()))&&(R.includes(n[0].toLowerCase())||R.includes(n[1].toLowerCase()))}function c(n){return typeof n=="string"?R.includes(n.toLowerCase()):n.length===0||n?.length===1&&R.includes(n[0].toLowerCase())}function t(n){return n==="string"&&S.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&S.includes(n[0].toLowerCase())}}),define(oe[248],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var L;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(L=e.ColorScheme||(e.ColorScheme={}));function i(k){return k===L.HIGH_CONTRAST_DARK||k===L.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function D(k){return k===L.DARK||k===L.HIGH_CONTRAST_DARK}e.isDark=D}),define(oe[116],ae([0,1,52,3,2,5,40,248]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var I;(function(u){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"}u.isThemeColor=l})(I=e.ThemeColor||(e.ThemeColor={}));function y(u){return{id:u}}e.themeColorFromId=y;var C;(function(u){function l(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||I.isThemeColor(n.color))}u.isThemeIcon=l;const d=new RegExp(`^\\$\\((${L.CSSIcon.iconNameExpression}(?:${L.CSSIcon.iconModifierExpression})?)\\)$`);function p(n){const r=d.exec(n);if(!r)return;const[,o]=r;return{id:o}}u.fromString=p;function S(n){return{id:n}}u.fromId=S;function R(n,r){let o=n.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),r&&(o=`${o}~${r}`),{id:o}}u.modify=R;function s(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}u.getModifier=s;function c(n,r){return n.id===r.id&&n.color?.id===r.color?.id}u.isEqual=c;function t(n,r){return{id:n.id,color:r?y(r):void 0}}u.asThemeIcon=t,u.asClassNameArray=L.CSSIcon.asClassNameArray,u.asClassName=L.CSSIcon.asClassName,u.asCSSSelector=L.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=L.Codicon.file,e.FolderThemeIcon=L.Codicon.folder;function w(u){switch(u){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const d=this.a.indexOf(l);this.a.splice(d,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const m=new g;N.Registry.add(e.Extensions.ThemingContribution,m);function f(u){return m.onColorThemeChange(u)}e.registerThemingParticipant=f;class v extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(d=>this.n(d)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,d){let p=this.h.getColor(l);return p&&d&&(p=d(p,this.h)),p?p.toString():null}}e.Themable=v}),define(oe[249],ae([0,1,52,8,175,116]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function N(g,m){const f=[{name:null,description:(0,D.localize)(0,null)}];return f.push(...g.map(v=>({name:v.profileName,description:P(v)}))),m&&f.push(...m.map(v=>({name:v.title,description:I(v)}))),{values:f.map(v=>v.name),markdownDescriptions:f.map(v=>v.description)}}e.createProfileSchemaEnums=N;function P(g){let m=`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:L.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?m+=`
- args: "${g.args}"`:m+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(m+=`
- overrideName: ${g.overrideName}`),g.color&&(m+=`
- color: ${g.color}`),g.env&&(m+=`
- env: ${JSON.stringify(g.env)}`),m}function I(g){return`$(${k.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:L.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function y(g,m){if(!g&&!m)return!0;if(typeof g=="string"&&typeof m=="string")return g===m;if(Array.isArray(g)&&Array.isArray(m)){if(g.length!==m.length)return!1;for(let f=0;f<g.length;f++)if(g[f]!==m[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function C(g,m){if(!g&&!m)return!0;if(!g||!m)return!1;if(k.ThemeIcon.isThemeIcon(g)&&k.ThemeIcon.isThemeIcon(m))return g.id===m.id&&g.color===m.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof m=="object"&&"light"in m&&"dark"in m){const f=g,v=m;if((i.URI.isUri(f.light)||w(f.light))&&(i.URI.isUri(f.dark)||w(f.dark))&&(i.URI.isUri(v.light)||w(v.light))&&(i.URI.isUri(v.dark)||w(v.dark)))return f.light.path===v.light.path&&f.dark.path===v.dark.path}if(i.URI.isUri(g)&&i.URI.isUri(m)||w(g)||w(m)){const f=g,v=m;return f.path===v.path&&f.scheme===v.scheme}return!1}e.terminalIconsEqual=C;function w(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}e.isUriComponents=w}),define(oe[250],ae([0,1,52,174,46,40,249]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(L.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(L.Codicon.getAll(),S=>`$(${S.id})`)};const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},y={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),u={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(u),p()}e.registerTerminalPlatformConfiguration=l;let d;function p(S,R){const s=k.Registry.as(D.Extensions.Configuration);let c;S&&(c=(0,N.createProfileSchemaEnums)(S?.profiles,R));const t=d;d={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?c?.values:void 0,markdownEnumDescriptions:S?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?c?.values:void 0,markdownEnumDescriptions:S?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?c?.values:void 0,markdownEnumDescriptions:S?.os===1?c?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[d],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(oe[251],ae([0,1,50,52,12,4,13,28,91,247,116]),function(Z,e,L,i,D,k,N,P,I,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let w,g=!0;function m(t,n,r,o,a=process.env,h,b,E,T){return h=h||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},k.isWindows?f(r,h,a,b,o.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:o.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:o.getValue("terminal.integrated.defaultProfile.windows"),T,E):R(h,b,r,t&&typeof t=="object"?{...t}:o.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:o.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,E,a)}e.detectAvailableProfiles=m;async function f(t,n,r,o,a,h,b,E,T){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let F=!1;(0,y.getWindowsBuildNumber)()>=16299&&(F=!0),await l(E);const A=new Map;if(t){A.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),A.set("Windows PowerShell",{path:`${M}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),A.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),A.set("Command Prompt",{path:`${M}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0}),A.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),A.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:i.Codicon.terminalBash,isAutoDetected:!0});const z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;A.set("Cmder",{path:`${M}\\cmd.exe`,args:["/K",z],requiresPath:process.env.CMDER_ROOT?z:{path:z,isUnsafe:!0},isAutoDetected:!0})}s(h,A);const $=await v(A.entries(),b,n,r,o,T);if(t||a)try{const z=await p(`${M}\\${F?"wsl":"bash"}.exe`,b);for(const H of z)(!h||!(H.profileName in h))&&$.push(H)}catch{g&&(o?.info("WSL is not installed, so could not detect WSL profiles"),g=!1)}return $}async function v(t,n,r,o=process.env,a,h){const b=[];for(const[E,T]of t){if(T===null)continue;let O,M,F;if("source"in T){const H=w?.get(T.source);if(!H)continue;O=H.paths,M=T.args||H.args,T.icon?F=u(T.icon):H.icon&&(F=H.icon)}else O=Array.isArray(T.path)?T.path:[T.path],M=k.isWindows||Array.isArray(T.args)?T.args:void 0,F=u(T.icon);let A;if(h){const H=O.map(ie=>typeof ie=="string"?ie:ie.path),X=await h(H);A=new Array(O.length);for(let ie=0;ie<O.length;ie++)typeof O[ie]=="string"?A[ie]=X[ie]:A[ie]={path:X[ie],isUnsafe:!0}}else A=O.slice();let $;if(T.requiresPath){let H;if((0,N.isString)(T.requiresPath)?H=T.requiresPath:(H=T.requiresPath.path,T.requiresPath.isUnsafe&&($=H)),!await r.existsFile(H))continue}const z=await c(E,n,A,r,o,M,T.env,T.overrideName,T.isAutoDetected,$);z?(z.isAutoDetected=T.isAutoDetected,z.icon=F,z.color=T.color,b.push(z)):a?.debug("Terminal profile not validated",E,O)}return a?.debug("Validated terminal profiles",b),b}function u(t){return typeof t=="string"?{id:t}:t}async function l(t){w&&!t||(w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:t||await d(),icon:C.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function d(){const t=[];for await(const n of(0,I.enumeratePowerShellInstallations)())t.push(n.exePath);return t}async function p(t,n){const r=[],o=await new Promise((b,E)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,O)=>{if(T)return E("Problem occurred when getting wsl distros");b(O)})});if(!o)return[];const a=new RegExp(/[\r?\n]/),h=o.split(a).filter(b=>b.trim().length>0&&b!=="");for(const b of h){if(b===""||b.startsWith("docker-desktop"))continue;const E=`${b} (WSL)`,T={profileName:E,path:t,args:["-d",`${b}`],isDefault:E===n,icon:S(b),isAutoDetected:!1};r.push(T)}return r}function S(t){return t.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):t.includes("Debian")?C.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function R(t,n,r,o,a,h,b,E){const T=new Map;if(r){const O=(await t.readFile("/etc/shells")).toString(),M=h||O.split(`
`).filter(A=>A.trim().includes("#")&&A.trim().length>0),F=new Map;for(const A of M){let $=(0,D.basename)(A),z=F.get($)||0;z++,z>1&&($=`${$} (${z})`),F.set($,z),T.set($,{path:A,isAutoDetected:!0})}}return s(o,T),await v(T.entries(),a,t,E,n,b)}function s(t,n){if(!!t)for(const[r,o]of Object.entries(t))o===null||!("path"in o)&&!("source"in o)?n.delete(r):(o.icon=o.icon||n.get(r)?.icon,n.set(r,o))}async function c(t,n,r,o,a,h,b,E,T,O){if(r.length===0)return Promise.resolve(void 0);const M=r.shift();if(M==="")return c(t,n,r,o,a,h,b,E,T);const F=typeof M!="string"&&M.isUnsafe,A=typeof M=="string"?M:M.path,$={profileName:t,path:A,args:h,env:b,overrideName:E,isAutoDetected:T,isDefault:t===n,isUnsafePath:F,requiresUnsafePath:O};if((0,D.basename)(A)===A){const H=a.PATH?a.PATH.split(D.delimiter):void 0,X=await(0,y.findExecutable)(A,void 0,H,void 0,o.existsFile);return X?($.path=X,$.isFromPath=!0,$):c(t,n,r,o,a,h)}return await o.existsFile((0,D.normalize)(A))?$:c(t,n,r,o,a,h,b,E,T)}}),define(oe[77],ae([0,1,3,16,5,9]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var N;(function(v){v.Http="http",v.Https="https"})(N=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=w;function g(v,u,l,d){if(l===1)return!1;if(l===2&&w(u)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(p?.length===4&&parseInt(p[1])>=18)return!1}return v<1024}e.isPortPrivileged=g;class m{constructor(u,l,d){this.remoteAddress=u,this.localAddress=l,this.b=d,this.a=new L.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=m;let f=class{constructor(u,l){this.i=u,this.j=l,this.a=new L.Emitter,this.onTunnelOpened=this.a.event,this.b=new L.Emitter,this.onTunnelClosed=this.b.event,this.c=new L.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const u=this.j.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.e=u,u?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.f=u.elevation,this.g=u.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const u=[],l=Array.from(this.d.values());for(const d of l){const p=Array.from(d.values());for(const S of p){const R=await S.value;R&&u.push(R)}}return u}async dispose(){for(const u of this.d.values()){for(const{value:l}of u.values())await l.then(d=>d?.dispose());u.clear()}this.d.clear()}setEnvironmentTunnel(u,l,d,p,S){this.o(u,l,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:l,localAddress:d,privacy:p,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,l){(w(u)||C(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const d=this.q(u,l);if(d)return++d.refcount,d.value}openTunnel(u,l,d,p,S,R=!1,s,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${d} on local port ${S}.`),!u)return;if(l||(l="localhost"),p||(p=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(u,l,d,p,S,R,s,c);return t?t.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(n);return(n.tunnelRemoteHost!==l||n.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const l=this.d.get(u.tunnelRemoteHost);if(l){const d=l.get(u.tunnelRemotePort);d&&(d.refcount--,await this.n(u.tunnelRemoteHost,u.tunnelRemotePort,d))}}}}async n(u,l,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${l}.`);const p=d.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(u)&&this.d.get(u).delete(l),p}}async closeTunnel(u,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${l} `);const d=this.d.get(u);if(d&&d.has(l)){const p=d.get(l);p.refcount=0,await this.n(u,l,p)}}o(u,l,d){this.d.has(u)||this.d.set(u,new Map),this.d.get(u).set(l,{refcount:1,value:d})}async p(u,l){const d=this.d.get(u);d&&(await d.get(l)||d.delete(l),d.size===0&&this.d.delete(u))}q(u,l){const d=[u];C(u)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):w(u)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const p=d.map(S=>this.d.get(S));for(const S of p){const R=S?.get(l);if(R)return R}}canTunnel(u){return!!y(u)}s(u,l,d,p,S,R,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${d} on local port ${p}.`);const c=d;this.h.add(c);const t=p===void 0?d:p,n={elevationRequired:S?this.isPortPrivileged(t):!1},r={remoteAddress:{host:l,port:d},localAddressPort:p,privacy:R,public:R?R!==P.Private:void 0,protocol:s},o=u.forwardPort(r,n);return o?(this.o(l,d,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),o}};f=ye([K(0,k.ILogService),K(1,i.IConfigurationService)],f),e.AbstractTunnelService=f}),define(oe[252],ae([0,1,9,77,2,7,6]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let I=class kt extends D.Disposable{constructor(C,w){super(),this.f=C,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,w,g,m,f,v,u){const l=new P,d=await Promise.resolve(this.f.openTunnel(C,l,g,m,f,v,u));if(!d)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${m} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),l.dispose(),await d.dispose(),(0,k.canceled)();return l.setTunnel(d),this.b.set(w,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${d.localAddress} (local) to ${g}:${m} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(C,w){const g=this.b.get(C);!g||g.setAddress(w)}async destroyTunnel(C){const w=this.b.get(C);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await w.dispose();return}this.c.add(C)}};I.a=0,I=ye([K(0,i.ISharedTunnelsService),K(1,L.ILogService)],I),e.SharedProcessTunnelService=I}),define(oe[253],ae([0,1,86,34,134,223,6,2,16,9,25,221,77,109,4]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(S,R,s,c,t){let n;for(let r=3;r&&(n?.dispose(),n=await new u(S,R,s,c,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));r--);return n}class u extends P.Disposable{constructor(R,s,c,t,n){super(),this.j=s,this.k=n,this.privacy=g.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=L.createServer(),this.c=new N.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(s=>{s()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,s=(0,g.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,D.findFreePortFaster)(R,2,1e3,s),t=null;return this.b.listen(c,this.j),await this.c.wait(),t=this.b.address(),t||(c=0,this.b.listen(c,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(R){R.pause();const s=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,w.connectRemoteAgentTunnel)(this.a,s,this.tunnelRemotePort),t=c.getSocket().socket,n=c.readEntireBuffer();c.dispose(),n.byteLength>0&&R.write(n.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),t.end()}),R.on("close",()=>t.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),t.destroy()}),t.on("end",()=>R.end()),t.on("close",()=>R.end()),t.on("error",()=>{R.destroy()}),R.pipe(t),t.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),t.end()})}}let l=class extends g.AbstractTunnelService{constructor(R,s,c,t,n){super(s,n),this.t=R,this.u=c,this.v=t}isPortPrivileged(R){return(0,g.isPortPrivileged)(R,this.k,f.OS,i.release())}r(R,s,c,t,n,r,o,a){const h=this.q(s,c);if(h)return++h.refcount,h.value;if(this.e)return this.s(this.e,s,c,n,r,o,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${c} on local port ${n}.`);const b={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},E=v(b,t,s,c,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(s,c,E),E}}};l=ye([K(1,y.ILogService),K(2,m.ISignService),K(3,C.IProductService),K(4,I.IConfigurationService)],l),e.BaseTunnelService=l;let d=class extends l{constructor(R,s,c,t){super(k.nodeSocketFactory,R,s,c,t)}};d=ye([K(0,y.ILogService),K(1,m.ISignService),K(2,C.IProductService),K(3,I.IConfigurationService)],d),e.TunnelService=d;let p=class extends P.Disposable{constructor(R,s,c,t){super(),this.b=R,this.c=s,this.f=c,this.g=t,this.a=new Map}async openTunnel(R,s,c,t,n,r,o,a,h){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${t} on local port ${r}.`),!this.a.has(R)){const b=new d(this.b,this.f,this.c,this.g);this.B(b),this.a.set(R,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(s,c,t,n,r,o,a,h)}};p=ye([K(0,y.ILogService),K(1,C.IProductService),K(2,m.ISignService),K(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(oe[29],ae([0,1,5]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(oe[254],ae([0,1,3,2,24,4,39,68,16,15,95,231,9,104,245,115,250,251,176,8,12,29]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var s;(function(n){n[n.MaxRestarts=5]="MaxRestarts"})(s||(s={}));let c=0,t=class extends i.Disposable{constructor(r,o,a,h,b,E){super(),this.C=r,this.D=o,this.F=a,this.G=h,this.H=b,this.I=E,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new L.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new L.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new L.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new L.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new L.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new L.Emitter),this.onProcessData=this.s.event,this.t=this.B(new L.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new L.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new L.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new L.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new L.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new L.Emitter),this.onProcessExit=this.z.event,(0,u.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,i.toDisposable)(()=>this.O())),this.f=this.B(new f.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.D.onDidChangeConfiguration(async T=>{T.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(k.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this.D,this.G,{_:[]},process.env)}catch(r){return this.G.error("ptyHost was unable to resolve shell environment",r),{}}}N(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},o=(0,C.parsePtyHostPort)(this.F.args,this.F.isBuilt);o&&(o.break&&o.port?r.debugBrk=o.port:!o.break&&o.port&&(r.debug=o.port));const a=new P.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,r);this.m.fire(),N.ProxyChannel.toService(a.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(a.onDidProcessExit(O=>{this.l.fire(O.code),this.i||(this.g<=s.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${O.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${O.code}, giving up`))}));const b=a.getChannel(v.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(b,this.G.getLevel());const E=p.URI.file((0,S.join)(this.F.logsPath,"ptyhost.log"));this.H.registerLoggerResource({id:"ptyHostLog",name:(0,d.localize)(0,null),resource:E}),this.B(this.G.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(b,this.G.getLevel())})),this.B(this.H.onDidChangeLogLevel(({resource:O,logLevel:M})=>{this.I.extUri.isEqual(E,O)&&m.LogLevelChannelClient.setLevel(b,M??this.G.getLevel())}));const T=N.ProxyChannel.toService(a.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(T.onProcessData(O=>this.s.fire(O))),this.B(T.onProcessReady(O=>this.t.fire(O))),this.B(T.onProcessExit(O=>this.z.fire(O))),this.B(T.onDidChangeProperty(O=>this.y.fire(O))),this.B(T.onProcessReplay(O=>this.u.fire(O))),this.B(T.onProcessOrphanQuestion(O=>this.v.fire(O))),this.B(T.onDidRequestDetach(O=>this.w.fire(O))),[a,T]}dispose(){this.i=!0,super.dispose()}async createProcess(r,o,a,h,b,E,T,O,M,F,A){const $=setTimeout(()=>this.S(),v.HeartbeatConstants.CreateProcessTimeout),z=await this.b.createProcess(r,o,a,h,b,E,T,O,M,F,A);return clearTimeout($),c=Math.max(c,z),z}updateTitle(r,o,a){return this.b.updateTitle(r,o,a)}updateIcon(r,o,a,h){return this.b.updateIcon(r,o,a,h)}attachToProcess(r){return this.b.attachToProcess(r)}detachFromProcess(r,o){return this.b.detachFromProcess(r,o)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(r){return this.b.start(r)}shutdown(r,o){return this.b.shutdown(r,o)}input(r,o){return this.b.input(r,o)}processBinary(r,o){return this.b.processBinary(r,o)}resize(r,o,a){return this.b.resize(r,o,a)}acknowledgeDataEvent(r,o){return this.b.acknowledgeDataEvent(r,o)}setUnicodeVersion(r,o){return this.b.setUnicodeVersion(r,o)}getInitialCwd(r){return this.b.getInitialCwd(r)}getCwd(r){return this.b.getCwd(r)}getLatency(r){return this.b.getLatency(r)}orphanQuestionReply(r){return this.b.orphanQuestionReply(r)}installAutoReply(r,o){return this.b.installAutoReply(r,o)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(r){return this.b.uninstallAutoReply(r)}getDefaultSystemShell(r){return this.b.getDefaultSystemShell(r)}async getProfiles(r,o,a,h=!1){const b=await this.c;return(0,l.detectAvailableProfiles)(o,a,h,this.D,b,void 0,this.G,this.W.bind(this,r))}getEnvironment(){return this.b.getEnvironment()}getWslPath(r,o){return this.b.getWslPath(r,o)}getRevivedPtyNewId(r){return this.b.getRevivedPtyNewId(r)}setTerminalLayoutInfo(r){return this.b.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this.b.getTerminalLayoutInfo(r)}async requestDetachInstance(r,o){return this.b.requestDetachInstance(r,o)}async acceptDetachInstanceReply(r,o){return this.b.acceptDetachInstanceReply(r,o)}async freePortKillProcess(r){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(r)}async serializeTerminalState(r){return this.b.serializeTerminalState(r)}async reviveTerminalProcesses(r,o){return this.b.reviveTerminalProcesses(r,o)}async refreshProperty(r,o){return this.b.refreshProperty(r,o)}async updateProperty(r,o,a){return this.b.updateProperty(r,o,a)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.G.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}R(){this.G.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.G.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(r,o){return this.f.createRequest({workspaceId:r,originalText:o})}async acceptPtyHostResolvedVariables(r,o){this.f.acceptReply(r,o)}};t=ye([K(1,I.IConfigurationService),K(2,y.IEnvironmentService),K(3,g.ILogService),K(4,g.ILoggerService),K(5,R.IUriIdentityService)],t),e.PtyHostService=t}),define(oe[255],ae([0,1,29,71,14,22,132,3,2]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class y{constructor(g){this.uri=g,this.time=y._clock++}touch(){return this.time=y._clock++,this}}y._clock=0;let C=class{constructor(g){this.g=g,this.c=new I.DisposableStore,this.f=2**16;const m=new Map,f=v=>{let u=m.get(v.scheme);return u===void 0&&(u=g.hasProvider(v)&&!this.g.hasCapability(v,1024),m.set(v.scheme,u)),u};this.c.add(P.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{m.delete(v.scheme)})),this.extUri=new k.ExtUri(f),this.d=new N.SkipList((v,u)=>this.extUri.compare(v,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,k.normalizePath)(g));const m=this.d.get(g);return m?m.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new y(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((f,v)=>f[1].touch<v[1].touch?1:f[1].touch>v[1].touch?-1:0);y._clock=0,this.d.clear();const m=this.f*.5;for(let f=0;f<m;f++)this.d.set(g[f][0],g[f][1].touch())}};C=ye([K(0,D.IFileService)],C),e.UriIdentityService=C,(0,i.registerSingleton)(L.IUriIdentityService,C,1)}),define(oe[256],ae([0,1,3,2,14,44,49,17]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,w,g,m){super(),this.c=C,this.f=w,this.g=g,this.h=m,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=N.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(f=>this.i(f)))}watch(C,w){this.b.set(C,C);const g=this.f.watch(this.j(C),w);return(0,i.toDisposable)(()=>{this.b.delete(C),g.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,w,g){return this.f.rename(this.j(C),this.j(w),g)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,w,g){const m=(0,k.newWriteableStream)(f=>P.VSBuffer.concat(f.map(v=>P.VSBuffer.wrap(v))).buffer);return(async()=>{try{const f=await this.readFile(C);m.end(f)}catch(f){m.error(f),m.end()}})(),m}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,w,g){return this.f.writeFile(this.j(C),w,g)}delete(C,w){return this.f.delete(this.j(C),w)}copy(C,w,g){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(w),g);throw new Error("copy not supported")}i(C){const w=[];for(const g of C){if(g.resource.scheme!==this.c)continue;const m=this.k(g.resource);this.b.findSubstr(m)&&w.push({resource:m,type:g.type})}w.length&&(this.h.debug("User data changed"),this.a.fire(w))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(oe[61],ae([0,1,83]),function(Z,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(N,P,I,y){const C=(0,L.setProperty)(N,P,I,y)[0];return C&&(N=N.substring(0,C.offset)+C.content+N.substring(C.offset+C.length)),N}e.edit=i;function D(N,P,I){let y=I;for(;y>=0;){if(N.charAt(y)===P.charAt(P.length-1)&&P.length===1)return y+1;if(y--,P.length===2&&y>=0&&N.charAt(y)===P.charAt(0))return y+2}return 0}e.getLineStartOffset=D;function k(N,P,I){let y=I;for(;y>=0;)if(N.charAt(y)===P.charAt(P.length-1)&&P.length===1||(y++,P.length===2&&y>=0&&N.charAt(y)===P.charAt(1)))return y;return N.length-1}e.getLineEndOffset=k}),define(oe[257],ae([0,1,32,54,13]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(m,f,v,u,l,d){const p=[],S=[],R=[];if(!f){const $=m.filter(({identifier:z})=>l.every(H=>H.toLowerCase()!==z.id.toLowerCase()));return{local:{added:p,removed:S,updated:R},remote:$.length>0?{added:$,updated:[],removed:[],all:$}:null}}m=m.map(w),f=f.map(w),v=v?v.map(w):null;const s=new Map,c=$=>{$.uuid&&s.set($.id.toLowerCase(),$.uuid)};m.forEach(({identifier:$})=>c($)),f.forEach(({identifier:$})=>c($)),v?.forEach(({identifier:$})=>c($));const t=$=>{const z=$.identifier.uuid||s.get($.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${$.identifier.id.toLowerCase()}`},n=($,z)=>($.set(t(z),z),$),r=m.reduce(n,new Map),o=f.reduce(n,new Map),a=f.reduce(($,z)=>n($,(0,L.deepClone)(z)),new Map),h=v?v.reduce(n,new Map):null,b=u.reduce(n,new Map),E=l.reduce(($,z)=>{const H=s.get(z.toLowerCase());return $.add(H?`uuid:${H}`:`id:${z.toLowerCase()}`)},new Set),T=d.reduce(($,{id:z,uuid:H})=>(H=H??s.get(z.toLowerCase()),$.add(H?`uuid:${H}`:`id:${z.toLowerCase()}`)),new Set),O=N(r,o,E,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const $=N(h,r,E,!1),z=N(h,o,E,!0),H=(X,ie,G,j)=>({...j,installed:ie.installed||G.installed,version:G.version&&(!ie.installed||i.gt(G.version,ie.version))?G.version:ie.version,state:I(ie,G,h?.get(X)),preRelease:(ie.installed?j.preRelease:G.preRelease)??ie.preRelease});for(const X of z.removed.values()){const ie=r.get(X);if(!ie)continue;const G=(0,D.assertIsDefined)(h?.get(X)),j=!T.has(X)&&G.installed;ie.installed&&j?S.push(ie.identifier):a.set(X,ie)}for(const X of z.added.values()){const ie=(0,D.assertIsDefined)(o.get(X)),G=r.get(X);if(G){if(O.updated.has(X)){const j=H(X,G,ie,ie);P(G,ie,!1,!1)||R.push(g(j,X)),a.set(X,j)}}else ie.installed&&p.push(g(ie,X))}for(const X of z.updated.values()){const ie=(0,D.assertIsDefined)(o.get(X)),G=(0,D.assertIsDefined)(h?.get(X)),j=r.get(X);if(j)if(!T.has(X)&&G.installed&&j.installed&&!ie.installed)S.push(j.identifier);else{const x=H(X,j,ie,ie);R.push(g(x,X)),a.set(X,x)}else ie.installed&&p.push(g(ie,X))}for(const X of $.added.values())z.added.has(X)||a.set(X,(0,D.assertIsDefined)(r.get(X)));for(const X of $.updated.values()){if(z.removed.has(X)||z.updated.has(X))continue;const ie=(0,D.assertIsDefined)(r.get(X)),G=(0,D.assertIsDefined)(o.get(X));a.set(X,H(X,ie,G,ie))}for(const X of $.removed.values())z.updated.has(X)||z.removed.has(X)||b.has(X)||!(0,D.assertIsDefined)(o.get(X)).installed||T.has(X)||!(0,D.assertIsDefined)(h?.get(X)).installed||a.delete(X)}const M=[],F=N(o,a,new Set,!0),A=F.added.size>0||F.updated.size>0||F.removed.size>0;return A&&a.forEach(($,z)=>M.push(g($,z))),{local:{added:p,removed:S,updated:R},remote:A?{added:[...F.added].map($=>a.get($)),updated:[...F.updated].map($=>a.get($)),removed:[...F.removed].map($=>o.get($)),all:M}:null}}e.merge=k;function N(m,f,v,u){const l=m?[...m.keys()].filter(s=>!v.has(s)):[],d=[...f.keys()].filter(s=>!v.has(s)),p=d.filter(s=>l.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),S=l.filter(s=>d.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),R=new Set;for(const s of l){if(S.has(s))continue;const c=m.get(s),t=f.get(s);(!t||!P(c,t,u,!0))&&R.add(s)}return{added:p,removed:S,updated:R}}function P(m,f,v,u){return!(m.disabled!==f.disabled||u&&m.installed!==f.installed||m.installed&&f.installed&&m.preRelease!==f.preRelease||!C(m.state,f.state)||v&&m.version!==f.version)}function I(m,f,v){const u=m.state,l=f.state,d=v?.state;if(!f.version||u&&i.gt(m.version,f.version))return u;if(l&&i.gt(f.version,m.version)||!u)return l;if(!l)return u;const p=(0,L.deepClone)(u),S=d?y(d,l):{added:Object.keys(l).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set},R=d?y(d,u):{added:Object.keys(u).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set};for(const s of[...S.added.values(),...S.updated.values()])p[s]=l[s];for(const s of S.removed.values())R.updated.has(s)||delete p[s];return p}function y(m,f){const v=Object.keys(m),u=Object.keys(f),l=u.filter(S=>v.indexOf(S)===-1).reduce((S,R)=>(S.add(R),S),new Set),d=v.filter(S=>u.indexOf(S)===-1).reduce((S,R)=>(S.add(R),S),new Set),p=new Set;for(const S of v){if(d.has(S))continue;const R=m[S],s=f[S];(0,L.equals)(R,s)||p.add(S)}return{added:l,removed:d,updated:p}}function C(m={},f={}){const{added:v,removed:u,updated:l}=y(m,f);return v.size===0&&u.size===0&&l.size===0}function w(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function g(m,f){const v={identifier:{id:m.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(v.version=m.version),m.disabled&&(v.disabled=!0),m.installed&&(v.installed=!0),m.state&&(v.state=m.state),v}}),define(oe[117],ae([0,1,21,16,5]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return y=y.filter(C=>C!==P&&C!==`-${P}`),I&&y.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,2)}updateSynchronizedExtensions(P,I){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return y=y.filter(C=>C!==P&&C!==`-${P}`),I&&y.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,2)}getIgnoredExtensions(P){const I=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),y=this.b().map(g=>g.toLowerCase()),C=[],w=[];if(Array.isArray(y))for(const g of y)g.startsWith("-")?w.push(g.substring(1)):C.push(g);return(0,L.distinct)([...I,...C].filter(g=>w.indexOf(g)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};k=ye([K(0,i.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(oe[258],ae([0,1,21,35,32,196,61]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(S){return(0,i.parse)(S)||[]}e.parseKeybindings=P;async function I(S,R,s,c,t){const n=P(S),r=P(R),o=s?P(s):null,a=[...n,...r,...o||[]].map(H=>H.key),h=await t.resolveUserBindings(a),b=C(n,r,o,h);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:R,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const E=g(n),T=g(r),O=o?g(o):null,M=f(E,T,h),F=O?f(O,E,h):{added:[...E.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},A=O?f(O,T,h):{added:[...T.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},$=y(M,F,A);let z=S;for(const H of $.removed.values())$.conflicts.has(H)||(z=d(z,H,c));for(const H of $.added.values()){if($.conflicts.has(H))continue;const X=T.get(H);if(X.some(ie=>ie.command!==`-${H}`&&b.conflicts.has(h[ie.key]))){$.conflicts.add(H);continue}z=l(z,X,c)}for(const H of $.updated.values()){if($.conflicts.has(H))continue;const X=T.get(H);if(X.some(ie=>ie.command!==`-${H}`&&b.conflicts.has(h[ie.key]))){$.conflicts.add(H);continue}z=p(z,H,X,c)}return{mergeContent:z,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=I;function y(S,R,s){const c=new Set,t=new Set,n=new Set,r=new Set;for(const o of R.removed.values())s.updated.has(o)&&r.add(o);for(const o of s.removed.values())r.has(o)||(R.updated.has(o)?r.add(o):t.add(o));for(const o of R.added.values())r.has(o)||s.added.has(o)&&S.updated.has(o)&&r.add(o);for(const o of s.added.values())r.has(o)||(R.added.has(o)?S.updated.has(o)&&r.add(o):c.add(o));for(const o of R.updated.values())r.has(o)||s.updated.has(o)&&S.updated.has(o)&&r.add(o);for(const o of s.updated.values())r.has(o)||(R.updated.has(o)?S.updated.has(o)&&r.add(o):n.add(o));return{added:c,removed:t,updated:n,conflicts:r}}function C(S,R,s,c){const t=new Set,n=w(S,c),r=w(R,c),o=s?w(s,c):null,a=m(n,r);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=o?m(o,n):{added:[...n.keys()].reduce((F,A)=>(F.add(A),F),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const b=o?m(o,r):{added:[...r.keys()].reduce((F,A)=>(F.add(A),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:E,removed:T,updated:O,conflicts:M}=y(a,h,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:T,updated:O,conflicts:M}}function w(S,R){const s=new Map;for(const c of S){const t=R[c.key];let n=s.get(t);n||(n=[],s.set(t,n)),n.push(c)}return s}function g(S){const R=new Map;for(const s of S){const c=s.command[0]==="-"?s.command.substring(1):s.command;let t=R.get(c);t||(t=[],R.set(c,t)),t.push(s)}return R}function m(S,R){const s=[...S.keys()],c=[...R.keys()],t=c.filter(o=>s.indexOf(o)===-1).reduce((o,a)=>(o.add(a),o),new Set),n=s.filter(o=>c.indexOf(o)===-1).reduce((o,a)=>(o.add(a),o),new Set),r=new Set;for(const o of s){if(n.has(o))continue;const a=S.get(o).map(b=>({...b,key:o})),h=R.get(o).map(b=>({...b,key:o}));(0,L.equals)(a,h,(b,E)=>u(b,E))||r.add(o)}return{added:t,removed:n,updated:r}}function f(S,R,s){const c=[...S.keys()],t=[...R.keys()],n=t.filter(a=>c.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),r=c.filter(a=>t.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),o=new Set;for(const a of c){if(r.has(a))continue;const h=S.get(a).map(E=>({...E,key:s[E.key]})),b=R.get(a).map(E=>({...E,key:s[E.key]}));v(h,b)||o.add(a)}return{added:n,removed:r,updated:o}}function v(S,R){return!(!(0,L.equals)(S.filter(({command:s})=>s[0]!=="-"),R.filter(({command:s})=>s[0]!=="-"),(s,c)=>u(s,c))||!(0,L.equals)(S.filter(({command:s})=>s[0]==="-"),R.filter(({command:s})=>s[0]==="-"),(s,c)=>u(s,c)))}function u(S,R){if(S.command!==R.command||S.key!==R.key)return!1;const s=k.ContextKeyExpr.deserialize(S.when),c=k.ContextKeyExpr.deserialize(R.when);return!(s&&!c||!s&&c||s&&c&&!s.equals(c)||!D.equals(S.args,R.args))}function l(S,R,s){for(const c of R)S=N.edit(S,[-1],c,s);return S}function d(S,R,s){const c=P(S);for(let t=c.length-1;t>=0;t--)(c[t].command===R||c[t].command===`-${R}`)&&(S=N.edit(S,[t],void 0,s));return S}function p(S,R,s,c){const t=P(S),n=t.findIndex(r=>r.command===R||r.command===`-${R}`);for(let r=t.length-1;r>=0;r--)(t[r].command===R||t[r].command===`-${R}`)&&(S=N.edit(S,[r],void 0,c));for(let r=s.length-1;r>=0;r--)S=N.edit(S,[n],s[r],c);return S}}),define(oe[259],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(k,N,P){const I={},y={},C=new Set;if(!N)return{local:{added:I,updated:y,removed:[...C.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const w=i(k,N);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:I,updated:y,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=i(P,k),m=i(P,N),f={},v={},u=new Set,l=new Set;for(const d of g.removed.values())m.updated.has(d)?I[d]=N[d]:u.add(d);for(const d of m.removed.values())l.has(d)||(g.updated.has(d)?l.add(d):C.add(d));for(const d of g.updated.values())l.has(d)||(m.updated.has(d)?w.updated.has(d)&&l.add(d):v[d]=k[d]);for(const d of m.updated.values())l.has(d)||(g.updated.has(d)?w.updated.has(d)&&l.add(d):k[d]!==void 0&&(y[d]=N[d]));for(const d of g.added.values())l.has(d)||(m.added.has(d)?w.updated.has(d)&&l.add(d):f[d]=k[d]);for(const d of m.added.values())l.has(d)||(g.added.has(d)?w.updated.has(d)&&l.add(d):I[d]=N[d]);return{local:{added:I,removed:[...C.values()],updated:y},remote:{added:f,removed:[...u.values()],updated:v},conflicts:[...l.values()]}}e.merge=L;function i(k,N){const P=k?Object.keys(k):[],I=N?Object.keys(N):[],y=I.filter(g=>P.indexOf(g)===-1).reduce((g,m)=>(g.add(m),g),new Set),C=P.filter(g=>I.indexOf(g)===-1).reduce((g,m)=>(g.add(m),g),new Set),w=new Set;for(const g of P){if(C.has(g))continue;const m=k[g],f=N[g];m!==f&&w.add(g)}return{added:y,removed:C,updated:w}}function D(k,N){const{added:P,removed:I,updated:y}=i(k,N);return P.size===0&&I.size===0&&y.size===0}e.areSame=D}),define(oe[260],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(D,k,N,P){const I={added:[],removed:[],updated:[]};let y={added:[],removed:[],updated:[]};if(!k){const w=D.filter(({id:g})=>!P.includes(g));return w.length?y.added=w:y=null,{local:I,remote:y}}const C=i(D,k,P);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const w=i(N,D,P),g=i(N,k,P);for(const m of g.removed){const f=D.find(v=>v.id===m);f&&I.removed.push(f)}for(const m of g.added){const f=k.find(v=>v.id===m);w.added.includes(m)?C.updated.includes(m)&&I.updated.push(f):I.added.push(f)}for(const m of g.updated)I.updated.push(k.find(f=>f.id===m));for(const m of w.added)g.added.includes(m)||y.added.push(D.find(f=>f.id===m));for(const m of w.updated)g.removed.includes(m)||g.updated.includes(m)||y.updated.push(D.find(f=>f.id===m));for(const m of w.removed){const f=k.find(v=>v.id===m);f&&y.removed.push(f)}}return y.added.length===0&&y.removed.length===0&&y.updated.length===0&&(y=null),{local:I,remote:y}}e.merge=L;function i(D,k,N){D=D?D.filter(({id:g})=>!N.includes(g)):[],k=k.filter(({id:g})=>!N.includes(g));const P=D.map(({id:g})=>g),I=k.map(({id:g})=>g),y=I.filter(g=>P.indexOf(g)===-1),C=P.filter(g=>I.indexOf(g)===-1),w=[];for(const{id:g,name:m,shortName:f}of D){if(C.includes(g))continue;const v=k.find(u=>u.id===g);(!v||v.name!==m||v.shortName!==f)&&w.push(g)}return{added:y,removed:C,updated:w}}}),define(oe[26],ae([0,1,21,13,182,46,30,5,106,40]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EXTENSIONS_SYNC_CONTEXT_KEY=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const r=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(o=>!!r[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function w(){const r=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(r).filter(b=>!!r[b].ignoreSync),a=Object.keys(r).filter(b=>r[b].scope===2||r[b].scope===6),h=C();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...a,...h])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const r="vscode://schemas/ignoredSettings",o=y.Registry.as(k.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=y.Registry.as(I.Extensions.JSONContribution),h=()=>{const b=C(),E=w().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),T=Object.keys(k.allSettings.properties).filter(F=>E.indexOf(F)===-1),O=E.filter(F=>b.indexOf(F)===-1),M={items:{type:"string",enum:[...T,...O.map(F=>`-${F}`)]}};a.registerSchema(r,M)};return o.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=g;function m(r){return r&&(0,i.isObject)(r)&&(0,i.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=m;var f;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(r,...o){return r?[r,...o]:o}e.getPathSegments=v;function u(r,o,a,h){return h.joinPath(a.userDataSyncHome,...v(r,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=u,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(r){const o={};return o[e.HEADER_EXECUTION_ID]=r,o}e.createSyncHeaders=l;var d;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(o,a,h,b){super(o),this.code=a,this.resource=h,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class S extends p{constructor(o,a,h,b,E){super(o,h,void 0,E),this.url=a,this.serverCode=b}}e.UserDataSyncStoreError=S;class R extends p{constructor(o,a){super(o,a)}}e.UserDataAutoSyncError=R,function(r){function o(a){if(a instanceof r)return a;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(h&&h[1]){const b=h[2]==="unknown"?void 0:h[2],E=h[3]==="unknown"?void 0:h[3];return new r(a.message,h[1],b,E)}return new r(a.message,"Unknown")}r.toUserDataSyncError=o}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var c;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var t;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(r){return`sync.enable.${r}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview",e.EXTENSIONS_SYNC_CONTEXT_KEY="extensionsSync"}),define(oe[261],ae([0,1,32,26]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(N,P,I,y,C){if(!P)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const w=k(N,P);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=I?k(I,P):{added:Object.keys(P).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},m=I?k(I,N):{added:Object.keys(N).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},v=L.deepClone(P),u=!I;for(const d of m.added.values())d!==i.SYNC_SERVICE_URL_TYPE&&u&&g.added.has(d)||(v[d]=N[d]);for(const d of m.updated.values())v[d]=N[d];for(const d of m.removed.values())y.unregistered.includes(d)||delete v[d];for(const d of g.added.values()){const p=P[d];if(y.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(I&&m.added.has(d))continue;const S=N[d];S&&S.value===p.value||d===i.SYNC_SERVICE_URL_TYPE&&u&&m.added.has(d)||(S?f.updated[d]=p:f.added[d]=p)}for(const d of g.updated.values()){const p=P[d];if(y.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(d)||m.removed.has(d))continue;const S=N[d];S&&S.value===p.value||(f.updated[d]=p)}for(const d of g.removed.values()){if(y.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}m.updated.has(d)||m.removed.has(d)||f.removed.push(d)}const l=k(P,v);return{local:f,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:v}}}e.merge=D;function k(N,P){const I=Object.keys(N),y=Object.keys(P),C=y.filter(m=>I.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),w=I.filter(m=>y.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),g=new Set;for(const m of I){if(w.has(m))continue;const f=N[m],v=P[m];L.equals(f,v)||g.add(m)}return{added:C,removed:w,updated:g}}}),define(oe[262],ae([0,1,21,35,83,43,32,61,26]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function y(a,h,b){let E=[];b?E=w(b):E=C(h);const T=[],O=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const M of E)M.startsWith("-")?O.push(M.substring(1)):T.push(M);return(0,L.distinct)([...a,...T].filter(M=>O.indexOf(M)===-1))}e.getIgnoredSettings=y;function C(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function w(a){const h=(0,i.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function g(a,h){const b=(0,i.parse)(a)||{};let E="{}";for(const T of Object.keys(b)){const O=(0,D.setProperty)(E,[T],b[T],h);E=(0,D.applyEdits)(E,O)}return E}e.removeComments=g;function m(a,h,b,E){if(b.length){const T=o(h),O=(0,i.parse)(h)||{},M=(0,i.parse)(a);if(!M)return a;const F=[];for(const A of b){const $=O[A],z=M[A];$===void 0?a=P.edit(a,[A],void 0,E):z!==void 0?a=P.edit(a,[A],$,E):F.push(s(A,T))}F.sort((A,$)=>A.startOffset-$.startOffset),F.forEach(A=>a=d(A.setting.key,h,a,E))}return a}e.updateIgnoredSettings=m;function f(a,h,b,E,T,O){const M=m(a,h,E,O),F=b!==M,A=b!==h;if(!F&&!A)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!A)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(A&&!F)return{conflictsSettings:[],localContent:m(h,a,E,O),remoteContent:null,hasConflicts:!1};if(b===null&&u(a)){const q=v(a,h,E)?null:m(h,a,E,O);return{conflictsSettings:[],localContent:q,remoteContent:null,hasConflicts:!1}}let $=a,z=h;const H=(0,i.parse)(a),X=(0,i.parse)(h),ie=b?(0,i.parse)(b):null,G=E.reduce((q,J)=>(q.add(J),q),new Set),j=l(H,X,G),V=l(ie,H,G),x=l(ie,X,G),ee=new Map,re=new Set,te=q=>{re.add(q);const J=T.filter(({key:_})=>_===q)[0];J?($=P.edit($,[q],J.value,O),z=P.edit(z,[q],J.value,O)):ee.set(q,{key:q,localValue:H[q],remoteValue:X[q]})};for(const q of V.removed.values())x.updated.has(q)?te(q):z=P.edit(z,[q],void 0,O);for(const q of x.removed.values())re.has(q)||(V.updated.has(q)?te(q):$=P.edit($,[q],void 0,O));for(const q of V.updated.values())re.has(q)||(x.updated.has(q)?j.updated.has(q)&&te(q):z=P.edit(z,[q],H[q],O));for(const q of x.updated.values())re.has(q)||(V.updated.has(q)?j.updated.has(q)&&te(q):$=P.edit($,[q],X[q],O));for(const q of V.added.values())re.has(q)||(x.added.has(q)?j.updated.has(q)&&te(q):z=d(q,$,z,O));for(const q of x.added.values())re.has(q)||(V.added.has(q)?j.updated.has(q)&&te(q):$=d(q,z,$,O));const U=ee.size>0||!v($,z,E),B=U||!v($,a,[]),W=U||!v(z,h,[]);return{localContent:B?$:null,remoteContent:W?z:null,conflictsSettings:[...ee.values()],hasConflicts:U}}e.merge=f;function v(a,h,b){if(a===h)return!0;const E=(0,i.parse)(a),T=(0,i.parse)(h),O=b.reduce((A,$)=>(A.add($),A),new Set),M=o(a).filter(A=>!(A.setting&&O.has(A.setting.key))),F=o(h).filter(A=>!(A.setting&&O.has(A.setting.key)));if(M.length!==F.length)return!1;for(let A=0;A<M.length;A++){const $=M[A],z=F[A];if($.setting&&z.setting){if($.setting.key!==z.setting.key||!N.equals(E[$.setting.key],T[$.setting.key]))return!1}else if(!$.setting&&!z.setting){if($.value!==z.value)return!1}else return!1}return!0}e.areSame=v;function u(a){return a?o(a).length===0:!0}e.isEmpty=u;function l(a,h,b){const E=a?Object.keys(a).filter(A=>!b.has(A)):[],T=Object.keys(h).filter(A=>!b.has(A)),O=T.filter(A=>E.indexOf(A)===-1).reduce((A,$)=>(A.add($),A),new Set),M=E.filter(A=>T.indexOf(A)===-1).reduce((A,$)=>(A.add($),A),new Set),F=new Set;if(a)for(const A of E){if(M.has(A))continue;const $=a[A],z=h[A];N.equals($,z)||F.add(A)}return{added:O,removed:M,updated:F}}function d(a,h,b,E){const T=(0,i.parse)(h),O=o(h),M=o(b),F=p(a,O,M);return S(b,a,T[a],F,M,E)}e.addSetting=d;function p(a,h,b){const E=h.findIndex(O=>O.setting?.key===a),T=h[E-1];if(T){if(T.setting){const M=s(T.setting.key,b);if(M)return{index:b.indexOf(M),insertAfter:!0}}else{const M=c(E,h);if(M){const F=s(M.setting.key,b);if(F){const A=t(b.indexOf(F),b),$=n(h,M,h[E]);if(A){const z=n(b,F,A),H=r($,z);return H?{index:b.indexOf(H),insertAfter:!0}:{index:b.indexOf(A),insertAfter:!1}}else{const z=n(b,F,b[b.length-1]),H=r($,z);return H?{index:b.indexOf(H),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const O=h[E+1];if(O)if(O.setting){const M=s(O.setting.key,b);if(M)return{index:b.indexOf(M),insertAfter:!1}}else{const M=t(E,h);if(M){const F=s(M.setting.key,b);if(F){const A=c(b.indexOf(F),b),$=n(h,h[E],M);if(A){const z=n(b,A,F),H=r($.reverse(),z.reverse());return H?{index:b.indexOf(H),insertAfter:!1}:{index:b.indexOf(A),insertAfter:!0}}else{const z=n(b,b[0],F),H=r($.reverse(),z.reverse());return H?{index:b.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function S(a,h,b,E,T,O){let M;return E.index===-1?M=(0,D.setProperty)(a,[h],b,O):M=R(a,h,b,E,T,O).map(F=>(0,D.withFormatting)(a,F,O)[0]),(0,D.applyEdits)(a,M)}function R(a,h,b,E,T,O){const M=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,F=(0,k.getEOL)(O,a),A=T[E.index];if(E.insertAfter){const $=[];if(A.setting)$.push({offset:A.endOffset,length:0,content:","+M});else{const z=t(E.index,T),H=c(E.index,T),X=H?.setting?.commaOffset;H&&X===void 0&&$.push({offset:H.endOffset,length:0,content:","});const ie=X!==void 0&&X>A.endOffset;$.push({offset:ie?X+1:A.endOffset,length:0,content:z?F+M+",":F+M})}return $}else{if(A.setting)return[{offset:A.startOffset,length:0,content:M+","}];const $=(T[E.index-1]&&!T[E.index-1].setting?F:"")+M+(t(E.index,T)?",":"")+F;return[{offset:A.startOffset,length:0,content:$}]}}function s(a,h){return h.filter(b=>b.setting?.key===a)[0]}function c(a,h){for(let b=a-1;b>=0;b--)if(h[b].setting)return h[b]}function t(a,h){for(let b=a+1;b<h.length;b++)if(h[b].setting)return h[b]}function n(a,h,b){const E=a.indexOf(h),T=a.indexOf(b);return a.filter((O,M)=>E<M&&M<T)}function r(a,h){if(a.length&&h.length){let b=0;for(;b<h.length&&b<a.length;b++)if(a[b].value!==h[b].value)return h[b-1];return h[b-1]}}function o(a){const h=[];let b=-1,E,T;const O={onObjectBegin:M=>{b++},onObjectProperty:(M,F,A)=>{b===0&&(E=F,T=M)},onObjectEnd:(M,F)=>{b--,b===0&&h.push({startOffset:E,endOffset:M+F,value:a.substring(E,M+F),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(M,F)=>{b++},onArrayEnd:(M,F)=>{b--,b===0&&h.push({startOffset:E,endOffset:M+F,value:a.substring(E,M+F),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(M,F,A)=>{b===0&&h.push({startOffset:E,endOffset:F+A,value:a.substring(E,F+A),setting:{key:T,commaOffset:void 0}})},onSeparator:(M,F,A)=>{if(b===0&&M===","){let $=h.length-1;for(;$>=0&&!h[$].setting;$--);const z=h[$];z&&h.splice($,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:F}})}},onComment:(M,F)=>{b===0&&h.push({startOffset:M,endOffset:M+F,value:a.substring(M,M+F)})}};return(0,i.visit)(a,O),h}}),define(oe[78],ae([0,1,3,2,5,26]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let N=class extends i.Disposable{get account(){return this.a}constructor(I,y){super(),this.g=I,this.h=y,this.b=this.B(new L.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new L.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};N=ye([K(0,k.IUserDataSyncStoreService),K(1,k.IUserDataSyncLogService)],N),e.UserDataSyncAccountService=N}),define(oe[263],ae([0,1,2,8]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(g){this.a=g}listen(g,m){switch(m){case"onError":return this.a.onError}throw new Error(`Event not found: ${m}`)}call(g,m,f){switch(m){case"triggerSync":return this.a.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(g){this.a=g}listen(g,m){throw new Error(`Event not found: ${m}`)}call(g,m,f){switch(m){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class N{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=N;class P{constructor(g){this.a=g}listen(g,m){switch(m){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${m}`)}async call(g,m,f){switch(m){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(f[0],f[1]);case"setEnablements":return this.a.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(g){this.a=g}listen(g,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(g,m,f){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class y{constructor(g){this.a=g}listen(g,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(g,m,f){switch(m){case"switch":return this.a.switch(f[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=y;class C extends L.Disposable{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:i.URI.revive(g.url),type:g.type,defaultUrl:i.URI.revive(g.defaultUrl),insidersUrl:i.URI.revive(g.insidersUrl),stableUrl:i.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(oe[264],ae([0,1,15,9]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(N,P){super(),this.g=this.B(N.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(N,...P){this.g.trace(N,...P)}debug(N,...P){this.g.debug(N,...P)}info(N,...P){this.g.info(N,...P)}warn(N,...P){this.g.warn(N,...P)}error(N,...P){this.g.error(N,...P)}flush(){this.g.flush()}};D=ye([K(0,i.ILoggerService),K(1,L.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(oe[265],ae([0,1,6,3,2]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:y}){super(),this.a=this.B(new D.DisposableStore),i.Event.latch(i.Event.any(P,I))(this.f,this,this.a),this.b=(0,L.createCancelablePromise)(()=>y()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=k}),define(oe[118],ae([0,1,185,12,49,22,8,5,24]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function y(t){const n=t;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=y;function C(t){return typeof t?.id=="string"&&!y(t)&&!g(t)}e.isEmptyWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,i.basename)(t)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=w;function g(t){const n=t;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function m(t){const n=t;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=m;var f;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function v(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=v;function u(t){const n=t;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=u;class l{constructor(n,r,o,a,h){this.h=n,this.j=o,this.k=a,this.l=h,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class d{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function p(t){return new d({uri:t,index:0,name:(0,k.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(t,n){return k.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function R(t){let n;return N.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=R;function s(t,n){return!S(t,n)&&!R(t)}e.isSavedWorkspace=s;function c(t){return(typeof t=="string"?(0,i.extname)(t):(0,k.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(oe[18],ae([0,1,66,3,2,22,8,177,15,14,5,9,118,37,29,6,31,27,13]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function S(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:N.URI.revive(t.location).with({scheme:n}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=S;function R(t,n,r,o){return{id:t,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,k.joinPath)(r,"globalStorage"),settingsResource:(0,k.joinPath)(r,"settings.json"),keybindingsResource:(0,k.joinPath)(r,"keybindings.json"),tasksResource:(0,k.joinPath)(r,"tasks.json"),snippetsHome:(0,k.joinPath)(r,"snippets"),extensionsResource:(0,k.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=R;let s=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,a){super(),this.m=n,this.n=r,this.r=o,this.s=a,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const h of this.G()){if(!h.name||!(0,d.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}n.push(R((0,k.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}const r=new m.ResourceMap,o=new Map,a=R((0,L.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...a,extensionsResource:this.L()??a.extensionsResource,isDefault:!0}),n.length){const h=this.I();if(h.workspaces)for(const[b,E]of Object.entries(h.workspaces)){const T=N.URI.parse(b),O=N.URI.parse(E),M=n.find(F=>this.r.extUri.isEqual(F.location,O));M&&r.set(T,M)}if(h.emptyWindows)for(const[b,E]of Object.entries(h.emptyWindows)){const T=N.URI.parse(E),O=n.find(M=>this.r.extUri.isEqual(M.location,T));O&&o.set(b,O)}}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,l.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const b of this.profiles){const E=o.exec(b.name),T=E?parseInt(E[1]):0;a=T>a?T:a}const h=`${r} ${a+1}`;return this.createProfile((0,L.hash)((0,u.generateUuid)()).toString(16),h,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,L.hash)((0,u.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(n,r,o);return a&&await this.setProfileForWorkspace(a,h),h}async v(n,r,o){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(r);return a||(a=(async()=>{try{const h=this.profiles.find(T=>T.name===r||T.id===n);if(h)return h;const b=R(n,r,(0,k.joinPath)(this.profilesHome,n),o);await this.n.createFolder(b.location);const E=[];return this.h.fire({profile:b,join(T){E.push(T)}}),await v.Promises.settled(E),this.z([b],[],[]),b}finally{this.k.delete(r)}})(),this.k.set(r,a)),a}async updateProfile(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=R(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.z([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(a){o.push(a)}});try{await Promise.allSettled(o)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.F(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.D(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.w(n);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}w(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}z(n,r,o){const a=[...this.profiles,...n],h=[];this.l.profiles=[];for(let b of a)b.isDefault||r.some(E=>b.id===E.id)||(b=o.find(E=>b.id===E.id)??b,b.isTransient?this.l.profiles.push(b):h.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.H(h),this.t=void 0,this.C(n,r,o)}C(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}D(n,r,o){o=r?.isTransient?!0:o,o||this.D(n,void 0,!0);const a=this.w(n),h=o?this.l:this.u;N.URI.isUri(a)?(h.workspaces.delete(a),r&&h.workspaces.set(a,r)):(h.emptyWindows.delete(a),r&&h.emptyWindows.set(a,r)),o||this.F()}F(){const n={};for(const[o,a]of this.u.workspaces.entries())n[o.toString()]=a.location.toString();const r={};for(const[o,a]of this.u.emptyWindows.entries())r[o.toString()]=a.location.toString();this.J({workspaces:n,emptyWindows:r}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};s.b="userDataProfiles",s.c="profileAssociations",s=ye([K(0,I.IEnvironmentService),K(1,y.IFileService),K(2,f.IUriIdentityService),K(3,w.ILogService)],s),e.UserDataProfilesService=s;class c extends s{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=c}),define(oe[266],ae([0,1,6,2,18]),function(Z,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends i.Disposable{constructor(P){super(),this.B(new L.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};k=ye([K(0,D.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(oe[267],ae([0,1,21,6,23,7,3,2,4,8,157,30,33,42,9,25,19,18]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,a,h){super(),this.t=n,this.u=r,this.v=o,this.w=a,this.y=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.k.forEach(b=>b.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(C.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),R(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const a={...o,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,m.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},h=F=>`${g.ExtensionKey.create(F).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!y.URI.isUri(r)){const F=this.j.get(h(r));if(F){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:A}=await F.task.waitUntilTaskIsFinished();return A}}const b=[],E=[],T=[],O=this.Q(n,r,a);y.URI.isUri(r)||this.j.set(h(r),{task:O,waitingTasks:[]}),this.l.fire({identifier:O.identifier,source:r,profileLocation:a.profileLocation}),this.v.info("Installing extension:",O.identifier.id),b.push({task:O,manifest:n});let M=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const A=await this.F(O.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),$=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:z,manifest:H}of(0,L.distinct)(A,({gallery:X})=>X.identifier.id)){M=M||!!H.extensionDependencies?.some(G=>(0,g.areSameExtensions)({id:G},O.identifier));const X=h(z),ie=this.j.get(X);if(ie){if(this.C(O,ie.task)){const G=ie.task.identifier;this.v.info("Waiting for already requested installing extension",G.id,O.identifier.id),ie.waitingTasks.push(O),E.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,j=>j.some(V=>(0,g.areSameExtensions)(V.identifier,G)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",G.id,O.identifier.id),!j.find(x=>(0,g.areSameExtensions)(x.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!$.some(({identifier:G})=>(0,g.areSameExtensions)(G,z.identifier))){const G=this.Q(H,z,{...a,donotIncludePackAndDependencies:!0});this.j.set(X,{task:G,waitingTasks:[O]}),this.l.fire({identifier:G.identifier,source:z,profileLocation:a.profileLocation}),this.v.info("Installing extension:",G.identifier.id,O.identifier.id),b.push({task:G,manifest:H})}}}catch(A){if(y.URI.isUri(O.source))(0,L.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",O.identifier.id,A.message),(0,L.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",O.identifier.id,A.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),A}const F=b.reduce((A,{task:$,manifest:z})=>(A.set($.identifier.id.toLowerCase(),{task:$,manifest:z}),A),new Map);for(;F.size;){let A;const $=[...F.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(H=>F.has(H.toLowerCase())));$.length?A=F.size===1?$:$.filter(({task:z})=>!(z===O&&!M)):(this.v.info("Found extensions with circular dependencies",$.map(({task:z})=>z.identifier.id)),A=[...F.values()]),await this.D(A.map(async({task:z})=>{const H=new Date().getTime();try{const{local:X}=await z.run();if(await this.D(this.s.map(ie=>ie.postInstall(X,z.source,a,D.CancellationToken.None))),!y.URI.isUri(z.source)){const ie=z.operation===3,G=ie?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(s(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:G}),I.isWeb&&z.operation!==3)try{await this.t.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}T.push({local:X,identifier:z.identifier,operation:z.operation,source:z.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw y.URI.isUri(z.source)||s(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-H,error:X}),this.v.error("Error while installing the extension:",z.identifier.id),X}finally{F.delete(z.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),T.forEach(({identifier:A})=>this.v.info("Extension installed successfully:",A.id)),this.m.fire(T),T.filter(({identifier:A})=>(0,g.areSameExtensions)(A,O.identifier))[0].local}catch(F){if(b.forEach(({task:A})=>A.cancel()),T.length)try{const A=await Promise.allSettled(T.map(({local:$})=>this.R($,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let $=0;$<A.length;$++){const z=A[$],{identifier:H}=T[$];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",H.id):this.v.warn("Rollback: Error while uninstalling extension",H.id,(0,k.getErrorMessage)(z.reason))}}catch(A){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(A),T.map(({identifier:$})=>$.id))}throw this.m.fire(b.map(({task:A})=>({identifier:A.identifier,operation:2,source:A.source,context:a.context,profileLocation:a.profileLocation}))),F}finally{for(const{task:F}of b)F.source&&!y.URI.isUri(F.source)&&this.j.delete(h(F.source))}}C(n,r){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===n&&(a.includes(r)||a.some(h=>this.C(h,r)))||o===r&&a[0]&&!this.C(n,a[0]))return!1;return!0}async D(n){const r=[],o=[],a=await Promise.allSettled(n);for(const h of a)h.status==="fulfilled"?r.push(h.value):o.push(h.reason);if(o.length)throw S(o);return r}async F(n,r,o,a,h){if(!this.t.isEnabled())return[];const b=await this.getInstalled(void 0,h),E=[],T=[],O=async(M,F)=>{E.push(M);const A=F.extensionDependencies||[],$=[...A];if(F.extensionPack){const z=o?b.find(H=>(0,g.areSameExtensions)(H.identifier,M)):void 0;for(const H of F.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(X=>(0,g.areSameExtensions)({id:X},{id:H}))||$.every(X=>!(0,g.areSameExtensions)({id:X},{id:H}))&&$.push(H)}if($.length){const z=$.filter(H=>E.every(X=>!(0,g.areSameExtensions)(X,{id:H})));if(z.length){const H=await this.t.getExtensions(z.map(X=>({id:X,preRelease:a})),D.CancellationToken.None);for(const X of H){if(E.find(j=>(0,g.areSameExtensions)(j,X.identifier)))continue;const ie=A.some(j=>(0,g.areSameExtensions)({id:j},X.identifier));let G;try{G=await this.G(X,!1,a)}catch(j){if(j instanceof w.ExtensionManagementError&&j.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.v.info("Skipping the packed extension as it cannot be installed",X.identifier.id);continue}else throw j}T.push({gallery:G.extension,manifest:G.manifest}),await O(G.extension.identifier,G.manifest)}}}};return await O(n,r),T}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,g.areSameExtensions)(n.identifier,E)))throw new w.ExtensionManagementError(C.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const E=await this.getTargetPlatform();throw new w.ExtensionManagementError(C.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(E)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(n,r,o);if(h){if(o&&!r&&n.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(C.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],D.CancellationToken.None))[0]?new w.ExtensionManagementError(C.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(C.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",h.identifier.id);const b=await this.t.getManifest(h,D.CancellationToken.None);if(b===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(b.version!==h.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:b}}async H(n,r,o){const a=await this.getTargetPlatform();let h=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(h=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!h&&await this.t.isExtensionCompatible(n,o,a)&&(h=n),h||(r?h=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:h=await this.t.getCompatibleExtension(n,o,a)),h}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},a=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,h=this.k.get(a(n.identifier));if(h)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),h.waitUntilTaskIsFinished();const b=M=>{const F=this.R(M,o);return this.k.set(a(F.extension.identifier),F),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),F},E=(M,F)=>{F?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),F.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(M),error:F}),this.p.fire({identifier:M.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},T=[],O=[];try{T.push(b(n));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const F=this.M(n,M);for(const A of F)this.k.has(a(A.identifier))?this.v.info("Extensions is already requested to uninstall",A.identifier.id):T.push(b(A))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(T.map(F=>F.extension),M,n),await this.D(T.map(async F=>{try{if(await F.run(),await this.D(this.s.map(A=>A.postUninstall(F.extension,o,D.CancellationToken.None))),F.extension.identifier.uuid)try{await this.t.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}E(F.extension)}catch(A){const $=A instanceof w.ExtensionManagementError?A:new w.ExtensionManagementError((0,k.getErrorMessage)(A),w.ExtensionManagementErrorCode.Internal);throw E(F.extension,$),$}finally{O.push(F)}}))}catch(M){const F=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,k.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);for(const A of T){try{A.cancel()}catch{}O.includes(A)||E(A.extension,F)}throw F}finally{for(const M of T)this.k.delete(a(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(n,r,o){for(const a of n){const h=this.N(a,r);if(h.length){const b=h.filter(E=>!n.some(T=>(0,g.areSameExtensions)(T.identifier,E.identifier)));if(b.length)throw new Error(this.L(a,b,o))}}}L(n,r,o){return o===n?r.length===1?C.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const h=r.filter(E=>!E.isBuiltin&&a.some(T=>(0,g.areSameExtensions)({id:T},E.identifier))),b=[];for(const E of h)b.push(...this.M(E,r,o));return[...h,...b]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,g.areSameExtensions)({id:a},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ye([K(0,w.IExtensionGalleryService),K(1,u.ITelemetryService),K(2,f.ILogService),K(3,v.IProductService),K(4,l.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function S(t){const n=Array.isArray(t)?t:[t];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=S;function R(t){if(t instanceof w.ExtensionManagementError)return t;const n=new w.ExtensionManagementError(t.message,w.ExtensionManagementErrorCode.Internal);return n.stack=t.stack,n}function s(t,n,{extensionData:r,verificationStatus:o,duration:a,error:h,durationSinceUpdate:b}){let E,T;h&&(h instanceof w.ExtensionManagementError?(E=h.code,h.code===w.ExtensionManagementErrorCode.Signature&&(T=h.message)):E=w.ExtensionManagementErrorCode.Internal),t.publicLog(n,{...r,verificationStatus:o,success:!h,duration:a,errorcode:E,errorcodeDetail:T,durationSinceUpdate:b})}e.reportTelemetry=s;class c{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(n=>new Promise((r,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=c}),define(oe[51],ae([0,1,6,17,2,3,37,8,33,42,14,5,9,18,29,13,7,19]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let S=class extends D.Disposable{constructor(t,n,r,o,a,h){super(),this.h=t,this.i=n,this.j=r,this.k=o,this.l=a,this.m=h,this.a=this.B(new k.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new k.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(t,n){return this.n(t,void 0,n)}async addExtensionsToProfile(t,n){const r=[],o=[];try{return await this.n(n,a=>{const h=[];for(const b of a)t.some(([E])=>(0,I.areSameExtensions)(E.identifier,b.identifier)&&E.manifest.version!==b.version)?r.push(b):h.push(b);for(const[b,E]of t)if(!h.some(T=>(0,I.areSameExtensions)(T.identifier,b.identifier)&&T.version===b.manifest.version)){const T={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:E};o.push(T),h.push(T)}return o.length&&this.a.fire({extensions:o,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),h}),o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),o}catch(a){throw o.length&&this.b.fire({extensions:o,error:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:a,profileLocation:n}),a}}async removeExtensionFromProfile(t,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,o=>{const a=[];for(const h of o)(0,I.areSameExtensions)(h.identifier,t.identifier)?r.push(h):a.push(h);return r.length&&this.c.fire({extensions:r,profileLocation:n}),a}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.f.fire({extensions:r,error:o,profileLocation:n}),o}}async n(t,n,r){return this.v(t).queue(async()=>{let o=[],a;try{const h=await this.i.readFile(t);a=JSON.parse(h.value.toString())}catch(h){if((0,C.toFileOperationResult)(h)!==1)throw h;if(this.k.extUri.isEqual(t,this.j.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&r?.bailOutWhenFileNotFound)throw new p((0,u.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.p(t);let h=!1;for(const b of a){R(b)||this.p(t);let E;if((0,v.isString)(b.location))E=this.s(b.location);else{E=P.URI.revive(b.location);const T=this.r(E);T&&(h=!0,b.location=T)}o.push({identifier:b.identifier,location:E,version:b.version,metadata:b.metadata})}h&&await this.i.writeFile(t,i.VSBuffer.fromString(JSON.stringify(a)))}if(n){o=n(o);const h=o.map(b=>({identifier:b.identifier,version:b.version,location:this.r(b.location)??b.location.toJSON(),metadata:b.metadata}));await this.i.writeFile(t,i.VSBuffer.fromString(JSON.stringify(h)))}return o})}p(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(t){return this.k.extUri.isEqualOrParent(t,this.h)?this.k.extUri.relativePath(this.h,t):void 0}s(t){return this.k.extUri.joinPath(this.h,t)}async u(){return this.t||(this.t=(async()=>{const t=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(t)).value.toString()}catch(o){if((0,C.toFileOperationResult)(o)===1)return;throw o}this.m.info("Migrating extensions from old default profile location",t.toString());let r;try{const o=JSON.parse(n);Array.isArray(o)&&o.every(a=>R(a))?r=o:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.m.error(o)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",t.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(o){if((0,C.toFileOperationResult)(o)===3)this.m.info("Migration from old default profile location to new location is done by another window",t.toString(),this.j.defaultProfile.extensionsResource.toString());else throw o}try{await this.i.del(t)}catch(o){(0,C.toFileOperationResult)(o)!==1&&this.m.error(o)}return r})()),this.t}v(t){let n=this.g.get(t);return n||(n=new L.Queue,this.g.set(t,n)),n}};S=ye([K(1,C.IFileService),K(2,m.IUserDataProfilesService),K(3,f.IUriIdentityService),K(4,l.ITelemetryService),K(5,g.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function R(c){return(0,v.isObject)(c)&&(0,y.isIExtensionIdentifier)(c.identifier)&&(s(c.location)||(0,v.isString)(c.location))&&c.version&&(0,v.isString)(c.version)}function s(c){return c?(0,v.isString)(c.path)&&(0,v.isString)(c.scheme):!1}}),define(oe[79],ae([0,1,21,6,32,17,7,35,140,2,24,12,4,22,54,89,13,8,160,15,33,42,70,14,5,9,25,3,67,51,18,29,191,192]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R,s,c,t,n,r,o,a,h,b,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var M;(function(ie){function G(j,V){if(j===V)return!0;const x=Object.keys(j),ee=new Set;for(const re of Object.keys(V))ee.add(re);if(x.length!==ee.size)return!1;for(const re of x){if(j[re]!==V[re])return!1;ee.delete(re)}return ee.size===0}ie.equals=G})(M=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends y.Disposable{constructor(G,j,V,x,ee,re,te,U,B,W,q,J){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=j,this.l=V,this.m=x,this.n=ee,this.p=re,this.r=te,this.s=U,this.t=B,this.u=W,this.v=q,this.w=J,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,m.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,m.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance($,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(G,j,V){const[x,ee]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(j)]),re=V?await this.scanExtensionsUnderDevelopment(G,[...x,...ee]):[];return this.F(x,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const j=[];j.push(this.G(!!G.useCache,G.language)),j.push(this.H(G.language,!!G.checkControlFile));const[V,x]=await Promise.all(j);return this.D([...V,...x],0,G,!1)}async scanUserExtensions(G){const j=G.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const V=this.v.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,x=await this.J(j,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,V),ee=G.useCache&&!x.devMode&&x.excludeObsolete?this.j:this.k;let re;try{re=await ee.scanExtensions(x)}catch(te){if(te instanceof h.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),re=await ee.scanExtensions(x);else throw te}return re=await this.D(re,1,G,!0),this.s.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(G,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(x=>x.scheme===C.Schemas.file).map(async x=>{const ee=await this.J(x,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ee)).map(te=>(te.type=j.find(U=>(0,S.areSameExtensions)(U.identifier,te.identifier))?.type??te.type,this.k.validate(te,ee)))}))).flat();return this.D(V,"development",G,!0)}return[]}async scanExistingExtension(G,j,V){const x=await this.J(G,!1,j,!0,V.language,!0,void 0),ee=await this.k.scanExtension(x);return!ee||!V.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(G,j,V){const x=await this.J(G,!1,j,!0,V.language,!0,void 0),ee=await this.k.scanOneOrMultipleExtensions(x);return this.D(ee,j,V,!0)}async scanMetadata(G){const j=(0,m.joinPath)(G,"package.json"),V=(await this.r.readFile(j)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,j){const V=(0,m.joinPath)(G,"package.json"),x=(await this.r.readFile(V)).value.toString(),ee=JSON.parse(x);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...j},await this.r.writeFile((0,m.joinPath)(G,"package.json"),k.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof h.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw G}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.p.addExtensionsToProfile(G.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,c.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.s.error(G)}finally{this.z=void 0}})()),this.z}async D(G,j,V,x){return V.includeAllVersions||(G=this.F(j===0?G:void 0,j===1?G:void 0,j==="development"?G:void 0,await this.getTargetPlatform(),x)),V.includeInvalid||(G=G.filter(ee=>ee.isValid)),G.sort((ee,re)=>{const te=w.basename(ee.location.fsPath),U=w.basename(re.location.fsPath);return te<U?-1:te>U?1:0})}F(G,j,V,x,ee){const re=(U,B,W)=>{if(U.isValid&&!B.isValid)return!1;if(U.isValid===B.isValid){if(ee&&f.gt(U.manifest.version,B.manifest.version))return this.s.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(f.eq(U.manifest.version,B.manifest.version)){if(U.type===0)return this.s.debug(`Skipping extension ${B.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===x)return this.s.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${U.location.path} with ${B.location.path}.`):this.s.debug(`Overwriting user extension ${U.location.path} with ${B.location.path}.`),!0},te=new Map;return G?.forEach(U=>{const B=R.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!1))&&te.set(B,U)}),j?.forEach(U=>{const B=R.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);if(!W&&G&&U.type===0){this.s.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!W||re(W,U,!1))&&te.set(B,U)}),V?.forEach(U=>{const B=R.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!0))&&te.set(B,U),te.set(B,U)}),[...te.values()]}async G(G,j){this.s.trace("Started scanning system extensions");const V=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),ee=await(G&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",ee.length),ee}async H(G,j){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const x=j?await this.I():{},ee=[],re=l.URI.file(w.normalize(w.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of V){const B=x[U.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":ee.push((0,m.joinPath)(re,U.name));break;default:ee.push(l.URI.file(B));break}}const te=await Promise.all(ee.map(async U=>this.k.scanExtension(await this.J(U,!1,0,!0,G,!0,void 0))));return this.s.trace("Scanned dev system extensions:",te.length),(0,L.coalesce)(te)}async I(){try{const G=await this.r.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async J(G,j,V,x,ee,re,te){const U=await this.f(ee??g.language),B=await this.L(G),W=j&&!this.v.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,q=W?await this.L(W):void 0;return new A(G,B,W,q,j,te,V,x,re,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ee,U)}async L(G){try{const j=await this.r.stat(G);if(typeof j.mtime=="number")return j.mtime}catch{}}};F=ye([K(4,b.IUserDataProfilesService),K(5,h.IExtensionsProfileScannerService),K(6,c.IFileService),K(7,n.ILogService),K(8,p.IEnvironmentService),K(9,r.IProductService),K(10,E.IUriIdentityService),K(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class A{constructor(G,j,V,x,ee,re,te,U,B,W,q,J,_,Y,Q){this.location=G,this.mtime=j,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=x,this.profile=ee,this.profileScanOptions=re,this.type=te,this.excludeObsolete=U,this.validate=B,this.productVersion=W,this.productDate=q,this.productCommit=J,this.devMode=_,this.language=Y,this.translations=Q}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,j){return(0,m.isEqual)(G.location,j.location)&&G.mtime===j.mtime&&(0,m.isEqual)(G.applicationExtensionslocation,j.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&G.profile===j.profile&&D.equals(G.profileScanOptions,j.profileScanOptions)&&G.type===j.type&&G.excludeObsolete===j.excludeObsolete&&G.validate===j.validate&&G.productVersion===j.productVersion&&G.productDate===j.productDate&&G.productCommit===j.productCommit&&G.devMode===j.devMode&&G.language===j.language&&M.equals(G.translations,j.translations)}}e.ExtensionScannerInput=A;let $=class extends y.Disposable{constructor(G,j,V,x,ee){super(),this.f=G,this.g=j,this.h=V,this.i=x,this.j=ee}async scanExtensions(G){const j=G.profile?await this.l(G):await this.k(G);let V={};if(G.excludeObsolete&&G.type===1)try{const x=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(x)}catch{}return(0,u.isEmptyObject)(V)?j:j.filter(x=>!V[S.ExtensionKey.create(x).toString()])}async k(G){const j=await this.i.resolve(G.location);if(!j.children?.length)return[];const V=await Promise.all(j.children.map(async x=>{if(!x.isDirectory||G.type===1&&(0,m.basename)(x.resource).indexOf(".")===0)return null;const ee=new A(x.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ee)}));return(0,L.coalesce)(V).sort((x,ee)=>x.location.path<ee.location.path?-1:1)}async l(G){let j=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){j=j.filter(x=>!x.metadata?.isApplicationScoped);const V=await this.m(G.applicationExtensionslocation,x=>!!x.metadata?.isApplicationScoped,G);j.push(...V)}return j}async m(G,j,V){const x=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!x.length)return[];const ee=await Promise.all(x.map(async re=>{if(j(re)){const te=new A(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,re.metadata)}return null}));return(0,L.coalesce)(ee)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,m.joinPath)(G.location,"package.json"))){const j=await this.scanExtension(G);return j?[j]:[]}else return await this.scanExtensions(G)}catch(j){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(G,j){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=R.UNDEFINED_PUBLISHER),j=j??V.__metadata,delete V.__metadata;const x=(0,S.getGalleryExtensionId)(V.publisher,V.name),ee=j?.id?{id:x,uuid:j.id}:{id:x},re=j?.isSystem?0:G.type,te=re===0||!!j?.isBuiltin;O.ImplicitActivationEvents.updateManifest(V),V=await this.n(G.location,V,A.createNlsConfiguration(G));const U={type:re,identifier:ee,manifest:V,location:G.location,isBuiltin:te,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return G.validate?this.validate(U,G):U}}catch(V){G.type!==0&&this.j.error(V)}return null}validate(G,j){let V=!0;const x=(0,s.validateExtensionManifest)(j.productVersion,j.productDate,j.location,G.manifest,G.isBuiltin);for(const[ee,re]of x)ee===v.default.Error&&(V=!1,this.j.error(this.t(j.location,re)));return G.isValid=V,G.validations=x,G}async scanExtensionManifest(G){const j=(0,m.joinPath)(G,"package.json");let V;try{V=(await this.i.readFile(j)).value.toString()}catch(ee){return(0,c.toFileOperationResult)(ee)!==1&&this.j.error(this.t(G,(0,d.localize)(0,null,j.path,ee.message))),null}let x;try{x=JSON.parse(V)}catch{const re=[];(0,P.parse)(V,re);for(const te of re)this.j.error(this.t(G,(0,d.localize)(1,null,j.path,te.offset,te.length,(0,I.getParseErrorMessage)(te.error))));return null}return(0,P.getNodeType)(x)!=="object"?(this.j.error(this.t(G,(0,d.localize)(2,null,j.path))),null):x}async n(G,j,V){const x=await this.p(G,j,V);if(x)try{const ee=[],re=await this.r(x.default,ee);if(ee.length>0)return ee.forEach(U=>{this.j.error(this.t(G,(0,d.localize)(3,null,x.default?.path,(0,I.getParseErrorMessage)(U.error))))}),j;if((0,P.getNodeType)(x)!=="object")return this.j.error(this.t(G,(0,d.localize)(4,null,x.default?.path))),j;const te=x.values||Object.create(null);return(0,T.localizeManifest)(j,te,re)}catch{}return j}async p(G,j,V){const x=(0,m.joinPath)(G,"package.nls.json"),ee=(B,W)=>{W.forEach(q=>{this.j.error(this.t(G,(0,d.localize)(5,null,B?.path,(0,I.getParseErrorMessage)(q.error))))})},re=B=>{this.j.error(this.t(G,(0,d.localize)(6,null,B?.path)))},te=`${j.publisher}.${j.name}`,U=V.translations[te];if(U)try{const B=l.URI.file(U),W=(await this.i.readFile(B)).value.toString(),q=[],J=(0,P.parse)(W,q);return q.length>0?(ee(B,q),{values:void 0,default:x}):(0,P.getNodeType)(J)!=="object"?(re(B),{values:void 0,default:x}):{values:J.contents?J.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.i.exists(x))return;let W;try{W=await this.s(G,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const q=(await this.i.readFile(W.localized)).value.toString(),J=[],_=(0,P.parse)(q,J);return J.length>0?(ee(W.localized,J),{values:void 0,default:W.original}):(0,P.getNodeType)(_)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:_,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(G,j){if(G)try{const V=(await this.i.readFile(G)).value.toString();return(0,P.parse)(V,j)}catch{}}s(G,j){return new Promise((V,x)=>{const ee=re=>{const te=(0,m.joinPath)(G,`package.nls.${re}.json`);this.i.exists(te).then(U=>{U&&V({localized:te,original:(0,m.joinPath)(G,"package.nls.json")});const B=re.lastIndexOf("-");B===-1?V({localized:(0,m.joinPath)(G,"package.nls.json"),original:null}):(re=re.substring(0,B),ee(re))})};if(j.devMode||j.pseudo||!j.language)return V({localized:(0,m.joinPath)(G,"package.nls.json"),original:null});ee(j.language)})}t(G,j){return`[${G.path}]: ${j}`}};$=ye([K(1,h.IExtensionsProfileScannerService),K(2,E.IUriIdentityService),K(3,c.IFileService),K(4,n.ILogService)],$);let z=class extends ${constructor(G,j,V,x,ee,re){super(j,V,x,ee,re),this.y=G,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(G){const j=await this.z();if(this.u=G,j&&j.input&&A.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.v.trigger(()=>this.D()),j.result.map(x=>(x.location=l.URI.revive(x.location),x));const V=await super.scanExtensions(G);return await this.C({input:G,result:V}),V}async z(){try{const G=await this.i.readFile(this.y),j=JSON.parse(G.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(G))}return null}async C(G){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify(G)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const G=await this.z();if(!G)return;const j=G.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(V,j))try{await this.i.del(this.y),this.w.fire()}catch(x){this.j.error(x)}}};z=ye([K(2,h.IExtensionsProfileScannerService),K(3,E.IUriIdentityService),K(4,c.IFileService),K(5,n.ILogService)],z);function H(ie,G){const j=(0,S.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:j,identifier:new R.ExtensionIdentifier(j),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:G,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=H;class X extends F{constructor(G,j,V,x,ee,re,te,U,B,W,q,J){super(G,j,(0,m.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)(x,R.MANIFEST_CACHE_FOLDER),ee,re,te,U,B,W,q,J),this.M=(async()=>{if(g.translationsConfigFile)try{const _=await this.r.readFile(l.URI.file(g.translationsConfigFile));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(G){return this.M}}e.NativeExtensionsScannerService=X}),define(oe[268],ae([0,1,9,18,29,19,51,14,15,8]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let C=class extends N.AbstractExtensionsProfileScannerService{constructor(g,m,f,v,u,l){super(y.URI.file(g.extensionsPath),m,f,v,u,l)}};C=ye([K(0,I.INativeEnvironmentService),K(1,P.IFileService),K(2,i.IUserDataProfilesService),K(3,D.IUriIdentityService),K(4,k.ITelemetryService),K(5,L.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(oe[269],ae([0,1,50,6,38,3,2,24,12,28,9,18]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends N.Disposable{constructor(f,v){super(),this.b=f,this.f=v,this.a=new i.Limiter(5)}async postUninstall(f){const v=this.g(f,"uninstall");return v&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(v.script,"uninstall",v.args,!0,f).then(()=>this.f.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),u=>this.f.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${u}`)))),y.Promises.rm(this.j(f)).then(void 0,u=>this.f.error("Error while removing extension storage path",u))}g(f,v){const u=`vscode:${v}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[u]=="string"){const l=f.manifest.scripts[u].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${u} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(f,v,u,l,d){return new Promise((p,S)=>{const R=this.i(f,v,u,d);let s;const c=t=>{s&&(clearTimeout(s),s=null),t?S(t):p(void 0)};R.on("error",t=>{c((0,D.toErrorMessage)(t)||"Unknown")}),R.on("exit",(t,n)=>{c(t?`post-${v} process exited with code ${t}`:void 0)}),l&&(s=setTimeout(()=>{s=null,R.kill(),S("timed out")},5e3))})}i(f,v,u,l){const d={silent:!0,execArgv:void 0},p=(0,L.fork)(f,[`--type=extension-post-${v}`,...u],d);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const S=k.Event.fromNodeEventEmitter(p.stdout,"data"),R=k.Event.fromNodeEventEmitter(p.stderr,"data");S(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${v}`,t)),R(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${v}`,t));const s=k.Event.any(k.Event.map(S,t=>({data:`%c${t}`,format:[""]})),k.Event.map(R,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(s,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}j(f){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};g=ye([K(0,w.IUserDataProfilesService),K(1,C.ILogService)],g),e.ExtensionsLifecycle=g}),define(oe[270],ae([0,1,8,15,51,79,14,5,9,25,29,18]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends k.NativeExtensionsScannerService{constructor(f,v,u,l,d,p,S,R){super(L.URI.file(d.builtinExtensionsPath),L.URI.file(d.extensionsPath),d.userHome,L.URI.file(d.userDataPath),f,v,u,l,d,p,S,R)}};g=ye([K(0,w.IUserDataProfilesService),K(1,D.IExtensionsProfileScannerService),K(2,N.IFileService),K(3,I.ILogService),K(4,i.INativeEnvironmentService),K(5,y.IProductService),K(6,C.IUriIdentityService),K(7,P.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(oe[20],ae([0,1,6,3,2,102,13,69,5,18]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var g;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function m(d){const p=d.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=m;class f extends D.Disposable{constructor(p={flushInterval:f.a}){super(),this.j=p,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,S){if(S===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:S,target:this.F(p)[S]})}r(p){this.f.fire({reason:p})}get(p,S,R){return this.L(S)?.get(p,R)}getBoolean(p,S,R){return this.L(S)?.getBoolean(p,R)}getNumber(p,S,R){return this.L(S)?.getNumber(p,R)}store(p,S,R,s){if((0,N.isUndefinedOrNull)(S)){this.remove(p,R);return}this.t(()=>{this.u(p,R,s),this.L(R)?.set(p,S)})}remove(p,S){this.t(()=>{this.u(p,S,void 0),this.L(S)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,S){const R=[],s=this.F(p);for(const c of Object.keys(s))s[c]===S&&R.push(c);return R}u(p,S,R){const s=this.F(S);typeof R=="number"?s[p]!==R&&(s[p]=R,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(s))):typeof s[p]=="number"&&(delete s[p],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(s)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const S=this.L(p);return S?m(S):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=C.NONE){this.f.fire({reason:p});const S=this.L(-1),R=this.L(0),s=this.L(1);switch(p){case C.NONE:await L.Promises.settled([S?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await L.Promises.settled([S?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return l(p,S,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,S){return this.r(C.NONE),(0,y.isUserDataProfile)(p)?this.N(p,S):this.O(p,S)}H(p,S){return!(p.id===S.id||v(S)&&v(p))}I(p,S,R,s){this.t(()=>{if(s)for(const[c,t]of p)S.set(c,t);else{const c=new Set;for(const[t,n]of p)c.add(t),S.get(t)!==n&&this.n(R,t);for(const[t]of S.items)c.has(t)||this.n(R,t)}})}}e.AbstractStorageService=f,f.a=60*1e3;function v(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class u extends f{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=u;async function l(d,p,S,R,s,c){const t=O=>{try{return JSON.parse(O)}catch{return O}},n=new Map,r=new Map;d.forEach((O,M)=>{n.set(M,O),r.set(M,t(O))});const o=new Map,a=new Map;p.forEach((O,M)=>{o.set(M,O),a.set(M,t(O))});const h=new Map,b=new Map;S.forEach((O,M)=>{h.set(M,O),b.set(M,t(O))}),console.group(R!==s?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const E=[];if(n.forEach((O,M)=>{E.push({key:M,value:O})}),console.table(E),console.groupEnd(),console.log(r),R!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const O=[];o.forEach((M,F)=>{O.push({key:F,value:M})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const T=[];h.forEach((O,M)=>{T.push({key:M,value:O})}),console.table(T),console.groupEnd(),console.log(b)}e.logStorage=l}),define(oe[119],ae([0,1,3,2,13,30,33,20]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends i.Disposable{constructor(w,g){super(),this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new y(w)),this.B(this.b.onDidChange(m=>this.a.fire({extensions:m,source:"storage"}))),this.B(g.onDidInstallExtensions(m=>m.forEach(({local:f,operation:v})=>{f&&v===4&&this.f(f.identifier)})))}async enableExtension(w,g){return this.f(w)?(this.a.fire({extensions:[w],source:g}),!0):!1}async disableExtension(w,g){return this.c(w)?(this.a.fire({extensions:[w],source:g}),!0):!1}getDisabledExtensions(){return this.h(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(w){const g=this.getDisabledExtensions();return g.every(m=>!(0,N.areSameExtensions)(m,w))?(g.push(w),this.g(g),!0):!1}f(w){const g=this.getDisabledExtensions();for(let m=0;m<g.length;m++){const f=g[m];if((0,N.areSameExtensions)(f,w))return g.splice(m,1),this.g(g),!0}return!1}g(w){this.i(k.DISABLED_EXTENSIONS_STORAGE_PATH,w)}h(w){return this.b.get(w,0)}i(w,g){this.b.set(w,g,0)}};I=ye([K(0,P.IStorageService),K(1,k.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class y extends i.Disposable{constructor(w){super(),this.c=w,this.a=Object.create(null),this.b=this.B(new L.Emitter),this.onDidChange=this.b.event,this.B(w.onDidChangeValue(g=>this.f(g)))}get(w,g){let m;return g===0?((0,D.isUndefinedOrNull)(this.a[w])&&(this.a[w]=this.g(w,g)),m=this.a[w]):m=this.g(w,g),JSON.parse(m)}set(w,g,m){const f=JSON.stringify(g.map(({id:u,uuid:l})=>({id:u,uuid:l})));this.g(w,m)!==f&&(m===0&&(g.length?this.a[w]=f:delete this.a[w]),this.h(w,g.length?f:void 0,m))}f(w){if(w.scope===0&&!(0,D.isUndefinedOrNull)(this.a[w.key])&&this.g(w.key,w.scope)!==this.a[w.key]){const m=this.get(w.key,w.scope);delete this.a[w.key];const f=this.get(w.key,w.scope),v=m.filter(l=>!f.some(d=>(0,N.areSameExtensions)(l,d))),u=f.filter(l=>!m.some(d=>(0,N.areSameExtensions)(d,l)));(v.length||u.length)&&this.b.fire([...v,...u])}}g(w,g){return this.c.get(w,g,"[]")}h(w,g,m){g?this.c.store(w,g,m,1):this.c.remove(w,m)}}e.StorageManager=y}),define(oe[271],ae([0,1,21,23,7,4,36,13,8,16,15,30,33,70,14,9,25,60,238,20,19]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const R=k.isWeb?"web":(0,w.getTargetPlatform)(k.platform,N.arch);var s;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function c(...U){return String(U.reduce((B,W)=>B|W,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(B=a){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,W=this.d.pageSize){return new h({...this.d,pageNumber:B,pageSize:W})}withFilter(B,...W){const q=[...this.d.criteria,...W.length?W.map(J=>({filterType:B,value:J})):[{filterType:B}]];return new h({...this.d,criteria:q})}withSortBy(B){return new h({...this.d,sortBy:B})}withSortOrder(B){return new h({...this.d,sortOrder:B})}withFlags(...B){return new h({...this.d,flags:B.reduce((W,q)=>W|q,0)})}withAssetTypes(...B){return new h({...this.d,assetTypes:B})}withSource(B){return new h({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:W,pageSize:q,sortBy:J,sortOrder:_,flags:Y,assetTypes:Q}=this.d;return{filters:[{criteria:B,pageNumber:W,pageSize:q,sortBy:J,sortOrder:_}],assetTypes:Q,flags:Y}}get searchText(){const B=this.d.criteria.filter(W=>W.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function b(U,B){const W=(U||[]).filter(q=>q.statisticName===B)[0];return W?W.value:0}function E(U){const B="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(q=>q.assetType.indexOf(B)===0).reduce((q,J)=>{const _=M(U,J.assetType);return _&&q.push([J.assetType.substring(B.length),_]),q},[])}function T(U){if(U.properties){const B=U.properties.filter(J=>J.key===n.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=B.filter(J=>W.test(J.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return M(U,n.Repository)}function O(U){return{uri:`${U.fallbackAssetUri}/${n.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${n.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function M(U,B){return U.files.filter(q=>q.assetType===B)[0]?{uri:`${U.assetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function F(U,B){const W=U.properties?U.properties.filter(J=>J.key===B):[],q=W.length>0&&W[0].value;return q?q.split(",").map(J=>(0,g.adoptToGalleryExtensionId)(J)):[]}function A(U){const B=U.properties?U.properties.filter(W=>W.key===r.Engine):[];return B.length>0&&B[0].value||""}function $(U){const B=U.properties?U.properties.filter(W=>W.key===r.PreRelease):[];return B.length>0&&B[0].value==="true"}function z(U){const B=U.properties?U.properties.filter(q=>q.key===r.LocalizedLanguages):[],W=B.length>0&&B[0].value||"";return W?W.split(","):[]}function H(U){return U.properties?.find(B=>B.key===r.SponsorLink)?.value}function X(U){return U.indexOf("preview")!==-1}function ie(U){return U.targetPlatform?(0,w.toTargetPlatform)(U.targetPlatform):"undefined"}function G(U){const B=(0,L.distinct)(U.versions.map(ie)),W=!!U.tags?.includes(w.WEB_EXTENSION_TAG),q=B.indexOf("web");return W?q===-1&&B.push("web"):q!==-1&&B.splice(q,1),B}function j(U,B){const W=(0,w.getFallbackTargetPlarforms)(B);for(let q=0;q<U.length;q++){const J=U[q];if(J.version===U[q-1]?.version){let _=q;const Y=ie(J);if(Y===B)for(;_>0&&U[_-1].version===J.version;)_--;else if(W.includes(Y))for(;_>0&&U[_-1].version===J.version&&ie(U[_-1])!==B;)_--;_!==q&&(U.splice(q,1),U.splice(_,0,J))}}return U}e.sortExtensionVersions=j;function V(U,B,W){U.telemetryData={index:B,querySource:W}}function x(U,B,W){const q=U.versions[0],J={manifest:M(B,n.Manifest),readme:M(B,n.Details),changelog:M(B,n.Changelog),license:M(B,n.License),repository:T(B),download:O(B),icon:M(B,n.Icon),signature:M(B,n.Signature),coreTranslations:E(B)};return{identifier:{id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:B.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(q),description:U.shortDescription||"",installCount:b(U.statistics,"install"),rating:b(U.statistics,"averagerating"),ratingCount:b(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:W,assets:J,properties:{dependencies:F(B,r.Dependency),extensionPack:F(B,r.ExtensionPack),engine:A(B),localizedLanguages:z(B),targetPlatform:ie(B),isPreReleaseVersion:$(B)},hasPreReleaseVersion:$(q),hasReleaseVersion:!0,preview:X(U.flags),isSigned:!!J.signature}}let ee=class{constructor(B,W,q,J,_,Y,Q,se){this.k=W,this.l=q,this.n=J,this.o=_,this.q=Y,this.u=Q,this.w=se;const le=Q.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(Q.version,Q,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,W,q){const J=i.CancellationToken.isCancellationToken(W)?{}:W,_=i.CancellationToken.isCancellationToken(W)?W:q,Y=[],Q=[],se=[],le=[];let ue=!0;for(const be of B){be.uuid?Q.push(be.uuid):Y.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!Q.length&&!Y.length)return[];let pe=new h().withPage(1,B.length);Q.length&&(pe=pe.withFilter(t.ExtensionId,...Q)),Y.length&&(pe=pe.withFilter(t.ExtensionName,...Y)),(J.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions)),J.source&&(pe=pe.withSource(J.source));const{extensions:we}=await this.z(pe,{targetPlatform:J.targetPlatform??R,includePreRelease:se,versions:le,compatible:!!J.compatible},_);return J.source&&we.forEach((be,Ee)=>V(be,Ee,J.source)),we}async getCompatibleExtension(B,W,q){if((0,w.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(B,W,q))return B;const J=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:_}=await this.z(J,{targetPlatform:q,compatible:!0,includePreRelease:W},i.CancellationToken.None);return _[0]||null}async isExtensionCompatible(B,W,q){if(!(0,w.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,q)||!W&&B.properties.isPreReleaseVersion)return!1;let J=B.properties.engine;if(!J){const _=await this.getManifest(B,i.CancellationToken.None);if(!_)throw new Error("Manifest was not found");J=_.engines.vscode}return(0,m.isEngineValid)(J,this.u.version,this.u.date)}async y(B,W,q,J,_){if(!(0,w.isTargetPlatformCompatible)(ie(B),J,_)||W!=="any"&&$(B)!==(W==="prerelease"))return!1;if(q)try{const Y=await this.E(B);if(!(0,m.isEngineValid)(Y,this.u.version,this.u.date))return!1}catch(Y){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,D.getErrorMessage)(Y)),!1}return!0}async query(B,W){let q=B.text||"";const J=B.pageSize??50;let _=new h().withPage(1,J);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(_=_.withFilter(t.Category,we||pe),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(_=_.withFilter(t.Tag,we||pe),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),_=_.withFilter(t.SearchText,q)),_=_.withSortBy(0)):B.ids?_=_.withFilter(t.ExtensionId,...B.ids):B.names?_=_.withFilter(t.ExtensionName,...B.names):_=_.withSortBy(4),typeof B.sortBy=="number"&&(_=_.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(_=_.withSortOrder(B.sortOrder)),B.source&&(_=_.withSource(B.source));const Y=async(ue,pe)=>{const{extensions:we,total:be}=await this.z(ue,{targetPlatform:R,compatible:!1,includePreRelease:!!B.includePreRelease},pe);return we.forEach((Ee,Te)=>V(Ee,(ue.pageNumber-1)*ue.pageSize+Te,B.source)),{extensions:we,total:be}},{extensions:Q,total:se}=await Y(_,W),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new D.CancellationError;const{extensions:we}=await Y(_.withPage(ue+1),pe);return we};return{firstPage:Q,total:se,pageSize:_.pageSize,getPage:le}}async z(B,W,q){const J=B.flags;!!(B.flags&s.IncludeLatestVersionOnly)&&!!(B.flags&s.IncludeVersions)&&(B=B.withFlags(B.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(B.flags&s.IncludeLatestVersionOnly)&&!(B.flags&s.IncludeVersions)&&(B=B.withFlags(B.flags,s.IncludeLatestVersionOnly)),W.versions?.length&&(B=B.withFlags(B.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),B=B.withFlags(B.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:_,total:Y}=await this.B(B,q);if(!(B.flags&s.IncludeLatestVersionOnly)){const ue=[];for(const pe of _){const we=await this.A(pe,W);we&&ue.push(we)}return{extensions:ue,total:Y}}const se=[],le=new Map;for(let ue=0;ue<_.length;ue++){const pe=_[ue],we={id:(0,g.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,P.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Te=>(0,g.areSameExtensions)(Te,we))?.includePreRelease;if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(G(pe),W.targetPlatform))continue;const Ee=await this.A(pe,W);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==W.targetPlatform&&Ee.hasPreReleaseVersion?le.set(pe.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),pe=new h().withFlags(J&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:we}=await this.z(pe,W,q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of we){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:Y}}async A(B,W){const q={id:(0,g.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},J=W.versions?.find(se=>(0,g.areSameExtensions)(se,q))?.version,_=(0,P.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(se=>(0,g.areSameExtensions)(se,q))?.includePreRelease,Y=G(B),Q=j(B.versions,W.targetPlatform);if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(Y,W.targetPlatform))return null;for(let se=0;se<Q.length;se++){const le=Q[se];if(!(J&&le.version!==J)){if(await this.y(le,_?"any":"release",W.compatible,Y,W.targetPlatform))return x(B,le,Y);if(J&&le.version===J)return null}}return J||W.compatible?null:x(B,B.versions[0],Y)}async B(B,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,s.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,c(s.Unpublished));const q=await this.j,J=JSON.stringify(B.raw),_={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},Y=new Date().getTime();let Q,se,le=0;try{if(Q=await this.k.request({type:"POST",url:this.g&&B.criteria.some(pe=>pe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:_},W),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(Q);if(ue){const pe=ue.results[0],we=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-Y,success:!!Q&&(0,l.isSuccess)(Q),responseBodySize:Q?.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(B,W,q,J){if(!this.isEnabled())return;const _=k.isWeb?this.x(`/itemName/${B}.${W}/version/${q}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${W}/${q}/stats?statType=${J}`),Y=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:Y};try{await this.k.request({type:"POST",url:_,headers:se},i.CancellationToken.None)}catch{}}async download(B,W,q){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const J=(0,g.getGalleryExtensionTelemetryData)(B),_=new Date().getTime(),Y=ue=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:ue}),Q=q===2?"install":q===3?"update":"",se=Q?{uri:`${B.assets.download.uri}${I.URI.parse(B.assets.download.uri).query?"&":"?"}${Q}=true`,fallbackUri:`${B.assets.download.fallbackUri}${I.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${Q}=true`}:B.assets.download,le=await this.D(se);await this.q.writeFile(W,le.stream),Y(new Date().getTime()-_)}async downloadSignatureArchive(B,W){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const q=await this.D(B.assets.signature);await this.q.writeFile(W,q.stream)}async getReadme(B,W){if(B.assets.readme){const q=await this.D(B.assets.readme,{},W);return await(0,l.asTextOrError)(q)||""}return""}async getManifest(B,W){if(B.assets.manifest){const q=await this.D(B.assets.manifest,{},W),J=await(0,l.asTextOrError)(q);return J?JSON.parse(J):null}return null}async C(B,W){const q=M(B,n.Manifest);if(!q)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},_=await this.D(q,{headers:J});return await(0,l.asJson)(_)}async getCoreTranslation(B,W){const q=B.assets.coreTranslations.filter(J=>J[0]===W.toUpperCase())[0];if(q){const J=await this.D(q[1]),_=await(0,l.asTextOrError)(J);return _?JSON.parse(_):null}return null}async getChangelog(B,W){if(B.assets.changelog){const q=await this.D(B.assets.changelog,{},W);return await(0,l.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(B,W,q){let J=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?J=J.withFilter(t.ExtensionId,B.identifier.uuid):J=J.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:_}=await this.B(J,i.CancellationToken.None);if(!_.length)return[];const Y=G(_[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(Y,q))return[];const Q=[];await Promise.all(_[0].versions.map(async ue=>{try{await this.y(ue,W?"any":"release",!0,Y,q)&&Q.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of j(Q,q))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:$(ue)}));return se}async D(B,W={},q=i.CancellationToken.None){const J=await this.j,_={type:"GET"},Y={...J,...W.headers||{}};W={...W,..._,headers:Y};const Q=B.uri,se=B.fallbackUri,le={...W,url:Q};try{const ue=await this.k.request(le,q);if(ue.res.statusCode===200)return ue;const pe=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const pe=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:Q,message:pe});const we={...W,url:se};return this.k.request(we,q)}}async E(B){let W=A(B);if(!W){const q=await this.C(B,i.CancellationToken.None);if(!q)throw new Error("Manifest was not found");W=q.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const B=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,l.asJson)(B),q=[],J={};if(W){for(const _ of W.malicious)q.push({id:_});if(W.migrateToPreRelease)for(const[_,Y]of Object.entries(W.migrateToPreRelease))(!Y.engine||(0,m.isEngineValid)(Y.engine,this.u.version,this.u.date))&&(J[_.toLowerCase()]={disallowInstall:!0,extension:{id:Y.id,displayName:Y.displayName,autoMigrate:{storage:!!Y.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[_,Y]of Object.entries(W.deprecated))Y&&(J[_.toLowerCase()]=(0,P.isBoolean)(Y)?{}:Y)}return{malicious:q,deprecated:J}}};ee=ye([K(1,l.IRequestService),K(2,v.ILogService),K(3,C.IEnvironmentService),K(4,S.ITelemetryService),K(5,f.IFileService),K(6,u.IProductService),K(7,y.IConfigurationService)],ee);let re=class extends ee{constructor(B,W,q,J,_,Y,Q,se){super(B,W,q,J,_,Y,Q,se)}};re=ye([K(0,p.IStorageService),K(1,l.IRequestService),K(2,v.ILogService),K(3,C.IEnvironmentService),K(4,S.ITelemetryService),K(5,f.IFileService),K(6,u.IProductService),K(7,y.IConfigurationService)],re),e.ExtensionGalleryService=re;let te=class extends ee{constructor(B,W,q,J,_,Y,Q){super(void 0,B,W,q,J,_,Y,Q)}};te=ye([K(0,l.IRequestService),K(1,v.ILogService),K(2,C.IEnvironmentService),K(3,S.ITelemetryService),K(4,f.IFileService),K(5,u.IProductService),K(6,y.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(oe[80],ae([0,1,5,3,2,20,33,25,21,9,13]),function(Z,e,L,i,D,k,N,P,I,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class Ze extends D.Disposable{static b(f){return`extensionKeys/${(0,N.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static c(f){const v=w.exec(f);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(f,v){const u=await f.getInstalled(),l=[];for(const[d,p]of Ze.f(v)){const S=u.find(R=>(0,N.areSameExtensions)(R.identifier,{id:d}))?.manifest.version;for(const R of p)S!==R&&l.push(Ze.b({id:d,version:R}))}for(const d of l)v.remove(d,0)}static f(f){const v=new Map,u=f.keys(0,1);for(const l of u){const d=Ze.c(l);if(d){let p=v.get(d.id.toLowerCase());p||v.set(d.id.toLowerCase(),p=[]),p.push(d.version)}}return v}constructor(f,v,u){super(),this.i=f,this.j=v,this.k=u,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(f),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(f){if(f.scope!==0)return;if(this.h.has(f.key.toLowerCase())){this.g.fire();return}const v=Ze.c(f.key);if(v){if(this.i.get(f.key,0)===void 0)this.h.delete(v.id.toLowerCase());else{let u=this.h.get(v.id.toLowerCase());u||this.h.set(v.id.toLowerCase(),u=[]),u.push(v.version),this.g.fire()}return}}m(f){if((0,C.isString)(f))return f;const v=f.manifest?f.manifest.publisher:f.publisher,u=f.manifest?f.manifest.name:f.name;return(0,N.getExtensionId)(v,u)}getExtensionState(f,v){const u=this.m(f),l=this.getExtensionStateRaw(f,v);if(l)try{return JSON.parse(l)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${v}): ${d}`)}}getExtensionStateRaw(f,v){const u=this.m(f),l=this.i.get(u,v?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${v}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(f,v,u){const l=this.m(f);v===void 0?this.i.remove(l,u?0:1):this.i.store(l,JSON.stringify(v),u?0:1,1)}setKeysForSync(f,v){this.i.store(Ze.b(f),JSON.stringify(v),0,1)}getKeysForSync(f){const v=this.j.extensionSyncedKeys?.[f.id.toLowerCase()],u=this.i.get(Ze.b(f),0),l=u?JSON.parse(u):void 0;return l&&v?(0,I.distinct)([...l,...v]):l||v}addToMigrationList(f,v){if(f!==v){const u=this.n.filter(l=>!l.includes(f)&&!l.includes(v));u.push([f,v]),this.n=u}}getSourceExtensionToMigrate(f){const v=this.n.find(([,u])=>f===u);return v?v[0]:void 0}get n(){const f=this.i.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(f);if(Array.isArray(v))return v}catch{}return[]}set n(f){f.length?this.i.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};g.a=512*1024,g=ye([K(0,k.IStorageService),K(1,P.IProductService),K(2,y.ILogService)],g),e.ExtensionStorageService=g}),define(oe[272],ae([0,1,21,6,3,12,4,36,8,161,15,30,33,214,99,14,58,25,20,19]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const S="extensionTips/promptedExecutableTips",R="extensionTips/lastPromptedMediumImpExeTime";let s=class extends m.ExtensionTipsService{constructor(t,n,r,o,a,h,b,E){super(b,E),this.m=t,this.n=n,this.p=r,this.r=o,this.s=a,this.t=h,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([T,O])=>{const M=[],F=[],A=[];Object.entries(O.recommendations).forEach(([$,z])=>{z.important?O.important?M.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):F.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):A.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),M.length&&this.g.set(T,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:M}),F.length&&this.h.set(T,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:F}),A.length&&this.j.set(T,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:A})}),(0,i.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),n=await this.I(this.h);return[...t,...n]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),n=await this.I(this.h),r=await this.p.getInstalled();this.k=this.v(t,r),this.l=this.v(n,r)}v(t,n){const r=new Map;t.forEach(E=>r.set(E.extensionId.toLowerCase(),E));const{installed:o,uninstalled:a}=this.H([...r.keys()],n);for(const E of o){const T=r.get(E);T&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:T.exeName})}for(const E of a){const T=r.get(E);T&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:T.exeName})}const h=this.F(),b=new Map;for(const E of a){const T=r.get(E);if(T&&(!h[T.exeName]||!h[T.exeName].includes(T.extensionId))){let O=b.get(T.exeName);O||(O=[],b.set(T.exeName,O)),O.push(T)}}return b}w(){if(this.k.size===0)return;const[t,n]=[...this.k.entries()][0];this.z(n).then(r=>{switch(r){case"reacted":this.G(n[0].exeName,n);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const o=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(o(()=>this.w()));break}case"toomany":{const o=this.B((0,i.disposableTimeout)(()=>{o.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),n=Date.now()-t,r=7*24*60*60*1e3;if(n<r){const h=this.B((0,i.disposableTimeout)(()=>{h.dispose(),this.y()},r-n));return}const[o,a]=[...this.l.entries()][0];this.z(a).then(h=>{switch(h){case"reacted":{this.D(Date.now()),this.l.delete(o),this.G(a[0].exeName,a);const b=this.B((0,i.disposableTimeout)(()=>{b.dispose(),this.y()},r));break}case"ignored":this.l.delete(o),this.y();break;case"incompatibleWindow":{const b=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(b(()=>this.y()));break}case"toomany":{const b=this.B((0,i.disposableTimeout)(()=>{b.dispose(),this.y()},36e5));break}}})}async z(t){const n=await this.p.getInstalled(1),r=t.filter(a=>!a.whenNotInstalled||a.whenNotInstalled.every(h=>n.every(b=>!(0,g.areSameExtensions)(b.identifier,{id:h})))).map(({extensionId:a})=>a.toLowerCase()),o=(0,y.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(r,o,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(R,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(R,t,-1,1)}F(){return JSON.parse(this.r.get(S,-1,"{}"))}G(t,n){const r=this.F();r[t]=n.map(({extensionId:o})=>o.toLowerCase()),this.r.store(S,JSON.stringify(r),-1,0)}H(t,n){const r=[],o=[],a=n.reduce((h,b)=>(h.add(b.identifier.id.toLowerCase()),h),new Set);return t.forEach(h=>{a.has(h.toLowerCase())?r.push(h):o.push(h)}),{installed:r,uninstalled:o}}async I(t){const n=[],r=new Map;for(const o of t.keys()){const a=t.get(o);if(!a||!(0,L.isNonEmptyArray)(a.recommendations))continue;const h=[];N.isWindows?a.windowsPath&&h.push(a.windowsPath.replace("%USERPROFILE%",()=>P.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>P.env.ProgramFiles).replace("%APPDATA%",()=>P.env.APPDATA).replace("%WINDIR%",()=>P.env.WINDIR)):(h.push((0,k.join)("/usr/local/bin",o)),h.push((0,k.join)("/usr/bin",o)),h.push((0,k.join)(this.m.userHome.fsPath,o)));for(const b of h){let E=r.get(b);if(E===void 0&&(E=await this.b.exists(I.URI.file(b)),r.set(b,E)),E)for(const{extensionId:T,extensionName:O,isExtensionPack:M,whenNotInstalled:F}of a.recommendations)n.push({extensionId:T,extensionName:O,isExtensionPack:M,exeName:o,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:F})}}return n}};s=ye([K(0,C.INativeEnvironmentService),K(1,p.ITelemetryService),K(2,w.IExtensionManagementService),K(3,d.IStorageService),K(4,u.INativeHostService),K(5,f.IExtensionRecommendationNotificationService),K(6,v.IFileService),K(7,l.IProductService)],s),e.ExtensionTipsService=s}),define(oe[273],ae([0,1,6,2,22,69,20,76,18]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class y extends N.AbstractStorageService{constructor(w,g,m,f){super(),this.X=w,this.Y=g,this.Z=m,this.ab=f,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const w=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),g=this.B(new k.Storage(w));return this.B(g.onDidChangeStorage(m=>this.n(-1,m))),g}cb(w){this.Q.clear(),this.P=w;let g;if((0,N.isProfileUsingDefaultStorage)(w))g=this.s;else{const m=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),w));g=this.Q.add(new k.Storage(m))}return this.Q.add(g.onDidChangeStorage(m=>this.n(0,m))),g}db(w){this.U.clear(),this.S=w?.id;let g;if(w){const m=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),w));g=this.U.add(new k.Storage(m)),this.U.add(g.onDidChangeStorage(f=>this.n(1,f)))}return g}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(w){switch(w){case-1:return this.s;case 0:return this.R;default:return this.W}}M(w){switch(w){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(N.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(w,g){if(!this.H(this.P,w))return;const m=this.R,f=m.items;m!==this.s&&await m.close(),this.R=this.cb(w),await this.R.init(),this.I(f,this.R,0,g)}async O(w,g){const m=this.W,f=m?.items??new Map;await m?.close(),this.W=this.db(w),await this.W.init(),this.I(f,this.W,1,g)}hasScope(w){return(0,I.isUserDataProfile)(w)?this.P.id===w.id:this.S===w.id}}e.NativeStorageService=y}),define(oe[62],ae([0,1,2,69,5,20]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let N=class extends L.Disposable{constructor(y){super(),this.a=y}async readStorageData(y){return this.withProfileScopedStorageService(y,async C=>this.b(C))}async updateStorageData(y,C,w){return this.withProfileScopedStorageService(y,async g=>this.c(g,C,w))}async withProfileScopedStorageService(y,C){if(this.a.hasScope(y))return C(this.a);const w=await this.createStorageDatabase(y),g=new P(w);try{await g.initialize();const m=await C(g);return await g.flush(),m}finally{g.dispose(),await this.f(w)}}b(y){const C=new Map,w=g=>{for(const m of y.keys(0,g))C.set(m,{value:y.get(m,0),target:g})};return w(0),w(1),C}c(y,C,w){for(const[g,m]of C)y.store(g,m,0,w)}async f(y){try{await y.close()}finally{(0,L.isDisposable)(y)&&y.dispose()}}};N=ye([K(0,k.IStorageService)],N),e.AbstractUserDataProfileStorageService=N;class P extends k.AbstractStorageService{constructor(y){super({flushInterval:100}),this.p=this.B(new i.Storage(y))}J(){return this.p.init()}L(y){return y===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[274],ae([0,1,3,2,22,15,57,18]),function(Z,e,L,i,D,k,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,w,g){super(),this.b=[],this.c=this.B(new L.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=w.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(g.userRoamingDataHome,"profiles"),this.b=C.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(m=>{const f=m.added.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),v=m.removed.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),u=m.updated.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme));this.b=m.all.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:f,removed:v,updated:u,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,w,g){const m=await this.a.call("createNamedProfile",[C,w,g]);return(0,P.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(C,w,g,m){const f=await this.a.call("createProfile",[C,w,g,m]);return(0,P.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(C){const w=await this.a.call("createTransientProfile",[C]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(C,w){await this.a.call("setProfileForWorkspace",[C,w])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,w){const g=await this.a.call("updateProfile",[C,w]);return(0,P.reviveProfile)(g,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=ye([K(1,N.IMainProcessService),K(2,k.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(oe[275],ae([0,1,3,2,57,9,62,20,76,18,71]),function(Z,e,L,i,D,k,N,P,I,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let w=class extends N.AbstractUserDataProfileStorageService{constructor(m,f,v,u){super(v),this.h=m;const l=m.getChannel("profileStorageListener"),d=this.B(new i.MutableDisposable);this.g=this.B(new L.Emitter({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(p=>{u.trace("profile storage changes",p),this.g.fire({targetChanges:p.targetChanges.map(S=>(0,y.reviveProfile)(S,f.profilesHome.scheme)),valueChanges:p.valueChanges.map(S=>({...S,profile:(0,y.reviveProfile)(S.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(m){const f=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(m)?new I.ApplicationStorageDatabaseClient(f):new I.ProfileStorageDatabaseClient(f,m)}};w=ye([K(0,D.IMainProcessService),K(1,y.IUserDataProfilesService),K(2,P.IStorageService),K(3,k.ILogService)],w),e.UserDataProfileStorageService=w,(0,C.registerSingleton)(N.IUserDataProfileStorageService,w,1)}),define(oe[41],ae([0,1,21,6,17,23,3,35,2,27,13,178,16,15,14,9,45,20,19,29,26,18]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function s(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||c(h.syncData)))}e.isRemoteUserData=s;function c(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=c;function t(h,b){return`${(0,y.uppercaseFirstLetter)(h)}${b.isDefault?"":` (${b.name})`}`}e.getSyncResourceLogLabel=t;let n=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(b,E,T,O,M,F,A,$,z,H,X,ie){super(),this.syncResource=b,this.collection=E,this.C=T,this.D=O,this.F=M,this.G=F,this.H=A,this.I=$,this.J=z,this.L=H,this.M=X,this.c=null,this.k="idle",this.l=this.B(new N.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new N.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new N.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(b.syncResource,b.profile),this.h=ie.extUri,this.f=this.h.joinPath(O.userDataSyncHome,...(0,S.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,S.PREVIEW_DIR_NAME),this.u=(0,S.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,O,this.h),this.j=(0,u.getServiceMachineId)(O,T,M)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const E=await this.S(b.remoteUserData,b.lastSyncUserData,!0,this.lb());this.O(E)}else{this.L.trace(`${this.y}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.rb(b):!0)&&this.t.fire()}}O(b){this.k!==b&&(this.k=b,this.l.fire(b))}async sync(b,E={}){await this.P(b,!0,this.lb(),E)}async preview(b,E,T={}){return this.P(b,!1,E,T)}async apply(b,E={}){try{this.z={...E};const T=await this.X(b);return this.O(T),this.c}finally{this.z={}}}async P(b,E,T,O){try{if(this.z={...O},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let M="idle";try{const F=await this.getLastSyncUserData(),A=await this.R(b,F);return M=await this.S(A,F,E,T),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(M)}}finally{this.z={}}}async replace(b){const E=this.hb(b);if(!E)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const T=await this.getLastSyncUserData(),O=await this.R(null,T),M=await this.Q(O),F=await this.nb({ref:O.ref,syncData:E},T,M,this.lb(),k.CancellationToken.None),A=[];for(const $ of F){const z=await this.pb($,$.remoteResource,void 0,k.CancellationToken.None),{remoteChange:H}=await this.pb($,$.previewResource,$.remoteContent,k.CancellationToken.None);A.push([$,{...z,remoteChange:H!==0?H:2}])}await this.qb(O,T,A,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(b){const E=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===E}async R(b,E){if(E){const T=b?b[this.resource]:void 0;if(E.ref===T||T===void 0&&E.syncData===null)return E}return this.getRemoteUserData(E)}async S(b,E,T,O){if(b.syncData&&b.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new S.UserDataSyncError((0,w.localize)(0,null,this.resource,this.mb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(b,E,T,O)}catch(M){if(M instanceof S.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(b,E,T,O);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),E=await this.getLastSyncUserData(),this.S(b,E,T,O)}throw M}}async U(b,E,T,O){try{const M=await this.Q(b),F=!M&&E===null&&this.db()!==void 0,A=T&&!F;this.c||(this.c=(0,i.createCancelablePromise)(z=>this.bb(b,E,M,A,O,z)));let $=await this.c;if(T&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of $.resourcePreviews)$=await this.accept(z.remoteResource)||$}return this.Z($.resourcePreviews),$.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":T?await this.X(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(b){return await this.W(b,async E=>{const T=await this.ob(E,k.CancellationToken.None);await this.C.writeFile(E.previewResource,D.VSBuffer.fromString(T?.content||""));const O=T&&!T.hasConflicts?await this.pb(E,E.previewResource,void 0,k.CancellationToken.None):void 0;return E.acceptResult=O,E.mergeState=T.hasConflicts?"conflict":O?"accepted":"preview",E.localChange=O?O.localChange:T.localChange,E.remoteChange=O?O.remoteChange:T.remoteChange,E}),this.c}async accept(b,E){return await this.W(b,async T=>{const O=await this.pb(T,b,E,k.CancellationToken.None);return T.acceptResult=O,T.mergeState="accepted",T.localChange=O.localChange,T.remoteChange=O.remoteChange,T}),this.c}async discard(b){return await this.W(b,async E=>{const T=await this.ob(E,k.CancellationToken.None);return await this.C.writeFile(E.previewResource,D.VSBuffer.fromString(T.content||"")),E.acceptResult=void 0,E.mergeState="preview",E.localChange=T.localChange,E.remoteChange=T.remoteChange,E}),this.c}async W(b,E){if(!this.c)return;let T=await this.c;const O=T.resourcePreviews.findIndex(({localResource:M,remoteResource:F,previewResource:A})=>this.h.isEqual(M,b)||this.h.isEqual(F,b)||this.h.isEqual(A,b));O!==-1&&(this.c=(0,i.createCancelablePromise)(async M=>{const F=[...T.resourcePreviews];return F[O]=await E(F[O]),{...T,resourcePreviews:F}}),T=await this.c,this.Z(T.resourcePreviews),T.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(b){if(!this.c)return"idle";const E=await this.c;return E.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":E.resourcePreviews.some(({mergeState:T})=>T!=="accepted")?"syncing":(await this.qb(E.remoteUserData,E.lastSyncUserData,E.resourcePreviews.map(T=>[T,T.acceptResult]),b),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(b){const E=b.filter(({mergeState:T})=>T==="conflict");(0,L.equals)(this.m,E,(T,O)=>this.h.isEqual(T.previewResource,O.previewResource))||(this.m=E,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async ab(b){const E=this.c?await this.c:null;if(E)for(const T of E.resourcePreviews){if(this.h.isEqual(T.acceptedResource,b))return T.acceptResult?T.acceptResult.content:null;if(this.h.isEqual(T.remoteResource,b))return T.remoteContent;if(this.h.isEqual(T.localResource,b))return T.localContent;if(this.h.isEqual(T.baseResource,b))return T.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(b){(0,f.toFileOperationResult)(b)!==1&&this.L.error(b)}}async bb(b,E,T,O,M,F){const A=await this.nb(b,E,T,M,F),$=[];for(const z of A){const H=z.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)$.push({...z,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=O?await this.ob(z,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(X?.content||""));const ie=X&&!X.hasConflicts?await this.pb(z,z.previewResource,void 0,F):void 0;$.push({...z,acceptResult:ie,mergeState:X?.hasConflicts?"conflict":ie?"accepted":"preview",localChange:ie?ie.localChange:X?X.localChange:z.localChange,remoteChange:ie?ie.remoteChange:X?X.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:E,resourcePreviews:$,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){let b=this.db();if(b||(b=await this.gb()),!b)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const E=JSON.parse(b),T=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!E.version&&!!T&&E.version!==T,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${E.version} is not compatible with current sync state version ${T}.`),await this.resetLocal(),null;let O,M=1;for(;O===void 0&&M++<6;)try{const F=await this.eb();F&&(F.ref===E.ref?O=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof f.FileOperationError&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof S.UserDataSyncError)throw F;this.L.error(F,M)}}if(O===void 0)try{const F=await this.G.resolveResourceContent(this.resource,E.ref,this.collection,this.z);O=F===null?null:this.hb(F),await this.fb({ref:E.ref,syncData:O})}catch(F){if(F instanceof S.UserDataSyncError&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return O===void 0?null:{...E,syncData:O}}async cb(b,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const T=this.I.getResourceSyncStateVersion(this.resource),O={ref:b.ref,version:T,...E};this.F.store(this.v,JSON.stringify(O),-1,1),await this.fb(b)}db(){return this.F.get(this.v,-1)}async eb(){const b=(await this.C.readFile(this.u)).value.toString();try{const E=b?JSON.parse(b):void 0;if(s(E))return E}catch(E){this.L.error(E)}}async fb(b){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(b)))}async gb(){try{const b=await this.C.readFile(this.u),E=JSON.parse(b.value.toString());await this.C.del(this.u),E.ref&&E.content!==void 0&&(this.F.store(this.v,JSON.stringify({...E,content:void 0}),-1,1),await this.fb({ref:E.ref,syncData:E.content===null?null:JSON.parse(E.content)}))}catch(b){b instanceof f.FileOperationError&&b.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(b)}return this.F.get(this.v,-1)}async getRemoteUserData(b){const{ref:E,content:T}=await this.ib(b);let O=null;return T!==null&&(O=this.hb(T)),{ref:E,syncData:O}}hb(b){try{const E=JSON.parse(b);if(c(E))return E}catch(E){this.L.error(E)}throw new S.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(b){const E=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.G.readResource(this.resource,E,this.collection,this.z)}async jb(b,E){const T=await this.j,O={version:this.mb,machineId:T,content:b};try{return E=await this.G.writeResource(this.resource,JSON.stringify(O),E,this.collection,this.z),{ref:E,syncData:O}}catch(M){throw M instanceof S.UserDataSyncError&&M.code==="TooLarge"&&(M=new S.UserDataSyncError(M.message,M.code,this.resource)),M}}async kb(b){const E={version:this.mb,content:b};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(E))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=ye([K(2,f.IFileService),K(3,m.IEnvironmentService),K(4,l.IStorageService),K(5,S.IUserDataSyncStoreService),K(6,S.IUserDataSyncBackupStoreService),K(7,S.IUserDataSyncEnablementService),K(8,d.ITelemetryService),K(9,S.IUserDataSyncLogService),K(10,g.IConfigurationService),K(11,p.IUriIdentityService)],n),e.AbstractSynchroniser=n;let r=class extends n{constructor(b,E,T,O,M,F,A,$,z,H,X,ie,G){super(E,T,O,M,F,A,$,z,H,X,ie,G),this.i=b,this.B(this.C.watch(this.h.dirname(b))),this.B(this.C.onDidFilesChange(j=>this.tb(j)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(b,E,T){try{E?await this.C.writeFile(this.i,D.VSBuffer.fromString(b),T?void 0:E):await this.C.createFile(this.i,D.VSBuffer.fromString(b),{overwrite:T})}catch(O){throw O instanceof f.FileOperationError&&O.fileOperationResult===1||O instanceof f.FileOperationError&&O.fileOperationResult===3?new S.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}async sb(){try{await this.C.del(this.i)}catch(b){if(!(b instanceof f.FileOperationError&&b.fileOperationResult===1))throw b}}tb(b){!b.contains(this.i)||this.triggerLocalChange()}};r=ye([K(3,f.IFileService),K(4,m.IEnvironmentService),K(5,l.IStorageService),K(6,S.IUserDataSyncStoreService),K(7,S.IUserDataSyncBackupStoreService),K(8,S.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,S.IUserDataSyncLogService),K(11,g.IConfigurationService),K(12,p.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let o=class extends r{constructor(b,E,T,O,M,F,A,$,z,H,X,ie,G,j){super(b,E,T,O,M,F,A,$,z,H,X,G,j),this.ub=ie,this.wb=void 0}vb(b,E){const T=[],O=(0,P.parse)(b,T,{allowEmptyContent:!0,allowTrailingComma:!0});return T.length>0||!(0,C.isUndefined)(O)&&E!==Array.isArray(O)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};o=ye([K(3,f.IFileService),K(4,m.IEnvironmentService),K(5,l.IStorageService),K(6,S.IUserDataSyncStoreService),K(7,S.IUserDataSyncBackupStoreService),K(8,S.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,S.IUserDataSyncLogService),K(11,S.IUserDataSyncUtilService),K(12,g.IConfigurationService),K(13,p.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let a=class{constructor(b,E,T,O,M,F,A){this.resource=b,this.g=E,this.h=T,this.j=O,this.k=M,this.l=F,this.d=A.extUri,this.f=(0,S.getLastSyncResourceUri)(void 0,this.resource,T,this.d)}async initialize({ref:b,content:E}){if(!E){this.j.info("Remote content does not exist.",this.resource);return}const T=this.m(E);if(!!T)try{await this.doInitialize({ref:b,syncData:T})}catch(O){this.j.error(O)}}m(b){try{const E=JSON.parse(b);if(c(E))return E}catch(E){this.j.error(E)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const T={ref:b.ref,version:void 0,...E};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(T),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(b)))}};a=ye([K(1,R.IUserDataProfilesService),K(2,m.IEnvironmentService),K(3,v.ILogService),K(4,f.IFileService),K(5,l.IStorageService),K(6,p.IUriIdentityService)],a),e.AbstractInitializer=a}),define(oe[120],ae([0,1,6,23,7,3,43,2,27,16,15,119,30,33,80,14,5,72,9,20,19,29,18,41,257,117,26,62]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R,s,c,t,n,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(M,F){const A=JSON.parse(M.content);if(M.version===1||M.version===2){const $=(await F.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of A)M.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),M.version===2&&$.every(H=>!(0,m.areSameExtensions)(H.identifier,z.identifier))&&(z.installed=!0)}return A}function h(M){return JSON.parse(M.content)}e.parseExtensions=h;function b(M,F){return M.sort((A,$)=>!A.identifier.uuid&&$.identifier.uuid?-1:A.identifier.uuid&&!$.identifier.uuid?1:(0,I.compare)(A.identifier.id,$.identifier.id)),F?(0,N.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=b;let E=class extends c.AbstractSynchroniser{constructor(F,A,$,z,H,X,ie,G,j,V,x,ee,re,te,U,B,W){super({syncResource:"extensions",profile:F},A,z,$,H,X,ie,ee,re,V,x,U),this.yb=G,this.zb=j,this.Ab=W,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(T),this.B(k.Event.any(k.Event.filter(this.yb.onDidInstallExtensions,q=>q.some(({local:J})=>!!J)),k.Event.filter(this.yb.onDidUninstallExtension,q=>!q.error),k.Event.filter(B.onDidChange,q=>q.valueChanges.some(({profile:J,changes:_})=>this.syncResource.profile.id===J.id&&_.some(Y=>Y.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),te.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(F,A){const $=F.syncData?await a(F.syncData,this.yb):null,z=A?.skippedExtensions||[],H=A?.builtinExtensions||[],X=A?.syncData?await a(A.syncData,this.yb):null,{localExtensions:ie,ignoredExtensions:G}=await this.xb.getLocalExtensions(this.syncResource.profile);$?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:V}=(0,t.merge)(ie,$,X,z,G,H),x={local:j,remote:V,content:this.Db(ie,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:V!==null?2:0},ee=this.Jb(ie,!1);return[{skippedExtensions:z,builtinExtensions:H,baseResource:this.tb,baseContent:X?this.Jb(X,!1):ee,localResource:this.ub,localContent:ee,localExtensions:ie,remoteResource:this.vb,remoteExtensions:$,remoteContent:$?this.Jb($,!1):null,previewResource:this.sb,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.wb}]}async rb(F){const A=F.syncData?await a(F.syncData,this.yb):null,{localExtensions:$,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:H}=(0,t.merge)($,A,A,F.skippedExtensions||[],z,F.builtinExtensions||[]);return H!==null}Db(F,A,$,z){const H=[...A,...$],X=new Set,ie=G=>{X.add(G.id.toLowerCase()),G.uuid&&X.add(G.uuid)};H.forEach(({identifier:G})=>ie(G)),z.forEach(ie);for(const G of F)X.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&X.has(G.identifier.uuid)||H.push(G);return this.Jb(H,!1)}async ob(F,A){return{...F.previewResult,hasConflicts:!1}}async pb(F,A,$,z){if(this.h.isEqual(A,this.ub))return this.Gb(F);if(this.h.isEqual(A,this.vb))return this.Hb(F);if(this.h.isEqual(A,this.sb))return F.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async Gb(F){const A=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(A),z=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,$,F.builtinExtensions),{local:H,remote:X}=z;return{content:F.localContent,local:H,remote:X,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:X!==null?2:0}}async Hb(F){const A=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(A),z=F.remoteContent?JSON.parse(F.remoteContent):null;if(z!==null){const H=(0,t.merge)(F.localExtensions,z,F.localExtensions,[],$,F.builtinExtensions),{local:X,remote:ie}=H;return{content:F.remoteContent,local:X,remote:ie,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:ie!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(F,A,$,z){let{skippedExtensions:H,localExtensions:X}=$[0][0];const{local:ie,remote:G,localChange:j,remoteChange:V}=$[0][1];if(j===0&&V===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),j!==0&&(await this.kb(JSON.stringify(X)),H=await this.xb.updateLocalExtensions(ie.added,ie.removed,ie.updated,H,this.syncResource.profile)),G){this.L.trace(`${this.y}: Updating remote extensions...`);const x=JSON.stringify(G.all);F=await this.jb(x,z?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${G.added.length?` Added: ${JSON.stringify(G.added.map(ee=>ee.identifier.id))}.`:""}${G.updated.length?` Updated: ${JSON.stringify(G.updated.map(ee=>ee.identifier.id))}.`:""}${G.removed.length?` Removed: ${JSON.stringify(G.removed.map(ee=>ee.identifier.id))}.`:""}`)}if(A?.ref!==F.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const x=X.filter(ee=>!ee.installed).map(ee=>ee.identifier);await this.cb(F,{skippedExtensions:H,builtinExtensions:x}),this.L.info(`${this.y}: Updated last synchronized extensions.${H.length?` Skipped: ${JSON.stringify(H.map(ee=>ee.identifier.id))}.`:""}`)}}async resolveContent(F){if(this.h.isEqual(this.vb,F)||this.h.isEqual(this.tb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.wb,F)){const A=await this.ab(F);return A&&this.Jb(JSON.parse(A),!0)}return null}Jb(F,A){return b(F,A)}async hasLocalData(){try{const{localExtensions:F}=await this.xb.getLocalExtensions(this.syncResource.profile);if(F.some(A=>A.installed||A.disabled))return!0}catch{}return!1}};E=ye([K(2,C.IEnvironmentService),K(3,v.IFileService),K(4,p.IStorageService),K(5,r.IUserDataSyncStoreService),K(6,r.IUserDataSyncBackupStoreService),K(7,g.IExtensionManagementService),K(8,n.IIgnoredExtensionsManagementService),K(9,r.IUserDataSyncLogService),K(10,y.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,S.ITelemetryService),K(13,f.IExtensionStorageService),K(14,R.IUriIdentityService),K(15,o.IUserDataProfileStorageService),K(16,u.IInstantiationService)],E),e.ExtensionsSynchroniser=E;let T=class{constructor(F,A,$,z,H,X){this.a=F,this.b=A,this.c=$,this.d=z,this.f=H,this.g=X}async getLocalExtensions(F){const A=await this.a.getInstalled(void 0,F.extensionsResource),$=this.d.getIgnoredExtensions(A);return{localExtensions:await this.j(F,async(H,X)=>{const ie=H.getDisabledExtensions();return A.map(G=>{const{identifier:j,isBuiltin:V,manifest:x,preRelease:ee}=G,re={identifier:j,preRelease:ee,version:x.version};ie.some(te=>(0,m.areSameExtensions)(te,j))&&(re.disabled=!0),V||(re.installed=!0);try{const te=X.getKeysForSync({id:j.id,version:x.version});if(te){const U=X.getExtensionState(G,!0)||{};re.state=Object.keys(U).reduce((B,W)=>(te.includes(W)&&(B[W]=U[W]),B),{})}}catch(te){this.g.info(`${(0,c.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,D.getErrorMessage)(te))}return re})}),ignoredExtensions:$}}async updateLocalExtensions(F,A,$,z,H){const X=(0,c.getSyncResourceLogLabel)("extensions",H),ie=[],G=[],j=[],V=await this.a.getInstalled(void 0,H.extensionsResource);if((F.length||$.length)&&await this.j(H,async(ee,re)=>{await L.Promises.settled([...F,...$].map(async te=>{const U=V.find(W=>(0,m.areSameExtensions)(W.identifier,te.identifier));if(U&&U.isBuiltin){te.state&&U.manifest.version===te.version&&this.h(te.state,U,U.manifest.version,re),ee.getDisabledExtensions().some(q=>(0,m.areSameExtensions)(q,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id),await ee.disableExtension(te.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id),await ee.enableExtension(te.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id))),G.push(te.identifier);return}const B=(await this.c.getExtensions([{...te.identifier,preRelease:te.preRelease}],i.CancellationToken.None))[0];if(te.state&&(U?U.manifest.version===te.version:!!B)&&this.h(te.state,U||B,U?.manifest.version,re),B)try{ee.getDisabledExtensions().some(q=>(0,m.areSameExtensions)(q,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id,B.version),await ee.disableExtension(B.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id,B.version)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id,B.version),await ee.enableExtension(B.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id,B.version))),(!U||U.preRelease!==te.preRelease)&&(await this.a.canInstall(B)?ie.push([te,B]):(this.g.info(`${X}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),j.push(te)))}catch(W){j.push(te),this.g.error(W),this.g.info(`${X}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else j.push(te),this.g.info(`${X}: Skipped synchronizing extension because the extension is not found.`,te.identifier.id)}))}),A.length){const ee=V.filter(({identifier:re,isBuiltin:te})=>!te&&A.some(U=>(0,m.areSameExtensions)(re,U)));await L.Promises.settled(ee.map(async re=>{this.g.trace(`${X}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:H.extensionsResource}),this.g.info(`${X}: Uninstalled local extension.`,re.identifier.id),G.push(re.identifier)}))}for(const[ee,re]of ie)try{this.g.trace(`${X}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:ee.preRelease,profileLocation:H.extensionsResource,context:{[r.EXTENSIONS_SYNC_CONTEXT_KEY]:!0}}),this.g.info(`${X}: Installed extension.`,re.identifier.id,re.version),G.push(re.identifier)}catch(te){j.push(ee),te instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatiblePreRelease,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(te.code)?this.g.info(`${X}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(te),this.g.info(`${X}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const x=[];for(const ee of z)G.some(re=>(0,m.areSameExtensions)(re,ee.identifier))||x.push(ee);for(const ee of j)x.some(re=>(0,m.areSameExtensions)(re.identifier,ee.identifier))||x.push(ee);return x}h(F,A,$,z){const H=z.getExtensionState(A,!0)||{},X=$?z.getKeysForSync({id:A.identifier.id,version:$}):void 0;X?X.forEach(ie=>{H[ie]=F[ie]}):Object.keys(F).forEach(ie=>H[ie]=F[ie]),z.setExtensionState(A,H,!0)}async j(F,A){return this.b.withProfileScopedStorageService(F,async $=>{const z=new P.DisposableStore,H=this.f.createChild(new l.ServiceCollection([p.IStorageService,$])),X=z.add(H.createInstance(w.GlobalExtensionEnablementService)),ie=z.add(H.createInstance(f.ExtensionStorageService));try{return await A(X,ie)}finally{z.dispose()}})}};T=ye([K(0,g.IExtensionManagementService),K(1,o.IUserDataProfileStorageService),K(2,g.IExtensionGalleryService),K(3,n.IIgnoredExtensionsManagementService),K(4,u.IInstantiationService),K(5,r.IUserDataSyncLogService)],T),e.LocalExtensionsProvider=T;let O=class extends c.AbstractInitializer{constructor(F,A,$,z,H,X,ie,G){super("extensions",z,H,X,$,ie,G),this.o=F,this.p=A}async q(F){return F.syncData?await a(F.syncData,this.o):null}t(F,A){const $=[],z=[],H=[];for(const X of F){if(this.p.hasToNeverSyncExtension(X.identifier.id))continue;const ie=A.find(G=>(0,m.areSameExtensions)(G.identifier,X.identifier));ie?($.push(ie),X.disabled&&H.push(X.identifier)):X.installed&&(z.push({...X.identifier,preRelease:!!X.preRelease}),X.disabled&&H.push(X.identifier))}return{installedExtensions:$,newExtensions:z,disabledExtensions:H,remoteExtensions:F}}};O=ye([K(0,g.IExtensionManagementService),K(1,n.IIgnoredExtensionsManagementService),K(2,v.IFileService),K(3,s.IUserDataProfilesService),K(4,C.IEnvironmentService),K(5,d.ILogService),K(6,p.IStorageService),K(7,R.IUriIdentityService)],O),e.AbstractExtensionsInitializer=O}),define(oe[121],ae([0,1,17,7,3,35,43,4,31,16,15,14,9,45,20,19,29,41,61,261,26,18,62,5]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",n=["locale"];function r(T,O){const M=T.storage?Object.keys(T.storage).sort():[],F={};return M.forEach(A=>F[A]=T.storage[A]),T.storage=F,O?(0,N.toFormattedString)(T,{}):JSON.stringify(T)}e.stringify=r;const o=1;let a=class extends l.AbstractSynchroniser{constructor(O,M,F,A,$,z,H,X,ie,G,j,V,x,ee){super({syncResource:"globalState",profile:O},M,A,X,V,$,z,ie,G,H,j,x),this.wb=F,this.mb=o,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ee.createInstance(h),this.B(A.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(A.onDidFilesChange,re=>re.contains(this.D.argvResource)),D.Event.filter(F.onDidChange,re=>!!(re.targetChanges.some(te=>this.syncResource.profile.id===te.id)||re.valueChanges.some(({profile:te,changes:U})=>this.syncResource.profile.id===te.id&&U.some(B=>B.target===0)))))(()=>this.triggerLocalChange()))}async nb(O,M,F){const A=O.syncData?JSON.parse(O.syncData.content):null;M=M===null&&F?O:M;const $=M&&M.syncData?JSON.parse(M.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);A?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.Eb($),{local:X,remote:ie}=(0,p.merge)(z.storage,A?A.storage:null,$?$.storage:null,H,this.L),G={content:null,local:X,remote:ie,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:ie.all!==null?2:0},j=r(z,!1);return[{baseResource:this.r,baseContent:$?r($,!1):j,localResource:this.sb,localContent:j,localUserData:z,remoteResource:this.tb,remoteContent:A?r(A,!1):null,previewResource:this.p,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.ub,storageKeys:H}]}async rb(O){const M=O.syncData?JSON.parse(O.syncData.content):null;if(M===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),A=await this.Eb(M),{remote:$}=(0,p.merge)(F.storage,M.storage,M.storage,A,this.L);return $.all!==null}async ob(O,M){return{...O.previewResult,hasConflicts:!1}}async pb(O,M,F,A){if(this.h.isEqual(M,this.sb))return this.Bb(O);if(this.h.isEqual(M,this.tb))return this.Cb(O);if(this.h.isEqual(M,this.p))return O.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Bb(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async Cb(O){if(O.remoteContent!==null){const M=JSON.parse(O.remoteContent),{local:F,remote:A}=(0,p.merge)(O.localUserData.storage,M.storage,null,O.storageKeys,this.L);return{content:O.remoteContent,local:F,remote:A,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(O,M,F,A){const{localUserData:$}=F[0][0],{local:z,remote:H,localChange:X,remoteChange:ie}=F[0][1];if(X===0&&ie===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),X!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify($)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),ie!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const G=JSON.stringify({storage:H.all});O=await this.jb(G,A?null:O.ref),this.L.info(`${this.y}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}M?.ref!==O.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(O),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(O){if(this.h.isEqual(this.tb,O)||this.h.isEqual(this.r,O)||this.h.isEqual(this.sb,O)||this.h.isEqual(this.ub,O)){const M=await this.ab(O);return M&&r(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(O){const M=await this.wb.readStorageData(this.syncResource.profile),F=[],A=[];for(const[H,X]of M)X.target===0?F.push(H):X.target===1&&A.push(H);const $=[...F,...A],z=O?.storage?Object.keys(O.storage).filter(H=>!H.startsWith(t)&&!$.includes(H)&&M.get(H)!==void 0):[];if(!P.isWeb){const H=[...S.ALL_SYNC_RESOURCES.map(X=>(0,S.getEnablementKey)(X)),S.SYNC_SERVICE_URL_TYPE];z.push(...H),A.push(...H)}return{user:F,machine:A,unregistered:z}}};a=ye([K(2,s.IUserDataProfileStorageService),K(3,w.IFileService),K(4,S.IUserDataSyncStoreService),K(5,S.IUserDataSyncBackupStoreService),K(6,S.IUserDataSyncLogService),K(7,C.IEnvironmentService),K(8,S.IUserDataSyncEnablementService),K(9,v.ITelemetryService),K(10,y.IConfigurationService),K(11,f.IStorageService),K(12,u.IUriIdentityService),K(13,c.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let h=class{constructor(O,M,F,A){this.a=O,this.b=M,this.c=F,this.d=A}async getLocalGlobalState(O){const M={};if(O.isDefault){const A=await this.f(),$=(0,k.parse)(A);for(const z of n)$[z]!==void 0&&(M[`${t}${z}`]={version:1,value:$[z]})}const F=await this.c.readStorageData(O);for(const[A,$]of F)$.value&&$.target===0&&(M[A]={version:1,value:$.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const O=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),O.value.toString()}catch(O){this.d.debug((0,i.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:M,updated:F},A){const $=(0,l.getSyncResourceLogLabel)("globalState",A),z={},H=new Map,X=await this.c.readStorageData(A),ie=(G,j)=>{for(const V of G){if(V.startsWith(t)){z[V.substring(t.length)]=j?j[V].value:void 0;continue}if(j){const x=j[V];x.value!==X.get(V)?.value&&H.set(V,x.value)}else X.get(V)!==void 0&&H.set(V,void 0)}};if(ie(Object.keys(O),O),ie(Object.keys(F),F),ie(M),Object.keys(z).length){this.d.trace(`${$}: Updating locale...`);const G=await this.f();let j=G;for(const V of Object.keys(z))j=(0,d.edit)(j,[V],z[V],{});G!==j&&(this.d.trace(`${$}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.VSBuffer.fromString(j)),this.d.info(`${$}: Updated locale.`)),this.d.info(`${$}: Updated locale`)}H.size&&(this.d.trace(`${$}: Updating global state...`),await this.c.updateStorageData(A,H,0),this.d.info(`${$}: Updated global state`,[...H.keys()]))}};h=ye([K(0,w.IFileService),K(1,C.IEnvironmentService),K(2,s.IUserDataProfileStorageService),K(3,S.IUserDataSyncLogService)],h),e.LocalGlobalStateProvider=h;let b=class extends l.AbstractInitializer{constructor(O,M,F,A,$,z){super("globalState",F,A,$,M,O,z)}async doInitialize(O){const M=O.syncData?JSON.parse(O.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},A={};for(const $ of Object.keys(M.storage))$.startsWith(t)?F[$.substring(t.length)]=M.storage[$].value:this.l.get($,0)===void 0&&(A[$]=M.storage[$].value);if(Object.keys(F).length){let $="{}";try{$=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(F))$=(0,d.edit)($,[z],F[z],{});await this.k.writeFile(this.h.argvResource,L.VSBuffer.fromString($))}if(Object.keys(A).length)for(const $ of Object.keys(A))this.l.store($,A[$],0,0)}};b=ye([K(0,f.IStorageService),K(1,w.IFileService),K(2,R.IUserDataProfilesService),K(3,C.IEnvironmentService),K(4,S.IUserDataSyncLogService),K(5,u.IUriIdentityService)],b),e.GlobalStateInitializer=b;let E=class{constructor(O,M,F,A,$){this.a=O,this.b=M,this.c=F,this.d=A,this.f=$}getSyncStoreType(O){return this.h(O)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const M=(0,S.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(O,M)}catch(F){if(F instanceof S.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(O,M)}throw F}}async g(O,M){const F=await this.a.readResource("globalState",null,void 0,M),A=this.h(F)||{storage:{}};A.storage[S.SYNC_SERVICE_URL_TYPE]={value:O,version:o};const $=await(0,m.getServiceMachineId)(this.c,this.d,this.b),z={version:o,machineId:$,content:r(A,!1)};await this.a.writeResource("globalState",JSON.stringify(z),F.ref,void 0,M)}h({content:O}){if(!O)return null;const M=JSON.parse(O);if((0,l.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};E=ye([K(1,f.IStorageService),K(2,C.IEnvironmentService),K(3,w.IFileService),K(4,g.ILogService)],E),e.UserDataSyncStoreTypeSynchronizer=E}),define(oe[122],ae([0,1,21,17,3,35,4,13,179,16,15,14,20,19,29,18,41,258,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(s,c,t){try{const n=JSON.parse(s);if(!c)return(0,P.isUndefined)(n.all)?null:n.all;switch(N.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=p;let S=class extends u.AbstractJsonFileSynchroniser{constructor(c,t,n,r,o,a,h,b,E,T,O,M,F){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},t,b,E,T,n,r,h,M,o,O,a,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(c,t,n,r){const o=c.syncData?p(c.syncData.content,r.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&n?c:t;const a=t?this.Jb(t):null,h=await this.p(),b=await this.xb();let E=null,T=!1,O=!1,M=!1;if(o){let $=h?h.value.toString():"[]";if($=$||"[]",this.vb($,!0))throw new d.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==$||a!==o){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)($,o,a,b,this.ub);z.hasChanges&&(E=z.mergeContent,M=z.hasConflicts,T=M||z.mergeContent!==$,O=M||z.mergeContent!==o)}}else h&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),E=h.value.toString(),O=!0);const F={content:M?a:E,localChange:T?h?2:1:0,remoteChange:O?2:0,hasConflicts:M},A=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:A,localChange:F.localChange,remoteResource:this.Cb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(c){const t=this.Jb(c);if(t===null)return!0;const n=await this.p(),r=n?n.value.toString():"",o=await this.xb(),a=await(0,l.merge)(r||"[]",t,t,o,this.ub);return a.hasConflicts||a.mergeContent!==t}async ob(c,t){return c.previewResult}async pb(c,t,n,r){if(this.h.isEqual(t,this.Bb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return n===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(c,t,n,r){const{fileContent:o}=n[0][0];let{content:a,localChange:h,remoteChange:b}=n[0][1];if(h===0&&b===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new d.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),o&&await this.kb(this.Kb(o.value.toString())),await this.r(a||"[]",o,r),this.L.info(`${this.y}: Updated local keybindings`)),b!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const E=this.Kb(a||"[]",c.syncData?.content);c=await this.jb(E,r?null:c.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(c,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.p();if(c){const t=(0,k.parse)(c.value.toString());if((0,L.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Ab,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Db,c)?this.ab(c):null}Jb(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Lb()?null:p(c.syncData.content,this.Lb(),this.L)}Kb(c,t){let n={};try{n=JSON.parse(t||"{}")}catch(r){this.L.error(r)}switch(this.Lb()?delete n.all:n.all=c,N.OS){case 2:n.mac=c;break;case 3:n.linux=c;break;case 1:n.windows=c;break}return JSON.stringify(n)}Lb(){return!!this.M.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};S=ye([K(2,d.IUserDataSyncStoreService),K(3,d.IUserDataSyncBackupStoreService),K(4,d.IUserDataSyncLogService),K(5,y.IConfigurationService),K(6,d.IUserDataSyncEnablementService),K(7,w.IFileService),K(8,C.IEnvironmentService),K(9,g.IStorageService),K(10,d.IUserDataSyncUtilService),K(11,m.ITelemetryService),K(12,f.IUriIdentityService)],S),e.KeybindingsSynchroniser=S;let R=class extends u.AbstractInitializer{constructor(c,t,n,r,o,a){super("keybindings",t,n,r,c,o,a)}async doInitialize(c){const t=c.syncData?this.i(c.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(c)}async c(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,k.parse)(c.value.toString());return!(0,L.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}i(c){try{return p(c,!0,this.j)}catch(t){return this.j.error(t),null}}};R=ye([K(0,w.IFileService),K(1,v.IUserDataProfilesService),K(2,C.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,g.IStorageService),K(5,f.IUriIdentityService)],R),e.KeybindingsInitializer=R}),define(oe[123],ae([0,1,17,3,180,16,74,15,30,14,20,19,29,18,41,61,262,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function p(s){const c=JSON.parse(s);return d(c)?c:{settings:s}}e.parseSettingsSyncContent=p;let S=class extends f.AbstractJsonFileSynchroniser{constructor(c,t,n,r,o,a,h,b,E,T,O,M,F,A){super(c.settingsResource,{syncResource:"settings",profile:c},t,n,r,o,a,h,O,M,b,E,T,A),this.zb=F,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(c){const t=await this.getLastSyncUserData(),n=await this.R(c,t),r=this.Gb(n),o=new N.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(c,t,n){const r=await this.p(),o=await this.xb(),a=this.Gb(c);t=t===null&&n?c:t;const h=t?this.Gb(t):null,b=await this.Kb();let E=null,T=!1,O=!1,M=!1;if(a){let z=r?r.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const H=(0,u.merge)(z,a.settings,h?h.settings:null,b,[],o);E=H.localContent||H.remoteContent,T=H.localContent!==null,O=H.remoteContent!==null,M=H.hasConflicts}else r&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),E=r.value.toString().trim()||"{}",this.Lb(E),O=!0);const F=r?r.value.toString():null,A=h?.settings??null,$={content:M?A:E,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:M};return[{fileContent:r,baseResource:this.baseResource,baseContent:A,localResource:this.localResource,localContent:F,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async rb(c){const t=this.Gb(c);if(t===null)return!0;const n=await this.p(),r=n?n.value.toString().trim():"",o=await this.Kb(),a=await this.xb();return(0,u.merge)(r||"{}",t.settings,t.settings,o,[],a).remoteContent!==null}async ob(c,t){const n=await this.xb(),r=await this.Kb();return{...c.previewResult,content:c.previewResult.content?(0,u.updateIgnoredSettings)(c.previewResult.content,"{}",r,n):null}}async pb(c,t,n,r){const o=await this.xb(),a=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:c.fileContent?(0,u.updateIgnoredSettings)(c.fileContent.value.toString(),"{}",a,o):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:c.remoteContent!==null?(0,u.updateIgnoredSettings)(c.remoteContent,c.fileContent?c.fileContent.value.toString():"{}",a,o):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,c.fileContent?c.fileContent.value.toString():"{}",a,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(c,t,n,r){const{fileContent:o}=n[0][0];let{content:a,localChange:h,remoteChange:b}=n[0][1];if(h===0&&b===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.Lb(a),h!==0&&(this.L.trace(`${this.y}: Updating local settings...`),o&&await this.kb(JSON.stringify(this.Ib(o.value.toString()))),await this.r(a,o,r),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),b!==0){const E=await this.xb(),T=this.Gb(c),O=await this.Kb(a);a=(0,u.updateIgnoredSettings)(a,T?T.settings:"{}",O,E),this.L.trace(`${this.y}: Updating remote settings...`),c=await this.jb(JSON.stringify(this.Ib(a)),r?null:c.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(c),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const c=await this.p();if(c){const t=await this.xb(),n=(0,v.edit)(c.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,u.isEmpty)(n)}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)||this.h.isEqual(this.baseResource,c)?this.ab(c):null}async ab(c){let t=await super.ab(c);if(t){const n=await this.xb(),r=await this.Kb();t=(0,u.updateIgnoredSettings)(t,"{}",r,n)}return t}Gb(c){return c.syncData?this.Hb(c.syncData.content):null}Hb(c){try{return p(c)}catch(t){this.L.error(t)}return null}Ib(c){return{settings:c}}async Kb(c){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const n=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),i.Event.filter(this.zb.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,u.getIgnoredSettings)(t,this.M,c)}Lb(c){if(this.vb(c,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};S=ye([K(2,y.IFileService),K(3,P.IEnvironmentService),K(4,C.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncLogService),K(8,l.IUserDataSyncUtilService),K(9,k.IConfigurationService),K(10,l.IUserDataSyncEnablementService),K(11,w.ITelemetryService),K(12,I.IExtensionManagementService),K(13,g.IUriIdentityService)],S),e.SettingsSynchroniser=S;let R=class extends f.AbstractInitializer{constructor(c,t,n,r,o,a){super("settings",t,n,r,c,o,a)}async doInitialize(c){const t=c.syncData?this.i(c.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.VSBuffer.fromString(t.settings)),await this.n(c)}async c(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,u.isEmpty)(c.value.toString().trim())}catch(c){return c.fileOperationResult===1}}i(c){try{return p(c)}catch(t){this.j.error(t)}return null}};R=ye([K(0,y.IFileService),K(1,m.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,l.IUserDataSyncLogService),K(4,C.IStorageService),K(5,g.IUriIdentityService)],R),e.SettingsInitializer=R}),define(oe[124],ae([0,1,17,3,32,16,15,14,20,19,29,18,41,259,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function v(d){return JSON.parse(d.content)}e.parseSnippets=v;let u=class extends g.AbstractSynchroniser{constructor(p,S,R,s,c,t,n,r,o,a,h,b){super({syncResource:"snippets",profile:p},S,s,R,c,t,n,a,h,r,o,b),this.mb=1,this.p=p.snippetsHome,this.B(this.C.watch(R.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,E=>E.affects(this.p))(()=>this.triggerLocalChange()))}async nb(p,S,R){const s=await this.Cb(),c=this.Bb(s),t=p.syncData?this.Ab(p.syncData):null;S=S===null&&R?p:S;const n=S&&S.syncData?this.Ab(S.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,m.merge)(c,t,n);return this.wb(r,s,t||{},n||{})}async rb(p){const S=p.syncData?this.Ab(p.syncData):null;if(S===null)return!0;const R=await this.Cb(),s=this.Bb(R),c=(0,m.merge)(s,S,S);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async ob(p,S){return p.previewResult}async pb(p,S,R,s){if(this.h.isEqualOrParent(S,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(S,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(S,this.g))return R===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:R,localChange:R===null?p.fileContent!==null?3:0:2,remoteChange:R===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async qb(p,S,R,s){const c=R.map(([t,n])=>({...t,acceptResult:n}));c.every(({localChange:t,remoteChange:n})=>t===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),c.some(({localChange:t})=>t!==0)&&(await this.xb(c),await this.yb(c,s)),c.some(({remoteChange:t})=>t!==0)&&(p=await this.zb(c,p,s)),S?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of c)try{await this.C.del(t)}catch{}}wb(p,S,R,s){const c=new Map;for(const t of Object.keys(p.local.added)){const n={content:p.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.local.updated)){const n={content:p.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},r=S[t]?S[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=S[t]?S[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.added)){const n={content:p.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},r=S[t]?S[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.updated)){const n={content:p.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},r=S[t]?S[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.conflicts){const n={content:s[t]??null,hasConflicts:!0,localChange:S[t]?2:1,remoteChange:R[t]?2:1},r=S[t]?S[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t]||null,localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(S))if(!c.has(t)){const n={content:S[t]?S[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=S[t]?S[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t]||null,localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(p):null}async hasLocalData(){try{const p=await this.Cb();if(Object.keys(p).length)return!0}catch{}return!1}async xb(p){const S={};for(const R of p)R.fileContent&&(S[this.h.basename(R.localResource)]=R.fileContent);await this.kb(JSON.stringify(this.Bb(S)))}async yb(p,S){for(const{fileContent:R,acceptResult:s,localResource:c,remoteResource:t,localChange:n}of p)if(n!==0){const r=t?this.h.basename(t):this.h.basename(c),o=this.h.joinPath(this.p,r);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(o)),await this.C.del(o),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(o))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(o)),await this.C.createFile(o,L.VSBuffer.fromString(s.content),{overwrite:S}),this.L.info(`${this.y}: Created snippet`,this.h.basename(o))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(o)),await this.C.writeFile(o,L.VSBuffer.fromString(s.content),S?void 0:R),this.L.info(`${this.y}: Updated snippet`,this.h.basename(o)))}}async zb(p,S,R){const s=S.syncData?this.Ab(S.syncData):{},c=(0,D.deepClone)(s);for(const{acceptResult:t,localResource:n,remoteResource:r,remoteChange:o}of p)if(o!==0){const a=n?this.h.basename(n):this.h.basename(r);o===3?delete c[a]:c[a]=t.content}return(0,m.areSame)(s,c)||(this.L.trace(`${this.y}: Updating remote snippets...`),S=await this.jb(JSON.stringify(c),R?null:S.ref),this.L.info(`${this.y}: Updated remote snippets`)),S}Ab(p){return v(p)}Bb(p){const S={};for(const R of Object.keys(p))S[R]=p[R].value.toString();return S}async Cb(){const p={};let S;try{S=await this.C.resolve(this.p)}catch(R){if(R instanceof P.FileOperationError&&R.fileOperationResult===1)return p;throw R}for(const R of S.children||[]){const s=R.resource,c=this.h.extname(s);if(c===".json"||c===".code-snippets"){const t=this.h.relativePath(this.p,s),n=await this.C.readFile(s);p[t]=n}}return p}};u=ye([K(2,N.IEnvironmentService),K(3,P.IFileService),K(4,I.IStorageService),K(5,f.IUserDataSyncStoreService),K(6,f.IUserDataSyncBackupStoreService),K(7,f.IUserDataSyncLogService),K(8,k.IConfigurationService),K(9,f.IUserDataSyncEnablementService),K(10,y.ITelemetryService),K(11,C.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let l=class extends g.AbstractInitializer{constructor(p,S,R,s,c,t){super("snippets",S,R,s,p,c,t)}async doInitialize(p){const S=p.syncData?JSON.parse(p.syncData.content):null;if(!S){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(S)){const c=S[s];if(c){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(t,L.VSBuffer.fromString(c)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(p)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};l=ye([K(0,P.IFileService),K(1,w.IUserDataProfilesService),K(2,N.IEnvironmentService),K(3,f.IUserDataSyncLogService),K(4,I.IStorageService),K(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[125],ae([0,1,17,16,15,14,20,19,29,18,41,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function g(u,l){try{return JSON.parse(u).tasks??null}catch(d){return l.error(d),null}}e.getTasksContentFromSyncContent=g;let m=class extends C.AbstractFileSynchroniser{constructor(l,d,p,S,R,s,c,t,n,r,o,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,t,n,r,p,S,c,o,R,s,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,d,p,S){const R=l.syncData?g(l.syncData.content,this.L):null;d=d===null&&p?l:d;const s=d?.syncData?g(d.syncData.content,this.L):null,c=await this.p();let t=null,n=!1,r=!1,o=!1;if(l.syncData){const b=c?c.value.toString():null;if(!s||s!==b||s!==R){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const E=v(b,R,s);t=E.content,o=E.hasConflicts,n=E.hasLocalChanged,r=E.hasRemoteChanged}}else c&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=c.value.toString(),r=!0);const a={content:o?s:t,localChange:n?c?2:1:0,remoteChange:r?2:0,hasConflicts:o},h=c?c.value.toString():null;return[{fileContent:c,baseResource:this.wb,baseContent:s,localResource:this.xb,localContent:h,localChange:a.localChange,remoteResource:this.yb,remoteContent:R,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const d=l?.syncData?g(l.syncData.content,this.L):null;if(d===null)return!0;const p=await this.p(),S=p?p.value.toString():null,R=v(S,d,d);return R.hasLocalChanged||R.hasRemoteChanged}async ob(l,d){return l.previewResult}async pb(l,d,p,S){if(this.h.isEqual(d,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.vb))return p===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(l,d,p,S){const{fileContent:R}=p[0][0],{content:s,localChange:c,remoteChange:t}=p[0][1];if(c===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),c!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),R&&await this.kb(JSON.stringify(this.Fb(R.value.toString()))),s?await this.r(s,R,S):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Fb(s));l=await this.jb(n,S?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};m=ye([K(2,w.IUserDataSyncStoreService),K(3,w.IUserDataSyncBackupStoreService),K(4,w.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,w.IUserDataSyncEnablementService),K(7,k.IFileService),K(8,D.IEnvironmentService),K(9,N.IStorageService),K(10,P.ITelemetryService),K(11,I.IUriIdentityService)],m),e.TasksSynchroniser=m;let f=class extends C.AbstractInitializer{constructor(l,d,p,S,R,s){super("tasks",d,p,S,l,R,s),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const d=l.syncData?g(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.VSBuffer.fromString(d)),await this.n(l)}async i(){return this.k.exists(this.c)}};f=ye([K(0,k.IFileService),K(1,y.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,w.IUserDataSyncLogService),K(4,N.IStorageService),K(5,I.IUriIdentityService)],f),e.TasksInitializer=f;function v(u,l,d){if(u===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(u===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=d!==u,S=d!==l;return!p&&!S?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!S?{content:u,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:S&&!p?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:u,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[126],ae([0,1,43,16,15,14,20,19,29,18,41,260,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let m=class extends C.AbstractSynchroniser{constructor(l,d,p,S,R,s,c,t,n,r,o,a,h){super({syncResource:"profiles",profile:l},d,S,R,s,c,t,o,a,n,r,h),this.r=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?v(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),p=await this.R(l,d);return p?.syncData?v(p.syncData):null}async nb(l,d,p){if(!this.r.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const S=l.syncData?v(l.syncData):null,R=d?.syncData?v(d.syncData):null,s=this.zb(),{local:c,remote:t}=(0,w.merge)(s,S,R,[]),n={local:c,remote:t,content:R?this.Ab(R):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:t!==null?2:0},r=f(s,!1);return[{baseResource:this.baseResource,baseContent:R?this.Ab(R):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:S?this.Ab(S):null,remoteProfiles:S,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const d=l?.syncData?v(l.syncData):null,p=this.zb(),{remote:S}=(0,w.merge)(p,d,d,[]);return!!S?.added.length||!!S?.removed.length||!!S?.updated.length}async ob(l,d){return{...l.previewResult,hasConflicts:!1}}async pb(l,d,p,S){if(this.h.isEqual(d,this.localResource))return this.wb(l);if(this.h.isEqual(d,this.remoteResource))return this.xb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async wb(l){const d=this.zb(),p=(0,w.merge)(d,null,null,[]),{local:S,remote:R}=p;return{content:l.localContent,local:S,remote:R,localChange:S.added.length>0||S.removed.length>0||S.updated.length>0?2:0,remoteChange:R!==null?2:0}}async xb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,p=[],S=[];for(const R of this.zb()){const s=d?.find(c=>c.id===R.id);s&&(p.push({id:R.id,name:R.name,collection:s.collection}),S.push(R))}if(d!==null){const R=(0,w.merge)(S,d,p,[]),{local:s,remote:c}=R;return{content:l.remoteContent,local:s,remote:c,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,d,p,S){const{local:R,remote:s,localChange:c,remoteChange:t}=p[0][1];c===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=p[0][0].remoteProfiles||[];if(n.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.kb(f(this.zb(),!1));const r=[];for(const o of R.added)r.push((async()=>{this.L.trace(`${this.y}: Creating '${o.name}' profile...`),await this.r.createProfile(o.id,o.name,{shortName:o.shortName}),this.L.info(`${this.y}: Created profile '${o.name}'.`)})());for(const o of R.removed)r.push((async()=>{this.L.trace(`${this.y}: Removing '${o.name}' profile...`),await this.r.removeProfile(o),this.L.info(`${this.y}: Removed profile '${o.name}'.`)})());for(const o of R.updated){const a=this.r.profiles.find(h=>h.id===o.id);a?r.push((async()=>{this.L.trace(`${this.y}: Updating '${o.name}' profile...`),await this.r.updateProfile(a,{name:o.name,shortName:o.shortName}),this.L.info(`${this.y}: Updated profile '${o.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(r)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const r=[],o=n.length+(s?.added.length??0)<=20;if(o)for(const a of s?.added||[]){const h=await this.G.createCollection(this.z);r.push(h),n.push({id:a.id,name:a.name,collection:h,shortName:a.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])n.splice(n.findIndex(({id:h})=>a.id===h),1);for(const a of s?.updated||[]){const h=n.find(({id:b})=>a.id===b);h&&n.splice(n.indexOf(h),1,{id:a.id,name:a.name,collection:h.collection,shortName:a.shortName})}try{l=await this.updateRemoteProfiles(n,S?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${o&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(r.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of r)await this.G.deleteCollection(h,this.z)}throw a}for(const a of s?.removed||[])await this.G.deleteCollection(a.collection,this.z)}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.jb(this.Ab(l),d)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.ab(l);return d&&(0,L.toFormattedString)(JSON.parse(d),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((d,p)=>d.name.localeCompare(p.name)))}};m=ye([K(2,y.IUserDataProfilesService),K(3,k.IFileService),K(4,D.IEnvironmentService),K(5,N.IStorageService),K(6,g.IUserDataSyncStoreService),K(7,g.IUserDataSyncBackupStoreService),K(8,g.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,g.IUserDataSyncEnablementService),K(11,P.ITelemetryService),K(12,I.IUriIdentityService)],m),e.UserDataProfilesManifestSynchroniser=m;function f(u,l){const d=[...u].sort((p,S)=>p.name.localeCompare(S.name)).map(p=>({id:p.id,name:p.name}));return l?(0,L.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=f;function v(u){return JSON.parse(u.content)}e.parseUserDataProfilesManifest=v}),define(oe[276],ae([0,1,6,17,65,2,22,16,15,14,18,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends k.Disposable{constructor(f,v,u,l,d){super(),this.a=f,this.b=v,this.c=u,this.f=l,this.g=d,this.h()}async h(){for(const v of this.g.profiles)for(const u of w.ALL_SYNC_RESOURCES)try{await this.j(this.i(v,u))}catch(l){this.f.error(l)}let f;try{f=await this.b.resolve(this.a.userDataSyncHome)}catch(v){(0,y.toFileOperationResult)(v)!==1&&this.f.error(v);return}if(f.children){for(const v of f.children)if(v.isDirectory&&!this.g.profiles.some(u=>u.id===v.name))try{this.f.info("Deleting non existing profile from backup",v.resource.path),await this.b.del(v.resource,{recursive:!0})}catch(u){this.f.error(u)}}}async getAllRefs(f,v){const u=this.i(f,v),l=await this.b.resolve(u);return l.children?l.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)})):[]}async resolveContent(f,v,u){const l=this.i(f,v),d=(0,N.joinPath)(l,u);try{return(await this.b.readFile(d)).value.toString()}catch(p){return this.f.error(p),null}}async backup(f,v,u){const l=this.i(f,v),d=(0,N.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,i.VSBuffer.fromString(u))}catch(p){this.f.error(p)}try{this.j(l)}catch{}}i(f,v){return(0,N.joinPath)(this.a.userDataSyncHome,...f.isDefault?[v]:[f.id,v])}async j(f){try{try{if(!await this.b.exists(f))return}catch{return}const v=await this.b.resolve(f);if(v.children){const u=v.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=u.filter(S=>Date.now()-this.k(S)>l);const p=u.length-d.length;p<10&&(d=d.slice(10-p)),await L.Promises.settled(d.map(async S=>{this.f.info("Deleting from backup",S.resource.path),await this.b.del(S.resource)}))}}catch(v){this.f.error(v)}}k(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};g=ye([K(0,I.IEnvironmentService),K(1,y.IFileService),K(2,P.IConfigurationService),K(3,w.IUserDataSyncLogService),K(4,C.IUserDataProfilesService)],g),e.UserDataSyncBackupStoreService=g}),define(oe[277],ae([0,1,3,2,4,15,20,19,26]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const y="sync.enable";let C=class extends i.Disposable{constructor(g,m,f,v){super(),this.c=g,this.f=m,this.g=f,this.h=v,this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new L.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(u=>this.j(u)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(y,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(y,{enabled:g}),this.c.store(y,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,I.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,m){if(this.isResourceEnabled(g)!==m){const f=(0,I.getEnablementKey)(g);this.i(f,m)}}getResourceSyncStateVersion(g){}i(g,m){this.c.store(g,m,-1,D.isWeb?0:1)}j(g){if(g.scope!==-1)return;if(y===g.key){this.a.fire(this.isEnabled());return}const m=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===g.key)[0];if(m){this.b.fire([m,this.isResourceEnabled(m)]);return}}};C=ye([K(0,N.IStorageService),K(1,P.ITelemetryService),K(2,k.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(oe[81],ae([0,1,3,2,4,27,183,15,14,5,25,45,20,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,y.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",v="Safari",u="Chrome",l="Edge",d="Firefox",p="Android";function S(c){switch(c){case v:case u:case l:case d:case p:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function R(){return D.isSafari?v:D.isChrome?u:D.isEdge?l:D.isFirefox?d:D.isAndroid?p:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let s=class st extends i.Disposable{constructor(t,n,r,o,a,h){super(),this.h=r,this.i=o,this.j=a,this.k=h,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,w.getServiceMachineId)(t,n,r)}async getMachines(t){const n=await this.f;return(await this.m(t)).machines.map(o=>({...o,isCurrent:o.id===n}))}async addCurrentMachine(t){const n=await this.f,r=await this.m(t);r.machines.some(({id:o})=>o===n)||(r.machines.push({id:n,name:this.l(r.machines),platform:R()}),await this.n(r))}async removeCurrentMachine(t){const n=await this.f,r=await this.m(t),o=r.machines.filter(({id:a})=>a!==n);o.length!==r.machines.length&&(r.machines=o,await this.n(r))}async renameMachine(t,n,r){const o=await this.m(r),a=o.machines.find(({id:h})=>h===t);if(a){a.name=n,await this.n(o);const h=await this.f;t===h&&this.h.store(f,n,-1,1)}}async setEnablements(t){const n=await this.m();for(const[r,o]of t){const a=n.machines.find(h=>h.id===r);a&&(a.disabled=o?void 0:!0)}await this.n(n)}l(t){const n=this.h.get(f,-1);if(n)return n;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${R()} (${this.k.nameShort})`,o=new RegExp(`${(0,k.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let a=0;for(const h of t){const b=o.exec(h.name),E=b?parseInt(b[1]):0;a=E>a?E:a}return`${r} #${a+1}`}async m(t){this.g=await this.p(t);const n=this.r(this.g);if(n.version!==st.a)throw new Error((0,N.localize)(0,null,this.k.nameLong));return n}async n(t){const n=JSON.stringify(t),r=await this.i.writeResource(st.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async p(t){if(this.g){const n=t&&t.latest?t.latest[st.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(st.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.j.error(n)}return{version:st.a,machines:[]}}};s.a=1,s.b="machines",s=ye([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,g.IStorageService),K(3,m.IUserDataSyncStoreService),K(4,m.IUserDataSyncLogService),K(5,C.IProductService)],s),e.UserDataSyncMachinesService=s}),define(oe[278],ae([0,1,6,65,38,7,3,2,4,22,8,181,25,20,19,26,78,81]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",p="sync.sessionId",S="sync.storeUrl",R="sync.productQuality";let s=class extends P.Disposable{get j(){const n=this.z.get(S,-1);return n?C.URI.parse(n):void 0}set j(n){n?this.z.store(S,n.toString(),-1,1):this.z.remove(S,-1)}get l(){return this.z.get(R,-1)}set l(n){n?this.z.store(R,n,-1,1):this.z.remove(R,-1)}constructor(n,r,o,a,h,b,E,T,O,M){super(),this.n=r,this.p=o,this.r=a,this.s=h,this.u=b,this.v=E,this.w=T,this.y=O,this.z=M,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new N.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new L.ThrottledDelayer(this.O())),this.i=this.j,this.j=r.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(r.onDidChangeUserDataSyncStore(()=>{(0,y.isEqual)(this.j,r.userDataSyncStore?.url)||(this.i=this.j,this.j=r.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(E.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(h.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(N.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:r}=this.F();n?this.a.value===void 0&&(this.a.value=new c(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(r&&this.u.info(r),this.a.clear()):r&&this.r.isEnabled()&&this.u.info(r))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,r,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),r)this.G(!1);else throw a}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const r=v.UserDataSyncError.toUserDataSyncError(n);r instanceof v.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:r.code,service:this.n.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?I.isWeb&&r.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(r),this.b++),this.h.fire(r)}async J(){this.z.store(d,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(n,r,o){if(this.a.value===void 0)return this.f.cancel();if(r&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};s=ye([K(0,g.IProductService),K(1,v.IUserDataSyncStoreManagementService),K(2,v.IUserDataSyncStoreService),K(3,v.IUserDataSyncEnablementService),K(4,v.IUserDataSyncService),K(5,v.IUserDataSyncLogService),K(6,u.IUserDataSyncAccountService),K(7,f.ITelemetryService),K(8,l.IUserDataSyncMachinesService),K(9,m.IStorageService)],s),e.UserDataAutoSyncService=s;class c extends P.Disposable{constructor(n,r,o,a,h,b,E,T){super(),this.j=n,this.k=r,this.l=o,this.m=a,this.n=h,this.p=b,this.r=E,this.s=T,this.b=this.B(new P.MutableDisposable),this.c=this.B(new N.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new N.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}u(){this.b.value=(0,L.disposableTimeout)(()=>this.sync(c.a,!1),this.k)}sync(n,r){const o=(0,L.createCancelablePromise)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(h){if((0,k.isCancellationError)(h))return}return this.y(n,r,a)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,y.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),r=this.l.userDataSyncStore;return!!r&&!!n&&(!(0,y.isEqual)(r.defaultUrl,n.defaultUrl)||!(0,y.isEqual)(r.insidersUrl,n.insidersUrl)||!(0,y.isEqual)(r.stableUrl,n.stableUrl))}async y(n,r,o){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let a;try{await this.z(r,o)}catch(h){if(this.r.error(h),a=h,v.UserDataSyncError.toUserDataSyncError(h).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(r,o),a=void 0}catch(b){this.r.error(b),a=b}}this.f.fire(a)}async z(n,r){if(this.h=await this.n.createSyncTask(this.g,n),r.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new v.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const o=this.s.get(p,-1);if(o&&this.g&&o!==this.g.session)throw this.v()?await this.w()?new v.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(r.isCancellationRequested)return;const h=a.find(b=>b.isCurrent);if(h?.disabled)throw new v.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(b){throw new v.UserDataAutoSyncError((0,D.toErrorMessage)(b),b instanceof v.UserDataSyncError?b.code:"Unknown")}this.g&&this.g.session!==o&&this.s.store(p,this.g.session,-1,1),!r.isCancellationRequested&&(h||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}c.a="Interval"}),define(oe[279],ae([0,1,8,184,15,14,45,20,29,26,18,41,124,123,122,16,125,120,121,5,126,43]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let s=class Ve{constructor(t,n,r,o,a,h,b,E,T,O){this.e=t,this.f=n,this.g=r,this.h=a,this.i=h,this.j=b,this.k=E,this.l=T,this.m=O,this.d=o.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const n=this.K(t.content,"profiles");return(0,S.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(t,n){return(await this.e.getAllResourceRefs(t,n?.collection)).map(({created:o,ref:a})=>({created:o,uri:this.I({remote:!0,syncResource:t,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,n){return(await this.f.getAllRefs(n,t)).map(({created:o,ref:a})=>({created:o,uri:this.I({remote:!1,syncResource:t,profile:n.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const n=this.J(t),r=n?this.k.profiles.find(o=>o.id===n.profile):void 0;return n&&r?{profile:r,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:t}){const n=this.J(t);if(!n)return[];const r=this.k.profiles.find(o=>o.id===n.profile);switch(n.syncResource){case"settings":return this.r(t,r);case"keybindings":return this.t(t,r);case"tasks":return this.v(t,r);case"snippets":return this.x(t,r);case"globalState":return this.C(t,r);case"extensions":return this.z(t,r);case"profiles":return this.F(t,r)}}async getMachineId({uri:t}){const n=this.J(t);if(!!n){if(n.remote){if(n.ref){const{content:r}=await this.L(n.syncResource,n.ref,n.collection);if(r)return this.K(r,n.syncResource)?.machineId}return}return(0,N.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const n=this.J(t);if(!n||n.node===Ve.a)return null;if(n.ref){const r=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&r?this.o(n.syncResource,r,n.node):r}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(t,n,r,o,a){if(t){const{content:b}=await this.L(n,a,o);return b}const h=this.k.profiles.find(b=>b.id===r);return h?this.f.resolveContent(h,n,a):null}o(t,n,r){const o=this.K(n,t);switch(t){case"settings":return this.s(o,r);case"keybindings":return this.u(o,r);case"tasks":return this.w(o,r);case"snippets":return this.y(o,r);case"globalState":return this.D(o,r);case"extensions":return this.A(o,r);case"profiles":return this.G(o,r)}}async q(t,n){const r=this.k.profiles.find(o=>o.id===n);if(!r)return null;switch(t){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,n){const r=this.d.joinPath(t,"settings.json"),o=n?n.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:o}]}s(t,n){switch(n){case"settings.json":return(0,m.parseSettingsSyncContent)(t.content).settings}return null}t(t,n){const r=this.d.joinPath(t,"keybindings.json"),o=n?n.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:o}]}u(t,n){switch(n){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(y.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,n){const r=this.d.joinPath(t,"tasks.json"),o=n?n.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:o}]}w(t,n){switch(n){case"tasks.json":return(0,u.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,n){const r=await this.resolveContent(t);if(r){const o=this.K(r,"snippets");if(o){const a=(0,g.parseSnippets)(o),h=[];for(const b of Object.keys(a)){const E=this.d.joinPath(t,b),T=n?this.d.joinPath(n.snippetsHome,b):this.d.joinPath(t,Ve.a);h.push({resource:E,comparableResource:T})}return h}}return[]}y(t,n){return(0,g.parseSnippets)(t)[n]||null}z(t,n){const r=this.d.joinPath(t,"extensions.json"),o=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:o}]}A(t,n){switch(n){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:n}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(n,!0)}C(t,n){const r=this.d.joinPath(t,"globalState.json"),o=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:o}]}D(t,n){switch(n){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const n=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(n,!0)}F(t,n){const r=this.d.joinPath(t,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:o}]}G(t,n){switch(n){case"profiles.json":return(0,R.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,S.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(t){const n=t.remote?Ve.b:Ve.c,r=[t.syncResource,t.profile];return t.collection&&r.push(`collection:${t.collection}`),t.ref&&r.push(`ref:${t.ref}`),t.node&&r.push(t.node),this.d.joinPath(L.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...r)}J(t){if(t.scheme!==y.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const n=[];for(;t.path!=="/";)n.unshift(this.d.basename(t)),t=this.d.dirname(t);if(n.length<2)return;const r=t.authority===Ve.b,o=n.shift(),a=n.shift();let h,b,E;for(;n.length;){const T=n.shift();T.startsWith("collection:")?h=T.substring(11):T.startsWith("ref:")?b=T.substring(4):E=T}return{remote:r,syncResource:o,profile:a,collection:h,ref:b,node:E}}K(t,n){try{const r=JSON.parse(t);if((0,w.isSyncData)(r))return r}catch(r){this.g.error(r)}throw new y.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",n)}async L(t,n,r){const o=await this.e.resolveResourceContent(t,n,r);return{ref:n,content:o}}};s.a="not-existing-resource",s.b="remote-backup",s.c="local-backup",s=ye([K(0,y.IUserDataSyncStoreService),K(1,y.IUserDataSyncBackupStoreService),K(2,y.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,D.IEnvironmentService),K(5,P.IStorageService),K(6,k.IFileService),K(7,C.IUserDataProfilesService),K(8,v.IConfigurationService),K(9,p.IInstantiationService)],s),e.UserDataSyncResourceProviderService=s}),define(oe[280],ae([0,1,21,6,23,38,3,2,22,13,31,16,30,5,20,19,18,120,121,122,123,124,125,126,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let r=class extends P.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(E,T,O,M,F,A,$,z,H){super(),this.v=E,this.w=T,this.y=O,this.z=M,this.C=F,this.D=A,this.F=$,this.G=z,this.H=H,this.f="uninitialized",this.g=this.B(new N.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new N.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new N.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new N.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new N.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new N.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new N.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,P.toDisposable)(()=>this.W()))}async createSyncTask(E,T){this.X(),this.z.info("Sync started.");const O=new Date().getTime(),M=(0,C.generateUuid)();try{const z=(0,t.createSyncHeaders)(M);T&&(z["Cache-Control"]="no-cache"),E=await this.v.manifest(E,z)}catch(z){const H=t.UserDataSyncError.toUserDataSyncError(z);throw h(H,M,this.w,this.C),H}const F=!1,A=this;let $;return{manifest:E,async run(){if(F)throw new Error("Can run a task only once");$=(0,i.createCancelablePromise)(z=>A.I(E,!1,M,z)),await $.finally(()=>$=void 0),A.z.info(`Sync done. Took ${new Date().getTime()-O}ms`),A.S()},stop(){return $?.cancel(),A.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const E=new Date().getTime(),T=(0,C.generateUuid)(),O=(0,t.createSyncHeaders)(T);let M;try{M=await this.v.manifest(null,O)}catch($){const z=t.UserDataSyncError.toUserDataSyncError($);throw h(z,T,this.w,this.C),z}await this.resetLocal();const F=this,A=new D.CancellationTokenSource;return{id:T,async merge(){return F.I(M,!0,T,A.token)},async apply(){try{try{await F.L(M,T,A.token)}catch($){if(t.UserDataSyncError.toUserDataSyncError($).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(M,T,A.token);else throw $}}catch($){throw F.z.error($),$}F.z.info(`Sync done. Took ${new Date().getTime()-E}ms`),F.S()},async stop(){A.cancel(),await F.N(),await F.resetLocal()}}}async I(E,T,O,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,E,T,O,M));const A=F.enabled.find($=>$.resource==="profiles");if(A){const $=await A.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J($,E,T,O,M)}}finally{this.l.fire(this.k)}}async J(E,T,O,M,F){for(const A of E){if(F.isCancellationRequested)return;const $=this.G.profiles.find(H=>H.id===A.id);if(!$){this.z.error(`Profile with id:${A.id} and name: ${A.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",A.name);const z=this.getOrCreateActiveProfileSynchronizer($,A);this.k.push(...await this.M(z,T,O,M,F))}for(const[A,$]of this.u.entries())this.G.profiles.some(z=>z.id===$[0].profile.id)||($[1].dispose(),this.u.delete(A))}async L(E,T,O){const M=this.U();for(const H of M){if(O.isCancellationRequested)return;await H.apply(T,O)}const F=M.find(H=>H.profile.isDefault);if(!F)return;const A=F.enabled.find(H=>H.resource==="profiles");if(!A)return;const z=(await A.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(H=>M.every(X=>X.profile.id!==H.id));z.length&&await this.J(z,E,!1,T,O)}async M(E,T,O,M,F){return(await E.sync(T,O,M,F)).map(([$,z])=>({profile:E.profile,syncResource:$,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(E=>E.stop()))}async resolveContent(E){const T=await this.H.resolveContent(E);if(T)return T;for(const O of this.U())for(const M of O.enabled){const F=await M.resolveContent(E);if(F)return F}return null}async replace(E){this.X();const T=this.H.resolveUserDataSyncResource(E);if(!T)return;const O=await this.resolveContent(E.uri);!O||await this.O(T.profile,async M=>{if(T.syncResource===M.resource)return await M.replace(O),!0})}async accept(E,T,O,M){this.X(),await this.O(E.profile,async F=>{if(E.syncResource===F.resource)return await F.accept(T,O),M&&await F.apply((0,y.isBoolean)(M)?!1:M.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,T){return this.H.getRemoteSyncResourceHandles(E,T)}async getLocalSyncResourceHandles(E,T){return this.H.getLocalSyncResourceHandles(E,T??this.G.defaultProfile)}async getAssociatedResources(E){return this.H.getAssociatedResources(E)}async getMachineId(E){return this.H.getMachineId(E)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async T=>{if(T.resource!=="globalState"&&await T.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async T=>{if(await T.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(E){this.z.error(E)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[E]of this.u.values())try{await E.resetLocal()}catch(T){this.z.error(T)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.H.getRemoteSyncedProfiles(),T=E.map(A=>A.collection),O=await this.v.getAllCollections(),M=O.filter(A=>!T.includes(A));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(A=>this.v.deleteCollection(A))),this.z.info("Deleted redundant collections on server"));const F=E.filter(A=>O.includes(A.collection));if(F.length!==E.length){this.z.info("Updating remote profiles with invalid collections on server");const A=this.y.createInstance(c.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await A.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{A.dispose()}}}async O(E,T){const O=new P.DisposableStore;try{const M=this.u.get(E.id);if(M){const H=await this.P(M[0],T,O);return(0,y.isUndefined)(H)?null:H}if(E.isDefault){const H=O.add(this.y.createInstance(o,E,void 0)),X=await this.P(H,T,O);return(0,y.isUndefined)(X)?null:X}if(this.G.isEnabled())return null;const F=O.add(this.y.createInstance(c.UserDataProfilesManifestSynchroniser,E,void 0)),A=await this.v.manifest(null),z=(await F.getRemoteSyncedProfiles(A?.latest??null)||[]).find(H=>H.id===E.id);if(z){const H=O.add(this.y.createInstance(o,E,z.collection)),X=await this.P(H,T,O);return(0,y.isUndefined)(X)?null:X}return null}finally{O.dispose()}}async P(E,T,O){const M=[...E.enabled,...E.disabled.map(F=>O.add(E.createSynchronizer(F)))];for(const F of M){const A=await T(F);if(!(0,y.isUndefined)(A))return A}}Q(E){const T=this.f;this.f!==E&&(this.f=E,this.g.fire(E),T==="hasConflicts"&&this.S())}R(){const E=this.U().map(T=>T.conflicts).flat();(0,L.equals)(this.i,E,(T,O)=>T.profile.id===O.profile.id&&T.syncResource===O.syncResource&&(0,L.equals)(T.conflicts,O.conflicts,(M,F)=>(0,I.isEqual)(M.previewResource,F.previewResource)))||(this.i=E,this.j.fire(E))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(E,T){let O=this.u.get(E.id);if(O&&O[0].collection!==T?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.u.delete(E.id)),!O){const M=new P.DisposableStore,F=M.add(this.y.createInstance(o,E,T?.collection));M.add(F.onDidChangeStatus(A=>this.Q(A))),M.add(F.onDidChangeConflicts(A=>this.R())),M.add(F.onDidChangeLocal(A=>this.h.fire(A))),this.u.set(E.id,O=[F,M])}return O[0]}U(){const E=[];for(const[T]of this.u.values())E.push(T);return E}W(){this.u.forEach(([,E])=>E.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};r=ye([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,m.IInstantiationService),K(3,t.IUserDataSyncLogService),K(4,v.ITelemetryService),K(5,f.IStorageService),K(6,t.IUserDataSyncEnablementService),K(7,u.IUserDataProfilesService),K(8,t.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let o=class extends P.Disposable{get enabled(){return this.f.sort((E,T)=>E[1]-T[1]).map(([E])=>E)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(E=>!this.l.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.j}constructor(E,T,O,M,F,A,$,z,H,X){super(),this.profile=E,this.collection=T,this.l=O,this.m=M,this.n=F,this.r=A,this.t=$,this.u=z,this.v=H,this.w=X,this.f=[],this.g="idle",this.h=this.B(new N.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new N.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new N.Emitter),this.onDidChangeConflicts=this.k.event,this.B(O.onDidChangeResourceEnablement(([ie,G])=>this.y(ie,G))),this.B((0,P.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.ALL_SYNC_RESOURCES)O.isResourceEnabled(ie)&&this.z(ie)}y(E,T){T?this.z(E):this.C(E)}z(E){if(this.f.some(([F])=>F.resource===E))return;if(E==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const T=new P.DisposableStore,O=T.add(this.createSynchronizer(E));T.add(O.onDidChangeStatus(()=>this.G())),T.add(O.onDidChangeConflicts(()=>this.H())),T.add(O.onDidChangeLocal(()=>this.i.fire(E)));const M=this.I(E);this.f.push([O,M,T])}C(E){const T=this.f.findIndex(([O])=>O.resource===E);if(T!==-1){const[[O,,M]]=this.f.splice(T,1);M.dispose(),this.G(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(E){switch(E){case"settings":return this.m.createInstance(S.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(R.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(s.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(c.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,T,O,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const A=[],$=(0,t.createSyncHeaders)(O),z=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,H=T?await this.D(z):{};for(const X of F){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(X.resource))return[];try{if(T){const ie=await X.preview(z,H,$);if(ie)for(const G of ie.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await X.merge(G.previewResource)}else await X.sync(z,$)}catch(ie){const G=t.UserDataSyncError.toUserDataSyncError(ie);if(h(G,O,this.r,this.t),a(ie))throw G;this.u.error(ie),this.u.error(`${X.resource}: ${(0,k.toErrorMessage)(ie)}`),A.push([X.resource,G])}}return A}finally{this.G()}}async apply(E,T){const O=(0,t.createSyncHeaders)(E);for(const M of this.enabled){if(T.isCancellationRequested)return;try{await M.apply(!1,O)}catch(F){const A=t.UserDataSyncError.toUserDataSyncError(F);if(h(A,E,this.r,this.t),a(F))throw A;this.u.error(F),this.u.error(`${M.resource}: ${(0,k.toErrorMessage)(F)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(T){this.u.error(T)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(T){this.u.error(`${E.resource}: ${(0,k.toErrorMessage)(T)}`),this.u.error(T)}}async D(E){if(!this.profile.isDefault)return{};const T=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.enabled.find(M=>M instanceof S.SettingsSynchroniser);if(O){const M=await O.getRemoteUserDataSyncConfiguration(E);return{...T,...M}}return T}F(E){this.g!==E&&(this.g=E,this.h.fire(E))}G(){return this.H(),this.enabled.some(E=>E.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const E=this.enabled.filter(T=>T.status==="hasConflicts").filter(T=>T.conflicts.conflicts.length>0).map(T=>T.conflicts);(0,L.equals)(this.j,E,(T,O)=>T.syncResource===O.syncResource&&(0,L.equals)(T.conflicts,O.conflicts,(M,F)=>(0,I.isEqual)(M.previewResource,F.previewResource)))||(this.j=E,this.k.fire(E))}I(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=ye([K(2,t.IUserDataSyncEnablementService),K(3,m.IInstantiationService),K(4,g.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,v.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,u.IUserDataProfilesService),K(9,w.IConfigurationService)],o);function a(b){if(b instanceof t.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function h(b,E,T,O){O.publicLog2("sync/error",{code:b.code,serverCode:b instanceof t.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof t.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:E,service:T.userDataSyncStore.url.toString()})}}),define(oe[281],ae([0,1,3,2,8,18,26]),function(Z,e,L,i,D,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(g,m){return{...g,profile:(0,k.reviveProfile)(g.profile,m.profilesHome.scheme)}}function I(g){return{created:g.created,uri:D.URI.revive(g.uri)}}class y{constructor(m,f,v){this.c=m,this.d=f,this.f=v,this.a=new Map,this.b=new L.Emitter}listen(m,f){switch(f){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${f}`)}async call(m,f,v){try{return await this.g(m,f,v)}catch(u){throw this.f.error(u),u}}async g(m,f,v){switch(f){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(v[0]));case"accept":return this.c.accept(P(v[0],this.d),D.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(v[0],(0,k.reviveProfile)(v[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.c.replace(I(v[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(v[0]));case"getMachineId":return this.c.getMachineId(I(v[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(f.startsWith("manualSync/")){const u=f.substring(11),l=v[0],d=this.h(l);switch(v=v.slice(1),u){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(m){const f=this.a.get(this.j(m));if(!f)throw new Error(`Manual sync taks not found: ${m}`);return f}async i(){const m=await this.c.createManualSyncTask();return this.a.set(this.j(m.id),m),m.id}j(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=y;let C=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(m,f){super(),this.k=f,this.b="uninitialized",this.c=this.B(new L.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new L.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new L.Emitter),this.onSyncErrors=this.j.event,this.a={call(v,u,l){return m.call(v,u,l).then(null,d=>{throw N.UserDataSyncError.toUserDataSyncError(d)})},listen(v,u){return m.listen(v,u)}},this.a.call("_getInitialData").then(([v,u,l])=>{this.l(v),this.m(u),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(v=>this.m(v))),this.B(this.a.listen("onSyncErrors")(v=>this.j.fire(v.map(u=>({...u,error:N.UserDataSyncError.toUserDataSyncError(u.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const m=await this.a.call("createManualSyncTask"),f=this;return new w(m,{async call(u,l,d){return f.a.call(`manualSync/${u}`,[m,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(m,f,v,u){return this.a.call("accept",[m,f,v,u])}resolveContent(m){return this.a.call("resolveContent",[m])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(m,f){return(await this.a.call("getLocalSyncResourceHandles",[m,f])).map(({created:u,uri:l})=>({created:u,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(m,f){return(await this.a.call("getRemoteSyncResourceHandles",[m,f])).map(({created:u,uri:l})=>({created:u,uri:D.URI.revive(l)}))}async getAssociatedResources(m){return(await this.a.call("getAssociatedResources",[m])).map(({resource:v,comparableResource:u})=>({resource:D.URI.revive(v),comparableResource:D.URI.revive(u)}))}getMachineId(m){return this.a.call("getMachineId",[m])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(m){return this.a.call("replace",[m])}async l(m){this.b=m,this.c.fire(m)}async m(m){this.f=m.map(f=>({syncResource:f.syncResource,profile:(0,k.reviveProfile)(f.profile,this.k.profilesHome.scheme),conflicts:f.conflicts.map(v=>({...v,baseResource:D.URI.revive(v.baseResource),localResource:D.URI.revive(v.localResource),remoteResource:D.URI.revive(v.remoteResource),previewResource:D.URI.revive(v.previewResource)}))})),this.g.fire(this.f)}n(m){this.h!==m&&(this.h=m,this.i.fire(m))}};C=ye([K(1,k.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class w extends i.Disposable{constructor(m,f){super(),this.id=m,this.a=f}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[282],ae([0,1,6,23,7,3,2,142,4,22,13,8,31,16,15,14,25,60,45,20,26]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const R="sync.previous.store",s="sync.donot-make-requests-until",c="sync.user-session-id",t="sync.machine-session-id",n=100,r=1e3*60*5;let o=class extends N.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(S.SYNC_SERVICE_URL_TYPE,-1)}set c(O){this.h.store(S.SYNC_SERVICE_URL_TYPE,O,-1,I.isWeb?0:1)}constructor(O,M,F){super(),this.f=O,this.g=M,this.h=F,this.a=this.B(new k.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(k.Event.filter(F.onDidChangeValue,A=>A.key===S.SYNC_SERVICE_URL_TYPE&&A.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[S.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(O,M){O=I.isWeb&&O?.web?{...O,...O.web}:O;const F={...O||{},...M||{}};if(F&&(0,C.isString)(F.url)&&(0,C.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(A=>Array.isArray(F.authenticationProviders[A].scopes))){const A=F,$=!!A.canSwitch&&!M?.url,z=A.url===A.insidersUrl?"insiders":"stable",H=($?this.c:void 0)||z,X=M?.url||(H==="insiders"?A.insidersUrl:H==="stable"?A.stableUrl:A.url);return{url:w.URI.parse(X),type:H,defaultType:z,defaultUrl:w.URI.parse(A.url),stableUrl:w.URI.parse(A.stableUrl),insidersUrl:w.URI.parse(A.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(A.authenticationProviders).reduce((ie,G)=>(ie.push({id:G,scopes:A.authenticationProviders[G].scopes}),ie),[])}}}};o=ye([K(0,u.IProductService),K(1,m.IConfigurationService),K(2,p.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let a=class extends o{constructor(O,M,F){super(O,M,F);const A=this.h.get(R,-1);A&&(this.k=JSON.parse(A));const $=this.f[S.CONFIGURATION_SYNC_STORE_KEY];$?this.h.store(R,JSON.stringify($),-1,1):this.h.remove(R,-1)}async switch(O){O!==this.c&&(this.c=O,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};a=ye([K(0,u.IProductService),K(1,m.IConfigurationService),K(2,p.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends N.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(O,M,F,A,$,z,H){super(),this.k=F,this.l=A,this.n=H,this.g=this.B(new k.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new k.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(O),this.c=(0,d.getServiceMachineId)($,z,H).then(X=>{const ie={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(ie["X-Client-Commit"]=M.commit),ie}),this.f=new E(n,r,this.k,this.l),this.r(),this.B((0,N.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(O,M){this.b={token:O,type:M}}p(O){this.a=O?(0,y.joinPath)(O,"v1"):void 0}r(){const O=this.n.getNumber(s,-1);O&&Date.now()<O&&this.t(new Date(O))}t(O){this.i?.getTime()!==O?.getTime()&&(this.i=O,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(s,this.i.getTime(),-1,1),this.s=(0,L.createCancelablePromise)(M=>(0,L.timeout)(this.i.getTime()-Date.now(),M).then(()=>this.t(void 0))),this.s.then(null,M=>null)):this.n.remove(s,-1),this.j.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,y.joinPath)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const F=await this.w(M,{type:"GET",headers:O},[],i.CancellationToken.None);return(await(0,l.asJson)(F))?.map(({id:A})=>A)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,y.joinPath)(this.a,"collection").toString();O={...O},O["Content-Type"]=P.Mimes.text;const F=await this.w(M,{type:"POST",headers:O},[],i.CancellationToken.None),A=await(0,l.asTextOrError)(F);if(!A)throw new S.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);return A}async deleteCollection(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=O?(0,y.joinPath)(this.a,"collection",O).toString():(0,y.joinPath)(this.a,"collection").toString();M={...M},await this.w(F,{type:"DELETE",headers:M},[],i.CancellationToken.None)}async getAllResourceRefs(O,M){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.u(this.a,M,O),A={},$=await this.w(F.toString(),{type:"GET",headers:A},[],i.CancellationToken.None);return(await(0,l.asJson)($)||[]).map(({url:H,created:X})=>({ref:(0,y.relativePath)(F,F.with({path:H})),created:X*1e3}))}async resolveResourceContent(O,M,F,A={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,y.joinPath)(this.u(this.a,F,O),M).toString();A={...A},A["Cache-Control"]="no-cache";const z=await this.w($,{type:"GET",headers:A},[],i.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(O,M,F){if(!this.a)throw new Error("No settings sync store url configured.");const A=M!==null?(0,y.joinPath)(this.u(this.a,F,O),M).toString():this.u(this.a,F,O).toString(),$={};await this.w(A,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,y.joinPath)(this.a,"resource").toString(),M={"Content-Type":P.Mimes.text};await this.w(O,{type:"DELETE",headers:M},[],i.CancellationToken.None)}async readResource(O,M,F,A={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,y.joinPath)(this.u(this.a,F,O),"latest").toString();A={...A},A["Cache-Control"]="no-cache",M&&(A["If-None-Match"]=M.ref);const z=await this.w($,{type:"GET",headers:A},[304],i.CancellationToken.None);let H=null;if(z.res.statusCode===304&&(H=M),H===null){const X=z.res.headers.etag;if(!X)throw new S.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",z.res.statusCode,z.res.headers[S.HEADER_OPERATION_ID]);const ie=await(0,l.asTextOrError)(z);if(!ie&&z.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",$,"EmptyResponse",z.res.statusCode,z.res.headers[S.HEADER_OPERATION_ID]);H={ref:X,content:ie}}return H}async writeResource(O,M,F,A,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,A,O).toString();$={...$},$["Content-Type"]=P.Mimes.text,F&&($["If-Match"]=F);const H=await this.w(z,{type:"POST",data:M,headers:$},[],i.CancellationToken.None),X=H.res.headers.etag;if(!X)throw new S.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[S.HEADER_OPERATION_ID]);return X}async manifest(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,y.joinPath)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const A=await this.w(F,{type:"GET",headers:M},[304],i.CancellationToken.None);let $=null;if(A.res.statusCode===304&&($=O),!$){const H=A.res.headers.etag;if(!H)throw new S.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",A.res.statusCode,A.res.headers[S.HEADER_OPERATION_ID]);const X=await(0,l.asTextOrError)(A);if(!X&&A.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",F,"EmptyResponse",A.res.statusCode,A.res.headers[S.HEADER_OPERATION_ID]);X&&($={...JSON.parse(X),ref:H})}const z=this.n.get(c,-1);return z&&$&&z!==$.session&&this.v(),$===null&&z&&this.v(),$&&this.n.store(c,$.session,-1,1),$}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(O,M,F){return M?(0,y.joinPath)(O,"collection",M,"resource",F):(0,y.joinPath)(O,"resource",F)}v(){this.n.remove(c,-1),this.n.remove(t,-1)}async w(O,M,F,A){if(!this.b)throw new S.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const $=await this.c;M.headers={...M.headers||{},...$,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(M.headers),this.l.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let z;try{z=await this.f.request(O,M,A)}catch(j){if(!(j instanceof S.UserDataSyncStoreError)){let V="RequestFailed";const x=(0,D.getErrorMessage)(j).toLowerCase();x.includes("xhr timeout")?V="RequestTimeout":x.includes("protocol")&&x.includes("not supported")?V="RequestProtocolNotSupported":x.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":x.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.isCancellationError)(j)&&(V="RequestCanceled"),j=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,V,void 0,void 0)}throw this.l.info("Request failed",O),j}const H=z.res.headers[S.HEADER_OPERATION_ID],X={url:O,status:z.res.statusCode,"execution-id":M.headers[S.HEADER_EXECUTION_ID],"operation-id":H},ie=(0,l.isSuccess)(z)||z.res.statusCode&&F.indexOf(z.res.statusCode)!==-1;let G="";if(ie?this.l.trace("Request succeeded",X):(this.l.info("Request failed",X),G=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new S.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",z.res.statusCode,H);if(this.h.fire(),z.res.statusCode===404)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",z.res.statusCode,H);if(z.res.statusCode===405)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested endpoint is not found (405). ${G}`,O,"MethodNotFound",z.res.statusCode,H);if(z.res.statusCode===409)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",z.res.statusCode,H);if(z.res.statusCode===410)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",z.res.statusCode,H);if(z.res.statusCode===412)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",z.res.statusCode,H);if(z.res.statusCode===413)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",z.res.statusCode,H);if(z.res.statusCode===426)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",z.res.statusCode,H);if(z.res.statusCode===429){const j=z.res.headers["retry-after"];throw j?(this.t(new Date(Date.now()+parseInt(j)*1e3)),new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",z.res.statusCode,H)):new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",z.res.statusCode,H)}if(!ie)throw new S.UserDataSyncStoreError("Server returned "+z.res.statusCode,O,"Unknown",z.res.statusCode,H);return z}y(O){let M=this.n.get(t,-1);M===void 0&&(M=(0,g.generateUuid)(),this.n.store(t,M,-1,1)),O["X-Machine-Session-Id"]=M;const F=this.n.get(c,-1);F!==void 0&&(O["X-User-Session-Id"]=F)}};h=ye([K(1,u.IProductService),K(2,l.IRequestService),K(3,S.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,v.IFileService),K(6,p.IStorageService)],h),e.UserDataSyncStoreClient=h;let b=class extends h{constructor(O,M,F,A,$,z,H){super(O.userDataSyncStore?.url,M,F,A,$,z,H),this.B(O.onDidChangeUserDataSyncStore(()=>this.p(O.userDataSyncStore?.url)))}};b=ye([K(0,S.IUserDataSyncStoreManagementService),K(1,u.IProductService),K(2,l.IRequestService),K(3,S.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,v.IFileService),K(6,p.IStorageService)],b),e.UserDataSyncStoreService=b;class E{constructor(O,M,F,A){this.c=O,this.d=M,this.f=F,this.g=A,this.a=[],this.b=void 0}request(O,M,F){if(this.h()&&this.i(),M.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new S.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(M,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=E}),define(oe[283],ae([0,1,3,58,25,20,19,278,26,78,81]),function(Z,e,L,i,D,k,N,P,I,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(m,f,v,u,l,d,p,S,R,s,c){super(m,f,v,u,l,p,S,R,s,c),this.B(L.Event.debounce(L.Event.any(L.Event.map(d.onDidFocusWindow,()=>"windowFocus"),L.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=ye([K(0,D.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,i.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,y.IUserDataSyncAccountService),K(8,N.ITelemetryService),K(9,C.IUserDataSyncMachinesService),K(10,k.IStorageService)],w),e.UserDataAutoSyncService=w}),define(oe[284],ae([0,1,100,24,4,22]),function(Z,e,L,i,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function N(y){function C(){let w=y.scheme===i.Schemas.file?(0,k.originalFSPath)(y):y.toString();return D.isLinux||(w=w.toLowerCase()),(0,L.createHash)("md5").update(w).digest("hex")}return{id:C(),configPath:y}}e.getWorkspaceIdentifier=N;function P(y,C){function w(){if(y.scheme!==i.Schemas.file)return(0,L.createHash)("md5").update(y.toString()).digest("hex");if(!C)return;let m;return D.isLinux?m=C.ino:D.isMacintosh?m=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?m=Math.floor(C.birthtimeMs):m=C.birthtime.getTime()),(0,L.createHash)("md5").update(y.fsPath).update(m?String(m):"").digest("hex")}const g=w();if(typeof g=="string")return{id:g,uri:y}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[285],ae([0,1,6,7,2,12,28,15,57,9,58,76,118,284]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends D.Disposable{constructor(u,l,d,p){super(),this.a=u,this.b=l,this.c=d,this.f=p,this.B(new L.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=await N.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new w.StorageClient(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const p=(0,k.join)(this.a.workspaceStorageHome.fsPath,d);d.length===m.NON_EMPTY_WORKSPACE_ID_LENGTH||d===g.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(s=>s.workspace?.id===d)||await l.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await N.Promises.rm(p))}))}catch(u){(0,i.onUnexpectedError)(u)}}};f=ye([K(0,P.INativeEnvironmentService),K(1,y.ILogService),K(2,C.INativeHostService),K(3,I.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(oe[127],ae([0,1,53,6,12,13,28,153,294,295]),function(Z,e,L,i,D,k,N,P,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(s,c){let t=c.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=s,this.cause=c}}e.ExtractError=C;function w(R){const s=R.externalFileAttributes>>16||33188;return[448,56,7].map(c=>s&c).reduce((c,t)=>c+t,s&61440)}function g(R){if(R instanceof C)return R;let s;return/end of central directory record signature not found/.test(R.message)&&(s="CorruptZip"),new C(s,R)}function m(R,s,c,t,n,r){const o=D.dirname(s),a=D.join(t,o);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,s)));const h=D.join(t,s);let b;return r.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((E,T)=>{if(!r.isCancellationRequested)try{b=(0,L.createWriteStream)(h,{mode:c}),b.once("close",()=>E()),b.once("error",T),R.once("error",T),R.pipe(b)}catch(O){T(O)}}))}function f(R,s,c,t){let n=(0,i.createCancelablePromise)(()=>Promise.resolve()),r=0;return t.onCancellationRequested(()=>{n.cancel(),R.close()}),new Promise((o,a)=>{const h=new i.Sequencer,b=E=>{E.isCancellationRequested||(r++,R.readEntry())};R.once("error",a),R.once("close",()=>n.then(()=>{t.isCancellationRequested||R.entryCount===r?o():a(new C("Incomplete",new Error(P.localize(1,null,r,R.entryCount))))},a)),R.readEntry(),R.on("entry",E=>{if(t.isCancellationRequested)return;if(!c.sourcePathRegex.test(E.fileName)){b(t);return}const T=E.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(T)){const F=D.join(s,T);n=(0,i.createCancelablePromise)(A=>N.Promises.mkdir(F,{recursive:!0}).then(()=>b(A)).then(void 0,a));return}const O=u(R,E),M=w(E);n=(0,i.createCancelablePromise)(F=>h.queue(()=>O.then(A=>m(A,T,M,s,c,F).then(()=>b(F)))).then(null,a))})})}function v(R,s=!1){return new Promise((c,t)=>{(0,I.open)(R,s?{lazyEntries:!0}:void 0,(n,r)=>{n?t(g(n)):c((0,k.assertIsDefined)(r))})})}function u(R,s){return new Promise((c,t)=>{R.openReadStream(s,(n,r)=>{n?t(g(n)):c((0,k.assertIsDefined)(r))})})}function l(R,s){return new Promise((c,t)=>{const n=new y.ZipFile;s.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,L.createWriteStream)(R);n.outputStream.pipe(r),n.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>c(R))})}e.zip=l;function d(R,s,c={},t){const n=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let r=v(R,!0);return c.overwrite&&(r=r.then(o=>N.Promises.rm(s).then(()=>o))),r.then(o=>f(o,s,{sourcePathRegex:n},t))}e.extract=d;function p(R,s){return v(R).then(c=>new Promise((t,n)=>{c.on("entry",r=>{r.fileName===s&&u(c,r).then(o=>t(o),o=>n(o))}),c.once("close",()=>n(new Error(P.localize(2,null,s))))}))}function S(R,s){return p(R,s).then(c=>new Promise((t,n)=>{const r=[];c.once("error",n),c.on("data",o=>r.push(o)),c.on("end",()=>t(Buffer.concat(r)))}))}e.buffer=S}),define(oe[286],ae([0,1,127,163]),function(Z,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,L.buffer)(k,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(oe[128],ae([0,1,6,23,38,7,3,2,37,24,12,4,22,54,13,8,31,28,127,162,97,15,267,30,33,51,79,236,269,286,220,237,42,70,14,5,9,25,19,29,18]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R,s,c,t,n,r,o,a,h,b,E,T,O,M,F,A,$,z,H,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(c.IExtensionManagementService);let ie=class extends s.AbstractExtensionManagementService{constructor(U,B,W,q,J,_,Y,Q,se,le,ue,pe){super(U,B,W,le,pe),this.Y=J,this.Z=_,this.ab=Y,this.bb=se,this.cb=ue,this.X=new Map,this.kb=new I.ResourceSet;const we=this.B(Q.createInstance(a.ExtensionsLifecycle));this.S=this.B(Q.createInstance(G,Ee=>we.postUninstall(Ee))),this.U=this.B(new b.ExtensionsManifestCache(q,this)),this.W=this.B(Q.createInstance(o.ExtensionsDownloader));const be=this.B(new E.ExtensionsWatcher(this,this.Y,pe,_,ue,se,W));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(U){this.v.trace("ExtensionManagementService#zip",U.identifier.id);const B=await this.ib(U),W=await(0,d.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,B);return v.URI.file(W)}async unzip(U){return this.v.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:B,cleanup:W}=await this.eb(U),q=C.resolve(B.fsPath);try{return await(0,h.getManifest)(q)}finally{await W()}}getInstalled(U,B){return this.S.scanExtensions(U??null,B)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(U,B={}){this.v.trace("ExtensionManagementService#install",U.toString());const{location:W,cleanup:q}=await this.eb(U);try{const J=await(0,h.getManifest)(C.resolve(W.fsPath));if(J.engines&&J.engines.vscode&&!(0,O.isEngineValid)(J.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,t.getGalleryExtensionId)(J.publisher,J.name),this.w.version));return await this.z(J,W,B)}finally{await q()}}async installFromLocation(U,B){this.v.trace("ExtensionManagementService#installFromLocation",U.toString());const W=await this.S.scanUserExtensionAtLocation(U);if(!W)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.nb([W],B),this.v.info("Successfully installed extension",W.identifier.id,B.toString()),W}getMetadata(U){return this.Y.scanMetadata(U.location)}async updateMetadata(U,B){this.v.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const W={...B};return B.isPreReleaseVersion&&(W.preRelease=!0),U=await this.S.updateMetadata(U,W),this.U.invalidate(),U}async updateExtensionScope(U,B){return this.v.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.S.updateMetadata(U,{isMachineScoped:B}),this.U.invalidate(),U}async reinstallFromGallery(U){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const B=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:B,compatible:!0},i.CancellationToken.None);if(!W)throw new Error(p.localize(2,null));await this.S.setUninstalled(U);try{await this.S.removeUninstalledExtension(U)}catch(q){throw new Error(p.localize(3,null,(0,D.toErrorMessage)(q)))}return this.installFromGallery(W)}markAsUninstalled(...U){return this.S.setUninstalled(...U)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(U,B){const{location:W}=await this.W.download(U,B);return W}async eb(U){if(U.scheme===y.Schemas.file)return{location:U,async cleanup(){}};this.v.trace("Downloading extension from",U.toString());const B=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.ab.download(U,B),this.v.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.bb.del(B)}catch(q){this.v.error(q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(U,B,W){let q;if(v.URI.isUri(B))q=new x(U,B,W,this.t,this.S,this.v);else{const J=t.ExtensionKey.create(B).toString();q=this.X.get(J),q||(this.X.set(J,q=new V(U,B,W,this.W,this.S,this.v)),q.waitUntilTaskIsFinished().then(()=>this.X.delete(J)))}return new ee(q,W.profileLocation,this.cb,this.y,this.Y,this.Z)}R(U,B){return new re(U,B.profileLocation,this.Z)}async ib(U){const B=async q=>{let J=await l.Promises.readdir(q);J=J.map(Q=>C.join(q,Q));const _=await Promise.all(J.map(Q=>l.Promises.stat(Q)));let Y=Promise.resolve([]);return _.forEach((Q,se)=>{const le=J[se];Q.isFile()&&(Y=Y.then(ue=>[...ue,le])),Q.isDirectory()&&(Y=Y.then(ue=>B(le).then(pe=>[...ue,...pe])))}),Y};return(await B(U.location.fsPath)).map(q=>({path:`extension/${C.relative(U.location.fsPath,q)}`,localPath:q}))}async jb({added:U,removed:B}){if(B)for(const W of B.extensions)this.v.info("Extensions removed from another source",W.id,B.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:B.profileLocation});if(U){const q=(await this.S.scanExtensions(1,U.profileLocation)).filter(J=>U.extensions.some(_=>(0,t.areSameExtensions)(_,J.identifier)));this.m.fire(q.map(J=>(this.v.info("Extensions added from another source",J.identifier.id,U.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:U.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(B=>this.kb.add(B)));const U=await this.bb.resolve(this.Y.userExtensionsLocation);for(const B of U.children??[])B.isDirectory&&this.kb.add(B.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(B=>this.mb(B)))}async mb(U){if(!U.affects(this.Y.userExtensionsLocation,1))return;const B=[];for(const W of U.rawAdded){if(this.kb.has(W)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(W),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(W,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(W).startsWith(".")||!(await this.bb.stat(W)).isDirectory)continue;const q=await this.S.scanUserExtensionAtLocation(W);q&&q.installedTimestamp===void 0&&(this.kb.add(W),B.push(q))}B.length&&(await this.nb(B,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",B.map(W=>W.identifier.id)))}async nb(U,B){await this.Z.addExtensionsToProfile(U.map(W=>[W,void 0]),B),this.m.fire(U.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:B})))}};ie=ye([K(0,c.IExtensionGalleryService),K(1,z.ITelemetryService),K(2,A.ILogService),K(3,R.INativeEnvironmentService),K(4,r.IExtensionsScannerService),K(5,n.IExtensionsProfileScannerService),K(6,S.IDownloadService),K(7,F.IInstantiationService),K(8,M.IFileService),K(9,$.IProductService),K(10,H.IUriIdentityService),K(11,X.IUserDataProfilesService)],ie),e.ExtensionManagementService=ie;let G=class extends P.Disposable{constructor(U,B,W,q){super(),this.j=U,this.k=B,this.l=W,this.m=q,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,g.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new L.Queue}async cleanUp(){await this.v()}async scanExtensions(U,B){const W={includeInvalid:!0,profileLocation:B};let q=[];return U===null||U===0?q.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):U===1&&q.push(...await this.l.scanUserExtensions(W)),q=U!==null?q.filter(J=>J.type===U):q,Promise.all(q.map(J=>this.u(J)))}async scanAllUserExtensions(U){const B=await this.l.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(B.map(W=>this.u(W)))}async scanUserExtensionAtLocation(U){try{const B=await this.l.scanExistingExtension(U,1,{includeInvalid:!0});if(B)return await this.u(B)}catch(B){this.m.error(B)}return null}async extractUserExtension(U,B,W,q){const J=U.toString(),_=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),Y=C.join(this.l.userExtensionsLocation.fsPath,J);try{await l.Promises.rm(Y)}catch{throw new c.ExtensionManagementError(p.localize(4,null,Y,U.id),c.ExtensionManagementErrorCode.Delete)}await this.p(U,B,_,q),await this.l.updateMetadata(v.URI.file(_),W);try{this.h.fire(v.URI.file(Y)),await this.s(U,_,Y,Date.now()+2*60*1e3),this.m.info("Renamed to",Y)}catch(Q){try{await l.Promises.rm(_)}catch{}if(Q.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.m.info(`Rename failed because of ${(0,k.getErrorMessage)(Q)}. Deleted from extracted location`,_),Q}return this.t(v.URI.file(Y),1)}async updateMetadata(U,B){return await this.l.updateMetadata(U.location,B),this.t(U.location,U.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...U){const B=U.map(W=>t.ExtensionKey.create(W));await this.n(W=>B.forEach(q=>{W[q.toString()]=!0,this.m.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(U){await this.n(q=>delete q[U.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(q=>t.ExtensionKey.create(q).equals(U))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(U,B){this.m.trace(`Deleting ${B} extension from disk`,U.identifier.id,U.location.fsPath),await l.Promises.rm(U.location.fsPath),this.m.info("Deleted from disk",U.identifier.id,U.location.fsPath)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.n(B=>delete B[t.ExtensionKey.create(U).toString()])}async n(U){return this.g.queue(async()=>{let B;try{B=await l.Promises.readFile(this.c,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let W={};if(B)try{W=JSON.parse(B)}catch{}return U&&(U(W),Object.keys(W).length?await l.Promises.writeFile(this.c,JSON.stringify(W)):await l.Promises.rm(this.c)),W})}async p(U,B,W,q){this.m.trace(`Started extracting the extension from ${B} to ${W}`);try{await l.Promises.rm(W)}catch(J){throw new c.ExtensionManagementError(this.w(J).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(B,W,{sourcePath:"extension",overwrite:!0},q),this.m.info(`Extracted extension to ${W}:`,U.id)}catch(J){try{await l.Promises.rm(W)}catch{}let _=c.ExtensionManagementErrorCode.Extract;throw J instanceof d.ExtractError&&(J.type==="CorruptZip"?_=c.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(_=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(J.message,_)}}async s(U,B,W,q){try{await l.Promises.rename(B,W)}catch(J){if(w.isWindows&&J&&J.code==="EPERM"&&Date.now()<q)return this.m.info(`Failed renaming ${B} to ${W} with 'EPERM' error. Trying again...`,U.id),this.s(U,B,W,q);throw new c.ExtensionManagementError(J.message||p.localize(5,null,B,W),J.code||c.ExtensionManagementErrorCode.Rename)}}async t(U,B){const W=await this.l.scanExistingExtension(U,B,{includeInvalid:!0});if(W)return this.u(W);throw new Error(p.localize(6,null,U.path))}async u(U){const B=await this.k.resolve(U.location);let W,q;return B.children&&(W=B.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,q=B.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:W,changelogUrl:q,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated}}async v(){const U=await this.getUninstalledExtensions(),B=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const _ of B)U[t.ExtensionKey.create(_).toString()]||W.add(_.identifier.id.toLowerCase());const q=(0,t.groupByExtension)(B,_=>_.identifier);await L.Promises.settled(q.map(async _=>{const Y=_.sort((Q,se)=>m.rcompare(Q.manifest.version,se.manifest.version))[0];W.has(Y.identifier.id.toLowerCase())||await this.j(await this.u(Y))}));const J=B.filter(_=>_.metadata&&U[t.ExtensionKey.create(_).toString()]);await L.Promises.settled(J.map(_=>this.removeUninstalledExtension(_)))}w(U){const B=Array.isArray(U)?U:[U];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((W,q)=>new Error(`${W.message}${W.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}};G=ye([K(1,M.IFileService),K(2,r.IExtensionsScannerService),K(3,A.ILogService)],G),e.ExtensionsScanner=G;class j extends s.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,f.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(U,B,W,q,J){super(),this.identifier=U,this.source=B,this.l=W,this.m=q,this.n=J,this.j="Unverified",this.k=2}async o(U,B){try{const W=await this.p(U.key);if(W)return this.m.updateMetadata(W,U.metadata)}catch{throw w.isMacintosh?new c.ExtensionManagementError(p.localize(7,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(p.localize(8,null),c.ExtensionManagementErrorCode.Internal)}return this.s(U,B)}async p(U){if(!await this.q(U))return null;this.n.trace("Removing the extension from uninstalled list:",U.id);const W=await this.m.setInstalled(U);return this.n.info("Removed the extension from uninstalled list:",U.id),W}async q(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}async s({zipPath:U,key:B,metadata:W},q){const J=await this.m.extractUserExtension(B,U,W,q);return this.n.info("Extracting completed.",B.id),J}}class V extends j{constructor(U,B,W,q,J,_){super(B.identifier,B,W,J,_),this.t=U,this.u=B,this.v=q}async h(U){const W=(await this.m.scanExtensions(null,void 0)).find(Y=>(0,t.areSameExtensions)(Y.identifier,this.u.identifier));W&&(this.k=3);const q={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,T.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||W?.isMachineScoped,isBuiltin:this.l.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,f.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(W,q),metadata:q};const{location:J,verificationStatus:_}=await this.v.download(this.u,this.k);try{return this.j=_,this.x(J.fsPath),{local:await this.o({zipPath:J.fsPath,key:t.ExtensionKey.create(this.u),metadata:q},U),metadata:q}}catch(Y){try{await this.v.delete(J)}catch(Q){this.n.warn("Error while deleting the downloaded file",J.toString(),(0,k.getErrorMessage)(Q))}throw Y}}async x(U){try{await(0,h.getManifest)(U)}catch(B){throw new c.ExtensionManagementError((0,s.joinErrors)(B).message,c.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class x extends j{constructor(U,B,W,q,J,_){super({id:(0,t.getGalleryExtensionId)(U.publisher,U.name)},B,W,J,_),this.t=U,this.u=B,this.v=q}async h(U){const B=new t.ExtensionKey(this.identifier,this.t.version),q=(await this.m.scanExtensions(1,void 0)).find(Y=>(0,t.areSameExtensions)(this.identifier,Y.identifier)),J=await this.x(this.identifier.id,this.t.version,U);if(J.isApplicationScoped=(0,T.isApplicationScopedExtension)(this.t),J.isMachineScoped=this.l.isMachineScoped||q?.isMachineScoped,J.isBuiltin=this.l.isBuiltin||q?.isBuiltin,J.installedTimestamp=Date.now(),q)if(this.k=3,B.equals(new t.ExtensionKey(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(p.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&m.gt(q.manifest.version,this.t.version)&&await this.m.setUninstalled(q);else{const Y=await this.p(B);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(p.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:C.resolve(this.u.fsPath),key:B,metadata:J},U),metadata:J}}async x(U,B,W){try{let[q]=await this.v.getExtensions([{id:U,version:B}],W);if(q||([q]=await this.v.getExtensions([{id:U}],W)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class ee{get verificationStatus(){return this.d.verificationStatus}constructor(U,B,W,q,J,_){this.d=U,this.g=B,this.h=W,this.j=q,this.k=J,this.l=_,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const U=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[U.local,U.metadata]],this.g),U}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class re extends s.AbstractExtensionTask{constructor(U,B,W){super(),this.extension=U,this.j=B,this.k=W}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[287],ae([0,1,2,30,80,235,128,9,20]),function(Z,e,L,i,D,k,N,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let y=class extends L.Disposable{constructor(w,g,m,f,v,u){super(),w.removeUninstalledExtensions(),(0,k.migrateUnsupportedExtensions)(w,g,m,f,u),D.ExtensionStorageService.removeOutdatedExtensionVersions(w,v)}};y=ye([K(0,N.INativeServerExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,D.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,I.IStorageService),K(5,P.ILogService)],y),e.ExtensionsContributions=y}),define(oe[296],ae([0,1,94,34,38,7,2,24,22,8,39,151,212,213,206,207,285,195,198,16,218,96,233,97,225,15,230,119,271,30,98,197,272,128,99,193,14,209,210,55,5,204,72,205,57,73,239,9,104,58,105,25,60,20,273,110,19,111,112,113,47,242,115,246,254,80,117,26,78,276,263,264,81,277,280,281,282,283,275,62,265,109,232,77,253,222,252,108,229,29,255,4,256,199,216,215,79,270,18,51,211,59,274,227,241,266,234,107,103,279,287,268]),function(Z,e,L,i,D,k,N,P,I,y,C,w,g,m,f,v,u,l,d,p,S,R,s,c,t,n,r,o,a,h,b,E,T,O,M,F,A,$,z,H,X,ie,G,j,V,x,ee,re,te,U,B,W,q,J,_,Y,Q,se,le,ue,pe,we,be,Ee,Te,Ue,Ye,Be,ce,de,ge,Ce,Pe,Ae,De,je,Oe,Fe,ze,ke,Ne,ne,he,fe,me,ve,Ie,Re,He,$e,Le,qe,Ge,et,rt,vt,At,Lt,St,Tt,Ot,bt,Nt,Ut,Mt,Ft,jt,Et,Ct,$t,Bt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class qt extends N.Disposable{constructor(Se){super(),this.f=Se,this.a=this.B(new w.Server),this.b=void 0,this.c=void 0,this.g()}g(){const Se=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",Se),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Me="vscode:electron-main->shared-process=disposeWorker",We=(Je,it)=>{this.h(it)};L.ipcRenderer.on(Me,We),this.B((0,N.toDisposable)(()=>L.ipcRenderer.removeListener(Me,We)))}h(Se){this.b?.disposeWorker(Se)}async open(){const Se=await this.i();(0,Be.registerConfiguration)(),Se.invokeFunction(Me=>{const We=Me.get(re.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(We)}),this.B((0,N.combinedDisposable)(Se.createInstance(g.CodeCacheCleaner,this.f.codeCachePath),Se.createInstance(m.LanguagePackCachedDataCleaner),Se.createInstance(u.UnusedWorkspaceStorageDataCleaner),Se.createInstance(v.LogsDataCleaner),Se.createInstance(f.LocalizationsUpdater),Se.createInstance(Bt.ExtensionsContributions),Se.createInstance(Ft.UserDataProfilesCleaner)))}async i(){const Se=new G.ServiceCollection,Me={_serviceBrand:void 0,...B.default};Se.set(W.IProductService,Me);const We=new C.StaticRouter(Qe=>Qe==="main"),Je=new j.MessagePortMainProcessService(this.a,We);Se.set(V.IMainProcessService,Je);const it=this.f.policiesData?new Ot.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;Se.set(bt.IPolicyService,it);const Ke=new r.SharedProcessEnvironmentService(this.f.args,Me);Se.set(n.INativeEnvironmentService,Ke);const ct=new te.LogLevelChannelClient(this.a.getChannel("logLevel",We)),tt=new te.LoggerChannelClient(void 0,this.f.logLevel,ct.onDidChangeLogLevel,this.f.loggers,Je.getChannel("logger"));Se.set(re.ILoggerService,tt);const ft=this.B(new re.MultiplexLogService([this.B(new re.ConsoleLogger(this.f.logLevel)),this.B(tt.createLogger((0,I.joinPath)(y.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new te.FollowerLogService(ct,ft));Se.set(re.ILogService,xe),this.c=new Ct.SharedProcessLifecycleService(xe),Se.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),Se.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new $.FileService(xe));Se.set(A.IFileService,_e);const dt=this.B(new z.DiskFileSystemProvider(xe));_e.registerProvider(P.Schemas.file,dt);const gt=this.B(new Ge.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,xe));_e.registerProvider(P.Schemas.vscodeUserData,gt);const nt=this.B(new Nt.UserDataProfilesNativeService(this.f.profiles,Je,Ke));Se.set(St.IUserDataProfilesService,nt);const Xe=this.B(new S.ConfigurationService(nt.defaultProfile.settingsResource,_e,it,xe));Se.set(p.IConfigurationService,Xe);const ot=new _.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);Se.set(J.IStorageService,ot),this.B((0,N.toDisposable)(()=>ot.flush())),await Promise.all([Xe.initialize(),ot.initialize()]);const lt=new Le.UriIdentityService(_e);Se.set($e.IUriIdentityService,lt),Se.set(q.IRequestService,new Ut.SharedProcessRequestService(Je,Xe,Me,xe)),Se.set(l.IChecksumService,new H.SyncDescriptor(d.ChecksumService,void 0,!1)),Se.set(vt.IV8InspectProfilingService,new H.SyncDescriptor(rt.InspectProfilingService,void 0,!1));const ut=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});Se.set(U.INativeHostService,ut),Se.set(c.IDownloadService,new H.SyncDescriptor(t.DownloadService,void 0,!0));const mt=this.B(new Ne.ActiveWindowManager(ut)),pt=new C.StaticRouter(Qe=>mt.getActiveClientId().then(yt=>Qe===yt));Se.set(M.IExtensionRecommendationNotificationService,new F.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",pt)));let ht;const at=[],Pt=(0,pe.isInternalTelemetry)(Me,Xe);if((0,pe.supportsTelemetry)(Me,Ke)){const Qe=new le.TelemetryLogAppender(tt,Ke);at.push(Qe);const{installSourcePath:yt}=Ke;if(Me.aiConfig?.ariaKey){const Dt=new Mt.OneDataSystemAppender(Pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,N.toDisposable)(()=>Dt.flush())),at.push(Dt)}ht=new ue.TelemetryService({appenders:at,commonProperties:(0,Y.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,Pt,yt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{ht=pe.NullTelemetryService;const Qe=pe.NullAppender;at.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(at)),Se.set(Q.ITelemetryService,ht);const Vt=new we.CustomEndpointTelemetryService(Xe,ht,tt,Ke,Me);Se.set(Q.ICustomEndpointTelemetryService,Vt),Se.set(Tt.IExtensionsProfileScannerService,new H.SyncDescriptor(zt.ExtensionsProfileScannerService,void 0,!0)),Se.set(At.IExtensionsScannerService,new H.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),Se.set(b.IExtensionSignatureVerificationService,new H.SyncDescriptor(b.ExtensionSignatureVerificationService,void 0,!0)),Se.set(O.INativeServerExtensionManagementService,new H.SyncDescriptor(O.ExtensionManagementService,void 0,!0)),Se.set(h.IExtensionGalleryService,new H.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),Se.set(h.IExtensionTipsService,new H.SyncDescriptor(T.ExtensionTipsService,void 0,!1)),Se.set(x.ILanguagePackService,new H.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1)),Se.set(R.IDiagnosticsService,new H.SyncDescriptor(s.DiagnosticsService,void 0,!1)),Se.set(ce.IUserDataSyncAccountService,new H.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),Se.set(Be.IUserDataSyncLogService,new H.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),Se.set(Be.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Se.set(h.IGlobalExtensionEnablementService,new H.SyncDescriptor(o.GlobalExtensionEnablementService,void 0,!1)),Se.set(Ye.IIgnoredExtensionsManagementService,new H.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),Se.set(Ue.IExtensionStorageService,new H.SyncDescriptor(Ue.ExtensionStorageService)),Se.set(Be.IUserDataSyncStoreManagementService,new H.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),Se.set(Be.IUserDataSyncStoreService,new H.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),Se.set(Pe.IUserDataSyncMachinesService,new H.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),Se.set(Be.IUserDataSyncBackupStoreService,new H.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),Se.set(Be.IUserDataSyncEnablementService,new H.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),Se.set(Be.IUserDataSyncService,new H.SyncDescriptor(De.UserDataSyncService,void 0,!1)),Se.set(ke.IUserDataProfileStorageService,new H.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),Se.set(Be.IUserDataSyncResourceProviderService,new H.SyncDescriptor($t.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Te.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe,tt,lt);return Rt.initialize(),Se.set(Ee.ILocalPtyService,this.B(Rt)),Se.set(ne.ISignService,new H.SyncDescriptor(he.SignService,void 0,!1)),Se.set(fe.ISharedTunnelsService,new H.SyncDescriptor(me.SharedTunnelsService)),Se.set(ve.ISharedProcessTunnelService,new H.SyncDescriptor(Ie.SharedProcessTunnelService)),Se.set(Et.IRemoteTunnelService,new H.SyncDescriptor(jt.RemoteTunnelService)),new ie.InstantiationService(Se)}j(Se){const Me=new te.LogLevelChannel(Se.get(re.ILogService),Se.get(re.ILoggerService));this.a.registerChannel("logLevel",Me);const We=new E.ExtensionManagementChannel(Se.get(h.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=C.ProxyChannel.fromService(Se.get(x.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const it=C.ProxyChannel.fromService(Se.get(R.IDiagnosticsService));this.a.registerChannel("diagnostics",it);const Ke=new E.ExtensionTipsChannel(Se.get(h.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const ct=C.ProxyChannel.fromService(Se.get(l.IChecksumService));this.a.registerChannel("checksum",ct);const tt=C.ProxyChannel.fromService(Se.get(vt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",tt);const ft=new ge.UserDataSyncMachinesServiceChannel(Se.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ft);const xe=C.ProxyChannel.fromService(Se.get(Q.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(Se.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const dt=new ge.UserDataSyncStoreManagementServiceChannel(Se.get(Be.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",dt);const gt=new je.UserDataSyncChannel(Se.get(Be.IUserDataSyncService),Se.get(St.IUserDataProfilesService),Se.get(re.ILogService));this.a.registerChannel("userDataSync",gt);const nt=this.B(Se.get(X.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const ot=Se.get(Ee.ILocalPtyService),lt=C.ProxyChannel.fromService(ot);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,lt);const ut=C.ProxyChannel.fromService(Se.get(ve.ISharedProcessTunnelService));this.a.registerChannel(ve.ipcSharedProcessTunnelChannelName,ut);const mt=C.ProxyChannel.fromService(Se.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const pt=C.ProxyChannel.fromService(Se.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",pt)}k(Se){window.addEventListener("unhandledrejection",Me=>{(0,k.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Me=>{const We=(0,D.toErrorMessage)(Me,!0);!We||Se.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Wt(It){const Se=new qt(It);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Wt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/243854703b7fa371abb752ec0df7817a615a308b/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
