/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/path","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/codicons","vs/base/common/assert","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(te){for(var e=[],c=0,t=te.length;c<t;c++)e[c]=ye[te[c]];return e};define(ye[50],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(R){return R?R.replace(/\$\((.*?)\)/g,(k,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(k,A,y){this.id=k,this.fontCharacter=A,this.description=y,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add","\\ea60"),t.plus=new t("plus",t.add.fontCharacter),t.gistNew=new t("gist-new",t.add.fontCharacter),t.repoCreate=new t("repo-create",t.add.fontCharacter),t.lightbulb=new t("lightbulb","\\ea61"),t.lightBulb=new t("light-bulb","\\ea61"),t.repo=new t("repo","\\ea62"),t.repoDelete=new t("repo-delete","\\ea62"),t.gistFork=new t("gist-fork","\\ea63"),t.repoForked=new t("repo-forked","\\ea63"),t.gitPullRequest=new t("git-pull-request","\\ea64"),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned","\\ea64"),t.recordKeys=new t("record-keys","\\ea65"),t.keyboard=new t("keyboard","\\ea65"),t.tag=new t("tag","\\ea66"),t.tagAdd=new t("tag-add","\\ea66"),t.tagRemove=new t("tag-remove","\\ea66"),t.person=new t("person","\\ea67"),t.personFollow=new t("person-follow","\\ea67"),t.personOutline=new t("person-outline","\\ea67"),t.personFilled=new t("person-filled","\\ea67"),t.gitBranch=new t("git-branch","\\ea68"),t.gitBranchCreate=new t("git-branch-create","\\ea68"),t.gitBranchDelete=new t("git-branch-delete","\\ea68"),t.sourceControl=new t("source-control","\\ea68"),t.mirror=new t("mirror","\\ea69"),t.mirrorPublic=new t("mirror-public","\\ea69"),t.star=new t("star","\\ea6a"),t.starAdd=new t("star-add","\\ea6a"),t.starDelete=new t("star-delete","\\ea6a"),t.starEmpty=new t("star-empty","\\ea6a"),t.comment=new t("comment","\\ea6b"),t.commentAdd=new t("comment-add","\\ea6b"),t.alert=new t("alert","\\ea6c"),t.warning=new t("warning","\\ea6c"),t.search=new t("search","\\ea6d"),t.searchSave=new t("search-save","\\ea6d"),t.logOut=new t("log-out","\\ea6e"),t.signOut=new t("sign-out","\\ea6e"),t.logIn=new t("log-in","\\ea6f"),t.signIn=new t("sign-in","\\ea6f"),t.eye=new t("eye","\\ea70"),t.eyeUnwatch=new t("eye-unwatch","\\ea70"),t.eyeWatch=new t("eye-watch","\\ea70"),t.circleFilled=new t("circle-filled","\\ea71"),t.primitiveDot=new t("primitive-dot",t.circleFilled.fontCharacter),t.closeDirty=new t("close-dirty",t.circleFilled.fontCharacter),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.fontCharacter),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.fontCharacter),t.debugHint=new t("debug-hint",t.circleFilled.fontCharacter),t.primitiveSquare=new t("primitive-square","\\ea72"),t.edit=new t("edit","\\ea73"),t.pencil=new t("pencil","\\ea73"),t.info=new t("info","\\ea74"),t.issueOpened=new t("issue-opened","\\ea74"),t.gistPrivate=new t("gist-private","\\ea75"),t.gitForkPrivate=new t("git-fork-private","\\ea75"),t.lock=new t("lock","\\ea75"),t.mirrorPrivate=new t("mirror-private","\\ea75"),t.close=new t("close","\\ea76"),t.removeClose=new t("remove-close","\\ea76"),t.x=new t("x","\\ea76"),t.repoSync=new t("repo-sync","\\ea77"),t.sync=new t("sync","\\ea77"),t.clone=new t("clone","\\ea78"),t.desktopDownload=new t("desktop-download","\\ea78"),t.beaker=new t("beaker","\\ea79"),t.microscope=new t("microscope","\\ea79"),t.vm=new t("vm","\\ea7a"),t.deviceDesktop=new t("device-desktop","\\ea7a"),t.file=new t("file","\\ea7b"),t.fileText=new t("file-text","\\ea7b"),t.more=new t("more","\\ea7c"),t.ellipsis=new t("ellipsis","\\ea7c"),t.kebabHorizontal=new t("kebab-horizontal","\\ea7c"),t.mailReply=new t("mail-reply","\\ea7d"),t.reply=new t("reply","\\ea7d"),t.organization=new t("organization","\\ea7e"),t.organizationFilled=new t("organization-filled","\\ea7e"),t.organizationOutline=new t("organization-outline","\\ea7e"),t.newFile=new t("new-file","\\ea7f"),t.fileAdd=new t("file-add","\\ea7f"),t.newFolder=new t("new-folder","\\ea80"),t.fileDirectoryCreate=new t("file-directory-create","\\ea80"),t.trash=new t("trash","\\ea81"),t.trashcan=new t("trashcan","\\ea81"),t.history=new t("history","\\ea82"),t.clock=new t("clock","\\ea82"),t.folder=new t("folder","\\ea83"),t.fileDirectory=new t("file-directory","\\ea83"),t.symbolFolder=new t("symbol-folder","\\ea83"),t.logoGithub=new t("logo-github","\\ea84"),t.markGithub=new t("mark-github","\\ea84"),t.github=new t("github","\\ea84"),t.terminal=new t("terminal","\\ea85"),t.console=new t("console","\\ea85"),t.repl=new t("repl","\\ea85"),t.zap=new t("zap","\\ea86"),t.symbolEvent=new t("symbol-event","\\ea86"),t.error=new t("error","\\ea87"),t.stop=new t("stop","\\ea87"),t.variable=new t("variable","\\ea88"),t.symbolVariable=new t("symbol-variable","\\ea88"),t.array=new t("array","\\ea8a"),t.symbolArray=new t("symbol-array","\\ea8a"),t.symbolModule=new t("symbol-module","\\ea8b"),t.symbolPackage=new t("symbol-package","\\ea8b"),t.symbolNamespace=new t("symbol-namespace","\\ea8b"),t.symbolObject=new t("symbol-object","\\ea8b"),t.symbolMethod=new t("symbol-method","\\ea8c"),t.symbolFunction=new t("symbol-function","\\ea8c"),t.symbolConstructor=new t("symbol-constructor","\\ea8c"),t.symbolBoolean=new t("symbol-boolean","\\ea8f"),t.symbolNull=new t("symbol-null","\\ea8f"),t.symbolNumeric=new t("symbol-numeric","\\ea90"),t.symbolNumber=new t("symbol-number","\\ea90"),t.symbolStructure=new t("symbol-structure","\\ea91"),t.symbolStruct=new t("symbol-struct","\\ea91"),t.symbolParameter=new t("symbol-parameter","\\ea92"),t.symbolTypeParameter=new t("symbol-type-parameter","\\ea92"),t.symbolKey=new t("symbol-key","\\ea93"),t.symbolText=new t("symbol-text","\\ea93"),t.symbolReference=new t("symbol-reference","\\ea94"),t.goToFile=new t("go-to-file","\\ea94"),t.symbolEnum=new t("symbol-enum","\\ea95"),t.symbolValue=new t("symbol-value","\\ea95"),t.symbolRuler=new t("symbol-ruler","\\ea96"),t.symbolUnit=new t("symbol-unit","\\ea96"),t.activateBreakpoints=new t("activate-breakpoints","\\ea97"),t.archive=new t("archive","\\ea98"),t.arrowBoth=new t("arrow-both","\\ea99"),t.arrowDown=new t("arrow-down","\\ea9a"),t.arrowLeft=new t("arrow-left","\\ea9b"),t.arrowRight=new t("arrow-right","\\ea9c"),t.arrowSmallDown=new t("arrow-small-down","\\ea9d"),t.arrowSmallLeft=new t("arrow-small-left","\\ea9e"),t.arrowSmallRight=new t("arrow-small-right","\\ea9f"),t.arrowSmallUp=new t("arrow-small-up","\\eaa0"),t.arrowUp=new t("arrow-up","\\eaa1"),t.bell=new t("bell","\\eaa2"),t.bold=new t("bold","\\eaa3"),t.book=new t("book","\\eaa4"),t.bookmark=new t("bookmark","\\eaa5"),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified","\\eaa6"),t.debugBreakpointConditional=new t("debug-breakpoint-conditional","\\eaa7"),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled","\\eaa7"),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified","\\eaa8"),t.debugBreakpointData=new t("debug-breakpoint-data","\\eaa9"),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled","\\eaa9"),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified","\\eaaa"),t.debugBreakpointLog=new t("debug-breakpoint-log","\\eaab"),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled","\\eaab"),t.briefcase=new t("briefcase","\\eaac"),t.broadcast=new t("broadcast","\\eaad"),t.browser=new t("browser","\\eaae"),t.bug=new t("bug","\\eaaf"),t.calendar=new t("calendar","\\eab0"),t.caseSensitive=new t("case-sensitive","\\eab1"),t.check=new t("check","\\eab2"),t.checklist=new t("checklist","\\eab3"),t.chevronDown=new t("chevron-down","\\eab4"),t.dropDownButton=new t("drop-down-button",t.chevronDown.fontCharacter),t.chevronLeft=new t("chevron-left","\\eab5"),t.chevronRight=new t("chevron-right","\\eab6"),t.chevronUp=new t("chevron-up","\\eab7"),t.chromeClose=new t("chrome-close","\\eab8"),t.chromeMaximize=new t("chrome-maximize","\\eab9"),t.chromeMinimize=new t("chrome-minimize","\\eaba"),t.chromeRestore=new t("chrome-restore","\\eabb"),t.circle=new t("circle","\\eabc"),t.circleOutline=new t("circle-outline",t.circle.fontCharacter),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.fontCharacter),t.circleSlash=new t("circle-slash","\\eabd"),t.circuitBoard=new t("circuit-board","\\eabe"),t.clearAll=new t("clear-all","\\eabf"),t.clippy=new t("clippy","\\eac0"),t.closeAll=new t("close-all","\\eac1"),t.cloudDownload=new t("cloud-download","\\eac2"),t.cloudUpload=new t("cloud-upload","\\eac3"),t.code=new t("code","\\eac4"),t.collapseAll=new t("collapse-all","\\eac5"),t.colorMode=new t("color-mode","\\eac6"),t.commentDiscussion=new t("comment-discussion","\\eac7"),t.compareChanges=new t("compare-changes","\\eafd"),t.creditCard=new t("credit-card","\\eac9"),t.dash=new t("dash","\\eacc"),t.dashboard=new t("dashboard","\\eacd"),t.database=new t("database","\\eace"),t.debugContinue=new t("debug-continue","\\eacf"),t.debugDisconnect=new t("debug-disconnect","\\ead0"),t.debugPause=new t("debug-pause","\\ead1"),t.debugRestart=new t("debug-restart","\\ead2"),t.debugStart=new t("debug-start","\\ead3"),t.debugStepInto=new t("debug-step-into","\\ead4"),t.debugStepOut=new t("debug-step-out","\\ead5"),t.debugStepOver=new t("debug-step-over","\\ead6"),t.debugStop=new t("debug-stop","\\ead7"),t.debug=new t("debug","\\ead8"),t.deviceCameraVideo=new t("device-camera-video","\\ead9"),t.deviceCamera=new t("device-camera","\\eada"),t.deviceMobile=new t("device-mobile","\\eadb"),t.diffAdded=new t("diff-added","\\eadc"),t.diffIgnored=new t("diff-ignored","\\eadd"),t.diffModified=new t("diff-modified","\\eade"),t.diffRemoved=new t("diff-removed","\\eadf"),t.diffRenamed=new t("diff-renamed","\\eae0"),t.diff=new t("diff","\\eae1"),t.discard=new t("discard","\\eae2"),t.editorLayout=new t("editor-layout","\\eae3"),t.emptyWindow=new t("empty-window","\\eae4"),t.exclude=new t("exclude","\\eae5"),t.extensions=new t("extensions","\\eae6"),t.eyeClosed=new t("eye-closed","\\eae7"),t.fileBinary=new t("file-binary","\\eae8"),t.fileCode=new t("file-code","\\eae9"),t.fileMedia=new t("file-media","\\eaea"),t.filePdf=new t("file-pdf","\\eaeb"),t.fileSubmodule=new t("file-submodule","\\eaec"),t.fileSymlinkDirectory=new t("file-symlink-directory","\\eaed"),t.fileSymlinkFile=new t("file-symlink-file","\\eaee"),t.fileZip=new t("file-zip","\\eaef"),t.files=new t("files","\\eaf0"),t.filter=new t("filter","\\eaf1"),t.flame=new t("flame","\\eaf2"),t.foldDown=new t("fold-down","\\eaf3"),t.foldUp=new t("fold-up","\\eaf4"),t.fold=new t("fold","\\eaf5"),t.folderActive=new t("folder-active","\\eaf6"),t.folderOpened=new t("folder-opened","\\eaf7"),t.gear=new t("gear","\\eaf8"),t.gift=new t("gift","\\eaf9"),t.gistSecret=new t("gist-secret","\\eafa"),t.gist=new t("gist","\\eafb"),t.gitCommit=new t("git-commit","\\eafc"),t.gitCompare=new t("git-compare","\\eafd"),t.gitMerge=new t("git-merge","\\eafe"),t.githubAction=new t("github-action","\\eaff"),t.githubAlt=new t("github-alt","\\eb00"),t.globe=new t("globe","\\eb01"),t.grabber=new t("grabber","\\eb02"),t.graph=new t("graph","\\eb03"),t.gripper=new t("gripper","\\eb04"),t.heart=new t("heart","\\eb05"),t.home=new t("home","\\eb06"),t.horizontalRule=new t("horizontal-rule","\\eb07"),t.hubot=new t("hubot","\\eb08"),t.inbox=new t("inbox","\\eb09"),t.issueClosed=new t("issue-closed","\\eba4"),t.issueReopened=new t("issue-reopened","\\eb0b"),t.issues=new t("issues","\\eb0c"),t.italic=new t("italic","\\eb0d"),t.jersey=new t("jersey","\\eb0e"),t.json=new t("json","\\eb0f"),t.kebabVertical=new t("kebab-vertical","\\eb10"),t.key=new t("key","\\eb11"),t.law=new t("law","\\eb12"),t.lightbulbAutofix=new t("lightbulb-autofix","\\eb13"),t.linkExternal=new t("link-external","\\eb14"),t.link=new t("link","\\eb15"),t.listOrdered=new t("list-ordered","\\eb16"),t.listUnordered=new t("list-unordered","\\eb17"),t.liveShare=new t("live-share","\\eb18"),t.loading=new t("loading","\\eb19"),t.location=new t("location","\\eb1a"),t.mailRead=new t("mail-read","\\eb1b"),t.mail=new t("mail","\\eb1c"),t.markdown=new t("markdown","\\eb1d"),t.megaphone=new t("megaphone","\\eb1e"),t.mention=new t("mention","\\eb1f"),t.milestone=new t("milestone","\\eb20"),t.mortarBoard=new t("mortar-board","\\eb21"),t.move=new t("move","\\eb22"),t.multipleWindows=new t("multiple-windows","\\eb23"),t.mute=new t("mute","\\eb24"),t.noNewline=new t("no-newline","\\eb25"),t.note=new t("note","\\eb26"),t.octoface=new t("octoface","\\eb27"),t.openPreview=new t("open-preview","\\eb28"),t.package_=new t("package","\\eb29"),t.paintcan=new t("paintcan","\\eb2a"),t.pin=new t("pin","\\eb2b"),t.play=new t("play","\\eb2c"),t.run=new t("run","\\eb2c"),t.plug=new t("plug","\\eb2d"),t.preserveCase=new t("preserve-case","\\eb2e"),t.preview=new t("preview","\\eb2f"),t.project=new t("project","\\eb30"),t.pulse=new t("pulse","\\eb31"),t.question=new t("question","\\eb32"),t.quote=new t("quote","\\eb33"),t.radioTower=new t("radio-tower","\\eb34"),t.reactions=new t("reactions","\\eb35"),t.references=new t("references","\\eb36"),t.refresh=new t("refresh","\\eb37"),t.regex=new t("regex","\\eb38"),t.remoteExplorer=new t("remote-explorer","\\eb39"),t.remote=new t("remote","\\eb3a"),t.remove=new t("remove","\\eb3b"),t.replaceAll=new t("replace-all","\\eb3c"),t.replace=new t("replace","\\eb3d"),t.repoClone=new t("repo-clone","\\eb3e"),t.repoForcePush=new t("repo-force-push","\\eb3f"),t.repoPull=new t("repo-pull","\\eb40"),t.repoPush=new t("repo-push","\\eb41"),t.report=new t("report","\\eb42"),t.requestChanges=new t("request-changes","\\eb43"),t.rocket=new t("rocket","\\eb44"),t.rootFolderOpened=new t("root-folder-opened","\\eb45"),t.rootFolder=new t("root-folder","\\eb46"),t.rss=new t("rss","\\eb47"),t.ruby=new t("ruby","\\eb48"),t.saveAll=new t("save-all","\\eb49"),t.saveAs=new t("save-as","\\eb4a"),t.save=new t("save","\\eb4b"),t.screenFull=new t("screen-full","\\eb4c"),t.screenNormal=new t("screen-normal","\\eb4d"),t.searchStop=new t("search-stop","\\eb4e"),t.server=new t("server","\\eb50"),t.settingsGear=new t("settings-gear","\\eb51"),t.settings=new t("settings","\\eb52"),t.shield=new t("shield","\\eb53"),t.smiley=new t("smiley","\\eb54"),t.sortPrecedence=new t("sort-precedence","\\eb55"),t.splitHorizontal=new t("split-horizontal","\\eb56"),t.splitVertical=new t("split-vertical","\\eb57"),t.squirrel=new t("squirrel","\\eb58"),t.starFull=new t("star-full","\\eb59"),t.starHalf=new t("star-half","\\eb5a"),t.symbolClass=new t("symbol-class","\\eb5b"),t.symbolColor=new t("symbol-color","\\eb5c"),t.symbolCustomColor=new t("symbol-customcolor","\\eb5c"),t.symbolConstant=new t("symbol-constant","\\eb5d"),t.symbolEnumMember=new t("symbol-enum-member","\\eb5e"),t.symbolField=new t("symbol-field","\\eb5f"),t.symbolFile=new t("symbol-file","\\eb60"),t.symbolInterface=new t("symbol-interface","\\eb61"),t.symbolKeyword=new t("symbol-keyword","\\eb62"),t.symbolMisc=new t("symbol-misc","\\eb63"),t.symbolOperator=new t("symbol-operator","\\eb64"),t.symbolProperty=new t("symbol-property","\\eb65"),t.wrench=new t("wrench","\\eb65"),t.wrenchSubaction=new t("wrench-subaction","\\eb65"),t.symbolSnippet=new t("symbol-snippet","\\eb66"),t.tasklist=new t("tasklist","\\eb67"),t.telescope=new t("telescope","\\eb68"),t.textSize=new t("text-size","\\eb69"),t.threeBars=new t("three-bars","\\eb6a"),t.thumbsdown=new t("thumbsdown","\\eb6b"),t.thumbsup=new t("thumbsup","\\eb6c"),t.tools=new t("tools","\\eb6d"),t.triangleDown=new t("triangle-down","\\eb6e"),t.triangleLeft=new t("triangle-left","\\eb6f"),t.triangleRight=new t("triangle-right","\\eb70"),t.triangleUp=new t("triangle-up","\\eb71"),t.twitter=new t("twitter","\\eb72"),t.unfold=new t("unfold","\\eb73"),t.unlock=new t("unlock","\\eb74"),t.unmute=new t("unmute","\\eb75"),t.unverified=new t("unverified","\\eb76"),t.verified=new t("verified","\\eb77"),t.versions=new t("versions","\\eb78"),t.vmActive=new t("vm-active","\\eb79"),t.vmOutline=new t("vm-outline","\\eb7a"),t.vmRunning=new t("vm-running","\\eb7b"),t.watch=new t("watch","\\eb7c"),t.whitespace=new t("whitespace","\\eb7d"),t.wholeWord=new t("whole-word","\\eb7e"),t.window=new t("window","\\eb7f"),t.wordWrap=new t("word-wrap","\\eb80"),t.zoomIn=new t("zoom-in","\\eb81"),t.zoomOut=new t("zoom-out","\\eb82"),t.listFilter=new t("list-filter","\\eb83"),t.listFlat=new t("list-flat","\\eb84"),t.listSelection=new t("list-selection","\\eb85"),t.selection=new t("selection","\\eb85"),t.listTree=new t("list-tree","\\eb86"),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified","\\eb87"),t.debugBreakpointFunction=new t("debug-breakpoint-function","\\eb88"),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled","\\eb88"),t.debugStackframeActive=new t("debug-stackframe-active","\\eb89"),t.circleSmallFilled=new t("circle-small-filled","\\eb8a"),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.fontCharacter),t.debugStackframe=new t("debug-stackframe","\\eb8b"),t.debugStackframeFocused=new t("debug-stackframe-focused","\\eb8b"),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported","\\eb8c"),t.symbolString=new t("symbol-string","\\eb8d"),t.debugReverseContinue=new t("debug-reverse-continue","\\eb8e"),t.debugStepBack=new t("debug-step-back","\\eb8f"),t.debugRestartFrame=new t("debug-restart-frame","\\eb90"),t.callIncoming=new t("call-incoming","\\eb92"),t.callOutgoing=new t("call-outgoing","\\eb93"),t.menu=new t("menu","\\eb94"),t.expandAll=new t("expand-all","\\eb95"),t.feedback=new t("feedback","\\eb96"),t.groupByRefType=new t("group-by-ref-type","\\eb97"),t.ungroupByRefType=new t("ungroup-by-ref-type","\\eb98"),t.account=new t("account","\\eb99"),t.bellDot=new t("bell-dot","\\eb9a"),t.debugConsole=new t("debug-console","\\eb9b"),t.library=new t("library","\\eb9c"),t.output=new t("output","\\eb9d"),t.runAll=new t("run-all","\\eb9e"),t.syncIgnored=new t("sync-ignored","\\eb9f"),t.pinned=new t("pinned","\\eba0"),t.githubInverted=new t("github-inverted","\\eba1"),t.debugAlt=new t("debug-alt","\\eb91"),t.serverProcess=new t("server-process","\\eba2"),t.serverEnvironment=new t("server-environment","\\eba3"),t.pass=new t("pass","\\eba4"),t.stopCircle=new t("stop-circle","\\eba5"),t.playCircle=new t("play-circle","\\eba6"),t.record=new t("record","\\eba7"),t.debugAltSmall=new t("debug-alt-small","\\eba8"),t.vmConnect=new t("vm-connect","\\eba9"),t.cloud=new t("cloud","\\ebaa"),t.merge=new t("merge","\\ebab"),t.exportIcon=new t("export","\\ebac"),t.graphLeft=new t("graph-left","\\ebad"),t.magnet=new t("magnet","\\ebae"),t.notebook=new t("notebook","\\ebaf"),t.redo=new t("redo","\\ebb0"),t.checkAll=new t("check-all","\\ebb1"),t.pinnedDirty=new t("pinned-dirty","\\ebb2"),t.passFilled=new t("pass-filled","\\ebb3"),t.circleLargeFilled=new t("circle-large-filled","\\ebb4"),t.circleLarge=new t("circle-large","\\ebb5"),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.fontCharacter),t.combine=new t("combine","\\ebb6"),t.gather=new t("gather","\\ebb6"),t.table=new t("table","\\ebb7"),t.variableGroup=new t("variable-group","\\ebb8"),t.typeHierarchy=new t("type-hierarchy","\\ebb9"),t.typeHierarchySub=new t("type-hierarchy-sub","\\ebba"),t.typeHierarchySuper=new t("type-hierarchy-super","\\ebbb"),t.gitPullRequestCreate=new t("git-pull-request-create","\\ebbc"),t.runAbove=new t("run-above","\\ebbd"),t.runBelow=new t("run-below","\\ebbe"),t.notebookTemplate=new t("notebook-template","\\ebbf"),t.debugRerun=new t("debug-rerun","\\ebc0"),t.workspaceTrusted=new t("workspace-trusted","\\ebc1"),t.workspaceUntrusted=new t("workspace-untrusted","\\ebc2"),t.workspaceUnspecified=new t("workspace-unspecified","\\ebc3"),t.terminalCmd=new t("terminal-cmd","\\ebc4"),t.terminalDebian=new t("terminal-debian","\\ebc5"),t.terminalLinux=new t("terminal-linux","\\ebc6"),t.terminalPowershell=new t("terminal-powershell","\\ebc7"),t.terminalTmux=new t("terminal-tmux","\\ebc8"),t.terminalUbuntu=new t("terminal-ubuntu","\\ebc9"),t.terminalBash=new t("terminal-bash","\\ebca"),t.arrowSwap=new t("arrow-swap","\\ebcb"),t.copy=new t("copy","\\ebcc"),t.personAdd=new t("person-add","\\ebcd"),t.filterFilled=new t("filter-filled","\\ebce"),t.wand=new t("wand","\\ebcf"),t.debugLineByLine=new t("debug-line-by-line","\\ebd0"),t.inspect=new t("inspect","\\ebd1"),t.layers=new t("layers","\\ebd2"),t.layersDot=new t("layers-dot","\\ebd3"),t.layersActive=new t("layers-active","\\ebd4"),t.compass=new t("compass","\\ebd5"),t.compassDot=new t("compass-dot","\\ebd6"),t.compassActive=new t("compass-active","\\ebd7"),t.azure=new t("azure","\\ebd8"),t.issueDraft=new t("issue-draft","\\ebd9"),t.gitPullRequestClosed=new t("git-pull-request-closed","\\ebda"),t.gitPullRequestDraft=new t("git-pull-request-draft","\\ebdb"),t.debugAll=new t("debug-all","\\ebdc"),t.debugCoverage=new t("debug-coverage","\\ebdd"),t.runErrors=new t("run-errors","\\ebde"),t.folderLibrary=new t("folder-library","\\ebdf"),t.debugContinueSmall=new t("debug-continue-small","\\ebe0"),t.beakerStop=new t("beaker-stop","\\ebe1"),t.graphLine=new t("graph-line","\\ebe2"),t.graphScatter=new t("graph-scatter","\\ebe3"),t.pieChart=new t("pie-chart","\\ebe4"),t.bracket=new t("bracket",t.json.fontCharacter),t.bracketDot=new t("bracket-dot","\\ebe5"),t.bracketError=new t("bracket-error","\\ebe6"),t.lockSmall=new t("lock-small","\\ebe7"),t.azureDevops=new t("azure-devops","\\ebe8"),t.verifiedFilled=new t("verified-filled","\\ebe9"),t.newLine=new t("newline","\\ebea"),t.layout=new t("layout","\\ebeb"),t.layoutActivitybarLeft=new t("layout-activitybar-left","\\ebec"),t.layoutActivitybarRight=new t("layout-activitybar-right","\\ebed"),t.layoutPanelLeft=new t("layout-panel-left","\\ebee"),t.layoutPanelCenter=new t("layout-panel-center","\\ebef"),t.layoutPanelJustify=new t("layout-panel-justify","\\ebf0"),t.layoutPanelRight=new t("layout-panel-right","\\ebf1"),t.layoutPanel=new t("layout-panel","\\ebf2"),t.layoutSidebarLeft=new t("layout-sidebar-left","\\ebf3"),t.layoutSidebarRight=new t("layout-sidebar-right","\\ebf4"),t.layoutStatusbar=new t("layout-statusbar","\\ebf5"),t.layoutMenubar=new t("layout-menubar","\\ebf6"),t.layoutCentered=new t("layout-centered","\\ebf7"),t.layoutSidebarRightOff=new t("layout-sidebar-right-off","\\ec00"),t.layoutPanelOff=new t("layout-panel-off","\\ec01"),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off","\\ec02"),t.target=new t("target","\\ebf8"),t.indent=new t("indent","\\ebf9"),t.recordSmall=new t("record-small","\\ebfa"),t.errorSmall=new t("error-small","\\ebfb"),t.arrowCircleDown=new t("arrow-circle-down","\\ebfc"),t.arrowCircleLeft=new t("arrow-circle-left","\\ebfd"),t.arrowCircleRight=new t("arrow-circle-right","\\ebfe"),t.arrowCircleUp=new t("arrow-circle-up","\\ebff"),t.heartFilled=new t("heart-filled","\\ec04"),t.map=new t("map","\\ec05"),t.mapFilled=new t("map-filled","\\ec06"),t.circleSmall=new t("circle-small","\\ec07"),t.bellSlash=new t("bell-slash","\\ec08"),t.bellSlashDot=new t("bell-slash-dot","\\ec09"),t.commentUnresolved=new t("comment-unresolved","\\ec0a"),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes","\\ec0b"),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes","\\ec0c"),t.searchFuzzy=new t("search-fuzzy","\\ec0d"),t.commentDraft=new t("comment-draft","\\ec0e"),t.dialogError=new t("dialog-error",t.error.fontCharacter),t.dialogWarning=new t("dialog-warning",t.warning.fontCharacter),t.dialogInfo=new t("dialog-info",t.info.fontCharacter),t.dialogClose=new t("dialog-close",t.close.fontCharacter),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.fontCharacter),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.fontCharacter),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.fontCharacter),t.treeFilterClear=new t("tree-filter-clear",t.close.fontCharacter),t.treeItemLoading=new t("tree-item-loading",t.loading.fontCharacter),t.menuSelection=new t("menu-selection",t.check.fontCharacter),t.menuSubmenu=new t("menu-submenu",t.chevronRight.fontCharacter),t.menuBarMore=new t("menubar-more",t.more.fontCharacter),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.fontCharacter),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.fontCharacter),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.fontCharacter),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.fontCharacter),t.toolBarMore=new t("toolbar-more",t.more.fontCharacter),t.quickInputBack=new t("quick-input-back",t.arrowLeft.fontCharacter);var P;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function A(L){if(L instanceof t)return["codicon","codicon-"+L.id];const T=k.exec(L.id);if(!T)return A(t.error);const[,v,D]=T,w=["codicon","codicon-"+v];return D&&w.push("codicon-modifier-"+D.substring(1)),w}R.asClassNameArray=A;function y(L){return A(L).join(" ")}R.asClassName=y;function C(L){return"."+A(L).join(".")}R.asCSSSelector=C})(P=e.CSSIcon||(e.CSSIcon={}))}),define(ye[61],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(k,A){const y=Object.create(null);for(const C of k){const L=A(C);let T=y[L];T||(T=y[L]=[]),T.push(C)}return y}e.groupBy=c;function t(k,A){const y=[],C=[];for(const L of k)A.has(L)||y.push(L);for(const L of A)k.has(L)||C.push(L);return{removed:y,added:C}}e.diffSets=t;function P(k,A){const y=[],C=[];for(const[L,T]of k)A.has(L)||y.push(T);for(const[L,T]of A)k.has(L)||C.push(T);return{removed:y,added:C}}e.diffMaps=P;class R{constructor(){this.a=new Map}add(A,y){let C=this.a.get(A);C||(C=new Set,this.a.set(A,C)),C.add(y)}delete(A,y){const C=this.a.get(A);!C||(C.delete(y),C.size===0&&this.a.delete(A))}forEach(A,y){const C=this.a.get(A);!C||C.forEach(y)}}e.SetMap=R}),define(ye[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(k){return(A,y,C)=>{let L=null,T=null;if(typeof C.value=="function"?(L="value",T=C.value):typeof C.get=="function"&&(L="get",T=C.get),!T)throw new Error("not supported");C[L]=k(T,y)}}function t(k,A,y){let C=null,L=null;if(typeof y.value=="function"?(C="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(C="get",L=y.get),!L)throw new Error("not supported");const T=`$memoize$${A}`;y[C]=function(...v){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[T]}}e.memoize=t;function P(k,A,y){return c((C,L)=>{const T=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...D){this[v]||(this[v]=y?y():void 0),clearTimeout(this[T]),A&&(this[v]=A(this[v],...D),D=[this[v]]),this[T]=setTimeout(()=>{C.apply(this,D),this[v]=y?y():void 0},k)}})}e.debounce=P;function R(k,A,y){return c((C,L)=>{const T=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,D=`$throttle$lastRun$${L}`,w=`$throttle$pending$${L}`;return function(...f){if(this[v]||(this[v]=y?y():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...f)),this[w])return;const d=this[D]+k;d<=Date.now()?(this[D]=Date.now(),C.apply(this,[this[v]]),this[v]=y?y():void 0):(this[w]=!0,this[T]=setTimeout(()=>{this[w]=!1,this[D]=Date.now(),C.apply(this,[this[v]]),this[v]=y?y():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[9],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?b.isErrorNoTelemetry(i)?new b(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=c,e.errorHandler=new c;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function P(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=P;function R(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=R;function k(g){if(g instanceof Error){const{name:i,message:l}=g,o=g.stacktrace||g.stack;return{$isError:!0,name:i,message:l,stack:o,noTelemetry:b.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=k;const A="Canceled";function y(g){return g instanceof C?!0:g instanceof Error&&g.name===A&&g.message===A}e.isCancellationError=y;class C extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=C;function L(){const g=new Error(A);return g.name=g.message,g}e.canceled=L;function T(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=T;function v(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=v;function D(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function w(g){const i=new Error(`${g} has been disposed`);return i.name="DISPOSED",i}e.disposed=w;function f(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=f;class d extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=d;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof b)return i;const l=new b;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype);debugger}}e.BugIndicatingError=E}),define(ye[16],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,oe=0){return se[se.length-(1+oe)]}e.tail=t;function P(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=P;function R(se,oe,fe=(Z,ce)=>Z===ce){if(se===oe)return!0;if(!se||!oe||se.length!==oe.length)return!1;for(let Z=0,ce=se.length;Z<ce;Z++)if(!fe(se[Z],oe[Z]))return!1;return!0}e.equals=R;function k(se,oe){const fe=se.length-1;oe<fe&&(se[oe]=se[fe]),se.pop()}e.removeFastWithoutKeepingOrder=k;function A(se,oe,fe){return y(se.length,Z=>fe(se[Z],oe))}e.binarySearch=A;function y(se,oe){let fe=0,Z=se-1;for(;fe<=Z;){const ce=(fe+Z)/2|0,ne=oe(ce);if(ne<0)fe=ce+1;else if(ne>0)Z=ce-1;else return ce}return-(fe+1)}e.binarySearch2=y;function C(se,oe){let fe=0,Z=se.length;if(Z===0)return 0;for(;fe<Z;){const ce=Math.floor((fe+Z)/2);oe(se[ce])?Z=ce:fe=ce+1}return fe}e.findFirstInSorted=C;function L(se,oe,fe){if(se=se|0,se>=oe.length)throw new TypeError("invalid index");const Z=oe[Math.floor(oe.length*Math.random())],ce=[],ne=[],N=[];for(const H of oe){const Q=fe(H,Z);Q<0?ce.push(H):Q>0?ne.push(H):N.push(H)}return se<ce.length?L(se,ce,fe):se<ce.length+N.length?N[0]:L(se-(ce.length+N.length),ne,fe)}e.quickSelect=L;function T(se,oe){const fe=[];let Z;for(const ce of se.slice(0).sort(oe))!Z||oe(Z[0],ce)!==0?(Z=[ce],fe.push(Z)):Z.push(ce);return fe}e.groupBy=T;function v(se,oe,fe){const Z=[];function ce(H,Q,Y){if(Q===0&&Y.length===0)return;const he=Z[Z.length-1];he&&he.start+he.deleteCount===H?(he.deleteCount+=Q,he.toInsert.push(...Y)):Z.push({start:H,deleteCount:Q,toInsert:Y})}let ne=0,N=0;for(;;){if(ne===se.length){ce(ne,0,oe.slice(N));break}if(N===oe.length){ce(ne,se.length-ne,[]);break}const H=se[ne],Q=oe[N],Y=fe(H,Q);Y===0?(ne+=1,N+=1):Y<0?(ce(ne,1,[]),ne+=1):Y>0&&(ce(ne,0,[Q]),N+=1)}return Z}e.sortedDiff=v;function D(se,oe,fe){const Z=v(se,oe,fe),ce=[],ne=[];for(const N of Z)ce.push(...se.slice(N.start,N.start+N.deleteCount)),ne.push(...N.toInsert);return{removed:ce,added:ne}}e.delta=D;function w(se,oe,fe){if(fe===0)return[];const Z=se.slice(0,fe).sort(oe);return d(se,oe,Z,fe,se.length),Z}e.top=w;function f(se,oe,fe,Z,ce){return fe===0?Promise.resolve([]):new Promise((ne,N)=>{(async()=>{const H=se.length,Q=se.slice(0,fe).sort(oe);for(let Y=fe,he=Math.min(fe+Z,H);Y<H;Y=he,he=Math.min(he+Z,H)){if(Y>fe&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new c.CancellationError;d(se,oe,Q,Y,he)}return Q})().then(ne,N)})}e.topAsync=f;function d(se,oe,fe,Z,ce){for(const ne=fe.length;Z<ce;Z++){const N=se[Z];if(oe(N,fe[ne-1])<0){fe.pop();const H=C(fe,Q=>oe(N,Q)<0);fe.splice(H,0,N)}}}function m(se){return se.filter(oe=>!!oe)}e.coalesce=m;function p(se){let oe=0;for(let fe=0;fe<se.length;fe++)se[fe]&&(se[oe]=se[fe],oe+=1);se.length=oe}e.coalesceInPlace=p;function b(se,oe,fe){se.splice(fe,0,se.splice(oe,1)[0])}e.move=b;function E(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=E;function g(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=g;function i(se,oe=fe=>fe){const fe=new Set;return se.filter(Z=>{const ce=oe(Z);return fe.has(ce)?!1:(fe.add(ce),!0)})}e.distinct=i;function l(se){const oe=new Set;return fe=>{const Z=se(fe);return oe.has(Z)?!1:(oe.add(Z),!0)}}e.uniqueFilter=l;function o(se,oe){const fe=a(se,oe);if(fe!==-1)return se[fe]}e.findLast=o;function a(se,oe){for(let fe=se.length-1;fe>=0;fe--){const Z=se[fe];if(oe(Z))return fe}return-1}e.lastIndex=a;function s(se,oe){return se.length>0?se[0]:oe}e.firstOrDefault=s;function u(se,oe){return se.length>0?se[se.length-1]:oe}e.lastOrDefault=u;function r(se,oe,fe=(Z,ce)=>Z===ce){let Z=0;for(let ce=0,ne=Math.min(se.length,oe.length);ce<ne&&fe(se[ce],oe[ce]);ce++)Z++;return Z}e.commonPrefixLength=r;function n(se){return[].concat(...se)}e.flatten=n;function h(se,oe){let fe=typeof oe=="number"?se:0;typeof oe=="number"?fe=se:(fe=0,oe=se);const Z=[];if(fe<=oe)for(let ce=fe;ce<oe;ce++)Z.push(ce);else for(let ce=fe;ce>oe;ce--)Z.push(ce);return Z}e.range=h;function S(se,oe,fe){return se.reduce((Z,ce)=>(Z[oe(ce)]=fe?fe(ce):ce,Z),Object.create(null))}e.index=S;function I(se,oe){return se.push(oe),()=>F(se,oe)}e.insert=I;function F(se,oe){const fe=se.indexOf(oe);if(fe>-1)return se.splice(fe,1),oe}e.remove=F;function K(se,oe,fe){const Z=se.slice(0,oe),ce=se.slice(oe);return Z.concat(fe,ce)}e.arrayInsert=K;function q(se,oe){let fe;if(typeof oe=="number"){let Z=oe;fe=()=>{const ce=Math.sin(Z++)*179426549;return ce-Math.floor(ce)}}else fe=Math.random;for(let Z=se.length-1;Z>0;Z-=1){const ce=Math.floor(fe()*(Z+1)),ne=se[Z];se[Z]=se[ce],se[ce]=ne}}e.shuffle=q;function M(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.unshift(oe))}e.pushToStart=M;function B(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.push(oe))}e.pushToEnd=B;function O(se,oe){for(const fe of oe)se.push(fe)}e.pushMany=O;function U(se,oe){return Array.isArray(se)?se.map(oe):oe(se)}e.mapArrayOrNot=U;function z(se){return Array.isArray(se)?se:[se]}e.asArray=z;function j(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=j;function ue(se,oe){for(const fe of se){const Z=oe(fe);if(Z!==void 0)return Z}}e.mapFind=ue;function V(se,oe,fe){const Z=J(se,oe),ce=se.length,ne=fe.length;se.length=ce+ne;for(let N=ce-1;N>=Z;N--)se[N+ne]=se[N];for(let N=0;N<ne;N++)se[N+Z]=fe[N]}e.insertInto=V;function _(se,oe,fe,Z){const ce=J(se,oe),ne=se.splice(ce,fe);return V(se,ce,Z),ne}e.splice=_;function J(se,oe){return oe<0?Math.max(oe+se.length,0):Math.min(oe,se.length)}var ie;(function(se){function oe(ce){return ce<0}se.isLessThan=oe;function fe(ce){return ce>0}se.isGreaterThan=fe;function Z(ce){return ce===0}se.isNeitherLessOrGreaterThan=Z,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function ee(se,oe){return(fe,Z)=>oe(se(fe),se(Z))}e.compareBy=ee;function X(...se){return(oe,fe)=>{for(const Z of se){const ce=Z(oe,fe);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const G=(se,oe)=>se-oe;e.numberComparator=G;function de(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>0&&(fe=ce)}return fe}e.findMaxBy=de;function be(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>=0&&(fe=ce)}return fe}e.findLastMaxBy=be;function Ee(se,oe){return de(se,(fe,Z)=>-oe(fe,Z))}e.findMinBy=Ee;class Pe{constructor(oe){this.f=oe,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(oe){let fe=this.c;for(;fe<this.f.length&&oe(this.f[fe]);)fe++;const Z=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,Z}takeFromEndWhile(oe){let fe=this.d;for(;fe>=0&&oe(this.f[fe]);)fe--;const Z=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const oe=this.f[this.c];return this.c++,oe}removeLast(){const oe=this.f[this.d];return this.d--,oe}takeCount(oe){const fe=this.f.slice(this.c,this.c+oe);return this.c+=oe,fe}}e.ArrayQueue=Pe;class Fe{constructor(oe){this.iterate=oe}forEach(oe){this.iterate(fe=>(oe(fe),!0))}toArray(){const oe=[];return this.iterate(fe=>(oe.push(fe),!0)),oe}filter(oe){return new Fe(fe=>this.iterate(Z=>oe(Z)?fe(Z):!0))}map(oe){return new Fe(fe=>this.iterate(Z=>fe(oe(Z))))}some(oe){let fe=!1;return this.iterate(Z=>(fe=oe(Z),!fe)),fe}findFirst(oe){let fe;return this.iterate(Z=>oe(Z)?(fe=Z,!1):!0),fe}findLast(oe){let fe;return this.iterate(Z=>(oe(Z)&&(fe=Z),!0)),fe}findLastMaxBy(oe){let fe,Z=!0;return this.iterate(ce=>((Z||ie.isGreaterThan(oe(ce,fe)))&&(Z=!1,fe=ce),!0)),fe}}e.CallbackIterable=Fe,Fe.empty=new Fe(se=>{})}),define(ye[51],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(y,C){if(!y)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function P(y,C="Unreachable"){throw new Error(C)}e.assertNever=P;function R(y){if(!y)throw new c.BugIndicatingError("Assertion Failed")}e.assert=R;function k(y){if(!y()){debugger;y(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function A(y,C){let L=0;for(;L<y.length-1;){const T=y[L],v=y[L+1];if(!C(T,v))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const P=this;let R=!1,k;return function(){return R||(R=!0,k=t.apply(P,arguments)),k}}e.once=c}),define(ye[101],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[64],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function P(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}t.is=P;const R=Object.freeze([]);function k(){return R}t.empty=k;function*A(E){yield E}t.single=A;function y(E){return P(E)?E:A(E)}t.wrap=y;function C(E){return E||R}t.from=C;function L(E){return!E||E[Symbol.iterator]().next().done===!0}t.isEmpty=L;function T(E){return E[Symbol.iterator]().next().value}t.first=T;function v(E,g){for(const i of E)if(g(i))return!0;return!1}t.some=v;function D(E,g){for(const i of E)if(g(i))return i}t.find=D;function*w(E,g){for(const i of E)g(i)&&(yield i)}t.filter=w;function*f(E,g){let i=0;for(const l of E)yield g(l,i++)}t.map=f;function*d(...E){for(const g of E)for(const i of g)yield i}t.concat=d;function m(E,g,i){let l=i;for(const o of E)l=g(l,o);return l}t.reduce=m;function*p(E,g,i=E.length){for(g<0&&(g+=E.length),i<0?i+=E.length:i>E.length&&(i=E.length);g<i;g++)yield E[g]}t.slice=p;function b(E,g=Number.POSITIVE_INFINITY){const i=[];if(g===0)return[i,E];const l=E[Symbol.iterator]();for(let o=0;o<g;o++){const a=l.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return l}}]}t.consume=b})(c=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function k(i,l=!1){let o=0;const a=i.length;let s="",u=0,r=16,n=0;function h(B){let O=0,U=0;for(;O<B;){const z=i.charCodeAt(o);if(z>=48&&z<=57)U=U*16+z-48;else if(z>=65&&z<=70)U=U*16+z-65+10;else if(z>=97&&z<=102)U=U*16+z-97+10;else break;o++,O++}return O<B&&(U=-1),U}function S(B){o=B,s="",u=0,r=16,n=0}function I(){const B=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&C(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&C(i.charCodeAt(o)))for(o++;o<i.length&&C(i.charCodeAt(o));)o++;else return n=3,i.substring(B,o);let O=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&C(i.charCodeAt(o))){for(o++;o<i.length&&C(i.charCodeAt(o));)o++;O=o}else n=3;return i.substring(B,O)}function F(){let B="",O=o;for(;;){if(o>=a){B+=i.substring(O,o),n=2;break}const U=i.charCodeAt(o);if(U===34){B+=i.substring(O,o),o++;break}if(U===92){if(B+=i.substring(O,o),o++,o>=a){n=2;break}switch(i.charCodeAt(o++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=h(4);j>=0?B+=String.fromCharCode(j):n=4;break}default:n=5}O=o;continue}if(U>=0&&U<=31)if(y(U)){B+=i.substring(O,o),n=2;break}else n=6;o++}return B}function K(){if(s="",n=0,u=o,o>=a)return u=a,r=17;let B=i.charCodeAt(o);if(A(B)){do o++,s+=String.fromCharCode(B),B=i.charCodeAt(o);while(A(B));return r=15}if(y(B))return o++,s+=String.fromCharCode(B),B===13&&i.charCodeAt(o)===10&&(o++,s+=`
`),r=14;switch(B){case 123:return o++,r=1;case 125:return o++,r=2;case 91:return o++,r=3;case 93:return o++,r=4;case 58:return o++,r=6;case 44:return o++,r=5;case 34:return o++,s=F(),r=10;case 47:{const O=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<a&&!y(i.charCodeAt(o));)o++;return s=i.substring(O,o),r=12}if(i.charCodeAt(o+1)===42){o+=2;const U=a-1;let z=!1;for(;o<U;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,n=1),s=i.substring(O,o),r=13}return s+=String.fromCharCode(B),o++,r=16}case 45:if(s+=String.fromCharCode(B),o++,o===a||!C(i.charCodeAt(o)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=I(),r=11;default:for(;o<a&&q(B);)o++,B=i.charCodeAt(o);if(u!==o){switch(s=i.substring(u,o),s){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return s+=String.fromCharCode(B),o++,r=16}}function q(B){if(A(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let B;do B=K();while(B>=12&&B<=15);return B}return{setPosition:S,getPosition:()=>o,scan:l?M:K,getToken:()=>r,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>n}}e.createScanner=k;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function C(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function T(i,l){const o=[],a=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function n(h,S,I,F){u.value=h,u.offset=S,u.length=I,u.type=F,u.colonOffset=void 0,s=u}try{b(i,{onObjectBegin:(h,S)=>{if(l<=h)throw a;s=void 0,r=l>h,o.push("")},onObjectProperty:(h,S,I)=>{if(l<S||(n(h,S,I,"property"),o[o.length-1]=h,l<=S+I))throw a},onObjectEnd:(h,S)=>{if(l<=h)throw a;s=void 0,o.pop()},onArrayBegin:(h,S)=>{if(l<=h)throw a;s=void 0,o.push(0)},onArrayEnd:(h,S)=>{if(l<=h)throw a;s=void 0,o.pop()},onLiteralValue:(h,S,I)=>{if(l<S||(n(h,S,I,g(h)),l<=S+I))throw a},onSeparator:(h,S,I)=>{if(l<=S)throw a;if(h===":"&&s&&s.type==="property")s.colonOffset=S,r=!1,s=void 0;else if(h===","){const F=o[o.length-1];typeof F=="number"?o[o.length-1]=F+1:(r=!0,o[o.length-1]=""),s=void 0}}})}catch(h){if(h!==a)throw h}return{path:o,previousNode:s,isAtPropertyKey:r,matches:h=>{let S=0;for(let I=0;S<h.length&&I<o.length;I++)if(h[S]===o[I]||h[S]==="*")S++;else if(h[S]!=="**")return!1;return S===h.length}}}e.getLocation=T;function v(i,l=[],o=R.DEFAULT){let a=null,s=[];const u=[];function r(h){Array.isArray(s)?s.push(h):a!==null&&(s[a]=h)}return b(i,{onObjectBegin:()=>{const h={};r(h),u.push(s),s=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const h=[];r(h),u.push(s),s=h,a=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:r,onError:(h,S,I)=>{l.push({error:h,offset:S,length:I})}},o),s[0]}e.parse=v;function D(i,l=[],o=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function u(h){return a.children.push(h),h}b(i,{onObjectBegin:h=>{a=u({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,S,I)=>{a=u({type:"property",offset:S,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:S,length:I,parent:a})},onObjectEnd:(h,S)=>{a.length=h+S-a.offset,a=a.parent,s(h+S)},onArrayBegin:(h,S)=>{a=u({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,S)=>{a.length=h+S-a.offset,a=a.parent,s(h+S)},onLiteralValue:(h,S,I)=>{u({type:g(h),offset:S,length:I,parent:a,value:h}),s(S+I)},onSeparator:(h,S,I)=>{a.type==="property"&&(h===":"?a.colonOffset=S:h===","&&s(S))},onError:(h,S,I)=>{l.push({error:h,offset:S,length:I})}},o);const n=a.children[0];return n&&delete n.parent,n}e.parseTree=D;function w(i,l){if(!i)return;let o=i;for(const a of l)if(typeof a=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===a){o=u.children[1],s=!0;break}if(!s)return}else{const s=a;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}e.findNodeAtLocation=w;function f(i){if(!i.parent||!i.parent.children)return[];const l=f(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;l.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&l.push(o)}return l}e.getNodePath=f;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const l=Object.create(null);for(const o of i.children){const a=o.children[1];a&&(l[o.children[0].value]=d(a))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function m(i,l,o=!1){return l>=i.offset&&l<i.offset+i.length||o&&l===i.offset+i.length}e.contains=m;function p(i,l,o=!1){if(m(i,l,o)){const a=i.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=l;s++){const u=p(a[s],l,o);if(u)return u}return i}}e.findNodeAtOffset=p;function b(i,l,o=R.DEFAULT){const a=k(i,!1);function s(ee){return ee?()=>ee(a.getTokenOffset(),a.getTokenLength()):()=>!0}function u(ee){return ee?X=>ee(X,a.getTokenOffset(),a.getTokenLength()):()=>!0}const r=s(l.onObjectBegin),n=u(l.onObjectProperty),h=s(l.onObjectEnd),S=s(l.onArrayBegin),I=s(l.onArrayEnd),F=u(l.onLiteralValue),K=u(l.onSeparator),q=s(l.onComment),M=u(l.onError),B=o&&o.disallowComments,O=o&&o.allowTrailingComma;function U(){for(;;){const ee=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:B||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ee){case 12:case 13:B?z(10):q();break;case 16:z(1);break;case 15:case 14:break;default:return ee}}}function z(ee,X=[],G=[]){if(M(ee),X.length+G.length>0){let de=a.getToken();for(;de!==17;){if(X.indexOf(de)!==-1){U();break}else if(G.indexOf(de)!==-1)break;de=U()}}}function j(ee){const X=a.getTokenValue();return ee?F(X):n(X),U(),!0}function ue(){switch(a.getToken()){case 11:{let ee=0;try{ee=JSON.parse(a.getTokenValue()),typeof ee!="number"&&(z(2),ee=0)}catch{z(2)}F(ee);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function V(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),a.getToken()===6?(K(":"),U(),ie()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function _(){r(),U();let ee=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ee||z(4,[],[]),K(","),U(),a.getToken()===2&&O)break}else ee&&z(6,[],[]);V()||z(4,[],[2,5]),ee=!0}return h(),a.getToken()!==2?z(7,[2],[]):U(),!0}function J(){S(),U();let ee=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ee||z(4,[],[]),K(","),U(),a.getToken()===4&&O)break}else ee&&z(6,[],[]);ie()||z(4,[],[4,5]),ee=!0}return I(),a.getToken()!==4?z(8,[4],[]):U(),!0}function ie(){switch(a.getToken()){case 3:return J();case 1:return _();case 10:return j(!0);default:return ue()}}return U(),a.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):ie()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function E(i,l){const o=k(i),a=[];let s,u=0,r;do switch(r=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:u!==r&&a.push(i.substring(u,r)),l!==void 0&&a.push(o.getTokenValue().replace(/[^\r\n]/g,l)),u=o.getPosition();break}while(s!==17);return a.join("")}e.stripComments=E;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ye[65],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=c}),define(ye[6],Ce([1,0,63,64]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let R=null;function k(u){R=u}if(e.setDisposableTracker=k,P){const u="__is_disposable_tracked__";k(new class{trackDisposable(r){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[u]||console.log(n)},3e3)}setParent(r,n){if(r&&r!==p.None)try{r[u]=!0}catch{}}markAsDisposed(r){if(r&&r!==p.None)try{r[u]=!0}catch{}}markAsSingleton(r){}})}function A(u){return R?.trackDisposable(u),u}function y(u){R?.markAsDisposed(u)}function C(u,r){R?.setParent(u,r)}function L(u,r){if(!!R)for(const n of u)R.setParent(n,r)}function T(u){return R?.markAsSingleton(u),u}e.markAsSingleton=T;function v(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=v;function D(u){if(t.Iterable.is(u)){const r=[];for(const n of u)if(n)try{n.dispose()}catch(h){r.push(h)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=D;function w(u){for(const r of u)v(r)&&r.dispose();return[]}e.disposeIfDisposable=w;function f(...u){const r=d(()=>D(u));return L(u,r),r}e.combinedDisposable=f;function d(u){const r=A({dispose:(0,c.once)(()=>{y(r),u()})});return r}e.toDisposable=d;class m{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{D(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return C(r,this),this.f?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new m,A(this),C(this.q,this)}dispose(){y(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class b{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&C(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&C(r,null),r}}e.MutableDisposable=b;class E{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(r){let n=r;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,y(this))},this}}e.SafeDisposable=g;class i{constructor(){this.a=new Map}acquire(r,...n){let h=this.a.get(r);h||(h={counter:0,object:this.b(r,...n)},this.a.set(r,h));const{object:S}=h,I=(0,c.once)(()=>{--h.counter===0&&(this.c(r,h.object),this.a.delete(r))});return h.counter++,{object:S,dispose:I}}}e.ReferenceCollection=i;class l{constructor(r){this.a=r}async acquire(r,...n){const h=this.a.acquire(r,...n);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(S){throw h.dispose(),S}}}e.AsyncReferenceCollection=l;class o{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=o;function a(u){const r=new m;try{u(r)}finally{r.dispose()}}e.disposeOnReturn=a;class s{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,n,h=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this.a.get(r)?.dispose(),this.a.set(r,n)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(ye[66],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(R){this.element=R,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let R=this.a;for(;R!==c.Undefined;){const k=R.next;R.prev=c.Undefined,R.next=c.Undefined,R=k}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,k){const A=new c(R);if(this.a===c.Undefined)this.a=A,this.b=A;else if(k){const C=this.b;this.b=A,A.prev=C,C.next=A}else{const C=this.a;this.a=A,A.next=C,C.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==c.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==c.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==c.Undefined&&R.next!==c.Undefined){const k=R.prev;k.next=R.next,R.next.prev=k}else R.prev===c.Undefined&&R.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):R.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):R.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==c.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(te,e){"use strict";var c,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(w,f,d){let m=w.get(f);return m===void 0&&(m=d,w.set(f,m)),m}e.getOrSet=R;function k(w){const f=[];return w.forEach((d,m)=>{f.push(`${m} => ${d}`)}),`Map(${w.size}) {${f.join(", ")}}`}e.mapToString=k;function A(w){const f=[];return w.forEach(d=>{f.push(d)}),`Set(${w.size}) {${f.join(", ")}}`}e.setToString=A;class y{constructor(f,d){this.uri=f,this.value=d}}class C{constructor(f,d){this[c]="ResourceMap",f instanceof C?(this.b=new Map(f.b),this.c=d??C.a):(this.b=new Map,this.c=f??C.a)}set(f,d){return this.b.set(this.c(f),new y(f,d)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,d){typeof d<"u"&&(f=f.bind(d));for(const[m,p]of this.b)f(p.value,p.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}e.ResourceMap=C,C.a=w=>w.toString();class L{constructor(f,d){this[t]="ResourceSet",!f||typeof f=="function"?this.a=new C(f):(this.a=new C(d),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,d){this.a.forEach((m,p)=>f.call(d,p,p,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var T;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class v{constructor(){this[P]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,d=0){const m=this.a.get(f);if(!!m)return d!==0&&this.j(m,d),m.value}set(f,d,m=0){let p=this.a.get(f);if(p)p.value=d,m!==0&&this.j(p,m);else{switch(p={key:f,value:d,next:void 0,previous:void 0},m){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(f,p),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const d=this.a.get(f);if(!!d)return this.a.delete(f),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,d){const m=this.e;let p=this.b;for(;p;){if(d?f.bind(d)(p.value,p.key,this):f(p.value,p.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const f=this,d=this.e;let m=this.b;const p={[Symbol.iterator](){return p},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.key,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return p}values(){const f=this,d=this.e;let m=this.b;const p={[Symbol.iterator](){return p},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.value,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return p}entries(){const f=this,d=this.e;let m=this.b;const p={[Symbol.iterator](){return p},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:[m.key,m.value],done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return p}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let d=this.b,m=this.size;for(;d&&m>f;)this.a.delete(d.key),d=d.next,m--;this.b=d,this.d=m,d&&(d.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const d=f.next,m=f.previous;if(!d||!m)throw new Error("Invalid list");d.previous=m,m.next=d}f.next=void 0,f.previous=void 0,this.e++}j(f,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(f===this.b)return;const m=f.next,p=f.previous;f===this.c?(p.next=void 0,this.c=p):(m.previous=p,p.next=m),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(d===2){if(f===this.c)return;const m=f.next,p=f.previous;f===this.b?(m.previous=void 0,this.b=m):(m.previous=p,p.next=m),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((d,m)=>{f.push([m,d])}),f}fromJSON(f){this.clear();for(const[d,m]of f)this.set(d,m)}}e.LinkedMap=v;class D extends v{constructor(f,d=1){super(),this.k=f,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,d=2){return super.get(f,d)}peek(f){return super.get(f,0)}set(f,d){return super.set(f,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=D}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(se,oe){for(var fe=0;fe<oe.length;fe++){var Z=oe[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(se,Z.key,Z)}}function c(se,oe,fe){return oe&&e(se.prototype,oe),fe&&e(se,fe),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,oe){if(!!se){if(typeof se=="string")return P(se,oe);var fe=Object.prototype.toString.call(se).slice(8,-1);if(fe==="Object"&&se.constructor&&(fe=se.constructor.name),fe==="Map"||fe==="Set")return Array.from(se);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return P(se,oe)}}function P(se,oe){(oe==null||oe>se.length)&&(oe=se.length);for(var fe=0,Z=new Array(oe);fe<oe;fe++)Z[fe]=se[fe];return Z}function R(se,oe){var fe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(fe)return(fe=fe.call(se)).next.bind(fe);if(Array.isArray(se)||(fe=t(se))||oe&&se&&typeof se.length=="number"){fe&&(se=fe);var Z=0;return function(){return Z>=se.length?{done:!0}:{done:!1,value:se[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=k();function A(se){te.defaults=se}var y=/[&<>"']/,C=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(oe){return v[oe]};function w(se,oe){if(oe){if(y.test(se))return se.replace(C,D)}else if(L.test(se))return se.replace(T,D);return se}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(se){return se.replace(f,function(oe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(se,oe){se=typeof se=="string"?se:se.source,oe=oe||"";var fe={replace:function(ce,ne){return ne=ne.source||ne,ne=ne.replace(m,"$1"),se=se.replace(ce,ne),fe},getRegex:function(){return new RegExp(se,oe)}};return fe}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(se,oe,fe){if(se){var Z;try{Z=decodeURIComponent(d(fe)).replace(b,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!E.test(fe)&&(fe=s(oe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},l=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(se,oe){i[" "+se]||(l.test(se)?i[" "+se]=se+"/":i[" "+se]=h(se,"/",!0)),se=i[" "+se];var fe=se.indexOf(":")===-1;return oe.substring(0,2)==="//"?fe?oe:se.replace(o,"$1")+oe:oe.charAt(0)==="/"?fe?oe:se.replace(a,"$1")+oe:se+oe}var u={exec:function(){}};function r(se){for(var oe=1,fe,Z;oe<arguments.length;oe++){fe=arguments[oe];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(se[Z]=fe[Z])}return se}function n(se,oe){var fe=se.replace(/\|/g,function(ne,N,H){for(var Q=!1,Y=N;--Y>=0&&H[Y]==="\\";)Q=!Q;return Q?"|":" |"}),Z=fe.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function h(se,oe,fe){var Z=se.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ne=se.charAt(Z-ce-1);if(ne===oe&&!fe)ce++;else if(ne!==oe&&fe)ce++;else break}return se.slice(0,Z-ce)}function S(se,oe){if(se.indexOf(oe[1])===-1)return-1;for(var fe=se.length,Z=0,ce=0;ce<fe;ce++)if(se[ce]==="\\")ce++;else if(se[ce]===oe[0])Z++;else if(se[ce]===oe[1]&&(Z--,Z<0))return ce;return-1}function I(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(se,oe){if(oe<1)return"";for(var fe="";oe>1;)oe&1&&(fe+=se),oe>>=1,se+=se;return fe+se}function K(se,oe,fe,Z){var ce=oe.href,ne=oe.title?w(oe.title):null,N=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){Z.state.inLink=!0;var H={type:"link",raw:fe,href:ce,title:ne,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,H}return{type:"image",raw:fe,href:ce,title:ne,text:w(N)}}function q(se,oe){var fe=se.match(/^(\s+)(?:```)/);if(fe===null)return oe;var Z=fe[1];return oe.split(`
`).map(function(ce){var ne=ce.match(/^\s+/);if(ne===null)return ce;var N=ne[0];return N.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var M=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},oe.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ne=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:h(ne,`
`)}}},oe.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ne=ce[0],N=q(ne,ce[3]||"");return{type:"code",raw:ne,lang:ce[2]?ce[2].trim():ce[2],text:N}}},oe.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ne=ce[2].trim();if(/#$/.test(ne)){var N=h(ne,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ne=N.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ne,tokens:this.lexer.inline(ne)}}},oe.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},oe.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ne=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},oe.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ne,N,H,Q,Y,he,we,Ae,pe,De,ke,Ve,Ge=ce[1].trim(),et=Ge.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(Ve=!1,!(!(ce=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ce[0],Z=Z.substring(ne.length),Ae=ce[2].split(`
`,1)[0],pe=Z.split(`
`,1)[0],this.options.pedantic?(Q=2,ke=Ae.trimLeft()):(Q=ce[2].search(/[^ ]/),Q=Q>4?1:Q,ke=Ae.slice(Q),Q+=ce[1].length),he=!1,!Ae&&/^ *$/.test(pe)&&(ne+=pe+`
`,Z=Z.substring(pe.length+1),Ve=!0),!Ve)for(var st=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");Z&&(De=Z.split(`
`,1)[0],Ae=De,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Ae)||rt.test(Ae)||st.test(Ae)||ht.test(Z)));){if(Ae.search(/[^ ]/)>=Q||!Ae.trim())ke+=`
`+Ae.slice(Q);else if(!he)ke+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),ne+=De+`
`,Z=Z.substring(De.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(ne)&&(we=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&(H=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ne,task:!!N,checked:H,loose:!1,text:ke}),Qe.raw+=ne}Qe.items[Qe.items.length-1].raw=ne.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var ae=Qe.items.length;for(Y=0;Y<ae;Y++){this.lexer.state.top=!1,Qe.items[Y].tokens=this.lexer.blockTokens(Qe.items[Y].text,[]);var $=Qe.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),le=$.every(function(Ie){for(var Le=Ie.raw.split(""),$e=0,Xe=R(Le),Ze;!(Ze=Xe()).done;){var pt=Ze.value;if(pt===`
`&&($e+=1),$e>1)return!0}return!1});!Qe.loose&&$.length&&le&&(Qe.loose=!0,Qe.items[Y].loose=!0)}return Qe}},oe.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ne={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ce[0]):w(ce[0]);ne.type="paragraph",ne.text=N,ne.tokens=this.lexer.inline(N)}return ne}},oe.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ne=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ce[0],href:ce[2],title:ce[3]}}},oe.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ne={type:"table",header:n(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ce[0];var N=ne.align.length,H,Q,Y,he;for(H=0;H<N;H++)/^ *-+: *$/.test(ne.align[H])?ne.align[H]="right":/^ *:-+: *$/.test(ne.align[H])?ne.align[H]="center":/^ *:-+ *$/.test(ne.align[H])?ne.align[H]="left":ne.align[H]=null;for(N=ne.rows.length,H=0;H<N;H++)ne.rows[H]=n(ne.rows[H],ne.header.length).map(function(we){return{text:we}});for(N=ne.header.length,Q=0;Q<N;Q++)ne.header[Q].tokens=this.lexer.inline(ne.header[Q].text);for(N=ne.rows.length,Q=0;Q<N;Q++)for(he=ne.rows[Q],Y=0;Y<he.length;Y++)he[Y].tokens=this.lexer.inline(he[Y].text);return ne}}},oe.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},oe.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ne=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ne,tokens:this.lexer.inline(ne)}}},oe.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},oe.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:w(ce[1])}},oe.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):w(ce[0]):ce[0]}},oe.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ne=ce[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var N=h(ne.slice(0,-1),"\\");if((ne.length-N.length)%2===0)return}else{var H=S(ce[2],"()");if(H>-1){var Q=ce[0].indexOf("!")===0?5:4,Y=Q+ce[1].length+H;ce[2]=ce[2].substring(0,H),ce[0]=ce[0].substring(0,Y).trim(),ce[3]=""}}var he=ce[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=ce[3]?ce[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ne)?he=he.slice(1):he=he.slice(1,-1)),K(ce,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},oe.reflink=function(Z,ce){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var N=(ne[2]||ne[1]).replace(/\s+/g," ");if(N=ce[N.toLowerCase()],!N||!N.href){var H=ne[0].charAt(0);return{type:"text",raw:H,text:H}}return K(ne,N,ne[0],this.lexer)}},oe.emStrong=function(Z,ce,ne){ne===void 0&&(ne="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=N[1]||N[2]||"";if(!H||H&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Q=N[0].length-1,Y,he,we=Q,Ae=0,pe=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Q);(N=pe.exec(ce))!=null;)if(Y=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Y){if(he=Y.length,N[3]||N[4]){we+=he;continue}else if((N[5]||N[6])&&Q%3&&!((Q+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(Q,he)%2){var De=Z.slice(1,Q+N.index+he);return{type:"em",raw:Z.slice(0,Q+N.index+he+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=Z.slice(2,Q+N.index+he-1);return{type:"strong",raw:Z.slice(0,Q+N.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},oe.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ne=ce[2].replace(/\n/g," "),N=/[^ ]/.test(ne),H=/^ /.test(ne)&&/ $/.test(ne);return N&&H&&(ne=ne.substring(1,ne.length-1)),ne=w(ne,!0),{type:"codespan",raw:ce[0],text:ne}}},oe.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},oe.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},oe.autolink=function(Z,ce){var ne=this.rules.inline.autolink.exec(Z);if(ne){var N,H;return ne[2]==="@"?(N=w(this.options.mangle?ce(ne[1]):ne[1]),H="mailto:"+N):(N=w(ne[1]),H=N),{type:"link",raw:ne[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.url=function(Z,ce){var ne;if(ne=this.rules.inline.url.exec(Z)){var N,H;if(ne[2]==="@")N=w(this.options.mangle?ce(ne[0]):ne[0]),H="mailto:"+N;else{var Q;do Q=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Q!==ne[0]);N=w(ne[0]),ne[1]==="www."?H="http://"+N:H=N}return{type:"link",raw:ne[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.inlineText=function(Z,ce){var ne=this.rules.inline.text.exec(Z);if(ne){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]):ne[0]:N=w(this.options.smartypants?ce(ne[0]):ne[0]),{type:"text",raw:ne[0],text:N}}},se}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=p(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=p(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=p(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=p(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=p(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=r({},B),B.gfm=r({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=p(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=r({},B.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:p(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=p(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=p(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=p(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=p(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=p(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=p(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=p(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=p(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=p(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=p(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=p(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=r({},O),O.pedantic=r({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=r({},O.normal,{escape:p(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=p(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=r({},O.gfm,{br:p(O.br).replace("{2,}","*").getRegex(),text:p(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(se){var oe="",fe,Z,ce=se.length;for(fe=0;fe<ce;fe++)Z=se.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var j=function(){function se(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||te.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:O.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=O.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=O.breaks:Z.inline=O.gfm),this.tokenizer.rules=Z}se.lex=function(Z,ce){var ne=new se(ce);return ne.lex(Z)},se.lexInline=function(Z,ce){var ne=new se(ce);return ne.inlineTokens(Z)};var oe=se.prototype;return oe.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},oe.blockTokens=function(Z,ce){var ne=this;ce===void 0&&(ce=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(we,Ae,pe){return Ae+"    ".repeat(pe.length)});for(var N,H,Q,Y;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(N=we.call({lexer:ne},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=Z.slice(1),pe=void 0;ne.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Ae),typeof pe=="number"&&pe>=0&&(we=Math.min(we,pe))}),we<1/0&&we>=0&&(Q=Z.substring(0,we+1))}(),this.state.top&&(N=this.tokenizer.paragraph(Q))){H=ce[ce.length-1],Y&&H.type==="paragraph"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N),Y=Q.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(Z){var he="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ce},oe.inline=function(Z,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:Z,tokens:ce}),ce},oe.inlineTokens=function(Z,ce){var ne=this;ce===void 0&&(ce=[]);var N,H,Q,Y=Z,he,we,Ae;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,he.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ne},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.emStrong(Z,Y,Ae)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.autolink(Z,z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,z))){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Ve=Z.slice(1),Ge=void 0;ne.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},Ve),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(Q=Z.substring(0,ke+1))}(),N=this.tokenizer.inlineText(Q,U)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),we=!0,H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(Z){var De="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ce},c(se,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),se}(),ue=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.code=function(Z,ce,ne){var N=(ce||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(Z,N);H!=null&&H!==Z&&(ne=!0,Z=H)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+w(N,!0)+'">'+(ne?Z:w(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:w(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ce,ne,N){if(this.options.headerIds){var H=this.options.headerPrefix+N.slug(ne);return"<h"+ce+' id="'+H+'">'+Z+"</h"+ce+`>
`}return"<h"+ce+">"+Z+"</h"+ce+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ce,ne){var N=ce?"ol":"ul",H=ce&&ne!==1?' start="'+ne+'"':"";return"<"+N+H+`>
`+Z+"</"+N+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ce){var ne=ce.header?"th":"td",N=ce.align?"<"+ne+' align="'+ce.align+'">':"<"+ne+">";return N+Z+("</"+ne+`>
`)},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ce,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<a href="'+w(Z)+'"';return ce&&(N+=' title="'+ce+'"'),N+=">"+ne+"</a>",N},oe.image=function(Z,ce,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<img src="'+Z+'" alt="'+ne+'"';return ce&&(N+=' title="'+ce+'"'),N+=this.options.xhtml?"/>":">",N},oe.text=function(Z){return Z},se}(),V=function(){function se(){}var oe=se.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ce,ne){return""+ne},oe.image=function(Z,ce,ne){return""+ne},oe.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var oe=se.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ce){var ne=Z,N=0;if(this.seen.hasOwnProperty(ne)){N=this.seen[Z];do N++,ne=Z+"-"+N;while(this.seen.hasOwnProperty(ne))}return ce||(this.seen[Z]=N,this.seen[ne]=0),ne},oe.slug=function(Z,ce){ce===void 0&&(ce={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ce.dryrun)},se}(),J=function(){function se(fe){this.options=fe||te.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new _}se.parse=function(Z,ce){var ne=new se(ce);return ne.parse(Z)},se.parseInline=function(Z,ce){var ne=new se(ce);return ne.parseInline(Z)};var oe=se.prototype;return oe.parse=function(Z,ce){ce===void 0&&(ce=!0);var ne="",N,H,Q,Y,he,we,Ae,pe,De,ke,Ve,Ge,et,Qe,nt,st,ht,Me,rt,ae=Z.length;for(N=0;N<ae;N++){if(ke=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(rt=this.options.extensions.renderers[ke.type].call({parser:this},ke),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ne+=rt||"";continue}switch(ke.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Ae="",Y=ke.header.length,H=0;H<Y;H++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Ae),De="",Y=ke.rows.length,H=0;H<Y;H++){for(we=ke.rows[H],Ae="",he=we.length,Q=0;Q<he;Q++)Ae+=this.renderer.tablecell(this.parseInline(we[Q].tokens),{header:!1,align:ke.align[Q]});De+=this.renderer.tablerow(Ae)}ne+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),ne+=this.renderer.blockquote(De);continue}case"list":{for(Ve=ke.ordered,Ge=ke.start,et=ke.loose,Y=ke.items.length,De="",H=0;H<Y;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(nt.tokens,et),De+=this.renderer.listitem(Qe,ht,st);ne+=this.renderer.list(De,Ve,Ge);continue}case"html":{ne+=this.renderer.html(ke.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<ae&&Z[N+1].type==="text";)ke=Z[++N],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ne+=ce?this.renderer.paragraph(De):De;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ne},oe.parseInline=function(Z,ce){ce=ce||this.renderer;var ne="",N,H,Q,Y=Z.length;for(N=0;N<Y;N++){if(H=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(Q=this.options.extensions.renderers[H.type].call({parser:this},H),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ne+=Q||"";continue}switch(H.type){case"escape":{ne+=ce.text(H.text);break}case"html":{ne+=ce.html(H.text);break}case"link":{ne+=ce.link(H.href,H.title,this.parseInline(H.tokens,ce));break}case"image":{ne+=ce.image(H.href,H.title,H.text);break}case"strong":{ne+=ce.strong(this.parseInline(H.tokens,ce));break}case"em":{ne+=ce.em(this.parseInline(H.tokens,ce));break}case"codespan":{ne+=ce.codespan(H.text);break}case"br":{ne+=ce.br();break}case"del":{ne+=ce.del(this.parseInline(H.tokens,ce));break}case"text":{ne+=ce.text(H.text);break}default:{var he='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ne},se}();function ie(se,oe,fe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof oe=="function"&&(fe=oe,oe=null),oe=r({},ie.defaults,oe||{}),I(oe),fe){var Z=oe.highlight,ce;try{ce=j.lex(se,oe)}catch(Y){return fe(Y)}var ne=function(he){var we;if(!he)try{oe.walkTokens&&ie.walkTokens(ce,oe.walkTokens),we=J.parse(ce,oe)}catch(Ae){he=Ae}return oe.highlight=Z,he?fe(he):fe(null,we)};if(!Z||Z.length<3||(delete oe.highlight,!ce.length))return ne();var N=0;ie.walkTokens(ce,function(Y){Y.type==="code"&&(N++,setTimeout(function(){Z(Y.text,Y.lang,function(he,we){if(he)return ne(he);we!=null&&we!==Y.text&&(Y.text=we,Y.escaped=!0),N--,N===0&&ne()})},0))}),N===0&&ne();return}function H(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+w(Y.message+"",!0)+"</pre>";throw Y}try{var Q=j.lex(se,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ie.walkTokens(Q,oe.walkTokens)).then(function(){return J.parse(Q,oe)}).catch(H);ie.walkTokens(Q,oe.walkTokens)}return J.parse(Q,oe)}catch(Y){H(Y)}}ie.options=ie.setOptions=function(se){return r(ie.defaults,se),A(ie.defaults),ie},ie.getDefaults=k,ie.defaults=te.defaults,ie.use=function(){for(var se=arguments.length,oe=new Array(se),fe=0;fe<se;fe++)oe[fe]=arguments[fe];var Z=r.apply(void 0,[{}].concat(oe)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},ne;oe.forEach(function(N){if(N.extensions&&(ne=!0,N.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var Y=ce.renderers?ce.renderers[Q.name]:null;Y?ce.renderers[Q.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var pe=Q.renderer.apply(this,we);return pe===!1&&(pe=Y.apply(this,we)),pe}:ce.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[Q.level]?ce[Q.level].unshift(Q.tokenizer):ce[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?ce.startBlock?ce.startBlock.push(Q.start):ce.startBlock=[Q.start]:Q.level==="inline"&&(ce.startInline?ce.startInline.push(Q.start):ce.startInline=[Q.start]))}Q.childTokens&&(ce.childTokens[Q.name]=Q.childTokens)})),N.renderer&&function(){var Q=ie.defaults.renderer||new ue,Y=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var De=arguments.length,ke=new Array(De),Ve=0;Ve<De;Ve++)ke[Ve]=arguments[Ve];var Ge=N.renderer[Ae].apply(Q,ke);return Ge===!1&&(Ge=pe.apply(Q,ke)),Ge}};for(var he in N.renderer)Y(he);Z.renderer=Q}(),N.tokenizer&&function(){var Q=ie.defaults.tokenizer||new M,Y=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var De=arguments.length,ke=new Array(De),Ve=0;Ve<De;Ve++)ke[Ve]=arguments[Ve];var Ge=N.tokenizer[Ae].apply(Q,ke);return Ge===!1&&(Ge=pe.apply(Q,ke)),Ge}};for(var he in N.tokenizer)Y(he);Z.tokenizer=Q}(),N.walkTokens){var H=ie.defaults.walkTokens;Z.walkTokens=function(Q){var Y=[];return Y.push(N.walkTokens.call(this,Q)),H&&(Y=Y.concat(H.call(this,Q))),Y}}ne&&(Z.extensions=ce),ie.setOptions(Z)})},ie.walkTokens=function(se,oe){for(var fe=[],Z=function(){var H=ne.value;switch(fe=fe.concat(oe.call(ie,H)),H.type){case"table":{for(var Q=R(H.header),Y;!(Y=Q()).done;){var he=Y.value;fe=fe.concat(ie.walkTokens(he.tokens,oe))}for(var we=R(H.rows),Ae;!(Ae=we()).done;)for(var pe=Ae.value,De=R(pe),ke;!(ke=De()).done;){var Ve=ke.value;fe=fe.concat(ie.walkTokens(Ve.tokens,oe))}break}case"list":{fe=fe.concat(ie.walkTokens(H.items,oe));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[H.type]?ie.defaults.extensions.childTokens[H.type].forEach(function(Ge){fe=fe.concat(ie.walkTokens(H[Ge],oe))}):H.tokens&&(fe=fe.concat(ie.walkTokens(H.tokens,oe)))}},ce=R(se),ne;!(ne=ce()).done;)Z();return fe},ie.parseInline=function(se,oe){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");oe=r({},ie.defaults,oe||{}),I(oe);try{var fe=j.lexInline(se,oe);return oe.walkTokens&&ie.walkTokens(fe,oe.walkTokens),J.parseInline(fe,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+w(Z.message+"",!0)+"</pre>";throw Z}},ie.Parser=J,ie.parser=J.parse,ie.Renderer=ue,ie.TextRenderer=V,ie.Lexer=j,ie.lexer=j.lex,ie.Tokenizer=M,ie.Slugger=_,ie.parse=ie;var ee=ie.options,X=ie.setOptions,G=ie.use,de=ie.walkTokens,be=ie.parseInline,Ee=ie,Pe=J.parse,Fe=j.lex;te.Lexer=j,te.Parser=J,te.Renderer=ue,te.Slugger=_,te.TextRenderer=V,te.Tokenizer=M,te.getDefaults=k,te.lexer=Fe,te.marked=ie,te.options=ee,te.parse=Ee,te.parseInline=be,te.parser=Pe,te.setOptions=X,te.use=G,te.walkTokens=de,Object.defineProperty(te,"__esModule",{value:!0})}),define(ye[85],Ce([1,0,28]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function P(C){return y(C,"NFC",t)}e.normalizeNFC=P;const R=new c.LRUCache(1e4);function k(C){return y(C,"NFD",R)}e.normalizeNFD=k;const A=/[^\u0000-\u0080]/;function y(C,L,T){if(!C)return C;const v=T.get(C);if(v)return v;let D;return A.test(C)?D=C.normalize(L):D=C,T.set(C,D),D}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(L){return k(L).replace(C,"")}}()}),define(ye[102],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(A,y,C){return Math.min(Math.max(A,y),C)}e.clamp=c;function t(A,y){return(y+A%y)%y}e.rot=t;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class k{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const C=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function te(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function k(y){R.push(y,Date.now())}function A(){const y=[];for(let C=0;C<R.length;C+=2)y.push({name:R[C],startTime:R[C+1]});return y}return{mark:k,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const k of performance.getEntriesByType("mark"))R.push({name:k.name,startTime:Math.round(P+k.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function c(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:te)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function c(t){if(e[t])return e[t].exports;var P=e[t]={i:t,l:!1,exports:{}};return te[t].call(P.exports,P,P.exports,c),P.l=!0,P.exports}return c.m=te,c.c=e,c.d=function(t,P,R){c.o(t,P)||Object.defineProperty(t,P,{enumerable:!0,get:R})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,P){if(1&P&&(t=c(t)),8&P||4&P&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(c.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&P&&typeof t!="string")for(var k in t)c.d(R,k,function(A){return t[A]}.bind(null,k));return R},c.n=function(t){var P=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(P,"a",P),P},c.o=function(t,P){return Object.prototype.hasOwnProperty.call(t,P)},c.p="",c(c.s=0)}([function(te,e,c){(function(t){var P;e=te.exports=G,P=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],C=0,L=C++;y[L]="0|[1-9]\\d*";var T=C++;y[T]="[0-9]+";var v=C++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=C++;y[D]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var w=C++;y[w]="("+y[T]+")\\.("+y[T]+")\\.("+y[T]+")";var f=C++;y[f]="(?:"+y[L]+"|"+y[v]+")";var d=C++;y[d]="(?:"+y[T]+"|"+y[v]+")";var m=C++;y[m]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var p=C++;y[p]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var b=C++;y[b]="[0-9A-Za-z-]+";var E=C++;y[E]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var g=C++,i="v?"+y[D]+y[m]+"?"+y[E]+"?";y[g]="^"+i+"$";var l="[v=\\s]*"+y[w]+y[p]+"?"+y[E]+"?",o=C++;y[o]="^"+l+"$";var a=C++;y[a]="((?:<|>)?=?)";var s=C++;y[s]=y[T]+"|x|X|\\*";var u=C++;y[u]=y[L]+"|x|X|\\*";var r=C++;y[r]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[m]+")?"+y[E]+"?)?)?";var n=C++;y[n]="[v=\\s]*("+y[s]+")(?:\\.("+y[s]+")(?:\\.("+y[s]+")(?:"+y[p]+")?"+y[E]+"?)?)?";var h=C++;y[h]="^"+y[a]+"\\s*"+y[r]+"$";var S=C++;y[S]="^"+y[a]+"\\s*"+y[n]+"$";var I=C++;y[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=C++;y[F]="(?:~>?)";var K=C++;y[K]="(\\s*)"+y[F]+"\\s+",A[K]=new RegExp(y[K],"g");var q=C++;y[q]="^"+y[F]+y[r]+"$";var M=C++;y[M]="^"+y[F]+y[n]+"$";var B=C++;y[B]="(?:\\^)";var O=C++;y[O]="(\\s*)"+y[B]+"\\s+",A[O]=new RegExp(y[O],"g");var U=C++;y[U]="^"+y[B]+y[r]+"$";var z=C++;y[z]="^"+y[B]+y[n]+"$";var j=C++;y[j]="^"+y[a]+"\\s*("+l+")$|^$";var ue=C++;y[ue]="^"+y[a]+"\\s*("+i+")$|^$";var V=C++;y[V]="(\\s*)"+y[a]+"\\s*("+l+"|"+y[r]+")",A[V]=new RegExp(y[V],"g");var _=C++;y[_]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var J=C++;y[J]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var ie=C++;y[ie]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)P(ee,y[ee]),A[ee]||(A[ee]=new RegExp(y[ee]));function X(pe,De){if(pe instanceof G)return pe;if(typeof pe!="string"||pe.length>R||!(De?A[o]:A[g]).test(pe))return null;try{return new G(pe,De)}catch{return null}}function G(pe,De){if(pe instanceof G){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(pe,De);P("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?A[o]:A[g]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var Ge=+Ve;if(Ge>=0&&Ge<k)return Ge}return Ve}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=X,e.valid=function(pe,De){var ke=X(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=X(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(pe){return P("SemVer.compare",this.version,this.loose,pe),pe instanceof G||(pe=new G(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},G.prototype.compareMain=function(pe){return pe instanceof G||(pe=new G(pe,this.loose)),be(this.major,pe.major)||be(this.minor,pe.minor)||be(this.patch,pe.patch)},G.prototype.comparePre=function(pe){if(pe instanceof G||(pe=new G(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],Ve=pe.prerelease[De];if(P("prerelease compare",De,ke,Ve),ke===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(ke===void 0)return-1;if(ke!==Ve)return be(ke,Ve)}while(++De)},G.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,Ve){typeof ke=="string"&&(Ve=ke,ke=void 0);try{return new G(pe,ke).inc(De,Ve).version}catch{return null}},e.diff=function(pe,De){if(se(pe,De))return null;var ke=X(pe),Ve=X(De);if(ke.prerelease.length||Ve.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==Ve[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==Ve[Ge])return Ge},e.compareIdentifiers=be;var de=/^[0-9]+$/;function be(pe,De){var ke=de.test(pe),Ve=de.test(De);return ke&&Ve&&(pe=+pe,De=+De),ke&&!Ve?-1:Ve&&!ke?1:pe<De?-1:pe>De?1:0}function Ee(pe,De,ke){return new G(pe,ke).compare(new G(De,ke))}function Pe(pe,De,ke){return Ee(pe,De,ke)>0}function Fe(pe,De,ke){return Ee(pe,De,ke)<0}function se(pe,De,ke){return Ee(pe,De,ke)===0}function oe(pe,De,ke){return Ee(pe,De,ke)!==0}function fe(pe,De,ke){return Ee(pe,De,ke)>=0}function Z(pe,De,ke){return Ee(pe,De,ke)<=0}function ce(pe,De,ke,Ve){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,Ve);break;case"!=":Ge=oe(pe,ke,Ve);break;case">":Ge=Pe(pe,ke,Ve);break;case">=":Ge=fe(pe,ke,Ve);break;case"<":Ge=Fe(pe,ke,Ve);break;case"<=":Ge=Z(pe,ke,Ve);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function ne(pe,De){if(pe instanceof ne){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof ne))return new ne(pe,De);P("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===N?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(pe,De){return be(De,pe)},e.major=function(pe,De){return new G(pe,De).major},e.minor=function(pe,De){return new G(pe,De).minor},e.patch=function(pe,De){return new G(pe,De).patch},e.compare=Ee,e.compareLoose=function(pe,De){return Ee(pe,De,!0)},e.rcompare=function(pe,De,ke){return Ee(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,Ve){return e.compare(ke,Ve,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,Ve){return e.rcompare(ke,Ve,De)})},e.gt=Pe,e.lt=Fe,e.eq=se,e.neq=oe,e.gte=fe,e.lte=Z,e.cmp=ce,e.Comparator=ne;var N={};function H(pe,De){if(pe instanceof H)return pe.loose===De?pe:new H(pe.raw,De);if(pe instanceof ne)return new H(pe.value,De);if(!(this instanceof H))return new H(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function Q(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,De,ke,Ve,Ge,et,Qe,nt,st,ht,Me,rt,ae){return((De=Q(ke)?"":Q(Ve)?">="+ke+".0.0":Q(Ge)?">="+ke+"."+Ve+".0":">="+De)+" "+(nt=Q(st)?"":Q(ht)?"<"+(+st+1)+".0.0":Q(Me)?"<"+st+"."+(+ht+1)+".0":rt?"<="+st+"."+ht+"."+Me+"-"+rt:"<="+nt)).trim()}function he(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(P(pe[ke].semver),pe[ke].semver!==N&&pe[ke].semver.prerelease.length>0){var Ve=pe[ke].semver;if(Ve.major===De.major&&Ve.minor===De.minor&&Ve.patch===De.patch)return!0}return!1}return!0}function we(pe,De,ke){try{De=new H(De,ke)}catch{return!1}return De.test(pe)}function Ae(pe,De,ke,Ve){var Ge,et,Qe,nt,st;switch(pe=new G(pe,Ve),De=new H(De,Ve),ke){case">":Ge=Pe,et=Z,Qe=Fe,nt=">",st=">=";break;case"<":Ge=Fe,et=fe,Qe=Pe,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(pe,De,Ve))return!1;for(var ht=0;ht<De.set.length;++ht){var Me=De.set[ht],rt=null,ae=null;if(Me.forEach(function($){$.semver===N&&($=new ne(">=0.0.0")),rt=rt||$,ae=ae||$,Ge($.semver,rt.semver,Ve)?rt=$:Qe($.semver,ae.semver,Ve)&&(ae=$)}),rt.operator===nt||rt.operator===st||(!ae.operator||ae.operator===nt)&&et(pe,ae.semver)||ae.operator===st&&Qe(pe,ae.semver))return!1}return!0}ne.prototype.parse=function(pe){var De=this.loose?A[j]:A[ue],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new G(ke[2],this.loose):this.semver=N},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(pe){return P("Comparator.test",pe,this.loose),this.semver===N||(typeof pe=="string"&&(pe=new G(pe,this.loose)),ce(pe,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(pe,De){if(!(pe instanceof ne))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,De),we(this.value,ke,De);if(pe.operator==="")return ke=new H(this.value,De),we(pe.semver,ke,De);var Ve=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ce(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ce(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return Ve||Ge||et&&Qe||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),P("range",pe,De);var ke=De?A[J]:A[_];pe=pe.replace(ke,Y),P("hyphen replace",pe),pe=pe.replace(A[V],"$1$2$3"),P("comparator trim",pe,A[V]),pe=(pe=(pe=pe.replace(A[K],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var Ve=De?A[j]:A[ue],Ge=pe.split(" ").map(function(et){return function(Qe,nt){return P("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(rt,ae){P("caret",rt,ae);var $=ae?A[z]:A[U];return rt.replace($,function(le,Ie,Le,$e,Xe){var Ze;return P("caret",rt,le,Ie,Le,$e,Xe),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q($e)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Xe?(P("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+Xe+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+Xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+Xe+" <"+(+Ie+1)+".0.0"):(P("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+" <"+(+Ie+1)+".0.0"),P("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(Qe,nt),P("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(rt,ae){var $=ae?A[M]:A[q];return rt.replace($,function(le,Ie,Le,$e,Xe){var Ze;return P("tilde",rt,le,Ie,Le,$e,Xe),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q($e)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Xe?(P("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=">="+Ie+"."+Le+"."+$e+Xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0",P("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(Qe,nt),P("tildes",Qe),Qe=function(st,ht){return P("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(rt,ae){rt=rt.trim();var $=ae?A[S]:A[h];return rt.replace($,function(le,Ie,Le,$e,Xe,Ze){P("xRange",rt,le,Ie,Le,$e,Xe,Ze);var pt=Q(Le),mt=pt||Q($e),ct=mt||Q(Xe);return Ie==="="&&ct&&(Ie=""),pt?le=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&ct?(mt&&($e=0),ct&&(Xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,$e=0,Xe=0):ct&&($e=+$e+1,Xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:$e=+$e+1),le=Ie+Le+"."+$e+"."+Xe):mt?le=">="+Le+".0.0 <"+(+Le+1)+".0.0":ct&&(le=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0"),P("xRange return",le),le})}(Me,ht)}).join(" ")}(Qe,nt),P("xrange",Qe),Qe=function(st,ht){return P("replaceStars",st,ht),st.trim().replace(A[ie],"")}(Qe,nt),P("stars",Qe),Qe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(Ve)})),Ge=Ge.map(function(et){return new ne(et,De)})},H.prototype.intersects=function(pe,De){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(Ve){return pe.set.some(function(Ge){return Ge.every(function(et){return Ve.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new H(pe,De).set.map(function(ke){return ke.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new G(pe,this.loose));for(var De=0;De<this.set.length;De++)if(he(this.set[De],pe))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(pe,De,ke){var Ve=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(Ve&&Ge.compare(Qe)!==-1||(Ge=new G(Ve=Qe,ke)))}),Ve},e.minSatisfying=function(pe,De,ke){var Ve=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(Ve&&Ge.compare(Qe)!==1||(Ge=new G(Ve=Qe,ke)))}),Ve},e.validRange=function(pe,De){try{return new H(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Ae(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Ae(pe,De,">",ke)},e.outside=Ae,e.prerelease=function(pe,De){var ke=X(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new H(pe,ke),De=new H(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof G)return pe;if(typeof pe!="string")return null;var De=pe.match(A[I]);return De==null?null:X((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,c(1))},function(te,e){var c,t,P=te.exports={};function R(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function A(d){if(c===setTimeout)return setTimeout(d,0);if((c===R||!c)&&setTimeout)return c=setTimeout,setTimeout(d,0);try{return c(d,0)}catch{try{return c.call(null,d,0)}catch{return c.call(this,d,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:R}catch{c=R}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var y,C=[],L=!1,T=-1;function v(){L&&y&&(L=!1,y.length?C=y.concat(C):T=-1,C.length&&D())}function D(){if(!L){var d=A(v);L=!0;for(var m=C.length;m;){for(y=C,C=[];++T<m;)y&&y[T].run();T=-1,m=C.length}y=null,L=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(d)}}function w(d,m){this.fun=d,this.array=m}function f(){}P.nextTick=function(d){var m=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)m[p-1]=arguments[p];C.push(new w(d,m)),C.length!==1||L||A(D)},w.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(d){return[]},P.binding=function(d){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(d){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ye[103],Ce([1,0,9,6]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(E){const g=E;return g?typeof g.read=="function":!1}e.isReadable=P;function R(E){const g=E;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function k(E){const g=E;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(E,g){return new y(E,g)}e.newWriteableStream=A;class y{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,c.onUnexpectedError)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let l;switch(g){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const o=l.indexOf(i);o>=0&&l.splice(o,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(E,g){const i=[];let l;for(;(l=E.read())!==null;)i.push(l);return g(i)}e.consumeReadable=C;function L(E,g,i){const l=[];let o;for(;(o=E.read())!==null&&l.length<i;)l.push(o);return o===null&&l.length>0?g(l):{read:()=>{if(l.length>0)return l.shift();if(typeof o<"u"){const a=o;return o=void 0,a}return E.read()}}}e.peekReadable=L;function T(E,g){return new Promise((i,l)=>{const o=[];v(E,{onData:a=>{g&&o.push(a)},onError:a=>{g?l(a):i(void 0)},onEnd:()=>{i(g?g(o):void 0)}})})}e.consumeStream=T;function v(E,g){let i=!1;return E.on("error",l=>{i||g.onError(l)}),E.on("end",()=>{i||g.onEnd()}),E.on("data",l=>{i||g.onData(l)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function D(E,g){return new Promise((i,l)=>{const o=new t.DisposableStore,a=[],s=n=>{if(a.push(n),a.length>g)return o.dispose(),E.pause(),i({stream:E,buffer:a,ended:!1})},u=n=>l(n),r=()=>i({stream:E,buffer:a,ended:!0});o.add((0,t.toDisposable)(()=>E.removeListener("error",u))),E.on("error",u),o.add((0,t.toDisposable)(()=>E.removeListener("end",r))),E.on("end",r),o.add((0,t.toDisposable)(()=>E.removeListener("data",s))),E.on("data",s)})}e.peekStream=D;function w(E,g){const i=A(g);return i.end(E),i}e.toStream=w;function f(){const E=A(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=f;function d(E){let g=!1;return{read:()=>g?null:(g=!0,E)}}e.toReadable=d;function m(E,g,i){const l=A(i);return v(E,{onData:o=>l.write(g.data(o)),onError:o=>l.error(g.error?g.error(o):o),onEnd:()=>l.end()}),l}e.transform=m;function p(E,g,i){let l=!1;return{read:()=>{const o=g.read();return l?o:(l=!0,o!==null?i([E,o]):E)}}}e.prefixedReadable=p;function b(E,g,i){let l=!1;const o=A(i);return v(g,{onData:a=>l?o.write(a):(l=!0,o.write(i([E,a]))),onError:a=>o.error(a),onEnd:()=>{l||(l=!0,o.write(E)),o.end()}}),o}e.prefixedStream=b}),define(ye[22],Ce([1,0,103]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let P,R;class k{static alloc(n){return t?new k(Buffer.allocUnsafe(n)):new k(new Uint8Array(n))}static wrap(n){return t&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new k(n)}static fromString(n,h){return!(h?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(n)):(P||(P=new TextEncoder),new k(P.encode(n)))}static fromByteArray(n){const h=k.alloc(n.length);for(let S=0,I=n.length;S<I;S++)h.buffer[S]=n[S];return h}static concat(n,h){if(typeof h>"u"){h=0;for(let F=0,K=n.length;F<K;F++)h+=n[F].byteLength}const S=k.alloc(h);let I=0;for(let F=0,K=n.length;F<K;F++){const q=n[F];S.set(q,I),I+=q.byteLength}return S}constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}clone(){const n=k.alloc(this.byteLength);return n.set(this),n}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,h){return new k(this.buffer.subarray(n,h))}set(n,h){if(n instanceof k)this.buffer.set(n.buffer,h);else if(n instanceof Uint8Array)this.buffer.set(n,h);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),h);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(n){return C(this.buffer,n)}writeUInt32BE(n,h){L(this.buffer,n,h)}readUInt32LE(n){return T(this.buffer,n)}writeUInt32LE(n,h){v(this.buffer,n,h)}readUInt8(n){return D(this.buffer,n)}writeUInt8(n,h){w(this.buffer,n,h)}}e.VSBuffer=k;function A(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}e.readUInt16LE=A;function y(r,n,h){r[h+0]=n&255,n=n>>>8,r[h+1]=n&255}e.writeUInt16LE=y;function C(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}e.readUInt32BE=C;function L(r,n,h){r[h+3]=n,n=n>>>8,r[h+2]=n,n=n>>>8,r[h+1]=n,n=n>>>8,r[h]=n}e.writeUInt32BE=L;function T(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}e.readUInt32LE=T;function v(r,n,h){r[h+0]=n&255,n=n>>>8,r[h+1]=n&255,n=n>>>8,r[h+2]=n&255,n=n>>>8,r[h+3]=n&255}e.writeUInt32LE=v;function D(r,n){return r[n]}e.readUInt8=D;function w(r,n,h){r[h]=n}e.writeUInt8=w;function f(r){return c.consumeReadable(r,n=>k.concat(n))}e.readableToBuffer=f;function d(r){return c.toReadable(r)}e.bufferToReadable=d;function m(r){return c.consumeStream(r,n=>k.concat(n))}e.streamToBuffer=m;async function p(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await m(r.stream)])}e.bufferedStreamToBuffer=p;function b(r){return c.toStream(r,n=>k.concat(n))}e.bufferToStream=b;function E(r){return c.transform(r,{data:n=>typeof n=="string"?k.fromString(n):k.wrap(n)},n=>k.concat(n))}e.streamToBufferReadableStream=E;function g(r){return c.newWriteableStream(n=>k.concat(n),r)}e.newWriteableBufferStream=g;function i(r,n){return c.prefixedReadable(r,n,h=>k.concat(h))}e.prefixedBufferReadable=i;function l(r,n){return c.prefixedStream(r,n,h=>k.concat(h))}e.prefixedBufferStream=l;function o(r){let n=0,h=0,S=0;const I=new Uint8Array(Math.floor(r.length/4*3)),F=q=>{switch(h){case 3:I[S++]=n|q,h=0;break;case 2:I[S++]=n|q>>>2,n=q<<6,h=3;break;case 1:I[S++]=n|q>>>4,n=q<<4,h=2;break;default:n=q<<2,h=1}};for(let q=0;q<r.length;q++){const M=r.charCodeAt(q);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${r[q]}`)}}const K=S;for(;h>0;)F(0);return k.wrap(I).slice(0,K)}e.decodeBase64=o;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:r},n=!0,h=!1){const S=h?s:a;let I="";const F=r.byteLength%3;let K=0;for(;K<r.byteLength-F;K+=3){const q=r[K+0],M=r[K+1],B=r[K+2];I+=S[q>>>2],I+=S[(q<<4|M>>>4)&63],I+=S[(M<<2|B>>>6)&63],I+=S[B&63]}if(F===1){const q=r[K+0];I+=S[q>>>2],I+=S[q<<4&63],n&&(I+="==")}else if(F===2){const q=r[K+0],M=r[K+1];I+=S[q>>>2],I+=S[(q<<4|M>>>4)&63],I+=S[M<<2&63],n&&(I+="=")}return I}e.encodeBase64=u}),define(ye[10],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(l){return typeof l=="string"}e.isString=c;function t(l){return Array.isArray(l)&&l.every(o=>c(o))}e.isStringArray=t;function P(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=P;function R(l){const o=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof o}e.isTypedArray=R;function k(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=k;function A(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=A;function y(l){return l===!0||l===!1}e.isBoolean=y;function C(l){return typeof l>"u"}e.isUndefined=C;function L(l){return!T(l)}e.isDefined=L;function T(l){return C(l)||l===null}e.isUndefinedOrNull=T;function v(l,o){if(!l)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=v;function D(l){if(T(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=D;function w(...l){const o=[];for(let a=0;a<l.length;a++){const s=l[a];if(T(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);o.push(s)}return o}e.assertAllDefined=w;const f=Object.prototype.hasOwnProperty;function d(l){if(!P(l))return!1;for(const o in l)if(f.call(l,o))return!1;return!0}e.isEmptyObject=d;function m(l){return typeof l=="function"}e.isFunction=m;function p(...l){return l.length>0&&l.every(m)}e.areFunctions=p;function b(l,o){const a=Math.min(l.length,o.length);for(let s=0;s<a;s++)E(l[s],o[s])}e.validateConstraints=b;function E(l,o){if(c(o)){if(typeof l!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(l instanceof o)return}catch{}if(!T(l)&&l.constructor===o||o.length===1&&o.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function g(l){return l===null?void 0:l}e.withNullAsUndefined=g;function i(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=i}),define(ye[23],Ce([1,0,10]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([b,E])=>{p[b]=E&&typeof E=="object"?t(E):E}),p}e.deepClone=t;function P(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const E in b)if(R.call(b,E)){const g=b[E];typeof g=="object"&&!Object.isFrozen(g)&&!(0,c.isTypedArray)(g)&&p.push(g)}}return m}e.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function k(m,p){return A(m,p,new Set)}e.cloneAndChange=k;function A(m,p,b){if((0,c.isUndefinedOrNull)(m))return m;const E=p(m);if(typeof E<"u")return E;if(Array.isArray(m)){const g=[];for(const i of m)g.push(A(i,p,b));return g}if((0,c.isObject)(m)){if(b.has(m))throw new Error("Cannot clone recursive data-structure");b.add(m);const g={};for(const i in m)R.call(m,i)&&(g[i]=A(m[i],p,b));return b.delete(m),g}return m}function y(m,p,b=!0){return(0,c.isObject)(m)?((0,c.isObject)(p)&&Object.keys(p).forEach(E=>{E in m?b&&((0,c.isObject)(m[E])&&(0,c.isObject)(p[E])?y(m[E],p[E],b):m[E]=p[E]):m[E]=p[E]}),m):p}e.mixin=y;function C(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let b,E;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(b=0;b<m.length;b++)if(!C(m[b],p[b]))return!1}else{const g=[];for(E in m)g.push(E);g.sort();const i=[];for(E in p)i.push(E);if(i.sort(),!C(g,i))return!1;for(b=0;b<g.length;b++)if(!C(m[g[b]],p[g[b]]))return!1}return!0}e.equals=C;function L(m){const p=new Set;return JSON.stringify(m,(b,E)=>{if((0,c.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=L;function T(m,p){const b=Object.create(null);return!m||!p||Object.keys(p).forEach(g=>{const i=m[g],l=p[g];C(i,l)||(b[g]=l)}),b}e.distinct=T;function v(m,p){const b=p.toLowerCase(),E=Object.keys(m).find(g=>g.toLowerCase()===b);return E?m[E]:m[p]}e.getCaseInsensitive=v;function D(m,p){const b=Object.create(null);for(const[E,g]of Object.entries(m))p(E,g)&&(b[E]=g);return b}e.filter=D;function w(m){let p=[],b=Object.getPrototypeOf(m);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=w;function f(m){const p=[];for(const b of w(m))typeof m[b]=="function"&&p.push(b);return p}e.getAllMethodNames=f;function d(m,p){const b=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},E={};for(const g of m)E[g]=b(g);return E}e.createProxyObject=d}),define(ye[104],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(R){return R<0?0:R>255?255:R|0}e.toUint8=t;function P(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=P}),define(ye[30],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return c.test(P)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),k=[];for(let A=0;A<256;A++)k.push(A.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,C="";return C+=k[R[y++]],C+=k[R[y++]],C+=k[R[y++]],C+=k[R[y++]],C+="-",C+=k[R[y++]],C+=k[R[y++]],C+="-",C+=k[R[y++]],C+=k[R[y++]],C+="-",C+=k[R[y++]],C+=k[R[y++]],C+="-",C+=k[R[y++]],C+=k[R[y++]],C+=k[R[y++]],C+=k[R[y++]],C+=k[R[y++]],C+=k[R[y++]],C}}()}),define(ye[148],Ce([1,0,16,30]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function P(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=P;function R(A,y,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:C}),value:void 0}}e.createFileDataTransferItem=R;class k{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,C){const L=this.a.get(y);L?L.push(C):this.a.set(this.b(y),[C])}replace(y,C){this.a.set(this.b(y),[C])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,C]of this.a.entries())for(const L of C)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[C,L]of this.entries())y(L,C)}b(y){return y.toLowerCase()}}e.VSDataTransfer=k,e.UriList=Object.freeze({create:A=>(0,c.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[105],Ce([1,0,104]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(A){const y=(0,c.toUint8)(A);this.c=y,this.a=t.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const C=(0,c.toUint8)(y);A>=0&&A<256?this.a[A]=C:this.b.set(A,C)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var P;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(P||(P={}));class R{constructor(){this.a=new t(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(P,R){this.lineNumber=P,this.column=R}with(P=this.lineNumber,R=this.column){return P===this.lineNumber&&R===this.column?this:new c(P,R)}delta(P=0,R=0){return this.with(this.lineNumber+P,this.column+R)}equals(P){return c.equals(this,P)}static equals(P,R){return!P&&!R?!0:!!P&&!!R&&P.lineNumber===R.lineNumber&&P.column===R.column}isBefore(P){return c.isBefore(this,P)}static isBefore(P,R){return P.lineNumber<R.lineNumber?!0:R.lineNumber<P.lineNumber?!1:P.column<R.column}isBeforeOrEqual(P){return c.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,R){return P.lineNumber<R.lineNumber?!0:R.lineNumber<P.lineNumber?!1:P.column<=R.column}static compare(P,R){const k=P.lineNumber|0,A=R.lineNumber|0;if(k===A){const y=P.column|0,C=R.column|0;return y-C}return k-A}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new c(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=c}),define(ye[36],Ce([1,0,52]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(R,k,A,y){R>A||R===A&&k>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=k):(this.startLineNumber=R,this.startColumn=k,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return t.containsPosition(this,R)}static containsPosition(R,k){return!(k.lineNumber<R.startLineNumber||k.lineNumber>R.endLineNumber||k.lineNumber===R.startLineNumber&&k.column<R.startColumn||k.lineNumber===R.endLineNumber&&k.column>R.endColumn)}static strictContainsPosition(R,k){return!(k.lineNumber<R.startLineNumber||k.lineNumber>R.endLineNumber||k.lineNumber===R.startLineNumber&&k.column<=R.startColumn||k.lineNumber===R.endLineNumber&&k.column>=R.endColumn)}containsRange(R){return t.containsRange(this,R)}static containsRange(R,k){return!(k.startLineNumber<R.startLineNumber||k.endLineNumber<R.startLineNumber||k.startLineNumber>R.endLineNumber||k.endLineNumber>R.endLineNumber||k.startLineNumber===R.startLineNumber&&k.startColumn<R.startColumn||k.endLineNumber===R.endLineNumber&&k.endColumn>R.endColumn)}strictContainsRange(R){return t.strictContainsRange(this,R)}static strictContainsRange(R,k){return!(k.startLineNumber<R.startLineNumber||k.endLineNumber<R.startLineNumber||k.startLineNumber>R.endLineNumber||k.endLineNumber>R.endLineNumber||k.startLineNumber===R.startLineNumber&&k.startColumn<=R.startColumn||k.endLineNumber===R.endLineNumber&&k.endColumn>=R.endColumn)}plusRange(R){return t.plusRange(this,R)}static plusRange(R,k){let A,y,C,L;return k.startLineNumber<R.startLineNumber?(A=k.startLineNumber,y=k.startColumn):k.startLineNumber===R.startLineNumber?(A=k.startLineNumber,y=Math.min(k.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),k.endLineNumber>R.endLineNumber?(C=k.endLineNumber,L=k.endColumn):k.endLineNumber===R.endLineNumber?(C=k.endLineNumber,L=Math.max(k.endColumn,R.endColumn)):(C=R.endLineNumber,L=R.endColumn),new t(A,y,C,L)}intersectRanges(R){return t.intersectRanges(this,R)}static intersectRanges(R,k){let A=R.startLineNumber,y=R.startColumn,C=R.endLineNumber,L=R.endColumn;const T=k.startLineNumber,v=k.startColumn,D=k.endLineNumber,w=k.endColumn;return A<T?(A=T,y=v):A===T&&(y=Math.max(y,v)),C>D?(C=D,L=w):C===D&&(L=Math.min(L,w)),A>C||A===C&&y>L?null:new t(A,y,C,L)}equalsRange(R){return t.equalsRange(this,R)}static equalsRange(R,k){return!R&&!k?!0:!!R&&!!k&&R.startLineNumber===k.startLineNumber&&R.startColumn===k.startColumn&&R.endLineNumber===k.endLineNumber&&R.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(R){return new c.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(R){return new c.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,k){return new t(this.startLineNumber,this.startColumn,R,k)}setStartPosition(R,k){return new t(R,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(R){return new t(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(R){return new t(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new t(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,k=R){return new t(R.lineNumber,R.column,k.lineNumber,k.column)}static lift(R){return R?new t(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,k){return!(R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn||k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn)}static areIntersecting(R,k){return!(R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn||k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,k){if(R&&k){const C=R.startLineNumber|0,L=k.startLineNumber|0;if(C===L){const T=R.startColumn|0,v=k.startColumn|0;if(T===v){const D=R.endLineNumber|0,w=k.endLineNumber|0;if(D===w){const f=R.endColumn|0,d=k.endColumn|0;return f-d}return D-w}return T-v}return C-L}return(R?1:0)-(k?1:0)}static compareRangesUsingEnds(R,k){return R.endLineNumber===k.endLineNumber?R.endColumn===k.endColumn?R.startLineNumber===k.startLineNumber?R.startColumn-k.startColumn:R.startLineNumber-k.startLineNumber:R.endColumn-k.endColumn:R.endLineNumber-k.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,52,36]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(P=e.SelectionDirection||(e.SelectionDirection={}));class R extends t.Range{constructor(A,y,C,L){super(A,y,C,L),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=C,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let C=0,L=A.length;C<L;C++)if(!this.selectionsEqual(A[C],y[C]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,C,L,T){return T===0?new R(A,y,C,L):new R(C,L,A,y)}}e.Selection=R}),define(ye[150],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,105]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class P extends c.CharacterClassifier{constructor(A){super(0);for(let y=0,C=A.length;y<C;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=P;function R(k){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=k(y)),A[y])}e.getMapForWordSeparators=R(k=>new P(k))}),define(ye[106],Ce([1,0,64,6,66]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(T=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)T.indexOf(D)>=0||(v+="\\"+D);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function k(T){let v=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)v=T;else{let D="g";T.ignoreCase&&(D+="i"),T.multiline&&(D+="m"),T.unicode&&(D+="u"),v=new RegExp(T.source,D)}return v.lastIndex=0,v}e.ensureValidWordDefinition=k;const A=new P.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(T){const v=A.unshift(T);return(0,t.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=y;function C(T,v,D,w,f){if(f||(f=c.Iterable.first(A)),D.length>f.maxLen){let E=T-f.maxLen/2;return E<0?E=0:w+=E,D=D.substring(E,T+f.maxLen/2),C(T,v,D,w,f)}const d=Date.now(),m=T-1-w;let p=-1,b=null;for(let E=1;!(Date.now()-d>=f.timeBudget);E++){const g=m-f.windowSize*E;v.lastIndex=Math.max(0,g);const i=L(v,D,m,p);if(!i&&b||(b=i,g<=0))break;p=g}if(b){const E={word:b[0],startColumn:w+1+b.index,endColumn:w+1+b.index+b[0].length};return v.lastIndex=0,E}return null}e.getWordAtText=C;function L(T,v,D,w){let f;for(;f=T.exec(v);){const d=f.index||0;if(d<=D&&T.lastIndex>=D)return f;if(w>0&&d>w)return null}return null}}),define(ye[152],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,C=A.notIn.length;y<C;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const C=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(C);return this.isOK(L)}g(A,y){for(let C=A;C<=y;C++){const L=String.fromCharCode(C);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class P{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=P;function R(k,A,y){k.has(A)?k.get(A).push(y):k.set(A,[y])}}),define(ye[153],Ce([1,0,105]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class P{constructor(w,f,d){const m=new Uint8Array(w*f);for(let p=0,b=w*f;p<b;p++)m[p]=d;this.a=m,this.rows=w,this.cols=f}get(w,f){return this.a[w*this.cols+f]}set(w,f,d){this.a[w*this.cols+f]=d}}class R{constructor(w){let f=0,d=0;for(let p=0,b=w.length;p<b;p++){const[E,g,i]=w[p];g>f&&(f=g),E>d&&(d=E),i>d&&(d=i)}f++,d++;const m=new P(d,f,0);for(let p=0,b=w.length;p<b;p++){const[E,g,i]=w[p];m.set(E,g,i)}this.a=m,this.b=f}nextState(w,f){return f<0||f>=this.b?0:this.a.get(w,f)}}e.StateMachine=R;let k=null;function A(){return k===null&&(k=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var y;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let C=null;function L(){if(C===null){C=new c.CharacterClassifier(0);const D=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<D.length;f++)C.set(D.charCodeAt(f),1);const w=".;:";for(let f=0;f<w.length;f++)C.set(w.charCodeAt(f),2)}return C}class T{static a(w,f,d,m,p){let b=p-1;do{const E=f.charCodeAt(b);if(w.get(E)!==2)break;b--}while(b>m);if(m>0){const E=f.charCodeAt(m-1),g=f.charCodeAt(b);(E===40&&g===41||E===91&&g===93||E===123&&g===125)&&b--}return{range:{startLineNumber:d,startColumn:m+1,endLineNumber:d,endColumn:b+2},url:f.substring(m,b+1)}}static computeLinks(w,f=A()){const d=L(),m=[];for(let p=1,b=w.getLineCount();p<=b;p++){const E=w.getLineContent(p),g=E.length;let i=0,l=0,o=0,a=1,s=!1,u=!1,r=!1,n=!1;for(;i<g;){let h=!1;const S=E.charCodeAt(i);if(a===13){let I;switch(S){case 40:s=!0,I=0;break;case 41:I=s?0:1;break;case 91:r=!0,u=!0,I=0;break;case 93:r=!1,I=u?0:1;break;case 123:n=!0,I=0;break;case 125:I=n?0:1;break;case 39:case 34:case 96:o===S?I=1:o===39||o===34||o===96?I=0:I=1;break;case 42:I=o===42?1:0;break;case 124:I=o===124?1:0;break;case 32:I=r?0:1;break;default:I=d.get(S)}I===1&&(m.push(T.a(d,E,p,l,i)),h=!0)}else if(a===12){let I;S===91?(u=!0,I=0):I=d.get(S),I===1?h=!0:a=13}else a=f.nextState(a,S),a===0&&(h=!0);h&&(a=1,s=!1,u=!1,n=!1,l=i+1,o=S),i++}a===13&&m.push(T.a(d,E,p,l,g))}return m}}e.LinkComputer=T;function v(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:T.computeLinks(D)}e.computeLinks=v}),define(ye[107],Ce([1,0,23]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var P;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(P=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var k;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(E){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,E.tabSize|0),E.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,E.indentSize|0),this.a=!1),this.insertSpaces=Boolean(E.insertSpaces),this.defaultEOL=E.defaultEOL|0,this.trimAutoWhitespace=Boolean(E.trimAutoWhitespace),this.bracketPairColorizationOptions=E.bracketPairColorizationOptions}equals(E){return this.tabSize===E.tabSize&&this.a===E.a&&this.indentSize===E.indentSize&&this.insertSpaces===E.insertSpaces&&this.defaultEOL===E.defaultEOL&&this.trimAutoWhitespace===E.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,E.bracketPairColorizationOptions)}createChangeEvent(E){return{tabSize:this.tabSize!==E.tabSize,indentSize:this.indentSize!==E.indentSize,insertSpaces:this.insertSpaces!==E.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==E.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class L{constructor(E,g){this._findMatchBrand=void 0,this.range=E,this.matches=g}}e.FindMatch=L;var T;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var D;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(D=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class f{constructor(E,g,i,l,o,a){this.identifier=E,this.range=g,this.text=i,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=o,this._isTracked=a}}e.ValidAnnotatedEditOperation=f;class d{constructor(E,g,i){this.regex=E,this.wordSeparators=g,this.simpleSearch=i}}e.SearchData=d;class m{constructor(E,g,i){this.reverseEdits=E,this.changes=g,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=m;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(ye[154],Ce([1,0,16,104]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class P{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,C){y=(0,t.toUint32)(y);const L=this.a,T=this.b,v=C.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+v),this.a.set(C,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}setValue(y,C){return y=(0,t.toUint32)(y),C=(0,t.toUint32)(C),this.a[y]===C?!1:(this.a[y]=C,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,C){y=(0,t.toUint32)(y),C=(0,t.toUint32)(C);const L=this.a,T=this.b;if(y>=L.length)return!1;const v=L.length-y;return C>=v&&(C=v),C===0?!1:(this.a=new Uint32Array(L.length-C),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+C),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let C=this.c[0]+1;C===0&&(this.b[0]=this.a[0],C++),y>=this.a.length&&(y=this.a.length-1);for(let L=C;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let C=0,L=this.a.length-1,T=0,v=0,D=0;for(;C<=L;)if(T=C+(L-C)/2|0,v=this.b[T],D=v-this.a[T],y<D)L=T-1;else if(y>=v)C=T+1;else break;return new k(T,y-D)}}e.PrefixSumComputer=P;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const C=this.e[y],L=C>0?this.d[C-1]:0;return new k(C,y-L)}removeValues(y,C){this.a.splice(y,C),this.f(y)}insertValues(y,C){this.a=(0,c.arrayInsert)(this.a,y,C),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,C=this.a.length;y<C;y++){const L=this.a[y],T=y>0?this.d[y-1]:0;this.d[y]=T+L;for(let v=0;v<L;v++)this.e[T+v]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,C){this.a[y]!==C&&(this.a[y]=C,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class k{constructor(y,C){this.index=y,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=k}),define(ye[155],Ce([19,20]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ye[156],Ce([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ye[157],Ce([1,0,156]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,P=t*60,R=P*24,k=R*7,A=R*30,y=R*365;function C(T,v,D,w){typeof T!="number"&&(T=T.getTime());const f=Math.round((new Date().getTime()-T)/1e3);if(f<-30)return(0,c.localize)(0,null,C(new Date().getTime()+f*1e3,!1));if(!w&&f<30)return(0,c.localize)(1,null);let d;return f<t?(d=f,v?d===1?D?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):D?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?D?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):D?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):f<P?(d=Math.floor(f/t),v?d===1?D?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):D?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?D?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):D?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):f<R?(d=Math.floor(f/P),v?d===1?D?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):D?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?D?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):D?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):f<k?(d=Math.floor(f/R),v?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):f<A?(d=Math.floor(f/k),v?d===1?D?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):D?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?D?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):D?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):f<y?(d=Math.floor(f/A),v?d===1?D?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):D?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?D?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):D?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(f/y),v?d===1?D?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):D?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?D?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):D?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=C;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[158],Ce([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ye[45],Ce([1,0,16,10,158]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(T,v){return v&&(T.stack||T.stacktrace)?P.localize(0,null,A(T),k(T.stack)||k(T.stacktrace)):A(T)}function k(T){return Array.isArray(T)?T.join(`
`):T}function A(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?P.localize(1,null,T.message):T.message||P.localize(2,null)}function y(T=null,v=!1){if(!T)return P.localize(3,null);if(Array.isArray(T)){const D=c.coalesce(T),w=y(D[0],v);return D.length>1?P.localize(4,null,w,D.length):w}if(t.isString(T))return T;if(T.detail){const D=T.detail;if(D.error)return R(D.error,v);if(D.exception)return R(D.exception,v)}return T.stack?R(T,v):T.message?T.message:P.localize(5,null)}e.toErrorMessage=y;function C(T){const v=T;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=C;function L(T,v){let D;return typeof T=="string"?D=new Error(T):D=T,D.actions=v,D}e.createErrorWithActions=L}),define(ye[159],Ce([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,159]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,P=!1,R=!1,k=!1,A=!1,y=!1,C=!1,L=!1,T=!1,v=!1,D,w=e.LANGUAGE_DEFAULT,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const p=typeof m?.versions?.electron=="string",b=p&&m?.type==="renderer";if(typeof navigator=="object"&&!b)d=navigator.userAgent,t=d.indexOf("Windows")>=0,P=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,y=!0,D=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,w=D;else if(typeof m=="object"){t=m.platform==="win32",P=m.platform==="darwin",R=m.platform==="linux",k=R&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,C=p,T=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const r=m.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),h=n.availableLanguages["*"];D=n.locale,w=h||e.LANGUAGE_DEFAULT,f=n._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var E;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function g(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let i=0;P?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=P,e.isLinux=R,e.isLinuxSnap=k,e.isNative=A,e.isElectron=C,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=T,e.platform=i,e.userAgent=d,e.language=w;var l;(function(r){function n(){return e.language}r.value=n;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function S(){return e.language==="en"}r.isDefault=S})(l=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let S=0,I=r.length;S<I;S++){const F=r[S];if(F.id===h.data.vscodeScheduleAsyncWork){r.splice(S,1),F.callback();return}}});let n=0;return h=>{const S=++n;r.push({id:S,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||L?2:t?1:3;let a=!0,s=!1;function u(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,a=new Uint16Array(r.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[37],Ce([1,0,12]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const P=c.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[11],Ce([1,0,37]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,P=97,R=90,k=122,A=46,y=47,C=92,L=58,T=63;class v extends Error{constructor(l,o,a){let s;typeof o=="string"&&o.indexOf("not ")===0?(s="must not be",o=o.replace(/^not /,"")):s="must be";const u=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${u} ${s} of type ${o}`;r+=`. Received type ${typeof a}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function D(i,l){if(i===null||typeof i!="object")throw new v(l,"Object",i)}function w(i,l){if(typeof i!="string")throw new v(l,"string",i)}const f=c.platform==="win32";function d(i){return i===y||i===C}function m(i){return i===y}function p(i){return i>=t&&i<=R||i>=P&&i<=k}function b(i,l,o,a){let s="",u=0,r=-1,n=0,h=0;for(let S=0;S<=i.length;++S){if(S<i.length)h=i.charCodeAt(S);else{if(a(h))break;h=y}if(a(h)){if(!(r===S-1||n===1))if(n===2){if(s.length<2||u!==2||s.charCodeAt(s.length-1)!==A||s.charCodeAt(s.length-2)!==A){if(s.length>2){const I=s.lastIndexOf(o);I===-1?(s="",u=0):(s=s.slice(0,I),u=s.length-1-s.lastIndexOf(o)),r=S,n=0;continue}else if(s.length!==0){s="",u=0,r=S,n=0;continue}}l&&(s+=s.length>0?`${o}..`:"..",u=2)}else s.length>0?s+=`${o}${i.slice(r+1,S)}`:s=i.slice(r+1,S),u=S-r-1;r=S,n=0}else h===A&&n!==-1?++n:n=-1}return s}function E(i,l){D(l,"pathObject");const o=l.dir||l.root,a=l.base||`${l.name||""}${l.ext||""}`;return o?o===l.root?`${o}${a}`:`${o}${i}${a}`:a}e.win32={resolve(...i){let l="",o="",a=!1;for(let s=i.length-1;s>=-1;s--){let u;if(s>=0){if(u=i[s],w(u,"path"),u.length===0)continue}else l.length===0?u=c.cwd():(u=c.env[`=${l}`]||c.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==l.toLowerCase()&&u.charCodeAt(2)===C)&&(u=`${l}\\`));const r=u.length;let n=0,h="",S=!1;const I=u.charCodeAt(0);if(r===1)d(I)&&(n=1,S=!0);else if(d(I))if(S=!0,d(u.charCodeAt(1))){let F=2,K=F;for(;F<r&&!d(u.charCodeAt(F));)F++;if(F<r&&F!==K){const q=u.slice(K,F);for(K=F;F<r&&d(u.charCodeAt(F));)F++;if(F<r&&F!==K){for(K=F;F<r&&!d(u.charCodeAt(F));)F++;(F===r||F!==K)&&(h=`\\\\${q}\\${u.slice(K,F)}`,n=F)}}}else n=1;else p(I)&&u.charCodeAt(1)===L&&(h=u.slice(0,2),n=2,r>2&&d(u.charCodeAt(2))&&(S=!0,n=3));if(h.length>0)if(l.length>0){if(h.toLowerCase()!==l.toLowerCase())continue}else l=h;if(a){if(l.length>0)break}else if(o=`${u.slice(n)}\\${o}`,a=S,S&&l.length>0)break}return o=b(o,!a,"\\",d),a?`${l}\\${o}`:`${l}${o}`||"."},normalize(i){w(i,"path");const l=i.length;if(l===0)return".";let o=0,a,s=!1;const u=i.charCodeAt(0);if(l===1)return m(u)?"\\":i;if(d(u))if(s=!0,d(i.charCodeAt(1))){let n=2,h=n;for(;n<l&&!d(i.charCodeAt(n));)n++;if(n<l&&n!==h){const S=i.slice(h,n);for(h=n;n<l&&d(i.charCodeAt(n));)n++;if(n<l&&n!==h){for(h=n;n<l&&!d(i.charCodeAt(n));)n++;if(n===l)return`\\\\${S}\\${i.slice(h)}\\`;n!==h&&(a=`\\\\${S}\\${i.slice(h,n)}`,o=n)}}}else o=1;else p(u)&&i.charCodeAt(1)===L&&(a=i.slice(0,2),o=2,l>2&&d(i.charCodeAt(2))&&(s=!0,o=3));let r=o<l?b(i.slice(o),!s,"\\",d):"";return r.length===0&&!s&&(r="."),r.length>0&&d(i.charCodeAt(l-1))&&(r+="\\"),a===void 0?s?`\\${r}`:r:s?`${a}\\${r}`:`${a}${r}`},isAbsolute(i){w(i,"path");const l=i.length;if(l===0)return!1;const o=i.charCodeAt(0);return d(o)||l>2&&p(o)&&i.charCodeAt(1)===L&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,o;for(let u=0;u<i.length;++u){const r=i[u];w(r,"path"),r.length>0&&(l===void 0?l=o=r:l+=`\\${r}`)}if(l===void 0)return".";let a=!0,s=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++s;const u=o.length;u>1&&d(o.charCodeAt(1))&&(++s,u>2&&(d(o.charCodeAt(2))?++s:a=!1))}if(a){for(;s<l.length&&d(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(i,l){if(w(i,"from"),w(l,"to"),i===l)return"";const o=e.win32.resolve(i),a=e.win32.resolve(l);if(o===a||(i=o.toLowerCase(),l=a.toLowerCase(),i===l))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===C;)s++;let u=i.length;for(;u-1>s&&i.charCodeAt(u-1)===C;)u--;const r=u-s;let n=0;for(;n<l.length&&l.charCodeAt(n)===C;)n++;let h=l.length;for(;h-1>n&&l.charCodeAt(h-1)===C;)h--;const S=h-n,I=r<S?r:S;let F=-1,K=0;for(;K<I;K++){const M=i.charCodeAt(s+K);if(M!==l.charCodeAt(n+K))break;M===C&&(F=K)}if(K!==I){if(F===-1)return a}else{if(S>I){if(l.charCodeAt(n+K)===C)return a.slice(n+K+1);if(K===2)return a.slice(n+K)}r>I&&(i.charCodeAt(s+K)===C?F=K:K===2&&(F=3)),F===-1&&(F=0)}let q="";for(K=s+F+1;K<=u;++K)(K===u||i.charCodeAt(K)===C)&&(q+=q.length===0?"..":"\\..");return n+=F,q.length>0?`${q}${a.slice(n,h)}`:(a.charCodeAt(n)===C&&++n,a.slice(n,h))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=e.win32.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===C){if(l.charCodeAt(1)===C){const o=l.charCodeAt(2);if(o!==T&&o!==A)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===C)return`\\\\?\\${l}`;return i},dirname(i){w(i,"path");const l=i.length;if(l===0)return".";let o=-1,a=0;const s=i.charCodeAt(0);if(l===1)return d(s)?i:".";if(d(s)){if(o=a=1,d(i.charCodeAt(1))){let n=2,h=n;for(;n<l&&!d(i.charCodeAt(n));)n++;if(n<l&&n!==h){for(h=n;n<l&&d(i.charCodeAt(n));)n++;if(n<l&&n!==h){for(h=n;n<l&&!d(i.charCodeAt(n));)n++;if(n===l)return i;n!==h&&(o=a=n+1)}}}}else p(s)&&i.charCodeAt(1)===L&&(o=l>2&&d(i.charCodeAt(2))?3:2,a=o);let u=-1,r=!0;for(let n=l-1;n>=a;--n)if(d(i.charCodeAt(n))){if(!r){u=n;break}}else r=!1;if(u===-1){if(o===-1)return".";u=o}return i.slice(0,u)},basename(i,l){l!==void 0&&w(l,"ext"),w(i,"path");let o=0,a=-1,s=!0,u;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(o=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let r=l.length-1,n=-1;for(u=i.length-1;u>=o;--u){const h=i.charCodeAt(u);if(d(h)){if(!s){o=u+1;break}}else n===-1&&(s=!1,n=u+1),r>=0&&(h===l.charCodeAt(r)?--r===-1&&(a=u):(r=-1,a=n))}return o===a?a=n:a===-1&&(a=i.length),i.slice(o,a)}for(u=i.length-1;u>=o;--u)if(d(i.charCodeAt(u))){if(!s){o=u+1;break}}else a===-1&&(s=!1,a=u+1);return a===-1?"":i.slice(o,a)},extname(i){w(i,"path");let l=0,o=-1,a=0,s=-1,u=!0,r=0;i.length>=2&&i.charCodeAt(1)===L&&p(i.charCodeAt(0))&&(l=a=2);for(let n=i.length-1;n>=l;--n){const h=i.charCodeAt(n);if(d(h)){if(!u){a=n+1;break}continue}s===-1&&(u=!1,s=n+1),h===A?o===-1?o=n:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===a+1?"":i.slice(o,s)},format:E.bind(null,"\\"),parse(i){w(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const o=i.length;let a=0,s=i.charCodeAt(0);if(o===1)return d(s)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(d(s)){if(a=1,d(i.charCodeAt(1))){let F=2,K=F;for(;F<o&&!d(i.charCodeAt(F));)F++;if(F<o&&F!==K){for(K=F;F<o&&d(i.charCodeAt(F));)F++;if(F<o&&F!==K){for(K=F;F<o&&!d(i.charCodeAt(F));)F++;F===o?a=F:F!==K&&(a=F+1)}}}}else if(p(s)&&i.charCodeAt(1)===L){if(o<=2)return l.root=l.dir=i,l;if(a=2,d(i.charCodeAt(2))){if(o===3)return l.root=l.dir=i,l;a=3}}a>0&&(l.root=i.slice(0,a));let u=-1,r=a,n=-1,h=!0,S=i.length-1,I=0;for(;S>=a;--S){if(s=i.charCodeAt(S),d(s)){if(!h){r=S+1;break}continue}n===-1&&(h=!1,n=S+1),s===A?u===-1?u=S:I!==1&&(I=1):u!==-1&&(I=-1)}return n!==-1&&(u===-1||I===0||I===1&&u===n-1&&u===r+1?l.base=l.name=i.slice(r,n):(l.name=i.slice(r,u),l.base=i.slice(r,n),l.ext=i.slice(u,n))),r>0&&r!==a?l.dir=i.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(f){const i=/\\/g;return()=>{const l=c.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...i){let l="",o=!1;for(let a=i.length-1;a>=-1&&!o;a--){const s=a>=0?i[a]:g();w(s,"path"),s.length!==0&&(l=`${s}/${l}`,o=s.charCodeAt(0)===y)}return l=b(l,!o,"/",m),o?`/${l}`:l.length>0?l:"."},normalize(i){if(w(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===y,o=i.charCodeAt(i.length-1)===y;return i=b(i,!l,"/",m),i.length===0?l?"/":o?"./":".":(o&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return w(i,"path"),i.length>0&&i.charCodeAt(0)===y},join(...i){if(i.length===0)return".";let l;for(let o=0;o<i.length;++o){const a=i[o];w(a,"path"),a.length>0&&(l===void 0?l=a:l+=`/${a}`)}return l===void 0?".":e.posix.normalize(l)},relative(i,l){if(w(i,"from"),w(l,"to"),i===l||(i=e.posix.resolve(i),l=e.posix.resolve(l),i===l))return"";const o=1,a=i.length,s=a-o,u=1,r=l.length-u,n=s<r?s:r;let h=-1,S=0;for(;S<n;S++){const F=i.charCodeAt(o+S);if(F!==l.charCodeAt(u+S))break;F===y&&(h=S)}if(S===n)if(r>n){if(l.charCodeAt(u+S)===y)return l.slice(u+S+1);if(S===0)return l.slice(u+S)}else s>n&&(i.charCodeAt(o+S)===y?h=S:S===0&&(h=0));let I="";for(S=o+h+1;S<=a;++S)(S===a||i.charCodeAt(S)===y)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(u+h)}`},toNamespacedPath(i){return i},dirname(i){if(w(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===y;let o=-1,a=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===y){if(!a){o=s;break}}else a=!1;return o===-1?l?"/":".":l&&o===1?"//":i.slice(0,o)},basename(i,l){l!==void 0&&w(l,"ext"),w(i,"path");let o=0,a=-1,s=!0,u;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let r=l.length-1,n=-1;for(u=i.length-1;u>=0;--u){const h=i.charCodeAt(u);if(h===y){if(!s){o=u+1;break}}else n===-1&&(s=!1,n=u+1),r>=0&&(h===l.charCodeAt(r)?--r===-1&&(a=u):(r=-1,a=n))}return o===a?a=n:a===-1&&(a=i.length),i.slice(o,a)}for(u=i.length-1;u>=0;--u)if(i.charCodeAt(u)===y){if(!s){o=u+1;break}}else a===-1&&(s=!1,a=u+1);return a===-1?"":i.slice(o,a)},extname(i){w(i,"path");let l=-1,o=0,a=-1,s=!0,u=0;for(let r=i.length-1;r>=0;--r){const n=i.charCodeAt(r);if(n===y){if(!s){o=r+1;break}continue}a===-1&&(s=!1,a=r+1),n===A?l===-1?l=r:u!==1&&(u=1):l!==-1&&(u=-1)}return l===-1||a===-1||u===0||u===1&&l===a-1&&l===o+1?"":i.slice(l,a)},format:E.bind(null,"/"),parse(i){w(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const o=i.charCodeAt(0)===y;let a;o?(l.root="/",a=1):a=0;let s=-1,u=0,r=-1,n=!0,h=i.length-1,S=0;for(;h>=a;--h){const I=i.charCodeAt(h);if(I===y){if(!n){u=h+1;break}continue}r===-1&&(n=!1,r=h+1),I===A?s===-1?s=h:S!==1&&(S=1):s!==-1&&(S=-1)}if(r!==-1){const I=u===0&&o?1:u;s===-1||S===0||S===1&&s===r-1&&s===u+1?l.base=l.name=i.slice(I,r):(l.name=i.slice(I,s),l.base=i.slice(I,r),l.ext=i.slice(s,r))}return u>0?l.dir=i.slice(0,u-1):o&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[108],Ce([1,0,65,11]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new c.Lazy(()=>{const n=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:n,collatorIsNumeric:n.resolvedOptions().numeric}}),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(n,h,S=!1){const I=n||"",F=h||"",K=P.value.collator.compare(I,F);return P.value.collatorIsNumeric&&K===0&&I!==F?I<F?-1:1:K}e.compareFileNames=A;function y(n,h){const S=R.value.collator;return n=n||"",h=h||"",E(S,n,h)}e.compareFileNamesDefault=y;function C(n,h){const S=R.value.collator;return n=n||"",h=h||"",o(n,h)||E(S,n,h)}e.compareFileNamesUpper=C;function L(n,h){const S=R.value.collator;return n=n||"",h=h||"",l(n,h)||E(S,n,h)}e.compareFileNamesLower=L;function T(n,h){return n=n||"",h=h||"",n===h?0:n<h?-1:1}e.compareFileNamesUnicode=T;function v(n,h){const[S,I]=p(n),[F,K]=p(h);let q=P.value.collator.compare(I,K);if(q===0){if(P.value.collatorIsNumeric&&I!==K)return I<K?-1:1;if(q=P.value.collator.compare(S,F),P.value.collatorIsNumeric&&q===0&&S!==F)return S<F?-1:1}return q}e.compareFileExtensions=v;function D(n,h){n=n||"",h=h||"";const S=b(n),I=b(h),F=R.value.collator,K=k.value.collator;return E(K,S,I)||E(F,n,h)}e.compareFileExtensionsDefault=D;function w(n,h){n=n||"",h=h||"";const S=b(n),I=b(h),F=R.value.collator,K=k.value.collator;return E(K,S,I)||o(n,h)||E(F,n,h)}e.compareFileExtensionsUpper=w;function f(n,h){n=n||"",h=h||"";const S=b(n),I=b(h),F=R.value.collator,K=k.value.collator;return E(K,S,I)||l(n,h)||E(F,n,h)}e.compareFileExtensionsLower=f;function d(n,h){n=n||"",h=h||"";const S=b(n).toLowerCase(),I=b(h).toLowerCase();return S!==I?S<I?-1:1:n!==h?n<h?-1:1:0}e.compareFileExtensionsUnicode=d;const m=/^(.*?)(\.([^.]*))?$/;function p(n,h=!1){const S=n?m.exec(n):[];let I=[S&&S[1]||"",S&&S[3]||""];return h&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function b(n){const h=n?m.exec(n):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function E(n,h,S){const I=n.compare(h,S);return I!==0?I:h.length!==S.length?h.length<S.length?-1:1:0}function g(n){const h=n.charAt(0);return h.toLocaleUpperCase()!==h}function i(n){const h=n.charAt(0);return h.toLocaleLowerCase()!==h}function l(n,h){return g(n)&&i(h)?-1:i(n)&&g(h)?1:0}function o(n,h){return i(n)&&g(h)?-1:g(n)&&i(h)?1:0}function a(n,h,S=!1){return S||(n=n&&n.toLowerCase(),h=h&&h.toLowerCase()),n===h?0:n<h?-1:1}function s(n,h,S=!1){const I=n.split(t.sep),F=h.split(t.sep),K=I.length-1,q=F.length-1;let M,B;for(let O=0;;O++){if(M=K===O,B=q===O,M&&B)return A(I[O],F[O],S);if(M)return-1;if(B)return 1;const U=a(I[O],F[O],S);if(U!==0)return U}}e.comparePaths=s;function u(n,h,S){const I=n.toLowerCase(),F=h.toLowerCase(),K=r(n,h,S);if(K)return K;const q=I.endsWith(S),M=F.endsWith(S);if(q!==M)return q?-1:1;const B=A(I,F);return B!==0?B:I.localeCompare(F)}e.compareAnything=u;function r(n,h,S){const I=n.toLowerCase(),F=h.toLowerCase(),K=I.startsWith(S),q=F.startsWith(S);if(K!==q)return K?-1:1;if(K&&q){if(I.length<F.length)return-1;if(I.length>F.length)return 1}return 0}e.compareByPrefix=r}),define(ye[86],Ce([1,0,11]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const T=(0,c.extname)(L),v=t[T.toLowerCase()];return v!==void 0?v:k(L)}e.getMediaOrTextMime=R;function k(L){const T=(0,c.extname)(L);return P[T.toLowerCase()]}e.getMediaMime=k;function A(L){for(const T in P)if(P[T]===L)return T}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function C(L,T){const v=y.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:T?void 0:L}e.normalizeMimeType=C}),define(ye[109],Ce([1,0,12]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var P;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const C=y.reduce((v,D)=>(v[D]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(v=>!C[v]).forEach(v=>{for(let D=0;D<L.length;D++)if(v.search(L[D])!==-1){delete A[v];break}})}e.sanitizeProcessEnvironment=R;function k(A){!A||(delete A.DEBUG,c.isMacintosh&&delete A.DYLD_LIBRARY_PATH,c.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(ye[44],Ce([1,0,12]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class P{static create(k=!0){return new P(k)}constructor(k){this.a=t&&k,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=P}),define(ye[3],Ce([1,0,9,63,6,66,44]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var C;(function(u){u.None=()=>P.Disposable.None;function r(Ee){if(y){const{onDidAddListener:Pe}=Ee,Fe=w.create();let se=0;Ee.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Fe.print()),Pe?.()}}}function n(Ee,Pe){return O(Ee,()=>{},0,void 0,void 0,Pe)}u.defer=n;function h(Ee){return(Pe,Fe=null,se)=>{let oe=!1,fe;return fe=Ee(Z=>{if(!oe)return fe?fe.dispose():oe=!0,Pe.call(Fe,Z)},null,se),oe&&fe.dispose(),fe}}u.once=h;function S(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>se.call(oe,Pe(Z)),null,fe),Fe)}u.map=S;function I(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>{Pe(Z),se.call(oe,Z)},null,fe),Fe)}u.forEach=I;function F(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>Pe(Z)&&se.call(oe,Z),null,fe),Fe)}u.filter=F;function K(Ee){return Ee}u.signal=K;function q(...Ee){return(Pe,Fe=null,se)=>(0,P.combinedDisposable)(...Ee.map(oe=>oe(fe=>Pe.call(Fe,fe),null,se)))}u.any=q;function M(Ee,Pe,Fe,se){let oe=Fe;return S(Ee,fe=>(oe=Pe(oe,fe),oe),se)}u.reduce=M;function B(Ee,Pe){let Fe;const se={onWillAddFirstListener(){Fe=Ee(oe.fire,oe)},onDidRemoveLastListener(){Fe?.dispose()}};Pe||r(se);const oe=new d(se);return Pe?.add(oe),oe.event}function O(Ee,Pe,Fe=100,se=!1,oe,fe){let Z,ce,ne,N=0;const H={leakWarningThreshold:oe,onWillAddFirstListener(){Z=Ee(Y=>{N++,ce=Pe(ce,Y),se&&!ne&&(Q.fire(ce),ce=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=ce;ce=void 0,ne=void 0,(!se||N>1)&&Q.fire(he),N=0},Fe)})},onDidRemoveLastListener(){Z.dispose()}};fe||r(H);const Q=new d(H);return fe?.add(Q),Q.event}u.debounce=O;function U(Ee,Pe=0,Fe){return u.debounce(Ee,(se,oe)=>se?(se.push(oe),se):[oe],Pe,void 0,void 0,Fe)}u.accumulate=U;function z(Ee,Pe=(se,oe)=>se===oe,Fe){let se=!0,oe;return F(Ee,fe=>{const Z=se||!Pe(fe,oe);return se=!1,oe=fe,Z},Fe)}u.latch=z;function j(Ee,Pe,Fe){return[u.filter(Ee,Pe,Fe),u.filter(Ee,se=>!Pe(se),Fe)]}u.split=j;function ue(Ee,Pe=!1,Fe=[]){let se=Fe.slice(),oe=Ee(ce=>{se?se.push(ce):Z.fire(ce)});const fe=()=>{se?.forEach(ce=>Z.fire(ce)),se=null},Z=new d({onWillAddFirstListener(){oe||(oe=Ee(ce=>Z.fire(ce)))},onDidAddFirstListener(){se&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){oe&&oe.dispose(),oe=null}});return Z.event}u.buffer=ue;class V{constructor(Pe){this.event=Pe,this.c=new P.DisposableStore}map(Pe){return new V(S(this.event,Pe,this.c))}forEach(Pe){return new V(I(this.event,Pe,this.c))}filter(Pe){return new V(F(this.event,Pe,this.c))}reduce(Pe,Fe){return new V(M(this.event,Pe,Fe,this.c))}latch(){return new V(z(this.event,void 0,this.c))}debounce(Pe,Fe=100,se=!1,oe){return new V(O(this.event,Pe,Fe,se,oe,this.c))}on(Pe,Fe,se){return this.event(Pe,Fe,se)}once(Pe,Fe,se){return h(this.event)(Pe,Fe,se)}dispose(){this.c.dispose()}}function _(Ee){return new V(Ee)}u.chain=_;function J(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.on(Pe,se),fe=()=>Ee.removeListener(Pe,se),Z=new d({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}u.fromNodeEventEmitter=J;function ie(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.addEventListener(Pe,se),fe=()=>Ee.removeEventListener(Pe,se),Z=new d({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}u.fromDOMEventEmitter=ie;function ee(Ee){return new Promise(Pe=>h(Ee)(Pe))}u.toPromise=ee;function X(Ee,Pe){return Pe(void 0),Ee(Fe=>Pe(Fe))}u.runAndSubscribe=X;function G(Ee,Pe){let Fe=null;function se(fe){Fe?.dispose(),Fe=new P.DisposableStore,Pe(fe,Fe)}se(void 0);const oe=Ee(fe=>se(fe));return(0,P.toDisposable)(()=>{oe.dispose(),Fe?.dispose()})}u.runAndSubscribeWithStore=G;class de{constructor(Pe,Fe){this.obs=Pe,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Fe||r(se),this.emitter=new d(se),Fe&&Fe.add(this.emitter)}beginUpdate(Pe){this.c++}handleChange(Pe,Fe){this.d=!0}endUpdate(Pe){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function be(Ee,Pe){return new de(Ee,Pe).emitter.event}u.fromObservable=be})(C=e.Event||(e.Event={}));class L{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${L.c++}`,L.all.add(this)}start(r){this.d=new k.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let T=-1;function v(u){const r=T;return T=u,{dispose(){T=r}}}e.setGlobalLeakWarningThreshold=v;class D{constructor(r,n=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=n,this.d=0}dispose(){this.c?.clear()}check(r,n){const h=this.threshold;if(h<=0||n<h)return;this.c||(this.c=new Map);const S=this.c.get(r.value)||0;if(this.c.set(r.value,S+1),this.d-=1,this.d<=0){this.d=h*.5;let I,F=0;for(const[K,q]of this.c)(!I||F<q)&&(I=K,F=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${F}):`),console.warn(I)}return()=>{const I=this.c.get(r.value)||0;this.c.set(r.value,I-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(r,n,h){this.callback=r,this.callbackThis=n,this.stack=h,this.subscription=new P.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class d{constructor(r){this.j=!1,this.d=r,this.f=T>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const r=Array.from(this.q);queueMicrotask(()=>{for(const n of r)n.subscription.isset()&&(n.subscription.unset(),n.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,n,h)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.Disposable.None;const S=this.q.isEmpty();S&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let I,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=w.create(),I=this.f.check(F,this.q.size+1)),A&&(F=F??w.create());const K=new f(r,n,F),q=this.q.push(K);S&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,n);const M=K.subscription.set(()=>{I?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return h instanceof P.DisposableStore?h.add(M):Array.isArray(h)&&h.push(M),M}),this.l}fire(r){if(this.q){this.m||(this.m=new p);for(const n of this.q)this.m.push(this,n,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class m{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(r,n,h){this.c.push(new b(r,n,h))}clear(r){const n=new R.LinkedList;for(const h of this.c)h.emitter!==r&&n.push(h);this.c=n}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(n){(0,c.onUnexpectedError)(n)}}}}e.EventDeliveryQueue=m;class p extends m{clear(r){this.c.clear()}}class b{constructor(r,n,h){this.emitter=r,this.listener=n,this.event=h}}class E extends d{async fireAsync(r,n,h){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const S of this.q)this.c.push([S,r]);for(;this.c.size>0&&!n.isCancellationRequested;){const[S,I]=this.c.shift(),F=[],K={...I,token:n,waitUntil:q=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");h&&(q=h(q,S.callback)),F.push(q)}};try{S.invoke(K)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(F),await Promise.allSettled(F).then(q=>{for(const M of q)M.status==="rejected"&&(0,c.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=E;class g extends d{constructor(r){super(r),this.h=0,this.s=new R.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=g;class i extends g{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=i;class l extends d{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(n=>super.fire(n)),this.c=[]}))}}e.MicrotaskEmitter=l;class o{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const n={event:r,listener:null};this.f.push(n),this.d&&this.j(n);const h=()=>{this.d&&this.k(n);const S=this.f.indexOf(n);this.f.splice(S,1)};return(0,P.toDisposable)((0,t.once)(h))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(n=>this.c.fire(n))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=o;class a{constructor(){this.c=[]}wrapEvent(r){return(n,h,S)=>r(I=>{const F=this.c[this.c.length-1];F?F.push(()=>n.call(h,I)):n.call(h,I)},void 0,S)}bufferEvents(r){const n=[];this.c.push(n);const h=r();return this.c.pop(),n.forEach(S=>S()),h}}e.EventBufferer=a;class s{constructor(){this.c=!1,this.d=C.None,this.f=P.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(ye[160],Ce([1,0,3,6,155]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends t.Disposable{constructor(v,D="",w="",f=!0,d){super(),this.h=this.B(new c.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=D,this.u=w,this.w=f,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,D){this.C&&await this.C(v)}}e.Action=R;class k extends t.Disposable{constructor(){super(...arguments),this.f=this.B(new c.Emitter),this.onWillRun=this.f.event,this.h=this.B(new c.Emitter),this.onDidRun=this.h.event}async run(v,D){if(!v.enabled)return;this.f.fire({action:v});let w;try{await this.runAction(v,D)}catch(f){w=f}this.h.fire({action:v,error:w})}async runAction(v,D){await v.run(D)}}e.ActionRunner=k;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let D=[];for(const w of v)w.length&&(D.length?D=[...D,new A,...w]:D=w);return D}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(v,D,w,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=D,this.class=f,this.a=w}async run(){}}e.SubmenuAction=y;class C extends R{constructor(){super(C.ID,P.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=C,C.ID="vs.actions.empty";function L(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label}}e.toAction=L}),define(ye[21],Ce([1,0,3]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,y){const C=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(C)}}});var P;(function(A){function y(C){return C===A.None||C===A.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=P.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=P.None}}e.CancellationTokenSource=k}),define(ye[161],Ce([1,0,21]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new c.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class P{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=P;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[8],Ce([1,0,161,65]),function(te,e,c,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const k=/{(\d+)}/g;function A($,...le){return le.length===0?$:$.replace(k,function(Ie,Le){const $e=parseInt(Le,10);return isNaN($e)||$e<0||$e>=le.length?Ie:le[$e]})}e.format=A;const y=/{([^}]+)}/g;function C($,le){return $.replace(y,(Ie,Le)=>le[Le]??Ie)}e.format2=C;function L($){return $.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=L;function T($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function v($,le){let Ie=0;const Le=le.charCodeAt(0);for(let $e=$.length-1;$e>=0;$e--)$.charCodeAt($e)===Le&&Ie++;return Ie}e.count=v;function D($,le,Ie="\u2026"){return $.length<=le?$:`${$.substr(0,le)}${Ie}`}e.truncate=D;function w($,le=" "){const Ie=f($,le);return d(Ie,le)}e.trim=w;function f($,le){if(!$||!le)return $;const Ie=le.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(le,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=f;function d($,le){if(!$||!le)return $;const Ie=le.length,Le=$.length;if(Ie===0||Le===0)return $;let $e=Le,Xe=-1;for(;Xe=$.lastIndexOf(le,$e-1),!(Xe===-1||Xe+Ie!==$e);){if(Xe===0)return"";$e=Xe}return $.substring(0,$e)}e.rtrim=d;function m($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function p($){return $.replace(/\*/g,"")}e.stripWildcards=p;function b($,le,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");le||($=T($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=b;function E($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function g($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function l($){return $.split(/\r\n|\r|\n/)}e.splitLines=l;function o($){for(let le=0,Ie=$.length;le<Ie;le++){const Le=$.charCodeAt(le);if(Le!==32&&Le!==9)return le}return-1}e.firstNonWhitespaceIndex=o;function a($,le=0,Ie=$.length){for(let Le=le;Le<Ie;Le++){const $e=$.charCodeAt(Le);if($e!==32&&$e!==9)return $.substring(le,Le)}return $.substring(le,Ie)}e.getLeadingWhitespace=a;function s($,le=$.length-1){for(let Ie=le;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=s;function u($,le,Ie){const Le=[];let $e=0;for(const Xe of $.matchAll(le)){if(Le.push($.slice($e,Xe.index)),Xe.index===void 0)throw new Error("match.index should be defined");$e=Xe.index+Xe[0].length,Le.push(Ie(Xe[0],...Xe.slice(1),Xe.index,$,Xe.groups))}return Le.push($.slice($e)),Promise.all(Le).then(Xe=>Xe.join(""))}e.replaceAsync=u;function r($,le){return $<le?-1:$>le?1:0}e.compare=r;function n($,le,Ie=0,Le=$.length,$e=0,Xe=le.length){for(;Ie<Le&&$e<Xe;Ie++,$e++){const mt=$.charCodeAt(Ie),ct=le.charCodeAt($e);if(mt<ct)return-1;if(mt>ct)return 1}const Ze=Le-Ie,pt=Xe-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstring=n;function h($,le){return S($,le,0,$.length,0,le.length)}e.compareIgnoreCase=h;function S($,le,Ie=0,Le=$.length,$e=0,Xe=le.length){for(;Ie<Le&&$e<Xe;Ie++,$e++){let mt=$.charCodeAt(Ie),ct=le.charCodeAt($e);if(mt===ct)continue;if(mt>=128||ct>=128)return n($.toLowerCase(),le.toLowerCase(),Ie,Le,$e,Xe);F(mt)&&(mt-=32),F(ct)&&(ct-=32);const Et=mt-ct;if(Et!==0)return Et}const Ze=Le-Ie,pt=Xe-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstringIgnoreCase=S;function I($){return $>=48&&$<=57}e.isAsciiDigit=I;function F($){return $>=97&&$<=122}e.isLowerAsciiLetter=F;function K($){return $>=65&&$<=90}e.isUpperAsciiLetter=K;function q($,le){return $.length===le.length&&S($,le)===0}e.equalsIgnoreCase=q;function M($,le){const Ie=le.length;return le.length>$.length?!1:S($,le,0,Ie)===0}e.startsWithIgnoreCase=M;function B($,le){const Ie=Math.min($.length,le.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==le.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=B;function O($,le){const Ie=Math.min($.length,le.length);let Le;const $e=$.length-1,Xe=le.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt($e-Le)!==le.charCodeAt(Xe-Le))return Le;return Ie}e.commonSuffixLength=O;function U($){return 55296<=$&&$<=56319}e.isHighSurrogate=U;function z($){return 56320<=$&&$<=57343}e.isLowSurrogate=z;function j($,le){return($-55296<<10)+(le-56320)+65536}e.computeCodePoint=j;function ue($,le,Ie){const Le=$.charCodeAt(Ie);if(U(Le)&&Ie+1<le){const $e=$.charCodeAt(Ie+1);if(z($e))return j(Le,$e)}return Le}e.getNextCodePoint=ue;function V($,le){const Ie=$.charCodeAt(le-1);if(z(Ie)&&le>1){const Le=$.charCodeAt(le-2);if(U(Le))return j(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(le,Ie=0){this.c=le,this.d=le.length,this.e=Ie}setOffset(le){this.e=le}prevCodePoint(){const le=V(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=ue(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=_;class J{get offset(){return this.c.offset}constructor(le,Ie=0){this.c=new _(le,Ie)}nextGraphemeLength(){const le=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=le.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Xe=Ie.offset,Ze=le.getGraphemeBreakType(Ie.nextCodePoint());if(Ve($e,Ze)){Ie.setOffset(Xe);break}$e=Ze}return Ie.offset-Le}prevGraphemeLength(){const le=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=le.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Xe=Ie.offset,Ze=le.getGraphemeBreakType(Ie.prevCodePoint());if(Ve(Ze,$e)){Ie.setOffset(Xe);break}$e=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ie($,le){return new J($,le).nextGraphemeLength()}e.nextCharLength=ie;function ee($,le){return new J($,le).prevGraphemeLength()}e.prevCharLength=ee;function X($,le){le>0&&z($.charCodeAt(le))&&le--;const Ie=le+ie($,le);return[Ie-ee($,Ie),Ie]}e.getCharContainingOffset=X;function G($){const le=new J($);let Ie=0;for(;!le.eol();)Ie++,le.nextGraphemeLength();return Ie}e.charCount=G;let de;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee($){return de||(de=be()),de.test($)}e.containsRTL=Ee;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Fe($){return Pe.test($)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function oe($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=oe;function fe($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=fe;function Z($,le){if($.length<le)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<le);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=Z;const ce=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function H($){return $&&($=$.replace(ce,""),$=$.replace(ne,""),$=$.replace(N,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function Y($){return Q($)?$.substr(1):$}e.stripUTF8BOM=Y;function he($,le){if(!$||!le||$.length<le.length)return!1;const Ie=le.length,Le=$.toLowerCase();let $e=0,Xe=-1;for(;$e<Ie;){const Ze=Le.indexOf(le[$e],Xe+1);if(Ze<0)return!1;Xe=Ze,$e++}return!0}e.fuzzyContains=he;function we($,le=!1){return $?(le&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=we;function Ae($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Ae;function pe($,le=1){if(le===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),le--;while(le>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function De($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=De;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function Ve($,le){return $===0?le!==5&&le!==7:$===2&&le===3?!1:$===4||$===2||$===3||le===4||le===2||le===3?!0:!($===8&&(le===8||le===9||le===11||le===12)||($===11||$===9)&&(le===9||le===10)||($===12||$===10)&&le===10||le===5||le===13||le===7||$===1||$===13&&le===14||$===6&&le===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const Ie=this.d,Le=Ie.length/3;let $e=1;for(;$e<=Le;)if(le<Ie[3*$e])$e=2*$e;else if(le>Ie[3*$e+1])$e=2*$e+1;else return Ie[3*$e+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,le){if($===0)return 0;const Ie=st($,le);if(Ie!==void 0)return Ie;const Le=new _(le,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,le){const Ie=new _(le,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let $e=Ie.offset;return $e>0&&Ie.prevCodePoint()===8205&&($e=Ie.offset),$e}function ht($){return 127995<=$&&$<=127999}var Me;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class rt{static getInstance(le){return rt.d.get(Array.from(le))}static getLocales(){return rt.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=rt,P=rt,rt.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),rt.d=new c.LRUCachedFunction($=>{function le(ct){const Et=new Map;for(let tt=0;tt<ct.length;tt+=2)Et.set(ct[tt],ct[tt+1]);return Et}function Ie(ct,Et){const tt=new Map(ct);for(const[ft,At]of Et)tt.set(ft,At);return tt}function Le(ct,Et){if(!ct)return Et;const tt=new Map;for(const[ft,At]of ct)Et.has(ft)&&tt.set(ft,At);return tt}const $e=P.c.value;let Xe=$.filter(ct=>!ct.startsWith("_")&&ct in $e);Xe.length===0&&(Xe=["_default"]);let Ze;for(const ct of Xe){const Et=le($e[ct]);Ze=Le(Ze,Et)}const pt=le($e._common),mt=Ie(pt,Ze);return new rt(mt)}),rt.e=new t.Lazy(()=>Object.keys(rt.c.value).filter($=>!$.startsWith("_")));class ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ae.c())),this.d}static isInvisibleCharacter(le){return ae.e().has(le)}static get codePoints(){return ae.e()}}e.InvisibleCharacters=ae,ae.d=void 0}),define(ye[32],Ce([1,0,11,12,8,10]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function A(s){return s.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=A;function y(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function C(s,u=c.posix.sep){if(!s)return"";const r=s.length,n=s.charCodeAt(0);if(k(n)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let S=3;const I=S;for(;S<r&&!k(s.charCodeAt(S));S++);if(I!==S&&!k(s.charCodeAt(S+1))){for(S+=1;S<r;S++)if(k(s.charCodeAt(S)))return s.slice(0,S+1).replace(/[\\/]/g,u)}}return u}else if(m(n)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(k(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=C;function L(s){if(!t.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let r=2;const n=r;for(;r<s.length&&(u=s.charCodeAt(r),u!==92);r++);return!(n===r||(u=s.charCodeAt(r+1),isNaN(u)||u===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(s,u=t.isWindows){const r=u?T:v;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||u&&D.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=w;function f(s,u,r){const n=s===u;return!r||n?n:!s||!u?!1:(0,P.equalsIgnoreCase)(s,u)}e.isEqual=f;function d(s,u,r,n=c.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(r){if(!(0,P.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let S=u.length;return u.charAt(u.length-1)===n&&S--,s.charAt(S)===n}return u.charAt(u.length-1)!==n&&(u+=n),s.indexOf(u)===0}e.isEqualOrParent=d;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function p(s,u){return t.isWindows&&s.endsWith(":")&&(s+=c.sep),(0,c.isAbsolute)(s)||(s=(0,c.join)(u,s)),s=(0,c.normalize)(s),t.isWindows?(s=(0,P.rtrim)(s,c.sep),s.endsWith(":")&&(s+=c.sep)):(s=(0,P.rtrim)(s,c.sep),s||(s=c.sep)),s}e.sanitizeFilePath=p;function b(s){const u=(0,c.normalize)(s);return t.isWindows?s.length>3?!1:E(u)&&(s.length===2||u.charCodeAt(2)===92):u===c.posix.sep}e.isRootOrDriveLetter=b;function E(s,u=t.isWindows){return u?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function g(s){return E(s)?s[0]:void 0}e.getDriveLetter=g;function i(s,u,r){return u.length>s.length?-1:s===u?0:(r&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=i;function l(s){const u=s.split(":");let r,n,h;for(const S of u){const I=Number(S);(0,R.isNumber)(I)?n===void 0?n=I:h===void 0&&(h=I):r=r?[r,S].join(":"):S}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:n!==void 0?n:void 0,column:h!==void 0?h:n!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(s,u,r=8){let n="";for(let S=0;S<r;S++)n+=o.charAt(Math.floor(Math.random()*o.length));let h;return u?h=`${u}-${n}`:h=n,s?(0,c.join)(s,h):h}e.randomPath=a}),define(ye[110],Ce([1,0,28,8]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...ne){return function(N,H){for(let Q=0,Y=ne.length;Q<Y;Q++){const he=ne[Q](N,H);if(he)return he}return null}}e.or=P,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ne,N,H){if(!H||H.length<N.length)return null;let Q;return ne?Q=t.startsWithIgnoreCase(H,N):Q=H.indexOf(N)===0,Q?N.length>0?[{start:0,end:N.length}]:[]:null}function k(ne,N){const H=N.toLowerCase().indexOf(ne.toLowerCase());return H===-1?null:[{start:H,end:H+ne.length}]}e.matchesContiguousSubString=k;function A(ne,N){return y(ne.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=A;function y(ne,N,H,Q){if(H===ne.length)return[];if(Q===N.length)return null;if(ne[H]===N[Q]){let Y=null;return(Y=y(ne,N,H+1,Q+1))?m({start:Q,end:Q+1},Y):null}return y(ne,N,H,Q+1)}function C(ne){return 97<=ne&&ne<=122}function L(ne){return 65<=ne&&ne<=90}e.isUpper=L;function T(ne){return 48<=ne&&ne<=57}function v(ne){return ne===32||ne===9||ne===10||ne===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>D.add(ne.charCodeAt(0)));function w(ne){return v(ne)||D.has(ne)}function f(ne,N){return ne===N||w(ne)&&w(N)}function d(ne){return C(ne)||L(ne)||T(ne)}function m(ne,N){return N.length===0?N=[ne]:ne.end===N[0].start?N[0].start=ne.start:N.unshift(ne),N}function p(ne,N){for(let H=N;H<ne.length;H++){const Q=ne.charCodeAt(H);if(L(Q)||T(Q)||H>0&&!d(ne.charCodeAt(H-1)))return H}return ne.length}function b(ne,N,H,Q){if(H===ne.length)return[];if(Q===N.length)return null;if(ne[H]!==N[Q].toLowerCase())return null;{let Y=null,he=Q+1;for(Y=b(ne,N,H+1,Q+1);!Y&&(he=p(N,he))<N.length;)Y=b(ne,N,H+1,he),he++;return Y===null?null:m({start:Q,end:Q+1},Y)}}function E(ne){let N=0,H=0,Q=0,Y=0,he=0;for(let ke=0;ke<ne.length;ke++)he=ne.charCodeAt(ke),L(he)&&N++,C(he)&&H++,d(he)&&Q++,T(he)&&Y++;const we=N/ne.length,Ae=H/ne.length,pe=Q/ne.length,De=Y/ne.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:pe,numericPercent:De}}function g(ne){const{upperPercent:N,lowerPercent:H}=ne;return H===0&&N>.6}function i(ne){const{upperPercent:N,lowerPercent:H,alphaPercent:Q,numericPercent:Y}=ne;return H>.2&&N<.8&&Q>.6&&Y<.2}function l(ne){let N=0,H=0,Q=0,Y=0;for(let he=0;he<ne.length;he++)Q=ne.charCodeAt(he),L(Q)&&N++,C(Q)&&H++,v(Q)&&Y++;return(N===0||H===0)&&Y===0?ne.length<=30:N<=5}function o(ne,N){if(!N||(N=N.trim(),N.length===0)||!l(ne)||N.length>60)return null;const H=E(N);if(!i(H)){if(!g(H))return null;N=N.toLowerCase()}let Q=null,Y=0;for(ne=ne.toLowerCase();Y<N.length&&(Q=b(ne,N,0,Y))===null;)Y=p(N,Y+1);return Q}e.matchesCamelCase=o;function a(ne,N,H=!1){if(!N||N.length===0)return null;let Q=null,Y=0;for(ne=ne.toLowerCase(),N=N.toLowerCase();Y<N.length&&(Q=s(ne,N,0,Y,H))===null;)Y=u(N,Y+1);return Q}e.matchesWords=a;function s(ne,N,H,Q,Y){if(H===ne.length)return[];if(Q===N.length)return null;if(f(ne.charCodeAt(H),N.charCodeAt(Q))){let he=null,we=Q+1;if(he=s(ne,N,H+1,Q+1,Y),!Y)for(;!he&&(we=u(N,we))<N.length;)he=s(ne,N,H+1,we,Y),we++;return he?ne.charCodeAt(H)!==N.charCodeAt(Q)?he:m({start:Q,end:Q+1},he):null}else return null}function u(ne,N){for(let H=N;H<ne.length;H++)if(w(ne.charCodeAt(H))||H>0&&w(ne.charCodeAt(H-1)))return H;return ne.length}const r=P(e.matchesPrefix,o,k),n=P(e.matchesPrefix,o,A),h=new c.LRUCache(1e4);function S(ne,N,H=!1){if(typeof ne!="string"||typeof N!="string")return null;let Q=h.get(ne);Q||(Q=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),h.set(ne,Q));const Y=Q.exec(N);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:H?n(ne,N):r(ne,N)}e.matchesFuzzy=S;function I(ne,N){const H=Pe(ne,ne.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?K(H):null}e.matchesFuzzy2=I;function F(ne,N,H,Q,Y,he){const we=Math.min(13,ne.length);for(;H<we;H++){const Ae=Pe(ne,N,H,Q,Y,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=F;function K(ne){if(typeof ne>"u")return[];const N=[],H=ne[1];for(let Q=ne.length-1;Q>1;Q--){const Y=ne[Q]+H,he=N[N.length-1];he&&he.end===Y?he.end=Y+1:N.push({start:Y,end:Y+1})}return N}e.createMatches=K;const q=128;function M(){const ne=[],N=[];for(let H=0;H<=q;H++)N[H]=0;for(let H=0;H<=q;H++)ne.push(N.slice(0));return ne}function B(ne){const N=[];for(let H=0;H<=ne;H++)N[H]=0;return N}const O=B(2*q),U=B(2*q),z=M(),j=M(),ue=M(),V=!1;function _(ne,N,H,Q,Y){function he(Ae,pe,De=" "){for(;Ae.length<pe;)Ae=De+Ae;return Ae}let we=` |   |${Q.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?we+=" |":we+=`${N[Ae-1]}|`,we+=ne[Ae].slice(0,Y+1).map(pe=>he(pe.toString(),3)).join("|")+`
`;return we}function J(ne,N,H,Q){ne=ne.substr(N),H=H.substr(Q),console.log(_(j,ne,ne.length,H,H.length)),console.log(_(ue,ne,ne.length,H,H.length)),console.log(_(z,ne,ne.length,H,H.length))}function ie(ne,N){if(N<0||N>=ne.length)return!1;const H=ne.codePointAt(N);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function ee(ne,N){if(N<0||N>=ne.length)return!1;switch(ne.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function X(ne,N,H){return N[ne]!==H[ne]}function G(ne,N,H,Q,Y,he,we=!1){for(;N<H&&Y<he;)ne[N]===Q[Y]&&(we&&(O[N]=Y),N+=1),Y+=1;return N===H}e.isPatternInWord=G;var de;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(de||(de={}));var be;(function(ne){ne.Default=[-100,0];function N(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ne.isDefault=N})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(N,H){this.firstMatchCanBeWeak=N,this.boostFullMatch=H}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Pe(ne,N,H,Q,Y,he,we=Ee.default){const Ae=ne.length>q?q:ne.length,pe=Q.length>q?q:Q.length;if(H>=Ae||he>=pe||Ae-H>pe-he||!G(N,H,Ae,Y,he,pe,!0))return;Fe(Ae,pe,H,he,N,Y);let De=1,ke=1,Ve=H,Ge=he;const et=[!1];for(De=1,Ve=H;Ve<Ae;De++,Ve++){const Me=O[Ve],rt=U[Ve],ae=Ve+1<Ae?U[Ve+1]:pe;for(ke=Me-he+1,Ge=Me;Ge<ae;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,le=!1;Ge<=rt&&($=se(ne,N,Ve,H,Q,Y,Ge,pe,he,z[De-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(le=!0,Ie=$+j[De-1][ke-1]);const Le=Ge>Me,$e=Le?j[De][ke-1]+(z[De][ke-1]>0?-5:0):0,Xe=Ge>Me+1&&z[De][ke-1]>0,Ze=Xe?j[De][ke-2]+(z[De][ke-2]>0?-5:0):0;if(Xe&&(!Le||Ze>=$e)&&(!le||Ze>=Ie))j[De][ke]=Ze,ue[De][ke]=3,z[De][ke]=0;else if(Le&&(!le||$e>=Ie))j[De][ke]=$e,ue[De][ke]=2,z[De][ke]=0;else if(le)j[De][ke]=Ie,ue[De][ke]=1,z[De][ke]=z[De-1][ke-1]+1;else throw new Error("not possible")}}if(V&&J(ne,H,Q,he),!et[0]&&!we.firstMatchCanBeWeak)return;De--,ke--;const Qe=[j[De][ke],he];let nt=0,st=0;for(;De>=1;){let Me=ke;do{const rt=ue[De][Me];if(rt===3)Me=Me-2;else if(rt===2)Me=Me-1;else break}while(Me>=1);nt>1&&N[H+De-1]===Y[he+ke-1]&&!X(Me+he-1,Q,Y)&&nt+1>z[De][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),De--,ke=Me-1,Qe.push(ke)}pe===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=Pe;function Fe(ne,N,H,Q,Y,he){let we=ne-1,Ae=N-1;for(;we>=H&&Ae>=Q;)Y[we]===he[Ae]&&(U[we]=Ae,we--),Ae--}function se(ne,N,H,Q,Y,he,we,Ae,pe,De,ke){if(N[H]!==he[we])return Number.MIN_SAFE_INTEGER;let Ve=1,Ge=!1;return we===H-Q?Ve=ne[H]===Y[we]?7:5:X(we,Y,he)&&(we===0||!X(we-1,Y,he))?(Ve=ne[H]===Y[we]?7:5,Ge=!0):ie(he,we)&&(we===0||!ie(he,we-1))?Ve=5:(ie(he,we-1)||ee(he,we-1))&&(Ve=5,Ge=!0),Ve>1&&H===Q&&(ke[0]=!0),Ge||(Ge=X(we,Y,he)||ie(he,we-1)||ee(he,we-1)),H===Q?we>pe&&(Ve-=Ge?3:5):De?Ve+=Ge?2:0:Ve+=Ge?0:1,we+1===Ae&&(Ve-=Ge?3:5),Ve}function oe(ne,N,H,Q,Y,he,we){return Z(ne,N,H,Q,Y,he,!0,we)}e.fuzzyScoreGracefulAggressive=oe;function fe(ne,N,H,Q,Y,he,we){return Z(ne,N,H,Q,Y,he,!1,we)}e.fuzzyScoreGraceful=fe;function Z(ne,N,H,Q,Y,he,we,Ae){let pe=Pe(ne,N,H,Q,Y,he,Ae);if(pe&&!we)return pe;if(ne.length>=3){const De=Math.min(7,ne.length-1);for(let ke=H+1;ke<De;ke++){const Ve=ce(ne,ke);if(Ve){const Ge=Pe(Ve,Ve.toLowerCase(),H,Q,Y,he,Ae);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ce(ne,N){if(N+1>=ne.length)return;const H=ne[N],Q=ne[N+1];if(H!==Q)return ne.slice(0,N)+Q+H+ne.slice(N+2)}}),define(ye[87],Ce([1,0,8]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return P(m,0)}e.hash=t;function P(m,p){switch(typeof m){case"object":return m===null?R(349,p):Array.isArray(m)?y(m,p):C(m,p);case"string":return A(m,p);case"boolean":return k(m,p);case"number":return R(m,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=P;function R(m,p){return(p<<5)-p+m|0}e.numberHash=R;function k(m,p){return R(m?433:863,p)}function A(m,p){p=R(149417,p);for(let b=0,E=m.length;b<E;b++)p=R(m.charCodeAt(b),p);return p}e.stringHash=A;function y(m,p){return p=R(104579,p),m.reduce((b,E)=>P(E,b),p)}function C(m,p){return p=R(181387,p),Object.keys(m).sort().reduce((b,E)=>(b=A(E,b),P(m[E],b)),p)}class L{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=P(p,this.g),this.g}}e.Hasher=L;var T;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function v(m,p,b=32){const E=b-p,g=~((1<<E)-1);return(m<<p|(g&m)>>>E)>>>0}function D(m,p=0,b=m.byteLength,E=0){for(let g=0;g<b;g++)m[p+g]=E}function w(m,p,b="0"){for(;m.length<p;)m=b+m;return m}function f(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(b=>b.toString(16).padStart(2,"0")).join(""):w((m>>>0).toString(16),p/4)}e.toHexString=f;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const E=this.p;let g=this.r,i=this.u,l,o;for(i!==0?(l=i,o=-1,i=0):(l=p.charCodeAt(0),o=0);;){let a=l;if(c.isHighSurrogate(l))if(o+1<b){const s=p.charCodeAt(o+1);c.isLowSurrogate(s)?(o++,a=c.computeCodePoint(l,s)):a=65533}else{i=l;break}else c.isLowSurrogate(l)&&(a=65533);if(g=this.w(E,g,a),o++,o<b)l=p.charCodeAt(o);else break}this.r=g,this.u=i}w(p,b,E){return E<128?p[b++]=E:E<2048?(p[b++]=192|(E&1984)>>>6,p[b++]=128|(E&63)>>>0):E<65536?(p[b++]=224|(E&61440)>>>12,p[b++]=128|(E&4032)>>>6,p[b++]=128|(E&63)>>>0):(p[b++]=240|(E&1835008)>>>18,p[b++]=128|(E&258048)>>>12,p[b++]=128|(E&4032)>>>6,p[b++]=128|(E&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=d.g,b=this.q;for(let r=0;r<64;r+=4)p.setUint32(r,b.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)p.setUint32(r,v(p.getUint32(r-12,!1)^p.getUint32(r-32,!1)^p.getUint32(r-56,!1)^p.getUint32(r-64,!1),1),!1);let E=this.h,g=this.l,i=this.m,l=this.n,o=this.o,a,s,u;for(let r=0;r<80;r++)r<20?(a=g&i|~g&l,s=1518500249):r<40?(a=g^i^l,s=1859775393):r<60?(a=g&i|g&l|i&l,s=2400959708):(a=g^i^l,s=3395469782),u=v(E,5)+a+o+s+p.getUint32(r*4,!1)&4294967295,o=l,l=i,i=v(g,30),g=E,E=u;this.h=this.h+E&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+o&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(ye[111],Ce([1,0,108,110,87,11,12,8]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,C=[y,[]];function L(z,j,ue,V){if(!z||!j)return C;const _=z.length,J=j.length;if(_<J)return C;const ie=z.toLowerCase();return T(j,ue,J,z,ie,_,V)}e.scoreFuzzy=L;function T(z,j,ue,V,_,J,ie){const ee=[],X=[];for(let Ee=0;Ee<ue;Ee++){const Pe=Ee*J,Fe=Pe-J,se=Ee>0,oe=z[Ee],fe=j[Ee];for(let Z=0;Z<J;Z++){const ce=Z>0,ne=Pe+Z,N=ne-1,H=Fe+Z-1,Q=ce?ee[N]:0,Y=se&&ce?ee[H]:0,he=se&&ce?X[H]:0;let we;!Y&&se?we=0:we=v(oe,fe,V,_,Z,he),we&&Y+we>=Q&&(ie||se||_.startsWith(j,Z))?(X[ne]=he+1,ee[ne]=Y+we):(X[ne]=y,ee[ne]=Q)}}const G=[];let de=ue-1,be=J-1;for(;de>=0&&be>=0;){const Ee=de*J+be;X[Ee]===y||(G.push(be),de--),be--}return[ee[ue*J-1],G.reverse()]}function v(z,j,ue,V,_,J){let ie=0;if(!D(j,V[_]))return ie;if(ie+=1,J>0&&(ie+=J*5),z===ue[_]&&(ie+=1),_===0)ie+=8;else{const ee=w(ue.charCodeAt(_-1));ee?ie+=ee:(0,t.isUpper)(ue.charCodeAt(_))&&J===0&&(ie+=2)}return ie}function D(z,j){return z===j?!0:z==="/"||z==="\\"?j==="/"||j==="\\":!1}function w(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(z,j,ue=0,V=0){const _=j;return _.values&&_.values.length>1?m(z,_.values,ue,V):p(z,j,ue,V)}e.scoreFuzzy2=d;function m(z,j,ue,V){let _=0;const J=[];for(const ie of j){const[ee,X]=p(z,ie,ue,V);if(typeof ee!="number")return f;_+=ee,J.push(...X)}return[_,n(J)]}function p(z,j,ue,V){const _=(0,t.fuzzyScore)(j.original,j.originalLowercase,ue,z,z.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,t.createMatches)(_)]:f}const b=Object.freeze({score:0}),E=1<<18,g=1<<17,i=1<<16;function l(z,j,ue,V){const _=V.values?V.values:[V];return(0,P.hash)({[V.normalized]:{values:_.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:z,description:j,allowNonContiguousMatches:ue}})}function o(z,j,ue,V,_){if(!z||!j.normalized)return b;const J=V.getItemLabel(z);if(!J)return b;const ie=V.getItemDescription(z),ee=l(J,ie,ue,j),X=_[ee];if(X)return X;const G=a(J,ie,V.getItemPath(z),j,ue);return _[ee]=G,G}e.scoreItemFuzzy=o;function a(z,j,ue,V,_){const J=!ue||!V.containsPathSeparator;return ue&&(k.isLinux?V.pathNormalized===ue:(0,A.equalsIgnoreCase)(V.pathNormalized,ue))?{score:E,labelMatch:[{start:0,end:z.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:V.values&&V.values.length>1?s(z,j,ue,V.values,J,_):u(z,j,ue,V,J,_)}function s(z,j,ue,V,_,J){let ie=0;const ee=[],X=[];for(const G of V){const{score:de,labelMatch:be,descriptionMatch:Ee}=u(z,j,ue,G,_,J);if(de===y)return b;ie+=de,be&&ee.push(...be),Ee&&X.push(...Ee)}return{score:ie,labelMatch:n(ee),descriptionMatch:n(X)}}function u(z,j,ue,V,_,J){if(_||!j){const[ie,ee]=L(z,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(ie){const X=(0,t.matchesPrefix)(V.normalized,z);let G;return X?(G=g,G+=Math.round(V.normalized.length/z.length*100)):G=i,{score:G+ie,labelMatch:X||r(ee)}}}if(j){let ie=j;ue&&(ie=`${j}${R.sep}`);const ee=ie.length,X=`${ie}${z}`,[G,de]=L(X,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(G){const be=r(de),Ee=[],Pe=[];return be.forEach(Fe=>{Fe.start<ee&&Fe.end>ee?(Ee.push({start:0,end:Fe.end-ee}),Pe.push({start:Fe.start,end:ee})):Fe.start>=ee?Ee.push({start:Fe.start-ee,end:Fe.end-ee}):Pe.push(Fe)}),{score:G,labelMatch:Ee,descriptionMatch:Pe}}}return b}function r(z){const j=[];if(!z)return j;let ue;for(const V of z)ue&&ue.end===V?ue.end+=1:(ue={start:V,end:V+1},j.push(ue));return j}function n(z){const j=z.sort((_,J)=>_.start-J.start),ue=[];let V;for(const _ of j)!V||!h(V,_)?(V=_,ue.push(_)):(V.start=Math.min(V.start,_.start),V.end=Math.max(V.end,_.end));return ue}function h(z,j){return!(z.end<j.start||j.end<z.start)}function S(z,j,ue,V,_,J){const ie=o(z,ue,V,_,J),ee=o(j,ue,V,_,J),X=ie.score,G=ee.score;if((X===E||G===E)&&X!==G)return X===E?-1:1;if(X>i||G>i){if(X!==G)return X>G?-1:1;if(X<g&&G<g){const oe=F(ie.labelMatch,ee.labelMatch);if(oe!==0)return oe}const Fe=_.getItemLabel(z)||"",se=_.getItemLabel(j)||"";if(Fe.length!==se.length)return Fe.length-se.length}if(X!==G)return X>G?-1:1;const de=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ee=I(z,ie,_),Pe=I(j,ee,_);return Ee&&Pe&&Ee!==Pe?Pe>Ee?-1:1:K(z,j,ue,_)}e.compareItemsByFuzzyScore=S;function I(z,j,ue){let V=-1,_=-1;if(j.descriptionMatch&&j.descriptionMatch.length?V=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(V=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(_=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=ue.getItemDescription(z);J&&(_+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(_=j.descriptionMatch[j.descriptionMatch.length-1].end);return _-V}function F(z,j){if(!z&&!j||(!z||!z.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!z||!z.length)return 1;const ue=z[0].start,_=z[z.length-1].end-ue,J=j[0].start,ee=j[j.length-1].end-J;return _===ee?0:ee<_?1:-1}function K(z,j,ue,V){const _=V.getItemLabel(z)||"",J=V.getItemLabel(j)||"",ie=V.getItemDescription(z),ee=V.getItemDescription(j),X=_.length+(ie?ie.length:0),G=J.length+(ee?ee.length:0);if(X!==G)return X-G;const de=V.getItemPath(z),be=V.getItemPath(j);return de&&be&&de.length!==be.length?de.length-be.length:_!==J?(0,c.compareAnything)(_,J,ue.normalized):ie&&ee&&ie!==ee?(0,c.compareAnything)(ie,ee,ue.normalized):de&&be&&de!==be?(0,c.compareAnything)(de,be,ue.normalized):0}function q(z){return z.startsWith('"')&&z.endsWith('"')}const M=" ";function B(z){typeof z!="string"&&(z="");const j=z.toLowerCase(),{pathNormalized:ue,normalized:V,normalizedLowercase:_}=O(z),J=ue.indexOf(R.sep)>=0,ie=q(z);let ee;const X=z.split(M);if(X.length>1)for(const G of X){const de=q(G),{pathNormalized:be,normalized:Ee,normalizedLowercase:Pe}=O(G);Ee&&(ee||(ee=[]),ee.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:be,normalized:Ee,normalizedLowercase:Pe,expectContiguousMatch:de}))}return{original:z,originalLowercase:j,pathNormalized:ue,normalized:V,normalizedLowercase:_,values:ee,containsPathSeparator:J,expectContiguousMatch:ie}}e.prepareQuery=B;function O(z){let j;k.isWindows?j=z.replace(/\//g,R.sep):j=z.replace(/\\/g,R.sep);const ue=(0,A.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function U(z){return Array.isArray(z)?B(z.map(j=>j.original).join(M)):B(z.original)}e.pieceToQuery=U}),define(ye[162],Ce([1,0,50,110,8]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",k=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${k.source}`,"g");function y(d){return d.replace(A,(m,p)=>p?m:`\\${m}`)}e.escapeIcons=y;const C=new RegExp(`\\\\${k.source}`,"g");function L(d){return d.replace(C,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function v(d){return d.indexOf(R)===-1?d:d.replace(T,(m,p,b,E)=>b?m:p||E||"")}e.stripIcons=v;const D=new RegExp(`\\$\\(${c.CSSIcon.iconNameCharacter}+\\)`,"g");function w(d){D.lastIndex=0;let m="";const p=[];let b=0;for(;;){const E=D.lastIndex,g=D.exec(d),i=d.substring(E,g?.index);if(i.length>0){m+=i;for(let l=0;l<i.length;l++)p.push(b)}if(!g)break;b+=g[0].length}return{text:m,iconOffsets:p}}e.parseLabelWithIcons=w;function f(d,m,p=!1){const{text:b,iconOffsets:E}=m;if(!E||E.length===0)return(0,t.matchesFuzzy)(d,b,p);const g=(0,P.ltrim)(b," "),i=b.length-g.length,l=(0,t.matchesFuzzy)(d,g,p);if(l)for(const o of l){const a=E[o.start+i]+i;o.start+=a,o.end+=a}return l}e.matchesFuzzyIconAware=f}),define(ye[38],Ce([1,0,8]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(t||(t={})),function(P){const R="error",k="warning",A="warn",y="info",C="ignore";function L(v){return v?c.equalsIgnoreCase(R,v)?P.Error:c.equalsIgnoreCase(k,v)||c.equalsIgnoreCase(A,v)?P.Warning:c.equalsIgnoreCase(y,v)?P.Info:P.Ignore:P.Ignore}P.fromValue=L;function T(v){switch(v){case P.Error:return R;case P.Warning:return k;case P.Info:return y;default:return C}}P.toString=T}(t||(t={})),e.default=t}),define(ye[67],Ce([1,0,16,8]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const w=D.charCodeAt(0),f=this.b.charCodeAt(this.c);return w-f}value(){return this.b[this.c]}}e.StringIterator=P;class R{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,t.compareSubstring)(D,this.b,0,D.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class k{constructor(D=!0,w=!0){this.f=D,this.g=w}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let w=D.length-1;w>=0;w--,this.c--){const f=this.b.charCodeAt(w);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,t.compareSubstring)(D,this.b,0,D.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var A;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(D,w){this.f=D,this.g=w,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(D,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,t.compare)(D,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class T{static forUris(D=()=>!1,w=()=>!1){return new T(new y(D,w))}static forPaths(D=!1){return new T(new k(void 0,!D))}static forStrings(){return new T(new P)}static forConfigKeys(){return new T(new R)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,w){if(w){const f=w.slice(0);(0,c.shuffle)(f);for(const d of f)this.set(d,D)}else{const f=D.slice(0);(0,c.shuffle)(f);for(const d of f)this.set(d[0],d[1])}}set(D,w){const f=this.b.reset(D);let d;this.c||(this.c=new C,this.c.segment=f.value());const m=[];for(d=this.c;;){const b=f.cmp(d.segment);if(b>0)d.left||(d.left=new C,d.left.segment=f.value()),m.push([-1,d]),d=d.left;else if(b<0)d.right||(d.right=new C,d.right.segment=f.value()),m.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new C,d.mid.segment=f.value()),m.push([0,d]),d=d.mid;else break}const p=d.value;d.value=w,d.key=D;for(let b=m.length-1;b>=0;b--){const E=m[b][1];E.updateHeight();const g=E.balanceFactor();if(g<-1||g>1){const i=m[b][0],l=m[b+1][0];if(i===1&&l===1)m[b][1]=E.rotateLeft();else if(i===-1&&l===-1)m[b][1]=E.rotateRight();else if(i===1&&l===-1)E.right=m[b+1][1]=m[b+1][1].rotateRight(),m[b][1]=E.rotateLeft();else if(i===-1&&l===1)E.left=m[b+1][1]=m[b+1][1].rotateLeft(),m[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(m[b-1][0]){case-1:m[b-1][1].left=m[b][1];break;case 1:m[b-1][1].right=m[b][1];break;case 0:m[b-1][1].mid=m[b][1];break}else this.c=m[0][1]}}return p}get(D){return this.d(D)?.value}d(D){const w=this.b.reset(D);let f=this.c;for(;f;){const d=w.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(w.hasNext())w.next(),f=f.mid;else break}return f}has(D){const w=this.d(D);return!(w?.value===void 0&&w?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,w){const f=this.b.reset(D),d=[];let m=this.c;for(;m;){const p=f.cmp(m.segment);if(p>0)d.push([-1,m]),m=m.left;else if(p<0)d.push([1,m]),m=m.right;else if(f.hasNext())f.next(),d.push([0,m]),m=m.mid;else break}if(!!m){if(w?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this.f(m.right);if(p.key){const{key:b,value:E,segment:g}=p;this.e(p.key,!1),m.key=b,m.value=E,m.segment=g}}else{const p=m.left??m.right;if(d.length>0){const[b,E]=d[d.length-1];switch(b){case-1:E.left=p;break;case 0:E.mid=p;break;case 1:E.right=p;break}}else this.c=p}for(let p=d.length-1;p>=0;p--){const b=d[p][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),d[p][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),d[p][1]=b.rotateRight()),p>0)switch(d[p-1][0]){case-1:d[p-1][1].left=d[p][1];break;case 1:d[p-1][1].right=d[p][1];break;case 0:d[p-1][1].mid=d[p][1];break}else this.c=d[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const w=this.b.reset(D);let f=this.c,d;for(;f;){const m=w.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(w.hasNext())w.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(D){return this.g(D,!1)}g(D,w){const f=this.b.reset(D);let d=this.c;for(;d;){const m=f.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):w?d.value:void 0}}hasElementOrSubtree(D){return this.g(D,!0)!==void 0}forEach(D){for(const[w,f]of this)D(f,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(D){const w=[];return this.j(D,w),w[Symbol.iterator]()}j(D,w){!D||(D.left&&this.j(D.left,w),D.value&&w.push([D.key,D.value]),D.mid&&this.j(D.mid,w),D.right&&this.j(D.right,w))}_isBalanced(){const D=w=>{if(!w)return!0;const f=w.balanceFactor();return f<-1||f>1?!1:D(w.left)&&D(w.right)};return D(this.c)}}e.TernarySearchTree=T}),define(ye[2],Ce([1,0,11,12]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,R=/^\//,k=/^\/\//;function A(o,a){if(!o.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!P.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!R.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,a){return!o&&!a?"file":o}function C(o,a){switch(o){case"https":case"http":case"file":a?a[0]!==T&&(a=T+a):a=T;break}return a}const L="",T="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(a){return a instanceof D?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,s,u,r,n,h=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=y(a,h),this.authority=s||L,this.path=C(this.scheme,u||L),this.query=r||L,this.fragment=n||L,A(this,h))}get fsPath(){return b(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:u,path:r,query:n,fragment:h}=a;return s===void 0?s=this.scheme:s===null&&(s=L),u===void 0?u=this.authority:u===null&&(u=L),r===void 0?r=this.path:r===null&&(r=L),n===void 0?n=this.query:n===null&&(n=L),h===void 0?h=this.fragment:h===null&&(h=L),s===this.scheme&&u===this.authority&&r===this.path&&n===this.query&&h===this.fragment?this:new f(s,u,r,n,h)}static parse(a,s=!1){const u=v.exec(a);return u?new f(u[2]||L,l(u[4]||L),l(u[5]||L),l(u[7]||L),l(u[9]||L),s):new f(L,L,L,L,L)}static file(a){let s=L;if(t.isWindows&&(a=a.replace(/\\/g,T)),a[0]===T&&a[1]===T){const u=a.indexOf(T,2);u===-1?(s=a.substring(2),a=T):(s=a.substring(2,u),a=a.substring(u)||T)}return new f("file",s,a,L,L)}static from(a){const s=new f(a.scheme,a.authority,a.path,a.query,a.fragment);return A(s,!0),s}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&a.scheme==="file"?u=D.file(c.win32.join(b(a,!0),...s)).path:u=c.posix.join(a.path,...s),a.with({path:u})}toString(a=!1){return E(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof D)return a;{const s=new f(a);return s._formatted=a.external,s._fsPath=a._sep===w?a.fsPath:null,s}}else return a}}e.URI=D;const w=t.isWindows?1:void 0;class f extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(a=!1){return a?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=w),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(o,a,s){let u,r=-1;for(let n=0;n<o.length;n++){const h=o.charCodeAt(n);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47||s&&h===91||s&&h===93||s&&h===58)r!==-1&&(u+=encodeURIComponent(o.substring(r,n)),r=-1),u!==void 0&&(u+=o.charAt(n));else{u===void 0&&(u=o.substr(0,n));const S=d[h];S!==void 0?(r!==-1&&(u+=encodeURIComponent(o.substring(r,n)),r=-1),u+=S):r===-1&&(r=n)}}return r!==-1&&(u+=encodeURIComponent(o.substring(r))),u!==void 0?u:o}function p(o){let a;for(let s=0;s<o.length;s++){const u=o.charCodeAt(s);u===35||u===63?(a===void 0&&(a=o.substr(0,s)),a+=d[u]):a!==void 0&&(a+=o[s])}return a!==void 0?a:o}function b(o,a){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?a?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=b;function E(o,a){const s=a?p:m;let u="",{scheme:r,authority:n,path:h,query:S,fragment:I}=o;if(r&&(u+=r,u+=":"),(n||r==="file")&&(u+=T,u+=T),n){let F=n.indexOf("@");if(F!==-1){const K=n.substr(0,F);n=n.substr(F+1),F=K.lastIndexOf(":"),F===-1?u+=s(K,!1,!1):(u+=s(K.substr(0,F),!1,!1),u+=":",u+=s(K.substr(F+1),!1,!0)),u+="@"}n=n.toLowerCase(),F=n.lastIndexOf(":"),F===-1?u+=s(n,!1,!0):(u+=s(n.substr(0,F),!1,!0),u+=n.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}u+=s(h,!0,!1)}return S&&(u+="?",u+=s(S,!1,!1)),I&&(u+="#",u+=a?I:m(I,!1,!1)),u}function g(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+g(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(o){return o.match(i)?o.replace(i,a=>g(a)):o}}),define(ye[68],Ce([1,0,22,8,2]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(C){return JSON.stringify(C,A)}e.stringify=R;function k(C){let L=JSON.parse(C);return L=y(L),L}e.parse=k;function A(C,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function y(C,L=0){if(!C||L>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return P.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof c.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let T=0;T<C.length;++T)C[T]=y(C[T],L+1);else for(const T in C)Object.hasOwnProperty.call(C,T)&&(C[T]=y(C[T],L+1))}return C}e.revive=y}),define(ye[17],Ce([1,0,9,12,2]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls",C.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,T,v){this.a[L]=T,this.b[L]=v}setConnectionToken(L,T){this.c[L]=T}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return c.onUnexpectedError(d),L}const T=L.authority;let v=this.a[T];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const D=this.b[T],w=this.c[T];let f=`path=${encodeURIComponent(L.path)}`;return typeof w=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),P.URI.from({scheme:t.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${D}`,path:this.f,query:f})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(L){const T=this.b(L,te);return this.uriToBrowserUri(T)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${R.vscodeFileResource}://${A.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||A.a,query:null,fragment:null}):L}asFileUri(L){const T=this.b(L,te);return this.uriToFileUri(T)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==A.a?L.authority:null,query:null,fragment:null}):L}b(L,T){return P.URI.isUri(L)?L:P.URI.parse(T.toUrl(L))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(C){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);C.CoopAndCoep=Object.freeze(L.get("3"));const T="vscode-coi";function v(w){let f;typeof w=="string"?f=new URL(w).searchParams:w instanceof URL?f=w.searchParams:P.URI.isUri(w)&&(f=new URL(w.toString(!0)).searchParams);const d=f?.get(T);if(!!d)return L.get(d)}C.getHeadersFromQuery=v;function D(w,f,d){if(!globalThis.crossOriginIsolated)return;const m=f&&d?"3":d?"2":"1";w instanceof URLSearchParams?w.set(T,m):w[T]=m}C.addSearchParam=D})(y=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,17,11,12,8,2]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(D){return(0,A.uriToFsPath)(D,!0)}e.originalFSPath=y;class C{constructor(w){this.a=w}compare(w,f,d=!1){return w===f?0:(0,k.compare)(this.getComparisonKey(w,d),this.getComparisonKey(f,d))}isEqual(w,f,d=!1){return w===f?!0:!w||!f?!1:this.getComparisonKey(w,d)===this.getComparisonKey(f,d)}getComparisonKey(w,f=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,f,d=!1){if(w.scheme===f.scheme){if(w.scheme===t.Schemas.file)return c.isEqualOrParent(y(w),y(f),this.a(w))&&w.query===f.query&&(d||w.fragment===f.fragment);if((0,e.isEqualAuthority)(w.authority,f.authority))return c.isEqualOrParent(w.path,f.path,this.a(w),"/")&&w.query===f.query&&(d||w.fragment===f.fragment)}return!1}joinPath(w,...f){return A.URI.joinPath(w,...f)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return P.posix.basename(w.path)}extname(w){return P.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let f;return w.scheme===t.Schemas.file?f=A.URI.file(P.dirname(y(w))).path:(f=P.posix.dirname(w.path),w.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),f="/")),w.with({path:f})}normalizePath(w){if(!w.path.length)return w;let f;return w.scheme===t.Schemas.file?f=A.URI.file(P.normalize(y(w))).path:f=P.posix.normalize(w.path),w.with({path:f})}relativePath(w,f){if(w.scheme!==f.scheme||!(0,e.isEqualAuthority)(w.authority,f.authority))return;if(w.scheme===t.Schemas.file){const p=P.relative(y(w),y(f));return R.isWindows?c.toSlashes(p):p}let d=w.path||"/";const m=f.path||"/";if(this.a(w)){let p=0;for(const b=Math.min(d.length,m.length);p<b&&!(d.charCodeAt(p)!==m.charCodeAt(p)&&d.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);d=m.substr(0,p)+d.substr(p)}return P.posix.relative(d,m)}resolvePath(w,f){if(w.scheme===t.Schemas.file){const d=A.URI.file(P.resolve(y(w),f));return w.with({authority:d.authority,path:d.path})}return f=c.toPosixPath(f),w.with({path:P.posix.resolve(w.path,f)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,f){return w===f||w!==void 0&&f!==void 0&&(0,k.equalsIgnoreCase)(w,f)}hasTrailingPathSeparator(w,f=P.sep){if(w.scheme===t.Schemas.file){const d=y(w);return d.length>c.getRoot(d).length&&d[d.length-1]===f}else{const d=w.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,f=P.sep){return(0,e.hasTrailingPathSeparator)(w,f)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,f=P.sep){let d=!1;if(w.scheme===t.Schemas.file){const m=y(w);d=m!==void 0&&m.length===c.getRoot(m).length&&m[m.length-1]===f}else{f="/";const m=w.path;d=m.length===1&&m.charCodeAt(m.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(w,f)?w.with({path:w.path+"/"}):w}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(D=>D.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new C(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(D,w){const f=[];for(let d=0;d<D.length;d++){const m=w(D[d]);D.some((p,b)=>b===d?!1:(0,e.isEqualOrParent)(m,w(p)))||f.push(D[d])}return f}e.distinctParents=L;var T;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function w(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,g]=b.split(":");E&&g&&d.set(E,g)});const p=f.path.substring(0,f.path.indexOf(";"));return p&&d.set(D.META_DATA_MIME,p),d}D.parseMetaData=w})(T=e.DataUri||(e.DataUri={}));function v(D,w,f){if(w){let d=D.path;return d&&d[0]!==P.posix.sep&&(d=P.posix.sep+d),D.with({scheme:f,authority:w,path:d})}return D.with({scheme:f})}e.toLocalResource=v}),define(ye[14],Ce([1,0,21,9,3,6,24,12]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(X){return!!X&&typeof X.then=="function"}e.isThenable=y;function C(X){const G=new c.CancellationTokenSource,de=X(G.token),be=new Promise((Ee,Pe)=>{const Fe=G.token.onCancellationRequested(()=>{Fe.dispose(),G.dispose(),Pe(new t.CancellationError)});Promise.resolve(de).then(se=>{Fe.dispose(),G.dispose(),Ee(se)},se=>{Fe.dispose(),G.dispose(),Pe(se)})});return new class{cancel(){G.cancel()}then(Ee,Pe){return be.then(Ee,Pe)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return be.finally(Ee)}}}e.createCancelablePromise=C;function L(X,G,de){return new Promise((be,Ee)=>{const Pe=G.onCancellationRequested(()=>{Pe.dispose(),be(de)});X.then(be,Ee).finally(()=>Pe.dispose())})}e.raceCancellation=L;function T(X,G){return new Promise((de,be)=>{const Ee=G.onCancellationRequested(()=>{Ee.dispose(),be(new t.CancellationError)});X.then(de,be).finally(()=>Ee.dispose())})}e.raceCancellationError=T;async function v(X){let G=-1;const de=X.map((Ee,Pe)=>Ee.then(Fe=>(G=Pe,Fe))),be=await Promise.race(de);return X.forEach((Ee,Pe)=>{Pe!==G&&Ee.cancel()}),be}e.raceCancellablePromises=v;function D(X,G,de){let be;const Ee=setTimeout(()=>{be?.(void 0),de?.()},G);return Promise.race([X.finally(()=>clearTimeout(Ee)),new Promise(Pe=>be=Pe)])}e.raceTimeout=D;function w(X){return new Promise((G,de)=>{const be=X();y(be)?be.then(G,de):G(be)})}e.asPromise=w;class f{constructor(){this.a=null,this.b=null,this.d=null}queue(G){if(this.a){if(this.d=G,!this.b){const de=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(de,de).then(be)})}return new Promise((de,be)=>{this.b.then(de,be)})}return this.a=G(),new Promise((de,be)=>{this.a.then(Ee=>{this.a=null,de(Ee)},Ee=>{this.a=null,be(Ee)})})}}e.Throttler=f;class d{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.Sequencer=d;class m{constructor(){this.a=new Map}queue(G,de){const Ee=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(G)===Ee&&this.a.delete(G)});return this.a.set(G,Ee),Ee}}e.SequencerByKey=m;const p=(X,G)=>{let de=!0;const be=setTimeout(()=>{de=!1,G()},X);return{isTriggered:()=>de,dispose:()=>{clearTimeout(be),de=!1}}},b=X=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,X())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,de=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((Ee,Pe)=>{this.d=Ee,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=de===e.MicrotaskDelay?b(be):p(de,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class g{constructor(G){this.a=new E(G),this.b=new f}trigger(G,de){return this.a.trigger(()=>this.b.queue(G),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=g;class i{constructor(){this.a=!1,this.b=new Promise((G,de)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class l extends i{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=l;function o(X,G){return G?new Promise((de,be)=>{const Ee=setTimeout(()=>{Pe.dispose(),de()},X),Pe=G.onCancellationRequested(()=>{clearTimeout(Ee),Pe.dispose(),be(new t.CancellationError)})}):C(de=>o(X,de))}e.timeout=o;function a(X,G=0){const de=setTimeout(X,G);return(0,R.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=a;function s(X){const G=[];let de=0;const be=X.length;function Ee(){return de<be?X[de++]():null}function Pe(Fe){Fe!=null&&G.push(Fe);const se=Ee();return se?se.then(Pe):Promise.resolve(G)}return Promise.resolve(null).then(Pe)}e.sequence=s;function u(X,G=be=>!!be,de=null){let be=0;const Ee=X.length,Pe=()=>{if(be>=Ee)return Promise.resolve(de);const Fe=X[be++];return Promise.resolve(Fe()).then(oe=>G(oe)?Promise.resolve(oe):Pe())};return Pe()}e.first=u;function r(X,G=be=>!!be,de=null){if(X.length===0)return Promise.resolve(de);let be=X.length;const Ee=()=>{be=-1;for(const Pe of X)Pe.cancel?.()};return new Promise((Pe,Fe)=>{for(const se of X)se.then(oe=>{--be>=0&&G(oe)?(Ee(),Pe(oe)):be===0&&Pe(de)}).catch(oe=>{--be>=0&&(Ee(),Fe(oe))})})}e.firstParallel=r;class n{constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new P.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((de,be)=>{this.f.push({factory:G,c:de,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const de=G.factory();de.then(G.c,G.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=n;class h extends n{constructor(){super(1)}}e.Queue=h;class S{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const G=new ue;return this.b.add(G),G.p}d(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,de=k.extUri){const be=de.getComparisonKey(G);let Ee=this.a.get(be);return Ee||(Ee=new h,P.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.g()}}e.ResourceQueue=S;class I{constructor(G,de){this.a=-1,typeof G=="function"&&typeof de=="number"&&this.setIfNotSet(G,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},de)}setIfNotSet(G,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},de))}}e.TimeoutTimer=I;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setInterval(()=>{G()},de)}}e.IntervalTimer=F;class K{constructor(G,de){this.b=-1,this.a=G,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class q{constructor(G,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=G,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class M extends K{constructor(G,de){super(G,de),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=M;class B extends R.Disposable{constructor(G,de){super(),this.g=G,this.h=de,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of G)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,A.setTimeout0)(()=>{if(G)return;const de=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(X,G)=>{const de=requestIdleCallback(X,typeof G=="number"?{timeout:G}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(de))}}}}();class O{constructor(G){this.d=!1,this.a=()=>{try{this.f=G()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=O;async function U(X,G,de){let be;for(let Ee=0;Ee<de;Ee++)try{return await X()}catch(Pe){be=Pe,await o(G)}throw be}e.retry=U;class z{hasPending(G){return this.a?typeof G=="number"?this.a.taskId===G:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(G,de,be){return this.a={taskId:G,cancel:()=>be?.(),promise:de},de.then(()=>this.d(G),()=>this.d(G)),de}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this.b)this.b.run=G;else{let de,be;const Ee=new Promise((Pe,Fe)=>{de=Pe,be=Fe});this.b={run:G,promise:Ee,promiseResolve:de,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class j{constructor(G,de=()=>Date.now()){this.d=G,this.f=de,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class ue{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((G,de)=>{this.a=G,this.b=de})}complete(G){return new Promise(de=>{this.a(G),this.f=!0,de()})}error(G){return new Promise(de=>{this.b(G),this.d=!0,de()})}cancel(){new Promise(G=>{this.b(new t.CancellationError),this.d=!0,G()})}}e.DeferredPromise=ue;var V;(function(X){async function G(be){let Ee;const Pe=await Promise.all(be.map(Fe=>Fe.then(se=>se,se=>{Ee||(Ee=se)})));if(typeof Ee<"u")throw Ee;return Pe}X.settled=G;function de(be){return new Promise(async(Ee,Pe)=>{try{await be(Ee,Pe)}catch(Fe){Pe(Fe)}})}X.withAsyncBody=de})(V=e.Promises||(e.Promises={}));var _;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(_||(_={}));class J{static fromArray(G){return new J(de=>{de.emitMany(G)})}static fromPromise(G){return new J(async de=>{de.emitMany(await G)})}static fromPromises(G){return new J(async de=>{await Promise.all(G.map(async be=>de.emitOne(await be)))})}static merge(G){return new J(async de=>{await Promise.all(G.map(async be=>{for await(const Ee of be)de.emitOne(Ee)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new P.Emitter,queueMicrotask(async()=>{const de={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(G(de)),this.j()}catch(be){this.k(be)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(G,de){return new J(async be=>{for await(const Ee of G)be.emitOne(de(Ee))})}map(G){return J.map(this,G)}static filter(G,de){return new J(async be=>{for await(const Ee of G)de(Ee)&&be.emitOne(Ee)})}filter(G){return J.filter(this,G)}static coalesce(G){return J.filter(G,de=>!!de)}coalesce(){return J.coalesce(this)}static async toPromise(G){const de=[];for await(const be of G)de.push(be);return de}toPromise(){return J.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ie extends J{constructor(G,de){super(de),this.l=G}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ie;function ee(X){const G=new c.CancellationTokenSource,de=X(G.token);return new ie(G,async be=>{const Ee=G.token.onCancellationRequested(()=>{Ee.dispose(),G.dispose(),be.reject(new t.CancellationError)});try{for await(const Pe of de){if(G.token.isCancellationRequested)return;be.emitOne(Pe)}Ee.dispose(),G.dispose()}catch(Pe){Ee.dispose(),G.dispose(),be.reject(Pe)}})}e.createCancelableAsyncIterable=ee}),define(ye[39],Ce([1,0,16,14,32,28,11,12,8]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",T="[^/\\\\]",v=/\//g;function D(ue,V){switch(ue){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}${V?`|${L}${T}+`:""})*?`}}function w(ue,V){if(!ue)return[];const _=[];let J=!1,ie=!1,ee="";for(const X of ue){switch(X){case V:if(!J&&!ie){_.push(ee),ee="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ee+=X}return ee&&_.push(ee),_}e.splitGlobAware=w;function f(ue){if(!ue)return"";let V="";const _=w(ue,e.GLOB_SPLIT);if(_.every(J=>J===e.GLOBSTAR))V=".*";else{let J=!1;_.forEach((ie,ee)=>{if(ie===e.GLOBSTAR){if(J)return;V+=D(2,ee===_.length-1)}else{let X=!1,G="",de=!1,be="";for(const Ee of ie){if(Ee!=="}"&&X){G+=Ee;continue}if(de&&(Ee!=="]"||!be)){let Pe;Ee==="-"?Pe=Ee:(Ee==="^"||Ee==="!")&&!be?Pe="^":Ee===e.GLOB_SPLIT?Pe="":Pe=(0,y.escapeRegExpCharacters)(Ee),be+=Pe;continue}switch(Ee){case"{":X=!0;continue;case"[":de=!0;continue;case"}":{V+=`(?:${w(G,",").map(se=>f(se)).join("|")})`,X=!1,G="";break}case"]":{V+="["+be+"]",de=!1,be="";break}case"?":V+=T;continue;case"*":V+=D(1);continue;default:V+=(0,y.escapeRegExpCharacters)(Ee)}}ee<_.length-1&&(_[ee+1]!==e.GLOBSTAR||ee+2<_.length)&&(V+=L)}J=ie===e.GLOBSTAR})}return V}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),l=function(){return!1},o=function(){return null};function a(ue,V){if(!ue)return o;let _;typeof ue!="string"?_=ue.pattern:_=ue,_=_.trim();const J=`${_}_${!!V.trimForExclusions}`;let ie=i.get(J);if(ie)return s(ie,ue);let ee;return d.test(_)?ie=r(_.substr(4),_):(ee=m.exec(u(_,V)))?ie=n(ee[1],_):(V.trimForExclusions?b:p).test(_)?ie=h(_,V):(ee=E.exec(u(_,V)))?ie=S(ee[1].substr(1),_,!0):(ee=g.exec(u(_,V)))?ie=S(ee[1],_,!1):ie=I(_),i.set(J,ie),s(ie,ue)}function s(ue,V){if(typeof V=="string")return ue;const _=function(J,ie){return(0,P.isEqualOrParent)(J,V.base,!A.isLinux)?ue((0,y.ltrim)(J.substr(V.base.length),k.sep),ie):null};return _.allBasenames=ue.allBasenames,_.allPaths=ue.allPaths,_.basenames=ue.basenames,_.patterns=ue.patterns,_}function u(ue,V){return V.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function r(ue,V){return function(_,J){return typeof _=="string"&&_.endsWith(ue)?V:null}}function n(ue,V){const _=`/${ue}`,J=`\\${ue}`,ie=function(X,G){return typeof X!="string"?null:G?G===ue?V:null:X===ue||X.endsWith(_)||X.endsWith(J)?V:null},ee=[ue];return ie.basenames=ee,ie.patterns=[V],ie.allBasenames=ee,ie}function h(ue,V){const _=z(ue.slice(1,-1).split(",").map(G=>a(G,V)).filter(G=>G!==o),ue),J=_.length;if(!J)return o;if(J===1)return _[0];const ie=function(G,de){for(let be=0,Ee=_.length;be<Ee;be++)if(_[be](G,de))return ue;return null},ee=_.find(G=>!!G.allBasenames);ee&&(ie.allBasenames=ee.allBasenames);const X=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return X.length&&(ie.allPaths=X),ie}function S(ue,V,_){const J=k.sep===k.posix.sep,ie=J?ue:ue.replace(v,k.sep),ee=k.sep+ie,X=k.posix.sep+ue;let G;return _?G=function(de,be){return typeof de=="string"&&(de===ie||de.endsWith(ee)||!J&&(de===ue||de.endsWith(X)))?V:null}:G=function(de,be){return typeof de=="string"&&(de===ie||!J&&de===ue)?V:null},G.allPaths=[(_?"*/":"./")+ue],G}function I(ue){try{const V=new RegExp(`^${f(ue)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?ue:null}}catch{return o}}function F(ue,V,_){return!ue||typeof V!="string"?!1:K(ue)(V,void 0,_)}e.match=F;function K(ue,V={}){if(!ue)return l;if(typeof ue=="string"||q(ue)){const _=a(ue,V);if(_===o)return l;const J=function(ie,ee){return!!_(ie,ee)};return _.allBasenames&&(J.allBasenames=_.allBasenames),_.allPaths&&(J.allPaths=_.allPaths),J}return O(ue,V)}e.parse=K;function q(ue){const V=ue;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function M(ue){return ue.allBasenames||[]}e.getBasenameTerms=M;function B(ue){return ue.allPaths||[]}e.getPathTerms=B;function O(ue,V){const _=z(Object.getOwnPropertyNames(ue).map(G=>U(G,ue[G],V)).filter(G=>G!==o)),J=_.length;if(!J)return o;if(!_.some(G=>!!G.requiresSiblings)){if(J===1)return _[0];const G=function(Ee,Pe){let Fe;for(let se=0,oe=_.length;se<oe;se++){const fe=_[se](Ee,Pe);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Fe||(Fe=[]),Fe.push(fe))}return Fe?(async()=>{for(const se of Fe){const oe=await se;if(typeof oe=="string")return oe}return null})():null},de=_.find(Ee=>!!Ee.allBasenames);de&&(G.allBasenames=de.allBasenames);const be=_.reduce((Ee,Pe)=>Pe.allPaths?Ee.concat(Pe.allPaths):Ee,[]);return be.length&&(G.allPaths=be),G}const ie=function(G,de,be){let Ee,Pe;for(let Fe=0,se=_.length;Fe<se;Fe++){const oe=_[Fe];oe.requiresSiblings&&be&&(de||(de=(0,k.basename)(G)),Ee||(Ee=de.substr(0,de.length-(0,k.extname)(G).length)));const fe=oe(G,de,Ee,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Pe||(Pe=[]),Pe.push(fe))}return Pe?(async()=>{for(const Fe of Pe){const se=await Fe;if(typeof se=="string")return se}return null})():null},ee=_.find(G=>!!G.allBasenames);ee&&(ie.allBasenames=ee.allBasenames);const X=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return X.length&&(ie.allPaths=X),ie}function U(ue,V,_){if(V===!1)return o;const J=a(ue,_);if(J===o)return o;if(typeof V=="boolean")return J;if(V){const ie=V.when;if(typeof ie=="string"){const ee=(X,G,de,be)=>{if(!be||!J(X,G))return null;const Ee=ie.replace("$(basename)",()=>de),Pe=be(Ee);return(0,t.isThenable)(Pe)?Pe.then(Fe=>Fe?ue:null):Pe?ue:null};return ee.requiresSiblings=!0,ee}}return J}function z(ue,V){const _=ue.filter(G=>!!G.basenames);if(_.length<2)return ue;const J=_.reduce((G,de)=>{const be=de.basenames;return be?G.concat(be):G},[]);let ie;if(V){ie=[];for(let G=0,de=J.length;G<de;G++)ie.push(V)}else ie=_.reduce((G,de)=>{const be=de.patterns;return be?G.concat(be):G},[]);const ee=function(G,de){if(typeof G!="string")return null;if(!de){let Ee;for(Ee=G.length;Ee>0;Ee--){const Pe=G.charCodeAt(Ee-1);if(Pe===47||Pe===92)break}de=G.substr(Ee)}const be=J.indexOf(de);return be!==-1?ie[be]:null};ee.basenames=J,ee.patterns=ie,ee.allBasenames=J;const X=ue.filter(G=>!G.basenames);return X.push(ee),X}function j(ue,V){return(0,c.equals)(ue,V,(_,J)=>typeof _=="string"&&typeof J=="string"?_===J:typeof _!="string"&&typeof J!="string"?_.base===J.base&&_.pattern===J.pattern:!1)}e.patternsEquals=j}),define(ye[112],Ce([1,0,9,162,24,8,2]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(m="",p=!1){if(this.value=m,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(m,p=0){return this.value+=v(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,p){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(m,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(m),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(m,p){const b=new RegExp((0,R.escapeRegExpCharacters)(p),"g");return m.replace(b,(E,g)=>m.charAt(g-1)!=="\\"?`\\${E}`:E)}}e.MarkdownString=y;function C(d){return L(d)?!d.value:Array.isArray(d)?d.every(C):!0}e.isEmptyMarkdownString=C;function L(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function T(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons&&d.supportHtml===m.supportHtml&&(d.baseUri===m.baseUri||!!d.baseUri&&!!m.baseUri&&(0,P.isEqual)(k.URI.from(d.baseUri),k.URI.from(m.baseUri)))}e.markdownStringEqual=T;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function D(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function w(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=w;function f(d){const m=[],p=d.split("|").map(E=>E.trim());d=p[0];const b=p[1];if(b){const E=/height=(\d+)/.exec(b),g=/width=(\d+)/.exec(b),i=E?E[1]:"",l=g?g[1]:"",o=isFinite(parseInt(l)),a=isFinite(parseInt(i));o&&m.push(`width="${l}"`),a&&m.push(`height="${i}"`)}return{href:d,dimensions:m}}e.parseHrefAndDimensions=f}),define(ye[113],Ce([1,0,16,32,11,12,24,8]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,a){const{os:s,tildify:u,relative:r}=a;if(r){const S=C(o,r,s);if(typeof S=="string")return S}let n=o.fsPath;if(s===1&&!R.isWindows?n=n.replace(/\//g,"\\"):s!==1&&R.isWindows&&(n=n.replace(/\\/g,"/")),s!==1&&u?.userHome){const S=u.userHome.fsPath;let I;o.scheme!==u.userHome.scheme&&o.path.startsWith(P.posix.sep)?I=u.userHome.with({path:o.path}).fsPath:I=o.fsPath,n=v(I,S,s)}return(s===1?P.win32:P.posix).normalize(L(n,s===1))}e.getPathLabel=y;function C(o,a,s){const u=s===1?P.win32:P.posix,r=s===3?k.extUri:k.extUriIgnorePathCase,n=a.getWorkspace(),h=(0,c.firstOrDefault)(n.folders);if(!h)return;o.scheme!==h.uri.scheme&&o.path.startsWith(P.posix.sep)&&(o=h.uri.with({path:o.path}));const S=a.getWorkspaceFolder(o);if(!S)return;let I;if(r.isEqual(S.uri,o)?I="":I=r.relativePath(S.uri,o)??"",I&&(I=u.normalize(I)),n.folders.length>1&&!a.noPrefix){const F=S.name?S.name:r.basenameOrAuthority(S.uri);I=I?`${F} \u2022 ${I}`:F}return I}function L(o,a=R.isWindows){return(0,t.hasDriveLetter)(o,a)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=L;let T=Object.create(null);function v(o,a,s=R.OS){if(s===1||!o||!a)return o;let u=T.original===a?T.normalized:void 0;u||(u=a,R.isWindows&&(u=(0,t.toSlashes)(u)),u=`${(0,A.rtrim)(u,P.posix.sep)}${P.posix.sep}`,T={original:a,normalized:u});let r=o;return R.isWindows&&(r=(0,t.toSlashes)(r)),(s===3?r.startsWith(u):(0,A.startsWithIgnoreCase)(r,u))?`~/${r.substr(u.length)}`:o}e.tildify=v;function D(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=D;const w="\u2026",f="\\\\",d="~";function m(o,a=P.sep){const s=new Array(o.length);let u=!1;for(let r=0;r<o.length;r++){const n=o[r];if(n===""){s[r]=`.${a}`;continue}if(!n){s[r]=n;continue}u=!0;let h="",S=n;S.indexOf(f)===0?(h=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length)):S.indexOf(a)===0?(h=S.substr(0,S.indexOf(a)+a.length),S=S.substr(S.indexOf(a)+a.length)):S.indexOf(d)===0&&(h=S.substr(0,S.indexOf(d)+d.length),S=S.substr(S.indexOf(d)+d.length));const I=S.split(a);for(let F=1;u&&F<=I.length;F++)for(let K=I.length-F;u&&K>=0;K--){u=!1;let q=I.slice(K,K+F).join(a);for(let M=0;!u&&M<o.length;M++)if(M!==r&&o[M]&&o[M].indexOf(q)>-1){const B=K+F===I.length,O=K>0&&o[M].indexOf(a)>-1?a+q:q,U=o[M].endsWith(O);u=!B||U}if(!u){let M="";(I[0].endsWith(":")||h!=="")&&(K===1&&(K=0,F++,q=I[0]+a+q),K>0&&(M=I[0]+a),M=h+M),K>0&&(M=M+w+a),M=M+q,K+F<I.length&&(M=M+a+w),s[r]=M}}u&&(s[r]=n)}return s}e.shorten=m;var p;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(o,a=Object.create(null)){const s=[];let u=!1,r="";for(const n of o)if(n==="$"||u&&n==="{")r&&s.push({value:r,type:p.TEXT}),r="",u=!0;else if(n==="}"&&u){const h=a[r];if(typeof h=="string")h.length&&s.push({value:h,type:p.VARIABLE});else if(h){const S=s[s.length-1];(!S||S.type!==p.SEPARATOR)&&s.push({value:h.label,type:p.SEPARATOR})}r="",u=!1}else r+=n;return r&&!u&&s.push({value:r,type:p.TEXT}),s.filter((n,h)=>{if(n.type===p.SEPARATOR){const S=s[h-1],I=s[h+1];return[S,I].every(F=>F&&(F.type===p.VARIABLE||F.type===p.TEXT)&&F.value.length>0)}return!0}).map(n=>n.value).join("")}e.template=b;function E(o,a){return R.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):o.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function g(o,a){return R.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):R.isWindows?o.replace(/&&|&/g,s=>s==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(o){const a=o.indexOf("/")!==-1?P.posix:P.win32,s=a.basename(o),u=a.dirname(o);return s.length?{name:s,parentPath:u}:{name:u,parentPath:""}}e.splitName=l}),define(ye[114],Ce([1,0,22,2]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(T){return T.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const D=this.a.transformIncoming(v);return D===v?v:P(t.URI.from(D))}transformOutgoing(v){const D=this.a.transformOutgoing(v);return D===v?v:P(t.URI.from(D))}transformOutgoingURI(v){const D=this.a.transformOutgoing(v);return D===v?v:t.URI.from(D)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function k(T,v,D){if(!T||D>200)return null;if(typeof T=="object"){if(T instanceof t.URI)return v.transformOutgoing(T);for(const w in T)if(Object.hasOwnProperty.call(T,w)){const f=k(T[w],v,D+1);f!==null&&(T[w]=f)}}return null}function A(T,v){const D=k(T,v,0);return D===null?T:D}e.transformOutgoingURIs=A;function y(T,v,D,w){if(!T||w>200)return null;if(typeof T=="object"){if(T.$mid===1)return D?t.URI.revive(v.transformIncoming(T)):v.transformIncoming(T);if(T instanceof c.VSBuffer)return null;for(const f in T)if(Object.hasOwnProperty.call(T,f)){const d=y(T[f],v,D,w+1);d!==null&&(T[f]=d)}}return null}function C(T,v){const D=y(T,v,!1,0);return D===null?T:D}e.transformIncomingURIs=C;function L(T,v){const D=y(T,v,!0,0);return D===null?T:D}e.transformAndReviveIncomingURIs=L}),define(ye[29],Ce([1,0,69,88,316,14,32,85,11,12,24,2]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function D(O,U=v.UNLINK){if((0,k.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?f(O):w(O)}async function w(O){try{const U=(0,k.randomPath)((0,t.tmpdir)());try{await c.promises.rename(O,U)}catch(z){return z.code==="ENOENT"?void 0:f(O)}f(U).catch(z=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function f(O){return(0,P.promisify)(c.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,k.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function m(O,U){return E(await(U?p(O):(0,P.promisify)(c.readdir)(O)))}async function p(O){try{return await(0,P.promisify)(c.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],z=await m(O);for(const j of z){let ue=!1,V=!1,_=!1;try{const J=await e.Promises.lstat((0,y.join)(O,j));ue=J.isFile(),V=J.isDirectory(),_=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}U.push({name:j,isFile:()=>ue,isDirectory:()=>V,isSymbolicLink:()=>_})}return U}function b(O){return E(c.readdirSync(O))}e.readdirSync=b;function E(O){return O.map(U=>typeof U=="string"?C.isMacintosh?(0,A.normalizeNFC)(U):U:(U.name=C.isMacintosh?(0,A.normalizeNFC)(U.name):U.name,U))}async function g(O){const U=await m(O),z=[];for(const j of U)await l.existsDirectory((0,y.join)(O,j))&&z.push(j);return z}function i(O,U=1e3){return new Promise(z=>{let j=!1;const ue=setInterval(()=>{j||(j=!0,c.access(O,V=>{j=!1,V&&(clearInterval(ue),z(void 0))}))},U)})}e.whenDeleted=i;var l;(function(O){async function U(ue){let V;try{if(V=await e.Promises.lstat(ue),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(ue),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(C.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ue)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw J}throw _}}O.stat=U;async function z(ue){try{const{stat:V,symbolicLink:_}=await O.stat(ue);return V.isFile()&&_?.dangling!==!0}catch{}return!1}O.existsFile=z;async function j(ue){try{const{stat:V,symbolicLink:_}=await O.stat(ue);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new R.ResourceQueue;function a(O,U,z){return o.queueFor(T.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=h(z);return new Promise((ue,V)=>r(O,U,j,_=>_?V(_):ue()))})}let s=!0;function u(O){s=O}e.configureFlushOnWrite=u;function r(O,U,z,j){if(!s)return c.writeFile(O,U,{mode:z.mode,flag:z.flag},j);c.open(O,z.flag,z.mode,(ue,V)=>{if(ue)return j(ue);c.writeFile(V,U,_=>{if(_)return c.close(V,()=>j(_));c.fdatasync(V,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),u(!1)),c.close(V,ie=>j(ie))))})})}function n(O,U,z){const j=h(z);if(!s)return c.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const ue=c.openSync(O,j.flag,j.mode);try{c.writeFileSync(ue,U);try{c.fdatasyncSync(ue)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),u(!1)}}finally{c.closeSync(ue)}}e.writeFileSync=n;function h(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function S(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch(z){if(O.toLowerCase()!==U.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await I(O,U,{preserveSymlinks:!1}),await D(O,v.MOVE);else throw z}}async function I(O,U,z){return K(O,U,{root:{source:O,target:U},options:z,handledSourcePaths:new Set})}const F=511;async function K(O,U,z){if(z.handledSourcePaths.has(O))return;z.handledSourcePaths.add(O);const{stat:j,symbolicLink:ue}=await l.stat(O);if(ue){if(z.options.preserveSymlinks)try{return await B(O,U,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(ue.dangling)return}return j.isDirectory()?q(O,U,j.mode&F,z):M(O,U,j.mode&F)}async function q(O,U,z,j){await e.Promises.mkdir(U,{recursive:!0,mode:z});const ue=await m(O);for(const V of ue)await K((0,y.join)(O,V),(0,y.join)(U,V),j)}async function M(O,U,z){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,z)}async function B(O,U,z){let j=await e.Promises.readlink(O);(0,k.isEqualOrParent)(j,z.root.source,!C.isLinux)&&(j=(0,y.join)(z.root.target,j.substr(z.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,P.promisify)(c.access)}get stat(){return(0,P.promisify)(c.stat)}get lstat(){return(0,P.promisify)(c.lstat)}get utimes(){return(0,P.promisify)(c.utimes)}get read(){return(O,U,z,j,ue)=>new Promise((V,_)=>{c.read(O,U,z,j,ue,(J,ie,ee)=>J?_(J):V({bytesRead:ie,buffer:ee}))})}get readFile(){return(0,P.promisify)(c.readFile)}get write(){return(O,U,z,j,ue)=>new Promise((V,_)=>{c.write(O,U,z,j,ue,(J,ie,ee)=>J?_(J):V({bytesWritten:ie,buffer:ee}))})}get appendFile(){return(0,P.promisify)(c.appendFile)}get fdatasync(){return(0,P.promisify)(c.fdatasync)}get truncate(){return(0,P.promisify)(c.truncate)}get rename(){return(0,P.promisify)(c.rename)}get copyFile(){return(0,P.promisify)(c.copyFile)}get open(){return(0,P.promisify)(c.open)}get close(){return(0,P.promisify)(c.close)}get symlink(){return(0,P.promisify)(c.symlink)}get readlink(){return(0,P.promisify)(c.readlink)}get chmod(){return(0,P.promisify)(c.chmod)}get mkdir(){return(0,P.promisify)(c.mkdir)}get unlink(){return(0,P.promisify)(c.unlink)}get rmdir(){return(0,P.promisify)(c.rmdir)}get realpath(){return(0,P.promisify)(c.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return g}get writeFile(){return a}get rm(){return D}get move(){return S}get copy(){return I}}}),define(ye[115],Ce([1,0,69,11,12,8,29]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(v){if(P.isLinux)return v;const D=(0,t.dirname)(v);if(v===D)return v;const w=((0,t.basename)(v)||v).toLowerCase();try{const d=(0,k.readdirSync)(D).filter(m=>m.toLowerCase()===w);if(d.length===1){const m=A(D);if(m)return(0,t.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(w);if(m>=0){const p=A(D);if(p)return(0,t.join)(p,d[m])}}}catch{}return null}e.realcaseSync=A;async function y(v){if(P.isLinux)return v;const D=(0,t.dirname)(v);if(v===D)return v;const w=((0,t.basename)(v)||v).toLowerCase();try{const d=(await k.Promises.readdir(D)).filter(m=>m.toLowerCase()===w);if(d.length===1){const m=await y(D);if(m)return(0,t.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(w);if(m>=0){const p=await y(D);if(p)return(0,t.join)(p,d[m])}}}catch{}return null}e.realcase=y;async function C(v){try{return await k.Promises.realpath(v)}catch{const w=T(v);return await k.Promises.access(w,c.constants.R_OK),w}}e.realpath=C;function L(v){try{return c.realpathSync(v)}catch{const w=T(v);return c.accessSync(w,c.constants.R_OK),w}}e.realpathSync=L;function T(v){return(0,R.rtrim)((0,t.normalize)(v),t.sep)}}),define(ye[116],Ce([1,0,11,12,37,109,10,29]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(T=P.env){return T.comspec||"cmd.exe"}e.getWindowsShell=y;function C(T){let v=[],D=!1;const w=function(f){if(D){v.push(f);return}(!T.send(f,m=>{if(m&&console.error(m),D=!1,v.length>0){const p=v.slice(0);v=[],p.forEach(b=>w(b))}})||t.isWindows)&&(D=!0)};return{send:w}}e.createQueuedSender=C;var L;(function(T){async function v(D,w,f){if(c.isAbsolute(D))return D;if(w===void 0&&(w=P.cwd()),c.dirname(D)!=="."||(f===void 0&&k.isString(P.env.PATH)&&(f=P.env.PATH.split(c.delimiter)),f===void 0||f.length===0))return c.join(w,D);async function m(p){if(await A.Promises.exists(p)){let b;try{b=await A.Promises.stat(p)}catch(E){E.message.startsWith("EACCES")&&(b=await A.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of f){let b;if(c.isAbsolute(p)?b=c.join(p,D):b=c.join(w,p,D),await m(b))return b;let E=b+".com";if(await m(E)||(E=b+".exe",await m(E)))return E}return c.join(w,D)}T.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(te,e,c,t){var P=arguments.length,R=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(te,e,c,t);else for(var A=te.length-1;A>=0;A--)(k=te[A])&&(R=(P<3?k(R):P>3?k(e,c,R):k(e,c))||R);return P>3&&R&&Object.defineProperty(e,c,R),R};define(ye[117],Ce([1,0,16,14,22,21,62,9,3,6,68,8,10]),function(te,e,c,t,P,R,k,A,y,C,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(D||(D={}));function w(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(f||(f={}));function d(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(m||(m={}));function p(V){let _=0;for(let J=0;;J+=7){const ie=V.read(1);if(_|=(ie.buffer[0]&127)<<J,!(ie.buffer[0]&128))return _}}const b=o(0);function E(V,_){if(_===0){V.write(b);return}let J=0;for(let ee=_;ee!==0;ee=ee>>>7)J++;const ie=P.VSBuffer.alloc(J);for(let ee=0;_!==0;ee++)ie.buffer[ee]=_&127,_=_>>>7,_>0&&(ie.buffer[ee]|=128);V.write(ie)}class g{constructor(_){this.b=_,this.a=0}read(_){const J=this.b.slice(this.a,this.a+_);return this.a+=J.byteLength,J}}e.BufferReader=g;class i{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=i;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function o(V){const _=P.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const a={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object),Uint:o(l.Int)},s=typeof Buffer<"u";function u(V,_){if(typeof _>"u")V.write(a.Undefined);else if(typeof _=="string"){const J=P.VSBuffer.fromString(_);V.write(a.String),E(V,J.byteLength),V.write(J)}else if(s&&Buffer.isBuffer(_)){const J=P.VSBuffer.wrap(_);V.write(a.Buffer),E(V,J.byteLength),V.write(J)}else if(_ instanceof P.VSBuffer)V.write(a.VSBuffer),E(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(a.Array),E(V,_.length);for(const J of _)u(V,J)}else if(typeof _=="number"&&(_|0)===_)V.write(a.Uint),E(V,_);else{const J=P.VSBuffer.fromString(JSON.stringify(_));V.write(a.Object),E(V,J.byteLength),V.write(J)}}e.serialize=u;function r(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(p(V)).toString();case l.Buffer:return V.read(p(V)).buffer;case l.VSBuffer:return V.read(p(V));case l.Array:{const J=p(V),ie=[];for(let ee=0;ee<J;ee++)ie.push(r(V));return ie}case l.Object:return JSON.parse(V.read(p(V)).toString());case l.Int:return p(V)}}e.deserialize=r;class n{constructor(_,J,ie=null,ee=1e3){this.h=_,this.j=J,this.k=ie,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(_,J){this.b.set(_,J),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const J=this.o([_.type]);this.k?.logOutgoing(J,0,1,d(_.type));return}case 201:case 202:case 204:case 203:{const J=this.o([_.type,_.id],_.data);this.k?.logOutgoing(J,_.id,1,d(_.type),_.data);return}}}o(_,J=void 0){const ie=new i;return u(ie,_),u(ie,J),this.p(ie.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const J=new g(_),ie=r(J),ee=r(J),X=ie[0];switch(X){case 100:return this.k?.logIncoming(_.byteLength,ie[1],1,`${w(X)}: ${ie[2]}.${ie[3]}`,ee),this.s({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ee});case 102:return this.k?.logIncoming(_.byteLength,ie[1],1,`${w(X)}: ${ie[2]}.${ie[3]}`,ee),this.t({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ee});case 101:return this.k?.logIncoming(_.byteLength,ie[1],1,`${w(X)}`),this.u({type:X,id:ie[1]});case 103:return this.k?.logIncoming(_.byteLength,ie[1],1,`${w(X)}`),this.u({type:X,id:ie[1]})}}s(_){const J=this.b.get(_.channelName);if(!J){this.v(_);return}const ie=new R.CancellationTokenSource;let ee;try{ee=J.call(this.j,_.name,_.arg,ie.token)}catch(de){ee=Promise.reject(de)}const X=_.id;ee.then(de=>{this.m({id:X,data:de,type:201}),this.d.delete(_.id)},de=>{de instanceof Error?this.m({id:X,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.m({id:X,data:de,type:203}),this.d.delete(_.id)});const G=(0,C.toDisposable)(()=>ie.cancel());this.d.set(_.id,G)}t(_){const J=this.b.get(_.channelName);if(!J){this.v(_);return}const ie=_.id,X=J.listen(this.j,_.name,_.arg)(G=>this.m({id:ie,data:G,type:204}));this.d.set(_.id,X)}u(_){const J=this.d.get(_.id);J&&(J.dispose(),this.d.delete(_.id))}v(_){let J=this.g.get(_.channelName);J||(J=[],this.g.set(_.channelName,J));const ie=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:_,timeoutTimer:ie})}w(_){const J=this.g.get(_);if(J){for(const ie of J)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,C.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var h;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(_,J=null){this.l=_,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=J}getChannel(_){const J=this;return{call(ie,ee,X){return J.a?Promise.reject(new A.CancellationError):J.m(_,ie,ee,X)},listen(ie,ee){return J.a?y.Event.None:J.o(_,ie,ee)}}}m(_,J,ie,ee=R.CancellationToken.None){const X=this.g++,de={id:X,type:100,channelName:_,name:J,arg:ie};if(ee.isCancellationRequested)return Promise.reject(new A.CancellationError);let be;return new Promise((Pe,Fe)=>{if(ee.isCancellationRequested)return Fe(new A.CancellationError);const se=()=>{const ce=ne=>{switch(ne.type){case 201:this.f.delete(X),Pe(ne.data);break;case 202:{this.f.delete(X);const N=new Error(ne.data.message);N.stack=Array.isArray(ne.data.stack)?ne.data.stack.join(`
`):ne.data.stack,N.name=ne.data.name,Fe(N);break}case 203:this.f.delete(X),Fe(ne.data);break}};this.f.set(X,ce),this.p(de)};let oe=null;this.b===m.Idle?se():(oe=(0,t.createCancelablePromise)(ce=>this.u()),oe.then(()=>{oe=null,se()}));const fe=()=>{oe?(oe.cancel(),oe=null):this.p({id:X,type:101}),Fe(new A.CancellationError)},Z=ee.onCancellationRequested(fe);be=(0,C.combinedDisposable)((0,C.toDisposable)(fe),Z),this.d.add(be)}).finally(()=>{this.d.delete(be)})}o(_,J,ie){const ee=this.g++,G={id:ee,type:102,channelName:_,name:J,arg:ie};let de=null;const be=new y.Emitter({onWillAddFirstListener:()=>{de=(0,t.createCancelablePromise)(Pe=>this.u()),de.then(()=>{de=null,this.d.add(be),this.p(G)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(be),this.p({id:ee,type:103}))}}),Ee=Pe=>be.fire(Pe.data);return this.f.set(ee,Ee),be.event}p(_){switch(_.type){case 100:case 102:{const J=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(J,_.id,0,`${w(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const J=this.q([_.type,_.id]);this.j?.logOutgoing(J,_.id,0,w(_.type));return}}}q(_,J=void 0){const ie=new i;return u(ie,_),u(ie,J),this.r(ie.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const J=new g(_),ie=r(J),ee=r(J),X=ie[0];switch(X){case 200:return this.j?.logIncoming(_.byteLength,0,0,d(X)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,ie[1],0,d(X),ee),this.t({type:ie[0],id:ie[1],data:ee})}}t(_){if(_.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,C.dispose)(this.d.values()),this.d.clear()}}qe([k.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class I{get connections(){const _=[];return this.f.forEach(J=>_.push(J)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:J,onDidClientDisconnect:ie})=>{y.Event.once(J.onMessage)(X=>{const G=new g(X),de=r(G),be=new n(J,de),Ee=new S(J);this.a.forEach((Fe,se)=>be.registerChannel(se,Fe));const Pe={channelServer:be,channelClient:Ee,ctx:de};this.f.add(Pe),this.g.fire(Pe),ie(()=>{be.dispose(),Ee.dispose(),this.f.delete(Pe),this.h.fire(Pe)})})})}getChannel(_,J){const ie=this;return{call(ee,X,G){let de;if((0,v.isFunction)(J)){const Ee=(0,c.getRandomElement)(ie.connections.filter(J));de=Ee?Promise.resolve(Ee):y.Event.toPromise(y.Event.filter(ie.onDidAddConnection,J))}else de=J.routeCall(ie,ee,X);const be=de.then(Ee=>Ee.channelClient.getChannel(_));return K(be).call(ee,X,G)},listen(ee,X){if((0,v.isFunction)(J))return ie.j(_,J,ee,X);const G=J.routeEvent(ie,ee,X).then(de=>de.channelClient.getChannel(_));return K(G).listen(ee,X)}}}j(_,J,ie,ee){const X=this;let G=new C.DisposableStore;const de=new y.Emitter({onWillAddFirstListener:()=>{G=new C.DisposableStore;const be=new y.EventMultiplexer,Ee=new Map,Pe=se=>{const fe=se.channelClient.getChannel(_).listen(ie,ee),Z=be.add(fe);Ee.set(se,Z)},Fe=se=>{const oe=Ee.get(se);!oe||(oe.dispose(),Ee.delete(se))};X.connections.filter(J).forEach(Pe),y.Event.filter(X.onDidAddConnection,J)(Pe,void 0,G),X.onDidRemoveConnection(Fe,void 0,G),be.event(de.fire,de,G),G.add(be)},onDidRemoveLastListener:()=>{G.dispose()}});return de.event}registerChannel(_,J){this.a.set(_,J),this.f.forEach(ie=>{ie.channelServer.registerChannel(_,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=I;class F{constructor(_,J,ie=null){const ee=new i;u(ee,J),_.send(ee.buffer),this.a=new S(_,ie),this.d=new n(_,J,ie)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,J){this.d.registerChannel(_,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function K(V){return{call(_,J,ie){return V.then(ee=>ee.call(_,J,ie))},listen(_,J){const ie=new y.Relay;return V.then(ee=>ie.input=ee.listen(_,J)),ie.event}}}e.getDelayedChannel=K;function q(V){let _=!1;return{call(J,ie,ee){return _?V.call(J,ie,ee):(0,t.timeout)(0).then(()=>_=!0).then(()=>V.call(J,ie,ee))},listen(J,ie){if(_)return V.listen(J,ie);const ee=new y.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>ee.input=V.listen(J,ie)),ee.event}}}e.getNextTickChannel=q;class M{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const J of _.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=M;var B;(function(V){function _(X,G){const de=X,be=G&&G.disableMarshalling,Ee=new Map;for(const Pe in de)ie(Pe)&&Ee.set(Pe,y.Event.buffer(de[Pe],!0));return new class{listen(Pe,Fe,se){const oe=Ee.get(Fe);if(oe)return oe;if(ee(Fe)){const fe=de[Fe];if(typeof fe=="function")return fe.call(de,se)}throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,se){const oe=de[Fe];if(typeof oe=="function"){if(!be&&Array.isArray(se))for(let fe=0;fe<se.length;fe++)se[fe]=(0,L.revive)(se[fe]);return oe.apply(de,se)}throw new Error(`Method not found: ${Fe}`)}}}V.fromService=_;function J(X,G){const de=G&&G.disableMarshalling;return new Proxy({},{get(be,Ee){if(typeof Ee=="string")return G?.properties?.has(Ee)?G.properties.get(Ee):ee(Ee)?function(Pe){return X.listen(Ee,Pe)}:ie(Ee)?X.listen(Ee):async function(...Pe){let Fe;G&&!(0,v.isUndefinedOrNull)(G.context)?Fe=[G.context,...Pe]:Fe=Pe;const se=await X.call(Ee,Fe);return de?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=J;function ie(X){return X[0]==="o"&&X[1]==="n"&&T.isUpperAsciiLetter(X.charCodeAt(2))}function ee(X){return/^onDynamic/.test(X)&&T.isUpperAsciiLetter(X.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function z(V){return Array.isArray(V)?V.map(U):U(V)}function j(V,_,J,ie,ee,X,G){G=z(G);const de=O[ee],be=de[ie%de.length];let Ee=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(X)?(Ee=Ee.concat(G),Ee.push(")")):Ee.push(G),console.log.apply(console,Ee)}class ue{constructor(_,J){this.d=_,this.f=J,this.a=0,this.b=0}logOutgoing(_,J,ie,ee,X){this.b+=_,j(this.d,this.b,_,J,ie,ee,X)}logIncoming(_,J,ie,ee,X){this.a+=_,j(this.f,this.a,_,J,ie,ee,X)}}e.IPCLogger=ue}),define(ye[118],Ce([1,0,14,22,3,6,117]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(S){S.Created="created",S.Read="read",S.Write="write",S.Open="open",S.Error="error",S.Close="close",S.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",S.NodeEndReceived="nodeEndReceived",S.NodeEndSent="nodeEndSent",S.NodeDrainBegin="nodeDrainBegin",S.NodeDrainEnd="nodeDrainEnd",S.zlibInflateError="zlibInflateError",S.zlibInflateData="zlibInflateData",S.zlibInflateInitialWrite="zlibInflateInitialWrite",S.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",S.zlibInflateWrite="zlibInflateWrite",S.zlibInflateFlushFired="zlibInflateFlushFired",S.zlibDeflateError="zlibDeflateError",S.zlibDeflateData="zlibDeflateData",S.zlibDeflateWrite="zlibDeflateWrite",S.zlibDeflateFlushFired="zlibDeflateFlushFired",S.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",S.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",S.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",S.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",S.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",S.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",S.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",S.ProtocolHeaderRead="protocolHeaderRead",S.ProtocolMessageRead="protocolMessageRead",S.ProtocolHeaderWrite="protocolHeaderWrite",S.ProtocolMessageWrite="protocolMessageWrite",S.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(S){S.enableDiagnostics=!1,S.records=[];const I=new WeakMap;let F=0;function K(M,B){if(!I.has(M)){const O=String(++F);I.set(M,O)}return I.get(M)}function q(M,B,O,U){if(!S.enableDiagnostics)return;const z=K(M,B);if(U instanceof t.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=t.VSBuffer.alloc(U.byteLength);j.set(U),S.records.push({timestamp:Date.now(),id:z,label:B,type:O,buff:j})}else S.records.push({timestamp:Date.now(),id:z,label:B,type:O,data:U})}S.traceSocketEvent=q})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(S){S[S.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",S[S.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function T(){return L||(L=t.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(I){this.a.push(I),this.b+=I.byteLength}read(I){return this.c(I,!0)}peek(I){return this.c(I,!1)}c(I,F){if(I===0)return T();if(I>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===I){const B=this.a[0];return F&&(this.a.shift(),this.b-=I),B}if(this.a[0].byteLength>I){const B=this.a[0].slice(0,I);return F&&(this.a[0]=this.a[0].slice(I),this.b-=I),B}const K=t.VSBuffer.alloc(I);let q=0,M=0;for(;I>0;){const B=this.a[M];if(B.byteLength>I){const O=B.slice(0,I);K.set(O,q),q+=I,F&&(this.a[M]=B.slice(I),this.b-=I),I-=I}else K.set(B,q),q+=B.byteLength,F?(this.a.shift(),this.b-=B.byteLength):M++,I-=B.byteLength}return K}}e.ChunkStream=v;var D;(function(S){S[S.None=0]="None",S[S.Regular=1]="Regular",S[S.Control=2]="Control",S[S.Ack=3]="Ack",S[S.Disconnect=5]="Disconnect",S[S.ReplayRequest=6]="ReplayRequest",S[S.Pause=7]="Pause",S[S.Resume=8]="Resume",S[S.KeepAlive=9]="KeepAlive",S[S.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",S[S.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(D||(D={}));function w(S){switch(S){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(S){S[S.HeaderLength=13]="HeaderLength",S[S.AcknowledgeTime=2e3]="AcknowledgeTime",S[S.TimeoutTime=2e4]="TimeoutTime",S[S.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",S[S.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",S[S.KeepAliveSendTime=5e3]="KeepAliveSendTime",S[S.LatencySampleTime=6e4]="LatencySampleTime",S[S.LatencySampleCount=5]="LatencySampleCount",S[S.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",S[S.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(I,F,K,q){this.type=I,this.id=F,this.ack=K,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends R.Disposable{constructor(I){super(),this.f=this.B(new P.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=I,this.b=!1,this.c=new v,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(I){if(!(!I||I.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(I);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,q=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new d(K,q,M,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(I){this.k=null,this.a=!1,this.b=!1,this.c=I,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(I){if(this.a)return;I.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=t.VSBuffer.alloc(13);F.writeUInt8(I.type,0),F.writeUInt32BE(I.id,1),F.writeUInt32BE(I.ack,5),F.writeUInt32BE(I.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(I.type),id:I.id,ack:I.ack,messageSize:I.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",I.data),this.j(F,I.data)}g(I,F){const K=this.f===0;return this.d.push(I,F),this.f+=I.byteLength+F.byteLength,K}h(){const I=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,I}j(I,F){this.g(I,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const I=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:I.byteLength}),this.c.write(I)}}class b extends R.Disposable{constructor(I){super(),this.f=new P.Emitter,this.onMessage=this.f.event,this.g=new P.Emitter,this.onDidDispose=this.g.event,this.a=I,this.b=this.B(new p(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(I){this.b.write(new d(1,0,0,I))}}e.Protocol=b;class E extends k.IPCClient{static fromSocket(I,F){return new E(new b(I),F)}get onDidDispose(){return this.b.onDidDispose}constructor(I,F,K=null){super(I,F,K),this.b=I}dispose(){super.dispose();const I=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),I.end()}}e.Client=E;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new P.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(I){this.b?this.d.length>0?this.d.push(I):this.a.fire(I):this.d.push(I)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class i{constructor(I){this.data=I,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let I=0,F=this.a;for(;F;)F=F.next,I++;return I}peek(){return this.a?this.a.data:null}toArray(){const I=[];let F=0,K=this.a;for(;K;)I[F++]=K.data,K=K.next;return I}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(I){const F=new i(I);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const I=Date.now();for(let F=0;F<o.a;F++)this.c[F]=I-1e3*F;setInterval(()=>{for(let F=o.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const I=Date.now(),F=(1+o.a)*1e3;let K=0;for(let q=0;q<o.a;q++)I-this.c[q]<=F&&K++;return 1-K/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;var a;(function(S){S[S.Good=0]="Good",S[S.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function s(S){switch(S){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class u{constructor(I){this.connectionHealth=I}}e.ConnectionHealthChangedEvent=u;class r{constructor(I,F){this.roundTripTime=I,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=r;class n{get unacknowledgedCount(){return this.c-this.d}constructor(I){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=I.loadEstimator??o.getInstance(),this.v=I.measureRoundTripTime??!1,this.w=I.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=I.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new m(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),I.initialChunk&&this.q.acceptChunk(I.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const I=new d(5,0,0,T());this.p.write(I),this.p.flush()}sendPause(){const I=new d(7,0,0,T());this.p.write(I)}sendResume(){const I=new d(8,0,0,T());this.p.write(I)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(I,F){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=I,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new m(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const I=new d(3,0,this.h,T());this.p.write(I);const F=this.b.toArray();for(let K=0,q=F.length;K<q;K++)this.p.write(F[K]);this.G()}acceptDisconnect(){this.z.fire()}E(I){if(I.ack>this.d){this.d=I.ack;do{const F=this.b.peek();if(F&&F.id<=I.ack)this.b.pop();else break}while(!0)}switch(I.type){case 0:break;case 1:{if(I.id>this.g)if(I.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new d(6,0,0,T())))}else this.g=I.id,this.j=Date.now(),this.F(),this.y.fire(I.data);break}case 2:{this.x.fire(I.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let K=0,q=F.length;K<q;K++)this.p.write(F[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(I.data);break}case 11:{this.r.handleResponse(I.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(I){const F=++this.c;this.h=this.g;const K=new d(1,F,this.h,I);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(I){const F=new d(2,0,0,I);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const I=Date.now()-this.j;if(I>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-I+5)}G(){if(this.c<=this.d||this.f||this.a)return;const I=this.b.peek(),F=Date.now()-I.writtenTime,K=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(F>=2e4&&K>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:K});return}const M=Math.max(2e4-F,2e4-K,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},M)}H(){if(this.g<=this.h)return;this.h=this.g;const I=new d(3,0,this.h,T());this.p.write(I)}I(){this.h=this.g;const I=new d(9,0,this.h,T());this.p.write(I)}J(I){this.h=this.g;const F=new d(10,0,this.h,I);this.p.write(F)}K(I){this.h=this.g;const F=new d(11,0,this.h,I);this.p.write(F)}}e.PersistentProtocol=n;class h extends R.Disposable{constructor(){super(),this.a=this.B(new P.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new P.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new P.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},I=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const I=++this.h,F=t.VSBuffer.alloc(4);F.writeUInt32BE(I,0),this.a.fire(F)},6e4)}handleResponse(I){if(I.byteLength!==4)return;const F=I.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const K=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=K;const M=this.l,B=this.j.filter(O=>O>=1e3).length;this.l=B>=3?1:0,K>1e3&&this.b.fire(new r(K,B)),M!==this.l&&this.c.fire(this.l)}}}),define(ye[119],Ce([1,0,22,9,3,6,11,12,30,117,118]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(r,n){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,n)}constructor(r,n=""){this.f=!0,this.debugLabel=n,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this.a),this.b=h=>{this.traceSocketEvent("close",{hadError:h}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const n=h=>{this.traceSocketEvent("read",h),r(c.VSBuffer.wrap(h))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(r){const n=h=>{r({type:0,hadError:h,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(r){const n=()=>{r()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,t.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,t.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=v;var D;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var w;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(w||(w={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,n){this.socket.traceSocketEvent(r,n)}constructor(r,n,h,S){super(),this.f=this.B(new P.Emitter),this.g=this.B(new P.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:h?.byteLength||0,recordInflateBytes:S}),this.a=this.B(new d(this,n,h,S,this.f,(I,F)=>this.k(I,F))),this.B(this.a.onError(I=>{console.error(I),(0,t.onUnexpectedError)(I),this.g.fire({type:0,hadError:!0,error:I})})),this.b=new L.ChunkStream,this.B(this.socket.onData(I=>this.l(I))),this.B(this.socket.onClose(I=>this.g.fire(I)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let h=2;r.byteLength<126?h+=0:r.byteLength<2**16?h+=2:h+=8;const S=c.VSBuffer.alloc(h);if(n?S.writeUInt8(194,0):S.writeUInt8(130,0),r.byteLength<126)S.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){S.writeUInt8(126,1);let I=1;S.writeUInt8(r.byteLength>>>8&255,++I),S.writeUInt8(r.byteLength>>>0&255,++I)}else{S.writeUInt8(127,1);let I=1;S.writeUInt8(0,++I),S.writeUInt8(0,++I),S.writeUInt8(0,++I),S.writeUInt8(0,++I),S.writeUInt8(r.byteLength>>>24&255,++I),S.writeUInt8(r.byteLength>>>16&255,++I),S.writeUInt8(r.byteLength>>>8&255,++I),S.writeUInt8(r.byteLength>>>0&255,++I)}this.socket.write(c.VSBuffer.concat([S,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),h=n.readUInt8(0),S=(h&128)>>>7,I=(h&64)>>>6,F=n.readUInt8(1),K=(F&128)>>>7,q=F&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=S,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(I)),this.j.firstFrameOfMessage=Boolean(S),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),h=n.readUInt8(1),S=(h&128)>>>7;let I=h&127,F=1;I===126?I=n.readUInt8(++F)*2**8+n.readUInt8(++F):I===127&&(I=n.readUInt8(++F)*0+n.readUInt8(++F)*0+n.readUInt8(++F)*0+n.readUInt8(++F)*0+n.readUInt8(++F)*2**24+n.readUInt8(++F)*2**16+n.readUInt8(++F)*2**8+n.readUInt8(++F));let K=0;S&&(K=n.readUInt8(++F)*2**24+n.readUInt8(++F)*2**16+n.readUInt8(++F)*2**8+n.readUInt8(++F)),this.j.state=3,this.j.readLen=I,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),b(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(r,n,h,S,I,F){super(),this.k=r,this.l=I,this.m=F,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,n?(this.b=this.B(new m(this.k,S,h,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const n=await this.r(this.f,r);this.m(n,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,n){return new Promise((h,S)=>{r.write(n),r.flush(I=>h(I))})}acceptFrame(r,n,h){this.h.push({data:r,isCompressed:n,isLastFrameOfMessage:h}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const n=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(n)}else this.l.fire(r.data)}this.s=!1}}u(r,n,h){return new Promise((S,I)=>{r.write(n),h&&r.write(c.VSBuffer.fromByteArray([0,0,255,255])),r.flush(F=>S(F))})}}class m extends R.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(r,n,h,S){super(),this.h=r,this.j=n,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=T().zlib.createInflateRaw(S),this.b.on("error",I=>{this.h.traceSocketEvent("zlibInflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.h.traceSocketEvent("zlibInflateData",I),this.g.push(c.VSBuffer.wrap(I))}),h&&(this.h.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this.b.write(h.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=c.VSBuffer.concat(this.g);this.g.length=0,r(n)})}}class p extends R.Disposable{constructor(r,n){super(),this.g=r,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.b=T().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",h=>{this.g.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this.a.fire(h)}),this.b.on("data",h=>{this.g.traceSocketEvent("zlibDeflateData",h),this.f.push(c.VSBuffer.wrap(h))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=c.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),r(n)})}}function b(u,r){if(r===0)return;const n=u.byteLength>>>2;for(let q=0;q<n;q++){const M=u.readUInt32BE(q*4);u.writeUInt32BE(M^r,q*4)}const h=n*4,S=u.byteLength-h,I=r>>>24&255,F=r>>>16&255,K=r>>>8&255;S>=1&&u.writeUInt8(u.readUInt8(h)^I,h),S>=2&&u.writeUInt8(u.readUInt8(h+1)^F,h+1),S>=3&&u.writeUInt8(u.readUInt8(h+2)^K,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function g(){const u=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):r=(0,k.join)(T().os.tmpdir(),`vscode-ipc-${u}.sock`),l(r),r}e.createRandomIPCHandle=g;function i(u,r,n){const h=T().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${n}-${r}-sock`;let S;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?S=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${n}-${r}.sock`):S=(0,k.join)(u,`${n}-${r}.sock`),l(S),S}e.createStaticIPCHandle=i;function l(u){const r=E[A.platform];typeof r=="number"&&u.length>=r&&console.warn(`WARNING: IPC handle "${u}" is longer than ${r} chars, try a shorter --user-data-dir`)}class o extends C.IPCServer{static b(r){const n=P.Event.fromNodeEventEmitter(r,"connection");return P.Event.map(n,h=>({protocol:new L.Protocol(new v(h,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(h,"close"))}))}constructor(r){super(o.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=o;function a(u){return new Promise((r,n)=>{const h=T().net.createServer();h.on("error",n),h.listen(u,()=>{h.removeListener("error",n),r(new o(h))})})}e.serve=a;function s(u,r){return new Promise((n,h)=>{const S=T().net.createConnection(u,()=>{S.removeListener("error",h),n(L.Client.fromSocket(new v(S,`ipc-client${r}`),r))});S.once("error",h)})}e.connect=s}),define(ye[163],Ce([1,0,39,11]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(R,k,A,y,C,L){if(Array.isArray(R)){let T=0;for(const v of R){const D=P(v,k,A,y,C,L);if(D===10)return D;D>T&&(T=D)}return T}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:T,pattern:v,scheme:D,hasAccessToAllModels:w,notebookType:f}=R;if(!y&&!w)return 0;f&&C&&(k=C);let d=0;if(D)if(D===k.scheme)d=10;else if(D==="*")d=5;else return 0;if(T)if(T===A)d=10;else if(T==="*")d=Math.max(d,5);else return 0;if(f)if(f===L)d=10;else if(f==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let m;if(typeof v=="string"?m=v:m={...v,base:(0,t.normalize)(v.base)},m===k.fsPath||(0,c.match)(m,k.fsPath))d=10;else return 0}return d}else return 0}}e.score=P}),define(ye[164],Ce([1,0,8,52,154]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,C,L){this.c=A,this.d=y,this.f=C,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const C of y)this.n(C.range),this.o(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,C=new Uint32Array(y);for(let L=0;L<y;L++)C[L]=this.d[L].length+A;this.h=new P.PrefixSumComputer(C)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const C=(0,c.splitLines)(y);if(C.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+C[0]+this.d[A.lineNumber-1].substring(A.column-1));return}C[C.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+C[0]);const L=new Uint32Array(C.length-1);for(let T=1;T<C.length;T++)this.d.splice(A.lineNumber+T-1,0,C[T]),L[T-1]=C[T].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[165],Ce([1,0,8,151,52,36,107]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(p,b,E,g){this.searchString=p,this.isRegex=b,this.matchCase=E,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=C(this.searchString):p=this.searchString.indexOf(`
`)>=0;let b=null;try{b=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!b)return null;let E=!this.isRegex&&!p;return E&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(E=this.matchCase),new k.SearchData(b,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,E?this.searchString:null)}}e.SearchParams=y;function C(m){if(!m||m.length===0)return!1;for(let p=0,b=m.length;p<b;p++){const E=m.charCodeAt(p);if(E===10)return!0;if(E===92){if(p++,p>=b)break;const g=m.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=C;function L(m,p,b){if(!b)return new k.FindMatch(m,null);const E=[];for(let g=0,i=p.length;g<i;g++)E[g]=p[g];return new k.FindMatch(m,E)}e.createFindMatch=L;class T{constructor(p){const b=[];let E=0;for(let g=0,i=p.length;g<i;g++)p.charCodeAt(g)===10&&(b[E++]=g);this.a=b}findLineFeedCountBeforeOffset(p){const b=this.a;let E=0,g=b.length-1;if(g===-1||p<=b[0])return 0;for(;E<g;){const i=E+((g-E)/2>>0);b[i]>=p?g=i-1:b[i+1]>=p?(E=i,g=i):E=i+1}return E+1}}class v{static findMatches(p,b,E,g,i){const l=b.parseSearchRequest();return l?l.regex.multiline?this.b(p,E,new d(l.wordSeparators,l.regex),g,i):this.c(p,E,l,g,i):[]}static a(p,b,E,g,i,l){let o,a=0;g?(a=g.findLineFeedCountBeforeOffset(i),o=b+i+a):o=b+i;let s;if(g){const h=g.findLineFeedCountBeforeOffset(i+l.length)-a;s=o+l.length+h}else s=o+l.length;const u=p.getPositionAt(o),r=p.getPositionAt(s);return new R.Range(u.lineNumber,u.column,r.lineNumber,r.column)}static b(p,b,E,g,i){const l=p.getOffsetAt(b.getStartPosition()),o=p.getValueInRange(b,1),a=p.getEOL()===`\r
`?new T(o):null,s=[];let u=0,r;for(E.reset(0);r=E.next(o);)if(s[u++]=L(this.a(p,l,o,a,r.index,r[0]),r,g),u>=i)return s;return s}static c(p,b,E,g,i){const l=[];let o=0;if(b.startLineNumber===b.endLineNumber){const s=p.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return o=this.d(E,s,b.startLineNumber,b.startColumn-1,o,l,g,i),l}const a=p.getLineContent(b.startLineNumber).substring(b.startColumn-1);o=this.d(E,a,b.startLineNumber,b.startColumn-1,o,l,g,i);for(let s=b.startLineNumber+1;s<b.endLineNumber&&o<i;s++)o=this.d(E,p.getLineContent(s),s,0,o,l,g,i);if(o<i){const s=p.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);o=this.d(E,s,b.endLineNumber,0,o,l,g,i)}return l}static d(p,b,E,g,i,l,o,a){const s=p.wordSeparators;if(!o&&p.simpleSearch){const n=p.simpleSearch,h=n.length,S=b.length;let I=-h;for(;(I=b.indexOf(n,I+h))!==-1;)if((!s||f(s,b,S,I,h))&&(l[i++]=new k.FindMatch(new R.Range(E,I+1+g,E,I+1+h+g),null),i>=a))return i;return i}const u=new d(p.wordSeparators,p.regex);let r;u.reset(0);do if(r=u.next(b),r&&(l[i++]=L(new R.Range(E,r.index+1+g,E,r.index+1+r[0].length+g),r,o),i>=a))return i;while(r);return i}static findNextMatch(p,b,E,g){const i=b.parseSearchRequest();if(!i)return null;const l=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(p,E,l,g):this.f(p,E,l,g)}static e(p,b,E,g){const i=new P.Position(b.lineNumber,1),l=p.getOffsetAt(i),o=p.getLineCount(),a=p.getValueInRange(new R.Range(i.lineNumber,i.column,o,p.getLineMaxColumn(o)),1),s=p.getEOL()===`\r
`?new T(a):null;E.reset(b.column-1);const u=E.next(a);return u?L(this.a(p,l,a,s,u.index,u[0]),u,g):b.lineNumber!==1||b.column!==1?this.e(p,new P.Position(1,1),E,g):null}static f(p,b,E,g){const i=p.getLineCount(),l=b.lineNumber,o=p.getLineContent(l),a=this.g(E,o,l,b.column,g);if(a)return a;for(let s=1;s<=i;s++){const u=(l+s-1)%i,r=p.getLineContent(u+1),n=this.g(E,r,u+1,1,g);if(n)return n}return null}static g(p,b,E,g,i){p.reset(g-1);const l=p.next(b);return l?L(new R.Range(E,l.index+1,E,l.index+1+l[0].length),l,i):null}static findPreviousMatch(p,b,E,g){const i=b.parseSearchRequest();if(!i)return null;const l=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(p,E,l,g):this.j(p,E,l,g)}static h(p,b,E,g){const i=this.b(p,new R.Range(1,1,b.lineNumber,b.column),E,g,10*A);if(i.length>0)return i[i.length-1];const l=p.getLineCount();return b.lineNumber!==l||b.column!==p.getLineMaxColumn(l)?this.h(p,new P.Position(l,p.getLineMaxColumn(l)),E,g):null}static j(p,b,E,g){const i=p.getLineCount(),l=b.lineNumber,o=p.getLineContent(l).substring(0,b.column-1),a=this.k(E,o,l,g);if(a)return a;for(let s=1;s<=i;s++){const u=(i+l-s-1)%i,r=p.getLineContent(u+1),n=this.k(E,r,u+1,g);if(n)return n}return null}static k(p,b,E,g){let i=null,l;for(p.reset(0);l=p.next(b);)i=L(new R.Range(E,l.index+1,E,l.index+1+l[0].length),l,g);return i}}e.TextModelSearch=v;function D(m,p,b,E,g){if(E===0)return!0;const i=p.charCodeAt(E-1);if(m.get(i)!==0||i===13||i===10)return!0;if(g>0){const l=p.charCodeAt(E);if(m.get(l)!==0)return!0}return!1}function w(m,p,b,E,g){if(E+g===b)return!0;const i=p.charCodeAt(E+g);if(m.get(i)!==0||i===13||i===10)return!0;if(g>0){const l=p.charCodeAt(E+g-1);if(m.get(l)!==0)return!0}return!1}function f(m,p,b,E,g){return D(m,p,b,E,g)&&w(m,p,b,E,g)}e.isValidMatch=f;class d{constructor(p,b){this._wordSeparators=p,this.a=b,this.b=-1,this.c=0}reset(p){this.a.lastIndex=p,this.b=-1,this.c=0}next(p){const b=p.length;let E;do{if(this.b+this.c===b||(E=this.a.exec(p),!E))return null;const g=E.index,i=E[0].length;if(g===this.b&&i===this.c){if(i===0){c.getNextCodePoint(p,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=i,!this._wordSeparators||f(this._wordSeparators,p,b,g,i))return E}while(E);return null}}e.Searcher=d}),define(ye[120],Ce([1,0,22,12]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(P||(P={}));function R(T){for(let v=0,D=T.length;v<D;v+=4){const w=T[v+0],f=T[v+1],d=T[v+2],m=T[v+3];T[v+0]=m,T[v+1]=d,T[v+2]=f,T[v+3]=w}}function k(T){const v=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return t.isLittleEndian()||R(v),c.VSBuffer.wrap(v)}function A(T){const v=T.buffer;if(t.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const D=new Uint8Array(v.byteLength);return D.set(v),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function y(T){const v=new Uint32Array(C(T));let D=0;if(v[D++]=T.id,T.type==="full")v[D++]=1,v[D++]=T.data.length,v.set(T.data,D),D+=T.data.length;else{v[D++]=2,v[D++]=T.deltas.length;for(const w of T.deltas)v[D++]=w.start,v[D++]=w.deleteCount,w.data?(v[D++]=w.data.length,v.set(w.data,D),D+=w.data.length):v[D++]=0}return k(v)}e.encodeSemanticTokensDto=y;function C(T){let v=0;if(v+=1+1,T.type==="full")v+=1+T.data.length;else{v+=1,v+=(1+1+1)*T.deltas.length;for(const D of T.deltas)D.data&&(v+=D.data.length)}return v}function L(T){const v=A(T);let D=0;const w=v[D++];if(v[D++]===1){const p=v[D++],b=v.subarray(D,D+p);return D+=p,{id:w,type:"full",data:b}}const d=v[D++],m=[];for(let p=0;p<d;p++){const b=v[D++],E=v[D++],g=v[D++];let i;g>0&&(i=v.subarray(D,D+g),D+=g),m[p]={start:b,deleteCount:E,data:i}}return{id:w,type:"delta",deltas:m}}e.decodeSemanticTokensDto=L}),define(ye[166],Ce([1,0,3,6]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class P{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const C=new R(this,A,y);return this.b.set(A,C),(0,t.toDisposable)(()=>{const L=this.b.get(A);!L||L!==C||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const C=this.b.get(A);return!C||C.isResolved?null:(await C.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const C=this.b.get(A);return!!(!C||C.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=P;class R extends t.Disposable{get isResolved(){return this.c}constructor(A,y,C){super(),this.f=A,this.g=y,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[70],Ce([1,0,50,2,36,166]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(h,S,I){this._tokenBrand=void 0,this.offset=h,this.type=S,this.language=I}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class A{constructor(h,S){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=S}}e.TokenizationResult=A;class y{constructor(h,S){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=S}}e.EncodedTokenizationResult=y;var C;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(n){const h=new Map;h.set(0,c.Codicon.symbolMethod),h.set(1,c.Codicon.symbolFunction),h.set(2,c.Codicon.symbolConstructor),h.set(3,c.Codicon.symbolField),h.set(4,c.Codicon.symbolVariable),h.set(5,c.Codicon.symbolClass),h.set(6,c.Codicon.symbolStruct),h.set(7,c.Codicon.symbolInterface),h.set(8,c.Codicon.symbolModule),h.set(9,c.Codicon.symbolProperty),h.set(10,c.Codicon.symbolEvent),h.set(11,c.Codicon.symbolOperator),h.set(12,c.Codicon.symbolUnit),h.set(13,c.Codicon.symbolValue),h.set(15,c.Codicon.symbolEnum),h.set(14,c.Codicon.symbolConstant),h.set(15,c.Codicon.symbolEnum),h.set(16,c.Codicon.symbolEnumMember),h.set(17,c.Codicon.symbolKeyword),h.set(27,c.Codicon.symbolSnippet),h.set(18,c.Codicon.symbolText),h.set(19,c.Codicon.symbolColor),h.set(20,c.Codicon.symbolFile),h.set(21,c.Codicon.symbolReference),h.set(22,c.Codicon.symbolCustomColor),h.set(23,c.Codicon.symbolFolder),h.set(24,c.Codicon.symbolTypeParameter),h.set(25,c.Codicon.account),h.set(26,c.Codicon.issues);function S(K){let q=h.get(K);return q||(console.info("No codicon found for CompletionItemKind "+K),q=c.Codicon.symbolProperty),q}n.toIcon=S;const I=new Map;I.set("method",0),I.set("function",1),I.set("constructor",2),I.set("field",3),I.set("variable",4),I.set("class",5),I.set("struct",6),I.set("interface",7),I.set("module",8),I.set("property",9),I.set("event",10),I.set("operator",11),I.set("unit",12),I.set("value",13),I.set("constant",14),I.set("enum",15),I.set("enum-member",16),I.set("enumMember",16),I.set("keyword",17),I.set("snippet",27),I.set("text",18),I.set("color",19),I.set("file",20),I.set("reference",21),I.set("customcolor",22),I.set("folder",23),I.set("type-parameter",24),I.set("typeParameter",24),I.set("account",25),I.set("issue",26);function F(K,q){let M=I.get(K);return typeof M>"u"&&!q&&(M=9),M}n.fromString=F})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(n){return n&&t.URI.isUri(n.uri)&&P.Range.isIRange(n.range)&&(P.Range.isIRange(n.originSelectionRange)||P.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=p;var b;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var E;(function(n){n[n.Deprecated=1]="Deprecated"})(E=e.SymbolTag||(e.SymbolTag={}));var g;(function(n){const h=new Map;h.set(0,c.Codicon.symbolFile),h.set(1,c.Codicon.symbolModule),h.set(2,c.Codicon.symbolNamespace),h.set(3,c.Codicon.symbolPackage),h.set(4,c.Codicon.symbolClass),h.set(5,c.Codicon.symbolMethod),h.set(6,c.Codicon.symbolProperty),h.set(7,c.Codicon.symbolField),h.set(8,c.Codicon.symbolConstructor),h.set(9,c.Codicon.symbolEnum),h.set(10,c.Codicon.symbolInterface),h.set(11,c.Codicon.symbolFunction),h.set(12,c.Codicon.symbolVariable),h.set(13,c.Codicon.symbolConstant),h.set(14,c.Codicon.symbolString),h.set(15,c.Codicon.symbolNumber),h.set(16,c.Codicon.symbolBoolean),h.set(17,c.Codicon.symbolArray),h.set(18,c.Codicon.symbolObject),h.set(19,c.Codicon.symbolKey),h.set(20,c.Codicon.symbolNull),h.set(21,c.Codicon.symbolEnumMember),h.set(22,c.Codicon.symbolStruct),h.set(23,c.Codicon.symbolEvent),h.set(24,c.Codicon.symbolOperator),h.set(25,c.Codicon.symbolTypeParameter);function S(I){let F=h.get(I);return F||(console.info("No codicon found for SymbolKind "+I),F=c.Codicon.symbolProperty),F}n.toIcon=S})(g=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(h){this.value=h}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var l;(function(n){function h(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}n.is=h})(l=e.Command||(e.Command={}));var o;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var u;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var r;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(r=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[167],Ce([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],Ce([1,0,167,12,106,16,23,150]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=C;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor($,le,Ie,Le){this.id=$,this.name=le,this.defaultValue=Ie,this.schema=Le}applyUpdate($,le){return D($,le)}compute($,le,Ie){return Ie}}class v{constructor($,le){this.newValue=$,this.didChange=le}}e.ApplyUpdateResult=v;function D(ae,$){if(typeof ae!="object"||typeof $!="object"||!ae||!$)return new v($,ae!==$);if(Array.isArray(ae)||Array.isArray($)){const Ie=Array.isArray(ae)&&Array.isArray($)&&R.equals(ae,$);return new v($,!Ie)}let le=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=D(ae[Ie],$[Ie]);Le.didChange&&(ae[Ie]=Le.newValue,le=!0)}return new v(ae,le)}class w{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,le){return D($,le)}validate($){return this.defaultValue}}class f{constructor($,le,Ie,Le){this.id=$,this.name=le,this.defaultValue=Ie,this.schema=Le}applyUpdate($,le){return D($,le)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,le,Ie){return Ie}}function d(ae,$){return typeof ae>"u"?$:ae==="false"?!1:Boolean(ae)}e.boolean=d;class m extends f{constructor($,le,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,le,Ie,Le)}validate($){return d($,this.defaultValue)}}function p(ae,$,le,Ie){if(typeof ae>"u")return $;let Le=parseInt(ae,10);return isNaN(Le)?$:(Le=Math.max(le,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=p;class b extends f{static clampedInt($,le,Ie,Le){return p($,le,Ie,Le)}constructor($,le,Ie,Le,$e,Xe=void 0){typeof Xe<"u"&&(Xe.type="integer",Xe.default=Ie,Xe.minimum=Le,Xe.maximum=$e),super($,le,Ie,Xe),this.minimum=Le,this.maximum=$e}validate($){return b.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class E extends f{static clamp($,le,Ie){return $<le?le:$>Ie?Ie:$}static float($,le){if(typeof $=="number")return $;if(typeof $>"u")return le;const Ie=parseFloat($);return isNaN(Ie)?le:Ie}constructor($,le,Ie,Le,$e){typeof $e<"u"&&($e.type="number",$e.default=Ie),super($,le,Ie,$e),this.validationFn=Le}validate($){return this.validationFn(E.float($,this.defaultValue))}}class g extends f{static string($,le){return typeof $!="string"?le:$}constructor($,le,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,le,Ie,Le)}validate($){return g.string($,this.defaultValue)}}function i(ae,$,le){return typeof ae!="string"||le.indexOf(ae)===-1?$:ae}e.stringSet=i;class l extends f{constructor($,le,Ie,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.enum=Le,$e.default=Ie),super($,le,Ie,$e),this.c=Le}validate($){return i($,this.defaultValue,this.c)}}class o extends T{constructor($,le,Ie,Le,$e,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=$e,Ze.default=Le),super($,le,Ie,Ze),this.c=$e,this.d=Xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function a(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,le,Ie){return Ie===0?$.accessibilitySupport:Ie}}class u extends T{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:c.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{insertSpace:d(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(ae){switch(ae){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function I(ae){switch(ae){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class F extends w{constructor(){super(135)}compute($,le,Ie){const Le=["monaco-editor"];return le.get(36)&&Le.push(le.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),le.get(70)==="default"?Le.push("mouse-default"):le.get(70)==="copy"&&Le.push("mouse-copy"),le.get(105)&&Le.push("showUnused"),le.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class K extends m{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute($,le,Ie){return Ie&&$.emptySelectionClipboard}}class q extends T{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:c.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{cursorMoveOnType:d(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":i(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":i(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(le.loop,this.defaultValue.loop)}}}class M extends T{constructor(){super(48,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?M.OFF:$==="true"?M.ON:$:Boolean($)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class B extends T{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?B.OFF:$==="true"?B.TRANSLATE:$:Boolean($)?B.TRANSLATE:B.OFF}compute($,le,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class O extends w{constructor(){super(47)}compute($,le,Ie){return $.fontInfo}}class U extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate($){const le=E.float($,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(le,6,100)}compute($,le,Ie){return $.fontInfo.fontSize}}class z extends T{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(b.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class j extends T{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...le},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...le},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...le},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{multiple:i(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??i(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??i(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??i(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??i(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??i(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ue extends T{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:c.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),delay:b.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:d(le.sticky,this.defaultValue.sticky),above:d(le.above,this.defaultValue.above)}}}var V;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class _ extends w{constructor(){super(138)}compute($,le,Ie){return _.computeLayout(le,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const le=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,le-1));const $e=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),Xe=Math.floor($.viewLineCount/$e);return{typicalViewportLineCount:le,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:Xe}}static c($,le){const Ie=$.outerWidth,Le=$.outerHeight,$e=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Xe=le.stableMinimapLayoutInput,Ze=Xe&&$.outerHeight===Xe.outerHeight&&$.lineHeight===Xe.lineHeight&&$.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===Xe.pixelRatio&&$.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&$.paddingTop===Xe.paddingTop&&$.paddingBottom===Xe.paddingBottom&&$.minimap.enabled===Xe.minimap.enabled&&$.minimap.side===Xe.minimap.side&&$.minimap.size===Xe.minimap.size&&$.minimap.showSlider===Xe.minimap.showSlider&&$.minimap.renderCharacters===Xe.minimap.renderCharacters&&$.minimap.maxColumn===Xe.minimap.maxColumn&&$.minimap.scale===Xe.minimap.scale&&$.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&$.isViewportWrapping===Xe.isViewportWrapping,pt=$.lineHeight,mt=$.typicalHalfwidthCharacterWidth,ct=$.scrollBeyondLastLine,Et=$.minimap.renderCharacters;let tt=$e>=2?Math.round($.minimap.scale*2):$.minimap.scale;const ft=$.minimap.maxColumn,At=$.minimap.size,Xt=$.minimap.side,Rt=$.verticalScrollbarWidth,gt=$.viewLineCount,Tt=$.remainingWidth,$t=$.isViewportWrapping,Nt=Et?2:3;let xe=Math.floor($e*Le);const Mt=xe/$e;let Ut=!1,Wt=!1,bt=Nt*tt,Re=tt/$e,Oe=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:lt,extraLinesBeyondLastLine:Pt,desiredRatio:St,minimapLineCount:yt}=_.computeContainedMinimapLineCount({viewLineCount:gt,scrollBeyondLastLine:ct,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:pt,pixelRatio:$e});if(gt/yt>1)Ut=!0,Wt=!0,tt=1,bt=1,Re=tt/$e;else{let Ct=!1,Dt=tt+1;if(At==="fit"){const qt=Math.ceil((lt+gt+Pt)*bt);$t&&Ze&&Tt<=le.stableFitRemainingWidth?(Ct=!0,Dt=le.stableFitMaxMinimapScale):Ct=qt>xe}if(At==="fill"||Ct){Ut=!0;const qt=tt;bt=Math.min(pt*$e,Math.max(1,Math.floor(1/St))),$t&&Ze&&Tt<=le.stableFitRemainingWidth&&(Dt=le.stableFitMaxMinimapScale),tt=Math.min(Dt,Math.max(1,Math.floor(bt/Nt))),tt>qt&&(Oe=Math.min(2,tt/qt)),Re=tt/$e/Oe,xe=Math.ceil(Math.max(it,lt+gt+Pt)*bt),$t?(le.stableMinimapLayoutInput=$,le.stableFitRemainingWidth=Tt,le.stableFitMaxMinimapScale=tt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Re),re=Math.min(Se,Math.max(0,Math.floor((Tt-Rt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor($e*re);const He=Ne/$e;Ne=Math.floor(Ne*Oe);const _e=Et?1:2,je=Xt==="left"?0:Ie-re-Rt;return{renderMinimap:_e,minimapLeft:je,minimapWidth:re,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:tt,minimapLineHeight:bt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:xe,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:Mt}}static computeLayout($,le){const Ie=le.outerWidth|0,Le=le.outerHeight|0,$e=le.lineHeight|0,Xe=le.lineNumbersDigitCount|0,Ze=le.typicalHalfwidthCharacterWidth,pt=le.maxDigitWidth,mt=le.pixelRatio,ct=le.viewLineCount,Et=$.get(130),tt=Et==="inherit"?$.get(129):Et,ft=tt==="inherit"?$.get(125):tt,At=$.get(128),Xt=le.isDominatedByLongLines,Rt=$.get(54),gt=$.get(64).renderType!==0,Tt=$.get(65),$t=$.get(99),Nt=$.get(80),xe=$.get(69),Mt=$.get(97),Ut=Mt.verticalScrollbarSize,Wt=Mt.verticalHasArrows,bt=Mt.arrowSize,Re=Mt.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let re=$.get(62);Oe&&Se&&(re+=16);let Ne=0;if(gt){const vt=Math.max(Xe,Tt);Ne=Math.round(vt*pt)}let He=0;Rt&&(He=$e);let _e=0,je=_e+He,it=je+Ne,lt=it+re;const Pt=Ie-He-Ne-re;let St=!1,yt=!1,kt=-1;tt==="inherit"&&Xt?(St=!0,yt=!0):ft==="on"||ft==="bounded"?yt=!0:ft==="wordWrapColumn"&&(kt=At);const Ct=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:$e,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:$t,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:xe,verticalScrollbarWidth:Ut,viewLineCount:ct,remainingWidth:Pt,isViewportWrapping:yt},le.memory||new L);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(_e+=Ct.minimapWidth,je+=Ct.minimapWidth,it+=Ct.minimapWidth,lt+=Ct.minimapWidth);const Dt=Pt-Ct.minimapWidth,qt=Math.max(1,Math.floor((Dt-Ut-2)/Ze)),Jt=Wt?bt:0;return yt&&(kt=Math.max(1,qt),ft==="bounded"&&(kt=Math.min(kt,At))),{width:Ie,height:Le,glyphMarginLeft:_e,glyphMarginWidth:He,lineNumbersLeft:je,lineNumbersWidth:Ne,decorationsLeft:it,decorationsWidth:re,contentLeft:lt,contentWidth:Dt,minimap:Ct,viewportColumn:qt,isWordWrapMinified:St,isViewportWrapping:yt,wrappingColumn:kt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Re,overviewRuler:{top:Jt,width:Ut,height:Le-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=_;class J extends T{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate($){return i($,"simple",["simple","advanced"])}compute($,le,Ie){return le.get(2)===2?"advanced":Ie}}class ie extends T{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:c.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(le.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends T{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:c.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return typeof le.enabled=="boolean"&&(le.enabled=le.enabled?"on":"off"),{enabled:i(le.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(le.fontFamily,this.defaultValue.fontFamily),padding:d(le.padding,this.defaultValue.padding)}}}class G extends T{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):b.clampedInt($,this.defaultValue,0,1e3)}compute($,le,Ie){return Ie<0?b.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class de extends E{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>E.clamp($,0,150),{markdownDescription:c.localize(60,null)})}compute($,le,Ie){return $.fontInfo.lineHeight}}class be extends T{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:$.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:c.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),autohide:d(le.autohide,this.defaultValue.autohide),size:i(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(le.side,this.defaultValue.side,["right","left"]),showSlider:i(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(le.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(le.scale,1,1,3),maxColumn:b.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(ae){return ae==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Pe extends T{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{top:b.clampedInt(le.top,0,0,1e3),bottom:b.clampedInt(le.bottom,0,0,1e3)}}}class Fe extends T{constructor(){const $={enabled:!0,cycle:!0};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:c.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),cycle:d(le.cycle,this.defaultValue.cycle)}}}class se extends w{constructor(){super(136)}compute($,le,Ie){return $.pixelRatio}}class oe extends T{constructor(){const $={other:"on",comments:"off",strings:"off"},le=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:le,default:$.strings,description:c.localize(79,null)},comments:{anyOf:le,default:$.comments,description:c.localize(80,null)},other:{anyOf:le,default:$.other,description:c.localize(81,null)}},default:$,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const mt=$?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!$||typeof $!="object")return this.defaultValue;const{other:le,comments:Ie,strings:Le}=$,$e=["on","inline","off"];let Xe,Ze,pt;return typeof le=="boolean"?Xe=le?"on":"off":Xe=i(le,this.defaultValue.other,$e),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,$e),typeof Le=="boolean"?pt=Le?"on":"off":pt=i(Le,this.defaultValue.strings,$e),{other:Xe,comments:Ze,strings:pt}}}var fe;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends T{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate($){let le=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(le=4,Ie=$):$==="interval"?le=3:$==="relative"?le=2:$==="on"?le=1:le=0),{renderType:le,renderFn:Ie}}}function ce(ae){const $=ae.get(92);return $==="editable"?ae.get(86):$!=="on"}e.filterValidationDecorations=ce;class ne extends T{constructor(){const $=[],le={type:"number",description:c.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:$,description:c.localize(90,null)})}validate($){if(Array.isArray($)){const le=[];for(const Ie of $)if(typeof Ie=="number")le.push({column:b.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;le.push({column:b.clampedInt(Le.column,0,0,1e4),color:Le.color})}return le.sort((Ie,Le)=>Ie.column-Le.column),le}return this.defaultValue}}function N(ae,$){if(typeof ae!="string")return $;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends T{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:c.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$,Ie=b.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=b.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(le.vertical,this.defaultValue.vertical),horizontal:N(le.horizontal,this.defaultValue.horizontal),useShadows:d(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:b.clampedInt(le.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:b.clampedInt(le.verticalSliderSize,Le,0,1e3),scrollByPage:d(le.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends T{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:c.localize(108,null)}})}applyUpdate($,le){let Ie=!1;le.allowedCharacters&&$&&(k.equals($.allowedCharacters,le.allowedCharacters)||($={...$,allowedCharacters:le.allowedCharacters},Ie=!0)),le.allowedLocales&&$&&(k.equals($.allowedLocales,le.allowedLocales)||($={...$,allowedLocales:le.allowedLocales},Ie=!0));const Le=super.applyUpdate($,le);return Ie?new v(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{nonBasicASCII:Ae(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,le){if(typeof $!="object"||!$)return le;const Ie={};for(const[Le,$e]of Object.entries($))$e===!0&&(Ie[Le]=!0);return Ie}}class Y extends T{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:c.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),mode:i(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class he extends T{constructor(){const $={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:c.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(le.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends T{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(112,null),c.localize(113,null),c.localize(114,null)],default:$.bracketPairs,description:c.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(116,null),c.localize(117,null),c.localize(118,null)],default:$.bracketPairsHorizontal,description:c.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:c.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:c.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(122,null),c.localize(123,null),c.localize(124,null)],default:$.highlightActiveIndentation,description:c.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{bracketPairs:Ae(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ae,$,le){const Ie=le.indexOf(ae);return Ie===-1?$:le[Ie]}class pe extends T{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(126,null),c.localize(127,null)],default:$.insertMode,description:c.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:c.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:c.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:c.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(132,null),c.localize(133,null),c.localize(134,null),c.localize(135,null)],default:$.selectionMode,markdownDescription:c.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:c.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:c.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:c.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:c.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:c.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{insertMode:i(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(le.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(le.showIcons,this.defaultValue.showIcons),showStatusBar:d(le.showStatusBar,this.defaultValue.showStatusBar),preview:d(le.preview,this.defaultValue.preview),previewMode:i(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(le.showMethods,this.defaultValue.showMethods),showFunctions:d(le.showFunctions,this.defaultValue.showFunctions),showConstructors:d(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(le.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(le.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(le.showFields,this.defaultValue.showFields),showVariables:d(le.showVariables,this.defaultValue.showVariables),showClasses:d(le.showClasses,this.defaultValue.showClasses),showStructs:d(le.showStructs,this.defaultValue.showStructs),showInterfaces:d(le.showInterfaces,this.defaultValue.showInterfaces),showModules:d(le.showModules,this.defaultValue.showModules),showProperties:d(le.showProperties,this.defaultValue.showProperties),showEvents:d(le.showEvents,this.defaultValue.showEvents),showOperators:d(le.showOperators,this.defaultValue.showOperators),showUnits:d(le.showUnits,this.defaultValue.showUnits),showValues:d(le.showValues,this.defaultValue.showValues),showConstants:d(le.showConstants,this.defaultValue.showConstants),showEnums:d(le.showEnums,this.defaultValue.showEnums),showEnumMembers:d(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(le.showKeywords,this.defaultValue.showKeywords),showWords:d(le.showWords,this.defaultValue.showWords),showColors:d(le.showColors,this.defaultValue.showColors),showFiles:d(le.showFiles,this.defaultValue.showFiles),showReferences:d(le.showReferences,this.defaultValue.showReferences),showFolders:d(le.showFolders,this.defaultValue.showFolders),showTypeParameters:d(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(le.showSnippets,this.defaultValue.showSnippets),showUsers:d(le.showUsers,this.defaultValue.showUsers),showIssues:d(le.showIssues,this.defaultValue.showIssues)}}}class De extends T{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(174,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends w{constructor(){super(137)}compute($,le,Ie){return le.get(86)?!0:$.tabFocusMode}}var Ve;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ve=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends T{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(175,null),c.localize(176,null),c.localize(177,null),c.localize(178,null)],description:c.localize(179,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,le,Ie){return le.get(2)===2?0:Ie}}class et extends w{constructor(){super(139)}compute($,le,Ie){const Le=le.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends T{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(180,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var rt;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.autoClosingBrackets=5]="autoClosingBrackets",ae[ae.autoClosingDelete=6]="autoClosingDelete",ae[ae.autoClosingOvertype=7]="autoClosingOvertype",ae[ae.autoClosingQuotes=8]="autoClosingQuotes",ae[ae.autoIndent=9]="autoIndent",ae[ae.automaticLayout=10]="automaticLayout",ae[ae.autoSurround=11]="autoSurround",ae[ae.bracketPairColorization=12]="bracketPairColorization",ae[ae.guides=13]="guides",ae[ae.codeLens=14]="codeLens",ae[ae.codeLensFontFamily=15]="codeLensFontFamily",ae[ae.codeLensFontSize=16]="codeLensFontSize",ae[ae.colorDecorators=17]="colorDecorators",ae[ae.colorDecoratorsLimit=18]="colorDecoratorsLimit",ae[ae.columnSelection=19]="columnSelection",ae[ae.comments=20]="comments",ae[ae.contextmenu=21]="contextmenu",ae[ae.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=23]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=25]="cursorStyle",ae[ae.cursorSurroundingLines=26]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=28]="cursorWidth",ae[ae.disableLayerHinting=29]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ae[ae.domReadOnly=31]="domReadOnly",ae[ae.dragAndDrop=32]="dragAndDrop",ae[ae.dropIntoEditor=33]="dropIntoEditor",ae[ae.emptySelectionClipboard=34]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=36]="extraEditorClassName",ae[ae.fastScrollSensitivity=37]="fastScrollSensitivity",ae[ae.find=38]="find",ae[ae.fixedOverflowWidgets=39]="fixedOverflowWidgets",ae[ae.folding=40]="folding",ae[ae.foldingStrategy=41]="foldingStrategy",ae[ae.foldingHighlight=42]="foldingHighlight",ae[ae.foldingImportsByDefault=43]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=44]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=46]="fontFamily",ae[ae.fontInfo=47]="fontInfo",ae[ae.fontLigatures=48]="fontLigatures",ae[ae.fontSize=49]="fontSize",ae[ae.fontWeight=50]="fontWeight",ae[ae.fontVariations=51]="fontVariations",ae[ae.formatOnPaste=52]="formatOnPaste",ae[ae.formatOnType=53]="formatOnType",ae[ae.glyphMargin=54]="glyphMargin",ae[ae.gotoLocation=55]="gotoLocation",ae[ae.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ae[ae.hover=57]="hover",ae[ae.inDiffEditor=58]="inDiffEditor",ae[ae.inlineSuggest=59]="inlineSuggest",ae[ae.letterSpacing=60]="letterSpacing",ae[ae.lightbulb=61]="lightbulb",ae[ae.lineDecorationsWidth=62]="lineDecorationsWidth",ae[ae.lineHeight=63]="lineHeight",ae[ae.lineNumbers=64]="lineNumbers",ae[ae.lineNumbersMinChars=65]="lineNumbersMinChars",ae[ae.linkedEditing=66]="linkedEditing",ae[ae.links=67]="links",ae[ae.matchBrackets=68]="matchBrackets",ae[ae.minimap=69]="minimap",ae[ae.mouseStyle=70]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=72]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=74]="multiCursorModifier",ae[ae.multiCursorPaste=75]="multiCursorPaste",ae[ae.multiCursorLimit=76]="multiCursorLimit",ae[ae.occurrencesHighlight=77]="occurrencesHighlight",ae[ae.overviewRulerBorder=78]="overviewRulerBorder",ae[ae.overviewRulerLanes=79]="overviewRulerLanes",ae[ae.padding=80]="padding",ae[ae.parameterHints=81]="parameterHints",ae[ae.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=84]="quickSuggestions",ae[ae.quickSuggestionsDelay=85]="quickSuggestionsDelay",ae[ae.readOnly=86]="readOnly",ae[ae.renameOnType=87]="renameOnType",ae[ae.renderControlCharacters=88]="renderControlCharacters",ae[ae.renderFinalNewline=89]="renderFinalNewline",ae[ae.renderLineHighlight=90]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=92]="renderValidationDecorations",ae[ae.renderWhitespace=93]="renderWhitespace",ae[ae.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ae[ae.roundedSelection=95]="roundedSelection",ae[ae.rulers=96]="rulers",ae[ae.scrollbar=97]="scrollbar",ae[ae.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=99]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=100]="scrollPredominantAxis",ae[ae.selectionClipboard=101]="selectionClipboard",ae[ae.selectionHighlight=102]="selectionHighlight",ae[ae.selectOnLineNumbers=103]="selectOnLineNumbers",ae[ae.showFoldingControls=104]="showFoldingControls",ae[ae.showUnused=105]="showUnused",ae[ae.snippetSuggestions=106]="snippetSuggestions",ae[ae.smartSelect=107]="smartSelect",ae[ae.smoothScrolling=108]="smoothScrolling",ae[ae.stickyScroll=109]="stickyScroll",ae[ae.stickyTabStops=110]="stickyTabStops",ae[ae.stopRenderingLineAfter=111]="stopRenderingLineAfter",ae[ae.suggest=112]="suggest",ae[ae.suggestFontSize=113]="suggestFontSize",ae[ae.suggestLineHeight=114]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ae[ae.suggestSelection=116]="suggestSelection",ae[ae.tabCompletion=117]="tabCompletion",ae[ae.tabIndex=118]="tabIndex",ae[ae.unicodeHighlighting=119]="unicodeHighlighting",ae[ae.unusualLineTerminators=120]="unusualLineTerminators",ae[ae.useShadowDOM=121]="useShadowDOM",ae[ae.useTabStops=122]="useTabStops",ae[ae.wordBreak=123]="wordBreak",ae[ae.wordSeparators=124]="wordSeparators",ae[ae.wordWrap=125]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=128]="wordWrapColumn",ae[ae.wordWrapOverride1=129]="wordWrapOverride1",ae[ae.wordWrapOverride2=130]="wordWrapOverride2",ae[ae.wrappingIndent=131]="wrappingIndent",ae[ae.wrappingStrategy=132]="wrappingStrategy",ae[ae.showDeprecated=133]="showDeprecated",ae[ae.inlayHints=134]="inlayHints",ae[ae.editorClassName=135]="editorClassName",ae[ae.pixelRatio=136]="pixelRatio",ae[ae.tabFocusMode=137]="tabFocusMode",ae[ae.layoutInfo=138]="layoutInfo",ae[ae.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(181,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(182,null),""],markdownDescription:c.localize(183,null)})),accessibilitySupport:Me(new s),accessibilityPageSize:Me(new b(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(184,null),tags:["accessibility"]})),ariaLabel:Me(new g(4,"ariaLabel",c.localize(185,null))),autoClosingBrackets:Me(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(186,null),c.localize(187,null),""],description:c.localize(188,null)})),autoClosingDelete:Me(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(189,null),""],description:c.localize(190,null)})),autoClosingOvertype:Me(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(191,null),""],description:c.localize(192,null)})),autoClosingQuotes:Me(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(193,null),c.localize(194,null),""],description:c.localize(195,null)})),autoIndent:Me(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[c.localize(196,null),c.localize(197,null),c.localize(198,null),c.localize(199,null),c.localize(200,null)],description:c.localize(201,null)})),automaticLayout:Me(new m(10,"automaticLayout",!1)),autoSurround:Me(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),""],description:c.localize(205,null)})),bracketPairColorization:Me(new he),bracketPairGuides:Me(new we),stickyTabStops:Me(new m(110,"stickyTabStops",!1,{description:c.localize(206,null)})),codeLens:Me(new m(14,"codeLens",!0,{description:c.localize(207,null)})),codeLensFontFamily:Me(new g(15,"codeLensFontFamily","",{description:c.localize(208,null)})),codeLensFontSize:Me(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(209,null)})),colorDecorators:Me(new m(17,"colorDecorators",!0,{description:c.localize(210,null)})),colorDecoratorsLimit:Me(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(211,null)})),columnSelection:Me(new m(19,"columnSelection",!1,{description:c.localize(212,null)})),comments:Me(new u),contextmenu:Me(new m(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new m(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(213,null)})),cursorBlinking:Me(new o(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:c.localize(214,null)})),cursorSmoothCaretAnimation:Me(new l(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(215,null),c.localize(216,null),c.localize(217,null)],description:c.localize(218,null)})),cursorStyle:Me(new o(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:c.localize(219,null)})),cursorSurroundingLines:Me(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(220,null)})),cursorSurroundingLinesStyle:Me(new l(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(221,null),c.localize(222,null)],description:c.localize(223,null)})),cursorWidth:Me(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(224,null)})),disableLayerHinting:Me(new m(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new m(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new m(31,"domReadOnly",!1)),dragAndDrop:Me(new m(32,"dragAndDrop",!0,{description:c.localize(225,null)})),emptySelectionClipboard:Me(new K),dropIntoEditor:Me(new Qe),stickyScroll:Me(new ee),experimentalWhitespaceRendering:Me(new l(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(226,null),c.localize(227,null),c.localize(228,null)],description:c.localize(229,null)})),extraEditorClassName:Me(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new E(37,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:c.localize(230,null)})),find:Me(new q),fixedOverflowWidgets:Me(new m(39,"fixedOverflowWidgets",!1)),folding:Me(new m(40,"folding",!0,{description:c.localize(231,null)})),foldingStrategy:Me(new l(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(232,null),c.localize(233,null)],description:c.localize(234,null)})),foldingHighlight:Me(new m(42,"foldingHighlight",!0,{description:c.localize(235,null)})),foldingImportsByDefault:Me(new m(43,"foldingImportsByDefault",!1,{description:c.localize(236,null)})),foldingMaximumRegions:Me(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(237,null)})),unfoldOnClickAfterEndOfLine:Me(new m(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(238,null)})),fontFamily:Me(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(239,null)})),fontInfo:Me(new O),fontLigatures2:Me(new M),fontSize:Me(new U),fontWeight:Me(new z),fontVariations:Me(new B),formatOnPaste:Me(new m(52,"formatOnPaste",!1,{description:c.localize(240,null)})),formatOnType:Me(new m(53,"formatOnType",!1,{description:c.localize(241,null)})),glyphMargin:Me(new m(54,"glyphMargin",!0,{description:c.localize(242,null)})),gotoLocation:Me(new j),hideCursorInOverviewRuler:Me(new m(56,"hideCursorInOverviewRuler",!1,{description:c.localize(243,null)})),hover:Me(new ue),inDiffEditor:Me(new m(58,"inDiffEditor",!1)),letterSpacing:Me(new E(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>E.clamp(ae,-5,20),{description:c.localize(244,null)})),lightbulb:Me(new ie),lineDecorationsWidth:Me(new G),lineHeight:Me(new de),lineNumbers:Me(new Z),lineNumbersMinChars:Me(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new m(66,"linkedEditing",!1,{description:c.localize(245,null)})),links:Me(new m(67,"links",!0,{description:c.localize(246,null)})),matchBrackets:Me(new l(68,"matchBrackets","always",["always","near","never"],{description:c.localize(247,null)})),minimap:Me(new be),mouseStyle:Me(new l(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new E(71,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:c.localize(248,null)})),mouseWheelZoom:Me(new m(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(249,null)})),multiCursorMergeOverlapping:Me(new m(73,"multiCursorMergeOverlapping",!0,{description:c.localize(250,null)})),multiCursorModifier:Me(new o(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null)],markdownDescription:c.localize(253,null)})),multiCursorPaste:Me(new l(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(254,null),c.localize(255,null)],markdownDescription:c.localize(256,null)})),multiCursorLimit:Me(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(257,null)})),occurrencesHighlight:Me(new m(77,"occurrencesHighlight",!0,{description:c.localize(258,null)})),overviewRulerBorder:Me(new m(78,"overviewRulerBorder",!0,{description:c.localize(259,null)})),overviewRulerLanes:Me(new b(79,"overviewRulerLanes",3,0,3)),padding:Me(new Pe),parameterHints:Me(new Fe),peekWidgetDefaultFocus:Me(new l(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),definitionLinkOpensInPeek:Me(new m(83,"definitionLinkOpensInPeek",!1,{description:c.localize(263,null)})),quickSuggestions:Me(new oe),quickSuggestionsDelay:Me(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(264,null)})),readOnly:Me(new m(86,"readOnly",!1)),renameOnType:Me(new m(87,"renameOnType",!1,{description:c.localize(265,null),markdownDeprecationMessage:c.localize(266,null)})),renderControlCharacters:Me(new m(88,"renderControlCharacters",!0,{description:c.localize(267,null),restricted:!0})),renderFinalNewline:Me(new l(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(268,null)})),renderLineHighlight:Me(new l(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(269,null)],description:c.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Me(new m(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(271,null)})),renderValidationDecorations:Me(new l(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(272,null),c.localize(273,null),c.localize(274,null),""],description:c.localize(275,null)})),revealHorizontalRightPadding:Me(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new m(95,"roundedSelection",!0,{description:c.localize(276,null)})),rulers:Me(new ne),scrollbar:Me(new H),scrollBeyondLastColumn:Me(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(277,null)})),scrollBeyondLastLine:Me(new m(99,"scrollBeyondLastLine",!0,{description:c.localize(278,null)})),scrollPredominantAxis:Me(new m(100,"scrollPredominantAxis",!0,{description:c.localize(279,null)})),selectionClipboard:Me(new m(101,"selectionClipboard",!0,{description:c.localize(280,null),included:t.isLinux})),selectionHighlight:Me(new m(102,"selectionHighlight",!0,{description:c.localize(281,null)})),selectOnLineNumbers:Me(new m(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(282,null),c.localize(283,null),c.localize(284,null)],description:c.localize(285,null)})),showUnused:Me(new m(105,"showUnused",!0,{description:c.localize(286,null)})),showDeprecated:Me(new m(133,"showDeprecated",!0,{description:c.localize(287,null)})),inlayHints:Me(new X),snippetSuggestions:Me(new l(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(288,null),c.localize(289,null),c.localize(290,null),c.localize(291,null)],description:c.localize(292,null)})),smartSelect:Me(new De),smoothScrolling:Me(new m(108,"smoothScrolling",!1,{description:c.localize(293,null)})),stopRenderingLineAfter:Me(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new Y),suggestFontSize:Me(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new m(115,"suggestOnTriggerCharacters",!0,{description:c.localize(296,null)})),suggestSelection:Me(new l(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null),c.localize(299,null)],description:c.localize(300,null)})),tabCompletion:Me(new l(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],description:c.localize(304,null)})),tabIndex:Me(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Q),unusualLineTerminators:Me(new l(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(305,null),c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),useShadowDOM:Me(new m(121,"useShadowDOM",!0)),useTabStops:Me(new m(122,"useTabStops",!0,{description:c.localize(309,null)})),wordBreak:Me(new l(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(310,null),c.localize(311,null)],description:c.localize(312,null)})),wordSeparators:Me(new g(124,"wordSeparators",P.USUAL_WORD_SEPARATORS,{description:c.localize(313,null)})),wordWrap:Me(new l(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(314,null),c.localize(315,null),c.localize(316,null),c.localize(317,null)],description:c.localize(318,null)})),wordWrapBreakAfterCharacters:Me(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(319,null)})),wordWrapOverride1:Me(new l(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new F),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new _),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new J)}}),define(ye[168],Ce([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],Ce([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],Ce([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],Ce([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],Ce([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ye[173],Ce([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ye[174],Ce([19,20]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[175],Ce([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ye[176],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[177],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[178],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[179],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[180],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[181],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[182],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[183],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[184],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[185],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ye[186],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(ye[187],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[188],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[189],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[190],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[191],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[192],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[193],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[194],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[195],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,k){this.a.set(R,k)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const k in R.contributes){const A=this.a.get(k);if(!A)continue;const y=R.contributes[k],C=Array.isArray(y)?y:[y];try{A(C,R.activationEvents)}catch(L){(0,c.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[196],Ce([1,0,24,38,170,317]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(m){return m=m.trim(),m==="*"||k.test(m)}e.isValidVersionStr=y;function C(m){if(!y(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=m.match(k);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=C;function L(m){if(!m)return null;const p=m.majorBase,b=m.majorMustEqual,E=m.minorBase;let g=m.minorMustEqual;const i=m.patchBase;let l=m.patchMustEqual;m.hasCaret&&(p===0||(g=!1),l=!1);let o=0;if(m.preRelease){const a=A.exec(m.preRelease);if(a){const[,s,u,r]=a;o=Date.UTC(Number(s),Number(u)-1,Number(r))}}return{majorBase:p,majorMustEqual:b,minorBase:E,minorMustEqual:g,patchBase:i,patchMustEqual:l,isMinimum:m.hasGreaterEquals,notBefore:o}}e.normalizeVersion=L;function T(m,p,b){let E;typeof m=="string"?E=L(C(m)):E=m;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof b=="string"?i=L(C(b)):i=b,!E||!i)return!1;const l=E.majorBase,o=E.minorBase,a=E.patchBase;let s=i.majorBase,u=i.minorBase,r=i.patchBase;const n=i.notBefore;let h=i.majorMustEqual,S=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?l>s?!0:l<s?!1:o>u?!0:o<u||g&&g<n?!1:a>=r:(l===1&&s===0&&(!h||!S||!I)&&(s=1,u=0,r=0,h=!0,S=!1,I=!1),l<s?!1:l>s?!h:o<u?!1:o>u?!S:a<r?!1:a>r?!I:!(g&&g<n))}e.isValidVersion=T;function v(m,p,b,E,g){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([t.default.Error,P.localize(0,null)]),i;if(typeof E.name!="string")return i.push([t.default.Error,P.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([t.default.Error,P.localize(2,null,"version")]),i;if(!E.engines)return i.push([t.default.Error,P.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([t.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!d(E.extensionDependencies))return i.push([t.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!d(E.activationEvents))return i.push([t.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([t.default.Error,P.localize(7,null,"activationEvents","main")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([t.default.Warning,P.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([t.default.Error,P.localize(9,null,"main")]),i;{const a=(0,c.joinPath)(b,E.main);(0,c.isEqualOrParent)(a,b)||i.push([t.default.Warning,P.localize(10,null,a.path,b.path)])}if(typeof E.activationEvents>"u")return i.push([t.default.Error,P.localize(11,null,"activationEvents","main")]),i}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([t.default.Error,P.localize(12,null,"browser")]),i;{const a=(0,c.joinPath)(b,E.browser);(0,c.isEqualOrParent)(a,b)||i.push([t.default.Warning,P.localize(13,null,a.path,b.path)])}if(typeof E.activationEvents>"u")return i.push([t.default.Error,P.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(E.version))return i.push([t.default.Error,P.localize(15,null)]),i;const l=[];if(!D(m,p,E,g,l))for(const a of l)i.push([t.default.Error,a]);return i}e.validateExtensionManifest=v;function D(m,p,b,E,g){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(m,p,b.engines.vscode,g)}e.isValidExtensionVersion=D;function w(m,p,b){return m==="*"||f(p,b,m)}e.isEngineValid=w;function f(m,p,b,E=[]){const g=L(C(b));if(!g)return E.push(P.localize(16,null,b)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return E.push(P.localize(17,null,b)),!1}else if(!g.majorMustEqual)return E.push(P.localize(18,null,b)),!1;return T(m,p,g)?!0:(E.push(P.localize(19,null,m,b)),!1)}function d(m){if(!Array.isArray(m))return!1;for(let p=0,b=m.length;p<b;p++)if(typeof m[p]!="string")return!1;return!0}}),define(ye[122],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(P,R=[],k=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=c}),define(ye[89],Ce([1,0,122]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var P;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function R(A,y,C){y instanceof c.SyncDescriptor||(y=new c.SyncDescriptor(y,[],Boolean(C))),t.push([A,y])}e.registerSingleton=R;function k(){return t}e.getSingletonServiceDescriptors=k}),define(ye[197],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R,k){this.key=R,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const k of this.a.values())k.outgoing.size===0&&R.push(k);return R}insertEdge(R,k){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(k);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const k=this.b(R);this.a.delete(k);for(const A of this.a.values())A.outgoing.delete(k),A.incoming.delete(k)}lookupOrInsertNode(R){const k=this.b(R);let A=this.a.get(k);return A||(A=new c(k,R),this.a.set(k,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[k,A]of this.a)R.push(`${k}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,k]of this.a){const A=new Set([R]),y=this.c(k,A);if(y)return y}}c(R,k){for(const[A,y]of R.outgoing){if(k.has(A))return[...k,A].join(" -> ");k.add(A);const C=this.c(y,k);if(C)return C;k.delete(A)}}}e.Graph=t}),define(ye[4],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=A})(c=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function t(k,A,y){A[c.DI_TARGET]===A?A[c.DI_DEPENDENCIES].push({id:k,index:y}):(A[c.DI_DEPENDENCIES]=[{id:k,index:y}],A[c.DI_TARGET]=A)}function P(k){if(c.serviceIds.has(k))return c.serviceIds.get(k);const A=function(y,C,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,y,L)};return A.toString=()=>k,c.serviceIds.set(k,A),A}e.createDecorator=P;function R(k){return k}e.refineServiceDecorator=R}),define(ye[53],Ce([1,0,10,2,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function R(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=R;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var A;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function C(m,p){const b=Object.create(null);for(const E in m)L(b,E,m[E],p);return b}e.toValuesTree=C;function L(m,p,b,E){const g=p.split("."),i=g.pop();let l=m;for(let o=0;o<g.length;o++){const a=g[o];let s=l[a];switch(typeof s){case"undefined":s=l[a]=Object.create(null);break;case"object":break;default:E(`Ignoring ${p} as ${g.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}l=s}if(typeof l=="object"&&l!==null)try{l[i]=b}catch{E(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(l)}`)}else E(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=L;function T(m,p){const b=p.split(".");v(m,b)}e.removeFromValueTree=T;function v(m,p){const b=p.shift();if(p.length===0){delete m[b];return}if(Object.keys(m).indexOf(b)!==-1){const E=m[b];typeof E=="object"&&!Array.isArray(E)&&(v(E,p),Object.keys(E).length===0&&delete m[b])}}function D(m,p,b){function E(l,o){let a=l;for(const s of o){if(typeof a!="object"||a===null)return;a=a[s]}return a}const g=p.split("."),i=E(m,g);return typeof i>"u"?b:i}e.getConfigurationValue=D;function w(m,p,b){Object.keys(p).forEach(E=>{E!=="__proto__"&&(E in m?c.isObject(m[E])&&c.isObject(p[E])?w(m[E],p[E],b):b&&(m[E]=p[E]):m[E]=p[E])})}e.merge=w;function f(m,p,b){const E=m.inspect(p),g=m.inspect(b);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:E.defaultValue}e.getMigratedSettingValue=f;function d(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[54],Ce([1,0,12,8,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",c.isEdge),R.set("isFirefox",c.isFirefox),R.set("isChrome",c.isChrome),R.set("isSafari",c.isSafari);const k=Object.prototype.hasOwnProperty;var A;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return T.INSTANCE}static true(){return v.INSTANCE}static has(M){return D.create(M)}static equals(M,B){return w.create(M,B)}static notEquals(M,B){return m.create(M,B)}static regex(M,B){return o.create(M,B)}static in(M,B){return f.create(M,B)}static notIn(M,B){return d.create(M,B)}static not(M){return p.create(M)}static and(...M){return u.create(M,null,!0)}static or(...M){return r.create(M,null,!0)}static greater(M,B){return E.create(M,B)}static greaterEquals(M,B){return g.create(M,B)}static smaller(M,B){return i.create(M,B)}static smallerEquals(M,B){return l.create(M,B)}static deserialize(M,B=!1){if(!!M)return this.c(M,B)}static c(M,B){const O=M.split("||");return r.create(O.map(U=>this.d(U,B)),null,!0)}static d(M,B){const O=M.split("&&");return u.create(O.map(U=>this.f(U,B)),null,!0)}static f(M,B){if(M=M.trim(),M.indexOf("!=")>=0){const O=M.split("!=");return m.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("==")>=0){const O=M.split("==");return w.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("=~")>=0){const O=M.split("=~");return o.create(O[0].trim(),this.h(O[1],B))}if(M.indexOf(" not in ")>=0){const O=M.split(" not in ");return d.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf(" in ")>=0){const O=M.split(" in ");return f.create(O[0].trim(),this.g(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const O=M.split(">=");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const O=M.split(">");return E.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const O=M.split("<=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const O=M.split("<");return i.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(M)?p.create(M.substr(1).trim()):D.create(M)}static g(M,B){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const O=/^'([^']*)'$/.exec(M);return O?O[1].trim():M}static h(M,B){if((0,t.isFalsyOrWhitespace)(M)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=M.indexOf("/"),U=M.lastIndexOf("/");if(O===U||O<0){if(B)throw new Error(`bad regexp-value '${M}', missing /-enclosure`);return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null}const z=M.slice(O+1,U),j=M[U+1]==="i"?"i":"";try{return new RegExp(z,j)}catch(ue){if(B)throw new Error(`bad regexp-value '${M}', parse error: ${ue}`);return console.warn(`bad regexp-value '${M}', parse error: ${ue}`),null}}}e.ContextKeyExpr=y;function C(q,M){const B=q?q.substituteConstants():void 0,O=M?M.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=C;function L(q,M){return q.cmp(M)}class T{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class D{static create(M,B=null){const O=R.get(M);return typeof O=="boolean"?O?v.INSTANCE:T.INSTANCE:new D(M,B)}constructor(M,B){this.key=M,this.c=B,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:h(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=R.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:T.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=D;class w{static create(M,B,O=null){if(typeof B=="boolean")return B?D.create(M,O):p.create(M,O);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?v.INSTANCE:T.INSTANCE:new w(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:S(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?v.INSTANCE:T.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=w;class f{static create(M,B){return new f(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:S(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.f),O=M.getValue(this.d);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?k.call(B,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class d{static create(M,B){return new d(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=11,this.c=f.create(M,B)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class m{static create(M,B,O=null){if(typeof B=="boolean")return B?p.create(M,O):D.create(M,O);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?T.INSTANCE:v.INSTANCE:new m(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:S(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?T.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=m;class p{static create(M,B=null){const O=R.get(M);return typeof O=="boolean"?O?T.INSTANCE:v.INSTANCE:new p(M,B)}constructor(M,B){this.c=M,this.d=B,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:h(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=R.get(this.c);return typeof M=="boolean"?M?T.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function b(q,M){if(typeof q=="string"){const B=parseFloat(q);isNaN(B)||(q=B)}return typeof q=="string"||typeof q=="number"?M(q):T.INSTANCE}class E{static create(M,B,O=null){return b(B,U=>new E(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:S(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=E;class g{static create(M,B,O=null){return b(B,U=>new g(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:S(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=g;class i{static create(M,B,O=null){return b(B,U=>new i(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:S(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class l{static create(M,B,O=null){return b(B,U=>new l(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:S(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=l;class o{static create(M,B){return new o(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return B<O?-1:B>O?1:0}equals(M){if(M.type===this.type){const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return this.d===M.d&&B===O}return!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=o;class a{static create(M){return new a(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new a(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function s(q){let M=null;for(let B=0,O=q.length;B<O;B++){const U=q[B].substituteConstants();if(q[B]!==U&&M===null){M=[];for(let z=0;z<B;z++)M[z]=q[z]}M!==null&&(M[B]=U)}return M===null?q:M}class u{static create(M,B,O){return u.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=s(this.expr);return M===this.expr?this:u.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(M))return!1;return!0}static d(M,B,O){const U=[];let z=!1;for(const j of M)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return T.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&z)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const ue=U.pop(),V=U.length===0,_=r.create(j.expr.map(J=>u.create([J,ue],null,O)),null,V);_&&(U.push(_),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let ue=j+1;ue<U.length;ue++)if(U[j].negate().equals(U[ue]))return T.INSTANCE;if(U.length===1)return U[0]}return new u(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new u(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());this.c=r.create(M,this,!0)}return this.c}}class r{static create(M,B,O){return r.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=s(this.expr);return M===this.expr?this:r.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(M))return!0;return!1}static d(M,B,O){let U=[],z=!1;if(M){for(let j=0,ue=M.length;j<ue;j++){const V=M[j];if(!!V){if(V.type===0){z=!0;continue}if(V.type===1)return v.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&z)return T.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let ue=j+1;ue<U.length;ue++)if(U[j].negate().equals(U[ue]))return v.INSTANCE;if(U.length===1)return U[0]}return new r(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new r(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());for(;M.length>1;){const B=M.shift(),O=M.shift(),U=[];for(const z of K(B))for(const j of K(O))U.push(u.create([z,j],null,!1));M.unshift(r.create(U,null,!1))}this.c=r.create(M,this,!0)}return this.c}}class n extends D{static all(){return n.d.values()}constructor(M,B,O){super(M,null),this.f=B,typeof O=="object"?n.d.push({...O,key:M}):O!==!0&&n.d.push({key:M,description:O,type:B!=null?typeof B:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return w.create(this.key,M)}notEqualsTo(M){return m.create(this.key,M)}}e.RawContextKey=n,n.d=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService");function h(q,M){return q<M?-1:q>M?1:0}function S(q,M,B,O){return q<B?-1:q>B?1:M<O?-1:M>O?1:0}function I(q,M){if(q.type===0||M.type===1)return!0;if(q.type===9)return M.type===9?F(q.expr,M.expr):!1;if(M.type===9){for(const B of M.expr)if(I(q,B))return!0;return!1}if(q.type===6){if(M.type===6)return F(M.expr,q.expr);for(const B of q.expr)if(I(B,M))return!0;return!1}return q.equals(M)}e.implies=I;function F(q,M){let B=0,O=0;for(;B<q.length&&O<M.length;){const U=q[B].cmp(M[O]);if(U<0)return!1;U===0&&B++,O++}return B===q.length}function K(q){return q.type===9?q.expr:[q]}}),define(ye[198],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],Ce([1,0,169,4]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function P(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function k(m,p){switch(m){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function A(m,p){return p==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(m,p,b){return A(p,b)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===b?!0:C(b).includes(m)}e.isTargetPlatformCompatible=y;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function L(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=L;var T;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var v;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var D;(function(m){m.Install="install",m.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var w;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var f;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal",m.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[199],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(ye[200],Ce([1,0,46,17,11,12,109,29,116,171,199]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=C.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends v{openTerminal(E,g){return this.spawnTerminal(c,E,y.getWindowsShell(),g)}spawnTerminal(E,g,i,l){const o=g.windowsExec||D.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const a=P.basename(o).toLowerCase();if(a==="cmder"||a==="cmder.exe")return E.spawn(o,l?[l]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return o.indexOf(" ")>=0&&s.push('""'),s.push(o),(a==="wt"||a==="wt.exe")&&s.push("-d ."),new Promise((u,r)=>{const n=d(process),h=E.spawn(i,s,{cwd:l,env:n});h.on("error",r),h.on("exit",()=>u())})}runInTerminal(E,g,i,l,o){const a="windowsExec"in o&&o.windowsExec?o.windowsExec:D.getDefaultTerminalWindows();return new Promise((s,u)=>{const r=`"${g} - ${T}"`,n=`""${i.join('" "')}" & pause"`,h=["/c","start",r,"/wait",a,"/c",n],S=Object.assign({},d(process),l);Object.keys(S).filter(K=>S[K]===null).forEach(K=>delete S[K]);const I={cwd:g,env:S,windowsVerbatimArguments:!0};c.spawn(D.b,h,I).on("error",K=>{u(m(K))}),s(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.WindowsExternalTerminalService=D,D.b="cmd.exe";class w extends v{openTerminal(E,g){return this.spawnTerminal(c,E,g)}runInTerminal(E,g,i,l,o){const a=o.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,u)=>{if(a===L.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const r=a===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",E||T,"-w",g];for(const F of i)h.push("-a"),h.push(F);if(l){const F=Object.assign({},d(process),l);for(const K in F){const q=F[K];q===null?(h.push("-u"),h.push(K)):(h.push("-e"),h.push(`${K}=${q}`))}}let S="";const I=c.spawn(w.b,h);I.on("error",F=>{u(m(F))}),I.stderr.on("data",F=>{S+=F.toString()}),I.on("exit",F=>{if(F===0)s(void 0);else if(S){const K=S.split(`
`,1);u(new Error(K[0]))}else u(new Error(C.localize(1,null,r,F)))})}else u(new Error(C.localize(2,null,a)))})}spawnTerminal(E,g,i){const l=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{const s=["-a",l];i&&s.push(i);const u=d(process),r=E.spawn("/usr/bin/open",s,{cwd:i,env:u});r.on("error",a),r.on("exit",()=>o())})}}e.MacExternalTerminalService=w,w.b="/usr/bin/osascript";class f extends v{openTerminal(E,g){return this.spawnTerminal(c,E,g)}runInTerminal(E,g,i,l,o){const a=o.linuxExec?Promise.resolve(o.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{const r=[];a.then(n=>{n.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const h=`${p(i)}; echo; read -p "${f.b}" -n1;`;r.push(`''${h}''`);const S=Object.assign({},d(process),l);Object.keys(S).filter(q=>S[q]===null).forEach(q=>delete S[q]);const I={cwd:g,env:S};let F="";const K=c.spawn(n,r,I);K.on("error",q=>{u(m(q))}),K.stderr.on("data",q=>{F+=q.toString()}),K.on("exit",q=>{if(q===0)s(void 0);else if(F){const M=F.split(`
`,1);u(new Error(M[0]))}else u(new Error(C.localize(4,null,n,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const E=await A.Promises.exists("/etc/debian_version");f.d=new Promise(g=>{E?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return f.d}spawnTerminal(E,g,i){const l=g.linuxExec?Promise.resolve(g.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{l.then(s=>{const u=d(process),r=E.spawn(s,[],{cwd:i,env:u});r.on("error",a),r.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=f,f.b=C.localize(3,null);function d(b){const E={...b.env};return(0,k.sanitizeProcessEnvironment)(E),E}function m(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(C.localize(5,null,b.path)):b}function p(b){let E="";for(const g of b)g.indexOf(" ")>=0?E+='"'+g+'"':E+=g,E+=" ";return E}}),define(ye[40],Ce([1,0,67,11,8,10,2,172,4,12]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function L(V){return V.create===!0}e.isFileOpenForWriteOptions=L;var T;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var v;(function(V){V[V.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var D;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(D=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=w;function f(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=f;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function m(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function b(V){return w(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var E;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(_,J){super(_),this.code=J}}e.FileSystemProviderError=g;function i(V,_){const J=new g(V.toString(),_);return o(J,_),J}e.createFileSystemProviderError=i;function l(V){return V||i((0,A.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=l;function o(V,_){return V.name=_?`${_} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=o;function a(V){if(!V)return E.Unknown;if(V instanceof g)return V.code;const _=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!_)return E.Unknown;switch(_[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=a;function s(V){if(V instanceof I)return V.fileOperationResult;switch(a(V)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(u=e.FileOperation||(e.FileOperation={}));class r{constructor(_,J,ie){this.resource=_,this.operation=J,this.target=ie}isOperation(_){return this.operation===_}}e.FileOperationEvent=r;var n;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class h{constructor(_,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const ee of _){const X=ie.get(ee.type);switch(X?X.push([ee.resource,ee]):ie.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,X]of ie)switch(ee){case 1:this.a=c.TernarySearchTree.forUris(()=>J),this.a.fill(X);break;case 0:this.b=c.TernarySearchTree.forUris(()=>J),this.b.fill(X);break;case 2:this.c=c.TernarySearchTree.forUris(()=>J),this.c.fill(X);break}}contains(_,...J){return this.d(_,{includeChildren:!1},...J)}affects(_,...J){return this.d(_,{includeChildren:!0},...J)}d(_,J,...ie){if(!_)return!1;const ee=ie.length>0;return!!((!ee||ie.includes(1))&&(this.a?.get(_)||J.includeChildren&&this.a?.findSuperstr(_))||(!ee||ie.includes(0))&&(this.b?.get(_)||J.includeChildren&&this.b?.findSuperstr(_))||(!ee||ie.includes(2))&&(this.c?.findSubstr(_)||J.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function S(V,_,J){return!V||!_||V===_||_.length>V.length?!1:(_.charAt(_.length-1)!==t.sep&&(_+=t.sep),J?(0,P.startsWithIgnoreCase)(V,_):V.indexOf(_)===0)}e.isParent=S;class I extends Error{constructor(_,J,ie){super(_),this.fileOperationResult=J,this.options=ie}}e.FileOperationError=I;class F extends I{constructor(_,J,ie,ee){super(_,J,ee),this.fileOperationResult=J,this.size=ie}}e.TooLargeFileOperationError=F;class K extends I{constructor(_,J,ie){super(_,2,ie),this.stat=J}}e.NotModifiedSinceFileOperationError=K;var q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=B;async function O(V,_){if(!_.hasProvider(k.URI.from({scheme:V.scheme})))return new Promise(J=>{const ie=_.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===V.scheme&&ee.added&&(ie.dispose(),J())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<U.KB?(0,A.localize)(1,null,_.toFixed(0)):_<U.MB?(0,A.localize)(2,null,(_/U.KB).toFixed(2)):_<U.GB?(0,A.localize)(3,null,(_/U.MB).toFixed(2)):_<U.TB?(0,A.localize)(4,null,(_/U.GB).toFixed(2)):(0,A.localize)(5,null,(_/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function j(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=j;function ue(V){return C.isWeb?V?10*U.MB:50*U.MB:V?100*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=ue}),define(ye[90],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...P){this.a=new Map;for(const[R,k]of P)this.set(R,k)}set(P,R){const k=this.a.get(P);return this.a.set(P,R),k}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=c}),define(ye[201],Ce([1,0,14,9,6,122,197,4,90,66]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class T extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new y.ServiceCollection,m=!1,p,b=L){this.f=d,this.g=m,this.h=p,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new k.Graph(E=>E):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...m){const p=w.traceInvocation(this.i,d);let b=!1;try{return d({get:g=>{if(b)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...m)}finally{b=!0,p.stop()}}createInstance(d,...m){let p,b;return d instanceof R.SyncDescriptor?(p=w.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(m),p)):(p=w.traceCreation(this.i,d),b=this.j(d,m,p)),p.stop(),b}j(d,m=[],p){const b=A._util.getServiceDependencies(d).sort((i,l)=>i.index-l.index),E=[];for(const i of b){const l=this.m(i.id,p);l||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(l)}const g=b.length>0?b[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${m.length} static arguments`);const i=g-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,g)}return Reflect.construct(d,m.concat(E))}k(d,m){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,m);else if(this.h)this.h.k(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const m=this.f.get(d);return!m&&this.h?this.h.l(d):m}m(d,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const p=this.l(d);return p instanceof R.SyncDescriptor?this.q(d,p,m.branch(d,!0)):(m.branch(d,!1),p)}q(d,m,p){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,m,p)}finally{this.o.delete(d)}}r(d,m,p){const b=new k.Graph(i=>i.id.toString());let E=0;const g=[{id:d,desc:m,_trace:p}];for(;g.length;){const i=g.pop();if(b.lookupOrInsertNode(i),E++>1e3)throw new T(b);for(const l of A._util.getServiceDependencies(i.desc.ctor)){const o=this.l(l.id);if(o||this.u(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),o instanceof R.SyncDescriptor){const a={id:l.id,desc:o,_trace:i._trace.branch(l.id,!0)};b.insertEdge(i,a),g.push(a)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new T(b);break}for(const{data:l}of i){if(this.l(l.id)instanceof R.SyncDescriptor){const a=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,a)}b.removeNode(l)}}return this.l(d)}s(d,m,p=[],b,E){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,m,p,b,E);if(this.h)return this.h.s(d,m,p,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}t(d,m,p=[],b,E){if(b){const g=new v(void 0,this.g,this,this.i);g.c=String(d);const i=new Map,l=new c.IdleValue(()=>{const o=g.j(m,p,E);for(const[a,s]of i){const u=o[a];if(typeof u=="function")for(const r of s)u.apply(o,r)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,a){if(!l.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let r=i.get(a);return r||(r=new C.LinkedList,i.set(a,r)),(h,S,I)=>{const F=r.push([h,S,I]);return(0,P.toDisposable)(F)}}if(a in o)return o[a];const s=l.value;let u=s[a];return typeof u!="function"||(u=u.bind(s),o[a]=u),u},set(o,a,s){return l.value[a]=s,!0},getPrototypeOf(o){return m.prototype}})}else return this.j(m,p,E)}u(d,m){if(m&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var D;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(D||(D={}));class w{static traceInvocation(d,m){return d?new w(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(d,m){return d?new w(1,m.name):w.c}constructor(d,m){this.type=d,this.name=m,this.g=Date.now(),this.h=[]}branch(d,m){const p=new w(3,d.toString());return this.h.push([d,m,p]),p}stop(){const d=Date.now()-this.g;w.f+=d;let m=!1;function p(E,g){const i=[],l=new Array(E+1).join("	");for(const[o,a,s]of g.h)if(a&&s){m=!0,i.push(`${l}CREATES -> ${o}`);const u=p(E+1,s);u&&i.push(u)}else i.push(`${l}uses -> ${o}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(d>2||m)&&w.all.add(b.join(`
`))}}e.Trace=w,w.all=new Set,w.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}},w.f=0}),define(ye[13],Ce([1,0,45,3,6,28,12,4]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function y(){return new Date().toISOString()}var C;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function L(s,u,r){switch(u){case C.Trace:s.trace(r);break;case C.Debug:s.debug(r);break;case C.Info:s.info(r);break;case C.Warning:s.warn(r);break;case C.Error:s.error(r);break;case C.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=L;function T(s){let u="";for(let r=0;r<s.length;r++){let n=s[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}u+=(r>0?" ":"")+n}return u}e.format=T;class v extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==C.Off&&this.b<=u}}e.AbstractLogger=v;class D extends v{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...r){this.f(C.Trace)&&this.g(C.Trace,T([u,...r]))}debug(u,...r){this.f(C.Debug)&&this.g(C.Debug,T([u,...r]))}info(u,...r){this.f(C.Info)&&this.g(C.Info,T([u,...r]))}warn(u,...r){this.f(C.Warning)&&this.g(C.Warning,T([u,...r]))}error(u,...r){if(this.f(C.Error))if(u instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=u.stack,this.g(C.Error,T(n))}else this.g(C.Error,T([u,...r]))}flush(){}}e.AbstractMessageLogger=D;class w extends v{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u),this.g=!k.isWindows}trace(u,...r){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...r):console.log(`[main ${y()}]`,u,...r))}debug(u,...r){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...r):console.log(`[main ${y()}]`,u,...r))}info(u,...r){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...r):console.log(`[main ${y()}]`,u,...r))}warn(u,...r){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,u,...r):console.warn(`[main ${y()}]`,u,...r))}error(u,...r){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,u,...r):console.error(`[main ${y()}]`,u,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class f extends v{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u)}trace(u,...r){this.f(C.Trace)&&console.log("%cTRACE","color: #888",u,...r)}debug(u,...r){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",u,...r)}info(u,...r){this.f(C.Info)&&console.log("%c INFO","color: #33f",u,...r)}warn(u,...r){this.f(C.Warning)&&console.log("%c WARN","color: #993",u,...r)}error(u,...r){this.f(C.Error)&&console.log("%c  ERR","color: #f33",u,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class d extends v{constructor(u,r=e.DEFAULT_LOG_LEVEL){super(),this.g=u,this.setLevel(r)}trace(u,...r){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(u),...r])}debug(u,...r){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(u),...r])}info(u,...r){this.f(C.Info)&&this.g.log(C.Info,[this.h(u),...r])}warn(u,...r){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(u),...r])}error(u,...r){this.f(C.Error)&&this.g.log(C.Error,[this.h(u),...r])}h(u){return typeof u=="string"?u:(0,c.toErrorMessage)(u,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=d;class m extends v{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const r of this.g)r.setLevel(u);super.setLevel(u)}trace(u,...r){for(const n of this.g)n.trace(u,...r)}debug(u,...r){for(const n of this.g)n.debug(u,...r)}info(u,...r){for(const n of this.g)n.info(u,...r)}warn(u,...r){for(const n of this.g)n.warn(u,...r)}error(u,...r){for(const n of this.g)n.error(u,...r)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.MultiplexLogService=m;class p extends P.Disposable{constructor(u){super(),this.b=u,this.B(u)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(u){this.b.setLevel(u)}getLevel(){return this.b.getLevel()}trace(u,...r){this.b.trace(u,...r)}debug(u,...r){this.b.debug(u,...r)}info(u,...r){this.b.info(u,...r)}warn(u,...r){this.b.warn(u,...r)}error(u,...r){this.b.error(u,...r)}flush(){this.b.flush()}}e.LogService=p;class b extends P.Disposable{constructor(u,r,n){if(super(),this.h=u,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new t.Emitter),this.onDidChangeLoggerResources=this.f.event,this.g=this.B(new t.Emitter),this.onDidChangeLogLevel=this.g.event,this.B(r(h=>this.j(h))),n)for(const h of n)this.c.set(h.resource,h)}getLogger(u){return this.b.get(u)}createLogger(u,r,n){let h=this.b.get(u);return h||(n=r?.always?C.Trace:n,h=this.k(u,n??this.getLogLevel(u)??this.h,r),this.b.set(u,h),this.registerLoggerResource({resource:u,logLevel:n,name:r?.name})),h}setLogLevel(u,r){const n=this.c.get(u);n&&r!==n.logLevel&&(n.logLevel=r===this.h?void 0:r,this.b.get(u)?.setLevel(r),this.c.set(n.resource,n),this.g.fire(n))}j(u){this.h=u;for(const[r,n]of this.b.entries())this.c.get(r)?.logLevel===void 0&&n.setLevel(this.h)}getLogLevel(u){return this.c.get(u)?.logLevel}registerLoggerResource(u){this.c.get(u.resource)||(this.c.set(u.resource,u),this.f.fire({added:[u],removed:[]}))}deregisterLoggerResource(u){const r=this.c.get(u);r&&(this.c.delete(u),this.f.fire({added:[],removed:[r]}))}getLoggerResources(){return this.c.values()}dispose(){this.b.forEach(u=>u.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=b;class E{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(u){}getLevel(){return C.Info}trace(u,...r){}debug(u,...r){}info(u,...r){}warn(u,...r){}error(u,...r){}critical(u,...r){}dispose(){}flush(){}}e.NullLogger=E;class g extends E{}e.NullLogService=g;class i extends b{constructor(){super(C.Info,t.Event.None)}k(u,r,n){return new E}}e.NullLoggerService=i;function l(s){if(s.verbose)return C.Trace;if(typeof s.logLevel=="string"){const u=a(s.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function o(s){switch(s){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=o;function a(s){switch(s){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=a}),define(ye[202],Ce([1,0,40,13]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(P||(P={}));async function R(C,L,T,v,D){try{const w=await new Promise((d,m)=>{te(["spdlog"],d,m)});w.setFlushOn(P.Trace);const f=await w.createAsyncRotatingLogger(C,L,T,v);return D?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(w){console.error(w)}return null}function k(C,L,T){switch(L){case t.LogLevel.Trace:C.trace(T);break;case t.LogLevel.Debug:C.debug(T);break;case t.LogLevel.Info:C.info(T);break;case t.LogLevel.Warning:C.warn(T);break;case t.LogLevel.Error:C.error(T);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(C,L){switch(L){case t.LogLevel.Trace:C.setLevel(P.Trace);break;case t.LogLevel.Debug:C.setLevel(P.Debug);break;case t.LogLevel.Info:C.setLevel(P.Info);break;case t.LogLevel.Warning:C.setLevel(P.Warning);break;case t.LogLevel.Error:C.setLevel(P.Error);break;case t.LogLevel.Off:C.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends t.AbstractMessageLogger{constructor(L,T,v,D,w){super(),this.k=[],this.setLevel(w),this.l=this.n(L,T,v,D),this.B(this.onDidChangeLogLevel(f=>{this.m&&A(this.m,f)}))}async n(L,T,v,D){const w=v?6:1,f=30/w*c.ByteSize.MB,d=await R(L,T,f,w,D);if(d){this.m=d,A(this.m,this.getLevel());for(const{level:m,message:p}of this.k)k(this.m,m,p);this.k=[]}}g(L,T){this.m?k(this.m,L,T):this.getLevel()<=L&&this.k.push({level:L,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[124],Ce([1,0,38,173,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var k;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function C(w,f){return f-w}y.compare=C;const L=Object.create(null);L[y.Error]=(0,t.localize)(0,null),L[y.Warning]=(0,t.localize)(1,null),L[y.Info]=(0,t.localize)(2,null);function T(w){return L[w]||""}y.toString=T;function v(w){switch(w){case c.default.Error:return y.Error;case c.default.Warning:return y.Warning;case c.default.Info:return y.Info;case c.default.Ignore:return y.Hint}}y.fromSeverity=v;function D(w){switch(w){case y.Error:return c.default.Error;case y.Warning:return c.default.Warning;case y.Info:return c.default.Info;case y.Hint:return c.default.Ignore}}y.toSeverity=D}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const C="";function L(v){return T(v,!0)}y.makeKey=L;function T(v,D){const w=[C];return v.source?w.push(v.source.replace("\xA6","\\\xA6")):w.push(C),v.code?typeof v.code=="string"?w.push(v.code.replace("\xA6","\\\xA6")):w.push(v.code.value.replace("\xA6","\\\xA6")):w.push(C),v.severity!==void 0&&v.severity!==null?w.push(k.toString(v.severity)):w.push(C),v.message&&D?w.push(v.message.replace("\xA6","\\\xA6")):w.push(C),v.startLineNumber!==void 0&&v.startLineNumber!==null?w.push(v.startLineNumber.toString()):w.push(C),v.startColumn!==void 0&&v.startColumn!==null?w.push(v.startColumn.toString()):w.push(C),v.endLineNumber!==void 0&&v.endLineNumber!==null?w.push(v.endLineNumber.toString()):w.push(C),v.endColumn!==void 0&&v.endColumn!==null?w.push(v.endColumn.toString()):w.push(C),w.push(C),w.join("\xA6")}y.makeKeyOptionalMessage=T})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,P.createDecorator)("markerService")}),define(ye[203],Ce([1,0,3,38,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,P.createDecorator)("notificationService");var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ye[125],Ce([1,0,8,2,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService");function R(C,L){return t.URI.isUri(C)?(0,c.equalsIgnoreCase)(C.scheme,L):(0,c.startsWithIgnoreCase)(C,L+":")}e.matchesScheme=R;function k(C,...L){return L.some(T=>R(C,T))}e.matchesSomeScheme=k;function A(C,L){return C.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function y(C){let L;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return T&&(L={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},C=C.with({fragment:""})),{selection:L,uri:C}}e.extractSelection=y}),define(ye[204],Ce([1,0,12,37]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const R=c.globals.vscode.context.configuration();if(R)P=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(P=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),!P.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(P,{version:R.version})}}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=P}),define(ye[205],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(c,t){e(c,t,te)}};define(ye[126],Ce([1,0,14,21,6,4]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var k;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends P.Disposable{constructor(T,v){super(),this.a=new c.DeferredPromise,v.withProgress(T,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,P.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};y=qe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class C extends P.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.B(new P.DisposableStore)}start(T){this.stop();const v=++this.a,D=new t.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,P.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,P.toDisposable)(()=>D.cancel())),this.b.add((0,P.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:D.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[33],Ce([1,0,51,10]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(k,A){c.ok(t.isString(k)),c.ok(t.isObject(A)),c.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,A)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new P}),define(ye[91],Ce([1,0,3,33]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,C){this.a[P(y)]=C,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const k=new R;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ye[127],Ce([1,0,16,3,10,168,53,91,33]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=y.Registry.as(A.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const o=new Set;this.n(i,l,o),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const l=new Set;this.o(i,l),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const o=new Set;this.o(l,o),this.n(i,!1,o),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const o=[];for(const{overrides:a,source:s}of i)for(const u in a)if(l.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const r=this.a.get(u),n=r?.valuesSources??new Map;if(s)for(const F of Object.keys(a[u]))n.set(F,s);const h={...r?.value||{},...a[u]};this.a.set(u,{source:s,value:h,valuesSources:n});const S=(0,k.getLanguageTagSettingPlainKey)(u),I={type:"object",default:h,description:R.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:P.isString(s)?void 0:s,defaultValueSource:s};o.push(...f(u)),this.d[u]=I,this.b.properties[u]=I}else{this.a.set(u,{value:a[u],source:s});const r=this.d[u];r&&(this.w(u,r),this.r(u,r))}this.m(o)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:o,source:a}of i)for(const s in o){const u=this.a.get(s),r=P.isString(a)?a:a?.id,n=P.isString(u?.source)?u?.source:u?.source?.id;if(r===n)if(l.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const h=this.d[s];h&&(this.w(s,h),this.r(s,h))}}this.u()}deltaConfiguration(i){let l=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,o){i.forEach(a=>{this.p(a,l,a.extensionInfo,a.restrictedProperties,void 0,o),this.c.push(a),this.q(a)})}o(i,l){const o=a=>{if(a.properties)for(const s in a.properties){l.add(s);const u=this.d[s];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[s],this.s(s,a.properties[s])}a.allOf?.forEach(s=>o(s))};for(const a of i){o(a);const s=this.c.indexOf(a);s!==-1&&this.c.splice(s,1)}}p(i,l=!0,o,a,s=3,u){s=P.isUndefinedOrNull(i.scope)?s:i.scope;const r=i.properties;if(r)for(const h in r){const S=r[h];if(l&&b(h,S)){delete r[h];continue}if(S.source=o,S.defaultDefaultValue=r[h].default,this.w(h,S),e.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=P.isUndefinedOrNull(S.scope)?s:S.scope,S.restricted=P.isUndefinedOrNull(S.restricted)?!!a?.includes(h):S.restricted),r[h].hasOwnProperty("included")&&!r[h].included){this.f[h]=r[h],delete r[h];continue}else this.d[h]=r[h],r[h].policy?.name&&this.e.set(r[h].policy.name,h);!r[h].deprecationMessage&&r[h].markdownDeprecationMessage&&(r[h].deprecationMessage=r[h].markdownDeprecationMessage),u.add(h)}const n=i.allOf;if(n)for(const h of n)this.p(h,l,o,a,s,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=o=>{const a=o.properties;if(a)for(const u in a)this.r(u,a[u]);o.allOf?.forEach(l)};l(i)}r(i,l){switch(e.allSettings.properties[i]=l,l.scope){case 1:e.applicationSettings.properties[i]=l;break;case 2:e.machineSettings.properties[i]=l;break;case 6:e.machineOverridableSettings.properties[i]=l;break;case 3:e.windowSettings.properties[i]=l;break;case 4:e.resourceSettings.properties[i]=l;break;case 5:e.resourceSettings.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.allSettings.properties[i],l.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,o),e.allSettings.properties[l]=o,e.applicationSettings.properties[l]=o,e.machineSettings.properties[l]=o,e.machineOverridableSettings.properties[l]=o,e.windowSettings.properties[l]=o,e.resourceSettings.properties[l]=o}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,l){const o=this.a.get(i);let a=o?.value,s=o?.source;P.isUndefined(a)&&(a=l.defaultDefaultValue,s=void 0),P.isUndefined(a)&&(a=m(l.type)),l.default=a,l.defaultValueSource=s}}const D="\\[([^\\]]+)\\]",w=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let l=w.exec(g);for(;l?.length;){const o=l[1].trim();o&&i.push(o),l=w.exec(g)}}return(0,c.distinct)(i)}e.overrideIdentifiersFromKey=f;function d(g){return g.reduce((i,l)=>`${i}[${l}]`,"")}e.keyFromOverrideIdentifiers=d;function m(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const p=new v;y.Registry.add(e.Extensions.Configuration,p);function b(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?R.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?R.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function E(){const g=[],i=p.getConfigurationProperties();for(const l of Object.keys(i))g.push([l,i[l].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=E}),define(ye[206],Ce([1,0,16,3,146,6,28,23,10,2,53,127,33]),function(te,e,c,t,P,R,k,A,y,C,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function D(l){return Object.isFrozen(l)?l:A.deepFreeze(l)}class w{constructor(o={},a=[],s=[],u){this.b=o,this.c=a,this.d=s,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(a=>{if(a instanceof w)return a;const s=new f("");return s.parseRaw(a),s.configurationModel});this.f=o.reduce((a,s)=>s===a?s:a.merge(s),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,L.getConfigurationValue)(this.contents,o):this.contents}inspect(o,a){const s=this.rawConfiguration.getValue(o),u=a?this.rawConfiguration.getOverrideValue(o,a):void 0,r=a?this.rawConfiguration.override(a).getValue(o):s;return{value:s,override:u,merged:r}}getOverrideValue(o,a){const s=this.i(a);return s?o?(0,L.getConfigurationValue)(s,o):s:void 0}getKeysForOverrideIdentifier(o){const a=[];for(const s of this.overrides)s.identifiers.includes(o)&&a.push(...s.keys);return c.distinct(a)}getAllOverrideIdentifiers(){const o=[];for(const a of this.overrides)o.push(...a.identifiers);return c.distinct(o)}override(o){let a=this.a.get(o);return a||(a=this.g(o),this.a.set(o,a)),a}merge(...o){const a=A.deepClone(this.contents),s=A.deepClone(this.overrides),u=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const n of o)if(r.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.h(a,n.contents);for(const h of n.overrides){const[S]=s.filter(I=>c.equals(I.identifiers,h.identifiers));S?(this.h(S.contents,h.contents),S.keys.push(...h.keys),S.keys=c.distinct(S.keys)):s.push(A.deepClone(h))}for(const h of n.keys)u.indexOf(h)===-1&&u.push(h)}return new w(a,u,s,r.every(n=>n instanceof w)?void 0:r)}g(o){const a=this.i(o);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const s={};for(const u of c.distinct([...Object.keys(this.contents),...Object.keys(a)])){let r=this.contents[u];const n=a[u];n&&(typeof r=="object"&&typeof n=="object"?(r=A.deepClone(r),this.h(r,n)):r=n),s[u]=r}return new w(s,this.keys,this.overrides)}h(o,a){for(const s of Object.keys(a)){if(s in o&&y.isObject(o[s])&&y.isObject(a[s])){this.h(o[s],a[s]);continue}o[s]=A.deepClone(a[s])}}i(o){let a=null,s=null;const u=r=>{r&&(s?this.h(s,r):s=A.deepClone(r))};for(const r of this.overrides)c.equals(r.identifiers,[o])?a=r.contents:r.identifiers.includes(o)&&u(r.contents);return u(a),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,a){this.j(o,a,!0)}setValue(o,a){this.j(o,a,!1)}removeValue(o){const a=this.keys.indexOf(o);a!==-1&&(this.keys.splice(a,1),(0,L.removeFromValueTree)(this.contents,o),T.OVERRIDE_PROPERTY_REGEX.test(o)&&this.overrides.splice(this.overrides.findIndex(s=>c.equals(s.identifiers,(0,T.overrideIdentifiersFromKey)(o))),1))}j(o,a,s){(0,L.addToValueTree)(this.contents,o,a,u=>console.error(u)),s=s||this.keys.indexOf(o)===-1,s&&this.keys.push(o),T.OVERRIDE_PROPERTY_REGEX.test(o)&&this.overrides.push({identifiers:(0,T.overrideIdentifiersFromKey)(o),keys:Object.keys(this.contents[o]),contents:(0,L.toValuesTree)(this.contents[o],u=>console.error(u))})}}e.ConfigurationModel=w;class f{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,a){if(!y.isUndefinedOrNull(o)){const s=this.g(o);this.parseRaw(s,a)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,a){this.a=o;const{contents:s,keys:u,overrides:r,restricted:n,hasExcludedProperties:h}=this.h(o,a);this.b=new w(s,u,r,h?[o]:void 0),this.c=n||[]}g(o){let a={},s=null,u=[];const r=[],n=[];function h(I){Array.isArray(u)?u.push(I):s!==null&&(u[s]=I)}const S={onObjectBegin:()=>{const I={};h(I),r.push(u),u=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{u=r.pop()},onArrayBegin:()=>{const I=[];h(I),r.push(u),u=I,s=null},onArrayEnd:()=>{u=r.pop()},onLiteralValue:h,onError:(I,F,K)=>{n.push({error:I,offset:F,length:K})}};if(o)try{P.visit(o,S),a=u[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return a}h(o,a){const s=v.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=this.i(o,s,!0,a);o=u.raw;const r=(0,L.toValuesTree)(o,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),n=Object.keys(o),h=this.j(o,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:r,keys:n,overrides:h,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(o,a,s,u){let r=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:r};const n={},h=[];for(const S in o)if(T.OVERRIDE_PROPERTY_REGEX.test(S)&&s){const I=this.i(o[S],a,!1,u);n[S]=I.raw,r=r||I.hasExcludedProperties,h.push(...I.restricted)}else{const I=a[S],F=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&h.push(S),(F===void 0||u.scopes===void 0||u.scopes.includes(F))&&!(u.skipRestricted&&I?.restricted)?n[S]=o[S]:r=!0}return{raw:n,restricted:h,hasExcludedProperties:r}}j(o,a){const s=[];for(const u of Object.keys(o))if(T.OVERRIDE_PROPERTY_REGEX.test(u)){const r={};for(const n in o[u])r[n]=o[u][n];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(u),keys:Object.keys(r),contents:(0,L.toValuesTree)(r,a)})}return s}}e.ConfigurationModelParser=f;class d extends R.Disposable{constructor(o,a,s,u){super(),this.f=o,this.g=a,this.h=u,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,o)))(()=>this.c.fire()))}async loadConfiguration(){try{const o=await this.h.readFile(this.f);return this.a.parse(o.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new w}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class m{constructor(o,a,s,u,r,n,h,S,I,F,K,q,M){this.a=o,this.b=a,this.c=s,this.overrideIdentifiers=u,this.d=r,this.f=n,this.g=h,this.h=S,this.i=I,this.j=F,this.k=K,this.l=q,this.m=M}get value(){return D(this.c)}n(o,a,s){const u=o.inspect(a,s);return{get value(){return D(u.value)},get override(){return D(u.override)},get merged(){return D(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(o,a,s,u,r=new w,n=new w,h=new k.ResourceMap,S=new w,I=new k.ResourceMap){this.c=o,this.d=a,this.f=s,this.g=u,this.h=r,this.i=n,this.j=h,this.l=S,this.m=I,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(o,a,s){return this.q(o,a,s).getValue(o)}updateValue(o,a,s={}){let u;s.resource?(u=this.m.get(s.resource),u||(u=new w,this.m.set(s.resource,u))):u=this.l,a===void 0?u.removeValue(o):u.setValue(o,a),s.resource||(this.a=null)}inspect(o,a,s){const u=this.q(o,a,s),r=this.u(a.resource,s),n=a.resource?this.m.get(a.resource)||this.l:this.l,h=new Set;for(const S of u.overrides)for(const I of S.identifiers)u.getOverrideValue(o,I)!==void 0&&h.add(I);return new m(o,a,u.getValue(o),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,r||void 0,n)}keys(o){const a=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,a){this.j.set(o,a),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,a){const s=[];if(!a){const{added:u,updated:r,removed:n}=g(this.c,o);a=[...u,...r,...n]}for(const u of a)for(const r of(0,T.overrideIdentifiersFromKey)(u)){const n=this.c.getKeysForOverrideIdentifier(r),h=o.getKeysForOverrideIdentifier(r),S=[...h.filter(I=>n.indexOf(I)===-1),...n.filter(I=>h.indexOf(I)===-1),...n.filter(I=>!A.equals(this.c.override(r).getValue(I),o.override(r).getValue(I)))];s.push([r,S])}return this.updateDefaultConfiguration(o),{keys:a,overrides:s}}compareAndUpdatePolicyConfiguration(o){const{added:a,updated:s,removed:u}=g(this.d,o),r=[...a,...s,...u];return r.length&&this.updatePolicyConfiguration(o),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:a,updated:s,removed:u,overrides:r}=g(this.applicationConfiguration,o),n=[...a,...s,...u];return n.length&&this.updateApplicationConfiguration(o),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(o){const{added:a,updated:s,removed:u,overrides:r}=g(this.localUserConfiguration,o),n=[...a,...s,...u];return n.length&&this.updateLocalUserConfiguration(o),{keys:n,overrides:r}}compareAndUpdateRemoteUserConfiguration(o){const{added:a,updated:s,removed:u,overrides:r}=g(this.remoteUserConfiguration,o),n=[...a,...s,...u];return n.length&&this.updateRemoteUserConfiguration(o),{keys:n,overrides:r}}compareAndUpdateWorkspaceConfiguration(o){const{added:a,updated:s,removed:u,overrides:r}=g(this.workspaceConfiguration,o),n=[...a,...s,...u];return n.length&&this.updateWorkspaceConfiguration(o),{keys:n,overrides:r}}compareAndUpdateFolderConfiguration(o,a){const s=this.p.get(o),{added:u,updated:r,removed:n,overrides:h}=g(s,a),S=[...u,...r,...n];return(S.length||!s)&&this.updateFolderConfiguration(o,a),{keys:S,overrides:h}}compareAndDeleteFolderConfiguration(o){const a=this.p.get(o);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:s,updated:u,removed:r,overrides:n}=g(a,void 0);return{keys:[...s,...u,...r],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,a,s){let u=this.r(a,s);return a.overrideIdentifier&&(u=u.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(u=u.merge(this.d)),u}r({resource:o},a){let s=this.s();if(a&&o){const u=a.getFolder(o);u&&(s=this.t(u.uri)||s);const r=this.m.get(o);r&&(s=s.merge(r))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let a=this.b.get(o);if(!a){const s=this.s(),u=this.j.get(o);u?(a=s.merge(u),this.b.set(o,a)):a=s}return a}u(o,a){if(a&&o){const s=a.getFolder(o);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,a)=>{const{contents:s,overrides:u,keys:r}=this.j.get(a);return o.push([a,{contents:s,overrides:u,keys:r}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(a=>o.add(a)),this.userConfiguration.keys.forEach(a=>o.add(a)),this.i.keys.forEach(a=>o.add(a)),this.j.forEach(a=>a.keys.forEach(s=>o.add(s))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>o.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>o.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>o.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(s=>o.add(s))),[...o.values()]}w(o){const a=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(s=>a.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>a.add(s)),this.i.getKeysForOverrideIdentifier(o).forEach(s=>a.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(o).forEach(u=>a.add(u))),[...a.values()]}static parse(o){const a=this.x(o.defaults),s=this.x(o.policy),u=this.x(o.application),r=this.x(o.user),n=this.x(o.workspace),h=o.folders.reduce((S,I)=>(S.set(C.URI.revive(I[0]),this.x(I[1])),S),new k.ResourceMap);return new p(a,s,u,r,new w,n,h,new w,new k.ResourceMap)}static x(o){return new w(o.contents,o.keys,o.overrides)}}e.Configuration=p;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const o=new Set,a=new Map;for(const u of l)u.keys.forEach(r=>o.add(r)),u.overrides.forEach(([r,n])=>{const h=(0,k.getOrSet)(a,r,new Set);n.forEach(S=>h.add(S))});const s=[];return a.forEach((u,r)=>s.push([r,[...u.values()]])),{keys:[...o.values()],overrides:s}}e.mergeChanges=b;class E{constructor(o,a,s,u){this.change=o,this.f=a,this.g=s,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of o.keys)this.affectedKeys.add(r);for(const[,r]of o.overrides)for(const n of r)this.affectedKeys.add(n);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(o,a){const s=this.a+o,u=this.d.indexOf(s);if(u<0)return!1;const r=u+s.length;if(r>=this.d.length)return!1;const n=this.d.charCodeAt(r);if(n!==this.b&&n!==this.c)return!1;if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(o,a,this.f?.workspace):void 0,S=this.g.getValue(o,a,this.h);return!A.equals(h,S)}return!0}}e.ConfigurationChangeEvent=E;function g(l,o){const{added:a,removed:s,updated:u}=i(o?.rawConfiguration,l?.rawConfiguration),r=[],n=l?.getAllOverrideIdentifiers()||[],h=o?.getAllOverrideIdentifiers()||[];if(o){const S=h.filter(I=>!n.includes(I));for(const I of S)r.push([I,o.getKeysForOverrideIdentifier(I)])}if(l){const S=n.filter(I=>!h.includes(I));for(const I of S)r.push([I,l.getKeysForOverrideIdentifier(I)])}if(o&&l){for(const S of n)if(h.includes(S)){const I=i({contents:l.getOverrideValue(void 0,S)||{},keys:l.getKeysForOverrideIdentifier(S)},{contents:o.getOverrideValue(void 0,S)||{},keys:o.getKeysForOverrideIdentifier(S)});r.push([S,[...I.added,...I.removed,...I.updated]])}}return{added:a,removed:s,updated:u,overrides:r}}function i(l,o){const a=l?o?l.keys.filter(r=>o.keys.indexOf(r)===-1):[...l.keys]:[],s=o?l?o.keys.filter(r=>l.keys.indexOf(r)===-1):[...o.keys]:[],u=[];if(l&&o){for(const r of o.keys)if(l.keys.indexOf(r)!==-1){const n=(0,L.getConfigurationValue)(o.contents,r),h=(0,L.getConfigurationValue)(l.contents,r);A.equals(n,h)||u.push(r)}}return{added:a,removed:s,updated:u}}}),define(ye[128],Ce([1,0,9,4]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var P;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends c.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===P.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===P.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===P.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,C=P.Unknown,L){super(y),this._message=y,this._code=C,this._detail=L,this.isHandled=C===P.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function k(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=k}),define(ye[71],Ce([1,0,17]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===c.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function P(C){if(!C)return;const L=C.indexOf("+");return L<0?C:C.substr(0,L)}e.getRemoteName=P;function R(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=R;function k(C){const{host:L,port:T}=y(C);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:T}}e.parseAuthorityWithPort=k;function A(C,L){let{host:T,port:v}=y(C);return typeof v>"u"&&(v=L),{host:T,port:v}}e.parseAuthorityWithOptionalPort=A;function y(C){const L=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const T=C.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const v=C.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:C,port:void 0}}}),define(ye[26],Ce([1,0,8,4,71]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=R;function k(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(f){this.value=f,this.c=f.toLowerCase()}static equals(f,d){if(typeof f>"u"||f===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof f=="string"||typeof d=="string"){const m=typeof f=="string"?f:f.value,p=typeof d=="string"?d:d.value;return c.equalsIgnoreCase(m,p)}return f.c===d.c}static toKey(f){return typeof f=="string"?f.toLowerCase():f.c}}e.ExtensionIdentifier=C;function L(w){return T(w)}e.isApplicationScopedExtension=L;function T(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function v(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function D(w,f){if(f){const d=`onResolveRemoteAuthority:${(0,P.getRemoteName)(f)}`;return w.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[207],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((P,R)=>te(["vsda"],P,R))}async createNewMessage(P){try{const R=await this.c(),k=new R.validator;if(k){const A=String(c.a++);return this.b.set(A,k),{id:A,data:k.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const k=this.b.get(P.id);if(!k)return!1;this.b.delete(P.id);try{return k.validate(R)==="ok"}catch{return!1}}async sign(P){try{const R=await this.c(),k=new R.signer;if(k)return k.sign(P)}catch{}return P}}e.SignService=c,c.a=1}),define(ye[208],Ce([1,0,12,37,2,30]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(C){if(c.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function A(C,L,T,v,D,w,f,d,m,p){const b=Object.create(null);b["common.machineId"]=f,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=D,b.version=w,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,c.PlatformToString)(c.platform),b["common.nodePlatform"]=t.platform,b["common.nodeArch"]=v,b["common.product"]=p||"desktop",d&&(b["common.msftInternal"]=d);let E=0;const g=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),c.isLinuxSnap&&(b["common.snap"]="true");const i=k(T);i&&(b["common.platformDetail"]=i);try{const l=await C.readFile(P.URI.file(m));b["common.source"]=l.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(C){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const T=L.toLowerCase();return C.some(v=>T===v)}e.verifyMicrosoftInternalDomain=y}),define(ye[209],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[72],Ce([1,0,23,10,3,53,71,208,209]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class C{constructor(r){this.value=r}}e.TelemetryTrustedValue=C;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,n){return Promise.resolve(void 0)}publicLog2(r,n){return this.publicLog(r,n)}publicLogError(r,n){return Promise.resolve(void 0)}publicLogError2(r,n){return this.publicLogError(r,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class T{async publicLog(r,n,h){}async publicLogError(r,n,h){}}e.NullEndpointTelemetryService=T,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(u,r){return P.Event.debounce(r.onDidChangeConfiguration,(h,S)=>{const I=h?new Set([...h.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:I}},1e3,!0)(h=>{h.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(h.source),configurationKeys:E(h.affectedKeys)})})}e.configurationTelemetry=v;function D(u,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!u.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=D;function w(u,r){return!(r.isBuilt||r.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=w;function f(u){const r=u.getValue(y.TELEMETRY_SETTING_ID),n=u.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function d(u){const r={},n={},h={};b(u,h);for(let S in h){S=S.length>150?S.substr(S.length-149):S;const I=h[S];typeof I=="number"?n[S]=I:typeof I=="boolean"?n[S]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${I.length}`),r[S]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(r[S]=I)}return{properties:r,measurements:n}}e.validateTelemetryData=d;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(u){if(!u)return"none";const r=(0,k.getRemoteName)(u);return m.has(r)?r:"other"}e.cleanRemoteAuthority=p;function b(u,r,n=0,h){if(!!u)for(const S of Object.getOwnPropertyNames(u)){const I=u[S],F=h?h+S:S;Array.isArray(I)?r[F]=(0,c.safeStringify)(I):I instanceof Date?r[F]=I.toISOString():(0,t.isObject)(I)?n<2?b(I,r,n+1,F+"."):r[F]=(0,c.safeStringify)(I):r[F]=I}}function E(u){if(!u)return[];const r=[];return g(r,"",u),r}function g(u,r,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(h=>g(u,r?`${r}.${h}`:h,n[h])):u.push(r)}function i(u,r){const n=u.msftInternalDomains||[],h=r.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||h}e.isInternalTelemetry=i;function l(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=l;function o(u,r){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const h=[];for(const K of r)for(;;){const q=K.exec(u);if(!q)break;h.push([q.index,K.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(n="";;){const K=I.exec(u);if(!K)break;const q=h.some(([M,B])=>K.index<B&&M<I.lastIndex);!S.test(K[0])&&!q&&(n+=u.substring(F,K.index)+"<REDACTED: user-file-path>",F=I.lastIndex)}return F<u.length&&(n+=u.substr(F)),n}function a(u){if(!u)return u;const r=u.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(r))return`<REDACTED: ${h.label}>`;return u}function s(u,r){return(0,c.cloneAndChange)(u,n=>{if(n instanceof C)return n.value;if(typeof n=="string"){let h=n.replaceAll("%20"," ");h=o(h,r);for(const S of r)h=h.replace(S,"");return h=a(h),h}})}e.cleanData=s}),define(ye[210],Ce([1,0,8,123,26,12,2,9,37,72]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(o,a){return o.uuid&&a.uuid?o.uuid===a.uuid:o.id===a.id?!0:(0,c.compareIgnoreCase)(o.id,a.id)===0}e.areSameExtensions=L;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(a){const s=a.manifest?a.manifest.version:a.version,u=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new v(a.identifier,s,u)}static parse(a){const s=T.exec(a);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(a,s,u="undefined"){this.version=s,this.targetPlatform=u,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof v?L(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=v;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(o){const a=D.exec(o);return a&&a[1]?[d(a[1]),a[2]]:[d(o),void 0]}e.getIdAndVersion=w;function f(o,a){return`${o}.${a}`}e.getExtensionId=f;function d(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function m(o,a){return d(f(o,a))}e.getGalleryExtensionId=m;function p(o,a){const s=[],u=r=>{for(const n of s)if(n.some(h=>L(a(h),a(r))))return n;return null};for(const r of o){const n=u(r);n?n.push(r):s.push([r])}return s}e.groupByExtension=p;function b(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(o){return{id:new C.TelemetryTrustedValue(o.identifier.id),name:new C.TelemetryTrustedValue(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function g(o,a){const s=[],u=a.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const r=u.shift();if(r&&s.every(n=>!L(n.identifier,{id:r}))){const n=o.filter(h=>L(h.identifier,{id:r}));n.length===1&&(s.push(n[0]),u.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=g;async function i(o,a){if(!R.isLinux)return!1;let s;try{s=(await o.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){a.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(r))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function l(o,a){const s=await i(o,a),u=(0,t.getTargetPlatform)(s?"alpine":R.platform,y.arch);return a.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=l}),define(ye[211],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=c;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t;function P(k){return Array.from(k.entries()).map(A=>[A[0],c(A[1].map)])}e.serializeEnvironmentVariableCollections=P;function R(k){return new Map(k.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[212],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,R,k=5){const A=R(y=>{const C=typeof y=="string"?y:y.data;let L=this.a.get(P);if(L){L.data.push(C);return}const T=setTimeout(()=>this.flushBuffer(P),k);L={data:[C],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(P),A.dispose()}},this.a.set(P,L)});return A}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const R=this.a.get(P);R&&(this.a.delete(P),this.b(P,R.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[213],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===c.HIGH_CONTRAST_DARK||R===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function P(R){return R===c.DARK||R===c.HIGH_CONTRAST_DARK}e.isDark=P}),define(ye[73],Ce([1,0,50,3,6,4,33,213]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var y;(function(d){function m(p){return p&&typeof p=="object"&&typeof p.id=="string"}d.isThemeColor=m})(y=e.ThemeColor||(e.ThemeColor={}));function C(d){return{id:d}}e.themeColorFromId=C;var L;(function(d){function m(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||y.isThemeColor(a.color))}d.isThemeIcon=m;const p=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function b(a){const s=p.exec(a);if(!s)return;const[,u]=s;return{id:u}}d.fromString=b;function E(a){return{id:a}}d.fromId=E;function g(a,s){let u=a.id;const r=u.lastIndexOf("~");return r!==-1&&(u=u.substring(0,r)),s&&(u=`${u}~${s}`),{id:u}}d.modify=g;function i(a){const s=a.id.lastIndexOf("~");if(s!==-1)return a.id.substring(s+1)}d.getModifier=i;function l(a,s){return a.id===s.id&&a.color?.id===s.color?.id}d.isEqual=l;function o(a,s){return{id:a.id,color:s?C(s):void 0}}d.asThemeIcon=o,d.asClassNameArray=c.CSSIcon.asClassNameArray,d.asClassName=c.CSSIcon.asClassName,d.asCSSSelector=c.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function T(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(m){return this.a.push(m),this.b.fire(m),(0,P.toDisposable)(()=>{const p=this.a.indexOf(m);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const D=new v;k.Registry.add(e.Extensions.ThemingContribution,D);function w(d){return D.onColorThemeChange(d)}e.registerThemingParticipant=w;class f extends P.Disposable{constructor(m){super(),this.k=m,this.h=m.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(m){this.h=m,this.updateStyles()}updateStyles(){}w(m,p){let b=this.h.getColor(m);return b&&p&&(b=p(b,this.h)),b?b.toString():null}}e.Themable=f}),define(ye[214],Ce([1,0,14,50,3,10,2,174,91,33,73]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var T;(function(E){function g(i,l){let o=i.defaults;for(;L.ThemeIcon.isThemeIcon(o);){const a=w.getIcon(o.id);if(!a)return;o=a.defaults}return o}E.getDefinition=g})(T=e.IconContribution||(e.IconContribution={}));var v;(function(E){function g(l){return{weight:l.weight,style:l.style,src:l.src.map(o=>({format:o.format,location:o.location.toString()}))}}E.toJSONObject=g;function i(l){const o=a=>(0,R.isString)(a)?a:void 0;if(l&&Array.isArray(l.src)&&l.src.every(a=>(0,R.isString)(a.format)&&(0,R.isString)(a.location)))return{weight:o(l.weight),style:o(l.style),src:l.src.map(a=>({format:a.format,location:k.URI.parse(a.location)}))}}E.fromJSONObject=i})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class D{constructor(){this.a=new P.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${t.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,i,l,o){const a=this.b[g];if(a){if(l&&!a.description){a.description=l,this.d.properties[g].markdownDescription=`${l} $(${g})`;const r=this.e.enum.indexOf(g);r!==-1&&(this.e.enumDescriptions[r]=l),this.a.fire()}return a}const s={id:g,description:l,defaults:i,deprecationMessage:o};this.b[g]=s;const u={$ref:"#/definitions/icons"};return o&&(u.deprecationMessage=o),l&&(u.markdownDescription=`${l}: $(${g})`),this.d.properties[g]=u,this.e.enum.push(g),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,i){const l=this.f[g];return l||(this.f[g]=i,this.a.fire(),i)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(a,s)=>a.id.localeCompare(s.id),i=a=>{for(;L.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(a=>this.b[a]);for(const a of o.filter(s=>!!s.description).sort(g))l.push(`|<i class="${i(a)}"></i>|${a.id}|${L.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const a of o.filter(s=>!L.ThemeIcon.isThemeIcon(s.defaults)).sort(g))l.push(`|<i class="${i(a)}"></i>|${a.id}|`);return l.join(`
`)}}const w=new D;C.Registry.add(e.Extensions.IconContribution,w);function f(E,g,i,l){return w.registerIcon(E,g,i,l)}e.registerIcon=f;function d(){return w}e.getIconRegistry=d;function m(){for(const E of t.Codicon.getAll())w.registerIcon(E.id,{fontCharacter:E.fontCharacter},E.description)}m(),e.iconsSchemaId="vscode://schemas/icons";const p=C.Registry.as(y.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,w.getIconSchema());const b=new c.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);w.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=f("widget-close",t.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",t.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",t.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=L.ThemeIcon.modify(t.Codicon.sync,"spin"),e.spinningLoading=L.ThemeIcon.modify(t.Codicon.loading,"spin")}),define(ye[129],Ce([1,0,3,53,4,13]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var k;(function(f){f.Http="http",f.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=T;function v(f,d,m,p){if(m===1)return!1;if(m===2&&T(d)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class D{constructor(d,m,p){this.remoteAddress=d,this.localAddress=m,this.b=p,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=D;let w=class{constructor(d,m){this.i=d,this.j=m,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],m=Array.from(this.d.values());for(const p of m){const b=Array.from(p.values());for(const E of b){const g=await E.value;g&&d.push(g)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:m}of d.values())await m.then(p=>p?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,m,p,b,E){this.o(d,m,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:m,localAddress:p,privacy:b,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,m){(T(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const p=this.q(d,m);if(p)return++p.refcount,p.value}openTunnel(d,m,p,b,E,g=!1,i,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${p} on local port ${E}.`),!d)return;if(m||(m="localhost"),b||(b=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.r(d,m,p,b,E,g,i,l);return o?o.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(m,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(a);return(a.tunnelRemoteHost!==m||a.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this.d.get(d.tunnelRemoteHost);if(m){const p=m.get(d.tunnelRemotePort);p&&(p.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,p))}}}}async n(d,m,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const b=p.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(m),b}}async closeTunnel(d,m){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const p=this.d.get(d);if(p&&p.has(m)){const b=p.get(m);b.refcount=0,await this.n(d,m,b)}}o(d,m,p){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(m,{refcount:1,value:p})}async p(d,m){const p=this.d.get(d);p&&(await p.get(m)||p.delete(m),p.size===0&&this.d.delete(d))}q(d,m){const p=[d];L(d)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):T(d)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(E=>this.d.get(E));for(const E of b){const g=E?.get(m);if(g)return g}}canTunnel(d){return!!C(d)}s(d,m,p,b,E,g,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${p} on local port ${b}.`);const l=p;this.h.add(l);const o=b===void 0?p:b,a={elevationRequired:E?this.isPortPrivileged(o):!1},s={remoteAddress:{host:m,port:p},localAddressPort:b,privacy:g,public:g?g!==A.Private:void 0,protocol:i},u=d.forwardPort(s,a);return u?(this.o(m,p,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),u}};w=qe([We(0,R.ILogService),We(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(ye[215],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[216],Ce([1,0,17]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(y){return y.scheme!==c.Schemas.file&&y.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function P(y){if(y.folders.length)return y.folders.every(C=>t(C.uri))?y.folders[0].uri:void 0;if(y.configuration&&t(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=P;function R(y){return P(y)?.scheme}e.getVirtualWorkspaceScheme=R;function k(y){return P(y)?.authority}e.getVirtualWorkspaceAuthority=k;function A(y){return P(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],Ce([1,0,175,11,67,24,2,4,17]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function C(o){const a=o;return typeof a?.id=="string"&&k.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=C;function L(o){return typeof o?.id=="string"&&!C(o)&&!v(o)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function T(o,a){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=o;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=T;function v(o){const a=o;return typeof a?.id=="string"&&k.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=v;function D(o){const a=o;if(a?.uri)return{id:a.id,uri:k.URI.revive(a.uri)};const s=o;if(s?.configPath)return{id:s.id,configPath:k.URI.revive(s.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=D;var w;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function f(o){const a=o;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=f;function d(o){const a=o;return!!(a&&typeof a=="object"&&k.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=d;class m{constructor(a,s,u,r,n){this.h=a,this.j=u,this.k=r,this.l=n,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class p{constructor(a,s){this.raw=s,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(o){return new p({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(o,a){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,a.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function g(o){let a;return k.URI.isUri(o)?a=o:a=o.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=g;function i(o,a){return!E(o,a)&&!g(o)}e.isSavedWorkspace=i;function l(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(ye[74],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const R=this.c++;return this.b.set(R,P),this.e(),R}get(P,R){return this.b.has(P)?this.b.get(P)[R]:void 0}delete(P){this.b.delete(P),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=c,c.a=!1}),define(ye[48],Ce([1,0,17,24,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[217],Ce([1,0,14]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,A,y){this.h=new Map,this.a=k,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new c.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of C.values())L.complete()}catch(L){for(const T of C.values())T.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this.d}get(k,A){let y=this.f[k];return typeof y>"u"&&(y=A),y}update(k,A){this.f[k]=A;const y=this.h.get(k);if(y!==void 0)return y.p;const C=new c.DeferredPromise;return this.h.set(k,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class P extends t{setKeysForSync(k){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},k)}constructor(k,A){super(k.identifier.value,!0,A),this.j=k}}e.ExtensionGlobalMemento=P}),define(ye[218],Ce([1,0,3,2]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class P{constructor(k){this.c=k,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(k,A,y,C){const T=this.c.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(A.value,y,C);this.b.fire(T)}$acceptDirtyStateChanged(k,A){this.c.getNotebookDocument(t.URI.revive(k)).acceptDirty(A)}$acceptModelSaved(k){const A=this.c.getNotebookDocument(t.URI.revive(k));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=P}),define(ye[18],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[219],Ce([1,0,26,3]),function(te,e,c,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){P.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(A.identifier),Je(this,P,y,"f"),Ue(this,P,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(A){return Ue(this,P,"f").get(this.a,A)}store(A,y){return Ue(this,P,"f").store(this.a,A,y)}delete(A){return Ue(this,P,"f").delete(this.a,A)}}e.ExtensionSecrets=R,P=new WeakMap}),define(ye[55],Ce([1,0,4,129,3,18]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var k;(function(y){function C(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:T.protocol}}y.fromApiTunnel=C;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==t.TunnelPrivacyId.ConstantPrivate&&T.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}y.fromServiceTunnel=L})(k=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let A=class{constructor(C){this.onDidChangeTunnels=new P.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,L){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,L){return{dispose:()=>{}}}async $providePortAttributes(C,L,T,v,D){return[]}async $forwardPort(C,L){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[56],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(ye[220],Ce([1,0,22]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let C=this.buffers.indexOf(y);return C<0&&(C=this.buffers.length,this.buffers.push(y)),C}}function P(A,y){if(y.serializeBuffersForPostMessage){const C=new t,L=(D,w)=>{if(w instanceof ArrayBuffer){const f=C.add(w);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(w)){const f=R(w);if(f){const d=C.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:f,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},T=JSON.stringify(A,L),v=C.buffers.map(D=>{const w=new Uint8Array(D);return c.VSBuffer.wrap(w)});return{message:T,buffers:v}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=P;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(A,y){const C=y.map(v=>{const D=new ArrayBuffer(v.byteLength);return new Uint8Array(D).set(v.buffer),D}),L=y.length?(v,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const w=D,{index:f}=w,d=C[f];if(w.view)switch(w.view.type){case 1:return new Int8Array(d,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return D}:void 0;return{message:JSON.parse(A,L),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(ye[221],Ce([1,0,114]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(R){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:R,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function P(R){return new c.URITransformer(t(R))}e.createURITransformer=P}),define(ye[130],Ce([1,0,185,10,2,6,4,33,40,17,45,160,38]),function(te,e,c,t,P,R,k,A,y,C,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(D=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var w;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(w=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const G=X;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=f;function d(X,G,de){for(const be of de.visibleEditorPanes)if(be.group.id===G&&X.matches(be.input))return be.getViewState()}e.findViewStateForEditor=d;function m(X){if(n(X))return!1;const G=X;return P.URI.isUri(G?.resource)}e.isResourceEditorInput=m;function p(X){if(n(X))return!1;const G=X;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=p;function b(X){if(n(X)||p(X))return!1;const G=X;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function E(X){if(n(X))return!1;const G=X;return G?G.resource===void 0||G.resource.scheme===C.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;const g=/Untitled-\d+/;function i(X){return X.scheme===C.Schemas.untitled&&X.path.length>1&&!g.test(X.path)}e.isUntitledWithAssociatedResource=i;function l(X){if(n(X))return!1;const G=X;return P.URI.isUri(G?.base?.resource)&&P.URI.isUri(G?.input1?.resource)&&P.URI.isUri(G?.input2?.resource)&&P.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=l;var o;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var a;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.a=new Map}registerSource(G,de){let be=this.a.get(G);return be||(be={source:G,label:de},this.a.set(G,be)),be.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.SaveSourceRegistry=new s;var u;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends R.Disposable{}e.AbstractEditorInput=r;function n(X){return X instanceof r}e.isEditorInput=n;function h(X){const G=X;return P.URI.isUri(G?.preferredResource)}function S(X){const G=X;return n(G?.primary)&&n(G?.secondary)}e.isSideBySideEditorInput=S;function I(X){const G=X;return n(G?.modified)&&n(G?.original)}e.isDiffEditorInput=I;function F(X,G,de,be,Ee){return ee(be,[(0,T.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const Pe={...de,limits:{size:Number.MAX_VALUE}};X.openEditor(G,Pe)}}),(0,T.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=F;function K(X){return n(X?.editor)}e.isEditorInputWithOptions=K;function q(X){const G=X;return K(X)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function M(X){const G=X;return typeof G?.groupId=="number"&&n(G.editor)}e.isEditorIdentifier=M;var B;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(G,de){if(!G)return;if(l(G))return e.EditorResourceAccessor.getOriginalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||l(G))return;const be=h(G)?G.preferredResource:G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}a(G){return S(G)||b(G)?{primary:G.primary,secondary:G.secondary}:I(G)||p(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,de){if(!G)return;if(l(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||l(G))return;const be=G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}b(G,de){if(Array.isArray(de)){if(de.some(be=>G.scheme===be))return G}else if(de===G.scheme)return G}}e.EditorResourceAccessor=new z;var j;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class ue{constructor(){this.c=new Map,this.d=new Map}start(G){const de=this.a=G.get(k.IInstantiationService);for(const[be,Ee]of this.c)this.e(be,Ee,de);this.c.clear()}e(G,de,be){const Ee=be.createInstance(de);this.d.set(G,Ee)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(G,de){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,de,this.a):this.c.set(G,de),(0,R.toDisposable)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new ue);async function V(X,G,de){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Ee=P.URI.revive(be.fileUri);if(!Ee){de.info("Cannot resolve the path because it is not valid.",be);return}if(!await G.canHandleResource(Ee)){de.info("Cannot resolve the path because it cannot be handled",be);return}let Fe=be.exists,se=be.type;if(typeof Fe!="boolean"||typeof se!="number")try{se=(await G.stat(Ee)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Fe=!0}catch(fe){de.error(fe),Fe=!1}if(!Fe&&be.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",be);return}if(se===y.FileType.Directory){de.info("Cannot resolve the path because it is a directory",be);return}const oe={...be.options,pinned:!0};return Fe?{resource:Ee,options:oe}:{resource:Ee,options:oe,forceUntitled:!0}}))}e.pathsToEditors=V;var _;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(_=e.EditorsOrder||(e.EditorsOrder={}));function J(X){const G=X;if(!G)return!1;const de=G;if(de.modified)return J(de.modified);const be=G;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}e.isTextEditorViewState=J;function ie(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=ie;function ee(X,G,de){const be=(0,L.createErrorWithActions)(X,G);return be.forceMessage=de?.forceMessage,be.forceSeverity=de?.forceSeverity,be.allowDialog=de?.allowDialog,be}e.createEditorOpenError=ee}),define(ye[222],Ce([1,0,3,186,4,6,28,33,16,61,23,50,214]),function(te,e,c,t,P,R,k,A,y,C,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",T.Codicon.window,(0,t.localize)(0,null));var D;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(D=e.Extensions||(e.Extensions={}));var w;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(o){switch(o){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class d extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(a,s,u){const r=this.get(a.id);if(r)return r;const n=a;return n.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,k.getOrSet)(this.g,s,[]).push(n),u?.isDefault&&this.h.push(n),this.c.fire({viewContainer:n,viewContainerLocation:s}),n}deregisterViewContainer(a){for(const s of this.g.keys()){const u=this.g.get(s),r=u?.indexOf(a);if(r!==-1){u?.splice(r,1),u.length===0&&this.g.delete(s),this.f.fire({viewContainer:a,viewContainerLocation:s});return}}}get(a){return this.all.filter(s=>s.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(u=>u?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(s=>this.getViewContainerLocation(s)===a)}}A.Registry.add(D.ViewContainersRegistry,new d);var m;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(m=e.ViewContentGroups||(e.ViewContentGroups={}));function p(o,a){const s=o.group??m.More,u=a.group??m.More;return s!==u?s.localeCompare(u):(o.order??5)-(a.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new C.SetMap}registerViews(a,s){this.registerViews2([{views:a,viewContainer:s}])}registerViews2(a){a.forEach(({views:s,viewContainer:u})=>this.l(s,u)),this.c.fire(a)}deregisterViews(a,s){const u=this.m(a,s);u.length&&this.f.fire({views:u,viewContainer:s})}moveViews(a,s){for(const u of this.j.keys())if(u!==s){const r=this.m(a,u);r.length&&(this.l(r,s),this.g.fire({views:r,from:u,to:s}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const s of this.i){const u=(this.j.get(s)||[]).filter(r=>r.id===a)[0];if(u)return u}return null}getViewContainer(a){for(const s of this.i)if((this.j.get(s)||[]).filter(r=>r.id===a)[0])return s;return null}registerViewWelcomeContent(a,s){return this.k.add(a,s),this.h.fire(a),(0,R.toDisposable)(()=>{this.k.delete(a,s),this.h.fire(a)})}registerViewWelcomeContent2(a,s){const u=new Map;for(const[r,n]of s)this.k.add(a,n),u.set(r,(0,R.toDisposable)(()=>{this.k.delete(a,n),this.h.fire(a)}));return this.h.fire(a),u}getViewWelcomeContent(a){const s=[];return this.k.forEach(a,u=>s.push(u)),s.sort(p)}l(a,s){let u=this.j.get(s);u||(u=[],this.j.set(s,u),this.i.push(s));for(const r of a){if(this.getView(r.id)!==null)throw new Error((0,t.localize)(1,null,r.id));u.push(r)}}m(a,s){const u=this.j.get(s);if(!u)return[];const r=[],n=[];for(const h of u)a.includes(h)?r.push(h):n.push(h);return r.length&&(n.length?this.j.set(s,n):(this.j.delete(s),this.i.splice(this.i.indexOf(s),1))),r}}A.Registry.add(D.ViewsRegistry,new b),e.IViewsService=(0,P.createDecorator)("viewsService"),e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var E;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(E=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(a,s){this.c=!1,this.d=!1,(0,L.mixin)(this,a),this.d=!!s,this.resolve=async u=>{if(s&&!this.c){const r=await s(u);r&&(this.tooltip=this.tooltip??r.tooltip,this.command=this.command??r.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class l extends Error{constructor(a){super((0,t.localize)(2,null,a))}}e.NoTreeViewError=l}),define(ye[131],Ce([1,0,3,14,187]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,C,L){const T={command:A};if(y&&Object.keys(y).length>0&&(T.arguments=y),this.s("request",T),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const D=this.f.get(T.seq);if(D){this.f.delete(T.seq);const w={type:"response",seq:0,request_seq:T.seq,success:!1,command:A,message:(0,P.localize)(0,null,L,A)};D(w)}},L)}return C&&this.f.set(T.seq,C),T.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,t.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,C=this.f.get(y.request_seq);C&&(this.f.delete(y.request_seq),C(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,C)=>A.set(C,y)),await(0,t.timeout)(500),A.forEach((y,C)=>{y({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[223],Ce([1,0,188,54,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const R=v=>c.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var k;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(k=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,P.createDecorator)("debugService");var T;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[224],Ce([1,0,8,2,11,23,17]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(o,a,s){return o.replace(A,function(u,r){return a&&r.length>0&&r[0]!=="_"?u:s&&s.hasOwnProperty(r)?s[r]:u})}e.formatPII=y;function C(o){const a={};for(const s of Object.keys(o))s.startsWith("!")||(a[s]=o[s]);return a}e.filterExceptionsFromTelemetry=C;function L(o){return o.configuration.request==="attach"&&!T(o)&&(!o.parentSession||L(o.parentSession))}e.isSessionAttach=L;function T(o){let a=o.configuration.type;if(!!a)return a==="vslsShare"&&(a=o.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(a,"extensionhost")||(0,c.equalsIgnoreCase)(a,"pwa-extensionhost")?o:o.parentSession?T(o.parentSession):void 0}e.getExtensionHostDebugSession=T;function v(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=v;function D(o,a,s){let u,r=0;const n=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=n.exec(o);){const S=h.index+1,I=S+h[0].length;if(S<=a&&I>=s){u=h[0],r=S;break}}if(u){const S=/\w+/g;let I=null;for(;(I=S.exec(u))&&!(I.index+1+r+I[0].length>=s););I&&(u=u.substring(0,S.lastIndex))}return u?{start:r,end:r+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=D;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(o){return!!(o&&o.match(w))}e.isUri=f;function d(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(f(o.path))return t.URI.parse(o.path);if((0,P.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function m(o){if(typeof o.path=="object"){const a=t.URI.revive(o.path);if(a)return a.scheme===k.Schemas.file?a.fsPath:a.toString()}return o.path}function p(o,a){const s=a?d:m,u=(0,R.deepClone)(o);return E(u,(r,n)=>{r&&n&&(n.path=s(n))}),u}e.convertToDAPaths=p;function b(o,a){const s=a?d:m,u=(0,R.deepClone)(o);return E(u,(r,n)=>{!r&&n&&(n.path=s(n))}),u}e.convertToVSCPaths=b;function E(o,a){switch(o.type){case"event":{const s=o;switch(s.event){case"output":a(!1,s.body.source);break;case"loadedSource":a(!1,s.body.source);break;case"breakpoint":a(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=o;switch(s.command){case"setBreakpoints":a(!0,s.arguments.source);break;case"breakpointLocations":a(!0,s.arguments.source);break;case"source":a(!0,s.arguments.source);break;case"gotoTargets":a(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(u=>a(!1,u));break;default:break}break}case"response":{const s=o;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(u=>a(!1,u.source));break;case"loadedSources":s.body.sources.forEach(u=>a(!1,u));break;case"scopes":s.body.scopes.forEach(u=>a(!1,u.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(u=>a(!1,u.source));break;case"setBreakpoints":s.body.breakpoints.forEach(u=>a(!1,u.source));break;case"disassemble":s.body?.instructions.forEach(r=>a(!1,r.location));break;default:break}break}}}function g(o){return o.filter(a=>!a.presentation?.hidden).sort((a,s)=>a.presentation?s.presentation?a.presentation.group?s.presentation.group?a.presentation.group!==s.presentation.group?a.presentation.group.localeCompare(s.presentation.group):i(a.presentation.order,s.presentation.order):-1:s.presentation.group?1:i(a.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=g;function i(o,a){return typeof o!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:o-a}async function l(o,a){const s=o.getValue("debug.saveBeforeStart",{overrideIdentifier:a.activeTextEditorLanguageId});if(s!=="none"&&(await a.saveAll(),s==="allEditorsInActiveGroup")){const u=a.activeEditorPane;u&&u.input.resource?.scheme===k.Schemas.untitled&&await a.save({editor:u.input,groupId:u.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(ye[225],Ce([1,0,46,226,23,11,12,8,29,189,131]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(m,p){this.p=p,this.r=Buffer.allocUnsafe(0),this.t=-1,m.on("data",b=>this.w(b))}sendMessage(m){if(this.p){const p=JSON.stringify(m);this.p.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${T.a}${p}`,"utf8")}}w(m){for(this.r=Buffer.concat([this.r,m]);;){if(this.t>=0){if(this.r.length>=this.t){const p=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(b){this.m.fire(new Error((b.message||b)+`
`+p))}continue}}else{const p=this.r.indexOf(T.a);if(p!==-1){const E=this.r.toString("utf8",0,p).split(T.b);for(const g of E){const i=g.split(T.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(p+T.a.length);continue}}break}}}e.StreamDebugAdapter=T,T.a=`\r
\r
`,T.b=/\r?\n/,T.l=/: */;class v extends T{startSession(){return new Promise((m,p)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),m(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.x.on("error",E=>{b?this.m.fire(E):p(E)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class D extends v{constructor(m){super(),this.z=m}y(m){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",m)}}e.SocketDebugAdapter=D;class w extends v{constructor(m){super(),this.z=m}y(m){return t.createConnection(this.z.path,m)}}e.NamedPipeDebugAdapter=w;class f extends T{constructor(m,p){super(),this.y=m,this.z=p}async startSession(){const m=this.y.command,p=this.y.args,b=this.y.options||{};try{if(m)if(R.isAbsolute(m)){if(!await y.Promises.exists(m))throw new Error(C.localize(0,null,m))}else m.indexOf("/")<0&&m.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.z));let E=process.env;if(b.env&&Object.keys(b.env).length>0&&(E=P.mixin(P.deepClone(process.env),b.env)),m==="node")if(Array.isArray(p)&&p.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:E,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(i.cwd=b.cwd);const l=c.fork(p[0],p.slice(1),i);if(!l.pid)throw new Error(C.localize(2,null,p[0]));this.x=l}else throw new Error(C.localize(3,null));else{const g={env:E};b.cwd&&(g.cwd=b.cwd),this.x=c.spawn(m,p,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,i)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(E){this.m.fire(E)}}async stopSession(){return this.x?(await this.u(),k.isWindows?new Promise((m,p)=>{const b=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(E,g,i){if(E)return p(E)});b.on("exit",m),b.on("error",p)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(m,p){if(!m)return;const b=Object.create(null);m.runtime&&(m.runtime.indexOf("./")===0?b.runtime=R.join(p,m.runtime):b.runtime=m.runtime),m.runtimeArgs&&(b.runtimeArgs=m.runtimeArgs),m.program&&(R.isAbsolute(m.program)?b.program=m.program:b.program=R.join(p,m.program)),m.args&&(b.args=m.args);const E=m;return E.win&&(b.win=f.A(E.win,p)),E.winx86&&(b.winx86=f.A(E.winx86,p)),E.windows&&(b.windows=f.A(E.windows,p)),E.osx&&(b.osx=f.A(E.osx,p)),E.linux&&(b.linux=f.A(E.linux,p)),b}static platformAdapterExecutable(m,p){let b=Object.create(null);p=p.toLowerCase();for(const a of m)if(a.contributes){const s=a.contributes.debuggers;s&&s.length>0&&s.filter(u=>typeof u.type=="string"&&A.equalsIgnoreCase(u.type,p)).forEach(u=>{const r=f.A(u,a.extensionLocation.fsPath);b=P.mixin(b,r,a.isBuiltin)})}let E;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?E=b.winx86||b.win||b.windows:k.isWindows?E=b.win||b.windows:k.isMacintosh?E=b.osx:k.isLinux&&(E=b.linux),E=E||b;const g=E.program||b.program,i=E.args||b.args,l=E.runtime||b.runtime,o=E.runtimeArgs||b.runtimeArgs;if(l)return{type:"executable",command:l,args:(o||[]).concat(typeof g=="string"?[g]:[]).concat(i||[])};if(g)return{type:"executable",command:g,args:i||[]}}}e.ExecutableDebugAdapter=f}),define(ye[227],Ce([1,0,46,32,12]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(C,L){return new Promise((T,v)=>{let D="";const w=c.spawn(C,L);w.pid&&w.stdout.on("data",f=>{D+=f.toString()}),w.on("error",f=>{v(f)}),w.on("close",f=>{T(D)})})}async function k(C){if(C)if(P.isWindows){const L=await new Promise((T,v)=>{te(["windows-process-tree"],T,v)});return new Promise(T=>{L.getProcessTree(C,v=>{T(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(C)]).then(L=>{const T=L.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=k;var A;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(A||(A={}));function y(C,L,T,v,D){C=C.trim().toLowerCase();let w;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?w=1:C.indexOf("cmd.exe")>=0?w=0:C.indexOf("bash")>=0?w=2:P.isWindows?w=0:w=2;let f,d=" ";switch(w){case 1:if(f=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),v){const m=(0,t.getDriveLetter)(v);m&&(d+=`${m}:; `),d+=`cd ${f(v)}; `}if(D)for(const m in D){const p=D[m];p===null?d+=`Remove-Item env:${m}; `:d+=`\${env:${m}}='${p}'; `}if(L.length>0){const m=L.shift(),p=T?m:f(m);d+=p[0]==="'"?`& ${p} `:`${p} `;for(const b of L)d+=b==="<"||b===">"||T?b:f(b),d+=" "}break;case 0:if(f=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>m.includes(p))||m.length===0?`"${m}"`:m),v){const m=(0,t.getDriveLetter)(v);m&&(d+=`${m}: && `),d+=`cd ${f(v)} && `}if(D){d+='cmd /C "';for(const m in D){let p=D[m];p===null?d+=`set "${m}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),d+=`set "${m}=${p}" && `)}}for(const m of L)d+=m==="<"||m===">"||T?m:f(m),d+=" ";D&&(d+='"');break;case 2:{f=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const m=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(v&&(d+=`cd ${f(v)} ; `),D){d+="/usr/bin/env";for(const p in D){const b=D[p];b===null?d+=` -u ${m(p)}`:d+=` ${m(`${p}=${b}`)}`}d+=" "}for(const p of L)d+=p==="<"||p===">"||T?p:f(p),d+=" ";break}}return d}e.prepareCommand=y}),define(ye[92],Ce([1,0,22,39,64,86,17,11,12,54]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var D;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(D=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var p;(function(U){U.scheme=k.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),ue=7;function V(G,de){const be=de.toString(ue),Pe=`${be.length<z.length?z[be.length-1]:"z"}${be}s${(0,c.encodeBase64)(c.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:U.scheme,fragment:Pe})}U.generate=V;function _(G){if(G.scheme!==U.scheme)return;const de=G.fragment.indexOf("s");if(de<0)return;const be=parseInt(G.fragment.substring(0,de).replace(j,""),ue),Ee=(0,c.decodeBase64)(G.fragment.substring(de+1)).toString();if(!isNaN(be))return{handle:be,notebook:G.with({scheme:Ee,fragment:null})}}U.parse=_;function J(G,de){return G.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${G.scheme!==k.Schemas.file?G.scheme:""}`})}U.generateCellOutputUri=J;function ie(G){if(G.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!de)return;const be=de[1]&&de[1]!==""?de[1]:void 0,Ee=de[2];return{outputId:be,notebook:G.with({scheme:Ee||k.Schemas.file,fragment:null})}}U.parseCellOutputUri=ie;function ee(G,de,be){return U.generate(G,de).with({scheme:be})}U.generateCellPropertyUri=ee;function X(G,de){if(G.scheme===de)return U.parse(G.with({scheme:U.scheme}))}U.parseCellPropertyUri=X})(p=e.CellUri||(e.CellUri={}));const b=U=>y.isWindows?U.replace(/\//g,"\\"):U;class E{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(z)].map(ue=>({pattern:ue,matches:t.parse(b(ue))}))}sort(z){const j=new Map(P.Iterable.map(z,V=>[V,b(V)]));let ue=[];for(const{matches:V}of this.d)for(const[_,J]of j)if(V(J)){ue.push(_),j.delete(_);break}return j.size&&(ue=ue.concat([...j.keys()].sort((V,_)=>this.e.indexOf(V)-this.e.indexOf(_)))),ue}prioritize(z,j){const ue=this.f(z);if(ue===-1){this.d.unshift({pattern:z,matches:t.parse(b(z))});return}const V=new Set(j.map(J=>this.f(J,ue)));V.delete(-1);const _=Array.from(V).sort();this.d.splice(ue+1,0,..._.map(J=>this.d[J]));for(let J=_.length-1;J>=0;J--)this.d.splice(_[J],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,j=this.d.length){const ue=b(z);for(let V=0;V<j;V++)if(this.d[V].matches(ue))return V;return-1}}e.MimeTypeDisplayOrder=E;function g(U,z,j,ue=(V,_)=>V===_){const V=[];function _(ee,X,G){if(X===0&&G.length===0)return;const de=V[V.length-1];de&&de.start+de.deleteCount===ee?(de.deleteCount+=X,de.toInsert.push(...G)):V.push({start:ee,deleteCount:X,toInsert:G})}let J=0,ie=0;for(;;){if(J===U.length){_(J,0,z.slice(ie));break}if(ie===z.length){_(J,U.length-J,[]);break}const ee=U[J],X=z[ie];if(ue(ee,X)){J+=1,ie+=1;continue}j(X)?(_(J,1,[]),J+=1):(_(J,0,[X]),ie+=1)}return V}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(U){const z=U;return!!((typeof z.include=="string"||t.isRelativePattern(z.include))&&(typeof z.exclude=="string"||t.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=l;function o(U,z,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(z)>=0||U.viewType===z)return!0;if(U.filenamePattern){const ue=l(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,V=l(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(t.match(ue,(0,A.basename)(j.fsPath).toLowerCase()))return!(V&&t.match(V,(0,A.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var a;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(z){return`${s.d}${z}`}static parse(z){if(z.startsWith(s.d))return z.substring(s.d.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s.d="notebook/";function u(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=u;const r=new TextDecoder;function n(U){const z=[];let j=!1;for(const ue of U)(z.length===0||j)&&(z.push(ue),j=!0);return F(z),O(c.VSBuffer.concat(z.map(ue=>c.VSBuffer.wrap(ue))))}e.compressOutputItemStreams=n;const h=`${String.fromCharCode(27)}[A`,S=h.split("").map(U=>U.charCodeAt(0)),I=10;function F(U){U.forEach((z,j)=>{if(j===0||z.length<h.length)return;const ue=U[j-1],V=z.subarray(0,h.length);if(V[0]===S[0]&&V[1]===S[1]&&V[2]===S[2]){const _=ue.lastIndexOf(I);if(_===-1)return;U[j-1]=ue.subarray(0,_),U[j]=z.subarray(h.length)}})}function K(U){let z=U;do U=z,z=U.replace(/[^\n]\x08/gm,"");while(z.length<U.length);return U}function q(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const z=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const M="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(U){return!U.buffer.includes(M)&&!U.buffer.includes(B)?U:c.VSBuffer.fromString(q(K(r.decode(U.buffer))))}}),define(ye[228],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[57],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class P{static fromExtHostTestItem(k,A,y=k.parent){if(k._isRoot)return new P([A]);const C=[k.id];for(let L=y;L&&L.id!==A;L=L.parent)C.push(L.id);return C.push(A),new P(C.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const A=k.indexOf("\0");return A===-1?k:k.slice(0,A)}static fromString(k){return new P(k.split("\0"))}static join(k,A){return new P([...k.path,A])}static joinToString(k,A){return k.toString()+"\0"+A}static parentId(k){const A=k.lastIndexOf("\0");return A===-1?void 0:k.slice(0,A)}static localId(k){const A=k.lastIndexOf("\0");return A===-1?k:k.slice(A+1)}static compare(k,A){return k===A?0:A.startsWith(k+"\0")?2:k.startsWith(A+"\0")?3:1}constructor(k,A=k.length){if(this.path=k,this.d=A,k.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new P(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new P(this.path,k)}compare(k){if(typeof k=="string")return P.compare(this.toString(),k);for(let A=0;A<k.d&&A<this.d;A++)if(k.path[A]!==this.path[A])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.TestId=P}),define(ye[75],Ce([1,0,2,36,57]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var k;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable",r[r.SupportsContinuousRun=64]="SupportsContinuousRun"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=r=>"runIn"in r;e.isStartControllerTests=A;var y;(function(r){r.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),r.deserialize=n=>({range:t.Range.lift(n.range),uri:c.URI.revive(n.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var C;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(C=e.TestMessageType||(e.TestMessageType={}));var L;(function(r){r.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.deserialize(n.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(r,n)=>`${n?"s":"e"}${r}`;e.getMarkId=T;var v;(function(r){r.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.deserialize(n.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var D;(function(r){r.serialize=n=>n.type===0?L.serialize(n):v.serialize(n),r.deserialize=n=>n.type===0?L.deserialize(n):v.deserialize(n)})(D=e.ITestMessage||(e.ITestMessage={}));var w;(function(r){r.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),r.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(D.serialize)}),r.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(D.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",d=(r,n)=>r+f+n;e.namespaceTestTag=d;const m=r=>{const n=r.indexOf(f);return{ctrlId:r.slice(0,n),tagId:r.slice(n+1)}};e.denamespaceTestTag=m;var p;(function(r){r.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),r.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?c.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var E;(function(r){r.serialize=n=>({expand:n.expand,item:p.serialize(n.item)}),r.deserialize=n=>({controllerId:P.TestId.root(n.item.extId),expand:n.expand,item:p.deserialize(n.item)})})(E=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},r.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(r,n)=>{n.expand!==void 0&&(r.expand=n.expand),n.item!==void 0&&(r.item=r.item?Object.assign(r.item,n.item):n.item)};e.applyTestItemUpdate=i;var l;(function(r){r.serializeWithoutMessages=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(w.serializeWithoutMessages),retired:n.retired}),r.serialize=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(w.serialize),retired:n.retired}),r.deserialize=n=>({...E.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(w.deserialize),retired:!0})})(l=e.TestResultItem||(e.TestResultItem={}));var o;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var a;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(r){r.deserialize=n=>n.op===0?{op:n.op,item:E.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n.op===2?{op:n.op,uri:c.URI.revive(n.uri),docv:n.docv}:n,r.serialize=n=>n.op===0?{op:n.op,item:E.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class u{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const S of n)switch(S.op){case 0:this.j(E.deserialize(S.item),h);break;case 1:this.k(g.deserialize(S.item),h);break;case 3:this.l(S.itemId,h);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}h.complete?.()}j(n,h){const S=P.TestId.parentId(n.item.extId)?.toString();let I;if(!S)I=this.p(n),this.f.add(I),this.d.set(n.item.extId,I);else if(this.d.has(S)){const F=this.d.get(S);F.children.add(n.item.extId),I=this.p(n,F),this.d.set(n.item.extId,I)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(I),n.expand===2&&this.g++,I}k(n,h){const S=this.d.get(n.extId);if(!!S)return n.expand!==void 0&&(S.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(S,n),h.update?.(S),S}l(n,h){const S=this.d.get(n);if(!S)return;const I=P.TestId.parentId(S.item.extId)?.toString();I?this.d.get(I).children.delete(S.item.extId):this.f.delete(S);const F=[[n]];for(;F.length;)for(const K of F.pop()){const q=this.d.get(K);q&&(F.push(q.children),this.d.delete(K),h.remove?.(q,q!==S),q.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=u}),define(ye[93],Ce([1,0,14,3,6,51,75,57]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(p,b)=>p===b,T=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:C,label:C,description:C,error:C,sortText:C,tags:(p,b)=>!(p.length!==b.length||p.some(E=>!b.includes(E)))}),v=(p,b)=>{let E;for(const[g,i]of T)i(p[g],b[g])||(E?E[g]=b[g]:E={[g]:b[g]});return E};class D extends P.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.G(E)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(E.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const g=this.tree.get(b);if(!!g){if((g.expandLevels===void 0||E>g.expandLevels)&&(g.expandLevels=E),g.expand===1){const i=this.I(g);return i.isOpen()?this.H(g,E-1):i.wait().then(()=>this.H(g,E-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,E-1)):this.H(g,E-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,E){switch(E.op){case 3:this.L(A.TestId.joinToString(b.fullId,E.id));break;case 0:this.u(E.item,b);break;case 5:for(const g of E.ops)this.p(b,g);break;case 1:this.w(E.new,E.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(E)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,E){const g=A.TestId.fromExtHostTestItem(b,this.root.id,E?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==E?.actual&&this.m.getChildren(i.parent).delete(b.id);let l=this.tree.get(g.toString());if(!l){l={fullId:g,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(l.fullId.toString(),l),this.C(b,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(b)}}),this.F(b,l,E);return}if(l.actual===b){this.D(b,l,E);return}if(l.actual.uri?.toString()!==b.uri?.toString())return this.L(g.toString()),this.u(b,E);const o=this.m.getChildren(l.actual),a=l.actual,s=v(this.m.toITestItem(a),this.m.toITestItem(b));this.m.getApiFor(a).listener=void 0,l.actual=b,l.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(b.tags,a.tags,g.toString()),delete s.tags),this.p(l,{op:4,update:s})),this.F(b,l,E);for(const[u,r]of o)this.m.getChildren(b).get(r.id)||this.L(A.TestId.joinToString(g,r.id));this.s(l.actual.uri)}w(b,E,g){const i=new Set(E.map(l=>l.id));for(const l of b)i.delete(l.id)||this.y(l);this.pushDiff({op:1,item:{extId:g,item:{tags:b.map(l=>(0,k.namespaceTestTag)(this.m.controllerId,l.id))}}}),i.forEach(this.z,this)}y(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,k.namespaceTestTag)(this.m.controllerId,b)}))}C(b,E){this.m.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}D(b,E,g){this.C(b,g);const i=this.m.getApiFor(b);i.parent=g?.actual,i.listener=l=>this.p(E,l),this.G(E)}F(b,E,g){this.D(b,E,g);for(const[i,l]of this.m.getChildren(b))this.u(l,E)}G(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.I(b))}H(b,E){if(E<0)return;const g=[];for(const[i,l]of this.m.getChildren(b.actual)){const o=this.expand(A.TestId.joinToString(b.fullId,l.id),E);(0,c.isThenable)(o)&&g.push(o)}if(g.length)return Promise.all(g).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const l=new c.Barrier;return l.open(),l}b.expand=2,this.J(b);const E=b.resolveBarrier=new c.Barrier,g=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(l){g(l)}return(0,c.isThenable)(i)?i.catch(g).then(()=>{E.open(),this.G(b)}):(E.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const g=[E];for(;g.length;){const i=g.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const l of i.actual.tags)this.z(l.id);this.tree.delete(i.fullId.toString());for(const[l,o]of this.m.getChildren(i.actual))g.push(this.tree.get(A.TestId.joinToString(i.fullId,o.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=D;class w extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=w;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(b,E,g){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=d;const m=(p,b,E)=>{let g=new Map;return{get size(){return g.size},forEach(i,l){for(const o of g.values())i.call(l,o,this)},[Symbol.iterator](){return g.entries()},replace(i){const l=new Map,o=new Set(g.keys()),a={op:5,ops:[]};for(const s of i){if(!(s instanceof E))throw new f(s.id);const u=b(s).controllerId;if(u!==p.controllerId)throw new d(s.id,u,p.controllerId);if(l.has(s.id))throw new w(s.id);l.set(s.id,s),o.delete(s.id),a.ops.push({op:0,item:s})}for(const s of o.keys())a.ops.push({op:3,id:s});p.listener?.(a),g=l},add(i){if(!(i instanceof E))throw new f(i.id);g.set(i.id,i),p.listener?.({op:0,item:i})},delete(i){g.delete(i)&&p.listener?.({op:3,id:i})},get(i){return g.get(i)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=m}),define(ye[132],Ce([1,0,93]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,P=(k,A)=>{const y={controllerId:A};return t.set(k,y),y};e.createPrivateApiFor=P;const R=k=>{const A=t.get(k);if(!A)throw new c.InvalidTestItemError(k?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[94],Ce([1,0,17,2]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function P(A,y){return A.scheme===c.Schemas.http||A.scheme===c.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===c.Schemas.file&&(A=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:y.authority,path:A.path})),t.URI.from({scheme:c.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=P;function R(A){return A.replace(/./g,y=>{const C=y.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?y:"-"+C.toString(16).padStart(4,"0")})}function k(A){return A.replace(/-([0-9a-f]{4})/g,(y,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=k}),define(ye[229],Ce([1,0,3,6,94]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,C){this.d=A,this.e=y,this.f=C,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const T of this.c.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,C,L,T){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){v=b;break}if(!v)throw new Error("not a visible editor");const D=this,w=this.a++,f=new c.Emitter,d=new c.Emitter,m=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,P.asWebviewUri)(b,D.f)}get cspSource(){return P.webviewGenericCspSource}set options(b){this.b=b,D.d.$setOptions(w,b)}get options(){return this.b}set html(b){this.a=b,D.d.$setHtml(w,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return D.d.$postMessage(w,b)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=C,this.webview=m,this.onDidDispose=d.event}dispose(){D.c.has(w)&&(D.c.delete(w),D.d.$disposeEditorInset(w),d.fire(),d.dispose(),f.dispose())}};return this.d.$createEditorInset(w,v.id,v.value.document.uri,y+1,C,L||{},T.identifier,T.extensionLocation),this.c.set(w,{editor:A,inset:p,onDidReceiveMessage:f}),p}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[230],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class P extends Error{constructor(k,A){super(A),this.variable=k}}e.VariableError=P}),define(ye[231],Ce([1,0,11,37,10,23,12,113,192,230,8]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(D,w,f,d){this.g=new Map,this.a=D,this.b=w,this.d=f,d&&(this.c=d.then(m=>this.h(m)))}h(D){if(k.isWindows){const w=Object.create(null);return Object.keys(D).forEach(f=>{w[f.toLowerCase()]=D[f]}),w}return D}resolveWithEnvironment(D,w,f){return this.j({env:this.h(D),userHome:void 0},w?w.uri:void 0,f)}async resolveAsync(D,w){const f={env:await this.c,userHome:await this.d};return this.j(f,D?D.uri:void 0,w)}async i(D,w,f,d){const m=R.deepClone(w);k.isWindows&&m.windows?Object.keys(m.windows).forEach(b=>m[b]=m.windows[b]):k.isMacintosh&&m.osx?Object.keys(m.osx).forEach(b=>m[b]=m.osx[b]):k.isLinux&&m.linux&&Object.keys(m.linux).forEach(b=>m[b]=m.linux[b]),delete m.windows,delete m.osx,delete m.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,D?D.uri:void 0,m,f,d)}async resolveAnyAsync(D,w,f){return this.i(D,w,f)}async resolveAnyMap(D,w,f){const d=new Map;return{newConfig:await this.i(D,w,f,d),resolvedVariables:d}}resolveWithInteractionReplace(D,w,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,w,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,w){if(this.g.has(D))throw new Error("Variable "+D+" is contributed twice.");this.g.set(D,w)}async j(D,w,f,d,m){if(P.isString(f))return this.l(D,w,f,d,m);if(Array.isArray(f))return Promise.all(f.map(p=>this.j(D,w,p,d,m)));if(P.isObject(f)){const p=Object.create(null),b=await Promise.all(Object.keys(f).map(async E=>[await this.l(D,w,E,d,m),await this.j(D,w,f[E],d,m)]));for(const[E,g]of b)p[E]=g;return p}return f}l(D,w,f,d,m){return(0,L.replaceAsync)(f,T.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(T.VARIABLE_LHS))return p;let E=await this.n(D,p,b,w,d);return m?.set(b,E),E!==p&&P.isString(E)&&E.match(T.VARIABLE_REGEXP)&&(E=await this.l(D,w,E,d,m)),E})}m(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async n(D,w,f,d,m){let p;const b=f.split(":");b.length>1&&(f=b[0],p=b[1]);const E=l=>{const o=this.a.getFilePath();if(o)return(0,A.normalizeDriveLetter)(o);throw new C.VariableError(l,(0,y.localize)(0,null,w))},g=l=>{const o=E(l);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,A.normalizeDriveLetter)(a)}throw new C.VariableError(l,(0,y.localize)(1,null,w,c.basename(o)))},i=l=>{if(p){const o=this.a.getFolderUri(p);if(o)return o;throw new C.VariableError(l,(0,y.localize)(2,null,w,p))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(l,(0,y.localize)(3,null,w)):new C.VariableError(l,(0,y.localize)(4,null,w))};switch(f){case"env":if(p){if(D.env){const l=D.env[k.isWindows?p.toLowerCase():p];if(P.isString(l))return l}return""}throw new C.VariableError(C.VariableKind.Env,(0,y.localize)(5,null,w));case"config":if(p){const l=this.a.getConfigurationValue(d,p);if(P.isUndefinedOrNull(l))throw new C.VariableError(C.VariableKind.Config,(0,y.localize)(6,null,w,p));if(P.isObject(l))throw new C.VariableError(C.VariableKind.Config,(0,y.localize)(7,null,w,p));return l}throw new C.VariableError(C.VariableKind.Config,(0,y.localize)(8,null,w));case"command":return this.o(C.VariableKind.Command,w,p,m,"command");case"input":return this.o(C.VariableKind.Input,w,p,m,"input");case"extensionInstallFolder":if(p){const l=await this.a.getExtension(p);if(!l)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,w,p));return this.m(l.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,w));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(C.VariableKind.WorkspaceFolder)));case"cwd":return d||p?(0,A.normalizeDriveLetter)(this.m(i(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(c.basename(this.m(i(C.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,y.localize)(11,null,w))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new C.VariableError(C.VariableKind.LineNumber,(0,y.localize)(12,null,w))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new C.VariableError(C.VariableKind.SelectedText,(0,y.localize)(13,null,w))}case"file":return E(C.VariableKind.File);case"fileWorkspaceFolder":return g(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||p?c.relative(this.m(i(C.VariableKind.RelativeFile)),E(C.VariableKind.RelativeFile)):E(C.VariableKind.RelativeFile);case"relativeFileDirname":{const l=c.dirname(E(C.VariableKind.RelativeFileDirname));if(d||p){const o=c.relative(this.m(i(C.VariableKind.RelativeFileDirname)),l);return o.length===0?".":o}return l}case"fileDirname":return c.dirname(E(C.VariableKind.FileDirname));case"fileExtname":return c.extname(E(C.VariableKind.FileExtname));case"fileBasename":return c.basename(E(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=c.basename(E(C.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-c.extname(l).length)}case"fileDirnameBasename":return c.basename(c.dirname(E(C.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||w}case"execInstallFolder":{const l=this.a.getAppRoot();return l||w}case"pathSeparator":return c.sep;default:try{const l=p?`${f}:${p}`:f;return this.o(C.VariableKind.Unknown,w,l,m,void 0)}catch{return w}}}}o(D,w,f,d,m){if(f&&d){const p=m===void 0?d[f]:d[m+":"+f];if(typeof p=="string")return p;throw new C.VariableError(D,(0,y.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,4,130]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var P;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var A;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function C(w){const f=w;return(0,t.isEditorInput)(f?.editor)&&(0,t.isEditorInput)(f?.replacement)}e.isEditorReplacement=C;var L;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function v(w){const f=w;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function D(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(ye[232],Ce([1,0,4,133]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function P(R){const k=R;return typeof R=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=P}),define(ye[233],Ce([1,0,4,198]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,26,3,11]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=R;class k{static isHostExtension(T,v,D){if(v.getExtensionDescription(T))return!1;const w=D.getExtensionDescription(T);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(T){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=T,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const T of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(T.identifier),T),this.f.push(T),Array.isArray(T.activationEvents))for(let v of T.activationEvents)v==="onUri"&&(v=`onUri:${c.ExtensionIdentifier.toKey(T.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(T)}}set(T){this.d=T,this.h(),this.c.fire(void 0)}deltaExtensions(T,v){this.d=C(this.d,v),this.d=this.d.concat(T);const D=k.j(this.d);return this.d=C(this.d,D.map(w=>w.identifier)),this.h(),this.c.fire(void 0),new R(D)}static j(T){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,p){this.addNode(m),this.addNode(p),this.c.has(m)?this.c.get(m).push(p):this.c.set(m,[p])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,p){const b=v.getArcs(m);for(let E=0;E<b.length;E++)if(!p.has(b[E]))return!1;return!0}getNodes(){return this.e}},D=new Map;for(const m of T){const p=c.ExtensionIdentifier.toKey(m.identifier);if(D.set(p,m),m.extensionDependencies)for(const b of m.extensionDependencies){const E=c.ExtensionIdentifier.toKey(b);v.addArc(p,E)}}const w=new Set;v.getNodes().filter(m=>v.getArcs(m).length===0).forEach(m=>w.add(m));const f=v.getNodes().filter(m=>!w.has(m));let d;do{d=!1;for(let m=0;m<f.length;m++){const p=f[m];v.hasOnlyGoodArcs(p,w)&&(f.splice(m,1),m--,w.add(p),d=!0)}}while(d);return f.map(m=>D.get(m))}containsActivationEvent(T){return this.g.has(T)}containsExtension(T){return this.e.has(c.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const v=this.g.get(T);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(T){const v=this.e.get(c.ExtensionIdentifier.toKey(T));return v||void 0}getExtensionDescriptionByUUID(T){for(const v of this.f)if(v.uuid===T)return v}getExtensionDescriptionByIdOrUUID(T,v){return this.getExtensionDescription(T)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=k;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function y(L,T){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,D=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(v!==D)return v-D;const w=P.posix.basename(L.extensionLocation.path),f=P.posix.basename(T.extensionLocation.path);return w<f?-1:w>f?1:0}function C(L,T){const v=new Set;return T.forEach(D=>v.add(c.ExtensionIdentifier.toKey(D))),L.filter(D=>!v.has(c.ExtensionIdentifier.toKey(D.identifier)))}}),define(ye[234],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class P{constructor(){this.type=2}serialize(T){T[P.ENV_KEY]="1"}}e.SocketExtHostConnection=P,P.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(T){T[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(L){delete L[t.ENV_KEY],delete L[P.ENV_KEY],delete L[R.ENV_KEY]}function A(L,T){k(T),L.serialize(T)}e.writeExtHostConnection=A;function y(L){if(L[t.ENV_KEY])return C(L,new t(L[t.ENV_KEY]));if(L[P.ENV_KEY])return C(L,new P);if(L[R.ENV_KEY])return C(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function C(L,T){return k(L),T}}),define(ye[95],Ce([1,0,22]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var P;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(P=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function k(C){const L=c.VSBuffer.alloc(1);switch(C){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=k;function A(C,L){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var y;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],Ce([1,0,4,3,13,25,95,71,72,23,2]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let T=class{constructor(f,d){this.i=f,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=d.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(f,d,m){const p=this.getTelemetryDetails(),b=new v(d,m,f,this.g,this.f,this.getBuiltInCommonProperties(f),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled});return this.h.set(f.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(f,d,m){this.d=f,this.f=d,this.c=m??{usage:!0,error:!0}}getBuiltInCommonProperties(f){const d={};switch(d["common.extname"]=`${f.publisher}.${f.name}`,d["common.extversion"]=f.version,d["common.vscodemachineid"]=this.i.telemetryInfo.machineId,d["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,d["common.vscodeversion"]=this.i.version,d["common.isnewappinstall"]=D(this.i.telemetryInfo.firstSessionDate),d["common.product"]=this.i.environment.appHost,this.i.uiKind){case k.UIKind.Web:d["common.uikind"]="web";break;case k.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),d}$onDidChangeTelemetryLevel(f){this.e=this.getTelemetryConfiguration(),this.d=f;const d=this.getTelemetryDetails();this.h.forEach(m=>{m.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(f,d){const m=this.h.get(f.value);return!m||m.ignoreUnhandledExtHostErrors?!1:(m.logError(d),!0)}};T=qe([We(0,R.IExtHostInitDataService),We(1,P.ILoggerService)],T),e.ExtHostTelemetry=T;class v{constructor(f,d,m,p,b,E,g){this.g=m,this.h=p,this.i=b,this.j=E,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.e=d?.ignoreBuiltInCommonProperties??!1,this.f=d?.additionalCommonProperties,this.a=f,this.c={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(f,d){this.d&&(this.c={isUsageEnabled:f,isErrorsEnabled:d},this.b.fire(this.d))}mixInCommonPropsAndCleanData(f){let d=f.properties??f;return d=(0,y.cleanData)(d,[]),this.f&&(d=(0,C.mixin)(d,this.f)),this.e||(d=(0,C.mixin)(d,this.j)),f.properties?f.properties=d:f=d,f}k(f,d){this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.a.sendEventData(f,d),this.h.trace(f,d)}logUsage(f,d){!this.c.isUsageEnabled||this.k(f,d)}logError(f,d){!this.c.isErrorsEnabled||(typeof f=="string"?this.k(f,d):this.a.sendErrorData(f,d))}get apiTelemetryLogger(){if(!this.d){const f=this,d={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.c.isUsageEnabled},get isErrorsEnabled(){return f.c.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.b.event.bind(f)};this.d=Object.freeze(d)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=v;function D(w){const f=Date.now()-new Date(w).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=D,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[27],Ce([1,0,3,2,4,26,210]),function(te,e,c,t,P,R,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class y{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class C{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class L{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class T{constructor(u){this.dependency=u}}e.MissingExtensionDependency=T;var v;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=D;class w{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,r){const n=[],h=[],S=[],I=[],F=m(this.c),K=m(u),q=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.c){const z=K.get(R.ExtensionIdentifier.toKey(U.identifier));if(!z){n.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!q(U,z)){n.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of u){const z=F.get(R.ExtensionIdentifier.toKey(U.identifier));if(!z){h.push(U);continue}if(!q(z,U)){n.push(z.identifier),F.delete(R.ExtensionIdentifier.toKey(z.identifier));continue}}const M=d(this.d),B=d(r);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||S.push(U);for(const U of r)M.has(R.ExtensionIdentifier.toKey(U))||I.push(U);const O={toRemove:n,toAdd:h,myToRemove:S,myToAdd:I};return this.delta(O),O}delta(u){const{toRemove:r,toAdd:n,myToRemove:h,myToAdd:S}=u,I=d(r),F=d(h);for(let K=0;K<this.c.length;K++)I.has(R.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)F.has(R.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of n)this.c.push(K);for(const K of S)this.d.push(K)}containsExtension(u){for(const r of this.d)if(R.ExtensionIdentifier.equals(r,u))return!0;return!1}}e.ExtensionHostExtensions=w;class f{constructor(u){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,u)for(const r of u)this.add(r)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,r){this.c.forEach(n=>u.call(r,n,n,this))}*entries(){for(const[u,r]of this.c)yield[r,r]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function d(s){const u=new Set;for(const r of s)u.add(R.ExtensionIdentifier.toKey(r));return u}e.extensionIdentifiersArrayToSet=d;function m(s){const u=new Map;for(const r of s)u.set(R.ExtensionIdentifier.toKey(r.identifier),r);return u}function p(s,u){return s.enabledApiProposals?s.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=p;function b(s,u){if(!p(s,u))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class E{constructor(u,r,n,h){this.codeLoadingTime=u,this.activateCallTime=r,this.activateResolvedTime=n,this.activationReason=h}}e.ActivationTimes=E;class g{constructor(u,r){this.description=u,this.value=r}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function l(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function o(s,u){return{identifier:new R.ExtensionIdentifier((0,k.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!u,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=o;class a{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,r){return Promise.resolve(0)}getInspectPorts(u,r){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(ye[235],Ce([1,0,9,134,26,27,13,14]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(m,p,b,E){this.startup=m,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=E}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class C{constructor(m){this.a=m,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(m,p){return m===-1||p===-1?-1:p-m}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=C;class L{constructor(m,p,b,E,g,i){this.activationFailed=m,this.activationFailedError=p,this.activationTimes=b,this.module=E,this.exports=g,this.subscriptions=i}}e.ActivatedExtension=L;class T extends L{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class v extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class D extends L{constructor(m){super(!0,m,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(m,p,b,E){this.g=E,this.a=m,this.b=p,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[m,p]of this.d)p.dispose()}isActivated(m){const p=this.d.get(P.ExtensionIdentifier.toKey(m));return Boolean(p&&p.value)}getActivatedExtension(m){const p=this.d.get(P.ExtensionIdentifier.toKey(m));if(!p||!p.value)throw new Error(`Extension '${m.value}' is not known or not activated`);return p.value}async activateByEvent(m,p){if(this.f[m])return;const b=this.a.getExtensionDescriptionsForActivationEvent(m);await this.h(b.map(E=>({id:E.identifier,reason:{startup:p,extensionId:E.identifier,activationEvent:m}}))),this.f[m]=!0}activateById(m,p){const b=this.a.getExtensionDescription(m);if(!b)throw new Error(`Extension '${m}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(m){const p=m.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(m){if(this.d.has(P.ExtensionIdentifier.toKey(m.id)))return this.d.get(P.ExtensionIdentifier.toKey(m.id));if(this.l(m.id))return this.k(m,null,[],null);const p=this.a.getExtensionDescription(m.id);if(!p){const g=new Error(`Cannot activate unknown extension '${m.id.value}'`),i=this.k(m,null,[],new D(g));return this.c.onExtensionActivationError(m.id,g,new R.MissingExtensionDependency(m.id.value)),i}const b=[],E=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const g of E){if(this.m(g))continue;const i=this.d.get(P.ExtensionIdentifier.toKey(g));if(i){b.push(i);continue}if(this.l(g)){b.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:m.reason}));continue}const l=this.a.getExtensionDescription(g);if(l){if(!l.main&&!l.browser)continue;b.push(this.j({id:l.identifier,reason:m.reason}));continue}const o=p.displayName||p.identifier.value,a=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${g}'`),s=this.k(m,p.displayName,[],new D(a));return this.c.onExtensionActivationError(p.identifier,a,new R.MissingExtensionDependency(g)),s}return this.k(m,p.displayName,b,null)}k(m,p,b,E){const g=new f(m.id,p,m.reason,b,E,this.c,this.g);return this.d.set(P.ExtensionIdentifier.toKey(m.id),g),g}l(m){return t.ExtensionDescriptionRegistry.isHostExtension(m,this.a,this.b)}m(m){const p=this.b.getExtensionDescription(m);return p?!p.main&&!p.browser:!1}};w=qe([We(3,k.ILogService)],w),e.ExtensionsActivator=w;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(m,p,b,E,g,i,l){this.c=m,this.d=p,this.f=b,this.g=E,this.h=g,this.j=i,this.k=l,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let m=0;m<this.g.length;m++){const p=this.g[m];if(p.value&&!p.value.activationFailed){this.g.splice(m,1),m--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new D(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(m=>m.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(m){const p=new Error;if(m&&m.name&&(p.name=m.name),m&&m.message?p.message=`Activating extension '${this.c.value}' failed: ${m.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${m}.`,m&&m.stack&&(p.stack=m.stack),this.h=new D(p),this.b&&c.isCancellationError(m))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(m)}}};f=qe([We(6,k.ILogService)],f)}),define(ye[236],Ce([1,0,13,25,27]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends c.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:P.ExtensionHostLogFileName}))}};R=qe([We(0,c.ILoggerService),We(1,t.IExtHostInitDataService)],R),e.ExtHostLogService=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[7],Ce([1,0,16,9,112,28,86,8,10,2,30,40,128,92,27]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w){"use strict";var f,d,m,p,b,E,g,i,l,o,a,s,u,r,n,h,S,I,F,K,q,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(x){return Object.assign(x,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(x,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[me,...Te]=arguments;return Reflect.construct(x,Te,me.constructor)}}})}var U;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=E=class{static from(...W){let me=W;return new E(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(W){f.set(this,void 0),Je(this,f,W,"f")}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),Je(this,f,void 0,"f"))}};f=new WeakMap,j=E=qe([O],j),e.Disposable=j;let ue=g=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(me)&&(me=Ke)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(me)&&(me=Ke)}return me}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:me,character:Te}=W;return typeof me=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(me<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&me===0?this:new g(this.line+Te,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Te===this.line&&me===this.character?this:new g(Te,me)}toJSON(){return{line:this.line,character:this.character}}};ue=g=qe([O],ue),e.Position=ue;let V=i=class{static isRange(W){return W instanceof i?!0:W?ue.isPosition(W.start)&&ue.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Te,Ke){let Ye,at;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ue(W,me),at=new ue(Te,Ke)):ue.isPosition(W)&&ue.isPosition(me)&&(Ye=ue.of(W),at=ue.of(me)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):ue.isPosition(W)?!(ue.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=ue.Max(W.start,this.c),Te=ue.Min(W.end,this.e);if(!me.isAfter(Te))return new i(me,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=ue.Min(W.start,this.c),Te=ue.Max(W.end,this.end);return new i(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return W?ue.isPosition(W)?Te=W:(Te=W.start||this.start,me=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new i(Te,me)}toJSON(){return[this.start,this.end]}};V=i=qe([O],V),e.Range=V;let _=l=class extends V{static isSelection(W){return W instanceof l?!0:W?V.isRange(W)&&ue.isPosition(W.anchor)&&ue.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Te,Ke){let Ye,at;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ue(W,me),at=new ue(Te,Ke)):ue.isPosition(W)&&ue.isPosition(me)&&(Ye=ue.of(W),at=ue.of(me)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=l=qe([O],_),e.Selection=_;class J{constructor(W,me,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=J;class ie extends Error{static NotAvailable(W,me){return new ie(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new ie(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=me,this._detail=Te,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var ee;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var X;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=o=class{static isTextEdit(W){return W instanceof o?!0:W?V.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new o(W,me)}static insert(W,me){return o.replace(new V(W,W),me)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const me=new o(new V(new ue(0,0),new ue(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!V.isRange(W))throw(0,t.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};G=o=qe([O],G),e.TextEdit=G;let de=a=class{static isNotebookCellEdit(W){return W instanceof a?!0:W?Gt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new a(W,me)}static insertCells(W,me){return new a(new Gt(W,W),me)}static deleteCells(W){return new a(W,[])}static updateCellMetadata(W,me){const Te=new a(new Gt(W,W),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(W){const me=new a(new Gt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};de=a=qe([O],de),e.NotebookEdit=de;class be{static isSnippetTextEdit(W){return W instanceof be?!0:W?V.isRange(W.range)&&Fe.isSnippetString(W.snippet):!1}static replace(W,me){return new be(W,me)}static insert(W,me){return be.replace(new V(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=be;var Ee;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Te,Ke){this.c.push({_type:1,from:W,to:me,options:Te,metadata:Ke})}createFile(W,me,Te){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Te})}deleteFile(W,me,Te){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Te})}e(W,me,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Te,Ke){const Ye=me.start,at=me.end;(Ye!==at||Te.length>0)&&this.c.push({_type:5,uri:W,index:Ye,count:at-Ye,cells:Te,metadata:Ke})}g(W,me,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:me,metadata:Te}})}replace(W,me,Te,Ke){this.c.push({_type:2,uri:W,edit:new G(me,Te),metadata:Ke})}insert(W,me,Te,Ke){this.replace(W,new V(me,me),Te,Ke)}delete(W,me,Te){this.replace(W,me,"",Te)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Te of me){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Ye):this.f(W,Ke.range,Ke.newCells,Ye):be.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&me.push(Te.edit);return me}entries(){const W=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Te=W.get(me.uri);Te||(Te=[me.uri,[]],W.set(me.uri,Te)),Te[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=qe([O],Pe),e.WorkspaceEdit=Pe;let Fe=s=class{static isSnippetString(W){return W instanceof s?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=s.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Te=new s;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=s.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Te=new s;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Fe=s=qe([O],Fe),e.SnippetString=Fe;var se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=u=class{static isLocation(W){return W instanceof u?!0:W?V.isRange(W.range)&&C.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(V.isRange(me))this.range=V.of(me);else if(ue.isPosition(me))this.range=new V(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=u=qe([O],fe),e.Location=fe;let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&V.isRange(W.location.range)&&C.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};Z=qe([O],Z),e.DiagnosticRelatedInformation=Z;let ce=class{constructor(W,me,Te=oe.Error){if(!V.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Te}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,c.equals)(W.tags,me.tags)&&(0,c.equals)(W.relatedInformation,me.relatedInformation,Z.isEqual)}};ce=qe([O],ce),e.Diagnostic=ce;let ne=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};ne=qe([O],ne),e.Hover=ne;var N;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(W,me=N.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};H=qe([O],H),e.DocumentHighlight=H;var Q;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Q=e.SymbolKind||(e.SymbolKind={}));var Y;(function(x){x[x.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let he=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Te,Ke,Ye){this.name=W,this.kind=me,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof fe?this.location=Ke:Te instanceof V&&(this.location=new fe(Ke,Te)),r.validate(this)}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};he=r=qe([O],he),e.SymbolInformation=he;let we=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}constructor(W,me,Te,Ke,Ye){this.name=W,this.detail=me,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],n.validate(this)}};we=n=qe([O],we),e.DocumentSymbol=we;var Ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,me){this.title=W,this.kind=me}};pe=qe([O],pe),e.CodeAction=pe;let De=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.c)}};De.c=".",De=h=qe([O],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([O],ke),e.SelectionRange=ke;class Ve{constructor(W,me,Te,Ke,Ye,at){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=Ve;class Ge{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=Ge;class et{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=et;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=S=class{static isMarkdownString(W){return W instanceof S?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){d.set(this,void 0),Je(this,d,new P.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Ue(this,d,"f").value}set value(W){Ue(this,d,"f").value=W}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(W){Ue(this,d,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,d,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,d,"f").supportHtml}set supportHtml(W){Ue(this,d,"f").supportHtml=W}get baseUri(){return Ue(this,d,"f").baseUri}set baseUri(W){Ue(this,d,"f").baseUri=W}appendText(W){return Ue(this,d,"f").appendText(W),this}appendMarkdown(W){return Ue(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Ue(this,d,"f").appendCodeblock(me??"",W),this}};d=new WeakMap,st=S=qe([O],st),e.MarkdownString=st;let ht=class{constructor(W,me){this.label=W,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Me=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};Me=qe([O],Me),e.SignatureInformation=Me;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=qe([O],rt),e.SignatureHelp=rt;var ae;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let le=class{constructor(W){this.value=W}};le=qe([O],le),e.InlayHintLabelPart=le;let Ie=class{constructor(W,me,Te){this.position=W,this.label=me,this.kind=Te}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(x){x[x.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let pt=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};pt=qe([O],pt),e.CompletionList=pt;let mt=class{constructor(W,me,Te){this.insertText=W,this.range=me,this.command=Te}};mt=qe([O],mt),e.InlineSuggestion=mt;let ct=class{constructor(W){this.commands=void 0,this.items=W}};ct=qe([O],ct),e.InlineSuggestionList=ct;var Et;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var tt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Xt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Rt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var gt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(gt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(me){switch(me){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(W,me){if(me&&!C.URI.isUri(me))throw(0,t.illegalArgument)("target");if(!V.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=me}};$t=qe([O],$t),e.DocumentLink=$t;let Nt=class{constructor(W,me,Te,Ke){this.red=W,this.green=me,this.blue=Te,this.alpha=Ke}};Nt=qe([O],Nt),e.Color=Nt;let xe=class{constructor(W,me){if(me&&!(me instanceof Nt))throw(0,t.illegalArgument)("color");if(!V.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=me}};xe=qe([O],xe),e.ColorInformation=xe;let Mt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};Mt=qe([O],Mt),e.ColorPresentation=Mt;var Ut;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(W,me,Te){if(this.startIndex=W,this.length=me,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var re;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var He;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let je=I=class{static from(W){switch(W){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,t.illegalArgument)("name");this.c=W}get id(){return this.c}};je.Clean=new I("clean","Clean"),je.Build=new I("build","Build"),je.Rebuild=new I("rebuild","Rebuild"),je.Test=new I("test","Test"),je=I=qe([O],je),e.TaskGroup=je;function it(x){let W="";for(let me=0;me<x.length;me++)W+=x[me].replace(/,/g,",,")+",";return W}let lt=class{constructor(W,me,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return it(W)}};lt=qe([O],lt),e.ProcessExecution=lt;let Pt=class{constructor(W,me,Te){if(this.f=[],Array.isArray(me)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W,this.f=me,this.g=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return it(W)}};Pt=qe([O],Pt),e.ShellExecution=Pt;var St;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=kt;let Ct=F=class{constructor(W,me,Te,Ke,Ye,at){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):me===yt.Global||me===yt.Workspace?(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=at):(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(F.g===me||F.e===me||F.f===me||F.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Ct.c="customExecution",Ct.e="process",Ct.f="shell",Ct.g="$empty",Ct=F=qe([O],Ct),e.Task=Ct;var Dt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Dt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(x){function W(me){const Te=me;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}x.isViewBadge=W})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=K=class{static isTreeItem(W,me){if(W instanceof K)return!0;const Te=W;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!C.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!C.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<vt.None&&Te.collapsibleState>vt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,w.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,me=vt.None){this.collapsibleState=me,C.URI.isUri(W)?this.resourceUri=W:this.label=W}};Jt=K=qe([O],Jt),e.TreeItem=Jt;var vt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,L.generateUuid)()}};oi=qe([O],oi),e.DataTransferItem=oi;let Zt=class{constructor(W){m.set(this,new Map);for(const[me,Te]of W??[]){const Ke=Ue(this,m,"f").get(me);Ke?Ke.push(Te):Ue(this,m,"f").set(me,[Te])}}get(W){return Ue(this,m,"f").get(W)?.[0]}set(W,me){Ue(this,m,"f").set(W,[me])}forEach(W,me){for(const[Te,Ke]of Ue(this,m,"f"))for(const Ye of Ke)W.call(me,Ye,Te,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[W,me]of Ue(this,m,"f"))for(const Te of me)yield[W,Te]}};Zt=qe([O],Zt),e.DataTransfer=Zt;let bi=class{constructor(W){this.insertText=W}};bi=qe([O],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(W){this.insertText=W}};Lt=qe([O],Lt),e.DocumentPasteEdit=Lt;let Ht=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Ht=qe([O],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let wi=class{constructor(W){this.id=W}};wi=qe([O],wi),e.ThemeColor=wi;var ai;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(W){this.c=W,this.e=C.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!C.URI.isUri(W)&&!C.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof me!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=C.URI.file(W):C.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([O],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(x,W){ut.set(x,W)}e.setBreakpointId=Bi;let Bt=class{constructor(W,me,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=ut.get(this)??(0,L.generateUuid)()),this.c}};Bt=qe([O],Bt),e.Breakpoint=Bt;let Qt=class extends Bt{constructor(W,me,Te,Ke,Ye){if(super(me,Te,Ke,Ye),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Qt=qe([O],Qt),e.SourceBreakpoint=Qt;let ci=class extends Bt{constructor(W,me,Te,Ke,Ye){super(me,Te,Ke,Ye),this.functionName=W}};ci=qe([O],ci),e.FunctionBreakpoint=ci;let vi=class extends Bt{constructor(W,me,Te,Ke,Ye,at,dt){if(super(Ke,Ye,at,dt),!me)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Te}};vi=qe([O],vi),e.DataBreakpoint=vi;let Ei=class{constructor(W,me,Te){this.command=W,this.args=me||[],this.options=Te}};Ei=qe([O],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(W,me){this.port=W,this.host=me}};li=qe([O],li),e.DebugAdapterServer=li;let Si=class{constructor(W){this.path=W}};Si=qe([O],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(W){this.implementation=W}};ui=qe([O],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(W,me){this.range=W,this.expression=me}};ti=qe([O],ti),e.EvaluatableExpression=ti;var $i;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(W,me){this.range=W,this.text=me}};ii=qe([O],ii),e.InlineValueText=ii;let ni=class{constructor(W,me,Te=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Te}};ni=qe([O],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(W,me){this.range=W,this.expression=me}};yi=qe([O],yi),e.InlineValueEvaluatableExpression=yi;let Ci=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};Ci=qe([O],Ci),e.InlineValueContext=Ci;var ri;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Di=q=class extends Error{static FileExists(W){return new q(W,T.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(W){return new q(W,T.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(W){return new q(W,T.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(W){return new q(W,T.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(W){return new q(W,T.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(W){return new q(W,T.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(W,me=T.FileSystemProviderErrorCode.Unknown,Te){super(C.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Di=q=qe([O],Di),e.FileSystemError=Di;let Ii=class{constructor(W,me,Te){this.start=W,this.end=me,this.kind=Te}};Ii=qe([O],Ii),e.FoldingRange=Ii;var zi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=Ri;function Li(x){return typeof x>"u"||(0,y.isStringArray)(x)}class ze{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Te=W.tokenTypes.length;me<Te;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Te=W.tokenModifiers.length;me<Te;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Te,Ke,Ye){if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(W,me,Te,Ke,Ye);if(V.isRange(W)&&typeof me=="string"&&Li(Te))return this.m(W,me,Te);throw(0,t.illegalArgument)()}m(W,me,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Ye=W.start.character,at=W.end.character-W.start.character,dt=this.j.get(me);let Ft=0;if(Te)for(const Vt of Te){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(Vt);Ft|=1<<Kt>>>0}this.n(Ke,Ye,at,dt,Ft)}n(W,me,Te,Ke,Ye){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Kt=0;for(let xt=0;xt<Ft;xt++){let _t=this.g[5*xt],Pi=this.g[5*xt+1];_t===0?(_t=Vt,Pi+=Kt):_t+=Vt,this.g[5*xt]=_t,this.g[5*xt+1]=Pi,Vt=_t,Kt=Pi}}let at=W,dt=me;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=W,this.e=me}static o(W){const me=[],Te=W.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Ft)=>{const Vt=W[5*dt],Kt=W[5*Ft];if(Vt===Kt){const xt=W[5*dt+1],_t=W[5*Ft+1];return xt-_t}return Vt-Kt});const Ke=new Uint32Array(W.length);let Ye=0,at=0;for(let dt=0;dt<Te;dt++){const Ft=5*me[dt],Vt=W[Ft+0],Kt=W[Ft+1],xt=W[Ft+2],_t=W[Ft+3],Pi=W[Ft+4],sn=Vt-Ye,Rn=sn===0?Kt-at:Kt,Ai=5*dt;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=xt,Ke[Ai+3]=_t,Ke[Ai+4]=Pi,Ye=Vt,at=Kt}return Ke}build(W){return this.f?new jt(new Uint32Array(this.g),W):new jt(ze.o(this.g),W)}}e.SemanticTokensBuilder=ze;class jt{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=jt;class Oi{constructor(W,me,Te){this.start=W,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=Oi;class wt{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=wt;var ji;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Ht("arrow-left")},di=qe([O],di),e.QuickInputButtons=di;var Ni;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(W){if(typeof W.badge=="string"){let me=(0,A.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,A.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ht.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Te){this.badge=W,this.tooltip=me,this.color=Te}}e.FileDecoration=qi;let Ti=class{constructor(W){this.kind=W}};Ti=qe([O],Ti),e.ColorTheme=Ti;var Gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(W){return W instanceof Gt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(me<0)throw(0,t.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Te=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Te=W.end),me===this.c&&Te===this.e?this:new Gt(me,Te)}}e.NotebookRange=Gt;class fi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>fi.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Te,Ke,Ye,at,dt){this.kind=W,this.value=me,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=at,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class Ki{constructor(W){this.cells=W}}e.NotebookData=Ki;class zt{static isNotebookCellOutputItem(W){return W instanceof zt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return zt.json(me,"application/vnd.code.notebook.error")}static stdout(W){return zt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return zt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new zt(W,me)}static text(W,me=k.Mimes.text){const Te=Ue(zt,p,"f",b).encode(String(W));return new zt(Te,me)}static json(W,me="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return zt.text(Te,me)}constructor(W,me){this.data=W,this.mime=me;const Te=(0,k.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=zt,p=zt,b={value:new TextEncoder};class mi{static isNotebookCellOutput(W){return W instanceof mi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<W.length;Ye++){const at=W[Ye],dt=(0,k.normalizeMimeType)(at.mime);if(!Te.has(dt)||(0,D.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),me&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Ye,at)=>!Ke.has(at))}constructor(W,me,Te){this.items=mi.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=mi;var Xi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var xi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ve;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ve=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Be{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Be;var ot;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(W,me=[]){this.uri=W,this.provides=(0,c.asArray)(me)}}e.NotebookRendererScript=Ot;class ln{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(W,me){this.label=W,this.timestamp=me}};Qi=qe([O],Qi),e.TimelineItem=Qi;var un;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,me=void 0,Te=void 0){this.include=W,this.exclude=me,this.profile=Te}};Fi=qe([O],Fi),e.TestRunRequest=Fi;let _i=class extends Fi{constructor(W=void 0,me=void 0,Te=void 0,Ke=!1){super(W,me,Te),this.continuous=Ke}};_i=qe([O],_i),e.TestRunRequest2=_i;let Yi=M=class{static diff(W,me,Te){const Ke=new M(W);return Ke.expectedOutput=me,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};Yi=M=qe([O],Yi),e.TestMessage=Yi;let Ji=class{constructor(W){this.id=W}};Ji=qe([O],Ji),e.TestTag=Ji;let gi=class{constructor(W,me){this.covered=W,this.total=me}};gi=qe([O],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(W,me){const Te=new gi(0,0),Ke=new gi(0,0),Ye=new gi(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ft of dt.branches)Ke.total+=1,Ke.covered+=Ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const at=new B(W,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=me,at}constructor(W,me,Te,Ke){this.uri=W,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=Ke}};Zi=B=qe([O],Zi),e.FileCoverage=Zi;let en=class{constructor(W,me,Te=[]){this.executionCount=W,this.location=me,this.branches=Te}};en=qe([O],en),e.StatementCoverage=en;let tn=class{constructor(W,me){this.executionCount=W,this.location=me}};tn=qe([O],tn),e.BranchCoverage=tn;let nn=class{constructor(W,me){this.executionCount=W,this.location=me}};nn=qe([O],nn),e.FunctionCoverage=nn;var bn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var vn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(W,me,Te,Ke,Ye,at){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=En;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=yn;class Cn{constructor(W,me,Te,Ke){this.base=W,this.input1=me,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Cn;class Dn{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Dn;class In{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=In;class kn{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=kn;class Tn{constructor(W,me,Te){this.original=W,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=An}),define(ye[135],Ce([1,0,51,17,8,164,106,7,16]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function L(w,f){f?C.set(w,f):C.delete(w)}e.setWordDefinitionFor=L;function T(w){return C.get(w)}class v extends R.MirrorTextModel{constructor(f,d,m,p,b,E,g,i){super(d,m,p,b),this.m=f,this.p=E,this.q=g,this.notebook=i,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,y.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===t.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(d){return d?f.s(d):f.getText()},get eol(){return f.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(d){return f.t(d)},offsetAt(d){return f.u(d)},positionAt(d){return f.v(d)},validateRange(d){return f.w(d)},validatePosition(d){return f.x(d)},getWordRangeAtPosition(d,m){return f.y(d,m)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,c.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,c.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const d=this.w(f);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const m=this.f,p=d.start.line,b=d.end.line,E=[];E.push(this.d[p].substring(d.start.character));for(let g=p+1;g<b;g++)E.push(this.d[g]);return E.push(this.d[b].substring(0,d.end.character)),E.join(m)}t(f){let d;if(f instanceof A.Position?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new D(d,this.d[d],d===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const d=this.h.getIndexOf(f),m=this.d[d.index].length;return new A.Position(d.index,Math.min(d.remainder,m))}w(f){if(!(f instanceof A.Range))throw new Error("Invalid argument");const d=this.x(f.start),m=this.x(f.end);return d===f.start&&m===f.end?f:new A.Range(d.line,d.character,m.line,m.character)}x(f){if(!(f instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:d,character:m}=f,p=!1;if(d<0)d=0,m=0,p=!0;else if(d>=this.d.length)d=this.d.length-1,m=this.d[d].length,p=!0;else{const b=this.d[d].length;m<0?(m=0,p=!0):m>b&&(m=b,p=!0)}return p?new A.Position(d,m):f}y(f,d){const m=this.x(f);if(!d)d=T(this.p);else if((0,P.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const p=(0,k.getWordAtText)(m.character+1,(0,k.ensureValidWordDefinition)(d),this.d[m.line],0);if(p)return new A.Range(m.line,p.startColumn-1,m.line,p.endColumn-1)}}e.ExtHostDocumentData=v;class D{constructor(f,d,m){this.a=f,this.b=d,this.c=m}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=D}),define(ye[237],Ce([1,0,7,18,3]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new P.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=c.ColorThemeKind.Light;break;case"hcDark":y=c.ColorThemeKind.HighContrast;break;case"hcLight":y=c.ColorThemeKind.HighContrastLight;break;default:y=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[15],Ce([1,0,16,22,148,63,112,28,147,68,86,23,10,2,36,70,124,132,130,92,57,75,232,7]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Re){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:He,positionLineNumber:_e,positionColumn:je}=re,it=new l.Position(Ne-1,He-1),lt=new l.Position(_e-1,je-1);return new l.Selection(it,lt)}Re.to=Oe;function Se(re){const{anchor:Ne,active:He}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(o=e.Selection||(e.Selection={}));var a;(function(Re){function Oe(re){if(!re)return;const{start:Ne,end:He}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Ne,startColumn:He,endLineNumber:_e,endColumn:je}=re;return new l.Range(Ne-1,He-1,_e-1,je-1)}Re.to=Se})(a=e.Range||(e.Range={}));var s;(function(Re){function Oe(Se){switch(Se){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Re.to=Oe})(s=e.TokenType||(e.TokenType={}));var u;(function(Re){function Oe(re){return new l.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(u=e.Position||(e.Position={}));var r;(function(Re){function Oe(Ne,He){return(0,c.coalesce)((0,c.asArray)(Ne).map(_e=>Se(_e,He)))}Re.from=Oe;function Se(Ne,He){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,He),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,He){return He&&typeof Ne=="string"?He.transformOutgoingScheme(Ne):Ne}})(r=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Re){function Oe(re){switch(re){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Re){function Oe(re){let Ne;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...a.from(re.range),message:re.message,source:re.source,code:Ne,severity:I.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(S.from),tags:Array.isArray(re.tags)?(0,c.coalesce)(re.tags.map(n.from)):void 0}}Re.from=Oe;function Se(re){const Ne=new l.Diagnostic(a.to(re),re.message,I.to(re.severity));return Ne.source=re.source,Ne.code=(0,v.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(S.to),Ne.tags=re.tags&&(0,c.coalesce)(re.tags.map(n.to)),Ne}Re.to=Se})(h=e.Diagnostic||(e.Diagnostic={}));var S;(function(Re){function Oe(re){return{...a.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new l.DiagnosticRelatedInformation(new l.Location(re.resource,a.to(re)),re.message)}Re.to=Se})(S=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var I;(function(Re){function Oe(re){switch(re){case l.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case d.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Re.to=Se})(I=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Re){function Oe(re){return typeof re=="number"&&re>=l.ViewColumn.One?re-1:re===l.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(F=e.ViewColumn||(e.ViewColumn={}));function K(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!K(Re[0])}e.isDecorationOptionsArr=q;var M;(function(Re){function Oe(je){return je.map(Re.from)}Re.fromMany=Oe;function Se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function re(je){let it;if(Se(je)){const{language:yt,value:kt}=je;it={value:"```"+yt+`
`+kt+"\n```\n"}}else l.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const lt=Object.create(null);it.uris=lt;const Pt=yt=>{try{let kt=D.URI.parse(yt,!0);kt=kt.with({query:Ne(kt.query,lt)}),lt[yt]=kt}catch{}return""},St=new y.marked.Renderer;return St.link=Pt,St.image=yt=>typeof yt=="string"?Pt(k.parseHrefAndDimensions(yt).href):"",(0,y.marked)(it.value,{renderer:St}),it}Re.from=re;function Ne(je,it){if(!je)return je;let lt;try{lt=(0,C.parse)(je)}catch{}if(!lt)return je;let Pt=!1;return lt=(0,T.cloneAndChange)(lt,St=>{if(D.URI.isUri(St)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[yt]=St,Pt=!0,yt}else return}),Pt?JSON.stringify(lt):je}function He(je){const it=new l.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?D.URI.from(je.baseUri):void 0,it}Re.to=He;function _e(je){if(!!je)return typeof je=="string"?je:Re.from(je)}Re.fromStrict=_e})(M=e.MarkdownString||(e.MarkdownString={}));function B(Re){return q(Re)?Re.map(Oe=>({range:a.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?M.fromMany(Oe.hoverMessage):Oe.hoverMessage?M.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:a.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?D.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ue;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?z.from(Se.light):void 0,dark:Se.dark?z.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(ue=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:a.from(re.range)}}Re.from=Oe;function Se(re){const Ne=new l.TextEdit(a.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Re.to=Se})(V=e.TextEdit||(e.TextEdit={}));var _;(function(Re){function Oe(re,Ne){const He={edits:[]};if(re instanceof l.WorkspaceEdit){const _e=new A.ResourceSet;for(const je of re._allEntries())je._type===1&&D.URI.isUri(je.to)&&je.from===void 0&&_e.add(je.to);for(const je of re._allEntries())je._type===1?He.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?He.edits.push({resource:je.uri,textEdit:V.from(je.edit),versionId:_e.has(je.uri)?void 0:Ne?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?He.edits.push({resource:je.uri,textEdit:{range:a.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:_e.has(je.uri)?void 0:Ne?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?He.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(je.uri)}):je._type===5&&He.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(pt.from)}})}return He}Re.from=Oe;function Se(re){const Ne=new l.WorkspaceEdit;for(const He of re.edits)He.textEdit?Ne.replace(D.URI.revive(He.resource),a.to(He.textEdit.range),He.textEdit.text):Ne.renameFile(D.URI.revive(He.oldResource),D.URI.revive(He.newResource),He.options);return Ne}Re.to=Se})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Oe=Object.create(null);Oe[l.SymbolKind.File]=0,Oe[l.SymbolKind.Module]=1,Oe[l.SymbolKind.Namespace]=2,Oe[l.SymbolKind.Package]=3,Oe[l.SymbolKind.Class]=4,Oe[l.SymbolKind.Method]=5,Oe[l.SymbolKind.Property]=6,Oe[l.SymbolKind.Field]=7,Oe[l.SymbolKind.Constructor]=8,Oe[l.SymbolKind.Enum]=9,Oe[l.SymbolKind.Interface]=10,Oe[l.SymbolKind.Function]=11,Oe[l.SymbolKind.Variable]=12,Oe[l.SymbolKind.Constant]=13,Oe[l.SymbolKind.String]=14,Oe[l.SymbolKind.Number]=15,Oe[l.SymbolKind.Boolean]=16,Oe[l.SymbolKind.Array]=17,Oe[l.SymbolKind.Object]=18,Oe[l.SymbolKind.Key]=19,Oe[l.SymbolKind.Null]=20,Oe[l.SymbolKind.EnumMember]=21,Oe[l.SymbolKind.Struct]=22,Oe[l.SymbolKind.Event]=23,Oe[l.SymbolKind.Operator]=24,Oe[l.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function re(Ne){for(const He in Oe)if(Oe[He]===Ne)return Number(He);return l.SymbolKind.Property}Re.to=re})(J=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Re){function Oe(re){switch(re){case l.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return l.SymbolTag.Deprecated}}Re.to=Se})(ie=e.SymbolTag||(e.SymbolTag={}));var ee;(function(Re){function Oe(re){return{name:re.name,kind:J.from(re.kind),tags:re.tags&&re.tags.map(ie.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Oe;function Se(re){const Ne=new l.SymbolInformation(re.name,J.to(re.kind),re.containerName,Ee.to(re.location));return Ne.tags=re.tags&&re.tags.map(ie.to),Ne}Re.to=Se})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:a.from(re.range),selectionRange:a.from(re.selectionRange),kind:J.from(re.kind),tags:re.tags?.map(ie.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Re.from=Oe;function Se(re){const Ne=new l.DocumentSymbol(re.name,re.detail,J.to(re.kind),a.to(re.range),a.to(re.selectionRange));return(0,c.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(ie.to)),re.children&&(Ne.children=re.children.map(Se)),Ne}Re.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(Re){function Oe(re){const Ne=new l.CallHierarchyItem(J.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),a.to(re.range),a.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,He){if(Ne=Ne??re._sessionId,He=He??re._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,name:re.name,detail:re.detail,kind:J.from(re.kind),uri:re.uri,range:a.from(re.range),selectionRange:a.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Re.from=Se})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(Re){function Oe(Se){return new l.CallHierarchyIncomingCall(G.to(Se.from),Se.fromRanges.map(re=>a.to(re)))}Re.to=Oe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Re){function Oe(Se){return new l.CallHierarchyOutgoingCall(G.to(Se.to),Se.fromRanges.map(re=>a.to(re)))}Re.to=Oe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(re){return{range:re.range&&a.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new l.Location(D.URI.revive(re.uri),a.to(re.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Pe;(function(Re){function Oe(re){const Ne=re,He=re;return{originSelectionRange:Ne.originSelectionRange?a.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:He.uri,range:a.from(Ne.targetRange?Ne.targetRange:He.range),targetSelectionRange:Ne.targetSelectionRange?a.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:D.URI.revive(re.uri),targetRange:a.to(re.range),targetSelectionRange:re.targetSelectionRange?a.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?a.to(re.originSelectionRange):void 0}}Re.to=Se})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Re){function Oe(re){return{range:a.from(re.range),contents:M.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new l.Hover(re.contents.map(M.to),a.to(re.range))}Re.to=Se})(Fe=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:a.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new l.EvaluatableExpression(a.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var oe;(function(Re){function Oe(re){if(re instanceof l.InlineValueText)return{type:"text",range:a.from(re.range),text:re.text};if(re instanceof l.InlineValueVariableLookup)return{type:"variable",range:a.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:a.to(re.range),text:re.text};case"variable":return{range:a.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:a.to(re.range),expression:re.expression}}}Re.to=Se})(oe=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:a.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new l.InlineValueContext(re.frameId,a.to(re.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Re){function Oe(re){return{range:a.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new l.DocumentHighlight(a.to(re.range),re.kind)}Re.to=Se})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Oe(Se){switch(Se){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Re.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ne;(function(Re){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ne=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Oe(re){switch(re){case l.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return l.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Oe=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function Se(He){return Oe.get(He)??9}Re.from=Se;const re=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ne(He){return re.get(He)??l.CompletionItemKind.Property}Re.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Re){function Oe(Se,re){const Ne=new l.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=H.to(Se.kind),Ne.tags=Se.tags?.map(N.to),Ne.detail=Se.detail,Ne.documentation=k.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,w.Range.isIRange(Se.range)?Ne.range=a.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:a.to(Se.range.insert),replacing:a.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new l.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof l.Range?new l.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map(He=>V.to(He))),Ne.command=re&&Se.command?re.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(Q=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:M.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:k.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation}}Re.to=Se})(Y=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Oe(re){return{label:re.label,documentation:M.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:k.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Oe(Se,re){const Ne=new l.InlayHint(u.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&De.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=k.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Re.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Ne=new l.InlayHintLabelPart(re.label);return Ne.tooltip=k.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,f.Command.is(re.command)&&(Ne.command=Se.fromInternal(re.command)),re.location&&(Ne.location=Ee.to(re.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:a.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?D.URI.parse(re.url,!0):D.URI.revive(re.url)}catch{}return new l.DocumentLink(a.to(re.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(Re){function Oe(re){const Ne=new l.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map(He=>V.to(He))),Ne}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Re.from=Se})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(re){return new l.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:a.from(re.range)}}Re.from=Oe;function Se(re){return new l.SelectionRange(a.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Oe(Se){switch(Se){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===l.EndOfLine.CRLF)return 1;if(re===l.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return l.EndOfLine.CRLF;if(re===0)return l.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=rt.from(Se.kind)),re}Re.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var rt;(function(Re){function Oe(Se){if(Se)switch(Se){case l.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Re.from=Oe})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?a.from(Se.selection):void 0,override:typeof Se.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe(He){return He instanceof l.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||re(He)?new l.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Oe;function Se(He){const _e=He;return _e?D.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(He){return typeof He=="string"?He:new l.RelativePattern(D.URI.revive(He.baseUri),He.pattern)}Re.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var le;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(le=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new l.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(Re){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Oe(re){switch(re){case l.NotebookCellKind.Markup:return b.CellKind.Markup;case l.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case b.CellKind.Markup:return l.NotebookCellKind.Markup;case b.CellKind.Code:default:return l.NotebookCellKind.Code}}Re.to=Se})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)l.NotebookCellData.validate(He),Ne.cells.push(pt.from(He));return Ne}Re.from=Oe;function Se(re){const Ne=new l.NotebookData(re.cells.map(pt.to));return(0,v.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var pt;(function(Re){function Oe(re){return{cellKind:Xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(ct.from):[]}}Re.from=Oe;function Se(re){return new l.NotebookCellData(Xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(ct.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(pt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new l.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Ne=re.items.map(mt.to);return new l.NotebookCellOutput(Ne,re.outputId,re.metadata)}Re.to=Se})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Re){function Oe(Ne){return re(Ne)?{include:(0,v.withNullAsUndefined)($.from(Ne.include)),exclude:(0,v.withNullAsUndefined)($.from(Ne.exclude))}:(0,v.withNullAsUndefined)($.from(Ne))}Re.from=Oe;function Se(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Re.to=Se;function re(Ne){const He=Ne;return He?!(0,v.isUndefinedOrNull)(He.include)&&!(0,v.isUndefinedOrNull)(He.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Re){function Oe(Se,re,Ne){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Re){function Oe(Se,re,Ne){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal(He,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var At;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(At=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Xt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new l.NotebookRendererScript(D.URI.revive(re.uri),re.provides)}Re.to=Se})(Xt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(Re){function Oe(re){return{message:M.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:a.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Ne=new l.TestMessage(typeof re.message=="string"?re.message:M.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?Ee.to(re.location):void 0,Ne}Re.to=Se})(Rt=e.TestMessage||(e.TestMessage={}));var gt;(function(Re){Re.namespace=g.namespaceTestTag,Re.denamespace=g.denamespaceTestTag})(gt=e.TestTag||(e.TestTag={}));var Tt;(function(Re){function Oe(re){const Ne=(0,m.getPrivateApiFor)(re).controllerId;return{extId:E.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:D.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>gt.namespace(Ne,He.id)),range:w.Range.lift(a.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&M.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:E.TestId.fromString(re.extId).localId,label:re.label,uri:D.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:He}=gt.denamespace(Ne);return new l.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new l.TestTag(re.id)}Re.to=Se}(gt=e.TestTag||(e.TestTag={}));var $t;(function(Re){const Oe=(re,Ne)=>{const He=[];for(const[je,it]of Ne)E.TestId.compare(it.item.extId,je)===2&&(Ne.delete(je),He.push(it));const _e={...Tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Rt.to)})),children:He.map(je=>Oe(je,Ne))};for(const je of _e.children)je.parent=_e;return _e};function Se(re){const Ne=[],He=new Map;for(const _e of re.items){He.set(_e.item.extId,_e);const je=E.TestId.root(_e.item.extId);re.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:re.completedAt,results:Ne.map(_e=>Oe(_e,He))}}Re.to=Se})($t=e.TestResults||(e.TestResults={}));var Nt;(function(Re){function Oe(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?u.from(He):a.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=re;function Ne(He){return{uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),function:He.functionCoverage&&Oe(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Re.fromFile=Ne})(Nt=e.TestCoverage||(e.TestCoverage={}));var xe;(function(Re){function Oe(Se){switch(Se){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Re.to=Oe})(xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Re){function Oe(re){const Ne=new l.TypeHierarchyItem(J.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),a.to(re.range),a.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,He){if(Ne=Ne??re._sessionId,He=He??re._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,kind:J.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:a.from(re.range),selectionRange:a.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Re.from=Se})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Ut=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Re){function Oe(He,_e,je){const it=_e.fileData;return it?new class extends l.DataTransferItem{asFile(){return{name:it.name,uri:D.URI.revive(it.uri),data:(0,R.once)(()=>je())}}}("",_e.id):He===L.Mimes.uriList&&_e.uriListData?new l.DataTransferItem(Ne(_e.uriListData)):new l.DataTransferItem(_e.asString)}Re.to=Oe;async function Se(He,_e){const je=await _e.asString();if(He===L.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:re(je)};const it=_e.asFile();return{id:_e.id,asString:je,fileData:it?{name:it.name,uri:it.uri}:void 0}}Re.from=Se;function re(He){return P.UriList.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return D.URI.parse(_e)}catch{}return _e})}function Ne(He){return P.UriList.create(He.map(_e=>typeof _e=="string"?_e:D.URI.revive(_e)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Re){function Oe(re,Ne){const He=re.items.map(([_e,je])=>[_e,Wt.to(_e,je,()=>Ne(je.id))]);return new l.DataTransfer(He)}Re.toDataTransfer=Oe;async function Se(re){const Ne={items:[]},He=[];return re.forEach((_e,je)=>{He.push((async()=>{Ne.items.push([je,await Wt.from(je,_e)])})())}),await Promise.all(He),Ne}Re.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[238],Ce([1,0,2,9,7,15,66]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(C,L,T,v={timeout:1500,errors:3}){this.c=C,this.d=L,this.f=T,this.g=v,this.a=new k.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(L,T,v)=>{const w={dispose:this.a.push([L,T,C])};return Array.isArray(v)&&v.push(w),w}}async $participateInSave(C,L){const T=c.URI.revive(C);let v=!1;const D=setTimeout(()=>v=!0,this.g.timeout),w=[];try{for(const f of[...this.a]){if(v)break;const d=this.d.getDocument(T),m=await this.h(f,{document:d,reason:R.TextDocumentSaveReason.to(L)});w.push(m)}}finally{clearTimeout(D)}return w}h([C,L,T],v){const D=this.b.get(C);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(T,C,L,v).then(()=>!0,w=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const f=this.b.get(C);this.b.set(C,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,L,T,v){const D=[],w=Date.now(),{document:f,reason:d}=v,{version:m}=f,p=Object.freeze({document:f,reason:d,waitUntil(b){if(Object.isFrozen(D))throw(0,t.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(b))}});try{L.apply(T,[p])}catch(b){return Promise.reject(b)}return Object.freeze(D),new Promise((b,E)=>{const g=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(D).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(g),b(i)}).catch(i=>{clearTimeout(g),E(i)})}).then(b=>{const E={edits:[]};for(const g of b)if(Array.isArray(g)&&g.every(i=>i instanceof P.TextEdit))for(const{newText:i,newEol:l,range:o}of g)E.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:o&&R.Range.from(o),text:i,eol:l&&R.EndOfLine.from(l)}});if(E.edits.length!==0)return m===f.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[239],Ce([1,0,17,2,15,7,92]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(T,v,D,w){this.start=T,this.deletedCount=v,this.deletedItems=D,this.items=w}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(T,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,v,D){this.notebook=T,this.h=v,this.j=D,this.handle=D.handle,this.uri=t.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(P.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return T.g},set mime(w){T.g=w},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(D)}return this.f}setOutputs(T){this.a=T.map(P.NotebookCellOutput.to)}setOutputItems(T,v,D){const w=D.map(P.NotebookCellOutputItem.to),f=this.a.find(d=>d.id===T);if(f&&(v||(f.items.length=0),f.items.push(...w),f.items.length>1&&f.items.every(d=>k.isTextStreamMime(d.mime)))){const d=new Map,m=[];f.items.forEach(p=>{let b;d.has(p.mime)?b=d.get(p.mime):(b=[],d.set(p.mime,b),m.push(p.mime)),b.push(p.data)}),f.items.length=0,m.forEach(p=>{const b=k.compressOutputItemStreams(d.get(p));f.items.push({mime:p,data:b.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=y;class C{constructor(T,v,D,w,f){this.k=T,this.l=v,this.m=D,this.uri=w,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,v={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===c.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(D){return D=T.n(D),T.b[D].apiCell},getCells(D){return(D?T.p(D):T.b).map(f=>f.apiCell)},save(){return T.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,v,D){this.g=T.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:D});const w={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},f=[];for(const m of T.rawEvents)m.kind===k.NotebookCellsChangeType.ModelChange?this.r(m.changes,!1,w.contentChanges):m.kind===k.NotebookCellsChangeType.Move?this.s(m.index,m.length,m.newIdx,w.contentChanges):m.kind===k.NotebookCellsChangeType.Output?(this.t(m.index,m.outputs),f.push({cell:this.b[m.index].apiCell,outputs:this.b[m.index].apiCell.outputs})):m.kind===k.NotebookCellsChangeType.OutputItem?(this.u(m.index,m.outputId,m.append,m.outputItems),f.push({cell:this.b[m.index].apiCell,outputs:this.b[m.index].apiCell.outputs})):m.kind===k.NotebookCellsChangeType.ChangeCellLanguage?(this.v(m.index,m.language),f.push({cell:this.b[m.index].apiCell,document:this.b[m.index].apiCell.document})):m.kind===k.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[m.index].apiCell,document:this.b[m.index].apiCell.document}):m.kind===k.NotebookCellsChangeType.ChangeCellMime?this.w(m.index,m.mime):m.kind===k.NotebookCellsChangeType.ChangeCellMetadata?(this.x(m.index,m.metadata),f.push({cell:this.b[m.index].apiCell,metadata:this.b[m.index].apiCell.metadata})):m.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(m.index,m.internalMetadata),f.push({cell:this.b[m.index].apiCell,executionSummary:this.b[m.index].apiCell.executionSummary}));const d=new Map;for(let m=0;m<f.length;m++){const p=f[m],b=d.get(p.cell);if(b===void 0){const E=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});d.set(p.cell,E-1)}else w.cellChanges[b]={...w.cellChanges[b],...p}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let v=T.start|0,D=T.end|0;return v<0&&(v=0),D>this.b.length&&(D=this.b.length),T.with({start:v,end:D})}p(T){T=this.o(T);const v=[];for(let D=T.start;D<T.end;D++)v.push(this.b[D]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,v,D){if(this.j)return;const w=[],f=[],d=[];if(T.reverse().forEach(m=>{const b=m[2].map(i=>{const l=new y(this,this.l,i);return v||f.push(y.asModelAddData(this.apiNotebook,i)),l}),E=new A(m[0],m[1],[],b),g=this.b.splice(m[0],m[1],...b);for(const i of g)d.push(i.uri),E.deletedItems.push(i.apiCell);w.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),D)for(const m of w)D.push(m.asApiEvent())}s(T,v,D,w){const f=this.b.splice(T,v);this.b.splice(D,0,...f);const d=[new A(T,v,f.map(m=>m.apiCell),[]),new A(D,0,[],f)];for(const m of d)w.push(m.asApiEvent())}t(T,v){this.b[T].setOutputs(v)}u(T,v,D,w){this.b[T].setOutputItems(v,D,w)}v(T,v){const D=this.b[T];D.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(D.uri,v)}w(T,v){const D=this.b[T];D.apiCell.mime=v}x(T,v){this.b[T].setMetadata(v)}y(T,v){this.b[T].setInternalMetadata(v)}getCellFromApiCell(T){return this.b.find(v=>v.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(v=>v.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}e.ExtHostNotebookDocument=C,C.a=0}),define(ye[136],Ce([1,0,9,15,7]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,C,L,T,v){this.id=A,this.f=y,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=L,this.c=v}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(P.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,C){A.f.$tryRevealRange(A.id,t.NotebookRange.from(y),C??P.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(t.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ye[240],Ce([1,0,3,13,15]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const C=this.d.getEditorById(A);y.visibleRanges&&C._acceptVisibleRanges(y.visibleRanges.ranges.map(P.NotebookRange.to)),y.selections&&C._acceptSelections(y.selections.selections.map(P.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(P.ViewColumn.to(A[y]))}};R=qe([We(0,t.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[241],Ce([1,0,15,126,178,21,62,9]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,D,w){const f=this.b++,{title:d,location:m,cancellable:p}=D,b={label:(0,P.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:c.ProgressLocation.from(m),title:d,source:b,cancellable:p},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.onUnexpectedExternalError),this.d(f,w,!!p)}d(v,D,w){let f;w&&(f=new R.CancellationTokenSource,this.c.set(v,f));const d=p=>{this.a.$progressEnd(p),this.c.delete(p),f?.dispose()};let m;try{m=D(new L(this.a,v),w&&f?f.token:R.CancellationToken.None)}catch(p){throw d(v),p}return m.then(p=>d(v),p=>d(v)),m}$acceptProgressCanceled(v){const D=this.c.get(v);D&&(D.cancel(),this.c.delete(v))}}e.ExtHostProgress=y;function C(T,v){return T.message=v.message,typeof v.increment=="number"&&(typeof T.increment=="number"?T.increment+=v.increment:T.increment=v.increment),T}class L extends t.Progress{constructor(v,D){super(w=>this.throttledReport(w)),this.c=v,this.d=D}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,k.throttle)(100,(T,v)=>C(T,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,36,132,57,93,75,15,2]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(b,E,g,i)=>{let l=E;return{enumerable:!0,configurable:!1,get(){return l},set(o){if(!g(l,o)){const a=l;l=o,b.listener?.(i(o,a))}}}},L=(b,E)=>b===E,T={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,E)=>!(b.length!==E.length||b.some(g=>!E.find(i=>g.id===i.id)))},v=b=>E=>({op:4,update:b(E)}),D=(b,E)=>({range:(()=>{let g;const i=v(l=>({range:c.Range.lift(A.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return g},set(l){b.listener?.({op:6}),T.range(g,l)||(g=l,b.listener?.(i(l)))}}})(),label:C(b,E,T.label,v(g=>({label:g}))),description:C(b,void 0,T.description,v(g=>({description:g}))),sortText:C(b,void 0,T.sortText,v(g=>({sortText:g}))),canResolveChildren:C(b,!1,T.canResolveChildren,g=>({op:2,state:g})),busy:C(b,!1,T.busy,v(g=>({busy:g}))),error:C(b,void 0,T.error,v(g=>({error:A.MarkdownString.fromStrict(g)||null}))),tags:C(b,[],T.tags,(g,i)=>({op:1,new:g.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),w=b=>{const E=P.TestId.fromString(b.extId),g=new d(E.controllerId,E.localId,b.label,y.URI.revive(b.uri)||void 0);return g.range=A.Range.to(b.range||void 0),g.description=b.description||void 0,g.sortText=b.sortText||void 0,g.tags=b.tags.map(i=>A.TestTag.to({id:(0,k.denamespaceTestTag)(i).tagId})),g},f=b=>{let E;for(const g of b.tests){const i=w(g.item);(0,t.getPrivateApiFor)(i).parent=E,E=i}return E};e.toItemFromContext=f;class d{constructor(E,g,i,l){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const o=(0,t.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof m?void 0:o.parent}},children:{value:(0,R.createTestItemChildren)(o,t.getPrivateApiFor,d),enumerable:!0,writable:!1},...D(o,i)})}}e.TestItemImpl=d;class m extends d{constructor(E,g){super(E,E,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class p extends R.TestItemCollection{constructor(E,g,i){super({controllerId:E,getDocumentVersion:l=>l&&i.getDocument(l)?.version,getApiFor:t.getPrivateApiFor,getChildren:l=>l.children,root:new m(E,g),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ye[138],Ce([1,0,51,9,101,15,7]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(v,D,w){const f=A.c.nextId();v.$registerTextEditorDecorationType(D.identifier,f,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=A,A.c=new P.IdGenerator("TextEditorDecorationType");class y{constructor(v,D){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,D){this.k();let w=null;if(v instanceof k.Position)w=new k.Range(v,v);else if(v instanceof k.Range)w=v;else throw new Error("Unrecognized location");this.l(w,D,!1)}insert(v,D){this.k(),this.l(new k.Range(v,v),D,!0)}delete(v){this.k();let D=null;if(v instanceof k.Range)D=v;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(v,D,w){const f=this.c.validateRange(v);this.g.push({range:f,text:D,forceMoveMarkers:w})}setEndOfLine(v){if(this.k(),v!==k.EndOfLine.LF&&v!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=v}}class C{constructor(v,D,w,f){this.c=v,this.d=D,this._accept(w),this.e=f;const d=this;this.value={get tabSize(){return d.f},set tabSize(m){d.m(m)},get indentSize(){return d.g},set indentSize(m){d.o(m)},get insertSpaces(){return d.h},set insertSpaces(m){d.q(m)},get cursorStyle(){return d.j},set cursorStyle(m){d.s(m)},get lineNumbers(){return d.k},set lineNumbers(m){d.t(m)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const D=Math.floor(v);return D>0?D:null}if(typeof v=="string"){const D=parseInt(v,10);return isNaN(D)?null:D>0?D:null}return null}m(v){const D=this.l(v);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const D=Math.floor(v);return D>0?D:null}if(typeof v=="string"){const D=parseInt(v,10);return isNaN(D)?null:D>0?D:null}return null}o(v){const D=this.n(v);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const D=this.p(v);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const D={};let w=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(w=!0,D.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,w=!0,D.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(w=!0,D.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,w=!0,D.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(w=!0,D.insertSpaces=f):this.h!==f&&(this.h=f,w=!0,D.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,w=!0,D.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,w=!0,D.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),w&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u(v,D){D.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(w)})}}e.ExtHostTextEditorOptions=C;class L{constructor(v,D,w,f,d,m,p,b){this.id=v,this.j=D,this.k=w,this.g=!1,this.h=new Set,this.c=d,this.d=new C(this.j,this.id,m,w),this.e=p,this.f=b;const E=this;this.value=Object.freeze({get document(){return f.value},set document(g){throw(0,t.readonly)("document")},get selection(){return E.c&&E.c[0]},set selection(g){if(!(g instanceof k.Selection))throw(0,t.illegalArgument)("selection");E.c=[g],E.l()},get selections(){return E.c},set selections(g){if(!Array.isArray(g)||g.some(i=>!(i instanceof k.Selection)))throw(0,t.illegalArgument)("selections");E.c=g,E.l()},get visibleRanges(){return E.e},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return E.d.value},set options(g){E.g||E.d.assign(g)},get viewColumn(){return E.f},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,i={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new y(f.value,i);return g(l),E.m(l)},insertSnippet(g,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!i||Array.isArray(i)&&i.length===0)o=E.c.map(a=>R.Range.from(a));else if(i instanceof k.Position){const{lineNumber:a,column:s}=R.Position.from(i);o=[{startLineNumber:a,startColumn:s,endLineNumber:a,endColumn:s}]}else if(i instanceof k.Range)o=[R.Range.from(i)];else{o=[];for(const a of i)if(a instanceof k.Range)o.push(R.Range.from(a));else{const{lineNumber:s,column:u}=R.Position.from(a);o.push({startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u})}}return D.$tryInsertSnippet(v,f.value.version,g.value,o,l)},setDecorations(g,i){const l=i.length===0;l&&!E.h.has(g.key)||(l?E.h.delete(g.key):E.h.add(g.key),E.n(()=>{if(R.isDecorationOptionsArr(i))return D.$trySetDecorations(v,g.key,R.fromRangeOrRangeWithMessage(i));{const o=new Array(4*i.length);for(let a=0,s=i.length;a<s;a++){const u=i[a];o[4*a]=u.start.line+1,o[4*a+1]=u.start.character+1,o[4*a+2]=u.end.line+1,o[4*a+3]=u.end.character+1}return D.$trySetDecorationsFast(v,g.key,o)}}))},revealRange(g,i){E.n(()=>D.$tryRevealRange(v,R.Range.from(g),i||k.TextEditorRevealType.Default))},show(g){D.$tryShowEditor(v,R.ViewColumn.from(g))},hide(){D.$tryHideEditor(v)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,c.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,c.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,c.ok)(!this.g),this.f=v}_acceptSelections(v){(0,c.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const D=v.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const w=D.edits.map(d=>d.range);w.sort((d,m)=>d.end.line===m.end.line?d.end.character===m.end.character?d.start.line===m.start.line?d.start.character-m.start.character:d.start.line-m.start.line:d.end.character-m.end.character:d.end.line-m.end.line);for(let d=0,m=w.length-1;d<m;d++){const p=w[d].end;if(w[d+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=D.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,f,{setEndOfLine:typeof D.setEndOfLine=="number"?R.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.ExtHostTextEditor=L}),define(ye[242],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[243],Ce([1,0,193,9,38,123,91,33,26,242,205,195]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=A.Registry.as(k.Extensions.JSONContribution);class D{constructor(g,i,l){this.a=g,this.b=i,this.c=l}d(g,i){this.a({type:g,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(P.default.Error,g)}warn(g){this.d(P.default.Warning,g)}info(g){this.d(P.default.Info,g)}}e.ExtensionMessageCollector=D;class w{static a(g){const i=new Set;for(let l=0,o=g.length;l<o;l++)i.add(y.ExtensionIdentifier.toKey(g[l].description.identifier));return i}static compute(g,i){if(!g||!g.length)return new w(i,[]);if(!i||!i.length)return new w([],g);const l=this.a(g),o=this.a(i),a=i.filter(u=>!l.has(y.ExtensionIdentifier.toKey(u.description.identifier))),s=g.filter(u=>!o.has(y.ExtensionIdentifier.toKey(u.description.identifier)));return new w(a,s)}constructor(g,i){this.added=g,this.removed=i}}e.ExtensionPointUserDelta=w;class f{constructor(g,i){this.name=g,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=w.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,t.onUnexpectedError)(g)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},m="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const i=new f(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,i),g.activationEventsGenerator&&T.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,v.registerSchema(m,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),v.registerSchema(m,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(ye[244],Ce([1,0,190,10,23,243,54,3]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var C;(function(v){function D(w,f,d){if(!w)return;const m=t.isString(w.type)?w.type:void 0;if(!m||m.length===0){d.error(c.localize(3,null));return}const p=[];if(Array.isArray(w.required))for(const b of w.required)t.isString(b)&&p.push(b);return{extensionId:f.value,taskType:m,required:p,properties:w.properties?P.deepClone(w.properties):{},when:w.when?k.ContextKeyExpr.deserialize(w.when):void 0}}v.from=D})(C||(C={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:y}});class T{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,w)=>{L.setHandler((f,d)=>{this.c=void 0;try{for(const m of d.removed){const p=m.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const m of d.added){const p=m.value;for(const b of p){const E=C.from(b,m.description.identifier,m.collector);E&&(this.a[E.taskType]=E)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const w of this.all()){const f={type:"object",additionalProperties:!1};w.required.length>0&&(f.required=w.required.slice(0)),w.properties!==void 0?f.properties=P.deepClone(w.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[w.taskType]},D.push(f)}this.c={oneOf:D}}return this.c}}e.TaskDefinitionRegistry=new T}),define(ye[245],Ce([1,0,191,10,24,23,54,244]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new k.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U(z){if(!z)return O.Strong;switch(z.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(y=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var T;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(O){function U(z){switch(z.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var D;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:T.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(D=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function z(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=z}(w=e.RuntimeType||(e.RuntimeType={}));var f;(function(O){function U(z){return t.isString(z)?z:z.value}O.value=U})(f=e.CommandString||(e.CommandString={}));var d;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function z(j){if(j!==void 0)return t.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=z})(d=e.TaskGroup||(e.TaskGroup={}));var m;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var p;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U(z){switch(z){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class i{constructor(U,z,j,ue,V,_){this._label="",this._id=U,z&&(this._label=z),j&&(this.type=j),this.runOptions=ue,this.configurationProperties=V,this._source=_}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(t.isString(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class l extends i{constructor(U,z,j,ue,V,_,J,ie){super(U,j,void 0,J,ie,z),this.command={},this._source=z,this.hasDefinedMatchers=_,V&&(this.command=V)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case w.Shell:z="shell";break;case w.Process:z="process";break;case w.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof l}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new l(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=l;class o extends i{constructor(U,z,j,ue,V,_,J){super(U,j,ue,_,J,z),this._source=z,this.configures=V}static is(U){return U instanceof o}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}}e.ConfiguringTask=o;class a extends i{constructor(U,z,j,ue,V,_,J,ie,ee){super(U,j,ue,ie,ee,z),this.defines=V,this.hasDefinedMatchers=J,this.command=_,this.icon=ee.icon,this.hide=ee.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof a}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new a(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=a;class s extends i{constructor(U,z,j,ue,V,_){super(U,j,ue,V,_,z),this._source=z}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new s(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=s;var u;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class n{constructor(U){this.c=new Map;for(let z=0;z<U.length;z++)this.c.set(U[z].uri.toString(),z)}compare(U,z){const j=U.getWorkspaceFolder(),ue=z.getWorkspaceFolder();if(j&&ue){let V=this.c.get(j.uri.toString());V=V===void 0?0:V+1;let _=this.c.get(ue.uri.toString());return _=_===void 0?0:_+1,V===_?U._label.localeCompare(z._label):V-_}else return!j&&ue?-1:j&&!ue?1:0}}e.TaskSorter=n;var h;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(O){O.SingleRun="singleRun",O.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var I;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(I=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(O){function U(z,j,ue,V){if(j){const _={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ue,__task:j};return z==="start"?_.resolvedVariables=V:z==="processStarted"?_.processId=V:z==="processEnded"&&(_.exitCode=V),Object.freeze(_)}else return Object.freeze({kind:"changed"})}O.create=U})(F=e.TaskEvent||(e.TaskEvent={}));var K;(function(O){function U(j){const ue=Object.keys(j).sort();let V="";for(const _ of ue){let J=j[_];J instanceof Object?J=U(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),V+=_+","+J+","}return V}function z(j){const V={_key:U(j),type:j.taskType};return Object.assign(V,j),V}O.create=z})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function U(z,j){const ue=A.TaskDefinitionRegistry.get(z.type);if(ue===void 0){const ie=R.deepClone(z);return delete ie._key,K.create(ie)}const V=Object.create(null);V.type=ue.taskType;const _=new Set;ue.required.forEach(ie=>_.add(ie));const J=ue.properties;for(const ie of Object.keys(J)){const ee=z[ie];if(ee!=null)V[ie]=ee;else if(_.has(ie)){const X=J[ie];if(X.default!==void 0)V[ie]=R.deepClone(X.default);else switch(X.type){case"boolean":V[ie]=!1;break;case"number":case"integer":V[ie]=0;break;case"string":V[ie]="";break;default:j.error(c.localize(2,null,JSON.stringify(z,void 0,0),ie));return}}}return K.create(V)}O.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[246],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((k,A)=>{this.b=k,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(k){this.f||this.h||(this.f=!0,this.g=k,this.a&&this.b(k))}resolveErr(k){this.f||this.h||(this.h=!0,this.i=k,this.a?this.d(k):(0,c.onUnexpectedError)(k))}then(k,A){return this.j().then(k,A)}catch(k){return this.j().then(void 0,k)}finally(k){return this.j().finally(k)}}e.LazyPromise=t;class P extends t{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=P}),define(ye[58],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function P(A){const y=new c(A);return t[y.nid]=y,y}e.createProxyIdentifier=P;function R(A){return t[A].sid}e.getStringIdentifierForProxy=R;class k{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=k}),define(ye[5],Ce([1,0,58]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(P=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var k;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(d){return d._id=T.a++,d}}e.IdObject=T,T.a=0;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var D;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(D=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[76],Ce([1,0,4,13,5,18]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(y,C){this.c=C,this.a=new Set,this.b=y.getProxy(P.MainContext.MainThreadTelemetry)}report(y,C,L){const T=this.d(y,C);this.a.has(T)||(this.a.add(T),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:y}))}d(y,C){return`${y}-${C.identifier.value}`}};k=qe([We(0,R.IExtHostRpcService),We(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,C){}})}),define(ye[247],Ce([1,0,3,5,7,26]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(y){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,C,L,T={}){const v=R.ExtensionIdentifier.toKey(y.identifier),D=this.f.get(v)||[],w=[...L].sort().join(" ");let f=D.find(d=>d.providerId===C&&d.scopes===w);if(f)return f.result;{const d=this.g(y,v,C,L,T);f={providerId:C,scopes:w,result:d},D.push(f),this.f.set(v,D);try{await d}finally{const m=D.findIndex(p=>p.providerId===C&&p.scopes===w);m>-1&&(D.splice(m),this.f.set(v,D))}return d}}async g(y,C,L,T,v={}){await this.a.$ensureProvider(L);const D=y.displayName||y.name;return this.a.$getSession(L,T,C,D,v)}async removeSession(y,C){const L=this.b.get(y);return L?L.provider.removeSession(C):this.a.$removeSession(y,C)}registerAuthenticationProvider(y,C,L,T){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:C,provider:L,options:T??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===y)||this.c.push({id:y,label:C});const v=L.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(y,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(y,C,T?.supportsMultipleAccounts??!1),new P.Disposable(()=>{v.dispose(),this.b.delete(y);const D=this.c.findIndex(w=>w.id===y);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,C){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,C){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,C){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,C){return this.d.fire({provider:{id:y,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ye[248],Ce([1,0,5,18,15]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>y.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,C){const L=P.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,C?.isRefactoring??!1)}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[249],Ce([1,0,5]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(R){const k=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(A){return k.$writeText(A)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[41],Ce([1,0,10,7,15,23,5,16,13,68,36,52,2,6,4,18,137,22,58,45,44,72]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g){"use strict";var i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(h,S){i.set(this,void 0),this.b=new Map,this.c=new Map,l.set(this,void 0),Je(this,i,h.getProxy(k.MainContext.MainThreadCommands),"f"),this.d=S,Je(this,l,h.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new a(this,I=>{const F=this.c.get(I);return F?.result===u.Void?F:void 0},S),this.f=[{processArgument(I){return(0,C.revive)(I)}},{processArgument(I){return(0,R.cloneAndChange)(I,function(F){if(L.Range.isIRange(F))return P.Range.to(F);if(T.Position.isIPosition(F))return P.Position.to(F);if(L.Range.isIRange(F.range)&&v.URI.isUri(F.uri))return P.location.to(F);if(F instanceof m.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const S=this.registerCommand(!1,h.id,async(...I)=>{const F=h.args.map((q,M)=>{if(!q.validate(I[M]))throw new Error(`Invalid argument '${q.name}' when running '${h.id}', received: ${I[M]}`);return q.convert(I[M])}),K=await this.executeCommand(h.internalId,...F);return h.result.convert(K,I,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new t.Disposable(()=>{S.dispose(),this.c.delete(h.id)})}registerCommand(h,S,I,F,K,q){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:I,thisArg:F,description:K,extension:q}),h&&Ue(this,i,"f").$registerCommand(S),new t.Disposable(()=>{this.b.delete(S)&&h&&Ue(this,i,"f").$unregisterCommand(S)})}executeCommand(h,...S){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,S,!0)}async g(h,S,I){if(this.b.has(h))return Ue(this,i,"f").$fireCommandActivationEvent(h),this.h(h,S,!1);{let F=!1;const K=(0,R.cloneAndChange)(S,function(q){if(q instanceof t.Position)return P.Position.from(q);if(q instanceof t.Range)return P.Range.from(q);if(q instanceof t.Location)return P.location.from(q);if(t.NotebookRange.isNotebookRange(q))return P.NotebookRange.from(q);if(q instanceof ArrayBuffer)return F=!0,m.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return F=!0,m.VSBuffer.wrap(q);if(q instanceof m.VSBuffer)return F=!0,q;if(!Array.isArray(q))return q});try{const q=await Ue(this,i,"f").$executeCommand(h,F?new p.SerializableObjectWithBuffers(K):K,I);return(0,C.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(h,S,!1);throw q}}}async h(h,S,I){const F=this.b.get(h);if(!F)throw new Error("Unknown command");const{callback:K,thisArg:q,description:M}=F;if(M)for(let O=0;O<M.args.length;O++)try{(0,c.validateConstraint)(S[O],M.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${M.args[O].name}' - ${M.args[O].description}`)}const B=E.StopWatch.create();try{return await K.apply(q,S)}catch(O){if(h===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...S);U&&(h=U.command)}throw this.d.error(O,h,F.extension?.identifier),I?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=h,this.source=F.extension?.displayName??F.extension?.name}}:O}finally{this.j(F,h,B.elapsed())}}j(h,S,I){!h.extension||Ue(this,l,"f").$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new g.TelemetryTrustedValue(S),duration:I})}$executeContributedCommand(h,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const I=this.b.get(h);return I?(S=S.map(F=>this.f.reduce((K,q)=>q.processArgument(K,I.extension?.identifier),F)),this.h(h,S,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),Ue(this,i,"f").$getCommands().then(S=>(h&&(S=S.filter(I=>I[0]!=="_")),S))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(const[S,I]of this.b){const{description:F}=I;F&&(h[S]=F)}return Promise.resolve(h)}};i=new WeakMap,l=new WeakMap,o=qe([We(0,f.IExtHostRpcService),We(1,y.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class a{constructor(h,S,I){this.d=h,this.f=S,this.g=I,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,S){if(!h)return;const I={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return I;const F=this.f(h.command);if(F)I.id=F.internalId,I.arguments=F.args.map((K,q)=>K.convert(h.arguments&&h.arguments[q]));else if((0,A.isNonEmptyArray)(h.arguments)){const K=`${h.command}/${++this.c}`;this.b.set(K,h),S.add((0,D.toDisposable)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),I.$ident=K,I.id=this.delegatingCommandId,I.arguments=[K],this.g.trace("CommandsConverter#CREATE",h.command,K)}return I}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const S=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.CommandsConverter=a;class s{constructor(h,S,I,F){this.name=h,this.description=S,this.validate=I,this.convert=F}optional(){return new s(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,S){return new s(h??this.name,S??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",n=>v.URI.isUri(n),n=>n),s.Position=new s("position","A position in a text document",n=>t.Position.isPosition(n),P.Position.from),s.Range=new s("range","A range in a text document",n=>t.Range.isRange(n),P.Range.from),s.Selection=new s("selection","A selection in a text document",n=>t.Selection.isSelection(n),P.Selection.from),s.Number=new s("number","",n=>typeof n=="number",n=>n),s.String=new s("string","",n=>typeof n=="string",n=>n),s.CallHierarchyItem=new s("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,P.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,P.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",n=>n instanceof d.TestItemImpl,P.TestItem.from);class u{constructor(h,S){this.description=h,this.convert=S}}e.ApiCommandResult=u,u.Void=new u("no result",n=>n);class r{constructor(h,S,I,F,K){this.id=h,this.internalId=S,this.description=I,this.args=F,this.result=K}}e.ApiCommand=r}),define(ye[250],Ce([1,0,2,15,7,70,41,16,120,125,17]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",D(t.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,A.isFalsyOrEmpty)(f))return;class m extends P.SymbolInformation{static to(b){const E=new m(b.name,t.SymbolKind.to(b.kind),b.containerName||"",new P.Location(d[0],t.Range.to(b.range)));return E.detail=b.detail,E.range=E.location.range,E.selectionRange=t.Range.to(b.selectionRange),E.children=b.children?b.children.map(m.to):[],E}}return f.map(m.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new k.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",D(t.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",D(t.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>P.Position.isPosition(d)),f=>f.map(t.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(d=>{let m;for(const p of d.reverse())m=new P.SelectionRange(t.Range.to(p),m);return m}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(t.WorkspaceSymbol.to))),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(t.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(t.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(t.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:t.Range.to(f.range),placeholder:f.text}})),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return t.WorkspaceEdit.to(f)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(t.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new P.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,y.decodeSemanticTokensDto)(f);if(d.type==="full")return new P.SemanticTokens(d.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range.optional()],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new P.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,y.decodeSemanticTokensDto)(f);if(d.type==="full")return new P.SemanticTokens(d.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,d,m)=>{if(!f)return new P.CompletionList([]);const p=f.suggestions.map(b=>t.CompletionItem.to(b,m));return new P.CompletionList(p,f.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return t.SignatureHelp.to(f)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,d,m)=>D(p=>new P.CodeLens(t.Range.to(p.range),p.command&&m.fromInternal(p.command)))(f))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>P.Range.isRange(f),f=>P.Selection.isSelection(f)?t.Selection.from(f):t.Range.from(f)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,d,m)=>D(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(p.command)}else{const b=new P.CodeAction(p.title,p.kind?new P.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=t.WorkspaceEdit.to(p.edit)),p.command&&(b.command=m.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(f))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new P.ColorInformation(t.Range.to(d.range),t.Color.to(d.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",f=>f instanceof P.Color,t.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:t.Range.from(f.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(t.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,d,m)=>f.map(t.InlayHint.to.bind(void 0,m)))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",D(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>t.NotebookExclusiveDocumentPattern.to(d))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(t.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new k.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>c.URI.isUri(f)||typeof f=="string"&&(0,C.matchesSomeScheme)(f,L.Schemas.http,L.Schemas.https),f=>f),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[t.ViewColumn.from(f),void 0]:[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[t.ViewColumn.from(f),void 0]:[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(t.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(t.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(t.TypeHierarchyItem.to))),new k.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[k.ApiCommandArgument.TestItem],k.ApiCommandResult.Void),new k.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[k.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],k.ApiCommandResult.Void),new k.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[k.ApiCommandArgument.String.with("name","The context key name"),new k.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],k.ApiCommandResult.Void)];class v{static register(d){T.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function D(f){return d=>{if(Array.isArray(d))return d.map(f)}}function w(f){if(!Array.isArray(f))return;const d=[];for(const m of f)R.isLocationLink(m)?d.push(t.DefinitionLink.to(m)):d.push(t.location.to(m));return d}}),define(ye[251],Ce([1,0,14,62,3,6,2,70,26,15,7,5]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(D,w,f){const d=D.getProxy(T.MainContext.MainThreadComments);class m{constructor(){this.b=new Map,this.c=new Map,w.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const u=this.b.get(s.handle);return u?u.value:s}else if(s&&s.$mid===7){const u=this.b.get(s.commentControlHandle);if(!u)return s;const r=u.getCommentThread(s.commentThreadHandle);return r?r.value:s}else if(s&&(s.$mid===9||s.$mid===8)){const u=this.b.get(s.thread.commentControlHandle);if(!u)return s;const r=u.getCommentThread(s.thread.commentThreadHandle);return r?s.$mid===8?r.value:{thread:r.value,text:s.text}:s}else if(s&&s.$mid===10){const u=this.b.get(s.thread.commentControlHandle);if(!u)return s;const r=u.getCommentThread(s.thread.commentThreadHandle);if(!r)return s;const n=s.commentUniqueId,h=r.getCommentByUniqueId(n);return h||s}else if(s&&s.$mid===11){const u=this.b.get(s.thread.commentControlHandle);if(!u)return s;const r=u.getCommentThread(s.thread.commentThreadHandle);if(!r)return s;const n=s.text,h=s.commentUniqueId,S=r.getCommentByUniqueId(h);return S?(typeof S.body=="string"?S.body=n:S.body=new L.MarkdownString(n),S):s}return s}})}createCommentController(s,u,r){const n=m.a++,h=new b(s,n,u,r);this.b.set(h.handle,h);const S=this.c.get(y.ExtensionIdentifier.toKey(s.identifier))||[];return S.push(h),this.c.set(y.ExtensionIdentifier.toKey(s.identifier),S),h.value}$createCommentThreadTemplate(s,u,r){const n=this.b.get(s);!n||n.$createCommentThreadTemplate(u,r)}async $updateCommentThreadTemplate(s,u,r){const n=this.b.get(s);!n||n.$updateCommentThreadTemplate(u,r)}$deleteCommentThread(s,u){this.b.get(s)?.$deleteCommentThread(u)}$provideCommentingRanges(s,u,r){const n=this.b.get(s);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const h=f.getDocument(k.URI.revive(u));return(0,c.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(h,r)).then(S=>S?S.map(I=>C.Range.from(I)):void 0)}$toggleReaction(s,u,r,n,h){const S=this.b.get(s);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const I=S.getCommentThread(u);if(I){const F=I.getCommentByUniqueId(n.uniqueIdInThread);if(S!==void 0&&F&&S.reactionHandler)return S.reactionHandler(F,i(h))}return Promise.resolve(void 0)})}dispose(){}}m.a=0;class p{set threadId(s){this.n=s}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(s){s.isEqual(this.p)||(this.p=s,this.b.range=s,this.c.fire())}get range(){return this.p}set canReply(s){this.d!==s&&(this.d=s,this.b.canReply=s,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(s){this.e=s,this.b.label=s,this.c.fire()}get contextValue(){return this.f}set contextValue(s){this.f=s,this.b.contextValue=s,this.c.fire()}get comments(){return this.q}set comments(s){this.q=s,this.b.comments=s,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(s){this.g=s,this.b.collapsibleState=s,this.c.fire()}get state(){return this.h}set state(s){this.h=s,this.b.state=s,this.c.fire()}get isDisposed(){return this.j}constructor(s,u,r,n,h,S,I,F){this.m=u,this.n=r,this.o=n,this.p=h,this.q=S,this.extensionDescription=I,this.r=F,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${s}.${this.handle}`),d.$createCommentThread(u,this.handle,this.n,this.o,C.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{d.$deleteCommentThread(u,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(q){K.range=q},get comments(){return K.comments},set comments(q){K.comments=q},get collapsibleState(){return K.collapsibleState},set collapsibleState(q){K.collapsibleState=q},get canReply(){return K.canReply},set canReply(q){K.canReply=q},get contextValue(){return K.contextValue},set contextValue(q){K.contextValue=q},get label(){return K.label},set label(q){K.label=q},get state(){return K.state},set state(q){K.state=q},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const s=r=>Object.prototype.hasOwnProperty.call(this.b,r),u={};s("range")&&(u.range=C.Range.from(this.p)),s("label")&&(u.label=this.label),s("contextValue")&&(u.contextValue=this.contextValue??null),s("comments")&&(u.comments=this.q.map(r=>E(this,r,this.k))),s("collapsibleState")&&(u.collapseState=l(this.g)),s("canReply")&&(u.canReply=this.canReply),s("state")&&(u.state=o(this.h)),s("isTemplate")&&(u.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,u)}getCommentByUniqueId(s){for(const u of this.k){const r=u[0],n=u[1];if(s===n)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(s=>s.dispose())}}p.a=0,qe([(0,t.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(s){this.b=s,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(s){this.c=s,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this.d}set options(s){this.d=s,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(s,u,r,n){this.f=s,this.g=u,this.h=r,this.i=n,this.a=new Map,d.$registerCommentController(this.handle,r,n);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(S){h.options=S},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(S){h.commentingRangeProvider=S},get reactionHandler(){return h.reactionHandler},set reactionHandler(S){h.reactionHandler=S},createCommentThread(S,I,F){return h.createCommentThread(S,I,F).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(s,u,r,n){if(typeof s=="string"){const h=new p(this.id,this.handle,s,u,r,n,this.f,!1);return this.a.set(h.handle,h),h}else{const h=new p(this.id,this.handle,void 0,s,u,r,this.f,!1);return this.a.set(h.handle,h),h}}$createCommentThreadTemplate(s,u){const r=new p(this.id,this.handle,void 0,k.URI.revive(s),C.Range.to(u),[],this.f,!0);return r.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(s,u){const r=this.a.get(s);r&&(r.range=C.Range.to(u))}$deleteCommentThread(s){this.a.get(s)?.dispose(),this.a.delete(s)}getCommentThread(s){return this.a.get(s)}dispose(){this.a.forEach(s=>{s.dispose()}),this.e.forEach(s=>s.dispose())}}function E(a,s,u){let r=u.get(s);r||(r=++a.commentHandle,u.set(s,r));const n=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:r,body:typeof s.body=="string"?s.body:C.MarkdownString.from(s.body),userName:s.author.name,userIconPath:n,label:s.label,commentReactions:s.reactions?s.reactions.map(h=>g(h)):void 0,timestamp:s.timestamp?.toJSON()}}function g(a){return{label:a.label,iconPath:a.iconPath?C.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?k.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function l(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function o(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new m}e.createExtHostComments=v}),define(ye[252],Ce([1,0,23,5,25,18]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let k=class{constructor(L,T){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,T){const v=this,D=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,T,D,arguments)}})}e(L,T,v,D){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:y(D,this.b)}),this.c&&this.f(L,v,D)}};k=qe([We(0,R.IExtHostRpcService),We(1,P.IExtHostInitDataService)],k),e.AbstractExtHostConsoleForwarder=k;const A=1e5;function y(C,L){const T=[];if(C.length)for(let v=0;v<C.length;v++){let D=C[v];if(typeof D>"u")D="undefined";else if(D instanceof Error){const w=D;w.stack?D=w.stack:D=w.toString()}T.push(D)}if(L){const v=new Error().stack;v&&T.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,c.safeStringify)(T);return v.length>A?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,4,18,13,16,8,11,27]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(w,f){this.h=f,this.f=new Map,this.g=w.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,f){const d=Mi.c++;this.f.set(d,{provider:w,extensionDescription:f}),this.g.$registerDecorationProvider(d,f.identifier.value);const m=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(d,null);return}const b=(0,y.asArray)(p);if(b.length<=Mi.d){this.g.$onDidChange(d,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,b.length);const E=b.map(l=>({uri:l,rank:(0,C.count)(l.path,"/")})),g=(0,y.groupBy)(E,(l,o)=>l.rank-o.rank||(0,C.compare)(l.uri.path,o.uri.path)),i=[];e:for(const l of g){let o;for(const a of l){const s=(0,L.dirname)(a.uri.path);if(o!==s&&(o=s,i.push(a.uri)>=Mi.d))break e}}this.g.$onDidChange(d,i)});return new P.Disposable(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(w,f,d){if(!this.f.has(w))return Object.create(null);const m=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(w);return await Promise.all(f.map(async E=>{try{const{uri:g,id:i}=E,l=await Promise.resolve(p.provideFileDecoration(c.URI.revive(g),d));if(!l)return;try{P.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,T.checkProposedApiEnabled)(b,"codiconDecoration"),m[i]=[l.propagate,l.tooltip,l.badge,l.color]}catch(o){this.h.warn(`INVALID decoration from extension '${b}': ${o}`)}}catch(g){this.h.error(g)}})),m}};v.c=0,v.d=250,v=qe([We(0,k.IExtHostRpcService),We(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[253],Ce([1,0,176,124,2,5,7,15,3,13,28,48]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";var v,D,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(p,b,E,g,i,l,o){this.d=p,this.e=b,this.f=E,this.g=g,v.set(this,void 0),D.set(this,void 0),w.set(this,void 0),this.c=!1,Je(this,w,new L.ResourceMap(a=>i.getComparisonKey(a)),"f"),Je(this,v,l,"f"),Je(this,D,o,"f")}dispose(){this.c||(Ue(this,D,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,w,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let E=[];if(P.URI.isUri(p)){if(!b){this.delete(p);return}Ue(this,w,"f").set(p,b.slice()),E=[p]}else if(Array.isArray(p)){E=[];let i;p=[...p].sort(f.j);for(const l of p){const[o,a]=l;if((!i||o.toString()!==i.toString())&&(i&&Ue(this,w,"f").get(i).length===0&&Ue(this,w,"f").delete(i),i=o,E.push(o),Ue(this,w,"f").set(o,[])),a)Ue(this,w,"f").get(o)?.push(...a);else{const s=Ue(this,w,"f").get(o);s&&(s.length=0)}}}if(Ue(this,D,"f").fire(E),!Ue(this,v,"f"))return;const g=[];for(const i of E){let l=[];const o=Ue(this,w,"f").get(i);if(o)if(o.length>this.f){l=[];const a=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const u of o)if(u.severity===a[s]&&l.push({...A.Diagnostic.from(u),modelVersionId:this.g(i)})===this.f)break e;l.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,o.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=o.map(a=>({...A.Diagnostic.from(a),modelVersionId:this.g(i)}));g.push([i,l])}Ue(this,v,"f").$changeMany(this.e,g)}delete(p){this.h(),Ue(this,D,"f").fire([p]),Ue(this,w,"f").delete(p),Ue(this,v,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Ue(this,D,"f").fire([...Ue(this,w,"f").keys()]),Ue(this,w,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[E,g]of this)p.call(b,E,g,this)}*[(v=new WeakMap,D=new WeakMap,w=new WeakMap,Symbol.iterator)](){this.h();for(const p of Ue(this,w,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Ue(this,w,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Ue(this,w,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=f;let d=class pi{static _mapper(p){const b=new L.ResourceMap;for(const E of p)b.set(E,E);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,E,g){this.h=b,this.j=E,this.k=g,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=p.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:E,e:g,g:i,h:l,j:o,k:a}=this,s=new class{$changeMany(n,h){g.$changeMany(n,h),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,n,h.length===0?"CLEARING":h)}$clear(n){g.$clear(n),l.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,n)}dispose(){g.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,u=b;else if(!E.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+pi.c++;while(E.has(u))}return new class extends f{constructor(){super(b,u,pi.d,n=>a.getDocument(n)?.version,o.extUri,s,i),E.set(u,this)}dispose(){super.dispose(),E.delete(u)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,E=[];for(const g of this.f.values())g.forEach((i,l)=>{let o=b.get(i.toString());typeof o>"u"&&(o=E.length,b.set(i.toString(),o),E.push([i,[]])),E[o][1]=E[o][1].concat(...l)});return E}}l(p){let b=[];for(const E of this.f.values())E.has(p)&&(b=b.concat(E.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",E=new f(b,b,pi.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(b,E),this.m=E}for(const[b,E]of p)this.m.set(P.URI.revive(b),E.map(A.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,C.ILogService),We(2,T.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[254],Ce([1,0,2,5]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(k){this.a=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this.a.$showOpenDialog(k).then(A=>A?A.map(y=>c.URI.revive(y)):void 0)}showSaveDialog(k){return this.a.$showSaveDialog(k).then(A=>A?c.URI.revive(A):void 0)}}e.ExtHostDialogs=P}),define(ye[255],Ce([1,0,9,2,7,5,17,21,8]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(T,v,D){this.d=v,this.e=D,this.b=new Map,this.c=T.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,v){if(Object.keys(k.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const D=C.a++;this.b.set(D,v),this.c.$registerTextContentProvider(D,T);let w;return typeof v.onDidChange=="function"&&(w=v.onDidChange(f=>{if(f.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(D,f).then(d=>{if(!d&&typeof d!="string")return;const m=this.d.getDocument(f);if(!m)return;const p=(0,y.splitLines)(d);if(!m.equalLines(p))return this.c.$onVirtualDocumentChange(f,d)},c.onUnexpectedError)})),new P.Disposable(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(T,v){const D=this.b.get(T);return D?Promise.resolve(D.provideTextDocumentContent(t.URI.revive(v),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(ye[256],Ce([1,0,3,6,2,5,135,15,10,23,7]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(D,w){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=D.getProxy(R.MainContext.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(f=>{for(const d of f)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const d of f)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const w=this.g.getDocument(D);if(w)return w}getDocument(D){const w=this.getDocumentData(D);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return w.document}ensureDocumentData(D){const w=this.g.getDocument(D);if(w)return Promise.resolve(w);let f=this.h.get(D.toString());return f||(f=this.f.$tryOpenDocument(D).then(d=>{this.h.delete(D.toString());const m=P.URI.revive(d);return(0,y.assertIsDefined)(this.g.getDocument(m))},d=>(this.h.delete(D.toString()),Promise.reject(d))),this.h.set(D.toString(),f)),f}createDocumentData(D){return this.f.$tryCreateDocument(D).then(w=>P.URI.revive(w))}$acceptModelLanguageChanged(D,w){const f=P.URI.revive(D),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(w),this.a.fire(d.document)}$acceptModelSaved(D){const w=P.URI.revive(D),f=this.g.getDocument(w);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(D,w){const f=P.URI.revive(D),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(w),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,w,f){const d=P.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");m._acceptIsDirty(f),m.onEvents(w);let p;w.isUndoing?p=L.TextDocumentChangeReason.Undo:w.isRedoing&&(p=L.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:m.document,contentChanges:w.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(D,w){(0,k.setWordDefinitionFor)(D,w)}}e.ExtHostDocuments=T}),define(ye[59],Ce([1,0,51,3,6,2,4,5,135,18,138,15,13,28,17,64,65]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(E,g){this.h=E,this.i=g,this.a=null,this.b=new Map,this.c=new D.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const g=[],i=[],l=[];if(E.removedDocuments)for(const o of E.removedDocuments){const a=R.URI.revive(o),s=this.c.get(a);s?.unref()&&(this.c.delete(a),g.push(s.value))}if(E.addedDocuments)for(const o of E.addedDocuments){const a=R.URI.revive(o.uri);let s=this.c.get(a);if(s&&a.scheme!==w.Schemas.vscodeNotebookCell&&a.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);s||(s=new m(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),a,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(a,s),i.push(s.value)),s.ref()}if(E.removedEditors)for(const o of E.removedEditors){const a=this.b.get(o);this.b.delete(o),a&&l.push(a)}if(E.addedEditors)for(const o of E.addedEditors){const a=R.URI.revive(o.documentUri);c.ok(this.c.has(a),`document '${a}' does not exist`),c.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const s=this.c.get(a).value,u=new L.ExtHostTextEditor(o.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>s.document),o.selections.map(T.Selection.to),o.options,o.visibleRanges.map(r=>T.Range.to(r)),typeof o.editorPosition=="number"?T.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,u)}E.newActiveEditor!==void 0&&(c.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,P.dispose)(g),(0,P.dispose)(l),E.removedDocuments&&this.e.fire(g),E.addedDocuments&&this.d.fire(i),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return f.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const g=this.b.get(this.a);return E?g:g?.value}allEditors(){return[...this.b.values()]}};p=qe([We(0,C.IExtHostRpcService),We(1,v.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],Ce([1,0,15,5,2,3,4,7,18,10,61]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class T{constructor(d,m,p){this.e=p,this.d=m,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,m={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(m)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(P.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,m){this.c=[],this.d="",this.b=d,this.e=m;for(const p of d.tabs)p.isActive&&(this.d=p.id),this.c.push(new T(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,m={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return c.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(p=>p.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(p=>p.apiObject))}};this.a=Object.freeze(m)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const p=new T(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,p),d.tabDto.isActive&&(this.d=p.tabId),p}else if(d.kind===1){const p=this.c.splice(d.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(d.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,p),p}const m=this.c.find(p=>p.tabId===d.tabDto.id);if(!m)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),m.acceptDtoUpdate(d.tabDto),m}activeTabId(){return this.d}}let D=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,m={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(p=>p.apiObject))},get activeTabGroup(){const p=d.d;return(0,C.assertIsDefined)(d.e.find(E=>E.groupId===p)?.apiObject)},close:async(p,b)=>{const E=Array.isArray(p)?p:[p];return E.length?w(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(m)}return this.f}$acceptEditorTabModel(d){const m=new Set(this.e.map(o=>o.groupId)),p=new Set(d.map(o=>o.groupId)),b=(0,L.diffSets)(m,p),E=this.e.filter(o=>b.removed.includes(o.groupId)).map(o=>o.apiObject),g=[],i=[];this.e=d.map(o=>{const a=new v(o,()=>this.d);return b.added.includes(a.groupId)?g.push(a.apiObject):i.push(a.apiObject),a});const l=(0,C.assertIsDefined)(d.find(o=>o.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:g,closed:E,changed:i}))}$acceptTabGroupUpdate(d){const m=this.e.find(p=>p.groupId===d.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const m=this.e.find(b=>b.groupId===d.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const p=m.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(d){for(const m of this.e)for(const p of m.tabs)if(p.apiObject===d)return p}h(d){return this.e.find(m=>m.apiObject===d)}async i(d,m){const p=[];for(const b of d){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");p.push(E.tabId)}return this.a.$closeTab(p,m)}async j(d,m){const p=[];for(const b of d){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");p.push(E.groupId)}return this.a.$closeGroup(p,m)}};D=qe([We(0,y.IExtHostRpcService)],D),e.ExtHostEditorTabs=D;function w(f){return f.tabs!==void 0}}),define(ye[257],Ce([1,0,2,5,6,7,15,153,8,22,27]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const f=this.a.indexOf(w);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),f=[];let d,m,p=14,b=14;for(const E of w){let g=d?(0,y.commonPrefixLength)(d,E):0;for(g===0?m=1:m=b;g<E.length;g++)g+1===E.length?(p=b,b=9):b+=1,f.push([m,E.toUpperCase().charCodeAt(g),b]),f.push([m,E.toLowerCase().charCodeAt(g),b]),m=b;d=E,b=p}f.push([9,58,10]),f.push([10,47,12]),this.b=new A.StateMachine(f)}}provideDocumentLinks(w){this.c();const f=[],d=A.LinkComputer.computeLinks({getLineContent(m){return w.lineAt(m-1).text},getLineCount(){return w.lineCount}},this.b);for(const m of d){const p=k.DocumentLink.to(m);p.target&&f.push(p)}return f}}class v{constructor(w,f){this.i=f,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,f,d,m={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const p=this.h++;this.b.add(f),this.d.add(f),this.c.set(p,d);let b=2;m.isCaseSensitive&&(b+=1024),m.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(w,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,f,b).catch(g=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${f}`),console.error(g)});const E=d.onDidChangeFile(g=>{const i=[];for(const l of g){const{uri:o,type:a}=l;if(o.scheme!==f)continue;let s;switch(a){case R.FileChangeType.Changed:s=0;break;case R.FileChangeType.Created:s=1;break;case R.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:o,type:s})}this.a.$onFileSystemChange(p,i)});return(0,P.toDisposable)(()=>{E.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(w){const{type:f,ctime:d,mtime:m,size:p,permissions:b}=w;return{type:f,ctime:d,mtime:m,size:p,permissions:b}}$stat(w,f){return Promise.resolve(this.k(w).stat(c.URI.revive(f))).then(d=>v.j(d))}$readdir(w,f){return Promise.resolve(this.k(w).readDirectory(c.URI.revive(f)))}$readFile(w,f){return Promise.resolve(this.k(w).readFile(c.URI.revive(f))).then(d=>C.VSBuffer.wrap(d))}$writeFile(w,f,d,m){return Promise.resolve(this.k(w).writeFile(c.URI.revive(f),d.buffer,m))}$delete(w,f,d){return Promise.resolve(this.k(w).delete(c.URI.revive(f),d))}$rename(w,f,d,m){return Promise.resolve(this.k(w).rename(c.URI.revive(f),c.URI.revive(d),m))}$copy(w,f,d,m){const p=this.k(w);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(c.URI.revive(f),c.URI.revive(d),m))}$mkdir(w,f){return Promise.resolve(this.k(w).createDirectory(c.URI.revive(f)))}$watch(w,f,d,m){const p=this.k(w).watch(c.URI.revive(d),m);this.f.set(f,p)}$unwatch(w,f){const d=this.f.get(f);d&&(d.dispose(),this.f.delete(f))}$open(w,f,d){const m=this.k(w);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(c.URI.revive(f),d))}$close(w,f){const d=this.k(w);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(f))}$read(w,f,d,m){const p=this.k(w);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(m);return Promise.resolve(p.read(f,d,b.buffer,0,m)).then(E=>b.slice(0,E))}$write(w,f,d,m){const p=this.k(w);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(f,d,m.buffer,0,m.byteLength))}k(w){const f=this.c.get(w);if(!f){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return f}}e.ExtHostFileSystem=v}),define(ye[77],Ce([1,0,5,40,7,22,4,18,48,6]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Yt{constructor(v,D){this.b=new Map,this.a=v.getProxy(c.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(f){try{const d=w.b.get(f.scheme);if(!d)return await w.a.$stat(f);await w.a.$ensureActivation(f.scheme);const m=await d.stat(f);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(d){Yt.c(d)}},async readDirectory(f){try{const d=w.b.get(f.scheme);return d?(await w.a.$ensureActivation(f.scheme),(await d.readDirectory(f)).slice()):await w.a.$readdir(f)}catch(d){return Yt.c(d)}},async createDirectory(f){try{return await w.a.$mkdir(f)}catch(d){return Yt.c(d)}},async readFile(f){try{const d=w.b.get(f.scheme);return d?(await w.a.$ensureActivation(f.scheme),(await d.readFile(f)).slice()):(await w.a.$readFile(f)).buffer}catch(d){return Yt.c(d)}},async writeFile(f,d){try{return await w.a.$writeFile(f,R.VSBuffer.wrap(d))}catch(m){return Yt.c(m)}},async delete(f,d){try{const m=w.b.get(f.scheme);return m?(await w.a.$ensureActivation(f.scheme),await m.delete(f,{recursive:!1,...d})):await w.a.$delete(f,{recursive:!1,useTrash:!1,...d})}catch(m){return Yt.c(m)}},async rename(f,d,m){try{return await w.a.$rename(f,d,{overwrite:!1,...m})}catch(p){return Yt.c(p)}},async copy(f,d,m){try{return await w.a.$copy(f,d,{overwrite:!1,...m})}catch(p){return Yt.c(p)}},isWritableFileSystem(f){const d=D.getCapabilities(f);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof P.FileSystemError)throw v;if(!(v instanceof Error))throw new P.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw P.FileSystemError.Unavailable(v.message);switch(v.name){case t.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(v.message);case t.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(v.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(v.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(v.message);case t.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(v.message);case t.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(v.message);default:throw new P.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,D){return this.b.set(v,D),(0,C.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[258],Ce([1,0,3,39,2,5,15,7]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,v,D,w,f,d,m,p){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const b=this.h(T,D,f);this.g=0,d&&(this.g+=1),m&&(this.g+=2),p&&(this.g+=4);const E=(0,t.parse)(f),g=typeof f=="string",i=w(l=>{if(!d)for(const o of l.created){const a=P.URI.revive(o);E(a.fsPath)&&(!g||v.getWorkspaceFolder(a))&&this.a.fire(a)}if(!m)for(const o of l.changed){const a=P.URI.revive(o);E(a.fsPath)&&(!g||v.getWorkspaceFolder(a))&&this.b.fire(a)}if(!p)for(const o of l.deleted){const a=P.URI.revive(o);E(a.fsPath)&&(!g||v.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,i)}h(T,v,D){const w=A.Disposable.from();if(typeof D=="string")return w;const f=T.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(D.pattern.includes(t.GLOBSTAR)||D.pattern.includes(t.GLOB_SPLIT))&&(d=!0);const m=Math.random();return f.$watch(v.identifier.value,m,D.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>f.$unwatch(m)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(T,v,D){this.j=T,this.k=v,this.l=D,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,v,D,w,f,d){return new y(this.j,T,v,this.a.event,k.GlobPattern.from(D),w,f,d)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,v){switch(T){case 2:this.b.fire(Object.freeze({files:v.map(D=>({oldUri:P.URI.revive(D.source),newUri:P.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(D=>P.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(D=>P.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,v){return(D,w,f)=>{const d=function(p){D.call(w,p)};return d.extension=T,v.event(d,void 0,f)}}async $onWillRunFileOperation(T,v,D,w){switch(T){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))},D,w);case 1:return await this.n(this.i,{files:v.map(f=>P.URI.revive(f.target))},D,w);case 0:case 3:return await this.n(this.h,{files:v.map(f=>P.URI.revive(f.target))},D,w)}}async n(T,v,D,w){const f=new Set,d=[];if(await T.fireAsync(v,w,async(p,b)=>{const E=Date.now(),g=await Promise.resolve(p);g instanceof A.WorkspaceEdit&&(d.push([b.extension,g]),f.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-E>D&&this.k.warn("SLOW file-participant",b.extension.identifier)}),w.isCancellationRequested||d.length===0)return;const m={edits:[]};for(const[,p]of d){const{edits:b}=k.WorkspaceEdit.from(p,{getTextDocumentVersion:E=>this.l.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});m.edits=m.edits.concat(b)}return{edit:m,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=C}),define(ye[259],Ce([1,0,2,41]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class P{constructor(k,A,y,C,L){this.a=A,this.b=y,this.c=C;const T=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new t.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new t.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new t.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new t.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const D=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri),notebookEditor:D.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(k,A,y,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:k,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=P}),define(ye[260],Ce([1,0,6,5]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(k){this.b=0,this.a=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,k),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=P}),define(ye[261],Ce([1,0,2,23,15,7,70,5,8,36,16,10,149,21,6,120,101,74,44,9,14,27]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(N,H){this.d=N,this.e=H}async provideDocumentSymbols(N,H){const Q=this.d.getDocument(N),Y=await this.e.provideDocumentSymbols(Q,H);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof R.DocumentSymbol?Y.map(P.DocumentSymbol.from):i.f(Y)}static f(N){N=N.slice(0).sort((Y,he)=>{let we=Y.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(Y.location.range.end)),we});const H=[],Q=[];for(const Y of N){const he={name:Y.name||"!!MISSING: name!!",kind:P.SymbolKind.from(Y.kind),tags:Y.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:P.Range.from(Y.location.range),selectionRange:P.Range.from(Y.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),H.push(he);break}const we=Q[Q.length-1];if(C.Range.containsRange(we.range,he.range)&&!C.Range.equalsRange(we.range,he.range)){we.children?.push(he),Q.push(he);break}Q.pop()}}return H}}class l{constructor(N,H,Q){this.g=N,this.h=H,this.j=Q,this.e=new m.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,H){const Q=this.g.getDocument(N),Y=await this.j.provideCodeLenses(Q,H);if(!Y||H.isCancellationRequested)return;const he=this.e.add(Y),we=new w.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let pe=0;pe<Y.length;pe++)Ae.lenses.push({cacheId:[he,pe],range:P.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,we)});return Ae}async resolveCodeLens(N,H){const Q=N.cacheId&&this.e.get(...N.cacheId);if(!Q)return;let Y;if(typeof this.j.resolveCodeLens!="function"||Q.isResolved?Y=Q:Y=await this.j.resolveCodeLens(Q,H),Y||(Y=Q),H.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(Y.command??l.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}l.d={command:"missing",title:"!!MISSING: command!!"};function o(ne){return Array.isArray(ne)?ne.map(P.DefinitionLink.from):ne?[P.DefinitionLink.from(ne)]:[]}class a{constructor(N,H){this.d=N,this.e=H}async provideDefinition(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideDefinition(Y,he,Q);return o(we)}}class s{constructor(N,H){this.d=N,this.e=H}async provideDeclaration(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideDeclaration(Y,he,Q);return o(we)}}class u{constructor(N,H){this.d=N,this.e=H}async provideImplementation(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideImplementation(Y,he,Q);return o(we)}}class r{constructor(N,H){this.d=N,this.e=H}async provideTypeDefinition(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideTypeDefinition(Y,he,Q);return o(we)}}class n{constructor(N,H){this.d=N,this.e=H}async provideHover(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideHover(Y,he,Q);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=Y.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),P.Hover.from(we)}}class h{constructor(N,H){this.d=N,this.e=H}async provideEvaluatableExpression(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideEvaluatableExpression(Y,he,Q);if(we)return P.EvaluatableExpression.from(we)}}class S{constructor(N,H){this.d=N,this.e=H}async provideInlineValues(N,H,Q,Y){const he=this.d.getDocument(N),we=await this.e.provideInlineValues(he,P.Range.to(H),P.InlineValueContext.to(Q),Y);if(Array.isArray(we))return we.map(Ae=>P.InlineValue.from(Ae))}}class I{constructor(N,H){this.d=N,this.e=H}async provideDocumentHighlights(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideDocumentHighlights(Y,he,Q);if(Array.isArray(we))return we.map(P.DocumentHighlight.from)}}class F{constructor(N,H){this.d=N,this.e=H}async provideLinkedEditingRanges(N,H,Q){const Y=this.d.getDocument(N),he=P.Position.to(H),we=await this.e.provideLinkedEditingRanges(Y,he,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(P.Range.from)),wordPattern:we.wordPattern}}}class K{constructor(N,H){this.d=N,this.e=H}async provideReferences(N,H,Q,Y){const he=this.d.getDocument(N),we=P.Position.to(H),Ae=await this.e.provideReferences(he,we,Q,Y);if(Array.isArray(Ae))return Ae.map(P.location.from)}}class q{constructor(N,H,Q,Y,he,we,Ae){this.g=N,this.h=H,this.j=Q,this.k=Y,this.l=he,this.m=we,this.n=Ae,this.e=new m.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,H,Q,Y){const he=this.g.getDocument(N),we=v.Selection.isISelection(H)?P.Selection.to(H):P.Range.to(H),Ae=[];for(const et of this.j.getDiagnostics(N))if(we.intersection(et.range)&&Ae.push(et)>q.d)break;const pe={diagnostics:Ae,only:Q.only?new R.CodeActionKind(Q.only):void 0,triggerKind:P.CodeActionTriggerKind.to(Q.trigger)},De=await this.k.provideCodeActions(he,we,pe,Y);if(!(0,L.isNonEmptyArray)(De)||Y.isCancellationRequested)return;const ke=this.e.add(De),Ve=new w.DisposableStore;this.f.set(ke,Ve);const Ge=[];for(let et=0;et<De.length;et++){const Qe=De[et];!Qe||(q.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,Ve)})):(pe.only&&(Qe.kind?pe.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,Ve),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(P.Diagnostic.from),edit:Qe.edit&&P.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(N,H){const[Q,Y]=N,he=this.e.get(Q,Y);if(!he||q.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,H)??he;return we?.edit?P.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}q.d=1e3;class M{constructor(N,H,Q,Y){this.d=N,this.e=H,this.f=Q,this.g=Y}async prepareDocumentPaste(N,H,Q,Y){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),we=H.map(pe=>P.Range.to(pe)),Ae=P.DataTransfer.toDataTransfer(Q,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,Y),P.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,H,Q,Y,he){const we=this.e.getDocument(H),Ae=Q.map(ke=>P.Range.to(ke)),pe=P.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),De=await this.f.provideDocumentPasteEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?P.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class B{constructor(N,H){this.d=N,this.e=H}async provideDocumentFormattingEdits(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(Y,H,Q);if(Array.isArray(he))return he.map(P.TextEdit.from)}}class O{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeFormattingEdits(N,H,Q,Y){const he=this.d.getDocument(N),we=P.Range.to(H),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,Q,Y);if(Array.isArray(Ae))return Ae.map(P.TextEdit.from)}}class U{constructor(N,H){this.d=N,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,H,Q,Y,he){const we=this.d.getDocument(N),Ae=P.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(we,Ae,Q,Y,he);if(Array.isArray(pe))return pe.map(P.TextEdit.from)}}class z{constructor(N,H){this.e=N,this.f=H,this.d=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,H){const Q=await this.e.provideWorkspaceSymbols(N,H);if(!(0,L.isNonEmptyArray)(Q))return{symbols:[]};const Y=this.d.add(Q),he={cacheId:Y,symbols:[]};for(let we=0;we<Q.length;we++){const Ae=Q[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...P.WorkspaceSymbol.from(Ae),cacheId:[Y,we]})}return he}async resolveWorkspaceSymbol(N,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const Q=this.d.get(...N.cacheId);if(Q){const Y=await this.e.resolveWorkspaceSymbol(Q,H);return Y&&(0,t.mixin)(N,P.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideRenameEdits(N,H,Q,Y){const he=this.d.getDocument(N),we=P.Position.to(H);try{const Ae=await this.e.provideRenameEdits(he,we,Q,Y);return Ae?P.WorkspaceEdit.from(Ae):void 0}catch(Ae){const pe=j.g(Ae);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,H,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(N),he=P.Position.to(H);try{const we=await this.e.prepareRename(Y,he,Q);let Ae,pe;if(R.Range.isRange(we)?(Ae=we,pe=Y.getText(we)):(0,T.isObject)(we)&&(Ae=we.range,pe=we.placeholder),!Ae||!pe)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Ae),text:pe}}catch(we){const Ae=j.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ue{constructor(N,H){this.resultId=N,this.tokens=H}}class V{constructor(N,H){this.f=N,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,H,Q){const Y=this.f.getDocument(N),he=H!==0?this.d.get(H):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,he.resultId,Q):await this.g.provideDocumentSemanticTokens(Y,Q);return he&&this.d.delete(H),we?(we=V.h(we),this.o(V.n(he,we),we)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return V.j(N)?V.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):V.l(N)?V.m(N)?N:new R.SemanticTokensEdits(N.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const H of N.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(N,H){if(!V.j(H)||!N||!N.tokens)return H;const Q=N.tokens,Y=Q.length,he=H.data,we=he.length;let Ae=0;const pe=Math.min(Y,we);for(;Ae<pe&&Q[Ae]===he[Ae];)Ae++;if(Ae===Y&&Ae===we)return new R.SemanticTokensEdits([],H.resultId);let De=0;const ke=pe-Ae;for(;De<ke&&Q[Y-De-1]===he[we-De-1];)De++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Y-Ae-De,data:he.subarray(Ae,we-De)}],H.resultId)}o(N,H){if(V.j(N)){const Q=this.e++;return this.d.set(Q,new ue(N.resultId,N.data)),(0,f.encodeSemanticTokensDto)({id:Q,type:"full",data:N.data})}if(V.l(N)){const Q=this.e++;return V.j(H)?this.d.set(Q,new ue(H.resultId,H.data)):this.d.set(Q,new ue(N.resultId)),(0,f.encodeSemanticTokensDto)({id:Q,type:"delta",deltas:(N.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class _{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeSemanticTokens(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(Y,P.Range.to(H),Q);return he?this.f(he):null}f(N){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class J{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,H,Q,Y,he){this.f=N,this.g=H,this.h=Q,this.j=Y,this.k=he,this.d=new m.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,H,Q,Y){const he=this.f.getDocument(N),we=P.Position.to(H),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),pe=Ae.with({end:we}),De=new p.StopWatch(!0),ke=await this.h.provideCompletionItems(he,we,Y,P.CompletionContext.to(Q));if(!ke||Y.isCancellationRequested)return;const Ve=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=J.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),et=new w.DisposableStore;this.e.set(Ge,et);const Qe=[],nt={x:Ge,b:Qe,a:{replace:P.Range.from(Ae),insert:P.Range.from(pe)},c:Ve.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<Ve.items.length;st++){const ht=Ve.items[st],Me=this.l(ht,[Ge,st],pe,Ae);Qe.push(Me)}return nt}async resolveCompletionItem(N,H){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.h.resolveCompletionItem(Q,H);if(!!Y)return this.l(Y,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H,Q,Y){const he=this.e.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(N.command,he),Ae={x:H,a:N.label,b:N.kind!==void 0?P.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(P.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:P.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(P.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let pe;return N.textEdit?pe=N.textEdit.range:N.range&&(pe=N.range),R.Range.isRange(pe)?Ae.j=P.Range.from(pe):pe&&(!Q?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Ae.j={insert:P.Range.from(pe.inserting),replace:P.Range.from(pe.replacing)}),Ae}}class ie{async provideInlineCompletions(N,H,Q,Y){}disposeCompletions(N){}handleDidShowCompletionItem(N,H){}}class ee extends ie{constructor(N,H,Q,Y){super(),this.f=N,this.g=H,this.h=Q,this.j=Y,this.d=new X,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[k.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[k.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,H,Q,Y){const he=this.g.getDocument(N),we=P.Position.to(H),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:P.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},Y);if(!Ae||Y.isCancellationRequested)return;const pe=Array.isArray(Ae)?Ae:Ae.items,De=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let Qe;Ge.command&&(ke||(ke=new w.DisposableStore),Qe=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?P.Range.from(Ge.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new w.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,H){const Q=this.d.get(N)?.items[H];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const H=this.e++;return this.d.set(H,N),H}disposeReferenceId(N){const H=this.d.get(N);return this.d.delete(N),H}get(N){return this.d.get(N)}}class G{constructor(N,H){this.e=N,this.f=H,this.d=new m.Cache("SignatureHelp")}async provideSignatureHelp(N,H,Q,Y){const he=this.e.getDocument(N),we=P.Position.to(H),Ae=this.g(Q),pe=await this.f.provideSignatureHelp(he,we,Y,Ae);if(pe){const De=this.d.add([pe]);return{...P.SignatureHelp.from(pe),id:De}}}g(N){let H;if(N.activeSignatureHelp){const Q=P.SignatureHelp.to(N.activeSignatureHelp),Y=this.d.get(N.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=Q.activeSignature,H.activeParameter=Q.activeParameter):H=Q}return{...N,activeSignatureHelp:H}}releaseSignatureHelp(N){this.d.delete(N)}}class de{constructor(N,H,Q,Y,he){this.f=N,this.g=H,this.h=Q,this.j=Y,this.k=he,this.d=new m.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,H,Q){const Y=this.f.getDocument(N),he=P.Range.to(H),we=await this.h.provideInlayHints(Y,he,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(Q.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new w.DisposableStore);const pe={hints:[],cacheId:Ae};for(let De=0;De<we.length;De++)this.l(we[De],he)&&pe.hints.push(this.m(we[De],[Ae,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(N,H){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.h.resolveInlayHint(Q,H);if(!!Y&&!!this.l(Y))return this.m(Y,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H){return N.label.length===0||Array.isArray(N.label)&&N.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(H&&!H.contains(N.position))}m(N,H){const Q=this.e.get(H[0]);if(!Q)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:P.MarkdownString.fromStrict(N.tooltip),position:P.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(P.TextEdit.from),kind:N.kind&&P.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Y.label=N.label:Y.label=N.label.map(he=>{const we={label:he.value};return we.tooltip=P.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=P.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,Q)),we}),Y}}class be{constructor(N,H){this.e=N,this.f=H,this.d=new m.Cache("DocumentLink")}async provideLinks(N,H){const Q=this.e.getDocument(N),Y=await this.f.provideDocumentLinks(Q,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(be.g).map(P.DocumentLink.from)};{const he=this.d.add(Y),we={links:[],cacheId:he};for(let Ae=0;Ae<Y.length;Ae++){if(!be.g(Y[Ae]))continue;const pe=P.DocumentLink.from(Y[Ae]);pe.cacheId=[he,Ae],we.links.push(pe)}return we}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,H){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.f.resolveDocumentLink(Q,H);if(!(!Y||!be.g(Y)))return P.DocumentLink.from(Y)}releaseLinks(N){this.d.delete(N)}}class Ee{constructor(N,H){this.d=N,this.e=H}async provideColors(N,H){const Q=this.d.getDocument(N),Y=await this.e.provideDocumentColors(Q,H);return Array.isArray(Y)?Y.map(we=>({color:P.Color.from(we.color),range:P.Range.from(we.range)})):[]}async provideColorPresentations(N,H,Q){const Y=this.d.getDocument(N),he=P.Range.to(H.range),we=P.Color.to(H.color),Ae=await this.e.provideColorPresentations(we,{document:Y,range:he},Q);if(!!Array.isArray(Ae))return Ae.map(P.ColorPresentation.from)}}class Pe{constructor(N,H){this.d=N,this.e=H}async provideFoldingRanges(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideFoldingRanges(Y,H,Q);if(!!Array.isArray(he))return he.map(P.FoldingRange.from)}}class Fe{constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideSelectionRanges(N,H,Q){const Y=this.d.getDocument(N),he=H.map(P.Position.to),we=await this.e.provideSelectionRanges(Y,he,Q);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let pe=0;pe<he.length;pe++){const De=[];Ae.push(De);let ke=he[pe],Ve=we[pe];for(;;){if(!Ve.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(P.SelectionRange.from(Ve)),!Ve.parent)break;ke=Ve.range,Ve=Ve.parent}}return Ae}}class se{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const Y=this.f.getDocument(N),he=P.Position.to(H),we=await this.g.prepareCallHierarchy(Y,he,Q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideCallsTo(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Y,Q);if(!!he)return he.map(we=>({from:this.h(N,we.from),fromRanges:we.fromRanges.map(Ae=>P.Range.from(Ae))}))}async provideCallsFrom(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Y,Q);if(!!he)return he.map(we=>({to:this.h(N,we.to),fromRanges:we.fromRanges.map(Ae=>P.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),Y=P.CallHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(Y._itemId,H),Y}j(N,H){return this.e.get(N)?.get(H)}}class oe{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const Y=this.f.getDocument(N),he=P.Position.to(H),we=await this.g.prepareTypeHierarchy(Y,he,Q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideSupertypes(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Y,Q);if(!!he)return he.map(we=>this.h(N,we))}async provideSubtypes(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Y,Q);if(!!he)return he.map(we=>this.h(N,we))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),Y=P.TypeHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(Y._itemId,H),Y}j(N,H){return this.e.get(N)?.get(H)}}class fe{constructor(N,H,Q,Y){this.d=N,this.e=H,this.f=Q,this.g=Y}async provideDocumentOnDropEdits(N,H,Q,Y,he){const we=this.e.getDocument(H),Ae=P.Position.to(Q),pe=P.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),De=await this.f.provideDocumentDropEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?P.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class Z{constructor(N,H){this.adapter=N,this.extension=H}}class ce{constructor(N,H,Q,Y,he,we,Ae,pe){this.g=H,this.h=Q,this.j=Y,this.k=he,this.l=we,this.m=Ae,this.n=pe,this.f=new Map,this.e=N.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(N){return P.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ce.d++}async s(N,H,Q,Y,he,we=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof H))return Y;const pe=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const De=Q(Ae.adapter,Ae.extension);return Promise.resolve(De).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),D.CancellationToken.isCancellationToken(he)?(0,E.raceCancellationError)(De,he):De}t(N,H){const Q=this.q();return this.f.set(Q,new Z(N,H)),Q}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,H,Q,Y){const he=this.t(new i(this.h,Q),N),we=Y&&Y.label||ce.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(H),we),this.p(he)}$provideDocumentSymbols(N,H,Q){return this.s(N,i,Y=>Y.provideDocumentSymbols(c.URI.revive(H),Q),void 0,Q)}registerCodeLensProvider(N,H,Q){const Y=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new Z(new l(this.h,this.j.converter,Q),N)),this.e.$registerCodeLensSupport(Y,this.o(H),he);let we=this.p(Y);if(he!==void 0){const Ae=Q.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(N,H,Q){return this.s(N,l,Y=>Y.provideCodeLenses(c.URI.revive(H),Q),void 0,Q)}$resolveCodeLens(N,H,Q){return this.s(N,l,Y=>Y.resolveCodeLens(H,Q),void 0,void 0)}$releaseCodeLenses(N,H){this.s(N,l,Q=>Promise.resolve(Q.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(N,H,Q){const Y=this.t(new a(this.h,Q),N);return this.e.$registerDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideDefinition(N,H,Q,Y){return this.s(N,a,he=>he.provideDefinition(c.URI.revive(H),Q,Y),[],Y)}registerDeclarationProvider(N,H,Q){const Y=this.t(new s(this.h,Q),N);return this.e.$registerDeclarationSupport(Y,this.o(H)),this.p(Y)}$provideDeclaration(N,H,Q,Y){return this.s(N,s,he=>he.provideDeclaration(c.URI.revive(H),Q,Y),[],Y)}registerImplementationProvider(N,H,Q){const Y=this.t(new u(this.h,Q),N);return this.e.$registerImplementationSupport(Y,this.o(H)),this.p(Y)}$provideImplementation(N,H,Q,Y){return this.s(N,u,he=>he.provideImplementation(c.URI.revive(H),Q,Y),[],Y)}registerTypeDefinitionProvider(N,H,Q){const Y=this.t(new r(this.h,Q),N);return this.e.$registerTypeDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideTypeDefinition(N,H,Q,Y){return this.s(N,r,he=>he.provideTypeDefinition(c.URI.revive(H),Q,Y),[],Y)}registerHoverProvider(N,H,Q,Y){const he=this.t(new n(this.h,Q),N);return this.e.$registerHoverProvider(he,this.o(H)),this.p(he)}$provideHover(N,H,Q,Y){return this.s(N,n,he=>he.provideHover(c.URI.revive(H),Q,Y),void 0,Y)}registerEvaluatableExpressionProvider(N,H,Q,Y){const he=this.t(new h(this.h,Q),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(H)),this.p(he)}$provideEvaluatableExpression(N,H,Q,Y){return this.s(N,h,he=>he.provideEvaluatableExpression(c.URI.revive(H),Q,Y),void 0,Y)}registerInlineValuesProvider(N,H,Q,Y){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new S(this.h,Q),N);this.e.$registerInlineValuesProvider(we,this.o(H),he);let Ae=this.p(we);if(he!==void 0){const pe=Q.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideInlineValues(N,H,Q,Y,he){return this.s(N,S,we=>we.provideInlineValues(c.URI.revive(H),Q,Y,he),void 0,he)}registerDocumentHighlightProvider(N,H,Q){const Y=this.t(new I(this.h,Q),N);return this.e.$registerDocumentHighlightProvider(Y,this.o(H)),this.p(Y)}$provideDocumentHighlights(N,H,Q,Y){return this.s(N,I,he=>he.provideDocumentHighlights(c.URI.revive(H),Q,Y),void 0,Y)}registerLinkedEditingRangeProvider(N,H,Q){const Y=this.t(new F(this.h,Q),N);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H)),this.p(Y)}$provideLinkedEditingRanges(N,H,Q,Y){return this.s(N,F,async he=>{const we=await he.provideLinkedEditingRanges(c.URI.revive(H),Q,Y);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(N,H,Q){const Y=this.t(new K(this.h,Q),N);return this.e.$registerReferenceSupport(Y,this.o(H)),this.p(Y)}$provideReferences(N,H,Q,Y,he){return this.s(N,K,we=>we.provideReferences(c.URI.revive(H),Q,Y,he),void 0,he)}registerCodeActionProvider(N,H,Q,Y){const he=new w.DisposableStore,we=this.t(new q(this.h,this.j.converter,this.k,Q,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(we,this.o(H),{providedKinds:Y?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Y?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},ce.u(N),Boolean(Q.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(N,H,Q,Y,he){return this.s(N,q,we=>we.provideCodeActions(c.URI.revive(H),Q,Y,he),void 0,he)}$resolveCodeAction(N,H,Q){return this.s(N,q,Y=>Y.resolveCodeAction(H,Q),void 0,void 0)}$releaseCodeActions(N,H){this.s(N,q,Q=>Promise.resolve(Q.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(N,H,Q){const Y=this.t(new B(this.h,Q),N);return this.e.$registerDocumentFormattingSupport(Y,this.o(H),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentFormattingEdits(N,H,Q,Y){return this.s(N,B,he=>he.provideDocumentFormattingEdits(c.URI.revive(H),Q,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(N,H,Q){const Y=this.t(new O(this.h,Q),N);return this.e.$registerRangeFormattingSupport(Y,this.o(H),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentRangeFormattingEdits(N,H,Q,Y,he){return this.s(N,O,we=>we.provideDocumentRangeFormattingEdits(c.URI.revive(H),Q,Y,he),void 0,he)}registerOnTypeFormattingEditProvider(N,H,Q,Y){const he=this.t(new U(this.h,Q),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(H),Y,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,H,Q,Y,he,we){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(H),Q,Y,he,we),void 0,we)}registerWorkspaceSymbolProvider(N,H){const Q=this.t(new z(H,this.l),N);return this.e.$registerNavigateTypeSupport(Q,typeof H.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(N,H,Q){return this.s(N,z,Y=>Y.provideWorkspaceSymbols(H,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(N,H,Q){return this.s(N,z,Y=>Y.resolveWorkspaceSymbol(H,Q),void 0,void 0)}$releaseWorkspaceSymbols(N,H){this.s(N,z,Q=>Q.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(N,H,Q){const Y=this.t(new j(this.h,Q,this.l),N);return this.e.$registerRenameSupport(Y,this.o(H),j.supportsResolving(Q)),this.p(Y)}$provideRenameEdits(N,H,Q,Y,he){return this.s(N,j,we=>we.provideRenameEdits(c.URI.revive(H),Q,Y,he),void 0,he)}$resolveRenameLocation(N,H,Q,Y){return this.s(N,j,he=>he.resolveRenameLocation(c.URI.revive(H),Q,Y),void 0,Y)}registerDocumentSemanticTokensProvider(N,H,Q,Y){const he=this.t(new V(this.h,Q),N),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(H),Y,we);let Ae=this.p(he);if(we){const pe=Q.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideDocumentSemanticTokens(N,H,Q,Y){return this.s(N,V,he=>he.provideDocumentSemanticTokens(c.URI.revive(H),Q,Y),null,Y)}$releaseDocumentSemanticTokens(N,H){this.s(N,V,Q=>Q.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,H,Q,Y){const he=this.t(new _(this.h,Q),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(H),Y),this.p(he)}$provideDocumentRangeSemanticTokens(N,H,Q,Y){return this.s(N,_,he=>he.provideDocumentRangeSemanticTokens(c.URI.revive(H),Q,Y),null,Y)}registerCompletionItemProvider(N,H,Q,Y){const he=this.t(new J(this.h,this.j.converter,Q,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(H),Y,J.supportsResolving(Q),`${N.identifier.value}(${Y.join("")})`),this.p(he)}$provideCompletionItems(N,H,Q,Y,he){return this.s(N,J,we=>we.provideCompletionItems(c.URI.revive(H),Q,Y,he),void 0,he)}$resolveCompletionItem(N,H,Q){return this.s(N,J,Y=>Y.resolveCompletionItem(H,Q),void 0,Q)}$releaseCompletionItems(N,H){this.s(N,J,Q=>Q.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(N,H,Q){const Y=new ee(N,this.h,Q,this.j.converter),he=this.t(Y,N);return this.e.$registerInlineCompletionsSupport(he,this.o(H),Y.supportsHandleDidShowCompletionItem),this.p(he)}$provideInlineCompletions(N,H,Q,Y,he){return this.s(N,ie,we=>we.provideInlineCompletions(c.URI.revive(H),Q,Y,he),void 0,he)}$handleInlineCompletionDidShow(N,H,Q){this.s(N,ie,async Y=>{Y.handleDidShowCompletionItem(H,Q)},void 0,void 0)}$freeInlineCompletionsList(N,H){this.s(N,ie,async Q=>{Q.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(N,H,Q,Y){const he=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,we=this.t(new G(this.h,Q),N);return this.e.$registerSignatureHelpProvider(we,this.o(H),he),this.p(we)}$provideSignatureHelp(N,H,Q,Y,he){return this.s(N,G,we=>we.provideSignatureHelp(c.URI.revive(H),Q,Y,he),void 0,he)}$releaseSignatureHelp(N,H){this.s(N,G,Q=>Q.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(N,H,Q){const Y=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new de(this.h,this.j.converter,Q,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(H),typeof Q.resolveInlayHint=="function",Y,ce.u(N));let we=this.p(he);if(Y!==void 0){const Ae=Q.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(N,H,Q,Y){return this.s(N,de,he=>he.provideInlayHints(c.URI.revive(H),Q,Y),void 0,Y)}$resolveInlayHint(N,H,Q){return this.s(N,de,Y=>Y.resolveInlayHint(H,Q),void 0,Q)}$releaseInlayHints(N,H){this.s(N,de,Q=>Q.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(N,H,Q){const Y=this.t(new be(this.h,Q),N);return this.e.$registerDocumentLinkProvider(Y,this.o(H),typeof Q.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(N,H,Q){return this.s(N,be,Y=>Y.provideLinks(c.URI.revive(H),Q),void 0,Q,H.scheme==="output")}$resolveDocumentLink(N,H,Q){return this.s(N,be,Y=>Y.resolveLink(H,Q),void 0,void 0,!0)}$releaseDocumentLinks(N,H){this.s(N,be,Q=>Q.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(N,H,Q){const Y=this.t(new Ee(this.h,Q),N);return this.e.$registerDocumentColorProvider(Y,this.o(H)),this.p(Y)}$provideDocumentColors(N,H,Q){return this.s(N,Ee,Y=>Y.provideColors(c.URI.revive(H),Q),[],Q)}$provideColorPresentations(N,H,Q,Y){return this.s(N,Ee,he=>he.provideColorPresentations(c.URI.revive(H),Q,Y),void 0,Y)}registerFoldingRangeProvider(N,H,Q){const Y=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new Z(new Pe(this.h,Q),N)),this.e.$registerFoldingRangeProvider(Y,this.o(H),N.identifier,he);let we=this.p(Y);if(he!==void 0){const Ae=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(N,H,Q,Y){return this.s(N,Pe,he=>he.provideFoldingRanges(c.URI.revive(H),Q,Y),void 0,Y)}registerSelectionRangeProvider(N,H,Q){const Y=this.t(new Fe(this.h,Q,this.l),N);return this.e.$registerSelectionRangeProvider(Y,this.o(H)),this.p(Y)}$provideSelectionRanges(N,H,Q,Y){return this.s(N,Fe,he=>he.provideSelectionRanges(c.URI.revive(H),Q,Y),[],Y)}registerCallHierarchyProvider(N,H,Q){const Y=this.t(new se(this.h,Q),N);return this.e.$registerCallHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareCallHierarchy(N,H,Q,Y){return this.s(N,se,he=>Promise.resolve(he.prepareSession(c.URI.revive(H),Q,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(N,H,Q,Y){return this.s(N,se,he=>he.provideCallsTo(H,Q,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(N,H,Q,Y){return this.s(N,se,he=>he.provideCallsFrom(H,Q,Y),void 0,Y)}$releaseCallHierarchy(N,H){this.s(N,se,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(N,H,Q){const Y=this.t(new oe(this.h,Q),N);return this.e.$registerTypeHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareTypeHierarchy(N,H,Q,Y){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(c.URI.revive(H),Q,Y)),void 0,Y)}$provideTypeHierarchySupertypes(N,H,Q,Y){return this.s(N,oe,he=>he.provideSupertypes(H,Q,Y),void 0,Y)}$provideTypeHierarchySubtypes(N,H,Q,Y){return this.s(N,oe,he=>he.provideSubtypes(H,Q,Y),void 0,Y)}$releaseTypeHierarchy(N,H){this.s(N,oe,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(N,H,Q){const Y=this.q();return this.f.set(Y,new Z(new fe(this.e,this.h,Q,Y),N)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(H)),this.p(Y)}$provideDocumentOnDropEdits(N,H,Q,Y,he,we){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(H,c.URI.revive(Q),Y,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,H,Q,Y){const he=this.q();return this.f.set(he,new Z(new M(this.e,this.h,Q,he),N)),this.e.$registerPasteEditProvider(he,this.o(H),!!Q.prepareDocumentPaste,Y.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,H,Q,Y,he){return this.s(N,M,we=>we.prepareDocumentPaste(c.URI.revive(H),Q,Y,he),void 0,he)}$providePasteEdits(N,H,Q,Y,he,we){return this.s(N,M,Ae=>Ae.providePasteEdits(H,c.URI.revive(Q),Y,he,we),void 0,we)}static w(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ce.w(N.decreaseIndentPattern),increaseIndentPattern:ce.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ce.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ce.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ce.w(N.beforeText),afterText:N.afterText?ce.w(N.afterText):void 0,previousLineText:N.previousLineText?ce.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ce.z)}setLanguageConfiguration(N,H,Q){const{wordPattern:Y}=Q;if(Y&&(0,y.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?ce.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?ce.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?ce.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport};return this.e.$setLanguageConfiguration(he,H,we),this.p(he)}$setWordDefinitions(N){for(const H of N)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(ye[262],Ce([1,0,5,15,7,38,14,6]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,T,v,D){this.c=T,this.d=v,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,T){await this.a.$changeLanguage(L,T);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,T){const v=L.version,D=t.Position.from(T),w=await this.a.$tokensAtPosition(L.uri,D),f={type:P.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new P.Range(T.line,T.character,T.line,T.character)};if(!w)return f;const d={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!d.range.contains(T)||v!==L.version?f:d}createLanguageStatusItem(L,T,v){const D=this.f++,w=this.a,f=this.g,d=`${L.identifier.value}/${T}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);f.add(d);const m={selector:v,id:T,name:L.displayName??L.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new A.DisposableStore,E=()=>{p?.dispose(),p=(0,k.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(D,{id:d,name:m.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===P.LanguageStatusSeverity.Error?R.default.Error:m.severity===P.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:m.command&&this.d.toInternal(m.command,b),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},g={dispose(){b.dispose(),p?.dispose(),w.$removeLanguageStatus(D),f.delete(d)},get id(){return m.id},get name(){return m.name},set name(i){m.name=i,E()},get selector(){return m.selector},set selector(i){m.selector=i,E()},get text(){return m.text},set text(i){m.text=i,E()},get detail(){return m.detail},set detail(i){m.detail=i,E()},get severity(){return m.severity},set severity(i){m.severity=i,E()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(i){m.accessibilityInformation=i,E()},get command(){return m.command},set command(i){m.command=i,E()},get busy(){return m.busy},set busy(i){m.busy=i,E()}};return E(),g}}e.ExtHostLanguages=y}),define(ye[97],Ce([1,0,12,8,2,4,13,5,25,18]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,D,w){this.f=w,this.d=new Map,this.a=D.getProxy(A.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(v,D){const{message:w,args:f,comment:d}=D;if(this.c)return(0,t.format2)(w,f??{});let m=w;d&&d.length>0&&(m+=`/${Array.isArray(d)?d.join(""):d}`);const p=this.d.get(v)?.contents[m];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${m}`),(0,t.format2)(p??w,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let D;const w=await this.g(v);if(!w){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(w),d=JSON.parse(f);D=v.isBuiltin?d.contents?.bundle:d}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${w}: ${f.message}`);return}D&&this.d.set(v.identifier.value,{contents:D,uri:w})}async g(v){if(v.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return P.URI.revive(D)}return v.l10n?P.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,y.IExtHostInitDataService),We(1,C.IExtHostRpcService),We(2,k.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,18,2,3,10,68]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let L=class extends c.AbstractLoggerService{constructor(D,w){super(w.logLevel,A.Event.None,w.loggers.map(f=>(0,C.revive)(f))),this.l=D.getProxy(t.MainContext.MainThreadLogger)}$setLevel(D,w){w?this.setLogLevel(k.URI.revive(w),D):(0,y.isUndefined)(D)||this.j(D)}k(D,w,f){return new T(this.l,D,w,f)}};L=qe([We(0,R.IExtHostRpcService),We(1,P.IExtHostInitDataService)],L),e.ExtHostLoggerService=L;class T extends c.AbstractMessageLogger{constructor(D,w,f,d){super(d?.always),this.m=D,this.n=w,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(w,d).then(()=>{this.r(this.l),this.k=!0})}g(D,w){const f=[[D,w]];this.k?this.r(f):this.l.push(...f)}r(D){this.m.$log(this.n,D)}}}),define(ye[263],Ce([1,0,5,13,27]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let k=class{constructor(y,C){this.b=C,this.a=y.getProxy(c.MainContext.MainThreadMessageService)}showMessage(y,C,L,T,v){const D={source:{identifier:y.identifier,label:y.displayName||y.name}};let w;typeof T=="string"||R(T)?w=[T,...v]:(D.modal=T?.modal,D.useCustom=T?.useCustom,D.detail=T?.detail,w=v),D.useCustom&&(0,P.checkProposedApiEnabled)(y,"resolvers");const f=[];for(let d=0;d<w.length;d++){const m=w[d];if(typeof m=="string")f.push({title:m,handle:d,isCloseAffordance:!1});else if(typeof m=="object"){const{title:p,isCloseAffordance:b}=m;f.push({title:p,isCloseAffordance:!!b,handle:d})}else this.b.warn("Invalid message item:",m)}return this.a.$showMessage(C,L,D,f).then(d=>{if(typeof d=="number")return w[d]})}};k=qe([We(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(ye[264],Ce([1,0,22,3,6,28,8,10,2,74,5,41,15,7,58,239,136]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,E,g,i){this.q=g,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===13){const o=l.notebookEditor?.notebookUri,a=l.cell.handle,u=this.g.get(o)?.getCell(a);if(u)return u.apiCell}if(l&&l.$mid===14){const o=l.uri,a=this.g.get(o);if(a)return a.apiNotebook}return l}}),m.x(E)}getEditorById(b){const E=this.h.get(b);if(!E)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(b){for(const[E,g]of this.h)if(g.apiEditor===b)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,E){const g=this.g.get(b);if(!g&&!E)throw new Error(`NO notebook document for '${b}'`);return g}static s(b,E){if(!E)return;const g=E.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(E.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:E.displayName,filenamePattern:g,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,E,g){const i=m.a++,l=typeof g.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(i,g),this.b.$registerNotebookCellStatusBarItemProvider(i,l,E);let o;return l!==void 0&&(o=g.onDidChangeCellStatusBarItems(a=>this.b.$emitCellStatusBarEvent(l))),new D.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,l),o?.dispose()})}async createNotebookDocument(b){const E=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return y.URI.revive(E)}async openNotebookDocument(b){const E=this.g.get(b);if(E)return E.apiNotebook;const g=await this.c.$tryOpenNotebook(b),i=this.g.get(y.URI.revive(g));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,E){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof E=="object"?g={position:v.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(v.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:g={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,g),l=i&&this.h.get(i)?.apiEditor;if(l)return l;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,E,g,i){const l=this.f.get(b),o=y.URI.revive(E),a=this.g.get(o);if(!a||!l)return;const s=a.getCellFromIndex(g);if(!s)return;const u=await l.provideCellStatusBarItems(s.apiCell,i);if(!u)return;const r=new P.DisposableStore,n=this.p.add([r]),S=(Array.isArray(u)?u:[u]).map(I=>v.NotebookStatusBarItem.from(I,this.i,r));return{cacheId:n,items:S}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,E,g,i,l){if((0,k.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,g),this.b.$registerNotebookSerializer(o,{id:b.identifier,location:b.extensionLocation},E,v.NotebookDocumentContentOptions.from(i),m.s(b,l)),(0,P.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(b,E,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const l=await i.deserializeNotebook(E.buffer,g);return new w.SerializableObjectWithBuffers(v.NotebookData.from(l))}async $notebookToData(b,E,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const l=await i.serializeNotebook(v.NotebookData.to(E.value),g);return c.VSBuffer.wrap(l)}w(b,E,g){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const i=new d.ExtHostNotebookEditor(E,this.d,b,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(E,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const g of b.value.removedDocuments){const i=y.URI.revive(g),l=this.g.get(i);l&&(l.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(l.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===i.toString()&&this.h.delete(o.id)}if(b.value.addedDocuments){const g=[];for(const i of b.value.addedDocuments){const l=y.URI.revive(i.uri);if(this.g.has(l))throw new Error(`adding EXISTING notebook ${l} `);const o=new f.ExtHostNotebookDocument(this.c,this.q,this.r,l,i);g.push(...i.cells.map(a=>f.ExtHostCell.asModelAddData(o.apiNotebook,a))),this.g.get(l)?.dispose(),this.g.set(l,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(o.apiNotebook)}}if(b.value.addedEditors)for(const g of b.value.addedEditors){if(this.h.has(g.id))return;const i=y.URI.revive(g.documentUri),l=this.g.get(i);l&&this.w(l,g.id,g)}const E=[];if(b.value.removedEditors)for(const g of b.value.removedEditors){const i=this.h.get(g);i&&(this.h.delete(g),this.k?.id===i.id&&(this.k=void 0),E.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const g=new Set;this.l.forEach(i=>g.add(i.id));for(const i of this.h.values()){const l=g.has(i.id);i._acceptVisibility(l)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const E=T.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new T.ApiCommandArgument("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>c.VSBuffer.wrap(l))],new T.ApiCommandResult("Notebook Data",l=>v.NotebookData.to(l.value))),i=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new w.SerializableObjectWithBuffers(v.NotebookData.from(l)))],new T.ApiCommandResult("Bytes",l=>l.buffer));b.registerApiCommand(g),b.registerApiCommand(i)}}e.ExtHostNotebookController=m,m.a=0}),define(ye[265],Ce([1,0,16,14,21,3,6,28,2,26,13,74,5,41,15,7,94,228,27,58]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=class{constructor(s,u,r,n,h){this.k=u,this.l=r,this.m=n,this.n=h,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=s.getProxy(v.MainContext.MainThreadNotebookKernels);const S=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const F=this.l.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:F}}else if(I&&"notebookEditor"in I){const F=this.l.getIdByEditor(I.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return I})],D.ApiCommandResult.Void);this.m.registerApiCommand(S)}createNotebookController(s,u,r,n,h,S){for(const ie of this.h.values())if(ie.controller.id===u&&C.ExtensionIdentifier.equals(s.identifier,ie.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const I=this.i++,F=this;this.n.trace(`NotebookController[${I}], CREATED by ${s.identifier.value}, ${u}`);const K=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${s.identifier}'`);let q=!1;const M=new k.DisposableStore,B=new R.Emitter,O=new R.Emitter,U={id:o(s.identifier,u),notebookType:r,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:n||s.identifier.value,preloads:S?S.map(w.NotebookRendererScript.from):[]};let z=h??K,j;this.a.$addKernel(I,U).catch(ie=>{console.log(ie),q=!0});let ue=0;const V=()=>{if(q)return;const ie=++ue;Promise.resolve().then(()=>{ie===ue&&this.a.$updateKernel(I,U)})},_=new A.ResourceMap,J={get id(){return u},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ie){U.label=ie??s.displayName??s.name,V()},get detail(){return U.detail??""},set detail(ie){U.detail=ie,V()},get description(){return U.description??""},set description(ie){U.description=ie,V()},get kind(){return(0,p.checkProposedApiEnabled)(s,"notebookControllerKind"),U.kind??""},set kind(ie){(0,p.checkProposedApiEnabled)(s,"notebookControllerKind"),U.kind=ie,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ie){U.supportedLanguages=ie,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){U.supportsExecutionOrder=ie,V()},get rendererScripts(){return U.preloads?U.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ie){z=ie??K},get interruptHandler(){return j},set interruptHandler(ie){j=ie,U.supportsInterrupt=Boolean(ie),V()},createNotebookCellExecution(ie){if(q)throw new Error("notebook controller is DISPOSED");if(!_.has(ie.notebook.uri))throw F.n.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return F._createNotebookCellExecution(ie,o(s.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${I}], DISPOSED`),q=!0,this.h.delete(I),M.dispose(),B.dispose(),O.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ie,ee){ee===f.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,ie.uri,ee)},onDidReceiveMessage:O.event,postMessage(ie,ee){return(0,p.checkProposedApiEnabled)(s,"notebookMessaging"),F.a.$postMessage(I,ee&&F.l.getIdByEditor(ee),ie)},asWebviewUri(ie){return(0,p.checkProposedApiEnabled)(s,"notebookMessaging"),(0,d.asWebviewUri)(ie,F.k.remote)}};return this.h.set(I,{extensionId:s.identifier,controller:J,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:_}),J}getIdByController(s){for(const[u,r]of this.h)if(r.controller===s)return o(r.extensionId,s.id);return null}createNotebookControllerDetectionTask(s,u){const r=this.d++,n=this;this.n.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${s.identifier.value}`),this.a.$addKernelDetectionTask(r,u);const h={dispose:()=>{this.c.delete(r),n.a.$removeKernelDetectionTask(r)}};return this.c.set(r,h),h}registerKernelSourceActionProvider(s,u,r){const n=this.f++,h=this;return this.e.set(n,r),this.n.trace(`NotebookKernelSourceActionProvider[${n}], CREATED by ${s.identifier.value}`),this.a.$addKernelSourceActionProvider(n,u),{dispose:()=>{this.e.delete(n),h.a.$removeKernelSourceActionProvider(n)}}}async $provideKernelSourceActions(s,u){const r=this.e.get(s);if(r){const n=new k.DisposableStore;return this.g.add([n]),(await r.provideNotebookKernelSourceActions(u)??[]).map(S=>w.NotebookKernelSourceAction.from(S,this.m.converter,n))}return[]}$acceptNotebookAssociation(s,u,r){const n=this.h.get(s);if(n){const h=this.l.getNotebookDocument(y.URI.revive(u));r?n.associatedNotebooks.set(h.uri,!0):n.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${s}] ASSOCIATE notebook`,h.uri.toString(),r),n.onDidChangeSelection.fire({selected:r,notebook:h.apiNotebook})}}async $executeCells(s,u,r){const n=this.h.get(s);if(!n)return;const h=this.l.getNotebookDocument(y.URI.revive(u)),S=[];for(const I of r){const F=h.getCell(I);F&&S.push(F.apiCell)}try{this.n.trace(`NotebookController[${s}] EXECUTE cells`,h.uri.toString(),S.length),await n.controller.executeHandler.call(n.controller,S,h.apiNotebook,n.controller)}catch(I){this.n.error(`NotebookController[${s}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(s,u,r){const n=this.h.get(s);if(!n)return;const h=this.l.getNotebookDocument(y.URI.revive(u));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,h.apiNotebook);else for(const S of r){const I=h.getCell(S);I&&this.b.get(I.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,u,r){const n=this.h.get(s);if(!n)return;const h=this.l.getEditorById(u);n.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:r}))}$cellExecutionChanged(s,u,r){const h=this.l.getNotebookDocument(y.URI.revive(s)).getCell(u);if(h){const S=r?w.NotebookCellExecutionState.to(r):f.NotebookCellExecutionState.Idle;S!==void 0&&this.j.fire({cell:h.apiCell,state:S})}}_createNotebookCellExecution(s,u){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this.l.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!n)throw new Error("invalid cell");if(this.b.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const h=new i(u,n,this.a);this.b.set(n.uri,h);const S=h.onDidChangeState(()=>{h.state===g.Resolved&&(h.dispose(),S.dispose(),this.b.delete(n.uri))});return h.asApiObject()}};E=qe([We(4,L.ILogService)],E),e.ExtHostNotebookKernels=E;var g;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(g||(g={}));class i extends k.Disposable{get state(){return this.f}constructor(s,u,r){super(),this.j=u,this.k=r,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new P.CancellationTokenSource),this.h=new l(10,n=>this.m(n)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,s,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(s){await this.h.addItem(s)}async m(s){const u=Array.isArray(s)?s:[s];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(s){let u=this.j;if(s&&(u=this.j.notebook.getCellFromApiCell(s)),!u)throw new Error("INVALID cell");return u.handle}s(s){return s.map(u=>{const r=f.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return r===u.items?w.NotebookCellOutput.from(u):w.NotebookCellOutput.from({items:r,id:u.id,metadata:u.metadata})})}async t(s,u,r){const n=this.r(u),h=this.s((0,c.asArray)(s));return this.l({editType:m.CellExecutionUpdateType.Output,cellHandle:n,append:r,outputs:h})}async w(s,u,r){return s=f.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(s),!0),this.l({editType:m.CellExecutionUpdateType.OutputItems,items:s.map(w.NotebookCellOutputItem.from),outputId:u.id,append:r})}asApiObject(){const s=this;return Object.freeze({get token(){return s.g.token},get cell(){return s.j.apiCell},get executionOrder(){return s.i},set executionOrder(r){s.i=r,s.m([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:s.i}])},start(r){if(s.f===g.Resolved||s.f===g.Started)throw new Error("Cannot call start again");s.f=g.Started,s.c.fire(),s.m({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,n){if(s.f===g.Resolved)throw new Error("Cannot call resolve twice");s.f=g.Resolved,s.c.fire(),s.h.flush(),s.k.$completeExecution(s.b,new b.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:r}))},clearOutput(r){return s.n(),s.t([],r,!1)},appendOutput(r,n){return s.n(),s.t(r,n,!0)},replaceOutput(r,n){return s.n(),s.t(r,n,!1)},appendOutputItems(r,n){return s.n(),s.w(r,n,!0)},replaceOutputItems(r,n){return s.n(),s.w(r,n,!1)}})}}i.a=0;class l{constructor(s,u){this.d=s,this.e=u,this.a=[],this.b=Date.now()}addItem(s){return this.a.push(s),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const s=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>s.complete())}}function o(a,s){return`${a.value}/${s}`}e.createKernelId=o}),define(ye[266],Ce([1,0,3,5,136]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,C){const L=this.c.getEditorById(A);this.a.get(y)?.fire({editor:L.apiEditor,message:C})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,T,v)=>this.d(y).event(L,T,v),postMessage:(L,T)=>{P.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,T]=[T,L]);const v=T&&P.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(v?.id,y,L)}}}d(A){let y=this.a.get(A);return y||(y=new c.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[267],Ce([1,0,6,10,2,27,5]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(C){this.b=new Map,this.a=C.getProxy(k.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(C,L,T){if((0,R.checkProposedApiEnabled)(C,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,T),this.a.$registerProfileContentHandler(L,T.name,T.description,C.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(C,L,T,v){const D=this.b.get(C);if(!D)throw new Error(`Unknown handler with id: ${C}`);return D.saveProfile(L,T,v)}async $readProfile(C,L,T){const v=this.b.get(C);if(!v)throw new Error(`Unknown handler with id: ${C}`);return v.readProfile((0,t.isString)(L)?L:P.URI.revive(L),T)}}e.ExtHostProfileContentHandlers=A}),define(ye[268],Ce([1,0,2,5,14]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(A){this.c=new Map,this.b=A.getProxy(t.MainContext.MainThreadQuickDiff)}$provideOriginalResource(A,y,C){const L=c.URI.revive(y),T=this.c.get(A);return T?(0,P.asPromise)(()=>T.provideOriginalResource(L,C)).then(v=>v||null):Promise.resolve(null)}async registerQuickDiffProvider(A,y,C){const L=R.a++;return this.c.set(L,A),await this.b.$registerQuickDiffProvider(L,y,C),{dispose:()=>this.c.delete(L)}}}e.ExtHostQuickDiff=R,R.a=0}),define(ye[269],Ce([1,0,21,3,6,5,2,7,9,16,38,73]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(D,w,f){const d=D.getProxy(R.MainContext.MainThreadQuickOpen);class m{constructor(s,u){this.e=new Map,this.f=0,this.a=s,this.b=u}showQuickPick(s,u,r=c.CancellationToken.None){this.c=void 0;const n=Promise.resolve(s),h=++this.f,S=d.$show(h,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},r),I={},F=S.then(()=>I);return Promise.race([F,n]).then(K=>{if(K!==I)return n.then(q=>{const M=[];for(let B=0;B<q.length;B++){const O=q[B];typeof O=="string"?M.push({label:O,handle:B}):O.kind===A.QuickPickItemKind.Separator?M.push({type:"separator",label:O.label}):M.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=B=>{u.onDidSelectItem(q[B])}),d.$setItems(h,M),S.then(B=>{if(typeof B=="number")return q[B];if(Array.isArray(B))return B.map(O=>q[O])})})}).then(void 0,K=>{if(!(0,y.isCancellationError)(K))return d.$setError(h,K),Promise.reject(K)})}$onItemSelected(s){this.c?.(s)}showInput(s,u=c.CancellationToken.None){return this.d=s?.validateInput,d.$input(s,typeof this.d=="function",u).then(void 0,r=>{if(!(0,y.isCancellationError)(r))return Promise.reject(r)})}async $validateInput(s){if(!this.d)return;const u=await this.d(s);if(!u||typeof u=="string")return u;let r;switch(u.severity){case A.InputBoxValidationSeverity.Info:r=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:r=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:r=L.default.Error;break;default:r=u.message?L.default.Error:L.default.Ignore;break}return{content:u.message,severity:r}}async showWorkspaceFolderPick(s,u=c.CancellationToken.None){const r=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!r)return;const n=await this.a.getWorkspaceFolders2();if(!!n)return n.find(h=>h.uri.toString()===r.uri.toString())}createQuickPick(s){const u=new l(s,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(s){const u=new o(s,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(s,u){this.e.get(s)?._fireDidChangeValue(u)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,u){const r=this.e.get(s);r instanceof l&&r._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const r=this.e.get(s);r instanceof l&&r._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){this.e.get(s)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(s,u,r){const n=this.e.get(s);n instanceof l&&n._fireDidTriggerItemButton(u,r)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class p{constructor(s,u){this.x=s,this.y=u,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((u,r)=>{const n=u===A.QuickInputButtons.Back?-1:r;this.o.set(n,u)}),this.z({buttons:s.map((u,r)=>({...i(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:r}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const u=this.o.get(s);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(s){if(!this.v){for(const u of Object.keys(s)){const r=s[u];this.u[u]=r===void 0?null:r}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function b(a){if(a instanceof A.ThemeIcon)return{id:a.id};const s=g(a),u=E(a);return{dark:typeof s=="string"?k.URI.file(s):s,light:typeof u=="string"?k.URI.file(u):u}}function E(a){return typeof a=="object"&&"light"in a?a.light:a}function g(a){return typeof a=="object"&&"dark"in a?a.dark:a}function i(a){const s=b(a.iconPath);let u,r;return"id"in s?r=T.ThemeIcon.asClassName(s):u=s,{iconPath:u,iconClass:r}}class l extends p{constructor(s,u){super(s.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((r,n)=>{this.C.set(n,r),this.D.set(r,n)});const u=[];for(let r=0;r<s.length;r++){const n=s[r];n.kind===A.QuickPickItemKind.Separator?u.push({type:"separator",label:n.label}):u.push({handle:r,label:n.label,description:n.description,detail:n.detail,picked:n.picked,alwaysShow:n.alwaysShow,buttons:n.buttons?.map((h,S)=>({...i(h),tooltip:h.tooltip,handle:S}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(s){const u=(0,C.coalesce)(s.map(r=>this.C.get(r)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(s){const u=(0,C.coalesce)(s.map(r=>this.C.get(r)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(s,u){const r=this.C.get(s);if(!r||!r.buttons||!r.buttons.length)return;const n=r.buttons[u];n&&this.N.fire({button:n,item:r})}}class o extends p{constructor(s,u){super(s.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:L.default.Error}):this.z({validationMessage:s.message,severity:s.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new m(w,f)}e.createExtHostQuickOpen=v});var Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c};define(ye[270],Ce([1,0,2,3,62,6,14,5,16,108,13,26,73,15,27]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w){"use strict";var f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(n){if(n)return typeof n.iconPath=="string"?c.URI.file(n.iconPath):c.URI.isUri(n.iconPath)||v.ThemeIcon.isThemeIcon(n.iconPath)?n.iconPath:void 0}function p(n,h){if(!n.iconPath&&!h.iconPath)return 0;if(n.iconPath){if(!h.iconPath)return 1}else return-1;const S=typeof n.iconPath=="string"?n.iconPath:c.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id,I=typeof h.iconPath=="string"?h.iconPath:c.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,C.comparePaths)(S,I)}function b(n,h){let S=0;if(n.strikeThrough!==h.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==h.faded)return n.faded?1:-1;if(n.tooltip!==h.tooltip)return(n.tooltip||"").localeCompare(h.tooltip||"");if(S=p(n,h),S!==0)return S;if(n.light&&h.light)S=p(n.light,h.light);else{if(n.light)return 1;if(h.light)return-1}if(S!==0)return S;if(n.dark&&h.dark)S=p(n.dark,h.dark);else{if(n.dark)return 1;if(h.dark)return-1}return S}function E(n,h){if(n.command!==h.command)return n.command<h.command?-1:1;if(n.title!==h.title)return n.title<h.title?-1:1;if(n.tooltip!==h.tooltip){if(n.tooltip!==void 0&&h.tooltip!==void 0)return n.tooltip<h.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(n.arguments===h.arguments)return 0;if(n.arguments)if(h.arguments){if(n.arguments.length!==h.arguments.length)return n.arguments.length-h.arguments.length}else return 1;else return-1;for(let S=0;S<n.arguments.length;S++){const I=n.arguments[S],F=h.arguments[S];if(I!==F)return I<F?-1:1}return 0}function g(n,h){let S=(0,C.comparePaths)(n.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(S!==0)return S;if(n.command&&h.command)S=E(n.command,h.command);else{if(n.command)return 1;if(h.command)return-1}if(S!==0)return S;if(n.decorations&&h.decorations)S=b(n.decorations,h.decorations);else{if(n.decorations)return 1;if(h.decorations)return-1}return S}function i(n,h){for(let S=0;S<n.length;S++)if(n[S]!==h[S])return!1;return!0}function l(n,h){return n.command===h.command&&n.title===h.title&&n.tooltip===h.tooltip&&(n.arguments&&h.arguments?i(n.arguments,h.arguments):n.arguments===h.arguments)}function o(n,h){return(0,y.equals)(n,h,l)}class a{get value(){return this.d}set value(h){h=h??"",Ue(this,f,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Ue(this,f,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,w.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,w.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Ue(this,f,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Ue(this,f,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Ue(this,f,"f").$setInputBoxVisibility(this.l,h))}constructor(h,S,I){this.k=h,this.l=I,f.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,f,S,"f")}showValidationMessage(h,S){(0,w.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,f,"f").$showValidationMessage(this.l,h,S)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=a,f=new WeakMap;class s{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,S,I,F,K){this.q=h,this.s=S,this.t=I,this.u=F,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,S){const I=this.h.get(h);return I?(0,k.asPromise)(()=>this.s.executeCommand(I.command,...I.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(g),I=(0,y.sortedDiff)(this.o,h,g).map(q=>{const M=q.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const U=B.resourceUri;let z;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const de=new R.DisposableStore;z=this.s.converter.toInternal(B.command,de),this.j.set(O,de)}else this.h.set(O,B.command);const j=m(B.decorations),ue=B.decorations&&m(B.decorations.light)||j,V=B.decorations&&m(B.decorations.dark)||j,_=[ue,V],J=B.decorations&&B.decorations.tooltip||"",ie=B.decorations&&!!B.decorations.strikeThrough,ee=B.decorations&&!!B.decorations.faded,X=B.contextValue||"";return{rawResource:[O,U,_,J,ie,ee,X,z],handle:O}});return{start:q.start,deleteCount:q.deleteCount,toInsert:M}}),F=I.map(({start:q,deleteCount:M,toInsert:B})=>[q,M,B.map(O=>O.rawResource)]),K=I.reverse();for(const{start:q,deleteCount:M,toInsert:B}of K){const O=B.map(z=>z.handle),U=this.n.splice(q,M,...O);for(const z of U)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=h,F}dispose(){this.l=!0,this.m.fire()}}s.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Ue(this,d,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h,Ue(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Ue(this,d,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new R.DisposableStore,this.l=h;const S=this.v.converter.toInternal(h,this.k.value);Ue(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:S})}get actionButton(){return(0,w.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,w.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=h;const S=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(I=>I.map(F=>this.v.converter.toInternal(F,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Ue(this,d,"f").$updateSourceControl(this.t,{actionButton:S??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&o(this.p,h))return;this.o.value=new R.DisposableStore,this.p=h;const S=(h||[]).map(I=>this.v.converter.toInternal(I,this.o.value));Ue(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:S})}get selected(){return this.q}constructor(h,S,I,F,K,q){this.u=h,this.v=I,this.w=F,this.x=K,this.y=q,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Je(this,d,S,"f"),this.f=new a(h,Ue(this,d,"f"),this.t),Ue(this,d,"f").$registerSourceControl(this.t,F,K,q)}createResourceGroup(h,S){const I=new s(Ue(this,d,"f"),this.v,this.t,h,S),F=t.Event.once(I.onDidDispose)(()=>this.z.delete(I));return this.z.set(I,F),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const h=[],S=[];for(const[I,F]of this.z){F.dispose();const K=I.onDidUpdateResourceStates(()=>{this.A.add(I),this.eventuallyUpdateResourceStates()});t.Event.once(I.onDidDispose)(()=>{this.A.delete(I),K.dispose(),this.e.delete(I.handle),Ue(this,d,"f").$unregisterGroup(this.t,I.handle)}),h.push([I.handle,I.id,I.label,I.features]);const q=I._takeResourceStateSnapshot();q.length>0&&S.push([I.handle,q]),this.e.set(I.handle,I)}Ue(this,d,"f").$registerGroups(this.t,h,S),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(S=>{const I=S._takeResourceStateSnapshot();I.length!==0&&h.push([S.handle,I])}),h.length>0&&Ue(this,d,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Ue(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,u.d=0,qe([(0,P.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,P.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let r=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(h,S,I){this.l=S,this.m=I,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=h.getProxy(A.MainContext.MainThreadSCM),this.f=h.getProxy(A.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const K=this.g.get(F.sourceControlHandle);if(!K)return F;const q=K.getResourceGroup(F.groupHandle);return q?q.getResourceState(F.handle):F}else if(F&&F.$mid===4){const K=this.g.get(F.sourceControlHandle);return K?K.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const K=this.g.get(F.handle);return K||F}return F}})}createSourceControl(h,S,I,F){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,S,I,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const K=on.d++,q=new u(h,this.e,this.l,S,I,F);this.g.set(K,q);const M=this.h.get(T.ExtensionIdentifier.toKey(h.identifier))||[];return M.push(q),this.h.set(T.ExtensionIdentifier.toKey(h.identifier),M),q}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const S=this.h.get(T.ExtensionIdentifier.toKey(h.identifier)),I=S&&S[S.length-1];return I&&I.inputBox}$provideOriginalResource(h,S,I){const F=c.URI.revive(S);this.m.trace("ExtHostSCM#$provideOriginalResource",h,F.toString());const K=this.g.get(h);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(F,I)).then(q=>q||null)}$onInputBoxValueChange(h,S){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const I=this.g.get(h);return I&&I.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(h,S,I,F){this.m.trace("ExtHostSCM#$executeResourceCommand",h,S,I);const K=this.g.get(h);if(!K)return Promise.resolve(void 0);const q=K.getResourceGroup(S);return q?q.$executeResourceCommand(I,F):Promise.resolve(void 0)}$validateInput(h,S,I){this.m.trace("ExtHostSCM#$validateInput",h);const F=this.g.get(h);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>F.inputBox.validateInput(S,I)).then(K=>{if(!K)return Promise.resolve(void 0);const q=D.MarkdownString.fromStrict(K.message);return q?Promise.resolve([q,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};r.d=0,r=qe([We(2,L.ILogService)],r),e.ExtHostSCM=r}),define(ye[98],Ce([1,0,5,3,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,C){return this.a.$setPassword(A,y,C)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[271],Ce([1,0,7,5,179,6,15,10]),function(te,e,c,t,P,R,k,A){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(w,f,d,m,p=c.StatusBarAlignment.Left,b){y.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Je(this,y,w,"f"),Je(this,C,f,"f"),this.c=L.a++,this.e=d,this.f=m,this.g=p,this.h=this.u(b)}u(w){if(!!(0,A.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!L.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof w=="string"?this.r={fromApi:w,internal:Ue(this,C,"f").toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:Ue(this,C,"f").toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let f;this.m?f=this.m:f=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const m=k.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,w,f,this.k,m,this.r?.internal,d,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,C=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const f={message:w};return this.b.unshift(f),this.c(),new c.Disposable(()=>{const d=this.b.indexOf(f);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(w,f){this.a=w.getProxy(t.MainContext.MainThreadStatusBar),this.b=f,this.c=new T(this)}createStatusBarEntry(w,f,d,m){return new L(this.a,this.b,w,f,d,m)}setStatusBarMessage(w,f){const d=this.c.setMessage(w);let m;return typeof f=="number"?m=setTimeout(()=>d.dispose(),f):typeof f<"u"&&f.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=v}),define(ye[99],Ce([1,0,5,3,4]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,C){const L=await this.a.$initializeExtensionStorage(A,y);let T;return L&&(T=this.d(A,y,L)),T||C}setValue(A,y,C){return this.a.$setValue(A,y,C)}$acceptValue(A,y,C){const L=this.d(A,y,C);L&&this.b.fire({shared:A,key:y,value:L})}d(A,y,C){try{return JSON.parse(C)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(ye[78],Ce([1,0,4,25,13,77,2]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let A=class{constructor(C,L,T){this.d=L,this.f=T,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(C){return k.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,L=await this.g(C);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(k.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:k.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(C){if(this.c)return k.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return k.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([We(0,t.IExtHostInitDataService),We(1,P.ILogService),We(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[42],Ce([1,0,3,5,4,2,18,6,7,180,9,211,21,30,212,73,10,14,15]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class b{constructor(r,n,h,S){this.k=r,this._id=n,this.l=h,this.m=S,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(F=>this.f=F);const I=this;this.value={get name(){return I.m||""},get processId(){return I.b},get creationOptions(){return I.l},get exitStatus(){return I.h},get state(){return I.j},sendText(F,K=!0){I.o(),I.k.$sendText(I._id,F,K)},show(F){I.o(),I.k.$show(I._id,F)},hide(){I.o(),I.k.$hide(I._id)},dispose(){I.a||(I.a=!0,I.k.$dispose(I._id))},get dimensions(){if(!(I.d===void 0||I.g===void 0))return{columns:I.d,rows:I.g}}}}async create(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:(0,d.withNullAsUndefined)(r.shellPath),shellArgs:(0,d.withNullAsUndefined)(r.shellArgs),cwd:(0,d.withNullAsUndefined)(r.cwd),env:(0,d.withNullAsUndefined)(r.env),icon:(0,d.withNullAsUndefined)(a(r.iconPath)),color:f.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,d.withNullAsUndefined)(r.message),strictEnv:(0,d.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this.n(r.location,n?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,n,h,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:f.ThemeColor.isThemeColor(S)?S.id:void 0,location:this.n(r,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,n){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in r?{viewColumn:p.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,n){this.h=Object.freeze({code:r,reason:n})}setDimensions(r,n){return r===this.d&&n===this.g||r===0||n===0?!1:(this.d=r,this.g=n,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(n=>{n!==r&&(this.b=Promise.resolve(r))})}}e.ExtHostTerminal=b;class E{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${n}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,n){this.g.setDimensions?.({columns:r,rows:n})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this.g.onDidWrite(n=>this.a.fire(n)),this.g.onDidClose?.((n=void 0)=>{this.f.fire(n===void 0?void 0:n)}),this.g.onDidOverrideDimensions?.(n=>{n&&this.d.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this.g.onDidChangeName?.(n=>{this.d.fire({type:"title",value:n})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:""})}}let g=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}get onDidWriteTerminalData(){return this.I.event}constructor(r,n){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=n.getProxy(t.MainContext.MainThreadTerminalService),this.s=new w.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[h,S]of this.g)S.shutdown(!0)}})}getDefaultShell(r){return(r?this.n:this.m)?.path||""}getDefaultShellArgs(r){return(r?this.n:this.m)?.args||[]}createExtensionTerminal(r,n){const h=new b(this.a,(0,D.generateUuid)(),r,r.name),S=new E(r.pty);return h.createExtensionTerminal(r.location,this.L(r,n).resolvedExtHostIdentifier,a(r.iconPath),s(r.color)).then(I=>{const F=this.M(I,S);this.h[I]=F}),this.f.push(h),h.value}L(r,n){if(n=n||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const h=r.location.parentTerminal;if(h){const S=this.f.find(I=>I.value===h);S&&(n.resolvedExtHostIdentifier=S._id)}}else r.location&&typeof r.location!="object"?n.location=r.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(r,n){if(!this.O(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const S=new E(n),I=this.M(r,S);this.h[r]=I}async $acceptActiveTerminalChanged(r){const n=this.b;if(r===null){this.b=void 0,n!==this.b&&this.F.fire(this.b);return}const h=this.O(r);h&&(this.b=h,n!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(r,n){const h=this.O(r);h&&this.I.fire({terminal:h.value,data:n})}async $acceptTerminalDimensions(r,n,h){const S=this.O(r);S&&S.setDimensions(n,h)&&this.G.fire({terminal:S.value,dimensions:S.value.dimensions})}async $acceptTerminalMaximumDimensions(r,n,h){this.g.get(r)?.resize(n,h)}async $acceptTerminalTitleChange(r,n){const h=this.O(r);h&&(h.name=n)}async $acceptTerminalClosed(r,n,h){const S=this.Q(this.f,r);if(S!==null){const I=this.f.splice(S,1)[0];I.setExitStatus(n,h),this.C.fire(I.value)}}$acceptTerminalOpened(r,n,h,S){if(n){const K=this.Q(this.f,n);if(K!==null){this.f[K]._id=r,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const I={name:S.name,shellPath:S.executable,shellArgs:S.args,cwd:typeof S.cwd=="string"?S.cwd:R.URI.revive(S.cwd),env:S.env,hideFromUser:S.hideFromUser},F=new b(this.a,r,I,h);this.f.push(F),this.D.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(r,n){this.O(r)?._setProcessId(n)}async $startExtensionTerminal(r,n){const h=this.O(r);if(!h)return{message:(0,C.localize)(0,null,r)};h.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async K=>{K===h.value&&(F.dispose(),I())})});const S=this.g.get(r);S?S.startSendingEvents(n):this.j[r]={initialDimensions:n}}M(r,n){const h=new A.DisposableStore;h.add(n.onProcessReady(I=>this.a.$sendProcessReady(r,I.pid,I.cwd))),h.add(n.onDidChangeProperty(I=>this.a.$sendProcessProperty(r,I))),this.s.startBuffering(r,n.onProcessData),h.add(n.onProcessExit(I=>this.N(r,I))),this.g.set(r,n);const S=this.j[r];return S&&n instanceof E&&(n.startSendingEvents(S.initialDimensions),delete this.j[r]),h}$acceptProcessAckDataEvent(r,n){this.g.get(r)?.acknowledgeDataEvent(n)}$acceptProcessInput(r,n){this.g.get(r)?.input(n)}$acceptTerminalInteraction(r){const n=this.O(r);n?.setInteractedWith()&&this.H.fire(n.value)}$acceptProcessResize(r,n,h){try{this.g.get(r)?.resize(n,h)}catch(S){if(S.code!=="EPIPE"&&S.code!=="ERR_IPC_CHANNEL_CLOSED")throw S}}$acceptProcessShutdown(r,n){this.g.get(r)?.shutdown(n)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(n=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(n=>this.a.$sendProcessProperty(r,{type:"cwd",value:n}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.u.add(r),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(r),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,n,h){if(this.v.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this.v.set(n,h),this.a.$registerProfileProvider(n,r.identifier.value),new y.Disposable(()=>{this.v.delete(n),this.a.$unregisterProfileProvider(n)})}registerTerminalQuickFixProvider(r,n,h){if(this.w.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.w.set(r,h),this.a.$registerQuickFixProvider(r,n),new y.Disposable(()=>{this.w.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,n){const h=new v.CancellationTokenSource().token;if(h.isCancellationRequested)return;const S=this.w.get(r);if(!S)return;const I=await S.provideTerminalQuickFixes(n,h);if(I!==null)return I}async $createContributedProfileTerminal(r,n){const h=new v.CancellationTokenSource().token;let S=await this.v.get(r)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(S&&!("options"in S)&&(S={options:S}),!S||!("options"in S))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in S.options){this.createExtensionTerminal(S.options,n);return}this.createTerminalFromOptions(S.options,n)}}async $provideLinks(r,n){const h=this.O(r);if(!h)return[];this.y.delete(r),this.z.get(r)?.dispose(!0);const I=new v.CancellationTokenSource;this.z.set(r,I);const F=[],K={terminal:h.value,line:n},q=[];for(const O of this.u)q.push(m.Promises.withAsyncBody(async U=>{I.token.onCancellationRequested(()=>U({provider:O,links:[]}));const z=await O.provideTerminalLinks(K,I.token)||[];I.token.isCancellationRequested||U({provider:O,links:z})}));const M=await Promise.all(q);if(I.token.isCancellationRequested)return[];const B=new Map;for(const O of M)O&&O.links.length>0&&F.push(...O.links.map(U=>{const z={id:g++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(z.id,{provider:O.provider,link:U}),z}));return this.y.set(r,B),F}$activateLink(r,n){const h=this.y.get(r)?.get(n);!h||h.provider.handleTerminalLink(h.link)}N(r,n){this.s.stopBuffering(r),this.g.delete(r),delete this.j[r];const h=this.h[r];h&&(h.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,n)}O(r){return this.P(this.f,r)}P(r,n){const h=this.Q(r,n);return h!==null?r[h]:null}Q(r,n){let h=null;return r.some((S,I)=>S._id===n?(h=I,!0):!1),h}getEnvironmentVariableCollection(r){let n=this.l.get(r.identifier.value);return n||(n=new l,this.S(r.identifier.value,n)),n}R(r,n){const h=(0,T.serializeEnvironmentVariableCollection)(n.map);this.a.$setEnvironmentVariableCollection(r,n.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(r){r.forEach(n=>{const h=n[0],S=new l(n[1]);this.S(h,S)})}$acceptDefaultProfile(r,n){const h=this.m;this.m=r,this.n=n,h?.path!==r.path&&this.J.fire(r.path)}S(r,n){this.l.set(r,n),n.onDidChangeCollection(()=>{this.R(r,n)})}};i=qe([We(1,k.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class l{get persistent(){return this.a}set persistent(r){this.a=r,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(r){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,n){this.d(r,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(r,n){this.d(r,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(r,n){this.d(r,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}d(r,n){const h=this.map.get(r);(!h||h.value!==n.value||h.type!==n.type)&&(this.map.set(r,n),this.b.fire())}get(r){return this.map.get(r)}forEach(r,n){this.map.forEach((h,S)=>r.call(n,S,h,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let o=class extends i{constructor(r){super(!1,r)}createTerminal(r,n,h){throw new L.NotSupportedError}createTerminalFromOptions(r,n){throw new L.NotSupportedError}};o=qe([We(0,k.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function a(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function s(u){return f.ThemeColor.isThemeColor(u)?u:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c};define(ye[272],Ce([1,0,16,14,22,21,3,63,87,6,23,10,30,5,18,137,15,7,57,93,75,27]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g){"use strict";var i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(O,U,z){this.j=z,this.c=new k.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(D.MainContext.MainThreadTesting),this.h=new K(this.f),this.g=new r(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const ue=j,V=ue.tests[ue.tests.length-1].item.extId;return this.d.get(p.TestId.root(V))?.collection.tree.get(V)?.actual??(0,f.toItemFromContext)(j)}})}createTestController(O,U,z,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const ue=new C.DisposableStore,V=ue.add(new f.ExtHostTestItemCollection(U,z,this.j));V.root.label=z;const _=new Map,J=this.f,ie={items:V.root.children,get label(){return z},set label(X){z=X,V.root.label=X,J.$updateController(U,{label:z})},get refreshHandler(){return j},set refreshHandler(X){j=X,J.$updateController(U,{canRefresh:!!X})},get id(){return U},createRunProfile:(X,G,de,be,Ee,Pe)=>{let Fe=(0,y.hash)(X);for(;_.has(Fe);)Fe++;return Pe!==void 0&&(0,g.checkProposedApiEnabled)(O,"testContinuousRun"),new q(this.f,_,U,Fe,X,G,de,be,Ee,Pe)},createTestItem(X,G,de){return new f.TestItemImpl(U,X,G,de)},createTestRun:(X,G,de=!0)=>this.g.createTestRun(U,V,X,G,de),set resolveHandler(X){V.resolveHandler=X},get resolveHandler(){return V.resolveHandler},dispose:()=>{ue.dispose()}};J.$registerTestController(U,z,!!j),ue.add((0,C.toDisposable)(()=>J.$unregisterTestController(U)));const ee={controller:ie,collection:V,profiles:_};return this.d.set(U,ee),ue.add((0,C.toDisposable)(()=>this.d.delete(U))),ue.add(V.onDidGenerateDiff(X=>J.$publishDiff(U,X.map(E.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(O,U=R.CancellationToken.None){const z=n(O);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(ue=>p.TestId.fromExtHostTestItem(ue,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:M[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:O.exclude?.map(ue=>ue.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,z){return(0,c.mapFind)(this.g.trackers,ue=>ue.id===O?ue.getCoverage(U):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(O,U,z,j){return(0,c.mapFind)(this.g.trackers,V=>V.id===O?V.getCoverage(U):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(d.TestResults.to(U))).concat(this.results).sort((U,z)=>z.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const z=this.d.get(p.TestId.fromString(O).controllerId)?.collection;z&&(await z.expand(O,U<0?1/0:U),z.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(E.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map(z=>this.k(z,!1,U)))}async $startContinuousRun(O,U){const z=new R.CancellationTokenSource(U),j=await Promise.all(O.map(ue=>this.k(ue,!0,z.token)));return!U.isCancellationRequested&&!j.some(ue=>ue.error)&&await new Promise(ue=>U.onCancellationRequested(ue)),z.dispose(!0),j}async k(O,U,z){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:ue,profiles:V}=j,_=V.get(O.profileId);if(!_)return{};const J=O.testIds.map(G=>ue.tree.get(G)).filter(T.isDefined),ie=O.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(T.isDefined).filter(G=>J.some(de=>de.fullId.compare(G.fullId)===2));if(!J.length)return{};const ee=new m.TestRunRequest2(J.some(G=>G.actual instanceof f.TestItemRootImpl)?void 0:J.map(G=>G.actual),ie.map(G=>G.actual),_,U),X=(0,E.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(ee,h.fromInternal(O,j.collection),z);try{return await _.runHandler(ee,z),{}}catch(G){return{error:String(G)}}finally{X&&(X.hasRunningTasks&&!z.isCancellationRequested&&await k.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};o=qe([We(0,w.IExtHostRpcService)],o),e.ExtHostTesting=o;const a=1e4;var s;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(s||(s={}));class u extends C.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,z){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new k.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(z));const j=this.B(new t.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,z=this.k.controllerId,j=(0,v.generateUuid)(),ue=new S(this.l,U,j),V=ee=>(X,...G)=>{if(J){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),ee(X,...G))},_=(ee,X)=>{const G=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(ee.uri&&ee.range){const de={range:d.Range.from(ee.range),uri:ee.uri};for(const be of G)be.location=be.location||de}this.l.$appendTestMessagesInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),G)};let J=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return ue.coverageProvider},set coverageProvider(ee){ue.coverageProvider=ee},enqueued:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),1)}),skipped:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),5)}),started:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),2)}),errored:V((ee,X,G)=>{_(ee,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),6,G)}),failed:V((ee,X,G)=>{_(ee,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),4,G)}),passed:V((ee,X)=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,X)}),appendOutput:(ee,X,G)=>{J||(G&&(this.k.isIncluded(G)?this.s(G):G=void 0),this.l.$appendOutputToRun(U,j,P.VSBuffer.fromString(ee),X&&d.location.from(X),G&&p.TestId.fromExtHostTestItem(G,z).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ie,coverage:ue}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),ie}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof f.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.g.has(p.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],z=this.k.colllection.root;for(;;){const j=d.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===z))break;O=O.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class r{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,z){return this.f(O,U,z)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,z,j,ue){const V=this.c.get(z);if(V)return V.createRun(j);const _=h.fromPublic(O,U,z,ue),J=n(z);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!z.continuous,profile:J&&{group:M[J.kind],id:J.profileId},exclude:z.exclude?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[],id:_.id,include:z.include?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[U.root.id],persist:ue});const ie=this.f(z,_);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),ie.dispose()}),ie.createRun(j)}f(O,U,z){const j=new u(U,this.d,z);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=r;const n=B=>{if(!!B.profile){if(!(B.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class h{static fromPublic(O,U,z,j){return new h(O,(0,v.generateUuid)(),z.include?.map(ue=>p.TestId.fromExtHostTestItem(ue,O).toString())??[O],z.exclude?.map(ue=>p.TestId.fromExtHostTestItem(ue,O).toString())??[],j,U)}static fromInternal(O,U){return new h(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,z,j,ue,V){this.controllerId=O,this.id=U,this.isPersisted=ue,this.colllection=V,this.c=z.map(_=>_+"\0"),this.d=j.map(_=>_+"\0")}isIncluded(O){const U=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const z of this.d)if(U===z||U.startsWith(z))return!1;for(const z of this.c)if(U===z||U.startsWith(z))return!0;return!1}}e.TestRunDto=h;class S{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,z){this.f=O,this.g=U,this.h=z}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const z=await this.d;let j=z?.[O];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class I{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,d.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=p.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:z}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class F extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new k.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:d.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new I(this.q)}}class K{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,A.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new F;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class q{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?d.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,z,j,ue,V,_,J=!1,ie=void 0,ee=!1){this.controllerId=z,this.profileId=j,this.d=ue,this.kind=V,this.runHandler=_,this.f=J,this._tag=ie,this.g=ee,i.set(this,void 0),l.set(this,void 0),Je(this,i,O,"f"),Je(this,l,U,"f"),U.set(j,this);const X=M[V];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Ue(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:z,tag:ie?d.TestTag.namespace(this.controllerId,ie.id):null,label:ue,group:X,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ee})}dispose(){Ue(this,l,"f")?.delete(this.profileId)&&(Je(this,l,void 0,"f"),Ue(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,i=new WeakMap,l=new WeakMap;const M={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ye[273],Ce([1,0,16,3,5,138,15,7]),function(te,e,c,t,P,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,T){this.i=T,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(P.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const T=this.i.allEditors();return L?T:T.map(v=>v.value)}async showTextDocument(L,T,v){let D;typeof T=="number"?D={position:k.ViewColumn.from(T),preserveFocus:v}:typeof T=="object"?D={position:k.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?k.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:D={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(L.uri,D),f=w&&this.i.getEditor(w);if(f)return f.value;throw w?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new R.TextEditorDecorationType(this.h,L,T).value}$acceptEditorPropertiesChanged(L,T){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(T.options&&v._acceptOptions(T.options),T.selections){const D=T.selections.selections.map(k.Selection.to);v._acceptSelections(D)}if(T.visibleRanges){const D=c.coalesce(T.visibleRanges.map(k.Range.to));v._acceptVisibleRanges(D)}if(T.options&&this.b.fire({textEditor:v.value,options:{...T.options,lineNumbers:k.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const D=A.TextEditorSelectionChangeKind.fromValue(T.selections.source),w=T.selections.selections.map(k.Selection.to);this.a.fire({textEditor:v.value,selections:w,kind:D})}if(T.visibleRanges){const D=c.coalesce(T.visibleRanges.map(k.Range.to));this.c.fire({textEditor:v.value,visibleRanges:D})}}$acceptEditorPositionData(L){for(const T in L){const v=this.i.getEditor(T);if(!v)throw new Error("Unknown text editor");const D=k.ViewColumn.to(L[T]);v.value.viewColumn!==D&&(v._acceptViewColumn(D),this.d.fire({textEditor:v.value,viewColumn:D}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ye[274],Ce([1,0,2,4,5,6,7,15,26,10]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class L{constructor(D,w){this.b=new Map,this.c=new Map,this.a=D.getProxy(P.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&y.ExtensionIdentifier.equals(d,this.b.get(f.source)?.extension)){const m=f.uri===void 0?void 0:c.URI.revive(f.uri);return this.c.get(f.source)?.get(T(m))?.get(f.handle)}else return;return f}})}async $getTimeline(D,w,f,d){return this.b.get(D)?.provider.provideTimeline(c.URI.revive(w),f,d)}registerTimelineProvider(D,w,f,d){const m=new R.DisposableStore,p=this.d(w.id,d,m).bind(this);let b;w.onDidChange&&(b=w.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:w.id}),this));const E=this.c;return this.f({...w,scheme:D,onDidChange:void 0,async provideTimeline(g,i,l){i?.resetCache&&(m.clear(),E.get(w.id)?.clear());const o=await w.provideTimeline(g,i,l);if(o==null)return;const a=p(g,i);return{...o,source:w.id,items:o.items.map(a)}},dispose(){for(const g of E.values())g.get(w.id)?.clear();b?.dispose(),m.dispose()}},f)}d(D,w,f){return(d,m)=>{let p;if(m?.cacheResults){let b=this.c.get(D);b===void 0&&(b=new Map,this.c.set(D,b));const E=T(d);p=b.get(E),p===void 0&&(p=new Map,b.set(E,p))}return b=>{const{iconPath:E,...g}=b,i=`${D}|${b.id??b.timestamp}`;p?.set(i,b);let l,o,a;b.iconPath&&(E instanceof k.ThemeIcon?a={id:E.id,color:E.color}:c.URI.isUri(E)?(l=E,o=E):{light:l,dark:o}=E);let s;return k.MarkdownString.isMarkdownString(g.tooltip)?s=A.MarkdownString.from(g.tooltip):(0,C.isString)(g.tooltip)?s=g.tooltip:k.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=A.MarkdownString.from(g.detail)):(0,C.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=g.detail),{...g,id:g.id??void 0,handle:i,source:D,command:b.command?w.toInternal(b.command,f):void 0,icon:l,iconDark:o,themeIcon:a,tooltip:s,accessibilityInformation:b.accessibilityInformation}}}}f(D,w){if(this.b.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this.a.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this.b.set(D.id,{provider:D,extension:w}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(D.id)?.clear();this.b.delete(D.id),this.a.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=L;function T(v){return v?.toString()}}),define(ye[275],Ce([1,0,6,17,2,5]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,C,L,T){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const v=T.schemes.find(D=>!k.a.has(D));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(C,L),this.b.$registerUriOpener(C,T.schemes,y,T.label),(0,c.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(y,C,L){const T=this.c.get(y);if(!T)throw new Error(`Unknown opener with id: ${y}`);const v=P.URI.revive(C);return T.canOpenExternalUri(v,L)}async $openUri(y,C,L){const T=this.c.get(y);if(!T)throw new Error(`Unknown opener id: '${y}'`);return T.openExternalUri(P.URI.revive(C.resolvedUri),{sourceUri:P.URI.revive(C.sourceUri)},L)}}e.ExtHostUriOpeners=k,k.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[276],Ce([1,0,5,2,6,9,26]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(C,L){if(this.c.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const T=A.a++;return this.c.add(k.ExtensionIdentifier.toKey(C)),this.d.set(T,L),this.b.$registerUriHandler(T,C),(0,P.toDisposable)(()=>{this.c.delete(k.ExtensionIdentifier.toKey(C)),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(C,L){const T=this.d.get(C);if(!T)return Promise.resolve(void 0);try{T.handleUri(t.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[79],Ce([1,0,3,17,23,2,196,220,94,5]),function(te,e,c,t,P,R,k,A,y,C){"use strict";var L,T,v,D,w,f,d,m,p,b,E,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(I,F,K,q,M,B,O){L.set(this,void 0),T.set(this,void 0),v.set(this,void 0),D.set(this,void 0),w.set(this,void 0),f.set(this,void 0),d.set(this,""),m.set(this,void 0),p.set(this,!1),b.set(this,!1),E.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new c.Emitter),this._onDidDispose=Ue(this,i,"f").event,Je(this,L,I,"f"),Je(this,T,F,"f"),Je(this,m,K,"f"),Je(this,D,q,"f"),Je(this,w,M,"f"),Je(this,f,B,"f"),Je(this,E,o(B),"f"),Je(this,g,a(B),"f"),Je(this,v,O,"f")}dispose(){Je(this,p,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(I){return Je(this,b,!0,"f"),(0,y.asWebviewUri)(I,Ue(this,D,"f"))}get cspSource(){const I=Ue(this,f,"f").extensionLocation;if(I.scheme===t.Schemas.https||I.scheme===t.Schemas.http){let F=I.toString();return F.endsWith("/")||(F+="/"),F+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,d,"f")}set html(I){this.a(),Ue(this,d,"f")!==I&&(Je(this,d,I,"f"),Ue(this,g,"f")&&!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(I)&&(Je(this,b,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,T,"f").$setHtml(Ue(this,L,"f"),this.b(I)))}get options(){return this.a(),Ue(this,m,"f")}set options(I){this.a(),P.equals(Ue(this,m,"f"),I)||Ue(this,T,"f").$setOptions(Ue(this,L,"f"),r(Ue(this,f,"f"),Ue(this,w,"f"),I)),Je(this,m,I,"f")}async postMessage(I){if(Ue(this,p,"f"))return!1;const F=(0,A.serializeWebviewMessage)(I,{serializeBuffersForPostMessage:Ue(this,E,"f")});return Ue(this,T,"f").$postMessage(Ue(this,L,"f"),F.message,...F.buffers)}a(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}b(I){if(!Ue(this,g,"f"))return I;const F=Ue(this,f,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,K=Ue(this,f,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,f,"f").extensionLocation.authority:void 0;return I.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,M,B,O,U,z)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),ue=(0,y.asWebviewUri)(j,{isRemote:F,authority:K}).toString();return`${M}${ue}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,M,B,O,U,z)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),ue=(0,y.asWebviewUri)(j,{isRemote:F,authority:K}).toString();return`${M}${ue}${z}`})}}e.ExtHostWebview=l,L=new WeakMap,T=new WeakMap,v=new WeakMap,D=new WeakMap,w=new WeakMap,f=new WeakMap,d=new WeakMap,m=new WeakMap,p=new WeakMap,b=new WeakMap,E=new WeakMap,g=new WeakMap,i=new WeakMap;function o(S){try{const I=(0,k.normalizeVersion)((0,k.parseVersion)(S.engines.vscode));return!!I&&I.majorBase>=1&&I.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function a(S){try{const I=(0,k.normalizeVersion)((0,k.parseVersion)(S.engines.vscode));return I?I.majorBase<1||I.majorBase===1&&I.minorBase<60:!1}catch{return!1}}class s{constructor(I,F,K,q,M){this.c=F,this.d=K,this.e=q,this.f=M,this.b=new Map,this.a=I.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(I,F,K){const q=this.g(I);if(q){const{message:M}=(0,A.deserializeWebviewMessage)(F,K.value);q._onMessageEmitter.fire(M)}}$onMissingCsp(I,F){this.e.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(I,F,K){const q=new l(I,this.a,n(F),this.c,this.d,K,this.f);return this.b.set(I,q),q._onDidDispose(()=>{this.b.delete(I)}),q}deleteWebview(I){this.b.delete(I)}g(I){return this.b.get(I)}}e.ExtHostWebviews=s;function u(S){return{id:S.identifier,location:S.extensionLocation}}e.toExtensionData=u;function r(S,I,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||h(S,I)}}e.serializeWebviewOptions=r;function n(S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots?.map(I=>R.URI.from(I))}}function h(S,I){return[...(I?.getWorkspaceFolders()||[]).map(F=>F.uri),S.extensionLocation]}}),define(ye[277],Ce([1,0,21,87,6,17,24,2,15,79,74,5,7]),function(te,e,c,t,P,R,k,A,y,C,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(l,o){this.document=l,this.b=o,this.a=1,this.c=new L.Cache("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,o){await this.f(l).undo(),o||this.disposeBackup()}async redo(l,o){await this.f(l).redo(),o||this.disposeBackup()}disposeEdits(l){for(const o of l)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=g(this.document.uri)+this.a++;return(0,k.joinPath)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const o=this.c.get(l,0);if(!o)throw new Error("No edit found");return o}}class w{constructor(){this.a=new Map}get(l,o){return this.a.get(this.b(l,o))}add(l,o,a){const s=this.b(l,o.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${l} resource:${o.uri}`);const u=new D(o,a);return this.a.set(s,u),u}delete(l,o){const a=this.b(l,o.uri);this.a.delete(a)}b(l,o){return`${l}@@@${o}`}}var f;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this.a=new Map}addTextProvider(l,o,a){return this.b(0,l,o,a)}addCustomProvider(l,o,a){return this.b(1,l,o,a)}get(l){return this.a.get(l)}b(l,o,a,s){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:l,extension:a,provider:s}),new v.Disposable(()=>this.a.delete(o))}}class m{constructor(l,o,a,s,u){this.d=o,this.f=a,this.g=s,this.h=u,this.b=new d,this.c=new w,this.a=l.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,o,a,s){const u=new P.DisposableStore;return b(a)?(u.add(this.b.addTextProvider(o,l,a)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(l),o,s.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(l))):(u.add(this.b.addCustomProvider(o,l,a)),p(a)&&u.add(a.onDidChangeCustomDocument(r=>{const n=this.i(o,r.document.uri);if(E(r)){const h=n.addEdit(r);this.a.$onDidEdit(r.document.uri,o,h,r.label)}else this.a.$onContentChange(r.document.uri,o)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(l),o,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(l))),v.Disposable.from(u,new v.Disposable(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(l,o,a,s,u){const r=this.b.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${o}'`);const n=A.URI.revive(l),h=await r.provider.openCustomDocument(n,{backupId:a,untitledDocumentData:s?.buffer},u);let S;return p(r.provider)&&this.f&&(S=this.f.workspaceValue(r.extension)??this.f.globalValue(r.extension)),this.c.add(o,h,S),{editable:p(r.provider)}}async $disposeCustomDocument(l,o){const a=this.b.get(o);if(!a)throw new Error(`No provider found for '${o}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${o}'`);const s=A.URI.revive(l),{document:u}=this.i(o,s);this.c.delete(o,u),u.dispose()}async $resolveCustomEditor(l,o,a,s,u,r){console.log("xxxx");const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);const h=y.ViewColumn.to(u),S=this.g.createNewWebview(o,s.contentOptions,n.extension),I=this.h.createNewWebviewPanel(o,a,s.title,h,s.options,S,!0),F=A.URI.revive(l);switch(n.type){case 1:{const{document:K}=this.i(a,F);return n.provider.resolveCustomEditor(K,I,r)}case 0:{const K=this.d.getDocument(F);return n.provider.resolveCustomTextEditor(K,I,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,o,a){this.i(o,l).disposeEdits(a)}async $onMoveCustomEditor(l,o,a){const s=this.b.get(a);if(!s)throw new Error(`No provider found for '${a}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const u=this.h.getWebviewPanel(l);if(!u)throw new Error("No webview found");const r=A.URI.revive(o),n=this.d.getDocument(r);await s.provider.moveCustomTextEditor(n,u,c.CancellationToken.None)}async $undo(l,o,a,s){return this.i(o,l).undo(a,s)}async $redo(l,o,a,s){return this.i(o,l).redo(a,s)}async $revert(l,o,a){const s=this.i(o,l);await this.j(o).revertCustomDocument(s.document,a),s.disposeBackup()}async $onSave(l,o,a){const s=this.i(o,l);await this.j(o).saveCustomDocument(s.document,a),s.disposeBackup()}async $onSaveAs(l,o,a,s){const u=this.i(o,l);return this.j(o).saveCustomDocumentAs(u.document,A.URI.revive(a),s)}async $backup(l,o,a){const s=this.i(o,l),r=await this.j(o).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},a);return s.updateBackup(r),r.id}i(l,o){const a=this.c.get(l,A.URI.revive(o));if(!a)throw new Error("No custom document found");return a}j(l){const a=this.b.get(l)?.provider;if(!a||!p(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=m;function p(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function E(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function g(i){const l=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(l)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[278],Ce([1,0,3,6,2,30,15,79,5,7]),function(te,e,c,t,P,R,k,A,y,C){"use strict";var L,T,v,D,w,f,d,m,p,b,E,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends t.Disposable{constructor(u,r,n,h){super(),L.set(this,void 0),T.set(this,void 0),v.set(this,void 0),D.set(this,void 0),w.set(this,void 0),f.set(this,void 0),d.set(this,void 0),m.set(this,void 0),p.set(this,!0),b.set(this,void 0),E.set(this,!1),g.set(this,this.B(new c.Emitter)),this.onDidDispose=Ue(this,g,"f").event,i.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Je(this,L,u,"f"),Je(this,T,r,"f"),Je(this,D,n,"f"),Je(this,v,h.viewType,"f"),Je(this,w,h.panelOptions,"f"),Je(this,m,h.viewColumn,"f"),Je(this,f,h.title,"f"),Je(this,b,h.active,"f")}dispose(){Ue(this,E,"f")||(Je(this,E,!0,"f"),Ue(this,g,"f").fire(),Ue(this,T,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,D,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,D,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,f,"f")}set title(u){this.c(),Ue(this,f,"f")!==u&&(Je(this,f,u,"f"),Ue(this,T,"f").$setTitle(Ue(this,L,"f"),u))}get iconPath(){return this.c(),Ue(this,d,"f")}set iconPath(u){this.c(),Ue(this,d,"f")!==u&&(Je(this,d,u,"f"),Ue(this,T,"f").$setIconPath(Ue(this,L,"f"),P.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Ue(this,w,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,m,"f")=="number"&&Ue(this,m,"f")<0))return Ue(this,m,"f")}get active(){return this.c(),Ue(this,b,"f")}get visible(){return this.c(),Ue(this,p,"f")}_updateViewState(u){Ue(this,E,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Je(this,b,u.active,"f"),Je(this,p,u.visible,"f"),Je(this,m,u.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(u,r){this.c(),Ue(this,T,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof u>"u"?void 0:k.ViewColumn.from(u),preserveFocus:!!r})}c(){if(Ue(this,E,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,v=new WeakMap,D=new WeakMap,w=new WeakMap,f=new WeakMap,d=new WeakMap,m=new WeakMap,p=new WeakMap,b=new WeakMap,E=new WeakMap,g=new WeakMap,i=new WeakMap;class o{static c(){return(0,R.generateUuid)()}constructor(u,r,n){this.g=r,this.h=n,this.e=new Map,this.f=new Map,this.d=u.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,r,n,h,S={}){const I=typeof h=="object"?h.viewColumn:h,F={viewColumn:k.ViewColumn.from(I),preserveFocus:typeof h=="object"&&!!h.preserveFocus},K=(0,A.shouldSerializeBuffersForPostMessage)(u),q=o.c();this.d.$createWebviewPanel((0,A.toExtensionData)(u),q,r,{title:n,panelOptions:a(S),webviewOptions:(0,A.serializeWebviewOptions)(u,this.h,S),serializeBuffersForPostMessage:K},F);const M=this.g.createNewWebview(q,S,u);return this.createNewWebviewPanel(q,r,n,I,S,M,!0)}$onDidChangeWebviewPanelViewStates(u){const r=Object.keys(u);r.sort((n,h)=>{const S=u[n],I=u[h];return S.active?1:I.active?-1:+S.visible-+I.visible});for(const n of r){const h=this.getWebviewPanel(n);if(!h)continue;const S=u[n];h._updateViewState({active:S.active,visible:S.visible,viewColumn:k.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,r,n){if(this.f.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.f.set(r,{serializer:n,extension:u}),this.d.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(u)}),new C.Disposable(()=>{this.f.delete(r),this.d.$unregisterSerializer(r)})}async $deserializeWebviewPanel(u,r,n,h){const S=this.f.get(r);if(!S)throw new Error(`No serializer found for '${r}'`);const{serializer:I,extension:F}=S,K=this.g.createNewWebview(u,n.webviewOptions,F),q=this.createNewWebviewPanel(u,r,n.title,h,n.panelOptions,K,n.active);await I.deserializeWebviewPanel(q,n.state)}createNewWebviewPanel(u,r,n,h,S,I,F){const K=new l(u,this.d,I,{viewType:r,title:n,viewColumn:h,panelOptions:S,active:F});return this.e.set(u,K),K}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=o;function a(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[279],Ce([1,0,3,6,79,15,5,7]),function(te,e,c,t,P,R,k,A){"use strict";var y,C,L,T,v,D,w,f,d,m,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends t.Disposable{constructor(i,l,o,a,s,u){super(),y.set(this,void 0),C.set(this,void 0),L.set(this,void 0),T.set(this,void 0),v.set(this,!1),D.set(this,void 0),w.set(this,void 0),f.set(this,void 0),d.set(this,void 0),m.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Ue(this,m,"f").event,p.set(this,this.B(new c.Emitter)),this.onDidDispose=Ue(this,p,"f").event,Je(this,L,o,"f"),Je(this,w,a,"f"),Je(this,y,i,"f"),Je(this,C,l,"f"),Je(this,T,s,"f"),Je(this,D,u,"f")}dispose(){Ue(this,v,"f")||(Je(this,v,!0,"f"),Ue(this,p,"f").fire(),Ue(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,w,"f")}set title(i){this.a(),Ue(this,w,"f")!==i&&(Je(this,w,i,"f"),Ue(this,C,"f").$setWebviewViewTitle(Ue(this,y,"f"),i))}get description(){return this.a(),Ue(this,f,"f")}set description(i){this.a(),Ue(this,f,"f")!==i&&(Je(this,f,i,"f"),Ue(this,C,"f").$setWebviewViewDescription(Ue(this,y,"f"),i))}get visible(){return Ue(this,D,"f")}get webview(){return Ue(this,T,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(i){i===Ue(this,D,"f")||Ue(this,v,"f")||(Je(this,D,i,"f"),Ue(this,m,"f").fire())}get badge(){return this.a(),Ue(this,d,"f")}set badge(i){this.a(),!(i?.value===Ue(this,d,"f")?.value&&i?.tooltip===Ue(this,d,"f")?.tooltip)&&(Je(this,d,R.ViewBadge.from(i),"f"),Ue(this,C,"f").$setWebviewViewBadge(Ue(this,y,"f"),i))}show(i){this.a(),Ue(this,C,"f").$show(Ue(this,y,"f"),!!i)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,C=new WeakMap,L=new WeakMap,T=new WeakMap,v=new WeakMap,D=new WeakMap,w=new WeakMap,f=new WeakMap,d=new WeakMap,m=new WeakMap,p=new WeakMap;class E{constructor(i,l){this.d=l,this.b=new Map,this.c=new Map,this.a=i.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,l,o,a){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:o,extension:i}),this.a.$registerWebviewViewProvider((0,P.toExtensionData)(i),l,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(i,l,o,a,s){const u=this.b.get(l);if(!u)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:n}=u,h=this.d.createNewWebview(i,{},n),S=new b(i,this.a,l,o,h,!0);this.c.set(i,S),await r.resolveWebviewView(S,{state:a},s)}async $onDidChangeWebviewViewVisibility(i,l){this.e(i)._setVisible(l)}async $disposeWebviewView(i){const l=this.e(i);this.c.delete(i),l.dispose(),this.d.deleteWebview(i)}e(i){const l=this.c.get(i);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=E}),define(ye[141],Ce([1,0,3,5,2,17,8,4,18]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class an{get state(){return this.d}constructor(T){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=T.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,v){let D;if(typeof T=="string"){D=T;try{T=P.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,k.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,D,v)}async asExternalUri(T,v){if((0,k.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this.b.$asExternalUri(T,v);return P.URI.from(D)}};C.a={focused:!0},C=qe([We(0,y.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[280],Ce([1,0,119,281,69,41,2,13,47]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(v,D,w){this.b=v,this.c=D,this.f=w,this.a=t.createServer((f,d)=>this.h(f,d)),this.g().catch(f=>(D.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,D){const w=(d,m)=>{D.writeHead(d,{"content-type":"application/json"}),D.end(JSON.stringify(m||null),p=>p&&this.c.error(p))},f=[];v.setEncoding("utf8"),v.on("data",d=>f.push(d)),v.on("end",async()=>{try{const d=JSON.parse(f.join(""));let m;switch(d.type){case"open":m=await this.i(d);break;case"openExternal":m=await this.j(d);break;case"status":m=await this.l(d);break;case"extensionManagement":m=await this.k(d);break;default:w(404,`Unknown message type: ${d.type}`);break}w(200,m)}catch(d){const m=d instanceof Error?d.message:JSON.stringify(d);w(500,m),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:D,folderURIs:w,forceNewWindow:f,diffMode:d,mergeMode:m,addMode:p,forceReuseWindow:b,gotoLineMode:E,waitMarkerFilePath:g,remoteAuthority:i}=v,l=[];if(Array.isArray(w))for(const u of w)try{l.push({folderUri:k.URI.parse(u)})}catch{}if(Array.isArray(D))for(const u of D)try{(0,y.hasWorkspaceFileExtension)(u)?l.push({workspaceUri:k.URI.parse(u)}):l.push({fileUri:k.URI.parse(u)})}catch{}const o=g?k.URI.file(g):void 0,s={forceNewWindow:f,diffMode:d,mergeMode:m,addMode:p,gotoLineMode:E,forceReuseWindow:b,preferNewWindow:!b&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",l,s),""}async j(v){for(const D of v.uris){const w=k.URI.parse(D),f=w.scheme==="file"?w:D;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const D=f=>f?.map(d=>/\.vsix$/i.test(d)?k.URI.parse(d):d),w={list:v.list,install:D(v.install),uninstall:D(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&P.existsSync(this.f)&&P.unlinkSync(this.f)}}e.CLIServerBase=C;let L=class extends C{constructor(v,D){super(v,D,(0,c.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,A.ILogService)],L),e.CLIServer=L}),define(ye[282],Ce([1,0,252,25,18]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let k=class extends c.AbstractExtHostConsoleForwarder{constructor(y,C){super(y,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,C,L){const T=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,T.write(`
START_NATIVE_LOG
`),C.apply(console,L),T.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,C){const L=process[y],T=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(D,w,f)=>{if(!this.g){v+=D.toString(w);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[C](v.slice(0,d)),v=v.slice(d+1))}T.call(L,D,w,f)}})}};k=qe([We(0,P.IExtHostRpcService),We(1,t.IExtHostInitDataService)],k),e.ExtHostConsoleForwarder=k}),define(ye[283],Ce([1,0,11,88,30,41,6,5,2,18]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends k.Disposable{constructor(v,D){super();const w=v.getProxy(A.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=y.URI.file((0,c.join)((0,t.tmpdir)(),(0,P.generateUuid)()));return await w.$download(f,d),d})}};L=qe([We(0,C.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[284],Ce([1,0,140,17,202,30]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class k extends c.ExtHostLoggerService{k(y,C,L){return y.scheme===t.Schemas.file?new P.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,C):super.k(y,C,L)}}e.ExtHostLoggerService=k}),define(ye[285],Ce([1,0,69,11,2,78,6,17,14,29]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const l=await super.g(i);if(l.scheme!==A.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const o=l.fsPath;let a=0;do{let s;a===0?s=o:s=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${a}`:`${o}-${a}`,await T(s);const u=t.join(s,"vscode.lock"),r=await f(this.d,u,!1);if(r)return this.i=r,process.on("exit",()=>{r.dispose()}),P.URI.file(s);a++}while(a<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(g){try{await C.Promises.stat(g);return}catch{}try{await C.Promises.mkdir(g,{recursive:!0})}catch{}}const v=1e3,D=10*60*1e3;class w extends k.Disposable{constructor(i,l){super(),this.b=i,this.c=l,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const o=await d(i,l);(!o||o.pid!==process.pid)&&(i.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await C.Promises.utimes(l,new Date,new Date)}catch(a){i.error(a),i.info(`Lock '${l}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+i};await C.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function f(g,i,l){try{const a={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(i,JSON.stringify(a),{flag:"wx"})}catch(a){g.error(a)}const o=await d(g,i);return!o||o.pid!==process.pid?l?(g.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),b(g,i)):(g.info(`Lock '${i}': Lock acquired.`),new w(g,i))}async function d(g,i){let l;try{l=await C.Promises.readFile(i)}catch(o){return g.error(o),null}try{return JSON.parse(String(l))}catch(o){return g.error(o),null}}async function m(g,i){let l;try{l=await C.Promises.stat(i)}catch(o){return g.error(o),0}return l.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function b(g,i){const l=await d(g,i);if(!l)return g.info(`Lock '${i}': Could not read pid of lock holder.`),E(g,i);if(l.willReleaseAt){let r=l.willReleaseAt-Date.now();if(r<5e3){for(r>0?g.info(`Lock '${i}': The lockfile is scheduled to be released in ${r} ms.`):g.info(`Lock '${i}': The lockfile is scheduled to have been released.`);r>0;){if(await(0,y.timeout)(Math.min(100,r)),await m(g,i)===0)return E(g,i);r=l.willReleaseAt-Date.now()}return E(g,i)}}if(!p(l.pid))return g.info(`Lock '${i}': The pid ${l.pid} appears to be gone.`),E(g,i);const o=await m(g,i),a=Date.now()-o;if(a<=D)return g.info(`Lock '${i}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;g.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const s=await m(g,i),u=Date.now()-s;return u<=D?(g.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(g.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),E(g,i))}async function E(g,i){g.info(`Lock '${i}': Deleting a stale lock.`);try{await C.Promises.unlink(i)}catch{}return f(g,i,!0)}}),define(ye[286],Ce([1,0,30,18,42]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends P.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,C){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:C})}createTerminalFromOptions(A,y){const C=new P.ExtHostTerminal(this.a,(0,c.generateUuid)(),A,A.name);return this.f.push(C),C.create(A,this.L(A,y)),C.value}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[287],Ce([1,0,5,18,184,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class p extends f.DisposableTunnel{}function b(r){const n=r.trim().split(`
`),h=[];return n.forEach(I=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(I);F&&F.length>=3&&h.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),h.reduce((I,F)=>(I[F.socket]=F,I),{})}e.getSockets=b;function E(...r){const n=[].concat(...r.map(i));return[...new Map(n.filter(h=>h.st==="0A").map(h=>{const S=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:g(S[0]),port:parseInt(S[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=E;function g(r){let n="";if(r.length===8)for(let h=r.length-2;h>=0;h-=2)n+=parseInt(r.substr(h,2),16),h!==0&&(n+=".");else for(let h=r.length-4;h>=0;h-=4)n+=parseInt(r.substr(h,4),16).toString(16),h!==0&&(n+=":");return n}function i(r){const n=r.trim().split(`
`),h=n.shift().trim().split(/\s+/).filter(I=>I!=="rx_queue"&&I!=="tm->when");return n.map(I=>I.trim().split(/\s+/).reduce((F,K,q)=>(F[h[q]||q]=K,F),{}))}e.loadConnectionTable=i;function l(r){return!!r.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||r.indexOf("out/server-main.js")!==-1||r.indexOf("_productName=VSCode")!==-1}function o(r){const n=r.trim().split(`
`),h=[];return n.forEach(S=>{const I=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);I&&I.length>=4&&h.push({pid:parseInt(I[1],10),ppid:parseInt(I[2]),cmd:I[3]})}),h}e.getRootProcesses=o;async function a(r,n,h){const S=h.reduce((F,K)=>(F[K.pid]=K,F),{}),I=[];return r.forEach(({socket:F,ip:K,port:q})=>{const M=n[F]?n[F].pid:void 0,B=M?S[M]?.cmd:void 0;M&&B&&!l(B)&&I.push({host:K,port:q,detail:B,pid:M})}),I}e.findPorts=a;function s(r,n,h){const S=new Map,I=o(n);for(const F of r){const K=h.get(F.port);if(K){S.set(F.port,K);continue}const q=I.find(M=>M.cmd.includes(`${F.port}`));if(q){let M=q,B;do B=I.find(O=>O.ppid===M.pid),B&&(M=B);while(B);S.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else S.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=s;let u=class extends R.Disposable{constructor(n,h,S){super(),this.n=S,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new w.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=n.getProxy(c.MainContext.MainThreadTunnelService),v.isLinux&&h.remote.isRemote&&h.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(n,h){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const S=await this.a.$openTunnel(h,n.displayName);if(S){const I=new p(S.remoteAddress,S.localAddress,()=>this.a.$closeTunnel(S.remoteAddress));return this.B(I),I}}async getTunnels(){return this.a.$getTunnels()}p(n){return Math.max(n*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(n,h){const S=this.r();return this.l.set(S,{selector:n,provider:h}),this.a.$registerPortsAttributesProvider(n,S),new T.Disposable(()=>{this.l.delete(S),this.a.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(n,h,S,I,F){const K=[];for(const M of n){const B=this.l.get(M);if(!B)return[];K.push(...await Promise.all(h.map(async O=>B.provider.providePortAttributes(O,S,I,F))))}const q=K.filter(M=>!!M);return q.length>0?q.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(n){if(n&&this.h)return;this.h=n;const h=new d.MovingAverage;let S;for(;this.h;){const I=new Date().getTime(),F=(await this.findCandidatePorts()).filter(q=>(0,f.isLocalhost)(q.host)||(0,f.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(q=>q.port).join(", ")}`);const K=new Date().getTime()-I;h.update(K),(!S||JSON.stringify(S)!==JSON.stringify(F))&&(S=F,await this.a.$onFoundNewCandidates(S)),await new Promise(q=>setTimeout(()=>q(),this.p(h.value)))}}async setTunnelFactory(n){if(n){if(n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.c=n.showCandidatePort,this.a.$setCandidateFilter()),n.tunnelFactory){this.b=n.tunnelFactory;let h=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const S=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:h}:void 0;this.a.$setTunnelProvider(S)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(n,h){if(this.f.has(n.host)){const S=this.f.get(n.host);S.has(n.port)&&(h&&S.get(n.port).disposeListener.dispose(),await S.get(n.port).tunnel.dispose(),S.delete(n.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(n,h){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this.b(n,h);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const I=await S;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(n.remoteAddress.host)||this.f.set(n.remoteAddress.host,new Map);const F=this.B(I.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(I.remoteAddress))));return this.f.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:I,disposeListener:F}),D.TunnelDtoConverter.fromApiTunnel(I)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(n){const h=await Promise.all(n.map(I=>this.c(I.host,I.port,I.detail??""))),S=n.filter((I,F)=>h[F]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(I=>I.port).join(", ")} to ${S.map(I=>I.port).join(", ")}`),S}async findCandidatePorts(){let n="",h="";try{n=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=E(n,h),I=await new Promise(z=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,ue,V)=>{z(ue)})}),F=b(I),K=await L.Promises.readdir("/proc"),q=[];for(const z of K)try{const j=Number(z),ue=C.joinPath(A.URI.file("/proc"),z);if((await L.Promises.stat(ue.fsPath)).isDirectory()&&!isNaN(j)){const _=await L.Promises.readlink(C.joinPath(ue,"cwd").fsPath),J=await L.Promises.readFile(C.joinPath(ue,"cmdline").fsPath,"utf8");q.push({pid:j,cwd:_,cmd:J})}}catch{}const M=[],B=S.filter(z=>{const j=F[z.socket];return j||M.push(z),j}),O=a(B,F,q);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(j=>{(0,y.exec)("ps -F -A -l | grep root",(ue,V,_)=>{j(V)})});this.j=s(M,z,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then(z=>U?z.concat(U):z)}};u=qe([We(0,t.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,m.ILogService)],u),e.ExtHostTunnelService=u}),define(ye[288],Ce([1,0,14,22,21,9,3,6,114,246,58]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(S,I){try{return JSON.stringify(S,I)}catch{return"null"}}const D="$$ref$$",w={[D]:-1};class f{constructor(I,F){this.jsonString=I,this.referencedBuffers=F}}function d(S,I=null,F=!1){const K=[];return{jsonString:(F?v:JSON.stringify)(S,(M,B)=>{if(typeof B>"u")return w;if(typeof B=="object"){if(B instanceof t.VSBuffer){const O=K.push(B)-1;return{[D]:O}}if(I)return I(M,B)}return B}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=d;function m(S,I,F){return JSON.parse(S,(K,q)=>{if(q){const M=q[D];if(typeof M=="number")return I[M];if(F&&q.$mid===1)return F.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=m;function p(S,I){return JSON.stringify(S,I)}function b(S){return S?(I,F)=>F&&F.$mid===1?S.transformOutgoing(F):F:null}var E;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class a extends A.Disposable{constructor(I,F=null,K=null){super(),this[T]=!0,this.b=this.B(new k.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=F,this.g=K,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,M=L.ProxyIdentifier.count;q<M;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(I=>{this.s[I].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(I){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(I){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(I){this.t!==I&&(this.t=I,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(I){return this.g?(0,y.transformIncomingURIs)(I,this.g):I}getProxy(I){const{nid:F,sid:K}=I;return this.l[F]||(this.l[F]=this.F(F,K)),this.l[F]}F(I,F){const K={get:(q,M)=>(typeof M=="string"&&!q[M]&&M.charCodeAt(0)===36&&(q[M]=(...B)=>this.O(I,M,B)),M===o?F:q[M])};return new Proxy(Object.create(null),K)}set(I,F){return this.k[I.nid]=F,F}assertRegistered(I){for(let F=0,K=I.length;F<K;F++){const q=I[F];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(I){if(this.j)return;const F=I.byteLength,K=s.read(I,0),q=K.readUInt8(),M=K.readUInt32();switch(q){case 1:case 2:{let{rpcId:B,method:O,args:U}=r.deserializeRequestJSONArgs(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,q===2);break}case 3:case 4:{let{rpcId:B,method:O,args:U}=r.deserializeRequestMixedArgs(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,q===4);break}case 5:{this.f?.logIncoming(F,M,0,"ack"),this.z(M);break}case 6:{this.I(F,M);break}case 7:{this.J(F,M,void 0);break}case 9:{let B=r.deserializeReplyOKJSON(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(F,M,B);break}case 10:{const B=r.deserializeReplyOKJSONWithBuffers(K,this.g);this.J(F,M,B);break}case 8:{const B=r.deserializeReplyOKVSBuffer(K);this.J(F,M,B);break}case 11:{let B=r.deserializeReplyErrError(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(F,M,B);break}case 12:{this.L(F,M,void 0);break}default:console.error("received unexpected message"),console.error(I)}}H(I,F,K,q,M,B){this.f?.logIncoming(I,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(K)}.${q}(`,M);const O=String(F);let U,z;if(B){const ue=new P.CancellationTokenSource;M.push(ue.token),U=this.M(K,q,M),z=()=>ue.cancel()}else U=this.M(K,q,M),z=i;this.p[O]=z;const j=r.serializeAcknowledged(F);this.f?.logOutgoing(j.byteLength,F,1,"ack"),this.c.send(j),U.then(ue=>{delete this.p[O];const V=r.serializeReplyOK(F,ue,this.h);this.f?.logOutgoing(V.byteLength,F,1,"reply:",ue),this.c.send(V)},ue=>{delete this.p[O];const V=r.serializeReplyErr(F,ue);this.f?.logOutgoing(V.byteLength,F,1,"replyErr:",ue),this.c.send(V)})}I(I,F){this.f?.logIncoming(I,F,1,"receiveCancel");const K=String(F);this.p[K]?.()}J(I,F,K){this.f?.logIncoming(I,F,0,"receiveReply:",K);const q=String(F);if(!this.s.hasOwnProperty(q))return;const M=this.s[q];delete this.s[q],M.resolveOk(K)}L(I,F,K){this.f?.logIncoming(I,F,0,"receiveReplyErr:",K);const q=String(F);if(!this.s.hasOwnProperty(q))return;const M=this.s[q];delete this.s[q];let B;K&&(K.$isError?(B=new Error,B.name=K.name,B.message=K.message,B.stack=K.stack):B=K),M.resolveErr(B)}M(I,F,K){try{return Promise.resolve(this.N(I,F,K))}catch(q){return Promise.reject(q)}}N(I,F,K){const q=this.k[I];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(I));const M=q[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(I));return M.apply(q,K)}O(I,F,K){if(this.j)return new C.CanceledLazyPromise;let q=null;if(K.length>0&&P.CancellationToken.isCancellationToken(K[K.length-1])&&(q=K.pop()),q&&q.isCancellationRequested)return Promise.reject(R.canceled());const M=r.serializeRequestArguments(K,this.h),B=++this.m,O=String(B),U=new C.LazyPromise;q&&q.onCancellationRequested(()=>{const j=r.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(r.serializeCancel(B))}),this.s[O]=U,this.y(B);const z=r.serializeRequest(B,I,F,M,!!q);return this.f?.logOutgoing(z.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(I)}.${F}(`,K),this.c.send(z),U}}e.RPCProtocol=a,T=l,a.a=3*1e3;class s{static alloc(I,F,K){const q=new s(t.VSBuffer.alloc(K+1+4),0);return q.writeUInt8(I),q.writeUInt32(F),q}static read(I,F){return new s(I,F)}get buffer(){return this.a}constructor(I,F){this.a=I,this.b=F}static sizeUInt8(){return 1}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+I).toString();return this.b+=I,K}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+I).toString();return this.b+=I,K}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+I);return this.b+=I,F}static sizeMixedArray(I){let F=0;F+=1;for(let K=0,q=I.length;K<q;K++){const M=I[K];switch(F+=1,M.type){case 1:F+=this.sizeLongString(M.value);break;case 2:F+=this.sizeVSBuffer(M.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let B=0;B<M.buffers.length;++B)F+=this.sizeVSBuffer(M.buffers[B]);break;case 4:break}}return F}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let F=0,K=I.length;F<K;F++){const q=I[F];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let M=0;M<q.buffers.length;++M)this.writeBuffer(q.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const F=new Array(I);for(let K=0;K<I;K++)switch(this.readUInt8()){case 1:F[K]=this.readLongString();break;case 2:F[K]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),B=this.readLongString(),O=[];for(let U=0;U<M;++U)O.push(this.readVSBuffer());F[K]=new L.SerializableObjectWithBuffers(m(B,O,null));break}case 4:F[K]=void 0;break}return F}}s.sizeUInt32=4;var u;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(u||(u={}));class r{static a(I){for(let F=0,K=I.length;F<K;F++)if(I[F]instanceof t.VSBuffer||I[F]instanceof L.SerializableObjectWithBuffers||typeof I[F]>"u")return!0;return!1}static serializeRequestArguments(I,F){if(this.a(I)){const K=[];for(let q=0,M=I.length;q<M;q++){const B=I[q];if(B instanceof t.VSBuffer)K[q]={type:2,value:B};else if(typeof B>"u")K[q]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=d(B.value,F);K[q]={type:3,value:t.VSBuffer.fromString(O),buffers:U}}else K[q]={type:1,value:t.VSBuffer.fromString(p(B,F))}}return{type:1,args:K}}return{type:0,args:p(I,F)}}static serializeRequest(I,F,K,q,M){switch(q.type){case 0:return this.b(I,F,K,q.args,M);case 1:return this.c(I,F,K,q.args,M)}}static b(I,F,K,q,M){const B=t.VSBuffer.fromString(K),O=t.VSBuffer.fromString(q);let U=0;U+=s.sizeUInt8(),U+=s.sizeShortString(B),U+=s.sizeLongString(O);const z=s.alloc(M?2:1,I,U);return z.writeUInt8(F),z.writeShortString(B),z.writeLongString(O),z.buffer}static deserializeRequestJSONArgs(I){const F=I.readUInt8(),K=I.readShortString(),q=I.readLongString();return{rpcId:F,method:K,args:JSON.parse(q)}}static c(I,F,K,q,M){const B=t.VSBuffer.fromString(K);let O=0;O+=s.sizeUInt8(),O+=s.sizeShortString(B),O+=s.sizeMixedArray(q);const U=s.alloc(M?4:3,I,O);return U.writeUInt8(F),U.writeShortString(B),U.writeMixedArray(q),U.buffer}static deserializeRequestMixedArgs(I){const F=I.readUInt8(),K=I.readShortString(),q=I.readMixedArray(),M=new Array(q.length);for(let B=0,O=q.length;B<O;B++){const U=q[B];typeof U=="string"?M[B]=JSON.parse(U):M[B]=U}return{rpcId:F,method:K,args:M}}static serializeAcknowledged(I){return s.alloc(5,I,0).buffer}static serializeCancel(I){return s.alloc(6,I,0).buffer}static serializeReplyOK(I,F,K){if(typeof F>"u")return this.d(I);if(F instanceof t.VSBuffer)return this.e(I,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:M}=d(F.value,K,!0);return this.g(I,q,M)}else return this.f(I,v(F,K))}static d(I){return s.alloc(7,I,0).buffer}static e(I,F){let K=0;K+=s.sizeVSBuffer(F);const q=s.alloc(8,I,K);return q.writeVSBuffer(F),q.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,F){const K=t.VSBuffer.fromString(F);let q=0;q+=s.sizeLongString(K);const M=s.alloc(9,I,q);return M.writeLongString(K),M.buffer}static g(I,F,K){const q=t.VSBuffer.fromString(F);let M=0;M+=s.sizeUInt32,M+=s.sizeLongString(q);for(const O of K)M+=s.sizeVSBuffer(O);const B=s.alloc(10,I,M);B.writeUInt32(K.length),B.writeLongString(q);for(const O of K)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(I){const F=I.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(I,F){const K=I.readUInt32(),q=I.readLongString(),M=[];for(let B=0;B<K;++B)M.push(I.readVSBuffer());return new L.SerializableObjectWithBuffers(m(q,M,F))}static serializeReplyErr(I,F){const K=F?v(R.transformErrorForSerialization(F),null):void 0;if(typeof K!="string")return this.h(I);const q=t.VSBuffer.fromString(K);let M=0;M+=s.sizeLongString(q);const B=s.alloc(11,I,M);return B.writeLongString(q),B.buffer}static deserializeReplyErrError(I){const F=I.readLongString();return JSON.parse(F)}static h(I){return s.alloc(12,I,0).buffer}}var n;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(n||(n={}));var h;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(h||(h={}))}),define(ye[289],Ce([1,0,3,33,54,4,40,9,14]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new P.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new P.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new P.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(f=>w.push(f)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new L);function T(D,w,f,d,m){return(0,y.createCancelablePromise)(async p=>{await(0,k.whenProviderRegistered)(f,d);const b=t.Registry.as(e.Extensions.OutputChannels);try{await v(f,1,d,m,p),b.registerChannel({id:D,label:w,file:f,log:!0})}catch(E){(0,A.isCancellationError)(E)||m.error("Error while registering log channel",f.toString(),(0,A.getErrorMessage)(E))}})}e.registerLogChannel=T;async function v(D,w,f,d,m){if(!await f.exists(D)){if(m.isCancellationRequested)throw new A.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",D.toString()),await(0,y.timeout)(1e3,m),await v(D,w+1,f,d,m)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new P.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,4,18,26,13,289,77,25,48,157,22,10,40,3,6]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class m extends k.AbstractMessageLogger{get disposed(){return this.l}constructor(g,i,l,o,a){super(),this.id=g,this.name=i,this.m=l,this.n=o,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const i=this.k;this.info(g),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(g,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:i))}hide(){this.n.$close(this.id)}g(g,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,k.log)(this.m,g,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends m{appendLine(g){this.append(g)}}let b=class{constructor(g,i,l,o,a,s){this.i=i,this.j=l,this.k=o,this.l=a,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[i,l]of this.g)l.visible=i===this.h}createOutputChannel(g,i,l){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const o=typeof i=="object"&&i.log,a=(0,D.isString)(i)?i:void 0;if((0,D.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const u=this.i.environment.extensionLogLevel?.find(([n])=>R.ExtensionIdentifier.equals(l.identifier,n))?.[1];u&&(s=(0,k.parseLogLevel)(u));const r=o?this.o(g,s,l):this.n(g,a,l);return r.then(n=>{this.g.set(n.id,n),n.visible=n.id===this.h}),o?this.r(g,s??this.m.getLevel(),r):this.q(g,r)}async n(g,i,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,a=this.k.extUri.joinPath(o,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(g,a,!1,i,l.identifier.value);return new m(u,g,s,this.a,l)}async o(g,i,l){const o=await this.p(l),a=this.k.extUri.joinPath(o,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(a,{name:g},i),u=await this.a.$register(g,a,!0,void 0,l.identifier.value);return new p(u,g,s,this.a,l)}p(g){let i=this.d.get(g.identifier.value);if(!i){const l=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(l)}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}return l})())}return i}q(g,i){let l=!1;const o=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return g},append(a){o(),i.then(s=>s.append(a))},appendLine(a){o(),i.then(s=>s.appendLine(a))},clear(){o(),i.then(a=>a.clear())},replace(a){o(),i.then(s=>s.replace(a))},show(a,s){o(),i.then(u=>u.show(a,s))},hide(){o(),i.then(a=>a.hide())},dispose(){l=!0,i.then(a=>a.dispose())}}}r(g,i,l){const o=new d.DisposableStore,a=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},s=o.add(new f.Emitter);function u(r){i=r,s.fire(r)}return l.then(r=>{o.add(r),r.logLevel!==i&&u(r.logLevel),o.add(r.onDidChangeLogLevel(n=>u(n)))}),{...this.q(g,l),get logLevel(){return i},onDidChangeLogLevel:s.event,trace(r,...n){a(),l.then(h=>h.trace(r,...n))},debug(r,...n){a(),l.then(h=>h.debug(r,...n))},info(r,...n){a(),l.then(h=>h.info(r,...n))},warn(r,...n){a(),l.then(h=>h.warn(r,...n))},error(r,...n){a(),l.then(h=>h.error(r,...n))},dispose(){o.dispose()}}}};b=qe([We(0,P.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,k.ILoggerService),We(5,k.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[290],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(ye[291],Ce([1,0,32,17,11,12,24,2,4,216,47,233,290]),function(te,e,c,t,P,R,k,A,y,C,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class cn{constructor(f,d,m,p){this.d=f,this.e=d,this.f=m,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??f})()}hasValidBasename(f,d,m){return typeof d=="string"||typeof d>"u"?this.a.then(p=>this.h(f,p,d)):this.h(f,d,m)}h(f,d,m){return f.scheme===t.Schemas.file||f.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(m??(0,k.basename)(f),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,C.getVirtualWorkspaceScheme)(d.getWorkspace());if(m)return m;const p=d.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:t.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?P.win32:P.posix)}async fileURI(f){let d="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const p=f.indexOf("/",2);p===-1?(d=f.substring(2),f="/"):(d=f.substring(2,p),f=f.substring(p)||"/")}return A.URI.from({scheme:t.Schemas.file,authority:d,path:f,query:"",fragment:""})}};D=qe([We(1,v.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],D),e.AbstractPathService=D}),define(ye[80],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(k,A){this.line=k,this.character=A}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,A){return new c(0,0)}with(k){return new c(0,0)}}e.Position=c;class t{constructor(k,A,y,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(k,A),this.end=new c(y,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var P;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(P=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,16,39,23,32,8,4,11,9,80,14]),function(te,e,c,t,P,R,k,A,y,C,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",D=" characters skipped \u27EB",w=(v.length+D.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var f;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function m(J){return!!J.preview}e.resultIsMatch=m;function p(J){return!!J.resource}e.isFileMatch=p;function b(J){return!!J.message}e.isProgressMessage=b;var E;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=g;class i{constructor(ie,ee,X){this.ranges=ee;const G=Array.isArray(ee)?ee:[ee];if(X&&X.matchLines===1&&l(G)){ie=(0,k.getNLines)(ie,X.matchLines);let de="",be=0,Ee=0;const Pe=Math.floor(X.charsPerLine/5),Fe=[];for(const se of G){const oe=Math.max(se.startColumn-Pe,0),fe=se.startColumn+X.charsPerLine;if(oe>Ee+Pe+w){const Z=v+(oe-Ee)+D;de+=Z+ie.slice(oe,fe),be+=oe-(Ee+Z.length)}else de+=ie.slice(Ee,fe);Fe.push(new a(0,se.startColumn-be,se.endColumn-be)),Ee=fe}this.preview={text:de,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const de=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ie,matches:(0,c.mapArrayOrNot)(ee,be=>new o(be.startLineNumber-de,be.startColumn,be.endLineNumber-de,be.endColumn))}}}}e.TextSearchMatch=i;function l(J){const ie=J[0].startLineNumber;for(const ee of J)if(ee.startLineNumber!==ie||ee.endLineNumber!==ie)return!1;return!0}class o{constructor(ie,ee,X,G){this.startLineNumber=ie,this.startColumn=ee,this.endLineNumber=X,this.endColumn=G}}e.SearchRange=o;class a extends o{constructor(ie,ee,X){super(ie,ee,ie,X)}}e.OneLineRange=a;var s;(function(J){J.List="list",J.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var u;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function r(J,ie=!0){const ee=J&&J.files&&J.files.exclude,X=ie&&J&&J.search&&J.search.exclude;if(!ee&&!X)return;if(!ee||!X)return ee||X;let G=Object.create(null);return G=P.mixin(G,P.deepClone(ee)),G=P.mixin(G,P.deepClone(X),!0),G}e.getExcludes=r;function n(J,ie){return J.excludePattern&&t.match(J.excludePattern,ie)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&t.match(J.includePattern,ie)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ee=>{const X=ee.folder.fsPath;if(R.isEqualOrParent(ie,X)){const G=y.relative(X,ie);return!ee.includePattern||!!t.match(ee.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var h;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(ie,ee){super(ie),this.code=ee}}e.SearchError=S;function I(J){const ie=J.message;if((0,C.isCancellationError)(J))return new S(ie,h.canceled);try{const ee=JSON.parse(ie);return new S(ee.message,ee.code)}catch{return new S(ie,h.other)}}e.deserializeSearchError=I;function F(J){const ie={message:J.message,code:J.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=F;function K(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=K;function q(J){return J.type==="success"}e.isSerializedSearchSuccess=q;function M(J){return!!J.path}e.isSerializedFileMatch=M;function B(J,ie){const ee=J.searchPath?J.searchPath:J.relativePath;return(0,k.fuzzyContains)(ee,ie)}e.isFilePatternMatch=B;class O{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(J,ie){const ee={...J||{},...ie||{}};return Object.keys(ee).filter(X=>{const G=ee[X];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=U;class z{constructor(ie,ee){this.c=null,this.a={...ie.excludePattern||{},...ee.excludePattern||{}},this.b=t.parse(this.a);let X=ie.includePattern;ee.includePattern&&(X?X={...X,...ee.includePattern}:X=ee.includePattern),X&&(this.c=t.parse(X))}matchesExcludesSync(ie,ee,X){return!!(this.b&&this.b(ie,ee,X))}includedInQuerySync(ie,ee,X){return!(this.b&&this.b(ie,ee,X)||this.c&&!this.c(ie,ee,X))}includedInQuery(ie,ee,X){const G=this.b(ie,ee,X),de=()=>this.c?!!this.c(ie,ee,X):!0;return(0,T.isThenable)(G)?G.then(be=>be?!1:de()):de()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=z;function j(J){for(const ie in J)if(typeof J[ie]!="boolean")return!0;return!1}function ue(J){if(!J)return;let ie;return ee=>(ie||(ie=(J()||Promise.resolve([])).then(X=>X?_(X):{})),ie.then(X=>!!X[ee]))}e.hasSiblingPromiseFn=ue;function V(J){if(!J)return;let ie;return ee=>{if(!ie){const X=J();ie=X?_(X):{}}return!!ie[ee]}}e.hasSiblingFn=V;function _(J){const ie={};for(const ee of J)ie[ee]=!0;return ie}}),define(ye[34],Ce([1,0,16,14,21,3,6,67,17,102,24,8,10,2,182,4,13,203,47,48,25,18,15,7,56,31,5]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g,i,l,o,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(q,M,B){return new L.ExtUri(O=>S(O,B)).isEqual(q,M)}function r(q,M,B){return u(q.uri,M.uri,B)?0:(0,T.compare)(q.uri.toString(),M.uri.toString())}function n(q,M,B){return q.index!==M.index?q.index<M.index?-1:1:u(q.uri,M.uri,B)?(0,T.compare)(q.name,M.name):(0,T.compare)(q.uri.toString(),M.uri.toString())}function h(q,M,B,O){const U=q.slice(0).sort((j,ue)=>B(j,ue,O)),z=M.slice(0).sort((j,ue)=>B(j,ue,O));return(0,c.delta)(U,z,(j,ue)=>B(j,ue,O))}function S(q,M){const B=M.getCapabilities(q.scheme);return!(B&&B&1024)}class I extends p.Workspace{static toExtHostWorkspace(M,B,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:ue,configuration:V,transient:_,isUntitled:J}=M,ie=[],ee=B;B?ue.forEach((be,Ee)=>{const Pe=D.URI.revive(be.uri),Fe=I.e(O||B,Pe,U);Fe?(Fe.name=be.name,Fe.index=be.index,ie.push(Fe)):ie.push({uri:Pe,name:be.name,index:Ee})}):ie.push(...ue.map(({uri:be,name:Ee,index:Pe})=>({uri:D.URI.revive(be),name:Ee,index:Pe}))),ie.sort((be,Ee)=>be.index<Ee.index?-1:1);const X=new I(z,j,ie,!!_,V?D.URI.revive(V):null,!!J,be=>S(be,U)),{added:G,removed:de}=h(ee?ee.workspaceFolders:[],X.workspaceFolders,r,U);return{workspace:X,added:G,removed:de}}static e(M,B,O){for(let U=0;U<M.folders.length;U++){const z=M.workspaceFolders[U];if(u(z.uri,B,O))return z}}constructor(M,B,O,U,z,j,ue){super(M,O.map(V=>new p.WorkspaceFolder(V)),U,z,ue),this.s=B,this.t=j,this.o=[],this.q=A.TernarySearchTree.forUris(ue),O.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(M,B){return B&&this.q.get(M)&&(M=(0,L.dirname)(M)),this.q.findSubstr(M)}resolveWorkspaceFolder(M){return this.q.get(M)}}let F=class{constructor(M,B,O,U,z){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new R.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=U,this.q=O,this.s=z,this.h=new C.Counter,this.j=new t.Barrier,this.n=M.getProxy(s.MainContext.MainThreadWorkspace),this.o=M.getProxy(s.MainContext.MainThreadMessageService);const j=B.workspace;this.k=j?new I(j.id,j.name,[],!!j.transient,j.configuration?D.URI.revive(j.configuration):null,!!j.isUntitled,ue=>S(ue,O)):void 0}$initializeWorkspace(M,B){this.u=B,this.$acceptWorkspaceData(M),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?D.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(M,B,O,...U){const z=[];if(Array.isArray(U)&&U.forEach(J=>{D.URI.isUri(J.uri)&&!z.some(ie=>u(ie.uri,J.uri,this.q))&&z.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.l||[B,O].some(J=>typeof J!="number"||J<0)||O===0&&z.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if(B+O>j.length)return!1;const ue=j.slice(0);ue.splice(B,O,...z.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ue.length;J++){const ie=ue[J];if(ue.some((ee,X)=>X!==J&&u(ie.uri,ee.uri,this.q)))return!1}ue.forEach((J,ie)=>J.index=ie);const{added:V,removed:_}=h(j,ue,n,this.q);if(V.length===0&&_.length===0)return!1;if(this.n){const J=M.displayName||M.name;this.n.$updateWorkspaceFolders(J,B,O,z).then(void 0,ie=>{this.l=void 0;const ee={source:{identifier:M.identifier,label:M.displayName||M.name}};this.o.$showMessage(m.Severity.Error,(0,w.localize)(0,null,J,ie.toString()),ee,[])})}return this.x(ue),!0}getWorkspaceFolder(M,B){if(!!this.w)return this.w.getWorkspaceFolder(M,B)}async getWorkspaceFolder2(M,B){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(M,B)}async resolveWorkspaceFolder(M){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(M)}getPath(){if(!this.w)return;const{folders:M}=this.w;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,B){let O,U="";if(typeof M=="string"?(O=D.URI.file(M),U=M):typeof M<"u"&&(O=M,U=M.fsPath),!O)return U;const z=this.getWorkspaceFolder(O,!0);if(!z)return U;typeof B>"u"&&this.w&&(B=this.w.folders.length>1);let j=(0,L.relativePath)(z.uri,O);return B&&z.name&&(j=`${z.name}/${j}`),j}x(M){this.w&&(this.l=I.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:M,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:B,added:O,removed:U}=I.toExtHostWorkspace(M,this.k,this.l,this.q);this.k=B||void 0,this.l=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(M,B,O,U,z=P.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:V}=K(i.GlobPattern.from(M));return this.n.$startFileSearch((0,v.withUndefinedAsNull)(ue),(0,v.withUndefinedAsNull)(V),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(O),z).then(_=>Array.isArray(_)?_.map(J=>D.URI.revive(J)):[])}async findTextInFiles(M,B,O,U,z=P.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),ue=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:V,folder:_}=K(i.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ie={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ue,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:V,excludePattern:J},ee=!1;if(this.t[j]=X=>{if(ee)return;const G=D.URI.revive(X.resource);X.results.forEach(de=>{(0,a.resultIsMatch)(de)?O({uri:G,preview:{text:de.preview.text,matches:(0,c.mapArrayOrNot)(de.preview.matches,be=>new l.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,c.mapArrayOrNot)(de.ranges,be=>new l.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):O({uri:G,text:de.text,lineNumber:de.lineNumber})})},z.isCancellationRequested)return{};try{const X=await this.n.$startTextSearch(M,(0,v.withUndefinedAsNull)(_),ie,j,z);return delete this.t[j],X||{}}catch(X){throw delete this.t[j],X}}$handleTextSearchResult(M,B){this.t[B]?.(M)}saveAll(M){return this.n.$saveAll(M)}resolveProxy(M){return this.n.$resolveProxy(M)}get trusted(){return this.u}requestWorkspaceTrust(M){return this.n.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(M,B){if(this.v.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.v.set(M,B);const O=this.s.transformOutgoingScheme(M),U=this.y++;return this.n.$registerEditSessionIdentityProvider(U,O),(0,k.toDisposable)(()=>{this.v.delete(M),this.n.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(M,B){this.g.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(D.URI.revive(M));if(!O){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.v.get(O.uri.scheme);if(this.g.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(O,B);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(M,B,O,U){this.g.info("Getting edit session identifier for workspaceFolder",M);const z=await this.resolveWorkspaceFolder(D.URI.revive(M));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const ue=await j.provideEditSessionIdentityMatch?.(B,O,U);if(this.g.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}};F=qe([We(0,g.IExtHostRpcService),We(1,E.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,o.IURITransformerService)],F),e.ExtHostWorkspace=F,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function K(q){let M,B;return q&&(typeof q=="string"?M=q:(M=q.pattern,B=D.URI.revive(q.baseUri))),{includePattern:M,folder:B}}}),define(ye[35],Ce([1,0,23,3,34,5,7,206,127,10,14,4,18,13,2]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(l,o){if(o){const a=o.split(".");let s=l;for(let u=0;s&&u<a.length;u++)s=s[a[u]];return s}}function d(l){return l instanceof w.URI}function m(l){return l&&l.uri instanceof w.URI&&l.languageId&&typeof l.languageId=="string"}function p(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function b(l){return l&&l.uri instanceof w.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function E(l){if(d(l))return{resource:l};if(m(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(p(l))return{overrideIdentifier:l.languageId};if(b(l))return{resource:l.uri};if(l===null)return{resource:null}}let g=class{constructor(o,a,s){this.a=o.getProxy(R.MainContext.MainThreadConfiguration),this.c=a,this.b=s,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new i(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,a){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,a))}};g=qe([We(0,v.IExtHostRpcService),We(1,P.IExtHostWorkspace),We(2,D.ILogService)],g),e.ExtHostConfiguration=g;class i{constructor(o,a,s,u){this.a=new t.Emitter,this.b=o,this.f=u,this.c=a,this.e=A.Configuration.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,a){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(a,s))}getConfiguration(o,a,s){const u=E(a)||{},r=this.g(o?f(this.e.getValue(void 0,u,this.c.workspace),o):this.e.getValue(void 0,u,this.c.workspace));o&&this.h(o,u,s?.identifier);function n(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case k.ConfigurationTarget.Global:return 2;case k.ConfigurationTarget.Workspace:return 5;case k.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(S){return typeof f(r,S)<"u"},get:(S,I)=>{this.h(o?`${o}.${S}`:S,u,s?.identifier);let F=f(r,S);if(typeof F>"u")F=I;else{let K;const q=(M,B)=>{let O;const U=()=>{K=K||(0,c.deepClone)(r),O=O||f(K,B)};return(0,C.isObject)(M)?new Proxy(M,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(K)return O=O||f(K,B),O[j];const ue=z[j];return typeof j=="string"?q(ue,`${B}.${j}`):ue},set:(z,j,ue)=>(U(),O&&(O[j]=ue),!0),deleteProperty:(z,j)=>(U(),O&&delete O[j],!0),defineProperty:(z,j,ue)=>(U(),O&&Object.defineProperty(O,j,ue),!0)}):M};F=q(F,S)}return F},update:(S,I,F,K)=>{S=o?`${o}.${S}`:S;const q=n(F);return I!==void 0?this.b.$updateConfigurationOption(q,S,I,u,K):this.b.$removeConfigurationOption(q,S,u,K)},inspect:S=>{S=o?`${o}.${S}`:S;const I=this.e.inspect(S,u,this.c.workspace);if(I)return{key:S,defaultValue:(0,c.deepClone)(I.policy?.value??I.default?.value),globalValue:(0,c.deepClone)(I.user?.value??I.application?.value),workspaceValue:(0,c.deepClone)(I.workspace?.value),workspaceFolderValue:(0,c.deepClone)(I.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(I.default?.override),globalLanguageValue:(0,c.deepClone)(I.user?.override??I.application?.override),workspaceLanguageValue:(0,c.deepClone)(I.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(I.workspaceFolder?.override),languageIds:(0,c.deepClone)(I.overrideIdentifiers)}}};return typeof r=="object"&&(0,c.mixin)(h,r,!1),Object.freeze(h)}g(o){const a=s=>(0,C.isObject)(s)?new Proxy(s,{get:(u,r)=>a(u[r]),set:(u,r,n)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(u,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(u,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return a(o)}h(o,a,s){const u=y.OVERRIDE_PROPERTY_REGEX.test(o)?4:this.d.get(o),r=s?`[${s.value}] `:"";if(u===4){typeof a?.resource>"u"&&this.f.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){a?.resource&&this.f.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,a){const s=new A.ConfigurationChangeEvent(o,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,r)=>s.affectsConfiguration(u,E(r))})}k(o){return o.reduce((a,s)=>(a.set(s[0],s[1]),a),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[81],Ce([1,0,2,14,3,5,7,34,59,35,21,42,18,25,4,17,12,13,76,245,9]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(i||(i={}));var l;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(l||(l={}));var o;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(o||(o={}));var a;(function(M){function B(z){if(z){const j=z;return j&&!!j.process}else return!1}M.is=B;function O(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=o.from(z.options)),j}M.from=O;function U(z){if(z!=null)return new k.ProcessExecution(z.process,z.args,z.options)}M.to=U})(a||(a={}));var s;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(s||(s={}));var u;(function(M){function B(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}M.is=B;function O(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=s.from(z.options)),j}M.from=O;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new k.ShellExecution(z.commandLine,z.options):new k.ShellExecution(z.command,z.args?z.args:[],z.options)}M.to=U})(u||(u={}));var r;(function(M){function B(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}M.is=B;function O(z){return{customExecution:"customExecution"}}M.from=O;function U(z,j){return j.get(z)}M.to=U})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var n;(function(M){function B(O,U){let z;return O.scope!==void 0&&typeof O.scope!="number"?z=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===k.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:z}}M.from=B})(n=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(M){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}M.from=B})(h||(h={}));var S;(function(M){function B(z,j){if(z==null)return[];const ue=[];for(const V of z){const _=O(V,j);_&&ue.push(_)}return ue}M.fromMany=B;function O(z,j){if(z==null)return;let ue;z.execution instanceof k.ProcessExecution?ue=a.from(z.execution):z.execution instanceof k.ShellExecution?ue=u.from(z.execution):z.execution&&z.execution instanceof k.CustomExecution&&(ue=r.from(z.execution));const V=i.from(z.definition);let _;return z.scope?typeof z.scope=="number"?_=z.scope:_=z.scope.uri:_=k.TaskScope.Workspace,!V||!_?void 0:{_id:z._id,definition:V,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:_},execution:ue,isBackground:z.isBackground,group:h.from(z.group),presentationOptions:l.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}M.from=O;async function U(z,j,ue){if(z==null)return;let V;a.is(z.execution)?V=a.to(z.execution):u.is(z.execution)?V=u.to(z.execution):r.is(z.execution)&&(V=r.to(z._id,ue));const _=i.to(z.definition);let J;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?J=z.source.scope:J=await j.resolveWorkspaceFolder(c.URI.revive(z.source.scope)):J=k.TaskScope.Workspace),!_||!J)return;const ie=new k.Task(_,J,z.name,z.source.label,V,z.problemMatchers);return z.isBackground!==void 0&&(ie.isBackground=z.isBackground),z.group!==void 0&&(ie.group=k.TaskGroup.from(z.group._id),ie.group&&z.group.isDefault&&(ie.group=new k.TaskGroup(ie.group.id,ie.group.label),z.group.isDefault===!0&&(ie.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ie.presentationOptions=l.to(z.presentationOptions)),z._id&&(ie._id=z._id),z.detail&&(ie.detail=z.detail),ie}M.to=U})(S=e.TaskDTO||(e.TaskDTO={}));var I;(function(M){function B(U){return U}M.from=B;function O(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=O})(I||(I={}));class F{constructor(B,O,U){this._id=O,this.a=U,g.set(this,void 0),Je(this,g,B,"f")}get task(){return this.a}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}g=new WeakMap;let K=class{constructor(B,O,U,z,j,ue,V,_){this.q=new P.Emitter,this.r=new P.Emitter,this.s=new P.Emitter,this.t=new P.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=z,this.d=j,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,U){if(!U)return new k.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:O,provider:U,extension:B}),this.a.$registerTaskProvider(z,O),new k.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(I.from(B)).then(async O=>{const U=[];for(const z of O){const j=await S.to(z,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(O,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],j=(0,t.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(ue=>this.u(O,z,U,ue));return new Promise(ue=>{j.then(V=>{Promise.all(z).then(()=>{ue(V)})})})}async $resolveTask(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await S.to(O,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(z,L.CancellationToken.None);if(!j)return;this.z(j,U);const ue=S.from(j,U.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(ue.execution)&&await this.x(ue,j,!0),await this.v(ue)}w(){return this.h++}async x(B,O,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,O.execution)),this.m.set(z,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new E.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get(B.id);if(U)return U;const z=new Promise((j,ue)=>{function V(_,J,ie){ie?j(new F(_,J.id,ie)):ue("Unexpected: Task does not exist.")}O?V(this,B,O):S.to(B.task,this.b,this.m).then(_=>V(this,B,_))});return this.l.set(B.id,z),z.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};K=qe([We(0,v.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,m.ILogService),We(7,p.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let q=class extends K{constructor(B,O,U,z,j,ue,V,_){super(B,O,U,z,j,ue,V,_),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=S.from(O,B);if(U===void 0)throw new Error("Task is not valid");if(r.is(U.execution))await this.x(U,O,!1);else throw new E.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),z}u(B,O,U,z){const j=[];if(z)for(const ue of z){this.z(ue,U),(!ue.definition||!B[ue.definition.type])&&this.f.warn(`The task [${ue.source}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`);const V=S.from(ue,U.extension);V&&r.is(V.execution)?(j.push(V),O.push(this.x(V,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v(B){if(r.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,U){}};q=qe([We(0,v.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,m.ILogService),We(7,p.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(ye[292],Ce([1,0,11,21,45,39,24,44,31]),function(te,e,c,t,P,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(v,D,w){this.k=v,this.l=D,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const D=this.k.folderQueries||[];return new Promise((w,f)=>{const d=m=>{this.f++,v(m)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(m=>{const p=m.toString(),b=c.basename(p);this.j&&this.j(p,b)||this.v(d,{base:m,basename:b})}),Promise.all(D.map(m=>this.p(m,d))).then(m=>{w({limitHit:this.e,stats:m[0]||void 0})},m=>{f(new Error((0,P.toErrorMessage)(m)))})})}async p(v,D){const w=new t.CancellationTokenSource,f=this.q(v),d=this.r(),m=new y.QueryGlobTester(this.k,v),p=!m.hasSiblingExcludeClauses();let b;try{this.h.add(w),b=A.StopWatch.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,w.token),g=b.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(E&&E.forEach(l=>{const o=c.posix.relative(v.folder.path,l.path);if(p){const a=c.basename(l.path);this.v(D,{base:v.folder,relativePath:o,basename:a});return}this.s(d,v.folder,o,D)}),this.g&&!this.e)?null:(this.u(d,m,D),{providerTime:g,postProcessTime:i.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(v){const D=(0,y.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),w=(0,y.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:w,includes:D,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},D,w,f){if(w===this.a){const m=c.basename(this.a);this.v(f,{base:D,relativePath:this.a,basename:m})}function d(m){const p=c.basename(m),b=c.dirname(m);let E=v[b];E||(E=v[b]=[],d(b)),E.push({base:D,relativePath:m,basename:p})}d(w)}u({rootEntries:v,pathToEntries:D},w,f){const d=this,m=this.a;function p(b){const E=(0,y.hasSiblingFn)(()=>b.map(g=>g.basename));for(let g=0,i=b.length;g<i;g++){const l=b[g],{relativePath:o,basename:a}=l;if(w.matchesExcludesSync(o,a,m!==a?E:void 0))continue;const s=D[o];if(s)p(s);else{if(o===m)continue;d.v(f,l)}if(d.e)break}}p(v)}v(v,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(D))}}class L{constructor(){this.b=new Map}fileSearch(v,D,w,f){const d=this.c(v.cacheKey),m=new C(v,D,d&&d.token);let p=0;const b=E=>{p+=E.length,w(E.map(g=>this.d(g)))};return this.e(m,L.a,b,f).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:E.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new t.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:k.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,D,w,f){f.onCancellationRequested(()=>{v.cancel()});const d=p=>{p&&(m.push(p),D>0&&m.length>=D&&(w(m),m=[]))};let m=[];return v.search(d).then(p=>(m.length&&w(m),p),p=>(m.length&&w(m),Promise.reject(p)))}}e.FileSearchManager=L,L.a=512}),define(ye[293],Ce([1,0,16,61,39,113,28,17,11,24,8,10,2,165,194,53,13,47,133,291,31]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(h,S,I,F,K){this.a=h,this.b=S,this.c=I,this.d=F,this.e=K}text(h,S,I={}){h=this.f(h,I);const F=this.a.getValue(),K=S&&S.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(S?.map(m.toWorkspaceFolder),I),type:2,contentPattern:h,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:F.search.usePCRE2||K||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(h,S){const I=this.a.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const F={...h,wordSeparators:I.editor.wordSeparators};return this.j(h,S)&&(F.isCaseSensitive=!0),this.k(h)&&(F.isMultiline=!0),F}file(h,S={}){return{...this.h(h,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(h,S){return h?(h=Array.isArray(h)?h.map(s):s(h),S?this.parseSearchPaths(h):{pattern:l(...Array.isArray(h)?h:[h])}):{}}h(h=[],S={}){const I=this.g(S.includePattern,S.expandPatterns),F=this.g(S.excludePattern,S.expandPatterns),K=h.length>1,q=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(O=>this.q(O,S,F)):h.map(O=>this.r(O,S,F,K))).filter(O=>!!O),M={_reason:S._reason,folderQueries:q,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:F.pattern,includePattern:I.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const O=c.coalesce(c.flatten(this.c.groups.map(j=>j.editors.map(ue=>ue.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(j=>(0,E.pathIncludedInQuery)(M,j.fsPath)),z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...M,...z}}const B=S.extraFileResources&&S.extraFileResources.filter(O=>(0,E.pathIncludedInQuery)(M,O.fsPath));return M.extraFileResources=B&&B.length?B:void 0,M}i(h){const S=[],I=new k.ResourceMap,F={};let K=!1;return h.forEach(q=>{if(q.scheme===A.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(q)){const B=this.b.getWorkspaceFolder(q)?.uri??q.with({path:y.dirname(q.fsPath)});let O=I.get(B);O||(K=!0,O={folder:B,includePattern:{}},S.push(O),I.set(B,O));const U=y.relative(B.fsPath,q.fsPath);(0,T.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else q.fsPath&&(K=!0,F[q.fsPath]=!0)}),{folderQueries:S,includePattern:F,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(h,S){if(S.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}k(h){return h.isMultiline||h.isRegExp&&(0,D.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const S=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(h)?h:o(h)).map(z=>{const j=this.e.resolvedUserHome;return j?(0,R.untildify)(z,j.scheme===A.Schemas.file?j.fsPath:j.path):z}),K=t.groupBy(F,z=>S(z)?"searchPaths":"exprSegments"),q=(K.exprSegments||[]).map(z=>L.rtrim(z,"/")).map(z=>L.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),a(z))),M={},B=this.m(K.searchPaths||[]);B&&B.length&&(M.searchPaths=B);const O=c.flatten(q),U=l(...O);return U&&(M.pattern=U),M}l(h,S){return S.disregardExcludeSettings?void 0:(0,E.getExcludes)(h,!S.disregardSearchExcludeSettings)}m(h){if(!h||!h.length)return[];const S=h.flatMap(F=>{let{pathPortion:K,globPortion:q}=i(F);return q&&(q=u(q)),this.n(K).flatMap(B=>this.o(B,q))}),I=new Map;return S.forEach(F=>{const K=F.searchPath.toString(),q=I.get(K);q?F.pattern&&(q.pattern=q.pattern||{},q.pattern[F.pattern]=!0):I.set(K,{searchPath:F.searchPath,pattern:F.pattern?l(F.pattern):void 0})}),Array.from(I.values())}n(h){if(y.isAbsolute(h)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==A.Schemas.file?[{searchPath:S[0].uri.with({path:h})}]:[{searchPath:v.URI.file(y.normalize(h))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(h=s(h),h.startsWith("../")||h===".."){const F=y.posix.resolve(S.path,h);return[{searchPath:S.with({path:F})}]}const I=u(h);return[{searchPath:S,pattern:I}]}else{if(h==="./"||h===".\\")return[];{const S=h.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(K=>{const q=S.match(new RegExp(`^${L.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return q?{match:q,folder:K}:null}).filter(T.isDefined);if(F.length)return F.map(K=>{const q=K.match[1];return{searchPath:K.folder.uri,pattern:q&&u(q)}});{const K=h.match(/\.[\/\\](.+)[\/\\]?/),q=K?K[1]:h,M=w.localize(0,null,q);throw new Error(M)}}}}o(h,S){const I=h.pattern&&S?`${h.pattern}/${S}`:h.pattern||S,F=[{searchPath:h.searchPath,pattern:I}];return I&&!I.endsWith("**")&&F.push({searchPath:h.searchPath,pattern:I+"/**"}),F}q(h,S,I){const F=this.r((0,m.toWorkspaceFolder)(h.searchPath),S,I,!1);return F?{...F,includePattern:h.pattern}:null}r(h,S,I,F){let K;const q=v.URI.isUri(h)?h:h.uri;if(I.searchPaths){const z=I.searchPaths.filter(j=>(0,C.isEqual)(j.searchPath,q))[0];if(z&&!z.pattern)return null;z&&(K=z.pattern)}const M=this.a.getValue({resource:q}),O={...this.l(M,S)||{},...K||{}},U=v.URI.isUri(h)?(0,C.basename)(h):h.name;return{folder:q,folderName:F?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!M.search.followSymlinks}}};g=qe([We(0,f.IConfigurationService),We(1,m.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,d.ILogService),We(4,b.IPathService)],g),e.QueryBuilder=g;function i(n){const h=n.match(/[\*\{\}\(\)\[\]\?]/);if(h){const S=h.index,I=n.substr(0,S).match(/[/|\\][^/\\]*$/);if(I){let F=n.substr(0,I.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:n.substr((I.index||0)+1)}}}return{pathPortion:n}}function l(...n){return n.length?n.reduce((h,S)=>(h[S]=!0,h),Object.create(null)):void 0}function o(n){return P.splitGlobAware(n,",").map(h=>h.trim()).filter(h=>!!h.length)}function a(n){return[`**/${n}/**`,`**/${n}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function s(n){return n.replace(/\\/g,"/")}function u(n){return s(n).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(n,h){n=c.distinct(n,F=>F.toString());const S=[],I=h.getWorkspace();return n&&n.forEach(F=>{let K;if(h.getWorkbenchState()===2)K=(0,C.relativePath)(I.folders[0].uri,F),K&&K!=="."&&(K="./"+K);else{const q=h.getWorkspaceFolder(F);if(q){const M=q.name;if(I.folders.filter(O=>O.name===M).length===1){const O=(0,C.relativePath)(q.uri,F);O===""?K=`./${q.name}`:K=`./${q.name}/${O}`}else K=F.fsPath}}K&&S.push(K)}),S}e.resolveResourcesForSearchIncludes=r}),define(ye[294],Ce([1,0,24,2,21,9,4,293,31,47]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(f,d){const m=d.activationEvents;if(!m)return Promise.resolve(void 0);const p=[],b=[];for(const a of m)if(/^workspaceContains:/.test(a)){const s=a.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||f.forceUsingSearch?b.push(s):p.push(s)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let E;const g=new Promise((a,s)=>{E=a}),i=a=>E({activationEvent:a}),l=Promise.all(p.map(a=>v(f,a,i))).then(()=>{}),o=D(f,d.identifier,b,i);return Promise.all([l,o]).then(()=>{E(void 0)}),g}e.checkActivateWorkspaceContainsExtension=T;async function v(f,d,m){for(const p of f.folders)if(await f.exists(c.joinPath(t.URI.revive(p),d))){m(`workspaceContains:${d}`);return}}async function D(f,d,m,p){if(m.length===0)return Promise.resolve(void 0);const b=new P.CancellationTokenSource,E=f.checkExists(f.folders,m,b.token),g=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},L);let i=!1;try{i=await E}catch(l){R.isCancellationError(l)||R.onUnexpectedError(l)}b.dispose(),clearTimeout(g),i&&p(`workspaceContains:${m.join(",")}`)}function w(f,d,m,p){const b=f.get(k.IInstantiationService),E=f.get(y.ISearchService),i=b.createInstance(A.QueryBuilder).file(d.map(l=>(0,C.toWorkspaceFolder)(t.URI.revive(l))),{_reason:"checkExists",includePattern:m,exists:!0});return E.fileSearch(i,p).then(l=>!!l.limitHit,l=>R.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=w});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(te,c):P?P.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[43],Ce([1,0,177,11,82,24,14,6,67,2,13,5,35,235,99,34,27,134,9,26,22,217,7,128,4,25,78,18,90,55,42,3,294,98,219,17,97,44]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g,i,l,o,a,s,u,r,n,h,S,I,F,K,q,M,B){"use strict";var O,U,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let j=class Ui extends A.Disposable{constructor(ee,X,G,de,be,Ee,Pe,Fe,se,oe,fe){super(),this.a=this.B(new S.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=G,this.f=Pe,this.j=de,this.k=be,this.l=Ee,this.m=se,this.p=oe,this.s=fe,this.t=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.w=new k.Barrier,this.y=new k.Barrier,this.z=new k.Barrier,this.C=new k.Barrier,this.F=new m.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new m.ExtensionDescriptionRegistry(_(this.F,Z)),this.G=new w.ExtHostStorage(this.g,this.l),this.H=new F.ExtHostSecretState(this.g),this.I=Fe,this.h=ee.createChild(new r.ServiceCollection([w.IExtHostStorage,this.G],[F.IExtHostSecretState,this.H])),this.J=this.B(new D.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,ne,N)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(ne),N)},actualActivateExtension:async(ce,ne)=>{if(m.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,ne),new D.HostExtension;const N=this.D.getExtensionDescription(ce);return this.Y(N,ne)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ee){p.onUnexpectedError(ee)}}async Q(){this.I.onWillDeactivateAll();let ee=[];try{ee=this.D.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.X(be))}catch{}await Promise.all(ee)}terminate(ee,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ee}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const G=this.Q();Promise.race([(0,k.timeout)(5e3),G]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(ee){return this.z.isOpen()?this.J.isActivated(ee):!1}async getExtension(ee){const X=await this.v.$getExtension(ee);let G;if(X?.browserNlsBundleUris){G={};for(const de of Object.keys(X.browserNlsBundleUris))G[de]=C.URI.revive(X.browserNlsBundleUris[de])}return X&&{...X,identifier:new b.ExtensionIdentifier(X.identifier.value),extensionLocation:C.URI.revive(X.extensionLocation),browserNlsBundleUris:G}}R(ee,X){return this.J.activateByEvent(ee,X)}S(ee,X){return this.J.activateById(ee,X)}activateByIdWithErrors(ee,X){return this.S(ee,X).then(()=>{const G=this.J.getActivatedExtension(ee);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ee=>this.D)}getExtensionExports(ee){return this.z.isOpen()?this.J.getActivatedExtension(ee).exports:null}async U(ee){if(ee.scheme!==q.Schemas.file)return ee;const X=await this.c.realpath(ee.fsPath);return C.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ee=>new J(ee))),this.L}async W(ee){const X=y.TernarySearchTree.forUris(G=>R.extUriBiasedIgnorePathCase.ignorePathCasing(G));return await Promise.all(ee.map(async G=>{if(this.ob(G)){const de=await this.U(G.extensionLocation);X.set(de,G)}})),X}X(ee){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ee))return X;const G=this.J.getActivatedExtension(ee);if(!G)return X;try{typeof G.module.deactivate=="function"&&(X=Promise.resolve(G.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${ee.value}':`),this.l.error(de)}try{(0,A.dispose)(G.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.l.error(de)}return X}async Y(ee,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ee.identifier):await this.v.$onWillActivateExtension(ee.identifier),this.ab(ee,X).then(G=>{const de=G.activationTimes;return this.v.$onDidActivateExtension(ee.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,X),this.Z(ee,X,"success",de),G},G=>{throw this.Z(ee,X,"failure"),G})}Z(ee,X,G,de){const be=ue(ee,X);this.u.$publicLog2("extensionActivationTimes",{...be,...de||{},outcome:G})}ab(ee,X){const G=ue(ee,X);this.u.$publicLog2("activatePlugin",G);const de=this.ob(ee);if(!de)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${ee.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const be=new D.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.pb(ee,(0,R.joinPath)(ee.extensionLocation,de),be),this.bb(ee)]).then(Ee=>(P.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Ui.cb(this.l,ee.identifier,Ee[0],Ee[1],be))).then(Ee=>(P.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),Ee))}bb(ee){const X=new g.ExtensionGlobalMemento(ee,this.G),G=new g.ExtensionMemento(ee.identifier.value,!1,this.G),de=new K.ExtensionSecrets(ee,this.H),be=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ee=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([X.whenReady,G.whenReady,this.I.whenReady]).then(()=>{const Pe=this;let Fe,se;const oe=(0,d.isProposedApiEnabled)(ee,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:G,secrets:de,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(ee.extensionLocation.fsPath,fe)},get storagePath(){return Pe.I.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Pe.I.globalValue(ee).fsPath},get logPath(){return t.join(Pe.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return C.URI.joinPath(Pe.f.logsLocation,ee.identifier.value)},get storageUri(){return Pe.I.workspaceValue(ee)},get globalStorageUri(){return Pe.I.globalValue(ee)},get extensionMode(){return be},get extension(){return Fe===void 0&&(Fe=new V(Pe,ee.identifier,ee,Ee,!1)),Fe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ee,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe.p.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!se){if(!oe)return;const fe=S.Event.buffer(S.Event.fromDOMEventEmitter(oe,"message",Z=>Z.data));oe.start(),se={onDidReceiveMessage:fe,postMessage:oe.postMessage.bind(oe)}}return se}})})}static cb(ee,X,G,de,be){return G=G||{activate:void 0,deactivate:void 0},this.db(ee,X,G,de,be).then(Ee=>new D.ActivatedExtension(!1,null,be.build(),G,Ee,de.subscriptions))}static db(ee,X,G,de,be){if(typeof G.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${X.value}`);const Ee=typeof global=="object"?global:self,Pe=G.activate.apply(Ee,[de]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Pe).then(Fe=>(be.activateResolveStop(),Fe))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(G)}eb(ee,X){this.S(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:X}).then(void 0,G=>{this.l.error(G)})}fb(){this.v.$setPerformanceMarks(P.getMarks());for(const ee of this.D.getAllExtensionDescriptions())if(ee.activationEvents)for(const X of ee.activationEvents)X==="onStartupFinished"&&this.eb(ee,X)}gb(){const ee=this.R("*",!0).then(void 0,be=>{this.l.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.hb(be.added)));const X=this.j.workspace?this.j.workspace.folders:[],G=this.hb(X),de=Promise.all([ee,G]).then(()=>{});return Promise.race([de,(0,k.timeout)(1e4)]).then(()=>{this.fb()}),de}hb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.ib(ee,X))).then(()=>{})}async ib(ee,X){if(this.isActivated(X.identifier))return;const G=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:ee.map(Ee=>Ee.uri),forceUsingSearch:G,exists:Ee=>this.c.exists(Ee.fsPath),checkExists:(Ee,Pe,Fe)=>this.t.$checkExists(Ee,Pe,Fe)},be=await(0,I.checkActivateWorkspaceContainsExtension)(de,X);if(!!be)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:be.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ee){throw console.error(ee),ee}}async jb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:X}=this.f.environment;if(!ee||!X)throw new Error(c.localize(0,null));const G=await this.pb(null,X,new D.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(c.localize(1,null,X.toString()));return new Promise((de,be)=>{const Ee=(se,oe)=>{se?be(se):de(typeof oe=="number"&&oe>0?1:0)},Pe=(0,R.originalFSPath)(X),Fe=G.run(Pe,Ee);Fe&&Fe.then&&Fe.then(()=>{de(0)}).catch(se=>{be(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,X){return this.M[ee]=X,(0,A.toDisposable)(()=>{delete this.M[ee]})}async lb(ee){const X=ee.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const G=ee.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this.M[G]}}async $resolveAuthority(ee,X){const G=B.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(ee)},${X})][${G.elapsed()}ms] `,be=oe=>this.l.info(`${de()}${oe}`),Ee=(oe,fe=void 0)=>this.l.error(`${de()}${oe}`,fe);be("activating resolver...");const{authorityPrefix:Pe,resolver:Fe}=await this.lb(ee);if(!Fe)return Ee("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Pe}.`,detail:void 0}};const se=new k.IntervalTimer;try{be("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Fe)),se.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),P.mark(`code/extHost/willResolveAuthority/${Pe}`);const oe=await Fe.resolve(ee,{resolveAttempt:X});P.mark(`code/extHost/didResolveAuthorityOK/${Pe}`),se.dispose(),be(`returned ${oe.host}:${oe.port}`);const fe={authority:ee,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Z={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:Z,tunnelInformation:{environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures}}}}catch(oe){if(P.mark(`code/extHost/didResolveAuthorityError/${Pe}`),se.dispose(),Ee("returned an error",oe),oe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(ee,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(ee)})`);const{resolver:G}=await this.lb(ee);if(!G)return null;const de=C.URI.revive(X);if(typeof G.getCanonicalURI>"u")return de;const be=await(0,k.asPromise)(()=>G.getCanonicalURI(de));return be||de}static mb(ee,X,G){const de=new m.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());de.deltaExtensions(G.toAdd,G.toRemove);const be=(0,d.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of G.myToRemove)be.delete(b.ExtensionIdentifier.toKey(Pe));for(const Pe of G.myToAdd)be.add(b.ExtensionIdentifier.toKey(Pe));const Ee=_(de,be);return{globalRegistry:de,myExtensions:Ee}}$startExtensionHost(ee){ee.toAdd.forEach(de=>de.extensionLocation=C.URI.revive(de.extensionLocation));const{globalRegistry:X,myExtensions:G}=Ui.mb(this.F,this.D,ee);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(G),this.kb()}$activateByEvent(ee,X){return X===1?this.R(ee,!1):this.z.wait().then(G=>this.R(ee,!1))}async $activate(ee,X){return await this.z.wait(),this.D.getExtensionDescription(ee)?(await this.S(ee,X),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(Ee=>Ee.extensionLocation=C.URI.revive(Ee.extensionLocation));const{globalRegistry:X,myExtensions:G}=Ui.mb(this.F,this.D,ee),de=await this.W(G);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(X.getAllExtensionDescriptions()),this.D.set(G),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const X=E.VSBuffer.alloc(ee),G=Math.random()%256;for(let de=0;de<ee;de++)X.writeUInt8(G,de);return X}async $updateRemoteConnectionData(ee){this.P=ee,this.a.fire()}};j=qe([We(0,o.IInstantiationService),We(1,e.IHostUtils),We(2,u.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,a.IExtHostInitDataService),We(7,s.IExtensionStoragePaths),We(8,n.IExtHostTunnelService),We(9,h.IExtHostTerminalService),We(10,M.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function ue(ie,ee){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class V{constructor(ee,X,G,de,be){O.set(this,void 0),U.set(this,void 0),z.set(this,void 0),Je(this,O,ee,"f"),Je(this,U,X,"f"),Je(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=t.normalize((0,R.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=de,this.isFromDifferentExtensionHost=be}get isActive(){return Ue(this,O,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,O,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,O,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,O=new WeakMap,U=new WeakMap,z=new WeakMap;function _(ie,ee){return ie.getAllExtensionDescriptions().filter(X=>ee.has(b.ExtensionIdentifier.toKey(X.identifier)))}class J{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.ExtensionPaths=J}),define(ye[295],Ce([1,0,82,2,5,35,27,26,18,25,4,43,37,13,8]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(g,i,l,o,a,s,u){this.c=g,this.d=i,this.e=l,this.f=o,this.g=a,this.h=s,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new m(this.c,i,this.d,g,this.i)),this.register(this.e.createInstance(p,i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const i of g.nodeModuleName)this.a.set(i,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(i=>g.alternativeModuleName(i))}};f=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,T.IExtHostExtensionService),We(5,C.IExtHostInitDataService),We(6,D.ILogService)],f),e.RequireInterceptor=f;let d=class rn{constructor(g){if(g.environment.appRoot&&rn.a.size){const i=(0,w.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),l="[a-z0-9_.-]",o=`@${l}+\\/${l}+|${l}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${a}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const i=this.b.exec(this.c(g));if(!i)return;const[,l,o,a]=i,s=rn.a.get(o);if(s!==void 0)return console.warn(`${o} as been renamed to ${s}, please update your imports`),l+s+a}c(g){return g.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,C.IExtHostInitDataService)],d);class m{constructor(g,i,l,o,a){this.c=g,this.d=i,this.e=l,this.f=o,this.g=a,this.nodeModuleName="vscode",this.a=new Map}load(g,i){const l=this.d.findSubstr(i);if(l){let o=this.a.get(A.ExtensionIdentifier.toKey(l.identifier));return o||(o=this.c(l,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(l.identifier),o)),o}if(!this.b){let o="";this.d.forEach((a,s)=>o+=`	${s} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${o}`),this.b=this.c(k.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(g,i,l){this.d=g,this.nodeModuleName="keytar",this.a=i.getProxy(P.MainContext.MainThreadTelemetry);const{environment:o}=l,a=i.getProxy(P.MainContext.MainThreadKeytar);if(o.appRoot){let s=o.appRoot.fsPath;v.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.b=new Set,this.b.add(`${s}/node_modules.asar/keytar`),this.b.add(`${s}/node_modules/keytar`)}this.c={getPassword:(s,u)=>a.$getPassword(s,u),setPassword:(s,u,r)=>a.$setPassword(s,u,r),deletePassword:(s,u)=>a.$deletePassword(s,u),findPassword:s=>a.$findPassword(s),findCredentials(s){return a.$findCredentials(s)}}}load(g,i){const l=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const i=g.length;if(i<=7||!this.b)return;const l=i-7;if((g.charAt(l)==="/"||g.charAt(l)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};p=qe([We(1,y.IExtHostRpcService),We(2,C.IExtHostInitDataService)],p);let b=class{constructor(g,i,l){this.e=g,this.f=i,this.nodeModuleName=["open","opn"],this.d=l.getProxy(P.MainContext.MainThreadTelemetry);const o=l.getProxy(P.MainContext.MainThreadWindow);this.c=(a,s)=>{const u=t.URI.parse(a);return s?this.g(a,s):u.scheme==="http"||u.scheme==="https"?o.$openUri(u,a,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?o.$openUri(u,a,{}):this.g(a,s)}}load(g,i,l){const o=this.e.findSubstr(i);return o&&(this.a=o.identifier.value,this.h()),this.b=l(g),this.c}g(g,i){return this.i(),this.b(g,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([We(2,y.IExtHostRpcService)],b)}),define(ye[49],Ce([1,0,65,6,11,37,4,59,60,43,7,34,231,35]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,k.createDecorator)("IExtHostVariableResolverProvider");class w extends v.AbstractVariableResolverService{constructor(m,p,b,E,g,i,l){function o(){if(b){const a=b.activeEditor();if(a)return a.document.uri;const s=E.tabGroups.all.find(u=>u.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof L.TextDiffTabInput||s.input instanceof L.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof L.TextTabInput||s.input instanceof L.NotebookEditorTabInput||s.input instanceof L.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:a=>{const s=i.folders.filter(u=>u.name===a);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(a,s)=>g.getConfiguration(void 0,a).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=o();if(a)return P.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const a=o();if(a){const s=p.getWorkspaceFolder(a);if(s)return P.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(b){const a=b.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(b){const a=b.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>m.getExtension(a)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(R.env))}}let f=class extends t.Disposable{constructor(m,p,b,E,g){super(),this.b=m,this.c=p,this.g=b,this.h=E,this.i=g,this.a=new c.Lazy(async()=>{const i=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.i,i,o,this.j())})}getResolver(){return this.a.value}j(){}};f=qe([We(0,C.IExtHostExtensionService),We(1,T.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,D.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[83],Ce([1,0,14,3,10,2,4,5,60,43,18,7,34,131,224,35,49]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,k.createDecorator)("IExtHostDebugService");let m=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,a,s,u,r,n){this.D=a,this.E=s,this.F=u,this.G=r,this.H=n,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=o.getProxy(A.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(S=>{this.I(h)}),this.I(h)})}asDebugSourceUri(o,a){const s=o;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let u=`debug:${encodeURIComponent(s.path||"")}`,r="?";return a&&(u+=`${r}session=${encodeURIComponent(a.id)}`,r="&"),u+=`${r}ref=${s.sourceReference}`,R.URI.parse(u)}else{if(s.path)return R.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(o){const a=[];for(const s of o.getAllExtensionDescriptions())if(s.contributes){const u=s.contributes.debuggers;if(u&&u.length>0)for(const r of u)(0,w.isDebuggerMainContribution)(r)&&a.push(r.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const o=[];return this.w.forEach(a=>o.push(a)),o}addBreakpoints(o){this.T();const a=o.filter(r=>{const n=r.id;return this.w.has(n)?!1:(this.w.set(n,r),!0)});this.U(a,[],[]);const s=[],u=new Map;for(const r of a)if(r instanceof T.SourceBreakpoint){let n=u.get(r.location.uri.toString());n||(n={type:"sourceMulti",uri:r.location.uri,lines:[]},u.set(r.location.uri.toString(),n),s.push(n)),n.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof T.FunctionBreakpoint&&s.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(o){this.T();const a=o.filter(n=>this.w.delete(n.id));this.U([],a,[]);const s=a.filter(n=>n instanceof T.SourceBreakpoint).map(n=>n.id),u=a.filter(n=>n instanceof T.FunctionBreakpoint).map(n=>n.id),r=a.filter(n=>n instanceof T.DataBreakpoint).map(n=>n.id);return this.k.$unregisterBreakpoints(s,u,r)}startDebugging(o,a,s){return this.k.$startDebugging(o?o.uri:void 0,a,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,a,s){if(!a)return new T.Disposable(()=>{});const u=this.d++;return this.f.push({type:o,handle:u,provider:a}),this.k.$registerDebugConfigurationProvider(o,s,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,u),new T.Disposable(()=>{this.f=this.f.filter(r=>r.provider!==a),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(o,a,s){if(!s)return new T.Disposable(()=>{});if(!this.P(o,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:a,handle:u,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(a,u),new T.Disposable(()=>{this.h=this.h.filter(r=>r.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(o,a){if(!a)return new T.Disposable(()=>{});const s=this.i++;return this.j.push({type:o,handle:s,factory:a}),new T.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==a)})}async $runInTerminal(o,a){return Promise.resolve(void 0)}async $substituteVariables(o,a){let s;const u=await this.W(o);return u&&(s={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(s,a)}J(o,a){if(o.type==="implementation")return new g(o.implementation)}K(){}async $startDASession(o,a){const s=this,u=await this.V(a);return this.R(this.M(u.type),u).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const n=this.L(r),h=this.J(n,u);if(!h)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const S=h;return this.A.set(o,S),this.Q(u).then(I=>(I&&this.B.set(o,I),S.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const K=F,q={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const M=await this.C.sign(K.arguments.value);q.body={signature:M},S.sendResponse(q)}else throw new Error("no signer")}catch(M){q.success=!1,q.message=M.message,S.sendResponse(q)}}else I&&I.onDidSendMessage&&I.onDidSendMessage(F),F=(0,w.convertToVSCPaths)(F,!0),s.k.$acceptDAMessage(o,F)}),S.onError(F=>{I&&I.onError&&I.onError(F),this.k.$acceptDAError(o,F.name,F.message,F.stack)}),S.onExit(F=>{I&&I.onExit&&I.onExit((0,P.withNullAsUndefined)(F),void 0),this.k.$acceptDAExit(o,(0,P.withNullAsUndefined)(F),void 0)}),I&&I.onWillStartSession&&I.onWillStartSession(),S.startSession()))})}$sendDAMessage(o,a){a=(0,w.convertToDAPaths)(a,!1);const s=this.B.get(o);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(a),this.A.get(o)?.sendMessage(a)}$stopDASession(o){const a=this.B.get(o);this.B.delete(o),a&&a.onWillStopSession&&a.onWillStopSession();const s=this.A.get(o);return this.A.delete(o),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const a=[],s=[],u=[];if(o.added)for(const r of o.added){const n=r.id;if(n&&!this.w.has(n)){let h;if(r.type==="function")h=new T.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")h=new T.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const S=R.URI.revive(r.uri);h=new T.SourceBreakpoint(new T.Location(S,new T.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}(0,T.setBreakpointId)(h,n),this.w.set(n,h),a.push(h)}}if(o.removed)for(const r of o.removed){const n=this.w.get(r);n&&(this.w.delete(r),s.push(n))}if(o.changed){for(const r of o.changed)if(r.id){const n=this.w.get(r.id);if(n){if(n instanceof T.FunctionBreakpoint&&r.type==="function"){const h=n;h.enabled=r.enabled,h.condition=r.condition,h.hitCondition=r.hitCondition,h.logMessage=r.logMessage,h.functionName=r.functionName}else if(n instanceof T.SourceBreakpoint&&r.type==="source"){const h=n;h.enabled=r.enabled,h.condition=r.condition,h.hitCondition=r.hitCondition,h.logMessage=r.logMessage,h.location=new T.Location(R.URI.revive(r.uri),new T.Position(r.line,r.character))}u.push(n)}}}this.U(a,s,u)}$provideDebugConfigurations(o,a,s){return(0,c.asPromise)(async()=>{const u=this.O(o);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.W(a);return u.provideDebugConfigurations(r,s)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(o,a,s,u){return(0,c.asPromise)(async()=>{const r=this.O(o);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const n=await this.W(a);return r.resolveDebugConfiguration(n,s,u)})}$resolveDebugConfigurationWithSubstitutedVariables(o,a,s,u){return(0,c.asPromise)(async()=>{const r=this.O(o);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const n=await this.W(a);return r.resolveDebugConfigurationWithSubstitutedVariables(n,s,u)})}async $provideDebugAdapter(o,a){const s=this.N(o);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(a);return this.R(s,u).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(r)})}async $acceptDebugSessionStarted(o){const a=await this.V(o);this.m.fire(a)}async $acceptDebugSessionTerminated(o){const a=await this.V(o);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,a){(await this.V(o))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(o,a){const u={session:await this.V(o),event:a.event,body:a.body};this.u.fire(u)}L(o){if(o instanceof T.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof T.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}M(o){const a=this.h.filter(s=>s.type===o);if(a.length>0)return a[0].factory}N(o){const a=this.h.filter(s=>s.handle===o);if(a.length>0)return a[0].factory}O(o){const a=this.f.filter(s=>s.handle===o);if(a.length>0)return a[0].provider}P(o,a){if(o.contributes){const s=o.contributes.debuggers;if(s&&s.length>0){for(const u of s)if(u.label&&u.type&&u.type===a)return!0}}return!1}Q(o){const s=o.configuration.type,u=this.j.filter(r=>r.type===s||r.type==="*").map(r=>(0,c.asPromise)(()=>r.factory.createDebugAdapterTracker(o)).then(n=>n,n=>null));return Promise.race([Promise.all(u).then(r=>{const n=r.filter(h=>!!h);if(n.length>0)return new E(n)}),new Promise(r=>setTimeout(()=>r(void 0),1e3))]).catch(r=>{})}async R(o,a){const s=a.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new T.DebugAdapterServer(s));if(o){const r=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>o.createDebugAdapterDescriptor(a,this.S(a,r))).then(n=>{if(n)return n})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,u))}S(o,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(o,a,s){(o.length>0||a.length>0||s.length>0)&&this.z.fire(Object.freeze({added:o,removed:a,changed:s}))}async V(o){if(o)if(typeof o=="string"){const a=this.l.get(o);if(a)return a}else{let a=this.l.get(o.id);if(!a){const s=await this.W(o.folderUri),u=o.parent?this.l.get(o.parent):void 0;a=new p(this.k,o.id,o.type,o.name,s,o.configuration,u),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(o){if(o){const a=R.URI.revive(o);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};m=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class p{constructor(o,a,s,u,r,n,h){this.d=o,this.f=a,this.g=s,this.h=u,this.i=r,this.j=n,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,a){return this.d.$customDebugAdapterRequest(this.f,o,a)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.ExtHostDebugSession=p;class b{constructor(o){this.value=Object.freeze({append(a){o.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=b;class E{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(a=>a.onError?a.onError(o):void 0)}onExit(o,a){this.d.forEach(s=>s.onExit?s.onExit(o,a):void 0)}}class g extends D.AbstractDebugAdapter{constructor(o){super(),this.h=o,o.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends m{constructor(o,a,s,u,r,n){super(o,a,s,u,r,n)}};i=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[296],Ce([1,0,9,82,2,5,288,13,89,90,25,201,18,56,43,96]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(b){const E=b.get(A.ILogService),i=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(l=>{E.error(l);const o=c.transformErrorForSerialization(l);i.$onUnexpectedError(o)})}static async installFullHandler(b){const E=b.get(A.ILogService),g=b.get(v.IExtHostRpcService),i=b.get(w.IExtHostExtensionService),l=b.get(f.IExtHostTelemetry),o=g.getProxy(R.MainContext.MainThreadExtensionService),a=g.getProxy(R.MainContext.MainThreadErrors),s=await i.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(r,n)=>{let h="",S,I;for(const F of n)h+=`
	at ${F.toString()}`,I=F.getFileName(),!S&&I&&(S=s.findSubstr(P.URI.file(I)));return u.set(r,S?.identifier),`${r.name||"Error"}: ${r.message||""}${h}`},c.setUnexpectedErrorHandler(r=>{E.error(r);const n=c.transformErrorForSerialization(r),h=u.get(r);if(!h){a.$onUnexpectedError(n);return}o.$onExtensionRuntimeError(h,n);const S=l.onExtensionError(h,r);E.trace("forwarded error to extension?",S,h)})}}Error.stackTraceLimit=100;class m{constructor(b,E,g,i,l){this.a=g,this.b=new k.RPCProtocol(b,null,i),E=m.e(E,this.b);const o=new C.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:l}),o.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),o.set(D.IURITransformerService,new D.URITransformerService(i)),o.set(w.IHostUtils,g);const a=new T.InstantiationService(o,!0);a.invokeFunction(d.installEarlyHandler),this.d=a.invokeFunction(s=>s.get(A.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=a.invokeFunction(s=>s.get(w.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(d.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(R.MainContext.MainThreadExtensionService);return P.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(E.transformIncomingURIs(i.extensionLocation));const l={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(o=>l[o]=P.URI.revive(E.transformIncomingURIs(i.browserNlsBundleUris[o]))),i.browserNlsBundleUris=l)}),b.environment.appRoot=P.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const g=b.environment.extensionDevelopmentLocationURI;return g&&(b.environment.extensionDevelopmentLocationURI=g.map(i=>P.URI.revive(E.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=P.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=P.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=P.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=P.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=P.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=P.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.logFile=P.URI.revive(E.transformIncomingURIs(b.logFile)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=m}),define(ye[297],Ce([1,0,14,12,183,200,207,83,60,43,18,42,7,49,34,225,227,35]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let p=class extends A.ExtHostDebugServiceBase{constructor(l,o,a,s,u,r,n){super(l,o,a,s,r,n),this.Z=u,this.X=new g}J(l,o){switch(l.type){case"server":return new f.SocketDebugAdapter(l);case"pipeServer":return new f.NamedPipeDebugAdapter(l);case"executable":return new f.ExecutableDebugAdapter(l,o.type)}return super.J(l,o)}S(l,o){const a=f.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),l.type);if(a)return new v.DebugAdapterExecutable(a.command,a.args,a.options)}K(){return new k.SignService}async $runInTerminal(l,o){if(l.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const a=await this.F.getConfigProvider(),s=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),r=l.title||P.localize(0,null),n=JSON.stringify({shell:s,shellArgs:u});let h=await this.X.checkout(n,r),S,I=!1;if(h)S=l.cwd;else{const M={shellPath:s,shellArgs:u,cwd:l.cwd,name:r,iconPath:new v.ThemeIcon("debug")};I=!0,h=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(h,n)}h.show(!0);const F=await h.processId;I?await new Promise(M=>setTimeout(M,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?h.sendText("cls"):s.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const K=(0,d.prepareCommand)(s,l.args,!!l.argsCanBeInterpretedByShell,S,l.env);h.sendText(K);const q=this.onDidTerminateDebugSession(M=>{M.id===o&&(this.X.free(h),q.dispose())});return F}else if(l.kind==="external")return E(l,await this.F.getConfigProvider());return super.$runInTerminal(l,o)}};p=qe([We(0,L.IExtHostRpcService),We(1,w.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,T.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,D.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let b;function E(i,l){if(!b)if(t.isWindows)b=new R.WindowsExternalTerminalService;else if(t.isMacintosh)b=new R.MacExternalTerminalService;else if(t.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=l.getConfiguration("terminal");return b.runInTerminal(i.title,i.cwd,i.args,i.env||{},o.external||{})}class g{constructor(){this.b=new Map}async checkout(l,o){const s=[...this.b.entries()].map(([u,r])=>(0,c.createCancelablePromise)(async n=>{if(u.name!==o||r.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await u.processId))return null;const h=Date.now();return r.lastUsedAt+g.a>h||n.isCancellationRequested||r.config!==l?null:(r.lastUsedAt=h,u)}));return await(0,c.firstParallel)(s,u=>!!u)}insert(l,o){this.b.set(l,{lastUsedAt:Date.now(),config:o})}free(l){const o=this.b.get(l);o&&(o.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}g.a=1e3}),define(ye[298],Ce([1,0,11,2,116,34,59,35,47,42,18,25,81,17,13,76,24,88,49]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(g,i,l,o,a,s,u,r,n){super(g,i,l,o,a,s,u,r),this.B=l,this.C=n,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,i){const l=i;if(!i.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const o=v.TaskHandleDTO.from(l,this.B),a=await this.a.$getTaskExecution(o);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.y(a,i);return this.a.$executeTask(o).catch(()=>{}),s}else{const o=v.TaskDTO.from(i,g);if(o===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(o.execution)&&await this.x(o,i,!1);const a=await this.y(await this.a.$getTaskExecution(o),i);return this.a.$executeTask(o).catch(()=>{}),a}}u(g,i,l,o){const a=[];if(o)for(const s of o){this.z(s,l),(!s.definition||!g[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const u=v.TaskDTO.from(s,l.extension);u&&(a.push(u),v.CustomExecutionDTO.is(u.execution)&&i.push(this.x(u,s,!0)))}return{tasks:a,extension:l.extension}}async v(g){return g}async F(g){let i=g&&g.length>0?g[0]:void 0;if(!i){const l=t.URI.file((0,m.homedir)());i=new y.WorkspaceFolder({uri:l,name:d.basename(l),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,i){const l=t.URI.revive(g),o={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(l),s=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),r=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(s);for(const n of i.variables)o.variables[n]=await u.resolveAsync(r,n);if(i.process!==void 0){let n;if(i.process.path!==void 0){n=i.process.path.split(c.delimiter);for(let h=0;h<n.length;h++)n[h]=await u.resolveAsync(r,n[h])}o.process=await P.win32.findExecutable(await u.resolveAsync(r,i.process.name),i.process.cwd!==void 0?await u.resolveAsync(r,i.process.cwd):void 0,n)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(g,i,l){return P.win32.findExecutable(g,i,l)}};b=qe([We(0,L.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,k.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,C.IExtHostTerminalService),We(6,w.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,p.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[299],Ce([1,0,88,49]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class P extends t.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=P}),define(ye[143],Ce([1,0,16,14,21,45,17,11,24,2,31]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(p,b,E,g){this.d=p,this.e=b,this.f=E,this.g=g,this.a=null,this.b=!1,this.c=0}search(p,b){const E=this.d.folderQueries||[],g=new P.CancellationTokenSource;return b.onCancellationRequested(()=>g.cancel()),new Promise((i,l)=>{this.a=new D(p);let o=!1;const a=(s,u)=>{if(!o&&!this.b){const r=this.h(s);f(s)&&typeof this.d.maxResults=="number"&&this.c+r>this.d.maxResults&&(this.b=!0,o=!0,g.cancel(),s=this.j(s,this.d.maxResults-this.c));const n=this.h(s);this.c+=n,(n>0||!f(s))&&this.a.add(s,u)}};Promise.all(E.map((s,u)=>this.k(s,r=>a(r,u),g.token))).then(s=>{g.dispose(),this.a.flush();const u=s.some(r=>!!r&&!!r.limitHit);i({limitHit:this.b||u,messages:(0,c.flatten)(s.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.g}})},s=>{g.dispose();const u=(0,R.toErrorMessage)(s);l(new Error(u))})})}h(p){return f(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const E=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:E.slice(0,b),preview:{matches:g.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,E){const g=new L.QueryGlobTester(this.d,p),i=[],l={report:s=>{if(!this.l(s))return;const u=p.folder.scheme===k.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(s.uri))):void 0,r=y.relativePath(p.folder,s.uri);if(r){const n=g.includedInQuery(r,A.basename(r),u);(0,t.isThenable)(n)?i.push(n.then(h=>{h&&b(s)})):n&&b(s)}}},o=this.n(p),a=await this.e.provideTextSearchResults(v(this.d.contentPattern),o,l,E);return i.length&&await Promise.all(i),a}l(p){if(f(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),E=(0,L.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),g={folder:C.URI.from(p.folder),excludes:E,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=T;function v(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class D{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new d(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(w(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=D;function w(m){return f(m)?{preview:{matches:(0,c.mapArrayOrNot)(m.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:m.preview.text},ranges:(0,c.mapArrayOrNot)(m.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function f(m){return!!m.preview}e.extensionResultIsMatch=f;class d{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=d,d.a=4e3,d.b=50}),define(ye[84],Ce([1,0,6,5,4,292,18,56,13,2,143]),function(te,e,c,t,P,R,k,A,y,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let T=class{constructor(f,d,m){this.k=f,this.l=d,this.n=m,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const m=this.d++;return this.e.set(m,d),this.c.$registerTextSearchProvider(m,this.o(f)),(0,c.toDisposable)(()=>{this.g.delete(f),this.e.delete(m),this.c.$unregisterProvider(m)})}registerFileSearchProvider(f,d){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const m=this.d++;return this.h.set(m,d),this.c.$registerFileSearchProvider(m,this.o(f)),(0,c.toDisposable)(()=>{this.i.delete(f),this.h.delete(m),this.c.$unregisterProvider(m)})}$provideFileSearchResults(f,d,m,p){const b=v(m),E=this.h.get(f);if(E)return this.j.fileSearch(b,E,g=>{this.c.$handleFileMatch(f,d,g.map(i=>i.resource))},p);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,m,p){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const E=v(m);return this.q(E,b).search(i=>this.c.$handleTextMatch(f,d,i),p)}$enableExtensionHostSearch(){}q(f,d){return new L.TextSearchManager(f,d,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};T=qe([We(0,k.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],T),e.ExtHostSearch=T;function v(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(D),extraFileResources:w.extraFileResources&&w.extraFileResources.map(f=>C.URI.revive(f))}}e.reviveQuery=v;function D(w){return{...w,folder:C.URI.revive(w.folder)}}}),define(ye[300],Ce([1,0,89,142,34,139,35,41,59,42,81,83,84,99,55,76,141,77,48,98,96,60,140,13,236,49,97]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g,i,l,o,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,c.registerSingleton)(l.ILoggerService,i.ExtHostLoggerService,1),(0,c.registerSingleton)(l.ILogService,o.ExtHostLogService,1),(0,c.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,c.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration,0),(0,c.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,c.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,c.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,0),(0,c.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,c.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace,0),(0,c.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,c.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry,0),(0,c.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,c.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(ye[100],Ce([1,0,16,13,31,80]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function k(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=k;function A(T,v,D,w){const f=(0,c.mapArrayOrNot)(D,y),d=new P.TextSearchMatch(v,f,w),m=d.preview.matches;return{ranges:(0,c.mapArrayOrNot)(f,C),uri:T,preview:{text:d.preview.text,matches:(0,c.mapArrayOrNot)(m,C)}}}e.createTextSearchResult=A;function y(T){return new P.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function C(T){return new R.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(v,D){this.a=v,this.b=D}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[301],Ce([1,0,46,11,85,32,12,8,100,302]),function(te,e,c,t,P,R,k,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(b,E,g,i){const l=v(b,E,g,i),o=E.folder.fsPath;return{cmd:c.spawn(L,l.args,{cwd:o}),rgDiskPath:L,siblingClauses:l.siblingClauses,rgArgs:l,cwd:o}}e.spawnRipgrepCmd=T;function v(b,E,g,i){const l=["--files","--hidden","--case-sensitive"];w([E],g,!1).forEach(a=>{const s=(0,y.anchorGlob)(a);if(l.push("-g",s),k.isMacintosh){const u=(0,P.normalizeNFD)(s);u!==s&&l.push("-g",u)}});const o=D([E],i,void 0,!1);return o.globArgs.forEach(a=>{const s=`!${(0,y.anchorGlob)(a)}`;if(l.push("-g",s),k.isMacintosh){const u=(0,P.normalizeNFD)(s);u!==s&&l.push("-g",u)}}),E.disregardIgnoreFiles!==!1?l.push("--no-ignore"):E.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),E.ignoreSymlinks||l.push("--follow"),b.exists&&l.push("--quiet"),l.push("--no-config"),E.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:o.siblingClauses}}function D(b,E,g,i=!0){const l=[];let o={};return b.forEach(a=>{const s=Object.assign({},a.excludePattern||{},E||{}),u=f(s,i?a.folder.fsPath:void 0,g);l.push(...u.globArgs),u.siblingClauses&&(o=Object.assign(o,u.siblingClauses))}),{globArgs:l,siblingClauses:o}}function w(b,E,g=!0){const i=[];return b.forEach(l=>{const o=Object.assign({},E||{},l.includePattern||{}),a=f(o,g?l.folder.fsPath:void 0);i.push(...a.globArgs)}),i}function f(b,E,g){const i=[],l={};return Object.keys(b).forEach(o=>{if(g&&g.has(o)||!o)return;const a=b[o];o=m(E?d(E,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof a=="boolean"&&a?(o.startsWith("\\\\")&&(o+="**"),i.push(p(o))):a&&a.when&&(l[o]=a)}),{globArgs:i,siblingClauses:l}}function d(b,E){return t.isAbsolute(E)?E:t.join(b,E)}e.getAbsoluteGlob=d;function m(b){return b=A.rtrim(b,"\\"),A.rtrim(b,"/")}function p(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=p}),define(ye[303],Ce([1,0,46,69,11,304,16,45,39,85,32,12,44,8,10,29,31,301,111]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(o=>o())});class E{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&y.parse(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,p.prepareQuery)(this.b).normalizedLowercase),this.u=a.excludePattern&&y.parse(a.excludePattern),this.t=new Map,a.folderQueries.forEach(s=>{const u=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),r=s.folder.fsPath;a.folderQueries.map(n=>n.folder.fsPath).filter(n=>n!==r).forEach(n=>{(0,L.isEqualOrParent)(n,r)&&(u[P.relative(r,n)]=!0)}),this.t.set(r,new i(u,r))})}cancel(){this.l=!0,b.forEach(a=>a())}walk(a,s,u,r,n){if(this.m=v.StopWatch.create(!1),this.l)return n(null,this.j);s.forEach(h=>{const S=P.basename(h.fsPath);this.u&&this.u(h.fsPath,S)||this.J(u,{relativePath:h.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(a,(h,S)=>{this.x(this.y,this,h,u,r,I=>{if(I){const F=(0,A.toErrorMessage)(I);console.error(F),this.q.push(F),S(I,void 0)}else S(null,void 0)})},(h,S)=>{this.m.stop();const I=h?k.coalesce(h)[0]:null;n(I,this.j)})}w(a,s,u){const r=new Array(a.length),n=new Array(a.length);let h=!1,S=0;if(a.length===0)return u(null,[]);a.forEach((I,F)=>{s(I,(K,q)=>{if(K?(h=!0,r[F]=null,n[F]=K):(r[F]=q,n[F]=null),++S===a.length)return u(h?n:null,r)})})}x(a,s,...u){try{a.apply(s,u)}catch(r){u[u.length-1](r)}}y(a,s,u,r){const n=a.folder.fsPath,h=T.isMacintosh,S=()=>M&&M.kill();b.add(S);let I=z=>{b.delete(S),I=()=>{},r(z)},F="";const K=this.D(),q=(0,m.spawnRipgrepCmd)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),M=q.cmd,B=!Object.keys(q.siblingClauses).length,O=q.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let U=`${q.rgDiskPath} ${O}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),u({message:U}),this.s=0,this.z(M,"utf8",u,(z,j,ue)=>{if(z){I(z);return}if(this.j){I();return}const _=(F+(h?C.normalizeNFC(j||""):j)).split(`
`);if(ue){const J=_.length;_[J-1]=_[J-1].trim(),_[J-1]||_.pop()}else F=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){I(new Error("Splitting up files failed"));return}if(this.s+=_.length,B){for(const J of _)if(this.J(s,{base:n,relativePath:J,searchPath:this.N(a,J)}),this.j){S();break}(ue||this.j)&&I();return}this.G(a,K,n,_,s),ue&&(this.H(K,n,s),I())})}spawnFindCmd(a){const s=this.t.get(a.folder.fsPath),u=s.getBasenameTerms(),r=s.getPathTerms(),n=["-L","."];if(u.length||r.length){n.push("-not","(","(");for(const h of u)n.push("-name",h),n.push("-o");for(const h of r)n.push("-path",h),n.push("-o");n.pop(),n.push(")","-prune",")")}return n.push("-type","f"),c.spawn("find",n,{cwd:a.folder.fsPath})}readStdout(a,s,u){let r="";this.z(a,s,()=>{},(n,h,S)=>{if(n){u(n);return}r+=h,S&&u(null,r)})}z(a,s,u,r){let n=(I,F,K)=>{(I||K)&&(n=()=>{},this.r?.stop()),r(I,F,K)},h=!1;a.stdout?(this.A(a.stdout,s,n),a.stdout.once("data",()=>h=!0)):u({message:"stdout is null"});let S;a.stderr?S=this.B(a.stderr):u({message:"stderr is null"}),a.on("error",I=>{n(I)}),a.on("close",I=>{let F;!h&&(F=this.C(S,s))&&l(F)?n(new Error(`command failed with error code ${I}: ${this.C(S,s)}`)):(this.g&&I===0&&(this.j=!0),n(null,"",!0))})}A(a,s,u){const r=new R.StringDecoder(s);return a.on("data",n=>{u(null,r.write(n))}),r}B(a){const s=[];return a.on("data",u=>{s.push(u)}),s}C(a,s){const u=new R.StringDecoder(s);return a.map(r=>u.write(r)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:s},u,r,n){r.indexOf(this.b)!==-1&&this.J(n,{base:u,relativePath:this.b,searchPath:this.N(a,this.b)});const h=S=>{const I=P.basename(S),F=P.dirname(S);let K=s[F];K||(K=s[F]=[],h(F)),K.push({base:u,relativePath:S,basename:I,searchPath:this.N(a,S)})};r.forEach(h)}H({rootEntries:a,pathToEntries:s},u,r){const n=this,h=this.t.get(u),S=this.b;function I(F){n.o++;const K=(0,d.hasSiblingFn)(()=>F.map(q=>q.basename));for(let q=0,M=F.length;q<M;q++){const B=F[q],{relativePath:O,basename:U}=B;if(h.test(O,U,S!==U?K:void 0))continue;const z=s[O];if(z)I(z);else{if(n.p++,O===S)continue;n.J(r,B)}if(n.j)break}}I(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,s,u,r,n){const h=a.folder,S=(0,d.hasSiblingFn)(()=>u);this.w(u,(I,F)=>{if(this.l||this.j)return F(null);const K=s?[s,I].join(P.sep):I;if(this.t.get(a.folder.fsPath).test(K,I,this.a.filePattern!==I?S:void 0))return F(null);const q=[h.fsPath,K].join(P.sep);t.lstat(q,(M,B)=>{if(M||this.l||this.j)return F(null);this.L(q,B,(O,U)=>O||this.l||this.j?F(null):U.isDirectory()?(this.o++,this.M(q,B,(z,j)=>z||this.l||this.j||(j=j||"",this.v[j])?F(null):(this.v[j]=!0,f.Promises.readdir(q).then(ue=>{if(this.l||this.j)return F(null);this.I(a,K,ue,r,V=>F(V||null))},ue=>{F(null)})))):(this.p++,K===this.b||this.h&&w.isNumber(U.size)&&U.size>this.h||this.J(r,{base:h.fsPath,relativePath:K,searchPath:this.N(a,K)}),F(null,void 0)))})},I=>{const F=I&&k.coalesce(I);return n(F&&F.length>0?F[0]:void 0)})}J(a,s){this.K(s)&&(!this.d||this.d(s.relativePath,P.basename(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(s))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(a,this.c)}return!0}L(a,s,u){return s.isSymbolicLink()?t.stat(a,u):u(null,s)}M(a,s,u){return s.isSymbolicLink()?t.realpath(a,(r,n)=>r?u(r):u(null,n)):u(null,a)}N(a,s){return a.folderName?P.join(a.folderName,s):s}}e.FileWalker=E;class g{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new E(a)}search(a,s,u){this.c.walk(this.a,this.b,a,s,(r,n)=>{u(r,{limitHit:n,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class i{constructor(a,s){this.expression=a,this.c=s,this.d(a)}d(a){let s,u;Object.keys(a).filter(r=>a[r]).forEach(r=>{P.isAbsolute(r)?(s=s||y.getEmptyExpression(),s[r]=a[r]):(u=u||y.getEmptyExpression(),u[r]=a[r])}),this.a=s&&y.parse(s,{trimForExclusions:!0}),this.b=u&&y.parse(u,{trimForExclusions:!0})}test(a,s,u){return this.b&&this.b(a,s,u)||this.a&&this.a(P.join(this.c,a),s,u)}getBasenameTerms(){const a=[];return this.a&&a.push(...y.getBasenameTerms(this.a)),this.b&&a.push(...y.getBasenameTerms(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...y.getPathTerms(this.a)),this.b&&a.push(...y.getPathTerms(this.b)),a}}function l(o){const a=o.trim().split(`
`),s=a[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return D.uppercaseFirstLetter(a[a.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(ye[305],Ce([1,0,103,22]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function P(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===o)}e.isUTFEncoding=P,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,k=512,A=512*8,y=512*128;var C;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(a,s){super(a),this.decodeStreamErrorKind=s}}e.DecodeStreamError=L;class T{static async create(a){let s;if(a!==e.UTF8)s=(await new Promise((r,n)=>{te(["@vscode/iconv-lite-umd"],r,n)})).getDecoder(f(a));else{const u=new TextDecoder;s={write(r){return u.decode(r,{stream:!0})},end(){return u.decode()}}}return new T(s)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function v(o,a){const s=a.minBytesRequiredForDetection??a.guessEncoding?A:k;return new Promise((u,r)=>{const n=(0,c.newWriteableStream)(q=>q.join("")),h=[];let S=0,I,F;const K=async()=>{try{const q=await l({buffer:t.VSBuffer.concat(h),bytesRead:S},a.guessEncoding);if(q.seemsBinary&&a.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await a.overwriteEncoding(q.encoding),I=await T.create(q.encoding);const M=I.write(t.VSBuffer.concat(h).buffer);n.write(M),h.length=0,S=0,u({stream:n,detected:q})}catch(q){F?.dispose(),n.destroy(),r(q)}};F=(0,c.listenStream)(o,{onData:async q=>{I?n.write(I.write(q.buffer)):(h.push(q),S+=q.byteLength,S>=s&&(o.pause(),await K(),setTimeout(()=>o.resume())))},onError:q=>n.error(q),onEnd:async()=>{I||await K(),n.end(I?.end())}})})}e.toDecodeStream=v;async function D(o,a,s){const r=(await new Promise((S,I)=>{te(["@vscode/iconv-lite-umd"],S,I)})).getEncoder(f(a),s);let n=!1,h=!1;return{read(){if(h)return null;const S=o.read();if(typeof S!="string"){if(h=!0,!n&&s?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const I=r.end();return I&&I.length>0?(n=!0,t.VSBuffer.wrap(I)):null}return n=!0,t.VSBuffer.wrap(r.write(S))}}}e.toEncodeReadable=D;async function w(o){return(await new Promise((s,u)=>{te(["@vscode/iconv-lite-umd"],s,u)})).encodingExists(f(o))}e.encodingExists=w;function f(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=f;function d(o,a){if(!o||a<e.UTF16be_BOM.length)return null;const s=o.readUInt8(0),u=o.readUInt8(1);if(s===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const r=o.readUInt8(2);return s===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&r===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const m=["ascii","utf-16","utf-32"];async function p(o){const a=await new Promise((h,S)=>{te(["jschardet"],h,S)}),s=o.slice(0,y),u=g(s.buffer),r=a.detect(u);if(!r||!r.encoding)return null;const n=r.encoding.toLowerCase();return 0<=m.indexOf(n)?null:E(r.encoding)}const b={ibm866:"cp866",big5:"cp950"};function E(o){const a=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[a]||a}function g(o){let a="";for(let s=0;s<o.length;s++)a+=String.fromCharCode(o[s]);return a}function i(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=o.match(/windows(\d+)/);return a?"windows-"+a[1]:o}}}e.toCanonicalName=i;function l({buffer:o,bytesRead:a},s){let u=d(o,a),r=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&o){let n=!0,h=!0,S=!1;for(let I=0;I<a&&I<R;I++){const F=I%2===1,K=o.readUInt8(I)===0;if(K&&(S=!0),n&&(F&&!K||!F&&K)&&(n=!1),h&&(F&&K||!F&&!K)&&(h=!1),K&&!n&&!h)break}S&&(n?u=e.UTF16le:h?u=e.UTF16be:r=!0)}return s&&!r&&!u&&o?p(o.slice(0,a)).then(n=>({seemsBinary:!1,encoding:n})):{seemsBinary:r,encoding:u}}e.detectEncodingFromBuffer=l,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,305,29,143]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends P.TextSearchManager{constructor(A,y,C=t,L="searchProcess"){super(A,y,{readdir:T=>C.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,c.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=R}),define(ye[306],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const R=this.a.get(P);return this.a.delete(P),R}}addDragOperationTransfer(P,R){this.a.set(P,R)}getRenderedTreeElement(P){if(this.b.has(P))return this.b.get(P)}addRenderedTreeItemElement(P,R){this.b.set(P,R)}removeRenderedTreeItemElement(P){this.b.has(P)&&this.b.delete(P)}}e.TreeviewsService=c}),define(ye[307],Ce([1,0,181,7,24,2,3,6,222,14,7,10,16,15,21,306,27]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(E,g){if((0,T.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let i;return Array.isArray(E.highlights)&&(i=E.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),i=i.length?i:void 0),{label:E.label,highlights:i}}}class p{constructor(g,i,l){this.d=g,this.e=i,this.f=l,this.a=new Map,this.b=new f.TreeviewsService;function o(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:a=>o(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(s=>o(s)?this.i(s):s):a})}registerTreeDataProvider(g,i,l){const o=this.createTreeView(g,{treeDataProvider:i},l);return{dispose:()=>o.dispose()}}createTreeView(g,i,l){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=i.dragAndDropController?.dropMimeTypes??[],a=i.dragAndDropController?.dragMimeTypes??[],s=!!i.dragAndDropController?.handleDrag,u=!!i.dragAndDropController?.handleDrop,r=this.h(g,i,l),n=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:o,dragMimeTypes:a,hasHandleDrag:s,hasHandleDrop:u});return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(l,"treeItemCheckbox"),r.onDidChangeCheckboxState},get message(){return r.message},set message(h){r.message=h},get title(){return r.title},set title(h){r.title=h},get description(){return r.description},set description(h){r.description=h},get badge(){return r.badge},set badge(h){h!==void 0&&L.ViewBadge.isViewBadge(h)?r.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(r.badge=void 0)},reveal:(h,S)=>r.reveal(h,S),dispose:async()=>{await n,this.a.delete(g),r.dispose()}}}$getChildren(g,i){const l=this.a.get(g);return l?l.getChildren(i):Promise.reject(new y.NoTreeViewError(g))}async $handleDrop(g,i,l,o,a,s,u,r){const n=this.a.get(g);if(!n)return Promise.reject(new y.NoTreeViewError(g));const h=D.DataTransfer.toDataTransfer(l,async S=>(await this.d.$resolveDropFileData(g,i,S)).buffer);return u===g&&r&&await this.g(h,n,r,a,s),n.onDrop(h,o,a)}async g(g,i,l,o,a){const s=this.b.removeDragOperationTransfer(a);if(s)(await s)?.forEach((u,r)=>{u&&g.set(r,u)});else if(a&&i.handleDrag){const u=i.handleDrag(l,g,o);this.b.addDragOperationTransfer(a,u),await u}return g}async $handleDrag(g,i,l,o){const a=this.a.get(g);if(!a)return Promise.reject(new y.NoTreeViewError(g));const s=await this.g(new t.DataTransfer,a,i,o,l);if(!!s)return D.DataTransfer.toDataTransferDTO(s)}async $hasResolve(g){const i=this.a.get(g);if(!i)throw new y.NoTreeViewError(g);return i.hasResolve}$resolve(g,i,l){const o=this.a.get(g);if(!o)throw new y.NoTreeViewError(g);return o.resolveTreeItem(i,l)}$setExpanded(g,i,l){const o=this.a.get(g);if(!o)throw new y.NoTreeViewError(g);o.setExpanded(i,l)}$setSelection(g,i){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setSelection(i)}$setFocus(g,i){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setFocus(i)}$setVisible(g,i){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setVisible(i)}$changeCheckboxState(g,i){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setCheckboxState(i)}h(g,i,l){const o=new b(g,i,this.d,this.e.converter,this.f,l);return this.a.set(g,o),o}i(g){const i=this.a.get(g.$treeViewId);return i&&"$treeItemHandle"in g?i.getExtensionElement(g.$treeItemHandle):i&&"$focusedTreeItem"in g&&g.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=p;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,T.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,i,l,o,a,s){if(super(),this.C=g,this.D=l,this.F=o,this.G=a,this.H=s,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new k.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new k.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new k.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new k.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new k.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new k.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new w.CancellationTokenSource,s.contributes&&s.contributes.views)for(const n in s.contributes.views)for(const h of s.contributes.views[n])h.id===g&&(this.J=h.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let u,r;this.B(k.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(u||(u=new Promise(S=>r=S),this.y=this.y.then(()=>u)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const S=r;return u=null,this.U(h).then(()=>S())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const i=g?this.getExtensionElement(g):void 0;if(g&&!i)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let l=this.Q(g);return l||(l=await this.R(i)),l?l.map(o=>o.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,i){i=i||{select:!0,focus:!1};const l=(0,T.isUndefinedOrNull)(i.select)?!0:i.select,o=(0,T.isUndefinedOrNull)(i.focus)?!1:i.focus,a=(0,T.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(s=>this.P(g,s[s.length-1]).then(u=>this.D.$reveal(this.C,{item:u.item,parentChain:s.map(r=>r.item)},{select:l,focus:o,expand:a})),s=>this.G.error(s)):this.D.$reveal(this.C,void 0,{select:l,focus:o,expand:a})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=D.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,i){const l=this.getExtensionElement(g);l&&(i?this.r.fire(Object.freeze({element:l})):this.s.fire(Object.freeze({element:l})))}setSelection(g){(0,v.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const i=(await Promise.all(g.map(async l=>{const o=this.getExtensionElement(l.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:l.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);i.forEach(l=>{l.treeItem.checkboxState=l.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(l=>[l.extensionItem,l.newState])})}async handleDrag(g,i,l){const o=[];for(const a of g){const s=this.getExtensionElement(a);s&&o.push(s)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,i,l),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,i,l){const o=i?this.getExtensionElement(i):void 0;if(!(!o&&i||!this.g?.handleDrop))return(0,C.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,g,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,i){if(!this.f.resolveTreeItem)return;const l=this.i.get(g);if(l){const o=this.j.get(l);if(o){const a=await this.f.resolveTreeItem(o.extensionItem,l,i)??o.extensionItem;return this.db(a),o.item.tooltip=this.ab(a.tooltip),o.item.command=this.bb(o.disposableStore,a.command),o.item}}}N(g){return this.O(g).then(i=>i?this.N(i).then(l=>this.P(i,l[l.length-1]).then(o=>(l.push(o),l))):Promise.resolve([]))}O(g){const i=this.j.get(g);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,C.asPromise)(()=>this.f.getParent(g))}P(g,i){const l=this.j.get(g);return l?Promise.resolve(l):(0,C.asPromise)(()=>this.f.getTreeItem(g)).then(o=>this.gb(g,o,i,!0)).then(o=>this.getChildren(i?i.item.handle:void 0).then(()=>{const a=this.getExtensionElement(o);if(a){const s=this.j.get(a);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(g){if(g){let i;if(typeof g=="string"){const l=this.getExtensionElement(g);i=l?this.j.get(l):void 0}else i=g;return i&&i.children||void 0}return this.h}async R(g){this.nb(g);const i=new w.CancellationTokenSource(this.S.token);try{const l=g?this.j.get(g):void 0,o=await this.f.getChildren(g);if(i.token.isCancellationRequested)return;const a=await Promise.all((0,v.coalesce)(o||[]).map(async s=>{const u=await this.f.getTreeItem(s);return u&&!i.token.isCancellationRequested?this.Z(s,u,l):null}));return i.token.isCancellationRequested?void 0:(0,v.coalesce)(a)}finally{i.dispose()}}U(g){if(g.some(l=>!l))return this.S.dispose(!0),this.S=new w.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const l=this.W(g);if(l.length)return this.X(l)}return Promise.resolve(void 0)}W(g){const i=new Set,l=g.map(a=>this.j.get(a));for(const a of l)if(a&&!i.has(a.item.handle)){let s=a;for(;s&&s.parent&&l.findIndex(u=>s&&s.parent&&u&&u.item.handle===s.parent.item.handle)===-1;){const u=this.i.get(s.parent.item.handle);s=u?this.j.get(u):void 0}s&&!s.parent&&i.add(a.item.handle)}const o=[];return i.forEach(a=>{const s=this.i.get(a);if(s){const u=this.j.get(s);u&&(!u.parent||!i.has(u.parent.item.handle))&&o.push(a)}}),o}X(g){const i={};return Promise.all(g.map(l=>this.Y(l).then(o=>{o&&(i[l]=o.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(g){const i=this.getExtensionElement(g);if(i){const l=this.j.get(i);if(l)return this.nb(i),(0,C.asPromise)(()=>this.f.getTreeItem(i)).then(o=>{if(o){const a=this.eb(i,o,l.parent);return this.lb(i,a,l,l.parent),l.dispose(),a}return null})}return Promise.resolve(null)}Z(g,i,l){const o=this.eb(g,i,l);if(i.id&&this.i.has(o.item.handle))throw new Error((0,c.localize)(0,null,i.id));return this.kb(g,o),this.mb(o,l),o}ab(g){return L.MarkdownString.isMarkdownString(g)?D.MarkdownString.from(g):g}bb(g,i){return i?{...this.F.toInternal(i,g),originalId:i.command}:void 0}cb(g){if(!g.checkboxState)return;let i,l;return typeof g.checkboxState=="number"?i=g.checkboxState:(i=g.checkboxState.state,l=g.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:l}}db(g){if(!L.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,i,l){this.db(i);const o=new A.DisposableStore,a=this.gb(g,i,l),s=this.hb(i);return{item:{handle:a,parentHandle:l?l.item.handle:void 0,label:m(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(o,i.command),contextValue:i.contextValue,icon:s,iconDark:this.ib(i)||s,themeIcon:this.fb(i),collapsibleState:(0,T.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:l,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(g){return g.iconPath instanceof L.ThemeIcon?g.iconPath:void 0}gb(g,{id:i,label:l,resourceUri:o},a,s){if(i)return`${b.b}/${i}`;const u=m(l,this.H),r=a?a.item.handle:b.a;let n=u?u.label:o?(0,P.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(g)?this.j.get(g).item.handle:void 0,S=this.Q(a)||[];let I,F=0;do{if(I=`${r}/${F}:${n}`,s||!this.i.has(I)||h===I)break;F++}while(F<=S.length);return I}hb(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return R.URI.isUri(g)?g:R.URI.file(g)}kb(g,i){this.i.set(i.item.handle,g),this.j.set(g,i)}lb(g,i,l,o){this.i.delete(i.item.handle),this.j.delete(g),i.item.handle!==l.item.handle&&this.i.delete(l.item.handle),this.kb(g,i);const a=this.Q(o)||[],s=a.filter(u=>u.item.handle===l.item.handle)[0];s&&a.splice(a.indexOf(s),1,i)}mb(g,i){i?(i.children||(i.children=[]),i.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const i=this.j.get(g);if(i){if(i.children)for(const l of i.children){const o=this.i.get(l.item.handle);o&&this.ob(o)}i.children=void 0}}else this.pb()}ob(g){const i=this.j.get(g);if(i){if(i.children)for(const l of i.children){const o=this.i.get(l.item.handle);o&&this.ob(o)}this.j.delete(g),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[308],Ce([1,0,21,9,3,38,2,121,107,152,163,40,5,95,250,249,41,251,35,253,254,255,238,256,59,43,257,258,261,262,263,142,241,269,270,271,99,42,273,307,15,7,72,276,79,141,34,229,260,71,139,81,83,84,13,56,18,25,264,237,55,76,247,274,78,77,279,277,278,248,48,272,275,98,60,96,265,80,266,17,125,240,218,259,6,27,223,97,215,267,268]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E,g,i,l,o,a,s,u,r,n,h,S,I,F,K,q,M,B,O,U,z,j,ue,V,_,J,ie,ee,X,G,de,be,Ee,Pe,Fe,se,oe,fe,Z,ce,ne,N,H,Q,Y,he,we,Ae,pe,De,ke,Ve,Ge,et,Qe,nt,st,ht,Me,rt,ae,$,le,Ie,Le,$e,Xe,Ze,pt,mt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(tt){const ft=tt.get(fe.IExtHostInitDataService),At=tt.get(ke.IExtHostFileSystemInfo),Xt=tt.get(he.IExtHostConsumerFileSystem),Rt=tt.get(a.IExtHostExtensionService),gt=tt.get(ie.IExtHostWorkspace),Tt=tt.get(nt.IExtHostTelemetry),$t=tt.get(p.IExtHostConfiguration),Nt=tt.get(se.IURITransformerService),xe=tt.get(oe.IExtHostRpcService),Mt=tt.get(M.IExtHostStorage),Ut=tt.get(Y.IExtensionStoragePaths),Wt=tt.get(Fe.ILoggerService),bt=tt.get(Fe.ILogService),Re=tt.get(ne.IExtHostTunnelService),Oe=tt.get(N.IExtHostApiDeprecationService),Se=tt.get(J.IExtHostWindow),re=tt.get(et.IExtHostSecretState),Ne=tt.get(Qe.IExtHostEditorTabs);xe.set(v.ExtHostContext.ExtHostFileSystemInfo,At),xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Wt),xe.set(v.ExtHostContext.ExtHostWorkspace,gt),xe.set(v.ExtHostContext.ExtHostConfiguration,$t),xe.set(v.ExtHostContext.ExtHostExtensionService,Rt),xe.set(v.ExtHostContext.ExtHostStorage,Mt),xe.set(v.ExtHostContext.ExtHostTunnelService,Re),xe.set(v.ExtHostContext.ExtHostWindow,Se),xe.set(v.ExtHostContext.ExtHostSecretState,re),xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),xe.set(v.ExtHostContext.ExtHostEditorTabs,Ne);const He=xe.set(v.ExtHostContext.ExtHostDecorations,tt.get(de.IExtHostDecorations)),_e=xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(o.IExtHostDocumentsAndEditors)),je=xe.set(v.ExtHostContext.ExtHostCommands,tt.get(d.IExtHostCommands)),it=xe.set(v.ExtHostContext.ExtHostTerminalService,tt.get(B.IExtHostTerminalService)),lt=xe.set(v.ExtHostContext.ExtHostDebugService,tt.get(Ee.IExtHostDebugService)),Pt=xe.set(v.ExtHostContext.ExtHostSearch,tt.get(Pe.IExtHostSearch)),St=xe.set(v.ExtHostContext.ExtHostTask,tt.get(be.IExtHostTask)),yt=xe.set(v.ExtHostContext.ExtHostOutputService,tt.get(S.IExtHostOutputService)),kt=xe.set(v.ExtHostContext.ExtHostLocalization,tt.get(Ze.IExtHostLocalizationService)),Ct=xe.set(v.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(xe)),Dt=xe.set(v.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(xe,_e)),qt=xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(xe,_e,bt)),Jt=xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,Dt,xe.getProxy(v.MainContext.MainThreadBulkEdits))),vt=xe.set(v.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(xe,je,_e,Dt)),si=xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new le.ExtHostNotebookDocuments(vt)),oi=xe.set(v.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(bt,vt)),Zt=xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(xe,ft,vt,je,bt)),bi=xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(xe,vt)),Lt=xe.set(v.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(xe,_e)),Ht=xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(xe.getProxy(v.MainContext.MainThreadTreeViews),je,bt)),wi=xe.set(v.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,ft.remote)),ai=xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,bt,At,_e)),ei=xe.set(v.ExtHostContext.ExtHostLanguages,new n.ExtHostLanguages(xe,Dt,je.converter,Nt)),ut=xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(xe,Nt,Dt,je,ai,bt,Oe,Tt)),Bi=xe.set(v.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(xe,ut)),Bt=xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(xe,bt,_e)),Qt=xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(xe,gt,je)),ci=xe.set(v.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(xe,je,bt)),vi=xe.set(v.ExtHostContext.ExtHostQuickDiff,new ct.ExtHostQuickDiff(xe)),Ei=xe.set(v.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(xe,je,Dt)),li=xe.set(v.ExtHostContext.ExtHostProgress,new I.ExtHostProgress(xe.getProxy(v.MainContext.MainThreadProgress))),Si=xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(xe)),ui=xe.set(v.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(xe)),ti=xe.set(v.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(xe)),$i=xe.set(v.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(xe,je)),ii=xe.set(v.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(xe,ft.remote,gt,bt,Oe)),ni=xe.set(v.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(xe,ii,gt)),yi=xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(xe,Dt,Ut,ii,ni)),Ci=xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(xe,ii)),ri=xe.set(v.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(xe,je,_e)),Di=xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(xe)),Ii=xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(xe));xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(xe,vt,_e,je,bt));const zi=Object.values(v.ExtHostContext);xe.assertRegistered(zi);const Wi=new De.ExtHostBulkEdits(xe,_e),Hi=new f.ExtHostClipboard(xe),ki=new h.ExtHostMessageService(xe,bt),Ri=new E.ExtHostDialogs(xe),Li=new q.ExtHostStatusBar(xe,je.converter);return w.ExtHostApiCommands.register(je),function(ze,jt,Oi){const wt=function(){let ge=!ze.isUnderDevelopment;function ve(){ge||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(ot){if(Array.isArray(ot))ot.forEach(Be);else if(typeof ot=="string")ve();else{const It=ot;typeof It.scheme>"u"&&ve(),typeof It.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),ji={getSession(ge,ve,Be){return ti.getSession(ze,ge,ve,Be)},async hasSession(ge,ve){return(0,$e.checkProposedApiEnabled)(ze,"authSession"),!!await ti.getSession(ze,ge,ve,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ge,ve,Be,ot){return ti.registerAuthenticationProvider(ge,ve,Be,ot)}},di={registerCommand(ge,ve,Be){return je.registerCommand(!0,ge,ve,Be,void 0,ze)},registerTextEditorCommand(ge,ve,Be){return je.registerCommand(!0,ge,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{ve.apply(Be,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+ge+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,ve,Be)=>((0,$e.checkProposedApiEnabled)(ze,"diffCommand"),je.registerCommand(!0,ge,async(...ot)=>{const It=_e.activeEditor(!0);if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);ve.apply(Be,[Ot,...ot])},void 0,void 0,ze)),executeCommand(ge,...ve){return je.executeCommand(ge,...ve)},getCommands(ge=!1){return je.getCommands(ge)}},Ni={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(ze,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return(0,$e.checkProposedApiEnabled)(ze,"telemetryLogger"),Tt.instantiateLogger(ze,ge)},openExternal(ge,ve){return Se.openUri(ge,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ft.environment.appUriScheme)return Ct.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!ft.remote.authority})}catch(ve){if((0,ae.matchesScheme)(ge,rt.Schemas.http)||(0,ae.matchesScheme)(ge,rt.Schemas.https))return ge;throw ve}},get remoteName(){return(0,G.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,ve,Be){return ri.createTestController(ze,ge,ve,Be)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.results}},hi=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ge,ve){(0,$e.isProposedApiEnabled)(ze,"extensionsAny")||(ve=!1);const Be=jt.mine.getExtensionDescription(ge);if(Be)return new a.Extension(Rt,ze.identifier,Be,hi,!1);if(ve){const ot=jt.all.getExtensionDescription(ge);if(ot)return new a.Extension(Rt,ze.identifier,ot,hi,!0)}},get all(){const ge=[];for(const ve of jt.mine.getAllExtensionDescriptions())ge.push(new a.Extension(Rt,ze.identifier,ve,hi,!1));return ge},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(ze,"extensionsAny");const ge=new $e.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ve=[];for(const Be of jt.all.getAllExtensionDescriptions()){const ot=!ge.has(Be.identifier);ve.push(new a.Extension(Rt,ze.identifier,Be,hi,ot))}return ve},get onDidChange(){return(0,$e.isProposedApiEnabled)(ze,"extensionsAny")?P.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Ti={createDiagnosticCollection(ge){return ai.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ge,ve){return ei.changeLanguage(ge.uri,ve)},match(ge,ve){const Be=Dt.getDocumentData(ve.uri)?.notebook;return(0,L.score)(z.LanguageSelector.from(ge),ve.uri,ve.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider(ge,ve,Be){return ut.registerCodeActionProvider(ze,wt(ge),ve,Be)},registerDocumentPasteEditProvider(ge,ve,Be){return(0,$e.checkProposedApiEnabled)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,wt(ge),ve,Be)},registerCodeLensProvider(ge,ve){return ut.registerCodeLensProvider(ze,wt(ge),ve)},registerDefinitionProvider(ge,ve){return ut.registerDefinitionProvider(ze,wt(ge),ve)},registerDeclarationProvider(ge,ve){return ut.registerDeclarationProvider(ze,wt(ge),ve)},registerImplementationProvider(ge,ve){return ut.registerImplementationProvider(ze,wt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return ut.registerTypeDefinitionProvider(ze,wt(ge),ve)},registerHoverProvider(ge,ve){return ut.registerHoverProvider(ze,wt(ge),ve,ze.identifier)},registerEvaluatableExpressionProvider(ge,ve){return ut.registerEvaluatableExpressionProvider(ze,wt(ge),ve,ze.identifier)},registerInlineValuesProvider(ge,ve){return ut.registerInlineValuesProvider(ze,wt(ge),ve,ze.identifier)},registerDocumentHighlightProvider(ge,ve){return ut.registerDocumentHighlightProvider(ze,wt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return ut.registerLinkedEditingRangeProvider(ze,wt(ge),ve)},registerReferenceProvider(ge,ve){return ut.registerReferenceProvider(ze,wt(ge),ve)},registerRenameProvider(ge,ve){return ut.registerRenameProvider(ze,wt(ge),ve)},registerDocumentSymbolProvider(ge,ve,Be){return ut.registerDocumentSymbolProvider(ze,wt(ge),ve,Be)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,ve){return ut.registerDocumentFormattingEditProvider(ze,wt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return ut.registerDocumentRangeFormattingEditProvider(ze,wt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,Be,...ot){return ut.registerOnTypeFormattingEditProvider(ze,wt(ge),ve,[Be].concat(ot))},registerDocumentSemanticTokensProvider(ge,ve,Be){return ut.registerDocumentSemanticTokensProvider(ze,wt(ge),ve,Be)},registerDocumentRangeSemanticTokensProvider(ge,ve,Be){return ut.registerDocumentRangeSemanticTokensProvider(ze,wt(ge),ve,Be)},registerSignatureHelpProvider(ge,ve,Be,...ot){return typeof Be=="object"?ut.registerSignatureHelpProvider(ze,wt(ge),ve,Be):ut.registerSignatureHelpProvider(ze,wt(ge),ve,typeof Be>"u"?[]:[Be,...ot])},registerCompletionItemProvider(ge,ve,...Be){return ut.registerCompletionItemProvider(ze,wt(ge),ve,Be)},registerInlineCompletionItemProvider(ge,ve){return ve.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,wt(ge),ve)},registerDocumentLinkProvider(ge,ve){return ut.registerDocumentLinkProvider(ze,wt(ge),ve)},registerColorProvider(ge,ve){return ut.registerColorProvider(ze,wt(ge),ve)},registerFoldingRangeProvider(ge,ve){return ut.registerFoldingRangeProvider(ze,wt(ge),ve)},registerSelectionRangeProvider(ge,ve){return ut.registerSelectionRangeProvider(ze,ge,ve)},registerCallHierarchyProvider(ge,ve){return ut.registerCallHierarchyProvider(ze,ge,ve)},registerTypeHierarchyProvider(ge,ve){return ut.registerTypeHierarchyProvider(ze,ge,ve)},setLanguageConfiguration:(ge,ve)=>ut.setLanguageConfiguration(ze,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,$e.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return ut.registerInlayHintsProvider(ze,ge,ve)},createLanguageStatusItem(ge,ve){return ei.createLanguageStatusItem(ze,ge,ve)},registerDocumentDropEditProvider(ge,ve){return ut.registerDocumentOnDropEditProvider(ze,ge,ve)}},Gi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ge,ve,Be){const ot=await(k.URI.isUri(ge)?Promise.resolve(Gt.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(ot,ve,Be)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,ve,Be){return Lt.onDidChangeActiveTextEditor(ge,ve,Be)},onDidChangeVisibleTextEditors(ge,ve,Be){return Lt.onDidChangeVisibleTextEditors(ge,ve,Be)},onDidChangeTextEditorSelection(ge,ve,Be){return Lt.onDidChangeTextEditorSelection(ge,ve,Be)},onDidChangeTextEditorOptions(ge,ve,Be){return Lt.onDidChangeTextEditorOptions(ge,ve,Be)},onDidChangeTextEditorVisibleRanges(ge,ve,Be){return Lt.onDidChangeTextEditorVisibleRanges(ge,ve,Be)},onDidChangeTextEditorViewColumn(ge,ve,Be){return Lt.onDidChangeTextEditorViewColumn(ge,ve,Be)},onDidCloseTerminal(ge,ve,Be){return it.onDidCloseTerminal(ge,ve,Be)},onDidOpenTerminal(ge,ve,Be){return it.onDidOpenTerminal(ge,ve,Be)},onDidChangeActiveTerminal(ge,ve,Be){return it.onDidChangeActiveTerminal(ge,ve,Be)},onDidChangeTerminalDimensions(ge,ve,Be){return(0,$e.checkProposedApiEnabled)(ze,"terminalDimensions"),it.onDidChangeTerminalDimensions(ge,ve,Be)},onDidChangeTerminalState(ge,ve,Be){return it.onDidChangeTerminalState(ge,ve,Be)},onDidWriteTerminalData(ge,ve,Be){return(0,$e.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ge,ve,Be)},get state(){return Se.state},onDidChangeWindowState(ge,ve,Be){return Se.onDidChangeWindowState(ge,ve,Be)},showInformationMessage(ge,...ve){return ki.showMessage(ze,R.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return ki.showMessage(ze,R.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return ki.showMessage(ze,R.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,Be){return Qt.showQuickPick(ge,ve,Be)},showWorkspaceFolderPick(ge){return Qt.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return Qt.showInput(ge,ve)},showOpenDialog(ge){return Ri.showOpenDialog(ge)},showSaveDialog(ge){return Ri.showSaveDialog(ge)},createStatusBarItem(ge,ve,Be){let ot,It,Ot;return typeof ge=="string"?(ot=ge,It=ve,Ot=Be):(It=ge,Ot=ve),Li.createStatusBarEntry(ze,ot,It,Ot)},setStatusBarMessage(ge,ve){return Li.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Oe.report("window.withScmProgress",ze,"Use 'withProgress' instead."),li.withProgress(ze,{location:j.ProgressLocation.SourceControl},(ve,Be)=>ge({report(ot){}}))},withProgress(ge,ve){return li.withProgress(ze,ge,ve)},createOutputChannel(ge,ve){return yt.createOutputChannel(ge,ve,ze)},createWebviewPanel(ge,ve,Be,ot){return ni.createWebviewPanel(ze,ge,ve,Be,ot)},createWebviewTextEditorInset(ge,ve,Be,ot){return(0,$e.checkProposedApiEnabled)(ze,"editorInsets"),wi.createWebviewEditorInset(ge,ve,Be,ot,ze)},createTerminal(ge,ve,Be){return typeof ge=="object"?"pty"in ge?it.createExtensionTerminal(ge):it.createTerminalFromOptions(ge):it.createTerminal(ge,ve,Be)},registerTerminalLinkProvider(ge){return it.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return it.registerProfileProvider(ze,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,$e.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),it.registerTerminalQuickFixProvider(ge,ze.identifier.value,ve)},registerTreeDataProvider(ge,ve){return Ht.registerTreeDataProvider(ge,ve,ze)},createTreeView(ge,ve){return Ht.createTreeView(ge,ve,ze)},registerWebviewPanelSerializer:(ge,ve)=>ni.registerWebviewPanelSerializer(ze,ge,ve),registerCustomEditorProvider:(ge,ve,Be={})=>yi.registerCustomEditorProvider(ze,ge,ve,Be),registerFileDecorationProvider(ge){return He.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return Ct.registerUriHandler(ze.identifier,ge)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,Be){return ui.onDidChangeActiveColorTheme(ge,ve,Be)},registerWebviewViewProvider(ge,ve,Be){return Ci.registerWebviewViewProvider(ze,ge,ve,Be?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,Be){return vt.onDidChangeActiveNotebookEditor(ge,ve,Be)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,ve,Be){return oi.onDidChangeNotebookEditorSelection(ge,ve,Be)},onDidChangeNotebookEditorVisibleRanges(ge,ve,Be){return oi.onDidChangeNotebookEditorVisibleRanges(ge,ve,Be)},showNotebookDocument(ge,ve){return vt.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,Be){return(0,$e.checkProposedApiEnabled)(ze,"externalUriOpener"),Di.registerExternalUriOpener(ze.identifier,ge,ve,Be)},registerProfileContentHandler(ge,ve){return(0,$e.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ii.registrProfileContentHandler(ze,ge,ve)},async registerQuickDiffProvider(ge,ve,Be){return(0,$e.checkProposedApiEnabled)(ze,"quickDiffProvider"),vi.registerQuickDiffProvider(ge,ve,Be)},get tabGroups(){return Ne.tabGroups}},Gt={get rootPath(){return Oe.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return gt.getWorkspaceFolder(ge)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(ge){throw t.readonly()},get workspaceFile(){return gt.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,ve,...Be)=>gt.updateWorkspaceFolders(ze,ge,ve||0,...Be),onDidChangeWorkspaceFolders:function(ge,ve,Be){return gt.onDidChangeWorkspace(ge,ve,Be)},asRelativePath:(ge,ve)=>gt.getRelativePath(ge,ve),findFiles:(ge,ve,Be,ot)=>gt.findFiles(ge,ve,Be,ze.identifier,ot),findTextInFiles:(ge,ve,Be,ot)=>{(0,$e.checkProposedApiEnabled)(ze,"findTextInFiles");let It,Ot;return typeof ve=="object"?(It=ve,Ot=Be):(It={},Ot=ve,ot=Be),gt.findTextInFiles(ge,It||{},Ot,ze.identifier,ot)},saveAll:ge=>gt.saveAll(ge),applyEdit(ge,ve){return Wi.applyWorkspaceEdit(ge,ze,ve)},createFileSystemWatcher:(ge,ve,Be,ot)=>Bt.createFileSystemWatcher(gt,ze,ge,ve,Be,ot),get textDocuments(){return Dt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let ve;const Be=ge;if(typeof ge=="string")ve=Promise.resolve(k.URI.file(ge));else if(k.URI.isUri(ge))ve=Promise.resolve(ge);else if(!Be||typeof Be=="object")ve=Dt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ot=>Dt.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(ge,ve,Be)=>Dt.onDidAddDocument(ge,ve,Be),onDidCloseTextDocument:(ge,ve,Be)=>Dt.onDidRemoveDocument(ge,ve,Be),onDidChangeTextDocument:(ge,ve,Be)=>Dt.onDidChangeDocument(ge,ve,Be),onDidSaveTextDocument:(ge,ve,Be)=>Dt.onDidSaveDocument(ge,ve,Be),onWillSaveTextDocument:(ge,ve,Be)=>Jt.getOnWillSaveTextDocumentEvent(ze)(ge,ve,Be),get notebookDocuments(){return vt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let Be;if(k.URI.isUri(ge))Be=ge,await vt.openNotebookDocument(ge);else if(typeof ge=="string")Be=k.URI.revive(await vt.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,ve,Be){return si.onDidSaveNotebookDocument(ge,ve,Be)},onDidChangeNotebookDocument(ge,ve,Be){return si.onDidChangeNotebookDocument(ge,ve,Be)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,ve,Be,ot){return vt.registerNotebookSerializer(ze,ge,ve,Be,(0,$e.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,ve,Be)=>Oi.onDidChangeConfiguration(ge,ve,Be),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,Oi.getConfiguration(ge,ve,ze)},registerTextDocumentContentProvider(ge,ve){return qt.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Oe.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(ze,ge,ve)),registerFileSystemProvider(ge,ve,Be){return(0,Le.combinedDisposable)(Bi.registerFileSystemProvider(ze,ge,ve,Be),Xt.addFileSystemProvider(ge,ve))},get fs(){return Xt.value},registerFileSearchProvider:(ge,ve)=>((0,$e.checkProposedApiEnabled)(ze,"fileSearchProvider"),Pt.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,$e.checkProposedApiEnabled)(ze,"textSearchProvider"),Pt.registerTextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,ve,Be)=>Bt.onDidCreateFile(ge,ve,Be),onDidDeleteFiles:(ge,ve,Be)=>Bt.onDidDeleteFile(ge,ve,Be),onDidRenameFiles:(ge,ve,Be)=>Bt.onDidRenameFile(ge,ve,Be),onWillCreateFiles:(ge,ve,Be)=>Bt.getOnWillCreateFileEvent(ze)(ge,ve,Be),onWillDeleteFiles:(ge,ve,Be)=>Bt.getOnWillDeleteFileEvent(ze)(ge,ve,Be),onWillRenameFiles:(ge,ve,Be)=>Bt.getOnWillRenameFileEvent(ze)(ge,ve,Be),openTunnel:ge=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.openTunnel(ze,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(ge,ve,Be)=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.onDidChangeTunnels(ge,ve,Be)),registerPortAttributesProvider:(ge,ve)=>((0,$e.checkProposedApiEnabled)(ze,"portsAttributes"),Re.registerPortsAttributesProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,$e.checkProposedApiEnabled)(ze,"timeline"),$i.registerTimelineProvider(ge,ve,ze.identifier,je.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:ge=>((0,$e.checkProposedApiEnabled)(ze,"workspaceTrust"),gt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,Be)=>gt.onDidGrantWorkspaceTrust(ge,ve,Be),registerEditSessionIdentityProvider:(ge,ve)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(ge,ve))},fi={get inputBox(){return Oe.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(ze)},createSourceControl(ge,ve,Be){return ci.createSourceControl(ze,ge,ve,Be)}},Ki={createCommentController(ge,ve){return Ei.createCommentController(ze,ge,ve)}},zt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,ve,Be){return lt.onDidStartDebugSession(ge,ve,Be)},onDidTerminateDebugSession(ge,ve,Be){return lt.onDidTerminateDebugSession(ge,ve,Be)},onDidChangeActiveDebugSession(ge,ve,Be){return lt.onDidChangeActiveDebugSession(ge,ve,Be)},onDidReceiveDebugSessionCustomEvent(ge,ve,Be){return lt.onDidReceiveDebugSessionCustomEvent(ge,ve,Be)},onDidChangeBreakpoints(ge,ve,Be){return lt.onDidChangeBreakpoints(ge,ve,Be)},registerDebugConfigurationProvider(ge,ve,Be){return lt.registerDebugConfigurationProvider(ge,ve,Be||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return lt.registerDebugAdapterDescriptorFactory(ze,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return lt.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,Be){return!Be||typeof Be=="object"&&"configuration"in Be?lt.startDebugging(ge,ve,{parentSession:Be}):lt.startDebugging(ge,ve,Be||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return lt.asDebugSourceUri(ge,ve)}},mi={registerTaskProvider:(ge,ve)=>St.registerTaskProvider(ze,ge,ve),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask(ze,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,ve,Be)=>St.onDidStartTask(ge,ve,Be),onDidEndTask:(ge,ve,Be)=>St.onDidEndTask(ge,ve,Be),onDidStartTaskProcess:(ge,ve,Be)=>St.onDidStartTaskProcess(ge,ve,Be),onDidEndTaskProcess:(ge,ve,Be)=>St.onDidEndTaskProcess(ge,ve,Be)},Xi={createNotebookController(ge,ve,Be,ot,It){return Zt.createNotebookController(ze,ge,ve,Be,ot,(0,$e.isProposedApiEnabled)(ze,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>vt.registerNotebookCellStatusBarItemProvider(ze,ge,ve),createRendererMessaging(ge){return bi.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,ve){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,Be){return(0,$e.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ge,ve,Be)}},xi={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return kt.getMessage(ze.identifier.value,{message:ve,args:Be})}return kt.getMessage(ze.identifier.value,ge[0])},get bundle(){return kt.getBundle(ze.identifier.value)},get uri(){return kt.getBundleUri(ze.identifier.value)}};return{version:ft.version,authentication:ji,commands:di,comments:Ki,debug:zt,env:Ni,extensions:qi,l10n:xi,languages:Ti,notebooks:Xi,scm:fi,tasks:mi,tests:Vi,window:Gi,workspace:Gt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:P.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:C.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:D.UIKind,Uri:k.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:ue.TelemetryTrustedValue,LogLevel:Fe.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[309],Ce([1,0,281,318,319,2,320]),function(te,e,c,t,P,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(T,v,D,w,f,d){const m=d.environment.useHostProxy,p=typeof m=="boolean"?m:!d.remote.isRemote,b=(0,k.createProxyResolver)({resolveProxy:g=>T.resolveProxy(g),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(g,i,...l)=>{switch(g){case k.LogLevel.Trace:w.trace(i,...l);break;case k.LogLevel.Debug:w.debug(i,...l);break;case k.LogLevel.Info:w.info(i,...l);break;case k.LogLevel.Warning:w.warn(i,...l);break;case k.LogLevel.Error:w.error(i,...l);break;case k.LogLevel.Critical:w.error(i,...l);break;case k.LogLevel.Off:break;default:o(g,i,l);break}function o(a,s,...u){w.error("Unknown log level",a),w.error(s,...u)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),E=y(v,b);return L(D,E)}e.connectProxyResolver=A;function y(T,v){const D={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(f=>{D.config=T.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(f=>{w.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,k.createHttpPatch)(c,v,{config:"off"},w,!0)),on:Object.assign({},c,(0,k.createHttpPatch)(c,v,{config:"on"},w,!0)),override:Object.assign({},c,(0,k.createHttpPatch)(c,v,{config:"override"},w,!0)),onRequest:Object.assign({},c,(0,k.createHttpPatch)(c,v,D,w,!0)),default:Object.assign(c,(0,k.createHttpPatch)(c,v,D,w,!1))},https:{off:Object.assign({},t,(0,k.createHttpPatch)(t,v,{config:"off"},w,!0)),on:Object.assign({},t,(0,k.createHttpPatch)(t,v,{config:"on"},w,!0)),override:Object.assign({},t,(0,k.createHttpPatch)(t,v,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,k.createHttpPatch)(t,v,D,w,!0)),default:Object.assign(t,(0,k.createHttpPatch)(t,v,D,w,!1))},tls:Object.assign(P,(0,k.createTlsPatch)(P))}}const C=new Map;function L(T,v){return T.getExtensionPathIndex().then(D=>{const w=globalThis._VSCODE_NODE_MODULES.module,f=w._load;w._load=function(m,p,b){if(m==="tls")return v.tls;if(m!=="http"&&m!=="https")return f.apply(this,arguments);const E=v[m],g=D.findSubstr(R.URI.file(p.filename));let i=C.get(g);if(i||C.set(g,i={}),!i[m]){const l=E.default;i[m]={...l}}return i[m]}})}}),define(ye[310],Ce([1,0,82,308,295,309,43,283,2,17,7,280,115,282]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends P.RequireInterceptor{j(){const m=this,p=globalThis._VSCODE_NODE_MODULES.module,b=p._load;p._load=function(l,o,a){return l=g(l),m.a.has(l)?m.a.get(l).load(l,y.URI.file((0,v.realpathSync)(o.filename)),s=>b.apply(this,[s,o,a])):b.apply(this,arguments)};const E=p._resolveLookupPaths;p._resolveLookupPaths=(i,l)=>E.call(this,g(i),l);const g=i=>{for(const l of m.b){const o=l(i);if(o){i=o;break}}return i}}}class f extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(D.ExtHostConsoleForwarder);const m=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const E=this.h.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=E.ipcHandlePath}await this.h.createInstance(w,m,{mine:this.D,all:this.F}).install(),c.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),c.mark("code/extHost/didInitProxyResolver")}ob(m){return m.main}async pb(m,p,b){if(p.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let E=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this.l.flush();const g=m?.identifier.value;m&&await this.s.initializeLocalizedMessages(m);try{g&&c.mark(`code/extHost/willLoadExtensionCode/${g}`),E=te.__$__nodeRequire(p.fsPath)}finally{g&&c.mark(`code/extHost/didLoadExtensionCode/${g}`),b.codeLoadingStop()}return E}async $setRemoteEnvironment(m){if(!!this.f.remote.isRemote)for(const p in m){const b=m[p];b===null?delete process.env[p]:process.env[p]=b}}}e.ExtHostExtensionService=f}),define(ye[145],Ce([1,0,46,321,304,16,61,39,11,8,2,31,80,322,302,100]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(h){this.a=h}provideTextSearchResults(h,S,I,F){return this.a.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((K,q)=>{F.onCancellationRequested(()=>V());const M=l(h,S),B=S.folder.fsPath,O=M.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${d} ${O}
 - cwd: ${B}`);let U=c.spawn(d,M,{cwd:B});U.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),q((0,T.serializeSearchError)(new T.SearchError(X&&X.message,T.SearchErrorCode.rgProcessError)))});let z=!1;const j=new E(S.maxResults,B,S.previewOptions);j.on("result",X=>{z=!0,J="",I.report(X)});let ue=!1;const V=()=>{ue=!0,U?.kill(),j?.cancel()};let _=!1;j.on("hitLimit",()=>{_=!0,V()});let J="";U.stdout.on("data",X=>{j.handleData(X),z||(J+=X)});let ie=!1;U.stdout.once("data",()=>ie=!0);let ee="";U.stderr.on("data",X=>{const G=X.toString();this.a.appendLine(G),ee.length+G.length<1e6&&(ee+=G)}),U.on("close",()=>{if(this.a.appendLine(ie?"Got data from stdout":"No data from stdout"),this.a.appendLine(z?"Got result from parser":"No result from parser"),J&&this.a.appendLine(`Got data without result: ${J}`),this.a.appendLine(""),ue)K({limitHit:_});else{j.flush(),U=null;let X;ee&&!ie&&(X=p(ee))?q((0,T.serializeSearchError)(new T.SearchError(X.message,X.code))):K({limitHit:_})}})})}}e.RipgrepTextSearchEngine=m;function p(n){const h=n.split(`
`),S=h[0].trim();if(h.some(F=>F.startsWith("regex parse error")))return new T.SearchError(b(h),T.SearchErrorCode.regexParseError);const I=S.match(/grep config error: unknown encoding: (.*)/);if(I)return new T.SearchError(`Unknown encoding: ${I[1]}`,T.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new T.SearchError(S.charAt(0).toUpperCase()+S.substr(1),T.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new T.SearchError(S.charAt(0).toUpperCase()+S.substr(1),T.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(S,T.SearchErrorCode.regexParseError)}function b(n){const h=["Regex parse error"],S=n.filter(I=>I.startsWith("PCRE2:"));if(S.length>=1){const I=S[0].replace("PCRE2:","");if(I.indexOf(":")!==-1&&I.split(":").length>=2){const F=I.split(":")[1];h.push(":"+F)}}return h.join("")}class E extends t.EventEmitter{constructor(h,S,I){super(),this.g=h,this.h=S,this.j=I,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new P.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(h,S){return super.on(h,S),this}handleData(h){if(this.b)return;const S=typeof h=="string"?h:this.d.write(h);this.k(S)}k(h){let S=h.indexOf(`
`);const I=this.a+h;if(S>=0)S+=this.a.length;else{this.a=I;return}let F=0;for(;S>=0;)this.m(I.substring(F,S).trim()),F=S+1,S=I.indexOf(`
`,F);this.a=I.substring(F)}m(h){if(this.b||!h)return;let S;try{S=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(S.type==="match"){const I=g(S.data.path),F=L.URI.file(y.join(this.h,I)),K=this.n(S.data,F);this.p(K),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const I=g(S.data.path),F=L.URI.file(y.join(this.h,I));this.o(S.data,F).forEach(q=>this.p(q))}}n(h,S){const I=h.line_number-1,F=g(h.lines),K=Buffer.from(F);let q=0,M=0,B=I;h.submatches.length===0&&h.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(h.submatches.map((U,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=g(U.match),ue=K.slice(q,U.start).toString(),V=i(ue),_=V.numLines>0?V.lastLineLength:V.lastLineLength+M,J=i(j),ie=V.numLines+B,ee=J.numLines+ie,X=J.numLines>0?J.lastLineLength:J.lastLineLength+_;return q=U.end,M=X,B=ee,new v.Range(ie,_,ee,X)}));return(0,f.createTextSearchResult)(S,F,O,this.j)}o(h,S){const I=g(h.lines),F=h.line_number;return I.replace(/\r?\n$/,"").split(`
`).map((K,q)=>({text:K,uri:S,lineNumber:F+q}))}p(h){this.emit("result",h)}}e.RipgrepParser=E;function g(n){return n.bytes?Buffer.from(n.bytes,"base64").toString():n.text}function i(n){const h=/\n/g;let S=0,I=-1,F;for(;F=h.exec(n);)S++,I=F.index;const K=I>=0?n.length-I-1:n.length;return{numLines:S,lastLineLength:K}}function l(n,h){const S=["--hidden"];S.push(n.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:I,otherIncludes:F}=(0,k.groupBy)(h.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const q=new Set;F.forEach(M=>{q.add(M)}),S.push("-g","!*"),q.forEach(M=>{o(M).map(f.anchorGlob).forEach(B=>{S.push("-g",B)})})}I&&I.length&&I.forEach(q=>{S.push("-g",q)}),h.excludes.map(f.anchorGlob).forEach(q=>S.push("-g",`!${q}`)),h.maxFileSize&&S.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),h.followSymlinks&&S.push("--follow"),h.encoding&&h.encoding!=="utf8"&&S.push("--encoding",h.encoding),n.pattern==="--"&&(n.isRegExp=!0,n.pattern="\\-\\-"),n.isMultiline&&!n.isRegExp&&(n.pattern=(0,C.escapeRegExpCharacters)(n.pattern),n.isRegExp=!0),h.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),n.isRegExp&&(n.pattern=a(n.pattern),S.push("--engine","auto"));let K;if(n.isWordMatch){const M=(0,C.createRegExp)(n.pattern,!!n.isRegExp,{wholeWord:n.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",M)}else if(n.isRegExp){let q=u(n.pattern);q=r(q),S.push("--regexp",q)}else K=n.pattern,S.push("--fixed-strings");return S.push("--no-config"),h.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),n.isMultiline&&S.push("--multiline"),h.beforeContext&&S.push("--before-context",h.beforeContext+""),h.afterContext&&S.push("--after-context",h.afterContext+""),S.push("--"),K&&S.push(K),S.push("."),S}function o(n){const h=(0,A.splitGlobAware)(n,"/");return h.map((S,I)=>h.slice(0,I+1).join("/"))}function a(n){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;n.match(h);)n=n.replace(h,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;n.match(S);)n=n.replace(S,"$1\\x{$2}");return n}e.unicodeEscapesToPCRE2=a;const s=n=>n.type==="Assertion"&&n.kind==="lookbehind";function u(n){let h;try{h=new D.RegExpParser().parsePattern(n)}catch{return n}let S="",I=0;const F=(M,B,O)=>{S+=n.slice(I,M)+O,I=B},K=[];return new D.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=K[0];if(!B)F(M.start,M.end,"\\r?\\n");else if(!K.some(s))if(B.type==="CharacterClass")if(B.negate){const O=n.slice(B.start+2,M.start)+n.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?F(B.start,B.end,O?`[^${O}]`:"."):F(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=n.slice(B.start+1,M.start)+n.slice(M.end,B.end-1);F(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){K.unshift(M)},onQuantifierLeave(){K.shift()},onCharacterClassRangeEnter(M){K.unshift(M)},onCharacterClassRangeLeave(){K.shift()},onCharacterClassEnter(M){K.unshift(M)},onCharacterClassLeave(){K.shift()},onAssertionEnter(M){s(M)&&K.push(M)},onAssertionLeave(M){K[0]===M&&K.shift()}}).visit(h),S+=n.slice(I),S}e.fixRegexNewline=u;function r(n){return n.replace(/\n/g,"\\r?\\n")}e.fixNewline=r}),define(ye[311],Ce([1,0,21,145,126,17]),function(te,e,c,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class k{constructor(C){this.b=C,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(C,L,T,v){const D=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const w={...L,folder:L.folder.with({scheme:R.Schemas.file})},f=new P.Progress(d=>T.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>D.provideTextSearchResults(C,w,f,d))}else return this.c(v,w=>D.provideTextSearchResults(C,L,T,w))}async c(C,L){const T=A(C);this.a.add(T);const v=await L(T.token);return this.a.delete(T),v}d(){this.a.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=k;function A(y){const C=new c.CancellationTokenSource;return y.onCancellationRequested(()=>C.cancel()),C}}),define(ye[312],Ce([1,0,29,145,144]),function(te,e,c,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,C,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(D){L({message:D})}},v=new P.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(T),c);return new Promise((D,w)=>v.search(f=>{C(f.map(k))},y).then(f=>D({limitHit:f.limitHit,type:"success",stats:f.stats}),w))}}e.TextSearchEngineAdapter=R;function k(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,C)=>{if(C.ranges){const L=C;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ye[313],Ce([1,0,16,14,9,3,111,11,44,2,40,31,303,312]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(E="searchProcess"){this.d=E,this.b=Object.create(null)}fileSearch(E){let g;const i=m(E),l=new R.Emitter({onDidAddFirstListener:()=>{g=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(v.Engine,i,a=>l.fire(a),o)),g.then(o=>l.fire(o),o=>l.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return l.event}textSearch(E){let g;const i=m(E),l=new R.Emitter({onDidAddFirstListener:()=>{g=(0,t.createCancelablePromise)(o=>this.f(i,a=>l.fire(a),o)),g.then(o=>l.fire(o),o=>l.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return l.event}f(E,g,i){return E.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new D.TextSearchEngineAdapter(E).search(i,g,g)}doFileSearch(E,g,i){return this.doFileSearchWithEngine(v.Engine,E,g,i)}doFileSearchWithEngine(E,g,i,l,o=w.a){let a=0;const s=r=>{Array.isArray(r)?(a+=r.length,i(r.map(n=>this.g(n)))):r.relativePath?(a++,i(this.g(r))):i(r)};if(g.sortByScore){let r=this.k(g,s,l);if(!r){const n=g.maxResults?Object.assign({},g,{maxResults:null}):g,h=new E(n);r=this.h(h,g,i,s,l)}return new Promise((n,h)=>{r.then(([S,I])=>{const F=I.map(K=>this.g(K));this.n(F,i,o),n(S)},h)})}const u=new E(g);return this.q(u,s,o,l).then(r=>({limitHit:r.limitHit,type:"success",stats:{detailStats:r.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}g(E){return{path:E.base?(0,A.join)(E.base,E.relativePath):E.relativePath}}h(E,g,i,l,o){const a=new R.Emitter;let s=(0,t.createCancelablePromise)(r=>{let n=[];const h=S=>{Array.isArray(S)?n=S:(l(S),a.fire(S))};return this.q(E,h,-1,r).then(S=>[S,n])}),u;if(g.cacheKey){u=this.j(g.cacheKey);const r={promise:s,event:a.event,resolved:!1};u.resultsToSearchCache[g.filePattern||""]=r,s.then(()=>{r.resolved=!0},n=>{delete u.resultsToSearchCache[g.filePattern||""]}),s=this.r(s)}return s.then(([r,n])=>{const h=u?u.scorerCache:Object.create(null),S=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.l(g,n,h,o).then(I=>{const F=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:r.stats,sortingTime:F,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:I.length},messages:r.messages,limitHit:r.limitHit||typeof g.maxResults=="number"&&n.length>g.maxResults},I]})})}j(E){const g=this.b[E];return g||(this.b[E]=new f)}k(E,g,i){const l=E.cacheKey&&this.b[E.cacheKey];if(!l)return;const o=this.o(l,E.filePattern||"",g,i);if(o)return o.then(([a,s,u])=>{const r=y.StopWatch.create(!1);return this.l(E,s,l.scorerCache,i).then(n=>{const h=r.elapsed(),S={fromCache:!0,detailStats:u,type:this.d,resultCount:s.length,sortingTime:h};return[{type:"success",limitHit:a.limitHit||typeof E.maxResults=="number"&&s.length>E.maxResults,stats:S},n]})})}l(E,g,i,l){const o=(0,k.prepareQuery)(E.filePattern||""),a=(u,r)=>(0,k.compareItemsByFuzzyScore)(u,r,o,!0,d,i),s=typeof E.maxResults=="number"?E.maxResults:Number.MAX_VALUE;return c.topAsync(g,a,s,1e4,l)}n(E,g,i){if(i&&i>0)for(let l=0;l<E.length;l+=i)g(E.slice(l,l+i));else g(E)}o(E,g,i,l){const o=y.StopWatch.create(!1),a=g.indexOf(A.sep)>=0;let s;for(const h in E.resultsToSearchCache)if(g.startsWith(h)){if(a&&h.indexOf(A.sep)<0&&h!=="")continue;const S=E.resultsToSearchCache[h];s={promise:this.r(S.promise),event:S.event,resolved:S.resolved};break}if(!s)return null;const u=o.elapsed(),r=y.StopWatch.create(!1),n=s.event(i);return l&&l.onCancellationRequested(()=>{n.dispose()}),s.promise.then(([h,S])=>{if(l&&l.isCancellationRequested)throw(0,P.canceled)();const I=[],F=(0,k.prepareQuery)(g).normalizedLowercase;for(const K of S)!(0,T.isFilePatternMatch)(K,F)||I.push(K);return[h,I,{cacheWasResolved:s.resolved,cacheLookupTime:u,cacheFilterTime:r.elapsed(),cacheEntryCount:S.length}]})}q(E,g,i,l){return new Promise((o,a)=>{let s=[];l?.onCancellationRequested(()=>E.cancel()),E.search(u=>{u&&(i?(s.push(u),i>0&&s.length>=i&&(g(s),s=[])):g(u))},u=>{g(u)},(u,r)=>{s.length&&g(s),u?a(u):o(r)})})}clearCache(E){return delete this.b[E],Promise.resolve(void 0)}r(E){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,i){return E.then(g,i)}catch(g){return this.then(void 0,g)}finally(g){return E.finally(g)}}}}e.SearchService=w,w.a=512;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(b){return(0,A.basename)(b.relativePath)}getItemDescription(b){return(0,A.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function m(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(E=>C.URI.revive(E))}}function p(b){return{...b,folder:C.URI.revive(b.folder)}}}),define(ye[314],Ce([1,0,6,17,2,29,13,25,18,84,56,31,313,311,100,144]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends C.ExtHostSearch{constructor(p,b,E,g){super(p,E,g),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new w.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new D.RipgrepSearchProvider(i)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const p=new w.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new D.RipgrepSearchProvider(p)),this.y(t.Schemas.file,new v.SearchService("fileSearchProvider"))}y(p,b){const E=this.d++;return this.v=b,this.t=E,this.c.$registerFileSearchProvider(E,this.o(p)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(E)})}$provideFileSearchResults(p,b,E,g){const i=(0,C.reviveQuery)(E);return p===this.t?this.z(p,b,i,g):super.$provideFileSearchResults(p,b,E,g)}z(p,b,E,g){const i=l=>{if((0,T.isSerializedFileMatch)(l)&&(l=[l]),Array.isArray(l)){this.c.$handleFileMatch(p,b,l.map(o=>P.URI.file(o.path)));return}l.message&&this.n.debug("ExtHostSearch",l.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(E,i,g)}$clearCache(p){return this.v?.clearCache(p),super.$clearCache(p)}q(p,b){return new f.NativeTextSearchManager(p,b,void 0,"textSearchProvider")}};d=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,k.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[315],Ce([1,0,89,286,298,297,314,310,287,83,43,84,81,42,55,78,285,284,13,299,49]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m,p,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,c.registerSingleton)(p.ILoggerService,m.ExtHostLoggerService,1),(0,c.registerSingleton)(f.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,c.registerSingleton)(C.IExtHostDebugService,R.ExtHostDebugService,0),(0,c.registerSingleton)(T.IExtHostSearch,k.NativeExtHostSearch,0),(0,c.registerSingleton)(v.IExtHostTask,P.ExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(w.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,c.registerSingleton)(E.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[323],Ce([1,0,226,324,82,9,118,119,204,95,296,22,29,115,14,121,221,234,300,315]),function(te,e,c,t,P,R,k,A,y,C,L,T,v,D,w,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const p=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=globalThis._VSCODE_NODE_MODULES.module,u=s._load;s._load=function(r){if(r==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const b=process.exit.bind(process);function E(s){process.exit=function(u){if(s)b(u);else{const r=new Error("An extension called process.exit() and this was prevented.");console.warn(r.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(s){b()};function i(){const s=(0,m.readExtHostConnection)(process.env);if(s.type===3)return new Promise((u,r)=>{const n=h=>{const S=h[0],I=new k.BufferedEmitter;S.on("message",F=>I.fire(T.VSBuffer.wrap(F.data))),S.on("close",()=>{g("renderer closed the MessagePort")}),S.start(),u({onMessage:I.event,send:F=>S.postMessage(F.buffer)})};process.parentPort.on("message",h=>n(h.ports))});if(s.type===2)return new Promise((u,r)=>{let n=null;const h=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,I=3e5,F=new w.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),S),K=new w.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),I);process.on("message",(M,B)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=T.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new A.NodeSocket(B,"extHost-socket");else{const z=T.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new A.WebSocketNodeSocket(new A.NodeSocket(B,"extHost-socket"),M.permessageDeflate,z,!1)}n?(F.cancel(),K.cancel(),n.beginAcceptReconnection(U,O),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(h),n=new k.PersistentProtocol({socket:U,initialChunk:O}),n.sendResume(),n.onDidDispose(()=>g("renderer disconnected")),u(n),n.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(K.isScheduled())return;F.isScheduled()&&K.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const u=s.pipeName;return new Promise((r,n)=>{const h=c.createConnection(u,()=>{h.removeListener("error",n);const S=new k.PersistentProtocol({socket:new A.NodeSocket(h,"extHost-renderer")});S.sendResume(),r(S)});h.once("error",n),h.on("close",()=>{g("renderer closed the socket")})})}}async function l(){const s=await i();return new class{constructor(){this.a=new k.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,s.onMessage(u=>{(0,C.isMessageOfType)(u,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||s.send(u)}async drain(){if(s.drain)return s.drain()}}}function o(s){return new Promise(u=>{const r=s.onMessage(n=>{r.dispose();const h=JSON.parse(n.toString()),S=h.commit,I=y.default.commit;if(S&&I&&S!==I&&b(55),h.parentPid){let F=0;setInterval(function(){try{process.kill(h.parentPid,0),F=0}catch(q){q&&q.code==="EPERM"?(F++,F>=3&&g(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):g(`parent process ${h.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let K;try{K=globalThis._VSCODE_NODE_MODULES["native-watchdog"],K.start(h.parentPid)}catch(q){(0,R.onUnexpectedError)(q)}}s.send((0,C.createMessageOfType)(0)),u({protocol:s,initData:h})});s.send((0,C.createMessageOfType)(1))})}async function a(){const s=[];process.on("unhandledRejection",(F,K)=>{s.push(K),setTimeout(()=>{const q=s.indexOf(K);q>=0&&K.catch(M=>{s.splice(q,1),(0,R.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,R.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const K=s.indexOf(F);K>=0&&s.splice(K,1)}),process.on("uncaughtException",function(F){(0,R.onUnexpectedError)(F)}),P.mark("code/extHost/willConnectToRenderer");const u=await l();P.mark("code/extHost/didConnectToRenderer");const r=await o(u);P.mark("code/extHost/didWaitForInitData");const{initData:n}=r;E(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,n.environment.skipWorkspaceStorageLock=(0,f.boolean)(p.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(K){b(K)}exists(K){return v.Promises.exists(K)}realpath(K){return(0,D.realpath)(K)}};let S=null;n.remote.authority&&p.transformURIs&&(S=(0,d.createURITransformer)(n.remote.authority));const I=new L.ExtensionHostMain(r.protocol,n,h,S);g=F=>I.terminate(F)}a().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/243854703b7fa371abb752ec0df7817a615a308b/core/vs/workbench/api/node/extensionHostProcess.js.map
