/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/async","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/codicons","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],n=0,k=te.length;n<k;n++)e[n]=Ie[te[n]];return e};define(Ie[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(C,A){const S=Object.create(null);for(const y of C){const N=A(y);let E=S[N];E||(E=S[N]=[]),E.push(y)}return S}e.groupBy=n;function k(C,A){const S=[],y=[];for(const N of C)A.has(N)||S.push(N);for(const N of A)C.has(N)||y.push(N);return{removed:S,added:y}}e.diffSets=k;function D(C,A){const S=[],y=[];for(const[N,E]of C)A.has(N)||S.push(E);for(const[N,E]of A)C.has(N)||y.push(E);return{removed:S,added:y}}e.diffMaps=D;class M{constructor(){this.a=new Map}add(A,S){let y=this.a.get(A);y||(y=new Set,this.a.set(A,y)),y.add(S)}delete(A,S){const y=this.a.get(A);!y||(y.delete(S),y.size===0&&this.a.delete(A))}forEach(A,S){const y=this.a.get(A);!y||y.forEach(S)}}e.SetMap=M}),define(Ie[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(C){return(A,S,y)=>{let N=null,E=null;if(typeof y.value=="function"?(N="value",E=y.value):typeof y.get=="function"&&(N="get",E=y.get),!E)throw new Error("not supported");y[N]=C(E,S)}}function k(C,A,S){let y=null,N=null;if(typeof S.value=="function"?(y="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",N=S.get),!N)throw new Error("not supported");const E=`$memoize$${A}`;S[y]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,m)}),this[E]}}e.memoize=k;function D(C,A,S){return n((y,N)=>{const E=`$debounce$${N}`,m=`$debounce$result$${N}`;return function(...p){this[m]||(this[m]=S?S():void 0),clearTimeout(this[E]),A&&(this[m]=A(this[m],...p),p=[this[m]]),this[E]=setTimeout(()=>{y.apply(this,p),this[m]=S?S():void 0},C)}})}e.debounce=D;function M(C,A,S){return n((y,N)=>{const E=`$throttle$timer$${N}`,m=`$throttle$result$${N}`,p=`$throttle$lastRun$${N}`,f=`$throttle$pending$${N}`;return function(...s){if(this[m]||(this[m]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...s)),this[f])return;const o=this[p]+C;o<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[m]]),this[m]=S?S():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),y.apply(this,[this[m]]),this[m]=S?S():void 0},o-Date.now()))}})}e.throttle=M}),define(Ie[84],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ie[111],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var k;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function C(r,h=!1){let i=0;const c=r.length;let t="",d=0,a=16,l=0;function g($){let T=0,L=0;for(;T<$;){const V=r.charCodeAt(i);if(V>=48&&V<=57)L=L*16+V-48;else if(V>=65&&V<=70)L=L*16+V-65+10;else if(V>=97&&V<=102)L=L*16+V-97+10;else break;i++,T++}return T<$&&(L=-1),L}function R($){i=$,t="",d=0,a=16,l=0}function O(){const $=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&y(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&y(r.charCodeAt(i)))for(i++;i<r.length&&y(r.charCodeAt(i));)i++;else return l=3,r.substring($,i);let T=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&y(r.charCodeAt(i))){for(i++;i<r.length&&y(r.charCodeAt(i));)i++;T=i}else l=3;return r.substring($,T)}function q(){let $="",T=i;for(;;){if(i>=c){$+=r.substring(T,i),l=2;break}const L=r.charCodeAt(i);if(L===34){$+=r.substring(T,i),i++;break}if(L===92){if($+=r.substring(T,i),i++,i>=c){l=2;break}switch(r.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const j=g(4);j>=0?$+=String.fromCharCode(j):l=4;break}default:l=5}T=i;continue}if(L>=0&&L<=31)if(S(L)){$+=r.substring(T,i),l=2;break}else l=6;i++}return $}function Z(){if(t="",l=0,d=i,i>=c)return d=c,a=17;let $=r.charCodeAt(i);if(A($)){do i++,t+=String.fromCharCode($),$=r.charCodeAt(i);while(A($));return a=15}if(S($))return i++,t+=String.fromCharCode($),$===13&&r.charCodeAt(i)===10&&(i++,t+=`
`),a=14;switch($){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,t=q(),a=10;case 47:{const T=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<c&&!S(r.charCodeAt(i));)i++;return t=r.substring(T,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const L=c-1;let V=!1;for(;i<L;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,l=1),t=r.substring(T,i),a=13}return t+=String.fromCharCode($),i++,a=16}case 45:if(t+=String.fromCharCode($),i++,i===c||!y(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=O(),a=11;default:for(;i<c&&x($);)i++,$=r.charCodeAt(i);if(d!==i){switch(t=r.substring(d,i),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode($),i++,a=16}}function x($){if(A($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=Z();while($>=12&&$<=15);return $}return{setPosition:R,getPosition:()=>i,scan:h?F:Z,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>l}}e.createScanner=C;function A(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function y(r){return r>=48&&r<=57}var N;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(N||(N={}));function E(r,h){const i=[],c=new Object;let t;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(g,R,O,q){d.value=g,d.offset=R,d.length=O,d.type=q,d.colonOffset=void 0,t=d}try{w(r,{onObjectBegin:(g,R)=>{if(h<=g)throw c;t=void 0,a=h>g,i.push("")},onObjectProperty:(g,R,O)=>{if(h<R||(l(g,R,O,"property"),i[i.length-1]=g,h<=R+O))throw c},onObjectEnd:(g,R)=>{if(h<=g)throw c;t=void 0,i.pop()},onArrayBegin:(g,R)=>{if(h<=g)throw c;t=void 0,i.push(0)},onArrayEnd:(g,R)=>{if(h<=g)throw c;t=void 0,i.pop()},onLiteralValue:(g,R,O)=>{if(h<R||(l(g,R,O,v(g)),h<=R+O))throw c},onSeparator:(g,R,O)=>{if(h<=R)throw c;if(g===":"&&t&&t.type==="property")t.colonOffset=R,a=!1,t=void 0;else if(g===","){const q=i[i.length-1];typeof q=="number"?i[i.length-1]=q+1:(a=!0,i[i.length-1]=""),t=void 0}}})}catch(g){if(g!==c)throw g}return{path:i,previousNode:t,isAtPropertyKey:a,matches:g=>{let R=0;for(let O=0;R<g.length&&O<i.length;O++)if(g[R]===i[O]||g[R]==="*")R++;else if(g[R]!=="**")return!1;return R===g.length}}}e.getLocation=E;function m(r,h=[],i=M.DEFAULT){let c=null,t=[];const d=[];function a(g){Array.isArray(t)?t.push(g):c!==null&&(t[c]=g)}return w(r,{onObjectBegin:()=>{const g={};a(g),d.push(t),t=g,c=null},onObjectProperty:g=>{c=g},onObjectEnd:()=>{t=d.pop()},onArrayBegin:()=>{const g=[];a(g),d.push(t),t=g,c=null},onArrayEnd:()=>{t=d.pop()},onLiteralValue:a,onError:(g,R,O)=>{h.push({error:g,offset:R,length:O})}},i),t[0]}e.parse=m;function p(r,h=[],i=M.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(g){c.type==="property"&&(c.length=g-c.offset,c=c.parent)}function d(g){return c.children.push(g),g}w(r,{onObjectBegin:g=>{c=d({type:"object",offset:g,length:-1,parent:c,children:[]})},onObjectProperty:(g,R,O)=>{c=d({type:"property",offset:R,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:g,offset:R,length:O,parent:c})},onObjectEnd:(g,R)=>{c.length=g+R-c.offset,c=c.parent,t(g+R)},onArrayBegin:(g,R)=>{c=d({type:"array",offset:g,length:-1,parent:c,children:[]})},onArrayEnd:(g,R)=>{c.length=g+R-c.offset,c=c.parent,t(g+R)},onLiteralValue:(g,R,O)=>{d({type:v(g),offset:R,length:O,parent:c,value:g}),t(R+O)},onSeparator:(g,R,O)=>{c.type==="property"&&(g===":"?c.colonOffset=R:g===","&&t(R))},onError:(g,R,O)=>{h.push({error:g,offset:R,length:O})}},i);const l=c.children[0];return l&&delete l.parent,l}e.parseTree=p;function f(r,h){if(!r)return;let i=r;for(const c of h)if(typeof c=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===c){i=d.children[1],t=!0;break}if(!t)return}else{const t=c;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}e.findNodeAtLocation=f;function s(r){if(!r.parent||!r.parent.children)return[];const h=s(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;h.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&h.push(i)}return h}e.getNodePath=s;function o(r){switch(r.type){case"array":return r.children.map(o);case"object":{const h=Object.create(null);for(const i of r.children){const c=i.children[1];c&&(h[i.children[0].value]=o(c))}return h}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=o;function u(r,h,i=!1){return h>=r.offset&&h<r.offset+r.length||i&&h===r.offset+r.length}e.contains=u;function b(r,h,i=!1){if(u(r,h,i)){const c=r.children;if(Array.isArray(c))for(let t=0;t<c.length&&c[t].offset<=h;t++){const d=b(c[t],h,i);if(d)return d}return r}}e.findNodeAtOffset=b;function w(r,h,i=M.DEFAULT){const c=C(r,!1);function t(re){return re?()=>re(c.getTokenOffset(),c.getTokenLength()):()=>!0}function d(re){return re?G=>re(G,c.getTokenOffset(),c.getTokenLength()):()=>!0}const a=t(h.onObjectBegin),l=d(h.onObjectProperty),g=t(h.onObjectEnd),R=t(h.onArrayBegin),O=t(h.onArrayEnd),q=d(h.onLiteralValue),Z=d(h.onSeparator),x=t(h.onComment),F=d(h.onError),$=i&&i.disallowComments,T=i&&i.allowTrailingComma;function L(){for(;;){const re=c.scan();switch(c.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(re){case 12:case 13:$?V(10):x();break;case 16:V(1);break;case 15:case 14:break;default:return re}}}function V(re,G=[],H=[]){if(F(re),G.length+H.length>0){let oe=c.getToken();for(;oe!==17;){if(G.indexOf(oe)!==-1){L();break}else if(H.indexOf(oe)!==-1)break;oe=L()}}}function j(re){const G=c.getTokenValue();return re?q(G):l(G),L(),!0}function le(){switch(c.getToken()){case 11:{let re=0;try{re=JSON.parse(c.getTokenValue()),typeof re!="number"&&(V(2),re=0)}catch{V(2)}q(re);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return L(),!0}function _(){return c.getToken()!==10?(V(3,[],[2,5]),!1):(j(!1),c.getToken()===6?(Z(":"),L(),de()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function pe(){a(),L();let re=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(re||V(4,[],[]),Z(","),L(),c.getToken()===2&&T)break}else re&&V(6,[],[]);_()||V(4,[],[2,5]),re=!0}return g(),c.getToken()!==2?V(7,[2],[]):L(),!0}function ue(){R(),L();let re=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(re||V(4,[],[]),Z(","),L(),c.getToken()===4&&T)break}else re&&V(6,[],[]);de()||V(4,[],[4,5]),re=!0}return O(),c.getToken()!==4?V(8,[4],[]):L(),!0}function de(){switch(c.getToken()){case 3:return ue();case 1:return pe();case 10:return j(!0);default:return le()}}return L(),c.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):de()?(c.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=w;function P(r,h){const i=C(r),c=[];let t,d=0,a;do switch(a=i.getPosition(),t=i.scan(),t){case 12:case 13:case 17:d!==a&&c.push(r.substring(d,a)),h!==void 0&&c.push(i.getTokenValue().replace(/[^\r\n]/g,h)),d=i.getPosition();break}while(t!==17);return c.join("")}e.stripComments=P;function v(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ie[28],Ce([1,0]),function(te,e){"use strict";var n,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(f,s,o){let u=f.get(s);return u===void 0&&(u=o,f.set(s,u)),u}e.getOrSet=M;function C(f){const s=[];return f.forEach((o,u)=>{s.push(`${u} => ${o}`)}),`Map(${f.size}) {${s.join(", ")}}`}e.mapToString=C;function A(f){const s=[];return f.forEach(o=>{s.push(o)}),`Set(${f.size}) {${s.join(", ")}}`}e.setToString=A;class S{constructor(s,o){this.uri=s,this.value=o}}class y{constructor(s,o){this[n]="ResourceMap",s instanceof y?(this.b=new Map(s.b),this.c=o??y.a):(this.b=new Map,this.c=s??y.a)}set(s,o){return this.b.set(this.c(s),new S(s,o)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[u,b]of this.b)s(b.value,b.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.ResourceMap=y,y.a=f=>f.toString();class N{constructor(s,o){this[k]="ResourceSet",!s||typeof s=="function"?this.a=new y(s):(this.a=new y(o),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,o){this.a.forEach((u,b)=>s.call(o,b,b,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var E;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class m{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,o=0){const u=this.a.get(s);if(!!u)return o!==0&&this.j(u,o),u.value}set(s,o,u=0){let b=this.a.get(s);if(b)b.value=o,u!==0&&this.j(b,u);else{switch(b={key:s,value:o,next:void 0,previous:void 0},u){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(s,b),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this.a.get(s);if(!!o)return this.a.delete(s),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,o){const u=this.e;let b=this.b;for(;b;){if(o?s.bind(o)(b.value,b.key,this):s(b.value,b.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const s=this,o=this.e;let u=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:u.key,done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return b}values(){const s=this,o=this.e;let u=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:u.value,done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return b}entries(){const s=this,o=this.e;let u=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const w={value:[u.key,u.value],done:!1};return u=u.next,w}else return{value:void 0,done:!0}}};return b}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this.b,u=this.size;for(;o&&u>s;)this.a.delete(o.key),o=o.next,u--;this.b=o,this.d=u,o&&(o.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const o=s.next,u=s.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}s.next=void 0,s.previous=void 0,this.e++}j(s,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this.b)return;const u=s.next,b=s.previous;s===this.c?(b.next=void 0,this.c=b):(u.previous=b,b.next=u),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(o===2){if(s===this.c)return;const u=s.next,b=s.previous;s===this.b?(u.previous=void 0,this.b=u):(u.previous=b,b.next=u),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((o,u)=>{s.push([u,o])}),s}fromJSON(s){this.clear();for(const[o,u]of s)this.set(o,u)}}e.LinkedMap=m;class p extends m{constructor(s,o=1){super(),this.k=s,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[112],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Te,Se){for(var ke=0;ke<Se.length;ke++){var se=Se[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function n(Te,Se,ke){return Se&&e(Te.prototype,Se),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function k(Te,Se){if(!!Te){if(typeof Te=="string")return D(Te,Se);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return D(Te,Se)}}function D(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var ke=0,se=new Array(Se);ke<Se;ke++)se[ke]=Te[ke];return se}function M(Te,Se){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=k(Te))||Se&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function A(Te){te.defaults=Te}var S=/[&<>"']/,y=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(Se){return m[Se]};function f(Te,Se){if(Se){if(S.test(Te))return Te.replace(y,p)}else if(N.test(Te))return Te.replace(E,p);return Te}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(s,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var u=/(^|[^\[])\^/g;function b(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var ke={replace:function(ce,J){return J=J.source||J,J=J.replace(u,"$1"),Te=Te.replace(ce,J),ke},getRegex:function(){return new RegExp(Te,Se)}};return ke}var w=/[^\w:]/g,P=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Te,Se,ke){if(Te){var se;try{se=decodeURIComponent(o(ke)).replace(w,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!P.test(ke)&&(ke=t(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},h=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(Te,Se){r[" "+Te]||(h.test(Te)?r[" "+Te]=Te+"/":r[" "+Te]=g(Te,"/",!0)),Te=r[" "+Te];var ke=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Te.replace(i,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Te.replace(c,"$1")+Se:Te+Se}var d={exec:function(){}};function a(Te){for(var Se=1,ke,se;Se<arguments.length;Se++){ke=arguments[Se];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Te[se]=ke[se])}return Te}function l(Te,Se){var ke=Te.replace(/\|/g,function(J,I,B){for(var W=!1,K=I;--K>=0&&B[K]==="\\";)W=!W;return W?"|":" |"}),se=ke.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function g(Te,Se,ke){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var J=Te.charAt(se-ce-1);if(J===Se&&!ke)ce++;else if(J!==Se&&ke)ce++;else break}return Te.slice(0,se-ce)}function R(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var ke=Te.length,se=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Se[0])se++;else if(Te[ce]===Se[1]&&(se--,se<0))return ce;return-1}function O(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Te,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Te),Se>>=1,Te+=Te;return ke+Te}function Z(Te,Se,ke,se){var ce=Se.href,J=Se.title?f(Se.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var B={type:"link",raw:ke,href:ce,title:J,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,B}return{type:"image",raw:ke,href:ce,title:J,text:f(I)}}function x(Te,Se){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return Se;var se=ke[1];return Se.split(`
`).map(function(ce){var J=ce.match(/^\s+/);if(J===null)return ce;var I=J[0];return I.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var F=function(){function Te(ke){this.options=ke||te.defaults}var Se=Te.prototype;return Se.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var J=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?J:g(J,`
`)}}},Se.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var J=ce[0],I=x(J,ce[3]||"");return{type:"code",raw:J,lang:ce[2]?ce[2].trim():ce[2],text:I}}},Se.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var J=ce[2].trim();if(/#$/.test(J)){var I=g(J,"#");(this.options.pedantic||!I||/ $/.test(I))&&(J=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var J=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var J,I,B,W,K,ee,he,ye,ae,be,Ee,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(J=ce[0],se=se.substring(J.length),ye=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),ee=!1,!ye&&/^ *$/.test(ae)&&(J+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Le=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(be=se.split(`
`,1)[0],ye=be,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Le.test(ye)||ot.test(ye)||it.test(ye)||dt.test(se)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!ee)Ee+=`
`+ye;else break;!ee&&!ye.trim()&&(ee=!0),J+=be+`
`,se=se.substring(be.length+1)}Xe.loose||(he?Xe.loose=!0:/\n *\n *$/.test(J)&&(he=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(Ee),I&&(B=I[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:J,task:!!I,checked:B,loose:!1,text:Ee}),Xe.raw+=J}Xe.items[Xe.items.length-1].raw=J.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(K=0;K<Y;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var Q=Xe.items[K].tokens.filter(function(Me){return Me.type==="space"}),ge=Q.every(function(Me){for(var ze=Me.raw.split(""),Ve=0,Ye=M(ze),nt;!(nt=Ye()).done;){var vt=nt.value;if(vt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&Q.length&&ge&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},Se.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var J={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);J.type="paragraph",J.text=I,J.tokens=this.lexer.inline(I)}return J}},Se.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var J=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var J={type:"table",header:l(ce[1]).map(function(he){return{text:he}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ce[0];var I=J.align.length,B,W,K,ee;for(B=0;B<I;B++)/^ *-+: *$/.test(J.align[B])?J.align[B]="right":/^ *:-+: *$/.test(J.align[B])?J.align[B]="center":/^ *:-+ *$/.test(J.align[B])?J.align[B]="left":J.align[B]=null;for(I=J.rows.length,B=0;B<I;B++)J.rows[B]=l(J.rows[B],J.header.length).map(function(he){return{text:he}});for(I=J.header.length,W=0;W<I;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(I=J.rows.length,W=0;W<I;W++)for(ee=J.rows[W],K=0;K<ee.length;K++)ee[K].tokens=this.lexer.inline(ee[K].text);return J}}},Se.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var J=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Se.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Se.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var J=ce[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var I=g(J.slice(0,-1),"\\");if((J.length-I.length)%2===0)return}else{var B=R(ce[2],"()");if(B>-1){var W=ce[0].indexOf("!")===0?5:4,K=W+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,K).trim(),ce[3]=""}}var ee=ce[2],he="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);ye&&(ee=ye[1],he=ye[3])}else he=ce[3]?ce[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),Z(ce,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(se,ce){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var I=(J[2]||J[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var B=J[0].charAt(0);return{type:"text",raw:B,text:B}}return Z(J,I,J[0],this.lexer)}},Se.emStrong=function(se,ce,J){J===void 0&&(J="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=I[1]||I[2]||"";if(!B||B&&(J===""||this.rules.inline.punctuation.exec(J))){var W=I[0].length-1,K,ee,he=W,ye=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+W);(I=ae.exec(ce))!=null;)if(K=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!K){if(ee=K.length,I[3]||I[4]){he+=ee;continue}else if((I[5]||I[6])&&W%3&&!((W+ee)%3)){ye+=ee;continue}if(he-=ee,!(he>0)){if(ee=Math.min(ee,ee+he+ye),Math.min(W,ee)%2){var be=se.slice(1,W+I.index+ee);return{type:"em",raw:se.slice(0,W+I.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=se.slice(2,W+I.index+ee-1);return{type:"strong",raw:se.slice(0,W+I.index+ee+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var J=ce[2].replace(/\n/g," "),I=/[^ ]/.test(J),B=/^ /.test(J)&&/ $/.test(J);return I&&B&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ce[0],text:J}}},Se.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(se,ce){var J=this.rules.inline.autolink.exec(se);if(J){var I,B;return J[2]==="@"?(I=f(this.options.mangle?ce(J[1]):J[1]),B="mailto:"+I):(I=f(J[1]),B=I),{type:"link",raw:J[0],text:I,href:B,tokens:[{type:"text",raw:I,text:I}]}}},Se.url=function(se,ce){var J;if(J=this.rules.inline.url.exec(se)){var I,B;if(J[2]==="@")I=f(this.options.mangle?ce(J[0]):J[0]),B="mailto:"+I;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);I=f(J[0]),J[1]==="www."?B="http://"+I:B=I}return{type:"link",raw:J[0],text:I,href:B,tokens:[{type:"text",raw:I,text:I}]}}},Se.inlineText=function(se,ce){var J=this.rules.inline.text.exec(se);if(J){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:I=f(this.options.smartypants?ce(J[0]):J[0]),{type:"text",raw:J[0],text:I}}},Te}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=b($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=b(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=b($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=b($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=b($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=b($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=a({},$),$.gfm=a({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=b($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=b($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=a({},$.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:b($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=b(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=b($._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=b(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=b(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=b(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=b(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=b(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=b(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=b(T.reflink).replace("label",T._label).replace("ref",$._label).getRegex(),T.nolink=b(T.nolink).replace("ref",$._label).getRegex(),T.reflinkSearch=b(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=a({},T),T.pedantic=a({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=a({},T.normal,{escape:b(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=b(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=a({},T.gfm,{br:b(T.br).replace("{2,}","*").getRegex(),text:b(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Te){var Se="",ke,se,ce=Te.length;for(ke=0;ke<ce;ke++)se=Te.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var j=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:$.normal,inline:T.normal};this.options.pedantic?(se.block=$.pedantic,se.inline=T.pedantic):this.options.gfm&&(se.block=$.gfm,this.options.breaks?se.inline=T.breaks:se.inline=T.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var J=new Te(ce);return J.lex(se)},Te.lexInline=function(se,ce){var J=new Te(ce);return J.inlineTokens(se)};var Se=Te.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(he,ye,ae){return ye+"    ".repeat(ae.length)});for(var I,B,W,K;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(I=he.call({lexer:J},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+I.raw,B.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,ye=se.slice(1),ae=void 0;J.options.extensions.startBlock.forEach(function(be){ae=be.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(he=Math.min(he,ae))}),he<1/0&&he>=0&&(W=se.substring(0,he+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){B=ce[ce.length-1],K&&B.type==="paragraph"?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(I),K=W.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(I);continue}if(se){var ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ce},Se.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Se.inlineTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]);var I,B,W,K=se,ee,he,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ae.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,ee.index)+"["+q("a",ee[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,ee.index)+"["+q("a",ee[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,ee.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(he||(ye=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(I=Ee.call({lexer:J},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&I.type==="text"&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),B=ce[ce.length-1],B&&I.type==="text"&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(se,K,ye)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(se,V)){se=se.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,V))){se=se.substring(I.raw.length),ce.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=se.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&(W=se.substring(0,Ee+1))}(),I=this.tokenizer.inlineText(W,L)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(ye=I.raw.slice(-1)),he=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):ce.push(I);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ce},n(Te,null,[{key:"rules",get:function(){return{block:$,inline:T}}}]),Te}(),le=function(){function Te(ke){this.options=ke||te.defaults}var Se=Te.prototype;return Se.code=function(se,ce,J){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,I);B!=null&&B!==se&&(J=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+f(I,!0)+'">'+(J?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:f(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ce,J,I){if(this.options.headerIds){var B=this.options.headerPrefix+I.slug(J);return"<h"+ce+' id="'+B+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ce,J){var I=ce?"ol":"ul",B=ce&&J!==1?' start="'+J+'"':"";return"<"+I+B+`>
`+se+"</"+I+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ce){var J=ce.header?"th":"td",I=ce.align?"<"+J+' align="'+ce.align+'">':"<"+J+">";return I+se+("</"+J+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ce,J){if(se=v(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var I='<a href="'+f(se)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+J+"</a>",I},Se.image=function(se,ce,J){if(se=v(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var I='<img src="'+se+'" alt="'+J+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},Se.text=function(se){return se},Te}(),_=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ce,J){return""+J},Se.image=function(se,ce,J){return""+J},Se.br=function(){return""},Te}(),pe=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ce){var J=se,I=0;if(this.seen.hasOwnProperty(J)){I=this.seen[se];do I++,J=se+"-"+I;while(this.seen.hasOwnProperty(J))}return ce||(this.seen[se]=I,this.seen[J]=0),J},Se.slug=function(se,ce){ce===void 0&&(ce={});var J=this.serialize(se);return this.getNextSafeSlug(J,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new pe}Te.parse=function(se,ce){var J=new Te(ce);return J.parse(se)},Te.parseInline=function(se,ce){var J=new Te(ce);return J.parseInline(se)};var Se=Te.prototype;return Se.parse=function(se,ce){ce===void 0&&(ce=!0);var J="",I,B,W,K,ee,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Le,ot,Y=se.length;for(I=0;I<Y;I++){if(Ee=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(ot=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=ot||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,o(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",K=Ee.header.length,B=0;B<K;B++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[B].tokens),{header:!0,align:Ee.align[B]});for(ae+=this.renderer.tablerow(ye),be="",K=Ee.rows.length,B=0;B<K;B++){for(he=Ee.rows[B],ye="",ee=he.length,W=0;W<ee;W++)ye+=this.renderer.tablecell(this.parseInline(he[W].tokens),{header:!1,align:Ee.align[W]});be+=this.renderer.tablerow(ye)}J+=this.renderer.table(ae,be);continue}case"blockquote":{be=this.parse(Ee.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(We=Ee.ordered,He=Ee.start,tt=Ee.loose,K=Ee.items.length,be="",B=0;B<K;B++)et=Ee.items[B],it=et.checked,dt=et.task,Xe="",et.task&&(Le=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Le+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Le+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Le}):Xe+=Le),Xe+=this.parse(et.tokens,tt),be+=this.renderer.listitem(Xe,dt,it);J+=this.renderer.list(be,We,He);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;I+1<Y&&se[I+1].type==="text";)Ee=se[++I],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=ce?this.renderer.paragraph(be):be;continue}default:{var Q='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return J},Se.parseInline=function(se,ce){ce=ce||this.renderer;var J="",I,B,W,K=se.length;for(I=0;I<K;I++){if(B=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(W=this.options.extensions.renderers[B.type].call({parser:this},B),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){J+=W||"";continue}switch(B.type){case"escape":{J+=ce.text(B.text);break}case"html":{J+=ce.html(B.text);break}case"link":{J+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{J+=ce.image(B.href,B.title,B.text);break}case"strong":{J+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{J+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{J+=ce.codespan(B.text);break}case"br":{J+=ce.br();break}case"del":{J+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{J+=ce.text(B.text);break}default:{var ee='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Te}();function de(Te,Se,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=a({},de.defaults,Se||{}),O(Se),ke){var se=Se.highlight,ce;try{ce=j.lex(Te,Se)}catch(K){return ke(K)}var J=function(ee){var he;if(!ee)try{Se.walkTokens&&de.walkTokens(ce,Se.walkTokens),he=ue.parse(ce,Se)}catch(ye){ee=ye}return Se.highlight=se,ee?ke(ee):ke(null,he)};if(!se||se.length<3||(delete Se.highlight,!ce.length))return J();var I=0;de.walkTokens(ce,function(K){K.type==="code"&&(I++,setTimeout(function(){se(K.text,K.lang,function(ee,he){if(ee)return J(ee);he!=null&&he!==K.text&&(K.text=he,K.escaped=!0),I--,I===0&&J()})},0))}),I===0&&J();return}function B(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(K.message+"",!0)+"</pre>";throw K}try{var W=j.lex(Te,Se);if(Se.walkTokens){if(Se.async)return Promise.all(de.walkTokens(W,Se.walkTokens)).then(function(){return ue.parse(W,Se)}).catch(B);de.walkTokens(W,Se.walkTokens)}return ue.parse(W,Se)}catch(K){B(K)}}de.options=de.setOptions=function(Te){return a(de.defaults,Te),A(de.defaults),de},de.getDefaults=C,de.defaults=te.defaults,de.use=function(){for(var Te=arguments.length,Se=new Array(Te),ke=0;ke<Te;ke++)Se[ke]=arguments[ke];var se=a.apply(void 0,[{}].concat(Se)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(I){if(I.extensions&&(J=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var K=ce.renderers?ce.renderers[W.name]:null;K?ce.renderers[W.name]=function(){for(var ee=arguments.length,he=new Array(ee),ye=0;ye<ee;ye++)he[ye]=arguments[ye];var ae=W.renderer.apply(this,he);return ae===!1&&(ae=K.apply(this,he)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=de.defaults.renderer||new le,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=I.renderer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var ee in I.renderer)K(ee);se.renderer=W}(),I.tokenizer&&function(){var W=de.defaults.tokenizer||new F,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=I.tokenizer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var ee in I.tokenizer)K(ee);se.tokenizer=W}(),I.walkTokens){var B=de.defaults.walkTokens;se.walkTokens=function(W){var K=[];return K.push(I.walkTokens.call(this,W)),B&&(K=K.concat(B.call(this,W))),K}}J&&(se.extensions=ce),de.setOptions(se)})},de.walkTokens=function(Te,Se){for(var ke=[],se=function(){var B=J.value;switch(ke=ke.concat(Se.call(de,B)),B.type){case"table":{for(var W=M(B.header),K;!(K=W()).done;){var ee=K.value;ke=ke.concat(de.walkTokens(ee.tokens,Se))}for(var he=M(B.rows),ye;!(ye=he()).done;)for(var ae=ye.value,be=M(ae),Ee;!(Ee=be()).done;){var We=Ee.value;ke=ke.concat(de.walkTokens(We.tokens,Se))}break}case"list":{ke=ke.concat(de.walkTokens(B.items,Se));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[B.type]?de.defaults.extensions.childTokens[B.type].forEach(function(He){ke=ke.concat(de.walkTokens(B[He],Se))}):B.tokens&&(ke=ke.concat(de.walkTokens(B.tokens,Se)))}},ce=M(Te),J;!(J=ce()).done;)se();return ke},de.parseInline=function(Te,Se){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=a({},de.defaults,Se||{}),O(Se);try{var ke=j.lexInline(Te,Se);return Se.walkTokens&&de.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},de.Parser=ue,de.parser=ue.parse,de.Renderer=le,de.TextRenderer=_,de.Lexer=j,de.lexer=j.lex,de.Tokenizer=F,de.Slugger=pe,de.parse=de;var re=de.options,G=de.setOptions,H=de.use,oe=de.walkTokens,ve=de.parseInline,Ae=de,Ue=ue.parse,xe=j.lex;te.Lexer=j,te.Parser=ue,te.Renderer=le,te.Slugger=pe,te.TextRenderer=_,te.Tokenizer=F,te.getDefaults=C,te.lexer=xe,te.marked=de,te.options=re,te.parse=Ae,te.parseInline=ve,te.parser=Ue,te.setOptions=G,te.use=H,te.walkTokens=oe,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ie[113],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(A,S,y){return Math.min(Math.max(A,S),y)}e.clamp=n;function k(A,S){return(S+A%S)%S}e.rot=k;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class M{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const y=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function te(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function C(S){M.push(S,Date.now())}function A(){const S=[];for(let y=0;y<M.length;y+=2)S.push({name:M[y],startTime:M[y+1]});return S}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(D+C.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=n(k))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var k in n)(typeof exports=="object"?exports:te)[k]=n[k]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return te[k].call(D.exports,D,D.exports,n),D.l=!0,D.exports}return n.m=te,n.c=e,n.d=function(k,D,M){n.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:M})},n.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},n.t=function(k,D){if(1&D&&(k=n(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var C in k)n.d(M,C,function(A){return k[A]}.bind(null,C));return M},n.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return n.d(D,"a",D),D},n.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},n.p="",n(n.s=0)}([function(te,e,n){(function(k){var D;e=te.exports=H,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],S=e.src=[],y=0,N=y++;S[N]="0|[1-9]\\d*";var E=y++;S[E]="[0-9]+";var m=y++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;S[p]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var f=y++;S[f]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var s=y++;S[s]="(?:"+S[N]+"|"+S[m]+")";var o=y++;S[o]="(?:"+S[E]+"|"+S[m]+")";var u=y++;S[u]="(?:-("+S[s]+"(?:\\."+S[s]+")*))";var b=y++;S[b]="(?:-?("+S[o]+"(?:\\."+S[o]+")*))";var w=y++;S[w]="[0-9A-Za-z-]+";var P=y++;S[P]="(?:\\+("+S[w]+"(?:\\."+S[w]+")*))";var v=y++,r="v?"+S[p]+S[u]+"?"+S[P]+"?";S[v]="^"+r+"$";var h="[v=\\s]*"+S[f]+S[b]+"?"+S[P]+"?",i=y++;S[i]="^"+h+"$";var c=y++;S[c]="((?:<|>)?=?)";var t=y++;S[t]=S[E]+"|x|X|\\*";var d=y++;S[d]=S[N]+"|x|X|\\*";var a=y++;S[a]="[v=\\s]*("+S[d]+")(?:\\.("+S[d]+")(?:\\.("+S[d]+")(?:"+S[u]+")?"+S[P]+"?)?)?";var l=y++;S[l]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[b]+")?"+S[P]+"?)?)?";var g=y++;S[g]="^"+S[c]+"\\s*"+S[a]+"$";var R=y++;S[R]="^"+S[c]+"\\s*"+S[l]+"$";var O=y++;S[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=y++;S[q]="(?:~>?)";var Z=y++;S[Z]="(\\s*)"+S[q]+"\\s+",A[Z]=new RegExp(S[Z],"g");var x=y++;S[x]="^"+S[q]+S[a]+"$";var F=y++;S[F]="^"+S[q]+S[l]+"$";var $=y++;S[$]="(?:\\^)";var T=y++;S[T]="(\\s*)"+S[$]+"\\s+",A[T]=new RegExp(S[T],"g");var L=y++;S[L]="^"+S[$]+S[a]+"$";var V=y++;S[V]="^"+S[$]+S[l]+"$";var j=y++;S[j]="^"+S[c]+"\\s*("+h+")$|^$";var le=y++;S[le]="^"+S[c]+"\\s*("+r+")$|^$";var _=y++;S[_]="(\\s*)"+S[c]+"\\s*("+h+"|"+S[a]+")",A[_]=new RegExp(S[_],"g");var pe=y++;S[pe]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var ue=y++;S[ue]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var de=y++;S[de]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)D(re,S[re]),A[re]||(A[re]=new RegExp(S[re]));function G(ae,be){if(ae instanceof H)return ae;if(typeof ae!="string"||ae.length>M||!(be?A[i]:A[v]).test(ae))return null;try{return new H(ae,be)}catch{return null}}function H(ae,be){if(ae instanceof H){if(ae.loose===be)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof H))return new H(ae,be);D("SemVer",ae,be),this.loose=be;var Ee=ae.trim().match(be?A[i]:A[v]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<C)return He}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,be){var Ee=G(ae,be);return Ee?Ee.version:null},e.clean=function(ae,be){var Ee=G(ae.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof H||(ae=new H(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},H.prototype.compareMain=function(ae){return ae instanceof H||(ae=new H(ae,this.loose)),ve(this.major,ae.major)||ve(this.minor,ae.minor)||ve(this.patch,ae.patch)},H.prototype.comparePre=function(ae){if(ae instanceof H||(ae=new H(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],We=ae.prerelease[be];if(D("prerelease compare",be,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return ve(Ee,We)}while(++be)},H.prototype.inc=function(ae,be){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,be,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new H(ae,Ee).inc(be,We).version}catch{return null}},e.diff=function(ae,be){if(Te(ae,be))return null;var Ee=G(ae),We=G(be);if(Ee.prerelease.length||We.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return He},e.compareIdentifiers=ve;var oe=/^[0-9]+$/;function ve(ae,be){var Ee=oe.test(ae),We=oe.test(be);return Ee&&We&&(ae=+ae,be=+be),Ee&&!We?-1:We&&!Ee?1:ae<be?-1:ae>be?1:0}function Ae(ae,be,Ee){return new H(ae,Ee).compare(new H(be,Ee))}function Ue(ae,be,Ee){return Ae(ae,be,Ee)>0}function xe(ae,be,Ee){return Ae(ae,be,Ee)<0}function Te(ae,be,Ee){return Ae(ae,be,Ee)===0}function Se(ae,be,Ee){return Ae(ae,be,Ee)!==0}function ke(ae,be,Ee){return Ae(ae,be,Ee)>=0}function se(ae,be,Ee){return Ae(ae,be,Ee)<=0}function ce(ae,be,Ee,We){var He;switch(be){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae!==Ee;break;case"":case"=":case"==":He=Te(ae,Ee,We);break;case"!=":He=Se(ae,Ee,We);break;case">":He=Ue(ae,Ee,We);break;case">=":He=ke(ae,Ee,We);break;case"<":He=xe(ae,Ee,We);break;case"<=":He=se(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+be)}return He}function J(ae,be){if(ae instanceof J){if(ae.loose===be)return ae;ae=ae.value}if(!(this instanceof J))return new J(ae,be);D("comparator",ae,be),this.loose=be,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,be){return ve(be,ae)},e.major=function(ae,be){return new H(ae,be).major},e.minor=function(ae,be){return new H(ae,be).minor},e.patch=function(ae,be){return new H(ae,be).patch},e.compare=Ae,e.compareLoose=function(ae,be){return Ae(ae,be,!0)},e.rcompare=function(ae,be,Ee){return Ae(be,ae,Ee)},e.sort=function(ae,be){return ae.sort(function(Ee,We){return e.compare(Ee,We,be)})},e.rsort=function(ae,be){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,be)})},e.gt=Ue,e.lt=xe,e.eq=Te,e.neq=Se,e.gte=ke,e.lte=se,e.cmp=ce,e.Comparator=J;var I={};function B(ae,be){if(ae instanceof B)return ae.loose===be?ae:new B(ae.raw,be);if(ae instanceof J)return new B(ae.value,be);if(!(this instanceof B))return new B(ae,be);if(this.loose=be,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function K(ae,be,Ee,We,He,tt,Xe,et,it,dt,Le,ot,Y){return((be=W(Ee)?"":W(We)?">="+Ee+".0.0":W(He)?">="+Ee+"."+We+".0":">="+be)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Le)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Le+"-"+ot:"<="+et)).trim()}function ee(ae,be){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(D(ae[Ee].semver),ae[Ee].semver!==I&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===be.major&&We.minor===be.minor&&We.patch===be.patch)return!0}return!1}return!0}function he(ae,be,Ee){try{be=new B(be,Ee)}catch{return!1}return be.test(ae)}function ye(ae,be,Ee,We){var He,tt,Xe,et,it;switch(ae=new H(ae,We),be=new B(be,We),Ee){case">":He=Ue,tt=se,Xe=xe,et=">",it=">=";break;case"<":He=xe,tt=ke,Xe=Ue,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ae,be,We))return!1;for(var dt=0;dt<be.set.length;++dt){var Le=be.set[dt],ot=null,Y=null;if(Le.forEach(function(Q){Q.semver===I&&(Q=new J(">=0.0.0")),ot=ot||Q,Y=Y||Q,He(Q.semver,ot.semver,We)?ot=Q:Xe(Q.semver,Y.semver,We)&&(Y=Q)}),ot.operator===et||ot.operator===it||(!Y.operator||Y.operator===et)&&tt(ae,Y.semver)||Y.operator===it&&Xe(ae,Y.semver))return!1}return!0}J.prototype.parse=function(ae){var be=this.loose?A[j]:A[le],Ee=ae.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new H(Ee[2],this.loose):this.semver=I},J.prototype.toString=function(){return this.value},J.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new H(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ae,be){if(!(ae instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new B(ae.value,be),he(this.value,Ee,be);if(ae.operator==="")return Ee=new B(this.value,be),he(ae.semver,Ee,be);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,be)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(ae){var be=this.loose;ae=ae.trim(),D("range",ae,be);var Ee=be?A[ue]:A[pe];ae=ae.replace(Ee,K),D("hyphen replace",ae),ae=ae.replace(A[_],"$1$2$3"),D("comparator trim",ae,A[_]),ae=(ae=(ae=ae.replace(A[Z],"$1~")).replace(A[T],"$1^")).split(/\s+/).join(" ");var We=be?A[j]:A[le],He=ae.split(" ").map(function(tt){return function(Xe,et){return D("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Le){return function(ot,Y){D("caret",ot,Y);var Q=Y?A[V]:A[L];return ot.replace(Q,function(ge,Me,ze,Ve,Ye){var nt;return D("caret",ot,ge,Me,ze,Ve,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=Me==="0"?">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+".0 <"+(+Me+1)+".0.0":Ye?(D("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+Ye+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+Ye+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+Ye+" <"+(+Me+1)+".0.0"):(D("no pr"),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+" <"+(+Me+1)+".0.0"),D("caret return",nt),nt})}(Le,dt)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Le){return function(ot,Y){var Q=Y?A[F]:A[x];return ot.replace(Q,function(ge,Me,ze,Ve,Ye){var nt;return D("tilde",ot,ge,Me,ze,Ve,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":Ye?(D("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=">="+Me+"."+ze+"."+Ve+Ye+" <"+Me+"."+(+ze+1)+".0"):nt=">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0",D("tilde return",nt),nt})}(Le,dt)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(it,dt){return D("replaceXRanges",it,dt),it.split(/\s+/).map(function(Le){return function(ot,Y){ot=ot.trim();var Q=Y?A[R]:A[g];return ot.replace(Q,function(ge,Me,ze,Ve,Ye,nt){D("xRange",ot,ge,Me,ze,Ve,Ye,nt);var vt=W(ze),wt=vt||W(Ve),Ct=wt||W(Ye);return Me==="="&&Ct&&(Me=""),vt?ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(wt&&(Ve=0),Ct&&(Ye=0),Me===">"?(Me=">=",wt?(ze=+ze+1,Ve=0,Ye=0):Ct&&(Ve=+Ve+1,Ye=0)):Me==="<="&&(Me="<",wt?ze=+ze+1:Ve=+Ve+1),ge=Me+ze+"."+Ve+"."+Ye):wt?ge=">="+ze+".0.0 <"+(+ze+1)+".0.0":Ct&&(ge=">="+ze+"."+Ve+".0 <"+ze+"."+(+Ve+1)+".0"),D("xRange return",ge),ge})}(Le,dt)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(it,dt){return D("replaceStars",it,dt),it.trim().replace(A[de],"")}(Xe,et),D("stars",Xe),Xe}(tt,be)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new J(tt,be)})},B.prototype.intersects=function(ae,be){if(!(ae instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,be)})})})})},e.toComparators=function(ae,be){return new B(ae,be).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},B.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new H(ae,this.loose));for(var be=0;be<this.set.length;be++)if(ee(this.set[be],ae))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new H(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new H(We=Xe,Ee)))}),We},e.validRange=function(ae,be){try{return new B(ae,be).range||"*"}catch{return null}},e.ltr=function(ae,be,Ee){return ye(ae,be,"<",Ee)},e.gtr=function(ae,be,Ee){return ye(ae,be,">",Ee)},e.outside=ye,e.prerelease=function(ae,be){var Ee=G(ae,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,be,Ee){return ae=new B(ae,Ee),be=new B(be,Ee),ae.intersects(be)},e.coerce=function(ae){if(ae instanceof H)return ae;if(typeof ae!="string")return null;var be=ae.match(A[O]);return be==null?null:G((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,n(1))},function(te,e){var n,k,D=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(o){if(n===setTimeout)return setTimeout(o,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{k=typeof clearTimeout=="function"?clearTimeout:C}catch{k=C}})();var S,y=[],N=!1,E=-1;function m(){N&&S&&(N=!1,S.length?y=S.concat(y):E=-1,y.length&&p())}function p(){if(!N){var o=A(m);N=!0;for(var u=y.length;u;){for(S=y,y=[];++E<u;)S&&S[E].run();E=-1,u=y.length}S=null,N=!1,function(b){if(k===clearTimeout)return clearTimeout(b);if((k===C||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(b);try{k(b)}catch{try{return k.call(null,b)}catch{return k.call(this,b)}}}(o)}}function f(o,u){this.fun=o,this.array=u}function s(){}D.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)u[b-1]=arguments[b];y.push(new f(o,u)),y.length!==1||N||A(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=s,D.addListener=s,D.once=s,D.off=s,D.removeListener=s,D.removeAllListeners=s,D.emit=s,D.prependListener=s,D.prependOnceListener=s,D.listeners=function(o){return[]},D.binding=function(o){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(o){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ie[114],Ce([1,0,11,6]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(P){const v=P;return v?typeof v.read=="function":!1}e.isReadable=D;function M(P){const v=P;return v?[v.on,v.pause,v.resume,v.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=M;function C(P){const v=P;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(P,v){return new S(P,v)}e.newWriteableStream=A;class S{constructor(v,r){this.e=v,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(r=>r(v))}h(v){this.c.error.length===0?(0,n.onUnexpectedError)(v):this.c.error.slice(0).forEach(r=>r(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,r){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(v,r){if(this.a.destroyed)return;let h;switch(v){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const i=h.indexOf(r);i>=0&&h.splice(i,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(P,v){const r=[];let h;for(;(h=P.read())!==null;)r.push(h);return v(r)}e.consumeReadable=y;function N(P,v,r){const h=[];let i;for(;(i=P.read())!==null&&h.length<r;)h.push(i);return i===null&&h.length>0?v(h):{read:()=>{if(h.length>0)return h.shift();if(typeof i<"u"){const c=i;return i=void 0,c}return P.read()}}}e.peekReadable=N;function E(P,v){return new Promise((r,h)=>{const i=[];m(P,{onData:c=>{v&&i.push(c)},onError:c=>{v?h(c):r(void 0)},onEnd:()=>{r(v?v(i):void 0)}})})}e.consumeStream=E;function m(P,v){let r=!1;return P.on("error",h=>{r||v.onError(h)}),P.on("end",()=>{r||v.onEnd()}),P.on("data",h=>{r||v.onData(h)}),(0,k.toDisposable)(()=>r=!0)}e.listenStream=m;function p(P,v){return new Promise((r,h)=>{const i=new k.DisposableStore,c=[],t=l=>{if(c.push(l),c.length>v)return i.dispose(),P.pause(),r({stream:P,buffer:c,ended:!1})},d=l=>h(l),a=()=>r({stream:P,buffer:c,ended:!0});i.add((0,k.toDisposable)(()=>P.removeListener("error",d))),P.on("error",d),i.add((0,k.toDisposable)(()=>P.removeListener("end",a))),P.on("end",a),i.add((0,k.toDisposable)(()=>P.removeListener("data",t))),P.on("data",t)})}e.peekStream=p;function f(P,v){const r=A(v);return r.end(P),r}e.toStream=f;function s(){const P=A(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=s;function o(P){let v=!1;return{read:()=>v?null:(v=!0,P)}}e.toReadable=o;function u(P,v,r){const h=A(r);return m(P,{onData:i=>h.write(v.data(i)),onError:i=>h.error(v.error?v.error(i):i),onEnd:()=>h.end()}),h}e.transform=u;function b(P,v,r){let h=!1;return{read:()=>{const i=v.read();return h?i:(h=!0,i!==null?r([P,i]):P)}}}e.prefixedReadable=b;function w(P,v,r){let h=!1;const i=A(r);return m(v,{onData:c=>h?i.write(c):(h=!0,i.write(r([P,c]))),onError:c=>i.error(c),onEnd:()=>{h||(h=!0,i.write(P)),i.end()}}),i}e.prefixedStream=w}),define(Ie[23],Ce([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let D,M;class C{static alloc(l){return k?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return k&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,g){return!(g?.dontUseNodeBuffer||!1)&&k?new C(Buffer.from(l)):(D||(D=new TextEncoder),new C(D.encode(l)))}static fromByteArray(l){const g=C.alloc(l.length);for(let R=0,O=l.length;R<O;R++)g.buffer[R]=l[R];return g}static concat(l,g){if(typeof g>"u"){g=0;for(let q=0,Z=l.length;q<Z;q++)g+=l[q].byteLength}const R=C.alloc(g);let O=0;for(let q=0,Z=l.length;q<Z;q++){const x=l[q];R.set(x,O),O+=x.byteLength}return R}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return k?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(l,g){return new C(this.buffer.subarray(l,g))}set(l,g){if(l instanceof C)this.buffer.set(l.buffer,g);else if(l instanceof Uint8Array)this.buffer.set(l,g);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),g);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return y(this.buffer,l)}writeUInt32BE(l,g){N(this.buffer,l,g)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,g){m(this.buffer,l,g)}readUInt8(l){return p(this.buffer,l)}writeUInt8(l,g){f(this.buffer,l,g)}}e.VSBuffer=C;function A(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=A;function S(a,l,g){a[g+0]=l&255,l=l>>>8,a[g+1]=l&255}e.writeUInt16LE=S;function y(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=y;function N(a,l,g){a[g+3]=l,l=l>>>8,a[g+2]=l,l=l>>>8,a[g+1]=l,l=l>>>8,a[g]=l}e.writeUInt32BE=N;function E(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=E;function m(a,l,g){a[g+0]=l&255,l=l>>>8,a[g+1]=l&255,l=l>>>8,a[g+2]=l&255,l=l>>>8,a[g+3]=l&255}e.writeUInt32LE=m;function p(a,l){return a[l]}e.readUInt8=p;function f(a,l,g){a[g]=l}e.writeUInt8=f;function s(a){return n.consumeReadable(a,l=>C.concat(l))}e.readableToBuffer=s;function o(a){return n.toReadable(a)}e.bufferToReadable=o;function u(a){return n.consumeStream(a,l=>C.concat(l))}e.streamToBuffer=u;async function b(a){return a.ended?C.concat(a.buffer):C.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=b;function w(a){return n.toStream(a,l=>C.concat(l))}e.bufferToStream=w;function P(a){return n.transform(a,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=P;function v(a){return n.newWriteableStream(l=>C.concat(l),a)}e.newWriteableBufferStream=v;function r(a,l){return n.prefixedReadable(a,l,g=>C.concat(g))}e.prefixedBufferReadable=r;function h(a,l){return n.prefixedStream(a,l,g=>C.concat(g))}e.prefixedBufferStream=h;function i(a){let l=0,g=0,R=0;const O=new Uint8Array(Math.floor(a.length/4*3)),q=x=>{switch(g){case 3:O[R++]=l|x,g=0;break;case 2:O[R++]=l|x>>>2,l=x<<6,g=3;break;case 1:O[R++]=l|x>>>4,l=x<<4,g=2;break;default:l=x<<2,g=1}};for(let x=0;x<a.length;x++){const F=a.charCodeAt(x);if(F>=65&&F<=90)q(F-65);else if(F>=97&&F<=122)q(F-97+26);else if(F>=48&&F<=57)q(F-48+52);else if(F===43||F===45)q(62);else if(F===47||F===95)q(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${a[x]}`)}}const Z=R;for(;g>0;)q(0);return C.wrap(O).slice(0,Z)}e.decodeBase64=i;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:a},l=!0,g=!1){const R=g?t:c;let O="";const q=a.byteLength%3;let Z=0;for(;Z<a.byteLength-q;Z+=3){const x=a[Z+0],F=a[Z+1],$=a[Z+2];O+=R[x>>>2],O+=R[(x<<4|F>>>4)&63],O+=R[(F<<2|$>>>6)&63],O+=R[$&63]}if(q===1){const x=a[Z+0];O+=R[x>>>2],O+=R[x<<4&63],l&&(O+="==")}else if(q===2){const x=a[Z+0],F=a[Z+1];O+=R[x>>>2],O+=R[(x<<4|F>>>4)&63],O+=R[F<<2&63],l&&(O+="=")}return O}e.encodeBase64=d}),define(Ie[34],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return n.test(D)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(A){for(let S=0;S<A.length;S++)A[S]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){D(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let S=0,y="";return y+=C[M[S++]],y+=C[M[S++]],y+=C[M[S++]],y+=C[M[S++]],y+="-",y+=C[M[S++]],y+=C[M[S++]],y+="-",y+=C[M[S++]],y+=C[M[S++]],y+="-",y+=C[M[S++]],y+=C[M[S++]],y+="-",y+=C[M[S++]],y+=C[M[S++]],y+=C[M[S++]],y+=C[M[S++]],y+=C[M[S++]],y+=C[M[S++]],y}}()}),define(Ie[115],Ce([1,0,18,34]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(A){return{id:(0,k.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=D;function M(A,S,y){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:S,data:y}),value:void 0}}e.createFileDataTransferItem=M;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,y){const N=this.a.get(S);N?N.push(y):this.a.set(this.b(S),[y])}replace(S,y){this.a.set(this.b(S),[y])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,y]of this.a.entries())for(const N of y)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[y,N]of this.entries())S(N,y)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:A=>(0,n.distinct)(A.map(S=>S.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(S=>!S.startsWith("#"))})}),define(Ie[116],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[117],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class k{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let S=0,y=A.notIn.length;S<y;S++)switch(A.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,S){if(A.getTokenCount()===0)return!0;const y=A.findTokenIndexAtOffset(S-2),N=A.getStandardTokenType(y);return this.isOK(N)}g(A,S){for(let y=A;y<=S;y++){const N=String.fromCharCode(y);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=k;class D{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of A)M(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),M(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),M(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),M(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&M(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function M(C,A,S){C.has(A)?C.get(A).push(S):C.set(A,[S])}}),define(Ie[118],Ce([14,15]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ie[119],Ce([14,15]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ie[120],Ce([1,0,119]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,M=D*24,C=M*7,A=M*30,S=M*365;function y(E,m,p,f){typeof E!="number"&&(E=E.getTime());const s=Math.round((new Date().getTime()-E)/1e3);if(s<-30)return(0,n.localize)(0,null,y(new Date().getTime()+s*1e3,!1));if(!f&&s<30)return(0,n.localize)(1,null);let o;return s<k?(o=s,m?o===1?p?(0,n.localize)(2,null,o):(0,n.localize)(3,null,o):p?(0,n.localize)(4,null,o):(0,n.localize)(5,null,o):o===1?p?(0,n.localize)(6,null,o):(0,n.localize)(7,null,o):p?(0,n.localize)(8,null,o):(0,n.localize)(9,null,o)):s<D?(o=Math.floor(s/k),m?o===1?p?(0,n.localize)(10,null,o):(0,n.localize)(11,null,o):p?(0,n.localize)(12,null,o):(0,n.localize)(13,null,o):o===1?p?(0,n.localize)(14,null,o):(0,n.localize)(15,null,o):p?(0,n.localize)(16,null,o):(0,n.localize)(17,null,o)):s<M?(o=Math.floor(s/D),m?o===1?p?(0,n.localize)(18,null,o):(0,n.localize)(19,null,o):p?(0,n.localize)(20,null,o):(0,n.localize)(21,null,o):o===1?p?(0,n.localize)(22,null,o):(0,n.localize)(23,null,o):p?(0,n.localize)(24,null,o):(0,n.localize)(25,null,o)):s<C?(o=Math.floor(s/M),m?o===1?(0,n.localize)(26,null,o):(0,n.localize)(27,null,o):o===1?(0,n.localize)(28,null,o):(0,n.localize)(29,null,o)):s<A?(o=Math.floor(s/C),m?o===1?p?(0,n.localize)(30,null,o):(0,n.localize)(31,null,o):p?(0,n.localize)(32,null,o):(0,n.localize)(33,null,o):o===1?p?(0,n.localize)(34,null,o):(0,n.localize)(35,null,o):p?(0,n.localize)(36,null,o):(0,n.localize)(37,null,o)):s<S?(o=Math.floor(s/A),m?o===1?p?(0,n.localize)(38,null,o):(0,n.localize)(39,null,o):p?(0,n.localize)(40,null,o):(0,n.localize)(41,null,o):o===1?p?(0,n.localize)(42,null,o):(0,n.localize)(43,null,o):p?(0,n.localize)(44,null,o):(0,n.localize)(45,null,o)):(o=Math.floor(s/S),m?o===1?p?(0,n.localize)(46,null,o):(0,n.localize)(47,null,o):p?(0,n.localize)(48,null,o):(0,n.localize)(49,null,o):o===1?p?(0,n.localize)(50,null,o):(0,n.localize)(51,null,o):p?(0,n.localize)(52,null,o):(0,n.localize)(53,null,o))}e.fromNow=y;function N(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ie[121],Ce([14,15]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ie[39],Ce([1,0,18,9,121]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(E,m){return m&&(E.stack||E.stacktrace)?D.localize(0,null,A(E),C(E.stack)||C(E.stacktrace)):A(E)}function C(E){return Array.isArray(E)?E.join(`
`):E}function A(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function S(E=null,m=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const p=n.coalesce(E),f=S(p[0],m);return p.length>1?D.localize(4,null,f,p.length):f}if(k.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return M(p.error,m);if(p.exception)return M(p.exception,m)}return E.stack?M(E,m):E.message?E.message:D.localize(5,null)}e.toErrorMessage=S;function y(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=y;function N(E,m){let p;return typeof E=="string"?p=new Error(E):p=E,p.actions=m,p}e.createErrorWithActions=N}),define(Ie[122],Ce([1,0,85,19]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new n.Lazy(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(l,g,R=!1){const O=l||"",q=g||"",Z=D.value.collator.compare(O,q);return D.value.collatorIsNumeric&&Z===0&&O!==q?O<q?-1:1:Z}e.compareFileNames=A;function S(l,g){const R=M.value.collator;return l=l||"",g=g||"",P(R,l,g)}e.compareFileNamesDefault=S;function y(l,g){const R=M.value.collator;return l=l||"",g=g||"",i(l,g)||P(R,l,g)}e.compareFileNamesUpper=y;function N(l,g){const R=M.value.collator;return l=l||"",g=g||"",h(l,g)||P(R,l,g)}e.compareFileNamesLower=N;function E(l,g){return l=l||"",g=g||"",l===g?0:l<g?-1:1}e.compareFileNamesUnicode=E;function m(l,g){const[R,O]=b(l),[q,Z]=b(g);let x=D.value.collator.compare(O,Z);if(x===0){if(D.value.collatorIsNumeric&&O!==Z)return O<Z?-1:1;if(x=D.value.collator.compare(R,q),D.value.collatorIsNumeric&&x===0&&R!==q)return R<q?-1:1}return x}e.compareFileExtensions=m;function p(l,g){l=l||"",g=g||"";const R=w(l),O=w(g),q=M.value.collator,Z=C.value.collator;return P(Z,R,O)||P(q,l,g)}e.compareFileExtensionsDefault=p;function f(l,g){l=l||"",g=g||"";const R=w(l),O=w(g),q=M.value.collator,Z=C.value.collator;return P(Z,R,O)||i(l,g)||P(q,l,g)}e.compareFileExtensionsUpper=f;function s(l,g){l=l||"",g=g||"";const R=w(l),O=w(g),q=M.value.collator,Z=C.value.collator;return P(Z,R,O)||h(l,g)||P(q,l,g)}e.compareFileExtensionsLower=s;function o(l,g){l=l||"",g=g||"";const R=w(l).toLowerCase(),O=w(g).toLowerCase();return R!==O?R<O?-1:1:l!==g?l<g?-1:1:0}e.compareFileExtensionsUnicode=o;const u=/^(.*?)(\.([^.]*))?$/;function b(l,g=!1){const R=l?u.exec(l):[];let O=[R&&R[1]||"",R&&R[3]||""];return g&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function w(l){const g=l?u.exec(l):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function P(l,g,R){const O=l.compare(g,R);return O!==0?O:g.length!==R.length?g.length<R.length?-1:1:0}function v(l){const g=l.charAt(0);return g.toLocaleUpperCase()!==g}function r(l){const g=l.charAt(0);return g.toLocaleLowerCase()!==g}function h(l,g){return v(l)&&r(g)?-1:r(l)&&v(g)?1:0}function i(l,g){return r(l)&&v(g)?-1:v(l)&&r(g)?1:0}function c(l,g,R=!1){return R||(l=l&&l.toLowerCase(),g=g&&g.toLowerCase()),l===g?0:l<g?-1:1}function t(l,g,R=!1){const O=l.split(k.sep),q=g.split(k.sep),Z=O.length-1,x=q.length-1;let F,$;for(let T=0;;T++){if(F=Z===T,$=x===T,F&&$)return A(O[T],q[T],R);if(F)return-1;if($)return 1;const L=c(O[T],q[T],R);if(L!==0)return L}}e.comparePaths=t;function d(l,g,R){const O=l.toLowerCase(),q=g.toLowerCase(),Z=a(l,g,R);if(Z)return Z;const x=O.endsWith(R),F=q.endsWith(R);if(x!==F)return x?-1:1;const $=A(O,q);return $!==0?$:O.localeCompare(q)}e.compareAnything=d;function a(l,g,R){const O=l.toLowerCase(),q=g.toLowerCase(),Z=O.startsWith(R),x=q.startsWith(R);if(Z!==x)return Z?-1:1;if(Z&&x){if(O.length<q.length)return-1;if(O.length>q.length)return 1}return 0}e.compareByPrefix=a}),define(Ie[64],Ce([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(N){const E=(0,n.extname)(N),m=k[E.toLowerCase()];return m!==void 0?m:C(N)}e.getMediaOrTextMime=M;function C(N){const E=(0,n.extname)(N);return D[E.toLowerCase()]}e.getMediaMime=C;function A(N){for(const E in D)if(D[E]===N)return E}e.getExtensionForMimeType=A;const S=/^(.+)\/(.+?)(;.+)?$/;function y(N,E){const m=S.exec(N);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:N}e.normalizeMimeType=y}),define(Ie[123],Ce([1,0,4,6,118]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends k.Disposable{constructor(m,p="",f="",s=!0,o){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=p,this.u=f,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,p){this.C&&await this.C(m)}}e.Action=M;class C extends k.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(m,p){if(!m.enabled)return;this.f.fire({action:m});let f;try{await this.runAction(m,p)}catch(s){f=s}this.h.fire({action:m,error:f})}async runAction(m,p){await m.run(p)}}e.ActionRunner=C;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let p=[];for(const f of m)f.length&&(p.length?p=[...p,new A,...f]:p=f);return p}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class S{get actions(){return this.a}constructor(m,p,f,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=p,this.class=s,this.a=f}async run(){}}e.SubmenuAction=S;class y extends M{constructor(){super(y.ID,D.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=y,y.ID="vs.actions.empty";function N(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.toAction=N}),define(Ie[40],Ce([1,0,19,20,10,9]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(t){return t===47||t===92}e.isPathSeparator=C;function A(t){return t.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=A;function S(t){return t.indexOf("/")===-1&&(t=A(t)),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t),t}e.toPosixPath=S;function y(t,d=n.posix.sep){if(!t)return"";const a=t.length,l=t.charCodeAt(0);if(C(l)){if(C(t.charCodeAt(1))&&!C(t.charCodeAt(2))){let R=3;const O=R;for(;R<a&&!C(t.charCodeAt(R));R++);if(O!==R&&!C(t.charCodeAt(R+1))){for(R+=1;R<a;R++)if(C(t.charCodeAt(R)))return t.slice(0,R+1).replace(/[\\/]/g,d)}}return d}else if(u(l)&&t.charCodeAt(1)===58)return C(t.charCodeAt(2))?t.slice(0,2)+d:t.slice(0,2);let g=t.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(C(t.charCodeAt(g)))return t.slice(0,g+1)}return""}e.getRoot=y;function N(t){if(!k.isWindows||!t||t.length<5)return!1;let d=t.charCodeAt(0);if(d!==92||(d=t.charCodeAt(1),d!==92))return!1;let a=2;const l=a;for(;a<t.length&&(d=t.charCodeAt(a),d!==92);a++);return!(l===a||(d=t.charCodeAt(a+1),isNaN(d)||d===92))}e.isUNC=N;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(t,d=k.isWindows){const a=d?E:m;return!(!t||t.length===0||/^\s+$/.test(t)||(a.lastIndex=0,a.test(t))||d&&p.test(t)||t==="."||t===".."||d&&t[t.length-1]==="."||d&&t.length!==t.trim().length||t.length>255)}e.isValidBasename=f;function s(t,d,a){const l=t===d;return!a||l?l:!t||!d?!1:(0,D.equalsIgnoreCase)(t,d)}e.isEqual=s;function o(t,d,a,l=n.sep){if(t===d)return!0;if(!t||!d||d.length>t.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(t,d))return!1;if(d.length===t.length)return!0;let R=d.length;return d.charAt(d.length-1)===l&&R--,t.charAt(R)===l}return d.charAt(d.length-1)!==l&&(d+=l),t.indexOf(d)===0}e.isEqualOrParent=o;function u(t){return t>=65&&t<=90||t>=97&&t<=122}e.isWindowsDriveLetter=u;function b(t,d){return k.isWindows&&t.endsWith(":")&&(t+=n.sep),(0,n.isAbsolute)(t)||(t=(0,n.join)(d,t)),t=(0,n.normalize)(t),k.isWindows?(t=(0,D.rtrim)(t,n.sep),t.endsWith(":")&&(t+=n.sep)):(t=(0,D.rtrim)(t,n.sep),t||(t=n.sep)),t}e.sanitizeFilePath=b;function w(t){const d=(0,n.normalize)(t);return k.isWindows?t.length>3?!1:P(d)&&(t.length===2||d.charCodeAt(2)===92):d===n.posix.sep}e.isRootOrDriveLetter=w;function P(t,d=k.isWindows){return d?u(t.charCodeAt(0))&&t.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function v(t){return P(t)?t[0]:void 0}e.getDriveLetter=v;function r(t,d,a){return d.length>t.length?-1:t===d?0:(a&&(t=t.toLowerCase(),d=d.toLowerCase()),t.indexOf(d))}e.indexOfPath=r;function h(t){const d=t.split(":");let a,l,g;for(const R of d){const O=Number(R);(0,M.isNumber)(O)?l===void 0?l=O:g===void 0&&(g=O):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:g!==void 0?g:l!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(t,d,a=8){let l="";for(let R=0;R<a;R++)l+=i.charAt(Math.floor(Math.random()*i.length));let g;return d?g=`${d}-${l}`:g=l,t?(0,n.join)(t,g):g}e.randomPath=c}),define(Ie[124],Ce([1,0,28,10]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(I,B){for(let W=0,K=J.length;W<K;W++){const ee=J[W](I,B);if(ee)return ee}return null}}e.or=D,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,I,B){if(!B||B.length<I.length)return null;let W;return J?W=k.startsWithIgnoreCase(B,I):W=B.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function C(J,I){const B=I.toLowerCase().indexOf(J.toLowerCase());return B===-1?null:[{start:B,end:B+J.length}]}e.matchesContiguousSubString=C;function A(J,I){return S(J.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=A;function S(J,I,B,W){if(B===J.length)return[];if(W===I.length)return null;if(J[B]===I[W]){let K=null;return(K=S(J,I,B+1,W+1))?u({start:W,end:W+1},K):null}return S(J,I,B,W+1)}function y(J){return 97<=J&&J<=122}function N(J){return 65<=J&&J<=90}e.isUpper=N;function E(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>p.add(J.charCodeAt(0)));function f(J){return m(J)||p.has(J)}function s(J,I){return J===I||f(J)&&f(I)}function o(J){return y(J)||N(J)||E(J)}function u(J,I){return I.length===0?I=[J]:J.end===I[0].start?I[0].start=J.start:I.unshift(J),I}function b(J,I){for(let B=I;B<J.length;B++){const W=J.charCodeAt(B);if(N(W)||E(W)||B>0&&!o(J.charCodeAt(B-1)))return B}return J.length}function w(J,I,B,W){if(B===J.length)return[];if(W===I.length)return null;if(J[B]!==I[W].toLowerCase())return null;{let K=null,ee=W+1;for(K=w(J,I,B+1,W+1);!K&&(ee=b(I,ee))<I.length;)K=w(J,I,B+1,ee),ee++;return K===null?null:u({start:W,end:W+1},K)}}function P(J){let I=0,B=0,W=0,K=0,ee=0;for(let Ee=0;Ee<J.length;Ee++)ee=J.charCodeAt(Ee),N(ee)&&I++,y(ee)&&B++,o(ee)&&W++,E(ee)&&K++;const he=I/J.length,ye=B/J.length,ae=W/J.length,be=K/J.length;return{upperPercent:he,lowerPercent:ye,alphaPercent:ae,numericPercent:be}}function v(J){const{upperPercent:I,lowerPercent:B}=J;return B===0&&I>.6}function r(J){const{upperPercent:I,lowerPercent:B,alphaPercent:W,numericPercent:K}=J;return B>.2&&I<.8&&W>.6&&K<.2}function h(J){let I=0,B=0,W=0,K=0;for(let ee=0;ee<J.length;ee++)W=J.charCodeAt(ee),N(W)&&I++,y(W)&&B++,m(W)&&K++;return(I===0||B===0)&&K===0?J.length<=30:I<=5}function i(J,I){if(!I||(I=I.trim(),I.length===0)||!h(J)||I.length>60)return null;const B=P(I);if(!r(B)){if(!v(B))return null;I=I.toLowerCase()}let W=null,K=0;for(J=J.toLowerCase();K<I.length&&(W=w(J,I,0,K))===null;)K=b(I,K+1);return W}e.matchesCamelCase=i;function c(J,I,B=!1){if(!I||I.length===0)return null;let W=null,K=0;for(J=J.toLowerCase(),I=I.toLowerCase();K<I.length&&(W=t(J,I,0,K,B))===null;)K=d(I,K+1);return W}e.matchesWords=c;function t(J,I,B,W,K){if(B===J.length)return[];if(W===I.length)return null;if(s(J.charCodeAt(B),I.charCodeAt(W))){let ee=null,he=W+1;if(ee=t(J,I,B+1,W+1,K),!K)for(;!ee&&(he=d(I,he))<I.length;)ee=t(J,I,B+1,he,K),he++;return ee?J.charCodeAt(B)!==I.charCodeAt(W)?ee:u({start:W,end:W+1},ee):null}else return null}function d(J,I){for(let B=I;B<J.length;B++)if(f(J.charCodeAt(B))||B>0&&f(J.charCodeAt(B-1)))return B;return J.length}const a=D(e.matchesPrefix,i,C),l=D(e.matchesPrefix,i,A),g=new n.LRUCache(1e4);function R(J,I,B=!1){if(typeof J!="string"||typeof I!="string")return null;let W=g.get(J);W||(W=new RegExp(k.convertSimple2RegExpPattern(J),"i"),g.set(J,W));const K=W.exec(I);return K?[{start:K.index,end:K.index+K[0].length}]:B?l(J,I):a(J,I)}e.matchesFuzzy=R;function O(J,I){const B=Ue(J,J.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?Z(B):null}e.matchesFuzzy2=O;function q(J,I,B,W,K,ee){const he=Math.min(13,J.length);for(;B<he;B++){const ye=Ue(J,I,B,W,K,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ee]}e.anyScore=q;function Z(J){if(typeof J>"u")return[];const I=[],B=J[1];for(let W=J.length-1;W>1;W--){const K=J[W]+B,ee=I[I.length-1];ee&&ee.end===K?ee.end=K+1:I.push({start:K,end:K+1})}return I}e.createMatches=Z;const x=128;function F(){const J=[],I=[];for(let B=0;B<=x;B++)I[B]=0;for(let B=0;B<=x;B++)J.push(I.slice(0));return J}function $(J){const I=[];for(let B=0;B<=J;B++)I[B]=0;return I}const T=$(2*x),L=$(2*x),V=F(),j=F(),le=F(),_=!1;function pe(J,I,B,W,K){function ee(ye,ae,be=" "){for(;ye.length<ae;)ye=be+ye;return ye}let he=` |   |${W.split("").map(ye=>ee(ye,3)).join("|")}
`;for(let ye=0;ye<=B;ye++)ye===0?he+=" |":he+=`${I[ye-1]}|`,he+=J[ye].slice(0,K+1).map(ae=>ee(ae.toString(),3)).join("|")+`
`;return he}function ue(J,I,B,W){J=J.substr(I),B=B.substr(W),console.log(pe(j,J,J.length,B,B.length)),console.log(pe(le,J,J.length,B,B.length)),console.log(pe(V,J,J.length,B,B.length))}function de(J,I){if(I<0||I>=J.length)return!1;const B=J.codePointAt(I);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(B)}}function re(J,I){if(I<0||I>=J.length)return!1;switch(J.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function G(J,I,B){return I[J]!==B[J]}function H(J,I,B,W,K,ee,he=!1){for(;I<B&&K<ee;)J[I]===W[K]&&(he&&(T[I]=K),I+=1),K+=1;return I===B}e.isPatternInWord=H;var oe;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var ve;(function(J){J.Default=[-100,0];function I(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}J.isDefault=I})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(I,B){this.firstMatchCanBeWeak=I,this.boostFullMatch=B}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ue(J,I,B,W,K,ee,he=Ae.default){const ye=J.length>x?x:J.length,ae=W.length>x?x:W.length;if(B>=ye||ee>=ae||ye-B>ae-ee||!H(I,B,ye,K,ee,ae,!0))return;xe(ye,ae,B,ee,I,K);let be=1,Ee=1,We=B,He=ee;const tt=[!1];for(be=1,We=B;We<ye;be++,We++){const Le=T[We],ot=L[We],Y=We+1<ye?L[We+1]:ae;for(Ee=Le-ee+1,He=Le;He<Y;Ee++,He++){let Q=Number.MIN_SAFE_INTEGER,ge=!1;He<=ot&&(Q=Te(J,I,We,B,W,K,He,ae,ee,V[be-1][Ee-1]===0,tt));let Me=0;Q!==Number.MAX_SAFE_INTEGER&&(ge=!0,Me=Q+j[be-1][Ee-1]);const ze=He>Le,Ve=ze?j[be][Ee-1]+(V[be][Ee-1]>0?-5:0):0,Ye=He>Le+1&&V[be][Ee-1]>0,nt=Ye?j[be][Ee-2]+(V[be][Ee-2]>0?-5:0):0;if(Ye&&(!ze||nt>=Ve)&&(!ge||nt>=Me))j[be][Ee]=nt,le[be][Ee]=3,V[be][Ee]=0;else if(ze&&(!ge||Ve>=Me))j[be][Ee]=Ve,le[be][Ee]=2,V[be][Ee]=0;else if(ge)j[be][Ee]=Me,le[be][Ee]=1,V[be][Ee]=V[be-1][Ee-1]+1;else throw new Error("not possible")}}if(_&&ue(J,B,W,ee),!tt[0]&&!he.firstMatchCanBeWeak)return;be--,Ee--;const Xe=[j[be][Ee],ee];let et=0,it=0;for(;be>=1;){let Le=Ee;do{const ot=le[be][Le];if(ot===3)Le=Le-2;else if(ot===2)Le=Le-1;else break}while(Le>=1);et>1&&I[B+be-1]===K[ee+Ee-1]&&!G(Le+ee-1,W,K)&&et+1>V[be][Le]&&(Le=Ee),Le===Ee?et++:et=1,it||(it=Le),be--,Ee=Le-1,Xe.push(Ee)}ae===ye&&he.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Ue;function xe(J,I,B,W,K,ee){let he=J-1,ye=I-1;for(;he>=B&&ye>=W;)K[he]===ee[ye]&&(L[he]=ye,he--),ye--}function Te(J,I,B,W,K,ee,he,ye,ae,be,Ee){if(I[B]!==ee[he])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return he===B-W?We=J[B]===K[he]?7:5:G(he,K,ee)&&(he===0||!G(he-1,K,ee))?(We=J[B]===K[he]?7:5,He=!0):de(ee,he)&&(he===0||!de(ee,he-1))?We=5:(de(ee,he-1)||re(ee,he-1))&&(We=5,He=!0),We>1&&B===W&&(Ee[0]=!0),He||(He=G(he,K,ee)||de(ee,he-1)||re(ee,he-1)),B===W?he>ae&&(We-=He?3:5):be?We+=He?2:0:We+=He?0:1,he+1===ye&&(We-=He?3:5),We}function Se(J,I,B,W,K,ee,he){return se(J,I,B,W,K,ee,!0,he)}e.fuzzyScoreGracefulAggressive=Se;function ke(J,I,B,W,K,ee,he){return se(J,I,B,W,K,ee,!1,he)}e.fuzzyScoreGraceful=ke;function se(J,I,B,W,K,ee,he,ye){let ae=Ue(J,I,B,W,K,ee,ye);if(ae&&!he)return ae;if(J.length>=3){const be=Math.min(7,J.length-1);for(let Ee=B+1;Ee<be;Ee++){const We=ce(J,Ee);if(We){const He=Ue(We,We.toLowerCase(),B,W,K,ee,ye);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(J,I){if(I+1>=J.length)return;const B=J[I],W=J[I+1];if(B!==W)return J.slice(0,I)+W+B+J.slice(I+2)}}),define(Ie[125],Ce([1,0,65,124,10]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",C=new RegExp(`\\$\\(${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function S(o){return o.replace(A,(u,b)=>b?u:`\\${u}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function N(o){return o.replace(y,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=N;const E=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function m(o){return o.indexOf(M)===-1?o:o.replace(E,(u,b,w,P)=>w?u:b||P||"")}e.stripIcons=m;const p=new RegExp(`\\$\\(${n.CSSIcon.iconNameCharacter}+\\)`,"g");function f(o){p.lastIndex=0;let u="";const b=[];let w=0;for(;;){const P=p.lastIndex,v=p.exec(o),r=o.substring(P,v?.index);if(r.length>0){u+=r;for(let h=0;h<r.length;h++)b.push(w)}if(!v)break;w+=v[0].length}return{text:u,iconOffsets:b}}e.parseLabelWithIcons=f;function s(o,u,b=!1){const{text:w,iconOffsets:P}=u;if(!P||P.length===0)return(0,k.matchesFuzzy)(o,w,b);const v=(0,D.ltrim)(w," "),r=w.length-v.length,h=(0,k.matchesFuzzy)(o,v,b);if(h)for(const i of h){const c=P[i.start+r]+r;i.start+=c,i.end+=c}return h}e.matchesFuzzyIconAware=s}),define(Ie[30],Ce([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const M="error",C="warning",A="warn",S="info",y="ignore";function N(m){return m?n.equalsIgnoreCase(M,m)?D.Error:n.equalsIgnoreCase(C,m)||n.equalsIgnoreCase(A,m)?D.Warning:n.equalsIgnoreCase(S,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function E(m){switch(m){case D.Error:return M;case D.Warning:return C;case D.Info:return S;default:return y}}D.toString=E}(k||(k={})),e.default=k}),define(Ie[46],Ce([1,0,18,10]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const f=p.charCodeAt(0),s=this.b.charCodeAt(this.c);return f-s}value(){return this.b[this.c]}}e.StringIterator=D;class M{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,k.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class C{constructor(p=!0,f=!0){this.f=p,this.g=f}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let f=p.length-1;f>=0;f--,this.c--){const s=this.b.charCodeAt(f);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,k.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var A;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(A||(A={}));class S{constructor(p,f){this.f=p,this.g=f,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,k.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(N||(N={}));class E{static forUris(p=()=>!1,f=()=>!1){return new E(new S(p,f))}static forPaths(p=!1){return new E(new C(void 0,!p))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new M)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,f){if(f){const s=f.slice(0);(0,n.shuffle)(s);for(const o of s)this.set(o,p)}else{const s=p.slice(0);(0,n.shuffle)(s);for(const o of s)this.set(o[0],o[1])}}set(p,f){const s=this.b.reset(p);let o;this.c||(this.c=new y,this.c.segment=s.value());const u=[];for(o=this.c;;){const w=s.cmp(o.segment);if(w>0)o.left||(o.left=new y,o.left.segment=s.value()),u.push([-1,o]),o=o.left;else if(w<0)o.right||(o.right=new y,o.right.segment=s.value()),u.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new y,o.mid.segment=s.value()),u.push([0,o]),o=o.mid;else break}const b=o.value;o.value=f,o.key=p;for(let w=u.length-1;w>=0;w--){const P=u[w][1];P.updateHeight();const v=P.balanceFactor();if(v<-1||v>1){const r=u[w][0],h=u[w+1][0];if(r===1&&h===1)u[w][1]=P.rotateLeft();else if(r===-1&&h===-1)u[w][1]=P.rotateRight();else if(r===1&&h===-1)P.right=u[w+1][1]=u[w+1][1].rotateRight(),u[w][1]=P.rotateLeft();else if(r===-1&&h===1)P.left=u[w+1][1]=u[w+1][1].rotateLeft(),u[w][1]=P.rotateRight();else throw new Error;if(w>0)switch(u[w-1][0]){case-1:u[w-1][1].left=u[w][1];break;case 1:u[w-1][1].right=u[w][1];break;case 0:u[w-1][1].mid=u[w][1];break}else this.c=u[0][1]}}return b}get(p){return this.d(p)?.value}d(p){const f=this.b.reset(p);let s=this.c;for(;s;){const o=f.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(f.hasNext())f.next(),s=s.mid;else break}return s}has(p){const f=this.d(p);return!(f?.value===void 0&&f?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,f){const s=this.b.reset(p),o=[];let u=this.c;for(;u;){const b=s.cmp(u.segment);if(b>0)o.push([-1,u]),u=u.left;else if(b<0)o.push([1,u]),u=u.right;else if(s.hasNext())s.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const b=this.f(u.right);if(b.key){const{key:w,value:P,segment:v}=b;this.e(b.key,!1),u.key=w,u.value=P,u.segment=v}}else{const b=u.left??u.right;if(o.length>0){const[w,P]=o[o.length-1];switch(w){case-1:P.left=b;break;case 0:P.mid=b;break;case 1:P.right=b;break}}else this.c=b}for(let b=o.length-1;b>=0;b--){const w=o[b][1];w.updateHeight();const P=w.balanceFactor();if(P>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),o[b][1]=w.rotateLeft()):P<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),o[b][1]=w.rotateRight()),b>0)switch(o[b-1][0]){case-1:o[b-1][1].left=o[b][1];break;case 1:o[b-1][1].right=o[b][1];break;case 0:o[b-1][1].mid=o[b][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const f=this.b.reset(p);let s=this.c,o;for(;s;){const u=f.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(f.hasNext())f.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(p){return this.g(p,!1)}g(p,f){const s=this.b.reset(p);let o=this.c;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):f?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[f,s]of this)p(s,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const f=[];return this.j(p,f),f[Symbol.iterator]()}j(p,f){!p||(p.left&&this.j(p.left,f),p.value&&f.push([p.key,p.value]),p.mid&&this.j(p.mid,f),p.right&&this.j(p.right,f))}_isBalanced(){const p=f=>{if(!f)return!0;const s=f.balanceFactor();return s<-1||s>1?!1:p(f.left)&&p(f.right)};return p(this.c)}}e.TernarySearchTree=E}),define(Ie[66],Ce([1,0,23,10,2]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(y){return JSON.stringify(y,A)}e.stringify=M;function C(y){let N=JSON.parse(y);return N=S(N),N}e.parse=C;function A(y,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,k.regExpFlags)(N)}:N}function S(y,N=0){if(!y||N>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return D.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof n.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let E=0;E<y.length;++E)y[E]=S(y[E],N+1);else for(const E in y)Object.hasOwnProperty.call(y,E)&&(y[E]=S(y[E],N+1))}return y}e.revive=S}),define(Ie[16],Ce([1,0,11,20,2]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${M.vscodeRemoteResource}`}set(N,E,m){this.a[N]=E,this.b[N]=m}setConnectionToken(N,E){this.c[N]=E}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(o){return n.onUnexpectedError(o),N}const E=N.authority;let m=this.a[E];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[E],f=this.c[E];let s=`path=${encodeURIComponent(N.path)}`;return typeof f=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),D.URI.from({scheme:k.isWeb?this.d:M.vscodeRemoteResource,authority:`${m}:${p}`,path:this.f,query:s})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(N){const E=this.b(N,te);return this.uriToBrowserUri(E)}uriToBrowserUri(N){return N.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===M.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${M.vscodeFileResource}://${A.a}`)?N.with({scheme:M.vscodeFileResource,authority:N.authority||A.a,query:null,fragment:null}):N}asFileUri(N){const E=this.b(N,te);return this.uriToFileUri(E)}uriToFileUri(N){return N.scheme===M.vscodeFileResource?N.with({scheme:M.file,authority:N.authority!==A.a?N.authority:null,query:null,fragment:null}):N}b(N,E){return D.URI.isUri(N)?N:D.URI.parse(E.toUrl(N))}}A.a="vscode-app",e.FileAccess=new A;var S;(function(y){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(N.get("3"));const E="vscode-coi";function m(f){let s;typeof f=="string"?s=new URL(f).searchParams:f instanceof URL?s=f.searchParams:D.URI.isUri(f)&&(s=new URL(f.toString(!0)).searchParams);const o=s?.get(E);if(!!o)return N.get(o)}y.getHeadersFromQuery=m;function p(f,s,o){if(!globalThis.crossOriginIsolated)return;const u=s&&o?"3":o?"2":"1";f instanceof URLSearchParams?f.set(E,u):f[E]=u}y.addSearchParam=p})(S=e.COI||(e.COI={}))}),define(Ie[24],Ce([1,0,40,16,19,20,10,2]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,A.uriToFsPath)(p,!0)}e.originalFSPath=S;class y{constructor(f){this.a=f}compare(f,s,o=!1){return f===s?0:(0,C.compare)(this.getComparisonKey(f,o),this.getComparisonKey(s,o))}isEqual(f,s,o=!1){return f===s?!0:!f||!s?!1:this.getComparisonKey(f,o)===this.getComparisonKey(s,o)}getComparisonKey(f,s=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,s,o=!1){if(f.scheme===s.scheme){if(f.scheme===k.Schemas.file)return n.isEqualOrParent(S(f),S(s),this.a(f))&&f.query===s.query&&(o||f.fragment===s.fragment);if((0,e.isEqualAuthority)(f.authority,s.authority))return n.isEqualOrParent(f.path,s.path,this.a(f),"/")&&f.query===s.query&&(o||f.fragment===s.fragment)}return!1}joinPath(f,...s){return A.URI.joinPath(f,...s)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let s;return f.scheme===k.Schemas.file?s=A.URI.file(D.dirname(S(f))).path:(s=D.posix.dirname(f.path),f.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),s="/")),f.with({path:s})}normalizePath(f){if(!f.path.length)return f;let s;return f.scheme===k.Schemas.file?s=A.URI.file(D.normalize(S(f))).path:s=D.posix.normalize(f.path),f.with({path:s})}relativePath(f,s){if(f.scheme!==s.scheme||!(0,e.isEqualAuthority)(f.authority,s.authority))return;if(f.scheme===k.Schemas.file){const b=D.relative(S(f),S(s));return M.isWindows?n.toSlashes(b):b}let o=f.path||"/";const u=s.path||"/";if(this.a(f)){let b=0;for(const w=Math.min(o.length,u.length);b<w&&!(o.charCodeAt(b)!==u.charCodeAt(b)&&o.charAt(b).toLowerCase()!==u.charAt(b).toLowerCase());b++);o=u.substr(0,b)+o.substr(b)}return D.posix.relative(o,u)}resolvePath(f,s){if(f.scheme===k.Schemas.file){const o=A.URI.file(D.resolve(S(f),s));return f.with({authority:o.authority,path:o.path})}return s=n.toPosixPath(s),f.with({path:D.posix.resolve(f.path,s)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,s){return f===s||f!==void 0&&s!==void 0&&(0,C.equalsIgnoreCase)(f,s)}hasTrailingPathSeparator(f,s=D.sep){if(f.scheme===k.Schemas.file){const o=S(f);return o.length>n.getRoot(o).length&&o[o.length-1]===s}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,s=D.sep){return(0,e.hasTrailingPathSeparator)(f,s)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,s=D.sep){let o=!1;if(f.scheme===k.Schemas.file){const u=S(f);o=u!==void 0&&u.length===n.getRoot(u).length&&u[u.length-1]===s}else{s="/";const u=f.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(f,s)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===k.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(p,f){const s=[];for(let o=0;o<p.length;o++){const u=f(p[o]);p.some((b,w)=>w===o?!1:(0,e.isEqualOrParent)(u,f(b)))||s.push(p[o])}return s}e.distinctParents=N;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(w=>{const[P,v]=w.split(":");P&&v&&o.set(P,v)});const b=s.path.substring(0,s.path.indexOf(";"));return b&&o.set(p.META_DATA_MIME,b),o}p.parseMetaData=f})(E=e.DataUri||(e.DataUri={}));function m(p,f,s){if(f){let o=p.path;return o&&o[0]!==D.posix.sep&&(o=D.posix.sep+o),p.with({scheme:s,authority:f,path:o})}return p.with({scheme:s})}e.toLocalResource=m}),define(Ie[12],Ce([1,0,21,11,4,6,24,20]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(G){return!!G&&typeof G.then=="function"}e.isThenable=S;function y(G){const H=new n.CancellationTokenSource,oe=G(H.token),ve=new Promise((Ae,Ue)=>{const xe=H.token.onCancellationRequested(()=>{xe.dispose(),H.dispose(),Ue(new k.CancellationError)});Promise.resolve(oe).then(Te=>{xe.dispose(),H.dispose(),Ae(Te)},Te=>{xe.dispose(),H.dispose(),Ue(Te)})});return new class{cancel(){H.cancel()}then(Ae,Ue){return ve.then(Ae,Ue)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ve.finally(Ae)}}}e.createCancelablePromise=y;function N(G,H,oe){return new Promise((ve,Ae)=>{const Ue=H.onCancellationRequested(()=>{Ue.dispose(),ve(oe)});G.then(ve,Ae).finally(()=>Ue.dispose())})}e.raceCancellation=N;function E(G,H){return new Promise((oe,ve)=>{const Ae=H.onCancellationRequested(()=>{Ae.dispose(),ve(new k.CancellationError)});G.then(oe,ve).finally(()=>Ae.dispose())})}e.raceCancellationError=E;async function m(G){let H=-1;const oe=G.map((Ae,Ue)=>Ae.then(xe=>(H=Ue,xe))),ve=await Promise.race(oe);return G.forEach((Ae,Ue)=>{Ue!==H&&Ae.cancel()}),ve}e.raceCancellablePromises=m;function p(G,H,oe){let ve;const Ae=setTimeout(()=>{ve?.(void 0),oe?.()},H);return Promise.race([G.finally(()=>clearTimeout(Ae)),new Promise(Ue=>ve=Ue)])}e.raceTimeout=p;function f(G){return new Promise((H,oe)=>{const ve=G();S(ve)?ve.then(H,oe):H(ve)})}e.asPromise=f;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(H){if(this.a){if(this.d=H,!this.b){const oe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(oe,oe).then(ve)})}return new Promise((oe,ve)=>{this.b.then(oe,ve)})}return this.a=H(),new Promise((oe,ve)=>{this.a.then(Ae=>{this.a=null,oe(Ae)},Ae=>{this.a=null,ve(Ae)})})}}e.Throttler=s;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.Sequencer=o;class u{constructor(){this.a=new Map}queue(H,oe){const Ae=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(H)===Ae&&this.a.delete(H)});return this.a.set(H,Ae),Ae}}e.SequencerByKey=u;const b=(G,H)=>{let oe=!0;const ve=setTimeout(()=>{oe=!1,H()},G);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ve),oe=!1}}},w=G=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,G())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class P{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,oe=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((Ae,Ue)=>{this.d=Ae,this.f=Ue}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=oe===e.MicrotaskDelay?w(ve):b(oe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=P;class v{constructor(H){this.a=new P(H),this.b=new s}trigger(H,oe){return this.a.trigger(()=>this.b.queue(H),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=v;class r{constructor(){this.a=!1,this.b=new Promise((H,oe)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class h extends r{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=h;function i(G,H){return H?new Promise((oe,ve)=>{const Ae=setTimeout(()=>{Ue.dispose(),oe()},G),Ue=H.onCancellationRequested(()=>{clearTimeout(Ae),Ue.dispose(),ve(new k.CancellationError)})}):y(oe=>i(G,oe))}e.timeout=i;function c(G,H=0){const oe=setTimeout(G,H);return(0,M.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=c;function t(G){const H=[];let oe=0;const ve=G.length;function Ae(){return oe<ve?G[oe++]():null}function Ue(xe){xe!=null&&H.push(xe);const Te=Ae();return Te?Te.then(Ue):Promise.resolve(H)}return Promise.resolve(null).then(Ue)}e.sequence=t;function d(G,H=ve=>!!ve,oe=null){let ve=0;const Ae=G.length,Ue=()=>{if(ve>=Ae)return Promise.resolve(oe);const xe=G[ve++];return Promise.resolve(xe()).then(Se=>H(Se)?Promise.resolve(Se):Ue())};return Ue()}e.first=d;function a(G,H=ve=>!!ve,oe=null){if(G.length===0)return Promise.resolve(oe);let ve=G.length;const Ae=()=>{ve=-1;for(const Ue of G)Ue.cancel?.()};return new Promise((Ue,xe)=>{for(const Te of G)Te.then(Se=>{--ve>=0&&H(Se)?(Ae(),Ue(Se)):ve===0&&Ue(oe)}).catch(Se=>{--ve>=0&&(Ae(),xe(Se))})})}e.firstParallel=a;class l{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((oe,ve)=>{this.f.push({factory:H,c:oe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const oe=H.factory();oe.then(H.c,H.e),oe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=l;class g extends l{constructor(){super(1)}}e.Queue=g;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const H=new le;return this.b.add(H),H.p}d(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,oe=C.extUri){const ve=oe.getComparisonKey(H);let Ae=this.a.get(ve);return Ae||(Ae=new g,D.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.g()}}e.ResourceQueue=R;class O{constructor(H,oe){this.a=-1,typeof H=="function"&&typeof oe=="number"&&this.setIfNotSet(H,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},oe)}setIfNotSet(H,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},oe))}}e.TimeoutTimer=O;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setInterval(()=>{H()},oe)}}e.IntervalTimer=q;class Z{constructor(H,oe){this.b=-1,this.a=H,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class x{constructor(H,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=H,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class F extends Z{constructor(H,oe){super(H,oe),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class $ extends M.Disposable{constructor(H,oe){super(),this.g=H,this.h=oe,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of H)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,A.setTimeout0)(()=>{if(H)return;const oe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(G,H)=>{const oe=requestIdleCallback(G,typeof H=="number"?{timeout:H}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(oe))}}}}();class T{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(oe){this.g=oe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function L(G,H,oe){let ve;for(let Ae=0;Ae<oe;Ae++)try{return await G()}catch(Ue){ve=Ue,await i(H)}throw ve}e.retry=L;class V{hasPending(H){return this.a?typeof H=="number"?this.a.taskId===H:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(H,oe,ve){return this.a={taskId:H,cancel:()=>ve?.(),promise:oe},oe.then(()=>this.d(H),()=>this.d(H)),oe}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this.b)this.b.run=H;else{let oe,ve;const Ae=new Promise((Ue,xe)=>{oe=Ue,ve=xe});this.b={run:H,promise:Ae,promiseResolve:oe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class j{constructor(H,oe=()=>Date.now()){this.d=H,this.f=oe,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((H,oe)=>{this.a=H,this.b=oe})}complete(H){return new Promise(oe=>{this.a(H),this.f=!0,oe()})}error(H){return new Promise(oe=>{this.b(H),this.d=!0,oe()})}cancel(){new Promise(H=>{this.b(new k.CancellationError),this.d=!0,H()})}}e.DeferredPromise=le;var _;(function(G){async function H(ve){let Ae;const Ue=await Promise.all(ve.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Ue}G.settled=H;function oe(ve){return new Promise(async(Ae,Ue)=>{try{await ve(Ae,Ue)}catch(xe){Ue(xe)}})}G.withAsyncBody=oe})(_=e.Promises||(e.Promises={}));var pe;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(pe||(pe={}));class ue{static fromArray(H){return new ue(oe=>{oe.emitMany(H)})}static fromPromise(H){return new ue(async oe=>{oe.emitMany(await H)})}static fromPromises(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>oe.emitOne(await ve)))})}static merge(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>{for await(const Ae of ve)oe.emitOne(Ae)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const oe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(H(oe)),this.j()}catch(ve){this.k(ve)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(H,oe){return new ue(async ve=>{for await(const Ae of H)ve.emitOne(oe(Ae))})}map(H){return ue.map(this,H)}static filter(H,oe){return new ue(async ve=>{for await(const Ae of H)oe(Ae)&&ve.emitOne(Ae)})}filter(H){return ue.filter(this,H)}static coalesce(H){return ue.filter(H,oe=>!!oe)}coalesce(){return ue.coalesce(this)}static async toPromise(H){const oe=[];for await(const ve of H)oe.push(ve);return oe}toPromise(){return ue.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class de extends ue{constructor(H,oe){super(oe),this.l=H}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function re(G){const H=new n.CancellationTokenSource,oe=G(H.token);return new de(H,async ve=>{const Ae=H.token.onCancellationRequested(()=>{Ae.dispose(),H.dispose(),ve.reject(new k.CancellationError)});try{for await(const Ue of oe){if(H.token.isCancellationRequested)return;ve.emitOne(Ue)}Ae.dispose(),H.dispose()}catch(Ue){Ae.dispose(),H.dispose(),ve.reject(Ue)}})}e.createCancelableAsyncIterable=re}),define(Ie[35],Ce([1,0,18,12,40,28,19,20,10]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",E="[^/\\\\]",m=/\//g;function p(le,_){switch(le){case 0:return"";case 1:return`${E}*?`;default:return`(?:${N}|${E}+${N}${_?`|${N}${E}+`:""})*?`}}function f(le,_){if(!le)return[];const pe=[];let ue=!1,de=!1,re="";for(const G of le){switch(G){case _:if(!ue&&!de){pe.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=G}return re&&pe.push(re),pe}e.splitGlobAware=f;function s(le){if(!le)return"";let _="";const pe=f(le,e.GLOB_SPLIT);if(pe.every(ue=>ue===e.GLOBSTAR))_=".*";else{let ue=!1;pe.forEach((de,re)=>{if(de===e.GLOBSTAR){if(ue)return;_+=p(2,re===pe.length-1)}else{let G=!1,H="",oe=!1,ve="";for(const Ae of de){if(Ae!=="}"&&G){H+=Ae;continue}if(oe&&(Ae!=="]"||!ve)){let Ue;Ae==="-"?Ue=Ae:(Ae==="^"||Ae==="!")&&!ve?Ue="^":Ae===e.GLOB_SPLIT?Ue="":Ue=(0,S.escapeRegExpCharacters)(Ae),ve+=Ue;continue}switch(Ae){case"{":G=!0;continue;case"[":oe=!0;continue;case"}":{_+=`(?:${f(H,",").map(Te=>s(Te)).join("|")})`,G=!1,H="";break}case"]":{_+="["+ve+"]",oe=!1,ve="";break}case"?":_+=E;continue;case"*":_+=p(1);continue;default:_+=(0,S.escapeRegExpCharacters)(Ae)}}re<pe.length-1&&(pe[re+1]!==e.GLOBSTAR||re+2<pe.length)&&(_+=N)}ue=de===e.GLOBSTAR})}return _}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.LRUCache(1e4),h=function(){return!1},i=function(){return null};function c(le,_){if(!le)return i;let pe;typeof le!="string"?pe=le.pattern:pe=le,pe=pe.trim();const ue=`${pe}_${!!_.trimForExclusions}`;let de=r.get(ue);if(de)return t(de,le);let re;return o.test(pe)?de=a(pe.substr(4),pe):(re=u.exec(d(pe,_)))?de=l(re[1],pe):(_.trimForExclusions?w:b).test(pe)?de=g(pe,_):(re=P.exec(d(pe,_)))?de=R(re[1].substr(1),pe,!0):(re=v.exec(d(pe,_)))?de=R(re[1],pe,!1):de=O(pe),r.set(ue,de),t(de,le)}function t(le,_){if(typeof _=="string")return le;const pe=function(ue,de){return(0,D.isEqualOrParent)(ue,_.base,!A.isLinux)?le((0,S.ltrim)(ue.substr(_.base.length),C.sep),de):null};return pe.allBasenames=le.allBasenames,pe.allPaths=le.allPaths,pe.basenames=le.basenames,pe.patterns=le.patterns,pe}function d(le,_){return _.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function a(le,_){return function(pe,ue){return typeof pe=="string"&&pe.endsWith(le)?_:null}}function l(le,_){const pe=`/${le}`,ue=`\\${le}`,de=function(G,H){return typeof G!="string"?null:H?H===le?_:null:G===le||G.endsWith(pe)||G.endsWith(ue)?_:null},re=[le];return de.basenames=re,de.patterns=[_],de.allBasenames=re,de}function g(le,_){const pe=V(le.slice(1,-1).split(",").map(H=>c(H,_)).filter(H=>H!==i),le),ue=pe.length;if(!ue)return i;if(ue===1)return pe[0];const de=function(H,oe){for(let ve=0,Ae=pe.length;ve<Ae;ve++)if(pe[ve](H,oe))return le;return null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function R(le,_,pe){const ue=C.sep===C.posix.sep,de=ue?le:le.replace(m,C.sep),re=C.sep+de,G=C.posix.sep+le;let H;return pe?H=function(oe,ve){return typeof oe=="string"&&(oe===de||oe.endsWith(re)||!ue&&(oe===le||oe.endsWith(G)))?_:null}:H=function(oe,ve){return typeof oe=="string"&&(oe===de||!ue&&oe===le)?_:null},H.allPaths=[(pe?"*/":"./")+le],H}function O(le){try{const _=new RegExp(`^${s(le)}$`);return function(pe){return _.lastIndex=0,typeof pe=="string"&&_.test(pe)?le:null}}catch{return i}}function q(le,_,pe){return!le||typeof _!="string"?!1:Z(le)(_,void 0,pe)}e.match=q;function Z(le,_={}){if(!le)return h;if(typeof le=="string"||x(le)){const pe=c(le,_);if(pe===i)return h;const ue=function(de,re){return!!pe(de,re)};return pe.allBasenames&&(ue.allBasenames=pe.allBasenames),pe.allPaths&&(ue.allPaths=pe.allPaths),ue}return T(le,_)}e.parse=Z;function x(le){const _=le;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=x;function F(le){return le.allBasenames||[]}e.getBasenameTerms=F;function $(le){return le.allPaths||[]}e.getPathTerms=$;function T(le,_){const pe=V(Object.getOwnPropertyNames(le).map(H=>L(H,le[H],_)).filter(H=>H!==i)),ue=pe.length;if(!ue)return i;if(!pe.some(H=>!!H.requiresSiblings)){if(ue===1)return pe[0];const H=function(Ae,Ue){let xe;for(let Te=0,Se=pe.length;Te<Se;Te++){const ke=pe[Te](Ae,Ue);if(typeof ke=="string")return ke;(0,k.isThenable)(ke)&&(xe||(xe=[]),xe.push(ke))}return xe?(async()=>{for(const Te of xe){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},oe=pe.find(Ae=>!!Ae.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const ve=pe.reduce((Ae,Ue)=>Ue.allPaths?Ae.concat(Ue.allPaths):Ae,[]);return ve.length&&(H.allPaths=ve),H}const de=function(H,oe,ve){let Ae,Ue;for(let xe=0,Te=pe.length;xe<Te;xe++){const Se=pe[xe];Se.requiresSiblings&&ve&&(oe||(oe=(0,C.basename)(H)),Ae||(Ae=oe.substr(0,oe.length-(0,C.extname)(H).length)));const ke=Se(H,oe,Ae,ve);if(typeof ke=="string")return ke;(0,k.isThenable)(ke)&&(Ue||(Ue=[]),Ue.push(ke))}return Ue?(async()=>{for(const xe of Ue){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function L(le,_,pe){if(_===!1)return i;const ue=c(le,pe);if(ue===i)return i;if(typeof _=="boolean")return ue;if(_){const de=_.when;if(typeof de=="string"){const re=(G,H,oe,ve)=>{if(!ve||!ue(G,H))return null;const Ae=de.replace("$(basename)",()=>oe),Ue=ve(Ae);return(0,k.isThenable)(Ue)?Ue.then(xe=>xe?le:null):Ue?le:null};return re.requiresSiblings=!0,re}}return ue}function V(le,_){const pe=le.filter(H=>!!H.basenames);if(pe.length<2)return le;const ue=pe.reduce((H,oe)=>{const ve=oe.basenames;return ve?H.concat(ve):H},[]);let de;if(_){de=[];for(let H=0,oe=ue.length;H<oe;H++)de.push(_)}else de=pe.reduce((H,oe)=>{const ve=oe.patterns;return ve?H.concat(ve):H},[]);const re=function(H,oe){if(typeof H!="string")return null;if(!oe){let Ae;for(Ae=H.length;Ae>0;Ae--){const Ue=H.charCodeAt(Ae-1);if(Ue===47||Ue===92)break}oe=H.substr(Ae)}const ve=ue.indexOf(oe);return ve!==-1?de[ve]:null};re.basenames=ue,re.patterns=de,re.allBasenames=ue;const G=le.filter(H=>!H.basenames);return G.push(re),G}function j(le,_){return(0,n.equals)(le,_,(pe,ue)=>typeof pe=="string"&&typeof ue=="string"?pe===ue:typeof pe!="string"&&typeof ue!="string"?pe.base===ue.base&&pe.pattern===ue.pattern:!1)}e.patternsEquals=j}),define(Ie[86],Ce([1,0,11,125,24,10,2]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",b=!1){if(this.value=u,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(u,b=0){return this.value+=m(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(w,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,b){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(u,b,w){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(u),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(u,b){const w=new RegExp((0,M.escapeRegExpCharacters)(b),"g");return u.replace(w,(P,v)=>u.charAt(v-1)!=="\\"?`\\${P}`:P)}}e.MarkdownString=S;function y(o){return N(o)?!o.value:Array.isArray(o)?o.every(y):!0}e.isEmptyMarkdownString=y;function N(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function E(o,u){return o===u?!0:!o||!u?!1:o.value===u.value&&o.isTrusted===u.isTrusted&&o.supportThemeIcons===u.supportThemeIcons&&o.supportHtml===u.supportHtml&&(o.baseUri===u.baseUri||!!o.baseUri&&!!u.baseUri&&(0,D.isEqual)(C.URI.from(o.baseUri),C.URI.from(u.baseUri)))}e.markdownStringEqual=E;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function p(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function f(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function s(o){const u=[],b=o.split("|").map(P=>P.trim());o=b[0];const w=b[1];if(w){const P=/height=(\d+)/.exec(w),v=/width=(\d+)/.exec(w),r=P?P[1]:"",h=v?v[1]:"",i=isFinite(parseInt(h)),c=isFinite(parseInt(r));i&&u.push(`width="${h}"`),c&&u.push(`height="${r}"`)}return{href:o,dimensions:u}}e.parseHrefAndDimensions=s}),define(Ie[87],Ce([1,0,18,40,19,20,24,10]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(i,c){const{os:t,tildify:d,relative:a}=c;if(a){const R=y(i,a,t);if(typeof R=="string")return R}let l=i.fsPath;if(t===1&&!M.isWindows?l=l.replace(/\//g,"\\"):t!==1&&M.isWindows&&(l=l.replace(/\\/g,"/")),t!==1&&d?.userHome){const R=d.userHome.fsPath;let O;i.scheme!==d.userHome.scheme&&i.path.startsWith(D.posix.sep)?O=d.userHome.with({path:i.path}).fsPath:O=i.fsPath,l=m(O,R,t)}return(t===1?D.win32:D.posix).normalize(N(l,t===1))}e.getPathLabel=S;function y(i,c,t){const d=t===1?D.win32:D.posix,a=t===3?C.extUri:C.extUriIgnorePathCase,l=c.getWorkspace(),g=(0,n.firstOrDefault)(l.folders);if(!g)return;i.scheme!==g.uri.scheme&&i.path.startsWith(D.posix.sep)&&(i=g.uri.with({path:i.path}));const R=c.getWorkspaceFolder(i);if(!R)return;let O;if(a.isEqual(R.uri,i)?O="":O=a.relativePath(R.uri,i)??"",O&&(O=d.normalize(O)),l.folders.length>1&&!c.noPrefix){const q=R.name?R.name:a.basenameOrAuthority(R.uri);O=O?`${q} \u2022 ${O}`:q}return O}function N(i,c=M.isWindows){return(0,k.hasDriveLetter)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=N;let E=Object.create(null);function m(i,c,t=M.OS){if(t===1||!i||!c)return i;let d=E.original===c?E.normalized:void 0;d||(d=c,M.isWindows&&(d=(0,k.toSlashes)(d)),d=`${(0,A.rtrim)(d,D.posix.sep)}${D.posix.sep}`,E={original:c,normalized:d});let a=i;return M.isWindows&&(a=(0,k.toSlashes)(a)),(t===3?a.startsWith(d):(0,A.startsWithIgnoreCase)(a,d))?`~/${a.substr(d.length)}`:i}e.tildify=m;function p(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=p;const f="\u2026",s="\\\\",o="~";function u(i,c=D.sep){const t=new Array(i.length);let d=!1;for(let a=0;a<i.length;a++){const l=i[a];if(l===""){t[a]=`.${c}`;continue}if(!l){t[a]=l;continue}d=!0;let g="",R=l;R.indexOf(s)===0?(g=R.substr(0,R.indexOf(s)+s.length),R=R.substr(R.indexOf(s)+s.length)):R.indexOf(c)===0?(g=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(o)===0&&(g=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length));const O=R.split(c);for(let q=1;d&&q<=O.length;q++)for(let Z=O.length-q;d&&Z>=0;Z--){d=!1;let x=O.slice(Z,Z+q).join(c);for(let F=0;!d&&F<i.length;F++)if(F!==a&&i[F]&&i[F].indexOf(x)>-1){const $=Z+q===O.length,T=Z>0&&i[F].indexOf(c)>-1?c+x:x,L=i[F].endsWith(T);d=!$||L}if(!d){let F="";(O[0].endsWith(":")||g!=="")&&(Z===1&&(Z=0,q++,x=O[0]+c+x),Z>0&&(F=O[0]+c),F=g+F),Z>0&&(F=F+f+c),F=F+x,Z+q<O.length&&(F=F+c+f),t[a]=F}}d&&(t[a]=l)}return t}e.shorten=u;var b;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function w(i,c=Object.create(null)){const t=[];let d=!1,a="";for(const l of i)if(l==="$"||d&&l==="{")a&&t.push({value:a,type:b.TEXT}),a="",d=!0;else if(l==="}"&&d){const g=c[a];if(typeof g=="string")g.length&&t.push({value:g,type:b.VARIABLE});else if(g){const R=t[t.length-1];(!R||R.type!==b.SEPARATOR)&&t.push({value:g.label,type:b.SEPARATOR})}a="",d=!1}else a+=l;return a&&!d&&t.push({value:a,type:b.TEXT}),t.filter((l,g)=>{if(l.type===b.SEPARATOR){const R=t[g-1],O=t[g+1];return[R,O].every(q=>q&&(q.type===b.VARIABLE||q.type===b.TEXT)&&q.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=w;function P(i,c){return M.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function v(i,c){return M.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function h(i){const c=i.indexOf("/")!==-1?D.posix:D.win32,t=c.basename(i),d=c.dirname(i);return t.length?{name:t,parentPath:d}:{name:d,parentPath:""}}e.splitName=h}),define(Ie[126],Ce([1,0,23,2]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(E){return E.toJSON()}class M{constructor(m){this.a=m}transformIncoming(m){const p=this.a.transformIncoming(m);return p===m?m:D(k.URI.from(p))}transformOutgoing(m){const p=this.a.transformOutgoing(m);return p===m?m:D(k.URI.from(p))}transformOutgoingURI(m){const p=this.a.transformOutgoing(m);return p===m?m:k.URI.from(p)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function C(E,m,p){if(!E||p>200)return null;if(typeof E=="object"){if(E instanceof k.URI)return m.transformOutgoing(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const s=C(E[f],m,p+1);s!==null&&(E[f]=s)}}return null}function A(E,m){const p=C(E,m,0);return p===null?E:p}e.transformOutgoingURIs=A;function S(E,m,p,f){if(!E||f>200)return null;if(typeof E=="object"){if(E.$mid===1)return p?k.URI.revive(m.transformIncoming(E)):m.transformIncoming(E);if(E instanceof n.VSBuffer)return null;for(const s in E)if(Object.hasOwnProperty.call(E,s)){const o=S(E[s],m,p,f+1);o!==null&&(E[s]=o)}}return null}function y(E,m){const p=S(E,m,!1,0);return p===null?E:p}e.transformIncomingURIs=y;function N(E,m){const p=S(E,m,!0,0);return p===null?E:p}e.transformAndReviveIncomingURIs=N}),define(Ie[127],Ce([1,0,35,19]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(M,C,A,S,y,N){if(Array.isArray(M)){let E=0;for(const m of M){const p=D(m,C,A,S,y,N);if(p===10)return p;p>E&&(E=p)}return E}else{if(typeof M=="string")return S?M==="*"?5:M===A?10:0:0;if(M){const{language:E,pattern:m,scheme:p,hasAccessToAllModels:f,notebookType:s}=M;if(!S&&!f)return 0;s&&y&&(C=y);let o=0;if(p)if(p===C.scheme)o=10;else if(p==="*")o=5;else return 0;if(E)if(E===A)o=10;else if(E==="*")o=Math.max(o,5);else return 0;if(s)if(s===N)o=10;else if(s==="*"&&N!==void 0)o=Math.max(o,5);else return 0;if(m){let u;if(typeof m=="string"?u=m:u={...m,base:(0,k.normalize)(m.base)},u===C.fsPath||(0,n.match)(u,C.fsPath))o=10;else return 0}return o}else return 0}}e.score=D}),define(Ie[88],Ce([1,0,23,20]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(D||(D={}));function M(E){for(let m=0,p=E.length;m<p;m+=4){const f=E[m+0],s=E[m+1],o=E[m+2],u=E[m+3];E[m+0]=u,E[m+1]=o,E[m+2]=s,E[m+3]=f}}function C(E){const m=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return k.isLittleEndian()||M(m),n.VSBuffer.wrap(m)}function A(E){const m=E.buffer;if(k.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const p=new Uint8Array(m.byteLength);return p.set(m),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(E){const m=new Uint32Array(y(E));let p=0;if(m[p++]=E.id,E.type==="full")m[p++]=1,m[p++]=E.data.length,m.set(E.data,p),p+=E.data.length;else{m[p++]=2,m[p++]=E.deltas.length;for(const f of E.deltas)m[p++]=f.start,m[p++]=f.deleteCount,f.data?(m[p++]=f.data.length,m.set(f.data,p),p+=f.data.length):m[p++]=0}return C(m)}e.encodeSemanticTokensDto=S;function y(E){let m=0;if(m+=1+1,E.type==="full")m+=1+E.data.length;else{m+=1,m+=(1+1+1)*E.deltas.length;for(const p of E.deltas)p.data&&(m+=p.data.length)}return m}function N(E){const m=A(E);let p=0;const f=m[p++];if(m[p++]===1){const b=m[p++],w=m.subarray(p,p+b);return p+=b,{id:f,type:"full",data:w}}const o=m[p++],u=[];for(let b=0;b<o;b++){const w=m[p++],P=m[p++],v=m[p++];let r;v>0&&(r=m.subarray(p,p+v),p+=v),u[b]={start:w,deleteCount:P,data:r}}return{id:f,type:"delta",deltas:u}}e.decodeSemanticTokensDto=N}),define(Ie[128],Ce([14,15]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ie[129],Ce([1,0,128,20,130,18,22,116]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=y;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class E{constructor(Q,ge,Me,ze){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=ze}applyUpdate(Q,ge){return p(Q,ge)}compute(Q,ge,Me){return Me}}class m{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=m;function p(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new m(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Me=Array.isArray(Y)&&Array.isArray(Q)&&M.equals(Y,Q);return new m(Q,!Me)}let ge=!1;for(const Me in Q)if(Q.hasOwnProperty(Me)){const ze=p(Y[Me],Q[Me]);ze.didChange&&(Y[Me]=ze.newValue,ge=!0)}return new m(Y,ge)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return p(Q,ge)}validate(Q){return this.defaultValue}}class s{constructor(Q,ge,Me,ze){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=ze}applyUpdate(Q,ge){return p(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Me){return Me}}function o(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:Boolean(Y)}e.boolean=o;class u extends s{constructor(Q,ge,Me,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Me),super(Q,ge,Me,ze)}validate(Q){return o(Q,this.defaultValue)}}function b(Y,Q,ge,Me){if(typeof Y>"u")return Q;let ze=parseInt(Y,10);return isNaN(ze)?Q:(ze=Math.max(ge,ze),ze=Math.min(Me,ze),ze|0)}e.clampedInt=b;class w extends s{static clampedInt(Q,ge,Me,ze){return b(Q,ge,Me,ze)}constructor(Q,ge,Me,ze,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=ze,Ye.maximum=Ve),super(Q,ge,Me,Ye),this.minimum=ze,this.maximum=Ve}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class P extends s{static clamp(Q,ge,Me){return Q<ge?ge:Q>Me?Me:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Me=parseFloat(Q);return isNaN(Me)?ge:Me}constructor(Q,ge,Me,ze,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Me),super(Q,ge,Me,Ve),this.validationFn=ze}validate(Q){return this.validationFn(P.float(Q,this.defaultValue))}}class v extends s{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Me,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Me),super(Q,ge,Me,ze)}validate(Q){return v.string(Q,this.defaultValue)}}function r(Y,Q,ge){return typeof Y!="string"||ge.indexOf(Y)===-1?Q:Y}e.stringSet=r;class h extends s{constructor(Q,ge,Me,ze,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=ze,Ve.default=Me),super(Q,ge,Me,Ve),this.c=ze}validate(Q){return r(Q,this.defaultValue,this.c)}}class i extends E{constructor(Q,ge,Me,ze,Ve,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ve,nt.default=ze),super(Q,ge,Me,nt),this.c=Ve,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function c(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Me){return Me===0?Q.accessibilitySupport:Me}}class d extends E{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function R(Y){switch(Y){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=R;function O(Y){switch(Y){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class q extends f{constructor(){super(135)}compute(Q,ge,Me){const ze=["monaco-editor"];return ge.get(36)&&ze.push(ge.get(36)),Q.extraEditorClassName&&ze.push(Q.extraEditorClassName),ge.get(70)==="default"?ze.push("mouse-default"):ge.get(70)==="copy"&&ze.push("mouse-copy"),ge.get(105)&&ze.push("showUnused"),ge.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class Z extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Q,ge,Me){return Me&&Q.emptySelectionClipboard}}class x extends E{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:n.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:n.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class F extends E{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.ON:Q:Boolean(Q)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class $ extends E{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?$.OFF:Q==="true"?$.TRANSLATE:Q:Boolean(Q)?$.TRANSLATE:$.OFF}compute(Q,ge,Me){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=$,$.OFF="normal",$.TRANSLATE="translate";class T extends f{constructor(){super(47)}compute(Q,ge,Me){return Q.fontInfo}}class L extends s{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(Q){const ge=P.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:P.clamp(ge,6,100)}compute(Q,ge,Me){return Q.fontInfo.fontSize}}class V extends E{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class j extends E{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Me,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Me,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Me,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Me,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Me,description:n.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:r(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??r(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??r(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??r(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??r(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??r(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends E{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:n.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:w.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),above:o(ge.above,this.defaultValue.above)}}}var _;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class pe extends f{constructor(){super(138)}compute(Q,ge,Me){return pe.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Me=Math.floor(Q.paddingTop/Q.lineHeight);let ze=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(ze=Math.max(ze,ge-1));const Ve=(Me+Q.viewLineCount+ze)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:ze,desiredRatio:Ve,minimapLineCount:Ye}}static c(Q,ge){const Me=Q.outerWidth,ze=Q.outerHeight,Ve=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=ge.stableMinimapLayoutInput,nt=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,vt=Q.lineHeight,wt=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,jt=Q.minimap.renderCharacters;let rt=Ve>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const mt=Q.minimap.maxColumn,Lt=Q.minimap.size,xt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,ht=Q.viewLineCount,kt=Q.remainingWidth,Bt=Q.isViewportWrapping,Ot=jt?2:3;let Ge=Math.floor(Ve*ze);const Mt=Ge/Ve;let Nt=!1,zt=!1,ft=Ot*rt,De=rt/Ve,Pe=1;if(Lt==="fill"||Lt==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:Tt,desiredRatio:bt,minimapLineCount:Et}=pe.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:ze,lineHeight:vt,pixelRatio:Ve});if(ht/Et>1)Nt=!0,zt=!0,rt=1,ft=1,De=rt/Ve;else{let St=!1,yt=rt+1;if(Lt==="fit"){const qt=Math.ceil((ct+ht+Tt)*ft);Bt&&nt&&kt<=ge.stableFitRemainingWidth?(St=!0,yt=ge.stableFitMaxMinimapScale):St=qt>Ge}if(Lt==="fill"||St){Nt=!0;const qt=rt;ft=Math.min(vt*Ve,Math.max(1,Math.floor(1/bt))),Bt&&nt&&kt<=ge.stableFitRemainingWidth&&(yt=ge.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(ft/Ot))),rt>qt&&(Pe=Math.min(2,rt/qt)),De=rt/Ve/Pe,Ge=Math.ceil(Math.max(Ze,ct+ht+Tt)*ft),Bt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=kt,ge.stableFitMaxMinimapScale=rt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const me=Math.floor(mt*De),X=Math.min(me,Math.max(0,Math.floor((kt-Pt-2)*De/(wt+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ve*X);const Be=Re/Ve;Re=Math.floor(Re*Pe);const Qe=jt?1:2,$e=xt==="left"?0:Me-X-Pt;return{renderMinimap:Qe,minimapLeft:$e,minimapWidth:X,minimapHeightIsEditorHeight:Nt,minimapIsSampling:zt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Be,minimapCanvasOuterHeight:Mt}}static computeLayout(Q,ge){const Me=ge.outerWidth|0,ze=ge.outerHeight|0,Ve=ge.lineHeight|0,Ye=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,vt=ge.maxDigitWidth,wt=ge.pixelRatio,Ct=ge.viewLineCount,jt=Q.get(130),rt=jt==="inherit"?Q.get(129):jt,mt=rt==="inherit"?Q.get(125):rt,Lt=Q.get(128),xt=ge.isDominatedByLongLines,Pt=Q.get(54),ht=Q.get(64).renderType!==0,kt=Q.get(65),Bt=Q.get(99),Ot=Q.get(80),Ge=Q.get(69),Mt=Q.get(97),Nt=Mt.verticalScrollbarSize,zt=Mt.verticalHasArrows,ft=Mt.arrowSize,De=Mt.horizontalScrollbarSize,Pe=Q.get(40),me=Q.get(104)!=="never";let X=Q.get(62);Pe&&me&&(X+=16);let Re=0;if(ht){const pt=Math.max(Ye,kt);Re=Math.round(pt*vt)}let Be=0;Pt&&(Be=Ve);let Qe=0,$e=Qe+Be,Ze=$e+Re,ct=Ze+X;const Tt=Me-Be-Re-X;let bt=!1,Et=!1,It=-1;rt==="inherit"&&xt?(bt=!0,Et=!0):mt==="on"||mt==="bounded"?Et=!0:mt==="wordWrapColumn"&&(It=Lt);const St=pe.c({outerWidth:Me,outerHeight:ze,lineHeight:Ve,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Bt,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Ge,verticalScrollbarWidth:Nt,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:Et},ge.memory||new N);St.renderMinimap!==0&&St.minimapLeft===0&&(Qe+=St.minimapWidth,$e+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const yt=Tt-St.minimapWidth,qt=Math.max(1,Math.floor((yt-Nt-2)/nt)),Jt=zt?ft:0;return Et&&(It=Math.max(1,qt),mt==="bounded"&&(It=Math.min(It,Lt))),{width:Me,height:ze,glyphMarginLeft:Qe,glyphMarginWidth:Be,lineNumbersLeft:$e,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:X,contentLeft:ct,contentWidth:yt,minimap:St,viewportColumn:qt,isWordWrapMinified:bt,isViewportWrapping:Et,wrappingColumn:It,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:De,overviewRuler:{top:Jt,width:Nt,height:ze-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=pe;class ue extends E{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,ge,Me){return ge.get(2)===2?"advanced":Me}}class de extends E{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:n.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class re extends E{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends E{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:n.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:r(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class H extends E{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):w.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Me){return Me<0?w.clampedInt(-Me*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class oe extends P{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>P.clamp(Q,0,150),{markdownDescription:n.localize(60,null)})}compute(Q,ge,Me){return Q.fontInfo.lineHeight}}class ve extends E{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:Q.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:n.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:r(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ge.side,this.defaultValue.side,["right","left"]),showSlider:r(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ge.scale,1,1,3),maxColumn:w.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(Y){return Y==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ue extends E{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:w.clampedInt(ge.top,0,0,1e3),bottom:w.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends E{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:n.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(Q,ge,Me){return Q.pixelRatio}}class Se extends E{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:n.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:n.localize(80,null)},other:{anyOf:ge,default:Q.other,description:n.localize(81,null)}},default:Q,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const wt=Q?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Me,strings:ze}=Q,Ve=["on","inline","off"];let Ye,nt,vt;return typeof ge=="boolean"?Ye=ge?"on":"off":Ye=r(ge,this.defaultValue.other,Ve),typeof Me=="boolean"?nt=Me?"on":"off":nt=r(Me,this.defaultValue.comments,Ve),typeof ze=="boolean"?vt=ze?"on":"off":vt=r(ze,this.defaultValue.strings,Ve),{other:Ye,comments:nt,strings:vt}}}var ke;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends E{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Me=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function ce(Y){const Q=Y.get(92);return Q==="editable"?Y.get(86):Q!=="on"}e.filterValidationDecorations=ce;class J extends E{constructor(){const Q=[],ge={type:"number",description:n.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:Q,description:n.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Me of Q)if(typeof Me=="number")ge.push({column:w.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const ze=Me;ge.push({column:w.clampedInt(ze.column,0,0,1e4),color:ze.color})}return ge.sort((Me,ze)=>Me.column-ze.column),ge}return this.defaultValue}}function I(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends E{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:n.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Me=w.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=w.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ge.vertical,this.defaultValue.vertical),horizontal:I(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:w.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:w.clampedInt(ge.verticalSliderSize,ze,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends E{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:n.localize(108,null)}})}applyUpdate(Q,ge){let Me=!1;ge.allowedCharacters&&Q&&(C.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Me=!0)),ge.allowedLocales&&Q&&(C.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Me=!0));const ze=super.applyUpdate(Q,ge);return Me?new m(ze.newValue,!0):ze}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:ye(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Me={};for(const[ze,Ve]of Object.entries(Q))Ve===!0&&(Me[ze]=!0);return Me}}class K extends E{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:n.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:r(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends E{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:n.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class he extends E{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(112,null),n.localize(113,null),n.localize(114,null)],default:Q.bracketPairs,description:n.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(116,null),n.localize(117,null),n.localize(118,null)],default:Q.bracketPairsHorizontal,description:n.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:n.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:n.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(122,null),n.localize(123,null),n.localize(124,null)],default:Q.highlightActiveIndentation,description:n.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:ye(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(Y,Q,ge){const Me=ge.indexOf(Y);return Me===-1?Q:ge[Me]}class ae extends E{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(126,null),n.localize(127,null)],default:Q.insertMode,description:n.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:n.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:n.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:n.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(132,null),n.localize(133,null),n.localize(134,null),n.localize(135,null)],default:Q.selectionMode,markdownDescription:n.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:n.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:n.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:n.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:n.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:n.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:r(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:r(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class be extends E{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(174,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends f{constructor(){super(137)}compute(Q,ge,Me){return ge.get(86)?!0:Q.tabFocusMode}}var We;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends E{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(175,null),n.localize(176,null),n.localize(177,null),n.localize(178,null)],description:n.localize(179,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Me){return ge.get(2)===2?0:Me}}class tt extends f{constructor(){super(139)}compute(Q,ge,Me){const ze=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Xe extends E{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(180,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?it:k.isLinux?dt:et,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ot;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.autoClosingBrackets=5]="autoClosingBrackets",Y[Y.autoClosingDelete=6]="autoClosingDelete",Y[Y.autoClosingOvertype=7]="autoClosingOvertype",Y[Y.autoClosingQuotes=8]="autoClosingQuotes",Y[Y.autoIndent=9]="autoIndent",Y[Y.automaticLayout=10]="automaticLayout",Y[Y.autoSurround=11]="autoSurround",Y[Y.bracketPairColorization=12]="bracketPairColorization",Y[Y.guides=13]="guides",Y[Y.codeLens=14]="codeLens",Y[Y.codeLensFontFamily=15]="codeLensFontFamily",Y[Y.codeLensFontSize=16]="codeLensFontSize",Y[Y.colorDecorators=17]="colorDecorators",Y[Y.colorDecoratorsLimit=18]="colorDecoratorsLimit",Y[Y.columnSelection=19]="columnSelection",Y[Y.comments=20]="comments",Y[Y.contextmenu=21]="contextmenu",Y[Y.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=23]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=25]="cursorStyle",Y[Y.cursorSurroundingLines=26]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=28]="cursorWidth",Y[Y.disableLayerHinting=29]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Y[Y.domReadOnly=31]="domReadOnly",Y[Y.dragAndDrop=32]="dragAndDrop",Y[Y.dropIntoEditor=33]="dropIntoEditor",Y[Y.emptySelectionClipboard=34]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=36]="extraEditorClassName",Y[Y.fastScrollSensitivity=37]="fastScrollSensitivity",Y[Y.find=38]="find",Y[Y.fixedOverflowWidgets=39]="fixedOverflowWidgets",Y[Y.folding=40]="folding",Y[Y.foldingStrategy=41]="foldingStrategy",Y[Y.foldingHighlight=42]="foldingHighlight",Y[Y.foldingImportsByDefault=43]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=44]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=46]="fontFamily",Y[Y.fontInfo=47]="fontInfo",Y[Y.fontLigatures=48]="fontLigatures",Y[Y.fontSize=49]="fontSize",Y[Y.fontWeight=50]="fontWeight",Y[Y.fontVariations=51]="fontVariations",Y[Y.formatOnPaste=52]="formatOnPaste",Y[Y.formatOnType=53]="formatOnType",Y[Y.glyphMargin=54]="glyphMargin",Y[Y.gotoLocation=55]="gotoLocation",Y[Y.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Y[Y.hover=57]="hover",Y[Y.inDiffEditor=58]="inDiffEditor",Y[Y.inlineSuggest=59]="inlineSuggest",Y[Y.letterSpacing=60]="letterSpacing",Y[Y.lightbulb=61]="lightbulb",Y[Y.lineDecorationsWidth=62]="lineDecorationsWidth",Y[Y.lineHeight=63]="lineHeight",Y[Y.lineNumbers=64]="lineNumbers",Y[Y.lineNumbersMinChars=65]="lineNumbersMinChars",Y[Y.linkedEditing=66]="linkedEditing",Y[Y.links=67]="links",Y[Y.matchBrackets=68]="matchBrackets",Y[Y.minimap=69]="minimap",Y[Y.mouseStyle=70]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=72]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=74]="multiCursorModifier",Y[Y.multiCursorPaste=75]="multiCursorPaste",Y[Y.multiCursorLimit=76]="multiCursorLimit",Y[Y.occurrencesHighlight=77]="occurrencesHighlight",Y[Y.overviewRulerBorder=78]="overviewRulerBorder",Y[Y.overviewRulerLanes=79]="overviewRulerLanes",Y[Y.padding=80]="padding",Y[Y.parameterHints=81]="parameterHints",Y[Y.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=84]="quickSuggestions",Y[Y.quickSuggestionsDelay=85]="quickSuggestionsDelay",Y[Y.readOnly=86]="readOnly",Y[Y.renameOnType=87]="renameOnType",Y[Y.renderControlCharacters=88]="renderControlCharacters",Y[Y.renderFinalNewline=89]="renderFinalNewline",Y[Y.renderLineHighlight=90]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=92]="renderValidationDecorations",Y[Y.renderWhitespace=93]="renderWhitespace",Y[Y.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Y[Y.roundedSelection=95]="roundedSelection",Y[Y.rulers=96]="rulers",Y[Y.scrollbar=97]="scrollbar",Y[Y.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=99]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=100]="scrollPredominantAxis",Y[Y.selectionClipboard=101]="selectionClipboard",Y[Y.selectionHighlight=102]="selectionHighlight",Y[Y.selectOnLineNumbers=103]="selectOnLineNumbers",Y[Y.showFoldingControls=104]="showFoldingControls",Y[Y.showUnused=105]="showUnused",Y[Y.snippetSuggestions=106]="snippetSuggestions",Y[Y.smartSelect=107]="smartSelect",Y[Y.smoothScrolling=108]="smoothScrolling",Y[Y.stickyScroll=109]="stickyScroll",Y[Y.stickyTabStops=110]="stickyTabStops",Y[Y.stopRenderingLineAfter=111]="stopRenderingLineAfter",Y[Y.suggest=112]="suggest",Y[Y.suggestFontSize=113]="suggestFontSize",Y[Y.suggestLineHeight=114]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Y[Y.suggestSelection=116]="suggestSelection",Y[Y.tabCompletion=117]="tabCompletion",Y[Y.tabIndex=118]="tabIndex",Y[Y.unicodeHighlighting=119]="unicodeHighlighting",Y[Y.unusualLineTerminators=120]="unusualLineTerminators",Y[Y.useShadowDOM=121]="useShadowDOM",Y[Y.useTabStops=122]="useTabStops",Y[Y.wordBreak=123]="wordBreak",Y[Y.wordSeparators=124]="wordSeparators",Y[Y.wordWrap=125]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=128]="wordWrapColumn",Y[Y.wordWrapOverride1=129]="wordWrapOverride1",Y[Y.wordWrapOverride2=130]="wordWrapOverride2",Y[Y.wrappingIndent=131]="wrappingIndent",Y[Y.wrappingStrategy=132]="wrappingStrategy",Y[Y.showDeprecated=133]="showDeprecated",Y[Y.inlayHints=134]="inlayHints",Y[Y.editorClassName=135]="editorClassName",Y[Y.pixelRatio=136]="pixelRatio",Y[Y.tabFocusMode=137]="tabFocusMode",Y[Y.layoutInfo=138]="layoutInfo",Y[Y.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(181,null)})),acceptSuggestionOnEnter:Le(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(182,null),""],markdownDescription:n.localize(183,null)})),accessibilitySupport:Le(new t),accessibilityPageSize:Le(new w(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(184,null),tags:["accessibility"]})),ariaLabel:Le(new v(4,"ariaLabel",n.localize(185,null))),autoClosingBrackets:Le(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(186,null),n.localize(187,null),""],description:n.localize(188,null)})),autoClosingDelete:Le(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(189,null),""],description:n.localize(190,null)})),autoClosingOvertype:Le(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(191,null),""],description:n.localize(192,null)})),autoClosingQuotes:Le(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(193,null),n.localize(194,null),""],description:n.localize(195,null)})),autoIndent:Le(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[n.localize(196,null),n.localize(197,null),n.localize(198,null),n.localize(199,null),n.localize(200,null)],description:n.localize(201,null)})),automaticLayout:Le(new u(10,"automaticLayout",!1)),autoSurround:Le(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(202,null),n.localize(203,null),n.localize(204,null),""],description:n.localize(205,null)})),bracketPairColorization:Le(new ee),bracketPairGuides:Le(new he),stickyTabStops:Le(new u(110,"stickyTabStops",!1,{description:n.localize(206,null)})),codeLens:Le(new u(14,"codeLens",!0,{description:n.localize(207,null)})),codeLensFontFamily:Le(new v(15,"codeLensFontFamily","",{description:n.localize(208,null)})),codeLensFontSize:Le(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(209,null)})),colorDecorators:Le(new u(17,"colorDecorators",!0,{description:n.localize(210,null)})),colorDecoratorsLimit:Le(new w(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(211,null)})),columnSelection:Le(new u(19,"columnSelection",!1,{description:n.localize(212,null)})),comments:Le(new d),contextmenu:Le(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new u(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(213,null)})),cursorBlinking:Le(new i(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:n.localize(214,null)})),cursorSmoothCaretAnimation:Le(new h(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(215,null),n.localize(216,null),n.localize(217,null)],description:n.localize(218,null)})),cursorStyle:Le(new i(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:n.localize(219,null)})),cursorSurroundingLines:Le(new w(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(220,null)})),cursorSurroundingLinesStyle:Le(new h(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(221,null),n.localize(222,null)],description:n.localize(223,null)})),cursorWidth:Le(new w(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(224,null)})),disableLayerHinting:Le(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new u(31,"domReadOnly",!1)),dragAndDrop:Le(new u(32,"dragAndDrop",!0,{description:n.localize(225,null)})),emptySelectionClipboard:Le(new Z),dropIntoEditor:Le(new Xe),stickyScroll:Le(new re),experimentalWhitespaceRendering:Le(new h(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(226,null),n.localize(227,null),n.localize(228,null)],description:n.localize(229,null)})),extraEditorClassName:Le(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Le(new P(37,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:n.localize(230,null)})),find:Le(new x),fixedOverflowWidgets:Le(new u(39,"fixedOverflowWidgets",!1)),folding:Le(new u(40,"folding",!0,{description:n.localize(231,null)})),foldingStrategy:Le(new h(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(232,null),n.localize(233,null)],description:n.localize(234,null)})),foldingHighlight:Le(new u(42,"foldingHighlight",!0,{description:n.localize(235,null)})),foldingImportsByDefault:Le(new u(43,"foldingImportsByDefault",!1,{description:n.localize(236,null)})),foldingMaximumRegions:Le(new w(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(237,null)})),unfoldOnClickAfterEndOfLine:Le(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(238,null)})),fontFamily:Le(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(239,null)})),fontInfo:Le(new T),fontLigatures2:Le(new F),fontSize:Le(new L),fontWeight:Le(new V),fontVariations:Le(new $),formatOnPaste:Le(new u(52,"formatOnPaste",!1,{description:n.localize(240,null)})),formatOnType:Le(new u(53,"formatOnType",!1,{description:n.localize(241,null)})),glyphMargin:Le(new u(54,"glyphMargin",!0,{description:n.localize(242,null)})),gotoLocation:Le(new j),hideCursorInOverviewRuler:Le(new u(56,"hideCursorInOverviewRuler",!1,{description:n.localize(243,null)})),hover:Le(new le),inDiffEditor:Le(new u(58,"inDiffEditor",!1)),letterSpacing:Le(new P(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>P.clamp(Y,-5,20),{description:n.localize(244,null)})),lightbulb:Le(new de),lineDecorationsWidth:Le(new H),lineHeight:Le(new oe),lineNumbers:Le(new se),lineNumbersMinChars:Le(new w(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new u(66,"linkedEditing",!1,{description:n.localize(245,null)})),links:Le(new u(67,"links",!0,{description:n.localize(246,null)})),matchBrackets:Le(new h(68,"matchBrackets","always",["always","near","never"],{description:n.localize(247,null)})),minimap:Le(new ve),mouseStyle:Le(new h(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new P(71,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:n.localize(248,null)})),mouseWheelZoom:Le(new u(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(249,null)})),multiCursorMergeOverlapping:Le(new u(73,"multiCursorMergeOverlapping",!0,{description:n.localize(250,null)})),multiCursorModifier:Le(new i(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[n.localize(251,null),n.localize(252,null)],markdownDescription:n.localize(253,null)})),multiCursorPaste:Le(new h(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorLimit:Le(new w(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(257,null)})),occurrencesHighlight:Le(new u(77,"occurrencesHighlight",!0,{description:n.localize(258,null)})),overviewRulerBorder:Le(new u(78,"overviewRulerBorder",!0,{description:n.localize(259,null)})),overviewRulerLanes:Le(new w(79,"overviewRulerLanes",3,0,3)),padding:Le(new Ue),parameterHints:Le(new xe),peekWidgetDefaultFocus:Le(new h(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(260,null),n.localize(261,null)],description:n.localize(262,null)})),definitionLinkOpensInPeek:Le(new u(83,"definitionLinkOpensInPeek",!1,{description:n.localize(263,null)})),quickSuggestions:Le(new Se),quickSuggestionsDelay:Le(new w(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(264,null)})),readOnly:Le(new u(86,"readOnly",!1)),renameOnType:Le(new u(87,"renameOnType",!1,{description:n.localize(265,null),markdownDeprecationMessage:n.localize(266,null)})),renderControlCharacters:Le(new u(88,"renderControlCharacters",!0,{description:n.localize(267,null),restricted:!0})),renderFinalNewline:Le(new h(89,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(268,null)})),renderLineHighlight:Le(new h(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(269,null)],description:n.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Le(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(271,null)})),renderValidationDecorations:Le(new h(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new h(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(272,null),n.localize(273,null),n.localize(274,null),""],description:n.localize(275,null)})),revealHorizontalRightPadding:Le(new w(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new u(95,"roundedSelection",!0,{description:n.localize(276,null)})),rulers:Le(new J),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new w(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(277,null)})),scrollBeyondLastLine:Le(new u(99,"scrollBeyondLastLine",!0,{description:n.localize(278,null)})),scrollPredominantAxis:Le(new u(100,"scrollPredominantAxis",!0,{description:n.localize(279,null)})),selectionClipboard:Le(new u(101,"selectionClipboard",!0,{description:n.localize(280,null),included:k.isLinux})),selectionHighlight:Le(new u(102,"selectionHighlight",!0,{description:n.localize(281,null)})),selectOnLineNumbers:Le(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Le(new h(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(282,null),n.localize(283,null),n.localize(284,null)],description:n.localize(285,null)})),showUnused:Le(new u(105,"showUnused",!0,{description:n.localize(286,null)})),showDeprecated:Le(new u(133,"showDeprecated",!0,{description:n.localize(287,null)})),inlayHints:Le(new G),snippetSuggestions:Le(new h(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(288,null),n.localize(289,null),n.localize(290,null),n.localize(291,null)],description:n.localize(292,null)})),smartSelect:Le(new be),smoothScrolling:Le(new u(108,"smoothScrolling",!1,{description:n.localize(293,null)})),stopRenderingLineAfter:Le(new w(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ae),inlineSuggest:Le(new K),suggestFontSize:Le(new w(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new w(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new u(115,"suggestOnTriggerCharacters",!0,{description:n.localize(296,null)})),suggestSelection:Le(new h(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(297,null),n.localize(298,null),n.localize(299,null)],description:n.localize(300,null)})),tabCompletion:Le(new h(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(301,null),n.localize(302,null),n.localize(303,null)],description:n.localize(304,null)})),tabIndex:Le(new w(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new W),unusualLineTerminators:Le(new h(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(305,null),n.localize(306,null),n.localize(307,null)],description:n.localize(308,null)})),useShadowDOM:Le(new u(121,"useShadowDOM",!0)),useTabStops:Le(new u(122,"useTabStops",!0,{description:n.localize(309,null)})),wordBreak:Le(new h(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(310,null),n.localize(311,null)],description:n.localize(312,null)})),wordSeparators:Le(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:n.localize(313,null)})),wordWrap:Le(new h(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(314,null),n.localize(315,null),n.localize(316,null),n.localize(317,null)],description:n.localize(318,null)})),wordWrapBreakAfterCharacters:Le(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new w(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(319,null)})),wordWrapOverride1:Le(new h(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new h(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new q),pixelRatio:Le(new Te),tabFocusMode:Le(new Ee),layoutInfo:Le(new pe),wrappingInfo:Le(new tt),wrappingIndent:Le(new He),wrappingStrategy:Le(new ue)}}),define(Ie[131],Ce([14,15]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[132],Ce([14,15]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[133],Ce([14,15]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[134],Ce([14,15]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ie[135],Ce([14,15]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ie[136],Ce([14,15]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[137],Ce([14,15]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ie[138],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[139],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[140],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[141],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[142],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[143],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[144],Ce([14,15]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[145],Ce([14,15]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ie[146],Ce([14,15]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ie[147],Ce([14,15]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[148],Ce([14,15]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[149],Ce([14,15]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[150],Ce([14,15]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[151],Ce([14,15]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[152],Ce([14,15]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[153],Ce([14,15]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[154],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map}register(M,C){this.a.set(M,C)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const C in M.contributes){const A=this.a.get(C);if(!A)continue;const S=M.contributes[C],y=Array.isArray(S)?S:[S];try{A(y,M.activationEvents)}catch(N){(0,n.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ie[155],Ce([1,0,24,30,133,255]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||C.test(u)}e.isValidVersionStr=S;function y(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=u.match(C);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=y;function N(u){if(!u)return null;const b=u.majorBase,w=u.majorMustEqual,P=u.minorBase;let v=u.minorMustEqual;const r=u.patchBase;let h=u.patchMustEqual;u.hasCaret&&(b===0||(v=!1),h=!1);let i=0;if(u.preRelease){const c=A.exec(u.preRelease);if(c){const[,t,d,a]=c;i=Date.UTC(Number(t),Number(d)-1,Number(a))}}return{majorBase:b,majorMustEqual:w,minorBase:P,minorMustEqual:v,patchBase:r,patchMustEqual:h,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=N;function E(u,b,w){let P;typeof u=="string"?P=N(y(u)):P=u;let v;b instanceof Date?v=b.getTime():typeof b=="string"&&(v=new Date(b).getTime());let r;if(typeof w=="string"?r=N(y(w)):r=w,!P||!r)return!1;const h=P.majorBase,i=P.minorBase,c=P.patchBase;let t=r.majorBase,d=r.minorBase,a=r.patchBase;const l=r.notBefore;let g=r.majorMustEqual,R=r.minorMustEqual,O=r.patchMustEqual;return r.isMinimum?h>t?!0:h<t?!1:i>d?!0:i<d||v&&v<l?!1:c>=a:(h===1&&t===0&&(!g||!R||!O)&&(t=1,d=0,a=0,g=!0,R=!1,O=!1),h<t?!1:h>t?!g:i<d?!1:i>d?!R:c<a?!1:c>a?!O:!(v&&v<l))}e.isValidVersion=E;function m(u,b,w,P,v){const r=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return r.push([k.default.Error,D.localize(0,null)]),r;if(typeof P.name!="string")return r.push([k.default.Error,D.localize(1,null,"name")]),r;if(typeof P.version!="string")return r.push([k.default.Error,D.localize(2,null,"version")]),r;if(!P.engines)return r.push([k.default.Error,D.localize(3,null,"engines")]),r;if(typeof P.engines.vscode!="string")return r.push([k.default.Error,D.localize(4,null,"engines.vscode")]),r;if(typeof P.extensionDependencies<"u"&&!o(P.extensionDependencies))return r.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),r;if(typeof P.activationEvents<"u"){if(!o(P.activationEvents))return r.push([k.default.Error,D.localize(6,null,"activationEvents")]),r;if(typeof P.main>"u"&&typeof P.browser>"u")return r.push([k.default.Error,D.localize(7,null,"activationEvents","main")]),r}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&r.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return r.push([k.default.Error,D.localize(9,null,"main")]),r;{const c=(0,n.joinPath)(w,P.main);(0,n.isEqualOrParent)(c,w)||r.push([k.default.Warning,D.localize(10,null,c.path,w.path)])}if(typeof P.activationEvents>"u")return r.push([k.default.Error,D.localize(11,null,"activationEvents","main")]),r}if(typeof P.browser<"u"){if(typeof P.browser!="string")return r.push([k.default.Error,D.localize(12,null,"browser")]),r;{const c=(0,n.joinPath)(w,P.browser);(0,n.isEqualOrParent)(c,w)||r.push([k.default.Warning,D.localize(13,null,c.path,w.path)])}if(typeof P.activationEvents>"u")return r.push([k.default.Error,D.localize(14,null,"activationEvents","browser")]),r}if(!M.valid(P.version))return r.push([k.default.Error,D.localize(15,null)]),r;const h=[];if(!p(u,b,P,v,h))for(const c of h)r.push([k.default.Error,c]);return r}e.validateExtensionManifest=m;function p(u,b,w,P,v){return P||typeof w.main>"u"&&typeof w.browser>"u"?!0:s(u,b,w.engines.vscode,v)}e.isValidExtensionVersion=p;function f(u,b,w){return u==="*"||s(b,w,u)}e.isEngineValid=f;function s(u,b,w,P=[]){const v=N(y(w));if(!v)return P.push(D.localize(16,null,w)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return P.push(D.localize(17,null,w)),!1}else if(!v.majorMustEqual)return P.push(D.localize(18,null,w)),!1;return E(u,b,v)?!0:(P.push(D.localize(19,null,u,w)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let b=0,w=u.length;b<w;b++)if(typeof u[b]!="string")return!1;return!0}}),define(Ie[89],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(D,M=[],C=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=n}),define(Ie[67],Ce([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var D;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function M(A,S,y){S instanceof n.SyncDescriptor||(S=new n.SyncDescriptor(S,[],Boolean(y))),k.push([A,S])}e.registerSingleton=M;function C(){return k}e.getSingletonServiceDescriptors=C}),define(Ie[156],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class k{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const A=this.lookupOrInsertNode(M),S=this.lookupOrInsertNode(C);A.outgoing.set(S.key,S),S.incoming.set(A.key,A)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let A=this.a.get(C);return A||(A=new n(C,M),this.a.set(C,A)),A}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,A]of this.a)M.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const A=new Set([M]),S=this.c(C,A);if(S)return S}}c(M,C){for(const[A,S]of M.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const y=this.c(S,C);if(y)return y;C.delete(A)}}}e.Graph=k}),define(Ie[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(n=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(C,A,S){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:C,index:S}):(A[n.DI_DEPENDENCIES]=[{id:C,index:S}],A[n.DI_TARGET]=A)}function D(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const A=function(S,y,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(A,S,N)};return A.toString=()=>C,n.serviceIds.set(C,A),A}e.createDecorator=D;function M(C){return C}e.refineServiceDecorator=M}),define(Ie[41],Ce([1,0,9,2,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationOverrides=M;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=C;var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function y(u,b){const w=Object.create(null);for(const P in u)N(w,P,u[P],b);return w}e.toValuesTree=y;function N(u,b,w,P){const v=b.split("."),r=v.pop();let h=u;for(let i=0;i<v.length;i++){const c=v[i];let t=h[c];switch(typeof t){case"undefined":t=h[c]=Object.create(null);break;case"object":break;default:P(`Ignoring ${b} as ${v.slice(0,i+1).join(".")} is ${JSON.stringify(t)}`);return}h=t}if(typeof h=="object"&&h!==null)try{h[r]=w}catch{P(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(h)}`)}else P(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=N;function E(u,b){const w=b.split(".");m(u,w)}e.removeFromValueTree=E;function m(u,b){const w=b.shift();if(b.length===0){delete u[w];return}if(Object.keys(u).indexOf(w)!==-1){const P=u[w];typeof P=="object"&&!Array.isArray(P)&&(m(P,b),Object.keys(P).length===0&&delete u[w])}}function p(u,b,w){function P(h,i){let c=h;for(const t of i){if(typeof c!="object"||c===null)return;c=c[t]}return c}const v=b.split("."),r=P(u,v);return typeof r>"u"?w:r}e.getConfigurationValue=p;function f(u,b,w){Object.keys(b).forEach(P=>{P!=="__proto__"&&(P in u?n.isObject(u[P])&&n.isObject(b[P])?f(u[P],b[P],w):w&&(u[P]=b[P]):u[P]=b[P])})}e.merge=f;function s(u,b,w){const P=u.inspect(b),v=u.inspect(w);return typeof P.userValue<"u"||typeof P.workspaceValue<"u"||typeof P.workspaceFolderValue<"u"?P.value:typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:P.defaultValue}e.getMigratedSettingValue=s;function o(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ie[42],Ce([1,0,20,10,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",n.isMacintosh),M.set("isLinux",n.isLinux),M.set("isWindows",n.isWindows),M.set("isWeb",n.isWeb),M.set("isMacNative",n.isMacintosh&&!n.isWeb),M.set("isEdge",n.isEdge),M.set("isFirefox",n.isFirefox),M.set("isChrome",n.isChrome),M.set("isSafari",n.isSafari);const C=Object.prototype.hasOwnProperty;var A;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return E.INSTANCE}static true(){return m.INSTANCE}static has(F){return p.create(F)}static equals(F,$){return f.create(F,$)}static notEquals(F,$){return u.create(F,$)}static regex(F,$){return i.create(F,$)}static in(F,$){return s.create(F,$)}static notIn(F,$){return o.create(F,$)}static not(F){return b.create(F)}static and(...F){return d.create(F,null,!0)}static or(...F){return a.create(F,null,!0)}static greater(F,$){return P.create(F,$)}static greaterEquals(F,$){return v.create(F,$)}static smaller(F,$){return r.create(F,$)}static smallerEquals(F,$){return h.create(F,$)}static deserialize(F,$=!1){if(!!F)return this.c(F,$)}static c(F,$){const T=F.split("||");return a.create(T.map(L=>this.d(L,$)),null,!0)}static d(F,$){const T=F.split("&&");return d.create(T.map(L=>this.f(L,$)),null,!0)}static f(F,$){if(F=F.trim(),F.indexOf("!=")>=0){const T=F.split("!=");return u.create(T[0].trim(),this.g(T[1],$))}if(F.indexOf("==")>=0){const T=F.split("==");return f.create(T[0].trim(),this.g(T[1],$))}if(F.indexOf("=~")>=0){const T=F.split("=~");return i.create(T[0].trim(),this.h(T[1],$))}if(F.indexOf(" not in ")>=0){const T=F.split(" not in ");return o.create(T[0].trim(),this.g(T[1],$))}if(F.indexOf(" in ")>=0){const T=F.split(" in ");return s.create(T[0].trim(),this.g(T[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const T=F.split(">=");return v.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const T=F.split(">");return P.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const T=F.split("<=");return h.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const T=F.split("<");return r.create(T[0].trim(),T[1].trim())}return/^\!\s*/.test(F)?b.create(F.substr(1).trim()):p.create(F)}static g(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const T=/^'([^']*)'$/.exec(F);return T?T[1].trim():F}static h(F,$){if((0,k.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const T=F.indexOf("/"),L=F.lastIndexOf("/");if(T===L||T<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const V=F.slice(T+1,L),j=F[L+1]==="i"?"i":"";try{return new RegExp(V,j)}catch(le){if($)throw new Error(`bad regexp-value '${F}', parse error: ${le}`);return console.warn(`bad regexp-value '${F}', parse error: ${le}`),null}}}e.ContextKeyExpr=S;function y(x,F){const $=x?x.substituteConstants():void 0,T=F?F.substituteConstants():void 0;return!$&&!T?!0:!$||!T?!1:$.equals(T)}e.expressionsAreEqualWithConstantSubstitution=y;function N(x,F){return x.cmp(F)}class E{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class m{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class p{static create(F,$=null){const T=M.get(F);return typeof T=="boolean"?T?m.INSTANCE:E.INSTANCE:new p(F,$)}constructor(F,$){this.key=F,this.c=$,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:g(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=M.get(this.key);return typeof F=="boolean"?F?m.INSTANCE:E.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class f{static create(F,$,T=null){if(typeof $=="boolean")return $?p.create(F,T):b.create(F,T);const L=M.get(F);return typeof L=="boolean"?$===(L?"true":"false")?m.INSTANCE:E.INSTANCE:new f(F,$,T)}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=M.get(this.c);if(typeof F=="boolean"){const $=F?"true":"false";return this.d===$?m.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class s{static create(F,$){return new s(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:R(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.f),T=F.getValue(this.d);return Array.isArray($)?$.includes(T):typeof T=="string"&&typeof $=="object"&&$!==null?C.call($,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=s;class o{static create(F,$){return new o(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=11,this.c=s.create(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class u{static create(F,$,T=null){if(typeof $=="boolean")return $?b.create(F,T):p.create(F,T);const L=M.get(F);return typeof L=="boolean"?$===(L?"true":"false")?E.INSTANCE:m.INSTANCE:new u(F,$,T)}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=M.get(this.c);if(typeof F=="boolean"){const $=F?"true":"false";return this.d===$?E.INSTANCE:m.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class b{static create(F,$=null){const T=M.get(F);return typeof T=="boolean"?T?E.INSTANCE:m.INSTANCE:new b(F,$)}constructor(F,$){this.c=F,this.d=$,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:g(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=M.get(this.c);return typeof F=="boolean"?F?E.INSTANCE:m.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function w(x,F){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?F(x):E.INSTANCE}class P{static create(F,$,T=null){return w($,L=>new P(F,L,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=P;class v{static create(F,$,T=null){return w($,L=>new v(F,L,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=v;class r{static create(F,$,T=null){return w($,L=>new r(F,L,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=r;class h{static create(F,$,T=null){return w($,L=>new h(F,L,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=h;class i{static create(F,$){return new i(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const $=this.f?this.f.source:"",T=F.f?F.f.source:"";return $<T?-1:$>T?1:0}equals(F){if(F.type===this.type){const $=this.f?this.f.source:"",T=F.f?F.f.source:"";return this.d===F.d&&$===T}return!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=c.create(this)),this.c}}e.ContextKeyRegexExpr=i;class c{static create(F){return new c(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new c(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=c;function t(x){let F=null;for(let $=0,T=x.length;$<T;$++){const L=x[$].substituteConstants();if(x[$]!==L&&F===null){F=[];for(let V=0;V<$;V++)F[V]=x[V]}F!==null&&(F[$]=L)}return F===null?x:F}class d{static create(F,$,T){return d.d(F,$,T)}constructor(F,$){this.expr=F,this.c=$,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const L=N(this.expr[$],F.expr[$]);if(L!==0)return L}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=t(this.expr);return F===this.expr?this:d.create(F,this.c,!1)}evaluate(F){for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static d(F,$,T){const L=[];let V=!1;for(const j of F)if(!!j){if(j.type===1){V=!0;continue}if(j.type===0)return E.INSTANCE;if(j.type===6){L.push(...j.expr);continue}L.push(j)}if(L.length===0&&V)return m.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(N);for(let j=1;j<L.length;j++)L[j-1].equals(L[j])&&(L.splice(j,1),j--);if(L.length===1)return L[0];for(;L.length>1;){const j=L[L.length-1];if(j.type!==9)break;L.pop();const le=L.pop(),_=L.length===0,pe=a.create(j.expr.map(ue=>d.create([ue,le],null,T)),null,_);pe&&(L.push(pe),L.sort(N))}if(L.length===1)return L[0];if(T){for(let j=0;j<L.length;j++)for(let le=j+1;le<L.length;le++)if(L[j].negate().equals(L[le]))return E.INSTANCE;if(L.length===1)return L[0]}return new d(L,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const $ of this.expr)F.push(...$.keys());return F}map(F){return new d(this.expr.map($=>$.map(F)),null)}negate(){if(!this.c){const F=[];for(const $ of this.expr)F.push($.negate());this.c=a.create(F,this,!0)}return this.c}}class a{static create(F,$,T){return a.d(F,$,T)}constructor(F,$){this.expr=F,this.c=$,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const L=N(this.expr[$],F.expr[$]);if(L!==0)return L}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=t(this.expr);return F===this.expr?this:a.create(F,this.c,!1)}evaluate(F){for(let $=0,T=this.expr.length;$<T;$++)if(this.expr[$].evaluate(F))return!0;return!1}static d(F,$,T){let L=[],V=!1;if(F){for(let j=0,le=F.length;j<le;j++){const _=F[j];if(!!_){if(_.type===0){V=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){L=L.concat(_.expr);continue}L.push(_)}}if(L.length===0&&V)return E.INSTANCE;L.sort(N)}if(L.length!==0){if(L.length===1)return L[0];for(let j=1;j<L.length;j++)L[j-1].equals(L[j])&&(L.splice(j,1),j--);if(L.length===1)return L[0];if(T){for(let j=0;j<L.length;j++)for(let le=j+1;le<L.length;le++)if(L[j].negate().equals(L[le]))return m.INSTANCE;if(L.length===1)return L[0]}return new a(L,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const $ of this.expr)F.push(...$.keys());return F}map(F){return new a(this.expr.map($=>$.map(F)),null)}negate(){if(!this.c){const F=[];for(const $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),T=F.shift(),L=[];for(const V of Z($))for(const j of Z(T))L.push(d.create([V,j],null,!1));F.unshift(a.create(L,null,!1))}this.c=a.create(F,this,!0)}return this.c}}class l extends p{static all(){return l.d.values()}constructor(F,$,T){super(F,null),this.f=$,typeof T=="object"?l.d.push({...T,key:F}):T!==!0&&l.d.push({key:F,description:T,type:$!=null?typeof $:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return f.create(this.key,F)}notEqualsTo(F){return u.create(this.key,F)}}e.RawContextKey=l,l.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function g(x,F){return x<F?-1:x>F?1:0}function R(x,F,$,T){return x<$?-1:x>$?1:F<T?-1:F>T?1:0}function O(x,F){if(x.type===0||F.type===1)return!0;if(x.type===9)return F.type===9?q(x.expr,F.expr):!1;if(F.type===9){for(const $ of F.expr)if(O(x,$))return!0;return!1}if(x.type===6){if(F.type===6)return q(F.expr,x.expr);for(const $ of x.expr)if(O($,F))return!0;return!1}return x.equals(F)}e.implies=O;function q(x,F){let $=0,T=0;for(;$<x.length&&T<F.length;){const L=x[$].cmp(F[T]);if(L<0)return!1;L===0&&$++,T++}return $===x.length}function Z(x){return x.type===9?x.expr:[x]}}),define(Ie[157],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[90],Ce([1,0,132,3]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function C(u,b){switch(u){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function A(u,b){return b==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function S(u,b,w){return A(b,w)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===w?!0:y(w).includes(u)}e.isTargetPlatformCompatible=S;function y(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function N(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=N;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var s;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(b,w){super(b),this.code=w,this.name=w}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,134,3,20]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function N(_){return _.create===!0}e.isFileOpenForWriteOptions=N;var E;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var m;(function(_){_[_.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var p;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=f;function s(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=s;function o(_){return!!(_.capabilities&32768)}e.hasFileCloneCapability=o;function u(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function b(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=b;function w(_){return f(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var P;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.FileSystemProviderError=v;function r(_,pe){const ue=new v(_.toString(),pe);return i(ue,pe),ue}e.createFileSystemProviderError=r;function h(_){return _||r((0,A.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=h;function i(_,pe){return _.name=pe?`${pe} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=i;function c(_){if(!_)return P.Unknown;if(_ instanceof v)return _.code;const pe=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!pe)return P.Unknown;switch(pe[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=c;function t(_){if(_ instanceof O)return _.fileOperationResult;switch(c(_)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var d;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(d=e.FileOperation||(e.FileOperation={}));class a{constructor(pe,ue,de){this.resource=pe,this.operation=ue,this.target=de}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=a;var l;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class g{constructor(pe,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const re of pe){const G=de.get(re.type);switch(G?G.push([re.resource,re]):de.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,G]of de)switch(re){case 1:this.a=n.TernarySearchTree.forUris(()=>ue),this.a.fill(G);break;case 0:this.b=n.TernarySearchTree.forUris(()=>ue),this.b.fill(G);break;case 2:this.c=n.TernarySearchTree.forUris(()=>ue),this.c.fill(G);break}}contains(pe,...ue){return this.d(pe,{includeChildren:!1},...ue)}affects(pe,...ue){return this.d(pe,{includeChildren:!0},...ue)}d(pe,ue,...de){if(!pe)return!1;const re=de.length>0;return!!((!re||de.includes(1))&&(this.a?.get(pe)||ue.includeChildren&&this.a?.findSuperstr(pe))||(!re||de.includes(0))&&(this.b?.get(pe)||ue.includeChildren&&this.b?.findSuperstr(pe))||(!re||de.includes(2))&&(this.c?.findSubstr(pe)||ue.includeChildren&&this.c?.findSuperstr(pe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function R(_,pe,ue){return!_||!pe||_===pe||pe.length>_.length?!1:(pe.charAt(pe.length-1)!==k.sep&&(pe+=k.sep),ue?(0,D.startsWithIgnoreCase)(_,pe):_.indexOf(pe)===0)}e.isParent=R;class O extends Error{constructor(pe,ue,de){super(pe),this.fileOperationResult=ue,this.options=de}}e.FileOperationError=O;class q extends O{constructor(pe,ue,de,re){super(pe,ue,re),this.fileOperationResult=ue,this.size=de}}e.TooLargeFileOperationError=q;class Z extends O{constructor(pe,ue,de){super(pe,2,de),this.stat=ue}}e.NotModifiedSinceFileOperationError=Z;var x;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=$;async function T(_,pe){if(!pe.hasProvider(C.URI.from({scheme:_.scheme})))return new Promise(ue=>{const de=pe.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===_.scheme&&re.added&&(de.dispose(),ue())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(pe){return(0,M.isNumber)(pe)||(pe=0),pe<L.KB?(0,A.localize)(1,null,pe.toFixed(0)):pe<L.MB?(0,A.localize)(2,null,(pe/L.KB).toFixed(2)):pe<L.GB?(0,A.localize)(3,null,(pe/L.MB).toFixed(2)):pe<L.TB?(0,A.localize)(4,null,(pe/L.GB).toFixed(2)):(0,A.localize)(5,null,(pe/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function j(_){return{maxFileSize:_===0?300*L.MB:16*L.GB,maxHeapSize:_===0?700*L.MB:2*700*L.MB}}e.getPlatformFileLimits=j;function le(_){return y.isWeb?_?10*L.MB:50*L.MB:_?100*L.MB:1024*L.MB}e.getLargeFileConfirmationLimit=le}),define(Ie[68],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...D){this.a=new Map;for(const[M,C]of D)this.set(M,C)}set(D,M){const C=this.a.get(D);return this.a.set(D,M),C}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=n}),define(Ie[158],Ce([1,0,12,11,6,89,156,3,68,159]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class m{constructor(o=new S.ServiceCollection,u=!1,b,w=N){this.f=o,this.g=u,this.h=b,this.i=w,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=w?b?._globalGraph??new C.Graph(P=>P):void 0}createChild(o){return new m(o,this.g,this,this.i)}invokeFunction(o,...u){const b=f.traceInvocation(this.i,o);let w=!1;try{return o({get:v=>{if(w)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const r=this.m(v,b);if(!r)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...u)}finally{w=!0,b.stop()}}createInstance(o,...u){let b,w;return o instanceof M.SyncDescriptor?(b=f.traceCreation(this.i,o.ctor),w=this.j(o.ctor,o.staticArguments.concat(u),b)):(b=f.traceCreation(this.i,o),w=this.j(o,u,b)),b.stop(),w}j(o,u=[],b){const w=A._util.getServiceDependencies(o).sort((r,h)=>r.index-h.index),P=[];for(const r of w){const h=this.m(r.id,b);h||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${r.id}.`,!1),P.push(h)}const v=w.length>0?w[0].index:u.length;if(u.length!==v){console.trace(`[createInstance] First service dependency of ${o.name} at position ${v+1} conflicts with ${u.length} static arguments`);const r=v-u.length;r>0?u=u.concat(new Array(r)):u=u.slice(0,v)}return Reflect.construct(o,u.concat(P))}k(o,u){if(this.f.get(o)instanceof M.SyncDescriptor)this.f.set(o,u);else if(this.h)this.h.k(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const u=this.f.get(o);return!u&&this.h?this.h.l(o):u}m(o,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const b=this.l(o);return b instanceof M.SyncDescriptor?this.q(o,b,u.branch(o,!0)):(u.branch(o,!1),b)}q(o,u,b){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,u,b)}finally{this.o.delete(o)}}r(o,u,b){const w=new C.Graph(r=>r.id.toString());let P=0;const v=[{id:o,desc:u,_trace:b}];for(;v.length;){const r=v.pop();if(w.lookupOrInsertNode(r),P++>1e3)throw new E(w);for(const h of A._util.getServiceDependencies(r.desc.ctor)){const i=this.l(h.id);if(i||this.u(`[createInstance] ${o} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(h.id)),i instanceof M.SyncDescriptor){const c={id:h.id,desc:i,_trace:r._trace.branch(h.id,!0)};w.insertEdge(r,c),v.push(c)}}}for(;;){const r=w.roots();if(r.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:h}of r){if(this.l(h.id)instanceof M.SyncDescriptor){const c=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,c)}w.removeNode(h)}}return this.l(o)}s(o,u,b=[],w,P){if(this.f.get(o)instanceof M.SyncDescriptor)return this.t(o,u,b,w,P);if(this.h)return this.h.s(o,u,b,w,P);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(o,u,b=[],w,P){if(w){const v=new m(void 0,this.g,this,this.i);v.c=String(o);const r=new Map,h=new n.IdleValue(()=>{const i=v.j(u,b,P);for(const[c,t]of r){const d=i[c];if(typeof d=="function")for(const a of t)d.apply(i,a)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,c){if(!h.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let a=r.get(c);return a||(a=new y.LinkedList,r.set(c,a)),(g,R,O)=>{const q=a.push([g,R,O]);return(0,D.toDisposable)(q)}}if(c in i)return i[c];const t=h.value;let d=t[c];return typeof d!="function"||(d=d.bind(t),i[c]=d),d},set(i,c,t){return h.value[c]=t,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,b,P)}u(o,u){if(u&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=m;var p;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(p||(p={}));class f{static traceInvocation(o,u){return o?new f(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,u){return o?new f(1,u.name):f.c}constructor(o,u){this.type=o,this.name=u,this.g=Date.now(),this.h=[]}branch(o,u){const b=new f(3,o.toString());return this.h.push([o,u,b]),b}stop(){const o=Date.now()-this.g;f.f+=o;let u=!1;function b(P,v){const r=[],h=new Array(P+1).join("	");for(const[i,c,t]of v.h)if(c&&t){u=!0,r.push(`${h}CREATES -> ${i}`);const d=b(P+1,t);d&&r.push(d)}else r.push(`${h}uses -> ${i}`);return r.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||u)&&f.all.add(w.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ie[13],Ce([1,0,39,4,6,28,20,3]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function S(){return new Date().toISOString()}var y;(function(t){t[t.Off=0]="Off",t[t.Trace=1]="Trace",t[t.Debug=2]="Debug",t[t.Info=3]="Info",t[t.Warning=4]="Warning",t[t.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function N(t,d,a){switch(d){case y.Trace:t.trace(a);break;case y.Debug:t.debug(a);break;case y.Info:t.info(a);break;case y.Warning:t.warn(a);break;case y.Error:t.error(a);break;case y.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=N;function E(t){let d="";for(let a=0;a<t.length;a++){let l=t[a];if(typeof l=="object")try{l=JSON.stringify(l)}catch{}d+=(a>0?" ":"")+l}return d}e.format=E;class m extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==y.Off&&this.b<=d}}e.AbstractLogger=m;class p extends m{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...a){this.f(y.Trace)&&this.g(y.Trace,E([d,...a]))}debug(d,...a){this.f(y.Debug)&&this.g(y.Debug,E([d,...a]))}info(d,...a){this.f(y.Info)&&this.g(y.Info,E([d,...a]))}warn(d,...a){this.f(y.Warning)&&this.g(y.Warning,E([d,...a]))}error(d,...a){if(this.f(y.Error))if(d instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=d.stack,this.g(y.Error,E(l))}else this.g(y.Error,E([d,...a]))}flush(){}}e.AbstractMessageLogger=p;class f extends m{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.g=!C.isWindows}trace(d,...a){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,d,...a):console.log(`[main ${S()}]`,d,...a))}debug(d,...a){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,d,...a):console.log(`[main ${S()}]`,d,...a))}info(d,...a){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,d,...a):console.log(`[main ${S()}]`,d,...a))}warn(d,...a){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,d,...a):console.warn(`[main ${S()}]`,d,...a))}error(d,...a){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,d,...a):console.error(`[main ${S()}]`,d,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class s extends m{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d)}trace(d,...a){this.f(y.Trace)&&console.log("%cTRACE","color: #888",d,...a)}debug(d,...a){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",d,...a)}info(d,...a){this.f(y.Info)&&console.log("%c INFO","color: #33f",d,...a)}warn(d,...a){this.f(y.Warning)&&console.log("%c WARN","color: #993",d,...a)}error(d,...a){this.f(y.Error)&&console.log("%c  ERR","color: #f33",d,...a)}dispose(){}flush(){}}e.ConsoleLogger=s;class o extends m{constructor(d,a=e.DEFAULT_LOG_LEVEL){super(),this.g=d,this.setLevel(a)}trace(d,...a){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(d),...a])}debug(d,...a){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(d),...a])}info(d,...a){this.f(y.Info)&&this.g.log(y.Info,[this.h(d),...a])}warn(d,...a){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(d),...a])}error(d,...a){this.f(y.Error)&&this.g.log(y.Error,[this.h(d),...a])}h(d){return typeof d=="string"?d:(0,n.toErrorMessage)(d,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=o;class u extends m{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const a of this.g)a.setLevel(d);super.setLevel(d)}trace(d,...a){for(const l of this.g)l.trace(d,...a)}debug(d,...a){for(const l of this.g)l.debug(d,...a)}info(d,...a){for(const l of this.g)l.info(d,...a)}warn(d,...a){for(const l of this.g)l.warn(d,...a)}error(d,...a){for(const l of this.g)l.error(d,...a)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.MultiplexLogService=u;class b extends D.Disposable{constructor(d){super(),this.b=d,this.B(d)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(d){this.b.setLevel(d)}getLevel(){return this.b.getLevel()}trace(d,...a){this.b.trace(d,...a)}debug(d,...a){this.b.debug(d,...a)}info(d,...a){this.b.info(d,...a)}warn(d,...a){this.b.warn(d,...a)}error(d,...a){this.b.error(d,...a)}flush(){this.b.flush()}}e.LogService=b;class w extends D.Disposable{constructor(d,a,l){if(super(),this.h=d,this.b=new M.ResourceMap,this.c=new M.ResourceMap,this.f=this.B(new k.Emitter),this.onDidChangeLoggerResources=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeLogLevel=this.g.event,this.B(a(g=>this.j(g))),l)for(const g of l)this.c.set(g.resource,g)}getLogger(d){return this.b.get(d)}createLogger(d,a,l){let g=this.b.get(d);return g||(l=a?.always?y.Trace:l,g=this.k(d,l??this.getLogLevel(d)??this.h,a),this.b.set(d,g),this.registerLoggerResource({resource:d,logLevel:l,name:a?.name})),g}setLogLevel(d,a){const l=this.c.get(d);l&&a!==l.logLevel&&(l.logLevel=a===this.h?void 0:a,this.b.get(d)?.setLevel(a),this.c.set(l.resource,l),this.g.fire(l))}j(d){this.h=d;for(const[a,l]of this.b.entries())this.c.get(a)?.logLevel===void 0&&l.setLevel(this.h)}getLogLevel(d){return this.c.get(d)?.logLevel}registerLoggerResource(d){this.c.get(d.resource)||(this.c.set(d.resource,d),this.f.fire({added:[d],removed:[]}))}deregisterLoggerResource(d){const a=this.c.get(d);a&&(this.c.delete(d),this.f.fire({added:[],removed:[a]}))}getLoggerResources(){return this.c.values()}dispose(){this.b.forEach(d=>d.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=w;class P{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(d){}getLevel(){return y.Info}trace(d,...a){}debug(d,...a){}info(d,...a){}warn(d,...a){}error(d,...a){}critical(d,...a){}dispose(){}flush(){}}e.NullLogger=P;class v extends P{}e.NullLogService=v;class r extends w{constructor(){super(y.Info,k.Event.None)}k(d,a,l){return new P}}e.NullLoggerService=r;function h(t){if(t.verbose)return y.Trace;if(typeof t.logLevel=="string"){const d=c(t.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function i(t){switch(t){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=i;function c(t){switch(t){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=c}),define(Ie[91],Ce([1,0,30,135,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(f,s){return s-f}S.compare=y;const N=Object.create(null);N[S.Error]=(0,k.localize)(0,null),N[S.Warning]=(0,k.localize)(1,null),N[S.Info]=(0,k.localize)(2,null);function E(f){return N[f]||""}S.toString=E;function m(f){switch(f){case n.default.Error:return S.Error;case n.default.Warning:return S.Warning;case n.default.Info:return S.Info;case n.default.Ignore:return S.Hint}}S.fromSeverity=m;function p(f){switch(f){case S.Error:return n.default.Error;case S.Warning:return n.default.Warning;case S.Info:return n.default.Info;case S.Hint:return n.default.Ignore}}S.toSeverity=p}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(S){const y="";function N(m){return E(m,!0)}S.makeKey=N;function E(m,p){const f=[y];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(y),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(y),m.severity!==void 0&&m.severity!==null?f.push(C.toString(m.severity)):f.push(y),m.message&&p?f.push(m.message.replace("\xA6","\\\xA6")):f.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(y),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(y),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}S.makeKeyOptionalMessage=E})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ie[160],Ce([1,0,4,30,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,D.createDecorator)("notificationService");var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new S,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=A;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(Ie[92],Ce([1,0,10,2,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function M(y,N){return k.URI.isUri(y)?(0,n.equalsIgnoreCase)(y.scheme,N):(0,n.startsWithIgnoreCase)(y,N+":")}e.matchesScheme=M;function C(y,...N){return N.some(E=>M(y,E))}e.matchesSomeScheme=C;function A(y,N){return y.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=A;function S(y){let N;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(y.fragment);return E&&(N={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},y=y.with({fragment:""})),{selection:N,uri:y}}e.extractSelection=S}),define(Ie[161],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,k){var D=arguments.length,M=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,n):k,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,n,k);else for(var A=te.length-1;A>=0;A--)(C=te[A])&&(M=(D<3?C(M):D>3?C(e,n,M):C(e,n))||M);return D>3&&M&&Object.defineProperty(e,n,M),M},je=this&&this.__param||function(te,e){return function(n,k){e(n,k,te)}};define(Ie[162],Ce([1,0,12,21,6,3]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var C;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(E){this.b=E}report(E){this.a=E,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(E,m){super(),this.a=new n.DeferredPromise,m.withProgress(E,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(E){this.b?this.b.report(E):this.c=E}};S=qe([je(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends D.Disposable{constructor(E){super(),this.g=E,this.a=0,this.b=this.B(new D.DisposableStore)}start(E){this.stop();const m=++this.a,p=new k.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},E),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>p.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:p.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(E){this.a===E&&this.b.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ie[29],Ce([1,0,47,9]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(C,A){n.ok(k.isString(C)),n.ok(k.isObject(A)),n.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new D}),define(Ie[69],Ce([1,0,4,29]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,y){this.a[D(S)]=y,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;k.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[93],Ce([1,0,18,4,9,131,41,69,29]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=S.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(r,h=!0){this.registerConfigurations([r],h)}registerConfigurations(r,h=!0){const i=new Set;this.n(r,h,i),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(r){const h=new Set;this.o(r,h),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:r,remove:h}){const i=new Set;this.o(h,i),this.n(r,!1,i),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(r){const h=new Set;this.k(r,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(r,h){const i=[];for(const{overrides:c,source:t}of r)for(const d in c)if(h.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const a=this.a.get(d),l=a?.valuesSources??new Map;if(t)for(const q of Object.keys(c[d]))l.set(q,t);const g={...a?.value||{},...c[d]};this.a.set(d,{source:t,value:g,valuesSources:l});const R=(0,C.getLanguageTagSettingPlainKey)(d),O={type:"object",default:g,description:M.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:D.isString(t)?void 0:t,defaultValueSource:t};i.push(...s(d)),this.d[d]=O,this.b.properties[d]=O}else{this.a.set(d,{value:c[d],source:t});const a=this.d[d];a&&(this.w(d,a),this.r(d,a))}this.m(i)}deregisterDefaultConfigurations(r){const h=new Set;this.l(r,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(r,h){for(const{overrides:i,source:c}of r)for(const t in i){const d=this.a.get(t),a=D.isString(c)?c:c?.id,l=D.isString(d?.source)?d?.source:d?.source?.id;if(a===l)if(h.add(t),this.a.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.d[t],delete this.b.properties[t];else{const g=this.d[t];g&&(this.w(t,g),this.r(t,g))}}this.u()}deltaConfiguration(r){let h=!1;const i=new Set;r.removedDefaults&&(this.l(r.removedDefaults,i),h=!0),r.addedDefaults&&(this.k(r.addedDefaults,i),h=!0),r.removedConfigurations&&this.o(r.removedConfigurations,i),r.addedConfigurations&&this.n(r.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const h of r)this.h.add(h);this.u()}n(r,h,i){r.forEach(c=>{this.p(c,h,c.extensionInfo,c.restrictedProperties,void 0,i),this.c.push(c),this.q(c)})}o(r,h){const i=c=>{if(c.properties)for(const t in c.properties){h.add(t);const d=this.d[t];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[t],this.s(t,c.properties[t])}c.allOf?.forEach(t=>i(t))};for(const c of r){i(c);const t=this.c.indexOf(c);t!==-1&&this.c.splice(t,1)}}p(r,h=!0,i,c,t=3,d){t=D.isUndefinedOrNull(r.scope)?t:r.scope;const a=r.properties;if(a)for(const g in a){const R=a[g];if(h&&w(g,R)){delete a[g];continue}if(R.source=i,R.defaultDefaultValue=a[g].default,this.w(g,R),e.OVERRIDE_PROPERTY_REGEX.test(g)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?t:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!c?.includes(g):R.restricted),a[g].hasOwnProperty("included")&&!a[g].included){this.f[g]=a[g],delete a[g];continue}else this.d[g]=a[g],a[g].policy?.name&&this.e.set(a[g].policy.name,g);!a[g].deprecationMessage&&a[g].markdownDeprecationMessage&&(a[g].deprecationMessage=a[g].markdownDeprecationMessage),d.add(g)}const l=r.allOf;if(l)for(const g of l)this.p(g,h,i,c,t,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const h=i=>{const c=i.properties;if(c)for(const d in c)this.r(d,c[d]);i.allOf?.forEach(h)};h(r)}r(r,h){switch(e.allSettings.properties[r]=h,h.scope){case 1:e.applicationSettings.properties[r]=h;break;case 2:e.machineSettings.properties[r]=h;break;case 6:e.machineOverridableSettings.properties[r]=h;break;case 3:e.windowSettings.properties[r]=h;break;case 4:e.resourceSettings.properties[r]=h;break;case 5:e.resourceSettings.properties[r]=h,this.g.properties[r]=h;break}}s(r,h){switch(delete e.allSettings.properties[r],h.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const h=`[${r}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(h,i),e.allSettings.properties[h]=i,e.applicationSettings.properties[h]=i,e.machineSettings.properties[h]=i,e.machineOverridableSettings.properties[h]=i,e.windowSettings.properties[h]=i,e.resourceSettings.properties[h]=i}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this.i.fire()}w(r,h){const i=this.a.get(r);let c=i?.value,t=i?.source;D.isUndefined(c)&&(c=h.defaultDefaultValue,t=void 0),D.isUndefined(c)&&(c=u(h.type)),h.default=c,h.defaultValueSource=t}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(v){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let h=f.exec(v);for(;h?.length;){const i=h[1].trim();i&&r.push(i),h=f.exec(v)}}return(0,n.distinct)(r)}e.overrideIdentifiersFromKey=s;function o(v){return v.reduce((r,h)=>`${r}[${h}]`,"")}e.keyFromOverrideIdentifiers=o;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const b=new m;S.Registry.add(e.Extensions.Configuration,b);function w(v,r){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):b.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):r.policy?.name&&b.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,v,r.policy?.name,b.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.validateProperty=w;function P(){const v=[],r=b.getConfigurationProperties();for(const h of Object.keys(r))v.push([h,r[h].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=P}),define(Ie[163],Ce([1,0,18,4,111,6,28,22,9,2,41,93,29]),function(te,e,n,k,D,M,C,A,S,y,N,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function p(h){return Object.isFrozen(h)?h:A.deepFreeze(h)}class f{constructor(i={},c=[],t=[],d){this.b=i,this.c=c,this.d=t,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(c=>{if(c instanceof f)return c;const t=new s("");return t.parseRaw(c),t.configurationModel});this.f=i.reduce((c,t)=>t===c?t:c.merge(t),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,N.getConfigurationValue)(this.contents,i):this.contents}inspect(i,c){const t=this.rawConfiguration.getValue(i),d=c?this.rawConfiguration.getOverrideValue(i,c):void 0,a=c?this.rawConfiguration.override(c).getValue(i):t;return{value:t,override:d,merged:a}}getOverrideValue(i,c){const t=this.i(c);return t?i?(0,N.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const c=[];for(const t of this.overrides)t.identifiers.includes(i)&&c.push(...t.keys);return n.distinct(c)}getAllOverrideIdentifiers(){const i=[];for(const c of this.overrides)i.push(...c.identifiers);return n.distinct(i)}override(i){let c=this.a.get(i);return c||(c=this.g(i),this.a.set(i,c)),c}merge(...i){const c=A.deepClone(this.contents),t=A.deepClone(this.overrides),d=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const l of i)if(a.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(c,l.contents);for(const g of l.overrides){const[R]=t.filter(O=>n.equals(O.identifiers,g.identifiers));R?(this.h(R.contents,g.contents),R.keys.push(...g.keys),R.keys=n.distinct(R.keys)):t.push(A.deepClone(g))}for(const g of l.keys)d.indexOf(g)===-1&&d.push(g)}return new f(c,d,t,a.every(l=>l instanceof f)?void 0:a)}g(i){const c=this.i(i);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const t={};for(const d of n.distinct([...Object.keys(this.contents),...Object.keys(c)])){let a=this.contents[d];const l=c[d];l&&(typeof a=="object"&&typeof l=="object"?(a=A.deepClone(a),this.h(a,l)):a=l),t[d]=a}return new f(t,this.keys,this.overrides)}h(i,c){for(const t of Object.keys(c)){if(t in i&&S.isObject(i[t])&&S.isObject(c[t])){this.h(i[t],c[t]);continue}i[t]=A.deepClone(c[t])}}i(i){let c=null,t=null;const d=a=>{a&&(t?this.h(t,a):t=A.deepClone(a))};for(const a of this.overrides)n.equals(a.identifiers,[i])?c=a.contents:a.identifiers.includes(i)&&d(a.contents);return d(c),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,c){this.j(i,c,!0)}setValue(i,c){this.j(i,c,!1)}removeValue(i){const c=this.keys.indexOf(i);c!==-1&&(this.keys.splice(c,1),(0,N.removeFromValueTree)(this.contents,i),E.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(t=>n.equals(t.identifiers,(0,E.overrideIdentifiersFromKey)(i))),1))}j(i,c,t){(0,N.addToValueTree)(this.contents,i,c,d=>console.error(d)),t=t||this.keys.indexOf(i)===-1,t&&this.keys.push(i),E.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,N.toValuesTree)(this.contents[i],d=>console.error(d))})}}e.ConfigurationModel=f;class s{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,c){if(!S.isUndefinedOrNull(i)){const t=this.g(i);this.parseRaw(t,c)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,c){this.a=i;const{contents:t,keys:d,overrides:a,restricted:l,hasExcludedProperties:g}=this.h(i,c);this.b=new f(t,d,a,g?[i]:void 0),this.c=l||[]}g(i){let c={},t=null,d=[];const a=[],l=[];function g(O){Array.isArray(d)?d.push(O):t!==null&&(d[t]=O)}const R={onObjectBegin:()=>{const O={};g(O),a.push(d),d=O,t=null},onObjectProperty:O=>{t=O},onObjectEnd:()=>{d=a.pop()},onArrayBegin:()=>{const O=[];g(O),a.push(d),d=O,t=null},onArrayEnd:()=>{d=a.pop()},onLiteralValue:g,onError:(O,q,Z)=>{l.push({error:O,offset:q,length:Z})}};if(i)try{D.visit(i,R),c=d[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return c}h(i,c){const t=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),d=this.i(i,t,!0,c);i=d.raw;const a=(0,N.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),l=Object.keys(i),g=this.j(i,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:a,keys:l,overrides:g,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(i,c,t,d){let a=!1;if(!d?.scopes&&!d?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const l={},g=[];for(const R in i)if(E.OVERRIDE_PROPERTY_REGEX.test(R)&&t){const O=this.i(i[R],c,!1,d);l[R]=O.raw,a=a||O.hasExcludedProperties,g.push(...O.restricted)}else{const O=c[R],q=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&g.push(R),(q===void 0||d.scopes===void 0||d.scopes.includes(q))&&!(d.skipRestricted&&O?.restricted)?l[R]=i[R]:a=!0}return{raw:l,restricted:g,hasExcludedProperties:a}}j(i,c){const t=[];for(const d of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(d)){const a={};for(const l in i[d])a[l]=i[d][l];t.push({identifiers:(0,E.overrideIdentifiersFromKey)(d),keys:Object.keys(a),contents:(0,N.toValuesTree)(a,c)})}return t}}e.ConfigurationModelParser=s;class o extends M.Disposable{constructor(i,c,t,d){super(),this.f=i,this.g=c,this.h=d,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new s(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(t.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class u{constructor(i,c,t,d,a,l,g,R,O,q,Z,x,F){this.a=i,this.b=c,this.c=t,this.overrideIdentifiers=d,this.d=a,this.f=l,this.g=g,this.h=R,this.i=O,this.j=q,this.k=Z,this.l=x,this.m=F}get value(){return p(this.c)}n(i,c,t){const d=i.inspect(c,t);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class b{constructor(i,c,t,d,a=new f,l=new f,g=new C.ResourceMap,R=new f,O=new C.ResourceMap){this.c=i,this.d=c,this.f=t,this.g=d,this.h=a,this.i=l,this.j=g,this.l=R,this.m=O,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(i,c,t){return this.q(i,c,t).getValue(i)}updateValue(i,c,t={}){let d;t.resource?(d=this.m.get(t.resource),d||(d=new f,this.m.set(t.resource,d))):d=this.l,c===void 0?d.removeValue(i):d.setValue(i,c),t.resource||(this.a=null)}inspect(i,c,t){const d=this.q(i,c,t),a=this.u(c.resource,t),l=c.resource?this.m.get(c.resource)||this.l:this.l,g=new Set;for(const R of d.overrides)for(const O of R.identifiers)d.getOverrideValue(i,O)!==void 0&&g.add(O);return new u(i,c,d.getValue(i),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,l)}keys(i){const c=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,c){this.j.set(i,c),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,c){const t=[];if(!c){const{added:d,updated:a,removed:l}=v(this.c,i);c=[...d,...a,...l]}for(const d of c)for(const a of(0,E.overrideIdentifiersFromKey)(d)){const l=this.c.getKeysForOverrideIdentifier(a),g=i.getKeysForOverrideIdentifier(a),R=[...g.filter(O=>l.indexOf(O)===-1),...l.filter(O=>g.indexOf(O)===-1),...l.filter(O=>!A.equals(this.c.override(a).getValue(O),i.override(a).getValue(O)))];t.push([a,R])}return this.updateDefaultConfiguration(i),{keys:c,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:c,updated:t,removed:d}=v(this.d,i),a=[...c,...t,...d];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:c,updated:t,removed:d,overrides:a}=v(this.applicationConfiguration,i),l=[...c,...t,...d];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:c,updated:t,removed:d,overrides:a}=v(this.localUserConfiguration,i),l=[...c,...t,...d];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:c,updated:t,removed:d,overrides:a}=v(this.remoteUserConfiguration,i),l=[...c,...t,...d];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:c,updated:t,removed:d,overrides:a}=v(this.workspaceConfiguration,i),l=[...c,...t,...d];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(i,c){const t=this.p.get(i),{added:d,updated:a,removed:l,overrides:g}=v(t,c),R=[...d,...a,...l];return(R.length||!t)&&this.updateFolderConfiguration(i,c),{keys:R,overrides:g}}compareAndDeleteFolderConfiguration(i){const c=this.p.get(i);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:d,removed:a,overrides:l}=v(c,void 0);return{keys:[...t,...d,...a],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,c,t){let d=this.r(c,t);return c.overrideIdentifier&&(d=d.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(d=d.merge(this.d)),d}r({resource:i},c){let t=this.s();if(c&&i){const d=c.getFolder(i);d&&(t=this.t(d.uri)||t);const a=this.m.get(i);a&&(t=t.merge(a))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let c=this.b.get(i);if(!c){const t=this.s(),d=this.j.get(i);d?(c=t.merge(d),this.b.set(i,c)):c=t}return c}u(i,c){if(c&&i){const t=c.getFolder(i);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,c)=>{const{contents:t,overrides:d,keys:a}=this.j.get(c);return i.push([c,{contents:t,overrides:d,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(c=>i.add(c)),this.userConfiguration.keys.forEach(c=>i.add(c)),this.i.keys.forEach(c=>i.add(c)),this.j.forEach(c=>c.keys.forEach(t=>i.add(t))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}w(i){const c=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(t=>c.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>c.add(t)),this.i.getKeysForOverrideIdentifier(i).forEach(t=>c.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(d=>c.add(d))),[...c.values()]}static parse(i){const c=this.x(i.defaults),t=this.x(i.policy),d=this.x(i.application),a=this.x(i.user),l=this.x(i.workspace),g=i.folders.reduce((R,O)=>(R.set(y.URI.revive(O[0]),this.x(O[1])),R),new C.ResourceMap);return new b(c,t,d,a,new f,l,g,new f,new C.ResourceMap)}static x(i){return new f(i.contents,i.keys,i.overrides)}}e.Configuration=b;function w(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const i=new Set,c=new Map;for(const d of h)d.keys.forEach(a=>i.add(a)),d.overrides.forEach(([a,l])=>{const g=(0,C.getOrSet)(c,a,new Set);l.forEach(R=>g.add(R))});const t=[];return c.forEach((d,a)=>t.push([a,[...d.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=w;class P{constructor(i,c,t,d){this.change=i,this.f=c,this.g=t,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const l of a)this.affectedKeys.add(l);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=b.parse(this.f.data)),this.i}affectsConfiguration(i,c){const t=this.a+i,d=this.d.indexOf(t);if(d<0)return!1;const a=d+t.length;if(a>=this.d.length)return!1;const l=this.d.charCodeAt(a);if(l!==this.b&&l!==this.c)return!1;if(c){const g=this.previousConfiguration?this.previousConfiguration.getValue(i,c,this.f?.workspace):void 0,R=this.g.getValue(i,c,this.h);return!A.equals(g,R)}return!0}}e.ConfigurationChangeEvent=P;function v(h,i){const{added:c,removed:t,updated:d}=r(i?.rawConfiguration,h?.rawConfiguration),a=[],l=h?.getAllOverrideIdentifiers()||[],g=i?.getAllOverrideIdentifiers()||[];if(i){const R=g.filter(O=>!l.includes(O));for(const O of R)a.push([O,i.getKeysForOverrideIdentifier(O)])}if(h){const R=l.filter(O=>!g.includes(O));for(const O of R)a.push([O,h.getKeysForOverrideIdentifier(O)])}if(i&&h){for(const R of l)if(g.includes(R)){const O=r({contents:h.getOverrideValue(void 0,R)||{},keys:h.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});a.push([R,[...O.added,...O.removed,...O.updated]])}}return{added:c,removed:t,updated:d,overrides:a}}function r(h,i){const c=h?i?h.keys.filter(a=>i.keys.indexOf(a)===-1):[...h.keys]:[],t=i?h?i.keys.filter(a=>h.keys.indexOf(a)===-1):[...i.keys]:[],d=[];if(h&&i){for(const a of i.keys)if(h.keys.indexOf(a)!==-1){const l=(0,N.getConfigurationValue)(i.contents,a),g=(0,N.getConfigurationValue)(h.contents,a);A.equals(l,g)||d.push(a)}}return{added:c,removed:t,updated:d}}}),define(Ie[94],Ce([1,0,11,3]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var D;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof M&&S._code===D.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof M&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof M&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof M&&S.isHandled}constructor(S,y=D.Unknown,N){super(S),this._message=S,this._code=y,this._detail=N,this.isHandled=y===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function C(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.getRemoteAuthorityPrefix=C}),define(Ie[48],Ce([1,0,16]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(y){return y.scheme===n.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=k;function D(y){if(!y)return;const N=y.indexOf("+");return N<0?y:y.substr(0,N)}e.getRemoteName=D;function M(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=M;function C(y){const{host:N,port:E}=S(y);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:E}}e.parseAuthorityWithPort=C;function A(y,N){let{host:E,port:m}=S(y);return typeof m>"u"&&(m=N),{host:E,port:m}}e.parseAuthorityWithOptionalPort=A;function S(y){const N=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const E=y.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(Ie[25],Ce([1,0,10,3,48]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var S;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(s){this.value=s,this.c=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const u=typeof s=="string"?s:s.value,b=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(u,b)}return s.c===o.c}static toKey(s){return typeof s=="string"?s.toLowerCase():s.c}}e.ExtensionIdentifier=y;function N(f){return E(f)}e.isApplicationScopedExtension=N;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function p(f,s){if(s){const o=`onResolveRemoteAuthority:${(0,D.getRemoteName)(s)}`;return f.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[164],Ce([1,0,20,49,2,34]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(y){if(n.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function A(y,N,E,m,p,f,s,o,u,b){const w=Object.create(null);w["common.machineId"]=s,w.sessionID=(0,M.generateUuid)()+Date.now(),w.commitHash=p,w.version=f,w["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,n.PlatformToString)(n.platform),w["common.nodePlatform"]=k.platform,w["common.nodeArch"]=m,w["common.product"]=b||"desktop",o&&(w["common.msftInternal"]=o);let P=0;const v=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.isLinuxSnap&&(w["common.snap"]="true");const r=C(E);r&&(w["common.platformDetail"]=r);try{const h=await y.readFile(D.URI.file(u));w["common.source"]=h.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=A;function S(y){const N=k.env.USERDNSDOMAIN;if(!N)return!1;const E=N.toLowerCase();return y.some(m=>E===m)}e.verifyMicrosoftInternalDomain=S}),define(Ie[165],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[50],Ce([1,0,22,9,4,41,48,164,165]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class y{constructor(a){this.value=a}}e.TelemetryTrustedValue=y;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,l){return Promise.resolve(void 0)}publicLog2(a,l){return this.publicLog(a,l)}publicLogError(a,l){return Promise.resolve(void 0)}publicLogError2(a,l){return this.publicLogError(a,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class E{async publicLog(a,l,g){}async publicLogError(a,l,g){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(d,a){return D.Event.debounce(a.onDidChangeConfiguration,(g,R)=>{const O=g?new Set([...g.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:O}},1e3,!0)(g=>{g.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(g.source),configurationKeys:P(g.affectedKeys)})})}e.configurationTelemetry=m;function p(d,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!d.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=p;function f(d,a){return!(a.isBuilt||a.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.isLoggingOnly=f;function s(d){const a=d.getValue(S.TELEMETRY_SETTING_ID),l=d.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(d.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=s;function o(d){const a={},l={},g={};w(d,g);for(let R in g){R=R.length>150?R.substr(R.length-149):R;const O=g[R];typeof O=="number"?l[R]=O:typeof O=="boolean"?l[R]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${O.length}`),a[R]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(a[R]=O)}return{properties:a,measurements:l}}e.validateTelemetryData=o;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function b(d){if(!d)return"none";const a=(0,C.getRemoteName)(d);return u.has(a)?a:"other"}e.cleanRemoteAuthority=b;function w(d,a,l=0,g){if(!!d)for(const R of Object.getOwnPropertyNames(d)){const O=d[R],q=g?g+R:R;Array.isArray(O)?a[q]=(0,n.safeStringify)(O):O instanceof Date?a[q]=O.toISOString():(0,k.isObject)(O)?l<2?w(O,a,l+1,q+"."):a[q]=(0,n.safeStringify)(O):a[q]=O}}function P(d){if(!d)return[];const a=[];return v(a,"",d),a}function v(d,a,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(g=>v(d,a?`${a}.${g}`:g,l[g])):d.push(a)}function r(d,a){const l=d.msftInternalDomains||[],g=a.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(l)||g}e.isInternalTelemetry=r;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.getPiiPathsFromEnvironment=h;function i(d,a){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let l=d;const g=[];for(const Z of a)for(;;){const x=Z.exec(d);if(!x)break;g.push([x.index,Z.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let q=0;for(l="";;){const Z=O.exec(d);if(!Z)break;const x=g.some(([F,$])=>Z.index<$&&F<O.lastIndex);!R.test(Z[0])&&!x&&(l+=d.substring(q,Z.index)+"<REDACTED: user-file-path>",q=O.lastIndex)}return q<d.length&&(l+=d.substr(q)),l}function c(d){if(!d)return d;const a=d.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of l)if(g.regex.test(a))return`<REDACTED: ${g.label}>`;return d}function t(d,a){return(0,n.cloneAndChange)(d,l=>{if(l instanceof y)return l.value;if(typeof l=="string"){let g=l.replaceAll("%20"," ");g=i(g,a);for(const R of a)g=g.replace(R,"");return g=c(g),g}})}e.cleanData=t}),define(Ie[166],Ce([1,0,10,90,25,20,2,11,49,50]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(i,c){return i.uuid&&c.uuid?i.uuid===c.uuid:i.id===c.id?!0:(0,n.compareIgnoreCase)(i.id,c.id)===0}e.areSameExtensions=N;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(c){const t=c.manifest?c.manifest.version:c.version,d=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new m(c.identifier,t,d)}static parse(c){const t=E.exec(c);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(c,t,d="undefined"){this.version=t,this.targetPlatform=d,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof m?N(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(i){const c=p.exec(i);return c&&c[1]?[o(c[1]),c[2]]:[o(i),void 0]}e.getIdAndVersion=f;function s(i,c){return`${i}.${c}`}e.getExtensionId=s;function o(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function u(i,c){return o(s(i,c))}e.getGalleryExtensionId=u;function b(i,c){const t=[],d=a=>{for(const l of t)if(l.some(g=>N(c(g),c(a))))return l;return null};for(const a of i){const l=d(a);l?l.push(a):t.push([a])}return t}e.groupByExtension=b;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function P(i){return{id:new y.TelemetryTrustedValue(i.identifier.id),name:new y.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(i,c){const t=[],d=c.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const a=d.shift();if(a&&t.every(l=>!N(l.identifier,{id:a}))){const l=i.filter(g=>N(g.identifier,{id:a}));l.length===1&&(t.push(l[0]),d.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=v;async function r(i,c){if(!M.isLinux)return!1;let t;try{t=(await i.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await i.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){c.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function h(i,c){const t=await r(i,c),d=(0,k.getTargetPlatform)(t?"alpine":M.platform,S.arch);return c.debug("ComputeTargetPlatform:",d),d}e.computeTargetPlatform=h}),define(Ie[167],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=n;function k(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=k;function D(C){return Array.from(C.entries()).map(A=>[A[0],n(A[1].map)])}e.serializeEnvironmentVariableCollections=D;function M(C){return new Map(C.map(A=>[A[0],{map:k(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ie[168],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,M,C=5){const A=M(S=>{const y=typeof S=="string"?S:S.data;let N=this.a.get(D);if(N){N.data.push(y);return}const E=setTimeout(()=>this.flushBuffer(D),C);N={data:[y],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(D),A.dispose()}},this.a.set(D,N)});return A}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const M=this.a.get(D);M&&(this.a.delete(D),this.b(D,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ie[169],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var n;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(n=e.ColorScheme||(e.ColorScheme={}));function k(M){return M===n.HIGH_CONTRAST_DARK||M===n.HIGH_CONTRAST_LIGHT}e.isHighContrast=k;function D(M){return M===n.DARK||M===n.HIGH_CONTRAST_DARK}e.isDark=D}),define(Ie[51],Ce([1,0,65,4,6,3,29,169]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var S;(function(o){function u(b){return b&&typeof b=="object"&&typeof b.id=="string"}o.isThemeColor=u})(S=e.ThemeColor||(e.ThemeColor={}));function y(o){return{id:o}}e.themeColorFromId=y;var N;(function(o){function u(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||S.isThemeColor(c.color))}o.isThemeIcon=u;const b=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function w(c){const t=b.exec(c);if(!t)return;const[,d]=t;return{id:d}}o.fromString=w;function P(c){return{id:c}}o.fromId=P;function v(c,t){let d=c.id;const a=d.lastIndexOf("~");return a!==-1&&(d=d.substring(0,a)),t&&(d=`${d}~${t}`),{id:d}}o.modify=v;function r(c){const t=c.id.lastIndexOf("~");if(t!==-1)return c.id.substring(t+1)}o.getModifier=r;function h(c,t){return c.id===t.id&&c.color?.id===t.color?.id}o.isEqual=h;function i(c,t){return{id:c.id,color:t?y(t):void 0}}o.asThemeIcon=i,o.asClassNameArray=n.CSSIcon.asClassNameArray,o.asClassName=n.CSSIcon.asClassName,o.asCSSSelector=n.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function E(o){switch(o){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new k.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,D.toDisposable)(()=>{const b=this.a.indexOf(u);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new m;C.Registry.add(e.Extensions.ThemingContribution,p);function f(o){return p.onColorThemeChange(o)}e.registerThemingParticipant=f;class s extends D.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,b){let w=this.h.getColor(u);return w&&b&&(w=b(w,this.h)),w?w.toString():null}}e.Themable=s}),define(Ie[170],Ce([1,0,12,65,4,9,2,136,69,29,51]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var E;(function(P){function v(r,h){let i=r.defaults;for(;N.ThemeIcon.isThemeIcon(i);){const c=f.getIcon(i.id);if(!c)return;i=c.defaults}return i}P.getDefinition=v})(E=e.IconContribution||(e.IconContribution={}));var m;(function(P){function v(h){return{weight:h.weight,style:h.style,src:h.src.map(i=>({format:i.format,location:i.location.toString()}))}}P.toJSONObject=v;function r(h){const i=c=>(0,M.isString)(c)?c:void 0;if(h&&Array.isArray(h.src)&&h.src.every(c=>(0,M.isString)(c.format)&&(0,M.isString)(c.location)))return{weight:i(h.weight),style:i(h.style),src:h.src.map(c=>({format:c.format,location:C.URI.parse(c.location)}))}}P.fromJSONObject=r})(m=e.IconFontDefinition||(e.IconFontDefinition={}));class p{constructor(){this.a=new D.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${k.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,r,h,i){const c=this.b[v];if(c){if(h&&!c.description){c.description=h,this.d.properties[v].markdownDescription=`${h} $(${v})`;const a=this.e.enum.indexOf(v);a!==-1&&(this.e.enumDescriptions[a]=h),this.a.fire()}return c}const t={id:v,description:h,defaults:r,deprecationMessage:i};this.b[v]=t;const d={$ref:"#/definitions/icons"};return i&&(d.deprecationMessage=i),h&&(d.markdownDescription=`${h}: $(${v})`),this.d.properties[v]=d,this.e.enum.push(v),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const r=this.e.enum.indexOf(v);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,r){const h=this.f[v];return h||(this.f[v]=r,this.a.fire(),r)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(c,t)=>c.id.localeCompare(t.id),r=c=>{for(;N.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(c=>this.b[c]);for(const c of i.filter(t=>!!t.description).sort(v))h.push(`|<i class="${r(c)}"></i>|${c.id}|${N.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const c of i.filter(t=>!N.ThemeIcon.isThemeIcon(t.defaults)).sort(v))h.push(`|<i class="${r(c)}"></i>|${c.id}|`);return h.join(`
`)}}const f=new p;y.Registry.add(e.Extensions.IconContribution,f);function s(P,v,r,h){return f.registerIcon(P,v,r,h)}e.registerIcon=s;function o(){return f}e.getIconRegistry=o;function u(){for(const P of k.Codicon.getAll())f.registerIcon(P.id,{fontCharacter:P.fontCharacter},P.description)}u(),e.iconsSchemaId="vscode://schemas/icons";const b=y.Registry.as(S.Extensions.JSONContribution);b.registerSchema(e.iconsSchemaId,f.getIconSchema());const w=new n.RunOnceScheduler(()=>b.notifySchemaChanged(e.iconsSchemaId),200);f.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=s("widget-close",k.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=s("goto-previous-location",k.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=s("goto-next-location",k.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=N.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=N.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Ie[171],Ce([1,0,4,41,3,13]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var C;(function(s){s.Http="http",s.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=E;function m(s,o,u,b){if(u===1)return!1;if(u===2&&E(o)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(w?.length===4&&parseInt(w[1])>=18)return!1}return s<1024}e.isPortPrivileged=m;class p{constructor(o,u,b){this.remoteAddress=o,this.localAddress=u,this.b=b,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let f=class{constructor(o,u){this.i=o,this.j=u,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],u=Array.from(this.d.values());for(const b of u){const w=Array.from(b.values());for(const P of w){const v=await P.value;v&&o.push(v)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:u}of o.values())await u.then(b=>b?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,u,b,w,P){this.o(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:b,privacy:w,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(E(o)||N(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const b=this.q(o,u);if(b)return++b.refcount,b.value}openTunnel(o,u,b,w,P,v=!1,r,h){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${b} on local port ${P}.`),!o)return;if(u||(u="localhost"),w||(w=this.k),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(o,u,b,w,P,v,r,h);return i?i.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const t=this.m(c);return(c.tunnelRemoteHost!==u||c.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(t),t}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this.d.get(o.tunnelRemoteHost);if(u){const b=u.get(o.tunnelRemotePort);b&&(b.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,b))}}}}async n(o,u,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const w=b.value.then(async P=>{P&&(await P.dispose(!0),this.b.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(u),w}}async closeTunnel(o,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const b=this.d.get(o);if(b&&b.has(u)){const w=b.get(u);w.refcount=0,await this.n(o,u,w)}}o(o,u,b){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(u,{refcount:1,value:b})}async p(o,u){const b=this.d.get(o);b&&(await b.get(u)||b.delete(u),b.size===0&&this.d.delete(o))}q(o,u){const b=[o];N(o)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):E(o)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const w=b.map(P=>this.d.get(P));for(const P of w){const v=P?.get(u);if(v)return v}}canTunnel(o){return!!y(o)}s(o,u,b,w,P,v,r){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${b} on local port ${w}.`);const h=b;this.h.add(h);const i=w===void 0?b:w,c={elevationRequired:P?this.isPortPrivileged(i):!1},t={remoteAddress:{host:u,port:b},localAddressPort:w,privacy:v,public:v?v!==A.Private:void 0,protocol:r},d=o.forwardPort(t,c);return d?(this.o(u,b,d),d.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(h)})):this.h.delete(h),d}};f=qe([je(0,M.ILogService),je(1,k.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ie[172],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var k;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(k=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[173],Ce([1,0,16]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(S){return S.scheme!==n.Schemas.file&&S.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=k;function D(S){if(S.folders.length)return S.folders.every(y=>k(y.uri))?S.folders[0].uri:void 0;if(S.configuration&&k(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function M(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=M;function C(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=C;function A(S){return D(S)!==void 0}e.isVirtualWorkspace=A}),define(Ie[52],Ce([1,0,137,19,46,24,2,3,16]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function y(i){const c=i;return typeof c?.id=="string"&&C.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=y;function N(i){return typeof i?.id=="string"&&!y(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,k.basename)(i)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const t=i;return t.configuration?{id:t.id,configPath:t.configuration}:t.folders.length===1?{id:t.id,uri:t.folders[0].uri}:{id:t.id}}e.toWorkspaceIdentifier=E;function m(i){const c=i;return typeof c?.id=="string"&&C.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=m;function p(i){const c=i;if(c?.uri)return{id:c.id,uri:C.URI.revive(c.uri)};const t=i;if(t?.configPath)return{id:t.id,configPath:C.URI.revive(t.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=p;var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function s(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=s;function o(i){const c=i;return!!(c&&typeof c=="object"&&C.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=o;class u{constructor(c,t,d,a,l){this.h=c,this.j=d,this.k=a,this.l=l,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=t}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class b{constructor(c,t){this.raw=t,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,M.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function w(i){return new b({uri:i,index:0,name:(0,M.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(i,c){return M.extUriBiasedIgnorePathCase.isEqualOrParent(i,c.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function v(i){let c;return C.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=v;function r(i,c){return!P(i,c)&&!v(i)}e.isSavedWorkspace=r;function h(i){return(typeof i=="string"?(0,k.extname)(i):(0,M.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=h}),define(Ie[53],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const M=this.c++;return this.b.set(M,D),this.e(),M}get(D,M){return this.b.has(D)?this.b.get(D)[M]:void 0}delete(D){this.b.delete(D),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=n,n.a=!1}),define(Ie[37],Ce([1,0,16,24,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new k.ExtUri(A=>{const S=this.b.get(A.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(A,S){S===null?this.b.delete(A.scheme):this.b.set(A.scheme,S)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ie[174],Ce([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(C,A,S){this.h=new Map,this.a=C,this.b=A,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new n.RunOnceScheduler(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of y.values())N.complete()}catch(N){for(const E of y.values())E.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,A){let S=this.f[C];return typeof S>"u"&&(S=A),S}update(C,A){this.f[C]=A;const S=this.h.get(C);if(S!==void 0)return S.p;const y=new n.DeferredPromise;return this.h.set(C,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.ExtensionMemento=k;class D extends k{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,A){super(C.identifier.value,!0,A),this.j=C}}e.ExtensionGlobalMemento=D}),define(Ie[175],Ce([1,0,4,2]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(C){this.c=C,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,A,S,y){const E=this.c.getNotebookDocument(k.URI.revive(C)).acceptModelChanged(A.value,S,y);this.b.fire(E)}$acceptDirtyStateChanged(C,A){this.c.getNotebookDocument(k.URI.revive(C)).acceptDirty(A)}$acceptModelSaved(C){const A=this.c.getNotebookDocument(k.URI.revive(C));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ie[17],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class k{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[176],Ce([1,0,25,4]),function(te,e,n,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,S){D.set(this,void 0),this.b=new k.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(A.identifier),Je(this,D,S,"f"),Oe(this,D,"f").onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(A){return Oe(this,D,"f").get(this.a,A)}store(A,S){return Oe(this,D,"f").store(this.a,A,S)}delete(A){return Oe(this,D,"f").delete(this.a,A)}}e.ExtensionSecrets=M,D=new WeakMap}),define(Ie[70],Ce([1,0,3,171,4,17]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function y(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:E.protocol}}S.fromApiTunnel=y;function N(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==k.TunnelPrivacyId.ConstantPrivate&&E.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}S.fromServiceTunnel=N})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let A=class{constructor(y){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,N){}async getTunnels(){return[]}async setTunnelFactory(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,N){return{dispose:()=>{}}}async $providePortAttributes(y,N,E,m,p){return[]}async $forwardPort(y,N){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([je(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ie[54],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class k{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=k}),define(Ie[177],Ce([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function D(A,S){if(S.serializeBuffersForPostMessage){const y=new k,N=(p,f)=>{if(f instanceof ArrayBuffer){const s=y.add(f);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(f)){const s=M(f);if(s){const o=y.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:s,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},E=JSON.stringify(A,N),m=y.buffers.map(p=>{const f=new Uint8Array(p);return n.VSBuffer.wrap(f)});return{message:E,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=D;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(A,S){const y=S.map(m=>{const p=new ArrayBuffer(m.byteLength);return new Uint8Array(p).set(m.buffer),p}),N=S.length?(m,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const f=p,{index:s}=f,o=y[s];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse(A,N),arrayBuffers:y}}e.deserializeWebviewMessage=C}),define(Ie[95],Ce([1,0,145,9,2,6,3,29,36,16,39,123,30]),function(te,e,n,k,D,M,C,A,S,y,N,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(p=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function s(G){const H=G;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=s;function o(G,H,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===H&&G.matches(ve.input))return ve.getViewState()}e.findViewStateForEditor=o;function u(G){if(l(G))return!1;const H=G;return D.URI.isUri(H?.resource)}e.isResourceEditorInput=u;function b(G){if(l(G))return!1;const H=G;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=b;function w(G){if(l(G)||b(G))return!1;const H=G;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function P(G){if(l(G))return!1;const H=G;return H?H.resource===void 0||H.resource.scheme===y.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;const v=/Untitled-\d+/;function r(G){return G.scheme===y.Schemas.untitled&&G.path.length>1&&!v.test(G.path)}e.isUntitledWithAssociatedResource=r;function h(G){if(l(G))return!1;const H=G;return D.URI.isUri(H?.base?.resource)&&D.URI.isUri(H?.input1?.resource)&&D.URI.isUri(H?.input2?.resource)&&D.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=h;var i;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(i=e.Verbosity||(e.Verbosity={}));var c;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class t{constructor(){this.a=new Map}registerSource(H,oe){let ve=this.a.get(H);return ve||(ve={source:H,label:oe},this.a.set(H,ve)),ve.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new t;var d;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends M.Disposable{}e.AbstractEditorInput=a;function l(G){return G instanceof a}e.isEditorInput=l;function g(G){const H=G;return D.URI.isUri(H?.preferredResource)}function R(G){const H=G;return l(H?.primary)&&l(H?.secondary)}e.isSideBySideEditorInput=R;function O(G){const H=G;return l(H?.modified)&&l(H?.original)}e.isDiffEditorInput=O;function q(G,H,oe,ve,Ae){return re(ve,[(0,E.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Ue={...oe,limits:{size:Number.MAX_VALUE}};G.openEditor(H,Ue)}}),(0,E.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=q;function Z(G){return l(G?.editor)}e.isEditorInputWithOptions=Z;function x(G){const H=G;return Z(G)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function F(G){const H=G;return typeof H?.groupId=="number"&&l(H.editor)}e.isEditorIdentifier=F;var $;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var T;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var L;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(L=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(H,oe){if(!H)return;if(h(H))return e.EditorResourceAccessor.getOriginalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Ue}=this.a(H);if(Ae&&Ue){if(oe?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(Ue,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===L.ANY)return this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(Ue,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===L.PRIMARY?Ae:Ue}}if(b(H)||w(H)||h(H))return;const ve=g(H)?H.preferredResource:H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(H){return R(H)||w(H)?{primary:H.primary,secondary:H.secondary}:O(H)||b(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,oe){if(!H)return;if(h(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Ue}=this.a(H);if(Ae&&Ue){if(oe?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(Ue,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===L.ANY)return this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(Ue,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===L.PRIMARY?Ae:Ue}}if(b(H)||w(H)||h(H))return;const ve=H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(H,oe){if(Array.isArray(oe)){if(oe.some(ve=>H.scheme===ve))return H}else if(oe===H.scheme)return H}}e.EditorResourceAccessor=new V;var j;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(H){const oe=this.a=H.get(C.IInstantiationService);for(const[ve,Ae]of this.c)this.e(ve,Ae,oe);this.c.clear()}e(H,oe,ve){const Ae=ve.createInstance(oe);this.d.set(H,Ae)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(H,oe){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,oe,this.a):this.c.set(H,oe),(0,M.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new le);async function _(G,H,oe){return!G||!G.length?[]:await Promise.all(G.map(async ve=>{const Ae=D.URI.revive(ve.fileUri);if(!Ae){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await H.canHandleResource(Ae)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let xe=ve.exists,Te=ve.type;if(typeof xe!="boolean"||typeof Te!="number")try{Te=(await H.stat(Ae)).isDirectory?S.FileType.Directory:S.FileType.Unknown,xe=!0}catch(ke){oe.error(ke),xe=!1}if(!xe&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(Te===S.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const Se={...ve.options,pinned:!0};return xe?{resource:Ae,options:Se}:{resource:Ae,options:Se,forceUntitled:!0}}))}e.pathsToEditors=_;var pe;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(pe=e.EditorsOrder||(e.EditorsOrder={}));function ue(G){const H=G;if(!H)return!1;const oe=H;if(oe.modified)return ue(oe.modified);const ve=H;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}e.isTextEditorViewState=ue;function de(G){return(0,N.isErrorWithActions)(G)}e.isEditorOpenError=de;function re(G,H,oe){const ve=(0,N.createErrorWithActions)(G,H);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}e.createEditorOpenError=re}),define(Ie[178],Ce([1,0,4,146,3,6,28,29,18,62,22,65,170]),function(te,e,n,k,D,M,C,A,S,y,N,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",E.Codicon.window,(0,k.localize)(0,null));var p;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(p=e.Extensions||(e.Extensions={}));var f;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function s(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=s;class o extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(c,t,d){const a=this.get(c.id);if(a)return a;const l=c;return l.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,C.getOrSet)(this.g,t,[]).push(l),d?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:t}),l}deregisterViewContainer(c){for(const t of this.g.keys()){const d=this.g.get(t),a=d?.indexOf(c);if(a!==-1){d?.splice(a,1),d.length===0&&this.g.delete(t),this.f.fire({viewContainer:c,viewContainerLocation:t});return}}}get(c){return this.all.filter(t=>t.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(t=>this.getViewContainers(t).filter(d=>d?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(t=>this.getViewContainerLocation(t)===c)}}A.Registry.add(p.ViewContainersRegistry,new o);var u;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function b(i,c){const t=i.group??u.More,d=c.group??u.More;return t!==d?t.localeCompare(d):(i.order??5)-(c.order??5)}class w extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new y.SetMap}registerViews(c,t){this.registerViews2([{views:c,viewContainer:t}])}registerViews2(c){c.forEach(({views:t,viewContainer:d})=>this.l(t,d)),this.c.fire(c)}deregisterViews(c,t){const d=this.m(c,t);d.length&&this.f.fire({views:d,viewContainer:t})}moveViews(c,t){for(const d of this.j.keys())if(d!==t){const a=this.m(c,d);a.length&&(this.l(a,t),this.g.fire({views:a,from:d,to:t}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const t of this.i){const d=(this.j.get(t)||[]).filter(a=>a.id===c)[0];if(d)return d}return null}getViewContainer(c){for(const t of this.i)if((this.j.get(t)||[]).filter(a=>a.id===c)[0])return t;return null}registerViewWelcomeContent(c,t){return this.k.add(c,t),this.h.fire(c),(0,M.toDisposable)(()=>{this.k.delete(c,t),this.h.fire(c)})}registerViewWelcomeContent2(c,t){const d=new Map;for(const[a,l]of t)this.k.add(c,l),d.set(a,(0,M.toDisposable)(()=>{this.k.delete(c,l),this.h.fire(c)}));return this.h.fire(c),d}getViewWelcomeContent(c){const t=[];return this.k.forEach(c,d=>t.push(d)),t.sort(b)}l(c,t){let d=this.j.get(t);d||(d=[],this.j.set(t,d),this.i.push(t));for(const a of c){if(this.getView(a.id)!==null)throw new Error((0,k.localize)(1,null,a.id));d.push(a)}}m(c,t){const d=this.j.get(t);if(!d)return[];const a=[],l=[];for(const g of d)c.includes(g)?a.push(g):l.push(g);return a.length&&(l.length?this.j.set(t,l):(this.j.delete(t),this.i.splice(this.i.indexOf(t),1))),a}}A.Registry.add(p.ViewsRegistry,new w),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var P;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(P=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(c,t){this.c=!1,this.d=!1,(0,N.mixin)(this,c),this.d=!!t,this.resolve=async d=>{if(t&&!this.c){const a=await t(d);a&&(this.tooltip=this.tooltip??a.tooltip,this.command=this.command??a.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r;class h extends Error{constructor(c){super((0,k.localize)(2,null,c))}}e.NoTreeViewError=h}),define(Ie[179],Ce([1,0,4,12,147]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,S,y,N){const E={command:A};if(S&&Object.keys(S).length>0&&(E.arguments=S),this.s("request",E),typeof N=="number"){const m=setTimeout(()=>{clearTimeout(m);const p=this.f.get(E.seq);if(p){this.f.delete(E.seq);const f={type:"response",seq:0,request_seq:E.seq,success:!1,command:A,message:(0,D.localize)(0,null,N,A)};p(f)}},N)}return y&&this.f.set(E.seq,y),E.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,S){return A.type!=="event"||S.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,k.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const S=A,y=this.f.get(S.request_seq);y&&(this.f.delete(S.request_seq),y(S));break}}}}s(A,S){S.type=A,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((S,y)=>A.set(y,S)),await(0,k.timeout)(500),A.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ie[180],Ce([1,0,148,42,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=m=>n.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var C;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(C=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var S;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var E;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(E=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[181],Ce([1,0,10,2,19,22,16]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function S(i,c,t){return i.replace(A,function(d,a){return c&&a.length>0&&a[0]!=="_"?d:t&&t.hasOwnProperty(a)?t[a]:d})}e.formatPII=S;function y(i){const c={};for(const t of Object.keys(i))t.startsWith("!")||(c[t]=i[t]);return c}e.filterExceptionsFromTelemetry=y;function N(i){return i.configuration.request==="attach"&&!E(i)&&(!i.parentSession||N(i.parentSession))}e.isSessionAttach=N;function E(i){let c=i.configuration.type;if(!!c)return c==="vslsShare"&&(c=i.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(c,"extensionhost")||(0,n.equalsIgnoreCase)(c,"pwa-extensionhost")?i:i.parentSession?E(i.parentSession):void 0}e.getExtensionHostDebugSession=E;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function p(i,c,t){let d,a=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=l.exec(i);){const R=g.index+1,O=R+g[0].length;if(R<=c&&O>=t){d=g[0],a=R;break}}if(d){const R=/\w+/g;let O=null;for(;(O=R.exec(d))&&!(O.index+1+a+O[0].length>=t););O&&(d=d.substring(0,R.lastIndex))}return d?{start:a,end:a+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(i){return!!(i&&i.match(f))}e.isUri=s;function o(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(s(i.path))return k.URI.parse(i.path);if((0,D.isAbsolute)(i.path))return k.URI.file(i.path)}return i.path}function u(i){if(typeof i.path=="object"){const c=k.URI.revive(i.path);if(c)return c.scheme===C.Schemas.file?c.fsPath:c.toString()}return i.path}function b(i,c){const t=c?o:u,d=(0,M.deepClone)(i);return P(d,(a,l)=>{a&&l&&(l.path=t(l))}),d}e.convertToDAPaths=b;function w(i,c){const t=c?o:u,d=(0,M.deepClone)(i);return P(d,(a,l)=>{!a&&l&&(l.path=t(l))}),d}e.convertToVSCPaths=w;function P(i,c){switch(i.type){case"event":{const t=i;switch(t.event){case"output":c(!1,t.body.source);break;case"loadedSource":c(!1,t.body.source);break;case"breakpoint":c(!1,t.body.breakpoint.source);break;default:break}break}case"request":{const t=i;switch(t.command){case"setBreakpoints":c(!0,t.arguments.source);break;case"breakpointLocations":c(!0,t.arguments.source);break;case"source":c(!0,t.arguments.source);break;case"gotoTargets":c(!0,t.arguments.source);break;case"launchVSCode":t.arguments.args.forEach(d=>c(!1,d));break;default:break}break}case"response":{const t=i;if(t.success&&t.body)switch(t.command){case"stackTrace":t.body.stackFrames.forEach(d=>c(!1,d.source));break;case"loadedSources":t.body.sources.forEach(d=>c(!1,d));break;case"scopes":t.body.scopes.forEach(d=>c(!1,d.source));break;case"setFunctionBreakpoints":t.body.breakpoints.forEach(d=>c(!1,d.source));break;case"setBreakpoints":t.body.breakpoints.forEach(d=>c(!1,d.source));break;case"disassemble":t.body?.instructions.forEach(a=>c(!1,a.location));break;default:break}break}}}function v(i){return i.filter(c=>!c.presentation?.hidden).sort((c,t)=>c.presentation?t.presentation?c.presentation.group?t.presentation.group?c.presentation.group!==t.presentation.group?c.presentation.group.localeCompare(t.presentation.group):r(c.presentation.order,t.presentation.order):-1:t.presentation.group?1:r(c.presentation.order,t.presentation.order):-1:t.presentation?1:0)}e.getVisibleAndSorted=v;function r(i,c){return typeof i!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:i-c}async function h(i,c){const t=i.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(t!=="none"&&(await c.saveAll(),t==="allEditorsInActiveGroup")){const d=c.activeEditorPane;d&&d.input.resource?.scheme===C.Schemas.untitled&&await c.save({editor:d.input,groupId:d.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(Ie[71],Ce([1,0,23,35,182,64,16,19,20,42]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(L){L.Always="always",L.Never="never",L.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.ChangeCellLanguage=5]="ChangeCellLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",L[L.ChangeCellMime=13]="ChangeCellMime",L[L.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.Move=6]="Move",L[L.OutputItems=7]="OutputItems",L[L.PartialMetadata=8]="PartialMetadata",L[L.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var b;(function(L){L.scheme=C.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${V.join("")}]+`),le=7;function _(H,oe){const ve=oe.toString(le),Ue=`${ve.length<V.length?V[ve.length-1]:"z"}${ve}s${(0,n.encodeBase64)(n.VSBuffer.fromString(H.scheme),!0,!0)}`;return H.with({scheme:L.scheme,fragment:Ue})}L.generate=_;function pe(H){if(H.scheme!==L.scheme)return;const oe=H.fragment.indexOf("s");if(oe<0)return;const ve=parseInt(H.fragment.substring(0,oe).replace(j,""),le),Ae=(0,n.decodeBase64)(H.fragment.substring(oe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:H.with({scheme:Ae,fragment:null})}}L.parse=pe;function ue(H,oe){return H.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${H.scheme!==C.Schemas.file?H.scheme:""}`})}L.generateCellOutputUri=ue;function de(H){if(H.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!oe)return;const ve=oe[1]&&oe[1]!==""?oe[1]:void 0,Ae=oe[2];return{outputId:ve,notebook:H.with({scheme:Ae||C.Schemas.file,fragment:null})}}L.parseCellOutputUri=de;function re(H,oe,ve){return L.generate(H,oe).with({scheme:ve})}L.generateCellPropertyUri=re;function G(H,oe){if(H.scheme===oe)return L.parse(H.with({scheme:L.scheme}))}L.parseCellPropertyUri=G})(b=e.CellUri||(e.CellUri={}));const w=L=>S.isWindows?L.replace(/\//g,"\\"):L;class P{constructor(V=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(V)].map(le=>({pattern:le,matches:k.parse(w(le))}))}sort(V){const j=new Map(D.Iterable.map(V,_=>[_,w(_)]));let le=[];for(const{matches:_}of this.d)for(const[pe,ue]of j)if(_(ue)){le.push(pe),j.delete(pe);break}return j.size&&(le=le.concat([...j.keys()].sort((_,pe)=>this.e.indexOf(_)-this.e.indexOf(pe)))),le}prioritize(V,j){const le=this.f(V);if(le===-1){this.d.unshift({pattern:V,matches:k.parse(w(V))});return}const _=new Set(j.map(ue=>this.f(ue,le)));_.delete(-1);const pe=Array.from(_).sort();this.d.splice(le+1,0,...pe.map(ue=>this.d[ue]));for(let ue=pe.length-1;ue>=0;ue--)this.d.splice(pe[ue],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,j=this.d.length){const le=w(V);for(let _=0;_<j;_++)if(this.d[_].matches(le))return _;return-1}}e.MimeTypeDisplayOrder=P;function v(L,V,j,le=(_,pe)=>_===pe){const _=[];function pe(re,G,H){if(G===0&&H.length===0)return;const oe=_[_.length-1];oe&&oe.start+oe.deleteCount===re?(oe.deleteCount+=G,oe.toInsert.push(...H)):_.push({start:re,deleteCount:G,toInsert:H})}let ue=0,de=0;for(;;){if(ue===L.length){pe(ue,0,V.slice(de));break}if(de===V.length){pe(ue,L.length-ue,[]);break}const re=L[ue],G=V[de];if(le(re,G)){ue+=1,de+=1;continue}j(G)?(pe(ue,1,[]),ue+=1):(pe(ue,0,[G]),de+=1)}return _}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(L){L.default="default",L.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(L){const V=L;return!!((typeof V.include=="string"||k.isRelativePattern(V.include))&&(typeof V.exclude=="string"||k.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=h;function i(L,V,j){if(Array.isArray(L.viewType)&&L.viewType.indexOf(V)>=0||L.viewType===V)return!0;if(L.filenamePattern){const le=h(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,_=h(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(k.match(le,(0,A.basename)(j.fsPath).toLowerCase()))return!(_&&k.match(_,(0,A.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var c;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class t{static create(V){return`${t.d}${V}`}static parse(V){if(V.startsWith(t.d))return V.substring(t.d.length)}}e.NotebookWorkingCopyTypeIdentifier=t,t.d="notebook/";function d(L){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(L)}e.isTextStreamMime=d;const a=new TextDecoder;function l(L){const V=[];let j=!1;for(const le of L)(V.length===0||j)&&(V.push(le),j=!0);return q(V),T(n.VSBuffer.concat(V.map(le=>n.VSBuffer.wrap(le))))}e.compressOutputItemStreams=l;const g=`${String.fromCharCode(27)}[A`,R=g.split("").map(L=>L.charCodeAt(0)),O=10;function q(L){L.forEach((V,j)=>{if(j===0||V.length<g.length)return;const le=L[j-1],_=V.subarray(0,g.length);if(_[0]===R[0]&&_[1]===R[1]&&_[2]===R[2]){const pe=le.lastIndexOf(O);if(pe===-1)return;L[j-1]=le.subarray(0,pe),L[j]=V.subarray(g.length)}})}function Z(L){let V=L;do L=V,V=L.replace(/[^\n]\x08/gm,"");while(V.length<L.length);return L}function x(L){for(L=L.replace(/\r+\n/gm,`
`);L.search(/\r[^$]/g)>-1;){const V=L.match(/^(.*)\r+/m)[1];let j=L.match(/\r+(.*)$/m)[1];j=j+V.slice(j.length,V.length),L=L.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return L}const F="\b".charCodeAt(0),$="\r".charCodeAt(0);function T(L){return!L.buffer.includes(F)&&!L.buffer.includes($)?L:n.VSBuffer.fromString(x(Z(a.decode(L.buffer))))}}),define(Ie[183],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ie[43],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(C,A,S=C.parent){if(C._isRoot)return new D([A]);const y=[C.id];for(let N=S;N&&N.id!==A;N=N.parent)y.push(N.id);return y.push(A),new D(y.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const A=C.indexOf("\0");return A===-1?C:C.slice(0,A)}static fromString(C){return new D(C.split("\0"))}static join(C,A){return new D([...C.path,A])}static joinToString(C,A){return C.toString()+"\0"+A}static parentId(C){const A=C.lastIndexOf("\0");return A===-1?void 0:C.slice(0,A)}static localId(C){const A=C.lastIndexOf("\0");return A===-1?C:C.slice(A+1)}static compare(C,A){return C===A?0:A.startsWith(C+"\0")?2:C.startsWith(A+"\0")?3:1}constructor(C,A=C.length){if(this.path=C,this.d=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new D(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new D(this.path,C)}compare(C){if(typeof C=="string")return D.compare(this.toString(),C);for(let A=0;A<C.d&&A<this.d;A++)if(C.path[A]!==this.path[A])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=D}),define(Ie[55],Ce([1,0,2,56,43]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var C;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable",a[a.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=a=>"runIn"in a;e.isStartControllerTests=A;var S;(function(a){a.serialize=l=>({range:l.range.toJSON(),uri:l.uri.toJSON()}),a.deserialize=l=>({range:k.Range.lift(l.range),uri:n.URI.revive(l.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var y;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var N;(function(a){a.serialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,location:l.location&&S.serialize(l.location)}),a.deserialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,location:l.location&&S.deserialize(l.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const E=(a,l)=>`${l?"s":"e"}${a}`;e.getMarkId=E;var m;(function(a){a.serialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&S.serialize(l.location)}),a.deserialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&S.deserialize(l.location)})})(m=e.ITestOutputMessage||(e.ITestOutputMessage={}));var p;(function(a){a.serialize=l=>l.type===0?N.serialize(l):m.serialize(l),a.deserialize=l=>l.type===0?N.deserialize(l):m.deserialize(l)})(p=e.ITestMessage||(e.ITestMessage={}));var f;(function(a){a.serializeWithoutMessages=l=>({state:l.state,duration:l.duration,messages:[]}),a.serialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(p.serialize)}),a.deserialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(p.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const s="\0",o=(a,l)=>a+s+l;e.namespaceTestTag=o;const u=a=>{const l=a.indexOf(s);return{ctrlId:a.slice(0,l),tagId:a.slice(l+1)}};e.denamespaceTestTag=u;var b;(function(a){a.serialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?.toJSON(),range:l.range?.toJSON()||null,description:l.description,error:l.error,sortText:l.sortText}),a.deserialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?n.URI.revive(l.uri):void 0,range:l.range?k.Range.lift(l.range):null,description:l.description,error:l.error,sortText:l.sortText})})(b=e.ITestItem||(e.ITestItem={}));var w;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(a){a.serialize=l=>({expand:l.expand,item:b.serialize(l.item)}),a.deserialize=l=>({controllerId:D.TestId.root(l.item.extId),expand:l.expand,item:b.deserialize(l.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(a){a.serialize=l=>{let g;return l.item&&(g={},l.item.label!==void 0&&(g.label=l.item.label),l.item.tags!==void 0&&(g.tags=l.item.tags),l.item.busy!==void 0&&(g.busy=l.item.busy),l.item.uri!==void 0&&(g.uri=l.item.uri?.toJSON()),l.item.range!==void 0&&(g.range=l.item.range?.toJSON()),l.item.description!==void 0&&(g.description=l.item.description),l.item.error!==void 0&&(g.error=l.item.error),l.item.sortText!==void 0&&(g.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:g}},a.deserialize=l=>{let g;return l.item&&(g={},l.item.label!==void 0&&(g.label=l.item.label),l.item.tags!==void 0&&(g.tags=l.item.tags),l.item.busy!==void 0&&(g.busy=l.item.busy),l.item.range!==void 0&&(g.range=l.item.range?k.Range.lift(l.item.range):null),l.item.description!==void 0&&(g.description=l.item.description),l.item.error!==void 0&&(g.error=l.item.error),l.item.sortText!==void 0&&(g.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:g}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const r=(a,l)=>{l.expand!==void 0&&(a.expand=l.expand),l.item!==void 0&&(a.item=a.item?Object.assign(a.item,l.item):l.item)};e.applyTestItemUpdate=r;var h;(function(a){a.serializeWithoutMessages=l=>({...P.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.serializeWithoutMessages),retired:l.retired}),a.serialize=l=>({...P.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.serialize),retired:l.retired}),a.deserialize=l=>({...P.deserialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(f.deserialize),retired:!0})})(h=e.TestResultItem||(e.TestResultItem={}));var i;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var c;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var t;(function(a){a.deserialize=l=>l.op===0?{op:l.op,item:P.deserialize(l.item)}:l.op===1?{op:l.op,item:v.deserialize(l.item)}:l.op===2?{op:l.op,uri:n.URI.revive(l.uri),docv:l.docv}:l,a.serialize=l=>l.op===0?{op:l.op,item:P.serialize(l.item)}:l.op===1?{op:l.op,item:v.serialize(l.item)}:l})(t=e.TestsDiffOp||(e.TestsDiffOp={}));class d{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(l){const g=this.o();for(const R of l)switch(R.op){case 0:this.j(P.deserialize(R.item),g);break;case 1:this.k(v.deserialize(R.item),g);break;case 3:this.l(R.itemId,g);break;case 5:this.m(R.itemId);break;case 4:this.updatePendingRoots(R.amount);break;case 6:this.c.set(R.tag.id,R.tag);break;case 7:this.c.delete(R.id);break}g.complete?.()}j(l,g){const R=D.TestId.parentId(l.item.extId)?.toString();let O;if(!R)O=this.p(l),this.f.add(O),this.d.set(l.item.extId,O);else if(this.d.has(R)){const q=this.d.get(R);q.children.add(l.item.extId),O=this.p(l,q),this.d.set(l.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(l)}`);return}return g.add?.(O),l.expand===2&&this.g++,O}k(l,g){const R=this.d.get(l.extId);if(!!R)return l.expand!==void 0&&(R.expand===2&&this.g--,l.expand===2&&this.g++),(0,e.applyTestItemUpdate)(R,l),g.update?.(R),R}l(l,g){const R=this.d.get(l);if(!R)return;const O=D.TestId.parentId(R.item.extId)?.toString();O?this.d.get(O).children.delete(R.item.extId):this.f.delete(R);const q=[[l]];for(;q.length;)for(const Z of q.pop()){const x=this.d.get(Z);x&&(q.push(x.children),this.d.delete(Z),g.remove?.(x,x!==R),x.expand===2&&this.g--)}}m(l){}updatePendingRoots(l){this.h+=l}o(){return{}}}e.AbstractIncrementalTestCollection=d}),define(Ie[72],Ce([1,0,12,4,6,47,55,43]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(b,w)=>b===w,E=Object.entries({range:(b,w)=>b===w?!0:!b||!w?!1:b.equalsRange(w),busy:y,label:y,description:y,error:y,sortText:y,tags:(b,w)=>!(b.length!==w.length||b.some(P=>!w.includes(P)))}),m=(b,w)=>{let P;for(const[v,r]of E)r(b[v],w[v])||(P?P[v]=w[v]:P={[v]:w[v]});return P};class p extends D.Disposable{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(w){this.h=w;for(const P of this.tree.values())this.G(P)}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const P of this.k)if(P.op===2&&P.uri===w.uri){P.docv=w.docv;return}break}case 1:{const P=this.k[this.k.length-1];if(P){if(P.op===1&&P.item.extId===w.item.extId){(0,C.applyTestItemUpdate)(P.item,w.item);return}if(P.op===0&&P.item.item.extId===w.item.extId){(0,C.applyTestItemUpdate)(P.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,P){const v=this.tree.get(w);if(!!v){if((v.expandLevels===void 0||P>v.expandLevels)&&(v.expandLevels=P),v.expand===1){const r=this.I(v);return r.isOpen()?this.H(v,P-1):r.wait().then(()=>this.H(v,P-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,P-1)):this.H(v,P-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,P){switch(P.op){case 3:this.L(A.TestId.joinToString(w.fullId,P.id));break;case 0:this.u(P.item,w);break;case 5:for(const v of P.ops)this.p(w,v);break;case 1:this.w(P.new,P.old,w.fullId.toString());break;case 2:this.G(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:P.update}});break;case 6:this.s(w.actual.uri);break;default:(0,M.assertNever)(P)}}s(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}u(w,P){const v=A.TestId.fromExtHostTestItem(w,this.root.id,P?.actual),r=this.m.getApiFor(w);r.parent&&r.parent!==P?.actual&&this.m.getChildren(r.parent).delete(w.id);let h=this.tree.get(v.toString());if(!h){h={fullId:v,actual:w,expandLevels:P?.expandLevels?P.expandLevels-1:void 0,expand:0},w.tags.forEach(this.y,this),this.tree.set(h.fullId.toString(),h),this.C(w,P),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:h.expand,item:this.m.toITestItem(w)}}),this.F(w,h,P);return}if(h.actual===w){this.D(w,h,P);return}if(h.actual.uri?.toString()!==w.uri?.toString())return this.L(v.toString()),this.u(w,P);const i=this.m.getChildren(h.actual),c=h.actual,t=m(this.m.toITestItem(c),this.m.toITestItem(w));this.m.getApiFor(c).listener=void 0,h.actual=w,h.expand=0,t&&(t.hasOwnProperty("tags")&&(this.w(w.tags,c.tags,v.toString()),delete t.tags),this.p(h,{op:4,update:t})),this.F(w,h,P);for(const[d,a]of i)this.m.getChildren(w).get(a.id)||this.L(A.TestId.joinToString(v,a.id));this.s(h.actual.uri)}w(w,P,v){const r=new Set(P.map(h=>h.id));for(const h of w)r.delete(h.id)||this.y(h);this.pushDiff({op:1,item:{extId:v,item:{tags:w.map(h=>(0,C.namespaceTestTag)(this.m.controllerId,h.id))}}}),r.forEach(this.z,this)}y(w){const P=this.j.get(w.id);P?P.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,w.id)}}))}z(w){const P=this.j.get(w);P&&!--P.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,w)}))}C(w,P){this.m.getApiFor(w).parent=P&&P.actual!==this.root?P.actual:void 0}D(w,P,v){this.C(w,v);const r=this.m.getApiFor(w);r.parent=v?.actual,r.listener=h=>this.p(P,h),this.G(P)}F(w,P,v){this.D(w,P,v);for(const[r,h]of this.m.getChildren(w))this.u(h,P)}G(w){let P;this.h?w.resolveBarrier?P=w.resolveBarrier.isOpen()?3:2:P=w.actual.canResolveChildren?1:0:P=0,P!==w.expand&&(w.expand=P,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:P}}),P===1&&w.expandLevels!==void 0&&this.I(w))}H(w,P){if(P<0)return;const v=[];for(const[r,h]of this.m.getChildren(w.actual)){const i=this.expand(A.TestId.joinToString(w.fullId,h.id),P);(0,n.isThenable)(i)&&v.push(i)}if(v.length)return Promise.all(v).then(()=>{})}I(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const h=new n.Barrier;return h.open(),h}w.expand=2,this.J(w);const P=w.resolveBarrier=new n.Barrier,v=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,h)};let r;try{r=this.h(w.actual===this.root?void 0:w.actual)}catch(h){v(h)}return(0,n.isThenable)(r)?r.catch(v).then(()=>{P.open(),this.G(w)}):(P.open(),this.G(w)),w.resolveBarrier}J(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}L(w){const P=this.tree.get(w);if(!P)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const v=[P];for(;v.length;){const r=v.pop();if(!!r){this.m.getApiFor(r.actual).listener=void 0;for(const h of r.actual.tags)this.z(h.id);this.tree.delete(r.fullId.toString());for(const[h,i]of this.m.getChildren(r.actual))v.push(this.tree.get(A.TestId.joinToString(r.fullId,i.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.TestItemCollection=p;class f extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=f;class s extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=s;class o extends Error{constructor(w,P,v){super(`TestItem with ID "${w}" is from controller "${P}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=o;const u=(b,w,P)=>{let v=new Map;return{get size(){return v.size},forEach(r,h){for(const i of v.values())r.call(h,i,this)},[Symbol.iterator](){return v.entries()},replace(r){const h=new Map,i=new Set(v.keys()),c={op:5,ops:[]};for(const t of r){if(!(t instanceof P))throw new s(t.id);const d=w(t).controllerId;if(d!==b.controllerId)throw new o(t.id,d,b.controllerId);if(h.has(t.id))throw new f(t.id);h.set(t.id,t),i.delete(t.id),c.ops.push({op:0,item:t})}for(const t of i.keys())c.ops.push({op:3,id:t});b.listener?.(c),v=h},add(r){if(!(r instanceof P))throw new s(r.id);v.set(r.id,r),b.listener?.({op:0,item:r})},delete(r){v.delete(r)&&b.listener?.({op:3,id:r})},get(r){return v.get(r)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=u}),define(Ie[96],Ce([1,0,72]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,D=(C,A)=>{const S={controllerId:A};return k.set(C,S),S};e.createPrivateApiFor=D;const M=C=>{const A=k.get(C);if(!A)throw new n.InvalidTestItemError(C?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ie[73],Ce([1,0,16,2]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(A,S){return A.scheme===n.Schemas.http||A.scheme===n.Schemas.https?A:(S&&S.authority&&S.isRemote&&A.scheme===n.Schemas.file&&(A=k.URI.from({scheme:n.Schemas.vscodeRemote,authority:S.authority,path:A.path})),k.URI.from({scheme:n.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=D;function M(A){return A.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function C(A){return A.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=C}),define(Ie[184],Ce([1,0,4,6,73]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,S,y){this.d=A,this.e=S,this.f=y,this.a=0,this.b=new k.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const E of this.c.values())N.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,S,y,N,E){let m;for(const w of this.e.getVisibleTextEditors(!0))if(w.value===A){m=w;break}if(!m)throw new Error("not a visible editor");const p=this,f=this.a++,s=new n.Emitter,o=new n.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(w){return(0,D.asWebviewUri)(w,p.f)}get cspSource(){return D.webviewGenericCspSource}set options(w){this.b=w,p.d.$setOptions(f,w)}get options(){return this.b}set html(w){this.a=w,p.d.$setHtml(f,w)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(w){return p.d.$postMessage(f,w)}},b=new class{constructor(){this.editor=A,this.line=S,this.height=y,this.webview=u,this.onDidDispose=o.event}dispose(){p.c.has(f)&&(p.c.delete(f),p.d.$disposeEditorInset(f),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,S+1,y,N||{},E.identifier,E.extensionLocation),this.c.set(f,{editor:A,inset:b,onDidReceiveMessage:s}),b}$onDidDispose(A){const S=this.c.get(A);S&&S.inset.dispose()}$onDidReceiveMessage(A,S){this.c.get(A)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=M}),define(Ie[185],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var k;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(C,A){super(A),this.variable=C}}e.VariableError=D}),define(Ie[186],Ce([1,0,19,49,9,22,20,87,151,185,10]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(p,f,s,o){this.g=new Map,this.a=p,this.b=f,this.d=s,o&&(this.c=o.then(u=>this.h(u)))}h(p){if(C.isWindows){const f=Object.create(null);return Object.keys(p).forEach(s=>{f[s.toLowerCase()]=p[s]}),f}return p}resolveWithEnvironment(p,f,s){return this.j({env:this.h(p),userHome:void 0},f?f.uri:void 0,s)}async resolveAsync(p,f){const s={env:await this.c,userHome:await this.d};return this.j(s,p?p.uri:void 0,f)}async i(p,f,s,o){const u=M.deepClone(f);C.isWindows&&u.windows?Object.keys(u.windows).forEach(w=>u[w]=u.windows[w]):C.isMacintosh&&u.osx?Object.keys(u.osx).forEach(w=>u[w]=u.osx[w]):C.isLinux&&u.linux&&Object.keys(u.linux).forEach(w=>u[w]=u.linux[w]),delete u.windows,delete u.osx,delete u.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,p?p.uri:void 0,u,s,o)}async resolveAnyAsync(p,f,s){return this.i(p,f,s)}async resolveAnyMap(p,f,s){const o=new Map;return{newConfig:await this.i(p,f,s,o),resolvedVariables:o}}resolveWithInteractionReplace(p,f,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,f,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,f){if(this.g.has(p))throw new Error("Variable "+p+" is contributed twice.");this.g.set(p,f)}async j(p,f,s,o,u){if(D.isString(s))return this.l(p,f,s,o,u);if(Array.isArray(s))return Promise.all(s.map(b=>this.j(p,f,b,o,u)));if(D.isObject(s)){const b=Object.create(null),w=await Promise.all(Object.keys(s).map(async P=>[await this.l(p,f,P,o,u),await this.j(p,f,s[P],o,u)]));for(const[P,v]of w)b[P]=v;return b}return s}l(p,f,s,o,u){return(0,N.replaceAsync)(s,E.VARIABLE_REGEXP,async(b,w)=>{if(w.includes(E.VARIABLE_LHS))return b;let P=await this.n(p,b,w,f,o);return u?.set(w,P),P!==b&&D.isString(P)&&P.match(E.VARIABLE_REGEXP)&&(P=await this.l(p,f,P,o,u)),P})}m(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async n(p,f,s,o,u){let b;const w=s.split(":");w.length>1&&(s=w[0],b=w[1]);const P=h=>{const i=this.a.getFilePath();if(i)return(0,A.normalizeDriveLetter)(i);throw new y.VariableError(h,(0,S.localize)(0,null,f))},v=h=>{const i=P(h);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,A.normalizeDriveLetter)(c)}throw new y.VariableError(h,(0,S.localize)(1,null,f,n.basename(i)))},r=h=>{if(b){const i=this.a.getFolderUri(b);if(i)return i;throw new y.VariableError(h,(0,S.localize)(2,null,f,b))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(h,(0,S.localize)(3,null,f)):new y.VariableError(h,(0,S.localize)(4,null,f))};switch(s){case"env":if(b){if(p.env){const h=p.env[C.isWindows?b.toLowerCase():b];if(D.isString(h))return h}return""}throw new y.VariableError(y.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(b){const h=this.a.getConfigurationValue(o,b);if(D.isUndefinedOrNull(h))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(6,null,f,b));if(D.isObject(h))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(7,null,f,b));return h}throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(y.VariableKind.Command,f,b,u,"command");case"input":return this.o(y.VariableKind.Input,f,b,u,"input");case"extensionInstallFolder":if(b){const h=await this.a.getExtension(b);if(!h)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,b));return this.m(h.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(r(y.VariableKind.WorkspaceFolder)));case"cwd":return o||b?(0,A.normalizeDriveLetter)(this.m(r(y.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(n.basename(this.m(r(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new y.VariableError(y.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new y.VariableError(y.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return P(y.VariableKind.File);case"fileWorkspaceFolder":return v(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||b?n.relative(this.m(r(y.VariableKind.RelativeFile)),P(y.VariableKind.RelativeFile)):P(y.VariableKind.RelativeFile);case"relativeFileDirname":{const h=n.dirname(P(y.VariableKind.RelativeFileDirname));if(o||b){const i=n.relative(this.m(r(y.VariableKind.RelativeFileDirname)),h);return i.length===0?".":i}return h}case"fileDirname":return n.dirname(P(y.VariableKind.FileDirname));case"fileExtname":return n.extname(P(y.VariableKind.FileExtname));case"fileBasename":return n.basename(P(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=n.basename(P(y.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-n.extname(h).length)}case"fileDirnameBasename":return n.basename(n.dirname(P(y.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||f}case"execInstallFolder":{const h=this.a.getAppRoot();return h||f}case"pathSeparator":return n.sep;default:try{const h=b?`${s}:${b}`:s;return this.o(y.VariableKind.Unknown,f,h,u,void 0)}catch{return f}}}}o(p,f,s,o,u){if(s&&o){const b=u===void 0?o[s]:o[u+":"+s];if(typeof b=="string")return b;throw new y.VariableError(p,(0,S.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[97],Ce([1,0,3,95]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var D;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(f){const s=f;return(0,k.isEditorInput)(s?.editor)&&(0,k.isEditorInput)(s?.replacement)}e.isEditorReplacement=y;var N;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const s=f;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.isEditorGroup=m;function p(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ie[187],Ce([1,0,3,97]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(M){const C=M;return typeof M=="number"||(0,k.isEditorGroup)(C)}e.isPreferredGroup=D}),define(Ie[188],Ce([1,0,3,157]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(k.IEnvironmentService)}),define(Ie[98],Ce([1,0,25,4,19]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(E){this.removedDueToLooping=E}}e.DeltaExtensionsResult=M;class C{static isHostExtension(E,m,p){if(m.getExtensionDescription(E))return!1;const f=p.getExtensionDescription(E);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(E){this.c=new k.Emitter,this.onDidChange=this.c.event,this.d=E,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const E of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(E.identifier))){console.error("Extension `"+E.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(E.identifier),E),this.f.push(E),Array.isArray(E.activationEvents))for(let m of E.activationEvents)m==="onUri"&&(m=`onUri:${n.ExtensionIdentifier.toKey(E.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(E)}}set(E){this.d=E,this.h(),this.c.fire(void 0)}deltaExtensions(E,m){this.d=y(this.d,m),this.d=this.d.concat(E);const p=C.j(this.d);return this.d=y(this.d,p.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new M(p)}static j(E){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,b){this.addNode(u),this.addNode(b),this.c.has(u)?this.c.get(u).push(b):this.c.set(u,[b])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,b){const w=m.getArcs(u);for(let P=0;P<w.length;P++)if(!b.has(w[P]))return!1;return!0}getNodes(){return this.e}},p=new Map;for(const u of E){const b=n.ExtensionIdentifier.toKey(u.identifier);if(p.set(b,u),u.extensionDependencies)for(const w of u.extensionDependencies){const P=n.ExtensionIdentifier.toKey(w);m.addArc(b,P)}}const f=new Set;m.getNodes().filter(u=>m.getArcs(u).length===0).forEach(u=>f.add(u));const s=m.getNodes().filter(u=>!f.has(u));let o;do{o=!1;for(let u=0;u<s.length;u++){const b=s[u];m.hasOnlyGoodArcs(b,f)&&(s.splice(u,1),u--,f.add(b),o=!0)}}while(o);return s.map(u=>p.get(u))}containsActivationEvent(E){return this.g.has(E)}containsExtension(E){return this.e.has(n.ExtensionIdentifier.toKey(E))}getExtensionDescriptionsForActivationEvent(E){const m=this.g.get(E);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(E){const m=this.e.get(n.ExtensionIdentifier.toKey(E));return m||void 0}getExtensionDescriptionByUUID(E){for(const m of this.f)if(m.uuid===E)return m}getExtensionDescriptionByIdOrUUID(E,m){return this.getExtensionDescription(E)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=C;var A;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(A||(A={}));function S(N,E){const m=N.isBuiltin?0:N.isUnderDevelopment?2:1,p=E.isBuiltin?0:E.isUnderDevelopment?2:1;if(m!==p)return m-p;const f=D.posix.basename(N.extensionLocation.path),s=D.posix.basename(E.extensionLocation.path);return f<s?-1:f>s?1:0}function y(N,E){const m=new Set;return E.forEach(p=>m.add(n.ExtensionIdentifier.toKey(p))),N.filter(p=>!m.has(n.ExtensionIdentifier.toKey(p.identifier)))}}),define(Ie[74],Ce([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var D;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function C(y){const N=n.VSBuffer.alloc(1);switch(y){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=C;function A(y,N){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=A;var S;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[75],Ce([1,0,3,4,13,27,74,48,50,22,2]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class{constructor(s,o){this.i=s,this.a=new k.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new k.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(N.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(s,o,u){const b=this.getTelemetryDetails(),w=new m(o,u,s,this.g,this.f,this.getBuiltInCommonProperties(s),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled});return this.h.set(s.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(s,o,u){this.d=s,this.f=o,this.c=u??{usage:!0,error:!0}}getBuiltInCommonProperties(s){const o={};switch(o["common.extname"]=`${s.publisher}.${s.name}`,o["common.extversion"]=s.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=p(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:o["common.uikind"]="web";break;case C.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,A.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(s){this.e=this.getTelemetryConfiguration(),this.d=s;const o=this.getTelemetryDetails();this.h.forEach(u=>{u.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(s,o){const u=this.h.get(s.value);return!u||u.ignoreUnhandledExtHostErrors?!1:(u.logError(o),!0)}};E=qe([je(0,M.IExtHostInitDataService),je(1,D.ILoggerService)],E),e.ExtHostTelemetry=E;class m{constructor(s,o,u,b,w,P,v){this.g=u,this.h=b,this.i=w,this.j=P,this.b=new k.Emitter,this.ignoreUnhandledExtHostErrors=o?.ignoreUnhandledErrors??!1,this.e=o?.ignoreBuiltInCommonProperties??!1,this.f=o?.additionalCommonProperties,this.a=s,this.c={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,o){this.d&&(this.c={isUsageEnabled:s,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(s){let o=s.properties??s;return o=(0,S.cleanData)(o,[]),this.f&&(o=(0,y.mixin)(o,this.f)),this.e||(o=(0,y.mixin)(o,this.j)),s.properties?s.properties=o:s=o,s}k(s,o){this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,o=this.mixInCommonPropsAndCleanData(o||{}),this.i||this.a.sendEventData(s,o),this.h.trace(s,o)}logUsage(s,o){!this.c.isUsageEnabled||this.k(s,o)}logError(s,o){!this.c.isErrorsEnabled||(typeof s=="string"?this.k(s,o):this.a.sendErrorData(s,o))}get apiTelemetryLogger(){if(!this.d){const s=this,o={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.c.isUsageEnabled},get isErrorsEnabled(){return s.c.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.b.event.bind(s)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function p(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ie[26],Ce([1,0,4,2,3,25,166]),function(te,e,n,k,D,M,C){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class y{constructor(d){this.affinity=d,this.kind=2}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class N{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class E{constructor(d){this.dependency=d}}e.MissingExtensionDependency=E;var m;(function(t){t[t.LocalProcess=1]="LocalProcess",t[t.LocalWebWorker=2]="LocalWebWorker",t[t.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(t){if(t===null)return"None";switch(t){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=p;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(d,a){const l=[],g=[],R=[],O=[],q=u(this.c),Z=u(d),x=(L,V)=>L.extensionLocation.toString()===V.extensionLocation.toString()||L.isBuiltin===V.isBuiltin||L.isUserBuiltin===V.isUserBuiltin||L.isUnderDevelopment===V.isUnderDevelopment;for(const L of this.c){const V=Z.get(M.ExtensionIdentifier.toKey(L.identifier));if(!V){l.push(L.identifier),q.delete(M.ExtensionIdentifier.toKey(L.identifier));continue}if(!x(L,V)){l.push(L.identifier),q.delete(M.ExtensionIdentifier.toKey(L.identifier));continue}}for(const L of d){const V=q.get(M.ExtensionIdentifier.toKey(L.identifier));if(!V){g.push(L);continue}if(!x(V,L)){l.push(V.identifier),q.delete(M.ExtensionIdentifier.toKey(V.identifier));continue}}const F=o(this.d),$=o(a);for(const L of this.d)$.has(M.ExtensionIdentifier.toKey(L))||R.push(L);for(const L of a)F.has(M.ExtensionIdentifier.toKey(L))||O.push(L);const T={toRemove:l,toAdd:g,myToRemove:R,myToAdd:O};return this.delta(T),T}delta(d){const{toRemove:a,toAdd:l,myToRemove:g,myToAdd:R}=d,O=o(a),q=o(g);for(let Z=0;Z<this.c.length;Z++)O.has(M.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)q.has(M.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of l)this.c.push(Z);for(const Z of R)this.d.push(Z)}containsExtension(d){for(const a of this.d)if(M.ExtensionIdentifier.equals(a,d))return!0;return!1}}e.ExtensionHostExtensions=f;class s{constructor(d){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,d)for(const a of d)this.add(a)}get size(){return this.c.size}add(d){return this.c.set(this.d(d),d),this}clear(){this.c.clear()}delete(d){return this.c.delete(this.d(d))}has(d){return this.c.has(this.d(d))}forEach(d,a){this.c.forEach(l=>d.call(a,l,l,this))}*entries(){for(const[d,a]of this.c)yield[a,a]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=s;function o(t){const d=new Set;for(const a of t)d.add(M.ExtensionIdentifier.toKey(a));return d}e.extensionIdentifiersArrayToSet=o;function u(t){const d=new Map;for(const a of t)d.set(M.ExtensionIdentifier.toKey(a.identifier),a);return d}function b(t,d){return t.enabledApiProposals?t.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=b;function w(t,d){if(!b(t,d))throw new Error(`Extension '${t.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${t.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${t.identifier.value}`)}e.checkProposedApiEnabled=w;class P{constructor(d,a,l,g){this.codeLoadingTime=d,this.activateCallTime=a,this.activateResolvedTime=l,this.activationReason=g}}e.ActivationTimes=P;class v{constructor(d,a){this.description=d,this.value=a}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(t){t[t.Normal=0]="Normal",t[t.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function h(t){return{type:t.isBuiltin?0:1,isBuiltin:t.isBuiltin||t.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(t.publisher,t.name),uuid:t.uuid},manifest:t,location:t.extensionLocation,targetPlatform:t.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function i(t,d){return{identifier:new M.ExtensionIdentifier((0,C.getExtensionId)(t.manifest.publisher,t.manifest.name)),isBuiltin:t.type===0,isUserBuiltin:t.type===1&&t.isBuiltin,isUnderDevelopment:!!d,extensionLocation:t.location,...t.manifest,uuid:t.identifier.uuid,targetPlatform:t.targetPlatform,browserNlsBundleUris:t.browserNlsBundleUris}}e.toExtensionDescription=i;class c{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,a){return Promise.resolve(0)}getInspectPorts(d,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(Ie[189],Ce([1,0,11,98,25,26,13,12]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,b,w,P){this.startup=u,this.codeLoadingTime=b,this.activateCallTime=w,this.activateResolvedTime=P}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class y{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,b){return u===-1||b===-1?-1:b-u}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=y;class N{constructor(u,b,w,P,v,r){this.activationFailed=u,this.activationFailedError=b,this.activationTimes=w,this.module=P,this.exports=v,this.subscriptions=r}}e.ActivatedExtension=N;class E extends N{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=E;class m extends N{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class p extends N{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(u,b,w,P){this.g=P,this.a=u,this.b=b,this.c=w,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,b]of this.d)b.dispose()}isActivated(u){const b=this.d.get(D.ExtensionIdentifier.toKey(u));return Boolean(b&&b.value)}getActivatedExtension(u){const b=this.d.get(D.ExtensionIdentifier.toKey(u));if(!b||!b.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return b.value}async activateByEvent(u,b){if(this.f[u])return;const w=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(w.map(P=>({id:P.identifier,reason:{startup:b,extensionId:P.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,b){const w=this.a.getExtensionDescription(u);if(!w)throw new Error(`Extension '${u}' is not known`);return this.h([{id:w.identifier,reason:b}])}async h(u){const b=u.filter(w=>!this.isActivated(w.id)).map(w=>this.j(w));await Promise.all(b.map(w=>w.wait()))}j(u){if(this.d.has(D.ExtensionIdentifier.toKey(u.id)))return this.d.get(D.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const b=this.a.getExtensionDescription(u.id);if(!b){const v=new Error(`Cannot activate unknown extension '${u.id.value}'`),r=this.k(u,null,[],new p(v));return this.c.onExtensionActivationError(u.id,v,new M.MissingExtensionDependency(u.id.value)),r}const w=[],P=typeof b.extensionDependencies>"u"?[]:b.extensionDependencies;for(const v of P){if(this.m(v))continue;const r=this.d.get(D.ExtensionIdentifier.toKey(v));if(r){w.push(r);continue}if(this.l(v)){w.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:u.reason}));continue}const h=this.a.getExtensionDescription(v);if(h){if(!h.main&&!h.browser)continue;w.push(this.j({id:h.identifier,reason:u.reason}));continue}const i=b.displayName||b.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${v}'`),t=this.k(u,b.displayName,[],new p(c));return this.c.onExtensionActivationError(b.identifier,c,new M.MissingExtensionDependency(v)),t}return this.k(u,b.displayName,w,null)}k(u,b,w,P){const v=new s(u.id,b,u.reason,w,P,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(u.id),v),v}l(u){return k.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const b=this.b.getExtensionDescription(u);return b?!b.main&&!b.browser:!1}};f=qe([je(3,C.ILogService)],f),e.ExtensionsActivator=f;let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,b,w,P,v,r,h){this.c=u,this.d=b,this.f=w,this.g=P,this.h=v,this.j=r,this.k=h,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const b=this.g[u];if(b.value&&!b.value.activationFailed){this.g.splice(u,1),u--;continue}if(b.value&&b.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${b.friendlyName}' failed to activate`);w.detail=b.value.activationFailedError,this.h=new p(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const b=new Error;if(u&&u.name&&(b.name=u.name),u&&u.message?b.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:b.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(b.stack=u.stack),this.h=new p(b),this.b&&n.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,b,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};s=qe([je(6,C.ILogService)],s)}),define(Ie[190],Ce([1,0,13,27,26]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends n.LogService{constructor(A,S){super(A.createLogger(S.logFile,{name:D.ExtensionHostLogFileName}))}};M=qe([je(0,n.ILoggerService),je(1,k.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[7],Ce([1,0,18,11,86,28,64,10,9,2,34,36,94,71,26]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f){"use strict";var s,o,u,b,w,P,v,r,h,i,c,t,d,a,l,g,R,O,q,Z,x,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...we]=arguments;return Reflect.construct(z,we,ie.constructor)}}})}var L;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(L=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=P=class{static from(...U){let ie=U;return new P(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(U){s.set(this,void 0),Je(this,s,U,"f")}dispose(){typeof Oe(this,s,"f")=="function"&&(Oe(this,s,"f").call(this),Je(this,s,void 0,"f"))}};s=new WeakMap,j=P=qe([T],j),e.Disposable=j;let le=v=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:ie,character:we}=U;return typeof ie=="number"&&typeof we=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(ie<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,k.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ie===0?this:new v(this.line+we,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,k.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),we===this.line&&ie===this.character?this:new v(we,ie)}toJSON(){return{line:this.line,character:this.character}}};le=v=qe([T],le),e.Position=le;let _=r=class{static isRange(U){return U instanceof r?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,we,Ke){let _e,at;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(_e=new le(U,ie),at=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(_e=le.of(U),at=le.of(ie)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ie.isAfter(we))return new r(ie,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new r(ie,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,k.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ie=U.end||this.end):we=this.start,we.isEqual(this.c)&&ie.isEqual(this.end)?this:new r(we,ie)}toJSON(){return[this.start,this.end]}};_=r=qe([T],_),e.Range=_;let pe=h=class extends _{static isSelection(U){return U instanceof h?!0:U?_.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,we,Ke){let _e,at;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(_e=new le(U,ie),at=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(_e=le.of(U),at=le.of(ie)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};pe=h=qe([T],pe),e.Selection=pe;class ue{constructor(U,ie,we){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,k.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,k.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=ue;class de extends Error{static NotAvailable(U,ie){return new de(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new de(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ie,this._detail=we,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=i=class{static isTextEdit(U){return U instanceof i?!0:U?_.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new i(U,ie)}static insert(U,ie){return i.replace(new _(U,U),ie)}static delete(U){return i.replace(U,"")}static setEndOfLine(U){const ie=new i(new _(new le(0,0),new le(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!_.isRange(U))throw(0,k.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};H=i=qe([T],H),e.TextEdit=H;let oe=c=class{static isNotebookCellEdit(U){return U instanceof c?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new c(U,ie)}static insertCells(U,ie){return new c(new Kt(U,U),ie)}static deleteCells(U){return new c(U,[])}static updateCellMetadata(U,ie){const we=new c(new Kt(U,U),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(U){const ie=new c(new Kt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};oe=c=qe([T],oe),e.NotebookEdit=oe;class ve{static isSnippetTextEdit(U){return U instanceof ve?!0:U?_.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,ie){return new ve(U,ie)}static insert(U,ie){return ve.replace(new _(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=ve;var Ae;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Ue=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,we,Ke){this.c.push({_type:1,from:U,to:ie,options:we,metadata:Ke})}createFile(U,ie,we){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:we})}deleteFile(U,ie,we){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:we})}e(U,ie,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,we,Ke){const _e=ie.start,at=ie.end;(_e!==at||we.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:at-_e,cells:we,metadata:Ke})}g(U,ie,we,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:ie,metadata:we}})}replace(U,ie,we,Ke){this.c.push({_type:2,uri:U,edit:new H(ie,we),metadata:Ke})}insert(U,ie,we,Ke){this.replace(U,new _(ie,ie),we,Ke)}delete(U,ie,we){this.replace(U,ie,"",we)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const we of ie){if(!we)continue;let Ke,_e;Array.isArray(we)?(Ke=we[0],_e=we[1]):Ke=we,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,_e):this.f(U,Ke.range,Ke.newCells,_e):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:Ke,metadata:_e})}else{for(let we=0;we<this.c.length;we++){const Ke=this.c[we];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ie.push(we.edit);return ie}entries(){const U=new M.ResourceMap;for(const ie of this.c)if(ie._type===2){let we=U.get(ie.uri);we||(we=[ie.uri,[]],U.set(ie.uri,we)),we[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ue=qe([T],Ue),e.WorkspaceEdit=Ue;let xe=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=t.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const we=new t;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=t.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const we=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const we=new t;we.e=this.e,ie(we),this.e=we.e,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};xe=t=qe([T],xe),e.SnippetString=xe;var Te;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=d=class{static isLocation(U){return U instanceof d?!0:U?_.isRange(U.range)&&y.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(_.isRange(ie))this.range=_.of(ie);else if(le.isPosition(ie))this.range=new _(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=d=qe([T],ke),e.Location=ke;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&_.isRange(U.location.range)&&y.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};se=qe([T],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,ie,we=Se.Error){if(!_.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,n.equals)(U.tags,ie.tags)&&(0,n.equals)(U.relatedInformation,ie.relatedInformation,se.isEqual)}};ce=qe([T],ce),e.Diagnostic=ce;let J=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};J=qe([T],J),e.Hover=J;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(U,ie=I.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:I[this.kind]}}};B=qe([T],B),e.DocumentHighlight=B;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var K;(function(z){z[z.Deprecated=1]="Deprecated"})(K=e.SymbolTag||(e.SymbolTag={}));let ee=a=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,we,Ke,_e){this.name=U,this.kind=ie,this.containerName=_e,typeof we=="string"&&(this.containerName=we),Ke instanceof ke?this.location=Ke:we instanceof _&&(this.location=new ke(Ke,we)),a.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=a=qe([T],ee),e.SymbolInformation=ee;let he=l=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(l.validate)}constructor(U,ie,we,Ke,_e){this.name=U,this.detail=ie,this.kind=we,this.range=Ke,this.selectionRange=_e,this.children=[],l.validate(this)}};he=l=qe([T],he),e.DocumentSymbol=he;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ie){this.title=U,this.kind=ie}};ae=qe([T],ae),e.CodeAction=ae;let be=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};be.c=".",be=g=qe([T],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let Ee=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([T],Ee),e.SelectionRange=Ee;class We{constructor(U,ie,we,Ke,_e,at){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.CallHierarchyItem=We;class He{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([T],et),e.CodeLens=et;let it=R=class{static isMarkdownString(U){return U instanceof R?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new D.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,o,"f").value}set value(U){Oe(this,o,"f").value=U}get isTrusted(){return Oe(this,o,"f").isTrusted}set isTrusted(U){Oe(this,o,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,o,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,o,"f").supportHtml}set supportHtml(U){Oe(this,o,"f").supportHtml=U}get baseUri(){return Oe(this,o,"f").baseUri}set baseUri(U){Oe(this,o,"f").baseUri=U}appendText(U){return Oe(this,o,"f").appendText(U),this}appendMarkdown(U){return Oe(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Oe(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,it=R=qe([T],it),e.MarkdownString=it;let dt=class{constructor(U,ie){this.label=U,this.documentation=ie}};dt=qe([T],dt),e.ParameterInformation=dt;let Le=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Le=qe([T],Le),e.SignatureInformation=Le;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=qe([T],ot),e.SignatureHelp=ot;var Y;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([T],ge),e.InlayHintLabelPart=ge;let Me=class{constructor(U,ie,we){this.position=U,this.label=ie,this.kind=we}};Me=qe([T],Me),e.InlayHint=Me;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(z){z[z.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([T],nt),e.CompletionItem=nt;let vt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};vt=qe([T],vt),e.CompletionList=vt;let wt=class{constructor(U,ie,we){this.insertText=U,this.range=ie,this.command=we}};wt=qe([T],wt),e.InlineSuggestion=wt;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([T],Ct),e.InlineSuggestionList=Ct;var jt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(jt=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Lt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Lt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Bt=class{constructor(U,ie){if(ie&&!y.URI.isUri(ie))throw(0,k.illegalArgument)("target");if(!_.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=ie}};Bt=qe([T],Bt),e.DocumentLink=Bt;let Ot=class{constructor(U,ie,we,Ke){this.red=U,this.green=ie,this.blue=we,this.alpha=Ke}};Ot=qe([T],Ot),e.Color=Ot;let Ge=class{constructor(U,ie){if(ie&&!(ie instanceof Ot))throw(0,k.illegalArgument)("color");if(!_.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=ie}};Ge=qe([T],Ge),e.ColorInformation=Ge;let Mt=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};Mt=qe([T],Mt),e.ColorPresentation=Mt;var Nt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(zt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ie,we){if(this.startIndex=U,this.length=ie,this.tooltip=we,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,k.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=De;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class me{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=me;var X;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(X=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=Re;var Be;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Be=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=O=class{static from(U){switch(U){case"clean":return O.Clean;case"build":return O.Build;case"rebuild":return O.Rebuild;case"test":return O.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,k.illegalArgument)("name");this.c=U}get id(){return this.c}};$e.Clean=new O("clean","Clean"),$e.Build=new O("build","Build"),$e.Rebuild=new O("rebuild","Rebuild"),$e.Test=new O("test","Test"),$e=O=qe([T],$e),e.TaskGroup=$e;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,ie,we){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=we):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};ct=qe([T],ct),e.ProcessExecution=ct;let Tt=class{constructor(U,ie,we){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U,this.f=ie,this.g=we}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};Tt=qe([T],Tt),e.ShellExecution=Tt;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let St=q=class{constructor(U,ie,we,Ke,_e,at){this.j=!1,this.k=this.definition=U;let lt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=we,this.execution=Ke,lt=_e,this.j=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=_e,lt=at):(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=_e,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(q.g===ie||q.e===ie||q.f===ie||q.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=q=qe([T],St),e.Task=St;var yt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(z){function U(ie){const we=ie;return(0,S.isNumber)(we.value)?we.tooltip&&!(0,S.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=Z=class{static isTreeItem(U,ie){if(U instanceof Z)return!0;const we=U;if(we.label!==void 0&&!(0,S.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,S.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,S.isString)(we.iconPath)&&!y.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,S.isString)(we.iconPath.id))){const Ke=we.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!y.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!y.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,S.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!y.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,S.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<pt.None&&we.collapsibleState>pt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,S.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,S.isNumber)(we.checkboxState)?we.checkboxState:(0,S.isObject)(we.checkboxState)&&(0,S.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,_e=!(0,S.isNumber)(we.checkboxState)&&(0,S.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ie=pt.None){this.collapsibleState=ie,y.URI.isUri(U)?this.resourceUri=U:this.label=U}};Jt=Z=qe([T],Jt),e.TreeItem=Jt;var pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,N.generateUuid)()}};oi=qe([T],oi),e.DataTransferItem=oi;let Zt=class{constructor(U){u.set(this,new Map);for(const[ie,we]of U??[]){const Ke=Oe(this,u,"f").get(ie);Ke?Ke.push(we):Oe(this,u,"f").set(ie,[we])}}get(U){return Oe(this,u,"f").get(U)?.[0]}set(U,ie){Oe(this,u,"f").set(U,[ie])}forEach(U,ie){for(const[we,Ke]of Oe(this,u,"f"))for(const _e of Ke)U.call(ie,_e,we,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Oe(this,u,"f"))for(const we of ie)yield[U,we]}};Zt=qe([T],Zt),e.DataTransfer=Zt;let vi=class{constructor(U){this.insertText=U}};vi=qe([T],vi),e.DocumentDropEdit=vi;let At=class{constructor(U){this.insertText=U}};At=qe([T],At),e.DocumentPasteEdit=At;let Wt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Wt=qe([T],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([T],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(U){this.c=U,this.e=y.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!y.URI.isUri(U)&&!y.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof ie!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=y.URI.file(U):y.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([T],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(z,U){ut.set(z,U)}e.setBreakpointId=Bi;let Ut=class{constructor(U,ie,we,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=ut.get(this)??(0,N.generateUuid)()),this.c}};Ut=qe([T],Ut),e.Breakpoint=Ut;let Qt=class extends Ut{constructor(U,ie,we,Ke,_e){if(super(ie,we,Ke,_e),U===null)throw(0,k.illegalArgument)("location");this.location=U}};Qt=qe([T],Qt),e.SourceBreakpoint=Qt;let ci=class extends Ut{constructor(U,ie,we,Ke,_e){super(ie,we,Ke,_e),this.functionName=U}};ci=qe([T],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,ie,we,Ke,_e,at,lt){if(super(Ke,_e,at,lt),!ie)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=we}};Ei=qe([T],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,ie,we){this.command=U,this.args=ie||[],this.options=we}};wi=qe([T],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([T],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([T],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([T],li),e.DebugAdapterInlineImplementation=li;let ti=class{constructor(U,ie){this.range=U,this.expression=ie}};ti=qe([T],ti),e.EvaluatableExpression=ti;var $i;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(U,ie){this.range=U,this.text=ie}};ii=qe([T],ii),e.InlineValueText=ii;let ni=class{constructor(U,ie,we=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=we}};ni=qe([T],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(U,ie){this.range=U,this.expression=ie}};yi=qe([T],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Di=qe([T],Di),e.InlineValueContext=Di;var ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ii=x=class extends Error{static FileExists(U){return new x(U,E.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,E.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,E.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,E.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,E.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,E.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,ie=E.FileSystemProviderErrorCode.Unknown,we){super(y.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Ii=x=qe([T],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,ie,we){this.start=U,this.end=ie,this.kind=we}};Ci=qe([T],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,S.isStringArray)(z)}class Ne{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,we=U.tokenTypes.length;ie<we;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,we=U.tokenModifiers.length;ie<we;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,we,Ke,_e){if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,ie,we,Ke,_e);if(_.isRange(U)&&typeof ie=="string"&&Oi(we))return this.m(U,ie,we);throw(0,k.illegalArgument)()}m(U,ie,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,_e=U.start.character,at=U.end.character-U.start.character,lt=this.j.get(ie);let Ft=0;if(we)for(const Vt of we){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Ft|=1<<Gt>>>0}this.n(Ke,_e,at,lt,Ft)}n(U,ie,we,Ke,_e){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Ft;Xt++){let Yt=this.g[5*Xt],Pi=this.g[5*Xt+1];Yt===0?(Yt=Vt,Pi+=Gt):Yt+=Vt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pi,Vt=Yt,Gt=Pi}}let at=U,lt=ie;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=we,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=U,this.e=ie}static o(U){const ie=[],we=U.length/5|0;for(let lt=0;lt<we;lt++)ie[lt]=lt;ie.sort((lt,Ft)=>{const Vt=U[5*lt],Gt=U[5*Ft];if(Vt===Gt){const Xt=U[5*lt+1],Yt=U[5*Ft+1];return Xt-Yt}return Vt-Gt});const Ke=new Uint32Array(U.length);let _e=0,at=0;for(let lt=0;lt<we;lt++){const Ft=5*ie[lt],Vt=U[Ft+0],Gt=U[Ft+1],Xt=U[Ft+2],Yt=U[Ft+3],Pi=U[Ft+4],sn=Vt-_e,Rn=sn===0?Gt-at:Gt,Ai=5*lt;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=Xt,Ke[Ai+3]=Yt,Ke[Ai+4]=Pi,_e=Vt,at=Gt}return Ke}build(U){return this.f?new Ht(new Uint32Array(this.g),U):new Ht(Ne.o(this.g),U)}}e.SemanticTokensBuilder=Ne;class Ht{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Ht;class Fi{constructor(U,ie,we){this.start=U,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Fi;class gt{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Wt("arrow-left")},di=qe([T],di),e.QuickInputButtons=di;var Li;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Li=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,A.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,A.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Wt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,we){this.badge=U,this.tooltip=ie,this.color=we}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([T],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(ie<0)throw(0,k.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,we=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(we=U.end),ie===this.c&&we===this.e?this:new Kt(ie,we)}}e.NotebookRange=Kt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,we,Ke,_e,at,lt){this.kind=U,this.value=ie,this.languageId=we,this.mime=Ke,this.outputs=_e??[],this.metadata=at,this.executionSummary=lt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(U){this.cells=U}}e.NotebookData=Gi;class $t{static isNotebookCellOutputItem(U){return U instanceof $t?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return $t.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return $t.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return $t.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new $t(U,ie)}static text(U,ie=C.Mimes.text){const we=Oe($t,b,"f",w).encode(String(U));return new $t(we,ie)}static json(U,ie="text/x-json"){const we=JSON.stringify(U,void 0,"	");return $t.text(we,ie)}constructor(U,ie){this.data=U,this.mime=ie;const we=(0,C.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=$t,b=$t,w={value:new TextEncoder};class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const we=new Set,Ke=new Set;for(let _e=0;_e<U.length;_e++){const at=U[_e],lt=(0,C.normalizeMimeType)(at.mime);if(!we.has(lt)||(0,p.isTextStreamMime)(lt)){we.add(lt);continue}Ke.add(_e),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?U:U.filter((_e,at)=>!Ke.has(at))}constructor(U,ie,we){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,N.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=mi;var xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(fe=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fe{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=Fe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(U,ie=[]){this.uri=U,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=Rt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};Qi=qe([T],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Mi=class{constructor(U=void 0,ie=void 0,we=void 0){this.include=U,this.exclude=ie,this.profile=we}};Mi=qe([T],Mi),e.TestRunRequest=Mi;let Yi=class extends Mi{constructor(U=void 0,ie=void 0,we=void 0,Ke=!1){super(U,ie,we),this.continuous=Ke}};Yi=qe([T],Yi),e.TestRunRequest2=Yi;let _i=F=class{static diff(U,ie,we){const Ke=new F(U);return Ke.expectedOutput=ie,Ke.actualOutput=we,Ke}constructor(U){this.message=U}};_i=F=qe([T],_i),e.TestMessage=_i;let Ji=class{constructor(U){this.id=U}};Ji=qe([T],Ji),e.TestTag=Ji;let gi=class{constructor(U,ie){this.covered=U,this.total=ie}};gi=qe([T],gi),e.CoveredCount=gi;let Zi=$=class{static fromDetails(U,ie){const we=new gi(0,0),Ke=new gi(0,0),_e=new gi(0,0);for(const lt of ie)if("branches"in lt){we.total+=1,we.covered+=lt.executionCount>0?1:0;for(const Ft of lt.branches)Ke.total+=1,Ke.covered+=Ft.executionCount>0?1:0}else _e.total+=1,_e.covered+=lt.executionCount>0?1:0;const at=new $(U,we,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=ie,at}constructor(U,ie,we,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=Ke}};Zi=$=qe([T],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ie,we=[]){this.executionCount=U,this.location=ie,this.branches=we}};en=qe([T],en),e.StatementCoverage=en;let tn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};tn=qe([T],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};nn=qe([T],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,we,Ke,_e,at){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,we,Ke){this.base=U,this.input1=ie,this.input2=we,this.result=Ke}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,we){this.original=U,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(Ie[99],Ce([1,0,47,16,10,256,130,7,18]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const y=new Map;function N(f,s){s?y.set(f,s):y.delete(f)}e.setWordDefinitionFor=N;function E(f){return y.get(f)}class m extends M.MirrorTextModel{constructor(s,o,u,b,w,P,v,r){super(o,u,b,w),this.m=s,this.p=P,this.q=v,this.notebook=r,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,S.equals)(this.d,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.c},get fileName(){return s.c.fsPath},get isUntitled(){return s.c.scheme===k.Schemas.untitled},get languageId(){return s.p},get version(){return s.g},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return s.d.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,u){return s.y(o,u)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,n.ok)(!this.b),this.p=s}_acceptIsDirty(s){(0,n.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const u=this.f,b=o.start.line,w=o.end.line,P=[];P.push(this.d[b].substring(o.start.character));for(let v=b+1;v<w;v++)P.push(this.d[v]);return P.push(this.d[w].substring(0,o.end.character)),P.join(u)}t(s){let o;if(s instanceof A.Position?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.d[o],o===this.d.length-1)}u(s){return s=this.x(s),this.k(),this.h.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.k();const o=this.h.getIndexOf(s),u=this.d[o.index].length;return new A.Position(o.index,Math.min(o.remainder,u))}w(s){if(!(s instanceof A.Range))throw new Error("Invalid argument");const o=this.x(s.start),u=this.x(s.end);return o===s.start&&u===s.end?s:new A.Range(o.line,o.character,u.line,u.character)}x(s){if(!(s instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return s.with(0,0);let{line:o,character:u}=s,b=!1;if(o<0)o=0,u=0,b=!0;else if(o>=this.d.length)o=this.d.length-1,u=this.d[o].length,b=!0;else{const w=this.d[o].length;u<0?(u=0,b=!0):u>w&&(u=w,b=!0)}return b?new A.Position(o,u):s}y(s,o){const u=this.x(s);if(!o)o=E(this.p);else if((0,D.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(u.character+1,(0,C.ensureValidWordDefinition)(o),this.d[u.line],0);if(b)return new A.Range(u.line,b.startColumn-1,u.line,b.endColumn-1)}}e.ExtHostDocumentData=m;class p{constructor(s,o,u){this.a=s,this.b=o,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=p}),define(Ie[191],Ce([1,0,7,17,4]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let S;switch(A){case"light":S=n.ColorThemeKind.Light;break;case"hcDark":S=n.ColorThemeKind.HighContrast;break;case"hcLight":S=n.ColorThemeKind.HighContrastLight;break;default:S=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([je(0,k.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ie[8],Ce([1,0,18,23,115,192,86,28,112,66,64,22,9,2,56,76,91,96,95,71,43,55,187,7]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(De){function Pe(X){const{selectionStartLineNumber:Re,selectionStartColumn:Be,positionLineNumber:Qe,positionColumn:$e}=X,Ze=new h.Position(Re-1,Be-1),ct=new h.Position(Qe-1,$e-1);return new h.Selection(Ze,ct)}De.to=Pe;function me(X){const{anchor:Re,active:Be}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}De.from=me})(i=e.Selection||(e.Selection={}));var c;(function(De){function Pe(X){if(!X)return;const{start:Re,end:Be}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}De.from=Pe;function me(X){if(!X)return;const{startLineNumber:Re,startColumn:Be,endLineNumber:Qe,endColumn:$e}=X;return new h.Range(Re-1,Be-1,Qe-1,$e-1)}De.to=me})(c=e.Range||(e.Range={}));var t;(function(De){function Pe(me){switch(me){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}De.to=Pe})(t=e.TokenType||(e.TokenType={}));var d;(function(De){function Pe(X){return new h.Position(X.lineNumber-1,X.column-1)}De.to=Pe;function me(X){return{lineNumber:X.line+1,column:X.character+1}}De.from=me})(d=e.Position||(e.Position={}));var a;(function(De){function Pe(Re,Be){return(0,n.coalesce)((0,n.asArray)(Re).map(Qe=>me(Qe,Be)))}De.from=Pe;function me(Re,Be){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:X(Re.scheme,Be),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function X(Re,Be){return Be&&typeof Re=="string"?Be.transformOutgoingScheme(Re):Re}})(a=e.DocumentSelector||(e.DocumentSelector={}));var l;(function(De){function Pe(X){switch(X){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}De.from=Pe;function me(X){switch(X){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}De.to=me})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(De){function Pe(X){let Re;return X.code&&((0,m.isString)(X.code)||(0,m.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),{...c.from(X.range),message:X.message,source:X.source,code:Re,severity:O.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(R.from),tags:Array.isArray(X.tags)?(0,n.coalesce)(X.tags.map(l.from)):void 0}}De.from=Pe;function me(X){const Re=new h.Diagnostic(c.to(X),X.message,O.to(X.severity));return Re.source=X.source,Re.code=(0,m.isString)(X.code)?X.code:X.code?.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(R.to),Re.tags=X.tags&&(0,n.coalesce)(X.tags.map(l.to)),Re}De.to=me})(g=e.Diagnostic||(e.Diagnostic={}));var R;(function(De){function Pe(X){return{...c.from(X.location.range),message:X.message,resource:X.location.uri}}De.from=Pe;function me(X){return new h.DiagnosticRelatedInformation(new h.Location(X.resource,c.to(X)),X.message)}De.to=me})(R=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(De){function Pe(X){switch(X){case h.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}De.from=Pe;function me(X){switch(X){case o.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}De.to=me})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(De){function Pe(X){return typeof X=="number"&&X>=h.ViewColumn.One?X-1:X===h.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}De.from=Pe;function me(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=me})(q=e.ViewColumn||(e.ViewColumn={}));function Z(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!Z(De[0])}e.isDecorationOptionsArr=x;var F;(function(De){function Pe($e){return $e.map(De.from)}De.fromMany=Pe;function me($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function X($e){let Ze;if(me($e)){const{language:Et,value:It}=$e;Ze={value:"```"+Et+`
`+It+"\n```\n"}}else h.MarkdownString.isMarkdownString($e)?Ze={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml,baseUri:$e.baseUri}:typeof $e=="string"?Ze={value:$e}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=Et=>{try{let It=p.URI.parse(Et,!0);It=It.with({query:Re(It.query,ct)}),ct[Et]=It}catch{}return""},bt=new S.marked.Renderer;return bt.link=Tt,bt.image=Et=>typeof Et=="string"?Tt(C.parseHrefAndDimensions(Et).href):"",(0,S.marked)(Ze.value,{renderer:bt}),Ze}De.from=X;function Re($e,Ze){if(!$e)return $e;let ct;try{ct=(0,y.parse)($e)}catch{}if(!ct)return $e;let Tt=!1;return ct=(0,E.cloneAndChange)(ct,bt=>{if(p.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=bt,Tt=!0,Et}else return}),Tt?JSON.stringify(ct):$e}function Be($e){const Ze=new h.MarkdownString($e.value,$e.supportThemeIcons);return Ze.isTrusted=$e.isTrusted,Ze.supportHtml=$e.supportHtml,Ze.baseUri=$e.baseUri?p.URI.from($e.baseUri):void 0,Ze}De.to=Be;function Qe($e){if(!!$e)return typeof $e=="string"?$e:De.from($e)}De.fromStrict=Qe})(F=e.MarkdownString||(e.MarkdownString={}));function $(De){return x(De)?De.map(Pe=>({range:c.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?F.fromMany(Pe.hoverMessage):Pe.hoverMessage?F.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):De.map(Pe=>({range:c.from(Pe)}))}e.fromRangeOrRangeWithMessage=$;function T(De){return typeof De>"u"?De:typeof De=="string"?p.URI.file(De):De}e.pathOrURIToURI=T;var L;(function(De){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?T(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}De.from=Pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(De){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}De.from=Pe})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Pe(me){if(typeof me>"u")return me;switch(me){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Pe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?j.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?V.from(me.light):void 0,dark:me.dark?V.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}De.from=Pe})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(De){function Pe(X){return{text:X.newText,eol:X.newEol&&it.from(X.newEol),range:c.from(X.range)}}De.from=Pe;function me(X){const Re=new h.TextEdit(c.to(X.range),X.text);return Re.newEol=typeof X.eol>"u"?void 0:it.to(X.eol),Re}De.to=me})(_=e.TextEdit||(e.TextEdit={}));var pe;(function(De){function Pe(X,Re){const Be={edits:[]};if(X instanceof h.WorkspaceEdit){const Qe=new A.ResourceSet;for(const $e of X._allEntries())$e._type===1&&p.URI.isUri($e.to)&&$e.from===void 0&&Qe.add($e.to);for(const $e of X._allEntries())$e._type===1?Be.edits.push({oldResource:$e.from,newResource:$e.to,options:{...$e.options,contentsBase64:$e.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap($e.options.contents))},metadata:$e.metadata}):$e._type===2?Be.edits.push({resource:$e.uri,textEdit:_.from($e.edit),versionId:Qe.has($e.uri)?void 0:Re?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===6?Be.edits.push({resource:$e.uri,textEdit:{range:c.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:Qe.has($e.uri)?void 0:Re?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Be.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Be.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:Re?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(vt.from)}})}return Be}De.from=Pe;function me(X){const Re=new h.WorkspaceEdit;for(const Be of X.edits)Be.textEdit?Re.replace(p.URI.revive(Be.resource),c.to(Be.textEdit.range),Be.textEdit.text):Re.renameFile(p.URI.revive(Be.oldResource),p.URI.revive(Be.newResource),Be.options);return Re}De.to=me})(pe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(De){const Pe=Object.create(null);Pe[h.SymbolKind.File]=0,Pe[h.SymbolKind.Module]=1,Pe[h.SymbolKind.Namespace]=2,Pe[h.SymbolKind.Package]=3,Pe[h.SymbolKind.Class]=4,Pe[h.SymbolKind.Method]=5,Pe[h.SymbolKind.Property]=6,Pe[h.SymbolKind.Field]=7,Pe[h.SymbolKind.Constructor]=8,Pe[h.SymbolKind.Enum]=9,Pe[h.SymbolKind.Interface]=10,Pe[h.SymbolKind.Function]=11,Pe[h.SymbolKind.Variable]=12,Pe[h.SymbolKind.Constant]=13,Pe[h.SymbolKind.String]=14,Pe[h.SymbolKind.Number]=15,Pe[h.SymbolKind.Boolean]=16,Pe[h.SymbolKind.Array]=17,Pe[h.SymbolKind.Object]=18,Pe[h.SymbolKind.Key]=19,Pe[h.SymbolKind.Null]=20,Pe[h.SymbolKind.EnumMember]=21,Pe[h.SymbolKind.Struct]=22,Pe[h.SymbolKind.Event]=23,Pe[h.SymbolKind.Operator]=24,Pe[h.SymbolKind.TypeParameter]=25;function me(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}De.from=me;function X(Re){for(const Be in Pe)if(Pe[Be]===Re)return Number(Be);return h.SymbolKind.Property}De.to=X})(ue=e.SymbolKind||(e.SymbolKind={}));var de;(function(De){function Pe(X){switch(X){case h.SymbolTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return h.SymbolTag.Deprecated}}De.to=me})(de=e.SymbolTag||(e.SymbolTag={}));var re;(function(De){function Pe(X){return{name:X.name,kind:ue.from(X.kind),tags:X.tags&&X.tags.map(de.from),containerName:X.containerName,location:Ae.from(X.location)}}De.from=Pe;function me(X){const Re=new h.SymbolInformation(X.name,ue.to(X.kind),X.containerName,Ae.to(X.location));return Re.tags=X.tags&&X.tags.map(de.to),Re}De.to=me})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(De){function Pe(X){const Re={name:X.name||"!!MISSING: name!!",detail:X.detail,range:c.from(X.range),selectionRange:c.from(X.selectionRange),kind:ue.from(X.kind),tags:X.tags?.map(de.from)??[]};return X.children&&(Re.children=X.children.map(Pe)),Re}De.from=Pe;function me(X){const Re=new h.DocumentSymbol(X.name,X.detail,ue.to(X.kind),c.to(X.range),c.to(X.selectionRange));return(0,n.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(de.to)),X.children&&(Re.children=X.children.map(me)),Re}De.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(De){function Pe(X){const Re=new h.CallHierarchyItem(ue.to(X.kind),X.name,X.detail||"",p.URI.revive(X.uri),c.to(X.range),c.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Be){if(Re=Re??X._sessionId,Be=Be??X._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,name:X.name,detail:X.detail,kind:ue.from(X.kind),uri:X.uri,range:c.from(X.range),selectionRange:c.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(De){function Pe(me){return new h.CallHierarchyIncomingCall(H.to(me.from),me.fromRanges.map(X=>c.to(X)))}De.to=Pe})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(De){function Pe(me){return new h.CallHierarchyOutgoingCall(H.to(me.to),me.fromRanges.map(X=>c.to(X)))}De.to=Pe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(De){function Pe(X){return{range:X.range&&c.from(X.range),uri:X.uri}}De.from=Pe;function me(X){return new h.Location(p.URI.revive(X.uri),c.to(X.range))}De.to=me})(Ae=e.location||(e.location={}));var Ue;(function(De){function Pe(X){const Re=X,Be=X;return{originSelectionRange:Re.originSelectionRange?c.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Be.uri,range:c.from(Re.targetRange?Re.targetRange:Be.range),targetSelectionRange:Re.targetSelectionRange?c.from(Re.targetSelectionRange):void 0}}De.from=Pe;function me(X){return{targetUri:p.URI.revive(X.uri),targetRange:c.to(X.range),targetSelectionRange:X.targetSelectionRange?c.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?c.to(X.originSelectionRange):void 0}}De.to=me})(Ue=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(De){function Pe(X){return{range:c.from(X.range),contents:F.fromMany(X.contents)}}De.from=Pe;function me(X){return new h.Hover(X.contents.map(F.to),c.to(X.range))}De.to=me})(xe=e.Hover||(e.Hover={}));var Te;(function(De){function Pe(X){return{range:c.from(X.range),expression:X.expression}}De.from=Pe;function me(X){return new h.EvaluatableExpression(c.to(X.range),X.expression)}De.to=me})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Pe(X){if(X instanceof h.InlineValueText)return{type:"text",range:c.from(X.range),text:X.text};if(X instanceof h.InlineValueVariableLookup)return{type:"variable",range:c.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Pe;function me(X){switch(X.type){case"text":return{range:c.to(X.range),text:X.text};case"variable":return{range:c.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:c.to(X.range),expression:X.expression}}}De.to=me})(Se=e.InlineValue||(e.InlineValue={}));var ke;(function(De){function Pe(X){return{frameId:X.frameId,stoppedLocation:c.from(X.stoppedLocation)}}De.from=Pe;function me(X){return new h.InlineValueContext(X.frameId,c.to(X.stoppedLocation))}De.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(De){function Pe(X){return{range:c.from(X.range),kind:X.kind}}De.from=Pe;function me(X){return new h.DocumentHighlight(c.to(X.range),X.kind)}De.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Pe(me){switch(me){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}De.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(De){function Pe(me){return{triggerKind:ce.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}De.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var I;(function(De){function Pe(X){switch(X){case h.CompletionItemTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return h.CompletionItemTag.Deprecated}}De.to=me})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(De){const Pe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function me(Be){return Pe.get(Be)??9}De.from=me;const X=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Re(Be){return X.get(Be)??h.CompletionItemKind.Property}De.to=Re})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Pe(me,X){const Re=new h.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=B.to(me.kind),Re.tags=me.tags?.map(I.to),Re.detail=me.detail,Re.documentation=C.isMarkdownString(me.documentation)?F.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,f.Range.isIRange(me.range)?Re.range=c.to(me.range):typeof me.range=="object"&&(Re.range={inserting:c.to(me.range.insert),replacing:c.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new h.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof h.Range?new h.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Be=>_.to(Be))),Re.command=X&&me.command?X.fromInternal(me.command):void 0,Re}De.to=Pe})(W=e.CompletionItem||(e.CompletionItem={}));var K;(function(De){function Pe(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:F.fromStrict(X.documentation)}}De.from=Pe;function me(X){return{label:X.label,documentation:C.isMarkdownString(X.documentation)?F.to(X.documentation):X.documentation}}De.to=me})(K=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(De){function Pe(X){return{label:X.label,documentation:F.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(K.from):[],activeParameter:X.activeParameter}}De.from=Pe;function me(X){return{label:X.label,documentation:C.isMarkdownString(X.documentation)?F.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(K.to):[],activeParameter:X.activeParameter}}De.to=me})(ee=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(De){function Pe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ee.from):[]}}De.from=Pe;function me(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ee.to):[]}}De.to=me})(he=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Pe(me,X){const Re=new h.InlayHint(d.to(X.position),typeof X.label=="string"?X.label:X.label.map(ae.to.bind(void 0,me)),X.kind&&be.to(X.kind));return Re.textEdits=X.textEdits&&X.textEdits.map(_.to),Re.tooltip=C.isMarkdownString(X.tooltip)?F.to(X.tooltip):X.tooltip,Re.paddingLeft=X.paddingLeft,Re.paddingRight=X.paddingRight,Re}De.to=Pe})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Pe(me,X){const Re=new h.InlayHintLabelPart(X.label);return Re.tooltip=C.isMarkdownString(X.tooltip)?F.to(X.tooltip):X.tooltip,s.Command.is(X.command)&&(Re.command=me.fromInternal(X.command)),X.location&&(Re.location=Ae.to(X.location)),Re}De.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(De){function Pe(X){return X}De.from=Pe;function me(X){return X}De.to=me})(be=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Pe(X){return{range:c.from(X.range),url:X.target,tooltip:X.tooltip}}De.from=Pe;function me(X){let Re;if(X.url)try{Re=typeof X.url=="string"?p.URI.parse(X.url,!0):p.URI.revive(X.url)}catch{}return new h.DocumentLink(c.to(X.range),Re)}De.to=me})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Pe(X){const Re=new h.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=_.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Be=>_.to(Be))),Re}De.to=Pe;function me(X){return{label:X.label,textEdit:X.textEdit?_.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>_.from(Re)):void 0}}De.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(De){function Pe(X){return new h.Color(X[0],X[1],X[2],X[3])}De.to=Pe;function me(X){return[X.red,X.green,X.blue,X.alpha]}De.from=me})(He=e.Color||(e.Color={}));var tt;(function(De){function Pe(X){return{range:c.from(X.range)}}De.from=Pe;function me(X){return new h.SelectionRange(c.to(X.range))}De.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Pe(me){switch(me){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}De.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Pe(X){switch(X){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Pe;function me(X){switch(X){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}De.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Pe(X){if(X===h.EndOfLine.CRLF)return 1;if(X===h.EndOfLine.LF)return 0}De.from=Pe;function me(X){if(X===1)return h.EndOfLine.CRLF;if(X===0)return h.EndOfLine.LF}De.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(De){function Pe(me){const X={start:me.start+1,end:me.end+1};return me.kind&&(X.kind=ot.from(me.kind)),X}De.from=Pe})(Le=e.FoldingRange||(e.FoldingRange={}));var ot;(function(De){function Pe(me){if(me)switch(me){case h.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}De.from=Pe})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(De){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?c.from(me.selection):void 0,override:typeof me.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Pe})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(De){function Pe(Be){return Be instanceof h.RelativePattern?Be.toJSON():typeof Be=="string"?Be:me(Be)||X(Be)?new h.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}De.from=Pe;function me(Be){const Qe=Be;return Qe?p.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function X(Be){const Qe=Be;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Be){return typeof Be=="string"?Be:new h.RelativePattern(p.URI.revive(Be.baseUri),Be.pattern)}De.to=Re})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(De){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const X=me;return{language:X.language,scheme:X.scheme,pattern:Q.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}De.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Pe(X){return{start:X.start,end:X.end}}De.from=Pe;function me(X){return new h.NotebookRange(X.start,X.end)}De.to=me})(Me=e.NotebookRange||(e.NotebookRange={}));var ze;(function(De){function Pe(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}De.to=Pe;function me(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}De.from=me})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(De){function Pe(me){if(me===w.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(me===w.NotebookCellExecutionState.Pending)return;if(me===w.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}De.to=Pe})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(De){function Pe(X){switch(X){case h.NotebookCellKind.Markup:return w.CellKind.Markup;case h.NotebookCellKind.Code:default:return w.CellKind.Code}}De.from=Pe;function me(X){switch(X){case w.CellKind.Markup:return h.NotebookCellKind.Markup;case w.CellKind.Code:default:return h.NotebookCellKind.Code}}De.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Pe(X){const Re={metadata:X.metadata??Object.create(null),cells:[]};for(const Be of X.cells)h.NotebookCellData.validate(Be),Re.cells.push(vt.from(Be));return Re}De.from=Pe;function me(X){const Re=new h.NotebookData(X.cells.map(vt.to));return(0,m.isEmptyObject)(X.metadata)||(Re.metadata=X.metadata),Re}De.to=me})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(De){function Pe(X){return{cellKind:Ye.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:ze.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ct.from):[]}}De.from=Pe;function me(X){return new h.NotebookCellData(Ye.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ct.to):void 0,X.metadata,X.internalMetadata?ze.to(X.internalMetadata):void 0)}De.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(De){function Pe(X){return{mime:X.mime,valueBytes:k.VSBuffer.wrap(X.data)}}De.from=Pe;function me(X){return new h.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}De.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Pe(X){return{outputId:X.id,items:X.items.map(wt.from),metadata:X.metadata}}De.from=Pe;function me(X){const Re=X.items.map(wt.to);return new h.NotebookCellOutput(Re,X.outputId,X.metadata)}De.to=me})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var jt;(function(De){function Pe(Re){return X(Re)?{include:(0,m.withNullAsUndefined)(Q.from(Re.include)),exclude:(0,m.withNullAsUndefined)(Q.from(Re.exclude))}:(0,m.withNullAsUndefined)(Q.from(Re))}De.from=Pe;function me(Re){return X(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}De.to=me;function X(Re){const Be=Re;return Be?!(0,m.isUndefinedOrNull)(Be.include)&&!(0,m.isUndefinedOrNull)(Be.exclude):!1}})(jt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(De){function Pe(me,X,Re){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Be,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}De.from=Pe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(De){function Pe(me,X,Re){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:X.toInternal(Be,Re),label:me.label,description:me.description,detail:me.detail}}De.from=Pe})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Lt;(function(De){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}De.from=Pe})(Lt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var xt;(function(De){function Pe(X){return{uri:X.uri,provides:X.provides}}De.from=Pe;function me(X){return new h.NotebookRendererScript(p.URI.revive(X.uri),X.provides)}De.to=me})(xt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(De){function Pe(X){return{message:F.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:c.from(X.location.range),uri:X.location.uri}}}De.from=Pe;function me(X){const Re=new h.TestMessage(typeof X.message=="string"?X.message:F.to(X.message));return Re.actualOutput=X.actual,Re.expectedOutput=X.expected,Re.location=X.location?Ae.to(X.location):void 0,Re}De.to=me})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(De){De.namespace=v.namespaceTestTag,De.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(De){function Pe(X){const Re=(0,u.getPrivateApiFor)(X).controllerId;return{extId:P.TestId.fromExtHostTestItem(X,Re).toString(),label:X.label,uri:p.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Be=>ht.namespace(Re,Be.id)),range:f.Range.lift(c.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&F.fromStrict(X.error)||null}}De.from=Pe;function me(X){return{parent:void 0,error:void 0,id:P.TestId.fromString(X.extId).localId,label:X.label,uri:p.URI.revive(X.uri),tags:(X.tags||[]).map(Re=>{const{tagId:Be}=ht.denamespace(Re);return new h.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}De.toPlain=me})(kt=e.TestItem||(e.TestItem={})),function(De){function Pe(X){return{id:X.id}}De.from=Pe;function me(X){return new h.TestTag(X.id)}De.to=me}(ht=e.TestTag||(e.TestTag={}));var Bt;(function(De){const Pe=(X,Re)=>{const Be=[];for(const[$e,Ze]of Re)P.TestId.compare(Ze.item.extId,$e)===2&&(Re.delete($e),Be.push(Ze));const Qe={...kt.toPlain(X.item),parent:void 0,taskStates:X.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Ze=>Ze.type===0).map(Pt.to)})),children:Be.map($e=>Pe($e,Re))};for(const $e of Qe.children)$e.parent=Qe;return Qe};function me(X){const Re=[],Be=new Map;for(const Qe of X.items){Be.set(Qe.item.extId,Qe);const $e=P.TestId.root(Qe.item.extId);X.request.targets.some(Ze=>Ze.controllerId===$e&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:X.completedAt,results:Re.map(Qe=>Pe(Qe,Be))}}De.to=me})(Bt=e.TestResults||(e.TestResults={}));var Ot;(function(De){function Pe(Be){return{covered:Be.covered,total:Be.covered}}function me(Be){return"line"in Be?d.from(Be):c.from(Be)}function X(Be){return"branches"in Be?{count:Be.executionCount,location:me(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Be.executionCount,location:me(Be.location)}}De.fromDetailed=X;function Re(Be){return{uri:Be.uri,statement:Pe(Be.statementCoverage),branch:Be.branchCoverage&&Pe(Be.branchCoverage),function:Be.functionCoverage&&Pe(Be.functionCoverage),details:Be.detailedCoverage?.map(X)}}De.fromFile=Re})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(De){function Pe(me){switch(me){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}De.to=Pe})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(De){function Pe(X){const Re=new h.TypeHierarchyItem(ue.to(X.kind),X.name,X.detail||"",p.URI.revive(X.uri),c.to(X.range),c.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Be){if(Re=Re??X._sessionId,Be=Be??X._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,kind:ue.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:c.from(X.range),selectionRange:c.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Nt;(function(De){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}De.from=Pe})(Nt=e.ViewBadge||(e.ViewBadge={}));var zt;(function(De){function Pe(Be,Qe,$e){const Ze=Qe.fileData;return Ze?new class extends h.DataTransferItem{asFile(){return{name:Ze.name,uri:p.URI.revive(Ze.uri),data:(0,M.once)(()=>$e())}}}("",Qe.id):Be===N.Mimes.uriList&&Qe.uriListData?new h.DataTransferItem(Re(Qe.uriListData)):new h.DataTransferItem(Qe.asString)}De.to=Pe;async function me(Be,Qe){const $e=await Qe.asString();if(Be===N.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:X($e)};const Ze=Qe.asFile();return{id:Qe.id,asString:$e,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=me;function X(Be){return D.UriList.split(Be).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return p.URI.parse(Qe)}catch{}return Qe})}function Re(Be){return D.UriList.create(Be.map(Qe=>typeof Qe=="string"?Qe:p.URI.revive(Qe)))}})(zt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(De){function Pe(X,Re){const Be=X.items.map(([Qe,$e])=>[Qe,zt.to(Qe,$e,()=>Re($e.id))]);return new h.DataTransfer(Be)}De.toDataTransfer=Pe;async function me(X){const Re={items:[]},Be=[];return X.forEach((Qe,$e)=>{Be.push((async()=>{Re.items.push([$e,await zt.from($e,Qe)])})())}),await Promise.all(Be),Re}De.toDataTransferDTO=me})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[193],Ce([1,0,2,11,7,8,159]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(y,N,E,m={timeout:1500,errors:3}){this.c=y,this.d=N,this.f=E,this.g=m,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(N,E,m)=>{const f={dispose:this.a.push([N,E,y])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(y,N){const E=n.URI.revive(y);let m=!1;const p=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const s of[...this.a]){if(m)break;const o=this.d.getDocument(E),u=await this.h(s,{document:o,reason:M.TextDocumentSaveReason.to(N)});f.push(u)}}finally{clearTimeout(p)}return f}h([y,N,E],m){const p=this.b.get(y);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(E,y,N,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const s=this.b.get(y);this.b.set(y,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,N,E,m){const p=[],f=Date.now(),{document:s,reason:o}=m,{version:u}=s,b=Object.freeze({document:s,reason:o,waitUntil(w){if(Object.isFrozen(p))throw(0,k.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(w))}});try{N.apply(E,[b])}catch(w){return Promise.reject(w)}return Object.freeze(p),new Promise((w,P)=>{const v=setTimeout(()=>P(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(v),w(r)}).catch(r=>{clearTimeout(v),P(r)})}).then(w=>{const P={edits:[]};for(const v of w)if(Array.isArray(v)&&v.every(r=>r instanceof D.TextEdit))for(const{newText:r,newEol:h,range:i}of v)P.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:i&&M.Range.from(i),text:r,eol:h&&M.EndOfLine.from(h)}});if(P.edits.length!==0)return u===s.version?this.f.$tryApplyWorkspaceEdit(P):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ie[194],Ce([1,0,16,2,8,7,71]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(E,m,p,f){this.start=E,this.deletedCount=m,this.deletedItems=p,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(E,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,m,p){this.notebook=E,this.h=m,this.j=p,this.handle=p.handle,this.uri=k.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(D.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return E.g},set mime(f){E.g=f},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(p)}return this.f}setOutputs(E){this.a=E.map(D.NotebookCellOutput.to)}setOutputItems(E,m,p){const f=p.map(D.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===E);if(s&&(m||(s.items.length=0),s.items.push(...f),s.items.length>1&&s.items.every(o=>C.isTextStreamMime(o.mime)))){const o=new Map,u=[];s.items.forEach(b=>{let w;o.has(b.mime)?w=o.get(b.mime):(w=[],o.set(b.mime,w),u.push(b.mime)),w.push(b.data)}),s.items.length=0,u.forEach(b=>{const w=C.compressOutputItemStreams(o.get(b));s.items.push({mime:b,data:w.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=S;class y{constructor(E,m,p,f,s){this.k=E,this.l=m,this.m=p,this.uri=f,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const E=this,m={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===n.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(p){return p=E.n(p),E.b[p].apiCell},getCells(p){return(p?E.p(p):E.b).map(s=>s.apiCell)},save(){return E.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,m,p){this.g=E.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:p});const f={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},s=[];for(const u of E.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,f.contentChanges):u.kind===C.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,f.contentChanges):u.kind===C.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),s.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),s.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),s.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===C.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),s.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),s.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const o=new Map;for(let u=0;u<s.length;u++){const b=s[u],w=o.get(b.cell);if(w===void 0){const P=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});o.set(b.cell,P-1)}else f.cellChanges[w]={...f.cellChanges[w],...b}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let m=E.start|0,p=E.end|0;return m<0&&(m=0),p>this.b.length&&(p=this.b.length),E.with({start:m,end:p})}p(E){E=this.o(E);const m=[];for(let p=E.start;p<E.end;p++)m.push(this.b[p]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,m,p){if(this.j)return;const f=[],s=[],o=[];if(E.reverse().forEach(u=>{const w=u[2].map(r=>{const h=new S(this,this.l,r);return m||s.push(S.asModelAddData(this.apiNotebook,r)),h}),P=new A(u[0],u[1],[],w),v=this.b.splice(u[0],u[1],...w);for(const r of v)o.push(r.uri),P.deletedItems.push(r.apiCell);f.push(P)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),p)for(const u of f)p.push(u.asApiEvent())}s(E,m,p,f){const s=this.b.splice(E,m);this.b.splice(p,0,...s);const o=[new A(E,m,s.map(u=>u.apiCell),[]),new A(p,0,[],s)];for(const u of o)f.push(u.asApiEvent())}t(E,m){this.b[E].setOutputs(m)}u(E,m,p,f){this.b[E].setOutputItems(m,p,f)}v(E,m){const p=this.b[E];p.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(p.uri,m)}w(E,m){const p=this.b[E];p.apiCell.mime=m}x(E,m){this.b[E].setMetadata(m)}y(E,m){this.b[E].setInternalMetadata(m)}getCellFromApiCell(E){return this.b.find(m=>m.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(m=>m.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.ExtHostNotebookDocument=y,y.a=0}),define(Ie[100],Ce([1,0,11,8,7]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,S,y,N,E,m){this.id=A,this.f=S,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=N,this.c=m}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(S){this.selections=[S]},get selections(){return A.a},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");A.a=S,A.g(S)},get visibleRanges(){return A.b},revealRange(S,y){A.f.$tryRevealRange(A.id,k.NotebookRange.from(S),y??D.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(k.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ie[195],Ce([1,0,4,13,8]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,S){this.c=A,this.d=S,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,S);const y=this.d.getEditorById(A);S.visibleRanges&&y._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&y._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const S in A)this.d.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(A[S]))}};M=qe([je(0,k.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ie[196],Ce([1,0,8,162,140,21,63,11]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,p,f){const s=this.b++,{title:o,location:u,cancellable:b}=p,w={label:(0,D.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(s,{location:n.ProgressLocation.from(u),title:o,source:w,cancellable:b},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this.d(s,f,!!b)}d(m,p,f){let s;f&&(s=new M.CancellationTokenSource,this.c.set(m,s));const o=b=>{this.a.$progressEnd(b),this.c.delete(b),s?.dispose()};let u;try{u=p(new N(this.a,m),f&&s?s.token:M.CancellationToken.None)}catch(b){throw o(m),b}return u.then(b=>o(m),b=>o(m)),u}$acceptProgressCanceled(m){const p=this.c.get(m);p&&(p.cancel(),this.c.delete(m))}}e.ExtHostProgress=S;function y(E,m){return E.message=m.message,typeof m.increment=="number"&&(typeof E.increment=="number"?E.increment+=m.increment:E.increment=m.increment),E}class N extends k.Progress{constructor(m,p){super(f=>this.throttledReport(f)),this.c=m,this.d=p}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,C.throttle)(100,(E,m)=>y(E,m),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ie[101],Ce([1,0,56,96,43,72,55,8,2]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(w,P,v,r)=>{let h=P;return{enumerable:!0,configurable:!1,get(){return h},set(i){if(!v(h,i)){const c=h;h=i,w.listener?.(r(i,c))}}}},N=(w,P)=>w===P,E={range:(w,P)=>w===P?!0:!w||!P?!1:w.isEqual(P),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(w,P)=>!(w.length!==P.length||w.some(v=>!P.find(r=>v.id===r.id)))},m=w=>P=>({op:4,update:w(P)}),p=(w,P)=>({range:(()=>{let v;const r=m(h=>({range:n.Range.lift(A.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return v},set(h){w.listener?.({op:6}),E.range(v,h)||(v=h,w.listener?.(r(h)))}}})(),label:y(w,P,E.label,m(v=>({label:v}))),description:y(w,void 0,E.description,m(v=>({description:v}))),sortText:y(w,void 0,E.sortText,m(v=>({sortText:v}))),canResolveChildren:y(w,!1,E.canResolveChildren,v=>({op:2,state:v})),busy:y(w,!1,E.busy,m(v=>({busy:v}))),error:y(w,void 0,E.error,m(v=>({error:A.MarkdownString.fromStrict(v)||null}))),tags:y(w,[],E.tags,(v,r)=>({op:1,new:v.map(A.TestTag.from),old:r.map(A.TestTag.from)}))}),f=w=>{const P=D.TestId.fromString(w.extId),v=new o(P.controllerId,P.localId,w.label,S.URI.revive(w.uri)||void 0);return v.range=A.Range.to(w.range||void 0),v.description=w.description||void 0,v.sortText=w.sortText||void 0,v.tags=w.tags.map(r=>A.TestTag.to({id:(0,C.denamespaceTestTag)(r).tagId})),v},s=w=>{let P;for(const v of w.tests){const r=f(v.item);(0,k.getPrivateApiFor)(r).parent=P,P=r}return P};e.toItemFromContext=s;class o{constructor(P,v,r,h){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const i=(0,k.createPrivateApiFor)(this,P);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof u?void 0:i.parent}},children:{value:(0,M.createTestItemChildren)(i,k.getPrivateApiFor,o),enumerable:!0,writable:!1},...p(i,r)})}}e.TestItemImpl=o;class u extends o{constructor(P,v){super(P,P,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class b extends M.TestItemCollection{constructor(P,v,r){super({controllerId:P,getDocumentVersion:h=>h&&r.getDocument(h)?.version,getApiFor:k.getPrivateApiFor,getChildren:h=>h.children,root:new u(P,v),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(Ie[102],Ce([1,0,47,11,84,8,7]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(m,p,f){const s=A.c.nextId();m.$registerTextEditorDecorationType(p.identifier,s,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){m.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=A,A.c=new D.IdGenerator("TextEditorDecorationType");class S{constructor(m,p){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,p){this.k();let f=null;if(m instanceof C.Position)f=new C.Range(m,m);else if(m instanceof C.Range)f=m;else throw new Error("Unrecognized location");this.l(f,p,!1)}insert(m,p){this.k(),this.l(new C.Range(m,m),p,!0)}delete(m){this.k();let p=null;if(m instanceof C.Range)p=m;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(m,p,f){const s=this.c.validateRange(m);this.g.push({range:s,text:p,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==C.EndOfLine.LF&&m!==C.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this.h=m}}class y{constructor(m,p,f,s){this.c=m,this.d=p,this._accept(f),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(u){o.m(u)},get indentSize(){return o.g},set indentSize(u){o.o(u)},get insertSpaces(){return o.h},set insertSpaces(u){o.q(u)},get cursorStyle(){return o.j},set cursorStyle(u){o.s(u)},get lineNumbers(){return o.k},set lineNumbers(u){o.t(u)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}m(m){const p=this.l(m);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}o(m){const p=this.n(m);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const p=this.p(m);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const p={};let f=!1;if(typeof m.tabSize<"u"){const s=this.l(m.tabSize);s==="auto"?(f=!0,p.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,f=!0,p.tabSize=s)}if(typeof m.indentSize<"u"){const s=this.n(m.indentSize);s==="tabSize"?(f=!0,p.indentSize=s):typeof s=="number"&&this.g!==s&&(this.g=s,f=!0,p.indentSize=s)}if(typeof m.insertSpaces<"u"){const s=this.p(m.insertSpaces);s==="auto"?(f=!0,p.insertSpaces=s):this.h!==s&&(this.h=s,f=!0,p.insertSpaces=s)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,p.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(m,p){p.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=y;class N{constructor(m,p,f,s,o,u,b,w){this.id=m,this.j=p,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new y(this.j,this.id,u,f),this.e=b,this.f=w;const P=this;this.value=Object.freeze({get document(){return s.value},set document(v){throw(0,k.readonly)("document")},get selection(){return P.c&&P.c[0]},set selection(v){if(!(v instanceof C.Selection))throw(0,k.illegalArgument)("selection");P.c=[v],P.l()},get selections(){return P.c},set selections(v){if(!Array.isArray(v)||v.some(r=>!(r instanceof C.Selection)))throw(0,k.illegalArgument)("selections");P.c=v,P.l()},get visibleRanges(){return P.e},set visibleRanges(v){throw(0,k.readonly)("visibleRanges")},get options(){return P.d.value},set options(v){P.g||P.d.assign(v)},get viewColumn(){return P.f},set viewColumn(v){throw(0,k.readonly)("viewColumn")},edit(v,r={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new S(s.value,r);return v(h),P.m(h)},insertSnippet(v,r,h={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=P.c.map(c=>M.Range.from(c));else if(r instanceof C.Position){const{lineNumber:c,column:t}=M.Position.from(r);i=[{startLineNumber:c,startColumn:t,endLineNumber:c,endColumn:t}]}else if(r instanceof C.Range)i=[M.Range.from(r)];else{i=[];for(const c of r)if(c instanceof C.Range)i.push(M.Range.from(c));else{const{lineNumber:t,column:d}=M.Position.from(c);i.push({startLineNumber:t,startColumn:d,endLineNumber:t,endColumn:d})}}return p.$tryInsertSnippet(m,s.value.version,v.value,i,h)},setDecorations(v,r){const h=r.length===0;h&&!P.h.has(v.key)||(h?P.h.delete(v.key):P.h.add(v.key),P.n(()=>{if(M.isDecorationOptionsArr(r))return p.$trySetDecorations(m,v.key,M.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let c=0,t=r.length;c<t;c++){const d=r[c];i[4*c]=d.start.line+1,i[4*c+1]=d.start.character+1,i[4*c+2]=d.end.line+1,i[4*c+3]=d.end.character+1}return p.$trySetDecorationsFast(m,v.key,i)}}))},revealRange(v,r){P.n(()=>p.$tryRevealRange(m,M.Range.from(v),r||C.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(m,M.ViewColumn.from(v))},hide(){p.$tryHideEditor(m)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,n.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,n.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,n.ok)(!this.g),this.f=m}_acceptSelections(m){(0,n.ok)(!this.g),this.c=m}async l(){const m=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const p=m.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const f=p.edits.map(o=>o.range);f.sort((o,u)=>o.end.line===u.end.line?o.end.character===u.end.character?o.start.line===u.start.line?o.start.character-u.start.character:o.start.line-u.start.line:o.end.character-u.end.character:o.end.line-u.end.line);for(let o=0,u=f.length-1;o<u;o++){const b=f[o].end;if(f[o+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=p.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,s,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.ExtHostTextEditor=N}),define(Ie[197],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[198],Ce([1,0,152,11,30,90,69,29,25,197,161,154]),function(te,e,n,k,D,M,C,A,S,y,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=A.Registry.as(C.Extensions.JSONContribution);class p{constructor(v,r,h){this.a=v,this.b=r,this.c=h}d(v,r){this.a({type:v,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=p;class f{static a(v){const r=new Set;for(let h=0,i=v.length;h<i;h++)r.add(S.ExtensionIdentifier.toKey(v[h].description.identifier));return r}static compute(v,r){if(!v||!v.length)return new f(r,[]);if(!r||!r.length)return new f([],v);const h=this.a(v),i=this.a(r),c=r.filter(d=>!h.has(S.ExtensionIdentifier.toKey(d.description.identifier))),t=v.filter(d=>!i.has(S.ExtensionIdentifier.toKey(d.description.identifier)));return new f(c,t)}constructor(v,r){this.added=v,this.removed=r}}e.ExtensionPointUserDelta=f;class s{constructor(v,r){this.name=v,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=f.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,k.onUnexpectedError)(v)}}}e.ExtensionPoint=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const r=new s(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,r),v.activationEventsGenerator&&E.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,m.registerSchema(u,e.schema),r}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const w={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(w.ExtensionsRegistry,new b),e.ExtensionsRegistry=A.Registry.as(w.ExtensionsRegistry),m.registerSchema(u,e.schema),m.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Ie[199],Ce([1,0,149,9,22,198,42,4]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var y;(function(m){function p(f,s,o){if(!f)return;const u=k.isString(f.type)?f.type:void 0;if(!u||u.length===0){o.error(n.localize(3,null));return}const b=[];if(Array.isArray(f.required))for(const w of f.required)k.isString(w)&&b.push(w);return{extensionId:s.value,taskType:u,required:b,properties:f.properties?D.deepClone(f.properties):{},when:f.when?C.ContextKeyExpr.deserialize(f.when):void 0}}m.from=p})(y||(y={}));const N=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:S}});class E{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,f)=>{N.setHandler((s,o)=>{this.c=void 0;try{for(const u of o.removed){const b=u.value;for(const w of b)this.a&&w.type&&this.a[w.type]&&delete this.a[w.type]}for(const u of o.added){const b=u.value;for(const w of b){const P=y.from(w,u.description.identifier,u.collector);P&&(this.a[P.taskType]=P)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const f of this.all()){const s={type:"object",additionalProperties:!1};f.required.length>0&&(s.required=f.required.slice(0)),f.properties!==void 0?s.properties=D.deepClone(f.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[f.taskType]},p.push(s)}this.c={oneOf:p}}return this.c}}e.TaskDefinitionRegistry=new E}),define(Ie[200],Ce([1,0,150,9,24,22,42,199]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var S;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(T){function L(V){if(!V)return T.Strong;switch(V.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=L}(S=e.ShellQuoting||(e.ShellQuoting={}));var y;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(y=e.CommandOptions||(e.CommandOptions={}));var N;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(T){function L(V){switch(V.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=L}(N=e.RevealKind||(e.RevealKind={}));var E;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(E=e.RevealProblemKind||(e.RevealProblemKind={})),function(T){function L(V){switch(V.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=L}(E=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(T){function L(V){switch(V.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=L}(m=e.PanelKind||(e.PanelKind={}));var p;(function(T){T.defaults={echo:!0,reveal:N.Always,revealProblems:E.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(p=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(T){function L(j){switch(j.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=L;function V(j){switch(j){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=V}(f=e.RuntimeType||(e.RuntimeType={}));var s;(function(T){function L(V){return k.isString(V)?V:V.value}T.value=L})(s=e.CommandString||(e.CommandString={}));var o;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function L(j){return j===T.Clean._id||j===T.Build._id||j===T.Rebuild._id||j===T.Test._id}T.is=L;function V(j){if(j!==void 0)return k.isString(j)?L(j)?{_id:j,isDefault:!1}:void 0:j}T.from=V})(o=e.TaskGroup||(e.TaskGroup={}));var u;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var b;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function L(V){switch(V){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=L})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(T){T.parallel="parallel",T.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var P;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(P=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:P.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class r{constructor(L,V,j,le,_,pe){this._label="",this._id=L,V&&(this._label=V),j&&(this.type=j),this.runOptions=le,this.configurationProperties=_,this._source=pe}getDefinition(L){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,V=!1){if(L===void 0)return!1;if(k.isString(L))return L===this._label||L===this.configurationProperties.identifier||V&&L===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.CommonTask=r;class h extends r{constructor(L,V,j,le,_,pe,ue,de){super(L,j,void 0,ue,de,V),this.command={},this._source=V,this.hasDefinedMatchers=pe,_&&(this.command=_)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case f.Shell:V="shell";break;case f.Process:V="process";break;case f.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(L){return L instanceof h}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const L=this.d();if(!L)return;let V=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:L,id:V};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new h(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.CustomTask=h;class i extends r{constructor(L,V,j,le,_,pe,ue){super(L,j,le,pe,ue,V),this._source=V,this.configures=_}static is(L){return L instanceof i}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const L=this.d();if(!L)return;let V=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:L,id:V};return JSON.stringify(j)}}e.ConfiguringTask=i;class c extends r{constructor(L,V,j,le,_,pe,ue,de,re){super(L,j,le,de,re,V),this.defines=_,this.hasDefinedMatchers=ue,this.command=pe,this.icon=re.icon,this.hide=re.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof c}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new c(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.ContributedTask=c;class t extends r{constructor(L,V,j,le,_,pe){super(L,j,le,_,pe,V),this._source=V}clone(){return new t(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof t}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new t(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.InMemoryTask=t;var d;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(T){T._default=T.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var a;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(a=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(L){this.c=new Map;for(let V=0;V<L.length;V++)this.c.set(L[V].uri.toString(),V)}compare(L,V){const j=L.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(j&&le){let _=this.c.get(j.uri.toString());_=_===void 0?0:_+1;let pe=this.c.get(le.uri.toString());return pe=pe===void 0?0:pe+1,_===pe?L._label.localeCompare(V._label):_-pe}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=l;var g;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var R;(function(T){T.SingleRun="singleRun",T.Background="background"})(R=e.TaskRunType||(e.TaskRunType={}));var O;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(O=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(T){function L(V,j,le,_){if(j){const pe={kind:V,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return V==="start"?pe.resolvedVariables=_:V==="processStarted"?pe.processId=_:V==="processEnded"&&(pe.exitCode=_),Object.freeze(pe)}else return Object.freeze({kind:"changed"})}T.create=L})(q=e.TaskEvent||(e.TaskEvent={}));var Z;(function(T){function L(j){const le=Object.keys(j).sort();let _="";for(const pe of le){let ue=j[pe];ue instanceof Object?ue=L(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),_+=pe+","+ue+","}return _}function V(j){const _={_key:L(j),type:j.taskType};return Object.assign(_,j),_}T.create=V})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(T){function L(V,j){const le=A.TaskDefinitionRegistry.get(V.type);if(le===void 0){const de=M.deepClone(V);return delete de._key,Z.create(de)}const _=Object.create(null);_.type=le.taskType;const pe=new Set;le.required.forEach(de=>pe.add(de));const ue=le.properties;for(const de of Object.keys(ue)){const re=V[de];if(re!=null)_[de]=re;else if(pe.has(de)){const G=ue[de];if(G.default!==void 0)_[de]=M.deepClone(G.default);else switch(G.type){case"boolean":_[de]=!1;break;case"number":case"integer":_[de]=0;break;case"string":_[de]="";break;default:j.error(n.localize(2,null,JSON.stringify(V,void 0,0),de));return}}}return Z.create(_)}T.createTaskIdentifier=L})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[201],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,A)=>{this.b=C,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,n.onUnexpectedError)(C))}then(C,A){return this.j().then(C,A)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=k;class D extends k{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=D}),define(Ie[44],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const k=[];function D(A){const S=new n(A);return k[S.nid]=S,S}e.createProxyIdentifier=D;function M(A){return k[A].sid}e.getStringIdentifierForProxy=M;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ie[5],Ce([1,0,44]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var M;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(o){return o._id=E.a++,o}}e.IdObject=E,E.a=0;var m;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[77],Ce([1,0,3,13,5,17]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,y){this.c=y,this.a=new Set,this.b=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,y,N){const E=this.d(S,y);this.a.has(E)||(this.a.add(E),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}d(S,y){return`${S}-${y.identifier.value}`}};C=qe([je(0,M.IExtHostRpcService),je(1,k.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(A,S,y){}})}),define(Ie[202],Ce([1,0,4,5,7,25]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,y,N,E={}){const m=M.ExtensionIdentifier.toKey(S.identifier),p=this.f.get(m)||[],f=[...N].sort().join(" ");let s=p.find(o=>o.providerId===y&&o.scopes===f);if(s)return s.result;{const o=this.g(S,m,y,N,E);s={providerId:y,scopes:f,result:o},p.push(s),this.f.set(m,p);try{await o}finally{const u=p.findIndex(b=>b.providerId===y&&b.scopes===f);u>-1&&(p.splice(u),this.f.set(m,p))}return o}}async g(S,y,N,E,m={}){await this.a.$ensureProvider(N);const p=S.displayName||S.name;return this.a.$getSession(N,E,y,p,m)}async removeSession(S,y){const N=this.b.get(S);return N?N.provider.removeSession(y):this.a.$removeSession(S,y)}registerAuthenticationProvider(S,y,N,E){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:y,provider:N,options:E??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===S)||this.c.push({id:S,label:y});const m=N.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(S,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(S,y,E?.supportsMultipleAccounts??!1),new D.Disposable(()=>{m.dispose(),this.b.delete(S);const p=this.c.findIndex(f=>f.id===S);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this.d.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[203],Ce([1,0,5,17,8]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,S){this.a=A.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>S.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,S,y){const N=D.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,y?.isRefactoring??!1)}};M=qe([je(0,k.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ie[204],Ce([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(M){const C=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(A){return C.$writeText(A)}})}}e.ExtHostClipboard=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[38],Ce([1,0,9,7,8,22,5,18,13,66,56,257,2,6,3,17,101,23,44,39,78,50]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v){"use strict";var r,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(g,R){r.set(this,void 0),this.b=new Map,this.c=new Map,h.set(this,void 0),Je(this,r,g.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=R,Je(this,h,g.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,O=>{const q=this.c.get(O);return q?.result===d.Void?q:void 0},R),this.f=[{processArgument(O){return(0,y.revive)(O)}},{processArgument(O){return(0,M.cloneAndChange)(O,function(q){if(N.Range.isIRange(q))return D.Range.to(q);if(E.Position.isIPosition(q))return D.Position.to(q);if(N.Range.isIRange(q.range)&&m.URI.isUri(q.uri))return D.location.to(q);if(q instanceof u.VSBuffer)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const R=this.registerCommand(!1,g.id,async(...O)=>{const q=g.args.map((x,F)=>{if(!x.validate(O[F]))throw new Error(`Invalid argument '${x.name}' when running '${g.id}', received: ${O[F]}`);return x.convert(O[F])}),Z=await this.executeCommand(g.internalId,...q);return g.result.convert(Z,O,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new k.Disposable(()=>{R.dispose(),this.c.delete(g.id)})}registerCommand(g,R,O,q,Z,x){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:O,thisArg:q,description:Z,extension:x}),g&&Oe(this,r,"f").$registerCommand(R),new k.Disposable(()=>{this.b.delete(R)&&g&&Oe(this,r,"f").$unregisterCommand(R)})}executeCommand(g,...R){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,R,!0)}async g(g,R,O){if(this.b.has(g))return Oe(this,r,"f").$fireCommandActivationEvent(g),this.h(g,R,!1);{let q=!1;const Z=(0,M.cloneAndChange)(R,function(x){if(x instanceof k.Position)return D.Position.from(x);if(x instanceof k.Range)return D.Range.from(x);if(x instanceof k.Location)return D.location.from(x);if(k.NotebookRange.isNotebookRange(x))return D.NotebookRange.from(x);if(x instanceof ArrayBuffer)return q=!0,u.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return q=!0,u.VSBuffer.wrap(x);if(x instanceof u.VSBuffer)return q=!0,x;if(!Array.isArray(x))return x});try{const x=await Oe(this,r,"f").$executeCommand(g,q?new b.SerializableObjectWithBuffers(Z):Z,O);return(0,y.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(g,R,!1);throw x}}}async h(g,R,O){const q=this.b.get(g);if(!q)throw new Error("Unknown command");const{callback:Z,thisArg:x,description:F}=q;if(F)for(let T=0;T<F.args.length;T++)try{(0,n.validateConstraint)(R[T],F.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${F.args[T].name}' - ${F.args[T].description}`)}const $=P.StopWatch.create();try{return await Z.apply(x,R)}catch(T){if(g===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...R);L&&(g=L.command)}throw this.d.error(T,g,q.extension?.identifier),O?new class extends Error{constructor(){super((0,w.toErrorMessage)(T)),this.id=g,this.source=q.extension?.displayName??q.extension?.name}}:T}finally{this.j(q,g,$.elapsed())}}j(g,R,O){!g.extension||Oe(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new v.TelemetryTrustedValue(R),duration:O})}$executeContributedCommand(g,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const O=this.b.get(g);return O?(R=R.map(q=>this.f.reduce((Z,x)=>x.processArgument(Z,O.extension?.identifier),q)),this.h(g,R,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Oe(this,r,"f").$getCommands().then(R=>(g&&(R=R.filter(O=>O[0]!=="_")),R))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[R,O]of this.b){const{description:q}=O;q&&(g[R]=q)}return Promise.resolve(g)}};r=new WeakMap,h=new WeakMap,i=qe([je(0,s.IExtHostRpcService),je(1,S.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class c{constructor(g,R,O){this.d=g,this.f=R,this.g=O,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,R){if(!g)return;const O={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return O;const q=this.f(g.command);if(q)O.id=q.internalId,O.arguments=q.args.map((Z,x)=>Z.convert(g.arguments&&g.arguments[x]));else if((0,A.isNonEmptyArray)(g.arguments)){const Z=`${g.command}/${++this.c}`;this.b.set(Z,g),R.add((0,p.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),O.$ident=Z,O.id=this.delegatingCommandId,O.arguments=[Z],this.g.trace("CommandsConverter#CREATE",g.command,Z)}return O}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const R=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=c;class t{constructor(g,R,O,q){this.name=g,this.description=R,this.validate=O,this.convert=q}optional(){return new t(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,R){return new t(g??this.name,R??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",l=>m.URI.isUri(l),l=>l),t.Position=new t("position","A position in a text document",l=>k.Position.isPosition(l),D.Position.from),t.Range=new t("range","A range in a text document",l=>k.Range.isRange(l),D.Range.from),t.Selection=new t("selection","A selection in a text document",l=>k.Selection.isSelection(l),D.Selection.from),t.Number=new t("number","",l=>typeof l=="number",l=>l),t.String=new t("string","",l=>typeof l=="string",l=>l),t.CallHierarchyItem=new t("item","A call hierarchy item",l=>l instanceof k.CallHierarchyItem,D.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",l=>l instanceof k.TypeHierarchyItem,D.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",l=>l instanceof o.TestItemImpl,D.TestItem.from);class d{constructor(g,R){this.description=g,this.convert=R}}e.ApiCommandResult=d,d.Void=new d("no result",l=>l);class a{constructor(g,R,O,q,Z){this.id=g,this.internalId=R,this.description=O,this.args=q,this.result=Z}}e.ApiCommand=a}),define(Ie[205],Ce([1,0,2,8,7,76,38,18,88,92,16]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(k.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,A.isFalsyOrEmpty)(s))return;class u extends D.SymbolInformation{static to(w){const P=new u(w.name,k.SymbolKind.to(w.kind),w.containerName||"",new D.Location(o[0],k.Range.to(w.range)));return P.detail=w.detail,P.range=P.location.range,P.selectionRange=k.Range.to(w.selectionRange),P.children=w.children?w.children.map(u.to):[],P}}return s.map(u.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(k.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(k.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new C.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(k.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(k.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(k.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>D.Position.isPosition(o)),s=>s.map(k.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(o=>{let u;for(const b of o.reverse())u=new D.SelectionRange(k.Range.to(b),u);return u}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",s=>{if(!!s)return{range:k.Range.to(s.range),placeholder:s.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new D.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,S.decodeSemanticTokensDto)(s);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new D.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,S.decodeSemanticTokensDto)(s);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,o,u)=>{if(!s)return new D.CompletionList([]);const b=s.suggestions.map(w=>k.CompletionItem.to(w,u));return new D.CompletionList(b,s.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,o,u)=>p(b=>new D.CodeLens(k.Range.to(b.range),b.command&&u.fromInternal(b.command)))(s))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>D.Range.isRange(s),s=>D.Selection.isSelection(s)?k.Selection.from(s):k.Range.from(s)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,o,u)=>p(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(b.command)}else{const w=new D.CodeAction(b.title,b.kind?new D.CodeActionKind(b.kind):void 0);return b.edit&&(w.edit=k.WorkspaceEdit.to(b.edit)),b.command&&(w.command=u.fromInternal(b.command)),w.isPreferred=b.isPreferred,w}})(s))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new D.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",s=>s instanceof D.Color,k.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(s,o,u)=>s.map(k.InlayHint.to.bind(void 0,u)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",s=>n.URI.isUri(s)||typeof s=="string"&&(0,y.matchesSomeScheme)(s,N.Schemas.http,N.Schemas.https),s=>s),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,s=>s)],C.ApiCommandResult.Void)];class m{static register(o){E.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=m;function p(s){return o=>{if(Array.isArray(o))return o.map(s)}}function f(s){if(!Array.isArray(s))return;const o=[];for(const u of s)M.isLocationLink(u)?o.push(k.DefinitionLink.to(u)):o.push(k.location.to(u));return o}}),define(Ie[206],Ce([1,0,12,63,4,6,2,76,25,8,7,5]),function(te,e,n,k,D,M,C,A,S,y,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function m(p,f,s){const o=p.getProxy(E.MainContext.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const d=this.b.get(t.handle);return d?d.value:t}else if(t&&t.$mid===7){const d=this.b.get(t.commentControlHandle);if(!d)return t;const a=d.getCommentThread(t.commentThreadHandle);return a?a.value:t}else if(t&&(t.$mid===9||t.$mid===8)){const d=this.b.get(t.thread.commentControlHandle);if(!d)return t;const a=d.getCommentThread(t.thread.commentThreadHandle);return a?t.$mid===8?a.value:{thread:a.value,text:t.text}:t}else if(t&&t.$mid===10){const d=this.b.get(t.thread.commentControlHandle);if(!d)return t;const a=d.getCommentThread(t.thread.commentThreadHandle);if(!a)return t;const l=t.commentUniqueId,g=a.getCommentByUniqueId(l);return g||t}else if(t&&t.$mid===11){const d=this.b.get(t.thread.commentControlHandle);if(!d)return t;const a=d.getCommentThread(t.thread.commentThreadHandle);if(!a)return t;const l=t.text,g=t.commentUniqueId,R=a.getCommentByUniqueId(g);return R?(typeof R.body=="string"?R.body=l:R.body=new N.MarkdownString(l),R):t}return t}})}createCommentController(t,d,a){const l=u.a++,g=new w(t,l,d,a);this.b.set(g.handle,g);const R=this.c.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(g),this.c.set(S.ExtensionIdentifier.toKey(t.identifier),R),g.value}$createCommentThreadTemplate(t,d,a){const l=this.b.get(t);!l||l.$createCommentThreadTemplate(d,a)}async $updateCommentThreadTemplate(t,d,a){const l=this.b.get(t);!l||l.$updateCommentThreadTemplate(d,a)}$deleteCommentThread(t,d){this.b.get(t)?.$deleteCommentThread(d)}$provideCommentingRanges(t,d,a){const l=this.b.get(t);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const g=s.getDocument(C.URI.revive(d));return(0,n.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(g,a)).then(R=>R?R.map(O=>y.Range.from(O)):void 0)}$toggleReaction(t,d,a,l,g){const R=this.b.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const O=R.getCommentThread(d);if(O){const q=O.getCommentByUniqueId(l.uniqueIdInThread);if(R!==void 0&&q&&R.reactionHandler)return R.reactionHandler(q,r(g))}return Promise.resolve(void 0)})}dispose(){}}u.a=0;class b{set threadId(t){this.n=t}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(t){t.isEqual(this.p)||(this.p=t,this.b.range=t,this.c.fire())}get range(){return this.p}set canReply(t){this.d!==t&&(this.d=t,this.b.canReply=t,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(t){this.e=t,this.b.label=t,this.c.fire()}get contextValue(){return this.f}set contextValue(t){this.f=t,this.b.contextValue=t,this.c.fire()}get comments(){return this.q}set comments(t){this.q=t,this.b.comments=t,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(t){this.g=t,this.b.collapsibleState=t,this.c.fire()}get state(){return this.h}set state(t){this.h=t,this.b.state=t,this.c.fire()}get isDisposed(){return this.j}constructor(t,d,a,l,g,R,O,q){this.m=d,this.n=a,this.o=l,this.p=g,this.q=R,this.extensionDescription=O,this.r=q,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${t}.${this.handle}`),o.$createCommentThread(d,this.handle,this.n,this.o,y.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this.i.push({dispose:()=>{o.$deleteCommentThread(d,this.handle)}});const Z=this;this.value={get uri(){return Z.uri},get range(){return Z.range},set range(x){Z.range=x},get comments(){return Z.comments},set comments(x){Z.comments=x},get collapsibleState(){return Z.collapsibleState},set collapsibleState(x){Z.collapsibleState=x},get canReply(){return Z.canReply},set canReply(x){Z.canReply=x},get contextValue(){return Z.contextValue},set contextValue(x){Z.contextValue=x},get label(){return Z.label},set label(x){Z.label=x},get state(){return Z.state},set state(x){Z.state=x},dispose:()=>{Z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const t=a=>Object.prototype.hasOwnProperty.call(this.b,a),d={};t("range")&&(d.range=y.Range.from(this.p)),t("label")&&(d.label=this.label),t("contextValue")&&(d.contextValue=this.contextValue??null),t("comments")&&(d.comments=this.q.map(a=>P(this,a,this.k))),t("collapsibleState")&&(d.collapseState=h(this.g)),t("canReply")&&(d.canReply=this.canReply),t("state")&&(d.state=i(this.h)),t("isTemplate")&&(d.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,d)}getCommentByUniqueId(t){for(const d of this.k){const a=d[0],l=d[1];if(t===l)return a}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(t=>t.dispose())}}b.a=0,qe([(0,k.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class w{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(t){this.b=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(t){this.c=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this.d}set options(t){this.d=t,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(t,d,a,l){this.f=t,this.g=d,this.h=a,this.i=l,this.a=new Map,o.$registerCommentController(this.handle,a,l);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(R){g.options=R},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(R){g.commentingRangeProvider=R},get reactionHandler(){return g.reactionHandler},set reactionHandler(R){g.reactionHandler=R},createCommentThread(R,O,q){return g.createCommentThread(R,O,q).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(t,d,a,l){if(typeof t=="string"){const g=new b(this.id,this.handle,t,d,a,l,this.f,!1);return this.a.set(g.handle,g),g}else{const g=new b(this.id,this.handle,void 0,t,d,a,this.f,!1);return this.a.set(g.handle,g),g}}$createCommentThreadTemplate(t,d){const a=new b(this.id,this.handle,void 0,C.URI.revive(t),y.Range.to(d),[],this.f,!0);return a.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(a.handle,a),a}$updateCommentThreadTemplate(t,d){const a=this.a.get(t);a&&(a.range=y.Range.to(d))}$deleteCommentThread(t){this.a.get(t)?.dispose(),this.a.delete(t)}getCommentThread(t){return this.a.get(t)}dispose(){this.a.forEach(t=>{t.dispose()}),this.e.forEach(t=>t.dispose())}}function P(c,t,d){let a=d.get(t);a||(a=++c.commentHandle,d.set(t,a));const l=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:a,body:typeof t.body=="string"?t.body:y.MarkdownString.from(t.body),userName:t.author.name,userIconPath:l,label:t.label,commentReactions:t.reactions?t.reactions.map(g=>v(g)):void 0,timestamp:t.timestamp?.toJSON()}}function v(c){return{label:c.label,iconPath:c.iconPath?y.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function h(c){if(c!==void 0)switch(c){case N.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case N.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new u}e.createExtHostComments=m}),define(Ie[207],Ce([1,0,22,5,27,17]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(N,E){this.a=N.getProxy(k.MainContext.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,E){const m=this,p=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){m.e(N,E,p,arguments)}})}e(N,E,m,p){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:S(p,this.b)}),this.c&&this.f(N,m,p)}};C=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const A=1e5;function S(y,N){const E=[];if(y.length)for(let m=0;m<y.length;m++){let p=y[m];if(typeof p>"u")p="undefined";else if(p instanceof Error){const f=p;f.stack?p=f.stack:p=f.toString()}E.push(p)}if(N){const m=new Error().stack;m&&E.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,n.safeStringify)(E);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[103],Ce([1,0,2,5,7,3,17,13,18,10,19,26]),function(te,e,n,k,D,M,C,A,S,y,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ni{constructor(f,s){this.h=s,this.f=new Map,this.g=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,s){const o=Ni.c++;this.f.set(o,{provider:f,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const u=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(o,null);return}const w=(0,S.asArray)(b);if(w.length<=Ni.d){this.g.$onDidChange(o,w);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,w.length);const P=w.map(h=>({uri:h,rank:(0,y.count)(h.path,"/")})),v=(0,S.groupBy)(P,(h,i)=>h.rank-i.rank||(0,y.compare)(h.uri.path,i.uri.path)),r=[];e:for(const h of v){let i;for(const c of h){const t=(0,N.dirname)(c.uri.path);if(i!==t&&(i=t,r.push(c.uri)>=Ni.d))break e}}this.g.$onDidChange(o,r)});return new D.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(f,s,o){if(!this.f.has(f))return Object.create(null);const u=Object.create(null),{provider:b,extensionDescription:w}=this.f.get(f);return await Promise.all(s.map(async P=>{try{const{uri:v,id:r}=P,h=await Promise.resolve(b.provideFileDecoration(n.URI.revive(v),o));if(!h)return;try{D.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,E.checkProposedApiEnabled)(w,"codiconDecoration"),u[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(i){this.h.warn(`INVALID decoration from extension '${w}': ${i}`)}}catch(v){this.h.error(v)}})),u}};m.c=0,m.d=250,m=qe([je(0,C.IExtHostRpcService),je(1,A.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[208],Ce([1,0,138,91,2,5,7,8,4,13,28,37]),function(te,e,n,k,D,M,C,A,S,y,N,E){"use strict";var m,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class s{constructor(b,w,P,v,r,h,i){this.d=b,this.e=w,this.f=P,this.g=v,m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new N.ResourceMap(c=>r.getComparisonKey(c)),"f"),Je(this,m,h,"f"),Je(this,p,i,"f")}dispose(){this.c||(Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this.e),Oe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,w){if(!b){this.clear();return}this.h();let P=[];if(D.URI.isUri(b)){if(!w){this.delete(b);return}Oe(this,f,"f").set(b,w.slice()),P=[b]}else if(Array.isArray(b)){P=[];let r;b=[...b].sort(s.j);for(const h of b){const[i,c]=h;if((!r||i.toString()!==r.toString())&&(r&&Oe(this,f,"f").get(r).length===0&&Oe(this,f,"f").delete(r),r=i,P.push(i),Oe(this,f,"f").set(i,[])),c)Oe(this,f,"f").get(i)?.push(...c);else{const t=Oe(this,f,"f").get(i);t&&(t.length=0)}}}if(Oe(this,p,"f").fire(P),!Oe(this,m,"f"))return;const v=[];for(const r of P){let h=[];const i=Oe(this,f,"f").get(r);if(i)if(i.length>this.f){h=[];const c=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(const d of i)if(d.severity===c[t]&&h.push({...A.Diagnostic.from(d),modelVersionId:this.g(r)})===this.f)break e;h.push({severity:k.MarkerSeverity.Info,message:(0,n.localize)(0,null,i.length-this.f),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=i.map(c=>({...A.Diagnostic.from(c),modelVersionId:this.g(r)}));v.push([r,h])}Oe(this,m,"f").$changeMany(this.e,v)}delete(b){this.h(),Oe(this,p,"f").fire([b]),Oe(this,f,"f").delete(b),Oe(this,m,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this.e)}forEach(b,w){this.h();for(const[P,v]of this)b.call(w,P,v,this)}*[(m=new WeakMap,p=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const b of Oe(this,f,"f").keys())yield[b,this.get(b)]}get(b){this.h();const w=Oe(this,f,"f").get(b);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(b){return this.h(),Array.isArray(Oe(this,f,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,w){return b[0].toString()<w[0].toString()?-1:b[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=s;let o=class pi{static _mapper(b){const w=new N.ResourceMap;for(const P of b)w.set(P,P);return{uris:Object.freeze(Array.from(w.values()))}}constructor(b,w,P,v){this.h=w,this.j=P,this.k=v,this.f=new Map,this.g=new S.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=b.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,w){const{f:P,e:v,g:r,h,j:i,k:c}=this,t=new class{$changeMany(l,g){v.$changeMany(l,g),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,l,g.length===0?"CLEARING":g)}$clear(l){v.$clear(l),h.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,l)}dispose(){v.dispose()}};let d;if(!w)w="_generated_diagnostic_collection_name_#"+pi.c++,d=w;else if(!P.has(w))d=w;else{this.h.warn(`DiagnosticCollection with name '${w}' does already exist.`);do d=w+pi.c++;while(P.has(d))}return new class extends s{constructor(){super(w,d,pi.d,l=>c.getDocument(l)?.version,i.extUri,t,r),P.set(d,this)}dispose(){super.dispose(),P.delete(d)}}}getDiagnostics(b){if(b)return this.l(b);{const w=new Map,P=[];for(const v of this.f.values())v.forEach((r,h)=>{let i=w.get(r.toString());typeof i>"u"&&(i=P.length,w.set(r.toString(),i),P.push([r,[]])),P[i][1]=P[i][1].concat(...h)});return P}}l(b){let w=[];for(const P of this.f.values())P.has(b)&&(w=w.concat(P.get(b)));return w}$acceptMarkersChange(b){if(!this.m){const w="_generated_mirror",P=new s(w,w,pi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(w,P),this.m=P}for(const[w,P]of b)this.m.set(D.URI.revive(w),P.map(A.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([je(1,y.ILogService),je(2,E.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[209],Ce([1,0,2,5]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(C){this.a=C.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(A=>A?A.map(S=>n.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(A=>A?n.URI.revive(A):void 0)}}e.ExtHostDialogs=D}),define(Ie[210],Ce([1,0,11,2,7,5,16,21,10]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(E,m,p){this.d=m,this.e=p,this.b=new Map,this.c=E.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,m){if(Object.keys(C.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const p=y.a++;this.b.set(p,m),this.c.$registerTextContentProvider(p,E);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(s=>{if(s.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this.d.getDocument(s)&&this.$provideTextDocumentContent(p,s).then(o=>{if(!o&&typeof o!="string")return;const u=this.d.getDocument(s);if(!u)return;const b=(0,S.splitLines)(o);if(!u.equalLines(b))return this.c.$onVirtualDocumentChange(s,o)},n.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(E,m){const p=this.b.get(E);return p?Promise.resolve(p.provideTextDocumentContent(k.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=y,y.a=0}),define(Ie[211],Ce([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(p,f){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.DisposableStore,this.h=new Map,this.f=p.getProxy(M.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let s=this.h.get(p.toString());return s||(s=this.f.$tryOpenDocument(p).then(o=>{this.h.delete(p.toString());const u=D.URI.revive(o);return(0,S.assertIsDefined)(this.g.getDocument(u))},o=>(this.h.delete(p.toString()),Promise.reject(o))),this.h.set(p.toString(),s)),s}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>D.URI.revive(f))}$acceptModelLanguageChanged(p,f){const s=D.URI.revive(p),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(p){const f=D.URI.revive(p),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(p,f){const s=D.URI.revive(p),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,s){const o=D.URI.revive(p),u=this.g.getDocument(o);if(!u)throw new Error("unknown document");u._acceptIsDirty(s),u.onEvents(f);let b;f.isUndoing?b=N.TextDocumentChangeReason.Undo:f.isRedoing&&(b=N.TextDocumentChangeReason.Redo),this.c.fire((0,y.deepFreeze)({document:u.document,contentChanges:f.changes.map(w=>({range:A.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:b}))}setWordDefinitionFor(p,f){(0,C.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=E}),define(Ie[57],Ce([1,0,47,4,6,2,3,5,99,17,102,8,13,28,16,182,85]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(P){this.value=P,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(P,v){this.h=P,this.i=v,this.a=null,this.b=new Map,this.c=new p.ResourceMap,this.d=new k.Emitter,this.e=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(P){this.acceptDocumentsAndEditorsDelta(P)}acceptDocumentsAndEditorsDelta(P){const v=[],r=[],h=[];if(P.removedDocuments)for(const i of P.removedDocuments){const c=M.URI.revive(i),t=this.c.get(c);t?.unref()&&(this.c.delete(c),v.push(t.value))}if(P.addedDocuments)for(const i of P.addedDocuments){const c=M.URI.revive(i.uri);let t=this.c.get(c);if(t&&c.scheme!==f.Schemas.vscodeNotebookCell&&c.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);t||(t=new u(new S.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),c,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(c,t),r.push(t.value)),t.ref()}if(P.removedEditors)for(const i of P.removedEditors){const c=this.b.get(i);this.b.delete(i),c&&h.push(c)}if(P.addedEditors)for(const i of P.addedEditors){const c=M.URI.revive(i.documentUri);n.ok(this.c.has(c),`document '${c}' does not exist`),n.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const t=this.c.get(c).value,d=new N.ExtHostTextEditor(i.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>t.document),i.selections.map(E.Selection.to),i.options,i.visibleRanges.map(a=>E.Range.to(a)),typeof i.editorPosition=="number"?E.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,d)}P.newActiveEditor!==void 0&&(n.ok(P.newActiveEditor===null||this.b.has(P.newActiveEditor),`active editor '${P.newActiveEditor}' does not exist`),this.a=P.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(h),P.removedDocuments&&this.e.fire(v),P.addedDocuments&&this.d.fire(r),(P.removedEditors||P.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),P.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(P){return this.c.get(P)?.value}allDocuments(){return s.Iterable.map(this.c.values(),P=>P.value)}getEditor(P){return this.b.get(P)}activeEditor(P){if(!this.a)return;const v=this.b.get(this.a);return P?v:v?.value}allEditors(){return[...this.b.values()]}};b=qe([je(0,y.IExtHostRpcService),je(1,m.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[58],Ce([1,0,8,5,2,4,3,7,17,9,62]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class E{constructor(o,u,b){this.e=b,this.d=u,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,u={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(o,u){this.c=[],this.d="",this.b=o,this.e=u;for(const b of o.tabs)b.isActive&&(this.d=b.id),this.c.push(new E(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,u={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return n.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(b=>b.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(b=>b.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const b=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,b),o.tabDto.isActive&&(this.d=b.tabId),b}else if(o.kind===1){const b=this.c.splice(o.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(o.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,b),b}const u=this.c.find(b=>b.tabId===o.tabDto.id);if(!u)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(o.tabDto),u}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=o.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,u={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(b=>b.apiObject))},get activeTabGroup(){const b=o.d;return(0,y.assertIsDefined)(o.e.find(P=>P.groupId===b)?.apiObject)},close:async(b,w)=>{const P=Array.isArray(b)?b:[b];return P.length?f(P[0])?this.j(P,w):this.i(P,w):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(o){const u=new Set(this.e.map(i=>i.groupId)),b=new Set(o.map(i=>i.groupId)),w=(0,N.diffSets)(u,b),P=this.e.filter(i=>w.removed.includes(i.groupId)).map(i=>i.apiObject),v=[],r=[];this.e=o.map(i=>{const c=new m(i,()=>this.d);return w.added.includes(c.groupId)?v.push(c.apiObject):r.push(c.apiObject),c});const h=(0,y.assertIsDefined)(o.find(i=>i.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:v,closed:P,changed:r}))}$acceptTabGroupUpdate(o){const u=this.e.find(b=>b.groupId===o.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const u=this.e.find(w=>w.groupId===o.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const b=u.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(o){for(const u of this.e)for(const b of u.tabs)if(b.apiObject===o)return b}h(o){return this.e.find(u=>u.apiObject===o)}async i(o,u){const b=[];for(const w of o){const P=this.g(w);if(!P)throw new Error("Tab close: Invalid tab not found!");b.push(P.tabId)}return this.a.$closeTab(b,u)}async j(o,u){const b=[];for(const w of o){const P=this.h(w);if(!P)throw new Error("Group close: Invalid group not found!");b.push(P.groupId)}return this.a.$closeGroup(b,u)}};p=qe([je(0,S.IExtHostRpcService)],p),e.ExtHostEditorTabs=p;function f(s){return s.tabs!==void 0}}),define(Ie[212],Ce([1,0,2,5,6,7,8,258,10,23,26]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const s=this.a.indexOf(f);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),s=[];let o,u,b=14,w=14;for(const P of f){let v=o?(0,S.commonPrefixLength)(o,P):0;for(v===0?u=1:u=w;v<P.length;v++)v+1===P.length?(b=w,w=9):w+=1,s.push([u,P.toUpperCase().charCodeAt(v),w]),s.push([u,P.toLowerCase().charCodeAt(v),w]),u=w;o=P,w=b}s.push([9,58,10]),s.push([10,47,12]),this.b=new A.StateMachine(s)}}provideDocumentLinks(f){this.c();const s=[],o=A.LinkComputer.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this.b);for(const u of o){const b=C.DocumentLink.to(u);b.target&&s.push(b)}return s}}class m{constructor(f,s){this.i=s,this.b=new E,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,s,o,u={}){if(this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const b=this.h++;this.b.add(s),this.d.add(s),this.c.set(b,o);let w=2;u.isCaseSensitive&&(w+=1024),u.isReadonly&&(w+=2048),typeof o.copy=="function"&&(w+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.checkProposedApiEnabled)(f,"fsChunks"),w+=4),this.a.$registerFileSystemProvider(b,s,w).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${s}`),console.error(v)});const P=o.onDidChangeFile(v=>{const r=[];for(const h of v){const{uri:i,type:c}=h;if(i.scheme!==s)continue;let t;switch(c){case M.FileChangeType.Changed:t=0;break;case M.FileChangeType.Created:t=1;break;case M.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:t})}this.a.$onFileSystemChange(b,r)});return(0,D.toDisposable)(()=>{P.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(f){const{type:s,ctime:o,mtime:u,size:b,permissions:w}=f;return{type:s,ctime:o,mtime:u,size:b,permissions:w}}$stat(f,s){return Promise.resolve(this.k(f).stat(n.URI.revive(s))).then(o=>m.j(o))}$readdir(f,s){return Promise.resolve(this.k(f).readDirectory(n.URI.revive(s)))}$readFile(f,s){return Promise.resolve(this.k(f).readFile(n.URI.revive(s))).then(o=>y.VSBuffer.wrap(o))}$writeFile(f,s,o,u){return Promise.resolve(this.k(f).writeFile(n.URI.revive(s),o.buffer,u))}$delete(f,s,o){return Promise.resolve(this.k(f).delete(n.URI.revive(s),o))}$rename(f,s,o,u){return Promise.resolve(this.k(f).rename(n.URI.revive(s),n.URI.revive(o),u))}$copy(f,s,o,u){const b=this.k(f);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(n.URI.revive(s),n.URI.revive(o),u))}$mkdir(f,s){return Promise.resolve(this.k(f).createDirectory(n.URI.revive(s)))}$watch(f,s,o,u){const b=this.k(f).watch(n.URI.revive(o),u);this.f.set(s,b)}$unwatch(f,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(f,s,o){const u=this.k(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(n.URI.revive(s),o))}$close(f,s){const o=this.k(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(f,s,o,u){const b=this.k(f);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const w=y.VSBuffer.alloc(u);return Promise.resolve(b.read(s,o,w.buffer,0,u)).then(P=>w.slice(0,P))}$write(f,s,o,u){const b=this.k(f);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(s,o,u.buffer,0,u.byteLength))}k(f){const s=this.c.get(f);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.ExtHostFileSystem=m}),define(Ie[59],Ce([1,0,5,36,7,23,3,17,37,6]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class _t{constructor(m,p){this.b=new Map,this.a=m.getProxy(n.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(s){try{const o=f.b.get(s.scheme);if(!o)return await f.a.$stat(s);await f.a.$ensureActivation(s.scheme);const u=await o.stat(s);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(o){_t.c(o)}},async readDirectory(s){try{const o=f.b.get(s.scheme);return o?(await f.a.$ensureActivation(s.scheme),(await o.readDirectory(s)).slice()):await f.a.$readdir(s)}catch(o){return _t.c(o)}},async createDirectory(s){try{return await f.a.$mkdir(s)}catch(o){return _t.c(o)}},async readFile(s){try{const o=f.b.get(s.scheme);return o?(await f.a.$ensureActivation(s.scheme),(await o.readFile(s)).slice()):(await f.a.$readFile(s)).buffer}catch(o){return _t.c(o)}},async writeFile(s,o){try{return await f.a.$writeFile(s,M.VSBuffer.wrap(o))}catch(u){return _t.c(u)}},async delete(s,o){try{const u=f.b.get(s.scheme);return u?(await f.a.$ensureActivation(s.scheme),await u.delete(s,{recursive:!1,...o})):await f.a.$delete(s,{recursive:!1,useTrash:!1,...o})}catch(u){return _t.c(u)}},async rename(s,o,u){try{return await f.a.$rename(s,o,{overwrite:!1,...u})}catch(b){return _t.c(b)}},async copy(s,o,u){try{return await f.a.$copy(s,o,{overwrite:!1,...u})}catch(b){return _t.c(b)}},isWritableFileSystem(s){const o=p.getCapabilities(s);if(typeof o=="number")return!(o&2048)}})}static c(m){if(m instanceof D.FileSystemError)throw m;if(!(m instanceof Error))throw new D.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(m.message);switch(m.name){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(m.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(m.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(m.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(m.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(m.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(m.message);default:throw new D.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,p){return this.b.set(m,p),(0,y.toDisposable)(()=>this.b.delete(m))}};N=qe([je(0,A.IExtHostRpcService),je(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[213],Ce([1,0,4,35,2,5,8,7]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(E,m,p,f,s,o,u,b){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const w=this.h(E,p,s);this.g=0,o&&(this.g+=1),u&&(this.g+=2),b&&(this.g+=4);const P=(0,k.parse)(s),v=typeof s=="string",r=f(h=>{if(!o)for(const i of h.created){const c=D.URI.revive(i);P(c.fsPath)&&(!v||m.getWorkspaceFolder(c))&&this.a.fire(c)}if(!u)for(const i of h.changed){const c=D.URI.revive(i);P(c.fsPath)&&(!v||m.getWorkspaceFolder(c))&&this.b.fire(c)}if(!b)for(const i of h.deleted){const c=D.URI.revive(i);P(c.fsPath)&&(!v||m.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=A.Disposable.from(w,this.a,this.b,this.c,r)}h(E,m,p){const f=A.Disposable.from();if(typeof p=="string")return f;const s=E.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(p.pattern.includes(k.GLOBSTAR)||p.pattern.includes(k.GLOB_SPLIT))&&(o=!0);const u=Math.random();return s.$watch(m.identifier.value,u,p.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>s.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class y{constructor(E,m,p){this.j=E,this.k=m,this.l=p,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,m,p,f,s,o){return new S(this.j,E,m,this.a.event,C.GlobPattern.from(p),f,s,o)}$onFileEvent(E){this.a.fire(E)}$onDidRunFileOperation(E,m){switch(E){case 2:this.b.fire(Object.freeze({files:m.map(p=>({oldUri:D.URI.revive(p.source),newUri:D.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(p=>D.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(p=>D.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,m){return(p,f,s)=>{const o=function(b){p.call(f,b)};return o.extension=E,m.event(o,void 0,s)}}async $onWillRunFileOperation(E,m,p,f){switch(E){case 2:return await this.n(this.g,{files:m.map(s=>({oldUri:D.URI.revive(s.source),newUri:D.URI.revive(s.target)}))},p,f);case 1:return await this.n(this.i,{files:m.map(s=>D.URI.revive(s.target))},p,f);case 0:case 3:return await this.n(this.h,{files:m.map(s=>D.URI.revive(s.target))},p,f)}}async n(E,m,p,f){const s=new Set,o=[];if(await E.fireAsync(m,f,async(b,w)=>{const P=Date.now(),v=await Promise.resolve(b);v instanceof A.WorkspaceEdit&&(o.push([w.extension,v]),s.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-P>p&&this.k.warn("SLOW file-participant",w.extension.identifier)}),f.isCancellationRequested||o.length===0)return;const u={edits:[]};for(const[,b]of o){const{edits:w}=C.WorkspaceEdit.from(b,{getTextDocumentVersion:P=>this.l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(w)}return{edit:u,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=y}),define(Ie[214],Ce([1,0,2,38]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(C,A,S,y,N){this.a=A,this.b=S,this.c=y;const E=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new k.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new k.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new k.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new k.ApiCommandResult("Notebook and input URI",m=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const p=this.a.getEditorById(m.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:n.URI.revive(m.notebookUri),inputUri:n.URI.revive(m.inputUri),notebookEditor:p.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:n.URI.revive(m.notebookUri),inputUri:n.URI.revive(m.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(C,A,S,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=D}),define(Ie[215],Ce([1,0,6,5]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(C){this.b=0,this.a=C.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,C),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=D}),define(Ie[216],Ce([1,0,2,22,8,7,76,5,10,56,18,9,259,21,6,88,84,53,78,11,12,26]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(I,B){this.d=I,this.e=B}async provideDocumentSymbols(I,B){const W=this.d.getDocument(I),K=await this.e.provideDocumentSymbols(W,B);if(!(0,N.isFalsyOrEmpty)(K))return K[0]instanceof M.DocumentSymbol?K.map(D.DocumentSymbol.from):r.f(K)}static f(I){I=I.slice(0).sort((K,ee)=>{let he=K.location.range.start.compareTo(ee.location.range.start);return he===0&&(he=ee.location.range.end.compareTo(K.location.range.end)),he});const B=[],W=[];for(const K of I){const ee={name:K.name||"!!MISSING: name!!",kind:D.SymbolKind.from(K.kind),tags:K.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:D.Range.from(K.location.range),selectionRange:D.Range.from(K.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),B.push(ee);break}const he=W[W.length-1];if(y.Range.containsRange(he.range,ee.range)&&!y.Range.equalsRange(he.range,ee.range)){he.children?.push(ee),W.push(ee);break}W.pop()}}return B}}class h{constructor(I,B,W){this.g=I,this.h=B,this.j=W,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,B){const W=this.g.getDocument(I),K=await this.j.provideCodeLenses(W,B);if(!K||B.isCancellationRequested)return;const ee=this.e.add(K),he=new f.DisposableStore;this.f.set(ee,he);const ye={cacheId:ee,lenses:[]};for(let ae=0;ae<K.length;ae++)ye.lenses.push({cacheId:[ee,ae],range:D.Range.from(K[ae].range),command:this.h.toInternal(K[ae].command,he)});return ye}async resolveCodeLens(I,B){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let K;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?K=W:K=await this.j.resolveCodeLens(W,B),K||(K=W),B.isCancellationRequested)return;const ee=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ee)return I.command=this.h.toInternal(K.command??h.d,ee),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}h.d={command:"missing",title:"!!MISSING: command!!"};function i(J){return Array.isArray(J)?J.map(D.DefinitionLink.from):J?[D.DefinitionLink.from(J)]:[]}class c{constructor(I,B){this.d=I,this.e=B}async provideDefinition(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideDefinition(K,ee,W);return i(he)}}class t{constructor(I,B){this.d=I,this.e=B}async provideDeclaration(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideDeclaration(K,ee,W);return i(he)}}class d{constructor(I,B){this.d=I,this.e=B}async provideImplementation(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideImplementation(K,ee,W);return i(he)}}class a{constructor(I,B){this.d=I,this.e=B}async provideTypeDefinition(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideTypeDefinition(K,ee,W);return i(he)}}class l{constructor(I,B){this.d=I,this.e=B}async provideHover(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideHover(K,ee,W);if(!(!he||(0,N.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=K.getWordRangeAtPosition(ee)),he.range||(he.range=new M.Range(ee,ee)),D.Hover.from(he)}}class g{constructor(I,B){this.d=I,this.e=B}async provideEvaluatableExpression(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideEvaluatableExpression(K,ee,W);if(he)return D.EvaluatableExpression.from(he)}}class R{constructor(I,B){this.d=I,this.e=B}async provideInlineValues(I,B,W,K){const ee=this.d.getDocument(I),he=await this.e.provideInlineValues(ee,D.Range.to(B),D.InlineValueContext.to(W),K);if(Array.isArray(he))return he.map(ye=>D.InlineValue.from(ye))}}class O{constructor(I,B){this.d=I,this.e=B}async provideDocumentHighlights(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideDocumentHighlights(K,ee,W);if(Array.isArray(he))return he.map(D.DocumentHighlight.from)}}class q{constructor(I,B){this.d=I,this.e=B}async provideLinkedEditingRanges(I,B,W){const K=this.d.getDocument(I),ee=D.Position.to(B),he=await this.e.provideLinkedEditingRanges(K,ee,W);if(he&&Array.isArray(he.ranges))return{ranges:(0,N.coalesce)(he.ranges.map(D.Range.from)),wordPattern:he.wordPattern}}}class Z{constructor(I,B){this.d=I,this.e=B}async provideReferences(I,B,W,K){const ee=this.d.getDocument(I),he=D.Position.to(B),ye=await this.e.provideReferences(ee,he,W,K);if(Array.isArray(ye))return ye.map(D.location.from)}}class x{constructor(I,B,W,K,ee,he,ye){this.g=I,this.h=B,this.j=W,this.k=K,this.l=ee,this.m=he,this.n=ye,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,B,W,K){const ee=this.g.getDocument(I),he=m.Selection.isISelection(B)?D.Selection.to(B):D.Range.to(B),ye=[];for(const tt of this.j.getDiagnostics(I))if(he.intersection(tt.range)&&ye.push(tt)>x.d)break;const ae={diagnostics:ye,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},be=await this.k.provideCodeActions(ee,he,ae,K);if(!(0,N.isNonEmptyArray)(be)||K.isCancellationRequested)return;const Ee=this.e.add(be),We=new f.DisposableStore;this.f.set(Ee,We);const He=[];for(let tt=0;tt<be.length;tt++){const Xe=be[tt];!Xe||(x.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(I,B){const[W,K]=I,ee=this.e.get(W,K);if(!ee||x.o(ee)||!this.k.resolveCodeAction)return;const he=await this.k.resolveCodeAction(ee,B)??ee;return he?.edit?D.WorkspaceEdit.from(he.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}x.d=1e3;class F{constructor(I,B,W,K){this.d=I,this.e=B,this.f=W,this.g=K}async prepareDocumentPaste(I,B,W,K){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(I),he=B.map(ae=>D.Range.to(ae)),ye=D.DataTransfer.toDataTransfer(W,()=>{throw new w.NotImplementedError});return await this.f.prepareDocumentPaste(ee,he,ye,K),D.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(I,B,W,K,ee){const he=this.e.getDocument(B),ye=W.map(Ee=>D.Range.to(Ee)),ae=D.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolvePasteFileData(this.g,I,Ee)).buffer),be=await this.f.provideDocumentPasteEdits(he,ye,ae,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?D.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class ${constructor(I,B){this.d=I,this.e=B}async provideDocumentFormattingEdits(I,B,W){const K=this.d.getDocument(I),ee=await this.e.provideDocumentFormattingEdits(K,B,W);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class T{constructor(I,B){this.d=I,this.e=B}async provideDocumentRangeFormattingEdits(I,B,W,K){const ee=this.d.getDocument(I),he=D.Range.to(B),ye=await this.e.provideDocumentRangeFormattingEdits(ee,he,W,K);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class L{constructor(I,B){this.d=I,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,W,K,ee){const he=this.d.getDocument(I),ye=D.Position.to(B),ae=await this.e.provideOnTypeFormattingEdits(he,ye,W,K,ee);if(Array.isArray(ae))return ae.map(D.TextEdit.from)}}class V{constructor(I,B){this.e=I,this.f=B,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const W=await this.e.provideWorkspaceSymbols(I,B);if(!(0,N.isNonEmptyArray)(W))return{symbols:[]};const K=this.d.add(W),ee={cacheId:K,symbols:[]};for(let he=0;he<W.length;he++){const ye=W[he];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...D.WorkspaceSymbol.from(ye),cacheId:[K,he]})}return ee}async resolveWorkspaceSymbol(I,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const K=await this.e.resolveWorkspaceSymbol(W,B);return K&&(0,k.mixin)(I,D.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,B,W){this.d=I,this.e=B,this.f=W}async provideRenameEdits(I,B,W,K){const ee=this.d.getDocument(I),he=D.Position.to(B);try{const ye=await this.e.provideRenameEdits(ee,he,W,K);return ye?D.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=j.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(I,B,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(I),ee=D.Position.to(B);try{const he=await this.e.prepareRename(K,ee,W);let ye,ae;if(M.Range.isRange(he)?(ye=he,ae=K.getText(he)):(0,E.isObject)(he)&&(ye=he.range,ae=he.placeholder),!ye||!ae)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ye),text:ae}}catch(he){const ye=j.g(he);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(he)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class le{constructor(I,B){this.resultId=I,this.tokens=B}}class _{constructor(I,B){this.f=I,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,B,W){const K=this.f.getDocument(I),ee=B!==0?this.d.get(B):null;let he=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,ee.resultId,W):await this.g.provideDocumentSemanticTokens(K,W);return ee&&this.d.delete(B),he?(he=_.h(he),this.o(_.n(ee,he),he)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return _.j(I)?_.k(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):_.l(I)?_.m(I)?I:new M.SemanticTokensEdits(I.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(I,B){if(!_.j(B)||!I||!I.tokens)return B;const W=I.tokens,K=W.length,ee=B.data,he=ee.length;let ye=0;const ae=Math.min(K,he);for(;ye<ae&&W[ye]===ee[ye];)ye++;if(ye===K&&ye===he)return new M.SemanticTokensEdits([],B.resultId);let be=0;const Ee=ae-ye;for(;be<Ee&&W[K-be-1]===ee[he-be-1];)be++;return new M.SemanticTokensEdits([{start:ye,deleteCount:K-ye-be,data:ee.subarray(ye,he-be)}],B.resultId)}o(I,B){if(_.j(I)){const W=this.e++;return this.d.set(W,new le(I.resultId,I.data)),(0,s.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(_.l(I)){const W=this.e++;return _.j(B)?this.d.set(W,new le(B.resultId,B.data)):this.d.set(W,new le(I.resultId)),(0,s.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class pe{constructor(I,B){this.d=I,this.e=B}async provideDocumentRangeSemanticTokens(I,B,W){const K=this.d.getDocument(I),ee=await this.e.provideDocumentRangeSemanticTokens(K,D.Range.to(B),W);return ee?this.f(ee):null}f(I){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,B,W,K,ee){this.f=I,this.g=B,this.h=W,this.j=K,this.k=ee,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,B,W,K){const ee=this.f.getDocument(I),he=D.Position.to(B),ye=ee.getWordRangeAtPosition(he)||new M.Range(he,he),ae=ye.with({end:he}),be=new b.StopWatch(!0),Ee=await this.h.provideCompletionItems(ee,he,K,D.CompletionContext.to(W));if(!Ee||K.isCancellationRequested)return;const We=Array.isArray(Ee)?new M.CompletionList(Ee):Ee,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:D.Range.from(ye),insert:D.Range.from(ae)},c:We.isIncomplete||void 0,d:be.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Le=this.l(dt,[He,it],ae,ye);Xe.push(Le)}return et}async resolveCompletionItem(I,B){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const K=await this.h.resolveCompletionItem(W,B);if(!!K)return this.l(K,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,B,W,K){const ee=this.e.get(B[0]);if(!ee)throw Error("DisposableStore is missing...");const he=this.g.toInternal(I.command,ee),ye={x:B,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=I.textEdit.newText):typeof I.insertText=="string"?ye.h=I.insertText:I.insertText instanceof M.SnippetString&&(ye.h=I.insertText.value,ye.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),M.Range.isRange(ae)?ye.j=D.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!K?.isEqual(ae.replacing))&&(ye.j={insert:D.Range.from(ae.inserting),replace:D.Range.from(ae.replacing)}),ye}}class de{async provideInlineCompletions(I,B,W,K){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}}class re extends de{constructor(I,B,W,K){super(),this.f=I,this.g=B,this.h=W,this.j=K,this.d=new G,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,B,W,K){const ee=this.g.getDocument(I),he=D.Position.to(B),ye=await this.h.provideInlineCompletionItems(ee,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},K);if(!ye||K.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(Ee||(Ee=new f.DisposableStore),Xe=this.j.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?D.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:be.map(He=>(Ee||(Ee=new f.DisposableStore),this.j.toInternal(He,Ee)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const W=this.d.get(I)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const B=this.e++;return this.d.set(B,I),B}disposeReferenceId(I){const B=this.d.get(I);return this.d.delete(I),B}get(I){return this.d.get(I)}}class H{constructor(I,B){this.e=I,this.f=B,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(I,B,W,K){const ee=this.e.getDocument(I),he=D.Position.to(B),ye=this.g(W),ae=await this.f.provideSignatureHelp(ee,he,K,ye);if(ae){const be=this.d.add([ae]);return{...D.SignatureHelp.from(ae),id:be}}}g(I){let B;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),K=this.d.get(I.activeSignatureHelp.id,0);K?(B=K,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this.d.delete(I)}}class oe{constructor(I,B,W,K,ee){this.f=I,this.g=B,this.h=W,this.j=K,this.k=ee,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,B,W){const K=this.f.getDocument(I),ee=D.Range.to(B),he=await this.h.provideInlayHints(K,ee,W);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(he);this.e.set(ye,new f.DisposableStore);const ae={hints:[],cacheId:ye};for(let be=0;be<he.length;be++)this.l(he[be],ee)&&ae.hints.push(this.m(he[be],[ye,be]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),ae}async resolveInlayHint(I,B){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const K=await this.h.resolveInlayHint(W,B);if(!!K&&!!this.l(K))return this.m(K,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}m(I,B){const W=this.e.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const K={label:"",cacheId:B,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?K.label=I.label:K.label=I.label.map(ee=>{const he={label:ee.value};return he.tooltip=D.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(he.location=D.location.from(ee.location)),ee.command&&(he.command=this.g.toInternal(ee.command,W)),he}),K}}class ve{constructor(I,B){this.e=I,this.f=B,this.d=new u.Cache("DocumentLink")}async provideLinks(I,B){const W=this.e.getDocument(I),K=await this.f.provideDocumentLinks(W,B);if(!(!Array.isArray(K)||K.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ve.g).map(D.DocumentLink.from)};{const ee=this.d.add(K),he={links:[],cacheId:ee};for(let ye=0;ye<K.length;ye++){if(!ve.g(K[ye]))continue;const ae=D.DocumentLink.from(K[ye]);ae.cacheId=[ee,ye],he.links.push(ae)}return he}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const K=await this.f.resolveDocumentLink(W,B);if(!(!K||!ve.g(K)))return D.DocumentLink.from(K)}releaseLinks(I){this.d.delete(I)}}class Ae{constructor(I,B){this.d=I,this.e=B}async provideColors(I,B){const W=this.d.getDocument(I),K=await this.e.provideDocumentColors(W,B);return Array.isArray(K)?K.map(he=>({color:D.Color.from(he.color),range:D.Range.from(he.range)})):[]}async provideColorPresentations(I,B,W){const K=this.d.getDocument(I),ee=D.Range.to(B.range),he=D.Color.to(B.color),ye=await this.e.provideColorPresentations(he,{document:K,range:ee},W);if(!!Array.isArray(ye))return ye.map(D.ColorPresentation.from)}}class Ue{constructor(I,B){this.d=I,this.e=B}async provideFoldingRanges(I,B,W){const K=this.d.getDocument(I),ee=await this.e.provideFoldingRanges(K,B,W);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class xe{constructor(I,B,W){this.d=I,this.e=B,this.f=W}async provideSelectionRanges(I,B,W){const K=this.d.getDocument(I),ee=B.map(D.Position.to),he=await this.e.provideSelectionRanges(K,ee,W);if(!(0,N.isNonEmptyArray)(he))return[];if(he.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<ee.length;ae++){const be=[];ye.push(be);let Ee=ee[ae],We=he[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(be.push(D.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Te{constructor(I,B){this.f=I,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,B,W){const K=this.f.getDocument(I),ee=D.Position.to(B),he=await this.g.prepareCallHierarchy(K,ee,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideCallsTo(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(K,W);if(!!ee)return ee.map(he=>({from:this.h(I,he.from),fromRanges:he.fromRanges.map(ye=>D.Range.from(ye))}))}async provideCallsFrom(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(K,W);if(!!ee)return ee.map(he=>({to:this.h(I,he.to),fromRanges:he.fromRanges.map(ye=>D.Range.from(ye))}))}releaseSession(I){this.e.delete(I)}h(I,B){const W=this.e.get(I),K=D.CallHierarchyItem.from(B,I,W.size.toString(36));return W.set(K._itemId,B),K}j(I,B){return this.e.get(I)?.get(B)}}class Se{constructor(I,B){this.f=I,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,B,W){const K=this.f.getDocument(I),ee=D.Position.to(B),he=await this.g.prepareTypeHierarchy(K,ee,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideSupertypes(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(K,W);if(!!ee)return ee.map(he=>this.h(I,he))}async provideSubtypes(I,B,W){const K=this.j(I,B);if(!K)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(K,W);if(!!ee)return ee.map(he=>this.h(I,he))}releaseSession(I){this.e.delete(I)}h(I,B){const W=this.e.get(I),K=D.TypeHierarchyItem.from(B,I,W.size.toString(36));return W.set(K._itemId,B),K}j(I,B){return this.e.get(I)?.get(B)}}class ke{constructor(I,B,W,K){this.d=I,this.e=B,this.f=W,this.g=K}async provideDocumentOnDropEdits(I,B,W,K,ee){const he=this.e.getDocument(B),ye=D.Position.to(W),ae=D.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,Ee)).buffer),be=await this.f.provideDocumentDropEdits(he,ye,ae,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?D.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class se{constructor(I,B){this.adapter=I,this.extension=B}}class ce{constructor(I,B,W,K,ee,he,ye,ae){this.g=B,this.h=W,this.j=K,this.k=ee,this.l=he,this.m=ye,this.n=ae,this.f=new Map,this.e=I.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new M.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,B,W,K,ee,he=!1){const ye=this.f.get(I);if(!ye||!(ye.adapter instanceof B))return K;const ae=Date.now();he||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const be=W(ye.adapter,ye.extension);return Promise.resolve(be).catch(Ee=>{(0,w.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{he||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),p.CancellationToken.isCancellationToken(ee)?(0,P.raceCancellationError)(be,ee):be}t(I,B){const W=this.q();return this.f.set(W,new se(I,B)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,W,K){const ee=this.t(new r(this.h,W),I),he=K&&K.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(ee,this.o(B),he),this.p(ee)}$provideDocumentSymbols(I,B,W){return this.s(I,r,K=>K.provideDocumentSymbols(n.URI.revive(B),W),void 0,W)}registerCodeLensProvider(I,B,W){const K=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new se(new h(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(K,this.o(B),ee);let he=this.p(K);if(ee!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(ee));he=M.Disposable.from(he,ye)}return he}$provideCodeLenses(I,B,W){return this.s(I,h,K=>K.provideCodeLenses(n.URI.revive(B),W),void 0,W)}$resolveCodeLens(I,B,W){return this.s(I,h,K=>K.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(I,B){this.s(I,h,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,W){const K=this.t(new c(this.h,W),I);return this.e.$registerDefinitionSupport(K,this.o(B)),this.p(K)}$provideDefinition(I,B,W,K){return this.s(I,c,ee=>ee.provideDefinition(n.URI.revive(B),W,K),[],K)}registerDeclarationProvider(I,B,W){const K=this.t(new t(this.h,W),I);return this.e.$registerDeclarationSupport(K,this.o(B)),this.p(K)}$provideDeclaration(I,B,W,K){return this.s(I,t,ee=>ee.provideDeclaration(n.URI.revive(B),W,K),[],K)}registerImplementationProvider(I,B,W){const K=this.t(new d(this.h,W),I);return this.e.$registerImplementationSupport(K,this.o(B)),this.p(K)}$provideImplementation(I,B,W,K){return this.s(I,d,ee=>ee.provideImplementation(n.URI.revive(B),W,K),[],K)}registerTypeDefinitionProvider(I,B,W){const K=this.t(new a(this.h,W),I);return this.e.$registerTypeDefinitionSupport(K,this.o(B)),this.p(K)}$provideTypeDefinition(I,B,W,K){return this.s(I,a,ee=>ee.provideTypeDefinition(n.URI.revive(B),W,K),[],K)}registerHoverProvider(I,B,W,K){const ee=this.t(new l(this.h,W),I);return this.e.$registerHoverProvider(ee,this.o(B)),this.p(ee)}$provideHover(I,B,W,K){return this.s(I,l,ee=>ee.provideHover(n.URI.revive(B),W,K),void 0,K)}registerEvaluatableExpressionProvider(I,B,W,K){const ee=this.t(new g(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(B)),this.p(ee)}$provideEvaluatableExpression(I,B,W,K){return this.s(I,g,ee=>ee.provideEvaluatableExpression(n.URI.revive(B),W,K),void 0,K)}registerInlineValuesProvider(I,B,W,K){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new R(this.h,W),I);this.e.$registerInlineValuesProvider(he,this.o(B),ee);let ye=this.p(he);if(ee!==void 0){const ae=W.onDidChangeInlineValues(be=>this.e.$emitInlineValuesEvent(ee));ye=M.Disposable.from(ye,ae)}return ye}$provideInlineValues(I,B,W,K,ee){return this.s(I,R,he=>he.provideInlineValues(n.URI.revive(B),W,K,ee),void 0,ee)}registerDocumentHighlightProvider(I,B,W){const K=this.t(new O(this.h,W),I);return this.e.$registerDocumentHighlightProvider(K,this.o(B)),this.p(K)}$provideDocumentHighlights(I,B,W,K){return this.s(I,O,ee=>ee.provideDocumentHighlights(n.URI.revive(B),W,K),void 0,K)}registerLinkedEditingRangeProvider(I,B,W){const K=this.t(new q(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(K,this.o(B)),this.p(K)}$provideLinkedEditingRanges(I,B,W,K){return this.s(I,q,async ee=>{const he=await ee.provideLinkedEditingRanges(n.URI.revive(B),W,K);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ce.w(he.wordPattern):void 0}},void 0,K)}registerReferenceProvider(I,B,W){const K=this.t(new Z(this.h,W),I);return this.e.$registerReferenceSupport(K,this.o(B)),this.p(K)}$provideReferences(I,B,W,K,ee){return this.s(I,Z,he=>he.provideReferences(n.URI.revive(B),W,K,ee),void 0,ee)}registerCodeActionProvider(I,B,W,K){const ee=new f.DisposableStore,he=this.t(new x(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(he,this.o(B),{providedKinds:K?.providedCodeActionKinds?.map(ye=>ye.value),documentation:K?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},ce.u(I),Boolean(W.resolveCodeAction)),ee.add(this.p(he)),ee}$provideCodeActions(I,B,W,K,ee){return this.s(I,x,he=>he.provideCodeActions(n.URI.revive(B),W,K,ee),void 0,ee)}$resolveCodeAction(I,B,W){return this.s(I,x,K=>K.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(I,B){this.s(I,x,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,W){const K=this.t(new $(this.h,W),I);return this.e.$registerDocumentFormattingSupport(K,this.o(B),I.identifier,I.displayName||I.name),this.p(K)}$provideDocumentFormattingEdits(I,B,W,K){return this.s(I,$,ee=>ee.provideDocumentFormattingEdits(n.URI.revive(B),W,K),void 0,K)}registerDocumentRangeFormattingEditProvider(I,B,W){const K=this.t(new T(this.h,W),I);return this.e.$registerRangeFormattingSupport(K,this.o(B),I.identifier,I.displayName||I.name),this.p(K)}$provideDocumentRangeFormattingEdits(I,B,W,K,ee){return this.s(I,T,he=>he.provideDocumentRangeFormattingEdits(n.URI.revive(B),W,K,ee),void 0,ee)}registerOnTypeFormattingEditProvider(I,B,W,K){const ee=this.t(new L(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(ee,this.o(B),K,I.identifier),this.p(ee)}$provideOnTypeFormattingEdits(I,B,W,K,ee,he){return this.s(I,L,ye=>ye.provideOnTypeFormattingEdits(n.URI.revive(B),W,K,ee,he),void 0,he)}registerWorkspaceSymbolProvider(I,B){const W=this.t(new V(B,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,B,W){return this.s(I,V,K=>K.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,B,W){return this.s(I,V,K=>K.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this.s(I,V,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,W){const K=this.t(new j(this.h,W,this.l),I);return this.e.$registerRenameSupport(K,this.o(B),j.supportsResolving(W)),this.p(K)}$provideRenameEdits(I,B,W,K,ee){return this.s(I,j,he=>he.provideRenameEdits(n.URI.revive(B),W,K,ee),void 0,ee)}$resolveRenameLocation(I,B,W,K){return this.s(I,j,ee=>ee.resolveRenameLocation(n.URI.revive(B),W,K),void 0,K)}registerDocumentSemanticTokensProvider(I,B,W,K){const ee=this.t(new _(this.h,W),I),he=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(B),K,he);let ye=this.p(ee);if(he){const ae=W.onDidChangeSemanticTokens(be=>this.e.$emitDocumentSemanticTokensEvent(he));ye=M.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(I,B,W,K){return this.s(I,_,ee=>ee.provideDocumentSemanticTokens(n.URI.revive(B),W,K),null,K)}$releaseDocumentSemanticTokens(I,B){this.s(I,_,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,W,K){const ee=this.t(new pe(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(B),K),this.p(ee)}$provideDocumentRangeSemanticTokens(I,B,W,K){return this.s(I,pe,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive(B),W,K),null,K)}registerCompletionItemProvider(I,B,W,K){const ee=this.t(new ue(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(ee,this.o(B),K,ue.supportsResolving(W),`${I.identifier.value}(${K.join("")})`),this.p(ee)}$provideCompletionItems(I,B,W,K,ee){return this.s(I,ue,he=>he.provideCompletionItems(n.URI.revive(B),W,K,ee),void 0,ee)}$resolveCompletionItem(I,B,W){return this.s(I,ue,K=>K.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(I,B){this.s(I,ue,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,W){const K=new re(I,this.h,W,this.j.converter),ee=this.t(K,I);return this.e.$registerInlineCompletionsSupport(ee,this.o(B),K.supportsHandleDidShowCompletionItem),this.p(ee)}$provideInlineCompletions(I,B,W,K,ee){return this.s(I,de,he=>he.provideInlineCompletions(n.URI.revive(B),W,K,ee),void 0,ee)}$handleInlineCompletionDidShow(I,B,W){this.s(I,de,async K=>{K.handleDidShowCompletionItem(B,W)},void 0,void 0)}$freeInlineCompletionsList(I,B){this.s(I,de,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,W,K){const ee=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,he=this.t(new H(this.h,W),I);return this.e.$registerSignatureHelpProvider(he,this.o(B),ee),this.p(he)}$provideSignatureHelp(I,B,W,K,ee){return this.s(I,H,he=>he.provideSignatureHelp(n.URI.revive(B),W,K,ee),void 0,ee)}$releaseSignatureHelp(I,B){this.s(I,H,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,W){const K=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new oe(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(ee,this.o(B),typeof W.resolveInlayHint=="function",K,ce.u(I));let he=this.p(ee);if(K!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(K));he=M.Disposable.from(he,ye)}return he}$provideInlayHints(I,B,W,K){return this.s(I,oe,ee=>ee.provideInlayHints(n.URI.revive(B),W,K),void 0,K)}$resolveInlayHint(I,B,W){return this.s(I,oe,K=>K.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(I,B){this.s(I,oe,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,W){const K=this.t(new ve(this.h,W),I);return this.e.$registerDocumentLinkProvider(K,this.o(B),typeof W.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(I,B,W){return this.s(I,ve,K=>K.provideLinks(n.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(I,B,W){return this.s(I,ve,K=>K.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this.s(I,ve,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,W){const K=this.t(new Ae(this.h,W),I);return this.e.$registerDocumentColorProvider(K,this.o(B)),this.p(K)}$provideDocumentColors(I,B,W){return this.s(I,Ae,K=>K.provideColors(n.URI.revive(B),W),[],W)}$provideColorPresentations(I,B,W,K){return this.s(I,Ae,ee=>ee.provideColorPresentations(n.URI.revive(B),W,K),void 0,K)}registerFoldingRangeProvider(I,B,W){const K=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new se(new Ue(this.h,W),I)),this.e.$registerFoldingRangeProvider(K,this.o(B),I.identifier,ee);let he=this.p(K);if(ee!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));he=M.Disposable.from(he,ye)}return he}$provideFoldingRanges(I,B,W,K){return this.s(I,Ue,ee=>ee.provideFoldingRanges(n.URI.revive(B),W,K),void 0,K)}registerSelectionRangeProvider(I,B,W){const K=this.t(new xe(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(K,this.o(B)),this.p(K)}$provideSelectionRanges(I,B,W,K){return this.s(I,xe,ee=>ee.provideSelectionRanges(n.URI.revive(B),W,K),[],K)}registerCallHierarchyProvider(I,B,W){const K=this.t(new Te(this.h,W),I);return this.e.$registerCallHierarchyProvider(K,this.o(B)),this.p(K)}$prepareCallHierarchy(I,B,W,K){return this.s(I,Te,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(B),W,K)),void 0,K)}$provideCallHierarchyIncomingCalls(I,B,W,K){return this.s(I,Te,ee=>ee.provideCallsTo(B,W,K),void 0,K)}$provideCallHierarchyOutgoingCalls(I,B,W,K){return this.s(I,Te,ee=>ee.provideCallsFrom(B,W,K),void 0,K)}$releaseCallHierarchy(I,B){this.s(I,Te,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,W){const K=this.t(new Se(this.h,W),I);return this.e.$registerTypeHierarchyProvider(K,this.o(B)),this.p(K)}$prepareTypeHierarchy(I,B,W,K){return this.s(I,Se,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(B),W,K)),void 0,K)}$provideTypeHierarchySupertypes(I,B,W,K){return this.s(I,Se,ee=>ee.provideSupertypes(B,W,K),void 0,K)}$provideTypeHierarchySubtypes(I,B,W,K){return this.s(I,Se,ee=>ee.provideSubtypes(B,W,K),void 0,K)}$releaseTypeHierarchy(I,B){this.s(I,Se,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,W){const K=this.q();return this.f.set(K,new se(new ke(this.e,this.h,W,K),I)),this.e.$registerDocumentOnDropEditProvider(K,this.o(B)),this.p(K)}$provideDocumentOnDropEdits(I,B,W,K,ee,he){return this.s(I,ke,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(B,n.URI.revive(W),K,ee,he)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,W,K){const ee=this.q();return this.f.set(ee,new se(new F(this.e,this.h,W,ee),I)),this.e.$registerPasteEditProvider(ee,this.o(B),!!W.prepareDocumentPaste,K.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(I,B,W,K,ee){return this.s(I,F,he=>he.prepareDocumentPaste(n.URI.revive(B),W,K,ee),void 0,ee)}$providePasteEdits(I,B,W,K,ee,he){return this.s(I,F,ye=>ye.providePasteEdits(B,n.URI.revive(W),K,ee,he),void 0,he)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,B,W){const{wordPattern:K}=W;if(K&&(0,S.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(B,K):this.h.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ee=this.q(),he={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,B,he),this.p(ee)}$setWordDefinitions(I){for(const B of I)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[217],Ce([1,0,5,8,7,30,12,6]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,E,m,p){this.c=E,this.d=m,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,E){await this.a.$changeLanguage(N,E);const m=this.c.getDocumentData(N);if(!m)throw new Error(`document '${N.toString()}' NOT found`);return m.document}async tokenAtPosition(N,E){const m=N.version,p=k.Position.from(E),f=await this.a.$tokensAtPosition(N.uri,p),s={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(E)??new D.Range(E.line,E.character,E.line,E.character)};if(!f)return s;const o={range:k.Range.to(f.range),type:k.TokenType.to(f.type)};return!o.range.contains(E)||m!==N.version?s:o}createLanguageStatusItem(N,E,m){const p=this.f++,f=this.a,s=this.g,o=`${N.identifier.value}/${E}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);s.add(o);const u={selector:m,id:E,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const w=new A.DisposableStore,P=()=>{b?.dispose(),b=(0,C.disposableTimeout)(()=>{w.clear(),this.a.$setLanguageStatus(p,{id:o,name:u.name??N.displayName??N.name,source:N.displayName??N.name,selector:k.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===D.LanguageStatusSeverity.Error?M.default.Error:u.severity===D.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:u.command&&this.d.toInternal(u.command,w),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},v={dispose(){w.dispose(),b?.dispose(),f.$removeLanguageStatus(p),s.delete(o)},get id(){return u.id},get name(){return u.name},set name(r){u.name=r,P()},get selector(){return u.selector},set selector(r){u.selector=r,P()},get text(){return u.text},set text(r){u.text=r,P()},get detail(){return u.detail},set detail(r){u.detail=r,P()},get severity(){return u.severity},set severity(r){u.severity=r,P()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(r){u.accessibilityInformation=r,P()},get command(){return u.command},set command(r){u.command=r,P()},get busy(){return u.busy},set busy(r){u.busy=r,P()}};return P(),v}}e.ExtHostLanguages=S}),define(Ie[79],Ce([1,0,20,10,2,3,13,5,27,17]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(m,p,f){this.f=f,this.d=new Map,this.a=p.getProxy(A.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(m,p){const{message:f,args:s,comment:o}=p;if(this.c)return(0,k.format2)(f,s??{});let u=f;o&&o.length>0&&(u+=`/${Array.isArray(o)?o.join(""):o}`);const b=this.d.get(m)?.contents[u];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,k.format2)(b??f,s??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let p;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(f),o=JSON.parse(s);p=m.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${s.message}`);return}p&&this.d.set(m.identifier.value,{contents:p,uri:f})}async g(m){if(m.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return D.URI.revive(p)}return m.l10n?D.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([je(0,S.IExtHostInitDataService),je(1,y.IExtHostRpcService),je(2,C.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ie[218],Ce([1,0,13,5,27,17,2,4,9,66]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let N=class extends n.AbstractLoggerService{constructor(p,f){super(f.logLevel,A.Event.None,f.loggers.map(s=>(0,y.revive)(s))),this.l=p.getProxy(k.MainContext.MainThreadLogger)}$setLevel(p,f){f?this.setLogLevel(C.URI.revive(f),p):(0,S.isUndefined)(p)||this.j(p)}k(p,f,s){return new E(this.l,p,f,s)}};N=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],N),e.ExtHostLoggerService=N;class E extends n.AbstractMessageLogger{constructor(p,f,s,o){super(o?.always),this.m=p,this.n=f,this.k=!1,this.l=[],this.setLevel(s),this.m.$createLogger(f,o).then(()=>{this.r(this.l),this.k=!0})}g(p,f){const s=[[p,f]];this.k?this.r(s):this.l.push(...s)}r(p){this.m.$log(this.n,p)}}}),define(Ie[219],Ce([1,0,5,13,26]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let C=class{constructor(S,y){this.b=y,this.a=S.getProxy(n.MainContext.MainThreadMessageService)}showMessage(S,y,N,E,m){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof E=="string"||M(E)?f=[E,...m]:(p.modal=E?.modal,p.useCustom=E?.useCustom,p.detail=E?.detail,f=m),p.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const s=[];for(let o=0;o<f.length;o++){const u=f[o];if(typeof u=="string")s.push({title:u,handle:o,isCloseAffordance:!1});else if(typeof u=="object"){const{title:b,isCloseAffordance:w}=u;s.push({title:b,isCloseAffordance:!!w,handle:o})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(y,N,p,s).then(o=>{if(typeof o=="number")return f[o]})}};C=qe([je(1,k.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[220],Ce([1,0,23,4,6,28,10,9,2,53,5,38,8,7,44,194,100]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,P,v,r){this.q=v,this.r=r,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new k.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=w.getProxy(N.MainContext.MainThreadNotebook),this.c=w.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=w.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=P.converter,P.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const i=h.notebookEditor?.notebookUri,c=h.cell.handle,d=this.g.get(i)?.getCell(c);if(d)return d.apiCell}if(h&&h.$mid===14){const i=h.uri,c=this.g.get(i);if(c)return c.apiNotebook}return h}}),u.x(P)}getEditorById(w){const P=this.h.get(w);if(!P)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return P}getIdByEditor(w){for(const[P,v]of this.h)if(v.apiEditor===w)return P}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,P){const v=this.g.get(w);if(!v&&!P)throw new Error(`NO notebook document for '${w}'`);return v}static s(w,P){if(!P)return;const v=P.filenamePattern.map(r=>m.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(P.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${P.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:P.displayName,filenamePattern:v,exclusive:P.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,P,v){const r=u.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(r,v),this.b.$registerNotebookCellStatusBarItemProvider(r,h,P);let i;return h!==void 0&&(i=v.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(h))),new p.Disposable(()=>{this.f.delete(r),this.b.$unregisterNotebookCellStatusBarItemProvider(r,h),i?.dispose()})}async createNotebookDocument(w){const P=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&m.NotebookData.from(w.content)});return S.URI.revive(P)}async openNotebookDocument(w){const P=this.g.get(w);if(P)return P.apiNotebook;const v=await this.c.$tryOpenNotebook(w),r=this.g.get(S.URI.revive(v));return(0,A.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(w,P){S.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let v;typeof P=="object"?v={position:m.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selections:P.selections&&P.selections.map(m.NotebookRange.from),pinned:typeof P.preview=="boolean"?!P.preview:void 0}:v={preserveFocus:!1};const r=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,v),h=r&&this.h.get(r)?.apiEditor;if(h)return h;throw r?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,P,v,r){const h=this.f.get(w),i=S.URI.revive(P),c=this.g.get(i);if(!c||!h)return;const t=c.getCellFromIndex(v);if(!t)return;const d=await h.provideCellStatusBarItems(t.apiCell,r);if(!d)return;const a=new D.DisposableStore,l=this.p.add([a]),R=(Array.isArray(d)?d:[d]).map(O=>m.NotebookStatusBarItem.from(O,this.i,a));return{cacheId:l,items:R}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,P,v,r,h){if((0,C.isFalsyOrWhitespace)(P))throw new Error("viewType cannot be empty or just whitespace");const i=this.t++;return this.u.set(i,v),this.b.$registerNotebookSerializer(i,{id:w.identifier,location:w.extensionLocation},P,m.NotebookDocumentContentOptions.from(r),u.s(w,h)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(i)})}async $dataToNotebook(w,P,v){const r=this.u.get(w);if(!r)throw new Error("NO serializer found");const h=await r.deserializeNotebook(P.buffer,v);return new f.SerializableObjectWithBuffers(m.NotebookData.from(h))}async $notebookToData(w,P,v){const r=this.u.get(w);if(!r)throw new Error("NO serializer found");const h=await r.serializeNotebook(m.NotebookData.to(P.value),v);return n.VSBuffer.wrap(h)}w(w,P,v){if(this.h.has(P))throw new Error(`editor with id ALREADY EXSIST: ${P}`);const r=new o.ExtHostNotebookEditor(P,this.d,w,v.visibleRanges.map(m.NotebookRange.to),v.selections.map(m.NotebookRange.to),typeof v.viewColumn=="number"?m.ViewColumn.to(v.viewColumn):void 0);this.h.set(P,r)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const v of w.value.removedDocuments){const r=S.URI.revive(v),h=this.g.get(r);h&&(h.dispose(),this.g.delete(r),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(i=>i.document.uri)}),this.n.fire(h.apiNotebook));for(const i of this.h.values())i.notebookData.uri.toString()===r.toString()&&this.h.delete(i.id)}if(w.value.addedDocuments){const v=[];for(const r of w.value.addedDocuments){const h=S.URI.revive(r.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const i=new s.ExtHostNotebookDocument(this.c,this.q,this.r,h,r);v.push(...r.cells.map(c=>s.ExtHostCell.asModelAddData(i.apiNotebook,c))),this.g.get(h)?.dispose(),this.g.set(h,i),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(i.apiNotebook)}}if(w.value.addedEditors)for(const v of w.value.addedEditors){if(this.h.has(v.id))return;const r=S.URI.revive(v.documentUri),h=this.g.get(r);h&&this.w(h,v.id,v)}const P=[];if(w.value.removedEditors)for(const v of w.value.removedEditors){const r=this.h.get(v);r&&(this.h.delete(v),this.k?.id===r.id&&(this.k=void 0),P.push(r))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(r=>this.h.get(r)).filter(r=>!!r);const v=new Set;this.l.forEach(r=>v.add(r.id));for(const r of this.h.values()){const h=v.has(r.id);r._acceptVisibility(h)}this.l=[...this.h.values()].map(r=>r).filter(r=>r.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(w){const P=E.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[P,new E.ApiCommandArgument("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>n.VSBuffer.wrap(h))],new E.ApiCommandResult("Notebook Data",h=>m.NotebookData.to(h.value))),r=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[P,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new f.SerializableObjectWithBuffers(m.NotebookData.from(h)))],new E.ApiCommandResult("Bytes",h=>h.buffer));w.registerApiCommand(v),w.registerApiCommand(r)}}e.ExtHostNotebookController=u,u.a=0}),define(Ie[221],Ce([1,0,18,12,21,4,6,28,2,25,13,53,5,38,8,7,73,183,26,44]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let P=class{constructor(t,d,a,l,g){this.k=d,this.l=a,this.m=l,this.n=g,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new E.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=t.getProxy(m.MainContext.MainThreadNotebookKernels);const R=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const q=this.l.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:q}}else if(O&&"notebookEditor"in O){const q=this.l.getIdByEditor(O.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return O})],p.ApiCommandResult.Void);this.m.registerApiCommand(R)}createNotebookController(t,d,a,l,g,R){for(const de of this.h.values())if(de.controller.id===d&&y.ExtensionIdentifier.equals(t.identifier,de.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const O=this.i++,q=this;this.n.trace(`NotebookController[${O}], CREATED by ${t.identifier.value}, ${d}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${t.identifier}'`);let x=!1;const F=new C.DisposableStore,$=new M.Emitter,T=new M.Emitter,L={id:i(t.identifier,d),notebookType:a,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:l||t.identifier.value,preloads:R?R.map(f.NotebookRendererScript.from):[]};let V=g??Z,j;this.a.$addKernel(O,L).catch(de=>{console.log(de),x=!0});let le=0;const _=()=>{if(x)return;const de=++le;Promise.resolve().then(()=>{de===le&&this.a.$updateKernel(O,L)})},pe=new A.ResourceMap,ue={get id(){return d},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return L.label},set label(de){L.label=de??t.displayName??t.name,_()},get detail(){return L.detail??""},set detail(de){L.detail=de,_()},get description(){return L.description??""},set description(de){L.description=de,_()},get kind(){return(0,b.checkProposedApiEnabled)(t,"notebookControllerKind"),L.kind??""},set kind(de){(0,b.checkProposedApiEnabled)(t,"notebookControllerKind"),L.kind=de,_()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(de){L.supportedLanguages=de,_()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(de){L.supportsExecutionOrder=de,_()},get rendererScripts(){return L.preloads?L.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(de){V=de??Z},get interruptHandler(){return j},set interruptHandler(de){j=de,L.supportsInterrupt=Boolean(de),_()},createNotebookCellExecution(de){if(x)throw new Error("notebook controller is DISPOSED");if(!pe.has(de.notebook.uri))throw q.n.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return q._createNotebookCellExecution(de,i(t.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${O}], DISPOSED`),x=!0,this.h.delete(O),F.dispose(),$.dispose(),T.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(de,re){re===s.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(t,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(O,de.uri,re)},onDidReceiveMessage:T.event,postMessage(de,re){return(0,b.checkProposedApiEnabled)(t,"notebookMessaging"),q.a.$postMessage(O,re&&q.l.getIdByEditor(re),de)},asWebviewUri(de){return(0,b.checkProposedApiEnabled)(t,"notebookMessaging"),(0,o.asWebviewUri)(de,q.k.remote)}};return this.h.set(O,{extensionId:t.identifier,controller:ue,onDidReceiveMessage:T,onDidChangeSelection:$,associatedNotebooks:pe}),ue}getIdByController(t){for(const[d,a]of this.h)if(a.controller===t)return i(a.extensionId,t.id);return null}createNotebookControllerDetectionTask(t,d){const a=this.d++,l=this;this.n.trace(`NotebookControllerDetectionTask[${a}], CREATED by ${t.identifier.value}`),this.a.$addKernelDetectionTask(a,d);const g={dispose:()=>{this.c.delete(a),l.a.$removeKernelDetectionTask(a)}};return this.c.set(a,g),g}registerKernelSourceActionProvider(t,d,a){const l=this.f++,g=this;return this.e.set(l,a),this.n.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${t.identifier.value}`),this.a.$addKernelSourceActionProvider(l,d),{dispose:()=>{this.e.delete(l),g.a.$removeKernelSourceActionProvider(l)}}}async $provideKernelSourceActions(t,d){const a=this.e.get(t);if(a){const l=new C.DisposableStore;return this.g.add([l]),(await a.provideNotebookKernelSourceActions(d)??[]).map(R=>f.NotebookKernelSourceAction.from(R,this.m.converter,l))}return[]}$acceptNotebookAssociation(t,d,a){const l=this.h.get(t);if(l){const g=this.l.getNotebookDocument(S.URI.revive(d));a?l.associatedNotebooks.set(g.uri,!0):l.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${t}] ASSOCIATE notebook`,g.uri.toString(),a),l.onDidChangeSelection.fire({selected:a,notebook:g.apiNotebook})}}async $executeCells(t,d,a){const l=this.h.get(t);if(!l)return;const g=this.l.getNotebookDocument(S.URI.revive(d)),R=[];for(const O of a){const q=g.getCell(O);q&&R.push(q.apiCell)}try{this.n.trace(`NotebookController[${t}] EXECUTE cells`,g.uri.toString(),R.length),await l.controller.executeHandler.call(l.controller,R,g.apiNotebook,l.controller)}catch(O){this.n.error(`NotebookController[${t}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(t,d,a){const l=this.h.get(t);if(!l)return;const g=this.l.getNotebookDocument(S.URI.revive(d));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,g.apiNotebook);else for(const R of a){const O=g.getCell(R);O&&this.b.get(O.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,d,a){const l=this.h.get(t);if(!l)return;const g=this.l.getEditorById(d);l.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:a}))}$cellExecutionChanged(t,d,a){const g=this.l.getNotebookDocument(S.URI.revive(t)).getCell(d);if(g){const R=a?f.NotebookCellExecutionState.to(a):s.NotebookCellExecutionState.Idle;R!==void 0&&this.j.fire({cell:g.apiCell,state:R})}}_createNotebookCellExecution(t,d){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.l.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const g=new r(d,l,this.a);this.b.set(l.uri,g);const R=g.onDidChangeState(()=>{g.state===v.Resolved&&(g.dispose(),R.dispose(),this.b.delete(l.uri))});return g.asApiObject()}};P=qe([je(4,N.ILogService)],P),e.ExtHostNotebookKernels=P;var v;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(v||(v={}));class r extends C.Disposable{get state(){return this.f}constructor(t,d,a){super(),this.j=d,this.k=a,this.b=r.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new h(10,l=>this.m(l)),this.i=d.internalMetadata.executionOrder,this.k.$createExecution(this.b,t,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(t){await this.h.addItem(t)}async m(t){const d=Array.isArray(t)?t:[t];return this.k.$updateExecution(this.b,new w.SerializableObjectWithBuffers(d))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(t){let d=this.j;if(t&&(d=this.j.notebook.getCellFromApiCell(t)),!d)throw new Error("INVALID cell");return d.handle}s(t){return t.map(d=>{const a=s.NotebookCellOutput.ensureUniqueMimeTypes(d.items,!0);return a===d.items?f.NotebookCellOutput.from(d):f.NotebookCellOutput.from({items:a,id:d.id,metadata:d.metadata})})}async t(t,d,a){const l=this.r(d),g=this.s((0,n.asArray)(t));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:l,append:a,outputs:g})}async w(t,d,a){return t=s.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(t),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:t.map(f.NotebookCellOutputItem.from),outputId:d.id,append:a})}asApiObject(){const t=this;return Object.freeze({get token(){return t.g.token},get cell(){return t.j.apiCell},get executionOrder(){return t.i},set executionOrder(a){t.i=a,t.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:t.i}])},start(a){if(t.f===v.Resolved||t.f===v.Started)throw new Error("Cannot call start again");t.f=v.Started,t.c.fire(),t.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,l){if(t.f===v.Resolved)throw new Error("Cannot call resolve twice");t.f=v.Resolved,t.c.fire(),t.h.flush(),t.k.$completeExecution(t.b,new w.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:a}))},clearOutput(a){return t.n(),t.t([],a,!1)},appendOutput(a,l){return t.n(),t.t(a,l,!0)},replaceOutput(a,l){return t.n(),t.t(a,l,!1)},appendOutputItems(a,l){return t.n(),t.w(a,l,!0)},replaceOutputItems(a,l){return t.n(),t.w(a,l,!1)}})}}r.a=0;class h{constructor(t,d){this.d=t,this.e=d,this.a=[],this.b=Date.now()}addItem(t){return this.a.push(t),this.c||(this.c=new k.DeferredPromise,this.b=Date.now(),(0,k.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const t=this.c;this.c=void 0;const d=this.a;return this.a=[],this.e(d).finally(()=>t.complete())}}function i(c,t){return`${c.value}/${t}`}e.createKernelId=i}),define(Ie[222],Ce([1,0,4,5,100]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,S){this.c=S,this.a=new Map,this.b=A.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,S,y){const N=this.c.getEditorById(A);this.a.get(S)?.fire({editor:N.apiEditor,message:y})}createRendererMessaging(A,S){if(!A.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,E,m)=>this.d(S).event(N,E,m),postMessage:(N,E)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,E]=[E,N]);const m=E&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.b.$postMessage(m?.id,S,N)}}}d(A){let S=this.a.get(A);return S||(S=new n.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(A)}}),this.a.set(A,S),S)}}e.ExtHostNotebookRenderers=M}),define(Ie[223],Ce([1,0,6,9,2,26,5]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(y){this.b=new Map,this.a=y.getProxy(C.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,N,E){if((0,M.checkProposedApiEnabled)(y,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,E),this.a.$registerProfileContentHandler(N,E.name,E.description,y.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(y,N,E,m){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.saveProfile(N,E,m)}async $readProfile(y,N,E){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,k.isString)(N)?N:D.URI.revive(N),E)}}e.ExtHostProfileContentHandlers=A}),define(Ie[224],Ce([1,0,2,5,12]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class M{constructor(A){this.c=new Map,this.b=A.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(A,S,y){const N=n.URI.revive(S),E=this.c.get(A);return E?(0,D.asPromise)(()=>E.provideOriginalResource(N,y)).then(m=>m||null):Promise.resolve(null)}async registerQuickDiffProvider(A,S,y){const N=M.a++;return this.c.set(N,A),await this.b.$registerQuickDiffProvider(N,S,y),{dispose:()=>this.c.delete(N)}}}e.ExtHostQuickDiff=M,M.a=0}),define(Ie[225],Ce([1,0,21,4,6,5,2,7,11,18,30,51]),function(te,e,n,k,D,M,C,A,S,y,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(p,f,s){const o=p.getProxy(M.MainContext.MainThreadQuickOpen);class u{constructor(t,d){this.e=new Map,this.f=0,this.a=t,this.b=d}showQuickPick(t,d,a=n.CancellationToken.None){this.c=void 0;const l=Promise.resolve(t),g=++this.f,R=o.$show(g,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},a),O={},q=R.then(()=>O);return Promise.race([q,l]).then(Z=>{if(Z!==O)return l.then(x=>{const F=[];for(let $=0;$<x.length;$++){const T=x[$];typeof T=="string"?F.push({label:T,handle:$}):T.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:T.label}):F.push({label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,handle:$})}return d&&typeof d.onDidSelectItem=="function"&&(this.c=$=>{d.onDidSelectItem(x[$])}),o.$setItems(g,F),R.then($=>{if(typeof $=="number")return x[$];if(Array.isArray($))return $.map(T=>x[T])})})}).then(void 0,Z=>{if(!(0,S.isCancellationError)(Z))return o.$setError(g,Z),Promise.reject(Z)})}$onItemSelected(t){this.c?.(t)}showInput(t,d=n.CancellationToken.None){return this.d=t?.validateInput,o.$input(t,typeof this.d=="function",d).then(void 0,a=>{if(!(0,S.isCancellationError)(a))return Promise.reject(a)})}async $validateInput(t){if(!this.d)return;const d=await this.d(t);if(!d||typeof d=="string")return d;let a;switch(d.severity){case A.InputBoxValidationSeverity.Info:a=N.default.Info;break;case A.InputBoxValidationSeverity.Warning:a=N.default.Warning;break;case A.InputBoxValidationSeverity.Error:a=N.default.Error;break;default:a=d.message?N.default.Error:N.default.Ignore;break}return{content:d.message,severity:a}}async showWorkspaceFolderPick(t,d=n.CancellationToken.None){const a=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!a)return;const l=await this.a.getWorkspaceFolders2();if(!!l)return l.find(g=>g.uri.toString()===a.uri.toString())}createQuickPick(t){const d=new h(t,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}createInputBox(t){const d=new i(t,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}$onDidChangeValue(t,d){this.e.get(t)?._fireDidChangeValue(d)}$onDidAccept(t){this.e.get(t)?._fireDidAccept()}$onDidChangeActive(t,d){const a=this.e.get(t);a instanceof h&&a._fireDidChangeActive(d)}$onDidChangeSelection(t,d){const a=this.e.get(t);a instanceof h&&a._fireDidChangeSelection(d)}$onDidTriggerButton(t,d){this.e.get(t)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(t,d,a){const l=this.e.get(t);l instanceof h&&l._fireDidTriggerItemButton(d,a)}$onDidHide(t){this.e.get(t)?._fireDidHide()}}class b{constructor(t,d){this.x=t,this.y=d,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.Emitter,this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(t){this.b=t,this.z({title:t})}get step(){return this.c}set step(t){this.c=t,this.z({step:t})}get totalSteps(){return this.d}set totalSteps(t){this.d=t,this.z({totalSteps:t})}get enabled(){return this.g}set enabled(t){this.g=t,this.z({enabled:t})}get busy(){return this.j}set busy(t){this.j=t,this.z({busy:t})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(t){this.k=t,this.z({ignoreFocusOut:t})}get value(){return this.l}set value(t){this.l=t,this.z({value:t})}get placeholder(){return this.m}set placeholder(t){this.m=t,this.z({placeholder:t})}get buttons(){return this.n}set buttons(t){this.n=t.slice(),this.o.clear(),t.forEach((d,a)=>{const l=d===A.QuickInputButtons.Back?-1:a;this.o.set(l,d)}),this.z({buttons:t.map((d,a)=>({...r(d),tooltip:d.tooltip,handle:d===A.QuickInputButtons.Back?-1:a}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(t){this.l=t,this.q.fire(t)}_fireDidTriggerButton(t){const d=this.o.get(t);d&&this.r.fire(d)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(t){if(!this.v){for(const d of Object.keys(t)){const a=t[d];this.u[d]=a===void 0?null:a}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function w(c){if(c instanceof A.ThemeIcon)return{id:c.id};const t=v(c),d=P(c);return{dark:typeof t=="string"?C.URI.file(t):t,light:typeof d=="string"?C.URI.file(d):d}}function P(c){return typeof c=="object"&&"light"in c?c.light:c}function v(c){return typeof c=="object"&&"dark"in c?c.dark:c}function r(c){const t=w(c.iconPath);let d,a;return"id"in t?a=E.ThemeIcon.asClassName(t):d=t,{iconPath:d,iconClass:a}}class h extends b{constructor(t,d){super(t.identifier,d),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.Emitter,this.L=[],this.M=new k.Emitter,this.N=new k.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(t){this.B=t.slice(),this.C.clear(),this.D.clear(),t.forEach((a,l)=>{this.C.set(l,a),this.D.set(a,l)});const d=[];for(let a=0;a<t.length;a++){const l=t[a];l.kind===A.QuickPickItemKind.Separator?d.push({type:"separator",label:l.label}):d.push({handle:a,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((g,R)=>({...r(g),tooltip:g.tooltip,handle:R}))})}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(t){this.E=t,this.z({canSelectMany:t})}get matchOnDescription(){return this.F}set matchOnDescription(t){this.F=t,this.z({matchOnDescription:t})}get matchOnDetail(){return this.G}set matchOnDetail(t){this.G=t,this.z({matchOnDetail:t})}get sortByLabel(){return this.H}set sortByLabel(t){this.H=t,this.z({sortByLabel:t})}get keepScrollPosition(){return this.I}set keepScrollPosition(t){this.I=t,this.z({keepScrollPosition:t})}get activeItems(){return this.J}set activeItems(t){this.J=t.filter(d=>this.D.has(d)),this.z({activeItems:this.J.map(d=>this.D.get(d))})}get selectedItems(){return this.L}set selectedItems(t){this.L=t.filter(d=>this.D.has(d)),this.z({selectedItems:this.L.map(d=>this.D.get(d))})}_fireDidChangeActive(t){const d=(0,y.coalesce)(t.map(a=>this.C.get(a)));this.J=d,this.K.fire(d)}_fireDidChangeSelection(t){const d=(0,y.coalesce)(t.map(a=>this.C.get(a)));this.L=d,this.M.fire(d)}_fireDidTriggerItemButton(t,d){const a=this.C.get(t);if(!a||!a.buttons||!a.buttons.length)return;const l=a.buttons[d];l&&this.N.fire({button:l,item:a})}}class i extends b{constructor(t,d){super(t.identifier,d),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(t){this.B=t,this.z({password:t})}get prompt(){return this.C}set prompt(t){this.C=t,this.z({prompt:t})}get valueSelection(){return this.D}set valueSelection(t){this.D=t,this.z({valueSelection:t})}get validationMessage(){return this.E}set validationMessage(t){this.E=t,t?typeof t=="string"?this.z({validationMessage:t,severity:N.default.Error}):this.z({validationMessage:t.message,severity:t.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new u(f,s)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Ie[226],Ce([1,0,2,4,63,6,12,5,18,122,13,25,51,8,26]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f){"use strict";var s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?n.URI.file(l.iconPath):n.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function b(l,g){if(!l.iconPath&&!g.iconPath)return 0;if(l.iconPath){if(!g.iconPath)return 1}else return-1;const R=typeof l.iconPath=="string"?l.iconPath:n.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,O=typeof g.iconPath=="string"?g.iconPath:n.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,y.comparePaths)(R,O)}function w(l,g){let R=0;if(l.strikeThrough!==g.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==g.faded)return l.faded?1:-1;if(l.tooltip!==g.tooltip)return(l.tooltip||"").localeCompare(g.tooltip||"");if(R=b(l,g),R!==0)return R;if(l.light&&g.light)R=b(l.light,g.light);else{if(l.light)return 1;if(g.light)return-1}if(R!==0)return R;if(l.dark&&g.dark)R=b(l.dark,g.dark);else{if(l.dark)return 1;if(g.dark)return-1}return R}function P(l,g){if(l.command!==g.command)return l.command<g.command?-1:1;if(l.title!==g.title)return l.title<g.title?-1:1;if(l.tooltip!==g.tooltip){if(l.tooltip!==void 0&&g.tooltip!==void 0)return l.tooltip<g.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(l.arguments===g.arguments)return 0;if(l.arguments)if(g.arguments){if(l.arguments.length!==g.arguments.length)return l.arguments.length-g.arguments.length}else return 1;else return-1;for(let R=0;R<l.arguments.length;R++){const O=l.arguments[R],q=g.arguments[R];if(O!==q)return O<q?-1:1}return 0}function v(l,g){let R=(0,y.comparePaths)(l.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(R!==0)return R;if(l.command&&g.command)R=P(l.command,g.command);else{if(l.command)return 1;if(g.command)return-1}if(R!==0)return R;if(l.decorations&&g.decorations)R=w(l.decorations,g.decorations);else{if(l.decorations)return 1;if(g.decorations)return-1}return R}function r(l,g){for(let R=0;R<l.length;R++)if(l[R]!==g[R])return!1;return!0}function h(l,g){return l.command===g.command&&l.title===g.title&&l.tooltip===g.tooltip&&(l.arguments&&g.arguments?r(l.arguments,g.arguments):l.arguments===g.arguments)}function i(l,g){return(0,S.equals)(l,g,h)}class c{get value(){return this.d}set value(g){g=g??"",Oe(this,s,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Oe(this,s,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Oe(this,s,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Oe(this,s,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Oe(this,s,"f").$setInputBoxVisibility(this.l,g))}constructor(g,R,O){this.k=g,this.l=O,s.set(this,void 0),this.d="",this.e=new k.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,s,R,"f")}showValidationMessage(g,R){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,s,"f").$showValidationMessage(this.l,g,R)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=c,s=new WeakMap;class t{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,R,O,q,Z){this.q=g,this.s=R,this.t=O,this.u=q,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=t.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,R){const O=this.h.get(g);return O?(0,C.asPromise)(()=>this.s.executeCommand(O.command,...O.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(v),O=(0,S.sortedDiff)(this.o,g,v).map(x=>{const F=x.toInsert.map($=>{const T=this.e++;this.g.set(T,$);const L=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const oe=new M.DisposableStore;V=this.s.converter.toInternal($.command,oe),this.j.set(T,oe)}else this.h.set(T,$.command);const j=u($.decorations),le=$.decorations&&u($.decorations.light)||j,_=$.decorations&&u($.decorations.dark)||j,pe=[le,_],ue=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,re=$.decorations&&!!$.decorations.faded,G=$.contextValue||"";return{rawResource:[T,L,pe,ue,de,re,G,V],handle:T}});return{start:x.start,deleteCount:x.deleteCount,toInsert:F}}),q=O.map(({start:x,deleteCount:F,toInsert:$})=>[x,F,$.map(T=>T.rawResource)]),Z=O.reverse();for(const{start:x,deleteCount:F,toInsert:$}of Z){const T=$.map(V=>V.handle),L=this.n.splice(x,F,...T);for(const V of L)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=g,q}dispose(){this.l=!0,this.m.fire()}}t.d=0;class d{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Oe(this,o,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Oe(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Oe(this,o,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new M.DisposableStore,this.l=g;const R=this.v.converter.toInternal(g,this.k.value);Oe(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:R})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=g;const R=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(O=>O.map(q=>this.v.converter.toInternal(q,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,o,"f").$updateSourceControl(this.t,{actionButton:R??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&i(this.p,g))return;this.o.value=new M.DisposableStore,this.p=g;const R=(g||[]).map(O=>this.v.converter.toInternal(O,this.o.value));Oe(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:R})}get selected(){return this.q}constructor(g,R,O,q,Z,x){this.u=g,this.v=O,this.w=q,this.x=Z,this.y=x,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new k.Emitter,this.onDidChangeSelection=this.s.event,this.t=d.d++,this.z=new Map,this.A=new Set,Je(this,o,R,"f"),this.f=new c(g,Oe(this,o,"f"),this.t),Oe(this,o,"f").$registerSourceControl(this.t,q,Z,x)}createResourceGroup(g,R){const O=new t(Oe(this,o,"f"),this.v,this.t,g,R),q=k.Event.once(O.onDidDispose)(()=>this.z.delete(O));return this.z.set(O,q),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const g=[],R=[];for(const[O,q]of this.z){q.dispose();const Z=O.onDidUpdateResourceStates(()=>{this.A.add(O),this.eventuallyUpdateResourceStates()});k.Event.once(O.onDidDispose)(()=>{this.A.delete(O),Z.dispose(),this.e.delete(O.handle),Oe(this,o,"f").$unregisterGroup(this.t,O.handle)}),g.push([O.handle,O.id,O.label,O.features]);const x=O._takeResourceStateSnapshot();x.length>0&&R.push([O.handle,x]),this.e.set(O.handle,O)}Oe(this,o,"f").$registerGroups(this.t,g,R),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(R=>{const O=R._takeResourceStateSnapshot();O.length!==0&&g.push([R.handle,O])}),g.length>0&&Oe(this,o,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Oe(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,d.d=0,qe([(0,D.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let a=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(g,R,O){this.l=R,this.m=O,this.g=new Map,this.h=new Map,this.j=new k.Emitter,this.e=g.getProxy(A.MainContext.MainThreadSCM),this.f=g.getProxy(A.MainContext.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const Z=this.g.get(q.sourceControlHandle);if(!Z)return q;const x=Z.getResourceGroup(q.groupHandle);return x?x.getResourceState(q.handle):q}else if(q&&q.$mid===4){const Z=this.g.get(q.sourceControlHandle);return Z?Z.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const Z=this.g.get(q.handle);return Z||q}return q}})}createSourceControl(g,R,O,q){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,R,O,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const Z=on.d++,x=new d(g,this.e,this.l,R,O,q);this.g.set(Z,x);const F=this.h.get(E.ExtensionIdentifier.toKey(g.identifier))||[];return F.push(x),this.h.set(E.ExtensionIdentifier.toKey(g.identifier),F),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const R=this.h.get(E.ExtensionIdentifier.toKey(g.identifier)),O=R&&R[R.length-1];return O&&O.inputBox}$provideOriginalResource(g,R,O){const q=n.URI.revive(R);this.m.trace("ExtHostSCM#$provideOriginalResource",g,q.toString());const Z=this.g.get(g);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(q,O)).then(x=>x||null)}$onInputBoxValueChange(g,R){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const O=this.g.get(g);return O&&O.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(g,R,O,q){this.m.trace("ExtHostSCM#$executeResourceCommand",g,R,O);const Z=this.g.get(g);if(!Z)return Promise.resolve(void 0);const x=Z.getResourceGroup(R);return x?x.$executeResourceCommand(O,q):Promise.resolve(void 0)}$validateInput(g,R,O){this.m.trace("ExtHostSCM#$validateInput",g);const q=this.g.get(g);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>q.inputBox.validateInput(R,O)).then(Z=>{if(!Z)return Promise.resolve(void 0);const x=p.MarkdownString.fromStrict(Z.message);return x?Promise.resolve([x,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};a.d=0,a=qe([je(2,N.ILogService)],a),e.ExtHostSCM=a}),define(Ie[80],Ce([1,0,5,4,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this.b=new k.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,S){return this.a.$getPassword(A,S)}store(A,S,y){return this.a.$setPassword(A,S,y)}delete(A,S){return this.a.$deletePassword(A,S)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[227],Ce([1,0,7,5,141,6,8,9]),function(te,e,n,k,D,M,C,A){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(f,s,o,u,b=n.StatusBarAlignment.Left,w){S.set(this,void 0),y.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,S,f,"f"),Je(this,y,s,"f"),this.c=N.a++,this.e=o,this.f=u,this.g=b,this.h=this.u(w)}u(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!N.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof f=="string"?this.r={fromApi:f,internal:Oe(this,y,"f").toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:Oe(this,y,"f").toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Oe(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let s;this.m?s=this.m:s=(0,D.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=N.b.get(this.o.id));const u=C.MarkdownString.fromStrict(this.l);Oe(this,S,"f").$setEntry(this.c,f,s,this.k,u,this.r?.internal,o,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=N,S=new WeakMap,y=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const s={message:f};return this.b.unshift(s),this.c(),new n.Disposable(()=>{const o=this.b.indexOf(s);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,s){this.a=f.getProxy(k.MainContext.MainThreadStatusBar),this.b=s,this.c=new E(this)}createStatusBarEntry(f,s,o,u){return new N(this.a,this.b,f,s,o,u)}setStatusBarMessage(f,s){const o=this.c.setMessage(f);let u;return typeof s=="number"?u=setTimeout(()=>o.dispose(),s):typeof s<"u"&&s.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=m}),define(Ie[81],Ce([1,0,5,4,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A,S){this.c=S,this.b=new k.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,S){this.a.$registerExtensionStorageKeysToSync(A,S)}async initializeExtensionStorage(A,S,y){const N=await this.a.$initializeExtensionStorage(A,S);let E;return N&&(E=this.d(A,S,N)),E||y}setValue(A,S,y){return this.a.$setValue(A,S,y)}$acceptValue(A,S,y){const N=this.d(A,S,y);N&&this.b.fire({shared:A,key:S,value:N})}d(A,S,y){try{return JSON.parse(y)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${A}): ${N}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ie[82],Ce([1,0,3,27,13,59,2]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let A=class{constructor(y,N,E){this.d=N,this.f=E,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return C.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,N=await this.g(y);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(C.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(y){if(this.c)return C.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return C.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([je(0,k.IExtHostInitDataService),je(1,D.ILogService),je(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ie[60],Ce([1,0,4,5,3,2,17,6,7,142,11,167,21,34,168,51,9,12,8]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(a,l,g,R){this.k=a,this._id=l,this.l=g,this.m=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const O=this;this.value={get name(){return O.m||""},get processId(){return O.b},get creationOptions(){return O.l},get exitStatus(){return O.h},get state(){return O.j},sendText(q,Z=!0){O.o(),O.k.$sendText(O._id,q,Z)},show(q){O.o(),O.k.$show(O._id,q)},hide(){O.o(),O.k.$hide(O._id)},dispose(){O.a||(O.a=!0,O.k.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(a,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:a.name,shellPath:(0,o.withNullAsUndefined)(a.shellPath),shellArgs:(0,o.withNullAsUndefined)(a.shellArgs),cwd:(0,o.withNullAsUndefined)(a.cwd),env:(0,o.withNullAsUndefined)(a.env),icon:(0,o.withNullAsUndefined)(c(a.iconPath)),color:s.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,o.withNullAsUndefined)(a.message),strictEnv:(0,o.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this.n(a.location,l?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(a.isTransient)})}async createExtensionTerminal(a,l,g,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:s.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(a,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(a,l){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in a?{viewColumn:b.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus}:void 0:a}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(a){this.m=a}setExitStatus(a,l){this.h=Object.freeze({code:a,reason:l})}setDimensions(a,l){return a===this.d&&l===this.g||a===0||l===0?!1:(this.d=a,this.g=l,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(a){this.f?(this.f(a),this.f=void 0):this.b.then(l=>{l!==a&&(this.b=Promise.resolve(a))})}}e.ExtHostTerminal=w;class P{get onProcessReady(){return this.b.event}constructor(a){this.g=a,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(a){this.g.handleInput?.(a)}resize(a,l){this.g.setDimensions?.({columns:a,rows:l})}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(a||void 0),a&&this.g.setDimensions?.(a),this.b.fire({pid:-1,cwd:""})}}let v=1,r=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(a=>a.value)}get onDidWriteTerminalData(){return this.I.event}constructor(a,l){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=l.getProxy(k.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(a),this.B({dispose:()=>{for(const[g,R]of this.g)R.shutdown(!0)}})}getDefaultShell(a){return(a?this.n:this.m)?.path||""}getDefaultShellArgs(a){return(a?this.n:this.m)?.args||[]}createExtensionTerminal(a,l){const g=new w(this.a,(0,p.generateUuid)(),a,a.name),R=new P(a.pty);return g.createExtensionTerminal(a.location,this.L(a,l).resolvedExtHostIdentifier,c(a.iconPath),t(a.color)).then(O=>{const q=this.M(O,R);this.h[O]=q}),this.f.push(g),g.value}L(a,l){if(l=l||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const g=a.location.parentTerminal;if(g){const R=this.f.find(O=>O.value===g);R&&(l.resolvedExtHostIdentifier=R._id)}}else a.location&&typeof a.location!="object"?l.location=a.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(a,l){if(!this.O(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const R=new P(l),O=this.M(a,R);this.h[a]=O}async $acceptActiveTerminalChanged(a){const l=this.b;if(a===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const g=this.O(a);g&&(this.b=g,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(a,l){const g=this.O(a);g&&this.I.fire({terminal:g.value,data:l})}async $acceptTerminalDimensions(a,l,g){const R=this.O(a);R&&R.setDimensions(l,g)&&this.G.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptTerminalMaximumDimensions(a,l,g){this.g.get(a)?.resize(l,g)}async $acceptTerminalTitleChange(a,l){const g=this.O(a);g&&(g.name=l)}async $acceptTerminalClosed(a,l,g){const R=this.Q(this.f,a);if(R!==null){const O=this.f.splice(R,1)[0];O.setExitStatus(l,g),this.C.fire(O.value)}}$acceptTerminalOpened(a,l,g,R){if(l){const Z=this.Q(this.f,l);if(Z!==null){this.f[Z]._id=a,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const O={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:M.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},q=new w(this.a,a,O,g);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(a,l){this.O(a)?._setProcessId(l)}async $startExtensionTerminal(a,l){const g=this.O(a);if(!g)return{message:(0,y.localize)(0,null,a)};g.isOpen||await new Promise(O=>{const q=this.onDidOpenTerminal(async Z=>{Z===g.value&&(q.dispose(),O())})});const R=this.g.get(a);R?R.startSendingEvents(l):this.j[a]={initialDimensions:l}}M(a,l){const g=new A.DisposableStore;g.add(l.onProcessReady(O=>this.a.$sendProcessReady(a,O.pid,O.cwd))),g.add(l.onDidChangeProperty(O=>this.a.$sendProcessProperty(a,O))),this.s.startBuffering(a,l.onProcessData),g.add(l.onProcessExit(O=>this.N(a,O))),this.g.set(a,l);const R=this.j[a];return R&&l instanceof P&&(l.startSendingEvents(R.initialDimensions),delete this.j[a]),g}$acceptProcessAckDataEvent(a,l){this.g.get(a)?.acknowledgeDataEvent(l)}$acceptProcessInput(a,l){this.g.get(a)?.input(l)}$acceptTerminalInteraction(a){const l=this.O(a);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptProcessResize(a,l,g){try{this.g.get(a)?.resize(l,g)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(a,l){this.g.get(a)?.shutdown(l)}$acceptProcessRequestInitialCwd(a){this.g.get(a)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(a,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(a){this.g.get(a)?.getCwd().then(l=>this.a.$sendProcessProperty(a,{type:"cwd",value:l}))}$acceptProcessRequestLatency(a){return Promise.resolve(a)}registerLinkProvider(a){return this.u.add(a),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(a),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(a,l,g){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,g),this.a.$registerProfileProvider(l,a.identifier.value),new S.Disposable(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(a,l,g){if(this.w.has(a))throw new Error(`Terminal quick fix provider "${a}" is already registered`);return this.w.set(a,g),this.a.$registerQuickFixProvider(a,l),new S.Disposable(()=>{this.w.delete(a),this.a.$unregisterQuickFixProvider(a)})}async $provideTerminalQuickFixes(a,l){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const R=this.w.get(a);if(!R)return;const O=await R.provideTerminalQuickFixes(l,g);if(O!==null)return O}async $createContributedProfileTerminal(a,l){const g=new m.CancellationTokenSource().token;let R=await this.v.get(a)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,l);return}this.createTerminalFromOptions(R.options,l)}}async $provideLinks(a,l){const g=this.O(a);if(!g)return[];this.y.delete(a),this.z.get(a)?.dispose(!0);const O=new m.CancellationTokenSource;this.z.set(a,O);const q=[],Z={terminal:g.value,line:l},x=[];for(const T of this.u)x.push(u.Promises.withAsyncBody(async L=>{O.token.onCancellationRequested(()=>L({provider:T,links:[]}));const V=await T.provideTerminalLinks(Z,O.token)||[];O.token.isCancellationRequested||L({provider:T,links:V})}));const F=await Promise.all(x);if(O.token.isCancellationRequested)return[];const $=new Map;for(const T of F)T&&T.links.length>0&&q.push(...T.links.map(L=>{const V={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return $.set(V.id,{provider:T.provider,link:L}),V}));return this.y.set(a,$),q}$activateLink(a,l){const g=this.y.get(a)?.get(l);!g||g.provider.handleTerminalLink(g.link)}N(a,l){this.s.stopBuffering(a),this.g.delete(a),delete this.j[a];const g=this.h[a];g&&(g.dispose(),delete this.h[a]),this.a.$sendProcessExit(a,l)}O(a){return this.P(this.f,a)}P(a,l){const g=this.Q(a,l);return g!==null?a[g]:null}Q(a,l){let g=null;return a.some((R,O)=>R._id===l?(g=O,!0):!1),g}getEnvironmentVariableCollection(a){let l=this.l.get(a.identifier.value);return l||(l=new h,this.S(a.identifier.value,l)),l}R(a,l){const g=(0,E.serializeEnvironmentVariableCollection)(l.map);this.a.$setEnvironmentVariableCollection(a,l.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(a){a.forEach(l=>{const g=l[0],R=new h(l[1]);this.S(g,R)})}$acceptDefaultProfile(a,l){const g=this.m;this.m=a,this.n=l,g?.path!==a.path&&this.J.fire(a.path)}S(a,l){this.l.set(a,l),l.onDidChangeCollection(()=>{this.R(a,l)})}};r=qe([je(1,C.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class h{get persistent(){return this.a}set persistent(a){this.a=a,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(a){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(a)}get size(){return this.map.size}replace(a,l){this.d(a,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(a,l){this.d(a,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(a,l){this.d(a,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}d(a,l){const g=this.map.get(a);(!g||g.value!==l.value||g.type!==l.type)&&(this.map.set(a,l),this.b.fire())}get(a){return this.map.get(a)}forEach(a,l){this.map.forEach((g,R)=>a.call(l,R,g,this))}[Symbol.iterator](){return this.map.entries()}delete(a){this.map.delete(a),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let i=class extends r{constructor(a){super(!1,a)}createTerminal(a,l,g){throw new N.NotSupportedError}createTerminalFromOptions(a,l){throw new N.NotSupportedError}};i=qe([je(0,C.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function c(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function t(d){return s.ThemeColor.isThemeColor(d)?d:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Ie[228],Ce([1,0,18,12,23,21,4,192,229,6,22,9,34,5,17,101,8,7,43,72,55,26]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v){"use strict";var r,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(T,L,V){this.j=V,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(p.MainContext.MainThreadTesting),this.h=new Z(this.f),this.g=new a(this.f),L.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,_=le.tests[le.tests.length-1].item.extId;return this.d.get(b.TestId.root(_))?.collection.tree.get(_)?.actual??(0,s.toItemFromContext)(j)}})}createTestController(T,L,V,j){if(this.d.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const le=new y.DisposableStore,_=le.add(new s.ExtHostTestItemCollection(L,V,this.j));_.root.label=V;const pe=new Map,ue=this.f,de={items:_.root.children,get label(){return V},set label(G){V=G,_.root.label=G,ue.$updateController(L,{label:V})},get refreshHandler(){return j},set refreshHandler(G){j=G,ue.$updateController(L,{canRefresh:!!G})},get id(){return L},createRunProfile:(G,H,oe,ve,Ae,Ue)=>{let xe=(0,S.hash)(G);for(;pe.has(xe);)xe++;return Ue!==void 0&&(0,v.checkProposedApiEnabled)(T,"testContinuousRun"),new x(this.f,pe,L,xe,G,H,oe,ve,Ae,Ue)},createTestItem(G,H,oe){return new s.TestItemImpl(L,G,H,oe)},createTestRun:(G,H,oe=!0)=>this.g.createTestRun(L,_,G,H,oe),set resolveHandler(G){_.resolveHandler=G},get resolveHandler(){return _.resolveHandler},dispose:()=>{le.dispose()}};ue.$registerTestController(L,V,!!j),le.add((0,y.toDisposable)(()=>ue.$unregisterTestController(L)));const re={controller:de,collection:_,profiles:pe};return this.d.set(L,re),le.add((0,y.toDisposable)(()=>this.d.delete(L))),le.add(_.onDidGenerateDiff(G=>ue.$publishDiff(L,G.map(P.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(T,L=M.CancellationToken.None){const V=l(T);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(V.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(le=>b.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:F[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:T.exclude?.map(le=>le.id)},L)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,L,V){return(0,n.mapFind)(this.g.trackers,le=>le.id===T?le.getCoverage(L):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(T,L,V,j){return(0,n.mapFind)(this.g.trackers,_=>_.id===T?_.getCoverage(L):void 0)?.resolveFileCoverage(V,j)??Promise.resolve([])}$configureRunProfile(T,L){this.d.get(T)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(T,L){await this.d.get(T)?.controller.refreshHandler?.(L)}$publishTestResults(T){this.results=Object.freeze(T.map(L=>(0,N.deepFreeze)(o.TestResults.to(L))).concat(this.results).sort((L,V)=>V.completedAt-L.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,L){const V=this.d.get(b.TestId.fromString(T).controllerId)?.collection;V&&(await V.expand(T,L<0?1/0:L),V.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(P.TestsDiffOp.deserialize))}async $runControllerTests(T,L){return Promise.all(T.map(V=>this.k(V,!1,L)))}async $startContinuousRun(T,L){const V=new M.CancellationTokenSource(L),j=await Promise.all(T.map(le=>this.k(le,!0,V.token)));return!L.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>L.onCancellationRequested(le)),V.dispose(!0),j}async k(T,L,V){const j=this.d.get(T.controllerId);if(!j)return{};const{collection:le,profiles:_}=j,pe=_.get(T.profileId);if(!pe)return{};const ue=T.testIds.map(H=>le.tree.get(H)).filter(E.isDefined),de=T.excludeExtIds.map(H=>j.collection.tree.get(H)).filter(E.isDefined).filter(H=>ue.some(oe=>oe.fullId.compare(H.fullId)===2));if(!ue.length)return{};const re=new u.TestRunRequest2(ue.some(H=>H.actual instanceof s.TestItemRootImpl)?void 0:ue.map(H=>H.actual),de.map(H=>H.actual),pe,L),G=(0,P.isStartControllerTests)(T)&&this.g.prepareForMainThreadTestRun(re,g.fromInternal(T,j.collection),V);try{return await pe.runHandler(re,V),{}}catch(H){return{error:String(H)}}finally{G&&(G.hasRunningTasks&&!V.isCancellationRequested&&await C.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};i=qe([je(0,f.IExtHostRpcService)],i),e.ExtHostTesting=i;const c=1e4;var t;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(t||(t={}));class d extends y.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(T,L,V){super(),this.k=T,this.l=L,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(V));const j=this.B(new k.RunOnceScheduler(()=>this.m(),c));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const L=this.k.id,V=this.k.controllerId,j=(0,m.generateUuid)(),le=new R(this.l,L,j),_=re=>(G,...H)=>{if(ue){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(G)||(this.s(G),re(G,...H))},pe=(re,G)=>{const H=G instanceof Array?G.map(o.TestMessage.from):[o.TestMessage.from(G)];if(re.uri&&re.range){const oe={range:o.Range.from(re.range),uri:re.uri};for(const ve of H)ve.location=ve.location||oe}this.l.$appendTestMessagesInRun(L,j,b.TestId.fromExtHostTestItem(re,V).toString(),H)};let ue=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:T,get coverageProvider(){return le.coverageProvider},set coverageProvider(re){le.coverageProvider=re},enqueued:_(re=>{this.l.$updateTestStateInRun(L,j,b.TestId.fromExtHostTestItem(re,V).toString(),1)}),skipped:_(re=>{this.l.$updateTestStateInRun(L,j,b.TestId.fromExtHostTestItem(re,V).toString(),5)}),started:_(re=>{this.l.$updateTestStateInRun(L,j,b.TestId.fromExtHostTestItem(re,V).toString(),2)}),errored:_((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(L,j,b.TestId.fromExtHostTestItem(re,V).toString(),6,H)}),failed:_((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(L,j,b.TestId.fromExtHostTestItem(re,V).toString(),4,H)}),passed:_((re,G)=>{this.l.$updateTestStateInRun(L,j,b.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,G)}),appendOutput:(re,G,H)=>{ue||(H&&(this.k.isIncluded(H)?this.s(H):H=void 0),this.l.$appendOutputToRun(L,j,D.VSBuffer.fromString(re),G&&o.location.from(G),H&&b.TestId.fromExtHostTestItem(H,V).toString()))},end:()=>{ue||(ue=!0,this.l.$finishedTestRunTask(L,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:de,coverage:le}),this.l.$startedTestRunTask(L,{id:j,name:T,running:!0}),de}m(){for(const{run:T}of this.f.values())T.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(T){if(!(T instanceof s.TestItemImpl))throw new w.InvalidTestItemError(T.id);if(this.g.has(b.TestId.fromExtHostTestItem(T,this.k.controllerId).toString()))return;const L=[],V=this.k.colllection.root;for(;;){const j=o.TestItem.from(T);if(L.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),T===V))break;T=T.parent||V}this.l.$addTestsToRun(this.k.controllerId,this.k.id,L)}}class a{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,L,V){return this.f(T,L,V)}cancelRunById(T){for(const L of this.c.values())if(L.id===T){L.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,L,V,j,le){const _=this.c.get(V);if(_)return _.createRun(j);const pe=g.fromPublic(T,L,V,le),ue=l(V);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!V.continuous,profile:ue&&{group:F[ue.kind],id:ue.profileId},exclude:V.exclude?.map(re=>b.TestId.fromExtHostTestItem(re,L.root.id).toString())??[],id:pe.id,include:V.include?.map(re=>b.TestId.fromExtHostTestItem(re,L.root.id).toString())??[L.root.id],persist:le});const de=this.f(V,pe);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(pe.id),de.dispose()}),de.createRun(j)}f(T,L,V){const j=new d(L,this.d,V);return this.c.set(T,j),j.onEnd(()=>this.c.delete(T)),j}}e.TestRunCoordinator=a;const l=$=>{if(!!$.profile){if(!($.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class g{static fromPublic(T,L,V,j){return new g(T,(0,m.generateUuid)(),V.include?.map(le=>b.TestId.fromExtHostTestItem(le,T).toString())??[T],V.exclude?.map(le=>b.TestId.fromExtHostTestItem(le,T).toString())??[],j,L)}static fromInternal(T,L){return new g(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,L)}constructor(T,L,V,j,le,_){this.controllerId=T,this.id=L,this.isPersisted=le,this.colllection=_,this.c=V.map(pe=>pe+"\0"),this.d=j.map(pe=>pe+"\0")}isIncluded(T){const L=b.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const V of this.d)if(L===V||L.startsWith(V))return!1;for(const V of this.c)if(L===V||L.startsWith(V))return!0;return!1}}e.TestRunDto=g;class R{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,L,V){this.f=T,this.g=L,this.h=V}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(L){throw this.d=void 0,L}}async resolveFileCoverage(T,L){const V=await this.d;let j=V?.[T];return!this.c||!V||!j?[]:(j.detailedCoverage||(j=V[T]=await this.c.resolveFileCoverage?.(j,L)??j),j.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class O{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,o.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const L=b.TestId.parentId(T.item.extId);if(L&&this.g.has(L.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:L,f:V}=this;return{get added(){return[...T].map(j=>j.revived)},get updated(){return[...L].map(j=>j.revived)},get removed(){return[...V].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class q extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,L){return{...T,revived:o.TestItem.toPlain(T.item),depth:L?L.depth+1:0,children:new Set}}o(){return new O(this.q)}}class Z{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(L=>L.revived)},dispose:(0,A.once)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new q;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class x{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?o.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,L,V,j,le,_,pe,ue=!1,de=void 0,re=!1){this.controllerId=V,this.profileId=j,this.d=le,this.kind=_,this.runHandler=pe,this.f=ue,this._tag=de,this.g=re,r.set(this,void 0),h.set(this,void 0),Je(this,r,T,"f"),Je(this,h,L,"f"),L.set(j,this);const G=F[_];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Oe(this,r,"f").$publishTestRunProfile({profileId:j,controllerId:V,tag:de?o.TestTag.namespace(this.controllerId,de.id):null,label:le,group:G,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:re})}dispose(){Oe(this,h,"f")?.delete(this.profileId)&&(Je(this,h,void 0,"f"),Oe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,r=new WeakMap,h=new WeakMap;const F={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ie[230],Ce([1,0,18,4,5,102,8,7]),function(te,e,n,k,D,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,E){this.i=E,this.a=new k.Emitter,this.b=new k.Emitter,this.c=new k.Emitter,this.d=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const E=this.i.allEditors();return N?E:E.map(m=>m.value)}async showTextDocument(N,E,m){let p;typeof E=="number"?p={position:C.ViewColumn.from(E),preserveFocus:m}:typeof E=="object"?p={position:C.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?C.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(N.uri,p),s=f&&this.i.getEditor(f);if(s)return s.value;throw f?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,E){return new M.TextEditorDecorationType(this.h,N,E).value}$acceptEditorPropertiesChanged(N,E){const m=this.i.getEditor(N);if(!m)throw new Error("unknown text editor");if(E.options&&m._acceptOptions(E.options),E.selections){const p=E.selections.selections.map(C.Selection.to);m._acceptSelections(p)}if(E.visibleRanges){const p=n.coalesce(E.visibleRanges.map(C.Range.to));m._acceptVisibleRanges(p)}if(E.options&&this.b.fire({textEditor:m.value,options:{...E.options,lineNumbers:C.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const p=A.TextEditorSelectionChangeKind.fromValue(E.selections.source),f=E.selections.selections.map(C.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:p})}if(E.visibleRanges){const p=n.coalesce(E.visibleRanges.map(C.Range.to));this.c.fire({textEditor:m.value,visibleRanges:p})}}$acceptEditorPositionData(N){for(const E in N){const m=this.i.getEditor(E);if(!m)throw new Error("Unknown text editor");const p=C.ViewColumn.to(N[E]);m.value.viewColumn!==p&&(m._acceptViewColumn(p),this.d.fire({textEditor:m.value,viewColumn:p}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(Ie[231],Ce([1,0,2,3,5,6,7,8,25,9]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class N{constructor(p,f){this.b=new Map,this.c=new Map,this.a=p.getProxy(D.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&S.ExtensionIdentifier.equals(o,this.b.get(s.source)?.extension)){const u=s.uri===void 0?void 0:n.URI.revive(s.uri);return this.c.get(s.source)?.get(E(u))?.get(s.handle)}else return;return s}})}async $getTimeline(p,f,s,o){return this.b.get(p)?.provider.provideTimeline(n.URI.revive(f),s,o)}registerTimelineProvider(p,f,s,o){const u=new M.DisposableStore,b=this.d(f.id,o,u).bind(this);let w;f.onDidChange&&(w=f.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:f.id}),this));const P=this.c;return this.f({...f,scheme:p,onDidChange:void 0,async provideTimeline(v,r,h){r?.resetCache&&(u.clear(),P.get(f.id)?.clear());const i=await f.provideTimeline(v,r,h);if(i==null)return;const c=b(v,r);return{...i,source:f.id,items:i.items.map(c)}},dispose(){for(const v of P.values())v.get(f.id)?.clear();w?.dispose(),u.dispose()}},s)}d(p,f,s){return(o,u)=>{let b;if(u?.cacheResults){let w=this.c.get(p);w===void 0&&(w=new Map,this.c.set(p,w));const P=E(o);b=w.get(P),b===void 0&&(b=new Map,w.set(P,b))}return w=>{const{iconPath:P,...v}=w,r=`${p}|${w.id??w.timestamp}`;b?.set(r,w);let h,i,c;w.iconPath&&(P instanceof C.ThemeIcon?c={id:P.id,color:P.color}:n.URI.isUri(P)?(h=P,i=P):{light:h,dark:i}=P);let t;return C.MarkdownString.isMarkdownString(v.tooltip)?t=A.MarkdownString.from(v.tooltip):(0,y.isString)(v.tooltip)?t=v.tooltip:C.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=A.MarkdownString.from(v.detail)):(0,y.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=v.detail),{...v,id:v.id??void 0,handle:r,source:p,command:w.command?f.toInternal(w.command,s):void 0,icon:h,iconDark:i,themeIcon:c,tooltip:t,accessibilityInformation:w.accessibilityInformation}}}}f(p,f){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:f}),(0,M.toDisposable)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=N;function E(m){return m?.toString()}}),define(Ie[232],Ce([1,0,6,16,2,5]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,N,E){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=E.schemes.find(p=>!C.a.has(p));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,N),this.b.$registerUriOpener(y,E.schemes,S,E.label),(0,n.toDisposable)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(S,y,N){const E=this.c.get(S);if(!E)throw new Error(`Unknown opener with id: ${S}`);const m=D.URI.revive(y);return E.canOpenExternalUri(m,N)}async $openUri(S,y,N){const E=this.c.get(S);if(!E)throw new Error(`Unknown opener id: '${S}'`);return E.openExternalUri(D.URI.revive(y.resolvedUri),{sourceUri:D.URI.revive(y.sourceUri)},N)}}e.ExtHostUriOpeners=C,C.a=new Set([k.Schemas.http,k.Schemas.https])}),define(Ie[233],Ce([1,0,5,2,6,11,25]),function(te,e,n,k,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(y){this.c=new Set,this.d=new Map,this.b=y.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(y,N){if(this.c.has(C.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const E=A.a++;return this.c.add(C.ExtensionIdentifier.toKey(y)),this.d.set(E,N),this.b.$registerUriHandler(E,y),(0,D.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(y)),this.d.delete(E),this.b.$unregisterUriHandler(E)})}$handleExternalUri(y,N){const E=this.d.get(y);if(!E)return Promise.resolve(void 0);try{E.handleUri(k.URI.revive(N))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(y){return k.URI.revive(await this.b.$createAppUri(y))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[61],Ce([1,0,4,16,22,2,155,177,73,5]),function(te,e,n,k,D,M,C,A,S,y){"use strict";var N,E,m,p,f,s,o,u,b,w,P,v,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(O,q,Z,x,F,$,T){N.set(this,void 0),E.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),s.set(this,void 0),o.set(this,""),u.set(this,void 0),b.set(this,!1),w.set(this,!1),P.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new n.Emitter),this._onDidDispose=Oe(this,r,"f").event,Je(this,N,O,"f"),Je(this,E,q,"f"),Je(this,u,Z,"f"),Je(this,p,x,"f"),Je(this,f,F,"f"),Je(this,s,$,"f"),Je(this,P,i($),"f"),Je(this,v,c($),"f"),Je(this,m,T,"f")}dispose(){Je(this,b,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(O){return Je(this,w,!0,"f"),(0,S.asWebviewUri)(O,Oe(this,p,"f"))}get cspSource(){const O=Oe(this,s,"f").extensionLocation;if(O.scheme===k.Schemas.https||O.scheme===k.Schemas.http){let q=O.toString();return q.endsWith("/")||(q+="/"),q+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Oe(this,o,"f")}set html(O){this.a(),Oe(this,o,"f")!==O&&(Je(this,o,O,"f"),Oe(this,v,"f")&&!Oe(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(O)&&(Je(this,w,!0,"f"),Oe(this,m,"f").report("Webview vscode-resource: uris",Oe(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,E,"f").$setHtml(Oe(this,N,"f"),this.b(O)))}get options(){return this.a(),Oe(this,u,"f")}set options(O){this.a(),D.equals(Oe(this,u,"f"),O)||Oe(this,E,"f").$setOptions(Oe(this,N,"f"),a(Oe(this,s,"f"),Oe(this,f,"f"),O)),Je(this,u,O,"f")}async postMessage(O){if(Oe(this,b,"f"))return!1;const q=(0,A.serializeWebviewMessage)(O,{serializeBuffersForPostMessage:Oe(this,P,"f")});return Oe(this,E,"f").$postMessage(Oe(this,N,"f"),q.message,...q.buffers)}a(){if(Oe(this,b,"f"))throw new Error("Webview is disposed")}b(O){if(!Oe(this,v,"f"))return O;const q=Oe(this,s,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,Z=Oe(this,s,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Oe(this,s,"f").extensionLocation.authority:void 0;return O.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,F,$,T,L,V)=>{const j=M.URI.from({scheme:T||"file",path:decodeURIComponent(L)}),le=(0,S.asWebviewUri)(j,{isRemote:q,authority:Z}).toString();return`${F}${le}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,F,$,T,L,V)=>{const j=M.URI.from({scheme:T||"file",path:decodeURIComponent(L)}),le=(0,S.asWebviewUri)(j,{isRemote:q,authority:Z}).toString();return`${F}${le}${V}`})}}e.ExtHostWebview=h,N=new WeakMap,E=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,s=new WeakMap,o=new WeakMap,u=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,v=new WeakMap,r=new WeakMap;function i(R){try{const O=(0,C.normalizeVersion)((0,C.parseVersion)(R.engines.vscode));return!!O&&O.majorBase>=1&&O.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;function c(R){try{const O=(0,C.normalizeVersion)((0,C.parseVersion)(R.engines.vscode));return O?O.majorBase<1||O.majorBase===1&&O.minorBase<60:!1}catch{return!1}}class t{constructor(O,q,Z,x,F){this.c=q,this.d=Z,this.e=x,this.f=F,this.b=new Map,this.a=O.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(O,q,Z){const x=this.g(O);if(x){const{message:F}=(0,A.deserializeWebviewMessage)(q,Z.value);x._onMessageEmitter.fire(F)}}$onMissingCsp(O,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(O,q,Z){const x=new h(O,this.a,l(q),this.c,this.d,Z,this.f);return this.b.set(O,x),x._onDidDispose(()=>{this.b.delete(O)}),x}deleteWebview(O){this.b.delete(O)}g(O){return this.b.get(O)}}e.ExtHostWebviews=t;function d(R){return{id:R.identifier,location:R.extensionLocation}}e.toExtensionData=d;function a(R,O,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||g(R,O)}}e.serializeWebviewOptions=a;function l(R){return{enableCommandUris:R.enableCommandUris,enableScripts:R.enableScripts,enableForms:R.enableForms,portMapping:R.portMapping,localResourceRoots:R.localResourceRoots?.map(O=>M.URI.from(O))}}function g(R,O){return[...(O?.getWorkspaceFolders()||[]).map(q=>q.uri),R.extensionLocation]}}),define(Ie[234],Ce([1,0,21,229,6,16,24,2,8,61,53,5,7]),function(te,e,n,k,D,M,C,A,S,y,N,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(h,i){this.document=h,this.b=i,this.a=1,this.c=new N.Cache("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,i){await this.f(h).undo(),i||this.disposeBackup()}async redo(h,i){await this.f(h).redo(),i||this.disposeBackup()}disposeEdits(h){for(const i of h)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=v(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const i=this.c.get(h,0);if(!i)throw new Error("No edit found");return i}}class f{constructor(){this.a=new Map}get(h,i){return this.a.get(this.b(h,i))}add(h,i,c){const t=this.b(h,i.uri);if(this.a.has(t))throw new Error(`Document already exists for viewType:${h} resource:${i.uri}`);const d=new p(i,c);return this.a.set(t,d),d}delete(h,i){const c=this.b(h,i.uri);this.a.delete(c)}b(h,i){return`${h}@@@${i}`}}var s;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(h,i,c){return this.b(0,h,i,c)}addCustomProvider(h,i,c){return this.b(1,h,i,c)}get(h){return this.a.get(h)}b(h,i,c,t){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:h,extension:c,provider:t}),new m.Disposable(()=>this.a.delete(i))}}class u{constructor(h,i,c,t,d){this.d=i,this.f=c,this.g=t,this.h=d,this.b=new o,this.c=new f,this.a=h.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(h,i,c,t){const d=new D.DisposableStore;return w(c)?(d.add(this.b.addTextProvider(i,h,c)),this.a.$registerTextEditorProvider((0,y.toExtensionData)(h),i,t.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(h))):(d.add(this.b.addCustomProvider(i,h,c)),b(c)&&d.add(c.onDidChangeCustomDocument(a=>{const l=this.i(i,a.document.uri);if(P(a)){const g=l.addEdit(a);this.a.$onDidEdit(a.document.uri,i,g,a.label)}else this.a.$onContentChange(a.document.uri,i)})),this.a.$registerCustomEditorProvider((0,y.toExtensionData)(h),i,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(h))),m.Disposable.from(d,new m.Disposable(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(h,i,c,t,d){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${i}'`);const l=A.URI.revive(h),g=await a.provider.openCustomDocument(l,{backupId:c,untitledDocumentData:t?.buffer},d);let R;return b(a.provider)&&this.f&&(R=this.f.workspaceValue(a.extension)??this.f.globalValue(a.extension)),this.c.add(i,g,R),{editable:b(a.provider)}}async $disposeCustomDocument(h,i){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${i}'`);const t=A.URI.revive(h),{document:d}=this.i(i,t);this.c.delete(i,d),d.dispose()}async $resolveCustomEditor(h,i,c,t,d,a){console.log("xxxx");const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);const g=S.ViewColumn.to(d),R=this.g.createNewWebview(i,t.contentOptions,l.extension),O=this.h.createNewWebviewPanel(i,c,t.title,g,t.options,R,!0),q=A.URI.revive(h);switch(l.type){case 1:{const{document:Z}=this.i(c,q);return l.provider.resolveCustomEditor(Z,O,a)}case 0:{const Z=this.d.getDocument(q);return l.provider.resolveCustomTextEditor(Z,O,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,i,c){this.i(i,h).disposeEdits(c)}async $onMoveCustomEditor(h,i,c){const t=this.b.get(c);if(!t)throw new Error(`No provider found for '${c}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const d=this.h.getWebviewPanel(h);if(!d)throw new Error("No webview found");const a=A.URI.revive(i),l=this.d.getDocument(a);await t.provider.moveCustomTextEditor(l,d,n.CancellationToken.None)}async $undo(h,i,c,t){return this.i(i,h).undo(c,t)}async $redo(h,i,c,t){return this.i(i,h).redo(c,t)}async $revert(h,i,c){const t=this.i(i,h);await this.j(i).revertCustomDocument(t.document,c),t.disposeBackup()}async $onSave(h,i,c){const t=this.i(i,h);await this.j(i).saveCustomDocument(t.document,c),t.disposeBackup()}async $onSaveAs(h,i,c,t){const d=this.i(i,h);return this.j(i).saveCustomDocumentAs(d.document,A.URI.revive(c),t)}async $backup(h,i,c){const t=this.i(i,h),a=await this.j(i).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},c);return t.updateBackup(a),a.id}i(h,i){const c=this.c.get(h,A.URI.revive(i));if(!c)throw new Error("No custom document found");return c}j(h){const c=this.b.get(h)?.provider;if(!c||!b(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=u;function b(r){return!!r.onDidChangeCustomDocument}function w(r){return typeof r.resolveCustomTextEditor=="function"}function P(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function v(r){const h=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,k.hash)(h)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[235],Ce([1,0,4,6,2,34,8,61,5,7]),function(te,e,n,k,D,M,C,A,S,y){"use strict";var N,E,m,p,f,s,o,u,b,w,P,v,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends k.Disposable{constructor(d,a,l,g){super(),N.set(this,void 0),E.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),s.set(this,void 0),o.set(this,void 0),u.set(this,void 0),b.set(this,!0),w.set(this,void 0),P.set(this,!1),v.set(this,this.B(new n.Emitter)),this.onDidDispose=Oe(this,v,"f").event,r.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Oe(this,r,"f").event,Je(this,N,d,"f"),Je(this,E,a,"f"),Je(this,p,l,"f"),Je(this,m,g.viewType,"f"),Je(this,f,g.panelOptions,"f"),Je(this,u,g.viewColumn,"f"),Je(this,s,g.title,"f"),Je(this,w,g.active,"f")}dispose(){Oe(this,P,"f")||(Je(this,P,!0,"f"),Oe(this,v,"f").fire(),Oe(this,E,"f").$disposeWebview(Oe(this,N,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,p,"f")}get viewType(){return this.c(),Oe(this,m,"f")}get title(){return this.c(),Oe(this,s,"f")}set title(d){this.c(),Oe(this,s,"f")!==d&&(Je(this,s,d,"f"),Oe(this,E,"f").$setTitle(Oe(this,N,"f"),d))}get iconPath(){return this.c(),Oe(this,o,"f")}set iconPath(d){this.c(),Oe(this,o,"f")!==d&&(Je(this,o,d,"f"),Oe(this,E,"f").$setIconPath(Oe(this,N,"f"),D.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,u,"f")=="number"&&Oe(this,u,"f")<0))return Oe(this,u,"f")}get active(){return this.c(),Oe(this,w,"f")}get visible(){return this.c(),Oe(this,b,"f")}_updateViewState(d){Oe(this,P,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Je(this,w,d.active,"f"),Je(this,b,d.visible,"f"),Je(this,u,d.viewColumn,"f"),Oe(this,r,"f").fire({webviewPanel:this}))}reveal(d,a){this.c(),Oe(this,E,"f").$reveal(Oe(this,N,"f"),{viewColumn:typeof d>"u"?void 0:C.ViewColumn.from(d),preserveFocus:!!a})}c(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,E=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,s=new WeakMap,o=new WeakMap,u=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,v=new WeakMap,r=new WeakMap;class i{static c(){return(0,M.generateUuid)()}constructor(d,a,l){this.g=a,this.h=l,this.e=new Map,this.f=new Map,this.d=d.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,a,l,g,R={}){const O=typeof g=="object"?g.viewColumn:g,q={viewColumn:C.ViewColumn.from(O),preserveFocus:typeof g=="object"&&!!g.preserveFocus},Z=(0,A.shouldSerializeBuffersForPostMessage)(d),x=i.c();this.d.$createWebviewPanel((0,A.toExtensionData)(d),x,a,{title:l,panelOptions:c(R),webviewOptions:(0,A.serializeWebviewOptions)(d,this.h,R),serializeBuffersForPostMessage:Z},q);const F=this.g.createNewWebview(x,R,d);return this.createNewWebviewPanel(x,a,l,O,R,F,!0)}$onDidChangeWebviewPanelViewStates(d){const a=Object.keys(d);a.sort((l,g)=>{const R=d[l],O=d[g];return R.active?1:O.active?-1:+R.visible-+O.visible});for(const l of a){const g=this.getWebviewPanel(l);if(!g)continue;const R=d[l];g._updateViewState({active:R.active,visible:R.visible,viewColumn:C.ViewColumn.to(R.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.e.delete(d),this.g.deleteWebview(d)}registerWebviewPanelSerializer(d,a,l){if(this.f.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.f.set(a,{serializer:l,extension:d}),this.d.$registerSerializer(a,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(d)}),new y.Disposable(()=>{this.f.delete(a),this.d.$unregisterSerializer(a)})}async $deserializeWebviewPanel(d,a,l,g){const R=this.f.get(a);if(!R)throw new Error(`No serializer found for '${a}'`);const{serializer:O,extension:q}=R,Z=this.g.createNewWebview(d,l.webviewOptions,q),x=this.createNewWebviewPanel(d,a,l.title,g,l.panelOptions,Z,l.active);await O.deserializeWebviewPanel(x,l.state)}createNewWebviewPanel(d,a,l,g,R,O,q){const Z=new h(d,this.d,O,{viewType:a,title:l,viewColumn:g,panelOptions:R,active:q});return this.e.set(d,Z),Z}getWebviewPanel(d){return this.e.get(d)}}e.ExtHostWebviewPanels=i;function c(t){return{enableFindWidget:t.enableFindWidget,retainContextWhenHidden:t.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[236],Ce([1,0,4,6,61,8,5,7]),function(te,e,n,k,D,M,C,A){"use strict";var S,y,N,E,m,p,f,s,o,u,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends k.Disposable{constructor(r,h,i,c,t,d){super(),S.set(this,void 0),y.set(this,void 0),N.set(this,void 0),E.set(this,void 0),m.set(this,!1),p.set(this,void 0),f.set(this,void 0),s.set(this,void 0),o.set(this,void 0),u.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Oe(this,u,"f").event,b.set(this,this.B(new n.Emitter)),this.onDidDispose=Oe(this,b,"f").event,Je(this,N,i,"f"),Je(this,f,c,"f"),Je(this,S,r,"f"),Je(this,y,h,"f"),Je(this,E,t,"f"),Je(this,p,d,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,b,"f").fire(),Oe(this,E,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,f,"f")}set title(r){this.a(),Oe(this,f,"f")!==r&&(Je(this,f,r,"f"),Oe(this,y,"f").$setWebviewViewTitle(Oe(this,S,"f"),r))}get description(){return this.a(),Oe(this,s,"f")}set description(r){this.a(),Oe(this,s,"f")!==r&&(Je(this,s,r,"f"),Oe(this,y,"f").$setWebviewViewDescription(Oe(this,S,"f"),r))}get visible(){return Oe(this,p,"f")}get webview(){return Oe(this,E,"f")}get viewType(){return Oe(this,N,"f")}_setVisible(r){r===Oe(this,p,"f")||Oe(this,m,"f")||(Je(this,p,r,"f"),Oe(this,u,"f").fire())}get badge(){return this.a(),Oe(this,o,"f")}set badge(r){this.a(),!(r?.value===Oe(this,o,"f")?.value&&r?.tooltip===Oe(this,o,"f")?.tooltip)&&(Je(this,o,M.ViewBadge.from(r),"f"),Oe(this,y,"f").$setWebviewViewBadge(Oe(this,S,"f"),r))}show(r){this.a(),Oe(this,y,"f").$show(Oe(this,S,"f"),!!r)}a(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,N=new WeakMap,E=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,s=new WeakMap,o=new WeakMap,u=new WeakMap,b=new WeakMap;class P{constructor(r,h){this.d=h,this.b=new Map,this.c=new Map,this.a=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,h,i,c){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:i,extension:r}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(r),h,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(r)}),new A.Disposable(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(r,h,i,c,t){const d=this.b.get(h);if(!d)throw new Error(`No view provider found for '${h}'`);const{provider:a,extension:l}=d,g=this.d.createNewWebview(r,{},l),R=new w(r,this.a,h,i,g,!0);this.c.set(r,R),await a.resolveWebviewView(R,{state:c},t)}async $onDidChangeWebviewViewVisibility(r,h){this.e(r)._setVisible(h)}async $disposeWebviewView(r){const h=this.e(r);this.c.delete(r),h.dispose(),this.d.deleteWebview(r)}e(r){const h=this.c.get(r);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=P}),define(Ie[104],Ce([1,0,4,5,2,16,10,3,17]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class an{get state(){return this.d}constructor(E){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=E.getProxy(k.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(E){E!==this.d.focused&&(this.d={...this.d,focused:E},this.c.fire(this.d))}openUri(E,m){let p;if(typeof E=="string"){p=E;try{E=D.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,C.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,p,m)}async asExternalUri(E,m){if((0,C.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(E,m);return D.URI.from(p)}};y.a={focused:!0},y=qe([je(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[237],Ce([1,0,207,27,17]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(A,S){super(A,S)}f(A,S,y){S.apply(console,y)}};M=qe([je(0,D.IExtHostRpcService),je(1,k.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ie[238],Ce([1,0,12,23,21,11,4,6,126,201,44]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(R,O){try{return JSON.stringify(R,O)}catch{return"null"}}const p="$$ref$$",f={[p]:-1};class s{constructor(O,q){this.jsonString=O,this.referencedBuffers=q}}function o(R,O=null,q=!1){const Z=[];return{jsonString:(q?m:JSON.stringify)(R,(F,$)=>{if(typeof $>"u")return f;if(typeof $=="object"){if($ instanceof k.VSBuffer){const T=Z.push($)-1;return{[p]:T}}if(O)return O(F,$)}return $}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=o;function u(R,O,q){return JSON.parse(R,(Z,x)=>{if(x){const F=x[p];if(typeof F=="number")return O[F];if(q&&x.$mid===1)return q.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=u;function b(R,O){return JSON.stringify(R,O)}function w(R){return R?(O,q)=>q&&q.$mid===1?R.transformOutgoing(q):q:null}var P;(function(R){R[R.LocalSide=0]="LocalSide",R[R.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(R){R[R.Responsive=0]="Responsive",R[R.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},h=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class c extends A.Disposable{constructor(O,q=null,Z=null){super(),this[E]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=q,this.g=Z,this.h=w(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,F=N.ProxyIdentifier.count;x<F;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(O=>{this.s[O].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(O){this.u===0&&(this.v=Date.now()+c.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(O){this.v=Date.now()+c.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(O){this.t!==O&&(this.t=O,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(O){return this.g?(0,S.transformIncomingURIs)(O,this.g):O}getProxy(O){const{nid:q,sid:Z}=O;return this.l[q]||(this.l[q]=this.F(q,Z)),this.l[q]}F(O,q){const Z={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...$)=>this.O(O,F,$)),F===i?q:x[F])};return new Proxy(Object.create(null),Z)}set(O,q){return this.k[O.nid]=q,q}assertRegistered(O){for(let q=0,Z=O.length;q<Z;q++){const x=O[q];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(O){if(this.j)return;const q=O.byteLength,Z=t.read(O,0),x=Z.readUInt8(),F=Z.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:T,args:L}=a.deserializeRequestJSONArgs(Z);this.g&&(L=(0,S.transformIncomingURIs)(L,this.g)),this.H(q,F,$,T,L,x===2);break}case 3:case 4:{let{rpcId:$,method:T,args:L}=a.deserializeRequestMixedArgs(Z);this.g&&(L=(0,S.transformIncomingURIs)(L,this.g)),this.H(q,F,$,T,L,x===4);break}case 5:{this.f?.logIncoming(q,F,0,"ack"),this.z(F);break}case 6:{this.I(q,F);break}case 7:{this.J(q,F,void 0);break}case 9:{let $=a.deserializeReplyOKJSON(Z);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.J(q,F,$);break}case 10:{const $=a.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(q,F,$);break}case 8:{const $=a.deserializeReplyOKVSBuffer(Z);this.J(q,F,$);break}case 11:{let $=a.deserializeReplyErrError(Z);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.L(q,F,$);break}case 12:{this.L(q,F,void 0);break}default:console.error("received unexpected message"),console.error(O)}}H(O,q,Z,x,F,$){this.f?.logIncoming(O,q,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(Z)}.${x}(`,F);const T=String(q);let L,V;if($){const le=new D.CancellationTokenSource;F.push(le.token),L=this.M(Z,x,F),V=()=>le.cancel()}else L=this.M(Z,x,F),V=r;this.p[T]=V;const j=a.serializeAcknowledged(q);this.f?.logOutgoing(j.byteLength,q,1,"ack"),this.c.send(j),L.then(le=>{delete this.p[T];const _=a.serializeReplyOK(q,le,this.h);this.f?.logOutgoing(_.byteLength,q,1,"reply:",le),this.c.send(_)},le=>{delete this.p[T];const _=a.serializeReplyErr(q,le);this.f?.logOutgoing(_.byteLength,q,1,"replyErr:",le),this.c.send(_)})}I(O,q){this.f?.logIncoming(O,q,1,"receiveCancel");const Z=String(q);this.p[Z]?.()}J(O,q,Z){this.f?.logIncoming(O,q,0,"receiveReply:",Z);const x=String(q);if(!this.s.hasOwnProperty(x))return;const F=this.s[x];delete this.s[x],F.resolveOk(Z)}L(O,q,Z){this.f?.logIncoming(O,q,0,"receiveReplyErr:",Z);const x=String(q);if(!this.s.hasOwnProperty(x))return;const F=this.s[x];delete this.s[x];let $;Z&&(Z.$isError?($=new Error,$.name=Z.name,$.message=Z.message,$.stack=Z.stack):$=Z),F.resolveErr($)}M(O,q,Z){try{return Promise.resolve(this.N(O,q,Z))}catch(x){return Promise.reject(x)}}N(O,q,Z){const x=this.k[O];if(!x)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(O));const F=x[q];if(typeof F!="function")throw new Error("Unknown method "+q+" on actor "+(0,N.getStringIdentifierForProxy)(O));return F.apply(x,Z)}O(O,q,Z){if(this.j)return new y.CanceledLazyPromise;let x=null;if(Z.length>0&&D.CancellationToken.isCancellationToken(Z[Z.length-1])&&(x=Z.pop()),x&&x.isCancellationRequested)return Promise.reject(M.canceled());const F=a.serializeRequestArguments(Z,this.h),$=++this.m,T=String($),L=new y.LazyPromise;x&&x.onCancellationRequested(()=>{const j=a.serializeCancel($);this.f?.logOutgoing(j.byteLength,$,0,"cancel"),this.c.send(a.serializeCancel($))}),this.s[T]=L,this.y($);const V=a.serializeRequest($,O,q,F,!!x);return this.f?.logOutgoing(V.byteLength,$,0,`request: ${(0,N.getStringIdentifierForProxy)(O)}.${q}(`,Z),this.c.send(V),L}}e.RPCProtocol=c,E=h,c.a=3*1e3;class t{static alloc(O,q,Z){const x=new t(k.VSBuffer.alloc(Z+1+4),0);return x.writeUInt8(O),x.writeUInt32(q),x}static read(O,q){return new t(O,q)}get buffer(){return this.a}constructor(O,q){this.a=O,this.b=q}static sizeUInt8(){return 1}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+O).toString();return this.b+=O,Z}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+O).toString();return this.b+=O,Z}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+O);return this.b+=O,q}static sizeMixedArray(O){let q=0;q+=1;for(let Z=0,x=O.length;Z<x;Z++){const F=O[Z];switch(q+=1,F.type){case 1:q+=this.sizeLongString(F.value);break;case 2:q+=this.sizeVSBuffer(F.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)q+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return q}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let q=0,Z=O.length;q<Z;q++){const x=O[q];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const q=new Array(O);for(let Z=0;Z<O;Z++)switch(this.readUInt8()){case 1:q[Z]=this.readLongString();break;case 2:q[Z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),$=this.readLongString(),T=[];for(let L=0;L<F;++L)T.push(this.readVSBuffer());q[Z]=new N.SerializableObjectWithBuffers(u($,T,null));break}case 4:q[Z]=void 0;break}return q}}t.sizeUInt32=4;var d;(function(R){R[R.Simple=0]="Simple",R[R.Mixed=1]="Mixed"})(d||(d={}));class a{static a(O){for(let q=0,Z=O.length;q<Z;q++)if(O[q]instanceof k.VSBuffer||O[q]instanceof N.SerializableObjectWithBuffers||typeof O[q]>"u")return!0;return!1}static serializeRequestArguments(O,q){if(this.a(O)){const Z=[];for(let x=0,F=O.length;x<F;x++){const $=O[x];if($ instanceof k.VSBuffer)Z[x]={type:2,value:$};else if(typeof $>"u")Z[x]={type:4};else if($ instanceof N.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:L}=o($.value,q);Z[x]={type:3,value:k.VSBuffer.fromString(T),buffers:L}}else Z[x]={type:1,value:k.VSBuffer.fromString(b($,q))}}return{type:1,args:Z}}return{type:0,args:b(O,q)}}static serializeRequest(O,q,Z,x,F){switch(x.type){case 0:return this.b(O,q,Z,x.args,F);case 1:return this.c(O,q,Z,x.args,F)}}static b(O,q,Z,x,F){const $=k.VSBuffer.fromString(Z),T=k.VSBuffer.fromString(x);let L=0;L+=t.sizeUInt8(),L+=t.sizeShortString($),L+=t.sizeLongString(T);const V=t.alloc(F?2:1,O,L);return V.writeUInt8(q),V.writeShortString($),V.writeLongString(T),V.buffer}static deserializeRequestJSONArgs(O){const q=O.readUInt8(),Z=O.readShortString(),x=O.readLongString();return{rpcId:q,method:Z,args:JSON.parse(x)}}static c(O,q,Z,x,F){const $=k.VSBuffer.fromString(Z);let T=0;T+=t.sizeUInt8(),T+=t.sizeShortString($),T+=t.sizeMixedArray(x);const L=t.alloc(F?4:3,O,T);return L.writeUInt8(q),L.writeShortString($),L.writeMixedArray(x),L.buffer}static deserializeRequestMixedArgs(O){const q=O.readUInt8(),Z=O.readShortString(),x=O.readMixedArray(),F=new Array(x.length);for(let $=0,T=x.length;$<T;$++){const L=x[$];typeof L=="string"?F[$]=JSON.parse(L):F[$]=L}return{rpcId:q,method:Z,args:F}}static serializeAcknowledged(O){return t.alloc(5,O,0).buffer}static serializeCancel(O){return t.alloc(6,O,0).buffer}static serializeReplyOK(O,q,Z){if(typeof q>"u")return this.d(O);if(q instanceof k.VSBuffer)return this.e(O,q);if(q instanceof N.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=o(q.value,Z,!0);return this.g(O,x,F)}else return this.f(O,m(q,Z))}static d(O){return t.alloc(7,O,0).buffer}static e(O,q){let Z=0;Z+=t.sizeVSBuffer(q);const x=t.alloc(8,O,Z);return x.writeVSBuffer(q),x.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,q){const Z=k.VSBuffer.fromString(q);let x=0;x+=t.sizeLongString(Z);const F=t.alloc(9,O,x);return F.writeLongString(Z),F.buffer}static g(O,q,Z){const x=k.VSBuffer.fromString(q);let F=0;F+=t.sizeUInt32,F+=t.sizeLongString(x);for(const T of Z)F+=t.sizeVSBuffer(T);const $=t.alloc(10,O,F);$.writeUInt32(Z.length),$.writeLongString(x);for(const T of Z)$.writeBuffer(T);return $.buffer}static deserializeReplyOKJSON(O){const q=O.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(O,q){const Z=O.readUInt32(),x=O.readLongString(),F=[];for(let $=0;$<Z;++$)F.push(O.readVSBuffer());return new N.SerializableObjectWithBuffers(u(x,F,q))}static serializeReplyErr(O,q){const Z=q?m(M.transformErrorForSerialization(q),null):void 0;if(typeof Z!="string")return this.h(O);const x=k.VSBuffer.fromString(Z);let F=0;F+=t.sizeLongString(x);const $=t.alloc(11,O,F);return $.writeLongString(x),$.buffer}static deserializeReplyErrError(O){const q=O.readLongString();return JSON.parse(q)}static h(O){return t.alloc(12,O,0).buffer}}var l;(function(R){R[R.RequestJSONArgs=1]="RequestJSONArgs",R[R.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",R[R.RequestMixedArgs=3]="RequestMixedArgs",R[R.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",R[R.Acknowledged=5]="Acknowledged",R[R.Cancel=6]="Cancel",R[R.ReplyOKEmpty=7]="ReplyOKEmpty",R[R.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",R[R.ReplyOKJSON=9]="ReplyOKJSON",R[R.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",R[R.ReplyErrError=11]="ReplyErrError",R[R.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var g;(function(R){R[R.String=1]="String",R[R.VSBuffer=2]="VSBuffer",R[R.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",R[R.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[239],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const C=A=>{self.removeEventListener("message",C);const S=A.data;Object.defineProperties(self,{postMessage:{value(y,N){S.postMessage(y,N)}},onmessage:{get(){return S.onmessage},set(y){S.onmessage=y}}}),S.addEventListener("message",y=>{self.dispatchEvent(new MessageEvent("message",{data:y.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",C)}.toString();class k extends EventTarget{constructor(M,C,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${n})('${C}'))`,y=new Blob([S],{type:"application/javascript"}),N=URL.createObjectURL(y),E=new MessageChannel,m=N,p={type:"_newWorker",id:m,port:E.port2,url:N,options:A};M(p,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(N),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(f){E.port1.onmessage=f}},onmessageerror:{get(){return E.port1.onmessageerror},set(f){E.port1.onmessageerror=f}}}),E.port1.addEventListener("messageerror",f=>{const s=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(s)}),E.port1.addEventListener("message",f=>{const s=new MessageEvent("message",{data:f.data});this.dispatchEvent(s)}),E.port1.start()}}e.NestedWorker=k}),define(Ie[240],Ce([1,0,4,29,42,3,36,11,12]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(s=>f.push(s)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}k.Registry.add(e.Extensions.OutputChannels,new N);function E(p,f,s,o,u){return(0,S.createCancelablePromise)(async b=>{await(0,C.whenProviderRegistered)(s,o);const w=k.Registry.as(e.Extensions.OutputChannels);try{await m(s,1,o,u,b),w.registerChannel({id:p,label:f,file:s,log:!0})}catch(P){(0,A.isCancellationError)(P)||u.error("Error while registering log channel",s.toString(),(0,A.getErrorMessage)(P))}})}e.registerLogChannel=E;async function m(p,f,s,o,u){if(!await s.exists(p)){if(u.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",p.toString()),await(0,S.timeout)(1e3,u),await m(p,f+1,s,o,u)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Ie[105],Ce([1,0,5,3,17,25,13,240,59,27,37,120,23,9,36,4,6]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(v,r,h,i,c){super(),this.id=v,this.name=r,this.m=h,this.n=i,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(t=>this.setLevel(t)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,v)}replace(v){const r=this.k;this.info(v),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(v,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:r))}hide(){this.n.$close(this.id)}g(v,r){this.k+=m.VSBuffer.fromString(r).byteLength,(0,C.log)(this.m,v,r),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends u{appendLine(v){this.append(v)}}let w=class{constructor(v,r,h,i,c,t){this.i=r,this.j=h,this.k=i,this.l=c,this.m=t,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[r,h]of this.g)h.visible=r===this.h}createOutputChannel(v,r,h){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,c=(0,p.isString)(r)?r:void 0;if((0,p.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let t;const d=this.i.environment.extensionLogLevel?.find(([l])=>M.ExtensionIdentifier.equals(h.identifier,l))?.[1];d&&(t=(0,C.parseLogLevel)(d));const a=i?this.o(v,t,h):this.n(v,c,h);return a.then(l=>{this.g.set(l.id,l),l.visible=l.id===this.h}),i?this.r(v,t??this.m.getLevel(),a):this.q(v,a)}async n(v,r,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,c=this.k.extUri.joinPath(i,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.l.createLogger(c,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.a.$register(v,c,!1,r,h.identifier.value);return new u(d,v,t,this.a,h)}async o(v,r,h){const i=await this.p(h),c=this.k.extUri.joinPath(i,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.l.createLogger(c,{name:v},r),d=await this.a.$register(v,c,!0,void 0,h.identifier.value);return new b(d,v,t,this.a,h)}p(v){let r=this.d.get(v.identifier.value);if(!r){const h=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(h)}catch(i){if((0,f.toFileSystemProviderErrorCode)(i)!==f.FileSystemProviderErrorCode.FileExists)throw i}return h})())}return r}q(v,r){let h=!1;const i=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return v},append(c){i(),r.then(t=>t.append(c))},appendLine(c){i(),r.then(t=>t.appendLine(c))},clear(){i(),r.then(c=>c.clear())},replace(c){i(),r.then(t=>t.replace(c))},show(c,t){i(),r.then(d=>d.show(c,t))},hide(){i(),r.then(c=>c.hide())},dispose(){h=!0,r.then(c=>c.dispose())}}}r(v,r,h){const i=new o.DisposableStore,c=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},t=i.add(new s.Emitter);function d(a){r=a,t.fire(a)}return h.then(a=>{i.add(a),a.logLevel!==r&&d(a.logLevel),i.add(a.onDidChangeLogLevel(l=>d(l)))}),{...this.q(v,h),get logLevel(){return r},onDidChangeLogLevel:t.event,trace(a,...l){c(),h.then(g=>g.trace(a,...l))},debug(a,...l){c(),h.then(g=>g.debug(a,...l))},info(a,...l){c(),h.then(g=>g.info(a,...l))},warn(a,...l){c(),h.then(g=>g.warn(a,...l))},error(a,...l){c(),h.then(g=>g.error(a,...l))},dispose(){i.dispose()}}}};w=qe([je(0,D.IExtHostRpcService),je(1,y.IExtHostInitDataService),je(2,S.IExtHostConsumerFileSystem),je(3,N.IExtHostFileSystemInfo),je(4,C.ILoggerService),je(5,C.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(Ie[241],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ie[242],Ce([1,0,40,16,19,20,24,2,3,173,52,188,241]),function(te,e,n,k,D,M,C,A,S,y,N,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let p=class cn{constructor(s,o,u,b){this.d=s,this.e=o,this.f=u,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const w=await this.e.getEnvironment();return this.c=w?.userHome??s})()}hasValidBasename(s,o,u){return typeof o=="string"||typeof o>"u"?this.a.then(b=>this.h(s,b,o)):this.h(s,o,u)}h(s,o,u){return s.scheme===k.Schemas.file||s.scheme===k.Schemas.vscodeRemote?(0,n.isValidBasename)(u??(0,C.basename)(s),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return k.Schemas.vscodeRemote;const u=(0,y.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const b=o.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=o.getWorkspace().configuration;return w?w.scheme:k.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?D.win32:D.posix)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const b=s.indexOf("/",2);b===-1?(o=s.substring(2),s="/"):(o=s.substring(2,b),s=s.substring(b)||"/")}return A.URI.from({scheme:k.Schemas.file,authority:o,path:s,query:"",fragment:""})}};p=qe([je(1,m.IRemoteAgentService),je(2,E.IWorkbenchEnvironmentService),je(3,N.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(Ie[106],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(C,A){this.line=C,this.character=A}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,A){return new n(0,0)}with(C){return new n(0,0)}}e.Position=n;class k{constructor(C,A,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(C,A),this.end=new n(S,y)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new k(0,0,0,0)}with(C){return new k(0,0,0,0)}}e.Range=k;var D;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[45],Ce([1,0,18,35,22,40,10,3,19,11,106,12]),function(te,e,n,k,D,M,C,A,S,y,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",p=" characters skipped \u27EB",f=(m.length+p.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function u(ue){return!!ue.preview}e.resultIsMatch=u;function b(ue){return!!ue.resource}e.isFileMatch=b;function w(ue){return!!ue.message}e.isProgressMessage=w;var P;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(P=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=v;class r{constructor(de,re,G){this.ranges=re;const H=Array.isArray(re)?re:[re];if(G&&G.matchLines===1&&h(H)){de=(0,C.getNLines)(de,G.matchLines);let oe="",ve=0,Ae=0;const Ue=Math.floor(G.charsPerLine/5),xe=[];for(const Te of H){const Se=Math.max(Te.startColumn-Ue,0),ke=Te.startColumn+G.charsPerLine;if(Se>Ae+Ue+f){const se=m+(Se-Ae)+p;oe+=se+de.slice(Se,ke),ve+=Se-(Ae+se.length)}else oe+=de.slice(Ae,ke);xe.push(new c(0,Te.startColumn-ve,Te.endColumn-ve)),Ae=ke}this.preview={text:oe,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const oe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(re,ve=>new i(ve.startLineNumber-oe,ve.startColumn,ve.endLineNumber-oe,ve.endColumn))}}}}e.TextSearchMatch=r;function h(ue){const de=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==de||re.endLineNumber!==de)return!1;return!0}class i{constructor(de,re,G,H){this.startLineNumber=de,this.startColumn=re,this.endLineNumber=G,this.endColumn=H}}e.SearchRange=i;class c extends i{constructor(de,re,G){super(de,re,de,G)}}e.OneLineRange=c;var t;(function(ue){ue.List="list",ue.Tree="tree"})(t=e.ViewMode||(e.ViewMode={}));var d;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function a(ue,de=!0){const re=ue&&ue.files&&ue.files.exclude,G=de&&ue&&ue.search&&ue.search.exclude;if(!re&&!G)return;if(!re||!G)return re||G;let H=Object.create(null);return H=D.mixin(H,D.deepClone(re)),H=D.mixin(H,D.deepClone(G),!0),H}e.getExcludes=a;function l(ue,de){return ue.excludePattern&&k.match(ue.excludePattern,de)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&k.match(ue.includePattern,de)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const G=re.folder.fsPath;if(M.isEqualOrParent(de,G)){const H=S.relative(G,de);return!re.includePattern||!!k.match(re.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class R extends Error{constructor(de,re){super(de),this.code=re}}e.SearchError=R;function O(ue){const de=ue.message;if((0,y.isCancellationError)(ue))return new R(de,g.canceled);try{const re=JSON.parse(de);return new R(re.message,re.code)}catch{return new R(de,g.other)}}e.deserializeSearchError=O;function q(ue){const de={message:ue.message,code:ue.code};return new Error(JSON.stringify(de))}e.serializeSearchError=q;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function F(ue){return!!ue.path}e.isSerializedFileMatch=F;function $(ue,de){const re=ue.searchPath?ue.searchPath:ue.relativePath;return(0,C.fuzzyContains)(re,de)}e.isFilePatternMatch=$;class T{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=T;function L(ue,de){const re={...ue||{},...de||{}};return Object.keys(re).filter(G=>{const H=re[G];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=L;class V{constructor(de,re){this.c=null,this.a={...de.excludePattern||{},...re.excludePattern||{}},this.b=k.parse(this.a);let G=de.includePattern;re.includePattern&&(G?G={...G,...re.includePattern}:G=re.includePattern),G&&(this.c=k.parse(G))}matchesExcludesSync(de,re,G){return!!(this.b&&this.b(de,re,G))}includedInQuerySync(de,re,G){return!(this.b&&this.b(de,re,G)||this.c&&!this.c(de,re,G))}includedInQuery(de,re,G){const H=this.b(de,re,G),oe=()=>this.c?!!this.c(de,re,G):!0;return(0,E.isThenable)(H)?H.then(ve=>ve?!1:oe()):oe()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=V;function j(ue){for(const de in ue)if(typeof ue[de]!="boolean")return!0;return!1}function le(ue){if(!ue)return;let de;return re=>(de||(de=(ue()||Promise.resolve([])).then(G=>G?pe(G):{})),de.then(G=>!!G[re]))}e.hasSiblingPromiseFn=le;function _(ue){if(!ue)return;let de;return re=>{if(!de){const G=ue();de=G?pe(G):{}}return!!de[re]}}e.hasSiblingFn=_;function pe(ue){const de={};for(const re of ue)de[re]=!0;return de}}),define(Ie[31],Ce([1,0,18,12,21,4,6,46,16,113,24,10,9,2,144,3,13,160,52,37,27,17,8,7,54,45,5]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v,r,h,i,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(x,F,$){return new N.ExtUri(T=>R(T,$)).isEqual(x,F)}function a(x,F,$){return d(x.uri,F.uri,$)?0:(0,E.compare)(x.uri.toString(),F.uri.toString())}function l(x,F,$){return x.index!==F.index?x.index<F.index?-1:1:d(x.uri,F.uri,$)?(0,E.compare)(x.name,F.name):(0,E.compare)(x.uri.toString(),F.uri.toString())}function g(x,F,$,T){const L=x.slice(0).sort((j,le)=>$(j,le,T)),V=F.slice(0).sort((j,le)=>$(j,le,T));return(0,n.delta)(L,V,(j,le)=>$(j,le,T))}function R(x,F){const $=F.getCapabilities(x.scheme);return!($&&$&1024)}class O extends b.Workspace{static toExtHostWorkspace(F,$,T,L){if(!F)return{workspace:null,added:[],removed:[]};const{id:V,name:j,folders:le,configuration:_,transient:pe,isUntitled:ue}=F,de=[],re=$;$?le.forEach((ve,Ae)=>{const Ue=p.URI.revive(ve.uri),xe=O.e(T||$,Ue,L);xe?(xe.name=ve.name,xe.index=ve.index,de.push(xe)):de.push({uri:Ue,name:ve.name,index:Ae})}):de.push(...le.map(({uri:ve,name:Ae,index:Ue})=>({uri:p.URI.revive(ve),name:Ae,index:Ue}))),de.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const G=new O(V,j,de,!!pe,_?p.URI.revive(_):null,!!ue,ve=>R(ve,L)),{added:H,removed:oe}=g(re?re.workspaceFolders:[],G.workspaceFolders,a,L);return{workspace:G,added:H,removed:oe}}static e(F,$,T){for(let L=0;L<F.folders.length;L++){const V=F.workspaceFolders[L];if(d(V.uri,$,T))return V}}constructor(F,$,T,L,V,j,le){super(F,T.map(_=>new b.WorkspaceFolder(_)),L,V,le),this.s=$,this.t=j,this.o=[],this.q=A.TernarySearchTree.forUris(le),T.forEach(_=>{this.o.push(_),this.q.set(_.uri,_)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,$){return $&&this.q.get(F)&&(F=(0,N.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let q=class{constructor(F,$,T,L,V){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new M.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=L,this.q=T,this.s=V,this.h=new y.Counter,this.j=new k.Barrier,this.n=F.getProxy(t.MainContext.MainThreadWorkspace),this.o=F.getProxy(t.MainContext.MainThreadMessageService);const j=$.workspace;this.k=j?new O(j.id,j.name,[],!!j.transient,j.configuration?p.URI.revive(j.configuration):null,!!j.isUntitled,le=>R(le,T)):void 0}$initializeWorkspace(F,$){this.u=$,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?p.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,$,T,...L){const V=[];if(Array.isArray(L)&&L.forEach(ue=>{p.URI.isUri(ue.uri)&&!V.some(de=>d(de.uri,ue.uri,this.q))&&V.push({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri)})}),this.l||[$,T].some(ue=>typeof ue!="number"||ue<0)||T===0&&V.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if($+T>j.length)return!1;const le=j.slice(0);le.splice($,T,...V.map(ue=>({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<le.length;ue++){const de=le[ue];if(le.some((re,G)=>G!==ue&&d(de.uri,re.uri,this.q)))return!1}le.forEach((ue,de)=>ue.index=de);const{added:_,removed:pe}=g(j,le,l,this.q);if(_.length===0&&pe.length===0)return!1;if(this.n){const ue=F.displayName||F.name;this.n.$updateWorkspaceFolders(ue,$,T,V).then(void 0,de=>{this.l=void 0;const re={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(u.Severity.Error,(0,f.localize)(0,null,ue,de.toString()),re,[])})}return this.x(le),!0}getWorkspaceFolder(F,$){if(!!this.w)return this.w.getWorkspaceFolder(F,$)}async getWorkspaceFolder2(F,$){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,$)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,$){let T,L="";if(typeof F=="string"?(T=p.URI.file(F),L=F):typeof F<"u"&&(T=F,L=F.fsPath),!T)return L;const V=this.getWorkspaceFolder(T,!0);if(!V)return L;typeof $>"u"&&this.w&&($=this.w.folders.length>1);let j=(0,N.relativePath)(V.uri,T);return $&&V.name&&(j=`${V.name}/${j}`),j}x(F){this.w&&(this.l=O.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:$,added:T,removed:L}=O.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=$||void 0,this.l=void 0,this.c.fire(Object.freeze({added:T,removed:L}))}findFiles(F,$,T,L,V=D.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let j;if($===null?j=!1:$&&(typeof $=="string"?j=$:j=$.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:_}=Z(r.GlobPattern.from(F));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(le),(0,m.withUndefinedAsNull)(_),(0,m.withUndefinedAsNull)(j),(0,m.withUndefinedAsNull)(T),V).then(pe=>Array.isArray(pe)?pe.map(ue=>p.URI.revive(ue)):[])}async findTextInFiles(F,$,T,L,V=D.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),le=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:_,folder:pe}=Z(r.GlobPattern.from($.include)),ue=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:le,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:_,excludePattern:ue},re=!1;if(this.t[j]=G=>{if(re)return;const H=p.URI.revive(G.resource);G.results.forEach(oe=>{(0,c.resultIsMatch)(oe)?T({uri:H,preview:{text:oe.preview.text,matches:(0,n.mapArrayOrNot)(oe.preview.matches,ve=>new h.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,n.mapArrayOrNot)(oe.ranges,ve=>new h.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):T({uri:H,text:oe.text,lineNumber:oe.lineNumber})})},V.isCancellationRequested)return{};try{const G=await this.n.$startTextSearch(F,(0,m.withUndefinedAsNull)(pe),de,j,V);return delete this.t[j],G||{}}catch(G){throw delete this.t[j],G}}$handleTextSearchResult(F,$){this.t[$]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,$){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,$);const T=this.s.transformOutgoingScheme(F),L=this.y++;return this.n.$registerEditSessionIdentityProvider(L,T),(0,C.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(F,$){this.g.info("Getting edit session identifier for workspaceFolder",F);const T=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!T){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const L=this.v.get(T.uri.scheme);if(this.g.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!L),!L)return;const V=await L.provideEditSessionIdentity(T,$);if(this.g.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(F,$,T,L){this.g.info("Getting edit session identifier for workspaceFolder",F);const V=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!V){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const j=this.v.get(V.uri.scheme);if(this.g.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.($,T,L);if(this.g.info("Provider returned edit session identifier match result: ",le),!!le)return le}};q=qe([je(0,v.IExtHostRpcService),je(1,P.IExtHostInitDataService),je(2,w.IExtHostFileSystemInfo),je(3,o.ILogService),je(4,i.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function Z(x){let F,$;return x&&(typeof x=="string"?F=x:(F=x.pattern,$=p.URI.revive(x.baseUri))),{includePattern:F,folder:$}}}),define(Ie[32],Ce([1,0,22,4,31,5,7,163,93,9,12,3,17,13,2]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(h,i){if(i){const c=i.split(".");let t=h;for(let d=0;t&&d<c.length;d++)t=t[c[d]];return t}}function o(h){return h instanceof f.URI}function u(h){return h&&h.uri instanceof f.URI&&h.languageId&&typeof h.languageId=="string"}function b(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function w(h){return h&&h.uri instanceof f.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function P(h){if(o(h))return{resource:h};if(u(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(b(h))return{overrideIdentifier:h.languageId};if(w(h))return{resource:h.uri};if(h===null)return{resource:null}}let v=class{constructor(i,c,t){this.a=i.getProxy(M.MainContext.MainThreadConfiguration),this.c=c,this.b=t,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new r(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,c){this.getConfigProvider().then(t=>t.$acceptConfigurationChanged(i,c))}};v=qe([je(0,m.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,p.ILogService)],v),e.ExtHostConfiguration=v;class r{constructor(i,c,t,d){this.a=new k.Emitter,this.b=i,this.f=d,this.c=c,this.e=A.Configuration.parse(t),this.d=this.k(t.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,c){const t={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(c,t))}getConfiguration(i,c,t){const d=P(c)||{},a=this.g(i?s(this.e.getValue(void 0,d,this.c.workspace),i):this.e.getValue(void 0,d,this.c.workspace));i&&this.h(i,d,t?.identifier);function l(R){if(R==null)return null;if(typeof R=="boolean")return R?2:5;switch(R){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(R){return typeof s(a,R)<"u"},get:(R,O)=>{this.h(i?`${i}.${R}`:R,d,t?.identifier);let q=s(a,R);if(typeof q>"u")q=O;else{let Z;const x=(F,$)=>{let T;const L=()=>{Z=Z||(0,n.deepClone)(a),T=T||s(Z,$)};return(0,y.isObject)(F)?new Proxy(F,{get:(V,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return L(),()=>T;if(Z)return T=T||s(Z,$),T[j];const le=V[j];return typeof j=="string"?x(le,`${$}.${j}`):le},set:(V,j,le)=>(L(),T&&(T[j]=le),!0),deleteProperty:(V,j)=>(L(),T&&delete T[j],!0),defineProperty:(V,j,le)=>(L(),T&&Object.defineProperty(T,j,le),!0)}):F};q=x(q,R)}return q},update:(R,O,q,Z)=>{R=i?`${i}.${R}`:R;const x=l(q);return O!==void 0?this.b.$updateConfigurationOption(x,R,O,d,Z):this.b.$removeConfigurationOption(x,R,d,Z)},inspect:R=>{R=i?`${i}.${R}`:R;const O=this.e.inspect(R,d,this.c.workspace);if(O)return{key:R,defaultValue:(0,n.deepClone)(O.policy?.value??O.default?.value),globalValue:(0,n.deepClone)(O.user?.value??O.application?.value),workspaceValue:(0,n.deepClone)(O.workspace?.value),workspaceFolderValue:(0,n.deepClone)(O.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(O.default?.override),globalLanguageValue:(0,n.deepClone)(O.user?.override??O.application?.override),workspaceLanguageValue:(0,n.deepClone)(O.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(O.workspaceFolder?.override),languageIds:(0,n.deepClone)(O.overrideIdentifiers)}}};return typeof a=="object"&&(0,n.mixin)(g,a,!1),Object.freeze(g)}g(i){const c=t=>(0,y.isObject)(t)?new Proxy(t,{get:(d,a)=>c(d[a]),set:(d,a,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(d,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(d,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):t;return c(i)}h(i,c,t){const d=S.OVERRIDE_PROPERTY_REGEX.test(i)?4:this.d.get(i),a=t?`[${t.value}] `:"";if(d===4){typeof c?.resource>"u"&&this.f.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){c?.resource&&this.f.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,c){const t=new A.ConfigurationChangeEvent(i,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,a)=>t.affectsConfiguration(d,P(a))})}k(i){return i.reduce((c,t)=>(c.set(t[0],t[1]),c),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[107],Ce([1,0,2,12,4,5,7,31,57,32,21,60,17,27,3,16,20,13,77,200,11]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(F){function $(L){if(L!=null)return L}F.from=$;function T(L){if(L!=null)return L}F.to=T})(r||(r={}));var h;(function(F){function $(L){if(L!=null)return L}F.from=$;function T(L){if(L!=null)return L}F.to=T})(h||(h={}));var i;(function(F){function $(L){if(L!=null)return L}F.from=$;function T(L){if(L!=null)return L}F.to=T})(i||(i={}));var c;(function(F){function $(V){if(V){const j=V;return j&&!!j.process}else return!1}F.is=$;function T(V){if(V==null)return;const j={process:V.process,args:V.args};return V.options&&(j.options=i.from(V.options)),j}F.from=T;function L(V){if(V!=null)return new C.ProcessExecution(V.process,V.args,V.options)}F.to=L})(c||(c={}));var t;(function(F){function $(L){if(L!=null)return L}F.from=$;function T(L){if(L!=null)return L}F.to=T})(t||(t={}));var d;(function(F){function $(V){if(V){const j=V;return j&&(!!j.commandLine||!!j.command)}else return!1}F.is=$;function T(V){if(V==null)return;const j={};return V.commandLine!==void 0?j.commandLine=V.commandLine:(j.command=V.command,j.args=V.args),V.options&&(j.options=t.from(V.options)),j}F.from=T;function L(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new C.ShellExecution(V.commandLine,V.options):new C.ShellExecution(V.command,V.args?V.args:[],V.options)}F.to=L})(d||(d={}));var a;(function(F){function $(V){if(V){const j=V;return j&&j.customExecution==="customExecution"}else return!1}F.is=$;function T(V){return{customExecution:"customExecution"}}F.from=T;function L(V,j){return j.get(V)}F.to=L})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(F){function $(T,L){let V;return T.scope!==void 0&&typeof T.scope!="number"?V=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===C.TaskScope.Workspace&&L&&L.workspaceFile?V=L.workspaceFile:V=w.USER_TASKS_GROUP_KEY),{id:T._id,workspaceFolder:V}}F.from=$})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(F){function $(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}F.from=$})(g||(g={}));var R;(function(F){function $(V,j){if(V==null)return[];const le=[];for(const _ of V){const pe=T(_,j);pe&&le.push(pe)}return le}F.fromMany=$;function T(V,j){if(V==null)return;let le;V.execution instanceof C.ProcessExecution?le=c.from(V.execution):V.execution instanceof C.ShellExecution?le=d.from(V.execution):V.execution&&V.execution instanceof C.CustomExecution&&(le=a.from(V.execution));const _=r.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=C.TaskScope.Workspace,!_||!pe?void 0:{_id:V._id,definition:_,name:V.name,source:{extensionId:j.identifier.value,label:V.source,scope:pe},execution:le,isBackground:V.isBackground,group:g.from(V.group),presentationOptions:h.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}F.from=T;async function L(V,j,le){if(V==null)return;let _;c.is(V.execution)?_=c.to(V.execution):d.is(V.execution)?_=d.to(V.execution):a.is(V.execution)&&(_=a.to(V._id,le));const pe=r.to(V.definition);let ue;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?ue=V.source.scope:ue=await j.resolveWorkspaceFolder(n.URI.revive(V.source.scope)):ue=C.TaskScope.Workspace),!pe||!ue)return;const de=new C.Task(pe,ue,V.name,V.source.label,_,V.problemMatchers);return V.isBackground!==void 0&&(de.isBackground=V.isBackground),V.group!==void 0&&(de.group=C.TaskGroup.from(V.group._id),de.group&&V.group.isDefault&&(de.group=new C.TaskGroup(de.group.id,de.group.label),V.group.isDefault===!0&&(de.group.isDefault=V.group.isDefault))),V.presentationOptions&&(de.presentationOptions=h.to(V.presentationOptions)),V._id&&(de._id=V._id),V.detail&&(de.detail=V.detail),de}F.to=L})(R=e.TaskDTO||(e.TaskDTO={}));var O;(function(F){function $(L){return L}F.from=$;function T(L){if(!!L)return Object.assign(Object.create(null),L)}F.to=T})(O||(O={}));class q{constructor($,T,L){this._id=T,this.a=L,v.set(this,void 0),Je(this,v,$,"f")}get task(){return this.a}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}v=new WeakMap;let Z=class{constructor($,T,L,V,j,le,_,pe){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=$.getProxy(M.MainContext.MainThreadTask),this.b=L,this.c=V,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,T,L){if(!L)return new C.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:T,provider:L,extension:$}),this.a.$registerTaskProvider(V,T),new C.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem($,T){this.a.$registerTaskSystem($,T)}fetchTasks($){return this.a.$fetchTasks(O.from($)).then(async T=>{const L=[];for(const V of T){const j=await R.to(V,this.b,this.m);j&&L.push(j)}return L})}get taskExecutions(){const $=[];return this.k.forEach(T=>$.push(T)),$}terminateTask($){if(!($ instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,T,L){const V=this.m.get($.id);V&&(this.o.set($.id,V),this.e.attachPtyToTerminal(T,await V.callback(L))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const T=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const T=await this.y($.id);this.s.fire({execution:T,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const T=await this.y($.id);this.t.fire({execution:T,exitCode:$.exitCode})}$provideTasks($,T){const L=this.j.get($);if(!L)return Promise.reject(new Error("no handler found"));const V=[],j=(0,k.asPromise)(()=>L.provider.provideTasks(N.CancellationToken.None)).then(le=>this.u(T,V,L,le));return new Promise(le=>{j.then(_=>{Promise.all(V).then(()=>{le(_)})})})}async $resolveTask($,T){const L=this.j.get($);if(!L)return Promise.reject(new Error("no handler found"));if(T.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${L.type}].`);const V=await R.to(T,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const j=await L.provider.resolveTask(V,N.CancellationToken.None);if(!j)return;this.z(j,L);const le=R.from(j,L.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x($,T,L){const V=await this.a.$createTaskId($);!L&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,T.execution)),this.m.set(V,T.execution)}async y($,T){if(typeof $=="string"){const j=this.l.get($);if(!j)throw new P.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const L=this.l.get($.id);if(L)return L;const V=new Promise((j,le)=>{function _(pe,ue,de){de?j(new q(pe,ue.id,de)):le("Unexpected: Task does not exist.")}T?_(this,$,T):R.to($.task,this.b,this.m).then(pe=>_(this,$,pe))});return this.l.set($.id,V),V.then(j=>(this.k.set($.id,j),j),j=>Promise.reject(j))}z($,T){$._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const L=this.n.values();let V=L.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=L.next()}};Z=qe([je(0,m.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,A.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,y.IExtHostConfiguration),je(5,E.IExtHostTerminalService),je(6,u.ILogService),je(7,b.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let x=class extends Z{constructor($,T,L,V,j,le,_,pe){super($,T,L,V,j,le,_,pe),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const L=R.from(T,$);if(L===void 0)throw new Error("Task is not valid");if(a.is(L.execution))await this.x(L,T,!1);else throw new P.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(L),T);return this.a.$executeTask(L).catch(j=>{throw new Error(j)}),V}u($,T,L,V){const j=[];if(V)for(const le of V){this.z(le,L),(!le.definition||!$[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const _=R.from(le,L.extension);_&&a.is(_.execution)?(j.push(_),T.push(this.x(_,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:L.extension}}async v($){if(a.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,T,L){}};x=qe([je(0,m.IExtHostRpcService),je(1,p.IExtHostInitDataService),je(2,A.IExtHostWorkspace),je(3,S.IExtHostDocumentsAndEditors),je(4,y.IExtHostConfiguration),je(5,E.IExtHostTerminalService),je(6,u.ILogService),je(7,b.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[243],Ce([1,0,19,21,39,35,24,78,45]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(m,p,f){this.k=m,this.l=p,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&M.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const p=this.k.folderQueries||[];return new Promise((f,s)=>{const o=u=>{this.f++,m(u)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const b=u.toString(),w=n.basename(b);this.j&&this.j(b,w)||this.v(o,{base:u,basename:w})}),Promise.all(p.map(u=>this.p(u,o))).then(u=>{f({limitHit:this.e,stats:u[0]||void 0})},u=>{s(new Error((0,D.toErrorMessage)(u)))})})}async p(m,p){const f=new k.CancellationTokenSource,s=this.q(m),o=this.r(),u=new S.QueryGlobTester(this.k,m),b=!u.hasSiblingExcludeClauses();let w;try{this.h.add(f),w=A.StopWatch.create();const P=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,f.token),v=w.elapsed(),r=A.StopWatch.create();return this.g&&!this.e||(P&&P.forEach(h=>{const i=n.posix.relative(m.folder.path,h.path);if(b){const c=n.basename(h.path);this.v(p,{base:m.folder,relativePath:i,basename:c});return}this.s(o,m.folder,i,p)}),this.g&&!this.e)?null:(this.u(o,u,p),{providerTime:v,postProcessTime:r.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const p=(0,S.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:p,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},p,f,s){if(f===this.a){const u=n.basename(this.a);this.v(s,{base:p,relativePath:this.a,basename:u})}function o(u){const b=n.basename(u),w=n.dirname(u);let P=m[w];P||(P=m[w]=[],o(w)),P.push({base:p,relativePath:u,basename:b})}o(f)}u({rootEntries:m,pathToEntries:p},f,s){const o=this,u=this.a;function b(w){const P=(0,S.hasSiblingFn)(()=>w.map(v=>v.basename));for(let v=0,r=w.length;v<r;v++){const h=w[v],{relativePath:i,basename:c}=h;if(f.matchesExcludesSync(i,c,u!==c?P:void 0))continue;const t=p[i];if(t)b(t);else{if(i===u)continue;o.v(s,h)}if(o.e)break}}b(m)}v(m,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(p))}}class N{constructor(){this.b=new Map}fileSearch(m,p,f,s){const o=this.c(m.cacheKey),u=new y(m,p,o&&o.token);let b=0;const w=P=>{b+=P.length,f(P.map(v=>this.d(v)))};return this.e(u,N.a,w,s).then(P=>({limitHit:P.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:P.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new k.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:C.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,p,f,s){s.onCancellationRequested(()=>{m.cancel()});const o=b=>{b&&(u.push(b),p>0&&u.length>=p&&(f(u),u=[]))};let u=[];return m.search(o).then(b=>(u.length&&f(u),b),b=>(u.length&&f(u),Promise.reject(b)))}}e.FileSearchManager=N,N.a=512}),define(Ie[244],Ce([1,0,18,62,35,87,28,16,19,24,10,9,2,260,153,41,13,52,97,242,45]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(g,R,O,q,Z){this.a=g,this.b=R,this.c=O,this.d=q,this.e=Z}text(g,R,O={}){g=this.f(g,O);const q=this.a.getValue(),Z=R&&R.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(R?.map(u.toWorkspaceFolder),O),type:2,contentPattern:g,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:q.search.usePCRE2||Z||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(g,R){const O=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const q={...g,wordSeparators:O.editor.wordSeparators};return this.j(g,R)&&(q.isCaseSensitive=!0),this.k(g)&&(q.isMultiline=!0),q}file(g,R={}){return{...this.h(g,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}g(g,R){return g?(g=Array.isArray(g)?g.map(t):t(g),R?this.parseSearchPaths(g):{pattern:h(...Array.isArray(g)?g:[g])}):{}}h(g=[],R={}){const O=this.g(R.includePattern,R.expandPatterns),q=this.g(R.excludePattern,R.expandPatterns),Z=g.length>1,x=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(T=>this.q(T,R,q)):g.map(T=>this.r(T,R,q,Z))).filter(T=>!!T),F={_reason:R._reason,folderQueries:x,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:q.pattern,includePattern:O.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const T=n.coalesce(n.flatten(this.c.groups.map(j=>j.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const L=T.filter(j=>(0,P.pathIncludedInQuery)(F,j.fsPath)),V=this.i(L);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...F,...V}}const $=R.extraFileResources&&R.extraFileResources.filter(T=>(0,P.pathIncludedInQuery)(F,T.fsPath));return F.extraFileResources=$&&$.length?$:void 0,F}i(g){const R=[],O=new C.ResourceMap,q={};let Z=!1;return g.forEach(x=>{if(x.scheme===A.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(x)){const $=this.b.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let T=O.get($);T||(Z=!0,T={folder:$,includePattern:{}},R.push(T),O.set($,T));const L=S.relative($.fsPath,x.fsPath);(0,E.assertIsDefined)(T.includePattern)[L.replace(/\\/g,"/")]=!0}else x.fsPath&&(Z=!0,q[x.fsPath]=!0)}),{folderQueries:R,includePattern:q,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(g,R){if(R.isSmartCase){if(g.isRegExp){if(N.containsUppercaseCharacter(g.pattern,!0))return!0}else if(N.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,p.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const R=V=>S.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),q=(Array.isArray(g)?g:i(g)).map(V=>{const j=this.e.resolvedUserHome;return j?(0,M.untildify)(V,j.scheme===A.Schemas.file?j.fsPath:j.path):V}),Z=k.groupBy(q,V=>R(V)?"searchPaths":"exprSegments"),x=(Z.exprSegments||[]).map(V=>N.rtrim(V,"/")).map(V=>N.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),c(V))),F={},$=this.m(Z.searchPaths||[]);$&&$.length&&(F.searchPaths=$);const T=n.flatten(x),L=h(...T);return L&&(F.pattern=L),F}l(g,R){return R.disregardExcludeSettings?void 0:(0,P.getExcludes)(g,!R.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const R=g.flatMap(q=>{let{pathPortion:Z,globPortion:x}=r(q);return x&&(x=d(x)),this.n(Z).flatMap($=>this.o($,x))}),O=new Map;return R.forEach(q=>{const Z=q.searchPath.toString(),x=O.get(Z);x?q.pattern&&(x.pattern=x.pattern||{},x.pattern[q.pattern]=!0):O.set(Z,{searchPath:q.searchPath,pattern:q.pattern?h(q.pattern):void 0})}),Array.from(O.values())}n(g){if(S.isAbsolute(g)){const R=this.b.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==A.Schemas.file?[{searchPath:R[0].uri.with({path:g})}]:[{searchPath:m.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const R=this.b.getWorkspace().folders[0].uri;if(g=t(g),g.startsWith("../")||g===".."){const q=S.posix.resolve(R.path,g);return[{searchPath:R.with({path:q})}]}const O=d(g);return[{searchPath:R,pattern:O}]}else{if(g==="./"||g===".\\")return[];{const R=g.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(Z=>{const x=R.match(new RegExp(`^${N.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return x?{match:x,folder:Z}:null}).filter(E.isDefined);if(q.length)return q.map(Z=>{const x=Z.match[1];return{searchPath:Z.folder.uri,pattern:x&&d(x)}});{const Z=g.match(/\.[\/\\](.+)[\/\\]?/),x=Z?Z[1]:g,F=f.localize(0,null,x);throw new Error(F)}}}}o(g,R){const O=g.pattern&&R?`${g.pattern}/${R}`:g.pattern||R,q=[{searchPath:g.searchPath,pattern:O}];return O&&!O.endsWith("**")&&q.push({searchPath:g.searchPath,pattern:O+"/**"}),q}q(g,R,O){const q=this.r((0,u.toWorkspaceFolder)(g.searchPath),R,O,!1);return q?{...q,includePattern:g.pattern}:null}r(g,R,O,q){let Z;const x=m.URI.isUri(g)?g:g.uri;if(O.searchPaths){const V=O.searchPaths.filter(j=>(0,y.isEqual)(j.searchPath,x))[0];if(V&&!V.pattern)return null;V&&(Z=V.pattern)}const F=this.a.getValue({resource:x}),T={...this.l(F,R)||{},...Z||{}},L=m.URI.isUri(g)?(0,y.basename)(g):g.name;return{folder:x,folderName:q?L:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof R.disregardParentIgnoreFiles=="boolean"?R.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!F.search.followSymlinks}}};v=qe([je(0,s.IConfigurationService),je(1,u.IWorkspaceContextService),je(2,b.IEditorGroupsService),je(3,o.ILogService),je(4,w.IPathService)],v),e.QueryBuilder=v;function r(l){const g=l.match(/[\*\{\}\(\)\[\]\?]/);if(g){const R=g.index,O=l.substr(0,R).match(/[/|\\][^/\\]*$/);if(O){let q=l.substr(0,O.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:l.substr((O.index||0)+1)}}}return{pathPortion:l}}function h(...l){return l.length?l.reduce((g,R)=>(g[R]=!0,g),Object.create(null)):void 0}function i(l){return D.splitGlobAware(l,",").map(g=>g.trim()).filter(g=>!!g.length)}function c(l){return[`**/${l}/**`,`**/${l}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function t(l){return l.replace(/\\/g,"/")}function d(l){return t(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(l,g){l=n.distinct(l,q=>q.toString());const R=[],O=g.getWorkspace();return l&&l.forEach(q=>{let Z;if(g.getWorkbenchState()===2)Z=(0,y.relativePath)(O.folders[0].uri,q),Z&&Z!=="."&&(Z="./"+Z);else{const x=g.getWorkspaceFolder(q);if(x){const F=x.name;if(O.folders.filter(T=>T.name===F).length===1){const T=(0,y.relativePath)(x.uri,q);T===""?Z=`./${x.name}`:Z=`./${x.name}/${T}`}else Z=q.fsPath}}Z&&R.push(Z)}),R}e.resolveResourcesForSearchIncludes=a}),define(Ie[245],Ce([1,0,24,2,21,11,3,244,45,52]),function(te,e,n,k,D,M,C,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function E(s,o){const u=o.activationEvents;if(!u)return Promise.resolve(void 0);const b=[],w=[];for(const c of u)if(/^workspaceContains:/.test(c)){const t=c.substr(18);t.indexOf("*")>=0||t.indexOf("?")>=0||s.forceUsingSearch?w.push(t):b.push(t)}if(b.length===0&&w.length===0)return Promise.resolve(void 0);let P;const v=new Promise((c,t)=>{P=c}),r=c=>P({activationEvent:c}),h=Promise.all(b.map(c=>m(s,c,r))).then(()=>{}),i=p(s,o.identifier,w,r);return Promise.all([h,i]).then(()=>{P(void 0)}),v}e.checkActivateWorkspaceContainsExtension=E;async function m(s,o,u){for(const b of s.folders)if(await s.exists(n.joinPath(k.URI.revive(b),o))){u(`workspaceContains:${o}`);return}}async function p(s,o,u,b){if(u.length===0)return Promise.resolve(void 0);const w=new D.CancellationTokenSource,P=s.checkExists(s.folders,u,w.token),v=setTimeout(async()=>{w.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},N);let r=!1;try{r=await P}catch(h){M.isCancellationError(h)||M.onUnexpectedError(h)}w.dispose(),clearTimeout(v),r&&b(`workspaceContains:${u.join(",")}`)}function f(s,o,u,b){const w=s.get(C.IInstantiationService),P=s.get(S.ISearchService),r=w.createInstance(A.QueryBuilder).file(o.map(h=>(0,y.toWorkspaceFolder)(k.URI.revive(h))),{_reason:"checkExists",includePattern:u,exists:!0});return P.fileSearch(r,b).then(h=>!!h.limitHit,h=>M.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(Ie[33],Ce([1,0,139,19,83,24,12,6,46,2,13,5,32,189,81,31,26,98,11,25,23,174,7,94,3,27,82,17,68,70,60,4,245,80,176,16,79,78]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v,r,h,i,c,t,d,a,l,g,R,O,q,Z,x,F,$){"use strict";var T,L,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let j=class Ui extends A.Disposable{constructor(re,G,H,oe,ve,Ae,Ue,xe,Te,Se,ke){super(),this.a=this.B(new R.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=G,this.g=H,this.f=Ue,this.j=oe,this.k=ve,this.l=Ae,this.m=Te,this.p=Se,this.s=ke,this.t=this.g.getProxy(E.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(E.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(E.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const se=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(pe(this.F,se)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=xe,this.h=re.createChild(new a.ServiceCollection([f.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H])),this.J=this.B(new p.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,J,I)=>{this.v.$onExtensionActivationError(ce,b.transformErrorForSerialization(J),I)},actualActivateExtension:async(ce,J)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,J),new p.HostExtension;const I=this.D.getExtensionDescription(ce);return this.Y(I,J)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){b.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(re)}terminate(re,G=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(oe=>{this.l.error(oe)}),this.g.dispose();const H=this.Q();Promise.race([(0,C.timeout)(5e3),H]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.l.info(`Extension host exiting with code ${G}`),this.l.flush(),this.l.dispose(),this.c.exit(G)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const G=await this.v.$getExtension(re);let H;if(G?.browserNlsBundleUris){H={};for(const oe of Object.keys(G.browserNlsBundleUris))H[oe]=y.URI.revive(G.browserNlsBundleUris[oe])}return G&&{...G,identifier:new w.ExtensionIdentifier(G.identifier.value),extensionLocation:y.URI.revive(G.extensionLocation),browserNlsBundleUris:H}}R(re,G){return this.J.activateByEvent(re,G)}S(re,G){return this.J.activateById(re,G)}activateByIdWithErrors(re,G){return this.S(re,G).then(()=>{const H=this.J.getActivatedExtension(re);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==x.Schemas.file)return re;const G=await this.c.realpath(re.fsPath);return y.URI.file(G)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new ue(re))),this.L}async W(re){const G=S.TernarySearchTree.forUris(H=>M.extUriBiasedIgnorePathCase.ignorePathCasing(H));return await Promise.all(re.map(async H=>{if(this.ob(H)){const oe=await this.U(H.extensionLocation);G.set(oe,H)}})),G}X(re){let G=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return G;const H=this.J.getActivatedExtension(re);if(!H)return G;try{typeof H.module.deactivate=="function"&&(G=Promise.resolve(H.module.deactivate()).then(void 0,oe=>(this.l.error(oe),Promise.resolve(void 0))))}catch(oe){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(oe)}try{(0,A.dispose)(H.subscriptions)}catch(oe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(oe)}return G}async Y(re,G){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,G).then(H=>{const oe=H.activationTimes;return this.v.$onDidActivateExtension(re.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,G),this.Z(re,G,"success",oe),H},H=>{throw this.Z(re,G,"failure"),H})}Z(re,G,H,oe){const ve=le(re,G);this.u.$publicLog2("extensionActivationTimes",{...ve,...oe||{},outcome:H})}ab(re,G){const H=le(re,G);this.u.$publicLog2("activatePlugin",H);const oe=this.ob(re);if(!oe)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${re.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.l.flush();const ve=new p.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this.pb(re,(0,M.joinPath)(re.extensionLocation,oe),ve),this.bb(re)]).then(Ae=>(D.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Ui.cb(this.l,re.identifier,Ae[0],Ae[1],ve))).then(Ae=>(D.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ae))}bb(re){const G=new v.ExtensionGlobalMemento(re,this.G),H=new v.ExtensionMemento(re.identifier.value,!1,this.G),oe=new Z.ExtensionSecrets(re,this.H),ve=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ae=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([G.whenReady,H.whenReady,this.I.whenReady]).then(()=>{const Ue=this;let xe,Te;const Se=(0,o.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(w.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:H,secrets:oe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(ke){return k.join(re.extensionLocation.fsPath,ke)},get storagePath(){return Ue.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return Ue.I.globalValue(re).fsPath},get logPath(){return k.join(Ue.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return y.URI.joinPath(Ue.f.logsLocation,re.identifier.value)},get storageUri(){return Ue.I.workspaceValue(re)},get globalStorageUri(){return Ue.I.globalValue(re)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new _(Ue,re.identifier,re,Ae,!1)),xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(re,"extensionRuntime"),Ue.extensionRuntime},get environmentVariableCollection(){return Ue.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Te){if(!Se)return;const ke=R.Event.buffer(R.Event.fromDOMEventEmitter(Se,"message",se=>se.data));Se.start(),Te={onDidReceiveMessage:ke,postMessage:Se.postMessage.bind(Se)}}return Te}})})}static cb(re,G,H,oe,ve){return H=H||{activate:void 0,deactivate:void 0},this.db(re,G,H,oe,ve).then(Ae=>new p.ActivatedExtension(!1,null,ve.build(),H,Ae,oe.subscriptions))}static db(re,G,H,oe,ve){if(typeof H.activate=="function")try{ve.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Ae=typeof global=="object"?global:self,Ue=H.activate.apply(Ae,[oe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Ue).then(xe=>(ve.activateResolveStop(),xe))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(H)}eb(re,G){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:G}).then(void 0,H=>{this.l.error(H)})}fb(){this.v.$setPerformanceMarks(D.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const G of re.activationEvents)G==="onStartupFinished"&&this.eb(re,G)}gb(){const re=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const G=this.j.workspace?this.j.workspace.folders:[],H=this.hb(G),oe=Promise.all([re,H]).then(()=>{});return Promise.race([oe,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),oe}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(G=>this.ib(re,G))).then(()=>{})}async ib(re,G){if(this.isActivated(G.identifier))return;const H=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.l,folders:re.map(Ae=>Ae.uri),forceUsingSearch:H,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Ue,xe)=>this.t.$checkExists(Ae,Ue,xe)},ve=await(0,O.checkActivateWorkspaceContainsExtension)(oe,G);if(!!ve)return this.S(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:G}=this.f.environment;if(!re||!G)throw new Error(n.localize(0,null));const H=await this.pb(null,G,new p.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(n.localize(1,null,G.toString()));return new Promise((oe,ve)=>{const Ae=(Te,Se)=>{Te?ve(Te):oe(typeof Se=="number"&&Se>0?1:0)},Ue=(0,M.originalFSPath)(G),xe=H.run(Ue,Ae);xe&&xe.then&&xe.then(()=>{oe(0)}).catch(Te=>{ve(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,G){return this.M[re]=G,(0,A.toDisposable)(()=>{delete this.M[re]})}async lb(re){const G=re.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const H=re.substr(0,G);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this.M[H]}}async $resolveAuthority(re,G){const H=$.StopWatch.create(!1),oe=()=>`[resolveAuthority(${(0,h.getRemoteAuthorityPrefix)(re)},${G})][${H.elapsed()}ms] `,ve=Se=>this.l.info(`${oe()}${Se}`),Ae=(Se,ke=void 0)=>this.l.error(`${oe()}${Se}`,ke);ve("activating resolver...");const{authorityPrefix:Ue,resolver:xe}=await this.lb(re);if(!xe)return Ae("no resolver"),{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ue}.`,detail:void 0}};const Te=new C.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(xe)),Te.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Ue}`);const Se=await xe.resolve(re,{resolveAttempt:G});D.mark(`code/extHost/didResolveAuthorityOK/${Ue}`),Te.dispose(),ve(`returned ${Se.host}:${Se.port}`);const ke={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},se={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:se,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(D.mark(`code/extHost/didResolveAuthorityError/${Ue}`),Te.dispose(),Ae("returned an error",Se),Se instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,G){this.l.info(`$getCanonicalURI invoked for authority (${(0,h.getRemoteAuthorityPrefix)(re)})`);const{resolver:H}=await this.lb(re);if(!H)return null;const oe=y.URI.revive(G);if(typeof H.getCanonicalURI>"u")return oe;const ve=await(0,C.asPromise)(()=>H.getCanonicalURI(oe));return ve||oe}static mb(re,G,H){const oe=new u.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());oe.deltaExtensions(H.toAdd,H.toRemove);const ve=(0,o.extensionIdentifiersArrayToSet)(G.getAllExtensionDescriptions().map(Ue=>Ue.identifier));for(const Ue of H.myToRemove)ve.delete(w.ExtensionIdentifier.toKey(Ue));for(const Ue of H.myToAdd)ve.add(w.ExtensionIdentifier.toKey(Ue));const Ae=pe(oe,ve);return{globalRegistry:oe,myExtensions:Ae}}$startExtensionHost(re){re.toAdd.forEach(oe=>oe.extensionLocation=y.URI.revive(oe.extensionLocation));const{globalRegistry:G,myExtensions:H}=Ui.mb(this.F,this.D,re);return this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),this.kb()}$activateByEvent(re,G){return G===1?this.R(re,!1):this.z.wait().then(H=>this.R(re,!1))}async $activate(re,G){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,G),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ae=>Ae.extensionLocation=y.URI.revive(Ae.extensionLocation));const{globalRegistry:G,myExtensions:H}=Ui.mb(this.F,this.D,re),oe=await this.W(H);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const G=P.VSBuffer.alloc(re),H=Math.random()%256;for(let oe=0;oe<re;oe++)G.writeUInt8(H,oe);return G}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};j=qe([je(0,i.IInstantiationService),je(1,e.IHostUtils),je(2,d.IExtHostRpcService),je(3,s.IExtHostWorkspace),je(4,m.IExtHostConfiguration),je(5,N.ILogService),je(6,c.IExtHostInitDataService),je(7,t.IExtensionStoragePaths),je(8,l.IExtHostTunnelService),je(9,g.IExtHostTerminalService),je(10,F.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(de,re){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class _{constructor(re,G,H,oe,ve){T.set(this,void 0),L.set(this,void 0),V.set(this,void 0),Je(this,T,re,"f"),Je(this,L,G,"f"),Je(this,V,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=k.normalize((0,M.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=oe,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,T,"f").isActivated(Oe(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,T,"f").getExtensionExports(Oe(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,T,"f").activateByIdWithErrors(Oe(this,V,"f"),{startup:!1,extensionId:Oe(this,L,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,T=new WeakMap,L=new WeakMap,V=new WeakMap;function pe(de,re){return de.getAllExtensionDescriptions().filter(G=>re.has(w.ExtensionIdentifier.toKey(G.identifier)))}class ue{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=ue}),define(Ie[246],Ce([1,0,83,2,5,32,26,25,17,27,3,33,49,13,10]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(v,r,h,i,c,t,d){this.c=v,this.d=r,this.e=h,this.f=i,this.g=c,this.h=t,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new u(this.c,r,this.d,v,this.i)),this.register(this.e.createInstance(b,r)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(w,r,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const r of v.nodeModuleName)this.a.set(r,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(r=>v.alternativeModuleName(r))}};s=qe([je(2,N.IInstantiationService),je(3,M.IExtHostConfiguration),je(4,E.IExtHostExtensionService),je(5,y.IExtHostInitDataService),je(6,p.ILogService)],s),e.RequireInterceptor=s;let o=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const r=(0,f.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),h="[a-z0-9_.-]",i=`@${h}+\\/${h}+|${h}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${c}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const r=this.b.exec(this.c(v));if(!r)return;const[,h,i,c]=r,t=rn.a.get(i);if(t!==void 0)return console.warn(`${i} as been renamed to ${t}, please update your imports`),h+t+c}c(v){return v.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([je(0,y.IExtHostInitDataService)],o);class u{constructor(v,r,h,i,c){this.c=v,this.d=r,this.e=h,this.f=i,this.g=c,this.nodeModuleName="vscode",this.a=new Map}load(v,r){const h=this.d.findSubstr(r);if(h){let i=this.a.get(A.ExtensionIdentifier.toKey(h.identifier));return i||(i=this.c(h,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(h.identifier),i)),i}if(!this.b){let i="";this.d.forEach((c,t)=>i+=`	${t} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(v,r,h){this.d=v,this.nodeModuleName="keytar",this.a=r.getProxy(D.MainContext.MainThreadTelemetry);const{environment:i}=h,c=r.getProxy(D.MainContext.MainThreadKeytar);if(i.appRoot){let t=i.appRoot.fsPath;m.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.b=new Set,this.b.add(`${t}/node_modules.asar/keytar`),this.b.add(`${t}/node_modules/keytar`)}this.c={getPassword:(t,d)=>c.$getPassword(t,d),setPassword:(t,d,a)=>c.$setPassword(t,d,a),deletePassword:(t,d)=>c.$deletePassword(t,d),findPassword:t=>c.$findPassword(t),findCredentials(t){return c.$findCredentials(t)}}}load(v,r){const h=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const r=v.length;if(r<=7||!this.b)return;const h=r-7;if((v.charAt(h)==="/"||v.charAt(h)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};b=qe([je(1,S.IExtHostRpcService),je(2,y.IExtHostInitDataService)],b);let w=class{constructor(v,r,h){this.e=v,this.f=r,this.nodeModuleName=["open","opn"],this.d=h.getProxy(D.MainContext.MainThreadTelemetry);const i=h.getProxy(D.MainContext.MainThreadWindow);this.c=(c,t)=>{const d=k.URI.parse(c);return t?this.g(c,t):d.scheme==="http"||d.scheme==="https"?i.$openUri(d,c,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?i.$openUri(d,c,{}):this.g(c,t)}}load(v,r,h){const i=this.e.findSubstr(r);return i&&(this.a=i.identifier.value,this.h()),this.b=h(v),this.c}g(v,r){return this.i(),this.b(v,r)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};w=qe([je(2,S.IExtHostRpcService)],w)}),define(Ie[108],Ce([1,0,85,6,19,49,3,57,58,33,7,31,186,32]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(u,b,w,P,v,r,h){function i(){if(w){const c=w.activeEditor();if(c)return c.document.uri;const t=P.tabGroups.all.find(d=>d.isActive)?.activeTab;if(t!==void 0){if(t.input instanceof N.TextDiffTabInput||t.input instanceof N.NotebookDiffEditorTabInput)return t.input.modified;if(t.input instanceof N.TextTabInput||t.input instanceof N.NotebookEditorTabInput||t.input instanceof N.CustomEditorTabInput)return t.input.uri}}}super({getFolderUri:c=>{const t=r.folders.filter(d=>d.name===c);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(c,t)=>v.getConfiguration(void 0,c).get(t),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=i();if(c)return D.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const c=i();if(c){const t=b.getWorkspaceFolder(c);if(t)return D.normalize(t.uri.fsPath)}}},getSelectedText:()=>{if(w){const c=w.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(w){const c=w.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>u.getExtension(c)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(M.env))}}let s=class extends k.Disposable{constructor(u,b,w,P,v){super(),this.b=u,this.c=b,this.g=w,this.h=P,this.i=v,this.a=new n.Lazy(async()=>{const r=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,r,i,this.j())})}getResolver(){return this.a.value}j(){}};s=qe([je(0,y.IExtHostExtensionService),je(1,E.IExtHostWorkspace),je(2,A.IExtHostDocumentsAndEditors),je(3,p.IExtHostConfiguration),je(4,S.IExtHostEditorTabs)],s),e.ExtHostVariableResolverProviderService=s}),define(Ie[109],Ce([1,0,12,4,9,2,3,5,58,33,17,7,31,179,181,32,108]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(i,c,t,d,a,l){this.D=c,this.E=t,this.F=d,this.G=a,this.H=l,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new k.Emitter,this.n=new k.Emitter,this.o=new k.Emitter,this.u=new k.Emitter,this.k=i.getProxy(A.MainContext.MainThreadDebugService),this.z=new k.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new w(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(R=>{this.I(g)}),this.I(g)})}asDebugSourceUri(i,c){const t=i;if(typeof t.sourceReference=="number"&&t.sourceReference>0){let d=`debug:${encodeURIComponent(t.path||"")}`,a="?";return c&&(d+=`${a}session=${encodeURIComponent(c.id)}`,a="&"),d+=`${a}ref=${t.sourceReference}`,M.URI.parse(d)}else{if(t.path)return M.URI.file(t.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(i){const c=[];for(const t of i.getAllExtensionDescriptions())if(t.contributes){const d=t.contributes.debuggers;if(d&&d.length>0)for(const a of d)(0,f.isDebuggerMainContribution)(a)&&c.push(a.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const i=[];return this.w.forEach(c=>i.push(c)),i}addBreakpoints(i){this.T();const c=i.filter(a=>{const l=a.id;return this.w.has(l)?!1:(this.w.set(l,a),!0)});this.U(c,[],[]);const t=[],d=new Map;for(const a of c)if(a instanceof E.SourceBreakpoint){let l=d.get(a.location.uri.toString());l||(l={type:"sourceMulti",uri:a.location.uri,lines:[]},d.set(a.location.uri.toString(),l),t.push(l)),l.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof E.FunctionBreakpoint&&t.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this.k.$registerBreakpoints(t)}removeBreakpoints(i){this.T();const c=i.filter(l=>this.w.delete(l.id));this.U([],c,[]);const t=c.filter(l=>l instanceof E.SourceBreakpoint).map(l=>l.id),d=c.filter(l=>l instanceof E.FunctionBreakpoint).map(l=>l.id),a=c.filter(l=>l instanceof E.DataBreakpoint).map(l=>l.id);return this.k.$unregisterBreakpoints(t,d,a)}startDebugging(i,c,t){return this.k.$startDebugging(i?i.uri:void 0,c,{parentSessionID:t.parentSession?t.parentSession.id:void 0,lifecycleManagedByParent:t.lifecycleManagedByParent,repl:t.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:t.noDebug,compact:t.compact,suppressSaveBeforeStart:t.suppressSaveBeforeStart,suppressDebugStatusbar:t.suppressDebugStatusbar??t.debugUI?.simple,suppressDebugToolbar:t.suppressDebugToolbar??t.debugUI?.simple,suppressDebugView:t.suppressDebugView??t.debugUI?.simple})}stopDebugging(i){return this.k.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,c,t){if(!c)return new E.Disposable(()=>{});const d=this.d++;return this.f.push({type:i,handle:d,provider:c}),this.k.$registerDebugConfigurationProvider(i,t,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,d),new E.Disposable(()=>{this.f=this.f.filter(a=>a.provider!==c),this.k.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(i,c,t){if(!t)return new E.Disposable(()=>{});if(!this.P(i,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this.g++;return this.h.push({type:c,handle:d,factory:t}),this.k.$registerDebugAdapterDescriptorFactory(c,d),new E.Disposable(()=>{this.h=this.h.filter(a=>a.factory!==t),this.k.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(i,c){if(!c)return new E.Disposable(()=>{});const t=this.i++;return this.j.push({type:i,handle:t,factory:c}),new E.Disposable(()=>{this.j=this.j.filter(d=>d.factory!==c)})}async $runInTerminal(i,c){return Promise.resolve(void 0)}async $substituteVariables(i,c){let t;const d=await this.W(i);return d&&(t={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(t,c)}J(i,c){if(i.type==="implementation")return new v(i.implementation)}K(){}async $startDASession(i,c){const t=this,d=await this.V(c);return this.R(this.M(d.type),d).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const l=this.L(a),g=this.J(l,d);if(!g)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const R=g;return this.A.set(i,R),this.Q(d).then(O=>(O&&this.B.set(i,O),R.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const Z=q,x={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(Z.arguments.value);x.body={signature:F},R.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,R.sendResponse(x)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(q),q=(0,f.convertToVSCPaths)(q,!0),t.k.$acceptDAMessage(i,q)}),R.onError(q=>{O&&O.onError&&O.onError(q),this.k.$acceptDAError(i,q.name,q.message,q.stack)}),R.onExit(q=>{O&&O.onExit&&O.onExit((0,D.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(i,(0,D.withNullAsUndefined)(q),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),R.startSession()))})}$sendDAMessage(i,c){c=(0,f.convertToDAPaths)(c,!1);const t=this.B.get(i);t&&t.onWillReceiveMessage&&t.onWillReceiveMessage(c),this.A.get(i)?.sendMessage(c)}$stopDASession(i){const c=this.B.get(i);this.B.delete(i),c&&c.onWillStopSession&&c.onWillStopSession();const t=this.A.get(i);return this.A.delete(i),t?t.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const c=[],t=[],d=[];if(i.added)for(const a of i.added){const l=a.id;if(l&&!this.w.has(l)){let g;if(a.type==="function")g=new E.FunctionBreakpoint(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")g=new E.DataBreakpoint(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const R=M.URI.revive(a.uri);g=new E.SourceBreakpoint(new E.Location(R,new E.Position(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}(0,E.setBreakpointId)(g,l),this.w.set(l,g),c.push(g)}}if(i.removed)for(const a of i.removed){const l=this.w.get(a);l&&(this.w.delete(a),t.push(l))}if(i.changed){for(const a of i.changed)if(a.id){const l=this.w.get(a.id);if(l){if(l instanceof E.FunctionBreakpoint&&a.type==="function"){const g=l;g.enabled=a.enabled,g.condition=a.condition,g.hitCondition=a.hitCondition,g.logMessage=a.logMessage,g.functionName=a.functionName}else if(l instanceof E.SourceBreakpoint&&a.type==="source"){const g=l;g.enabled=a.enabled,g.condition=a.condition,g.hitCondition=a.hitCondition,g.logMessage=a.logMessage,g.location=new E.Location(M.URI.revive(a.uri),new E.Position(a.line,a.character))}d.push(l)}}}this.U(c,t,d)}$provideDebugConfigurations(i,c,t){return(0,n.asPromise)(async()=>{const d=this.O(i);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.W(c);return d.provideDebugConfigurations(a,t)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(i,c,t,d){return(0,n.asPromise)(async()=>{const a=this.O(i);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.W(c);return a.resolveDebugConfiguration(l,t,d)})}$resolveDebugConfigurationWithSubstitutedVariables(i,c,t,d){return(0,n.asPromise)(async()=>{const a=this.O(i);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.W(c);return a.resolveDebugConfigurationWithSubstitutedVariables(l,t,d)})}async $provideDebugAdapter(i,c){const t=this.N(i);if(!t)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.V(c);return this.R(t,d).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.L(a)})}async $acceptDebugSessionStarted(i){const c=await this.V(i);this.m.fire(c)}async $acceptDebugSessionTerminated(i){const c=await this.V(i);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(i){this.q=i?await this.V(i):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(i,c){(await this.V(i))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(i,c){const d={session:await this.V(i),event:c.event,body:c.body};this.u.fire(d)}L(i){if(i instanceof E.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof E.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}M(i){const c=this.h.filter(t=>t.type===i);if(c.length>0)return c[0].factory}N(i){const c=this.h.filter(t=>t.handle===i);if(c.length>0)return c[0].factory}O(i){const c=this.f.filter(t=>t.handle===i);if(c.length>0)return c[0].provider}P(i,c){if(i.contributes){const t=i.contributes.debuggers;if(t&&t.length>0){for(const d of t)if(d.label&&d.type&&d.type===c)return!0}}return!1}Q(i){const t=i.configuration.type,d=this.j.filter(a=>a.type===t||a.type==="*").map(a=>(0,n.asPromise)(()=>a.factory.createDebugAdapterTracker(i)).then(l=>l,l=>null));return Promise.race([Promise.all(d).then(a=>{const l=a.filter(g=>!!g);if(l.length>0)return new P(l)}),new Promise(a=>setTimeout(()=>a(void 0),1e3))]).catch(a=>{})}async R(i,c){const t=c.configuration.debugServer;if(typeof t=="number")return Promise.resolve(new E.DebugAdapterServer(t));if(i){const a=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>i.createDebugAdapterDescriptor(c,this.S(c,a))).then(l=>{if(l)return l})}const d=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,d))}S(i,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(i,c,t){(i.length>0||c.length>0||t.length>0)&&this.z.fire(Object.freeze({added:i,removed:c,changed:t}))}async V(i){if(i)if(typeof i=="string"){const c=this.l.get(i);if(c)return c}else{let c=this.l.get(i.id);if(!c){const t=await this.W(i.folderUri),d=i.parent?this.l.get(i.parent):void 0;c=new b(this.k,i.id,i.type,i.name,t,i.configuration,d),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(i){if(i){const c=M.URI.revive(i);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};u=qe([je(0,N.IExtHostRpcService),je(1,m.IExtHostWorkspace),je(2,y.IExtHostExtensionService),je(3,s.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class b{constructor(i,c,t,d,a,l,g){this.d=i,this.f=c,this.g=t,this.h=d,this.i=a,this.j=l,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(i){this.h=i,this.d.$setDebugSessionName(this.f,i)}get parentSession(){return this.k}_acceptNameChanged(i){this.h=i}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(i,c){return this.d.$customDebugAdapterRequest(this.f,i,c)}getDebugProtocolBreakpoint(i){return this.d.$getDebugProtocolBreakpoint(this.f,i.id)}}e.ExtHostDebugSession=b;class w{constructor(i){this.value=Object.freeze({append(c){i.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=w;class P{constructor(i){this.d=i}onWillStartSession(){this.d.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(i):void 0)}onWillStopSession(){this.d.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.d.forEach(c=>c.onError?c.onError(i):void 0)}onExit(i,c){this.d.forEach(t=>t.onExit?t.onExit(i,c):void 0)}}class v extends p.AbstractDebugAdapter{constructor(i){super(),this.h=i,i.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.h.handleMessage(i)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends u{constructor(i,c,t,d,a,l){super(i,c,t,d,a,l)}};r=qe([je(0,N.IExtHostRpcService),je(1,m.IExtHostWorkspace),je(2,y.IExtHostExtensionService),je(3,s.IExtHostConfiguration),je(4,S.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(Ie[247],Ce([1,0,11,83,2,5,238,13,67,68,27,158,17,54,33,75]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(w){const P=w.get(A.ILogService),r=w.get(m.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(h=>{P.error(h);const i=n.transformErrorForSerialization(h);r.$onUnexpectedError(i)})}static async installFullHandler(w){const P=w.get(A.ILogService),v=w.get(m.IExtHostRpcService),r=w.get(f.IExtHostExtensionService),h=w.get(s.IExtHostTelemetry),i=v.getProxy(M.MainContext.MainThreadExtensionService),c=v.getProxy(M.MainContext.MainThreadErrors),t=await r.getExtensionPathIndex(),d=new WeakMap;Error.prepareStackTrace=(a,l)=>{let g="",R,O;for(const q of l)g+=`
	at ${q.toString()}`,O=q.getFileName(),!R&&O&&(R=t.findSubstr(D.URI.file(O)));return d.set(a,R?.identifier),`${a.name||"Error"}: ${a.message||""}${g}`},n.setUnexpectedErrorHandler(a=>{P.error(a);const l=n.transformErrorForSerialization(a),g=d.get(a);if(!g){c.$onUnexpectedError(l);return}i.$onExtensionRuntimeError(g,l);const R=h.onExtensionError(g,a);P.trace("forwarded error to extension?",R,g)})}}Error.stackTraceLimit=100;class u{constructor(w,P,v,r,h){this.a=v,this.b=new C.RPCProtocol(w,null,r),P=u.e(P,this.b);const i=new y.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());i.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...P,messagePorts:h}),i.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),i.set(p.IURITransformerService,new p.URITransformerService(r)),i.set(f.IHostUtils,v);const c=new E.InstantiationService(i,!0);c.invokeFunction(o.installEarlyHandler),this.d=c.invokeFunction(t=>t.get(A.ILogService)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",P),this.c=c.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(o.installFullHandler)}async asBrowserUri(w){const P=this.b.getProxy(M.MainContext.MainThreadExtensionService);return D.URI.revive(await P.$asBrowserUri(w))}terminate(w){this.c.terminate(w)}static e(w,P){w.allExtensions.forEach(r=>{r.extensionLocation=D.URI.revive(P.transformIncomingURIs(r.extensionLocation));const h={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(i=>h[i]=D.URI.revive(P.transformIncomingURIs(r.browserNlsBundleUris[i]))),r.browserNlsBundleUris=h)}),w.environment.appRoot=D.URI.revive(P.transformIncomingURIs(w.environment.appRoot));const v=w.environment.extensionDevelopmentLocationURI;return v&&(w.environment.extensionDevelopmentLocationURI=v.map(r=>D.URI.revive(P.transformIncomingURIs(r)))),w.environment.extensionTestsLocationURI=D.URI.revive(P.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=D.URI.revive(P.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=D.URI.revive(P.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=D.URI.revive(P.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=D.URI.revive(P.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=D.URI.revive(P.transformIncomingURIs(w.logsLocation)),w.logFile=D.URI.revive(P.transformIncomingURIs(w.logFile)),w.workspace=P.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=u}),define(Ie[248],Ce([1,0,18,12,21,39,16,19,24,2,45]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(b,w,P,v){this.d=b,this.e=w,this.f=P,this.g=v,this.a=null,this.b=!1,this.c=0}search(b,w){const P=this.d.folderQueries||[],v=new D.CancellationTokenSource;return w.onCancellationRequested(()=>v.cancel()),new Promise((r,h)=>{this.a=new p(b);let i=!1;const c=(t,d)=>{if(!i&&!this.b){const a=this.h(t);s(t)&&typeof this.d.maxResults=="number"&&this.c+a>this.d.maxResults&&(this.b=!0,i=!0,v.cancel(),t=this.j(t,this.d.maxResults-this.c));const l=this.h(t);this.c+=l,(l>0||!s(t))&&this.a.add(t,d)}};Promise.all(P.map((t,d)=>this.k(t,a=>c(a,d),v.token))).then(t=>{v.dispose(),this.a.flush();const d=t.some(a=>!!a&&!!a.limitHit);r({limitHit:this.b||d,messages:(0,n.flatten)(t.map(a=>a?.message?Array.isArray(a.message)?a.message:[a.message]:[])),stats:{type:this.g}})},t=>{v.dispose();const d=(0,M.toErrorMessage)(t);h(new Error(d))})})}h(b){return s(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,w){const P=Array.isArray(b.ranges)?b.ranges:[b.ranges],v=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:P.slice(0,w),preview:{matches:v.slice(0,w),text:b.preview.text},uri:b.uri}}async k(b,w,P){const v=new N.QueryGlobTester(this.d,b),r=[],h={report:t=>{if(!this.l(t))return;const d=b.folder.scheme===C.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(t.uri))):void 0,a=S.relativePath(b.folder,t.uri);if(a){const l=v.includedInQuery(a,A.basename(a),d);(0,k.isThenable)(l)?r.push(l.then(g=>{g&&w(t)})):l&&w(t)}}},i=this.n(b),c=await this.e.provideTextSearchResults(m(this.d.contentPattern),i,h,P);return r.length&&await Promise.all(r),c}l(b){if(s(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const w=(0,N.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),P=(0,N.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),v={folder:y.URI.from(b.folder),excludes:P,includes:w,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=E;function m(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class p{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new o(512,w=>this.g(w))}add(b,w){this.d&&(this.b!==w||!S.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=w,this.d={resource:b.uri,results:[]}),this.d.results.push(f(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=p;function f(u){return s(u)?{preview:{matches:(0,n.mapArrayOrNot)(u.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:u.preview.text},ranges:(0,n.mapArrayOrNot)(u.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function s(u){return!!u.preview}e.extensionResultIsMatch=s;class o{constructor(b,w){this.g=b,this.h=w,this.c=0,this.d=[],this.e=0}addItem(b,w){!b||this.j(b,w)}addItems(b,w){!b||this.k(b,w)}j(b,w){this.d.push(b),this.e+=w,this.l()}k(b,w){this.d=this.d.concat(b),this.e+=w,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(Ie[110],Ce([1,0,6,5,3,243,17,54,13,2,248]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let E=class{constructor(s,o,u){this.k=s,this.l=o,this.n=u,this.c=this.k.getProxy(k.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const u=this.d++;return this.e.set(u,o),this.c.$registerTextSearchProvider(u,this.o(s)),(0,n.toDisposable)(()=>{this.g.delete(s),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(s,o){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const u=this.d++;return this.h.set(u,o),this.c.$registerFileSearchProvider(u,this.o(s)),(0,n.toDisposable)(()=>{this.i.delete(s),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(s,o,u,b){const w=m(u),P=this.h.get(s);if(P)return this.j.fileSearch(w,P,v=>{this.c.$handleFileMatch(s,o,v.map(r=>r.resource))},b);throw new Error("unknown provider: "+s)}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,u,b){const w=this.e.get(s);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const P=m(u);return this.q(P,w).search(r=>this.c.$handleTextMatch(s,o,r),b)}$enableExtensionHostSearch(){}q(s,o){return new N.TextSearchManager(s,o,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};E=qe([je(0,C.IExtHostRpcService),je(1,A.IURITransformerService),je(2,S.ILogService)],E),e.ExtHostSearch=E;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(s=>y.URI.revive(s))}}e.reviveQuery=m;function p(f){return{...f,folder:y.URI.revive(f.folder)}}}),define(Ie[249],Ce([1,0,67,105,31,103,32,38,57,60,107,109,110,81,70,77,104,59,37,80,75,58,218,13,190,108,79]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v,r,h,i,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(t.IExtHostLocalizationService,t.ExtHostLocalizationService,1),(0,n.registerSingleton)(h.ILoggerService,r.ExtHostLoggerService,1),(0,n.registerSingleton)(h.ILogService,i.ExtHostLogService,1),(0,n.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,n.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,n.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,n.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,n.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,n.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,n.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,n.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,n.registerSingleton)(P.IExtHostTelemetry,P.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(c.IExtHostVariableResolverProvider,c.ExtHostVariableResolverProviderService,0)}),define(Ie[250],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const M=this.a.get(D);return this.a.delete(D),M}}addDragOperationTransfer(D,M){this.a.set(D,M)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,M){this.b.set(D,M)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=n}),define(Ie[251],Ce([1,0,143,7,24,2,4,6,178,12,7,9,18,8,21,250,26]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(P,v){if((0,E.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let r;return Array.isArray(P.highlights)&&(r=P.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),r=r.length?r:void 0),{label:P.label,highlights:r}}}class b{constructor(v,r,h){this.d=v,this.e=r,this.f=h,this.a=new Map,this.b=new s.TreeviewsService;function i(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:c=>i(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(t=>i(t)?this.i(t):t):c})}registerTreeDataProvider(v,r,h){const i=this.createTreeView(v,{treeDataProvider:r},h);return{dispose:()=>i.dispose()}}createTreeView(v,r,h){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],c=r.dragAndDropController?.dragMimeTypes??[],t=!!r.dragAndDropController?.handleDrag,d=!!r.dragAndDropController?.handleDrop,a=this.h(v,r,h),l=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:c,hasHandleDrag:t,hasHandleDrop:d});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(h,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(g){a.message=g},get title(){return a.title},set title(g){a.title=g},get description(){return a.description},set description(g){a.description=g},get badge(){return a.badge},set badge(g){g!==void 0&&N.ViewBadge.isViewBadge(g)?a.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(a.badge=void 0)},reveal:(g,R)=>a.reveal(g,R),dispose:async()=>{await l,this.a.delete(v),a.dispose()}}}$getChildren(v,r){const h=this.a.get(v);return h?h.getChildren(r):Promise.reject(new S.NoTreeViewError(v))}async $handleDrop(v,r,h,i,c,t,d,a){const l=this.a.get(v);if(!l)return Promise.reject(new S.NoTreeViewError(v));const g=p.DataTransfer.toDataTransfer(h,async R=>(await this.d.$resolveDropFileData(v,r,R)).buffer);return d===v&&a&&await this.g(g,l,a,c,t),l.onDrop(g,i,c)}async g(v,r,h,i,c){const t=this.b.removeDragOperationTransfer(c);if(t)(await t)?.forEach((d,a)=>{d&&v.set(a,d)});else if(c&&r.handleDrag){const d=r.handleDrag(h,v,i);this.b.addDragOperationTransfer(c,d),await d}return v}async $handleDrag(v,r,h,i){const c=this.a.get(v);if(!c)return Promise.reject(new S.NoTreeViewError(v));const t=await this.g(new k.DataTransfer,c,r,i,h);if(!!t)return p.DataTransfer.toDataTransferDTO(t)}async $hasResolve(v){const r=this.a.get(v);if(!r)throw new S.NoTreeViewError(v);return r.hasResolve}$resolve(v,r,h){const i=this.a.get(v);if(!i)throw new S.NoTreeViewError(v);return i.resolveTreeItem(r,h)}$setExpanded(v,r,h){const i=this.a.get(v);if(!i)throw new S.NoTreeViewError(v);i.setExpanded(r,h)}$setSelection(v,r){const h=this.a.get(v);if(!h)throw new S.NoTreeViewError(v);h.setSelection(r)}$setFocus(v,r){const h=this.a.get(v);if(!h)throw new S.NoTreeViewError(v);h.setFocus(r)}$setVisible(v,r){const h=this.a.get(v);if(!h)throw new S.NoTreeViewError(v);h.setVisible(r)}$changeCheckboxState(v,r){const h=this.a.get(v);if(!h)throw new S.NoTreeViewError(v);h.setCheckboxState(r)}h(v,r,h){const i=new w(v,r,this.d,this.e.converter,this.f,h);return this.a.set(v,i),i}i(v){const r=this.a.get(v.$treeViewId);return r&&"$treeItemHandle"in v?r.getExtensionElement(v.$treeItemHandle):r&&"$focusedTreeItem"in v&&v.$focusedTreeItem?r.focusedElement:null}}e.ExtHostTreeViews=b;class w extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,E.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,r,h,i,c,t){if(super(),this.C=v,this.D=h,this.F=i,this.G=c,this.H=t,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const g of t.contributes.views[l])g.id===v&&(this.J=g.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(l=>this.w.fire({message:!1,element:l})));let d,a;this.B(C.Event.debounce(this.w.event,(l,g)=>(l||(l={message:!1,elements:[]}),g.element!==!1&&(d||(d=new Promise(R=>a=R),this.y=this.y.then(()=>d)),Array.isArray(g.element)?l.elements.push(...g.element):l.elements.push(g.element)),g.message&&(l.message=!0),l),200,!0)(({message:l,elements:g})=>{g.length&&(this.z=this.z.then(()=>{const R=a;return d=null,this.U(g).then(()=>R())})),l&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const r=v?this.getExtensionElement(v):void 0;if(v&&!r)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let h=this.Q(v);return h||(h=await this.R(r)),h?h.map(i=>i.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,r){r=r||{select:!0,focus:!1};const h=(0,E.isUndefinedOrNull)(r.select)?!0:r.select,i=(0,E.isUndefinedOrNull)(r.focus)?!1:r.focus,c=(0,E.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(t=>this.P(v,t[t.length-1]).then(d=>this.D.$reveal(this.C,{item:d.item,parentChain:t.map(a=>a.item)},{select:h,focus:i,expand:c})),t=>this.G.error(t)):this.D.$reveal(this.C,void 0,{select:h,focus:i,expand:c})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=p.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,r){const h=this.getExtensionElement(v);h&&(r?this.r.fire(Object.freeze({element:h})):this.s.fire(Object.freeze({element:h})))}setSelection(v){(0,m.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const r=(await Promise.all(v.map(async h=>{const i=this.getExtensionElement(h.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:h.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);r.forEach(h=>{h.treeItem.checkboxState=h.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:r.map(h=>[h.extensionItem,h.newState])})}async handleDrag(v,r,h){const i=[];for(const c of v){const t=this.getExtensionElement(c);t&&i.push(t)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,h),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,r,h){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,y.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(i,v,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,r){if(!this.f.resolveTreeItem)return;const h=this.i.get(v);if(h){const i=this.j.get(h);if(i){const c=await this.f.resolveTreeItem(i.extensionItem,h,r)??i.extensionItem;return this.db(c),i.item.tooltip=this.ab(c.tooltip),i.item.command=this.bb(i.disposableStore,c.command),i.item}}}N(v){return this.O(v).then(r=>r?this.N(r).then(h=>this.P(r,h[h.length-1]).then(i=>(h.push(i),h))):Promise.resolve([]))}O(v){const r=this.j.get(v);return r?Promise.resolve(r.parent?this.i.get(r.parent.item.handle):void 0):(0,y.asPromise)(()=>this.f.getParent(v))}P(v,r){const h=this.j.get(v);return h?Promise.resolve(h):(0,y.asPromise)(()=>this.f.getTreeItem(v)).then(i=>this.gb(v,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const c=this.getExtensionElement(i);if(c){const t=this.j.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}Q(v){if(v){let r;if(typeof v=="string"){const h=this.getExtensionElement(v);r=h?this.j.get(h):void 0}else r=v;return r&&r.children||void 0}return this.h}async R(v){this.nb(v);const r=new f.CancellationTokenSource(this.S.token);try{const h=v?this.j.get(v):void 0,i=await this.f.getChildren(v);if(r.token.isCancellationRequested)return;const c=await Promise.all((0,m.coalesce)(i||[]).map(async t=>{const d=await this.f.getTreeItem(t);return d&&!r.token.isCancellationRequested?this.Z(t,d,h):null}));return r.token.isCancellationRequested?void 0:(0,m.coalesce)(c)}finally{r.dispose()}}U(v){if(v.some(h=>!h))return this.S.dispose(!0),this.S=new f.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const h=this.W(v);if(h.length)return this.X(h)}return Promise.resolve(void 0)}W(v){const r=new Set,h=v.map(c=>this.j.get(c));for(const c of h)if(c&&!r.has(c.item.handle)){let t=c;for(;t&&t.parent&&h.findIndex(d=>t&&t.parent&&d&&d.item.handle===t.parent.item.handle)===-1;){const d=this.i.get(t.parent.item.handle);t=d?this.j.get(d):void 0}t&&!t.parent&&r.add(c.item.handle)}const i=[];return r.forEach(c=>{const t=this.i.get(c);if(t){const d=this.j.get(t);d&&(!d.parent||!r.has(d.parent.item.handle))&&i.push(c)}}),i}X(v){const r={};return Promise.all(v.map(h=>this.Y(h).then(i=>{i&&(r[h]=i.item)}))).then(()=>Object.keys(r).length?this.D.$refresh(this.C,r):void 0)}Y(v){const r=this.getExtensionElement(v);if(r){const h=this.j.get(r);if(h)return this.nb(r),(0,y.asPromise)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const c=this.eb(r,i,h.parent);return this.lb(r,c,h,h.parent),h.dispose(),c}return null})}return Promise.resolve(null)}Z(v,r,h){const i=this.eb(v,r,h);if(r.id&&this.i.has(i.item.handle))throw new Error((0,n.localize)(0,null,r.id));return this.kb(v,i),this.mb(i,h),i}ab(v){return N.MarkdownString.isMarkdownString(v)?p.MarkdownString.from(v):v}bb(v,r){return r?{...this.F.toInternal(r,v),originalId:r.command}:void 0}cb(v){if(!v.checkboxState)return;let r,h;return typeof v.checkboxState=="number"?r=v.checkboxState:(r=v.checkboxState.state,h=v.checkboxState.tooltip),{isChecked:r===N.TreeItemCheckboxState.Checked,tooltip:h}}db(v){if(!N.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,r,h){this.db(r);const i=new A.DisposableStore,c=this.gb(v,r,h),t=this.hb(r);return{item:{handle:c,parentHandle:h?h.item.handle:void 0,label:u(r.label,this.H),description:r.description,resourceUri:r.resourceUri,tooltip:this.ab(r.tooltip),command:this.bb(i,r.command),contextValue:r.contextValue,icon:t,iconDark:this.ib(r)||t,themeIcon:this.fb(r),collapsibleState:(0,E.isUndefinedOrNull)(r.collapsibleState)?N.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.cb(r)},extensionItem:r,parent:h,children:void 0,disposableStore:i,dispose(){i.dispose()}}}fb(v){return v.iconPath instanceof N.ThemeIcon?v.iconPath:void 0}gb(v,{id:r,label:h,resourceUri:i},c,t){if(r)return`${w.b}/${r}`;const d=u(h,this.H),a=c?c.item.handle:w.a;let l=d?d.label:i?(0,D.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const g=this.j.has(v)?this.j.get(v).item.handle:void 0,R=this.Q(c)||[];let O,q=0;do{if(O=`${a}/${q}:${l}`,t||!this.i.has(O)||g===O)break;q++}while(q<=R.length);return O}hb(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon))return typeof v.iconPath=="string"||M.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return M.URI.isUri(v)?v:M.URI.file(v)}kb(v,r){this.i.set(r.item.handle,v),this.j.set(v,r)}lb(v,r,h,i){this.i.delete(r.item.handle),this.j.delete(v),r.item.handle!==h.item.handle&&this.i.delete(h.item.handle),this.kb(v,r);const c=this.Q(i)||[],t=c.filter(d=>d.item.handle===h.item.handle)[0];t&&c.splice(c.indexOf(t),1,r)}mb(v,r){r?(r.children||(r.children=[]),r.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const r=this.j.get(v);if(r){if(r.children)for(const h of r.children){const i=this.i.get(h.item.handle);i&&this.ob(i)}r.children=void 0}}else this.pb()}ob(v){const r=this.j.get(v);if(r){if(r.children)for(const h of r.children){const i=this.i.get(h.item.handle);i&&this.ob(i)}this.j.delete(v),this.i.delete(r.item.handle),r.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Ie[252],Ce([1,0,21,11,4,30,2,129,261,117,127,36,5,74,205,204,38,206,32,208,209,210,193,211,57,33,212,213,216,217,219,105,196,225,226,227,81,60,230,251,8,7,50,233,61,104,31,184,215,48,103,107,109,110,13,54,17,27,220,191,70,77,202,231,82,59,236,234,235,203,37,228,232,80,58,75,221,106,222,16,92,195,175,214,6,26,180,79,172,223,224]),function(te,e,n,k,D,M,C,A,S,y,N,E,m,p,f,s,o,u,b,w,P,v,r,h,i,c,t,d,a,l,g,R,O,q,Z,x,F,$,T,L,V,j,le,_,pe,ue,de,re,G,H,oe,ve,Ae,Ue,xe,Te,Se,ke,se,ce,J,I,B,W,K,ee,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Le,ot,Y,Q,ge,Me,ze,Ve,Ye,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(rt){const mt=rt.get(ke.IExtHostInitDataService),Lt=rt.get(Ee.IExtHostFileSystemInfo),xt=rt.get(ee.IExtHostConsumerFileSystem),Pt=rt.get(c.IExtHostExtensionService),ht=rt.get(de.IExtHostWorkspace),kt=rt.get(et.IExtHostTelemetry),Bt=rt.get(b.IExtHostConfiguration),Ot=rt.get(Te.IURITransformerService),Ge=rt.get(Se.IExtHostRpcService),Mt=rt.get(F.IExtHostStorage),Nt=rt.get(K.IExtensionStoragePaths),zt=rt.get(xe.ILoggerService),ft=rt.get(xe.ILogService),De=rt.get(J.IExtHostTunnelService),Pe=rt.get(I.IExtHostApiDeprecationService),me=rt.get(ue.IExtHostWindow),X=rt.get(tt.IExtHostSecretState),Re=rt.get(Xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Lt),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,zt),Ge.set(m.ExtHostContext.ExtHostWorkspace,ht),Ge.set(m.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(m.ExtHostContext.ExtHostExtensionService,Pt),Ge.set(m.ExtHostContext.ExtHostStorage,Mt),Ge.set(m.ExtHostContext.ExtHostTunnelService,De),Ge.set(m.ExtHostContext.ExtHostWindow,me),Ge.set(m.ExtHostContext.ExtHostSecretState,X),Ge.set(m.ExtHostContext.ExtHostTelemetry,kt),Ge.set(m.ExtHostContext.ExtHostEditorTabs,Re);const Be=Ge.set(m.ExtHostContext.ExtHostDecorations,rt.get(oe.IExtHostDecorations)),Qe=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(i.IExtHostDocumentsAndEditors)),$e=Ge.set(m.ExtHostContext.ExtHostCommands,rt.get(o.IExtHostCommands)),Ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,rt.get($.IExtHostTerminalService)),ct=Ge.set(m.ExtHostContext.ExtHostDebugService,rt.get(Ae.IExtHostDebugService)),Tt=Ge.set(m.ExtHostContext.ExtHostSearch,rt.get(Ue.IExtHostSearch)),bt=Ge.set(m.ExtHostContext.ExtHostTask,rt.get(ve.IExtHostTask)),Et=Ge.set(m.ExtHostContext.ExtHostOutputService,rt.get(R.IExtHostOutputService)),It=Ge.set(m.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=Ge.set(m.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Ge)),yt=Ge.set(m.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Ge,Qe)),qt=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ge,Qe,ft)),Jt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(ft,yt,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),pt=Ge.set(m.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,$e,Qe,yt)),si=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(pt)),oi=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(ft,pt)),Zt=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,mt,pt,$e,ft)),vi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(Ge,pt)),At=Ge.set(m.ExtHostContext.ExtHostEditors,new T.ExtHostEditors(Ge,Qe)),Wt=Ge.set(m.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),$e,ft)),bi=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),At,mt.remote)),ai=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ge,ft,Lt,Qe)),ei=Ge.set(m.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ge,yt,$e.converter,Ot)),ut=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ge,Ot,yt,$e,ai,ft,Pe,kt)),Bi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(Ge,ut)),Ut=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Ge,ft,Qe)),Qt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ht,$e)),ci=Ge.set(m.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(Ge,$e,ft)),Ei=Ge.set(m.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ge)),wi=Ge.set(m.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ge,$e,yt)),ui=Ge.set(m.ExtHostContext.ExtHostProgress,new O.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),Si=Ge.set(m.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(Ge)),li=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ti=Ge.set(m.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),$i=Ge.set(m.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,$e)),ii=Ge.set(m.ExtHostContext.ExtHostWebviews,new pe.ExtHostWebviews(Ge,mt.remote,ht,ft,Pe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ii,ht)),yi=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,yt,Nt,ii,ni)),Di=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(Ge,ii)),ri=Ge.set(m.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,$e,Qe)),Ii=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ci=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,pt,Qe,$e,ft));const zi=Object.values(m.ExtHostContext);Ge.assertRegistered(zi);const Wi=new be.ExtHostBulkEdits(Ge,Qe),Hi=new s.ExtHostClipboard(Ge),ki=new g.ExtHostMessageService(Ge,ft),Ri=new P.ExtHostDialogs(Ge),Oi=new x.ExtHostStatusBar(Ge,$e.converter);return f.ExtHostApiCommands.register($e),function(Ne,Ht,Fi){const gt=function(){let ne=!Ne.isUnderDevelopment;function fe(){ne||(ft.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Fe(st){if(Array.isArray(st))st.forEach(Fe);else if(typeof st=="string")fe();else{const Dt=st;typeof Dt.scheme>"u"&&fe(),typeof Dt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return st}}(),Vi={getSession(ne,fe,Fe){return ti.getSession(Ne,ne,fe,Fe)},async hasSession(ne,fe){return(0,Ve.checkProposedApiEnabled)(Ne,"authSession"),!!await ti.getSession(Ne,ne,fe,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Fe,st){return ti.registerAuthenticationProvider(ne,fe,Fe,st)}},di={registerCommand(ne,fe,Fe){return $e.registerCommand(!0,ne,fe,Fe,void 0,Ne)},registerTextEditorCommand(ne,fe,Fe){return $e.registerCommand(!0,ne,(...st)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Rt=>{fe.apply(Fe,[Dt,Rt,...st])}).then(Rt=>{Rt||ft.warn("Edits from command "+ne+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+ne,Rt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ne,fe,Fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"diffCommand"),$e.registerCommand(!0,ne,async(...st)=>{const Dt=Qe.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);fe.apply(Fe,[Rt,...st])},void 0,void 0,Ne)),executeCommand(ne,...fe){return $e.executeCommand(ne,...fe)},getCommands(ne=!1){return $e.getCommands(ne)}},Li={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ne,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetryLogger"),kt.instantiateLogger(Ne,ne)},openExternal(ne,fe){return me.openUri(ne,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===mt.environment.appUriScheme)return St.createAppUri(ne);try{return await me.asExternalUri(ne,{allowTunneling:!!mt.remote.authority})}catch(fe){if((0,Y.matchesScheme)(ne,ot.Schemas.http)||(0,Y.matchesScheme)(ne,ot.Schemas.https))return ne;throw fe}},get remoteName(){return(0,H.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Li);const ji={createTestController(ne,fe,Fe){return ri.createTestController(Ne,ne,fe,Fe)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),ri.results}},hi=mt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ne,fe){(0,Ve.isProposedApiEnabled)(Ne,"extensionsAny")||(fe=!1);const Fe=Ht.mine.getExtensionDescription(ne);if(Fe)return new c.Extension(Pt,Ne.identifier,Fe,hi,!1);if(fe){const st=Ht.all.getExtensionDescription(ne);if(st)return new c.Extension(Pt,Ne.identifier,st,hi,!0)}},get all(){const ne=[];for(const fe of Ht.mine.getAllExtensionDescriptions())ne.push(new c.Extension(Pt,Ne.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ne,"extensionsAny");const ne=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of Ht.all.getAllExtensionDescriptions()){const st=!ne.has(Fe.identifier);fe.push(new c.Extension(Pt,Ne.identifier,Fe,hi,st))}return fe},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ne,"extensionsAny")?D.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Ti={createDiagnosticCollection(ne){return ai.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ne=>ai.getDiagnostics(ne),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ne,fe){return ei.changeLanguage(ne.uri,fe)},match(ne,fe){const Fe=yt.getDocumentData(fe.uri)?.notebook;return(0,N.score)(V.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ne,fe,Fe){return ut.registerCodeActionProvider(Ne,gt(ne),fe,Fe)},registerDocumentPasteEditProvider(ne,fe,Fe){return(0,Ve.checkProposedApiEnabled)(Ne,"documentPaste"),ut.registerDocumentPasteEditProvider(Ne,gt(ne),fe,Fe)},registerCodeLensProvider(ne,fe){return ut.registerCodeLensProvider(Ne,gt(ne),fe)},registerDefinitionProvider(ne,fe){return ut.registerDefinitionProvider(Ne,gt(ne),fe)},registerDeclarationProvider(ne,fe){return ut.registerDeclarationProvider(Ne,gt(ne),fe)},registerImplementationProvider(ne,fe){return ut.registerImplementationProvider(Ne,gt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ut.registerTypeDefinitionProvider(Ne,gt(ne),fe)},registerHoverProvider(ne,fe){return ut.registerHoverProvider(Ne,gt(ne),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ut.registerEvaluatableExpressionProvider(Ne,gt(ne),fe,Ne.identifier)},registerInlineValuesProvider(ne,fe){return ut.registerInlineValuesProvider(Ne,gt(ne),fe,Ne.identifier)},registerDocumentHighlightProvider(ne,fe){return ut.registerDocumentHighlightProvider(Ne,gt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ut.registerLinkedEditingRangeProvider(Ne,gt(ne),fe)},registerReferenceProvider(ne,fe){return ut.registerReferenceProvider(Ne,gt(ne),fe)},registerRenameProvider(ne,fe){return ut.registerRenameProvider(Ne,gt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Fe){return ut.registerDocumentSymbolProvider(Ne,gt(ne),fe,Fe)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,fe){return ut.registerDocumentFormattingEditProvider(Ne,gt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ut.registerDocumentRangeFormattingEditProvider(Ne,gt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Fe,...st){return ut.registerOnTypeFormattingEditProvider(Ne,gt(ne),fe,[Fe].concat(st))},registerDocumentSemanticTokensProvider(ne,fe,Fe){return ut.registerDocumentSemanticTokensProvider(Ne,gt(ne),fe,Fe)},registerDocumentRangeSemanticTokensProvider(ne,fe,Fe){return ut.registerDocumentRangeSemanticTokensProvider(Ne,gt(ne),fe,Fe)},registerSignatureHelpProvider(ne,fe,Fe,...st){return typeof Fe=="object"?ut.registerSignatureHelpProvider(Ne,gt(ne),fe,Fe):ut.registerSignatureHelpProvider(Ne,gt(ne),fe,typeof Fe>"u"?[]:[Fe,...st])},registerCompletionItemProvider(ne,fe,...Fe){return ut.registerCompletionItemProvider(Ne,gt(ne),fe,Fe)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ne,gt(ne),fe)},registerDocumentLinkProvider(ne,fe){return ut.registerDocumentLinkProvider(Ne,gt(ne),fe)},registerColorProvider(ne,fe){return ut.registerColorProvider(Ne,gt(ne),fe)},registerFoldingRangeProvider(ne,fe){return ut.registerFoldingRangeProvider(Ne,gt(ne),fe)},registerSelectionRangeProvider(ne,fe){return ut.registerSelectionRangeProvider(Ne,ne,fe)},registerCallHierarchyProvider(ne,fe){return ut.registerCallHierarchyProvider(Ne,ne,fe)},registerTypeHierarchyProvider(ne,fe){return ut.registerTypeHierarchyProvider(Ne,ne,fe)},setLanguageConfiguration:(ne,fe)=>ut.setLanguageConfiguration(Ne,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,Ve.checkProposedApiEnabled)(Ne,"tokenInformation"),ei.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return ut.registerInlayHintsProvider(Ne,ne,fe)},createLanguageStatusItem(ne,fe){return ei.createLanguageStatusItem(Ne,ne,fe)},registerDocumentDropEditProvider(ne,fe){return ut.registerDocumentOnDropEditProvider(Ne,ne,fe)}},Ki={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(ne,fe,Fe){const st=await(C.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(st,fe,Fe)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,fe,Fe){return At.onDidChangeActiveTextEditor(ne,fe,Fe)},onDidChangeVisibleTextEditors(ne,fe,Fe){return At.onDidChangeVisibleTextEditors(ne,fe,Fe)},onDidChangeTextEditorSelection(ne,fe,Fe){return At.onDidChangeTextEditorSelection(ne,fe,Fe)},onDidChangeTextEditorOptions(ne,fe,Fe){return At.onDidChangeTextEditorOptions(ne,fe,Fe)},onDidChangeTextEditorVisibleRanges(ne,fe,Fe){return At.onDidChangeTextEditorVisibleRanges(ne,fe,Fe)},onDidChangeTextEditorViewColumn(ne,fe,Fe){return At.onDidChangeTextEditorViewColumn(ne,fe,Fe)},onDidCloseTerminal(ne,fe,Fe){return Ze.onDidCloseTerminal(ne,fe,Fe)},onDidOpenTerminal(ne,fe,Fe){return Ze.onDidOpenTerminal(ne,fe,Fe)},onDidChangeActiveTerminal(ne,fe,Fe){return Ze.onDidChangeActiveTerminal(ne,fe,Fe)},onDidChangeTerminalDimensions(ne,fe,Fe){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(ne,fe,Fe)},onDidChangeTerminalState(ne,fe,Fe){return Ze.onDidChangeTerminalState(ne,fe,Fe)},onDidWriteTerminalData(ne,fe,Fe){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(ne,fe,Fe)},get state(){return me.state},onDidChangeWindowState(ne,fe,Fe){return me.onDidChangeWindowState(ne,fe,Fe)},showInformationMessage(ne,...fe){return ki.showMessage(Ne,M.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return ki.showMessage(Ne,M.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return ki.showMessage(Ne,M.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Fe){return Qt.showQuickPick(ne,fe,Fe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Qt.showInput(ne,fe)},showOpenDialog(ne){return Ri.showOpenDialog(ne)},showSaveDialog(ne){return Ri.showSaveDialog(ne)},createStatusBarItem(ne,fe,Fe){let st,Dt,Rt;return typeof ne=="string"?(st=ne,Dt=fe,Rt=Fe):(Dt=ne,Rt=fe),Oi.createStatusBarEntry(Ne,st,Dt,Rt)},setStatusBarMessage(ne,fe){return Oi.setStatusBarMessage(ne,fe)},withScmProgress(ne){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),ui.withProgress(Ne,{location:j.ProgressLocation.SourceControl},(fe,Fe)=>ne({report(st){}}))},withProgress(ne,fe){return ui.withProgress(Ne,ne,fe)},createOutputChannel(ne,fe){return Et.createOutputChannel(ne,fe,Ne)},createWebviewPanel(ne,fe,Fe,st){return ni.createWebviewPanel(Ne,ne,fe,Fe,st)},createWebviewTextEditorInset(ne,fe,Fe,st){return(0,Ve.checkProposedApiEnabled)(Ne,"editorInsets"),bi.createWebviewEditorInset(ne,fe,Fe,st,Ne)},createTerminal(ne,fe,Fe){return typeof ne=="object"?"pty"in ne?Ze.createExtensionTerminal(ne):Ze.createTerminalFromOptions(ne):Ze.createTerminal(ne,fe,Fe)},registerTerminalLinkProvider(ne){return Ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return Ze.registerProfileProvider(Ne,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(ne,Ne.identifier.value,fe)},registerTreeDataProvider(ne,fe){return Wt.registerTreeDataProvider(ne,fe,Ne)},createTreeView(ne,fe){return Wt.createTreeView(ne,fe,Ne)},registerWebviewPanelSerializer:(ne,fe)=>ni.registerWebviewPanelSerializer(Ne,ne,fe),registerCustomEditorProvider:(ne,fe,Fe={})=>yi.registerCustomEditorProvider(Ne,ne,fe,Fe),registerFileDecorationProvider(ne){return Be.registerFileDecorationProvider(ne,Ne)},registerUriHandler(ne){return St.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ne)},createInputBox(){return Qt.createInputBox(Ne)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Fe){return li.onDidChangeActiveColorTheme(ne,fe,Fe)},registerWebviewViewProvider(ne,fe,Fe){return Di.registerWebviewViewProvider(Ne,ne,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Fe){return pt.onDidChangeActiveNotebookEditor(ne,fe,Fe)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Fe){return oi.onDidChangeNotebookEditorSelection(ne,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Fe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,fe,Fe)},showNotebookDocument(ne,fe){return pt.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Fe){return(0,Ve.checkProposedApiEnabled)(Ne,"externalUriOpener"),Ii.registerExternalUriOpener(Ne.identifier,ne,fe,Fe)},registerProfileContentHandler(ne,fe){return(0,Ve.checkProposedApiEnabled)(Ne,"profileContentHandlers"),Ci.registrProfileContentHandler(Ne,ne,fe)},async registerQuickDiffProvider(ne,fe,Fe){return(0,Ve.checkProposedApiEnabled)(Ne,"quickDiffProvider"),Ei.registerQuickDiffProvider(ne,fe,Fe)},get tabGroups(){return Re.tabGroups}},Kt={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw k.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw k.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw k.readonly()},updateWorkspaceFolders:(ne,fe,...Fe)=>ht.updateWorkspaceFolders(Ne,ne,fe||0,...Fe),onDidChangeWorkspaceFolders:function(ne,fe,Fe){return ht.onDidChangeWorkspace(ne,fe,Fe)},asRelativePath:(ne,fe)=>ht.getRelativePath(ne,fe),findFiles:(ne,fe,Fe,st)=>ht.findFiles(ne,fe,Fe,Ne.identifier,st),findTextInFiles:(ne,fe,Fe,st)=>{(0,Ve.checkProposedApiEnabled)(Ne,"findTextInFiles");let Dt,Rt;return typeof fe=="object"?(Dt=fe,Rt=Fe):(Dt={},Rt=fe,st=Fe),ht.findTextInFiles(ne,Dt||{},Rt,Ne.identifier,st)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,fe){return Wi.applyWorkspaceEdit(ne,Ne,fe)},createFileSystemWatcher:(ne,fe,Fe,st)=>Ut.createFileSystemWatcher(ht,Ne,ne,fe,Fe,st),get textDocuments(){return yt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw k.readonly()},openTextDocument(ne){let fe;const Fe=ne;if(typeof ne=="string")fe=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Fe||typeof Fe=="object")fe=yt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>yt.ensureDocumentData(st).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,fe,Fe)=>yt.onDidAddDocument(ne,fe,Fe),onDidCloseTextDocument:(ne,fe,Fe)=>yt.onDidRemoveDocument(ne,fe,Fe),onDidChangeTextDocument:(ne,fe,Fe)=>yt.onDidChangeDocument(ne,fe,Fe),onDidSaveTextDocument:(ne,fe,Fe)=>yt.onDidSaveDocument(ne,fe,Fe),onWillSaveTextDocument:(ne,fe,Fe)=>Jt.getOnWillSaveTextDocumentEvent(Ne)(ne,fe,Fe),get notebookDocuments(){return pt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Fe;if(C.URI.isUri(ne))Fe=ne,await pt.openNotebookDocument(ne);else if(typeof ne=="string")Fe=C.URI.revive(await pt.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ne,fe,Fe){return si.onDidSaveNotebookDocument(ne,fe,Fe)},onDidChangeNotebookDocument(ne,fe,Fe){return si.onDidChangeNotebookDocument(ne,fe,Fe)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Fe,st){return pt.registerNotebookSerializer(Ne,ne,fe,Fe,(0,Ve.isProposedApiEnabled)(Ne,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,fe,Fe)=>Fi.onDidChangeConfiguration(ne,fe,Fe),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,Fi.getConfiguration(ne,fe,Ne)},registerTextDocumentContentProvider(ne,fe){return qt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ne,ne,fe)),registerFileSystemProvider(ne,fe,Fe){return(0,ze.combinedDisposable)(Bi.registerFileSystemProvider(Ne,ne,fe,Fe),xt.addFileSystemProvider(ne,fe))},get fs(){return xt.value},registerFileSearchProvider:(ne,fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Tt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"textSearchProvider"),Tt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),Pt.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),Si.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Fe)=>Ut.onDidCreateFile(ne,fe,Fe),onDidDeleteFiles:(ne,fe,Fe)=>Ut.onDidDeleteFile(ne,fe,Fe),onDidRenameFiles:(ne,fe,Fe)=>Ut.onDidRenameFile(ne,fe,Fe),onWillCreateFiles:(ne,fe,Fe)=>Ut.getOnWillCreateFileEvent(Ne)(ne,fe,Fe),onWillDeleteFiles:(ne,fe,Fe)=>Ut.getOnWillDeleteFileEvent(Ne)(ne,fe,Fe),onWillRenameFiles:(ne,fe,Fe)=>Ut.getOnWillRenameFileEvent(Ne)(ne,fe,Fe),openTunnel:ne=>((0,Ve.checkProposedApiEnabled)(Ne,"tunnels"),De.openTunnel(Ne,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ne,"tunnels"),De.getTunnels()},onDidChangeTunnels:(ne,fe,Fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"tunnels"),De.onDidChangeTunnels(ne,fe,Fe)),registerPortAttributesProvider:(ne,fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"portsAttributes"),De.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"timeline"),$i.registerTimelineProvider(ne,fe,Ne.identifier,$e.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,Ve.checkProposedApiEnabled)(Ne,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Fe)=>ht.onDidGrantWorkspaceTrust(ne,fe,Fe),registerEditSessionIdentityProvider:(ne,fe)=>((0,Ve.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,fe))},fi={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ne)},createSourceControl(ne,fe,Fe){return ci.createSourceControl(Ne,ne,fe,Fe)}},Gi={createCommentController(ne,fe){return wi.createCommentController(Ne,ne,fe)}},$t={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ne,fe,Fe){return ct.onDidStartDebugSession(ne,fe,Fe)},onDidTerminateDebugSession(ne,fe,Fe){return ct.onDidTerminateDebugSession(ne,fe,Fe)},onDidChangeActiveDebugSession(ne,fe,Fe){return ct.onDidChangeActiveDebugSession(ne,fe,Fe)},onDidReceiveDebugSessionCustomEvent(ne,fe,Fe){return ct.onDidReceiveDebugSessionCustomEvent(ne,fe,Fe)},onDidChangeBreakpoints(ne,fe,Fe){return ct.onDidChangeBreakpoints(ne,fe,Fe)},registerDebugConfigurationProvider(ne,fe,Fe){return ct.registerDebugConfigurationProvider(ne,fe,Fe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return ct.registerDebugAdapterDescriptorFactory(Ne,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return ct.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ct.startDebugging(ne,fe,{parentSession:Fe}):ct.startDebugging(ne,fe,Fe||{})},stopDebugging(ne){return ct.stopDebugging(ne)},addBreakpoints(ne){return ct.addBreakpoints(ne)},removeBreakpoints(ne){return ct.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return ct.asDebugSourceUri(ne,fe)}},mi={registerTaskProvider:(ne,fe)=>bt.registerTaskProvider(Ne,ne,fe),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ne,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,fe,Fe)=>bt.onDidStartTask(ne,fe,Fe),onDidEndTask:(ne,fe,Fe)=>bt.onDidEndTask(ne,fe,Fe),onDidStartTaskProcess:(ne,fe,Fe)=>bt.onDidStartTaskProcess(ne,fe,Fe),onDidEndTaskProcess:(ne,fe,Fe)=>bt.onDidEndTaskProcess(ne,fe,Fe)},xi={createNotebookController(ne,fe,Fe,st,Dt){return Zt.createNotebookController(Ne,ne,fe,Fe,st,(0,Ve.isProposedApiEnabled)(Ne,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>pt.registerNotebookCellStatusBarItemProvider(Ne,ne,fe),createRendererMessaging(ne){return vi.createRendererMessaging(Ne,ne)},createNotebookControllerDetectionTask(ne){return(0,Ve.checkProposedApiEnabled)(Ne,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ne,ne)},registerKernelSourceActionProvider(ne,fe){return(0,Ve.checkProposedApiEnabled)(Ne,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ne,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Fe){return(0,Ve.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,fe,Fe)}},Xi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Fe=!ne||typeof ne[0]!="object"?ne:ne[0];return It.getMessage(Ne.identifier.value,{message:fe,args:Fe})}return It.getMessage(Ne.identifier.value,ne[0])},get bundle(){return It.getBundle(Ne.identifier.value)},get uri(){return It.getBundleUri(Ne.identifier.value)}};return{version:mt.version,authentication:Vi,commands:di,comments:Gi,debug:$t,env:Li,extensions:qi,l10n:Xi,languages:Ti,notebooks:xi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:Kt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:y.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:p.UIKind,Uri:C.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=jt}),define(Ie[253],Ce([1,0,252,33,2,246,7,12,237]),function(te,e,n,k,D,M,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends M.RequireInterceptor{j(){}getModule(p,f){for(const s of this.b){const o=s(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const p=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(y,p,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(p){return p.browser}async pb(p,f,s){f=f.with({path:E(f.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const u=D.URI.revive(await this.v.$asBrowserUri(f)),b=await fetch(u.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),b.status!==200)throw new Error(b.statusText);const w=await b.text(),P=`${f.toString(!0)}#vscode-extension`,v=`${w}
//# sourceURL=${P}`;let r;try{r=new Function("module","exports","require",v)}catch(t){throw console.error(o?`Loading code for extension ${o} failed: ${t.message}`:`Loading code failed: ${t.message}`),console.error(`${f.toString(!0)}${typeof t.line=="number"?` line ${t.line}`:""}${typeof t.column=="number"?` column ${t.column}`:""}`),console.error(t),t}p&&await this.s.initializeLocalizedMessages(p);const h={},i={exports:h},c=t=>{const d=this.r.getModule(t,f);if(d===void 0)throw new Error(`Cannot load module '${t}'`);return d};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),r(i,h,c),i.exports!==h?i.exports:h}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(p){}async tb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+p;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=N;function E(m,p){return m.endsWith(p)?m:m+p}}),define(Ie[254],Ce([1,0,67,33,82,253]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(k.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,n.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Ie[262],Ce([1,0,23,4,74,247,239,19,83,16,2,249,254]),function(te,e,n,k,D,M,C,A,S,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function s(r){self.fetch=async function(h,i){return h instanceof Request||p(String(h))&&(h=(await r(N.URI.parse(String(h)))).toString(!0)),f(h,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,i,c,t,d){(async()=>(p(i.toString())&&(i=(await r(N.URI.parse(i.toString()))).toString(!0)),super.open(h,i,c??!0,t,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(h,i){if(/^file:/i.test(h.toString()))h=y.FileAccess.uriToBrowserUri(N.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const t=`(${function(g){function R(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const O=fetch.bind(self);self.fetch=function(Z,x){return Z instanceof Request?O(Z,x):O(R(Z),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,x,F,$,T){return super.open(Z,R(x),F??!0,$,T)}};const q=importScripts.bind(self);self.importScripts=(...Z)=>{q(...Z.map(R))},q(g)}.toString()}('${h}'))`;i=i||{},i.name=i.name||A.basename(h.toString());const d=new Blob([t],{type:"application/javascript"}),a=URL.createObjectURL(d);return new r(a,i)}}else self.Worker=class extends C.NestedWorker{constructor(r,h){super(m,r,{name:A.basename(r.toString()),...h})}};const o=new class{constructor(){this.pid=void 0}exit(r){E()}async exists(r){return!0}async realpath(r){return r}};class u{constructor(){const h=new MessageChannel,i=new k.Emitter;let c=!1;m(h.port2,[h.port2]),h.port1.onmessage=t=>{const{data:d}=t;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const a=n.VSBuffer.wrap(new Uint8Array(d,0,d.byteLength));if((0,D.isMessageOfType)(a,2)){c=!0,w("received terminate message from renderer");return}i.fire(a)},this.protocol={onMessage:i.event,send:t=>{if(!c){const d=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);h.port1.postMessage(d,[d])}}}}}function b(r){return new Promise(h=>{const i=r.onMessage(c=>{i.dispose();const t=JSON.parse(c.toString());r.send((0,D.createMessageOfType)(0)),h({protocol:r,initData:t})});r.send((0,D.createMessageOfType)(1))})}let w=r=>E();function P(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function v(){S.mark("code/extHost/willConnectToRenderer");const r=new u;return{onmessage(h){!P(h)||b(r.protocol).then(i=>{S.mark("code/extHost/didWaitForInitData");const c=new M.ExtensionHostMain(i.protocol,i.initData,o,null,h.data);s(t=>c.asBrowserUri(t)),w=t=>c.terminate(t)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/243854703b7fa371abb752ec0df7817a615a308b/core/vs/workbench/api/worker/extensionHostWorker.js.map
